/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         MYSQLparse
#define yylex           MYSQLlex
#define yyerror         MYSQLerror
#define yydebug         MYSQLdebug
#define yynerrs         MYSQLnerrs

/* First part of user prologue.  */
#line 25 "/home/buildbot/git/sql/sql_yacc.yy"

#define YYLIP  (& thd->m_parser_state->m_lip)
#define YYPS   (& thd->m_parser_state->m_yacc)
#define YYCSCL (thd->variables.character_set_client)

#define MYSQL_YACC
#define YYINITDEPTH 100
#define YYMAXDEPTH 3200                        /* Because of 64K stack */
#define Lex (thd->lex)

#define Select Lex->current_select
#include "mariadb.h"
#include "sql_priv.h"
#include "sql_parse.h"                        /* comp_*_creator */
#include "sql_table.h"                        /* primary_key_name */
#include "sql_partition.h"  /* partition_info, HASH_PARTITION */
#include "sql_acl.h"                          /* *_ACL */
#include "sql_class.h"      /* Key_part_spec, enum_filetype, Diag_condition_item_name */
#include "slave.h"
#include "lex_symbol.h"
#include "item_create.h"
#include "sp_head.h"
#include "sp_rcontext.h"
#include "sp.h"
#include "sql_show.h"
#include "sql_alter.h"                         // Sql_cmd_alter_table*
#include "sql_truncate.h"                      // Sql_cmd_truncate_table
#include "sql_admin.h"                         // Sql_cmd_analyze/Check..._table
#include "sql_partition_admin.h"               // Sql_cmd_alter_table_*_part.
#include "sql_handler.h"                       // Sql_cmd_handler_*
#include "sql_signal.h"
#include "sql_get_diagnostics.h"               // Sql_cmd_get_diagnostics
#include "sql_cte.h"
#include "sql_window.h"
#include "item_windowfunc.h"
#include "event_parse_data.h"
#include "create_options.h"
#include <myisam.h>
#include <myisammrg.h>
#include "keycaches.h"
#include "set_var.h"
#include "rpl_mi.h"
#include "lex_token.h"
#include "sql_lex.h"
#include "sql_sequence.h"
#include "my_base.h"
#include "sql_type_json.h"

/* this is to get the bison compilation windows warnings out */
#ifdef _MSC_VER
/* warning C4065: switch statement contains 'default' but no 'case' labels */
/* warning C4102: 'yyexhaustedlab': unreferenced label */
#pragma warning (disable : 4065 4102)
#endif
#ifdef __GNUC__
#pragma GCC diagnostic ignored "-Wunused-label" /* yyexhaustedlab: */
#endif

int yylex(void *yylval, void *yythd);

#define yyoverflow(A,B,C,D,E,F)               \
  {                                           \
    size_t val= *(F);                         \
    if (unlikely(my_yyoverflow((B), (D), &val))) \
    {                                         \
      yyerror(thd, (char*) (A));              \
      return 2;                               \
    }                                         \
    else                                      \
    {                                         \
      *(F)= (YYSIZE_T)val;                    \
    }                                         \
  }

#define MYSQL_YYABORT                         \
  do                                          \
  {                                           \
    LEX::cleanup_lex_after_parse_error(thd);  \
    YYABORT;                                  \
  } while (0)

#define MYSQL_YYABORT_UNLESS(A)                  \
  if (unlikely(!(A)))                            \
  {                                              \
    thd->parse_error();                          \
    MYSQL_YYABORT;                               \
  }

#define my_yyabort_error(A)                      \
  do { my_error A; MYSQL_YYABORT; } while(0)

#ifndef DBUG_OFF
#define YYDEBUG 1
#else
#define YYDEBUG 0
#endif


static Item* escape(THD *thd)
{
  thd->lex->escape_used= false;
  const char *esc= thd->variables.sql_mode & MODE_NO_BACKSLASH_ESCAPES ? "" : "\\";
  return new (thd->mem_root) Item_string_ascii(thd, esc, MY_TEST(esc[0]));
}


/**
  @brief Bison callback to report a syntax/OOM error

  This function is invoked by the bison-generated parser
  when a syntax error, a parse error or an out-of-memory
  condition occurs. This function is not invoked when the
  parser is requested to abort by semantic action code
  by means of YYABORT or YYACCEPT macros. This is why these
  macros should not be used (use MYSQL_YYABORT/MYSQL_YYACCEPT
  instead).

  The parser will abort immediately after invoking this callback.

  This function is not for use in semantic actions and is internal to
  the parser, as it performs some pre-return cleanup. 
  In semantic actions, please use thd->parse_error() or my_error to
  push an error into the error stack and MYSQL_YYABORT
  to abort from the parser.
*/

void MYSQLerror(THD *thd, const char *s)
{
  /*
    Restore the original LEX if it was replaced when parsing
    a stored procedure. We must ensure that a parsing error
    does not leave any side effects in the THD.
  */
  LEX::cleanup_lex_after_parse_error(thd);

  /* "parse error" changed into "syntax error" between bison 1.75 and 1.875 */
  if (strcmp(s,"parse error") == 0 || strcmp(s,"syntax error") == 0)
    s= ER_THD(thd, ER_SYNTAX_ERROR);
  thd->parse_error(s, 0);
}


#ifndef DBUG_OFF
void turn_parser_debug_on()
{
  /*
     MYSQLdebug is in sql/sql_yacc.cc, in bison generated code.
     Turning this option on is **VERY** verbose, and should be
     used when investigating a syntax error problem only.

     The syntax to run with bison traces is as follows :
     - Starting a server manually :
       mysqld --debug-dbug="d,parser_debug" ...
     - Running a test :
       mysql-test-run.pl --mysqld="--debug-dbug=d,parser_debug" ...

     The result will be in the process stderr (var/log/master.err)
   */

  extern int yydebug;
  yydebug= 1;
}
#endif


/**
  Helper action for a case expression statement (the expr in 'CASE expr').
  This helper is used for 'searched' cases only.
  @param lex the parser lex context
  @param expr the parsed expression
  @return 0 on success
*/

int LEX::case_stmt_action_expr(Item* expr)
{
  int case_expr_id= spcont->register_case_expr();
  sp_instr_set_case_expr *i;

  if (spcont->push_case_expr_id(case_expr_id))
    return 1;

  i= new (thd->mem_root)
    sp_instr_set_case_expr(sphead->instructions(), spcont, case_expr_id, expr,
                           this);

  sphead->add_cont_backpatch(i);
  return sphead->add_instr(i);
}

/**
  Helper action for a case when condition.
  This helper is used for both 'simple' and 'searched' cases.
  @param lex the parser lex context
  @param when the parsed expression for the WHEN clause
  @param simple true for simple cases, false for searched cases
*/

int LEX::case_stmt_action_when(Item *when, bool simple)
{
  uint ip= sphead->instructions();
  sp_instr_jump_if_not *i;
  Item_case_expr *var;
  Item *expr;

  if (simple)
  {
    var= new (thd->mem_root)
         Item_case_expr(thd, spcont->get_current_case_expr_id());

#ifdef DBUG_ASSERT_EXISTS
    if (var)
    {
      var->m_sp= sphead;
    }
#endif

    expr= new (thd->mem_root) Item_func_eq(thd, var, when);
    i= new (thd->mem_root) sp_instr_jump_if_not(ip, spcont, expr, this);
  }
  else
    i= new (thd->mem_root) sp_instr_jump_if_not(ip, spcont, when, this);

  /*
    BACKPATCH: Registering forward jump from
    "case_stmt_action_when" to "case_stmt_action_then"
    (jump_if_not from instruction 2 to 5, 5 to 8 ... in the example)
  */

  return
    !MY_TEST(i) ||
    sphead->push_backpatch(thd, i, spcont->push_label(thd, &empty_clex_str, 0)) ||
    sphead->add_cont_backpatch(i) ||
    sphead->add_instr(i);
}

/**
  Helper action for a case then statements.
  This helper is used for both 'simple' and 'searched' cases.
  @param lex the parser lex context
*/

int LEX::case_stmt_action_then()
{
  uint ip= sphead->instructions();
  sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, spcont);
  if (!MY_TEST(i) || sphead->add_instr(i))
    return 1;

  /*
    BACKPATCH: Resolving forward jump from
    "case_stmt_action_when" to "case_stmt_action_then"
    (jump_if_not from instruction 2 to 5, 5 to 8 ... in the example)
  */

  sphead->backpatch(spcont->pop_label());

  /*
    BACKPATCH: Registering forward jump from
    "case_stmt_action_then" to after END CASE
    (jump from instruction 4 to 12, 7 to 12 ... in the example)
  */

  return sphead->push_backpatch(thd, i, spcont->last_label());
}


/**
  Helper action for a SET statement.
  Used to push a system variable into the assignment list.

  @param tmp      the system variable with base name
  @param var_type the scope of the variable
  @param val      the value being assigned to the variable

  @return TRUE if error, FALSE otherwise.
*/

bool
LEX::set_system_variable(enum enum_var_type var_type,
                         sys_var *sysvar, const LEX_CSTRING *base_name,
                         Item *val)
{
  set_var *setvar;

  /* No AUTOCOMMIT from a stored function or trigger. */
  if (spcont && sysvar == Sys_autocommit_ptr)
    sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;

  if (val && val->type() == Item::FIELD_ITEM &&
      ((Item_field*)val)->table_name)
  {
    my_error(ER_WRONG_TYPE_FOR_VAR, MYF(0), sysvar->name.str);
    return TRUE;
  }

  if (!(setvar= new (thd->mem_root) set_var(thd, var_type, sysvar,
                                            base_name, val)))
    return TRUE;

  return var_list.push_back(setvar, thd->mem_root);
}


/**
  Helper action for a SET statement.
  Used to SET a field of NEW row.

  @param name     the field name
  @param val      the value being assigned to the row

  @return TRUE if error, FALSE otherwise.
*/

bool LEX::set_trigger_new_row(const LEX_CSTRING *name, Item *val)
{
  Item_trigger_field *trg_fld;
  sp_instr_set_trigger_field *sp_fld;

  /* QQ: Shouldn't this be field's default value ? */
  if (! val)
    val= new (thd->mem_root) Item_null(thd);

  DBUG_ASSERT(trg_chistics.action_time == TRG_ACTION_BEFORE &&
              (trg_chistics.event == TRG_EVENT_INSERT ||
               trg_chistics.event == TRG_EVENT_UPDATE));

  trg_fld= new (thd->mem_root)
            Item_trigger_field(thd, current_context(),
                               Item_trigger_field::NEW_ROW,
                               name, UPDATE_ACL, FALSE);

  if (unlikely(trg_fld == NULL))
    return TRUE;

  sp_fld= new (thd->mem_root)
        sp_instr_set_trigger_field(sphead->instructions(),
                                   spcont, trg_fld, val, this);

  if (unlikely(sp_fld == NULL))
    return TRUE;

  /*
    Let us add this item to list of all Item_trigger_field
    objects in trigger.
  */
  trg_table_fields.link_in_list(trg_fld, &trg_fld->next_trg_field);

  return sphead->add_instr(sp_fld);
}


/**
  Create an object to represent a SP variable in the Item-hierarchy.

  @param  name        The SP variable name.
  @param  spvar       The SP variable (optional).
  @param  start_in_q  Start position of the SP variable name in the query.
  @param  end_in_q    End position of the SP variable name in the query.

  @remark If spvar is not specified, the name is used to search for the
          variable in the parse-time context. If the variable does not
          exist, a error is set and NULL is returned to the caller.

  @return An Item_splocal object representing the SP variable, or NULL on error.
*/
Item_splocal*
LEX::create_item_for_sp_var(const Lex_ident_cli_st *cname, sp_variable *spvar)
{
  const Sp_rcontext_handler *rh;
  Item_splocal *item;
  const char *start_in_q= cname->pos();
  const char *end_in_q= cname->end();
  uint pos_in_q, len_in_q;
  Lex_ident_sys name(thd, cname);

  if (name.is_null())
    return NULL;  // EOM

  /* If necessary, look for the variable. */
  if (spcont && !spvar)
    spvar= find_variable(&name, &rh);

  if (!spvar)
  {
    my_error(ER_SP_UNDECLARED_VAR, MYF(0), name.str);
    return NULL;
  }

  DBUG_ASSERT(spcont && spvar);

  /* Position and length of the SP variable name in the query. */
  pos_in_q= (uint)(start_in_q - sphead->m_tmp_query);
  len_in_q= (uint)(end_in_q - start_in_q);

  item= new (thd->mem_root)
    Item_splocal(thd, rh, &name, spvar->offset, spvar->type_handler(),
                 pos_in_q, len_in_q);

#ifdef DBUG_ASSERT_EXISTS
  if (item)
    item->m_sp= sphead;
#endif

  return item;
}

/**
  Helper to resolve the SQL:2003 Syntax exception 1) in <in predicate>.
  See SQL:2003, Part 2, section 8.4 <in predicate>, Note 184, page 383.
  This function returns the proper item for the SQL expression
  <code>left [NOT] IN ( expr )</code>
  @param thd the current thread
  @param left the in predicand
  @param equal true for IN predicates, false for NOT IN predicates
  @param expr first and only expression of the in value list
  @return an expression representing the IN predicate.
*/
Item* handle_sql2003_note184_exception(THD *thd, Item* left, bool equal,
                                       Item *expr)
{
  /*
    Relevant references for this issue:
    - SQL:2003, Part 2, section 8.4 <in predicate>, page 383,
    - SQL:2003, Part 2, section 7.2 <row value expression>, page 296,
    - SQL:2003, Part 2, section 6.3 <value expression primary>, page 174,
    - SQL:2003, Part 2, section 7.15 <subquery>, page 370,
    - SQL:2003 Feature F561, "Full value expressions".

    The exception in SQL:2003 Note 184 means:
    Item_singlerow_subselect, which corresponds to a <scalar subquery>,
    should be re-interpreted as an Item_in_subselect, which corresponds
    to a <table subquery> when used inside an <in predicate>.

    Our reading of Note 184 is reccursive, so that all:
    - IN (( <subquery> ))
    - IN ((( <subquery> )))
    - IN '('^N <subquery> ')'^N
    - etc
    should be interpreted as a <table subquery>, no matter how deep in the
    expression the <subquery> is.
  */

  Item *result;

  DBUG_ENTER("handle_sql2003_note184_exception");

  if (expr->type() == Item::SUBSELECT_ITEM)
  {
    Item_subselect *expr2 = (Item_subselect*) expr;

    if (expr2->substype() == Item_subselect::SINGLEROW_SUBS)
    {
      Item_singlerow_subselect *expr3 = (Item_singlerow_subselect*) expr2;
      st_select_lex *subselect;

      /*
        Implement the mandated change, by altering the semantic tree:
          left IN Item_singlerow_subselect(subselect)
        is modified to
          left IN (subselect)
        which is represented as
          Item_in_subselect(left, subselect)
      */
      subselect= expr3->invalidate_and_restore_select_lex();
      result= new (thd->mem_root) Item_in_subselect(thd, left, subselect);

      if (! equal)
        result = negate_expression(thd, result);

      DBUG_RETURN(result);
    }
  }

  if (equal)
    result= new (thd->mem_root) Item_func_eq(thd, left, expr);
  else
    result= new (thd->mem_root) Item_func_ne(thd, left, expr);

  DBUG_RETURN(result);
}

/**
  Create a separate LEX for each assignment if in SP.

  If we are in SP we want have own LEX for each assignment.
  This is mostly because it is hard for several sp_instr_set
  and sp_instr_set_trigger instructions share one LEX.
  (Well, it is theoretically possible but adds some extra
  overhead on preparation for execution stage and IMO less
  robust).

  QQ: May be we should simply prohibit group assignments in SP?

  @see sp_create_assignment_instr

  @param thd           Thread context
  @param no_lookahead  True if the parser has no lookahead
*/

bool sp_create_assignment_lex(THD *thd, bool no_lookahead)
{
  LEX *lex= thd->lex;

  if (lex->sphead)
  {
    Lex_input_stream *lip= &thd->m_parser_state->m_lip;
    LEX *old_lex= lex;
    lex->sphead->reset_lex(thd);
    lex= thd->lex;

    /* Set new LEX as if we at start of set rule. */
    lex->sql_command= SQLCOM_SET_OPTION;
    if (lex->main_select_push())
      return true;
    mysql_init_select(lex);
    lex->var_list.empty();
    lex->autocommit= 0;
    /* get_ptr() is only correct with no lookahead. */
    if (no_lookahead)
        lex->sphead->m_tmp_query= lip->get_ptr();
    else
        lex->sphead->m_tmp_query= lip->get_tok_end();
    /* Inherit from outer lex. */
    lex->option_type= old_lex->option_type;
  }
  return false;
}


/**
  Create a SP instruction for a SET assignment.

  @see sp_create_assignment_lex

  @param thd           Thread context
  @param no_lookahead  True if the parser has no lookahead

  @return false if success, true otherwise.
*/

bool sp_create_assignment_instr(THD *thd, bool no_lookahead)
{
  LEX *lex= thd->lex;

  if (lex->sphead)
  {
    if (!lex->var_list.is_empty())
    {
      /*
        We have assignment to user or system variable or
        option setting, so we should construct sp_instr_stmt
        for it.
      */
      Lex_input_stream *lip= &thd->m_parser_state->m_lip;

      /*
        Extract the query statement from the tokenizer.  The
        end is either lip->ptr, if there was no lookahead,
        lip->tok_end otherwise.
      */
      static const LEX_CSTRING setsp= { STRING_WITH_LEN("SET ") };
      const char *qend= no_lookahead ? lip->get_ptr() : lip->get_tok_end();
      Lex_cstring qbuf(lex->sphead->m_tmp_query, qend);
      if (lex->new_sp_instr_stmt(thd, setsp, qbuf))
        return true;
    }
    lex->pop_select();
    if (lex->check_main_unit_semantics())
    {
      /*
        "lex" can be referrenced by:
        - sp_instr_set                          SET a= expr;
        - sp_instr_set_row_field                SET r.a= expr;
        - sp_instr_stmt (just generated above)  SET @a= expr;
        In this case, "lex" is fully owned by sp_instr_xxx and it will
        be deleted by the destructor ~sp_instr_xxx().
        So we should remove "lex" from the stack sp_head::m_lex,
        to avoid double free.
        Note, in case "lex" is not owned by any sp_instr_xxx,
        it's also safe to remove it from the stack right now.
        So we can remove it unconditionally, without testing lex->sp_lex_in_use.
      */
      lex->sphead->restore_lex(thd);
      return true;
    }
    enum_var_type inner_option_type= lex->option_type;
    if (lex->sphead->restore_lex(thd))
      return true;
    /* Copy option_type to outer lex in case it has changed. */
    thd->lex->option_type= inner_option_type;
  }
  return false;
}

void LEX::add_key_to_list(LEX_CSTRING *field_name,
                          enum Key::Keytype type, bool check_exists)
{
  Key *key;
  MEM_ROOT *mem_root= thd->mem_root;
  key= new (mem_root)
        Key(type, &null_clex_str, HA_KEY_ALG_UNDEF, false,
             DDL_options(check_exists ?
                         DDL_options::OPT_IF_NOT_EXISTS :
                         DDL_options::OPT_NONE));
  key->columns.push_back(new (mem_root) Key_part_spec(field_name, 0),
                         mem_root);
  alter_info.key_list.push_back(key, mem_root);
}

bool LEX::add_alter_list(const char *name, Virtual_column_info *expr,
                         bool exists)
{
  MEM_ROOT *mem_root= thd->mem_root;
  Alter_column *ac= new (mem_root) Alter_column(name, expr, exists);
  if (unlikely(ac == NULL))
    return true;
  alter_info.alter_list.push_back(ac, mem_root);
  alter_info.flags|= ALTER_CHANGE_COLUMN_DEFAULT;
  return false;
}

void LEX::init_last_field(Column_definition *field,
                          const LEX_CSTRING *field_name,
                          const CHARSET_INFO *cs)
{
  last_field= field;

  field->field_name= *field_name;

  /* reset LEX fields that are used in Create_field::set_and_check() */
  charset= cs;
}


bool LEX::set_bincmp(CHARSET_INFO *cs, bool bin)
{
  /*
     if charset is NULL - we're parsing a field declaration.
     we cannot call find_bin_collation for a field here, because actual
     field charset is determined in get_sql_field_charset() much later.
     so we only set a flag.
  */
  if (!charset)
  {
    charset= cs;
    last_field->flags|= bin ? BINCMP_FLAG : 0;
    return false;
  }

  charset= bin ? find_bin_collation(cs ? cs : charset)
               :                    cs ? cs : charset;
  return charset == NULL;
}

#define bincmp_collation(X,Y)           \
  do                                    \
  {                                     \
     if (unlikely(Lex->set_bincmp(X,Y))) \
       MYSQL_YYABORT;                   \
  } while(0)


Virtual_column_info *add_virtual_expression(THD *thd, Item *expr)
{
  Virtual_column_info *v= new (thd->mem_root) Virtual_column_info();
  if (unlikely(!v))
     return 0;
   v->expr= expr;
   v->utf8= 0;  /* connection charset */
   return v;
}



#line 751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "sql_yacc.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABORT_SYM = 3,                  /* ABORT_SYM  */
  YYSYMBOL_ACCESSIBLE_SYM = 4,             /* ACCESSIBLE_SYM  */
  YYSYMBOL_ADD = 5,                        /* ADD  */
  YYSYMBOL_ALL = 6,                        /* ALL  */
  YYSYMBOL_ALTER = 7,                      /* ALTER  */
  YYSYMBOL_ANALYZE_SYM = 8,                /* ANALYZE_SYM  */
  YYSYMBOL_AND_AND_SYM = 9,                /* AND_AND_SYM  */
  YYSYMBOL_AND_SYM = 10,                   /* AND_SYM  */
  YYSYMBOL_AS = 11,                        /* AS  */
  YYSYMBOL_ASC = 12,                       /* ASC  */
  YYSYMBOL_ASENSITIVE_SYM = 13,            /* ASENSITIVE_SYM  */
  YYSYMBOL_BEFORE_SYM = 14,                /* BEFORE_SYM  */
  YYSYMBOL_BETWEEN_SYM = 15,               /* BETWEEN_SYM  */
  YYSYMBOL_BIGINT = 16,                    /* BIGINT  */
  YYSYMBOL_BINARY = 17,                    /* BINARY  */
  YYSYMBOL_BIN_NUM = 18,                   /* BIN_NUM  */
  YYSYMBOL_BIT_AND = 19,                   /* BIT_AND  */
  YYSYMBOL_BIT_OR = 20,                    /* BIT_OR  */
  YYSYMBOL_BIT_XOR = 21,                   /* BIT_XOR  */
  YYSYMBOL_BLOB_MARIADB_SYM = 22,          /* BLOB_MARIADB_SYM  */
  YYSYMBOL_BLOB_ORACLE_SYM = 23,           /* BLOB_ORACLE_SYM  */
  YYSYMBOL_BODY_ORACLE_SYM = 24,           /* BODY_ORACLE_SYM  */
  YYSYMBOL_BOTH = 25,                      /* BOTH  */
  YYSYMBOL_BY = 26,                        /* BY  */
  YYSYMBOL_CALL_SYM = 27,                  /* CALL_SYM  */
  YYSYMBOL_CASCADE = 28,                   /* CASCADE  */
  YYSYMBOL_CASE_SYM = 29,                  /* CASE_SYM  */
  YYSYMBOL_CAST_SYM = 30,                  /* CAST_SYM  */
  YYSYMBOL_CHANGE = 31,                    /* CHANGE  */
  YYSYMBOL_CHAR_SYM = 32,                  /* CHAR_SYM  */
  YYSYMBOL_CHECK_SYM = 33,                 /* CHECK_SYM  */
  YYSYMBOL_COLLATE_SYM = 34,               /* COLLATE_SYM  */
  YYSYMBOL_CONDITION_SYM = 35,             /* CONDITION_SYM  */
  YYSYMBOL_CONSTRAINT = 36,                /* CONSTRAINT  */
  YYSYMBOL_CONTINUE_MARIADB_SYM = 37,      /* CONTINUE_MARIADB_SYM  */
  YYSYMBOL_CONTINUE_ORACLE_SYM = 38,       /* CONTINUE_ORACLE_SYM  */
  YYSYMBOL_CONVERT_SYM = 39,               /* CONVERT_SYM  */
  YYSYMBOL_COUNT_SYM = 40,                 /* COUNT_SYM  */
  YYSYMBOL_CREATE = 41,                    /* CREATE  */
  YYSYMBOL_CROSS = 42,                     /* CROSS  */
  YYSYMBOL_CUME_DIST_SYM = 43,             /* CUME_DIST_SYM  */
  YYSYMBOL_CURDATE = 44,                   /* CURDATE  */
  YYSYMBOL_CURRENT_USER = 45,              /* CURRENT_USER  */
  YYSYMBOL_CURRENT_ROLE = 46,              /* CURRENT_ROLE  */
  YYSYMBOL_CURSOR_SYM = 47,                /* CURSOR_SYM  */
  YYSYMBOL_CURTIME = 48,                   /* CURTIME  */
  YYSYMBOL_DATABASE = 49,                  /* DATABASE  */
  YYSYMBOL_DATABASES = 50,                 /* DATABASES  */
  YYSYMBOL_DATE_ADD_INTERVAL = 51,         /* DATE_ADD_INTERVAL  */
  YYSYMBOL_DATE_SUB_INTERVAL = 52,         /* DATE_SUB_INTERVAL  */
  YYSYMBOL_DAY_HOUR_SYM = 53,              /* DAY_HOUR_SYM  */
  YYSYMBOL_DAY_MICROSECOND_SYM = 54,       /* DAY_MICROSECOND_SYM  */
  YYSYMBOL_DAY_MINUTE_SYM = 55,            /* DAY_MINUTE_SYM  */
  YYSYMBOL_DAY_SECOND_SYM = 56,            /* DAY_SECOND_SYM  */
  YYSYMBOL_DECIMAL_NUM = 57,               /* DECIMAL_NUM  */
  YYSYMBOL_DECIMAL_SYM = 58,               /* DECIMAL_SYM  */
  YYSYMBOL_DECLARE_MARIADB_SYM = 59,       /* DECLARE_MARIADB_SYM  */
  YYSYMBOL_DECLARE_ORACLE_SYM = 60,        /* DECLARE_ORACLE_SYM  */
  YYSYMBOL_DEFAULT = 61,                   /* DEFAULT  */
  YYSYMBOL_DELETE_DOMAIN_ID_SYM = 62,      /* DELETE_DOMAIN_ID_SYM  */
  YYSYMBOL_DELETE_SYM = 63,                /* DELETE_SYM  */
  YYSYMBOL_DENSE_RANK_SYM = 64,            /* DENSE_RANK_SYM  */
  YYSYMBOL_DESC = 65,                      /* DESC  */
  YYSYMBOL_DESCRIBE = 66,                  /* DESCRIBE  */
  YYSYMBOL_DETERMINISTIC_SYM = 67,         /* DETERMINISTIC_SYM  */
  YYSYMBOL_DISTINCT = 68,                  /* DISTINCT  */
  YYSYMBOL_DIV_SYM = 69,                   /* DIV_SYM  */
  YYSYMBOL_DOUBLE_SYM = 70,                /* DOUBLE_SYM  */
  YYSYMBOL_DO_DOMAIN_IDS_SYM = 71,         /* DO_DOMAIN_IDS_SYM  */
  YYSYMBOL_DOT_DOT_SYM = 72,               /* DOT_DOT_SYM  */
  YYSYMBOL_DROP = 73,                      /* DROP  */
  YYSYMBOL_DUAL_SYM = 74,                  /* DUAL_SYM  */
  YYSYMBOL_EACH_SYM = 75,                  /* EACH_SYM  */
  YYSYMBOL_ELSE = 76,                      /* ELSE  */
  YYSYMBOL_ELSEIF_MARIADB_SYM = 77,        /* ELSEIF_MARIADB_SYM  */
  YYSYMBOL_ELSIF_ORACLE_SYM = 78,          /* ELSIF_ORACLE_SYM  */
  YYSYMBOL_ENCLOSED = 79,                  /* ENCLOSED  */
  YYSYMBOL_END_OF_INPUT = 80,              /* END_OF_INPUT  */
  YYSYMBOL_EQUAL_SYM = 81,                 /* EQUAL_SYM  */
  YYSYMBOL_ESCAPED = 82,                   /* ESCAPED  */
  YYSYMBOL_EXCEPT_SYM = 83,                /* EXCEPT_SYM  */
  YYSYMBOL_EXISTS = 84,                    /* EXISTS  */
  YYSYMBOL_EXTRACT_SYM = 85,               /* EXTRACT_SYM  */
  YYSYMBOL_FALSE_SYM = 86,                 /* FALSE_SYM  */
  YYSYMBOL_FETCH_SYM = 87,                 /* FETCH_SYM  */
  YYSYMBOL_FIRST_VALUE_SYM = 88,           /* FIRST_VALUE_SYM  */
  YYSYMBOL_FLOAT_NUM = 89,                 /* FLOAT_NUM  */
  YYSYMBOL_FLOAT_SYM = 90,                 /* FLOAT_SYM  */
  YYSYMBOL_FORCE_LOOKAHEAD = 91,           /* FORCE_LOOKAHEAD  */
  YYSYMBOL_FOREIGN = 92,                   /* FOREIGN  */
  YYSYMBOL_FOR_SYM = 93,                   /* FOR_SYM  */
  YYSYMBOL_FOR_SYSTEM_TIME_SYM = 94,       /* FOR_SYSTEM_TIME_SYM  */
  YYSYMBOL_FROM = 95,                      /* FROM  */
  YYSYMBOL_FULLTEXT_SYM = 96,              /* FULLTEXT_SYM  */
  YYSYMBOL_GE = 97,                        /* GE  */
  YYSYMBOL_GOTO_ORACLE_SYM = 98,           /* GOTO_ORACLE_SYM  */
  YYSYMBOL_GRANT = 99,                     /* GRANT  */
  YYSYMBOL_GROUP_SYM = 100,                /* GROUP_SYM  */
  YYSYMBOL_GROUP_CONCAT_SYM = 101,         /* GROUP_CONCAT_SYM  */
  YYSYMBOL_LAG_SYM = 102,                  /* LAG_SYM  */
  YYSYMBOL_LEAD_SYM = 103,                 /* LEAD_SYM  */
  YYSYMBOL_HAVING = 104,                   /* HAVING  */
  YYSYMBOL_HEX_NUM = 105,                  /* HEX_NUM  */
  YYSYMBOL_HEX_STRING = 106,               /* HEX_STRING  */
  YYSYMBOL_HOUR_MICROSECOND_SYM = 107,     /* HOUR_MICROSECOND_SYM  */
  YYSYMBOL_HOUR_MINUTE_SYM = 108,          /* HOUR_MINUTE_SYM  */
  YYSYMBOL_HOUR_SECOND_SYM = 109,          /* HOUR_SECOND_SYM  */
  YYSYMBOL_IDENT = 110,                    /* IDENT  */
  YYSYMBOL_IDENT_QUOTED = 111,             /* IDENT_QUOTED  */
  YYSYMBOL_IF_SYM = 112,                   /* IF_SYM  */
  YYSYMBOL_IGNORE_DOMAIN_IDS_SYM = 113,    /* IGNORE_DOMAIN_IDS_SYM  */
  YYSYMBOL_IGNORE_SYM = 114,               /* IGNORE_SYM  */
  YYSYMBOL_INDEX_SYM = 115,                /* INDEX_SYM  */
  YYSYMBOL_INFILE = 116,                   /* INFILE  */
  YYSYMBOL_INNER_SYM = 117,                /* INNER_SYM  */
  YYSYMBOL_INOUT_SYM = 118,                /* INOUT_SYM  */
  YYSYMBOL_INSENSITIVE_SYM = 119,          /* INSENSITIVE_SYM  */
  YYSYMBOL_INSERT = 120,                   /* INSERT  */
  YYSYMBOL_INTERSECT_SYM = 121,            /* INTERSECT_SYM  */
  YYSYMBOL_INTERVAL_SYM = 122,             /* INTERVAL_SYM  */
  YYSYMBOL_INTO = 123,                     /* INTO  */
  YYSYMBOL_INT_SYM = 124,                  /* INT_SYM  */
  YYSYMBOL_IN_SYM = 125,                   /* IN_SYM  */
  YYSYMBOL_IS = 126,                       /* IS  */
  YYSYMBOL_ITERATE_SYM = 127,              /* ITERATE_SYM  */
  YYSYMBOL_JOIN_SYM = 128,                 /* JOIN_SYM  */
  YYSYMBOL_KEYS = 129,                     /* KEYS  */
  YYSYMBOL_KEY_SYM = 130,                  /* KEY_SYM  */
  YYSYMBOL_KILL_SYM = 131,                 /* KILL_SYM  */
  YYSYMBOL_LE = 132,                       /* LE  */
  YYSYMBOL_LEADING = 133,                  /* LEADING  */
  YYSYMBOL_LEAVE_SYM = 134,                /* LEAVE_SYM  */
  YYSYMBOL_LEFT = 135,                     /* LEFT  */
  YYSYMBOL_LEFT_PAREN_ALT = 136,           /* LEFT_PAREN_ALT  */
  YYSYMBOL_LEFT_PAREN_WITH = 137,          /* LEFT_PAREN_WITH  */
  YYSYMBOL_LEFT_PAREN_LIKE = 138,          /* LEFT_PAREN_LIKE  */
  YYSYMBOL_LEX_HOSTNAME = 139,             /* LEX_HOSTNAME  */
  YYSYMBOL_LIKE = 140,                     /* LIKE  */
  YYSYMBOL_LIMIT = 141,                    /* LIMIT  */
  YYSYMBOL_LINEAR_SYM = 142,               /* LINEAR_SYM  */
  YYSYMBOL_LINES = 143,                    /* LINES  */
  YYSYMBOL_LOAD = 144,                     /* LOAD  */
  YYSYMBOL_LOCATOR_SYM = 145,              /* LOCATOR_SYM  */
  YYSYMBOL_LOCK_SYM = 146,                 /* LOCK_SYM  */
  YYSYMBOL_LONGBLOB = 147,                 /* LONGBLOB  */
  YYSYMBOL_LONGTEXT = 148,                 /* LONGTEXT  */
  YYSYMBOL_LONG_NUM = 149,                 /* LONG_NUM  */
  YYSYMBOL_LONG_SYM = 150,                 /* LONG_SYM  */
  YYSYMBOL_LOOP_SYM = 151,                 /* LOOP_SYM  */
  YYSYMBOL_LOW_PRIORITY = 152,             /* LOW_PRIORITY  */
  YYSYMBOL_MASTER_SSL_VERIFY_SERVER_CERT_SYM = 153, /* MASTER_SSL_VERIFY_SERVER_CERT_SYM  */
  YYSYMBOL_MATCH = 154,                    /* MATCH  */
  YYSYMBOL_MAX_SYM = 155,                  /* MAX_SYM  */
  YYSYMBOL_MAXVALUE_SYM = 156,             /* MAXVALUE_SYM  */
  YYSYMBOL_MEDIAN_SYM = 157,               /* MEDIAN_SYM  */
  YYSYMBOL_MEDIUMBLOB = 158,               /* MEDIUMBLOB  */
  YYSYMBOL_MEDIUMINT = 159,                /* MEDIUMINT  */
  YYSYMBOL_MEDIUMTEXT = 160,               /* MEDIUMTEXT  */
  YYSYMBOL_MINUTE_MICROSECOND_SYM = 161,   /* MINUTE_MICROSECOND_SYM  */
  YYSYMBOL_MINUTE_SECOND_SYM = 162,        /* MINUTE_SECOND_SYM  */
  YYSYMBOL_MIN_SYM = 163,                  /* MIN_SYM  */
  YYSYMBOL_MODIFIES_SYM = 164,             /* MODIFIES_SYM  */
  YYSYMBOL_MOD_SYM = 165,                  /* MOD_SYM  */
  YYSYMBOL_MYSQL_CONCAT_SYM = 166,         /* MYSQL_CONCAT_SYM  */
  YYSYMBOL_NATURAL = 167,                  /* NATURAL  */
  YYSYMBOL_NCHAR_STRING = 168,             /* NCHAR_STRING  */
  YYSYMBOL_NE = 169,                       /* NE  */
  YYSYMBOL_NEG = 170,                      /* NEG  */
  YYSYMBOL_NOT2_SYM = 171,                 /* NOT2_SYM  */
  YYSYMBOL_NOT_SYM = 172,                  /* NOT_SYM  */
  YYSYMBOL_NOW_SYM = 173,                  /* NOW_SYM  */
  YYSYMBOL_NO_WRITE_TO_BINLOG = 174,       /* NO_WRITE_TO_BINLOG  */
  YYSYMBOL_NTILE_SYM = 175,                /* NTILE_SYM  */
  YYSYMBOL_NULL_SYM = 176,                 /* NULL_SYM  */
  YYSYMBOL_NUM = 177,                      /* NUM  */
  YYSYMBOL_NUMERIC_SYM = 178,              /* NUMERIC_SYM  */
  YYSYMBOL_NTH_VALUE_SYM = 179,            /* NTH_VALUE_SYM  */
  YYSYMBOL_ON = 180,                       /* ON  */
  YYSYMBOL_OPTIMIZE = 181,                 /* OPTIMIZE  */
  YYSYMBOL_OPTIONALLY = 182,               /* OPTIONALLY  */
  YYSYMBOL_ORACLE_CONCAT_SYM = 183,        /* ORACLE_CONCAT_SYM  */
  YYSYMBOL_OR2_SYM = 184,                  /* OR2_SYM  */
  YYSYMBOL_ORDER_SYM = 185,                /* ORDER_SYM  */
  YYSYMBOL_OR_SYM = 186,                   /* OR_SYM  */
  YYSYMBOL_OTHERS_ORACLE_SYM = 187,        /* OTHERS_ORACLE_SYM  */
  YYSYMBOL_OUTER = 188,                    /* OUTER  */
  YYSYMBOL_OUTFILE = 189,                  /* OUTFILE  */
  YYSYMBOL_OUT_SYM = 190,                  /* OUT_SYM  */
  YYSYMBOL_OVER_SYM = 191,                 /* OVER_SYM  */
  YYSYMBOL_PACKAGE_ORACLE_SYM = 192,       /* PACKAGE_ORACLE_SYM  */
  YYSYMBOL_PAGE_CHECKSUM_SYM = 193,        /* PAGE_CHECKSUM_SYM  */
  YYSYMBOL_PARAM_MARKER = 194,             /* PARAM_MARKER  */
  YYSYMBOL_PARSE_VCOL_EXPR_SYM = 195,      /* PARSE_VCOL_EXPR_SYM  */
  YYSYMBOL_PARTITION_SYM = 196,            /* PARTITION_SYM  */
  YYSYMBOL_PERCENT_ORACLE_SYM = 197,       /* PERCENT_ORACLE_SYM  */
  YYSYMBOL_PERCENT_RANK_SYM = 198,         /* PERCENT_RANK_SYM  */
  YYSYMBOL_PERCENTILE_CONT_SYM = 199,      /* PERCENTILE_CONT_SYM  */
  YYSYMBOL_PERCENTILE_DISC_SYM = 200,      /* PERCENTILE_DISC_SYM  */
  YYSYMBOL_PORTION_SYM = 201,              /* PORTION_SYM  */
  YYSYMBOL_POSITION_SYM = 202,             /* POSITION_SYM  */
  YYSYMBOL_PRECISION = 203,                /* PRECISION  */
  YYSYMBOL_PRIMARY_SYM = 204,              /* PRIMARY_SYM  */
  YYSYMBOL_PROCEDURE_SYM = 205,            /* PROCEDURE_SYM  */
  YYSYMBOL_PURGE = 206,                    /* PURGE  */
  YYSYMBOL_RAISE_ORACLE_SYM = 207,         /* RAISE_ORACLE_SYM  */
  YYSYMBOL_RANGE_SYM = 208,                /* RANGE_SYM  */
  YYSYMBOL_RANK_SYM = 209,                 /* RANK_SYM  */
  YYSYMBOL_READS_SYM = 210,                /* READS_SYM  */
  YYSYMBOL_READ_SYM = 211,                 /* READ_SYM  */
  YYSYMBOL_READ_WRITE_SYM = 212,           /* READ_WRITE_SYM  */
  YYSYMBOL_REAL = 213,                     /* REAL  */
  YYSYMBOL_RECURSIVE_SYM = 214,            /* RECURSIVE_SYM  */
  YYSYMBOL_REF_SYSTEM_ID_SYM = 215,        /* REF_SYSTEM_ID_SYM  */
  YYSYMBOL_REFERENCES = 216,               /* REFERENCES  */
  YYSYMBOL_REGEXP = 217,                   /* REGEXP  */
  YYSYMBOL_RELEASE_SYM = 218,              /* RELEASE_SYM  */
  YYSYMBOL_RENAME = 219,                   /* RENAME  */
  YYSYMBOL_REPEAT_SYM = 220,               /* REPEAT_SYM  */
  YYSYMBOL_REQUIRE_SYM = 221,              /* REQUIRE_SYM  */
  YYSYMBOL_RESIGNAL_SYM = 222,             /* RESIGNAL_SYM  */
  YYSYMBOL_RESTRICT = 223,                 /* RESTRICT  */
  YYSYMBOL_RETURNING_SYM = 224,            /* RETURNING_SYM  */
  YYSYMBOL_RETURN_MARIADB_SYM = 225,       /* RETURN_MARIADB_SYM  */
  YYSYMBOL_RETURN_ORACLE_SYM = 226,        /* RETURN_ORACLE_SYM  */
  YYSYMBOL_REVOKE = 227,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 228,                    /* RIGHT  */
  YYSYMBOL_ROWS_SYM = 229,                 /* ROWS_SYM  */
  YYSYMBOL_ROWTYPE_ORACLE_SYM = 230,       /* ROWTYPE_ORACLE_SYM  */
  YYSYMBOL_ROW_NUMBER_SYM = 231,           /* ROW_NUMBER_SYM  */
  YYSYMBOL_SECOND_MICROSECOND_SYM = 232,   /* SECOND_MICROSECOND_SYM  */
  YYSYMBOL_SELECT_SYM = 233,               /* SELECT_SYM  */
  YYSYMBOL_SENSITIVE_SYM = 234,            /* SENSITIVE_SYM  */
  YYSYMBOL_SEPARATOR_SYM = 235,            /* SEPARATOR_SYM  */
  YYSYMBOL_SERVER_OPTIONS = 236,           /* SERVER_OPTIONS  */
  YYSYMBOL_SET = 237,                      /* SET  */
  YYSYMBOL_SET_VAR = 238,                  /* SET_VAR  */
  YYSYMBOL_SHIFT_LEFT = 239,               /* SHIFT_LEFT  */
  YYSYMBOL_SHIFT_RIGHT = 240,              /* SHIFT_RIGHT  */
  YYSYMBOL_SHOW = 241,                     /* SHOW  */
  YYSYMBOL_SIGNAL_SYM = 242,               /* SIGNAL_SYM  */
  YYSYMBOL_SMALLINT = 243,                 /* SMALLINT  */
  YYSYMBOL_SPATIAL_SYM = 244,              /* SPATIAL_SYM  */
  YYSYMBOL_SPECIFIC_SYM = 245,             /* SPECIFIC_SYM  */
  YYSYMBOL_SQLEXCEPTION_SYM = 246,         /* SQLEXCEPTION_SYM  */
  YYSYMBOL_SQLSTATE_SYM = 247,             /* SQLSTATE_SYM  */
  YYSYMBOL_SQLWARNING_SYM = 248,           /* SQLWARNING_SYM  */
  YYSYMBOL_SQL_BIG_RESULT = 249,           /* SQL_BIG_RESULT  */
  YYSYMBOL_SQL_SMALL_RESULT = 250,         /* SQL_SMALL_RESULT  */
  YYSYMBOL_SQL_SYM = 251,                  /* SQL_SYM  */
  YYSYMBOL_SSL_SYM = 252,                  /* SSL_SYM  */
  YYSYMBOL_STARTING = 253,                 /* STARTING  */
  YYSYMBOL_STATS_AUTO_RECALC_SYM = 254,    /* STATS_AUTO_RECALC_SYM  */
  YYSYMBOL_STATS_PERSISTENT_SYM = 255,     /* STATS_PERSISTENT_SYM  */
  YYSYMBOL_STATS_SAMPLE_PAGES_SYM = 256,   /* STATS_SAMPLE_PAGES_SYM  */
  YYSYMBOL_STDDEV_SAMP_SYM = 257,          /* STDDEV_SAMP_SYM  */
  YYSYMBOL_STD_SYM = 258,                  /* STD_SYM  */
  YYSYMBOL_STRAIGHT_JOIN = 259,            /* STRAIGHT_JOIN  */
  YYSYMBOL_SUM_SYM = 260,                  /* SUM_SYM  */
  YYSYMBOL_SYSDATE = 261,                  /* SYSDATE  */
  YYSYMBOL_TABLE_REF_PRIORITY = 262,       /* TABLE_REF_PRIORITY  */
  YYSYMBOL_TABLE_SYM = 263,                /* TABLE_SYM  */
  YYSYMBOL_TERMINATED = 264,               /* TERMINATED  */
  YYSYMBOL_TEXT_STRING = 265,              /* TEXT_STRING  */
  YYSYMBOL_THEN_SYM = 266,                 /* THEN_SYM  */
  YYSYMBOL_TINYBLOB = 267,                 /* TINYBLOB  */
  YYSYMBOL_TINYINT = 268,                  /* TINYINT  */
  YYSYMBOL_TINYTEXT = 269,                 /* TINYTEXT  */
  YYSYMBOL_TO_SYM = 270,                   /* TO_SYM  */
  YYSYMBOL_TRAILING = 271,                 /* TRAILING  */
  YYSYMBOL_TRIGGER_SYM = 272,              /* TRIGGER_SYM  */
  YYSYMBOL_TRUE_SYM = 273,                 /* TRUE_SYM  */
  YYSYMBOL_ULONGLONG_NUM = 274,            /* ULONGLONG_NUM  */
  YYSYMBOL_UNDERSCORE_CHARSET = 275,       /* UNDERSCORE_CHARSET  */
  YYSYMBOL_UNDO_SYM = 276,                 /* UNDO_SYM  */
  YYSYMBOL_UNION_SYM = 277,                /* UNION_SYM  */
  YYSYMBOL_UNIQUE_SYM = 278,               /* UNIQUE_SYM  */
  YYSYMBOL_UNLOCK_SYM = 279,               /* UNLOCK_SYM  */
  YYSYMBOL_UNSIGNED = 280,                 /* UNSIGNED  */
  YYSYMBOL_UPDATE_SYM = 281,               /* UPDATE_SYM  */
  YYSYMBOL_USAGE = 282,                    /* USAGE  */
  YYSYMBOL_USE_SYM = 283,                  /* USE_SYM  */
  YYSYMBOL_USING = 284,                    /* USING  */
  YYSYMBOL_UTC_DATE_SYM = 285,             /* UTC_DATE_SYM  */
  YYSYMBOL_UTC_TIMESTAMP_SYM = 286,        /* UTC_TIMESTAMP_SYM  */
  YYSYMBOL_UTC_TIME_SYM = 287,             /* UTC_TIME_SYM  */
  YYSYMBOL_VALUES = 288,                   /* VALUES  */
  YYSYMBOL_VALUES_IN_SYM = 289,            /* VALUES_IN_SYM  */
  YYSYMBOL_VALUES_LESS_SYM = 290,          /* VALUES_LESS_SYM  */
  YYSYMBOL_VARBINARY = 291,                /* VARBINARY  */
  YYSYMBOL_VARCHAR = 292,                  /* VARCHAR  */
  YYSYMBOL_VARIANCE_SYM = 293,             /* VARIANCE_SYM  */
  YYSYMBOL_VARYING = 294,                  /* VARYING  */
  YYSYMBOL_VAR_SAMP_SYM = 295,             /* VAR_SAMP_SYM  */
  YYSYMBOL_WHEN_SYM = 296,                 /* WHEN_SYM  */
  YYSYMBOL_WHERE = 297,                    /* WHERE  */
  YYSYMBOL_WHILE_SYM = 298,                /* WHILE_SYM  */
  YYSYMBOL_WITH = 299,                     /* WITH  */
  YYSYMBOL_WITH_CUBE_SYM = 300,            /* WITH_CUBE_SYM  */
  YYSYMBOL_WITH_ROLLUP_SYM = 301,          /* WITH_ROLLUP_SYM  */
  YYSYMBOL_WITH_SYSTEM_SYM = 302,          /* WITH_SYSTEM_SYM  */
  YYSYMBOL_XOR = 303,                      /* XOR  */
  YYSYMBOL_YEAR_MONTH_SYM = 304,           /* YEAR_MONTH_SYM  */
  YYSYMBOL_ZEROFILL = 305,                 /* ZEROFILL  */
  YYSYMBOL_IMPOSSIBLE_ACTION = 306,        /* IMPOSSIBLE_ACTION  */
  YYSYMBOL_BODY_MARIADB_SYM = 307,         /* BODY_MARIADB_SYM  */
  YYSYMBOL_ELSEIF_ORACLE_SYM = 308,        /* ELSEIF_ORACLE_SYM  */
  YYSYMBOL_ELSIF_MARIADB_SYM = 309,        /* ELSIF_MARIADB_SYM  */
  YYSYMBOL_EXCEPTION_ORACLE_SYM = 310,     /* EXCEPTION_ORACLE_SYM  */
  YYSYMBOL_GOTO_MARIADB_SYM = 311,         /* GOTO_MARIADB_SYM  */
  YYSYMBOL_OTHERS_MARIADB_SYM = 312,       /* OTHERS_MARIADB_SYM  */
  YYSYMBOL_PACKAGE_MARIADB_SYM = 313,      /* PACKAGE_MARIADB_SYM  */
  YYSYMBOL_RAISE_MARIADB_SYM = 314,        /* RAISE_MARIADB_SYM  */
  YYSYMBOL_ROWTYPE_MARIADB_SYM = 315,      /* ROWTYPE_MARIADB_SYM  */
  YYSYMBOL_REPLACE = 316,                  /* REPLACE  */
  YYSYMBOL_SUBSTRING = 317,                /* SUBSTRING  */
  YYSYMBOL_TRIM = 318,                     /* TRIM  */
  YYSYMBOL_ACCOUNT_SYM = 319,              /* ACCOUNT_SYM  */
  YYSYMBOL_ACTION = 320,                   /* ACTION  */
  YYSYMBOL_ADMIN_SYM = 321,                /* ADMIN_SYM  */
  YYSYMBOL_ADDDATE_SYM = 322,              /* ADDDATE_SYM  */
  YYSYMBOL_AFTER_SYM = 323,                /* AFTER_SYM  */
  YYSYMBOL_AGAINST = 324,                  /* AGAINST  */
  YYSYMBOL_AGGREGATE_SYM = 325,            /* AGGREGATE_SYM  */
  YYSYMBOL_ALGORITHM_SYM = 326,            /* ALGORITHM_SYM  */
  YYSYMBOL_ALWAYS_SYM = 327,               /* ALWAYS_SYM  */
  YYSYMBOL_ANY_SYM = 328,                  /* ANY_SYM  */
  YYSYMBOL_ASCII_SYM = 329,                /* ASCII_SYM  */
  YYSYMBOL_AT_SYM = 330,                   /* AT_SYM  */
  YYSYMBOL_ATOMIC_SYM = 331,               /* ATOMIC_SYM  */
  YYSYMBOL_AUTHORS_SYM = 332,              /* AUTHORS_SYM  */
  YYSYMBOL_AUTOEXTEND_SIZE_SYM = 333,      /* AUTOEXTEND_SIZE_SYM  */
  YYSYMBOL_AUTO_INC = 334,                 /* AUTO_INC  */
  YYSYMBOL_AUTO_SYM = 335,                 /* AUTO_SYM  */
  YYSYMBOL_AVG_ROW_LENGTH = 336,           /* AVG_ROW_LENGTH  */
  YYSYMBOL_AVG_SYM = 337,                  /* AVG_SYM  */
  YYSYMBOL_BACKUP_SYM = 338,               /* BACKUP_SYM  */
  YYSYMBOL_BEGIN_MARIADB_SYM = 339,        /* BEGIN_MARIADB_SYM  */
  YYSYMBOL_BEGIN_ORACLE_SYM = 340,         /* BEGIN_ORACLE_SYM  */
  YYSYMBOL_BINLOG_SYM = 341,               /* BINLOG_SYM  */
  YYSYMBOL_BIT_SYM = 342,                  /* BIT_SYM  */
  YYSYMBOL_BLOCK_SYM = 343,                /* BLOCK_SYM  */
  YYSYMBOL_BOOL_SYM = 344,                 /* BOOL_SYM  */
  YYSYMBOL_BOOLEAN_SYM = 345,              /* BOOLEAN_SYM  */
  YYSYMBOL_BTREE_SYM = 346,                /* BTREE_SYM  */
  YYSYMBOL_BYTE_SYM = 347,                 /* BYTE_SYM  */
  YYSYMBOL_CACHE_SYM = 348,                /* CACHE_SYM  */
  YYSYMBOL_CASCADED = 349,                 /* CASCADED  */
  YYSYMBOL_CATALOG_NAME_SYM = 350,         /* CATALOG_NAME_SYM  */
  YYSYMBOL_CHAIN_SYM = 351,                /* CHAIN_SYM  */
  YYSYMBOL_CHANGED = 352,                  /* CHANGED  */
  YYSYMBOL_CHARSET = 353,                  /* CHARSET  */
  YYSYMBOL_CHECKPOINT_SYM = 354,           /* CHECKPOINT_SYM  */
  YYSYMBOL_CHECKSUM_SYM = 355,             /* CHECKSUM_SYM  */
  YYSYMBOL_CIPHER_SYM = 356,               /* CIPHER_SYM  */
  YYSYMBOL_CLASS_ORIGIN_SYM = 357,         /* CLASS_ORIGIN_SYM  */
  YYSYMBOL_CLIENT_SYM = 358,               /* CLIENT_SYM  */
  YYSYMBOL_CLOB_MARIADB_SYM = 359,         /* CLOB_MARIADB_SYM  */
  YYSYMBOL_CLOB_ORACLE_SYM = 360,          /* CLOB_ORACLE_SYM  */
  YYSYMBOL_CLOSE_SYM = 361,                /* CLOSE_SYM  */
  YYSYMBOL_COALESCE = 362,                 /* COALESCE  */
  YYSYMBOL_CODE_SYM = 363,                 /* CODE_SYM  */
  YYSYMBOL_COLLATION_SYM = 364,            /* COLLATION_SYM  */
  YYSYMBOL_COLON_ORACLE_SYM = 365,         /* COLON_ORACLE_SYM  */
  YYSYMBOL_COLUMNS = 366,                  /* COLUMNS  */
  YYSYMBOL_COLUMN_ADD_SYM = 367,           /* COLUMN_ADD_SYM  */
  YYSYMBOL_COLUMN_CHECK_SYM = 368,         /* COLUMN_CHECK_SYM  */
  YYSYMBOL_COLUMN_CREATE_SYM = 369,        /* COLUMN_CREATE_SYM  */
  YYSYMBOL_COLUMN_DELETE_SYM = 370,        /* COLUMN_DELETE_SYM  */
  YYSYMBOL_COLUMN_GET_SYM = 371,           /* COLUMN_GET_SYM  */
  YYSYMBOL_COLUMN_SYM = 372,               /* COLUMN_SYM  */
  YYSYMBOL_COLUMN_NAME_SYM = 373,          /* COLUMN_NAME_SYM  */
  YYSYMBOL_COMMENT_SYM = 374,              /* COMMENT_SYM  */
  YYSYMBOL_COMMITTED_SYM = 375,            /* COMMITTED_SYM  */
  YYSYMBOL_COMMIT_SYM = 376,               /* COMMIT_SYM  */
  YYSYMBOL_COMPACT_SYM = 377,              /* COMPACT_SYM  */
  YYSYMBOL_COMPLETION_SYM = 378,           /* COMPLETION_SYM  */
  YYSYMBOL_COMPRESSED_SYM = 379,           /* COMPRESSED_SYM  */
  YYSYMBOL_CONCURRENT = 380,               /* CONCURRENT  */
  YYSYMBOL_CONNECTION_SYM = 381,           /* CONNECTION_SYM  */
  YYSYMBOL_CONSISTENT_SYM = 382,           /* CONSISTENT_SYM  */
  YYSYMBOL_CONSTRAINT_CATALOG_SYM = 383,   /* CONSTRAINT_CATALOG_SYM  */
  YYSYMBOL_CONSTRAINT_NAME_SYM = 384,      /* CONSTRAINT_NAME_SYM  */
  YYSYMBOL_CONSTRAINT_SCHEMA_SYM = 385,    /* CONSTRAINT_SCHEMA_SYM  */
  YYSYMBOL_CONTAINS_SYM = 386,             /* CONTAINS_SYM  */
  YYSYMBOL_CONTEXT_SYM = 387,              /* CONTEXT_SYM  */
  YYSYMBOL_CONTRIBUTORS_SYM = 388,         /* CONTRIBUTORS_SYM  */
  YYSYMBOL_CPU_SYM = 389,                  /* CPU_SYM  */
  YYSYMBOL_CUBE_SYM = 390,                 /* CUBE_SYM  */
  YYSYMBOL_CURRENT_SYM = 391,              /* CURRENT_SYM  */
  YYSYMBOL_CURRENT_POS_SYM = 392,          /* CURRENT_POS_SYM  */
  YYSYMBOL_CURSOR_NAME_SYM = 393,          /* CURSOR_NAME_SYM  */
  YYSYMBOL_CYCLE_SYM = 394,                /* CYCLE_SYM  */
  YYSYMBOL_DATAFILE_SYM = 395,             /* DATAFILE_SYM  */
  YYSYMBOL_DATA_SYM = 396,                 /* DATA_SYM  */
  YYSYMBOL_DATETIME = 397,                 /* DATETIME  */
  YYSYMBOL_DATE_FORMAT_SYM = 398,          /* DATE_FORMAT_SYM  */
  YYSYMBOL_DATE_SYM = 399,                 /* DATE_SYM  */
  YYSYMBOL_DAY_SYM = 400,                  /* DAY_SYM  */
  YYSYMBOL_DEALLOCATE_SYM = 401,           /* DEALLOCATE_SYM  */
  YYSYMBOL_DECODE_MARIADB_SYM = 402,       /* DECODE_MARIADB_SYM  */
  YYSYMBOL_DECODE_ORACLE_SYM = 403,        /* DECODE_ORACLE_SYM  */
  YYSYMBOL_DEFINER_SYM = 404,              /* DEFINER_SYM  */
  YYSYMBOL_DELAYED_SYM = 405,              /* DELAYED_SYM  */
  YYSYMBOL_DELAY_KEY_WRITE_SYM = 406,      /* DELAY_KEY_WRITE_SYM  */
  YYSYMBOL_DES_KEY_FILE = 407,             /* DES_KEY_FILE  */
  YYSYMBOL_DIAGNOSTICS_SYM = 408,          /* DIAGNOSTICS_SYM  */
  YYSYMBOL_DIRECTORY_SYM = 409,            /* DIRECTORY_SYM  */
  YYSYMBOL_DISABLE_SYM = 410,              /* DISABLE_SYM  */
  YYSYMBOL_DISCARD = 411,                  /* DISCARD  */
  YYSYMBOL_DISK_SYM = 412,                 /* DISK_SYM  */
  YYSYMBOL_DO_SYM = 413,                   /* DO_SYM  */
  YYSYMBOL_DUMPFILE = 414,                 /* DUMPFILE  */
  YYSYMBOL_DUPLICATE_SYM = 415,            /* DUPLICATE_SYM  */
  YYSYMBOL_DYNAMIC_SYM = 416,              /* DYNAMIC_SYM  */
  YYSYMBOL_ENABLE_SYM = 417,               /* ENABLE_SYM  */
  YYSYMBOL_END = 418,                      /* END  */
  YYSYMBOL_ENDS_SYM = 419,                 /* ENDS_SYM  */
  YYSYMBOL_ENGINES_SYM = 420,              /* ENGINES_SYM  */
  YYSYMBOL_ENGINE_SYM = 421,               /* ENGINE_SYM  */
  YYSYMBOL_ENUM = 422,                     /* ENUM  */
  YYSYMBOL_ERROR_SYM = 423,                /* ERROR_SYM  */
  YYSYMBOL_ERRORS = 424,                   /* ERRORS  */
  YYSYMBOL_ESCAPE_SYM = 425,               /* ESCAPE_SYM  */
  YYSYMBOL_EVENTS_SYM = 426,               /* EVENTS_SYM  */
  YYSYMBOL_EVENT_SYM = 427,                /* EVENT_SYM  */
  YYSYMBOL_EVERY_SYM = 428,                /* EVERY_SYM  */
  YYSYMBOL_EXCHANGE_SYM = 429,             /* EXCHANGE_SYM  */
  YYSYMBOL_EXAMINED_SYM = 430,             /* EXAMINED_SYM  */
  YYSYMBOL_EXCLUDE_SYM = 431,              /* EXCLUDE_SYM  */
  YYSYMBOL_EXECUTE_SYM = 432,              /* EXECUTE_SYM  */
  YYSYMBOL_EXCEPTION_MARIADB_SYM = 433,    /* EXCEPTION_MARIADB_SYM  */
  YYSYMBOL_EXIT_MARIADB_SYM = 434,         /* EXIT_MARIADB_SYM  */
  YYSYMBOL_EXIT_ORACLE_SYM = 435,          /* EXIT_ORACLE_SYM  */
  YYSYMBOL_EXPANSION_SYM = 436,            /* EXPANSION_SYM  */
  YYSYMBOL_EXPIRE_SYM = 437,               /* EXPIRE_SYM  */
  YYSYMBOL_EXPORT_SYM = 438,               /* EXPORT_SYM  */
  YYSYMBOL_EXTENDED_SYM = 439,             /* EXTENDED_SYM  */
  YYSYMBOL_EXTENT_SIZE_SYM = 440,          /* EXTENT_SIZE_SYM  */
  YYSYMBOL_FAST_SYM = 441,                 /* FAST_SYM  */
  YYSYMBOL_FAULTS_SYM = 442,               /* FAULTS_SYM  */
  YYSYMBOL_FILE_SYM = 443,                 /* FILE_SYM  */
  YYSYMBOL_FIRST_SYM = 444,                /* FIRST_SYM  */
  YYSYMBOL_FIXED_SYM = 445,                /* FIXED_SYM  */
  YYSYMBOL_FLUSH_SYM = 446,                /* FLUSH_SYM  */
  YYSYMBOL_FOLLOWS_SYM = 447,              /* FOLLOWS_SYM  */
  YYSYMBOL_FOLLOWING_SYM = 448,            /* FOLLOWING_SYM  */
  YYSYMBOL_FORCE_SYM = 449,                /* FORCE_SYM  */
  YYSYMBOL_FORMAT_SYM = 450,               /* FORMAT_SYM  */
  YYSYMBOL_FOUND_SYM = 451,                /* FOUND_SYM  */
  YYSYMBOL_FULL = 452,                     /* FULL  */
  YYSYMBOL_FUNCTION_SYM = 453,             /* FUNCTION_SYM  */
  YYSYMBOL_GENERAL = 454,                  /* GENERAL  */
  YYSYMBOL_GENERATED_SYM = 455,            /* GENERATED_SYM  */
  YYSYMBOL_GEOMETRYCOLLECTION = 456,       /* GEOMETRYCOLLECTION  */
  YYSYMBOL_GEOMETRY_SYM = 457,             /* GEOMETRY_SYM  */
  YYSYMBOL_GET_FORMAT = 458,               /* GET_FORMAT  */
  YYSYMBOL_GET_SYM = 459,                  /* GET_SYM  */
  YYSYMBOL_GLOBAL_SYM = 460,               /* GLOBAL_SYM  */
  YYSYMBOL_GRANTS = 461,                   /* GRANTS  */
  YYSYMBOL_HANDLER_SYM = 462,              /* HANDLER_SYM  */
  YYSYMBOL_HARD_SYM = 463,                 /* HARD_SYM  */
  YYSYMBOL_HASH_SYM = 464,                 /* HASH_SYM  */
  YYSYMBOL_HELP_SYM = 465,                 /* HELP_SYM  */
  YYSYMBOL_HIGH_PRIORITY = 466,            /* HIGH_PRIORITY  */
  YYSYMBOL_HISTORY_SYM = 467,              /* HISTORY_SYM  */
  YYSYMBOL_HOST_SYM = 468,                 /* HOST_SYM  */
  YYSYMBOL_HOSTS_SYM = 469,                /* HOSTS_SYM  */
  YYSYMBOL_HOUR_SYM = 470,                 /* HOUR_SYM  */
  YYSYMBOL_ID_SYM = 471,                   /* ID_SYM  */
  YYSYMBOL_IDENTIFIED_SYM = 472,           /* IDENTIFIED_SYM  */
  YYSYMBOL_IGNORE_SERVER_IDS_SYM = 473,    /* IGNORE_SERVER_IDS_SYM  */
  YYSYMBOL_IMMEDIATE_SYM = 474,            /* IMMEDIATE_SYM  */
  YYSYMBOL_IMPORT = 475,                   /* IMPORT  */
  YYSYMBOL_INCREMENT_SYM = 476,            /* INCREMENT_SYM  */
  YYSYMBOL_INDEXES = 477,                  /* INDEXES  */
  YYSYMBOL_INITIAL_SIZE_SYM = 478,         /* INITIAL_SIZE_SYM  */
  YYSYMBOL_INSERT_METHOD = 479,            /* INSERT_METHOD  */
  YYSYMBOL_INSTALL_SYM = 480,              /* INSTALL_SYM  */
  YYSYMBOL_INVOKER_SYM = 481,              /* INVOKER_SYM  */
  YYSYMBOL_IO_SYM = 482,                   /* IO_SYM  */
  YYSYMBOL_IPC_SYM = 483,                  /* IPC_SYM  */
  YYSYMBOL_ISOLATION = 484,                /* ISOLATION  */
  YYSYMBOL_ISOPEN_SYM = 485,               /* ISOPEN_SYM  */
  YYSYMBOL_ISSUER_SYM = 486,               /* ISSUER_SYM  */
  YYSYMBOL_INVISIBLE_SYM = 487,            /* INVISIBLE_SYM  */
  YYSYMBOL_JSON_SYM = 488,                 /* JSON_SYM  */
  YYSYMBOL_KEY_BLOCK_SIZE = 489,           /* KEY_BLOCK_SIZE  */
  YYSYMBOL_LANGUAGE_SYM = 490,             /* LANGUAGE_SYM  */
  YYSYMBOL_LAST_SYM = 491,                 /* LAST_SYM  */
  YYSYMBOL_LAST_VALUE = 492,               /* LAST_VALUE  */
  YYSYMBOL_LASTVAL_SYM = 493,              /* LASTVAL_SYM  */
  YYSYMBOL_LEAVES = 494,                   /* LEAVES  */
  YYSYMBOL_LESS_SYM = 495,                 /* LESS_SYM  */
  YYSYMBOL_LEVEL_SYM = 496,                /* LEVEL_SYM  */
  YYSYMBOL_LINESTRING = 497,               /* LINESTRING  */
  YYSYMBOL_LIST_SYM = 498,                 /* LIST_SYM  */
  YYSYMBOL_LOCAL_SYM = 499,                /* LOCAL_SYM  */
  YYSYMBOL_LOCKS_SYM = 500,                /* LOCKS_SYM  */
  YYSYMBOL_LOGFILE_SYM = 501,              /* LOGFILE_SYM  */
  YYSYMBOL_LOGS_SYM = 502,                 /* LOGS_SYM  */
  YYSYMBOL_MASTER_CONNECT_RETRY_SYM = 503, /* MASTER_CONNECT_RETRY_SYM  */
  YYSYMBOL_MASTER_DELAY_SYM = 504,         /* MASTER_DELAY_SYM  */
  YYSYMBOL_MASTER_GTID_POS_SYM = 505,      /* MASTER_GTID_POS_SYM  */
  YYSYMBOL_MASTER_HOST_SYM = 506,          /* MASTER_HOST_SYM  */
  YYSYMBOL_MASTER_LOG_FILE_SYM = 507,      /* MASTER_LOG_FILE_SYM  */
  YYSYMBOL_MASTER_LOG_POS_SYM = 508,       /* MASTER_LOG_POS_SYM  */
  YYSYMBOL_MASTER_PASSWORD_SYM = 509,      /* MASTER_PASSWORD_SYM  */
  YYSYMBOL_MASTER_PORT_SYM = 510,          /* MASTER_PORT_SYM  */
  YYSYMBOL_MASTER_SERVER_ID_SYM = 511,     /* MASTER_SERVER_ID_SYM  */
  YYSYMBOL_MASTER_SSL_CAPATH_SYM = 512,    /* MASTER_SSL_CAPATH_SYM  */
  YYSYMBOL_MASTER_SSL_CA_SYM = 513,        /* MASTER_SSL_CA_SYM  */
  YYSYMBOL_MASTER_SSL_CERT_SYM = 514,      /* MASTER_SSL_CERT_SYM  */
  YYSYMBOL_MASTER_SSL_CIPHER_SYM = 515,    /* MASTER_SSL_CIPHER_SYM  */
  YYSYMBOL_MASTER_SSL_CRL_SYM = 516,       /* MASTER_SSL_CRL_SYM  */
  YYSYMBOL_MASTER_SSL_CRLPATH_SYM = 517,   /* MASTER_SSL_CRLPATH_SYM  */
  YYSYMBOL_MASTER_SSL_KEY_SYM = 518,       /* MASTER_SSL_KEY_SYM  */
  YYSYMBOL_MASTER_SSL_SYM = 519,           /* MASTER_SSL_SYM  */
  YYSYMBOL_MASTER_SYM = 520,               /* MASTER_SYM  */
  YYSYMBOL_MASTER_USER_SYM = 521,          /* MASTER_USER_SYM  */
  YYSYMBOL_MASTER_USE_GTID_SYM = 522,      /* MASTER_USE_GTID_SYM  */
  YYSYMBOL_MASTER_HEARTBEAT_PERIOD_SYM = 523, /* MASTER_HEARTBEAT_PERIOD_SYM  */
  YYSYMBOL_MAX_CONNECTIONS_PER_HOUR = 524, /* MAX_CONNECTIONS_PER_HOUR  */
  YYSYMBOL_MAX_QUERIES_PER_HOUR = 525,     /* MAX_QUERIES_PER_HOUR  */
  YYSYMBOL_MAX_ROWS = 526,                 /* MAX_ROWS  */
  YYSYMBOL_MAX_SIZE_SYM = 527,             /* MAX_SIZE_SYM  */
  YYSYMBOL_MAX_UPDATES_PER_HOUR = 528,     /* MAX_UPDATES_PER_HOUR  */
  YYSYMBOL_MAX_STATEMENT_TIME_SYM = 529,   /* MAX_STATEMENT_TIME_SYM  */
  YYSYMBOL_MAX_USER_CONNECTIONS_SYM = 530, /* MAX_USER_CONNECTIONS_SYM  */
  YYSYMBOL_MEDIUM_SYM = 531,               /* MEDIUM_SYM  */
  YYSYMBOL_MEMORY_SYM = 532,               /* MEMORY_SYM  */
  YYSYMBOL_MERGE_SYM = 533,                /* MERGE_SYM  */
  YYSYMBOL_MESSAGE_TEXT_SYM = 534,         /* MESSAGE_TEXT_SYM  */
  YYSYMBOL_MICROSECOND_SYM = 535,          /* MICROSECOND_SYM  */
  YYSYMBOL_MIGRATE_SYM = 536,              /* MIGRATE_SYM  */
  YYSYMBOL_MINUTE_SYM = 537,               /* MINUTE_SYM  */
  YYSYMBOL_MINVALUE_SYM = 538,             /* MINVALUE_SYM  */
  YYSYMBOL_MIN_ROWS = 539,                 /* MIN_ROWS  */
  YYSYMBOL_MODE_SYM = 540,                 /* MODE_SYM  */
  YYSYMBOL_MODIFY_SYM = 541,               /* MODIFY_SYM  */
  YYSYMBOL_MONTH_SYM = 542,                /* MONTH_SYM  */
  YYSYMBOL_MULTILINESTRING = 543,          /* MULTILINESTRING  */
  YYSYMBOL_MULTIPOINT = 544,               /* MULTIPOINT  */
  YYSYMBOL_MULTIPOLYGON = 545,             /* MULTIPOLYGON  */
  YYSYMBOL_MUTEX_SYM = 546,                /* MUTEX_SYM  */
  YYSYMBOL_MYSQL_SYM = 547,                /* MYSQL_SYM  */
  YYSYMBOL_MYSQL_ERRNO_SYM = 548,          /* MYSQL_ERRNO_SYM  */
  YYSYMBOL_NAMES_SYM = 549,                /* NAMES_SYM  */
  YYSYMBOL_NAME_SYM = 550,                 /* NAME_SYM  */
  YYSYMBOL_NATIONAL_SYM = 551,             /* NATIONAL_SYM  */
  YYSYMBOL_NCHAR_SYM = 552,                /* NCHAR_SYM  */
  YYSYMBOL_NEVER_SYM = 553,                /* NEVER_SYM  */
  YYSYMBOL_NEW_SYM = 554,                  /* NEW_SYM  */
  YYSYMBOL_NEXT_SYM = 555,                 /* NEXT_SYM  */
  YYSYMBOL_NEXTVAL_SYM = 556,              /* NEXTVAL_SYM  */
  YYSYMBOL_NOCACHE_SYM = 557,              /* NOCACHE_SYM  */
  YYSYMBOL_NOCYCLE_SYM = 558,              /* NOCYCLE_SYM  */
  YYSYMBOL_NODEGROUP_SYM = 559,            /* NODEGROUP_SYM  */
  YYSYMBOL_NONE_SYM = 560,                 /* NONE_SYM  */
  YYSYMBOL_NOTFOUND_SYM = 561,             /* NOTFOUND_SYM  */
  YYSYMBOL_NO_SYM = 562,                   /* NO_SYM  */
  YYSYMBOL_NOMAXVALUE_SYM = 563,           /* NOMAXVALUE_SYM  */
  YYSYMBOL_NOMINVALUE_SYM = 564,           /* NOMINVALUE_SYM  */
  YYSYMBOL_NO_WAIT_SYM = 565,              /* NO_WAIT_SYM  */
  YYSYMBOL_NOWAIT_SYM = 566,               /* NOWAIT_SYM  */
  YYSYMBOL_NUMBER_MARIADB_SYM = 567,       /* NUMBER_MARIADB_SYM  */
  YYSYMBOL_NUMBER_ORACLE_SYM = 568,        /* NUMBER_ORACLE_SYM  */
  YYSYMBOL_NVARCHAR_SYM = 569,             /* NVARCHAR_SYM  */
  YYSYMBOL_OF_SYM = 570,                   /* OF_SYM  */
  YYSYMBOL_OFFSET_SYM = 571,               /* OFFSET_SYM  */
  YYSYMBOL_OLD_PASSWORD_SYM = 572,         /* OLD_PASSWORD_SYM  */
  YYSYMBOL_ONE_SYM = 573,                  /* ONE_SYM  */
  YYSYMBOL_ONLY_SYM = 574,                 /* ONLY_SYM  */
  YYSYMBOL_ONLINE_SYM = 575,               /* ONLINE_SYM  */
  YYSYMBOL_OPEN_SYM = 576,                 /* OPEN_SYM  */
  YYSYMBOL_OPTIONS_SYM = 577,              /* OPTIONS_SYM  */
  YYSYMBOL_OPTION = 578,                   /* OPTION  */
  YYSYMBOL_OWNER_SYM = 579,                /* OWNER_SYM  */
  YYSYMBOL_PACK_KEYS_SYM = 580,            /* PACK_KEYS_SYM  */
  YYSYMBOL_PAGE_SYM = 581,                 /* PAGE_SYM  */
  YYSYMBOL_PARSER_SYM = 582,               /* PARSER_SYM  */
  YYSYMBOL_PARTIAL = 583,                  /* PARTIAL  */
  YYSYMBOL_PARTITIONS_SYM = 584,           /* PARTITIONS_SYM  */
  YYSYMBOL_PARTITIONING_SYM = 585,         /* PARTITIONING_SYM  */
  YYSYMBOL_PASSWORD_SYM = 586,             /* PASSWORD_SYM  */
  YYSYMBOL_PERIOD_SYM = 587,               /* PERIOD_SYM  */
  YYSYMBOL_PERSISTENT_SYM = 588,           /* PERSISTENT_SYM  */
  YYSYMBOL_PHASE_SYM = 589,                /* PHASE_SYM  */
  YYSYMBOL_PLUGINS_SYM = 590,              /* PLUGINS_SYM  */
  YYSYMBOL_PLUGIN_SYM = 591,               /* PLUGIN_SYM  */
  YYSYMBOL_POINT_SYM = 592,                /* POINT_SYM  */
  YYSYMBOL_POLYGON = 593,                  /* POLYGON  */
  YYSYMBOL_PORT_SYM = 594,                 /* PORT_SYM  */
  YYSYMBOL_PRECEDES_SYM = 595,             /* PRECEDES_SYM  */
  YYSYMBOL_PRECEDING_SYM = 596,            /* PRECEDING_SYM  */
  YYSYMBOL_PREPARE_SYM = 597,              /* PREPARE_SYM  */
  YYSYMBOL_PRESERVE_SYM = 598,             /* PRESERVE_SYM  */
  YYSYMBOL_PREV_SYM = 599,                 /* PREV_SYM  */
  YYSYMBOL_PREVIOUS_SYM = 600,             /* PREVIOUS_SYM  */
  YYSYMBOL_PRIVILEGES = 601,               /* PRIVILEGES  */
  YYSYMBOL_PROCESS = 602,                  /* PROCESS  */
  YYSYMBOL_PROCESSLIST_SYM = 603,          /* PROCESSLIST_SYM  */
  YYSYMBOL_PROFILE_SYM = 604,              /* PROFILE_SYM  */
  YYSYMBOL_PROFILES_SYM = 605,             /* PROFILES_SYM  */
  YYSYMBOL_PROXY_SYM = 606,                /* PROXY_SYM  */
  YYSYMBOL_QUARTER_SYM = 607,              /* QUARTER_SYM  */
  YYSYMBOL_QUERY_SYM = 608,                /* QUERY_SYM  */
  YYSYMBOL_QUICK = 609,                    /* QUICK  */
  YYSYMBOL_RAW_MARIADB_SYM = 610,          /* RAW_MARIADB_SYM  */
  YYSYMBOL_RAW_ORACLE_SYM = 611,           /* RAW_ORACLE_SYM  */
  YYSYMBOL_READ_ONLY_SYM = 612,            /* READ_ONLY_SYM  */
  YYSYMBOL_REBUILD_SYM = 613,              /* REBUILD_SYM  */
  YYSYMBOL_RECOVER_SYM = 614,              /* RECOVER_SYM  */
  YYSYMBOL_REDOFILE_SYM = 615,             /* REDOFILE_SYM  */
  YYSYMBOL_REDO_BUFFER_SIZE_SYM = 616,     /* REDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_REDUNDANT_SYM = 617,            /* REDUNDANT_SYM  */
  YYSYMBOL_RELAY = 618,                    /* RELAY  */
  YYSYMBOL_RELAYLOG_SYM = 619,             /* RELAYLOG_SYM  */
  YYSYMBOL_RELAY_LOG_FILE_SYM = 620,       /* RELAY_LOG_FILE_SYM  */
  YYSYMBOL_RELAY_LOG_POS_SYM = 621,        /* RELAY_LOG_POS_SYM  */
  YYSYMBOL_RELAY_THREAD = 622,             /* RELAY_THREAD  */
  YYSYMBOL_RELOAD = 623,                   /* RELOAD  */
  YYSYMBOL_REMOVE_SYM = 624,               /* REMOVE_SYM  */
  YYSYMBOL_REORGANIZE_SYM = 625,           /* REORGANIZE_SYM  */
  YYSYMBOL_REPAIR = 626,                   /* REPAIR  */
  YYSYMBOL_REPEATABLE_SYM = 627,           /* REPEATABLE_SYM  */
  YYSYMBOL_REPLICATION = 628,              /* REPLICATION  */
  YYSYMBOL_RESET_SYM = 629,                /* RESET_SYM  */
  YYSYMBOL_RESTART_SYM = 630,              /* RESTART_SYM  */
  YYSYMBOL_RESOURCES = 631,                /* RESOURCES  */
  YYSYMBOL_RESTORE_SYM = 632,              /* RESTORE_SYM  */
  YYSYMBOL_RESUME_SYM = 633,               /* RESUME_SYM  */
  YYSYMBOL_RETURNED_SQLSTATE_SYM = 634,    /* RETURNED_SQLSTATE_SYM  */
  YYSYMBOL_RETURNS_SYM = 635,              /* RETURNS_SYM  */
  YYSYMBOL_REUSE_SYM = 636,                /* REUSE_SYM  */
  YYSYMBOL_REVERSE_SYM = 637,              /* REVERSE_SYM  */
  YYSYMBOL_ROLE_SYM = 638,                 /* ROLE_SYM  */
  YYSYMBOL_ROLLBACK_SYM = 639,             /* ROLLBACK_SYM  */
  YYSYMBOL_ROLLUP_SYM = 640,               /* ROLLUP_SYM  */
  YYSYMBOL_ROUTINE_SYM = 641,              /* ROUTINE_SYM  */
  YYSYMBOL_ROWCOUNT_SYM = 642,             /* ROWCOUNT_SYM  */
  YYSYMBOL_ROW_SYM = 643,                  /* ROW_SYM  */
  YYSYMBOL_ROW_COUNT_SYM = 644,            /* ROW_COUNT_SYM  */
  YYSYMBOL_ROW_FORMAT_SYM = 645,           /* ROW_FORMAT_SYM  */
  YYSYMBOL_RTREE_SYM = 646,                /* RTREE_SYM  */
  YYSYMBOL_SAVEPOINT_SYM = 647,            /* SAVEPOINT_SYM  */
  YYSYMBOL_SCHEDULE_SYM = 648,             /* SCHEDULE_SYM  */
  YYSYMBOL_SCHEMA_NAME_SYM = 649,          /* SCHEMA_NAME_SYM  */
  YYSYMBOL_SECOND_SYM = 650,               /* SECOND_SYM  */
  YYSYMBOL_SECURITY_SYM = 651,             /* SECURITY_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 652,             /* SEQUENCE_SYM  */
  YYSYMBOL_SERIALIZABLE_SYM = 653,         /* SERIALIZABLE_SYM  */
  YYSYMBOL_SERIAL_SYM = 654,               /* SERIAL_SYM  */
  YYSYMBOL_SESSION_SYM = 655,              /* SESSION_SYM  */
  YYSYMBOL_SERVER_SYM = 656,               /* SERVER_SYM  */
  YYSYMBOL_SETVAL_SYM = 657,               /* SETVAL_SYM  */
  YYSYMBOL_SHARE_SYM = 658,                /* SHARE_SYM  */
  YYSYMBOL_SHUTDOWN = 659,                 /* SHUTDOWN  */
  YYSYMBOL_SIGNED_SYM = 660,               /* SIGNED_SYM  */
  YYSYMBOL_SIMPLE_SYM = 661,               /* SIMPLE_SYM  */
  YYSYMBOL_SLAVE = 662,                    /* SLAVE  */
  YYSYMBOL_SLAVES = 663,                   /* SLAVES  */
  YYSYMBOL_SLAVE_POS_SYM = 664,            /* SLAVE_POS_SYM  */
  YYSYMBOL_SLOW = 665,                     /* SLOW  */
  YYSYMBOL_SNAPSHOT_SYM = 666,             /* SNAPSHOT_SYM  */
  YYSYMBOL_SOCKET_SYM = 667,               /* SOCKET_SYM  */
  YYSYMBOL_SOFT_SYM = 668,                 /* SOFT_SYM  */
  YYSYMBOL_SONAME_SYM = 669,               /* SONAME_SYM  */
  YYSYMBOL_SOUNDS_SYM = 670,               /* SOUNDS_SYM  */
  YYSYMBOL_SOURCE_SYM = 671,               /* SOURCE_SYM  */
  YYSYMBOL_SQL_BUFFER_RESULT = 672,        /* SQL_BUFFER_RESULT  */
  YYSYMBOL_SQL_CACHE_SYM = 673,            /* SQL_CACHE_SYM  */
  YYSYMBOL_SQL_CALC_FOUND_ROWS = 674,      /* SQL_CALC_FOUND_ROWS  */
  YYSYMBOL_SQL_NO_CACHE_SYM = 675,         /* SQL_NO_CACHE_SYM  */
  YYSYMBOL_SQL_THREAD = 676,               /* SQL_THREAD  */
  YYSYMBOL_STAGE_SYM = 677,                /* STAGE_SYM  */
  YYSYMBOL_STARTS_SYM = 678,               /* STARTS_SYM  */
  YYSYMBOL_START_SYM = 679,                /* START_SYM  */
  YYSYMBOL_STATEMENT_SYM = 680,            /* STATEMENT_SYM  */
  YYSYMBOL_STATUS_SYM = 681,               /* STATUS_SYM  */
  YYSYMBOL_STOP_SYM = 682,                 /* STOP_SYM  */
  YYSYMBOL_STORAGE_SYM = 683,              /* STORAGE_SYM  */
  YYSYMBOL_STORED_SYM = 684,               /* STORED_SYM  */
  YYSYMBOL_STRING_SYM = 685,               /* STRING_SYM  */
  YYSYMBOL_SUBCLASS_ORIGIN_SYM = 686,      /* SUBCLASS_ORIGIN_SYM  */
  YYSYMBOL_SUBDATE_SYM = 687,              /* SUBDATE_SYM  */
  YYSYMBOL_SUBJECT_SYM = 688,              /* SUBJECT_SYM  */
  YYSYMBOL_SUBPARTITIONS_SYM = 689,        /* SUBPARTITIONS_SYM  */
  YYSYMBOL_SUBPARTITION_SYM = 690,         /* SUBPARTITION_SYM  */
  YYSYMBOL_SUPER_SYM = 691,                /* SUPER_SYM  */
  YYSYMBOL_SUSPEND_SYM = 692,              /* SUSPEND_SYM  */
  YYSYMBOL_SWAPS_SYM = 693,                /* SWAPS_SYM  */
  YYSYMBOL_SWITCHES_SYM = 694,             /* SWITCHES_SYM  */
  YYSYMBOL_SYSTEM = 695,                   /* SYSTEM  */
  YYSYMBOL_SYSTEM_TIME_SYM = 696,          /* SYSTEM_TIME_SYM  */
  YYSYMBOL_TABLES = 697,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 698,               /* TABLESPACE  */
  YYSYMBOL_TABLE_CHECKSUM_SYM = 699,       /* TABLE_CHECKSUM_SYM  */
  YYSYMBOL_TABLE_NAME_SYM = 700,           /* TABLE_NAME_SYM  */
  YYSYMBOL_TEMPORARY = 701,                /* TEMPORARY  */
  YYSYMBOL_TEMPTABLE_SYM = 702,            /* TEMPTABLE_SYM  */
  YYSYMBOL_TEXT_SYM = 703,                 /* TEXT_SYM  */
  YYSYMBOL_THAN_SYM = 704,                 /* THAN_SYM  */
  YYSYMBOL_TIES_SYM = 705,                 /* TIES_SYM  */
  YYSYMBOL_TIMESTAMP = 706,                /* TIMESTAMP  */
  YYSYMBOL_TIMESTAMP_ADD = 707,            /* TIMESTAMP_ADD  */
  YYSYMBOL_TIMESTAMP_DIFF = 708,           /* TIMESTAMP_DIFF  */
  YYSYMBOL_TIME_SYM = 709,                 /* TIME_SYM  */
  YYSYMBOL_TRANSACTION_SYM = 710,          /* TRANSACTION_SYM  */
  YYSYMBOL_TRANSACTIONAL_SYM = 711,        /* TRANSACTIONAL_SYM  */
  YYSYMBOL_TRIGGERS_SYM = 712,             /* TRIGGERS_SYM  */
  YYSYMBOL_TRIM_ORACLE = 713,              /* TRIM_ORACLE  */
  YYSYMBOL_TRUNCATE_SYM = 714,             /* TRUNCATE_SYM  */
  YYSYMBOL_TYPES_SYM = 715,                /* TYPES_SYM  */
  YYSYMBOL_TYPE_SYM = 716,                 /* TYPE_SYM  */
  YYSYMBOL_UDF_RETURNS_SYM = 717,          /* UDF_RETURNS_SYM  */
  YYSYMBOL_UNBOUNDED_SYM = 718,            /* UNBOUNDED_SYM  */
  YYSYMBOL_UNCOMMITTED_SYM = 719,          /* UNCOMMITTED_SYM  */
  YYSYMBOL_UNDEFINED_SYM = 720,            /* UNDEFINED_SYM  */
  YYSYMBOL_UNDOFILE_SYM = 721,             /* UNDOFILE_SYM  */
  YYSYMBOL_UNDO_BUFFER_SIZE_SYM = 722,     /* UNDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_UNICODE_SYM = 723,              /* UNICODE_SYM  */
  YYSYMBOL_UNINSTALL_SYM = 724,            /* UNINSTALL_SYM  */
  YYSYMBOL_UNKNOWN_SYM = 725,              /* UNKNOWN_SYM  */
  YYSYMBOL_UNTIL_SYM = 726,                /* UNTIL_SYM  */
  YYSYMBOL_UPGRADE_SYM = 727,              /* UPGRADE_SYM  */
  YYSYMBOL_USER_SYM = 728,                 /* USER_SYM  */
  YYSYMBOL_USE_FRM = 729,                  /* USE_FRM  */
  YYSYMBOL_VALUE_SYM = 730,                /* VALUE_SYM  */
  YYSYMBOL_VARCHAR2_MARIADB_SYM = 731,     /* VARCHAR2_MARIADB_SYM  */
  YYSYMBOL_VARCHAR2_ORACLE_SYM = 732,      /* VARCHAR2_ORACLE_SYM  */
  YYSYMBOL_VARIABLES = 733,                /* VARIABLES  */
  YYSYMBOL_VERSIONING_SYM = 734,           /* VERSIONING_SYM  */
  YYSYMBOL_VIA_SYM = 735,                  /* VIA_SYM  */
  YYSYMBOL_VIEW_SYM = 736,                 /* VIEW_SYM  */
  YYSYMBOL_VIRTUAL_SYM = 737,              /* VIRTUAL_SYM  */
  YYSYMBOL_WAIT_SYM = 738,                 /* WAIT_SYM  */
  YYSYMBOL_WARNINGS = 739,                 /* WARNINGS  */
  YYSYMBOL_WEEK_SYM = 740,                 /* WEEK_SYM  */
  YYSYMBOL_WEIGHT_STRING_SYM = 741,        /* WEIGHT_STRING_SYM  */
  YYSYMBOL_WINDOW_SYM = 742,               /* WINDOW_SYM  */
  YYSYMBOL_WITHIN = 743,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 744,                  /* WITHOUT  */
  YYSYMBOL_WORK_SYM = 745,                 /* WORK_SYM  */
  YYSYMBOL_WRAPPER_SYM = 746,              /* WRAPPER_SYM  */
  YYSYMBOL_WRITE_SYM = 747,                /* WRITE_SYM  */
  YYSYMBOL_X509_SYM = 748,                 /* X509_SYM  */
  YYSYMBOL_XA_SYM = 749,                   /* XA_SYM  */
  YYSYMBOL_XML_SYM = 750,                  /* XML_SYM  */
  YYSYMBOL_YEAR_SYM = 751,                 /* YEAR_SYM  */
  YYSYMBOL_CONDITIONLESS_JOIN = 752,       /* CONDITIONLESS_JOIN  */
  YYSYMBOL_ON_SYM = 753,                   /* ON_SYM  */
  YYSYMBOL_PREC_BELOW_NOT = 754,           /* PREC_BELOW_NOT  */
  YYSYMBOL_755_ = 755,                     /* '='  */
  YYSYMBOL_756_ = 756,                     /* '>'  */
  YYSYMBOL_757_ = 757,                     /* '<'  */
  YYSYMBOL_758_ = 758,                     /* '|'  */
  YYSYMBOL_759_ = 759,                     /* '&'  */
  YYSYMBOL_760_ = 760,                     /* '-'  */
  YYSYMBOL_761_ = 761,                     /* '+'  */
  YYSYMBOL_762_ = 762,                     /* '*'  */
  YYSYMBOL_763_ = 763,                     /* '/'  */
  YYSYMBOL_764_ = 764,                     /* '%'  */
  YYSYMBOL_765_ = 765,                     /* '^'  */
  YYSYMBOL_766_ = 766,                     /* '~'  */
  YYSYMBOL_SUBQUERY_AS_EXPR = 767,         /* SUBQUERY_AS_EXPR  */
  YYSYMBOL_PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE = 768, /* PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE  */
  YYSYMBOL_USER = 769,                     /* USER  */
  YYSYMBOL_PREC_BELOW_CONTRACTION_TOKEN2 = 770, /* PREC_BELOW_CONTRACTION_TOKEN2  */
  YYSYMBOL_771_ = 771,                     /* '('  */
  YYSYMBOL_772_ = 772,                     /* ')'  */
  YYSYMBOL_EMPTY_FROM_CLAUSE = 773,        /* EMPTY_FROM_CLAUSE  */
  YYSYMBOL_774_ = 774,                     /* ','  */
  YYSYMBOL_775_ = 775,                     /* '!'  */
  YYSYMBOL_776_ = 776,                     /* '{'  */
  YYSYMBOL_777_ = 777,                     /* '}'  */
  YYSYMBOL_778_ = 778,                     /* ';'  */
  YYSYMBOL_779_ = 779,                     /* '.'  */
  YYSYMBOL_780_ = 780,                     /* '@'  */
  YYSYMBOL_781_ = 781,                     /* ':'  */
  YYSYMBOL_YYACCEPT = 782,                 /* $accept  */
  YYSYMBOL_query = 783,                    /* query  */
  YYSYMBOL_784_1 = 784,                    /* $@1  */
  YYSYMBOL_opt_end_of_input = 785,         /* opt_end_of_input  */
  YYSYMBOL_verb_clause = 786,              /* verb_clause  */
  YYSYMBOL_statement = 787,                /* statement  */
  YYSYMBOL_deallocate = 788,               /* deallocate  */
  YYSYMBOL_deallocate_or_drop = 789,       /* deallocate_or_drop  */
  YYSYMBOL_prepare = 790,                  /* prepare  */
  YYSYMBOL_791_2 = 791,                    /* $@2  */
  YYSYMBOL_execute = 792,                  /* execute  */
  YYSYMBOL_793_3 = 793,                    /* $@3  */
  YYSYMBOL_794_4 = 794,                    /* $@4  */
  YYSYMBOL_execute_using = 795,            /* execute_using  */
  YYSYMBOL_796_5 = 796,                    /* $@5  */
  YYSYMBOL_execute_params = 797,           /* execute_params  */
  YYSYMBOL_help = 798,                     /* help  */
  YYSYMBOL_799_6 = 799,                    /* $@6  */
  YYSYMBOL_change = 800,                   /* change  */
  YYSYMBOL_801_7 = 801,                    /* $@7  */
  YYSYMBOL_master_defs = 802,              /* master_defs  */
  YYSYMBOL_master_def = 803,               /* master_def  */
  YYSYMBOL_ignore_server_id_list = 804,    /* ignore_server_id_list  */
  YYSYMBOL_ignore_server_id = 805,         /* ignore_server_id  */
  YYSYMBOL_do_domain_id_list = 806,        /* do_domain_id_list  */
  YYSYMBOL_do_domain_id = 807,             /* do_domain_id  */
  YYSYMBOL_ignore_domain_id_list = 808,    /* ignore_domain_id_list  */
  YYSYMBOL_ignore_domain_id = 809,         /* ignore_domain_id  */
  YYSYMBOL_master_file_def = 810,          /* master_file_def  */
  YYSYMBOL_optional_connection_name = 811, /* optional_connection_name  */
  YYSYMBOL_connection_name = 812,          /* connection_name  */
  YYSYMBOL_create = 813,                   /* create  */
  YYSYMBOL_814_8 = 814,                    /* $@8  */
  YYSYMBOL_815_9 = 815,                    /* $@9  */
  YYSYMBOL_816_10 = 816,                   /* $@10  */
  YYSYMBOL_817_11 = 817,                   /* $@11  */
  YYSYMBOL_818_12 = 818,                   /* $@12  */
  YYSYMBOL_819_13 = 819,                   /* $@13  */
  YYSYMBOL_820_14 = 820,                   /* $@14  */
  YYSYMBOL_821_15 = 821,                   /* $@15  */
  YYSYMBOL_822_16 = 822,                   /* $@16  */
  YYSYMBOL_823_17 = 823,                   /* $@17  */
  YYSYMBOL_824_18 = 824,                   /* $@18  */
  YYSYMBOL_825_19 = 825,                   /* $@19  */
  YYSYMBOL_826_20 = 826,                   /* $@20  */
  YYSYMBOL_827_21 = 827,                   /* $@21  */
  YYSYMBOL_828_22 = 828,                   /* $@22  */
  YYSYMBOL_829_23 = 829,                   /* $@23  */
  YYSYMBOL_830_24 = 830,                   /* $@24  */
  YYSYMBOL_831_25 = 831,                   /* $@25  */
  YYSYMBOL_opt_sequence = 832,             /* opt_sequence  */
  YYSYMBOL_sequence_defs = 833,            /* sequence_defs  */
  YYSYMBOL_sequence_def = 834,             /* sequence_def  */
  YYSYMBOL_force_lookahead = 835,          /* force_lookahead  */
  YYSYMBOL_server_def = 836,               /* server_def  */
  YYSYMBOL_837_26 = 837,                   /* $@26  */
  YYSYMBOL_server_options_list = 838,      /* server_options_list  */
  YYSYMBOL_server_option = 839,            /* server_option  */
  YYSYMBOL_event_tail = 840,               /* event_tail  */
  YYSYMBOL_841_27 = 841,                   /* $@27  */
  YYSYMBOL_ev_schedule_time = 842,         /* ev_schedule_time  */
  YYSYMBOL_843_28 = 843,                   /* $@28  */
  YYSYMBOL_opt_ev_status = 844,            /* opt_ev_status  */
  YYSYMBOL_ev_starts = 845,                /* ev_starts  */
  YYSYMBOL_ev_ends = 846,                  /* ev_ends  */
  YYSYMBOL_opt_ev_on_completion = 847,     /* opt_ev_on_completion  */
  YYSYMBOL_ev_on_completion = 848,         /* ev_on_completion  */
  YYSYMBOL_opt_ev_comment = 849,           /* opt_ev_comment  */
  YYSYMBOL_ev_sql_stmt = 850,              /* ev_sql_stmt  */
  YYSYMBOL_851_29 = 851,                   /* $@29  */
  YYSYMBOL_clear_privileges = 852,         /* clear_privileges  */
  YYSYMBOL_opt_aggregate = 853,            /* opt_aggregate  */
  YYSYMBOL_sp_name = 854,                  /* sp_name  */
  YYSYMBOL_sp_a_chistics = 855,            /* sp_a_chistics  */
  YYSYMBOL_sp_c_chistics = 856,            /* sp_c_chistics  */
  YYSYMBOL_sp_chistic = 857,               /* sp_chistic  */
  YYSYMBOL_sp_c_chistic = 858,             /* sp_c_chistic  */
  YYSYMBOL_sp_suid = 859,                  /* sp_suid  */
  YYSYMBOL_call = 860,                     /* call  */
  YYSYMBOL_861_30 = 861,                   /* $@30  */
  YYSYMBOL_862_31 = 862,                   /* $@31  */
  YYSYMBOL_863_32 = 863,                   /* $@32  */
  YYSYMBOL_opt_sp_cparam_list = 864,       /* opt_sp_cparam_list  */
  YYSYMBOL_opt_sp_cparams = 865,           /* opt_sp_cparams  */
  YYSYMBOL_sp_cparams = 866,               /* sp_cparams  */
  YYSYMBOL_sp_fdparam_list = 867,          /* sp_fdparam_list  */
  YYSYMBOL_868_33 = 868,                   /* $@33  */
  YYSYMBOL_sp_fdparams = 869,              /* sp_fdparams  */
  YYSYMBOL_sp_param_name = 870,            /* sp_param_name  */
  YYSYMBOL_sp_param_name_and_type = 871,   /* sp_param_name_and_type  */
  YYSYMBOL_sp_pdparam_list = 872,          /* sp_pdparam_list  */
  YYSYMBOL_sp_pdparams = 873,              /* sp_pdparams  */
  YYSYMBOL_sp_pdparam = 874,               /* sp_pdparam  */
  YYSYMBOL_sp_opt_inout = 875,             /* sp_opt_inout  */
  YYSYMBOL_sp_parenthesized_pdparam_list = 876, /* sp_parenthesized_pdparam_list  */
  YYSYMBOL_877_34 = 877,                   /* $@34  */
  YYSYMBOL_sp_proc_stmts = 878,            /* sp_proc_stmts  */
  YYSYMBOL_sp_proc_stmts1 = 879,           /* sp_proc_stmts1  */
  YYSYMBOL_sp_decls = 880,                 /* sp_decls  */
  YYSYMBOL_sp_decl = 881,                  /* sp_decl  */
  YYSYMBOL_optionally_qualified_column_ident = 882, /* optionally_qualified_column_ident  */
  YYSYMBOL_row_field_name = 883,           /* row_field_name  */
  YYSYMBOL_row_field_definition = 884,     /* row_field_definition  */
  YYSYMBOL_row_field_definition_list = 885, /* row_field_definition_list  */
  YYSYMBOL_row_type_body = 886,            /* row_type_body  */
  YYSYMBOL_sp_decl_idents_init_vars = 887, /* sp_decl_idents_init_vars  */
  YYSYMBOL_sp_decl_variable_list = 888,    /* sp_decl_variable_list  */
  YYSYMBOL_sp_decl_body = 889,             /* sp_decl_body  */
  YYSYMBOL_890_35 = 890,                   /* $@35  */
  YYSYMBOL_sp_decl_handler = 891,          /* sp_decl_handler  */
  YYSYMBOL_892_36 = 892,                   /* $@36  */
  YYSYMBOL_opt_parenthesized_cursor_formal_parameters = 893, /* opt_parenthesized_cursor_formal_parameters  */
  YYSYMBOL_sp_cursor_stmt_lex = 894,       /* sp_cursor_stmt_lex  */
  YYSYMBOL_sp_cursor_stmt = 895,           /* sp_cursor_stmt  */
  YYSYMBOL_896_37 = 896,                   /* $@37  */
  YYSYMBOL_sp_handler_type = 897,          /* sp_handler_type  */
  YYSYMBOL_sp_hcond_list = 898,            /* sp_hcond_list  */
  YYSYMBOL_sp_hcond_element = 899,         /* sp_hcond_element  */
  YYSYMBOL_sp_cond = 900,                  /* sp_cond  */
  YYSYMBOL_sqlstate = 901,                 /* sqlstate  */
  YYSYMBOL_opt_value = 902,                /* opt_value  */
  YYSYMBOL_sp_hcond = 903,                 /* sp_hcond  */
  YYSYMBOL_raise_stmt_oracle = 904,        /* raise_stmt_oracle  */
  YYSYMBOL_signal_stmt = 905,              /* signal_stmt  */
  YYSYMBOL_signal_value = 906,             /* signal_value  */
  YYSYMBOL_opt_signal_value = 907,         /* opt_signal_value  */
  YYSYMBOL_opt_set_signal_information = 908, /* opt_set_signal_information  */
  YYSYMBOL_signal_information_item_list = 909, /* signal_information_item_list  */
  YYSYMBOL_signal_allowed_expr = 910,      /* signal_allowed_expr  */
  YYSYMBOL_signal_condition_information_item_name = 911, /* signal_condition_information_item_name  */
  YYSYMBOL_resignal_stmt = 912,            /* resignal_stmt  */
  YYSYMBOL_get_diagnostics = 913,          /* get_diagnostics  */
  YYSYMBOL_which_area = 914,               /* which_area  */
  YYSYMBOL_diagnostics_information = 915,  /* diagnostics_information  */
  YYSYMBOL_statement_information = 916,    /* statement_information  */
  YYSYMBOL_statement_information_item = 917, /* statement_information_item  */
  YYSYMBOL_simple_target_specification = 918, /* simple_target_specification  */
  YYSYMBOL_statement_information_item_name = 919, /* statement_information_item_name  */
  YYSYMBOL_condition_number = 920,         /* condition_number  */
  YYSYMBOL_condition_information = 921,    /* condition_information  */
  YYSYMBOL_condition_information_item = 922, /* condition_information_item  */
  YYSYMBOL_condition_information_item_name = 923, /* condition_information_item_name  */
  YYSYMBOL_sp_decl_ident = 924,            /* sp_decl_ident  */
  YYSYMBOL_sp_decl_idents = 925,           /* sp_decl_idents  */
  YYSYMBOL_sp_opt_default = 926,           /* sp_opt_default  */
  YYSYMBOL_sp_proc_stmt_in_returns_clause = 927, /* sp_proc_stmt_in_returns_clause  */
  YYSYMBOL_sp_proc_stmt = 928,             /* sp_proc_stmt  */
  YYSYMBOL_sp_proc_stmt_compound_ok = 929, /* sp_proc_stmt_compound_ok  */
  YYSYMBOL_sp_proc_stmt_if = 930,          /* sp_proc_stmt_if  */
  YYSYMBOL_931_38 = 931,                   /* $@38  */
  YYSYMBOL_sp_proc_stmt_statement = 932,   /* sp_proc_stmt_statement  */
  YYSYMBOL_933_39 = 933,                   /* $@39  */
  YYSYMBOL_RETURN_ALLMODES_SYM = 934,      /* RETURN_ALLMODES_SYM  */
  YYSYMBOL_sp_proc_stmt_return = 935,      /* sp_proc_stmt_return  */
  YYSYMBOL_936_40 = 936,                   /* $@40  */
  YYSYMBOL_reset_lex_expr = 937,           /* reset_lex_expr  */
  YYSYMBOL_938_41 = 938,                   /* $@41  */
  YYSYMBOL_sp_proc_stmt_exit_oracle = 939, /* sp_proc_stmt_exit_oracle  */
  YYSYMBOL_sp_proc_stmt_continue_oracle = 940, /* sp_proc_stmt_continue_oracle  */
  YYSYMBOL_sp_proc_stmt_leave = 941,       /* sp_proc_stmt_leave  */
  YYSYMBOL_sp_proc_stmt_iterate = 942,     /* sp_proc_stmt_iterate  */
  YYSYMBOL_sp_proc_stmt_goto_oracle = 943, /* sp_proc_stmt_goto_oracle  */
  YYSYMBOL_assignment_source_lex = 944,    /* assignment_source_lex  */
  YYSYMBOL_assignment_source_expr = 945,   /* assignment_source_expr  */
  YYSYMBOL_946_42 = 946,                   /* $@42  */
  YYSYMBOL_for_loop_bound_expr = 947,      /* for_loop_bound_expr  */
  YYSYMBOL_948_43 = 948,                   /* $@43  */
  YYSYMBOL_cursor_actual_parameters = 949, /* cursor_actual_parameters  */
  YYSYMBOL_opt_parenthesized_cursor_actual_parameters = 950, /* opt_parenthesized_cursor_actual_parameters  */
  YYSYMBOL_sp_proc_stmt_open = 951,        /* sp_proc_stmt_open  */
  YYSYMBOL_sp_proc_stmt_fetch_head = 952,  /* sp_proc_stmt_fetch_head  */
  YYSYMBOL_sp_proc_stmt_fetch = 953,       /* sp_proc_stmt_fetch  */
  YYSYMBOL_sp_proc_stmt_close = 954,       /* sp_proc_stmt_close  */
  YYSYMBOL_sp_fetch_list = 955,            /* sp_fetch_list  */
  YYSYMBOL_sp_if = 956,                    /* sp_if  */
  YYSYMBOL_957_44 = 957,                   /* $@44  */
  YYSYMBOL_958_45 = 958,                   /* $@45  */
  YYSYMBOL_959_46 = 959,                   /* $@46  */
  YYSYMBOL_sp_elseifs = 960,               /* sp_elseifs  */
  YYSYMBOL_case_stmt_specification = 961,  /* case_stmt_specification  */
  YYSYMBOL_962_47 = 962,                   /* $@47  */
  YYSYMBOL_case_stmt_body = 963,           /* case_stmt_body  */
  YYSYMBOL_964_48 = 964,                   /* $@48  */
  YYSYMBOL_965_49 = 965,                   /* $@49  */
  YYSYMBOL_simple_when_clause_list = 966,  /* simple_when_clause_list  */
  YYSYMBOL_searched_when_clause_list = 967, /* searched_when_clause_list  */
  YYSYMBOL_simple_when_clause = 968,       /* simple_when_clause  */
  YYSYMBOL_969_50 = 969,                   /* $@50  */
  YYSYMBOL_970_51 = 970,                   /* $@51  */
  YYSYMBOL_searched_when_clause = 971,     /* searched_when_clause  */
  YYSYMBOL_972_52 = 972,                   /* $@52  */
  YYSYMBOL_973_53 = 973,                   /* $@53  */
  YYSYMBOL_else_clause_opt = 974,          /* else_clause_opt  */
  YYSYMBOL_sp_label = 975,                 /* sp_label  */
  YYSYMBOL_sp_opt_label = 976,             /* sp_opt_label  */
  YYSYMBOL_sp_block_label = 977,           /* sp_block_label  */
  YYSYMBOL_sp_labeled_block = 978,         /* sp_labeled_block  */
  YYSYMBOL_979_54 = 979,                   /* $@54  */
  YYSYMBOL_sp_unlabeled_block = 980,       /* sp_unlabeled_block  */
  YYSYMBOL_981_55 = 981,                   /* $@55  */
  YYSYMBOL_sp_unlabeled_block_not_atomic = 982, /* sp_unlabeled_block_not_atomic  */
  YYSYMBOL_983_56 = 983,                   /* $@56  */
  YYSYMBOL_opt_sp_for_loop_direction = 984, /* opt_sp_for_loop_direction  */
  YYSYMBOL_sp_for_loop_index_and_bounds = 985, /* sp_for_loop_index_and_bounds  */
  YYSYMBOL_986_57 = 986,                   /* $@57  */
  YYSYMBOL_sp_for_loop_bounds = 987,       /* sp_for_loop_bounds  */
  YYSYMBOL_loop_body = 988,                /* loop_body  */
  YYSYMBOL_while_body = 989,               /* while_body  */
  YYSYMBOL_990_58 = 990,                   /* $@58  */
  YYSYMBOL_repeat_body = 991,              /* repeat_body  */
  YYSYMBOL_992_59 = 992,                   /* $@59  */
  YYSYMBOL_pop_sp_loop_label = 993,        /* pop_sp_loop_label  */
  YYSYMBOL_sp_labeled_control = 994,       /* sp_labeled_control  */
  YYSYMBOL_995_60 = 995,                   /* $@60  */
  YYSYMBOL_996_61 = 996,                   /* $@61  */
  YYSYMBOL_997_62 = 997,                   /* $@62  */
  YYSYMBOL_998_63 = 998,                   /* $@63  */
  YYSYMBOL_999_64 = 999,                   /* $@64  */
  YYSYMBOL_1000_65 = 1000,                 /* $@65  */
  YYSYMBOL_sp_unlabeled_control = 1001,    /* sp_unlabeled_control  */
  YYSYMBOL_1002_66 = 1002,                 /* $@66  */
  YYSYMBOL_1003_67 = 1003,                 /* $@67  */
  YYSYMBOL_1004_68 = 1004,                 /* $@68  */
  YYSYMBOL_1005_69 = 1005,                 /* $@69  */
  YYSYMBOL_1006_70 = 1006,                 /* $@70  */
  YYSYMBOL_trg_action_time = 1007,         /* trg_action_time  */
  YYSYMBOL_trg_event = 1008,               /* trg_event  */
  YYSYMBOL_change_tablespace_access = 1009, /* change_tablespace_access  */
  YYSYMBOL_change_tablespace_info = 1010,  /* change_tablespace_info  */
  YYSYMBOL_tablespace_info = 1011,         /* tablespace_info  */
  YYSYMBOL_opt_logfile_group_name = 1012,  /* opt_logfile_group_name  */
  YYSYMBOL_alter_tablespace_info = 1013,   /* alter_tablespace_info  */
  YYSYMBOL_logfile_group_info = 1014,      /* logfile_group_info  */
  YYSYMBOL_alter_logfile_group_info = 1015, /* alter_logfile_group_info  */
  YYSYMBOL_add_log_file = 1016,            /* add_log_file  */
  YYSYMBOL_change_ts_option_list = 1017,   /* change_ts_option_list  */
  YYSYMBOL_1018_71 = 1018,                 /* $@71  */
  YYSYMBOL_change_ts_options = 1019,       /* change_ts_options  */
  YYSYMBOL_change_ts_option = 1020,        /* change_ts_option  */
  YYSYMBOL_tablespace_option_list = 1021,  /* tablespace_option_list  */
  YYSYMBOL_tablespace_options = 1022,      /* tablespace_options  */
  YYSYMBOL_tablespace_option = 1023,       /* tablespace_option  */
  YYSYMBOL_alter_tablespace_option_list = 1024, /* alter_tablespace_option_list  */
  YYSYMBOL_alter_tablespace_options = 1025, /* alter_tablespace_options  */
  YYSYMBOL_alter_tablespace_option = 1026, /* alter_tablespace_option  */
  YYSYMBOL_logfile_group_option_list = 1027, /* logfile_group_option_list  */
  YYSYMBOL_logfile_group_options = 1028,   /* logfile_group_options  */
  YYSYMBOL_logfile_group_option = 1029,    /* logfile_group_option  */
  YYSYMBOL_alter_logfile_group_option_list = 1030, /* alter_logfile_group_option_list  */
  YYSYMBOL_alter_logfile_group_options = 1031, /* alter_logfile_group_options  */
  YYSYMBOL_alter_logfile_group_option = 1032, /* alter_logfile_group_option  */
  YYSYMBOL_ts_datafile = 1033,             /* ts_datafile  */
  YYSYMBOL_lg_undofile = 1034,             /* lg_undofile  */
  YYSYMBOL_lg_redofile = 1035,             /* lg_redofile  */
  YYSYMBOL_tablespace_name = 1036,         /* tablespace_name  */
  YYSYMBOL_logfile_group_name = 1037,      /* logfile_group_name  */
  YYSYMBOL_ts_access_mode = 1038,          /* ts_access_mode  */
  YYSYMBOL_opt_ts_initial_size = 1039,     /* opt_ts_initial_size  */
  YYSYMBOL_opt_ts_autoextend_size = 1040,  /* opt_ts_autoextend_size  */
  YYSYMBOL_opt_ts_max_size = 1041,         /* opt_ts_max_size  */
  YYSYMBOL_opt_ts_extent_size = 1042,      /* opt_ts_extent_size  */
  YYSYMBOL_opt_ts_undo_buffer_size = 1043, /* opt_ts_undo_buffer_size  */
  YYSYMBOL_opt_ts_redo_buffer_size = 1044, /* opt_ts_redo_buffer_size  */
  YYSYMBOL_opt_ts_nodegroup = 1045,        /* opt_ts_nodegroup  */
  YYSYMBOL_opt_ts_comment = 1046,          /* opt_ts_comment  */
  YYSYMBOL_opt_ts_engine = 1047,           /* opt_ts_engine  */
  YYSYMBOL_opt_ts_wait = 1048,             /* opt_ts_wait  */
  YYSYMBOL_ts_wait = 1049,                 /* ts_wait  */
  YYSYMBOL_size_number = 1050,             /* size_number  */
  YYSYMBOL_create_body = 1051,             /* create_body  */
  YYSYMBOL_1052_72 = 1052,                 /* $@72  */
  YYSYMBOL_create_like = 1053,             /* create_like  */
  YYSYMBOL_opt_create_select = 1054,       /* opt_create_select  */
  YYSYMBOL_create_select_query_expression = 1055, /* create_select_query_expression  */
  YYSYMBOL_opt_create_partitioning = 1056, /* opt_create_partitioning  */
  YYSYMBOL_opt_partitioning = 1057,        /* opt_partitioning  */
  YYSYMBOL_partitioning = 1058,            /* partitioning  */
  YYSYMBOL_1059_73 = 1059,                 /* $@73  */
  YYSYMBOL_have_partitioning = 1060,       /* have_partitioning  */
  YYSYMBOL_partition_entry = 1061,         /* partition_entry  */
  YYSYMBOL_1062_74 = 1062,                 /* $@74  */
  YYSYMBOL_partition = 1063,               /* partition  */
  YYSYMBOL_1064_75 = 1064,                 /* $@75  */
  YYSYMBOL_part_type_def = 1065,           /* part_type_def  */
  YYSYMBOL_1066_76 = 1066,                 /* $@76  */
  YYSYMBOL_1067_77 = 1067,                 /* $@77  */
  YYSYMBOL_1068_78 = 1068,                 /* $@78  */
  YYSYMBOL_opt_linear = 1069,              /* opt_linear  */
  YYSYMBOL_opt_key_algo = 1070,            /* opt_key_algo  */
  YYSYMBOL_part_field_list = 1071,         /* part_field_list  */
  YYSYMBOL_part_field_item_list = 1072,    /* part_field_item_list  */
  YYSYMBOL_part_field_item = 1073,         /* part_field_item  */
  YYSYMBOL_part_column_list = 1074,        /* part_column_list  */
  YYSYMBOL_part_func = 1075,               /* part_func  */
  YYSYMBOL_sub_part_func = 1076,           /* sub_part_func  */
  YYSYMBOL_opt_num_parts = 1077,           /* opt_num_parts  */
  YYSYMBOL_opt_sub_part = 1078,            /* opt_sub_part  */
  YYSYMBOL_1079_79 = 1079,                 /* $@79  */
  YYSYMBOL_1080_80 = 1080,                 /* $@80  */
  YYSYMBOL_sub_part_field_list = 1081,     /* sub_part_field_list  */
  YYSYMBOL_sub_part_field_item = 1082,     /* sub_part_field_item  */
  YYSYMBOL_part_func_expr = 1083,          /* part_func_expr  */
  YYSYMBOL_opt_num_subparts = 1084,        /* opt_num_subparts  */
  YYSYMBOL_part_defs = 1085,               /* part_defs  */
  YYSYMBOL_part_def_list = 1086,           /* part_def_list  */
  YYSYMBOL_part_definition = 1087,         /* part_definition  */
  YYSYMBOL_1088_81 = 1088,                 /* $@81  */
  YYSYMBOL_part_name = 1089,               /* part_name  */
  YYSYMBOL_opt_part_values = 1090,         /* opt_part_values  */
  YYSYMBOL_1091_82 = 1091,                 /* $@82  */
  YYSYMBOL_1092_83 = 1092,                 /* $@83  */
  YYSYMBOL_part_func_max = 1093,           /* part_func_max  */
  YYSYMBOL_part_values_in = 1094,          /* part_values_in  */
  YYSYMBOL_part_value_list = 1095,         /* part_value_list  */
  YYSYMBOL_part_value_item = 1096,         /* part_value_item  */
  YYSYMBOL_1097_84 = 1097,                 /* $@84  */
  YYSYMBOL_1098_85 = 1098,                 /* $@85  */
  YYSYMBOL_part_value_item_list = 1099,    /* part_value_item_list  */
  YYSYMBOL_part_value_expr_item = 1100,    /* part_value_expr_item  */
  YYSYMBOL_opt_sub_partition = 1101,       /* opt_sub_partition  */
  YYSYMBOL_sub_part_list = 1102,           /* sub_part_list  */
  YYSYMBOL_sub_part_definition = 1103,     /* sub_part_definition  */
  YYSYMBOL_1104_86 = 1104,                 /* $@86  */
  YYSYMBOL_sub_name = 1105,                /* sub_name  */
  YYSYMBOL_opt_part_options = 1106,        /* opt_part_options  */
  YYSYMBOL_opt_part_option_list = 1107,    /* opt_part_option_list  */
  YYSYMBOL_opt_part_option = 1108,         /* opt_part_option  */
  YYSYMBOL_opt_versioning_rotation = 1109, /* opt_versioning_rotation  */
  YYSYMBOL_1110_87 = 1110,                 /* $@87  */
  YYSYMBOL_opt_versioning_interval_start = 1111, /* opt_versioning_interval_start  */
  YYSYMBOL_opt_as = 1112,                  /* opt_as  */
  YYSYMBOL_opt_create_database_options = 1113, /* opt_create_database_options  */
  YYSYMBOL_create_database_options = 1114, /* create_database_options  */
  YYSYMBOL_create_database_option = 1115,  /* create_database_option  */
  YYSYMBOL_opt_if_not_exists_table_element = 1116, /* opt_if_not_exists_table_element  */
  YYSYMBOL_opt_if_not_exists = 1117,       /* opt_if_not_exists  */
  YYSYMBOL_create_or_replace = 1118,       /* create_or_replace  */
  YYSYMBOL_opt_create_table_options = 1119, /* opt_create_table_options  */
  YYSYMBOL_create_table_options_space_separated = 1120, /* create_table_options_space_separated  */
  YYSYMBOL_create_table_options = 1121,    /* create_table_options  */
  YYSYMBOL_create_table_option = 1122,     /* create_table_option  */
  YYSYMBOL_1123_88 = 1123,                 /* $@88  */
  YYSYMBOL_opt_versioning_option = 1124,   /* opt_versioning_option  */
  YYSYMBOL_versioning_option = 1125,       /* versioning_option  */
  YYSYMBOL_default_charset = 1126,         /* default_charset  */
  YYSYMBOL_default_collation = 1127,       /* default_collation  */
  YYSYMBOL_storage_engines = 1128,         /* storage_engines  */
  YYSYMBOL_known_storage_engines = 1129,   /* known_storage_engines  */
  YYSYMBOL_row_types = 1130,               /* row_types  */
  YYSYMBOL_merge_insert_types = 1131,      /* merge_insert_types  */
  YYSYMBOL_udf_type = 1132,                /* udf_type  */
  YYSYMBOL_create_field_list = 1133,       /* create_field_list  */
  YYSYMBOL_create_field_list_parens = 1134, /* create_field_list_parens  */
  YYSYMBOL_field_list = 1135,              /* field_list  */
  YYSYMBOL_field_list_item = 1136,         /* field_list_item  */
  YYSYMBOL_column_def = 1137,              /* column_def  */
  YYSYMBOL_key_def = 1138,                 /* key_def  */
  YYSYMBOL_1139_89 = 1139,                 /* $@89  */
  YYSYMBOL_1140_90 = 1140,                 /* $@90  */
  YYSYMBOL_1141_91 = 1141,                 /* $@91  */
  YYSYMBOL_1142_92 = 1142,                 /* $@92  */
  YYSYMBOL_1143_93 = 1143,                 /* $@93  */
  YYSYMBOL_1144_94 = 1144,                 /* $@94  */
  YYSYMBOL_1145_95 = 1145,                 /* $@95  */
  YYSYMBOL_constraint_def = 1146,          /* constraint_def  */
  YYSYMBOL_period_for_system_time = 1147,  /* period_for_system_time  */
  YYSYMBOL_period_for_application_time = 1148, /* period_for_application_time  */
  YYSYMBOL_opt_check_constraint = 1149,    /* opt_check_constraint  */
  YYSYMBOL_check_constraint = 1150,        /* check_constraint  */
  YYSYMBOL_opt_constraint_no_id = 1151,    /* opt_constraint_no_id  */
  YYSYMBOL_opt_constraint = 1152,          /* opt_constraint  */
  YYSYMBOL_constraint = 1153,              /* constraint  */
  YYSYMBOL_field_spec = 1154,              /* field_spec  */
  YYSYMBOL_1155_96 = 1155,                 /* @96  */
  YYSYMBOL_field_type_or_serial = 1156,    /* field_type_or_serial  */
  YYSYMBOL_1157_97 = 1157,                 /* $@97  */
  YYSYMBOL_1158_98 = 1158,                 /* $@98  */
  YYSYMBOL_opt_serial_attribute = 1159,    /* opt_serial_attribute  */
  YYSYMBOL_opt_serial_attribute_list = 1160, /* opt_serial_attribute_list  */
  YYSYMBOL_opt_asrow_attribute = 1161,     /* opt_asrow_attribute  */
  YYSYMBOL_opt_asrow_attribute_list = 1162, /* opt_asrow_attribute_list  */
  YYSYMBOL_field_def = 1163,               /* field_def  */
  YYSYMBOL_1164_99 = 1164,                 /* $@99  */
  YYSYMBOL_opt_generated_always = 1165,    /* opt_generated_always  */
  YYSYMBOL_vcol_opt_specifier = 1166,      /* vcol_opt_specifier  */
  YYSYMBOL_vcol_opt_attribute = 1167,      /* vcol_opt_attribute  */
  YYSYMBOL_vcol_opt_attribute_list = 1168, /* vcol_opt_attribute_list  */
  YYSYMBOL_vcol_attribute = 1169,          /* vcol_attribute  */
  YYSYMBOL_parse_vcol_expr = 1170,         /* parse_vcol_expr  */
  YYSYMBOL_1171_100 = 1171,                /* $@100  */
  YYSYMBOL_parenthesized_expr = 1172,      /* parenthesized_expr  */
  YYSYMBOL_virtual_column_func = 1173,     /* virtual_column_func  */
  YYSYMBOL_expr_or_literal = 1174,         /* expr_or_literal  */
  YYSYMBOL_column_default_expr = 1175,     /* column_default_expr  */
  YYSYMBOL_field_type = 1176,              /* field_type  */
  YYSYMBOL_qualified_field_type = 1177,    /* qualified_field_type  */
  YYSYMBOL_field_type_all = 1178,          /* field_type_all  */
  YYSYMBOL_field_type_numeric = 1179,      /* field_type_numeric  */
  YYSYMBOL_opt_binary_and_compression = 1180, /* opt_binary_and_compression  */
  YYSYMBOL_field_type_string = 1181,       /* field_type_string  */
  YYSYMBOL_field_type_temporal = 1182,     /* field_type_temporal  */
  YYSYMBOL_field_type_lob = 1183,          /* field_type_lob  */
  YYSYMBOL_field_type_misc = 1184,         /* field_type_misc  */
  YYSYMBOL_spatial_type = 1185,            /* spatial_type  */
  YYSYMBOL_char = 1186,                    /* char  */
  YYSYMBOL_nchar = 1187,                   /* nchar  */
  YYSYMBOL_varchar = 1188,                 /* varchar  */
  YYSYMBOL_nvarchar = 1189,                /* nvarchar  */
  YYSYMBOL_int_type = 1190,                /* int_type  */
  YYSYMBOL_real_type = 1191,               /* real_type  */
  YYSYMBOL_srid_option = 1192,             /* srid_option  */
  YYSYMBOL_float_options = 1193,           /* float_options  */
  YYSYMBOL_precision = 1194,               /* precision  */
  YYSYMBOL_field_options = 1195,           /* field_options  */
  YYSYMBOL_field_length = 1196,            /* field_length  */
  YYSYMBOL_opt_field_length = 1197,        /* opt_field_length  */
  YYSYMBOL_opt_field_length_default_1 = 1198, /* opt_field_length_default_1  */
  YYSYMBOL_opt_precision = 1199,           /* opt_precision  */
  YYSYMBOL_attribute_list = 1200,          /* attribute_list  */
  YYSYMBOL_attribute = 1201,               /* attribute  */
  YYSYMBOL_opt_compression_method = 1202,  /* opt_compression_method  */
  YYSYMBOL_opt_compressed = 1203,          /* opt_compressed  */
  YYSYMBOL_compressed = 1204,              /* compressed  */
  YYSYMBOL_compressed_deprecated_data_type_attribute = 1205, /* compressed_deprecated_data_type_attribute  */
  YYSYMBOL_compressed_deprecated_column_attribute = 1206, /* compressed_deprecated_column_attribute  */
  YYSYMBOL_asrow_attribute = 1207,         /* asrow_attribute  */
  YYSYMBOL_serial_attribute = 1208,        /* serial_attribute  */
  YYSYMBOL_with_or_without_system = 1209,  /* with_or_without_system  */
  YYSYMBOL_charset = 1210,                 /* charset  */
  YYSYMBOL_charset_name = 1211,            /* charset_name  */
  YYSYMBOL_charset_name_or_default = 1212, /* charset_name_or_default  */
  YYSYMBOL_opt_load_data_charset = 1213,   /* opt_load_data_charset  */
  YYSYMBOL_old_or_new_charset_name = 1214, /* old_or_new_charset_name  */
  YYSYMBOL_old_or_new_charset_name_or_default = 1215, /* old_or_new_charset_name_or_default  */
  YYSYMBOL_collation_name = 1216,          /* collation_name  */
  YYSYMBOL_opt_collate = 1217,             /* opt_collate  */
  YYSYMBOL_collation_name_or_default = 1218, /* collation_name_or_default  */
  YYSYMBOL_opt_default = 1219,             /* opt_default  */
  YYSYMBOL_charset_or_alias = 1220,        /* charset_or_alias  */
  YYSYMBOL_collate = 1221,                 /* collate  */
  YYSYMBOL_opt_binary = 1222,              /* opt_binary  */
  YYSYMBOL_binary = 1223,                  /* binary  */
  YYSYMBOL_opt_bin_mod = 1224,             /* opt_bin_mod  */
  YYSYMBOL_ws_nweights = 1225,             /* ws_nweights  */
  YYSYMBOL_1226_101 = 1226,                /* $@101  */
  YYSYMBOL_ws_level_flag_desc = 1227,      /* ws_level_flag_desc  */
  YYSYMBOL_ws_level_flag_reverse = 1228,   /* ws_level_flag_reverse  */
  YYSYMBOL_ws_level_flags = 1229,          /* ws_level_flags  */
  YYSYMBOL_ws_level_number = 1230,         /* ws_level_number  */
  YYSYMBOL_ws_level_list_item = 1231,      /* ws_level_list_item  */
  YYSYMBOL_ws_level_list = 1232,           /* ws_level_list  */
  YYSYMBOL_ws_level_range = 1233,          /* ws_level_range  */
  YYSYMBOL_ws_level_list_or_range = 1234,  /* ws_level_list_or_range  */
  YYSYMBOL_opt_ws_levels = 1235,           /* opt_ws_levels  */
  YYSYMBOL_opt_primary = 1236,             /* opt_primary  */
  YYSYMBOL_references = 1237,              /* references  */
  YYSYMBOL_opt_ref_list = 1238,            /* opt_ref_list  */
  YYSYMBOL_ref_list = 1239,                /* ref_list  */
  YYSYMBOL_opt_match_clause = 1240,        /* opt_match_clause  */
  YYSYMBOL_opt_on_update_delete = 1241,    /* opt_on_update_delete  */
  YYSYMBOL_delete_option = 1242,           /* delete_option  */
  YYSYMBOL_constraint_key_type = 1243,     /* constraint_key_type  */
  YYSYMBOL_key_or_index = 1244,            /* key_or_index  */
  YYSYMBOL_opt_key_or_index = 1245,        /* opt_key_or_index  */
  YYSYMBOL_keys_or_index = 1246,           /* keys_or_index  */
  YYSYMBOL_opt_unique = 1247,              /* opt_unique  */
  YYSYMBOL_fulltext = 1248,                /* fulltext  */
  YYSYMBOL_spatial = 1249,                 /* spatial  */
  YYSYMBOL_normal_key_options = 1250,      /* normal_key_options  */
  YYSYMBOL_fulltext_key_options = 1251,    /* fulltext_key_options  */
  YYSYMBOL_spatial_key_options = 1252,     /* spatial_key_options  */
  YYSYMBOL_normal_key_opts = 1253,         /* normal_key_opts  */
  YYSYMBOL_spatial_key_opts = 1254,        /* spatial_key_opts  */
  YYSYMBOL_fulltext_key_opts = 1255,       /* fulltext_key_opts  */
  YYSYMBOL_opt_USING_key_algorithm = 1256, /* opt_USING_key_algorithm  */
  YYSYMBOL_opt_key_algorithm_clause = 1257, /* opt_key_algorithm_clause  */
  YYSYMBOL_key_using_alg = 1258,           /* key_using_alg  */
  YYSYMBOL_all_key_opt = 1259,             /* all_key_opt  */
  YYSYMBOL_normal_key_opt = 1260,          /* normal_key_opt  */
  YYSYMBOL_spatial_key_opt = 1261,         /* spatial_key_opt  */
  YYSYMBOL_fulltext_key_opt = 1262,        /* fulltext_key_opt  */
  YYSYMBOL_btree_or_rtree = 1263,          /* btree_or_rtree  */
  YYSYMBOL_key_list = 1264,                /* key_list  */
  YYSYMBOL_key_part = 1265,                /* key_part  */
  YYSYMBOL_opt_ident = 1266,               /* opt_ident  */
  YYSYMBOL_string_list = 1267,             /* string_list  */
  YYSYMBOL_alter = 1268,                   /* alter  */
  YYSYMBOL_1269_102 = 1269,                /* $@102  */
  YYSYMBOL_1270_103 = 1270,                /* $@103  */
  YYSYMBOL_1271_104 = 1271,                /* $@104  */
  YYSYMBOL_1272_105 = 1272,                /* $@105  */
  YYSYMBOL_1273_106 = 1273,                /* $@106  */
  YYSYMBOL_1274_107 = 1274,                /* $@107  */
  YYSYMBOL_1275_108 = 1275,                /* $@108  */
  YYSYMBOL_1276_109 = 1276,                /* $@109  */
  YYSYMBOL_1277_110 = 1277,                /* $@110  */
  YYSYMBOL_1278_111 = 1278,                /* $@111  */
  YYSYMBOL_1279_112 = 1279,                /* $@112  */
  YYSYMBOL_account_locking_option = 1280,  /* account_locking_option  */
  YYSYMBOL_opt_password_expire_option = 1281, /* opt_password_expire_option  */
  YYSYMBOL_opt_account_locking_and_opt_password_expiration = 1282, /* opt_account_locking_and_opt_password_expiration  */
  YYSYMBOL_ev_alter_on_schedule_completion = 1283, /* ev_alter_on_schedule_completion  */
  YYSYMBOL_opt_ev_rename_to = 1284,        /* opt_ev_rename_to  */
  YYSYMBOL_opt_ev_sql_stmt = 1285,         /* opt_ev_sql_stmt  */
  YYSYMBOL_ident_or_empty = 1286,          /* ident_or_empty  */
  YYSYMBOL_alter_commands = 1287,          /* alter_commands  */
  YYSYMBOL_1288_113 = 1288,                /* $@113  */
  YYSYMBOL_1289_114 = 1289,                /* $@114  */
  YYSYMBOL_1290_115 = 1290,                /* $@115  */
  YYSYMBOL_remove_partitioning = 1291,     /* remove_partitioning  */
  YYSYMBOL_all_or_alt_part_name_list = 1292, /* all_or_alt_part_name_list  */
  YYSYMBOL_add_partition_rule = 1293,      /* add_partition_rule  */
  YYSYMBOL_1294_116 = 1294,                /* $@116  */
  YYSYMBOL_add_part_extra = 1295,          /* add_part_extra  */
  YYSYMBOL_reorg_partition_rule = 1296,    /* reorg_partition_rule  */
  YYSYMBOL_1297_117 = 1297,                /* $@117  */
  YYSYMBOL_reorg_parts_rule = 1298,        /* reorg_parts_rule  */
  YYSYMBOL_1299_118 = 1299,                /* $@118  */
  YYSYMBOL_alt_part_name_list = 1300,      /* alt_part_name_list  */
  YYSYMBOL_alt_part_name_item = 1301,      /* alt_part_name_item  */
  YYSYMBOL_alter_list = 1302,              /* alter_list  */
  YYSYMBOL_add_column = 1303,              /* add_column  */
  YYSYMBOL_alter_list_item = 1304,         /* alter_list_item  */
  YYSYMBOL_opt_index_lock_algorithm = 1305, /* opt_index_lock_algorithm  */
  YYSYMBOL_alter_algorithm_option = 1306,  /* alter_algorithm_option  */
  YYSYMBOL_alter_lock_option = 1307,       /* alter_lock_option  */
  YYSYMBOL_opt_column = 1308,              /* opt_column  */
  YYSYMBOL_opt_ignore = 1309,              /* opt_ignore  */
  YYSYMBOL_alter_options = 1310,           /* alter_options  */
  YYSYMBOL_1311_119 = 1311,                /* $@119  */
  YYSYMBOL_alter_options_part2 = 1312,     /* alter_options_part2  */
  YYSYMBOL_alter_option_list = 1313,       /* alter_option_list  */
  YYSYMBOL_alter_option = 1314,            /* alter_option  */
  YYSYMBOL_opt_restrict = 1315,            /* opt_restrict  */
  YYSYMBOL_opt_place = 1316,               /* opt_place  */
  YYSYMBOL_opt_to = 1317,                  /* opt_to  */
  YYSYMBOL_slave = 1318,                   /* slave  */
  YYSYMBOL_1319_120 = 1319,                /* $@120  */
  YYSYMBOL_1320_121 = 1320,                /* $@121  */
  YYSYMBOL_start = 1321,                   /* start  */
  YYSYMBOL_opt_start_transaction_option_list = 1322, /* opt_start_transaction_option_list  */
  YYSYMBOL_start_transaction_option_list = 1323, /* start_transaction_option_list  */
  YYSYMBOL_start_transaction_option = 1324, /* start_transaction_option  */
  YYSYMBOL_slave_thread_opts = 1325,       /* slave_thread_opts  */
  YYSYMBOL_1326_122 = 1326,                /* $@122  */
  YYSYMBOL_slave_thread_opt_list = 1327,   /* slave_thread_opt_list  */
  YYSYMBOL_slave_thread_opt = 1328,        /* slave_thread_opt  */
  YYSYMBOL_slave_until = 1329,             /* slave_until  */
  YYSYMBOL_slave_until_opts = 1330,        /* slave_until_opts  */
  YYSYMBOL_checksum = 1331,                /* checksum  */
  YYSYMBOL_1332_123 = 1332,                /* $@123  */
  YYSYMBOL_opt_checksum_type = 1333,       /* opt_checksum_type  */
  YYSYMBOL_repair_table_or_view = 1334,    /* repair_table_or_view  */
  YYSYMBOL_1335_124 = 1335,                /* $@124  */
  YYSYMBOL_repair = 1336,                  /* repair  */
  YYSYMBOL_1337_125 = 1337,                /* $@125  */
  YYSYMBOL_opt_mi_repair_type = 1338,      /* opt_mi_repair_type  */
  YYSYMBOL_mi_repair_types = 1339,         /* mi_repair_types  */
  YYSYMBOL_mi_repair_type = 1340,          /* mi_repair_type  */
  YYSYMBOL_opt_view_repair_type = 1341,    /* opt_view_repair_type  */
  YYSYMBOL_analyze = 1342,                 /* analyze  */
  YYSYMBOL_1343_126 = 1343,                /* $@126  */
  YYSYMBOL_analyze_table_list = 1344,      /* analyze_table_list  */
  YYSYMBOL_analyze_table_elem_spec = 1345, /* analyze_table_elem_spec  */
  YYSYMBOL_opt_persistent_stat_clause = 1346, /* opt_persistent_stat_clause  */
  YYSYMBOL_persistent_stat_spec = 1347,    /* persistent_stat_spec  */
  YYSYMBOL_persistent_column_stat_spec = 1348, /* persistent_column_stat_spec  */
  YYSYMBOL_1349_127 = 1349,                /* $@127  */
  YYSYMBOL_persistent_index_stat_spec = 1350, /* persistent_index_stat_spec  */
  YYSYMBOL_1351_128 = 1351,                /* $@128  */
  YYSYMBOL_table_column_list = 1352,       /* table_column_list  */
  YYSYMBOL_table_index_list = 1353,        /* table_index_list  */
  YYSYMBOL_table_index_name = 1354,        /* table_index_name  */
  YYSYMBOL_binlog_base64_event = 1355,     /* binlog_base64_event  */
  YYSYMBOL_check_view_or_table = 1356,     /* check_view_or_table  */
  YYSYMBOL_1357_129 = 1357,                /* $@129  */
  YYSYMBOL_check = 1358,                   /* check  */
  YYSYMBOL_1359_130 = 1359,                /* $@130  */
  YYSYMBOL_opt_mi_check_type = 1360,       /* opt_mi_check_type  */
  YYSYMBOL_mi_check_types = 1361,          /* mi_check_types  */
  YYSYMBOL_mi_check_type = 1362,           /* mi_check_type  */
  YYSYMBOL_opt_view_check_type = 1363,     /* opt_view_check_type  */
  YYSYMBOL_optimize = 1364,                /* optimize  */
  YYSYMBOL_1365_131 = 1365,                /* $@131  */
  YYSYMBOL_opt_no_write_to_binlog = 1366,  /* opt_no_write_to_binlog  */
  YYSYMBOL_rename = 1367,                  /* rename  */
  YYSYMBOL_1368_132 = 1368,                /* $@132  */
  YYSYMBOL_rename_list = 1369,             /* rename_list  */
  YYSYMBOL_table_to_table_list = 1370,     /* table_to_table_list  */
  YYSYMBOL_table_to_table = 1371,          /* table_to_table  */
  YYSYMBOL_keycache = 1372,                /* keycache  */
  YYSYMBOL_1373_133 = 1373,                /* $@133  */
  YYSYMBOL_keycache_list_or_parts = 1374,  /* keycache_list_or_parts  */
  YYSYMBOL_keycache_list = 1375,           /* keycache_list  */
  YYSYMBOL_assign_to_keycache = 1376,      /* assign_to_keycache  */
  YYSYMBOL_assign_to_keycache_parts = 1377, /* assign_to_keycache_parts  */
  YYSYMBOL_key_cache_name = 1378,          /* key_cache_name  */
  YYSYMBOL_preload = 1379,                 /* preload  */
  YYSYMBOL_1380_134 = 1380,                /* $@134  */
  YYSYMBOL_preload_list_or_parts = 1381,   /* preload_list_or_parts  */
  YYSYMBOL_preload_list = 1382,            /* preload_list  */
  YYSYMBOL_preload_keys = 1383,            /* preload_keys  */
  YYSYMBOL_preload_keys_parts = 1384,      /* preload_keys_parts  */
  YYSYMBOL_adm_partition = 1385,           /* adm_partition  */
  YYSYMBOL_1386_135 = 1386,                /* $@135  */
  YYSYMBOL_cache_keys_spec = 1387,         /* cache_keys_spec  */
  YYSYMBOL_1388_136 = 1388,                /* $@136  */
  YYSYMBOL_cache_key_list_or_empty = 1389, /* cache_key_list_or_empty  */
  YYSYMBOL_opt_ignore_leaves = 1390,       /* opt_ignore_leaves  */
  YYSYMBOL_select = 1391,                  /* select  */
  YYSYMBOL_1392_137 = 1392,                /* $@137  */
  YYSYMBOL_1393_138 = 1393,                /* $@138  */
  YYSYMBOL_select_into = 1394,             /* select_into  */
  YYSYMBOL_1395_139 = 1395,                /* $@139  */
  YYSYMBOL_1396_140 = 1396,                /* $@140  */
  YYSYMBOL_simple_table = 1397,            /* simple_table  */
  YYSYMBOL_table_value_constructor = 1398, /* table_value_constructor  */
  YYSYMBOL_1399_141 = 1399,                /* $@141  */
  YYSYMBOL_query_specification_start = 1400, /* query_specification_start  */
  YYSYMBOL_1401_142 = 1401,                /* $@142  */
  YYSYMBOL_1402_143 = 1402,                /* $@143  */
  YYSYMBOL_query_specification = 1403,     /* query_specification  */
  YYSYMBOL_select_into_query_specification = 1404, /* select_into_query_specification  */
  YYSYMBOL_query_expression = 1405,        /* query_expression  */
  YYSYMBOL_query_expression_no_with_clause = 1406, /* query_expression_no_with_clause  */
  YYSYMBOL_query_expression_body_ext = 1407, /* query_expression_body_ext  */
  YYSYMBOL_1408_144 = 1408,                /* $@144  */
  YYSYMBOL_1409_145 = 1409,                /* $@145  */
  YYSYMBOL_query_expression_body_ext_parens = 1410, /* query_expression_body_ext_parens  */
  YYSYMBOL_query_expression_body = 1411,   /* query_expression_body  */
  YYSYMBOL_1412_146 = 1412,                /* $@146  */
  YYSYMBOL_query_primary = 1413,           /* query_primary  */
  YYSYMBOL_query_simple = 1414,            /* query_simple  */
  YYSYMBOL_subselect = 1415,               /* subselect  */
  YYSYMBOL_subquery = 1416,                /* subquery  */
  YYSYMBOL_opt_from_clause = 1417,         /* opt_from_clause  */
  YYSYMBOL_from_clause = 1418,             /* from_clause  */
  YYSYMBOL_table_reference_list = 1419,    /* table_reference_list  */
  YYSYMBOL_select_options = 1420,          /* select_options  */
  YYSYMBOL_opt_history_unit = 1421,        /* opt_history_unit  */
  YYSYMBOL_history_point = 1422,           /* history_point  */
  YYSYMBOL_for_portion_of_time_clause = 1423, /* for_portion_of_time_clause  */
  YYSYMBOL_opt_for_portion_of_time_clause = 1424, /* opt_for_portion_of_time_clause  */
  YYSYMBOL_opt_for_system_time_clause = 1425, /* opt_for_system_time_clause  */
  YYSYMBOL_system_time_expr = 1426,        /* system_time_expr  */
  YYSYMBOL_select_option_list = 1427,      /* select_option_list  */
  YYSYMBOL_select_option = 1428,           /* select_option  */
  YYSYMBOL_select_lock_type = 1429,        /* select_lock_type  */
  YYSYMBOL_opt_select_lock_type = 1430,    /* opt_select_lock_type  */
  YYSYMBOL_opt_lock_wait_timeout_new = 1431, /* opt_lock_wait_timeout_new  */
  YYSYMBOL_select_item_list = 1432,        /* select_item_list  */
  YYSYMBOL_select_item = 1433,             /* select_item  */
  YYSYMBOL_remember_tok_start = 1434,      /* remember_tok_start  */
  YYSYMBOL_remember_name = 1435,           /* remember_name  */
  YYSYMBOL_remember_end = 1436,            /* remember_end  */
  YYSYMBOL_select_alias = 1437,            /* select_alias  */
  YYSYMBOL_opt_default_time_precision = 1438, /* opt_default_time_precision  */
  YYSYMBOL_opt_time_precision = 1439,      /* opt_time_precision  */
  YYSYMBOL_optional_braces = 1440,         /* optional_braces  */
  YYSYMBOL_expr = 1441,                    /* expr  */
  YYSYMBOL_boolean_test = 1442,            /* boolean_test  */
  YYSYMBOL_predicate = 1443,               /* predicate  */
  YYSYMBOL_bit_expr = 1444,                /* bit_expr  */
  YYSYMBOL_or = 1445,                      /* or  */
  YYSYMBOL_and = 1446,                     /* and  */
  YYSYMBOL_not = 1447,                     /* not  */
  YYSYMBOL_not2 = 1448,                    /* not2  */
  YYSYMBOL_comp_op = 1449,                 /* comp_op  */
  YYSYMBOL_all_or_any = 1450,              /* all_or_any  */
  YYSYMBOL_opt_dyncol_type = 1451,         /* opt_dyncol_type  */
  YYSYMBOL_dyncol_type = 1452,             /* dyncol_type  */
  YYSYMBOL_numeric_dyncol_type = 1453,     /* numeric_dyncol_type  */
  YYSYMBOL_temporal_dyncol_type = 1454,    /* temporal_dyncol_type  */
  YYSYMBOL_string_dyncol_type = 1455,      /* string_dyncol_type  */
  YYSYMBOL_1456_147 = 1456,                /* $@147  */
  YYSYMBOL_dyncall_create_element = 1457,  /* dyncall_create_element  */
  YYSYMBOL_dyncall_create_list = 1458,     /* dyncall_create_list  */
  YYSYMBOL_plsql_cursor_attr = 1459,       /* plsql_cursor_attr  */
  YYSYMBOL_explicit_cursor_attr = 1460,    /* explicit_cursor_attr  */
  YYSYMBOL_trim_operands = 1461,           /* trim_operands  */
  YYSYMBOL_column_default_non_parenthesized_expr = 1462, /* column_default_non_parenthesized_expr  */
  YYSYMBOL_primary_expr = 1463,            /* primary_expr  */
  YYSYMBOL_string_factor_expr = 1464,      /* string_factor_expr  */
  YYSYMBOL_simple_expr = 1465,             /* simple_expr  */
  YYSYMBOL_mysql_concatenation_expr = 1466, /* mysql_concatenation_expr  */
  YYSYMBOL_function_call_keyword_timestamp = 1467, /* function_call_keyword_timestamp  */
  YYSYMBOL_function_call_keyword = 1468,   /* function_call_keyword  */
  YYSYMBOL_substring_operands = 1469,      /* substring_operands  */
  YYSYMBOL_function_call_nonkeyword = 1470, /* function_call_nonkeyword  */
  YYSYMBOL_function_call_conflict = 1471,  /* function_call_conflict  */
  YYSYMBOL_geometry_function = 1472,       /* geometry_function  */
  YYSYMBOL_function_call_generic = 1473,   /* function_call_generic  */
  YYSYMBOL_1474_148 = 1474,                /* @148  */
  YYSYMBOL_fulltext_options = 1475,        /* fulltext_options  */
  YYSYMBOL_opt_natural_language_mode = 1476, /* opt_natural_language_mode  */
  YYSYMBOL_opt_query_expansion = 1477,     /* opt_query_expansion  */
  YYSYMBOL_opt_udf_expr_list = 1478,       /* opt_udf_expr_list  */
  YYSYMBOL_udf_expr_list = 1479,           /* udf_expr_list  */
  YYSYMBOL_udf_expr = 1480,                /* udf_expr  */
  YYSYMBOL_sum_expr = 1481,                /* sum_expr  */
  YYSYMBOL_1482_149 = 1482,                /* $@149  */
  YYSYMBOL_1483_150 = 1483,                /* $@150  */
  YYSYMBOL_1484_151 = 1484,                /* $@151  */
  YYSYMBOL_window_func_expr = 1485,        /* window_func_expr  */
  YYSYMBOL_window_func = 1486,             /* window_func  */
  YYSYMBOL_simple_window_func = 1487,      /* simple_window_func  */
  YYSYMBOL_inverse_distribution_function = 1488, /* inverse_distribution_function  */
  YYSYMBOL_percentile_function = 1489,     /* percentile_function  */
  YYSYMBOL_1490_152 = 1490,                /* $@152  */
  YYSYMBOL_inverse_distribution_function_def = 1491, /* inverse_distribution_function_def  */
  YYSYMBOL_order_by_single_element_list = 1492, /* order_by_single_element_list  */
  YYSYMBOL_window_name = 1493,             /* window_name  */
  YYSYMBOL_variable = 1494,                /* variable  */
  YYSYMBOL_1495_153 = 1495,                /* $@153  */
  YYSYMBOL_variable_aux = 1496,            /* variable_aux  */
  YYSYMBOL_opt_distinct = 1497,            /* opt_distinct  */
  YYSYMBOL_opt_gconcat_separator = 1498,   /* opt_gconcat_separator  */
  YYSYMBOL_opt_gorder_clause = 1499,       /* opt_gorder_clause  */
  YYSYMBOL_gorder_list = 1500,             /* gorder_list  */
  YYSYMBOL_opt_glimit_clause = 1501,       /* opt_glimit_clause  */
  YYSYMBOL_glimit_clause_init = 1502,      /* glimit_clause_init  */
  YYSYMBOL_glimit_clause = 1503,           /* glimit_clause  */
  YYSYMBOL_glimit_options = 1504,          /* glimit_options  */
  YYSYMBOL_in_sum_expr = 1505,             /* in_sum_expr  */
  YYSYMBOL_1506_154 = 1506,                /* $@154  */
  YYSYMBOL_cast_type = 1507,               /* cast_type  */
  YYSYMBOL_1508_155 = 1508,                /* $@155  */
  YYSYMBOL_1509_156 = 1509,                /* $@156  */
  YYSYMBOL_1510_157 = 1510,                /* $@157  */
  YYSYMBOL_cast_type_numeric = 1511,       /* cast_type_numeric  */
  YYSYMBOL_cast_type_temporal = 1512,      /* cast_type_temporal  */
  YYSYMBOL_opt_expr_list = 1513,           /* opt_expr_list  */
  YYSYMBOL_expr_list = 1514,               /* expr_list  */
  YYSYMBOL_ident_list_arg = 1515,          /* ident_list_arg  */
  YYSYMBOL_ident_list = 1516,              /* ident_list  */
  YYSYMBOL_when_list = 1517,               /* when_list  */
  YYSYMBOL_when_list_opt_else = 1518,      /* when_list_opt_else  */
  YYSYMBOL_decode_when_list_oracle = 1519, /* decode_when_list_oracle  */
  YYSYMBOL_table_ref = 1520,               /* table_ref  */
  YYSYMBOL_join_table_list = 1521,         /* join_table_list  */
  YYSYMBOL_esc_table_ref = 1522,           /* esc_table_ref  */
  YYSYMBOL_derived_table_list = 1523,      /* derived_table_list  */
  YYSYMBOL_join_table = 1524,              /* join_table  */
  YYSYMBOL_1525_158 = 1525,                /* $@158  */
  YYSYMBOL_1526_159 = 1526,                /* $@159  */
  YYSYMBOL_1527_160 = 1527,                /* $@160  */
  YYSYMBOL_1528_161 = 1528,                /* $@161  */
  YYSYMBOL_1529_162 = 1529,                /* $@162  */
  YYSYMBOL_1530_163 = 1530,                /* $@163  */
  YYSYMBOL_inner_join = 1531,              /* inner_join  */
  YYSYMBOL_normal_join = 1532,             /* normal_join  */
  YYSYMBOL_opt_use_partition = 1533,       /* opt_use_partition  */
  YYSYMBOL_use_partition = 1534,           /* use_partition  */
  YYSYMBOL_table_factor = 1535,            /* table_factor  */
  YYSYMBOL_table_primary_ident_opt_parens = 1536, /* table_primary_ident_opt_parens  */
  YYSYMBOL_table_primary_derived_opt_parens = 1537, /* table_primary_derived_opt_parens  */
  YYSYMBOL_table_reference_list_parens = 1538, /* table_reference_list_parens  */
  YYSYMBOL_nested_table_reference_list = 1539, /* nested_table_reference_list  */
  YYSYMBOL_join_table_parens = 1540,       /* join_table_parens  */
  YYSYMBOL_table_primary_ident = 1541,     /* table_primary_ident  */
  YYSYMBOL_table_primary_derived = 1542,   /* table_primary_derived  */
  YYSYMBOL_opt_outer = 1543,               /* opt_outer  */
  YYSYMBOL_index_hint_clause = 1544,       /* index_hint_clause  */
  YYSYMBOL_index_hint_type = 1545,         /* index_hint_type  */
  YYSYMBOL_index_hint_definition = 1546,   /* index_hint_definition  */
  YYSYMBOL_1547_164 = 1547,                /* $@164  */
  YYSYMBOL_1548_165 = 1548,                /* $@165  */
  YYSYMBOL_index_hints_list = 1549,        /* index_hints_list  */
  YYSYMBOL_opt_index_hints_list = 1550,    /* opt_index_hints_list  */
  YYSYMBOL_1551_166 = 1551,                /* $@166  */
  YYSYMBOL_opt_key_definition = 1552,      /* opt_key_definition  */
  YYSYMBOL_1553_167 = 1553,                /* $@167  */
  YYSYMBOL_opt_key_usage_list = 1554,      /* opt_key_usage_list  */
  YYSYMBOL_key_usage_element = 1555,       /* key_usage_element  */
  YYSYMBOL_key_usage_list = 1556,          /* key_usage_list  */
  YYSYMBOL_using_list = 1557,              /* using_list  */
  YYSYMBOL_interval = 1558,                /* interval  */
  YYSYMBOL_interval_time_stamp = 1559,     /* interval_time_stamp  */
  YYSYMBOL_date_time_type = 1560,          /* date_time_type  */
  YYSYMBOL_table_alias = 1561,             /* table_alias  */
  YYSYMBOL_opt_table_alias_clause = 1562,  /* opt_table_alias_clause  */
  YYSYMBOL_table_alias_clause = 1563,      /* table_alias_clause  */
  YYSYMBOL_opt_all = 1564,                 /* opt_all  */
  YYSYMBOL_opt_where_clause = 1565,        /* opt_where_clause  */
  YYSYMBOL_1566_168 = 1566,                /* $@168  */
  YYSYMBOL_opt_having_clause = 1567,       /* opt_having_clause  */
  YYSYMBOL_1568_169 = 1568,                /* $@169  */
  YYSYMBOL_opt_group_clause = 1569,        /* opt_group_clause  */
  YYSYMBOL_group_list = 1570,              /* group_list  */
  YYSYMBOL_olap_opt = 1571,                /* olap_opt  */
  YYSYMBOL_opt_window_clause = 1572,       /* opt_window_clause  */
  YYSYMBOL_window_def_list = 1573,         /* window_def_list  */
  YYSYMBOL_window_def = 1574,              /* window_def  */
  YYSYMBOL_window_spec = 1575,             /* window_spec  */
  YYSYMBOL_1576_170 = 1576,                /* $@170  */
  YYSYMBOL_opt_window_ref = 1577,          /* opt_window_ref  */
  YYSYMBOL_opt_window_partition_clause = 1578, /* opt_window_partition_clause  */
  YYSYMBOL_opt_window_order_clause = 1579, /* opt_window_order_clause  */
  YYSYMBOL_opt_window_frame_clause = 1580, /* opt_window_frame_clause  */
  YYSYMBOL_window_frame_units = 1581,      /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 1582,     /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 1583,      /* window_frame_start  */
  YYSYMBOL_window_frame_bound = 1584,      /* window_frame_bound  */
  YYSYMBOL_opt_window_frame_exclusion = 1585, /* opt_window_frame_exclusion  */
  YYSYMBOL_alter_order_clause = 1586,      /* alter_order_clause  */
  YYSYMBOL_alter_order_list = 1587,        /* alter_order_list  */
  YYSYMBOL_alter_order_item = 1588,        /* alter_order_item  */
  YYSYMBOL_opt_order_clause = 1589,        /* opt_order_clause  */
  YYSYMBOL_order_clause = 1590,            /* order_clause  */
  YYSYMBOL_1591_171 = 1591,                /* $@171  */
  YYSYMBOL_order_list = 1592,              /* order_list  */
  YYSYMBOL_order_dir = 1593,               /* order_dir  */
  YYSYMBOL_opt_limit_clause = 1594,        /* opt_limit_clause  */
  YYSYMBOL_limit_clause = 1595,            /* limit_clause  */
  YYSYMBOL_opt_global_limit_clause = 1596, /* opt_global_limit_clause  */
  YYSYMBOL_limit_options = 1597,           /* limit_options  */
  YYSYMBOL_limit_option = 1598,            /* limit_option  */
  YYSYMBOL_limit_rows_option = 1599,       /* limit_rows_option  */
  YYSYMBOL_delete_limit_clause = 1600,     /* delete_limit_clause  */
  YYSYMBOL_order_limit_lock = 1601,        /* order_limit_lock  */
  YYSYMBOL_opt_order_limit_lock = 1602,    /* opt_order_limit_lock  */
  YYSYMBOL_query_expression_tail = 1603,   /* query_expression_tail  */
  YYSYMBOL_opt_query_expression_tail = 1604, /* opt_query_expression_tail  */
  YYSYMBOL_opt_procedure_or_into = 1605,   /* opt_procedure_or_into  */
  YYSYMBOL_order_or_limit = 1606,          /* order_or_limit  */
  YYSYMBOL_opt_plus = 1607,                /* opt_plus  */
  YYSYMBOL_int_num = 1608,                 /* int_num  */
  YYSYMBOL_ulong_num = 1609,               /* ulong_num  */
  YYSYMBOL_real_ulong_num = 1610,          /* real_ulong_num  */
  YYSYMBOL_longlong_num = 1611,            /* longlong_num  */
  YYSYMBOL_ulonglong_num = 1612,           /* ulonglong_num  */
  YYSYMBOL_real_ulonglong_num = 1613,      /* real_ulonglong_num  */
  YYSYMBOL_dec_num_error = 1614,           /* dec_num_error  */
  YYSYMBOL_dec_num = 1615,                 /* dec_num  */
  YYSYMBOL_choice = 1616,                  /* choice  */
  YYSYMBOL_bool = 1617,                    /* bool  */
  YYSYMBOL_procedure_clause = 1618,        /* procedure_clause  */
  YYSYMBOL_1619_172 = 1619,                /* $@172  */
  YYSYMBOL_procedure_list = 1620,          /* procedure_list  */
  YYSYMBOL_procedure_list2 = 1621,         /* procedure_list2  */
  YYSYMBOL_procedure_item = 1622,          /* procedure_item  */
  YYSYMBOL_select_var_list_init = 1623,    /* select_var_list_init  */
  YYSYMBOL_1624_173 = 1624,                /* $@173  */
  YYSYMBOL_select_var_list = 1625,         /* select_var_list  */
  YYSYMBOL_select_var_ident = 1626,        /* select_var_ident  */
  YYSYMBOL_select_outvar = 1627,           /* select_outvar  */
  YYSYMBOL_into = 1628,                    /* into  */
  YYSYMBOL_into_destination = 1629,        /* into_destination  */
  YYSYMBOL_1630_174 = 1630,                /* $@174  */
  YYSYMBOL_1631_175 = 1631,                /* $@175  */
  YYSYMBOL_do = 1632,                      /* do  */
  YYSYMBOL_1633_176 = 1633,                /* $@176  */
  YYSYMBOL_drop = 1634,                    /* drop  */
  YYSYMBOL_1635_177 = 1635,                /* $@177  */
  YYSYMBOL_1636_178 = 1636,                /* $@178  */
  YYSYMBOL_1637_179 = 1637,                /* $@179  */
  YYSYMBOL_1638_180 = 1638,                /* $@180  */
  YYSYMBOL_table_list = 1639,              /* table_list  */
  YYSYMBOL_table_name = 1640,              /* table_name  */
  YYSYMBOL_table_name_with_opt_use_partition = 1641, /* table_name_with_opt_use_partition  */
  YYSYMBOL_table_alias_ref_list = 1642,    /* table_alias_ref_list  */
  YYSYMBOL_table_alias_ref = 1643,         /* table_alias_ref  */
  YYSYMBOL_opt_if_exists_table_element = 1644, /* opt_if_exists_table_element  */
  YYSYMBOL_opt_if_exists = 1645,           /* opt_if_exists  */
  YYSYMBOL_opt_temporary = 1646,           /* opt_temporary  */
  YYSYMBOL_insert = 1647,                  /* insert  */
  YYSYMBOL_1648_181 = 1648,                /* $@181  */
  YYSYMBOL_1649_182 = 1649,                /* $@182  */
  YYSYMBOL_replace = 1650,                 /* replace  */
  YYSYMBOL_1651_183 = 1651,                /* $@183  */
  YYSYMBOL_1652_184 = 1652,                /* $@184  */
  YYSYMBOL_insert_lock_option = 1653,      /* insert_lock_option  */
  YYSYMBOL_replace_lock_option = 1654,     /* replace_lock_option  */
  YYSYMBOL_insert2 = 1655,                 /* insert2  */
  YYSYMBOL_insert_table = 1656,            /* insert_table  */
  YYSYMBOL_1657_185 = 1657,                /* $@185  */
  YYSYMBOL_insert_field_spec = 1658,       /* insert_field_spec  */
  YYSYMBOL_1659_186 = 1659,                /* $@186  */
  YYSYMBOL_insert_field_list = 1660,       /* insert_field_list  */
  YYSYMBOL_opt_fields = 1661,              /* opt_fields  */
  YYSYMBOL_fields = 1662,                  /* fields  */
  YYSYMBOL_insert_values = 1663,           /* insert_values  */
  YYSYMBOL_values_list = 1664,             /* values_list  */
  YYSYMBOL_ident_eq_list = 1665,           /* ident_eq_list  */
  YYSYMBOL_ident_eq_value = 1666,          /* ident_eq_value  */
  YYSYMBOL_equal = 1667,                   /* equal  */
  YYSYMBOL_opt_equal = 1668,               /* opt_equal  */
  YYSYMBOL_opt_with = 1669,                /* opt_with  */
  YYSYMBOL_opt_by = 1670,                  /* opt_by  */
  YYSYMBOL_no_braces = 1671,               /* no_braces  */
  YYSYMBOL_1672_187 = 1672,                /* $@187  */
  YYSYMBOL_no_braces_with_names = 1673,    /* no_braces_with_names  */
  YYSYMBOL_1674_188 = 1674,                /* $@188  */
  YYSYMBOL_opt_values = 1675,              /* opt_values  */
  YYSYMBOL_opt_values_with_names = 1676,   /* opt_values_with_names  */
  YYSYMBOL_values = 1677,                  /* values  */
  YYSYMBOL_values_with_names = 1678,       /* values_with_names  */
  YYSYMBOL_expr_or_ignore = 1679,          /* expr_or_ignore  */
  YYSYMBOL_expr_or_ignore_or_default = 1680, /* expr_or_ignore_or_default  */
  YYSYMBOL_opt_insert_update = 1681,       /* opt_insert_update  */
  YYSYMBOL_1682_189 = 1682,                /* $@189  */
  YYSYMBOL_1683_190 = 1683,                /* $@190  */
  YYSYMBOL_update_table_list = 1684,       /* update_table_list  */
  YYSYMBOL_update = 1685,                  /* update  */
  YYSYMBOL_1686_191 = 1686,                /* $@191  */
  YYSYMBOL_1687_192 = 1687,                /* $@192  */
  YYSYMBOL_update_list = 1688,             /* update_list  */
  YYSYMBOL_update_elem = 1689,             /* update_elem  */
  YYSYMBOL_insert_update_list = 1690,      /* insert_update_list  */
  YYSYMBOL_insert_update_elem = 1691,      /* insert_update_elem  */
  YYSYMBOL_opt_low_priority = 1692,        /* opt_low_priority  */
  YYSYMBOL_delete = 1693,                  /* delete  */
  YYSYMBOL_1694_193 = 1694,                /* $@193  */
  YYSYMBOL_opt_delete_system_time = 1695,  /* opt_delete_system_time  */
  YYSYMBOL_delete_part2 = 1696,            /* delete_part2  */
  YYSYMBOL_delete_single_table = 1697,     /* delete_single_table  */
  YYSYMBOL_delete_single_table_for_period = 1698, /* delete_single_table_for_period  */
  YYSYMBOL_single_multi = 1699,            /* single_multi  */
  YYSYMBOL_1700_194 = 1700,                /* $@194  */
  YYSYMBOL_1701_195 = 1701,                /* $@195  */
  YYSYMBOL_opt_select_expressions = 1702,  /* opt_select_expressions  */
  YYSYMBOL_table_wild_list = 1703,         /* table_wild_list  */
  YYSYMBOL_table_wild_one = 1704,          /* table_wild_one  */
  YYSYMBOL_opt_wild = 1705,                /* opt_wild  */
  YYSYMBOL_opt_delete_options = 1706,      /* opt_delete_options  */
  YYSYMBOL_opt_delete_option = 1707,       /* opt_delete_option  */
  YYSYMBOL_truncate = 1708,                /* truncate  */
  YYSYMBOL_1709_196 = 1709,                /* $@196  */
  YYSYMBOL_opt_table_sym = 1710,           /* opt_table_sym  */
  YYSYMBOL_opt_profile_defs = 1711,        /* opt_profile_defs  */
  YYSYMBOL_profile_defs = 1712,            /* profile_defs  */
  YYSYMBOL_profile_def = 1713,             /* profile_def  */
  YYSYMBOL_opt_profile_args = 1714,        /* opt_profile_args  */
  YYSYMBOL_show = 1715,                    /* show  */
  YYSYMBOL_1716_197 = 1716,                /* $@197  */
  YYSYMBOL_show_param = 1717,              /* show_param  */
  YYSYMBOL_1718_198 = 1718,                /* $@198  */
  YYSYMBOL_1719_199 = 1719,                /* $@199  */
  YYSYMBOL_show_engine_param = 1720,       /* show_engine_param  */
  YYSYMBOL_master_or_binary = 1721,        /* master_or_binary  */
  YYSYMBOL_opt_storage = 1722,             /* opt_storage  */
  YYSYMBOL_opt_db = 1723,                  /* opt_db  */
  YYSYMBOL_opt_full = 1724,                /* opt_full  */
  YYSYMBOL_from_or_in = 1725,              /* from_or_in  */
  YYSYMBOL_binlog_in = 1726,               /* binlog_in  */
  YYSYMBOL_binlog_from = 1727,             /* binlog_from  */
  YYSYMBOL_wild_and_where = 1728,          /* wild_and_where  */
  YYSYMBOL_describe = 1729,                /* describe  */
  YYSYMBOL_1730_200 = 1730,                /* $@200  */
  YYSYMBOL_1731_201 = 1731,                /* $@201  */
  YYSYMBOL_explainable_command = 1732,     /* explainable_command  */
  YYSYMBOL_describe_command = 1733,        /* describe_command  */
  YYSYMBOL_analyze_stmt_command = 1734,    /* analyze_stmt_command  */
  YYSYMBOL_opt_extended_describe = 1735,   /* opt_extended_describe  */
  YYSYMBOL_opt_format_json = 1736,         /* opt_format_json  */
  YYSYMBOL_opt_describe_column = 1737,     /* opt_describe_column  */
  YYSYMBOL_flush = 1738,                   /* flush  */
  YYSYMBOL_1739_202 = 1739,                /* $@202  */
  YYSYMBOL_flush_options = 1740,           /* flush_options  */
  YYSYMBOL_1741_203 = 1741,                /* $@203  */
  YYSYMBOL_opt_flush_lock = 1742,          /* opt_flush_lock  */
  YYSYMBOL_flush_lock = 1743,              /* flush_lock  */
  YYSYMBOL_1744_204 = 1744,                /* $@204  */
  YYSYMBOL_flush_options_list = 1745,      /* flush_options_list  */
  YYSYMBOL_flush_option = 1746,            /* flush_option  */
  YYSYMBOL_opt_table_list = 1747,          /* opt_table_list  */
  YYSYMBOL_backup = 1748,                  /* backup  */
  YYSYMBOL_backup_statements = 1749,       /* backup_statements  */
  YYSYMBOL_1750_205 = 1750,                /* $@205  */
  YYSYMBOL_opt_delete_gtid_domain = 1751,  /* opt_delete_gtid_domain  */
  YYSYMBOL_delete_domain_id_list = 1752,   /* delete_domain_id_list  */
  YYSYMBOL_delete_domain_id = 1753,        /* delete_domain_id  */
  YYSYMBOL_optional_flush_tables_arguments = 1754, /* optional_flush_tables_arguments  */
  YYSYMBOL_reset = 1755,                   /* reset  */
  YYSYMBOL_1756_206 = 1756,                /* $@206  */
  YYSYMBOL_reset_options = 1757,           /* reset_options  */
  YYSYMBOL_reset_option = 1758,            /* reset_option  */
  YYSYMBOL_1759_207 = 1759,                /* $@207  */
  YYSYMBOL_1760_208 = 1760,                /* $@208  */
  YYSYMBOL_slave_reset_options = 1761,     /* slave_reset_options  */
  YYSYMBOL_master_reset_options = 1762,    /* master_reset_options  */
  YYSYMBOL_purge = 1763,                   /* purge  */
  YYSYMBOL_1764_209 = 1764,                /* $@209  */
  YYSYMBOL_kill = 1765,                    /* kill  */
  YYSYMBOL_1766_210 = 1766,                /* $@210  */
  YYSYMBOL_kill_type = 1767,               /* kill_type  */
  YYSYMBOL_kill_option = 1768,             /* kill_option  */
  YYSYMBOL_opt_connection = 1769,          /* opt_connection  */
  YYSYMBOL_kill_expr = 1770,               /* kill_expr  */
  YYSYMBOL_shutdown = 1771,                /* shutdown  */
  YYSYMBOL_1772_211 = 1772,                /* $@211  */
  YYSYMBOL_shutdown_option = 1773,         /* shutdown_option  */
  YYSYMBOL_use = 1774,                     /* use  */
  YYSYMBOL_load = 1775,                    /* load  */
  YYSYMBOL_1776_212 = 1776,                /* $@212  */
  YYSYMBOL_1777_213 = 1777,                /* $@213  */
  YYSYMBOL_1778_214 = 1778,                /* $@214  */
  YYSYMBOL_1779_215 = 1779,                /* $@215  */
  YYSYMBOL_data_or_xml = 1780,             /* data_or_xml  */
  YYSYMBOL_opt_local = 1781,               /* opt_local  */
  YYSYMBOL_load_data_lock = 1782,          /* load_data_lock  */
  YYSYMBOL_opt_duplicate = 1783,           /* opt_duplicate  */
  YYSYMBOL_opt_field_term = 1784,          /* opt_field_term  */
  YYSYMBOL_field_term_list = 1785,         /* field_term_list  */
  YYSYMBOL_field_term = 1786,              /* field_term  */
  YYSYMBOL_opt_line_term = 1787,           /* opt_line_term  */
  YYSYMBOL_line_term_list = 1788,          /* line_term_list  */
  YYSYMBOL_line_term = 1789,               /* line_term  */
  YYSYMBOL_opt_xml_rows_identified_by = 1790, /* opt_xml_rows_identified_by  */
  YYSYMBOL_opt_ignore_lines = 1791,        /* opt_ignore_lines  */
  YYSYMBOL_lines_or_rows = 1792,           /* lines_or_rows  */
  YYSYMBOL_opt_field_or_var_spec = 1793,   /* opt_field_or_var_spec  */
  YYSYMBOL_fields_or_vars = 1794,          /* fields_or_vars  */
  YYSYMBOL_field_or_var = 1795,            /* field_or_var  */
  YYSYMBOL_opt_load_data_set_spec = 1796,  /* opt_load_data_set_spec  */
  YYSYMBOL_load_data_set_list = 1797,      /* load_data_set_list  */
  YYSYMBOL_load_data_set_elem = 1798,      /* load_data_set_elem  */
  YYSYMBOL_text_literal = 1799,            /* text_literal  */
  YYSYMBOL_text_string = 1800,             /* text_string  */
  YYSYMBOL_hex_or_bin_String = 1801,       /* hex_or_bin_String  */
  YYSYMBOL_param_marker = 1802,            /* param_marker  */
  YYSYMBOL_signed_literal = 1803,          /* signed_literal  */
  YYSYMBOL_literal = 1804,                 /* literal  */
  YYSYMBOL_NUM_literal = 1805,             /* NUM_literal  */
  YYSYMBOL_temporal_literal = 1806,        /* temporal_literal  */
  YYSYMBOL_with_clause = 1807,             /* with_clause  */
  YYSYMBOL_1808_216 = 1808,                /* $@216  */
  YYSYMBOL_opt_recursive = 1809,           /* opt_recursive  */
  YYSYMBOL_with_list = 1810,               /* with_list  */
  YYSYMBOL_with_list_element = 1811,       /* with_list_element  */
  YYSYMBOL_1812_217 = 1812,                /* $@217  */
  YYSYMBOL_opt_with_column_list = 1813,    /* opt_with_column_list  */
  YYSYMBOL_with_column_list = 1814,        /* with_column_list  */
  YYSYMBOL_with_element_head = 1815,       /* with_element_head  */
  YYSYMBOL_insert_ident = 1816,            /* insert_ident  */
  YYSYMBOL_table_wild = 1817,              /* table_wild  */
  YYSYMBOL_select_sublist_qualified_asterisk = 1818, /* select_sublist_qualified_asterisk  */
  YYSYMBOL_order_ident = 1819,             /* order_ident  */
  YYSYMBOL_simple_ident = 1820,            /* simple_ident  */
  YYSYMBOL_simple_ident_nospvar = 1821,    /* simple_ident_nospvar  */
  YYSYMBOL_field_ident = 1822,             /* field_ident  */
  YYSYMBOL_table_ident = 1823,             /* table_ident  */
  YYSYMBOL_table_ident_opt_wild = 1824,    /* table_ident_opt_wild  */
  YYSYMBOL_table_ident_nodb = 1825,        /* table_ident_nodb  */
  YYSYMBOL_IDENT_cli = 1826,               /* IDENT_cli  */
  YYSYMBOL_ident_cli = 1827,               /* ident_cli  */
  YYSYMBOL_IDENT_sys = 1828,               /* IDENT_sys  */
  YYSYMBOL_TEXT_STRING_sys = 1829,         /* TEXT_STRING_sys  */
  YYSYMBOL_TEXT_STRING_literal = 1830,     /* TEXT_STRING_literal  */
  YYSYMBOL_TEXT_STRING_filesystem = 1831,  /* TEXT_STRING_filesystem  */
  YYSYMBOL_ident_table_alias = 1832,       /* ident_table_alias  */
  YYSYMBOL_ident_set_usual_case = 1833,    /* ident_set_usual_case  */
  YYSYMBOL_ident_sysvar_name = 1834,       /* ident_sysvar_name  */
  YYSYMBOL_ident = 1835,                   /* ident  */
  YYSYMBOL_label_ident = 1836,             /* label_ident  */
  YYSYMBOL_ident_or_text = 1837,           /* ident_or_text  */
  YYSYMBOL_user_maybe_role = 1838,         /* user_maybe_role  */
  YYSYMBOL_user_or_role = 1839,            /* user_or_role  */
  YYSYMBOL_user = 1840,                    /* user  */
  YYSYMBOL_keyword_table_alias = 1841,     /* keyword_table_alias  */
  YYSYMBOL_keyword_ident = 1842,           /* keyword_ident  */
  YYSYMBOL_keyword_label = 1843,           /* keyword_label  */
  YYSYMBOL_keyword_sysvar_name = 1844,     /* keyword_sysvar_name  */
  YYSYMBOL_keyword_sp_decl = 1845,         /* keyword_sp_decl  */
  YYSYMBOL_keyword_set_usual_case = 1846,  /* keyword_set_usual_case  */
  YYSYMBOL_keyword_sp_var_not_label = 1847, /* keyword_sp_var_not_label  */
  YYSYMBOL_keyword_sp_head = 1848,         /* keyword_sp_head  */
  YYSYMBOL_keyword_verb_clause = 1849,     /* keyword_verb_clause  */
  YYSYMBOL_keyword_set_special_case = 1850, /* keyword_set_special_case  */
  YYSYMBOL_keyword_sp_block_section = 1851, /* keyword_sp_block_section  */
  YYSYMBOL_keyword_sysvar_type = 1852,     /* keyword_sysvar_type  */
  YYSYMBOL_keyword_data_type = 1853,       /* keyword_data_type  */
  YYSYMBOL_keyword_sp_var_and_label = 1854, /* keyword_sp_var_and_label  */
  YYSYMBOL_set = 1855,                     /* set  */
  YYSYMBOL_1856_218 = 1856,                /* $@218  */
  YYSYMBOL_1857_219 = 1857,                /* $@219  */
  YYSYMBOL_1858_220 = 1858,                /* $@220  */
  YYSYMBOL_set_stmt_option_value_following_option_type_list = 1859, /* set_stmt_option_value_following_option_type_list  */
  YYSYMBOL_start_option_value_list = 1860, /* start_option_value_list  */
  YYSYMBOL_1861_221 = 1861,                /* $@221  */
  YYSYMBOL_1862_222 = 1862,                /* $@222  */
  YYSYMBOL_1863_223 = 1863,                /* $@223  */
  YYSYMBOL_start_option_value_list_following_option_type = 1864, /* start_option_value_list_following_option_type  */
  YYSYMBOL_1865_224 = 1865,                /* $@224  */
  YYSYMBOL_option_value_list_continued = 1866, /* option_value_list_continued  */
  YYSYMBOL_option_value_list = 1867,       /* option_value_list  */
  YYSYMBOL_1868_225 = 1868,                /* $@225  */
  YYSYMBOL_1869_226 = 1869,                /* $@226  */
  YYSYMBOL_option_value = 1870,            /* option_value  */
  YYSYMBOL_1871_227 = 1871,                /* $@227  */
  YYSYMBOL_option_type = 1872,             /* option_type  */
  YYSYMBOL_opt_var_type = 1873,            /* opt_var_type  */
  YYSYMBOL_opt_var_ident_type = 1874,      /* opt_var_ident_type  */
  YYSYMBOL_option_value_following_option_type = 1875, /* option_value_following_option_type  */
  YYSYMBOL_option_value_no_option_type = 1876, /* option_value_no_option_type  */
  YYSYMBOL_transaction_characteristics = 1877, /* transaction_characteristics  */
  YYSYMBOL_transaction_access_mode = 1878, /* transaction_access_mode  */
  YYSYMBOL_isolation_level = 1879,         /* isolation_level  */
  YYSYMBOL_transaction_access_mode_types = 1880, /* transaction_access_mode_types  */
  YYSYMBOL_isolation_types = 1881,         /* isolation_types  */
  YYSYMBOL_opt_for_user = 1882,            /* opt_for_user  */
  YYSYMBOL_text_or_password = 1883,        /* text_or_password  */
  YYSYMBOL_set_expr_or_default = 1884,     /* set_expr_or_default  */
  YYSYMBOL_lock = 1885,                    /* lock  */
  YYSYMBOL_1886_228 = 1886,                /* $@228  */
  YYSYMBOL_opt_lock_wait_timeout = 1887,   /* opt_lock_wait_timeout  */
  YYSYMBOL_table_or_tables = 1888,         /* table_or_tables  */
  YYSYMBOL_table_lock_list = 1889,         /* table_lock_list  */
  YYSYMBOL_table_lock = 1890,              /* table_lock  */
  YYSYMBOL_lock_option = 1891,             /* lock_option  */
  YYSYMBOL_unlock = 1892,                  /* unlock  */
  YYSYMBOL_1893_229 = 1893,                /* $@229  */
  YYSYMBOL_handler = 1894,                 /* handler  */
  YYSYMBOL_1895_230 = 1895,                /* $@230  */
  YYSYMBOL_handler_tail = 1896,            /* handler_tail  */
  YYSYMBOL_1897_231 = 1897,                /* $@231  */
  YYSYMBOL_handler_read_or_scan = 1898,    /* handler_read_or_scan  */
  YYSYMBOL_handler_scan_function = 1899,   /* handler_scan_function  */
  YYSYMBOL_handler_rkey_function = 1900,   /* handler_rkey_function  */
  YYSYMBOL_1901_232 = 1901,                /* $@232  */
  YYSYMBOL_handler_rkey_mode = 1902,       /* handler_rkey_mode  */
  YYSYMBOL_revoke = 1903,                  /* revoke  */
  YYSYMBOL_revoke_command = 1904,          /* revoke_command  */
  YYSYMBOL_admin_option_for_role = 1905,   /* admin_option_for_role  */
  YYSYMBOL_grant = 1906,                   /* grant  */
  YYSYMBOL_grant_command = 1907,           /* grant_command  */
  YYSYMBOL_opt_with_admin = 1908,          /* opt_with_admin  */
  YYSYMBOL_opt_with_admin_option = 1909,   /* opt_with_admin_option  */
  YYSYMBOL_role_list = 1910,               /* role_list  */
  YYSYMBOL_current_role = 1911,            /* current_role  */
  YYSYMBOL_grant_role = 1912,              /* grant_role  */
  YYSYMBOL_opt_table = 1913,               /* opt_table  */
  YYSYMBOL_grant_privileges = 1914,        /* grant_privileges  */
  YYSYMBOL_opt_privileges = 1915,          /* opt_privileges  */
  YYSYMBOL_object_privilege_list = 1916,   /* object_privilege_list  */
  YYSYMBOL_object_privilege = 1917,        /* object_privilege  */
  YYSYMBOL_1918_233 = 1918,                /* $@233  */
  YYSYMBOL_1919_234 = 1919,                /* $@234  */
  YYSYMBOL_1920_235 = 1920,                /* $@235  */
  YYSYMBOL_1921_236 = 1921,                /* $@236  */
  YYSYMBOL_opt_and = 1922,                 /* opt_and  */
  YYSYMBOL_require_list = 1923,            /* require_list  */
  YYSYMBOL_require_list_element = 1924,    /* require_list_element  */
  YYSYMBOL_grant_ident = 1925,             /* grant_ident  */
  YYSYMBOL_user_list = 1926,               /* user_list  */
  YYSYMBOL_grant_list = 1927,              /* grant_list  */
  YYSYMBOL_user_and_role_list = 1928,      /* user_and_role_list  */
  YYSYMBOL_via_or_with = 1929,             /* via_or_with  */
  YYSYMBOL_using_or_as = 1930,             /* using_or_as  */
  YYSYMBOL_grant_user = 1931,              /* grant_user  */
  YYSYMBOL_auth_expression = 1932,         /* auth_expression  */
  YYSYMBOL_auth_token = 1933,              /* auth_token  */
  YYSYMBOL_opt_auth_str = 1934,            /* opt_auth_str  */
  YYSYMBOL_opt_column_list = 1935,         /* opt_column_list  */
  YYSYMBOL_column_list = 1936,             /* column_list  */
  YYSYMBOL_column_list_id = 1937,          /* column_list_id  */
  YYSYMBOL_opt_require_clause = 1938,      /* opt_require_clause  */
  YYSYMBOL_resource_option = 1939,         /* resource_option  */
  YYSYMBOL_resource_option_list = 1940,    /* resource_option_list  */
  YYSYMBOL_opt_resource_options = 1941,    /* opt_resource_options  */
  YYSYMBOL_opt_grant_options = 1942,       /* opt_grant_options  */
  YYSYMBOL_opt_grant_option = 1943,        /* opt_grant_option  */
  YYSYMBOL_grant_option_list = 1944,       /* grant_option_list  */
  YYSYMBOL_grant_option = 1945,            /* grant_option  */
  YYSYMBOL_begin_stmt_mariadb = 1946,      /* begin_stmt_mariadb  */
  YYSYMBOL_1947_237 = 1947,                /* $@237  */
  YYSYMBOL_compound_statement = 1948,      /* compound_statement  */
  YYSYMBOL_opt_not = 1949,                 /* opt_not  */
  YYSYMBOL_opt_work = 1950,                /* opt_work  */
  YYSYMBOL_opt_chain = 1951,               /* opt_chain  */
  YYSYMBOL_opt_release = 1952,             /* opt_release  */
  YYSYMBOL_commit = 1953,                  /* commit  */
  YYSYMBOL_rollback = 1954,                /* rollback  */
  YYSYMBOL_savepoint = 1955,               /* savepoint  */
  YYSYMBOL_release = 1956,                 /* release  */
  YYSYMBOL_unit_type_decl = 1957,          /* unit_type_decl  */
  YYSYMBOL_union_option = 1958,            /* union_option  */
  YYSYMBOL_query_expression_option = 1959, /* query_expression_option  */
  YYSYMBOL_definer_opt = 1960,             /* definer_opt  */
  YYSYMBOL_no_definer = 1961,              /* no_definer  */
  YYSYMBOL_definer = 1962,                 /* definer  */
  YYSYMBOL_view_algorithm = 1963,          /* view_algorithm  */
  YYSYMBOL_opt_view_suid = 1964,           /* opt_view_suid  */
  YYSYMBOL_view_suid = 1965,               /* view_suid  */
  YYSYMBOL_view_list_opt = 1966,           /* view_list_opt  */
  YYSYMBOL_view_list = 1967,               /* view_list  */
  YYSYMBOL_view_select = 1968,             /* view_select  */
  YYSYMBOL_1969_238 = 1969,                /* $@238  */
  YYSYMBOL_view_check_option = 1970,       /* view_check_option  */
  YYSYMBOL_trigger_action_order = 1971,    /* trigger_action_order  */
  YYSYMBOL_trigger_follows_precedes_clause = 1972, /* trigger_follows_precedes_clause  */
  YYSYMBOL_trigger_tail = 1973,            /* trigger_tail  */
  YYSYMBOL_1974_239 = 1974,                /* $@239  */
  YYSYMBOL_1975_240 = 1975,                /* $@240  */
  YYSYMBOL_1976_241 = 1976,                /* $@241  */
  YYSYMBOL_1977_242 = 1977,                /* $@242  */
  YYSYMBOL_1978_243 = 1978,                /* $@243  */
  YYSYMBOL_sf_return_type = 1979,          /* sf_return_type  */
  YYSYMBOL_1980_244 = 1980,                /* $@244  */
  YYSYMBOL_sf_c_chistics_and_body = 1981,  /* sf_c_chistics_and_body  */
  YYSYMBOL_1982_245 = 1982,                /* $@245  */
  YYSYMBOL_sp_tail = 1983,                 /* sp_tail  */
  YYSYMBOL_1984_246 = 1984,                /* $@246  */
  YYSYMBOL_1985_247 = 1985,                /* $@247  */
  YYSYMBOL_xa = 1986,                      /* xa  */
  YYSYMBOL_opt_format_xid = 1987,          /* opt_format_xid  */
  YYSYMBOL_xid = 1988,                     /* xid  */
  YYSYMBOL_begin_or_start = 1989,          /* begin_or_start  */
  YYSYMBOL_opt_join_or_resume = 1990,      /* opt_join_or_resume  */
  YYSYMBOL_opt_one_phase = 1991,           /* opt_one_phase  */
  YYSYMBOL_opt_suspend = 1992,             /* opt_suspend  */
  YYSYMBOL_1993_248 = 1993,                /* $@248  */
  YYSYMBOL_opt_migrate = 1994,             /* opt_migrate  */
  YYSYMBOL_install = 1995,                 /* install  */
  YYSYMBOL_uninstall = 1996,               /* uninstall  */
  YYSYMBOL_keep_gcc_happy = 1997           /* keep_gcc_happy  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 826 "/home/buildbot/git/sql/sql_yacc.yy"

/* avoid unintentional %union size increases, it's what a parser stack made of */
static_assert(sizeof(YYSTYPE) == sizeof(void*)*2+8, "%union size check");
bool my_yyoverflow(short **a, YYSTYPE **b, size_t *yystacksize);

#line 2788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  735
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   100369

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  782
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  1216
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3404
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5907

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   1014


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   775,     2,     2,     2,   764,   759,     2,
     771,   772,   762,   761,   774,   760,   779,   763,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   781,   778,
     757,   755,   756,     2,   780,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   765,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   776,   758,   777,   766,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     767,   768,   769,   770,   773
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  2257,  2257,  2267,  2266,  2291,  2298,  2300,  2304,  2305,
    2306,  2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,
    2320,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,
    2330,  2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,
    2340,  2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,
    2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,
    2360,  2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,  2369,
    2373,  2380,  2381,  2386,  2385,  2396,  2402,  2404,  2401,  2413,
    2415,  2414,  2424,  2429,  2441,  2440,  2457,  2456,  2465,  2466,
    2470,  2474,  2478,  2482,  2486,  2490,  2500,  2505,  2509,  2513,
    2517,  2521,  2525,  2530,  2534,  2539,  2567,  2571,  2575,  2580,
    2583,  2585,  2586,  2590,  2596,  2598,  2599,  2603,  2609,  2611,
    2612,  2616,  2623,  2627,  2642,  2646,  2652,  2658,  2664,  2674,
    2678,  2682,  2696,  2708,  2695,  2732,  2731,  2787,  2794,  2786,
    2806,  2812,  2805,  2824,  2830,  2823,  2842,  2841,  2856,  2854,
    2870,  2868,  2882,  2881,  2892,  2891,  2901,  2900,  2912,  2910,
    2924,  2922,  2934,  2941,  2948,  2955,  2959,  2963,  2963,  2969,
    2970,  2974,  2975,  2979,  2984,  2990,  2996,  3004,  3010,  3016,
    3024,  3032,  3040,  3048,  3056,  3064,  3076,  3092,  3092,  3096,
    3095,  3107,  3108,  3112,  3117,  3122,  3127,  3132,  3137,  3142,
    3150,  3149,  3182,  3181,  3188,  3195,  3196,  3202,  3208,  3218,
    3224,  3230,  3232,  3239,  3240,  3244,  3254,  3255,  3263,  3263,
    3305,  3317,  3318,  3322,  3327,  3335,  3336,  3340,  3341,  3346,
    3348,  3350,  3352,  3354,  3356,  3358,  3364,  3365,  3369,  3370,
    3375,  3374,  3385,  3384,  3395,  3394,  3407,  3409,  3412,  3414,
    3418,  3422,  3431,  3436,  3436,  3446,  3447,  3451,  3459,  3464,
    3471,  3477,  3482,  3487,  3495,  3497,  3501,  3502,  3506,  3510,
    3511,  3512,  3513,  3518,  3517,  3529,  3530,  3534,  3535,  3540,
    3543,  3555,  3560,  3566,  3572,  3581,  3589,  3593,  3598,  3606,
    3610,  3617,  3627,  3635,  3643,  3654,  3655,  3662,  3664,  3663,
    3682,  3681,  3695,  3697,  3702,  3712,  3711,  3730,  3731,  3732,
    3733,  3738,  3740,  3745,  3760,  3768,  3772,  3792,  3793,  3797,
    3801,  3807,  3813,  3819,  3825,  3835,  3840,  3848,  3856,  3871,
    3877,  3878,  3884,  3887,  3891,  3899,  3916,  3918,  3936,  3942,
    3944,  3946,  3948,  3950,  3952,  3954,  3956,  3958,  3960,  3962,
    3964,  3969,  3977,  3993,  3994,  3999,  4005,  4014,  4021,  4030,
    4039,  4044,  4053,  4055,  4057,  4066,  4071,  4078,  4087,  4096,
    4098,  4100,  4102,  4104,  4106,  4108,  4110,  4112,  4114,  4116,
    4118,  4120,  4125,  4126,  4134,  4146,  4161,  4162,  4175,  4176,
    4177,  4178,  4179,  4183,  4184,  4185,  4186,  4187,  4188,  4189,
    4190,  4191,  4192,  4196,  4197,  4198,  4199,  4204,  4203,  4214,
    4214,  4236,  4237,  4242,  4241,  4259,  4270,  4270,  4283,  4288,
    4293,  4299,  4308,  4313,  4318,  4324,  4334,  4342,  4350,  4358,
    4368,  4367,  4389,  4388,  4409,  4415,  4423,  4424,  4428,  4436,
    4441,  4446,  4454,  4455,  4463,  4481,  4497,  4516,  4522,  4539,
    4516,  4558,  4560,  4561,  4566,  4565,  4635,  4641,  4635,  4651,
    4656,  4657,  4661,  4662,  4667,  4673,  4666,  4694,  4700,  4693,
    4719,  4729,  4733,  4737,  4738,  4742,  4753,  4751,  4768,  4767,
    4782,  4781,  4798,  4799,  4804,  4803,  4817,  4822,  4829,  4838,
    4853,  4852,  4872,  4871,  4896,  4905,  4904,  4912,  4911,  4922,
    4927,  4936,  4921,  4946,  4945,  4956,  4955,  4965,  4964,  4977,
    4984,  4976,  5001,  5000,  5012,  5014,  5019,  5021,  5023,  5040,
    5045,  5051,  5058,  5059,  5067,  5073,  5082,  5088,  5094,  5095,
    5099,  5099,  5104,  5105,  5106,  5110,  5111,  5112,  5116,  5120,
    5121,  5122,  5126,  5127,  5128,  5129,  5130,  5131,  5132,  5133,
    5137,  5141,  5142,  5143,  5147,  5148,  5149,  5150,  5151,  5155,
    5159,  5160,  5161,  5165,  5166,  5167,  5168,  5169,  5170,  5171,
    5175,  5179,  5180,  5181,  5185,  5186,  5187,  5192,  5200,  5208,
    5216,  5229,  5242,  5247,  5252,  5260,  5268,  5276,  5284,  5292,
    5300,  5308,  5318,  5328,  5338,  5340,  5344,  5349,  5359,  5360,
    5373,  5372,  5375,  5376,  5390,  5391,  5395,  5396,  5405,  5410,
    5421,  5458,  5459,  5464,  5463,  5479,  5494,  5493,  5515,  5514,
    5520,  5528,  5527,  5530,  5532,  5535,  5534,  5543,  5546,  5545,
    5554,  5555,  5561,  5562,  5579,  5580,  5584,  5585,  5589,  5603,
    5613,  5624,  5633,  5634,  5647,  5649,  5648,  5653,  5651,  5662,
    5663,  5667,  5681,  5693,  5694,  5707,  5716,  5738,  5739,  5744,
    5743,  5767,  5779,  5795,  5794,  5809,  5808,  5822,  5827,  5832,
    5852,  5870,  5874,  5901,  5913,  5914,  5919,  5928,  5918,  5953,
    5954,  5958,  5969,  5988,  6001,  6027,  6028,  6033,  6032,  6069,
    6078,  6079,  6083,  6084,  6088,  6090,  6096,  6102,  6104,  6106,
    6108,  6110,  6112,  6117,  6118,  6118,  6125,  6141,  6144,  6161,
    6162,  6166,  6167,  6171,  6172,  6176,  6177,  6182,  6185,  6193,
    6196,  6203,  6207,  6213,  6215,  6219,  6220,  6224,  6225,  6226,
    6230,  6245,  6250,  6255,  6260,  6265,  6270,  6275,  6290,  6296,
    6311,  6316,  6331,  6337,  6355,  6360,  6365,  6370,  6375,  6380,
    6386,  6385,  6411,  6412,  6413,  6418,  6423,  6428,  6430,  6432,
    6434,  6440,  6445,  6450,  6459,  6468,  6474,  6480,  6485,  6488,
    6490,  6494,  6513,  6521,  6536,  6546,  6557,  6558,  6559,  6560,
    6561,  6562,  6563,  6567,  6568,  6569,  6573,  6574,  6575,  6576,
    6581,  6588,  6595,  6596,  6600,  6601,  6602,  6603,  6604,  6608,
    6610,  6616,  6615,  6623,  6622,  6630,  6629,  6637,  6636,  6646,
    6643,  6654,  6652,  6661,  6660,  6699,  6707,  6715,  6723,  6724,
    6728,  6738,  6739,  6743,  6744,  6748,  6753,  6752,  6790,  6790,
    6793,  6792,  6803,  6804,  6808,  6809,  6813,  6814,  6818,  6819,
    6823,  6824,  6825,  6826,  6828,  6827,  6833,  6838,  6846,  6847,
    6852,  6855,  6859,  6863,  6870,  6871,  6875,  6876,  6880,  6886,
    6892,  6893,  6901,  6900,  6922,  6923,  6933,  6941,  6953,  6953,
    6956,  6957,  6964,  6972,  6976,  6984,  6985,  6986,  6987,  6988,
    6992,  6993,  6994,  7010,  7014,  7018,  7022,  7024,  7031,  7033,
    7038,  7040,  7041,  7042,  7046,  7050,  7055,  7060,  7064,  7068,
    7073,  7078,  7086,  7104,  7105,  7112,  7119,  7127,  7132,  7137,
    7142,  7147,  7158,  7163,  7168,  7173,  7175,  7177,  7179,  7181,
    7183,  7185,  7187,  7195,  7197,  7202,  7203,  7204,  7205,  7206,
    7207,  7208,  7209,  7213,  7217,  7218,  7222,  7223,  7227,  7228,
    7229,  7230,  7231,  7235,  7236,  7237,  7238,  7239,  7243,  7249,
    7250,  7255,  7257,  7264,  7265,  7266,  7270,  7274,  7275,  7276,
    7277,  7278,  7279,  7283,  7284,  7285,  7286,  7290,  7291,  7295,
    7296,  7300,  7301,  7306,  7307,  7311,  7312,  7313,  7320,  7321,
    7327,  7334,  7338,  7339,  7343,  7344,  7348,  7356,  7364,  7373,
    7377,  7383,  7387,  7388,  7397,  7406,  7412,  7418,  7431,  7437,
    7447,  7448,  7452,  7457,  7461,  7462,  7466,  7467,  7471,  7478,
    7482,  7483,  7487,  7495,  7496,  7500,  7501,  7505,  7506,  7510,
    7511,  7512,  7519,  7523,  7524,  7528,  7529,  7530,  7531,  7532,
    7544,  7548,  7549,  7554,  7553,  7566,  7567,  7571,  7574,  7575,
    7576,  7577,  7581,  7589,  7596,  7597,  7601,  7611,  7612,  7616,
    7617,  7620,  7622,  7626,  7638,  7639,  7643,  7650,  7663,  7664,
    7666,  7668,  7674,  7679,  7685,  7691,  7698,  7708,  7709,  7710,
    7711,  7712,  7716,  7717,  7721,  7722,  7726,  7727,  7731,  7732,
    7733,  7737,  7738,  7742,  7746,  7758,  7759,  7763,  7764,  7768,
    7769,  7773,  7774,  7778,  7779,  7783,  7784,  7788,  7789,  7794,
    7795,  7796,  7800,  7802,  7807,  7812,  7814,  7822,  7830,  7836,
    7845,  7846,  7850,  7854,  7855,  7865,  7866,  7867,  7871,  7875,
    7882,  7888,  7900,  7901,  7905,  7907,  7917,  7933,  7916,  7955,
    7954,  7971,  7980,  7979,  8000,  7999,  8020,  8019,  8038,  8032,
    8051,  8050,  8089,  8094,  8099,  8104,  8110,  8109,  8116,  8123,
    8135,  8122,  8157,  8161,  8169,  8172,  8176,  8180,  8188,  8190,
    8191,  8192,  8193,  8197,  8198,  8199,  8200,  8204,  8205,  8217,
    8218,  8222,  8223,  8226,  8228,  8236,  8244,  8246,  8248,  8249,
    8257,  8258,  8264,  8273,  8271,  8284,  8297,  8296,  8309,  8307,
    8320,  8327,  8337,  8338,  8347,  8354,  8358,  8364,  8362,  8379,
    8381,  8386,  8394,  8393,  8407,  8411,  8410,  8422,  8423,  8427,
    8440,  8441,  8445,  8449,  8456,  8461,  8465,  8472,  8479,  8483,
    8488,  8496,  8504,  8514,  8525,  8535,  8546,  8556,  8562,  8568,
    8575,  8581,  8595,  8609,  8614,  8618,  8623,  8624,  8625,  8630,
    8635,  8639,  8649,  8651,  8652,  8653,  8654,  8658,  8663,  8671,
    8676,  8684,  8685,  8689,  8690,  8694,  8694,  8697,  8699,  8703,
    8704,  8708,  8709,  8717,  8718,  8719,  8723,  8724,  8729,  8738,
    8739,  8740,  8741,  8746,  8745,  8755,  8754,  8762,  8769,  8779,
    8796,  8799,  8806,  8810,  8817,  8821,  8825,  8832,  8832,  8838,
    8839,  8843,  8844,  8845,  8849,  8850,  8859,  8866,  8867,  8872,
    8871,  8883,  8884,  8885,  8889,  8891,  8890,  8897,  8896,  8917,
    8918,  8922,  8923,  8927,  8928,  8929,  8933,  8934,  8939,  8938,
    8959,  8960,  8964,  8969,  8970,  8977,  8979,  8984,  8986,  8985,
    8998,  9000,  8999,  9013,  9014,  9019,  9028,  9029,  9030,  9034,
    9041,  9051,  9059,  9068,  9070,  9069,  9075,  9074,  9097,  9098,
    9102,  9103,  9107,  9108,  9109,  9110,  9111,  9112,  9116,  9117,
    9122,  9121,  9142,  9143,  9144,  9149,  9148,  9158,  9165,  9171,
    9180,  9181,  9185,  9201,  9200,  9213,  9214,  9218,  9219,  9223,
    9234,  9245,  9246,  9251,  9250,  9265,  9266,  9270,  9271,  9275,
    9286,  9298,  9297,  9305,  9305,  9314,  9315,  9320,  9321,  9331,
    9330,  9345,  9344,  9363,  9362,  9379,  9377,  9398,  9399,  9404,
    9403,  9417,  9427,  9416,  9437,  9449,  9513,  9518,  9533,  9534,
    9549,  9548,  9564,  9563,  9576,  9578,  9593,  9601,  9599,  9615,
    9633,  9635,  9645,  9649,  9690,  9699,  9709,  9710,  9714,  9718,
    9724,  9731,  9733,  9742,  9746,  9750,  9757,  9766,  9770,  9777,
    9794,  9797,  9805,  9808,  9815,  9819,  9823,  9827,  9834,  9835,
    9839,  9840,  9849,  9862,  9868,  9879,  9882,  9891,  9894,  9899,
    9907,  9908,  9909,  9923,  9928,  9950,  9956,  9962,  9968,  9969,
    9970,  9971,  9972,  9976,  9977,  9978,  9982,  9983,  9984,  9988,
    9989,  9994, 10045, 10052, 10095, 10101, 10105, 10111, 10117, 10123,
   10129, 10135, 10141, 10147, 10153, 10159, 10165, 10171, 10175, 10181,
   10190, 10196, 10204, 10210, 10219, 10225, 10233, 10243, 10249, 10256,
   10263, 10271, 10277, 10286, 10290, 10296, 10302, 10308, 10314, 10321,
   10327, 10333, 10339, 10345, 10352, 10358, 10364, 10370, 10376, 10382,
   10388, 10394, 10400, 10404, 10405, 10409, 10410, 10414, 10415, 10419,
   10420, 10424, 10425, 10426, 10427, 10428, 10429, 10433, 10434, 10439,
   10443, 10447, 10448, 10449, 10453, 10454, 10455, 10456, 10457, 10458,
   10462, 10463, 10464, 10469, 10468, 10474, 10482, 10505, 10512, 10521,
   10522, 10523, 10524, 10528, 10537, 10538, 10539, 10540, 10541, 10542,
   10543, 10544, 10576, 10577, 10578, 10579, 10580, 10581, 10582, 10583,
   10584, 10592, 10600, 10601, 10608, 10614, 10619, 10629, 10634, 10639,
   10645, 10650, 10656, 10667, 10674, 10679, 10684, 10689, 10694, 10699,
   10704, 10712, 10713, 10714, 10715, 10723, 10724, 10732, 10733, 10739,
   10743, 10749, 10755, 10764, 10765, 10774, 10781, 10795, 10801, 10807,
   10816, 10825, 10831, 10837, 10843, 10849, 10864, 10875, 10881, 10887,
   10893, 10899, 10905, 10913, 10920, 10924, 10930, 10938, 10947, 10951,
   10955, 10959, 10979, 10986, 10992, 10999, 11006, 11012, 11018, 11024,
   11030, 11036, 11042, 11048, 11054, 11061, 11067, 11074, 11080, 11086,
   11104, 11110, 11116, 11121, 11128, 11135, 11143, 11150, 11157, 11164,
   11171, 11188, 11194, 11200, 11206, 11212, 11219, 11225, 11231, 11240,
   11251, 11258, 11264, 11270, 11277, 11285, 11291, 11297, 11303, 11309,
   11317, 11323, 11329, 11335, 11341, 11349, 11361, 11368, 11383, 11389,
   11396, 11403, 11410, 11417, 11424, 11428, 11435, 11453, 11452, 11520,
   11525, 11533, 11535, 11540, 11541, 11545, 11546, 11550, 11551, 11555,
   11562, 11570, 11597, 11603, 11609, 11615, 11621, 11627, 11636, 11643,
   11645, 11642, 11652, 11663, 11669, 11675, 11681, 11687, 11693, 11699,
   11705, 11711, 11718, 11717, 11742, 11751, 11769, 11771, 11773, 11788,
   11795, 11802, 11809, 11816, 11823, 11830, 11837, 11844, 11851, 11862,
   11869, 11880, 11891, 11911, 11910, 11916, 11933, 11939, 11948, 11957,
   11967, 11966, 11978, 11988, 11996, 12001, 12009, 12010, 12015, 12020,
   12023, 12025, 12029, 12034, 12042, 12043, 12047, 12051, 12058, 12065,
   12072, 12085, 12084, 12101, 12104, 12103, 12108, 12107, 12112, 12111,
   12115, 12120, 12121, 12125, 12126, 12127, 12128, 12129, 12130, 12131,
   12132, 12136, 12137, 12138, 12139, 12146, 12147, 12151, 12156, 12164,
   12165, 12169, 12176, 12184, 12193, 12203, 12204, 12213, 12222, 12234,
   12235, 12247, 12258, 12259, 12265, 12270, 12284, 12292, 12290, 12310,
   12308, 12321, 12333, 12331, 12351, 12350, 12362, 12375, 12373, 12394,
   12393, 12406, 12420, 12421, 12422, 12426, 12427, 12435, 12436, 12440,
   12449, 12450, 12451, 12456, 12460, 12461, 12465, 12466, 12470, 12471,
   12479, 12487, 12495, 12496, 12509, 12527, 12536, 12537, 12542, 12545,
   12546, 12547, 12551, 12552, 12557, 12556, 12562, 12561, 12569, 12570,
   12573, 12575, 12575, 12579, 12579, 12584, 12585, 12589, 12591, 12596,
   12597, 12601, 12612, 12626, 12627, 12628, 12629, 12630, 12631, 12632,
   12633, 12634, 12635, 12636, 12637, 12641, 12642, 12643, 12644, 12645,
   12646, 12647, 12648, 12649, 12653, 12654, 12655, 12656, 12659, 12661,
   12662, 12666, 12667, 12671, 12679, 12681, 12685, 12687, 12686, 12700,
   12703, 12702, 12720, 12722, 12726, 12731, 12739, 12740, 12757, 12780,
   12781, 12787, 12788, 12792, 12805, 12804, 12813, 12814, 12823, 12824,
   12828, 12829, 12833, 12834, 12848, 12849, 12853, 12863, 12872, 12879,
   12886, 12896, 12897, 12904, 12914, 12915, 12917, 12919, 12921, 12923,
   12932, 12936, 12937, 12941, 12955, 12956, 12962, 12961, 12972, 12978,
   12987, 12988, 12989, 12994, 12995, 13000, 13007, 13013, 13023, 13032,
   13038, 13044, 13053, 13058, 13063, 13067, 13073, 13079, 13088, 13097,
   13101, 13108, 13109, 13113, 13118, 13123, 13136, 13140, 13144, 13148,
   13153, 13156, 13160, 13173, 13181, 13194, 13196, 13200, 13201, 13205,
   13206, 13207, 13208, 13209, 13210, 13214, 13215, 13216, 13217, 13218,
   13222, 13223, 13224, 13225, 13229, 13230, 13231, 13232, 13233, 13237,
   13238, 13239, 13240, 13241, 13245, 13250, 13251, 13255, 13256, 13260,
   13261, 13262, 13267, 13266, 13298, 13299, 13303, 13304, 13308, 13318,
   13318, 13330, 13331, 13334, 13354, 13358, 13363, 13371, 13377, 13388,
   13376, 13390, 13405, 13417, 13416, 13439, 13438, 13448, 13447, 13470,
   13476, 13490, 13505, 13513, 13517, 13522, 13521, 13530, 13535, 13541,
   13546, 13551, 13558, 13556, 13570, 13571, 13575, 13587, 13600, 13601,
   13605, 13619, 13623, 13632, 13635, 13642, 13643, 13651, 13663, 13650,
   13678, 13689, 13677, 13704, 13712, 13713, 13720, 13724, 13725, 13734,
   13735, 13739, 13739, 13752, 13753, 13755, 13754, 13767, 13773, 13775,
   13779, 13781, 13787, 13791, 13792, 13796, 13797, 13801, 13811, 13812,
   13816, 13817, 13821, 13822, 13826, 13827, 13832, 13831, 13847, 13846,
   13861, 13862, 13866, 13867, 13871, 13876, 13884, 13892, 13903, 13904,
   13913, 13914, 13922, 13924, 13926, 13924, 13936, 13950, 13957, 13967,
   13956, 13996, 13997, 14001, 14008, 14016, 14017, 14021, 14031, 14032,
   14039, 14038, 14059, 14062, 14069, 14070, 14080, 14095, 14103, 14116,
   14115, 14130, 14129, 14145, 14147, 14151, 14152, 14156, 14171, 14189,
   14190, 14194, 14195, 14199, 14200, 14201, 14206, 14205, 14226, 14228,
   14231, 14233, 14236, 14237, 14240, 14244, 14248, 14252, 14256, 14260,
   14264, 14268, 14272, 14280, 14283, 14293, 14292, 14311, 14318, 14326,
   14334, 14342, 14350, 14358, 14365, 14372, 14378, 14380, 14382, 14391,
   14395, 14400, 14399, 14406, 14405, 14411, 14420, 14427, 14432, 14437,
   14442, 14447, 14452, 14454, 14456, 14458, 14465, 14473, 14475, 14483,
   14490, 14497, 14505, 14511, 14516, 14524, 14532, 14540, 14544, 14549,
   14556, 14561, 14568, 14575, 14581, 14587, 14593, 14601, 14606, 14613,
   14620, 14627, 14634, 14639, 14644, 14649, 14654, 14661, 14683, 14685,
   14687, 14692, 14693, 14696, 14698, 14702, 14703, 14707, 14708, 14712,
   14713, 14717, 14718, 14722, 14723, 14727, 14728, 14736, 14748, 14747,
   14766, 14765, 14775, 14776, 14777, 14778, 14779, 14780, 14784, 14785,
   14789, 14796, 14797, 14799, 14800, 14804, 14805, 14818, 14819, 14820,
   14835, 14834, 14846, 14845, 14857, 14862, 14863, 14878, 14881, 14880,
   14893, 14894, 14899, 14901, 14903, 14905, 14907, 14909, 14917, 14919,
   14921, 14923, 14928, 14930, 14938, 14940, 14942, 14944, 14946, 14963,
   14964, 14968, 14972, 14985, 14984, 14999, 15009, 15010, 15013, 15015,
   15016, 15020, 15036, 15037, 15042, 15041, 15051, 15052, 15056, 15056,
   15060, 15059, 15065, 15069, 15070, 15074, 15075, 15082, 15087, 15086,
   15101, 15100, 15115, 15116, 15117, 15121, 15122, 15123, 15132, 15133,
   15137, 15141, 15149, 15149, 15154, 15155, 15164, 15176, 15190, 15201,
   15214, 15175, 15227, 15228, 15232, 15233, 15237, 15238, 15246, 15250,
   15251, 15252, 15255, 15257, 15261, 15262, 15266, 15271, 15278, 15283,
   15290, 15292, 15296, 15297, 15301, 15306, 15314, 15315, 15319, 15321,
   15329, 15330, 15334, 15335, 15336, 15340, 15342, 15347, 15348, 15357,
   15358, 15362, 15363, 15367, 15380, 15385, 15390, 15395, 15403, 15411,
   15416, 15424, 15432, 15447, 15454, 15460, 15470, 15471, 15479, 15480,
   15481, 15482, 15496, 15502, 15508, 15514, 15520, 15526, 15545, 15555,
   15565, 15571, 15578, 15588, 15595, 15602, 15613, 15612, 15637, 15638,
   15643, 15644, 15651, 15649, 15676, 15677, 15683, 15688, 15697, 15715,
   15716, 15720, 15725, 15733, 15738, 15746, 15751, 15756, 15761, 15767,
   15772, 15780, 15785, 15790, 15795, 15801, 15809, 15810, 15821, 15829,
   15833, 15839, 15845, 15855, 15861, 15870, 15880, 15881, 15885, 15886,
   15887, 15891, 15899, 15907, 15915, 15923, 15924, 15932, 15933, 15941,
   15942, 15947, 15956, 15957, 15965, 15966, 15974, 15975, 15976, 15980,
   15991, 16020, 16029, 16029, 16031, 16041, 16042, 16043, 16044, 16045,
   16046, 16047, 16048, 16053, 16054, 16055, 16056, 16057, 16058, 16059,
   16060, 16061, 16069, 16070, 16071, 16072, 16076, 16077, 16078, 16079,
   16080, 16081, 16082, 16083, 16087, 16088, 16089, 16090, 16091, 16092,
   16093, 16094, 16095, 16099, 16100, 16101, 16102, 16103, 16104, 16105,
   16106, 16119, 16120, 16121, 16122, 16123, 16124, 16125, 16126, 16127,
   16128, 16129, 16130, 16131, 16132, 16133, 16134, 16135, 16136, 16137,
   16138, 16139, 16140, 16141, 16142, 16143, 16144, 16145, 16146, 16147,
   16148, 16149, 16150, 16151, 16152, 16153, 16154, 16155, 16156, 16157,
   16158, 16159, 16160, 16161, 16162, 16163, 16164, 16165, 16166, 16167,
   16168, 16169, 16170, 16171, 16172, 16173, 16214, 16215, 16216, 16217,
   16218, 16219, 16230, 16231, 16232, 16233, 16234, 16235, 16236, 16237,
   16238, 16239, 16243, 16244, 16245, 16252, 16253, 16254, 16258, 16259,
   16260, 16269, 16270, 16271, 16272, 16273, 16274, 16275, 16276, 16277,
   16278, 16279, 16280, 16281, 16282, 16283, 16284, 16285, 16286, 16287,
   16288, 16289, 16290, 16291, 16292, 16293, 16294, 16295, 16296, 16297,
   16298, 16299, 16300, 16301, 16302, 16310, 16311, 16312, 16313, 16314,
   16315, 16316, 16317, 16318, 16319, 16320, 16321, 16322, 16323, 16324,
   16325, 16326, 16327, 16328, 16329, 16330, 16331, 16332, 16333, 16334,
   16335, 16336, 16337, 16338, 16339, 16340, 16341, 16342, 16343, 16344,
   16345, 16346, 16347, 16348, 16349, 16350, 16351, 16352, 16353, 16354,
   16355, 16356, 16361, 16362, 16363, 16364, 16365, 16366, 16367, 16368,
   16369, 16370, 16371, 16372, 16373, 16374, 16375, 16376, 16377, 16378,
   16379, 16380, 16381, 16382, 16383, 16384, 16385, 16386, 16387, 16388,
   16389, 16390, 16391, 16392, 16393, 16394, 16395, 16396, 16397, 16398,
   16399, 16400, 16401, 16402, 16403, 16404, 16405, 16406, 16407, 16408,
   16409, 16410, 16411, 16412, 16413, 16414, 16415, 16416, 16417, 16418,
   16419, 16420, 16421, 16422, 16423, 16424, 16425, 16426, 16427, 16428,
   16429, 16430, 16431, 16432, 16433, 16434, 16435, 16436, 16437, 16438,
   16439, 16440, 16441, 16442, 16443, 16444, 16445, 16446, 16447, 16448,
   16449, 16450, 16451, 16452, 16453, 16454, 16455, 16456, 16457, 16458,
   16459, 16460, 16461, 16462, 16463, 16464, 16465, 16466, 16467, 16468,
   16469, 16470, 16471, 16472, 16473, 16474, 16475, 16476, 16477, 16478,
   16479, 16480, 16481, 16482, 16483, 16484, 16485, 16486, 16487, 16488,
   16489, 16490, 16491, 16492, 16493, 16494, 16495, 16496, 16497, 16498,
   16499, 16500, 16501, 16502, 16503, 16504, 16505, 16506, 16507, 16508,
   16509, 16510, 16511, 16512, 16513, 16514, 16515, 16516, 16517, 16518,
   16519, 16520, 16521, 16522, 16523, 16524, 16525, 16526, 16527, 16528,
   16529, 16530, 16531, 16532, 16533, 16534, 16535, 16536, 16537, 16538,
   16539, 16540, 16541, 16542, 16543, 16544, 16545, 16546, 16547, 16548,
   16549, 16550, 16551, 16552, 16553, 16554, 16555, 16556, 16557, 16558,
   16559, 16560, 16561, 16562, 16563, 16564, 16565, 16566, 16567, 16568,
   16569, 16570, 16571, 16572, 16573, 16574, 16575, 16576, 16577, 16578,
   16579, 16580, 16581, 16582, 16583, 16584, 16585, 16586, 16587, 16588,
   16589, 16590, 16591, 16592, 16593, 16594, 16595, 16596, 16597, 16598,
   16599, 16600, 16601, 16602, 16603, 16604, 16605, 16606, 16607, 16608,
   16609, 16610, 16611, 16612, 16613, 16614, 16615, 16616, 16617, 16618,
   16619, 16620, 16621, 16622, 16623, 16624, 16625, 16626, 16627, 16628,
   16629, 16630, 16642, 16641, 16658, 16664, 16657, 16684, 16685, 16691,
   16690, 16697, 16696, 16706, 16705, 16716, 16715, 16721, 16729, 16731,
   16736, 16736, 16746, 16745, 16760, 16759, 16764, 16768, 16769, 16770,
   16774, 16775, 16776, 16777, 16781, 16782, 16783, 16784, 16789, 16794,
   16799, 16808, 16813, 16818, 16823, 16828, 16833, 16838, 16843, 16857,
   16868, 16887, 16905, 16917, 16925, 16930, 16946, 16947, 16948, 16949,
   16953, 16972, 16990, 16991, 16995, 16996, 16997, 16998, 17002, 17016,
   17020, 17025, 17030, 17041, 17042, 17043, 17049, 17055, 17067, 17066,
   17080, 17081, 17087, 17096, 17097, 17101, 17102, 17106, 17125, 17126,
   17127, 17132, 17133, 17138, 17137, 17155, 17154, 17166, 17175, 17185,
   17184, 17225, 17226, 17230, 17231, 17235, 17236, 17237, 17238, 17240,
   17239, 17252, 17253, 17254, 17255, 17256, 17262, 17267, 17273, 17279,
   17285, 17292, 17299, 17303, 17310, 17319, 17321, 17326, 17331, 17338,
   17345, 17352, 17359, 17366, 17373, 17385, 17386, 17390, 17391, 17395,
   17400, 17408, 17418, 17437, 17440, 17442, 17446, 17447, 17454, 17456,
   17460, 17461, 17466, 17465, 17469, 17468, 17472, 17471, 17475, 17474,
   17477, 17478, 17479, 17480, 17481, 17482, 17483, 17484, 17485, 17486,
   17487, 17488, 17489, 17490, 17491, 17492, 17493, 17494, 17495, 17496,
   17497, 17498, 17499, 17500, 17501, 17502, 17503, 17507, 17508, 17512,
   17513, 17517, 17524, 17531, 17541, 17551, 17560, 17569, 17582, 17587,
   17595, 17600, 17608, 17613, 17620, 17620, 17621, 17621, 17624, 17630,
   17636, 17641, 17648, 17654, 17661, 17670, 17674, 17680, 17690, 17694,
   17698, 17699, 17703, 17731, 17733, 17737, 17741, 17745, 17752, 17757,
   17762, 17767, 17772, 17780, 17781, 17785, 17786, 17791, 17792, 17796,
   17797, 17801, 17802, 17806, 17807, 17812, 17811, 17821, 17830, 17831,
   17835, 17836, 17841, 17842, 17843, 17848, 17849, 17850, 17854, 17866,
   17875, 17881, 17890, 17899, 17912, 17914, 17916, 17924, 17925, 17926,
   17930, 17931, 17937, 17938, 17939, 17940, 17941, 17942, 17952, 17953,
   17958, 17971, 17985, 17986, 17987, 17991, 17992, 17996, 17997, 18002,
   18003, 18007, 18013, 18022, 18022, 18036, 18037, 18038, 18039, 18049,
   18051, 18057, 18063, 18073, 18082, 18088, 18093, 18097, 18071, 18147,
   18146, 18163, 18162, 18178, 18186, 18177, 18200, 18204, 18208, 18212,
   18216, 18220, 18228, 18229, 18245, 18252, 18259, 18269, 18270, 18271,
   18275, 18276, 18277, 18281, 18282, 18287, 18289, 18288, 18294, 18295,
   18299, 18304, 18311, 18316, 18325
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABORT_SYM",
  "ACCESSIBLE_SYM", "ADD", "ALL", "ALTER", "ANALYZE_SYM", "AND_AND_SYM",
  "AND_SYM", "AS", "ASC", "ASENSITIVE_SYM", "BEFORE_SYM", "BETWEEN_SYM",
  "BIGINT", "BINARY", "BIN_NUM", "BIT_AND", "BIT_OR", "BIT_XOR",
  "BLOB_MARIADB_SYM", "BLOB_ORACLE_SYM", "BODY_ORACLE_SYM", "BOTH", "BY",
  "CALL_SYM", "CASCADE", "CASE_SYM", "CAST_SYM", "CHANGE", "CHAR_SYM",
  "CHECK_SYM", "COLLATE_SYM", "CONDITION_SYM", "CONSTRAINT",
  "CONTINUE_MARIADB_SYM", "CONTINUE_ORACLE_SYM", "CONVERT_SYM",
  "COUNT_SYM", "CREATE", "CROSS", "CUME_DIST_SYM", "CURDATE",
  "CURRENT_USER", "CURRENT_ROLE", "CURSOR_SYM", "CURTIME", "DATABASE",
  "DATABASES", "DATE_ADD_INTERVAL", "DATE_SUB_INTERVAL", "DAY_HOUR_SYM",
  "DAY_MICROSECOND_SYM", "DAY_MINUTE_SYM", "DAY_SECOND_SYM", "DECIMAL_NUM",
  "DECIMAL_SYM", "DECLARE_MARIADB_SYM", "DECLARE_ORACLE_SYM", "DEFAULT",
  "DELETE_DOMAIN_ID_SYM", "DELETE_SYM", "DENSE_RANK_SYM", "DESC",
  "DESCRIBE", "DETERMINISTIC_SYM", "DISTINCT", "DIV_SYM", "DOUBLE_SYM",
  "DO_DOMAIN_IDS_SYM", "DOT_DOT_SYM", "DROP", "DUAL_SYM", "EACH_SYM",
  "ELSE", "ELSEIF_MARIADB_SYM", "ELSIF_ORACLE_SYM", "ENCLOSED",
  "END_OF_INPUT", "EQUAL_SYM", "ESCAPED", "EXCEPT_SYM", "EXISTS",
  "EXTRACT_SYM", "FALSE_SYM", "FETCH_SYM", "FIRST_VALUE_SYM", "FLOAT_NUM",
  "FLOAT_SYM", "FORCE_LOOKAHEAD", "FOREIGN", "FOR_SYM",
  "FOR_SYSTEM_TIME_SYM", "FROM", "FULLTEXT_SYM", "GE", "GOTO_ORACLE_SYM",
  "GRANT", "GROUP_SYM", "GROUP_CONCAT_SYM", "LAG_SYM", "LEAD_SYM",
  "HAVING", "HEX_NUM", "HEX_STRING", "HOUR_MICROSECOND_SYM",
  "HOUR_MINUTE_SYM", "HOUR_SECOND_SYM", "IDENT", "IDENT_QUOTED", "IF_SYM",
  "IGNORE_DOMAIN_IDS_SYM", "IGNORE_SYM", "INDEX_SYM", "INFILE",
  "INNER_SYM", "INOUT_SYM", "INSENSITIVE_SYM", "INSERT", "INTERSECT_SYM",
  "INTERVAL_SYM", "INTO", "INT_SYM", "IN_SYM", "IS", "ITERATE_SYM",
  "JOIN_SYM", "KEYS", "KEY_SYM", "KILL_SYM", "LE", "LEADING", "LEAVE_SYM",
  "LEFT", "LEFT_PAREN_ALT", "LEFT_PAREN_WITH", "LEFT_PAREN_LIKE",
  "LEX_HOSTNAME", "LIKE", "LIMIT", "LINEAR_SYM", "LINES", "LOAD",
  "LOCATOR_SYM", "LOCK_SYM", "LONGBLOB", "LONGTEXT", "LONG_NUM",
  "LONG_SYM", "LOOP_SYM", "LOW_PRIORITY",
  "MASTER_SSL_VERIFY_SERVER_CERT_SYM", "MATCH", "MAX_SYM", "MAXVALUE_SYM",
  "MEDIAN_SYM", "MEDIUMBLOB", "MEDIUMINT", "MEDIUMTEXT",
  "MINUTE_MICROSECOND_SYM", "MINUTE_SECOND_SYM", "MIN_SYM", "MODIFIES_SYM",
  "MOD_SYM", "MYSQL_CONCAT_SYM", "NATURAL", "NCHAR_STRING", "NE", "NEG",
  "NOT2_SYM", "NOT_SYM", "NOW_SYM", "NO_WRITE_TO_BINLOG", "NTILE_SYM",
  "NULL_SYM", "NUM", "NUMERIC_SYM", "NTH_VALUE_SYM", "ON", "OPTIMIZE",
  "OPTIONALLY", "ORACLE_CONCAT_SYM", "OR2_SYM", "ORDER_SYM", "OR_SYM",
  "OTHERS_ORACLE_SYM", "OUTER", "OUTFILE", "OUT_SYM", "OVER_SYM",
  "PACKAGE_ORACLE_SYM", "PAGE_CHECKSUM_SYM", "PARAM_MARKER",
  "PARSE_VCOL_EXPR_SYM", "PARTITION_SYM", "PERCENT_ORACLE_SYM",
  "PERCENT_RANK_SYM", "PERCENTILE_CONT_SYM", "PERCENTILE_DISC_SYM",
  "PORTION_SYM", "POSITION_SYM", "PRECISION", "PRIMARY_SYM",
  "PROCEDURE_SYM", "PURGE", "RAISE_ORACLE_SYM", "RANGE_SYM", "RANK_SYM",
  "READS_SYM", "READ_SYM", "READ_WRITE_SYM", "REAL", "RECURSIVE_SYM",
  "REF_SYSTEM_ID_SYM", "REFERENCES", "REGEXP", "RELEASE_SYM", "RENAME",
  "REPEAT_SYM", "REQUIRE_SYM", "RESIGNAL_SYM", "RESTRICT", "RETURNING_SYM",
  "RETURN_MARIADB_SYM", "RETURN_ORACLE_SYM", "REVOKE", "RIGHT", "ROWS_SYM",
  "ROWTYPE_ORACLE_SYM", "ROW_NUMBER_SYM", "SECOND_MICROSECOND_SYM",
  "SELECT_SYM", "SENSITIVE_SYM", "SEPARATOR_SYM", "SERVER_OPTIONS", "SET",
  "SET_VAR", "SHIFT_LEFT", "SHIFT_RIGHT", "SHOW", "SIGNAL_SYM", "SMALLINT",
  "SPATIAL_SYM", "SPECIFIC_SYM", "SQLEXCEPTION_SYM", "SQLSTATE_SYM",
  "SQLWARNING_SYM", "SQL_BIG_RESULT", "SQL_SMALL_RESULT", "SQL_SYM",
  "SSL_SYM", "STARTING", "STATS_AUTO_RECALC_SYM", "STATS_PERSISTENT_SYM",
  "STATS_SAMPLE_PAGES_SYM", "STDDEV_SAMP_SYM", "STD_SYM", "STRAIGHT_JOIN",
  "SUM_SYM", "SYSDATE", "TABLE_REF_PRIORITY", "TABLE_SYM", "TERMINATED",
  "TEXT_STRING", "THEN_SYM", "TINYBLOB", "TINYINT", "TINYTEXT", "TO_SYM",
  "TRAILING", "TRIGGER_SYM", "TRUE_SYM", "ULONGLONG_NUM",
  "UNDERSCORE_CHARSET", "UNDO_SYM", "UNION_SYM", "UNIQUE_SYM",
  "UNLOCK_SYM", "UNSIGNED", "UPDATE_SYM", "USAGE", "USE_SYM", "USING",
  "UTC_DATE_SYM", "UTC_TIMESTAMP_SYM", "UTC_TIME_SYM", "VALUES",
  "VALUES_IN_SYM", "VALUES_LESS_SYM", "VARBINARY", "VARCHAR",
  "VARIANCE_SYM", "VARYING", "VAR_SAMP_SYM", "WHEN_SYM", "WHERE",
  "WHILE_SYM", "WITH", "WITH_CUBE_SYM", "WITH_ROLLUP_SYM",
  "WITH_SYSTEM_SYM", "XOR", "YEAR_MONTH_SYM", "ZEROFILL",
  "IMPOSSIBLE_ACTION", "BODY_MARIADB_SYM", "ELSEIF_ORACLE_SYM",
  "ELSIF_MARIADB_SYM", "EXCEPTION_ORACLE_SYM", "GOTO_MARIADB_SYM",
  "OTHERS_MARIADB_SYM", "PACKAGE_MARIADB_SYM", "RAISE_MARIADB_SYM",
  "ROWTYPE_MARIADB_SYM", "REPLACE", "SUBSTRING", "TRIM", "ACCOUNT_SYM",
  "ACTION", "ADMIN_SYM", "ADDDATE_SYM", "AFTER_SYM", "AGAINST",
  "AGGREGATE_SYM", "ALGORITHM_SYM", "ALWAYS_SYM", "ANY_SYM", "ASCII_SYM",
  "AT_SYM", "ATOMIC_SYM", "AUTHORS_SYM", "AUTOEXTEND_SIZE_SYM", "AUTO_INC",
  "AUTO_SYM", "AVG_ROW_LENGTH", "AVG_SYM", "BACKUP_SYM",
  "BEGIN_MARIADB_SYM", "BEGIN_ORACLE_SYM", "BINLOG_SYM", "BIT_SYM",
  "BLOCK_SYM", "BOOL_SYM", "BOOLEAN_SYM", "BTREE_SYM", "BYTE_SYM",
  "CACHE_SYM", "CASCADED", "CATALOG_NAME_SYM", "CHAIN_SYM", "CHANGED",
  "CHARSET", "CHECKPOINT_SYM", "CHECKSUM_SYM", "CIPHER_SYM",
  "CLASS_ORIGIN_SYM", "CLIENT_SYM", "CLOB_MARIADB_SYM", "CLOB_ORACLE_SYM",
  "CLOSE_SYM", "COALESCE", "CODE_SYM", "COLLATION_SYM", "COLON_ORACLE_SYM",
  "COLUMNS", "COLUMN_ADD_SYM", "COLUMN_CHECK_SYM", "COLUMN_CREATE_SYM",
  "COLUMN_DELETE_SYM", "COLUMN_GET_SYM", "COLUMN_SYM", "COLUMN_NAME_SYM",
  "COMMENT_SYM", "COMMITTED_SYM", "COMMIT_SYM", "COMPACT_SYM",
  "COMPLETION_SYM", "COMPRESSED_SYM", "CONCURRENT", "CONNECTION_SYM",
  "CONSISTENT_SYM", "CONSTRAINT_CATALOG_SYM", "CONSTRAINT_NAME_SYM",
  "CONSTRAINT_SCHEMA_SYM", "CONTAINS_SYM", "CONTEXT_SYM",
  "CONTRIBUTORS_SYM", "CPU_SYM", "CUBE_SYM", "CURRENT_SYM",
  "CURRENT_POS_SYM", "CURSOR_NAME_SYM", "CYCLE_SYM", "DATAFILE_SYM",
  "DATA_SYM", "DATETIME", "DATE_FORMAT_SYM", "DATE_SYM", "DAY_SYM",
  "DEALLOCATE_SYM", "DECODE_MARIADB_SYM", "DECODE_ORACLE_SYM",
  "DEFINER_SYM", "DELAYED_SYM", "DELAY_KEY_WRITE_SYM", "DES_KEY_FILE",
  "DIAGNOSTICS_SYM", "DIRECTORY_SYM", "DISABLE_SYM", "DISCARD", "DISK_SYM",
  "DO_SYM", "DUMPFILE", "DUPLICATE_SYM", "DYNAMIC_SYM", "ENABLE_SYM",
  "END", "ENDS_SYM", "ENGINES_SYM", "ENGINE_SYM", "ENUM", "ERROR_SYM",
  "ERRORS", "ESCAPE_SYM", "EVENTS_SYM", "EVENT_SYM", "EVERY_SYM",
  "EXCHANGE_SYM", "EXAMINED_SYM", "EXCLUDE_SYM", "EXECUTE_SYM",
  "EXCEPTION_MARIADB_SYM", "EXIT_MARIADB_SYM", "EXIT_ORACLE_SYM",
  "EXPANSION_SYM", "EXPIRE_SYM", "EXPORT_SYM", "EXTENDED_SYM",
  "EXTENT_SIZE_SYM", "FAST_SYM", "FAULTS_SYM", "FILE_SYM", "FIRST_SYM",
  "FIXED_SYM", "FLUSH_SYM", "FOLLOWS_SYM", "FOLLOWING_SYM", "FORCE_SYM",
  "FORMAT_SYM", "FOUND_SYM", "FULL", "FUNCTION_SYM", "GENERAL",
  "GENERATED_SYM", "GEOMETRYCOLLECTION", "GEOMETRY_SYM", "GET_FORMAT",
  "GET_SYM", "GLOBAL_SYM", "GRANTS", "HANDLER_SYM", "HARD_SYM", "HASH_SYM",
  "HELP_SYM", "HIGH_PRIORITY", "HISTORY_SYM", "HOST_SYM", "HOSTS_SYM",
  "HOUR_SYM", "ID_SYM", "IDENTIFIED_SYM", "IGNORE_SERVER_IDS_SYM",
  "IMMEDIATE_SYM", "IMPORT", "INCREMENT_SYM", "INDEXES",
  "INITIAL_SIZE_SYM", "INSERT_METHOD", "INSTALL_SYM", "INVOKER_SYM",
  "IO_SYM", "IPC_SYM", "ISOLATION", "ISOPEN_SYM", "ISSUER_SYM",
  "INVISIBLE_SYM", "JSON_SYM", "KEY_BLOCK_SIZE", "LANGUAGE_SYM",
  "LAST_SYM", "LAST_VALUE", "LASTVAL_SYM", "LEAVES", "LESS_SYM",
  "LEVEL_SYM", "LINESTRING", "LIST_SYM", "LOCAL_SYM", "LOCKS_SYM",
  "LOGFILE_SYM", "LOGS_SYM", "MASTER_CONNECT_RETRY_SYM",
  "MASTER_DELAY_SYM", "MASTER_GTID_POS_SYM", "MASTER_HOST_SYM",
  "MASTER_LOG_FILE_SYM", "MASTER_LOG_POS_SYM", "MASTER_PASSWORD_SYM",
  "MASTER_PORT_SYM", "MASTER_SERVER_ID_SYM", "MASTER_SSL_CAPATH_SYM",
  "MASTER_SSL_CA_SYM", "MASTER_SSL_CERT_SYM", "MASTER_SSL_CIPHER_SYM",
  "MASTER_SSL_CRL_SYM", "MASTER_SSL_CRLPATH_SYM", "MASTER_SSL_KEY_SYM",
  "MASTER_SSL_SYM", "MASTER_SYM", "MASTER_USER_SYM", "MASTER_USE_GTID_SYM",
  "MASTER_HEARTBEAT_PERIOD_SYM", "MAX_CONNECTIONS_PER_HOUR",
  "MAX_QUERIES_PER_HOUR", "MAX_ROWS", "MAX_SIZE_SYM",
  "MAX_UPDATES_PER_HOUR", "MAX_STATEMENT_TIME_SYM",
  "MAX_USER_CONNECTIONS_SYM", "MEDIUM_SYM", "MEMORY_SYM", "MERGE_SYM",
  "MESSAGE_TEXT_SYM", "MICROSECOND_SYM", "MIGRATE_SYM", "MINUTE_SYM",
  "MINVALUE_SYM", "MIN_ROWS", "MODE_SYM", "MODIFY_SYM", "MONTH_SYM",
  "MULTILINESTRING", "MULTIPOINT", "MULTIPOLYGON", "MUTEX_SYM",
  "MYSQL_SYM", "MYSQL_ERRNO_SYM", "NAMES_SYM", "NAME_SYM", "NATIONAL_SYM",
  "NCHAR_SYM", "NEVER_SYM", "NEW_SYM", "NEXT_SYM", "NEXTVAL_SYM",
  "NOCACHE_SYM", "NOCYCLE_SYM", "NODEGROUP_SYM", "NONE_SYM",
  "NOTFOUND_SYM", "NO_SYM", "NOMAXVALUE_SYM", "NOMINVALUE_SYM",
  "NO_WAIT_SYM", "NOWAIT_SYM", "NUMBER_MARIADB_SYM", "NUMBER_ORACLE_SYM",
  "NVARCHAR_SYM", "OF_SYM", "OFFSET_SYM", "OLD_PASSWORD_SYM", "ONE_SYM",
  "ONLY_SYM", "ONLINE_SYM", "OPEN_SYM", "OPTIONS_SYM", "OPTION",
  "OWNER_SYM", "PACK_KEYS_SYM", "PAGE_SYM", "PARSER_SYM", "PARTIAL",
  "PARTITIONS_SYM", "PARTITIONING_SYM", "PASSWORD_SYM", "PERIOD_SYM",
  "PERSISTENT_SYM", "PHASE_SYM", "PLUGINS_SYM", "PLUGIN_SYM", "POINT_SYM",
  "POLYGON", "PORT_SYM", "PRECEDES_SYM", "PRECEDING_SYM", "PREPARE_SYM",
  "PRESERVE_SYM", "PREV_SYM", "PREVIOUS_SYM", "PRIVILEGES", "PROCESS",
  "PROCESSLIST_SYM", "PROFILE_SYM", "PROFILES_SYM", "PROXY_SYM",
  "QUARTER_SYM", "QUERY_SYM", "QUICK", "RAW_MARIADB_SYM", "RAW_ORACLE_SYM",
  "READ_ONLY_SYM", "REBUILD_SYM", "RECOVER_SYM", "REDOFILE_SYM",
  "REDO_BUFFER_SIZE_SYM", "REDUNDANT_SYM", "RELAY", "RELAYLOG_SYM",
  "RELAY_LOG_FILE_SYM", "RELAY_LOG_POS_SYM", "RELAY_THREAD", "RELOAD",
  "REMOVE_SYM", "REORGANIZE_SYM", "REPAIR", "REPEATABLE_SYM",
  "REPLICATION", "RESET_SYM", "RESTART_SYM", "RESOURCES", "RESTORE_SYM",
  "RESUME_SYM", "RETURNED_SQLSTATE_SYM", "RETURNS_SYM", "REUSE_SYM",
  "REVERSE_SYM", "ROLE_SYM", "ROLLBACK_SYM", "ROLLUP_SYM", "ROUTINE_SYM",
  "ROWCOUNT_SYM", "ROW_SYM", "ROW_COUNT_SYM", "ROW_FORMAT_SYM",
  "RTREE_SYM", "SAVEPOINT_SYM", "SCHEDULE_SYM", "SCHEMA_NAME_SYM",
  "SECOND_SYM", "SECURITY_SYM", "SEQUENCE_SYM", "SERIALIZABLE_SYM",
  "SERIAL_SYM", "SESSION_SYM", "SERVER_SYM", "SETVAL_SYM", "SHARE_SYM",
  "SHUTDOWN", "SIGNED_SYM", "SIMPLE_SYM", "SLAVE", "SLAVES",
  "SLAVE_POS_SYM", "SLOW", "SNAPSHOT_SYM", "SOCKET_SYM", "SOFT_SYM",
  "SONAME_SYM", "SOUNDS_SYM", "SOURCE_SYM", "SQL_BUFFER_RESULT",
  "SQL_CACHE_SYM", "SQL_CALC_FOUND_ROWS", "SQL_NO_CACHE_SYM", "SQL_THREAD",
  "STAGE_SYM", "STARTS_SYM", "START_SYM", "STATEMENT_SYM", "STATUS_SYM",
  "STOP_SYM", "STORAGE_SYM", "STORED_SYM", "STRING_SYM",
  "SUBCLASS_ORIGIN_SYM", "SUBDATE_SYM", "SUBJECT_SYM", "SUBPARTITIONS_SYM",
  "SUBPARTITION_SYM", "SUPER_SYM", "SUSPEND_SYM", "SWAPS_SYM",
  "SWITCHES_SYM", "SYSTEM", "SYSTEM_TIME_SYM", "TABLES", "TABLESPACE",
  "TABLE_CHECKSUM_SYM", "TABLE_NAME_SYM", "TEMPORARY", "TEMPTABLE_SYM",
  "TEXT_SYM", "THAN_SYM", "TIES_SYM", "TIMESTAMP", "TIMESTAMP_ADD",
  "TIMESTAMP_DIFF", "TIME_SYM", "TRANSACTION_SYM", "TRANSACTIONAL_SYM",
  "TRIGGERS_SYM", "TRIM_ORACLE", "TRUNCATE_SYM", "TYPES_SYM", "TYPE_SYM",
  "UDF_RETURNS_SYM", "UNBOUNDED_SYM", "UNCOMMITTED_SYM", "UNDEFINED_SYM",
  "UNDOFILE_SYM", "UNDO_BUFFER_SIZE_SYM", "UNICODE_SYM", "UNINSTALL_SYM",
  "UNKNOWN_SYM", "UNTIL_SYM", "UPGRADE_SYM", "USER_SYM", "USE_FRM",
  "VALUE_SYM", "VARCHAR2_MARIADB_SYM", "VARCHAR2_ORACLE_SYM", "VARIABLES",
  "VERSIONING_SYM", "VIA_SYM", "VIEW_SYM", "VIRTUAL_SYM", "WAIT_SYM",
  "WARNINGS", "WEEK_SYM", "WEIGHT_STRING_SYM", "WINDOW_SYM", "WITHIN",
  "WITHOUT", "WORK_SYM", "WRAPPER_SYM", "WRITE_SYM", "X509_SYM", "XA_SYM",
  "XML_SYM", "YEAR_SYM", "CONDITIONLESS_JOIN", "ON_SYM", "PREC_BELOW_NOT",
  "'='", "'>'", "'<'", "'|'", "'&'", "'-'", "'+'", "'*'", "'/'", "'%'",
  "'^'", "'~'", "SUBQUERY_AS_EXPR",
  "PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE", "USER",
  "PREC_BELOW_CONTRACTION_TOKEN2", "'('", "')'", "EMPTY_FROM_CLAUSE",
  "','", "'!'", "'{'", "'}'", "';'", "'.'", "'@'", "':'", "$accept",
  "query", "$@1", "opt_end_of_input", "verb_clause", "statement",
  "deallocate", "deallocate_or_drop", "prepare", "$@2", "execute", "$@3",
  "$@4", "execute_using", "$@5", "execute_params", "help", "$@6", "change",
  "$@7", "master_defs", "master_def", "ignore_server_id_list",
  "ignore_server_id", "do_domain_id_list", "do_domain_id",
  "ignore_domain_id_list", "ignore_domain_id", "master_file_def",
  "optional_connection_name", "connection_name", "create", "$@8", "$@9",
  "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "$@17", "$@18",
  "$@19", "$@20", "$@21", "$@22", "$@23", "$@24", "$@25", "opt_sequence",
  "sequence_defs", "sequence_def", "force_lookahead", "server_def", "$@26",
  "server_options_list", "server_option", "event_tail", "$@27",
  "ev_schedule_time", "$@28", "opt_ev_status", "ev_starts", "ev_ends",
  "opt_ev_on_completion", "ev_on_completion", "opt_ev_comment",
  "ev_sql_stmt", "$@29", "clear_privileges", "opt_aggregate", "sp_name",
  "sp_a_chistics", "sp_c_chistics", "sp_chistic", "sp_c_chistic",
  "sp_suid", "call", "$@30", "$@31", "$@32", "opt_sp_cparam_list",
  "opt_sp_cparams", "sp_cparams", "sp_fdparam_list", "$@33", "sp_fdparams",
  "sp_param_name", "sp_param_name_and_type", "sp_pdparam_list",
  "sp_pdparams", "sp_pdparam", "sp_opt_inout",
  "sp_parenthesized_pdparam_list", "$@34", "sp_proc_stmts",
  "sp_proc_stmts1", "sp_decls", "sp_decl",
  "optionally_qualified_column_ident", "row_field_name",
  "row_field_definition", "row_field_definition_list", "row_type_body",
  "sp_decl_idents_init_vars", "sp_decl_variable_list", "sp_decl_body",
  "$@35", "sp_decl_handler", "$@36",
  "opt_parenthesized_cursor_formal_parameters", "sp_cursor_stmt_lex",
  "sp_cursor_stmt", "$@37", "sp_handler_type", "sp_hcond_list",
  "sp_hcond_element", "sp_cond", "sqlstate", "opt_value", "sp_hcond",
  "raise_stmt_oracle", "signal_stmt", "signal_value", "opt_signal_value",
  "opt_set_signal_information", "signal_information_item_list",
  "signal_allowed_expr", "signal_condition_information_item_name",
  "resignal_stmt", "get_diagnostics", "which_area",
  "diagnostics_information", "statement_information",
  "statement_information_item", "simple_target_specification",
  "statement_information_item_name", "condition_number",
  "condition_information", "condition_information_item",
  "condition_information_item_name", "sp_decl_ident", "sp_decl_idents",
  "sp_opt_default", "sp_proc_stmt_in_returns_clause", "sp_proc_stmt",
  "sp_proc_stmt_compound_ok", "sp_proc_stmt_if", "$@38",
  "sp_proc_stmt_statement", "$@39", "RETURN_ALLMODES_SYM",
  "sp_proc_stmt_return", "$@40", "reset_lex_expr", "$@41",
  "sp_proc_stmt_exit_oracle", "sp_proc_stmt_continue_oracle",
  "sp_proc_stmt_leave", "sp_proc_stmt_iterate", "sp_proc_stmt_goto_oracle",
  "assignment_source_lex", "assignment_source_expr", "$@42",
  "for_loop_bound_expr", "$@43", "cursor_actual_parameters",
  "opt_parenthesized_cursor_actual_parameters", "sp_proc_stmt_open",
  "sp_proc_stmt_fetch_head", "sp_proc_stmt_fetch", "sp_proc_stmt_close",
  "sp_fetch_list", "sp_if", "$@44", "$@45", "$@46", "sp_elseifs",
  "case_stmt_specification", "$@47", "case_stmt_body", "$@48", "$@49",
  "simple_when_clause_list", "searched_when_clause_list",
  "simple_when_clause", "$@50", "$@51", "searched_when_clause", "$@52",
  "$@53", "else_clause_opt", "sp_label", "sp_opt_label", "sp_block_label",
  "sp_labeled_block", "$@54", "sp_unlabeled_block", "$@55",
  "sp_unlabeled_block_not_atomic", "$@56", "opt_sp_for_loop_direction",
  "sp_for_loop_index_and_bounds", "$@57", "sp_for_loop_bounds",
  "loop_body", "while_body", "$@58", "repeat_body", "$@59",
  "pop_sp_loop_label", "sp_labeled_control", "$@60", "$@61", "$@62",
  "$@63", "$@64", "$@65", "sp_unlabeled_control", "$@66", "$@67", "$@68",
  "$@69", "$@70", "trg_action_time", "trg_event",
  "change_tablespace_access", "change_tablespace_info", "tablespace_info",
  "opt_logfile_group_name", "alter_tablespace_info", "logfile_group_info",
  "alter_logfile_group_info", "add_log_file", "change_ts_option_list",
  "$@71", "change_ts_options", "change_ts_option",
  "tablespace_option_list", "tablespace_options", "tablespace_option",
  "alter_tablespace_option_list", "alter_tablespace_options",
  "alter_tablespace_option", "logfile_group_option_list",
  "logfile_group_options", "logfile_group_option",
  "alter_logfile_group_option_list", "alter_logfile_group_options",
  "alter_logfile_group_option", "ts_datafile", "lg_undofile",
  "lg_redofile", "tablespace_name", "logfile_group_name", "ts_access_mode",
  "opt_ts_initial_size", "opt_ts_autoextend_size", "opt_ts_max_size",
  "opt_ts_extent_size", "opt_ts_undo_buffer_size",
  "opt_ts_redo_buffer_size", "opt_ts_nodegroup", "opt_ts_comment",
  "opt_ts_engine", "opt_ts_wait", "ts_wait", "size_number", "create_body",
  "$@72", "create_like", "opt_create_select",
  "create_select_query_expression", "opt_create_partitioning",
  "opt_partitioning", "partitioning", "$@73", "have_partitioning",
  "partition_entry", "$@74", "partition", "$@75", "part_type_def", "$@76",
  "$@77", "$@78", "opt_linear", "opt_key_algo", "part_field_list",
  "part_field_item_list", "part_field_item", "part_column_list",
  "part_func", "sub_part_func", "opt_num_parts", "opt_sub_part", "$@79",
  "$@80", "sub_part_field_list", "sub_part_field_item", "part_func_expr",
  "opt_num_subparts", "part_defs", "part_def_list", "part_definition",
  "$@81", "part_name", "opt_part_values", "$@82", "$@83", "part_func_max",
  "part_values_in", "part_value_list", "part_value_item", "$@84", "$@85",
  "part_value_item_list", "part_value_expr_item", "opt_sub_partition",
  "sub_part_list", "sub_part_definition", "$@86", "sub_name",
  "opt_part_options", "opt_part_option_list", "opt_part_option",
  "opt_versioning_rotation", "$@87", "opt_versioning_interval_start",
  "opt_as", "opt_create_database_options", "create_database_options",
  "create_database_option", "opt_if_not_exists_table_element",
  "opt_if_not_exists", "create_or_replace", "opt_create_table_options",
  "create_table_options_space_separated", "create_table_options",
  "create_table_option", "$@88", "opt_versioning_option",
  "versioning_option", "default_charset", "default_collation",
  "storage_engines", "known_storage_engines", "row_types",
  "merge_insert_types", "udf_type", "create_field_list",
  "create_field_list_parens", "field_list", "field_list_item",
  "column_def", "key_def", "$@89", "$@90", "$@91", "$@92", "$@93", "$@94",
  "$@95", "constraint_def", "period_for_system_time",
  "period_for_application_time", "opt_check_constraint",
  "check_constraint", "opt_constraint_no_id", "opt_constraint",
  "constraint", "field_spec", "@96", "field_type_or_serial", "$@97",
  "$@98", "opt_serial_attribute", "opt_serial_attribute_list",
  "opt_asrow_attribute", "opt_asrow_attribute_list", "field_def", "$@99",
  "opt_generated_always", "vcol_opt_specifier", "vcol_opt_attribute",
  "vcol_opt_attribute_list", "vcol_attribute", "parse_vcol_expr", "$@100",
  "parenthesized_expr", "virtual_column_func", "expr_or_literal",
  "column_default_expr", "field_type", "qualified_field_type",
  "field_type_all", "field_type_numeric", "opt_binary_and_compression",
  "field_type_string", "field_type_temporal", "field_type_lob",
  "field_type_misc", "spatial_type", "char", "nchar", "varchar",
  "nvarchar", "int_type", "real_type", "srid_option", "float_options",
  "precision", "field_options", "field_length", "opt_field_length",
  "opt_field_length_default_1", "opt_precision", "attribute_list",
  "attribute", "opt_compression_method", "opt_compressed", "compressed",
  "compressed_deprecated_data_type_attribute",
  "compressed_deprecated_column_attribute", "asrow_attribute",
  "serial_attribute", "with_or_without_system", "charset", "charset_name",
  "charset_name_or_default", "opt_load_data_charset",
  "old_or_new_charset_name", "old_or_new_charset_name_or_default",
  "collation_name", "opt_collate", "collation_name_or_default",
  "opt_default", "charset_or_alias", "collate", "opt_binary", "binary",
  "opt_bin_mod", "ws_nweights", "$@101", "ws_level_flag_desc",
  "ws_level_flag_reverse", "ws_level_flags", "ws_level_number",
  "ws_level_list_item", "ws_level_list", "ws_level_range",
  "ws_level_list_or_range", "opt_ws_levels", "opt_primary", "references",
  "opt_ref_list", "ref_list", "opt_match_clause", "opt_on_update_delete",
  "delete_option", "constraint_key_type", "key_or_index",
  "opt_key_or_index", "keys_or_index", "opt_unique", "fulltext", "spatial",
  "normal_key_options", "fulltext_key_options", "spatial_key_options",
  "normal_key_opts", "spatial_key_opts", "fulltext_key_opts",
  "opt_USING_key_algorithm", "opt_key_algorithm_clause", "key_using_alg",
  "all_key_opt", "normal_key_opt", "spatial_key_opt", "fulltext_key_opt",
  "btree_or_rtree", "key_list", "key_part", "opt_ident", "string_list",
  "alter", "$@102", "$@103", "$@104", "$@105", "$@106", "$@107", "$@108",
  "$@109", "$@110", "$@111", "$@112", "account_locking_option",
  "opt_password_expire_option",
  "opt_account_locking_and_opt_password_expiration",
  "ev_alter_on_schedule_completion", "opt_ev_rename_to", "opt_ev_sql_stmt",
  "ident_or_empty", "alter_commands", "$@113", "$@114", "$@115",
  "remove_partitioning", "all_or_alt_part_name_list", "add_partition_rule",
  "$@116", "add_part_extra", "reorg_partition_rule", "$@117",
  "reorg_parts_rule", "$@118", "alt_part_name_list", "alt_part_name_item",
  "alter_list", "add_column", "alter_list_item",
  "opt_index_lock_algorithm", "alter_algorithm_option",
  "alter_lock_option", "opt_column", "opt_ignore", "alter_options",
  "$@119", "alter_options_part2", "alter_option_list", "alter_option",
  "opt_restrict", "opt_place", "opt_to", "slave", "$@120", "$@121",
  "start", "opt_start_transaction_option_list",
  "start_transaction_option_list", "start_transaction_option",
  "slave_thread_opts", "$@122", "slave_thread_opt_list",
  "slave_thread_opt", "slave_until", "slave_until_opts", "checksum",
  "$@123", "opt_checksum_type", "repair_table_or_view", "$@124", "repair",
  "$@125", "opt_mi_repair_type", "mi_repair_types", "mi_repair_type",
  "opt_view_repair_type", "analyze", "$@126", "analyze_table_list",
  "analyze_table_elem_spec", "opt_persistent_stat_clause",
  "persistent_stat_spec", "persistent_column_stat_spec", "$@127",
  "persistent_index_stat_spec", "$@128", "table_column_list",
  "table_index_list", "table_index_name", "binlog_base64_event",
  "check_view_or_table", "$@129", "check", "$@130", "opt_mi_check_type",
  "mi_check_types", "mi_check_type", "opt_view_check_type", "optimize",
  "$@131", "opt_no_write_to_binlog", "rename", "$@132", "rename_list",
  "table_to_table_list", "table_to_table", "keycache", "$@133",
  "keycache_list_or_parts", "keycache_list", "assign_to_keycache",
  "assign_to_keycache_parts", "key_cache_name", "preload", "$@134",
  "preload_list_or_parts", "preload_list", "preload_keys",
  "preload_keys_parts", "adm_partition", "$@135", "cache_keys_spec",
  "$@136", "cache_key_list_or_empty", "opt_ignore_leaves", "select",
  "$@137", "$@138", "select_into", "$@139", "$@140", "simple_table",
  "table_value_constructor", "$@141", "query_specification_start", "$@142",
  "$@143", "query_specification", "select_into_query_specification",
  "query_expression", "query_expression_no_with_clause",
  "query_expression_body_ext", "$@144", "$@145",
  "query_expression_body_ext_parens", "query_expression_body", "$@146",
  "query_primary", "query_simple", "subselect", "subquery",
  "opt_from_clause", "from_clause", "table_reference_list",
  "select_options", "opt_history_unit", "history_point",
  "for_portion_of_time_clause", "opt_for_portion_of_time_clause",
  "opt_for_system_time_clause", "system_time_expr", "select_option_list",
  "select_option", "select_lock_type", "opt_select_lock_type",
  "opt_lock_wait_timeout_new", "select_item_list", "select_item",
  "remember_tok_start", "remember_name", "remember_end", "select_alias",
  "opt_default_time_precision", "opt_time_precision", "optional_braces",
  "expr", "boolean_test", "predicate", "bit_expr", "or", "and", "not",
  "not2", "comp_op", "all_or_any", "opt_dyncol_type", "dyncol_type",
  "numeric_dyncol_type", "temporal_dyncol_type", "string_dyncol_type",
  "$@147", "dyncall_create_element", "dyncall_create_list",
  "plsql_cursor_attr", "explicit_cursor_attr", "trim_operands",
  "column_default_non_parenthesized_expr", "primary_expr",
  "string_factor_expr", "simple_expr", "mysql_concatenation_expr",
  "function_call_keyword_timestamp", "function_call_keyword",
  "substring_operands", "function_call_nonkeyword",
  "function_call_conflict", "geometry_function", "function_call_generic",
  "@148", "fulltext_options", "opt_natural_language_mode",
  "opt_query_expansion", "opt_udf_expr_list", "udf_expr_list", "udf_expr",
  "sum_expr", "$@149", "$@150", "$@151", "window_func_expr", "window_func",
  "simple_window_func", "inverse_distribution_function",
  "percentile_function", "$@152", "inverse_distribution_function_def",
  "order_by_single_element_list", "window_name", "variable", "$@153",
  "variable_aux", "opt_distinct", "opt_gconcat_separator",
  "opt_gorder_clause", "gorder_list", "opt_glimit_clause",
  "glimit_clause_init", "glimit_clause", "glimit_options", "in_sum_expr",
  "$@154", "cast_type", "$@155", "$@156", "$@157", "cast_type_numeric",
  "cast_type_temporal", "opt_expr_list", "expr_list", "ident_list_arg",
  "ident_list", "when_list", "when_list_opt_else",
  "decode_when_list_oracle", "table_ref", "join_table_list",
  "esc_table_ref", "derived_table_list", "join_table", "$@158", "$@159",
  "$@160", "$@161", "$@162", "$@163", "inner_join", "normal_join",
  "opt_use_partition", "use_partition", "table_factor",
  "table_primary_ident_opt_parens", "table_primary_derived_opt_parens",
  "table_reference_list_parens", "nested_table_reference_list",
  "join_table_parens", "table_primary_ident", "table_primary_derived",
  "opt_outer", "index_hint_clause", "index_hint_type",
  "index_hint_definition", "$@164", "$@165", "index_hints_list",
  "opt_index_hints_list", "$@166", "opt_key_definition", "$@167",
  "opt_key_usage_list", "key_usage_element", "key_usage_list",
  "using_list", "interval", "interval_time_stamp", "date_time_type",
  "table_alias", "opt_table_alias_clause", "table_alias_clause", "opt_all",
  "opt_where_clause", "$@168", "opt_having_clause", "$@169",
  "opt_group_clause", "group_list", "olap_opt", "opt_window_clause",
  "window_def_list", "window_def", "window_spec", "$@170",
  "opt_window_ref", "opt_window_partition_clause",
  "opt_window_order_clause", "opt_window_frame_clause",
  "window_frame_units", "window_frame_extent", "window_frame_start",
  "window_frame_bound", "opt_window_frame_exclusion", "alter_order_clause",
  "alter_order_list", "alter_order_item", "opt_order_clause",
  "order_clause", "$@171", "order_list", "order_dir", "opt_limit_clause",
  "limit_clause", "opt_global_limit_clause", "limit_options",
  "limit_option", "limit_rows_option", "delete_limit_clause",
  "order_limit_lock", "opt_order_limit_lock", "query_expression_tail",
  "opt_query_expression_tail", "opt_procedure_or_into", "order_or_limit",
  "opt_plus", "int_num", "ulong_num", "real_ulong_num", "longlong_num",
  "ulonglong_num", "real_ulonglong_num", "dec_num_error", "dec_num",
  "choice", "bool", "procedure_clause", "$@172", "procedure_list",
  "procedure_list2", "procedure_item", "select_var_list_init", "$@173",
  "select_var_list", "select_var_ident", "select_outvar", "into",
  "into_destination", "$@174", "$@175", "do", "$@176", "drop", "$@177",
  "$@178", "$@179", "$@180", "table_list", "table_name",
  "table_name_with_opt_use_partition", "table_alias_ref_list",
  "table_alias_ref", "opt_if_exists_table_element", "opt_if_exists",
  "opt_temporary", "insert", "$@181", "$@182", "replace", "$@183", "$@184",
  "insert_lock_option", "replace_lock_option", "insert2", "insert_table",
  "$@185", "insert_field_spec", "$@186", "insert_field_list", "opt_fields",
  "fields", "insert_values", "values_list", "ident_eq_list",
  "ident_eq_value", "equal", "opt_equal", "opt_with", "opt_by",
  "no_braces", "$@187", "no_braces_with_names", "$@188", "opt_values",
  "opt_values_with_names", "values", "values_with_names", "expr_or_ignore",
  "expr_or_ignore_or_default", "opt_insert_update", "$@189", "$@190",
  "update_table_list", "update", "$@191", "$@192", "update_list",
  "update_elem", "insert_update_list", "insert_update_elem",
  "opt_low_priority", "delete", "$@193", "opt_delete_system_time",
  "delete_part2", "delete_single_table", "delete_single_table_for_period",
  "single_multi", "$@194", "$@195", "opt_select_expressions",
  "table_wild_list", "table_wild_one", "opt_wild", "opt_delete_options",
  "opt_delete_option", "truncate", "$@196", "opt_table_sym",
  "opt_profile_defs", "profile_defs", "profile_def", "opt_profile_args",
  "show", "$@197", "show_param", "$@198", "$@199", "show_engine_param",
  "master_or_binary", "opt_storage", "opt_db", "opt_full", "from_or_in",
  "binlog_in", "binlog_from", "wild_and_where", "describe", "$@200",
  "$@201", "explainable_command", "describe_command",
  "analyze_stmt_command", "opt_extended_describe", "opt_format_json",
  "opt_describe_column", "flush", "$@202", "flush_options", "$@203",
  "opt_flush_lock", "flush_lock", "$@204", "flush_options_list",
  "flush_option", "opt_table_list", "backup", "backup_statements", "$@205",
  "opt_delete_gtid_domain", "delete_domain_id_list", "delete_domain_id",
  "optional_flush_tables_arguments", "reset", "$@206", "reset_options",
  "reset_option", "$@207", "$@208", "slave_reset_options",
  "master_reset_options", "purge", "$@209", "kill", "$@210", "kill_type",
  "kill_option", "opt_connection", "kill_expr", "shutdown", "$@211",
  "shutdown_option", "use", "load", "$@212", "$@213", "$@214", "$@215",
  "data_or_xml", "opt_local", "load_data_lock", "opt_duplicate",
  "opt_field_term", "field_term_list", "field_term", "opt_line_term",
  "line_term_list", "line_term", "opt_xml_rows_identified_by",
  "opt_ignore_lines", "lines_or_rows", "opt_field_or_var_spec",
  "fields_or_vars", "field_or_var", "opt_load_data_set_spec",
  "load_data_set_list", "load_data_set_elem", "text_literal",
  "text_string", "hex_or_bin_String", "param_marker", "signed_literal",
  "literal", "NUM_literal", "temporal_literal", "with_clause", "$@216",
  "opt_recursive", "with_list", "with_list_element", "$@217",
  "opt_with_column_list", "with_column_list", "with_element_head",
  "insert_ident", "table_wild", "select_sublist_qualified_asterisk",
  "order_ident", "simple_ident", "simple_ident_nospvar", "field_ident",
  "table_ident", "table_ident_opt_wild", "table_ident_nodb", "IDENT_cli",
  "ident_cli", "IDENT_sys", "TEXT_STRING_sys", "TEXT_STRING_literal",
  "TEXT_STRING_filesystem", "ident_table_alias", "ident_set_usual_case",
  "ident_sysvar_name", "ident", "label_ident", "ident_or_text",
  "user_maybe_role", "user_or_role", "user", "keyword_table_alias",
  "keyword_ident", "keyword_label", "keyword_sysvar_name",
  "keyword_sp_decl", "keyword_set_usual_case", "keyword_sp_var_not_label",
  "keyword_sp_head", "keyword_verb_clause", "keyword_set_special_case",
  "keyword_sp_block_section", "keyword_sysvar_type", "keyword_data_type",
  "keyword_sp_var_and_label", "set", "$@218", "$@219", "$@220",
  "set_stmt_option_value_following_option_type_list",
  "start_option_value_list", "$@221", "$@222", "$@223",
  "start_option_value_list_following_option_type", "$@224",
  "option_value_list_continued", "option_value_list", "$@225", "$@226",
  "option_value", "$@227", "option_type", "opt_var_type",
  "opt_var_ident_type", "option_value_following_option_type",
  "option_value_no_option_type", "transaction_characteristics",
  "transaction_access_mode", "isolation_level",
  "transaction_access_mode_types", "isolation_types", "opt_for_user",
  "text_or_password", "set_expr_or_default", "lock", "$@228",
  "opt_lock_wait_timeout", "table_or_tables", "table_lock_list",
  "table_lock", "lock_option", "unlock", "$@229", "handler", "$@230",
  "handler_tail", "$@231", "handler_read_or_scan", "handler_scan_function",
  "handler_rkey_function", "$@232", "handler_rkey_mode", "revoke",
  "revoke_command", "admin_option_for_role", "grant", "grant_command",
  "opt_with_admin", "opt_with_admin_option", "role_list", "current_role",
  "grant_role", "opt_table", "grant_privileges", "opt_privileges",
  "object_privilege_list", "object_privilege", "$@233", "$@234", "$@235",
  "$@236", "opt_and", "require_list", "require_list_element",
  "grant_ident", "user_list", "grant_list", "user_and_role_list",
  "via_or_with", "using_or_as", "grant_user", "auth_expression",
  "auth_token", "opt_auth_str", "opt_column_list", "column_list",
  "column_list_id", "opt_require_clause", "resource_option",
  "resource_option_list", "opt_resource_options", "opt_grant_options",
  "opt_grant_option", "grant_option_list", "grant_option",
  "begin_stmt_mariadb", "$@237", "compound_statement", "opt_not",
  "opt_work", "opt_chain", "opt_release", "commit", "rollback",
  "savepoint", "release", "unit_type_decl", "union_option",
  "query_expression_option", "definer_opt", "no_definer", "definer",
  "view_algorithm", "opt_view_suid", "view_suid", "view_list_opt",
  "view_list", "view_select", "$@238", "view_check_option",
  "trigger_action_order", "trigger_follows_precedes_clause",
  "trigger_tail", "$@239", "$@240", "$@241", "$@242", "$@243",
  "sf_return_type", "$@244", "sf_c_chistics_and_body", "$@245", "sp_tail",
  "$@246", "$@247", "xa", "opt_format_xid", "xid", "begin_or_start",
  "opt_join_or_resume", "opt_one_phase", "opt_suspend", "$@248",
  "opt_migrate", "install", "uninstall", "keep_gcc_happy", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-5103)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3346)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
    7380,  4442,  1339, 92908, -5103,    45, -5103,   307, -5103, -5103,
   -5103,  4471, -5103, -5103, -5103, -5103, -5103, -5103,   194,   514,
   -5103,   213, -5103, -5103,   412, 88414,   -37,   986, -5103, 89698,
   -5103, -5103,   453, -5103, 89698, -5103, -5103, 92908, -5103, -5103,
    1199, -5103, -5103,   145,  2515,    50,  1434,   514,   910, -5103,
   -5103, 93550,   213,  1475, -5103, -5103,   -51, 92908,   213, -5103,
     910, 92908, -5103,   196,   195, -5103,  1705,  2676,   368,  1815,
    1818, -5103, -5103,  1401, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
    4003, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  2264, -5103,
   -5103, -5103, -5103,  4239,  1826, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, 77480, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103,   368, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, 92908, 92908,  1361,  1406, 92908,  2112,  2176, 89056,
   92908,  2176, -5103,    68, -5103, -5103,  1897, -5103,  1568, -5103,
     514,   325, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  1569, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  2137,  2117,
     700,  2085,  2343, 92908,   618,  2176, -5103,  2176,  2176,  2176,
    2176,  2366,  2176,  2176, 92908, -5103,  2176,  2176,   113, 92908,
   37587, -5103,  1467,   -38,  2381, -5103, -5103, -5103, -5103, -5103,
   -5103, 55526,   514, 23788,  2459, -5103, -5103,  2005,  3989,  1794,
   -5103,  2293, -5103, -5103, 92908, -5103, -5103, 55526, -5103,  2293,
   38333,  2821, -5103, 36126, 10472,  2293,   514,  2375, -5103,  1793,
   23788, -5103, -5103,   945, -5103, -5103, 92908, -5103, -5103, -5103,
    2249,   910, -5103, 89056, -5103, -5103, -5103, -5103,  2601, 23788,
     255,  2336, -5103, -5103,  2216, 78122, 89056,  2544,  2117,  2598,
   -5103,  1522,  1314, -5103,  1963,  2045,  2117,  1209,  2052,  2117,
    2485,  2176,  2176, -5103, -5103,  2204,  2204,  2204,  2272,  2204,
   -5103,  2204,  2678,  2004,   193, -5103, -5103,  2031, 92908,  2544,
   -5103, -5103, -5103,  2544,  2544,  2172,  2726,  2772,  2780,   753,
    1990,   204,   204,  1897, 59620,  1220,  2565, -5103,  2678,  2967,
    2049, -5103, -5103,   571,  2967,   368,  2967, -5103,   160,  1568,
     468, 92908, -5103, -5103, -5103,  2126, -5103, -5103, -5103,  2182,
   -5103,  2135,  1324, 58245, -5103, 92908,  2834, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103,   433, -5103, -5103,  2672,   218,
    2298,  2532,  2187, -5103,  2705, 89056, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, 92908,  2205, -5103,  2904, 23788,  2137,
   -5103,  2721, -5103, -5103, -5103, -5103, 78122, -5103, 92908, -5103,
    3009, -5103, -5103,  2922, -5103, -5103, 81352,   539, 92908,  2916,
   92908, 92908, 92908, 92908, 92908, -5103, 89056,  2351, -5103, -5103,
    2176,  2176, -5103, -5103,  2443,  2406,  3174,  2295,  2626, -5103,
    2483, -5103, -5103,  2393, -5103, -5103,   129, -5103, -5103, -5103,
      55,   226,   251,   318,  2918,   337,  1026,   353,   372, -5103,
   -5103, -5103,  2833,  2947,  2384, -5103,  2731, 23788, -5103, -5103,
   -5103,  3053, -5103, -5103,  1103,  2830,  1388, 78122, 98686, 80700,
   99618, 99618, 99618, -5103,   188,  2515, 92908, 99152, 92908, 49442,
   -5103,  2404, -5103, -5103,  8532, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, 92908, -5103, -5103,  2497,  2832, -5103, -5103,
   -5103, -5103, -5103,  2410, -5103, -5103, -5103, -5103, -5103, -5103,
   28954, -5103,  2416,  2426,  2430, 19360,  2434,  2437,  2445,  2448,
    2463,  2295,  2295,  2295,  2467,  2471,  2486,  2489, -5103,  2493,
    2499,  2531,  2535, -5103,  2548, -5103,  2557,  2560,  2568, -5103,
   -5103,    57,   124,  2569,  2581, 24526,  2582, -5103, 72344,  2588,
    2607,  2621,  2625, -5103, -5103, 23788,  2467,  2631, -5103, -5103,
    2654, -5103,  2659,  2677,  2679,  2683,  2697,  2700,  2712,  2716,
    3033,  2730,  2734,  2745,  2467, -5103, -5103, -5103,  2333,  2295,
    2467,  2467,  2749,  2758,  2759,  2773,  2781,  2784,  2788,  2789,
    2792,  2798,  2801, 90340,  2805,  2812,  2813,  2816,  2822,  2827,
    2841,     5,  2842,  2848,  2853,  2864,  2868,  2877,  2888,  2927,
    2934,  2938,  2939,  2942,  2946,  2948,  2954,  2955,  2555,  2961,
    2962,  2965,  2973,  2974,  2640,  2983,  2984,  2987,  2988,  2993,
    2994,  2998,    65,  3000,  3004,   184,  3005,  3007,  3010,  3011,
    3015,  3017,  3019,  3023, 29692, 30430, 28954, 17884, -5103, 92908,
   94192, -5103, -5103, -5103,  3480,  1159,  2060,  3736, 28954, -5103,
   -5103, -5103,  3373, -5103,  3252, -5103, -5103, -5103, -5103, -5103,
    3274,  3288, -5103,  3326, -5103, -5103,  3349,  3056, -5103,  3299,
   -5103, -5103, -5103, -5103, -5103,  2959,  3024,  3550,  3607, -5103,
   -5103,  1301, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,  3034,  3058, -5103,  3299, -5103, -5103,
   58947, 78122, 56202, -5103, -5103,  2443,  3229,  3634, -5103,  3725,
   -5103,  3642, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,  2821, -5103, -5103, 63778,  3586,  1466,    52,
     430,   440, 42485,   132, 85846,   500,  1215,  3045, 68492, 43951,
    3057,    62,  3066, -5103,  3067,  3068,  3073,  3074,  3086,  3095,
    3098, -5103, -5103, -5103,  3169,  3064,  3276,  1682, -5103, -5103,
      23,  3195,   489, -5103,  3452, -5103,  1682, -5103, 39001,  3738,
    2213, -5103,   946, -5103,  3787, -5103, -5103,  3205,  3192,  3221,
   -5103,  2451, -5103,  2117, -5103,   995, -5103,  3738,  1682,  2213,
   -5103,  3404,  3484,   901,  3814, -5103,  1153, -5103, -5103, -5103,
    3053, -5103,  3134, -5103, -5103,  2689, 92908, -5103,  3790, -5103,
   78122, -5103, -5103, -5103,  3141, 78122, 78122,  1053,   960,  3480,
    3143, 23788, -5103, -5103,  4879, 39713,  3345,  1867,  1009, -5103,
   -5103,  2515, 92908, -5103, -5103,   934, -5103,  3574, -5103,  3150,
   -5103, 94834,   960,  3833, -5103, -5103, -5103,  1025,  3547, -5103,
    3156, -5103, -5103, -5103, -5103, 78122, 92908,  2117, -5103, -5103,
   -5103, -5103,  3157, -5103, -5103,  3359,  3242, -5103,  3178, -5103,
   -5103,   396, -5103, -5103,  3857, -5103, 92908, -5103, -5103,  2544,
   -5103,  2544, -5103, -5103,  2544,  2544,  2544, -5103, -5103,  3202,
   -5103,  3490,  3493,  2705, -5103, 71702, 92908,  3853, -5103,  3981,
   -5103, -5103,  3177, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,  3756,  3689,  3689, -5103, 69134, -5103, -5103,  3855,  2565,
    3675, 86488,  3838,  3932, -5103,  3738, -5103, -5103, -5103,   534,
   92908, -5103,   534,   534, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,   368, -5103, -5103,   325, 45994, 92908,
    2967,  2049,  3903,  3570, -5103, 92908, -5103, -5103, -5103,  2295,
    3187, -5103, -5103, -5103, -5103, -5103,  3967, -5103, -5103, 78122,
    3396,  3584,  3584,  3584,  3979, -5103, -5103, -5103, 58245, 78122,
   -5103, -5103, -5103,   218, -5103,  1696, 92908, 78122,  3249, -5103,
   78122,  3208, 23788, -5103, 23788, 55526,  3571,  3480, -5103, -5103,
   78122,  1093, -5103, -5103, -5103,  3967,  3584, 78122,  3976, 78122,
    3899,  2565, -5103,  3226, -5103,  3230, -5103, -5103,  3929, 92908,
   -5103, -5103, -5103,  3235,  2351, 60321, -5103,  1345,  3596, 58947,
   78122, -5103, -5103,  3608,  3895, -5103, -5103, -5103, -5103, -5103,
    3329, -5103, -5103,  3256, -5103, -5103, -5103,  3259, -5103,  3259,
    3259, -5103, -5103,  3259, 58947, -5103, -5103, 58245,  1547,  5576,
    3919,  3325, -5103,  3790, -5103, 25264, -5103, 26002, -5103, -5103,
   -5103,  3534,   323,  1544, -5103, -5103,  3741, 92908,  3485,  3944,
    3918, -5103, -5103, -5103, -5103, -5103, -5103,  3749,  3279,  3904,
    3285, -5103, -5103, 23788,  3280, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, 78122,  3295, 28954, 28954, -5103,  4061,  4061,  4061,
   23788,  2890,  1457,  3653, 23788, 23788, 23788,  2169,  3301, -5103,
   -5103, -5103,   267, -5103,  3302, 23788, 23788, 73628,  3307,   949,
    4553, 23788,  4013, 23788, 23788, 23788, 23788, 17884,  4038, 23788,
   -5103, -5103, 94192, 73628,  3758,  3311, -5103,  3308, -5103,  2200,
   23788,  2281, 23788, -5103, -5103, 23788, 23788,  3318, 23788, 23788,
   31168,  3323, 23788, 23788,  3328,  3460,  4061,  4061,  2356, -5103,
   -5103, -5103, -5103, -5103, -5103,  4061,  4061, 23788, 23788, 18622,
   23788, 23788,  2367, 23788, 23788, 23788, -5103,  3324, 23788, 23788,
   23788, 23788, 23788, 23788, 23788, -5103, 23788, 23788, 23788, 23788,
   23788, 23788,  1316, 23788, 23788, 78122, 23788, 23788, 23788, 23788,
   23788, 23788, 23788,  4011, 78122, 23788, 23788, 23788, 23788,  4014,
   23788, 23788, 23788,  3334, 23788, 78122, 23788, -5103, 23788,  3514,
    3514, -5103, 23788, 18622, 23788,  3338, 74270, 23788, 23788, 23788,
   23788, 24526, -5103, 24526, -5103, -5103,  3342,   296,   313,   368,
   23788,  3336, 69776, -5103, -5103, -5103, -5103, 23788, 23788, 23788,
   31168, -5103,   501, -5103, -5103, -5103, -5103, -5103, 17146, 31168,
    3348, 31168, 31168,  3982,  2449, 31168, 31168, 31168, 31168, 31168,
   31168, 31168, 31906, 32644, 31168, 31168, 31168, 31168, -5103, 89056,
   28954, 79406,  3352,  4024, -5103, 94192, -5103,  1675,   577, -5103,
    2117,  3989, 34111, -5103,  3360, -5103,  3863,  3362, -5103,  1318,
    3357,  3365,  4049, 58947, 58245,  1712,  3381, -5103,  3371,   520,
    3377, -5103, -5103, 60321, 92908, -5103, -5103, -5103, -5103, -5103,
    4118, 23788, -5103, 58947, -5103,  1170, 16382, -5103,  1219,  1695,
      62, -5103, -5103, -5103, -5103, -5103, 16382, 92908, 64464,  3382,
    3477,  3398,  2544, 92908, 78122, 92908, 95476, 92908, 92908, 78122,
   58947, 78122, -5103, -5103, -5103, 92908,  1682,  2213,   982,  1682,
    4037, -5103,  1478,  1478, -5103, -5103, -5103, -5103, -5103, -5103,
    1682, 92908, 92908,  1682, 58245, -5103,  2213,  1973, -5103,  3683,
    3474, -5103, -5103, -5103,  3727, -5103, -5103,  4077,  3397, -5103,
    3752, -5103, -5103,  3500, -5103, -5103, 78122, -5103, -5103,  2213,
   -5103,  2213,  2213, 23788,  1682,  1682,  1682, 72986,  3411,  3413,
   -5103,  3412, -5103,  3414, -5103, -5103, -5103, -5103, 78122, -5103,
   -5103,  3407,  4063,  3417, -5103, -5103,  3996,  1221, -5103,  3842,
   -5103,  3978, -5103, 23788,  3480, 20098,  3692, -5103, -5103,  3695,
    3699,  3702, -5103, -5103, -5103, -5103,  3850,  3704, -5103,  2117,
    3708, -5103, -5103,  3438, -5103, -5103, -5103, 34111, 89056, -5103,
    3440, -5103,  3461, -5103,   167, -5103, -5103,  4133,  3552, 23788,
   -5103, -5103, 78122,  3960, -5103,  2117,  1522, 92908, -5103, -5103,
    4225, -5103,  1566, -5103, -5103, -5103,  3567,  1209, -5103, -5103,
    1318, -5103, -5103,  2204,  3647, -5103, -5103, -5103, 89056, -5103,
   -5103, -5103, -5103, -5103, -5103, 60321, 58245, 89056, -5103,  2544,
    2544, -5103, 78122, -5103, -5103, -5103,  2544,  2544,  2544,  3502,
    2086,  3467,  3478,  3486,  3488,  1263,  3497, 74912,  2315,   235,
    4129,  4144, -5103,  4058,  3013,  4058, -5103, -5103, 74912, 72986,
    3506,  3853, -5103, -5103, -5103, -5103, 89056,  3504, -5103, -5103,
    3503, -5103, 23788,  4253,  4179,  3855,  1369, -5103, -5103,  3854,
   -5103, 90340,  4056,  1081, -5103,  3507,  3629, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,   203, -5103, -5103, -5103,  1489,  3880,  3247,
   -5103, -5103, 89056,  3247,   885,  1834, -5103,  3521,  2117,  2718,
   -5103,  2718, -5103,  3821, -5103,  3823,   315, -5103,  1318, -5103,
   -5103, -5103, -5103, -5103, 78122,  3523, -5103,  3712, 92908,  2205,
    3531,  3533,  3480,  3480, 50118,  4280,  4015,  6049,   102,  3587,
   -5103, -5103, -5103, -5103, -5103, 78122, -5103, -5103,  2097,  3696,
    4034,  3756,  3622, -5103,  3545, -5103, -5103,   795,  4120, -5103,
   -5103,  4138, 92908,  4229, 81994, -5103, -5103,  4148, 92908,  1345,
    3556, -5103, -5103, -5103, -5103, -5103,    62, -5103,  3559,   142,
   78122, 78122, 55526,  3700, -5103, -5103, -5103, 92908, -5103, -5103,
   -5103, -5103,  4066,   348, 34761, 75554, -5103, 75554, 75554, -5103,
   -5103, -5103, -5103, -5103,  1026, -5103, -5103, -5103, -5103, -5103,
   -5103, 23788, 46696,  3480, -5103, -5103, 78122, -5103,  4228, -5103,
   -5103, 97402,   274, -5103, -5103,   147, 78122, -5103, -5103, 23788,
   -5103,  4222,  3705, 92908, -5103,  4288, -5103, -5103, -5103, -5103,
   -5103, -5103,  3480, 92908, 92908, 55526, 55526, 23788, -5103,  1578,
   23788, -5103,  3585, -5103,  3589,  3592,  3418,  3945, 23788, 23788,
   -5103,  3389,   378,   187, -5103,  3598,  3603, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103,  3605, -5103, -5103, -5103,   316,
     319,  3614, -5103, -5103, -5103,  3617,   368, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,  4273, -5103,   390,
   -5103, -5103,   212,   223,   330,   351,   371,  3631,   418,  3324,
    2017,  3604, 73628, 94192,  4061,  3618,  1302,  4061,  3627,   442,
    1325,   510, -5103,  1662,  1691,  3097, -5103,   513,   634, -5103,
   -5103,  3632,  3636,  4061,  3640,  3641,  3643,   640,   246,  3648,
   20836, 21574, 22312,  3170,  3649,   796,  1715,  4061,  3650,  1748,
    2109,  1754, 94192,   805,  1819,   844, -5103,  2147,   870,   880,
     917,   932,  1854,  1859,   942,  1004,  1096,  2167, -5103, -5103,
   -5103, -5103,  3657,  1864,  1886,  3658,  3655,  2188,  1968,  1972,
    1982,  2194,  2222,  2227, 78122,  3661,  1987,  1992,  1190,  2230,
   78122,  2105,  2129,  1279, -5103,  2141,  3667,  1288,   250,  3668,
    3669,  2183,  3672,  1311, -5103, 94192, 92908,  3676,  3624,   272,
     180,  1317,  2199,  4038,  4038, -5103, 23788,  3678,   158, 94192,
    1695, -5103,  4163,  2751,   395, -5103,  2060, -5103, -5103, -5103,
   -5103,   336, -5103,  3681,  2060,  3684,  2567, 17884, -5103,  1629,
    2515, 31168, 31168,  3686, 31168, 31168,  3682,  3682,  1378,  2889,
    2889,  3795,  3591, 24526,  1378, 24526,  1378,  3682,  3682,  3682,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  4218,  3687,
    1589,  3688, -5103, -5103, -5103, -5103, -5103, -5103,    48,  4088,
   -5103,  3875,   570, 23788, -5103,  3706,  4199,  4202,  4210, -5103,
   -5103, -5103, -5103, 58947, 58947, 78122,  4206, 23788,  4378, 60321,
    4387, -5103,  3709, 35411, 75554, 75554, 75554, -5103,  3711, -5103,
   23788, 92908, 92908, 16382, 63778,  4399,  4409,    62, 63092, -5103,
    3480,    62, -5103,  3732,  3733, -5103, -5103, 28954,  2493, -5103,
    3480, -5103,  1346,  4009, -5103,  3735,  3737, -5103,  3728,  3731,
    3743, 67208, 23788, -5103,    62,  1219, -5103, -5103, -5103, -5103,
   -5103,  3742, 92908, -5103, -5103, -5103, 92908, -5103, -5103, -5103,
   -5103, -5103, -5103,  2117, 23788, -5103, -5103,  1682, 92908,  1682,
   -5103,  2117,  4420, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,  1682, -5103, -5103, -5103, -5103, -5103,  3916,
    3738,  2451,  4037, -5103,  2213, 78122,  1682,  1682,  3480, -5103,
   -5103, -5103, -5103,  4294,  3756, 20098,  3753,  3759, -5103, -5103,
   55526, 92908, 92908, -5103, -5103,  2559, -5103,  3756,  4288, 89056,
   65150, 78122, -5103, -5103, -5103,   454, -5103, -5103, -5103, -5103,
   -5103,  3480,  2336,  2493, -5103,  3761,  3480, -5103, -5103,  4470,
   -5103, -5103, -5103, -5103,  2117, -5103, -5103,  5005, -5103, 78122,
   -5103, 71060, -5103, 71060,  2092, -5103, 96118, -5103,  2117,  3480,
   78122,  1202,   147, -5103,  4533, -5103, -5103,  3878, -5103, -5103,
   -5103,  3769, -5103,  3818, -5103, -5103, -5103,  3771, -5103,  4453,
   -5103,  1780,   438,   315, -5103, 92908, 92908, 92908, 78122, -5103,
   92908,  2544, -5103, -5103,  2544, 78122, 92908, 92908,  2544, 74912,
   -5103, -5103, -5103, -5103, -5103, 74912, -5103,   266, -5103,  3983,
    -168,  -168, -5103, -5103, -5103, -5103, -5103,  4423,  4058,  4058,
   74912,  4424,  4498, -5103, 92908,  6060,   380, -5103, 69134, 92908,
    3480, 23788, -5103,  3806,  4179, -5103,   147, -5103, 87772, -5103,
    4132, 87772, 87772, 94192,  4023, 23788,  3797, -5103,    62,    62,
    4016,  4319,  4323,  3925,  2117,  4326,  4327,  4328, -5103, -5103,
   -5103,  2117,  2117, -5103, -5103,    62, -5103,  2357, -5103, -5103,
   -5103, -5103,  3908,  1661, -5103,    62,    62, -5103,  2546, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103,  1126, -5103,   151,  1869,
   58245,  4282, -5103,  4402,  3813, -5103, 78122,  4492, -5103, -5103,
   -5103, -5103, 23788,  4332, -5103, -5103,  4015, -5103,  3837,  3845,
    3848,  3849,  3856,  3859,  3861,  3864,  3865,  3867,  3869,  3870,
    3872,  3873,  3874,  3877,  3879,  3881,  3882,  3884,  3885,  3887,
    3894,  3896,  3820, -5103, -5103,  3886, -5103, -5103, -5103, -5103,
      62,    62,    62,    62, -5103,  4227, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,  4104,  4515, -5103,  -168, 92908,  4346,
   81994, -5103,  4080,  4511, -5103, -5103, 72986, -5103,  3888, 78122,
   -5103, -5103, 60321, -5103, 89056, 58947, -5103, -5103, -5103,  3889,
    1578, 50794, -5103,  3883, -5103,  2234, -5103, 58245,  4337, -5103,
   75554,  3890, -5103,  3891,  4383,  4394,  4398,  4403, 55526,  2559,
    3480, -5103, -5103,  3898, -5103, -5103,  3996,  3689, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  3927,
    4178,  4300, -5103, -5103, -5103,  2662, -5103, -5103,  3480, -5103,
   -5103, -5103,  4558, 57538, 51470,  3907, -5103, -5103, -5103,  2251,
   -5103, -5103, 99618, 99618, 99618,  4288, -5103,  1409, -5103, 23788,
   -5103, -5103, 23788, -5103,  3480,  3802,  3239, 45338, -5103, 45338,
    3239, 23788, -5103,  3910, -5103,  4564,  4568, -5103, -5103, -5103,
   23788, -5103, 23788, -5103, 23788, -5103, 23788, 23788, 23788, 23788,
   23788, 23788, -5103, 31168, -5103,  3912,  3920, -5103, -5103,  3922,
   -5103, 23788, -5103, 23788, -5103, -5103, 23788, 23788, 23788, -5103,
   -5103,  3924, -5103, -5103, -5103, 23788, 23788, 23788, -5103, 23788,
    3832, 23788,  3841, 23788,  3858, 23788, -5103, 26740, -5103,  3928,
   -5103, -5103, -5103, -5103, -5103, 23788, -5103, 23788, -5103, 23788,
   23788, 23788, 23788, 23788, -5103, -5103, 23788, 23788, 23788, -5103,
   23788, -5103,  4508, 23788, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, 23788, -5103, -5103, -5103,
   -5103, 23788, -5103,   383, 27478, -5103, 23788, 23788, 23788, -5103,
   -5103, 23788,  3931,  3933, -5103, 92908, -5103, 23788,  1844,  2388,
     147,  3935, 23788, -5103,  3942,  3947,  3143, -5103, -5103, -5103,
   98044, 23788, -5103, -5103, -5103, -5103,   949, 31168,   276, 31168,
    2515,  2975, 17884, -5103,  1848,  2515,  4038,  4038, 92908,  4685,
    3941, -5103, 23788, 94192, 23788,  3948,  3943, -5103,  3952, 31168,
   -5103, -5103,  3953, -5103,  2064,  2388,  4026,  4401, -5103,  3480,
   34111,  4458, -5103, -5103, 78122,  2192,  4151, -5103, 58947, 58245,
   75554,  4638,  4639,  4640,  4641, -5103,  3480, -5103,  3958,    62,
      62, -5103, -5103,  7987, 58947, 16382, -5103, -5103, -5103, -5103,
    4473,  4474, -5103, -5103,   956,  4257,  4535, -5103, -5103, -5103,
    3973, -5103, -5103, -5103,   559, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,  3480, 16382, -5103,  3382,  3980, 36841,   779,
   -5103, -5103, -5103,  3480, -5103, -5103, -5103, -5103,  3997, -5103,
   -5103, -5103,  4573, -5103, -5103,  4420,  2565,  2213, -5103, -5103,
   74270,  2707, -5103, -5103, -5103, 20098, 52146, -5103,  2267, -5103,
    4748, 74270,  4461, -5103, -5103, -5103, -5103,   364, -5103, -5103,
   52822, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,  3992, -5103, -5103, 20098,  4010, -5103, -5103, -5103,  3889,
    1359,  4012,  3990, -5103, -5103, -5103, -5103, -5103, -5103,   363,
     718,  3062,  2565, -5103, -5103,    97, -5103, -5103, -5103, -5103,
   -5103,  1177, -5103, -5103, -5103, -5103,  1566,  2843, -5103,   147,
    4230, -5103, -5103,  1780,  4448, -5103,  4282,  4679,    83,  4592,
    4593, -5103,  3908, -5103, -5103, -5103, 92908, -5103,  4004,   808,
    4005, 78122,  3981,  3981, -5103,  -168,   302, -5103, 31168,  4764,
   -5103,  4510, 74912,  4649,  4655, -5103, 74912, -5103, -5103,  2305,
   -5103, -5103, 44681, -5103, -5103, -5103,  3480,   415,  1477, 23788,
   92908, -5103,  3806, -5103, -5103, -5103, 87772, -5103, -5103, -5103,
    1369,  4020,  1477,  4018, 63092, 44681, -5103,  4388,  4391,  1931,
   -5103, -5103, -5103, -5103, -5103, -5103,  4507,  1834, -5103,    62,
      62, -5103,   146,    62, -5103, -5103,   604, -5103, -5103,  2323,
     443,  3908, -5103,  2117,  2117,  2117,  2117,   147,  2117,  2117,
    2325, -5103,  4507,  4507,  2718, -5103,   963, -5103, -5103, -5103,
   -5103,  1106, -5103, -5103, 89056, -5103,  4523,  4530, -5103,  4531,
   -5103, -5103,   398, -5103,  2685,    73,  6061,   794, -5103,  4578,
   92908,  4788,  3813, -5103,   347,  2205,  3480, 55526, 23788, -5103,
    4029,  4030,   147,  4031,   147,   147,  2117,  2117,  3997,  2117,
     147,  2117,  2117,  2117,  2117,  2117,  2117,  2117,   147,  2117,
     997,  2747,  2117,   147,  6049, -5103,  2117,  2388,  4507,  4507,
    3696, -5103,  4709,    62, -5103,  3322, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,  4032, 72986,   907,
   -5103, 87130,  4597,  2565,  4064, -5103,  1318, -5103, -5103, -5103,
   -5103,  1338,  4730, -5103, -5103,  4753, -5103, 92908,   464,  4249,
    4559,  4068, 82636, 58245, 58245, 58245, 58245, 47414,  4654, 78122,
   -5103,  4721, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,  8823, -5103, -5103,
   -5103,  4374,  2580,  4065, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103,  4059, -5103, 23788, -5103, -5103,
    4425, -5103, -5103, -5103, -5103, -5103, 53498, 23788,  3480,  3480,
   23788,  4071,  4071,  4073,  4076, -5103,  4793, -5103,  4726,  4071,
    4071, -5103,  4071,  4727,  4071,  4071,  4081, -5103, -5103,  4084,
    4086,  4090,  3143, -5103, 23788, 23788,  2206,    60,  2209,  2241,
    1424,  1459,   279, -5103,  2270,  3133, 94192, -5103, -5103,  2290,
    2297,  2337,  2348,  2362, -5103,  1537,  3902,  1546,  3480, 23788,
    3480, 23788,  3480, 23788,  3480, 24526,  2397, -5103,  2332,  3536,
   -5103,  2344,  3971,  2413,   283,  2496,  1587,  2347,   288,  2542,
    2545,  2561,  2364, -5103,  2313,  4675,  2368, 24526,  2566,  2595,
    1591,  1623,  2599, 94192, 92908,  4085,  2645,  4089,  4089,   208,
   -5103,  4091, -5103, -5103, -5103,  4092, -5103,  2660, 23788, 23788,
    4094,  3480,  4095,  2060, -5103, 23788,  2515, 31168,   293, 31168,
   -5103, -5103,  4218, -5103, 23788, -5103,  4678,  4096,  3143,  4099,
    3480, -5103, -5103, 92908,  4102,  3736, -5103,  3997, -5103,  4749,
   -5103,  4849,  4105,  4123,  4106,  3953, -5103, 58947, -5103,  4659,
    4786,  3559, -5103,  4787, 58245, 58245, 58245, 58245, -5103, 41755,
   -5103, 83278, 16382, 16382, -5103, -5103, -5103,  4115,  4121,   884,
    4681, -5103, -5103, -5103, -5103, 92908, 92908, 16382, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103,  2976, -5103,  3738, -5103,
   -5103, -5103,  1682,  4116, -5103,    62,   352, -5103, 20098,  4128,
    4127, -5103,  4609, -5103, 92908,  4140,  4141,  4142, -5103, -5103,
   -5103,  4139,   368, 74270, -5103, -5103,  4146, 90982, -5103,  4149,
   -5103,  4708, -5103, -5103,  4642, 71060, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,  3738,  4376, -5103,
   -5103, -5103,  4170, -5103,  4154, -5103, -5103, 58245,    73,  4534,
    1232,  1232,  4752, 78122, 78122,  9367,  7956,  3908,  4165, 92908,
   -5103,  3813, -5103,   814, -5103, -5103, -5103, -5103,  3736,  -168,
    -168,  4777,  4650, 74912, 74912,  4780,  4657, 23788,  4167, -5103,
   92908, -5103,  1119, -5103,  4576, -5103, -5103, 23788, -5103, -5103,
   -5103, -5103,  3480,  4928,  4171, -5103, -5103, -5103, -5103, 23788,
   -5103, 23788,  4174,  4176, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
     383,   383, -5103, -5103,   383,   383, -5103, -5103, -5103, -5103,
     383,   383, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,  1661, -5103, -5103, -5103,  1126, -5103, -5103,  4683,  1499,
   -5103,  4765, -5103, -5103, -5103, -5103,  1136,   147,   147,   147,
    2747,  2095, -5103,  2685,  1823,  4517, -5103,  4610,  4580,  4760,
    4580,  4762,  4689,  3370,  4552,    62,  4766,  4937,    62, -5103,
     239,    62,    62,    62,    62,  4233,    62,    62,    62,    62,
    4768,    62,    62,  4560,    62,  4839,  4272,  4842,    62,  4778,
   -5103,  4275,    62,    62,    62,    62,  4580,    62,    62,  4779,
    4393,  4783,  4784,    62,    62,  1694, 92908,    62,    62,  4789,
   -5103, -5103,  7956, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
     450, 76196, -5103, -5103, -5103, -5103,    62,  2515,  1514,  4706,
     161, -5103,  2371, -5103,  4972, -5103,   165, -5103, -5103, 48090,
    3480,   156,   308, -5103,   405, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, 92908,  4507,  4515, -5103, 81994,  2565, -5103,
   92908,  4557,  4759,  3381, -5103, -5103, -5103, -5103, -5103, -5103,
    4219, 23788, -5103, -5103,  4895, -5103, -5103, 58245, -5103, -5103,
     315,   315,   315,   315,  2867,  4581, -5103, -5103, -5103,  4721,
    4501, -5103,  1430, -5103,  4071,  4071,    -5, -5103,  4073,  4795,
    4073, -5103,  4623,  2899,  2776,  4623, -5103,  2899,  4073, -5103,
    4232, -5103,  4623, -5103,  2899,  4071, -5103,  4071, -5103, -5103,
    2899,  4071, -5103,  4238,  4073, -5103, -5103,  4623, -5103, -5103,
   -5103, -5103,  1355,  2957,  4073, -5103, -5103, -5103,  4071,  -146,
    4071,  4071,  4071,  4434,  4071,  4071,  4949, -5103, -5103, -5103,
   -5103, -5103, -5103,  4073,   495,  4071,  4071,  4071,  4071,  4076,
    4918,  4919, -5103, 92908, -5103,  3480, -5103, 55526, 99618,   279,
    3480,  1960, -5103, -5103, -5103,  2030, -5103, -5103, -5103,  4837,
   -5103, -5103,  4071, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,  4244,  4038,  4038, -5103,  4991,  4785,
   -5103, -5103, 23788, 23788, -5103, 23788, -5103,  1745,  4247,  4722,
   -5103, -5103, -5103, -5103, -5103, -5103, 23788, 23788, 23788,  3480,
    3480,  3480,  4038, -5103, -5103,  3625, -5103, -5103,  3239, -5103,
   -5103, 23788, -5103, 23788, -5103, 23788, -5103, 23788, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103,   334,  4038, -5103, -5103,
   23788, 23788, -5103, -5103, -5103, 92908, -5103,  2388,  4252,  4532,
   -5103, -5103, -5103,  2388,  4392, -5103, -5103,  2388,   147, -5103,
   -5103, -5103, 92908, -5103,  2502,  2060, -5103, 23788,  2515,  4845,
    4259,  5008,  4265, -5103, 23788, 41755, -5103,  4268,  4269, -5103,
   -5103, -5103, -5103, 23788,  4889,  4848, -5103,  2388, 92908, -5103,
   -5103, -5103, 58245, 58245,  3709,  3709,  3709,  3709, 91624, -5103,
   -5103, -5103, -5103,  1850, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,    62,    62, -5103, 36841, 63778, -5103, -5103, -5103, -5103,
   -5103, -5103,  3738, -5103, 74270,  2565, 23050, -5103, -5103, -5103,
   20098, -5103, -5103,   949, -5103, 74270, 83920,  4274,  4271, -5103,
      62, 40381, -5103,  4276, -5103,  4278, -5103,  1889,  4611,  4904,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103,  4283, -5103, -5103,  2117,  2915,
   -5103, -5103,  4309, -5103, -5103, -5103, -5103, -5103, 78122, -5103,
   -5103, 41092,  4916, 78122, -5103, -5103,  4861, -5103,  6707, -5103,
   -5103, -5103, -5103,  1367,  4878,  5048,  4291, -5103, -5103, -5103,
   -5103,  4395,  4291,  3813, -5103, -5103, -5103,  4782, -5103, -5103,
   -5103,  4791,  3480, 92908, -5103, -5103, -5103,  1356,  2041,  4924,
    1477,  4298, 92908,  1477,  3480, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  1173, -5103,
   89056, -5103, -5103, -5103, -5103, -5103,  4893,  4899, -5103, -5103,
   -5103, -5103,  4486,   976, 76838,  2544, -5103,  2361,  4344, -5103,
   -5103, -5103,  2016, -5103,  2544,   454,   454,  4967,  2916,   213,
    2916, 40381,   380,  2099,  4951,  2176,  2466,  4348,  4880,  2916,
    2916,    62, 65836,   213, 74270,   179, -5103, -5103, -5103, -5103,
   78122,   201,   238,   277, -5103, -5103, 66522,  3997,   147,   147,
     213,  2117,  2117,    62,   147, -5103, -5103, -5103, 89056, 92908,
   -5103,  1935,   147,  3997,  3997,  2916,   286,  2117,   213, -5103,
     213,   213,  2268,   179, -5103, -5103, -5103,   147,   179, 40381,
   -5103,  6341, -5103, -5103, -5103, 41092, 92908,   150,  4867, -5103,
    4306, 61016, -5103,  4488, 23788, 23788,  4907, 92908,  4909, -5103,
    4717, -5103, 92908, -5103,   949, -5103, -5103, -5103,  4615,  4827,
    2507, -5103, -5103,  2514, -5103, -5103,  2521, -5103, -5103, -5103,
   -5103, -5103,  3888, -5103,  5001, -5103,  4670,  3711,   949, -5103,
    3480, -5103,  4524,   315,  4802,  4802,  4802,  4802, 55526, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103,  4980, -5103, -5103,  4623,
      62,  4623, -5103, -5103,  1095, -5103,  1095, -5103,   326, 63092,
   -5103, -5103, -5103, -5103,   730, 45338,  1651, -5103,  4725,  3586,
    4623, -5103,  4811,  2899, -5103, -5103,  1095,  2204, -5103, -5103,
    4623, -5103, -5103, -5103,  2204,  1095, -5103,  4812, -5103, -5103,
   -5103,  1095,  4623,  4537, 92908,  4949,  2899, -5103, -5103, 96760,
    2899,  1095, 23788, -5103,  4896, -5103,   730,  5091,  2899,  4623,
    1095,  1095, -5103,   231,  4339, -5103, 54174, -5103,  4340,  4341,
    4342,  4345,   730,  2522,  4347, -5103,   730,   730, -5103,  4350,
    4351, 23788,  2204,  4977,  2694,  1647,  2529,  4630,  4584, -5103,
    4520, -5103,  2702,  3480,  3480,  1907,  4073, -5103, -5103, -5103,
   -5103,  5010,  4071, -5103,  5093, -5103,  4071, -5103, -5103, -5103,
   -5103, -5103, -5103,  4360,  2746,  3480,  3480,  2756, -5103, -5103,
   -5103,  2538,  1922,  2761,  2793, -5103, -5103, -5103,  4363, -5103,
   -5103,   403, -5103,  4362, -5103, -5103,  2539,  5112,  1631, 23788,
   -5103,  4371, -5103, -5103, 92908,  4038,   990, -5103,  2571, -5103,
   -5103,  4372,  3709,  3709, -5103, -5103, 84562, 16382, 16382, -5103,
   -5103, -5103, -5103,  4138,  2493, -5103, -5103, -5103, -5103,  4375,
   -5103, -5103,  4367, -5103, 74270, 20098, -5103,  4377,  4379, -5103,
   -5103, -5103, 90982, -5103,  2575, -5103, -5103,  5140, 20098, -5103,
   -5103, 89056, -5103,  4381,  4384, 78764,  2876,  2586, -5103, -5103,
   -5103, -5103, -5103, 78122, -5103,   797, -5103,  7261, -5103,  7956,
     328,  3241, -5103, -5103,  1686,  4509, -5103,  4386, 92908,  2117,
    4390,  5145, 23788,  4396, 23788,  4397,  2590, -5103,   454, -5103,
     454, -5103,  1356,  5133,  5138,  5086,  5147,  2041, -5103,  2482,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,  4404, -5103, -5103,
   -5103, -5103,  4729, -5103,  4997, -5103,  4860,  2515, -5103, -5103,
     213,  4410,  2515,  5087, -5103,  4411,  5053,  5054,   454, -5103,
    2544, 78764, -5103,  2544,  2544, -5103, 78764, 40381, 78764, -5103,
   44681, 78764,  2916, 92908, -5103,  5092, -5103,  5056, 78764, 78764,
    2117, -5103, -5103, 40381,  4413, -5103,  1477, -5103, -5103, -5103,
    2459, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  4418, -5103,
   -5103, -5103, -5103, -5103,  2388, -5103, -5103,  2117, -5103, -5103,
    4892, -5103, -5103, -5103, -5103, -5103, -5103, -5103, 78764, -5103,
   -5103, -5103, 40381, -5103, 40381, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,  3593,  3103, -5103,
    4416,  4421, -5103, 92908, -5103, -5103, 78122, -5103, 43221, 92908,
   -5103, -5103, -5103, -5103, -5103,  3480,  4038,  4814, -5103, -5103,
    4538,  2117,  4792, -5103,  4894, -5103, 92908,   168, 55526, -5103,
     147, -5103,   147, -5103,   147, 31168, -5103, -5103,   368, -5103,
    4802,  1432, -5103, -5103, -5103, -5103, 54850, -5103,  5066,  4941,
   -5103, -5103, 92908, -5103,  4901,  4929, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,    62, -5103, -5103,
   -5103, -5103,  2594, -5103, -5103,  2614, -5103, -5103, -5103, -5103,
   96760, 10343, -5103,  2623, -5103, -5103, -5103,  4949,  4429, -5103,
   -5103,  3480,  4455, -5103, -5103, -5103, -5103,  5091, -5103, -5103,
   80048, -5103, -5103, -5103, 92908,  5118,  5119, -5103, -5103, -5103,
   -5103, -5103,  5036, -5103, -5103, -5103, -5103,  4443,  1477, -5103,
   -5103,  4444, 87772, -5103, -5103, 23788, -5103,  4682, -5103,  4794,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,   730, -5103, -5103,
   -5103, -5103,  3997, -5103, -5103, -5103,  4446, -5103,   147, -5103,
   23788, -5103, -5103,  4447,  4122,  1477, -5103, -5103,  4543,  4401,
    4452, 92908, -5103,  4848, -5103, -5103, -5103, -5103,  4511, -5103,
   85204, -5103, -5103, -5103, 92908, -5103, -5103,  3997,  4815, -5103,
    2636,  4647,  4456, 92908, 92908, 92908, -5103, -5103, 41092,  4457,
   -5103,  5225, -5103,  4861, -5103, -5103, -5103,  4465,  4464, -5103,
   92908, -5103, -5103,  5172, 55526, -5103, -5103, -5103,  5061,  1514,
   -5103,  4608,  4472,  9193, -5103, -5103, -5103,  4608, -5103,  3480,
   92908,  3480, 92908, -5103,  5151,  5151, -5103,  2204,  2204,  5219,
    2204, -5103,  5221,  5222,  2482, -5103,  4984,   976,  4850,  1823,
    5167, -5103, 92908,  5168, -5103, 23788,  2544, -5103, -5103, 78764,
    4970,  1101, 78764, 78764,  1726, -5103, 78764,  2097,  4118, -5103,
   78764,  4379, 92908, -5103, -5103,  1338, -5103, -5103, 74270, -5103,
   -5103, 78122, -5103, -5103,  4992,   150, -5103, 92908, -5103, -5103,
   -5103,  4487,  2003,  4480,  4481,  1560,  2019,  4482,  4238,  2035,
    4483,  4484,   350,  4485,  4489,  4490,  4491,  1355,   950,  2047,
    4493,  4495,  4496,  4071,  4500,  2071,  2072,  2088,  4071,  2111,
    4502,  5232, -5103, -5103,  4503, -5103, -5103, -5103, -5103, -5103,
     322, -5103,  2647, -5103, -5103, -5103, -5103, 48766, -5103, -5103,
   -5103,  3367, -5103,  4693, -5103,  1432, -5103,  4986, 78122, -5103,
   -5103, -5103, -5103,   730,  2204,   730,  4949, -5103, -5103, 92908,
   -5103, 92908,  5100, -5103, -5103, -5103, -5103, 15575, -5103, -5103,
   -5103,  4829, -5103,  2657, -5103, -5103,  4512, 23788, -5103, -5103,
   -5103,  1198,  2814, -5103, -5103, -5103,  4513, -5103,  4516,  4020,
   -5103,  3402,  4644,  4199,  4202,  4210,  4694,  4858, -5103,  4696,
   -5103,   147, -5103,  4525, 31168, -5103,  1454, -5103, -5103, -5103,
   -5103, -5103, -5103,  4940, -5103,  4526, 92908,  2661,  1477,  4527,
    2675,  4536, -5103, -5103, -5103,   364,   797, -5103,  2563, -5103,
   -5103,  5204, -5103,  4907, -5103, -5103, 92908,  1704,  4731, -5103,
   -5103, -5103,  2686,  2704,  2275, -5103, -5103, -5103, -5103,  2204,
   -5103,  2204,  2204, -5103,  4539, -5103, -5103, -5103, 78764,  1242,
    4540, -5103,  2823, 78764,  4970,  1577,  1232, -5103,  1232, -5103,
   -5103,  5245,  5248,   150, -5103, -5103, -5103, -5103, -5103,   213,
   -5103,  4541, 78122, -5103, -5103,  4379,  1177, 92908,  5156,  3040,
   10343, -5103, -5103,  4417, 92908,  4634, -5103, 55526,  4737,  5284,
    5286, -5103, 92908, 92266, 31168, -5103, -5103, -5103,  3756, -5103,
   -5103, -5103, -5103, -5103,  4542, -5103, 80048, -5103, -5103, -5103,
   -5103, 99618, -5103,  1477, 87772, 87772, -5103, -5103, -5103,   -13,
   -5103,  5312,  1403, -5103, -5103,   672, -5103, -5103, -5103, 92908,
    4551,  4635, -5103, -5103,  4622, -5103, -5103,  2995, -5103,  1661,
    2708,  1318, 92908, -5103,  5150,  1318, 92908,  5027, -5103, -5103,
   -5103, -5103, -5103,   161, -5103, 10343,  3241, -5103, -5103,  4761,
   -5103, 92908, -5103, -5103, -5103,  5306, -5103,  5308,  4565,  4566,
   -5103, -5103, -5103, -5103,  5232,  2388,  4848, -5103, 92908, -5103,
   -5103, -5103,  1232, -5103,  4569, -5103,  4574,  4575, -5103, 33382,
   -5103, -5103, -5103, -5103,  5212, -5103,  2738, -5103,  1503,  5159,
   -5103,  5214, -5103,  2117, -5103,  4652, -5103,  3040, -5103, -5103,
   -5103,  4616,  5223,  5175,    62, -5103, 89056, 33382, -5103,  5071,
   -5103,  5028,  5295, -5103,  5346,  3839, -5103, -5103, -5103, 23788,
    4943,  5204, -5103,  4781,  4790, -5103, -5103,  2741, -5103, -5103,
    3736, 74270, -5103, 92908, -5103, -5103, -5103, -5103, -5103, -5103,
    3402, -5103, -5103,  4720,  1268, -5103,  2769, -5103, -5103, -5103,
    2388, -5103,  4589, -5103,  4955,    62,    62,  4956,    62,    62,
      62,    62,  4595,  2995, -5103,  4946,  2808,  1318,  1584,  1477,
    4599,  1656,  4598, -5103, -5103, 78122,  4717, -5103, 56852, 92908,
    4594, -5103, -5103, 90982, 90982, -5103, -5103,  2820,  4602,  4604,
    4605, -5103, 92908,  4607, 92908, 92908,  2747,  2747, 17884, -5103,
   -5103, -5103, -5103, -5103, -5103,  3024, -5103,  4613, -5103, 92908,
   -5103, -5103, -5103,  1386, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, 61711, -5103, -5103,  5206, -5103,  4656,  1420,    62,
   -5103,  4419,  3480, 23788, -5103, -5103, -5103, -5103, -5103, 92266,
    4606, -5103,    62,   380, -5103, -5103, -5103, -5103, -5103, -5103,
   92908, -5103,  4614, -5103, -5103,   162,    62,  2117,  2117,    62,
    2600,  2600,  2388, 89056,  4697, -5103, -5103,    62, -5103,   848,
    4806,  2117,    62,  1381,  1584, -5103, -5103,    62, -5103, -5103,
    1381,  1656, -5103, -5103, 92908,  5296,  4978,  5204,  4617, 92908,
    4620,  2829, -5103, -5103, 92908, 92908,  4624,  2836, 92908,  2837,
    2844, -5103, -5103,  4625,  4848, -5103,  1156,  1156, -5103, -5103,
   -5103, -5103,  4629, -5103,   742, -5103, -5103,  4419,  3480, -5103,
   74270, 20098, -5103,  4635, -5103, -5103,  2851, -5103, 28216, -5103,
   -5103, -5103,  2117, -5103, -5103,  2117, -5103, -5103, -5103, -5103,
   -5103,  2858, -5103, 89056,  1232,  1232,  1381,   848, -5103, -5103,
   -5103,  3052, -5103,   147, -5103,  5255,  5068, -5103, 62406, -5103,
   -5103,  4631, -5103, -5103, -5103, 92908,  4626, -5103, -5103,  2884,
    2898, 92908,   848,  2907,  1584,  1656, -5103,  2908, -5103, -5103,
     466,  5082,  5224,  5231,   509, -5103,  3662,  3662,  1849, -5103,
   -5103,  5184, -5103, -5103,  4614, -5103,  4643, -5103,  3736, -5103,
   -5103, 89056, -5103,  4697, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, 92908,  4867,   848,  2914, -5103,   848, -5103, -5103, -5103,
   -5103, -5103, -5103,  5134,  5351, -5103,  4646, -5103,  3662, -5103,
   -5103, -5103, -5103, -5103,   177,  4944,  4576, -5103, 28216,  4648,
    2995, -5103, -5103,  5347, -5103, -5103, -5103,   848, -5103,  1156,
    1156, -5103, -5103, -5103,   177, -5103,  5398,  4924, -5103, -5103,
   -5103,  4796, -5103, -5103, -5103, -5103,  2204,  5311, -5103, -5103,
    5250,  4658,  1389,   411, 67850,  5193, -5103, -5103, 89056, -5103,
   -5103, -5103, -5103, -5103, 89056,  2925, -5103, -5103, 74270, -5103,
   -5103, 55526, -5103, -5103, 70418,  4660, -5103,    62,  5204, -5103,
   74270, -5103, -5103, -5103, 20098, -5103, -5103
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,  1126,  2355,     0,   454,     0,  1346,   721,  2210,  2348,
    2349,  2135,     2,   509,   220,   407,  2137,  2420,     0,     0,
     505,  1362,   862,   616,     0,   332,     0,     0,   512,   330,
     220,  1411,  3062,  2255,     0,  3153,  2198,     0,  1409,   507,
    2518,  3404,  2140,     0,  3305,     0,     0,     0,  3310,    71,
    2103,     0,  1362,   353,  3155,    84,     0,     0,  1362,  2404,
    3310,     0,  2432,     0,     0,  2236,     0,     0,     0,     0,
       3,     8,    22,     0,    44,    27,    32,    17,    21,    16,
      46,    59,    52,    29,  3307,   403,   404,   405,   406,    42,
    3340,    41,    11,    62,    63,    19,    49,    12,    15,    18,
      40,    48,    36,    43,    56,    57,  1432,  1408,  1436,  1407,
    1403,  1399,  1418,  1419,  1420,  1426,    25,    26,    33,    50,
      67,    23,    64,    60,    24,  2355,    13,    28,    14,    51,
      45,    37,    61,    68,    38,     0,    58,    39,    66,    31,
      53,    30,     9,    10,    20,    54,    55,    47,    69,    34,
      65,    35,  1171,     0,     0,     0,     0,     0,  2133,     0,
       0,  2133,  1255,  1476,  3338,  3339,  3340,  1363,     0,  1364,
       0,     0,  2556,  2557,  2764,  2812,  2813,  2706,  2841,  2658,
    2936,  2958,  2984,  2746,  2745,  2748,  2747,  2749,  2750,  2751,
    2752,  2753,  2754,  2631,  2755,  2756,  2757,  2759,  2758,  2760,
    2761,  2762,  2632,  2705,  2633,  2711,  2763,  2713,  2712,  2765,
    2634,  2635,  2766,  2767,  2768,  2769,  2689,  2637,  2636,  2770,
    2772,  2771,  2714,  2715,  2692,  2773,  2774,  2775,  2777,  2638,
    2639,  2640,  2641,  2642,  2776,  2643,  2778,  2693,  2779,  2780,
    2644,  2781,  2782,  2783,  2784,  2786,  2785,  2686,  2787,  2788,
    2790,  2791,  2792,  2789,  2793,  2794,  2796,  2795,  2717,  2797,
    2716,  2798,  2645,  2799,  2800,  2801,  2802,  2803,  2804,  2805,
    2806,  2807,  2808,  2694,  2809,  2810,  2811,  2833,  2707,  2814,
    2816,  2815,  2718,  2817,  2818,  2819,  2821,  2820,  2822,  2824,
    2646,  2647,  2648,  2823,  2825,  2826,  2827,  2828,  2829,  2831,
    2830,  2835,  2836,  2719,  2649,  2690,  2650,  2651,  2832,  2834,
    3039,  2837,  2838,  2720,  2721,  2839,  2652,  2708,  2840,  2695,
    2843,  2842,  2653,  2844,  2654,  2845,  2846,  2847,  2848,  2849,
    2851,  2853,  2850,  2854,  2855,  2861,  2655,  2852,  2856,  2857,
    2858,  2859,  2860,  2862,  2722,  2863,  2687,  2865,  2864,  2866,
    2867,  2868,  2869,  2723,  2870,  2709,  2871,  2872,  2873,  2886,
    2887,  2877,  2878,  2880,  2881,  2884,  2879,  2885,  2890,  2889,
    2891,  2892,  2893,  2894,  2895,  2888,  2875,  2882,  2883,  2876,
    2896,  2897,  2874,  2898,  2900,  2899,  2901,  2724,  2902,  2903,
    2904,  2905,  2906,  2907,  2908,  2909,  2911,  2910,  2912,  2725,
    2726,  2727,  2913,  2914,  2915,  2702,  2916,  2728,  2729,  2917,
    2920,  2918,  2919,  2921,  2922,  2927,  2928,  2929,  2688,  2924,
    2923,  2925,  2926,  2730,  2731,  2732,  2930,  2931,  2932,  2933,
    2935,  2934,  2696,  2657,  2656,  2659,  2937,  2938,  2660,  2939,
    2941,  2940,  2704,  2661,  2942,  2943,  2945,  2944,  2733,  2734,
    2662,  2691,  2663,  2664,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,  2957,  2735,  2736,  2959,  2960,
    2961,  2963,  2962,  2964,  2965,  2966,  2967,  2968,  2969,  2970,
    2665,  2971,  2697,  2972,  2973,  2666,  2975,  2974,  2667,  2976,
    2977,  2978,  2979,  2980,  2703,  2698,  2981,  2982,  2983,  2737,
    2985,  2986,  2987,  2699,  2988,  2989,  2990,  2668,  2991,  2992,
    2738,  2710,  2669,  2993,  2995,  2700,  2670,  2994,  2672,  2673,
    2996,  2997,  2998,  2671,  2999,  2674,  3000,  3001,  3003,  3002,
    3004,  3005,  3006,  3007,  2675,  3008,  3009,  2676,  3010,  2677,
    3011,  3012,  3013,  3014,  3016,  3015,  3017,  3018,  3019,  3020,
    3021,  3022,  3024,  3026,  3025,  3023,  3027,  3028,  2739,  3029,
    2678,  2740,  3034,  3035,  2741,  3030,  3031,  3032,  3033,  2701,
    3036,  3037,  3038,  2681,  3040,  3041,  3043,  3042,  2679,  2680,
    3044,  3045,  2685,  3046,  3047,  3052,  2742,  2743,  3048,  3049,
    3061,  3050,  3051,  3054,  3053,  3055,  3056,  2601,  2682,  3057,
    3058,  2683,  3059,  2684,  3060,  2744,  2561,  2572,   240,  2573,
    2598,  2596,  2600,  2594,  2595,  2599,  2593,  2597,   456,   129,
       0,     0,     0,     0,  2231,  2133,  2107,  2133,  2133,  2133,
    2133,     0,  2133,  2133,     0,  2136,  2133,  2133,     0,     0,
       0,   447,  2143,  2422,     0,  2442,  2443,  2437,  3143,  3144,
    3138,   409,     0,     0,     0,  2322,  2321,     0,     0,   317,
     329,   332,   325,   328,     0,   220,  1365,   409,   331,   332,
       0,  1441,  3064,     0,  2327,   332,     0,  2208,  2436,     0,
       0,  2519,  2516,  2208,  2393,  2395,     0,  2391,  1548,  1547,
       0,  3310,  2562,     0,  1341,  1373,  1299,  3311,  3312,     0,
      76,    79,  2360,   354,     0,     0,     0,   719,     0,     0,
    1307,     0,  3312,  3322,  2434,     0,   129,  1280,     0,   129,
    2238,  2133,  2133,  3387,  3388,     0,     0,     0,  3382,     0,
    3389,     0,  1436,     0,  1422,     1,     5,     0,     0,   719,
    1083,  1084,  1082,   719,   719,     0,     0,     0,     0,     0,
    3345,  3338,  3339,  3340,     0,  2089,  1956,  1437,  1436,  2036,
    2040,  3326,  3325,  3327,     0,     0,  2036,  1427,  2828,  2651,
    2941,     0,  2340,  2354,  2338,  2550,  1405,  1401,  1129,  1172,
    1132,   224,     0,     0,  1134,     0,     0,  1149,  2578,  2577,
    2576,  1146,  1145,  1144,  1142,     0,   580,   220,     0,  1257,
       0,     0,     0,  3346,  3345,     0,  1318,  2342,  2343,  2344,
    2345,  2346,  2347,  2350,     0,   246,   467,   470,     0,   459,
     462,     0,   130,   131,  1344,  1347,     0,   722,     0,   166,
       0,  2235,  2234,     0,  2233,  2211,     0,  2231,     0,  2131,
       0,     0,     0,     0,     0,   220,     0,  2323,   220,  2115,
    2133,  2133,   510,   484,  3208,  3223,  3224,  1489,  3220,  3225,
       0,  3222,  3214,     0,  3218,  3212,     0,  3244,  3216,  3221,
    2820,  2648,  2835,  2950,  2954,  2970,  2973,  2700,  3017,  3202,
    3187,  3203,     0,     0,  3206,  3210,     0,     0,  2144,  2145,
    2146,  1253,  2423,  2424,  2428,     0,  2446,     0,   422,     0,
       0,     0,     0,   411,   412,   478,     0,   418,     0,   409,
     393,     0,   392,   394,     0,   413,   388,   396,   395,   397,
     398,   399,   400,     0,   401,   402,   475,     0,   389,   390,
     506,   391,  2574,     0,  2575,  2603,  2605,  2602,  2604,  1360,
       0,  2506,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1489,  1489,  1489,  1486,     0,     0,     0,  2511,     0,
       0,     0,     0,  2502,     0,  2512,     0,     0,     0,  2504,
    2505,  2558,  2559,     0,     0,     0,     0,  2509,     0,     0,
       0,     0,     0,  2485,  1550,     0,  1486,     0,  2501,  2508,
       0,  2493,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1486,  2484,  2503,  2510,     0,  1489,
    1486,  1486,     0,     0,     0,     0,     0,  2747,  2631,  2762,
    2689,  2773,  2775,     0,  2638,  2639,  2640,  2641,  2642,  2686,
    2797,  2716,  2798,  2799,  2800,  2651,  2720,  2839,  2846,  2864,
    2866,  2723,  2905,  2907,  2912,  2725,  2726,  2727,  2918,  2919,
    2932,  2704,  2733,  2734,  2948,  2955,  2980,  2737,  2985,  2990,
    2993,  3013,  2740,  3034,  3035,  2741,  3033,  2701,  3046,  3052,
    3055,  3056,  2682,  2744,     0,     0,     0,     0,  1549,     0,
       0,  1790,  1434,  1624,   863,  1495,  1507,  1523,     0,  1622,
    1621,  1625,  1627,  1633,  1542,  1654,  1593,  1594,  1596,  1717,
    1595,  1600,  1601,     0,  1766,  1602,     0,     0,  1599,  2498,
    1598,  1597,  2499,  2500,  1592,  2536,  2572,     0,  2560,   618,
     617,     0,   344,   339,   347,   341,   343,   342,   348,   349,
     350,   345,   340,   346,   333,     0,   318,     0,   326,  3323,
       0,     0,   409,   513,   351,  3208,  2748,  2954,  3176,     0,
    3186,     0,  3337,  3332,  3334,  3333,  3330,  3331,  3335,  1462,
    3336,  1461,  1412,  1442,  1459,  1460,     0,     0,     0,  1001,
    3087,  3088,  2702,  2704,  2703,  3089,  3030,  2630,     0,     0,
    2567,     0,     0,  2568,  2627,  2625,  2629,  2624,  2628,  2623,
    2626,  3063,  3073,  3069,     0,     0,     0,  2335,  1079,  1078,
       0,     0,     0,  2277,     0,  1001,  2335,  2278,     0,  2013,
    2325,  2328,     0,  3091,  2291,  1080,  3092,  2321,     0,  2263,
    2279,  2240,  2284,   129,  3093,     0,  2324,  2013,  2335,     0,
    2256,     0,     0,     0,     0,  1475,     0,   327,  3154,  2209,
    1253,  2178,  1410,  2164,   508,     0,     0,  2148,  2151,  2147,
       0,  2392,   480,  3306,     0,     0,     0,     0,  3315,  1837,
    2104,     0,    80,    75,     0,     0,     0,     0,  2555,  3156,
      85,     0,     0,  3401,    73,     0,  2410,     0,  2408,  2405,
    2407,     0,  3315,     0,  2433,  1287,  1287,     0,     0,  1279,
    1281,  1282,  1287,  1287,  2239,     0,     0,     0,  2492,  2490,
    2491,  2563,  3384,  2489,  2488,  3393,  3395,  3378,     0,  3381,
    3380,  3390,  1425,  1424,     6,    70,     0,   220,   220,   719,
     168,   719,   140,   143,   719,   719,   719,   152,   156,     0,
     222,     0,     0,  3345,  1440,     0,     0,  1452,  1438,  1852,
    1439,  1854,  1851,  1850,  1849,  1880,  1881,  1883,  1882,  1884,
    1886,  1877,     0,     0,  2102,     0,  2097,  1957,  1962,  1956,
       0,     0,     0,     0,  2035,  2013,  2044,  2037,  1404,  2033,
       0,  1400,  1465,  1465,  3329,  3328,  3324,  2038,  1423,  1431,
    1429,  1430,  2039,  1421,     0,  2352,  2552,     0,  2357,     0,
    2036,  2040,  1017,     0,   225,     0,  3343,  3344,  3342,  1489,
    2579,  2582,  3341,  2583,   225,  1143,     0,   581,  2134,     0,
       0,     0,     0,     0,     0,   583,   582,   519,     0,     0,
    1261,  1262,  1256,  1258,  1260,     0,     0,     0,     0,  2356,
       0,   242,   248,   241,     0,   409,     0,   457,   463,    86,
       0,  1348,  2124,  2126,   165,     0,     0,     0,  2212,     0,
    1450,  1956,  2214,  2219,  2225,  2229,  2232,  2109,     0,     0,
    2112,  2118,  2117,  2111,  2323,     0,  2121,   594,     0,     0,
       0,  2122,  2105,     0,     0,  3209,  3207,  3241,  3240,  3245,
       0,  3242,  3238,     0,  3201,  3246,  3231,  3278,  3235,  3278,
    3278,  3232,  3239,  3278,     0,  3237,  3236,     0,  3204,     0,
       0,     0,  1254,  2151,  2429,     0,  2421,     0,  1383,  2448,
    2447,  2444,  1948,  3140,  3145,   416,   423,     0,     0,  2918,
       0,   428,   427,   426,   279,   444,   416,   419,   436,     0,
       0,   277,   410,     0,   442,   445,   499,   495,   503,   497,
     476,   472,     0,     0,     0,     0,  1628,  1954,  1954,  1954,
       0,     0,  1845,     0,     0,     0,     0,  1954,     0,  1664,
    1639,  1640,     0,  1665,     0,     0,     0,     0,     0,     0,
       0,     0,  1796,     0,     0,     0,     0,     0,     0,     0,
    2558,  2559,     0,     0,     0,  1839,  1841,  2536,  2560,  1954,
       0,  1954,     0,  1494,  1674,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1954,  1954,  1954,  1679,
    2486,  2507,  1683,  1685,  1684,  1954,  1954,     0,     0,     0,
       0,     0,  1954,     0,     0,     0,  2495,  2494,     0,     0,
       0,     0,     0,     0,     0,  2513,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2515,     0,     0,
       0,  2514,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1630,     0,  1629,  1631,     0,  1434,   864,     0,
       0,     0,     0,  1546,  1545,  1544,  1543,     0,     0,     0,
       0,  1552,     0,  1554,  1556,  1551,  1553,  1555,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1632,     0,
       0,     0,     0,     0,  2487,     0,  1727,     0,   630,  2418,
       0,     0,     0,   316,  1367,  2584,     0,  1366,  1370,  3140,
     492,  3207,     0,     0,     0,  3204,  1476,  1458,     0,     0,
    3065,  3067,  1000,     0,     0,  1003,  1005,  2169,  2168,  1004,
    1013,     0,  1002,     0,  3128,     0,     0,  3113,     0,  3094,
       0,  1009,  1011,  1010,  3108,  1008,     0,     0,     0,  3078,
       0,     0,   719,     0,     0,     0,     0,     0,     0,     0,
    2306,     0,  1475,  1475,  2257,     0,  2335,  2325,     0,  2335,
    2331,  2290,     0,     0,   775,  2018,  2014,  2283,  2329,  2330,
    2335,     0,     0,  2335,     0,  2297,  2325,  2335,  2252,     0,
       0,  2244,  2249,  2245,     0,  2251,  2250,  2253,  2241,  2242,
       0,  2270,  2299,     0,  2282,  2289,     0,  2269,  2276,     0,
    2287,  2325,  2325,     0,  2335,  2335,  2335,     0,  1476,     0,
     490,  2517,  2520,  2524,  2528,  2151,  2141,  2150,     0,  2394,
     279,     0,     0,  1375,  1377,  1376,  1393,  1301,  3314,     0,
    3316,     0,  3318,     0,    77,     0,     0,  2387,  2385,     0,
       0,     0,  2379,  2381,  2384,  2380,     0,     0,  2386,   129,
       0,  2382,  2361,  2364,  2371,  1475,  2362,     0,     0,   352,
     355,   357,     0,   360,  1948,  3159,  3158,     0,     0,     0,
    1305,  1308,     0,  2415,  2412,   129,     0,  2699,  3321,  3319,
       0,  1275,  1291,  1273,  1285,  1286,     0,     0,  1278,  1277,
    3140,  3402,  3403,     0,     0,  3379,  3396,  3377,     0,  3391,
    3392,  3376,     7,     4,   146,     0,     0,     0,   137,   719,
     719,   132,     0,   154,  1476,  1476,   719,   719,   719,     0,
       0,  1850,  1880,  1881,  1883,     0,  1882,     0,     0,  1948,
       0,     0,  1872,  1896,     0,  1896,  1874,  1875,     0,     0,
       0,  1452,  1878,  2564,  2098,  2101,     0,  2090,  2092,  2093,
    2576,  2095,     0,     0,  1959,  1962,  1467,  2026,  2027,     0,
    2025,     0,  2015,  2019,  2024,  2022,     0,  2006,  2043,  2034,
    2082,  1466,  2041,  2042,  1428,  2341,  2339,  2358,  2359,  2551,
    1406,  1402,  1018,  1017,   713,   716,   715,     0,     0,  1133,
     223,  2581,     0,  1135,     0,  2323,  1150,     0,     0,  2323,
     530,  2323,   584,  2582,  3271,     0,  3283,  3260,  3140,  1259,
    3347,  3348,  1140,  1138,     0,  1319,  1320,  1323,     0,   246,
       0,   249,   251,   468,   409,     0,     0,     0,  1358,     0,
    1356,  1355,  1353,  1354,  1352,     0,  1343,  1349,  1350,  2323,
     522,  1877,     0,  2215,  2221,  2128,  2130,  2550,     0,  1451,
    2217,  2004,     0,     0,     0,  2227,  2132,     0,     0,   594,
    2114,  3199,   597,   596,  2119,   595,  2170,  3258,  2113,  1263,
       0,     0,   409,   482,   485,  3234,  1490,     0,  3215,  3219,
    3213,  3217,     0,  3197,     0,     0,  3205,     0,     0,  3243,
    3226,  3230,  3229,  3227,     0,  3228,  3233,  3211,   408,   448,
    2138,  2847,  3046,  2430,  2426,  2425,     0,  2445,     0,  1949,
    1950,     0,     0,  1952,  3142,  2045,     0,  3139,   424,     0,
     416,     0,     0,     0,   439,   275,   420,   416,   429,   438,
     489,   278,   414,     0,     0,   409,   409,     0,   279,  3140,
       0,  1955,     0,  1811,     0,     0,     0,     0,     0,     0,
    1608,     0,     0,     0,  1749,     0,  1811,  1773,  2075,  2076,
    2056,  2057,  2055,  2058,  1487,     0,  2059,  2074,  1695,     0,
       0,     0,  1771,  1433,  1416,     0,     0,  1924,  1925,  1926,
    1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1937,
    1942,  1938,  1939,  1940,  1941,  1936,  1943,     0,  1923,     0,
    1797,  1762,     0,     0,     0,     0,   864,     0,     0,     0,
       0,     0,     0,     0,  1954,     0,     0,  1954,     0,     0,
       0,     0,  1772,     0,     0,     0,  1770,     0,     0,  1769,
    1652,     0,     0,  1954,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1584,     0,     0,     0,  1954,     0,     0,
       0,     0,     0,     0,     0,     0,  1577,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1946,  1944,
    1947,  1945,     0,     0,  1837,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1709,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1656,     0,     0,     0,  2541,     0,
    1049,     0,     0,     0,     0,  1623,     0,     0,     0,     0,
    3094,  1791,  1793,  1492,  1491,  1493,  1504,  1498,  1502,  1496,
    1500,     0,  1557,  2754,  1505,     0,     0,     0,  1508,  1517,
    1521,     0,     0,     0,     0,     0,  1539,  1540,  1528,  1526,
    1527,  1524,  1525,     0,  1530,     0,  1529,  1536,  1537,  1538,
    1541,  1626,  1012,  1634,  1974,  1764,  1765,  1789,  1978,     0,
    2537,  1476,  1580,  1579,  1581,  1582,  1583,   631,     0,   625,
     628,   642,     0,     0,  2417,     0,  2716,  2740,  2741,   334,
     337,   336,   338,     0,     0,     0,     0,     0,     0,     0,
       0,  3262,  3184,     0,     0,     0,     0,  1472,  1413,  1471,
       0,     0,     0,     0,     0,     0,  3111,     0,     0,  3110,
    3109,     0,  3130,     0,     0,  3115,  3136,  3137,  3134,  3135,
    3133,  3114,     0,     0,  3072,  3116,  3117,  3120,     0,     0,
       0,     0,     0,  3101,     0,  3030,  3074,  3075,  3080,  3070,
    2298,     0,     0,  2301,  2294,  2305,  2764,  2303,  2315,  2302,
    2296,  2307,  2295,     0,     0,  2312,  2308,  2335,     0,  2335,
    2310,     0,  2333,  2320,  2319,  2318,  2267,  2266,  2260,  2326,
    2313,  2309,   220,  2335,  2265,  2264,  2246,  2247,  2248,     0,
    2013,     0,  2331,  2300,  2325,     0,  2335,  2335,  2316,  2317,
    2286,  2288,  2197,     0,  1877,     0,     0,  2183,  2176,  2163,
     409,     0,     0,  2522,  2149,     0,  2152,  1877,   275,     0,
       0,     0,   615,  1393,  1379,  1395,  1303,  1302,  1300,  3313,
    3317,  1838,    79,  2191,  2189,    81,  2188,  2190,    82,  2396,
    2373,  2372,  2374,  2378,   129,  2383,  2375,     0,  2388,  2389,
     365,     0,   361,     0,     0,  3157,     0,   720,     0,    74,
       0,  1309,  2045,  2411,  2413,  2406,  3320,     0,  1276,  1293,
    1292,  1288,  1289,  1294,  1284,  1283,  2237,  3385,  3394,  3398,
    3383,   711,  3195,  3283,   189,     0,     0,     0,     0,   135,
       0,   719,   153,   157,   719,     0,     0,     0,   719,     0,
    1893,  1885,  1887,  1888,  1889,     0,  1892,     0,  1455,     0,
    1443,  1443,  1453,  1895,  1876,  1873,  1897,     0,  1896,  1896,
       0,     0,  1856,  1855,     0,  1948,  1006,  2094,     0,     0,
    1958,     0,  1960,  1969,  1959,  1469,  2045,  1463,     0,  2494,
       0,     0,     0,     0,     0,     0,     0,   714,  2170,  2170,
       0,     0,     0,     0,     0,     0,     0,     0,   226,   235,
    2580,     0,     0,   528,   529,  2170,   527,   570,   571,   574,
     575,   576,     0,     0,   577,  2170,  2170,   524,   550,   551,
     554,   555,   556,   557,   558,   520,     0,   525,     0,     0,
       0,  3295,  1127,  1163,  3349,  1136,     0,     0,  1322,   244,
     243,   247,     0,     0,   455,   464,   458,   460,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    87,    88,   109,     0,  1345,  1357,  2125,  1351,
    2170,  2170,  2170,  2170,   526,   559,   560,   563,   564,   565,
     566,   569,   567,   568,     0,  2323,  2216,  1443,     0,     0,
       0,  2553,     0,  2029,  2005,  2226,     0,  2230,  2229,     0,
    2110,  2120,     0,  2171,     0,     0,  1265,  1264,  2116,  2123,
    3140,   409,   483,   429,  3282,     0,  3281,     0,     0,  3194,
       0,  3254,  3257,  2550,     0,     0,     0,     0,   409,     0,
    2427,  2431,  1384,  1386,  1387,  1385,  1393,     0,  2565,  1953,
    2566,  2590,  2588,  2592,  2586,  2587,  2591,  2585,  2589,     0,
    3148,  3149,  3147,  2050,  2046,     0,  3141,  3146,   417,   425,
     440,   443,     0,     0,   409,     0,   421,   430,   434,     0,
     446,   500,   473,   473,   473,   275,  1361,     0,  1744,     0,
    1745,  1746,     0,  1609,  1846,     0,     0,     0,  1637,     0,
       0,     0,  1748,     0,  1488,     0,     0,  1612,  1604,  1417,
       0,  1775,     0,  1780,     0,  1778,     0,     0,     0,     0,
       0,     0,  1840,     0,  1842,  2537,     0,  1754,  1785,     0,
    1752,     0,  1774,     0,  1786,  1787,     0,     0,     0,  1758,
    1756,     0,  1760,  1757,  1759,     0,     0,     0,  1678,     0,
       0,     0,     0,     0,     0,     0,  1655,     0,  1691,     0,
    1742,  1692,  1693,  1694,  2540,     0,  1688,     0,  1689,     0,
       0,     0,     0,     0,  1641,  1642,     0,     0,     0,  1719,
       0,  1643,  1699,     0,  1617,  1720,  1701,  1648,  1649,  1721,
    1722,  1723,  1614,  1615,  1703,  1704,     0,  1725,  1616,  1705,
    1708,     0,  1651,  2045,     0,  1635,     0,     0,     0,  1653,
    1682,     0,     0,     0,  1613,     0,  1711,     0,     0,     0,
    2045,     0,     0,  1657,     0,     0,   865,  1435,  1605,  2538,
       0,     0,  1499,  1503,  1497,  1501,     0,     0,     0,     0,
    1516,     0,     0,  1509,  1519,  1522,     0,     0,  1976,     0,
       0,  1783,  1835,     0,     0,     0,  1738,  1739,     0,     0,
     624,   623,     0,   627,   703,     0,   644,   632,   621,  2419,
       0,     0,  1368,  1371,     0,     0,     0,  3185,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1477,  2536,     0,
       0,  3098,  3068,     0,     0,     0,  1016,  1015,  1014,  3129,
       0,     0,  3122,  3123,     0,     0,     0,  3095,  3096,  3097,
       0,  2613,  2569,  2571,     0,  2570,  2611,  2609,  2612,  2607,
    2608,  2606,  2610,  3104,     0,  3077,  3078,  3079,     0,     0,
    2293,  2304,  2336,  2337,  2261,  2314,  2311,  2332,  2045,  2271,
    2292,  2262,     0,  2285,  2243,  2333,  1956,  2325,  2258,  2259,
       0,  1452,  1477,  2179,  1476,  2180,   409,  2521,     0,  2526,
       0,  2158,     0,  2155,  2162,   608,  2142,     0,  2153,  2127,
     409,  1342,  1382,  1374,  1381,  1378,  1393,  1391,  1380,  1075,
    1074,     0,  1394,    78,     0,     0,  2376,  2377,  2370,  2390,
    2365,     0,   356,   366,   358,   362,   363,   364,   359,  2836,
    2918,     0,  1956,  3161,  3400,  1316,  1314,  1313,  1315,  1304,
    1310,  1311,  2416,  2414,  2409,  2435,  1291,     0,  1274,  2045,
       0,  3397,   147,   712,     0,   164,  3295,     0,  1099,     0,
       0,   133,   169,  3373,   155,  3363,     0,   148,     0,   224,
       0,     0,  1890,  1891,  1853,  1443,  1445,  1444,     0,     0,
    1447,     0,     0,     0,     0,  1861,     0,  1857,  1859,     0,
    1921,  1913,     0,  2099,  2091,  2096,  2535,  1966,  2010,     0,
       0,  1414,  1969,  1468,  2028,  2017,     0,  2021,  2020,  2023,
    1467,  2007,  2010,  1476,     0,     0,  1131,     0,     0,     0,
     229,   232,   230,   231,   579,   578,     0,  2323,   572,  2170,
    2170,   183,  2170,  2170,   182,   184,     0,   178,   175,   185,
    2170,  1151,   171,     0,     0,     0,     0,  2045,     0,     0,
       0,   191,     0,     0,  2323,   552,   531,   532,   535,   536,
     537,     0,  3265,  3264,     0,  3285,     0,     0,  3287,     0,
    3286,  3284,  3250,  3261,     0,  1158,  1017,     0,  1165,  1167,
       0,     0,  3349,  1321,     0,   246,   250,   409,     0,   461,
       0,     0,  2045,     0,  2045,  2045,     0,     0,  2045,     0,
    2045,     0,     0,     0,     0,     0,     0,     0,  2045,     0,
       0,     0,     0,  2045,     0,  1359,     0,     0,     0,     0,
    2323,   561,     0,  2170,   521,   538,   539,   542,   543,   544,
     545,   546,   549,   547,   548,  2213,  2129,  2229,     0,  2551,
    1475,     0,  2223,  1956,     0,  2228,  3140,  3200,   593,   774,
    3259,  1263,     0,   304,   432,   487,  3279,     0,  3299,     0,
       0,     0,     0,     0,     0,     0,     0,   409,  2192,     0,
    1393,  1397,  2438,  3151,  3152,  3150,  2053,  2054,  2051,  2049,
    2052,   441,   308,   310,   307,   309,  2622,     0,   295,   281,
     297,     0,   384,   290,   382,   383,  2619,  2617,  2621,  2615,
    2616,  2620,  2614,  2618,   479,     0,   280,     0,   437,   429,
       0,   494,   496,   474,   504,   498,   409,     0,  1812,  1843,
       0,   967,   967,   953,   971,  1829,     0,  1823,  1826,     0,
     967,  1831,   967,  1824,   967,     0,     0,  1821,  1822,     0,
       0,     0,  1750,  1747,     0,     0,     0,  1800,     0,     0,
       0,     0,     0,  1533,     0,  1733,     0,  1755,  1753,     0,
       0,     0,     0,     0,  1761,     0,  1661,  1659,  1590,     0,
    1588,     0,  1589,     0,  1591,     0,     0,  1743,     0,  1559,
    1578,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1838,     0,     0,  2061,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2542,     0,     0,     0,  1038,
    1044,  1047,  1048,  1050,  1042,     0,  1713,     0,     0,     0,
    1794,  1792,     0,  1514,  1510,     0,  1518,     0,     0,     0,
    1532,  1531,  1978,  1977,     0,  1782,     0,     0,  1836,  2539,
    1477,  1728,  1476,   634,     0,   652,   626,  2045,   629,     0,
     643,     0,   655,     0,     0,     0,   335,     0,  1372,     0,
       0,  3183,  3263,     0,     0,     0,     0,     0,  1470,  1478,
    1473,     0,     0,     0,  3066,  3112,  3103,     0,     0,     0,
       0,  3127,  3121,  3118,  3119,     0,     0,     0,  3102,  3076,
    3082,  3081,  3084,  3086,  2281,  2280,     0,  2334,  2013,  2254,
    2273,  2275,  2335,  2199,  2202,     0,  1948,  2187,     0,     0,
    2181,  2185,     0,  2525,     0,     0,     0,  2159,  2161,  2530,
    2529,  2541,     0,     0,  2154,   481,     0,  1915,    83,     0,
    2368,     0,  2363,  2366,     0,     0,  3172,  3173,  3165,  3168,
    3166,  3167,  3171,  3174,  3175,  3162,  3169,  2013,     0,  1306,
    1312,  1290,     0,  1297,  1295,  3386,  3399,     0,  1158,     0,
       0,     0,     0,     0,     0,   723,   723,   170,     0,     0,
     200,  3349,   160,     0,   158,   150,  1454,  1446,  1448,  1443,
    1443,     0,  1849,     0,     0,     0,  1849,     0,     0,   615,
       0,  1894,  1910,  1007,  2452,  1967,  1968,     0,  1963,  2011,
    2012,  1965,  1961,     0,  1970,  1972,  1415,  2016,  1464,     0,
    2009,     0,     0,  2085,  2087,   773,   772,   234,   233,   238,
     239,  2071,  2072,  2069,  2070,   585,   598,  2073,   599,   573,
    2045,  2045,  2175,  2174,  2045,  2045,   177,   174,  2173,  2172,
    2045,  2045,   172,   195,   194,   196,   197,   199,   198,   193,
    1147,     0,   586,   587,   553,     0,   533,  3268,     0,  3275,
    3270,  3273,  3253,  3252,  3251,  3248,     0,  2045,  2045,  2045,
       0,  2045,  3294,  3296,     0,     0,  1148,  1251,  1251,     0,
    1251,     0,     0,  1251,     0,  2170,     0,     0,  2170,   615,
    1269,  2170,  2170,  2170,  2170,     0,  2170,  2170,  2170,  2170,
       0,  2170,  2170,     0,  2170,     0,     0,     0,  2170,     0,
    1234,     0,  2170,  2170,  2170,  2170,  1251,  2170,  2170,     0,
       0,     0,     0,  2170,  2170,     0,     0,  2170,  2170,     0,
    1179,  1233,   725,   768,   752,   753,  1128,  1178,  1180,  1192,
     611,     0,  1210,  1236,  1237,  1235,     0,  3308,     0,     0,
     205,  3351,     0,  3353,     0,  1325,     0,  1324,   245,   409,
     465,  2045,  2045,   102,  2045,    94,    95,    90,   122,   123,
      92,    93,    98,    97,    99,   100,   103,   104,   101,    96,
      91,   126,   128,   127,   105,   124,   125,    89,   592,   591,
     590,   589,   562,     0,     0,  2323,   540,     0,  1956,  2554,
       0,     0,  2030,  1476,  2218,  2220,  2108,  2106,   511,   305,
       0,     0,   429,  3280,     0,  3193,  3198,     0,  3256,  3255,
    3283,  3283,  3283,  3283,   451,     0,  2139,  1388,  1393,  1397,
       0,  1389,  2449,   947,   969,   967,   984,   933,   953,   949,
     953,   943,   984,   890,   890,   984,   946,   890,   953,   948,
       0,   945,   984,   944,   890,     0,   937,   969,   884,   885,
     890,   967,   903,     0,   953,   926,   925,   984,   929,   930,
     928,   932,     0,   934,   953,   939,   927,   931,     0,     0,
     967,   967,   967,     0,     0,   967,   386,   872,   875,   877,
     876,   878,   879,   953,   969,   969,     0,     0,   967,   971,
       0,     0,   298,     0,   276,   431,   435,   409,   473,     0,
    1844,     0,   968,  1813,  1814,     0,  1828,   955,   954,     0,
     972,  1830,     0,  1827,  1816,  1833,  1820,  1825,  1832,  1818,
    1607,  1638,  1611,  1610,     0,     0,     0,  1672,     0,  1798,
    1781,  1779,     0,     0,  1645,     0,  1647,     0,     0,  1735,
    2539,  1702,  1777,  1675,  1706,  1650,     0,     0,     0,  1587,
    1585,  1586,     0,  1662,  1686,     0,  1576,  1687,     0,  1718,
    1668,     0,  1670,     0,  1671,     0,  1697,     0,  1673,  1700,
    1724,  1603,  2063,  2062,  2060,  1618,  2045,     0,  1676,  1636,
       0,     0,  1710,  2543,  2544,     0,  1712,     0,     0,  1049,
    1035,  1036,  1037,     0,  1039,  1041,  1043,     0,  2045,  1726,
    1535,  1534,     0,  1506,     0,  1515,  1512,     0,  1520,  1980,
    1979,     0,     0,  1729,  1835,  1478,  1740,     0,   635,   636,
     638,   640,   706,     0,   630,     0,   619,     0,   634,   622,
    1369,   493,     0,     0,  3180,  3179,  3178,  3177,     0,  1474,
    1482,  1481,  2533,  2537,  3100,  3099,  3132,  3131,  3125,  3124,
    3126,     0,     0,  3105,     0,     0,  2067,  2068,  2066,  2064,
    2065,  2272,  2013,  2268,     0,  1956,     0,  1913,  1477,  2177,
       0,   491,  2527,     0,  2157,     0,     0,     0,  2156,  2166,
       0,     0,  1918,     0,  1919,  1916,  1917,  2045,     0,     0,
     374,   369,   377,   371,   373,   372,   378,   379,   380,   381,
     375,   370,   376,   368,   367,     0,  3160,  1317,     0,     0,
    3196,   163,     0,  1115,  1117,  1116,  1100,  1101,     0,   141,
     144,   823,     0,     0,   134,   603,   611,   724,   727,   600,
     136,   273,   227,     0,     0,     0,   253,   788,   789,   787,
     786,     0,   253,  3349,  1457,  1456,  1862,     0,  1866,  1871,
    1867,     0,  1858,     0,  1879,  1922,  1914,     0,     0,  2460,
    2010,     0,     0,  2010,  1477,  2083,  1476,   176,   181,   180,
     173,   186,   179,   192,   534,  3269,  3267,  3266,     0,  3274,
       0,  3249,  3290,  3288,  3289,  3292,     0,     0,  3291,  3293,
    1152,  1153,  1159,  1154,  1122,   719,  1252,   717,     0,  1214,
    1218,  1215,     0,   824,   719,  1076,  1076,   717,  2131,  1362,
    2131,     0,     0,  2131,     0,  2133,  2131,     0,     0,  2131,
    2131,  2170,     0,  1362,     0,  2045,   613,  1272,  1270,  1271,
       0,  2045,  2045,  2045,   750,   771,     0,  2045,  2045,  2045,
    1362,     0,     0,  2170,  2045,  1227,  1174,  1228,     0,     0,
    1175,     0,  2045,  2045,  2045,  2131,  2045,     0,  1362,  1194,
    1362,  1362,     0,  2045,   758,   759,   757,  2045,  2045,     0,
     726,  1017,  1176,   612,  1177,   823,     0,  1266,   799,   826,
    2546,     0,  3309,     0,     0,     0,  1164,     0,   208,   206,
     216,  3350,     0,  1139,     0,  3353,  1327,  1328,     0,     0,
       0,   115,   117,     0,   119,   121,     0,   111,   113,   523,
     588,   541,  2229,  2222,     0,  2031,     0,  2224,     0,   488,
     433,   486,     0,  3283,  3297,  3297,  3297,  3297,   409,   447,
     450,  2193,  1390,  1398,  2451,  2450,     0,   970,   896,   984,
     982,   984,   910,   985,   957,   950,   957,   913,  1027,     0,
    1020,  1025,  1021,   919,  1023,     0,  1031,  1030,   891,   933,
     984,   921,     0,   890,   912,   918,   957,     0,   907,   916,
     984,   883,   920,   906,     0,   957,   922,   935,   938,   940,
     942,   957,   984,     0,     0,   386,   890,   905,   904,     0,
     890,   957,     0,   291,   951,   936,  1023,  1031,   890,   984,
     957,   957,   300,  2045,   302,   385,   409,   477,     0,     0,
       0,     0,  1023,     0,     0,  1834,  1023,  1023,  1751,     0,
       0,     0,     0,  1804,     0,     0,     0,     0,     0,  1606,
       0,  1731,     0,  1660,  1658,     0,   953,  1566,  1568,  1564,
    1567,     0,   967,  1570,     0,   934,   967,  1573,  1575,  1560,
    1561,  1562,  1563,     0,     0,  1847,  1848,     0,  2081,  2080,
    2079,     0,     0,     0,     0,  2545,  1033,  1715,     0,  1046,
    1040,  1038,  1045,     0,  1795,  1511,     0,     0,  1982,     0,
    1784,     0,  1741,   639,     0,     0,     0,   659,     0,   657,
     633,     0,  3182,  3181,  1480,  1479,     0,     0,     0,  3083,
    3085,  2274,  2201,  2004,  2203,  2204,  2196,  2186,  2184,     0,
    2160,  2531,  2542,   609,     0,     0,  1195,     0,  1196,  1207,
    1209,  1396,     0,  2401,     0,  2399,  2369,  2402,     0,  1296,
    1298,     0,   138,     0,     0,  1122,  2661,     0,   792,   794,
     795,   796,   797,     0,   604,  2449,   610,  1017,   728,   723,
     269,  3374,   514,   515,     0,     0,  3353,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1903,     0,  1902,
       0,  1908,  1912,     0,     0,     0,     0,  2453,  2455,     0,
    2100,  1964,  1973,  1971,  2008,  2088,  2086,     0,  3276,  3272,
    2048,  2047,     0,  1156,     0,  1155,  1160,     0,   825,  1123,
    1362,     0,     0,     0,  1238,     0,     0,     0,  1076,   815,
     719,  1122,  1077,   719,   719,  1212,     0,     0,     0,  1186,
       0,     0,  2131,     0,  1240,     0,  1239,     0,     0,     0,
       0,  1249,  1250,     0,  2000,  2002,  2010,  2078,  2077,   747,
       0,  1231,   740,   739,   742,   741,   744,   743,     0,  1247,
    1248,   736,   733,   745,     0,   735,   760,     0,   748,   730,
       0,   784,   785,   783,   754,   761,   731,   732,     0,   738,
     737,   734,     0,  1202,     0,   776,   781,   779,   778,   777,
     782,   780,   749,   767,   746,   762,  1191,  1251,  1251,  1211,
       0,   790,  2549,     0,  1268,  1213,     0,   800,     0,     0,
     766,   765,   763,   764,   215,   204,     0,     0,  1166,  1168,
       0,     0,  1169,  3352,  3355,  1137,  1333,     0,   409,   107,
    2045,   108,  2045,   106,  2045,     0,  2032,   306,     0,  3300,
    3297,     0,  3191,  3190,  3189,  3188,   409,   452,     0,     0,
     908,   986,     0,   909,   959,   960,   958,   886,   882,  1028,
    1022,   893,  1024,  1019,  1032,  1029,  1026,   982,   892,   914,
     915,   888,     0,  1124,   900,     0,   889,   941,   887,   901,
       0,     0,   287,     0,   285,   294,   917,   386,   282,   898,
     902,   387,     0,   911,   894,   895,   897,  1031,   880,   881,
    2045,   296,   315,   314,     0,     0,     0,   965,   963,   966,
     964,  1815,     0,  1817,  1819,  1666,  1667,  1801,  2010,  1799,
    1806,     0,     0,  1805,  1696,     0,  1646,     0,  1732,     0,
    1707,  1663,  1569,  1565,  1572,   935,  1571,  1023,  1690,  1669,
    1698,  1619,  2045,  1677,  1680,  1681,     0,  1714,  2045,  1513,
       0,  1985,  1984,     0,     0,  2010,  1730,   637,   707,   632,
       0,     0,   656,     0,   620,  2534,  3107,  3106,  2029,  2523,
       0,  2165,  2167,  1392,     0,  1920,  2397,  2045,     0,  2367,
       0,     0,     0,     0,     0,     0,   798,   791,   823,     0,
     602,   709,   729,   611,   272,   270,   271,     0,   265,   267,
       0,   236,   228,     0,   409,   518,   516,   517,     0,     0,
     149,     0,   254,     0,   256,   257,   162,     0,  3353,  1863,
       0,  1868,     0,  1860,  1898,  1898,  1909,     0,     0,     0,
       0,  2454,     0,     0,  2461,  2463,     0,  1154,     0,     0,
       0,  1197,     0,     0,  1216,     0,   719,  1072,  1073,  1122,
    1097,  2546,  1122,  1122,     0,  1185,     0,  1348,  1013,  1223,
       0,  1181,     0,  1225,  1226,  1263,   756,  1183,     0,  2003,
     614,  2389,  1190,   755,     0,  1266,  1182,  1204,  1188,  1217,
    1267,  1054,   969,   884,   885,   890,   967,   903,  2718,   953,
     926,   925,   984,   929,   930,   928,   932,  2728,   934,   953,
     939,   927,   931,  2736,   830,   967,   967,   967,  2743,   967,
       0,   818,   828,   873,  2548,   202,   207,   217,   218,  1141,
       0,  3354,     0,  1334,  1330,  1331,  1326,   409,   116,   120,
     112,     0,  3192,     0,  3304,  3298,  3302,     0,     0,   983,
     961,   962,   987,  1023,     0,  1023,   386,   286,   289,     0,
     292,     0,     0,   899,   324,   323,   321,   409,   311,   319,
     313,     0,   320,     0,   304,   501,     0,     0,  1803,  1763,
    1807,  1808,     0,  1734,  1736,  1574,     0,  1034,     0,  1981,
    1975,     0,     0,     0,     0,     0,     0,  1994,  1986,     0,
    1788,  2045,   705,     0,     0,   645,   662,   661,   658,  2200,
    2532,  1208,  2400,     0,  3170,     0,     0,     0,  2010,  1120,
       0,     0,   793,   605,   710,     0,  2449,   274,   269,   268,
     237,   187,  1476,   213,  3369,   227,     0,     0,     0,   258,
     227,   151,     0,     0,     0,  1906,  1904,  2458,  2459,     0,
    2456,     0,     0,  2462,     0,  1161,  1157,  1162,     0,  1199,
       0,   718,     0,  1122,  1097,  2546,     0,   801,     0,   805,
     807,     0,     0,  1266,  1187,  1232,  1224,  1241,  1222,  1362,
    2001,     0,     0,  1221,  1203,  1205,  1309,     0,  1058,   832,
       0,   827,   819,   840,     0,   209,  1170,   409,     0,     0,
       0,  1329,     0,  1336,     0,  3303,  3301,  2194,  1877,   924,
    1125,   923,   293,   288,   283,   952,  2045,   301,   322,   303,
     299,   473,   956,  2010,     0,     0,  1644,  1620,  1716,     0,
    1991,     0,     0,  1989,  1988,     0,  1983,  1990,   708,     0,
       0,   653,   669,   665,     0,   667,   668,   690,  2403,     0,
       0,  3140,     0,  1119,     0,  3140,     0,   769,   601,   266,
     188,  3375,  3364,   205,   214,     0,  3371,   161,   255,     0,
     263,     0,   159,  1865,  1870,     0,  1899,     0,     0,     0,
    2457,  2465,  2464,  3277,     0,     0,     0,  1198,     0,   820,
     813,   809,     0,  1098,     0,   803,     0,     0,  1230,     0,
    1220,  1184,   751,   615,     0,  1189,     0,  1057,     0,  1062,
    1052,   858,   998,     0,   861,     0,   831,   833,   991,   992,
     835,     0,     0,     0,     0,   874,     0,     0,   975,     0,
     978,     0,     0,   829,     0,   841,   974,   981,  2547,     0,
     211,   187,  3356,     0,     0,  1335,  1340,     0,  1337,  1339,
    1449,     0,  2439,     0,   312,   502,  1802,  1810,  1809,  1992,
       0,  1993,  1996,     0,     0,  1997,     0,   649,   651,   641,
       0,   646,     0,   663,     0,  2170,  2170,     0,  2170,  2170,
    2170,  2170,   683,   691,   693,     0,     0,  3140,  1087,  2010,
       0,  1089,     0,   607,   770,     0,   216,  3370,     0,     0,
       0,  1901,  1900,  1915,     0,  1219,  1201,     0,     0,     0,
       0,   811,     0,     0,     0,     0,     0,     0,     0,   870,
     871,  1229,   867,   868,   869,     0,  1193,     0,  1055,     0,
    1059,  1060,  1061,     0,  1053,   859,   860,   999,   834,   997,
     990,   989,     0,   980,   976,     0,   849,     0,     0,   982,
     973,   842,   210,     0,   203,   219,  3357,  3358,  1332,     0,
    2195,  2206,     0,  1006,   284,  1987,  1995,  1999,  1998,   647,
       0,   654,   676,   666,   672,     0,  2170,     0,     0,  2170,
       0,     0,     0,     0,     0,   660,   692,  2170,   190,  1085,
       0,     0,  2170,  1242,  1088,  1113,  1095,     0,  1118,  1121,
    1242,  1090,  1112,  1093,     0,     0,     0,   187,   261,     0,
       0,     0,  1200,   816,     0,     0,     0,     0,     0,     0,
       0,  2497,  2496,     0,     0,  1056,     0,     0,   996,   995,
     993,   994,  1483,   979,     0,   844,   988,   843,   212,  1338,
       0,     0,  2440,   653,   650,   676,     0,   674,     0,   670,
     664,   671,     0,   702,   696,     0,   698,   699,   697,   694,
     687,     0,   685,     0,     0,     0,  1242,  1086,  1111,  1110,
    1091,     0,  1105,  2045,   142,  1244,  1243,  1096,     0,   145,
    1094,     0,  1476,   218,  3372,     0,   259,  1907,  1905,     0,
       0,     0,  1085,     0,  1087,  1089,   866,     0,  1068,  1067,
       0,     0,  1064,  1063,     0,   977,   836,   836,   850,  2205,
    2207,  2466,   648,   673,     0,   681,   677,   679,   682,   701,
     700,     0,   684,     0,   695,  1102,  1103,   139,  1092,  1114,
    1104,  1246,  1245,  1109,  1108,  1106,  1107,   817,  3365,   201,
     262,     0,     0,  1085,     0,   802,  1085,   806,   808,  1206,
    1071,  1069,  1070,     0,     0,  1484,     0,   847,   837,   839,
     846,   852,   853,   851,   854,     0,  2452,   675,     0,     0,
     690,   689,   686,     0,   260,   814,   810,  1085,   804,     0,
       0,  1485,   838,   845,   855,   857,     0,  2460,   680,   678,
     688,     0,   812,  1066,  1065,   856,     0,  2468,  3366,  2467,
       0,  2472,  3361,     0,     0,  2479,  3359,  3360,     0,  3367,
    2470,  2471,  2469,  2474,     0,     0,  2476,  2477,     0,  2441,
    3362,   409,  2478,  2473,     0,  2480,  2482,     0,   187,  2475,
       0,  1476,  3368,  2481,     0,  1477,  2483
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5103, -5103, -5103, -5103,  2328,  4518, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,  2854, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,  2039, -5103,   521, -5103,   527, -5103,   528, -3085,  -623,
    4217, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,  2201, -2944, -4260, -5103, -5103,    26,  1615, -5103, -5103,
     358, -5103,    15, -5103, -5103, -5103, -4325,  -117,  -303, -5103,
      30,  4699,  -118,  4048,  1131, -4572, -5103, -5103, -5103, -5103,
   -5103, -5103, -1970, -5103, -5103,  1122, -5103,   472, -5103, -4685,
   -5103, -5103,   159, -5103, -5103, -5103, -1343,  -649,  -565, -5103,
     498, -5103,   232, -5103,   153, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,   219, -5103, -5103, -5103,    78,   872, -4433,
   -5103, -5103, -5103, -5103,  2786, -5103,  1926, -5103, -1794,  3726,
   -5103, -5103, -5103, -5103, -5103,  2863, -2461, -5103, -5103, -5103,
    1753, -5103, -2809, -5103, -4262,   -99,  -894,    21, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -1086, -5103, -5103, -5103, -5103,
   -5103, -5103, -2698,  1981, -5103,  1479, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,   953, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103,  2717, -5103, -5103,  4663,
   -5103, -5103, -5103, -5103,  1390, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,  3292, -5103, -5103,  3294,  3290, -5103,  3297,
   -5103, -2828, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,  4039, -5103, -5103, -5103, -3040, -5103,
   -5103, -2987,  3434, -5103, -2374, -5103, -5103, -2508, -5103, -5103,
   -2407,  1329, -5103, -5103,  2134,  1448, -5103, -1788, -2618, -2563,
   -5103, -5103, -5103, -2685, -2674,  -728,  3379, -1334, -2787, -5103,
   -5103, -5103,   190,   197,   417,  1571,  2138, -5103, -3693, -5103,
   -5103,   665, -5103, -5103, -5103, -5103, -5103,  1282,   459,  1281,
   -5103,   826,  3072, -2803, -5103, -5103, -5103, -5103, -5103, -5103,
    -138,   229,  -209, -5103, -4137,   462, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -4079, -5103, -5103, -5103,  -332, -5103,
   -5103,  -285, -5103, -5103,  -331, -5103,   -42, -5103, -5103, -5103,
   -5103, -5103,  2881, -1917,  1117,  -637, -5103, -3603,  1603, -3943,
   -3220, -5103, -5103,    89, -1306, -1287,  -214, -5103, -5103, -5103,
   -5103, -5103, -5103,  1052,   456,  1600, -3712, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -3709, -3696,   729, -5103, -4788, -5103,
   -5103, -5103, -4461, -5103, -5103, -5103, -5103, -5103, -5103,  -251,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -3637, -5103, -5103,
     -61,   -90, -5103,    32, -3690, -5103, -4375, -5103,  -803, -5103,
   -5103, -5103, -5103, -5103, -2242,  1385,  1507, -5103, -5103, -5103,
   -5103, -3425, -3102,  -165,  -248, -3091, -1534,  1453,   -88, -3967,
   -4764, -1105, -3707, -5103, -5103, -3056, -3190, -5103,  -667, -2826,
   -3184,   -98, -5103, -5103, -1717,   399, -3179, -5103,   996,   992,
   -2715, -3492, -3731,  1948, -5103, -5103,  1358, -5103, -1640,  1352,
   -5103, -5103, -5103,  1366, -5103,  -272, -5103, -5103, -5103, -5103,
   -3431, -5103, -2514, -3644, -5103, -5103,  5456,  5457, -3089,  -215,
    -217, -5103, -5103, -5103,   216, -5103, -5103, -1489,  -186,  -119,
    -111, -3654, -2596,   133, -3483,   993, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,   435,   439,
    1820, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  1639,
   -2453, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -3536, -4186,
   -5103, -5103,  1100, -5102, -3310, -3297, -3660,  4324, -5103, -5103,
   -5103, -5103,  4145, -3369, -3407, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103,  3626,  1579, -5103, -5103,  2339, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103,   211,  2352, -5103, -5103,
   -5103, -5103, -5103,  2826, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103,   -60, -5103, -5103, -5103, -5103, -5103,   437,  3487,
   -5103, -5103, -5103, -5103,   -11, -5103, -5103, -5103, -5103,  3132,
   -5103, -5103, -5103, -5103,  3014, -5103, -5103, -5103, -5103, -5103,
   -5103,  2131, -5103,  2728, -5103, -2478, -5103, -5103,  1580,  -158,
   -5103, -5103,   -77, -5103, -5103, -5103, -5103, -5103,    53, -5103,
   -5103, -5103,  5451, -1530,     9,   -65, -5103, -5103,     4, -5103,
   -5103,  4203,  -428,  2547,  -727,  4830, -5103, -5103, -5103, -5103,
   -2496,  2429, -5103,  4258, -5103, -5103,  4437,  1556,  4231,  2311,
    1619,  2508, -1711,  -161, -3048,  1400, -5103,  1776,  1195, 10818,
   -5103, -1482, -1511, -5103, -5103,   -43, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103,  2628,  2633, -5103, -5103,  3938,
   -2999, -5103, -5103,  -837, -5103, -2502, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  1993, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,  3893, -1630, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103,  1404, -5103, -2780, -5103, -5103, -5103, -5103,
   -5103,  1408,  -648, -5103,  4033, -5103,  4067, -5103, -1198, -1793,
    3630, -5103,  4279, -5103, -5103, -5103, -5103, -5103, -5103,  3637,
   -5103, -2046, -5103, -2532,  4285,  4287,  4290, -5103,  4292, -5103,
   -5103, -1786,   523, -5103,   867, -5103, -5103, -5103, -5103, -5103,
    1373, -5103,    58,   921,    61, -4181, -1503,  1557, -5103, -5103,
   -1824,  3659,  4083, -1304, -5103,  2950, -5103,  3638,  2027, -5103,
    2360, -5103,  1292,  1296, -5103, -5103,  2036, -5103, -5103, -5103,
   -5103,   617,   122, -5103, -5103, -5103,   505,   961, -2044, -5103,
     625, -3219,  4293,  -216, -1177, -5103, -1333,  2370,   609,  4897,
    -488, -5103, -5103,  4277, -5103, -2779, -5103,  -345, -1539,  -253,
   -3071, -4347, -3235, -5103, -1628, -5103, -5103, -5103, -5103, -5103,
    1304, -5103, -5103, -5103,  2985, -5103,  5554, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,  -692, -1211, -5103,
   -5103,  2857,  -407,  -141,  5579,   -46, -5103, -5103,   -45, -5103,
   -5103, -5103, -5103,  4169,  3801, -5103,  2825, -5103, -5103, -5103,
   -5103,  2500, -5103, -5103,   975,  -988,  3061,  2363, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103,   962, -5103,  1428, -1829, -5103,
   -5103, -5103, -5103,   -44, -5103, -5103, -5103,  1433, -5103,   -22,
    5006,   -25, -5103, -5103, -5103,  4854, -5103, -5103, -5103, -5103,
   -5103, -5103,  3590, -1411,  4857, -5103, -5103, -5103, -5103, -5103,
   -5103,  3154, -5103, -5103, -5103, -5103, -5103, -5103,  3892,  5024,
    -669, -1697, -5103,  -934,  3158,  2549,  -957, -5103, -5103, -5103,
    4312,  5029, -5103, -5103,  5577, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,  3104,   555, -5103, -5103, -5103, -5103,
   -5103,   651, -5103, -5103, -5103, -5103,  3783, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  4204, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103,  1700,  -123, -5103,   947,  -142, -5103,   602, -5103, -5103,
   -5103, -5103, -5103,  -177, -5103, -5103,  -182, -5103, -1380,  4711,
   -1337, -5103, -1690, -3322, -5103,    11, -5103, -5103, -5103,  3160,
   -5103, -5103, -5103, -5103,  1460, -5103, -5103, -2628,  -898, -1651,
   -3800,  1069, -5103, -5103, -5103,  -633,  4333,    -2,  1447, -1271,
   -5103, -5103,  2684,    -3,  -865,   -55,  -471,  -753, -1012, -5103,
    8611, -5103, -5103, -5103, -5103,  -659,  -656,  -654,  -635,  -644,
    -550,   306,  1114, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103,  2591, -5103, -5103, -5103,  1482, -5103,
    5055, -5103,  3361, -1720,  5059,  3234,  2619,  2622, -5103, -5103,
   -5103, -5103, -1723, -5103, -5103, -1709,   105, -5103,  3572, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103, -5103,  3784,  -561,
    -570,  3986,  5072,  4603, -5103,  4245, -5103, -5103, -5103, -5103,
   -5103,  1901, -5103, -1894,  2655, -1412, -2488, -5103, -5103,  3016,
    1379, -5103, -5103,  1671, -5103,  2314, -2525, -2986, -5103,  2517,
   -3035, -5103, -5103,   535, -5103, -5103, -5103,  1827,   121,  5043,
    4475, -5103, -5103, -5103, -5103,  5647, -5103, -5103,   138,  5672,
    5673,  5674,  -419, -5103, -3221, -5103, -4123, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103, -5103,   669, -5103,   460,
   -5103, -5103, -5103, -5103, -5103, -5103,  2181, -5103, -5103, -5103,
   -5103, -5103, -5103, -5103, -5103, -5103
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    69,   737,  1953,    70,    71,    72,    73,    74,  1919,
      75,  1261,  2582,  1263,  1885,  2585,    76,   706,    77,  2077,
    2782,  2783,  4496,  4497,  4490,  4491,  4493,  4494,  2784,   821,
     822,    78,  2638,  3745,  3242,  2635,  5062,  1959,  4723,  1960,
    4724,  2631,  3751,  4333,  1964,  2640,  1965,  4332,  4326,   745,
    3746,  3321,  3322,  5431,  1320,  3237,  3330,  3331,  2643,  4324,
    4476,  5365,  4480,  5510,  5624,  5433,  3358,  4902,  5366,  5367,
     640,  1331,   780,  2039,  5436,  2708,  5082,  2709,    79,   815,
    2069,  3365,  1433,  2070,  2071,  4747,  4748,  5092,  5093,  5094,
    5077,  5078,  5079,  5080,  4322,  4740,  2884,   909,  2175,  2885,
    4967,  4961,  4962,  4963,  4575,  3467,  3468,  3469,  4594,  3470,
    4980,  4985,  3989,  3990,  4508,  3471,  5237,  5238,  5239,   660,
    1137,  5240,    80,    81,   661,   669,   662,  1134,  2439,  1135,
      82,    83,   704,  1909,  1910,  1911,  1912,  3208,  2601,  3202,
    3203,  4293,  4968,  3473,  4583,   910,   911,   912,    85,   641,
     913,   914,   915,   916,  1533,  2168,  2169,   917,   918,   919,
     920,   921,  2887,  2888,  3487,  3435,  3991,  2889,  2179,   922,
     923,   924,   925,  1534,   886,   887,  2848,  4004,  4520,    86,
     618,   817,   818,  2076,  2756,   819,  2757,  3368,  4489,   820,
    1434,  2753,  1436,   926,  3491,   927,   928,  2188,   929,  1524,
      87,  1870,  2833,   852,  1474,  2124,   930,  1244,  2560,  1143,
    2447,  3492,   931,  2185,  2187,  2184,  3490,  5391,  2186,    88,
     651,   680,   639,  1473,   667,  4744,  5088,   792,   793,   829,
    2805,   794,  1444,  1405,  2045,  2735,  2736,  3336,  3337,  3404,
    3405,  3406,  2727,  2728,  2729,  2794,  2795,  2796,  2716,  2717,
    2718,  2049,  2713,  2714,   795,  1406,  1417,  2730,  2731,  2732,
    3410,  2798,  2799,  2800,  2801,  2733,  2114,  2734,  3805,  4314,
    4739,  4315,  5070,  3174,  4735,  4736,  4463,  4830,  3187,    89,
     654,  1120,  1738,  2431,  3635,  3072,  3074,  2432,  3634,  4207,
    4208,  4209,  3070,  3071,  5275,  3076,  3632,  5411,  5713,  5536,
    5537,  3624,  5541,  4216,  4678,  4679,  5041,  5276,  5417,  5645,
    5542,  5720,  5643,  5716,  5644,  5718,  5839,  5786,  5787,  5655,
    5731,  5732,  5791,  5840,  5552,  5553,  5554,  3628,  3629,  5272,
    5295,  3232,  2033,  2034,  4793,  1272,    90,  4316,  3911,  4317,
    4318,  4838,  5563,  3913,  3914,  3915,  3428,  1813,  4872,  4854,
    4331,  4880,  4319,  4727,  4728,  4729,  4730,  5464,  5583,  5466,
    5467,  5580,  5686,  5579,  4731,  4732,  5066,  5361,  4799,  4408,
    4392,  4393,  4468,  4888,  5191,  5363,  5359,  5486,  5487,  5827,
    5828,  5503,  5778,  5504,  5834,  5853,  5854,  5488,    91,   653,
    1686,  5589,  5590,  5591,  4066,  5192,  4067,  4068,  4562,  4069,
    4070,  4071,  4072,  4073,  4074,  4075,  4076,  4077,  4078,  4079,
    4973,  4565,  4097,  4937,  4092,  4563,  4561,  4101,  5505,  5506,
    4931,  4566,  4533,  4948,  5621,  5489,  5507,  5491,  4545,  1769,
    1770,  3273,  1783,  1784,  3107,  2469,  3108,  2037,  4546,  4547,
    4941,  4548,  4946,  4178,  5026,  4184,  4185,  4186,  3589,  3590,
    3591,  3592,  3593,  3031,  5492,  4887,  5358,  5476,  5479,  5604,
    5772,  4800,  4394,  4803,  1229,   746,  4395,  4396,  5736,  5663,
    5670,  5737,  5671,  5664,  5337,  3742,  5738,  5739,  5740,  5673,
    5666,  4306,  5287,  5288,  4788,  4952,    92,   162,  3356,  1392,
    1394,  1404,  3362,  2744,  2743,  1410,  1409,  2722,  4382,  4786,
    3856,  3359,  3930,  5199,   778,  3916,  5349,  5137,  5356,  3917,
    4707,  3918,  5329,  5457,  3919,  5157,  5354,  5474,  4708,  4709,
    3920,  3921,  3922,  5744,  5745,  5746,  4397,  1503,   798,   799,
    1422,  1423,  1424,  2828,  4885,  4420,    93,  2623,  2618,    94,
    1289,  1290,  1291,  1931,  1932,  2621,  2622,  3228,  3734,    95,
    1256,  2578,  1921,  2610,    96,  1275,  3219,  3220,  3221,  3729,
      97,  1430,  2065,  2066,  2748,  3937,  4488,  4906,  5206,  5373,
    5202,  5517,  5518,    98,   825,  1440,    99,   620,  2086,  2087,
    2088,  2786,   100,  1542,   170,   101,  1141,  1744,  1747,  1748,
     102,  1255,  1872,  1873,  1874,  1875,  3183,   103,  2156,  2852,
    2853,  2854,  2855,  2573,  3706,  2574,  2575,  3192,  4011,   104,
     760,  1391,   105,   759,  1390,   106,   107,   679,   732,   671,
    1756,   109,   110,  3175,  2224,   112,   766,   764,  1082,   114,
    1384,  1380,   115,  2225,  1083,   756,   757,  1338,  1162,  3258,
    3259,  2099,  2100,  2675,  2662,  1163,  1164,  1364,  2022,  2687,
    2458,  2459,  1854,  2460,  3649,  4229,  5775,  1563,  1484,  1259,
    1085,  1086,  1087,  1698,  1699,  1714,  1088,  1708,  2385,  4146,
    4639,  4640,  4641,  4642,  5017,  2306,  2307,  2426,  1089,  2294,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  2289,  1097,  1098,
    1099,  1100,  2421,  4128,  4129,  4621,  3065,  3066,  3067,  1101,
    2911,  4114,  2922,  1102,  1103,  1104,  1105,  1106,  3616,  1107,
    4202,  3783,  1108,  1692,  2371,  2251,  4613,  4119,  4997,  5001,
    5002,  5003,  5250,  2192,  2899,  3516,  4602,  4606,  4607,  3517,
    3518,  3617,  3036,  1584,  1585,  1552,  1553,  3567,  1339,  1340,
    1341,  1342,  1343,  3767,  3768,  4752,  4337,  4754,  4341,  1987,
    1988,  1991,  1992,  1344,  1345,  1346,  1347,  1975,  1348,  1349,
    1350,  2667,  5315,  4760,  4761,  5449,  5448,  4762,  4346,  4347,
    3771,  3772,  4273,  4274,  4275,  3269,  2247,  2248,  2322,  2161,
    2162,  2163,  2193,  1358,  2002,  2683,  3279,  2004,  3277,  3778,
    3281,  3784,  3785,  2416,  3058,  3612,  3060,  4668,  5033,  5034,
    5267,  5400,  5401,  5406,  3925,  4824,  4825,  2813,  1365,  2695,
    3291,  3781,  1815,  1816,  1817,  2012,  3284,  3285,  3422,  1367,
    1368,  1378,  1383,  1371,  1369,  2875,  4378,  4828,  3594,  3576,
    4713,  3806,  2216,  2217,  4829,  4651,  1372,  2696,  3792,  3793,
    3794,  1354,  1355,  1997,  1998,  1999,  1373,  1356,  2676,  3774,
     116,   699,   117,  2121,   839,  1470,  2120,  3199,  1442,  2566,
    2094,  2095,  1459,   787,   638,   118,   642,  2849,   119,   683,
    2565,   891,  1248,  1866,  1867,  1868,  3176,  3703,  3177,  3696,
    3697,  3178,  1242,  4268,  4269,  2823,  3819,  3820,  3814,  2559,
    3165,  1243,  1858,  3689,  2556,  3690,  2557,  2587,  3691,  4006,
    4928,  5521,  2553,   120,   677,  4255,  3683,  3684,  5630,  5631,
    1240,   121,   624,  2093,   835,  1448,  1451,  1452,  2103,  2809,
    3984,  1453,  1454,  2811,   836,   837,   122,   720,  1295,  1837,
    1838,  1839,  2540,   123,   674,  1230,  3678,  4252,  2526,   657,
    1468,  1820,  1233,  1821,  2522,  3149,  1804,   124,  1388,  1387,
     813,   125,   126,   772,   171,  2026,   127,  1264,  1902,  2599,
    3712,  3713,  4278,  1903,  1904,  3200,   128,   687,  1250,  3196,
    4714,  4715,  5059,   129,   711,  1279,  1280,  1925,  1923,  3224,
    2613,   130,  2433,   131,   643,   894,  1506,  1507,  2154,   132,
     714,  1284,   133,   134,   896,  4012,  5633,  5781,   647,  2158,
    1511,  5071,  4349,  4767,  4768,  4770,  5114,  5115,  5836,  5871,
    5882,  5875,  5885,  5886,  5889,  5895,  5896,  1109,  1302,  1303,
    1110,  5594,  1111,  1112,  1113,  2226,  1246,   682,  1861,  1862,
    3170,  2563,  3168,  1863,  3698,  3699,  3097,  3278,  1114,  3685,
    4789,  1443,  2096,  1267,   606,  1115,   607,   789,  1304,  1994,
    2859,  1181,  3124,  1117,   933,  1400,  1745,  2054,  2055,  2860,
     609,   934,  3125,  3475,  1183,   610,   611,   612,   613,   614,
     615,   616,   617,   136,   673,  1166,  2465,  1760,  1191,  1789,
    1778,  1788,  2496,  3136,  2499,  3137,  3138,  4244,  3671,  4245,
    3672,  1236,  2491,  1761,  3673,  2484,  2485,  2486,  2487,  3662,
    1775,  2475,  2481,   137,   897,  2167,   650,  1513,  1514,  2872,
     138,   676,   139,   705,  1269,  2606,  3212,  3213,  3725,  4295,
    3726,   140,  1148,  1149,   141,   880,  3235,  2839,  2110,  1403,
    2111,  2138,   883,  1476,   884,   885,  1490,  1487,  1493,  1489,
    3846,  3351,  3352,  2844,  2118,  2056,  2452,  3344,  4368,  2057,
    3840,  3841,  4369,  2128,  2835,  2836,  2741,  5214,  3853,  3355,
    4922,  3995,  5215,  5216,   142,   691,   143,  5083,   698,  1258,
    1882,   144,   145,   146,   147,   765,  1376,  1165,   163,   164,
     165,   166,   802,   803,  3361,  3932,  4483,  4484,  5201,  5878,
    5879,  2642,  3749,  5565,  5843,  5872,  5891,  5305,  5435,  5437,
    5568,  3244,  3748,  5084,   148,  1309,  1305,   731,  1951,  1945,
    1947,  2629,  3231,   149,   150,   151
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     608,   690,   801,   733,   113,  1232,  1179,  1228,  2027,   111,
     652,   135,  2411,   807,  1184,  1530,   935,  1185,  1142,  1186,
     797,    84,   663,  2215,  2014,  2357,   663,  1337,  2013,  1187,
    1402,   663,   935,  1516,   678,  1521,  1522,  1523,   784,  2223,
    2446,   702,  1527,   694,  2105,  2806,  3923,   710,   701,  3650,
    1844,  1260,  2441,   108,   709,  2005,  2588,  2814,   713,  3924,
     670,  3191,  3987,  2493,  2552,  3494,  3495,  3292,  2497,  3964,
     882,  3807,   734,  3790,  3472,  2257,  4344,  3677,  4096,   881,
    1586,  3519,  1995,  3520,  1940,  2133,  2035,  4307,  3773,  2275,
    2605,  2513,  2514,  1286,   808,  3188,  1293,  3807,  3807,  2750,
    1150,   936,  1316,  1546,   791,  2036,  1317,  1318,  3236,   881,
    2517,  3796,  2440,  2600,  3687,  3795,  2697,   936,  3339,  1467,
    3411,  4469,   775,  1188,  4891,   809,   810,   811,  1746,  2533,
    3521,  3412,   666,  2115,  1441,  3434,  3912,  1970,  3265,   113,
    3201,  3934,  3733,  4320,   777,  4389,   812,  2101,  4390,   779,
     781,  4898,   696,   781,  2546,  2547,   790,   796,  3260,  3260,
    4982,  4391,  4756,  3807,  3807,  3261,  1385,  1693,  1694,  5081,
    2826,  4486,  3812,  3340,  5204,   113,  4416,  3341,  2159,  1491,
     111,   712,   135,  5222,  1771,  1774,  1776,  3408,   108,  1693,
    1694,  3028,  3728,  1786,  2598,  2785,  1693,  1694,  4398,  2671,
    4400,   718,   715,  4410,  2396,  2397,  2398,  2399,  2400,  2401,
    2402,  2404,  2406,  2407,  2408,  2409,  2410,  2441,  2376,  2067,
    4180,  1693,  1694, -2351,   108,  1773,  2384,  2386,   750,  2389,
    2390,  2626,  1693,  1694,  3575, -3243,  4445,  1682,  1684,  1685,
    4827,  2845,  3409,  2846,  2847,  4118,  2159, -1951,  1530,  1811,
    4417,  1728,  2873,  4850, -2556,  1693,  1694,  2719, -1951,  1693,
    1694,  2873,  4832,   935,  2032,   935,   935,   935,  -415,  3626,
    1635,  1845,   935,  4181,   935,   806,   761,  2440,  1382,  -415,
   -2351,  1693,  1694, -1130,  2873,  1693,  1694,  3401,  1693,  1694,
   -2689,   684,  1693,  1694, -1130,  1846,  3836,  1693,  1694,  4834,
    1767,  2797,  1693,  1694,   804,  3260,  2873,  3949,  1980,   644,
    3308,  3415,  1401,  4965,   762,   692,  4544,  4544,  5719,   800,
    4544, -2557,  1693,  1694,  2208,  1693,  1694,  4544,  1693,  1694,
    1667,  1329,  1420,  4544,  2159, -2851,  2873,  1381,  4836,  1693,
    1694,  2956,  1695,  2873,  1696,  1587, -2851,  4859,   936,  2742,
     936,   936,   936,  3935,  3335,  5368,  2209,   936,  1167,   936,
    1693,  1694,  4905,  2159,  1695,  2827,  1696,  3740,  3852,  3676,
    1767,  1695,  2210,  1696,  4530,  4738,   648,  3822,  3451,   761,
    1693,  1694,  2873,  1981,  1767,  1428,  1805,   167,     8, -1422,
    1627,  2873,  3854, -2351,  1982,  5299,  1695,  5155,  1696,  1693,
    1694,  1983,  4100,  5362,  1693,  1694, -3226,  1695,  3845,  1696,
    4093,  4094,  1167,  2873,  3068,  4180,  2211,   762,  3976,  4105,
    4648,  4106,  3042,  4108,   685,   892,  2869,  1693,  1694,   655,
    1695, -3230,  1696,  1984,  1695,  5529,  1696, -1422,  1411,  2873,
    2176, -2351, -1422, -3163,  2212,    16,  5074,  1691, -2351,  1671,
    3342,  1693,  1694,  5075, -3163,  5481,  1695,  2117,  1696, -2351,
    1695,  1697,  1696,  1695,  1412,  1696, -1951,  1695,  4181,  1696,
     763,  2909,  1695,  4883,  1696, -1951, -2351,  1695,   659,  1696,
    2896, -1422,  2132,  1697,   838,  2870,   840,   841,   842,   843,
    1697,   845,   846,   621,  1985,   848,   849,  1695, -3229,  1696,
    1695,  3172,  1696,  1695, -3163,  1696,  1413,   935,  3161,  4418,
    2873,  4469,  3043,  5193,  1695,  1697,  1696, -3227,  5076,  1693,
    1694,  3179,  1693,  1694,  1949,  1986,  1697,  5820,  4375,  1330,
    4325, -2353,  3573, -3228, -1951,  1695,  2739,  1696,  3256, -2851,
     707,  2213,  3257,  1366,  2633,  3832,  3833,  4982,  1366,  1697,
    1366,  5483, -3233,  1697,  5880,  1695,  4212,  1696,    31,  3091,
    3092,  3093,  3094,  2627,  1877,   619,  2208,  3757,  5749,  3189,
    4573,  4478,  4205,   763,  1695,  1697,  1696,  1374,  4479,  1697,
    1296,  1297,  1697,  5404,  3190,   879,  1697,  2377, -2353, -1951,
     645,  1697,   936,  4534,  4884,  4536,  1697,    31,  2209,  3676,
    1840,    31,  1695,  4556,  1696,  1414,    36,  4649,  1337,  3044,
     664,  3970,  3971,    38,  2210,   879,  1697,   823,   708,  1697,
     796,  5438,  1697,  5090,    40,  4574,  1695,  1360,  1696,  4571,
     893,   796,  1913,  1697,  5797, -1951,   853,   790,  1254,  1375,
    5881,    42,  5821,  1693,  1694,  1415,  3869,  2838,  4584,  1693,
    1694,  1270,    38,   831,  1697,  4540,    38,  -221,  2211,  3855,
   -3163,  1139,  2907,    40,  5484,  4469,  5575,   790, -2708,  2221,
    1182,  5369,   688,   689,  1697,  5343,  3029,  2378, -2709,  1205,
    1362,  1767,  1957,  1251,  1958,  1586,  2212,  1961,  1962,  1963,
     790,   832,  3912,  1697,  1695,  1140,  1696,  1695,  1697,  1696,
    3077, -2353,  1268,   790,  1806,  5230,  1273,  1682,  1684,  1471,
    1472,  2721,   169,  3936,   823,  3775,  3776,   823,  3339,  2427,
    3411,  1697,  1460,  1461,  1462,   826,  3162,  2035,  2015,  4530,
    3762,  3412,   831,  1205,  3766,  1315,  2109,  3234, -2710,  3807,
    3101,  2450,  3818,   851,  3102,  1697,  2036,  4538,  2078, -2353,
    1429,   775,  4804,  3260, -3247,  2803, -2353,   939,  1767,  3756,
    3816,  2471,  1167,  3994,  4539,   850,  4091, -2353,  1386,  1379,
     832,  2463,  5532,  3340,  2379,  2115,  1636,   648,  2119,  2657,
     790,  1238,  1407,  2213, -2353,  2428,  2074,  3408,  2511,  4585,
    2672,  1466,  2492,  1421,  5072,  4364,  1808,  1767, -3164,  3741,
     935, -1951,   790,  3822, -3345,  1693,  1694, -2689,   622, -3164,
     649,  1431,  1253,  1697,  1693,  1694,  1697,  1768,  1695,  3069,
    1696,  5370,   686,   775,  1695,  1407,  1696,  1418, -2556, -3243,
     693, -2689,  4219,  1455,  1883,  1457,  1668,   781,   781,   781,
    1463,  1407,  3409,   790,  2442,  4182,  4544,  3156,  3676,  2516,
    2189,  3271,  2520,  1693,  1694,  5706,  4975,   719,   716, -3164,
    3034,  3035,   690,  2528,  5081,  1492,  2531,  4379,  5281,  4544,
    2534,  2085,  4327,  4544,  2788,  1465,  2085,  -606,  1469,  1693,
    1694,  4544,  3263,  3264, -3247,   936,  3343,  1768,  -606,  1693,
    1694,  1333,  3972,  2413,   775, -2557,  1520,  2549,  2550,  2551,
    3809,  1768,  2030,  1525,   881,  1528,   717,  2202,  2874,  3050,
    3051,  4524,  3054,  3055,  1969,  2545,  2085,  2874,   113,  5312,
    1535,  5313,  2160,   111,  4529,   135,  1693,  1694,  -114,  2719,
    -114, -2351,   656,  5715,  1587,  3038,  4487,  1697,  4328,  5205,
    2874,  1693,  1694,  1697,   646, -1951,  3440,  2053,  3338,  2259,
    1587,  1693,  1694,  4982,  3030,  1672,  1381,   937,   172,   173,
    3834,  2910,  2874,   648,  5382,  1313,  -415,   108,  4183,  4576,
    4577,  4578,  4009,   937,  4581,  5311,  2300,  4100,  5434,  1189,
    1695, -1130,  1696,  2388,  2923,  5495,  2924,  4590,  4501,  1695,
    2160,  1696,  2874,  2317,  4419,  2925,  2325,  2926,  2327,  2874,
   -3226,  2451,  2331,  2332,  2333,   623,  5134,  2797,  5136,  2442,
    2339,  5139,   733,  1693,  1694, -3164,  1324,  3407,  5144,  5145,
    2957,  2871,  3015,  3423,  3016, -3230,  2053,  4329,  1695,  1950,
    1696,  3575,  3575, -2851,  3078,  3575,  3575,  4783,  2874,  2214,
    4182,  3575,  3575,  3254,  3026,  1416,  3027,  2874,  3604,  4542,
    3605,  4124,  4942,  4125,  1695,  4150,  1696,  4151,  4469,  4540,
    4156,  3045,  4157,  5533,  1695,  4196,  1696,  4197,  1313,  2874,
   -1951,  2532,  4377,  1668,  3900,  2429,  1690,  4541,  2160, -2229,
    -118,  1687,  -118,  1205,  2879,   833, -3247,  2366,  1689,  2740,
    2915,  2886, -3229,  2916,  4942,  2874,    68,  1239,  4784,  1697,
    -264,  1695,  2420,  1696,  2927,  1693,  1694,  2160,  1697,  1587,
    4942, -3227,  4751,  4525,  4942,  4942,  1695,  1772,  1696,  1777,
    5039,  3431,  2740,  1780,  1785,  2928,  1695, -3228,  1696, -2722,
    1337,  4771,  5734,   672,  4774,    68,  5073,   790,   775,    68,
    2851, -3163,  3817,  3574,  2874,  2929, -3233,  1697,   834,  4350,
    2908,  3923,  1883,  1814,  5128,  2502,  4224,  4225,  4226,  4227,
    5776,  4353,  2921,  1759,  3924,  4389,  2874,  3659,  4390,   790,
    1809,   790,  3927,  1697,  1366,   790,   790,  -110,  1880,  -110,
    1530,  4391,    31,  1697,  5768, -2708,  2079,  4500,  1695,  3777,
    1696, -2229,  2931,  2466,   774, -2709,  3643,   648,  1768,  1693,
    1694,  5012,   881,  3674,   937,   790,   937,   937,   937, -2708,
    4697,   649,  2822,   937,  4720,   937,  2941,  3339,  4410, -2709,
    1697,   823,  5661,   823,  4461,  3180,  2380,   834,  1917,   807,
    2611,  4338,  4339, -1911,  5534,  1697,  3807,    38,  2740, -2353,
    1700,  3912,  4569,  1864,  4570,  1697,  5233,   775,    40,   648,
    1337,  5625,   775,   775,  3201, -2710,  1701,  3260,  3260,  4238,
     692,  1337,  1337,  4334,  4335,  5699,  4091,  1849,  4469,  1918,
     733,  5227,  3340,  2430,  1587,  1768,  2595,  5141,  1928, -2710,
    1695,  5825,  1696,  1401,  2943,  1702,  3636,  2947,  1693,  1694,
    3411,  1703,   775,  1941,  3434,  1942,  2725,  1693,  1694,  2462,
    2001,  3412,  2614,  5726,  5727,  2568,  4775,  1697,  2062,  1822,
     808,  1693,  1694,  1954,  1768,  1739,  2697,  2720,  5130,  5577,
    1693,  1694,  2636,  2637,  1257,  2035,  1693,  1694,  1704,  2645,
    2646,  2647,   775,  1977,  1693,  1694,  4469,  5662,  3666,  1687,
    5346,   809,   810,   811,  2036,  2518,  1689,  1955,  1956,  4409,
    1247,  2014,  2000,  1401,  2014,  2014,  4841,  3408,  3287,  3288,
    4940,  2802,   812,  3153,  2934,  3708,  2826,  2020,  4643,  1906,
    2699,  3837,  4856,  4857,  1695,  4934,  1696,  5535,  2689,  5769,
    1922,  4742,  3656,  2721,  1495,  2028,  2029,  4567,  1379,  3961,
    2441,   113,  2040,  5770,   881,  3938,   111,   649,   135,  1697,
    4935,  5804, -1911,  5309,  1878,  1325,   775,  3425,  2948,  1352,
     879,  3668,  3409,   681,  2955,   790,   775,  5754,  1693,  1694,
    1287,  5777,  3535,   781,   775,  3438, -3071,   775,  2829,  2830,
    2482,  3081,  3082,  1693,  1694,  2472,   824,   775,   692,   935,
     108,  2715,  3928,  3753,   775,  2080,  2097,  1715,   937,  5696,
    2440,  3252,  3710,  4542,  5040,  5637,  2107,  3253,  4544,  2725,
    3682,  2803,   790,  1695,  1841,  1696,   790,   775,  1693,  1694,
    4757,  3414,  1695,  2831,  1696,  4514,  4515,  4516,  4517,  3105,
    4923,  4924,  4925,  3109,  1504,  2053,  1695,   935,  1696,  3779,
    2726,   790,  3346,  1697,   790,  1695, -3164,  1696,  3676,  4330,
    2711,  1695,  2861,  1696,  1850,  2862,  3134,  2863,  1288,  1695,
    4366,  1696,   733,   167,  2171,  5412,  2223,  2865,  3675,  2719,
    3700,  1167,  1881,  2698,   936,  4942,  2864,  3865,  5454,  4785,
    3451,  5213,  2081,  2198,  2082,  2067,  3630,  1142,  5620,   775,
    1509,  5014,  3780,  1716,  4524,  5016,  1693,  1694,  3338,   695,
     935,   935,  3496,  3610,  3611,  1693,  1694,  5767,  3625,  3962,
    3144,  2827,  3146,  5717,  5735,  3603,  5721,  3606, -1911, -2229,
    2967,  1740,   936,   113,  2810,  -606,  3151,  4538,  4303,  2975,
    5638,  1687,  1697,  3660,  1281, -2550,  3452,  1395,  1689,  3158,
    3159,  1697,  1167,  1695,  4539,  1696,  1693,  1694,  1851,  1934,
    1693,  1694, -1362,  4239,  2715,  1697,  2712,  5149,  1695,  3661,
    1696,  2866,  2797,  1852,  1697,  1879,  3216,  3407,  2977,   888,
    1697,  5355,  3347,  2895,  2083,  3978,  5138,  1823,  1697,  1587,
    2935,   649,  1693,  1694,  1353,   936,   936,  2372,  5902,  4758,
    1546,  3216,   775,  1695,  2980,  1696,  5334,  4568,  3676,  5339,
    5340,   775,  2691,  2726,  2981,   697,  1693,  1694,  3711,  2381,
    2576,  3963,   775,  2519,  3676,  3676,  3053,  5697,  4944,  2974,
    1920,  1693,  1694,  2358,  2412,  2503,  1842,  2505,  2507,  2508,
    2509, -2229,  5463,   649,  5465,  4539,  3424,  2515,  1496,   790,
    4743,  2982,  3838,   113,   172,   173,  4304,  2555,  2367, -3071,
    1693,  1694,  2084,  2483,  2530,  5837,  2983,  3876,   879,  3980,
    3323,  1505,  1697,  2318,   665,  2319,  2986,  3986,  5771,  4943,
      68,  1695,  3022,  1696,  1693,  1694,   790,  1697,  2417, -2729,
    1695,  4942,  1696,  4942,  4682,  4683,  3039,  3835,  2434,  2134,
    5620,   937,  2473,  5413,  5414,  5567,  4525,  3758,  5353,  5085,
     790,   790,  2135,  2199,  4571,  4936,  2474,  1693,  1694,  4777,
     790,  2467,  1697,  1693,  1694,   938,   172,   173,  1510,  5394,
     790,  1695,  1935,  1696,  1266,  1695,  5348,  1696,  2987,  5248,
    5596,   938,  4552,  4367,  2494,  1759,  3217,  1190,  1389,   168,
     781,   775,   781,   781,   781,   781,   775,   790,   775,  5341,
     688,   689,   781,  2641,  2644,  4759,  5086,  1695,  5581,  1696,
    2136,  3217, -1017,  3430, -1017,   735,  5270,  5338,  2529,   781,
    2876,   790,  1802,  1351,  3349,  2535,  5455,  3098,  1693,  1694,
    2577,  1695,  3126,  1696,  1855,  3127,  5876,  3128,   169,  5031,
    1697,  2032,  1205,   775,  4474,  5415,  1695,  3130,  1696,  1697,
    5460,  5531,  3681,  2602,   775,  2692,  3129,  1396,  3969,  4258,
    5032,  3587,  4257,  1693,  1694,   775,   703,  2085,  1693,  1694,
    2988,  4974,   889,  1693,  1694,  1695,  3588,  1696,  4305,  3087,
    4889,  4802,  4802,  5660,  2164,  5212,  1856,  4991,   881,  4540,
    1697,  4993,  4994,  2630,  1697,  1693,  1694,   823,   736,  1695,
     879,  1696,  2634,  4637,  2453,   790,  3218,  4541,  3727,   761,
    2112,  3166,  4617,  1205,  1705,  1706,  1707,  2454,  3215,   775,
    3112,  5416,  1337,   823,  2616,   935,  1697,  2035,  1337,  4234,
    4235,  3218,  1695,   890,  1696,  2685,  5470,  1530,  1695,  4530,
    1696,  2677,  4475,  1337,  4243,   790,  2036,   762,  4809,  2014,
    1697,  5256,   790,   790,   790,  5600,  3847,  3848,  5661,   775,
    3849,  3850,  3851,  5342,  3006,  1697,  1512,  5087,  1913,  4380,
    1913,  3197,  5395,  2721,   775,  2136,  2085,  1693,  1694,  1803,
    2523,  1693,  1694,  4998,  5877,   775,   775,  2710,  4920,  2720,
    3485,  1693,  1694,   790,  1697,  2085,  1693,  1694,   738,  5407,
    2137,  1693,  1694,  1695,  3245,  1696,  4876,  3246,  3979,  3272,
     936,  3251,   938,  5456,   938,   938,   938,  4598,  1697,   688,
     689,   938,  2320,   938,  2524,  2321,  1397,  3493,  3493,  3493,
    5661,  4000,  4001,  4002,  4003,  2654, -1362,  2655,  1695,   790,
    1696,  5035,  1276,  1695,  1398,  1696,  2724,  3338,  1695,  4795,
    1696,  1697,  4270,  3011,  3049,  2015,  2165,  1697,  2015,  2015,
    3289,   775,  3014,  5704,  3761,  2749,  2803,  2802,  3765,  5423,
    1695,  3414,  1696,  5662,  2938,  1709,  2117,  3413,  1915,  5190,
    5795,  5796,   775,  2113,  2014,  3021,  5601,  4598,  3982,  1337,
    4618,  3032,  3655,  3113,  4576,  4577,  4578,  2942,  4581,  1455,
    2060,  2818,  4381,   763,  1763,  2820,  4454,  2686,  4796,  4599,
    2164,  3652,  3653,  1802,  1693,  1694,   782,   775,   775,  3985,
    4763,  3345,  1697,  4764,  2834,  4195,  2422,  4198,  1980,  3324,
    1277,  2843,  2843, -1017,  2843,  2843,  3667,  4600,  1693,  1694,
    1724,  1725,  1726,  1727,  2164,  5662,  1559,  1560,  1561,   790,
    1693,  1694,  1695,   775,  1696,  2488,  1695,  1697,  1696,  2525,
    2423,   783,  1697,   775,  5602,  2455,  1695,  1697,  1696,  5490,
    2882,  1695,   755,  1696,  5526,  2191,  1695,  2061,  1696,  4599,
    2890,   853,  2442,  3497,  1278,  1710,  -704,  3407,  2619,  1697,
    2079,  5588,  1693,  1694,  2489,  1326,   935,  5855,  4122,  3447,
    1711,  1693,  1694,  1981,  1612,  3627,  2191,  4603,  1693,  1694,
    1749,  1458,   785,   935,  1982,  1693,  1694,  5865,  1693,  1694,
    4797,  1983,  1298,  4765,  3476,  3346,  4455,  3477,  1916,  3478,
     113,   688,   689,  4123,  4601,  2919,  2424,  2204,   692,  3480,
    3325,   800,  2620,  3676,  5104,  1764,  5105,  3326,  3479,   935,
    1693,  1694,  3427,  1984,  1370,  3327,   938,   935,   935,   935,
    3064,   881,  1327,  3522,  5691,  5692,  5773,  3222,  2264,  2053,
    1803,  1697,  1530,  3609,  3527,  1697,  1445,  1712,  3676,  1693,
    1694,   936,  2165,  4542,  4802,  1697,  3485,  2191,   786,  1695,
    1697,  1696,  1464,  5462,  4798,  1697,   721,  5608,   936,  1693,
    1694,   155,  5255,  -822,  4601,  4766,  1693,  1694,  1818,  1299,
    1300,  4136,  2715,  1695,  1985,  1696,  2165,  2425,  2166,  1869,
    4138,  2658,   733,   805,  1876,  1695,  2659,  1696,  3328,  4865,
    2660,   775,  3561,  3481,   936,  3799,  3642,   775,  1819, -2715,
    5668,  3283,   936,   936,   936,  1986,  1693,  1694,   814,  2267,
    2490,  1298,  2085,  3023,  5135,  3347,  4889,  1693,  1694,   754,
    3062,  4153,  2191,  3572,  4409,  4170,  2053,  1695,  3063,  1696,
    5147,  1693,  1694,  2191,   722,  5445,  1695,  3807,  1696,  4851,
     937,  3126,   692,  1695,  3127,  1696,  3128,   755,  3141,  3329,
    1695,  1687,  1696,  1695,   879,  1696,  3130,  4171,  1689,  2112,
    3145,   827,  3292,  5446,  1351,  3129,  1693,  1694,  1697,  5156,
    2661,  5158,  3800,  2412,  3618,  3807,  3807,  1328,  5863,  5864,
    5439,  5005,  1693,  1694,  2283,  1695,  4852,  1696,   937,  3348,
    3619,  4698,  1697,   816,  2944,  2297,  5802,  5831,  1299,  1300,
     790,   790,   775,   828,  1697,  2208,   790,  1587,  5801,  2080,
    2843,  2843,  2843,  2843,  1695,  4791,  1696,  1828,  3099,  3100,
    5447,  1759,  4162,  2945,  2392,   790,   844,  2867,  5290,  1301,
    5593,  1179, -2170,  4792,  1695,  4574,  1696,  2209,  2046,  1184,
    4528,  1695,  1185,  1696,  1186,  1119,  1697,  2968,  2058,  3123,
    4163,   937,   937,  2210,  1187,  1697,  2063,  4853,  5593,  3140,
   -2170,  4251,  1697,   781,   895,  1693,  1694,  1121,  5379,  1697,
    5381,  3142,  1697,  3807,  3181,   781,  2091,  1226,  2091,  3147,
    2971,  1695,  3243,  1696,  1136,  4690,  2973,  1239,  3248,  3250,
     658,   935,  1695,  5832,  1696,  1337,  2081,  2211,  2082,  1337,
    4586,  4587,   775,  4659,  1697,   935,  1695,  4661,  1696,   938,
    4296,  1693,  1694,  1530,  1693,  1694,  1734,  3349,  1864,  3169,
    4814,  1767,  3150,  5525,  1241,  2212,   790,  3184,   775,   113,
    1693,  1694,  2113,  1697,  2393,  1693,  1694,  3047,  1458,  2720,
    1252,  1695,  1709,  1696,  1743,  4513,  5833,  1138,  1188,  2394,
    1536,  2976,   823,  1697,  2041,  1144,   775,  1695,  1610,  1696,
    1697,  1237,  3485,  3211,  1693,  1694,  3214,   775,  1693,  1694,
    3639,  1257,  4609,  4610,  3700,  4081,   936,  3350,  1401,  5393,
    1262,  3062,  3818,  2001,  1265,  4220,  2984,  4082,  2083,  4686,
     936,  2985,  3238,  3239,  3240,   775,  2991,   781,  4656,  4625,
    1697,  3414,   775,  3249,   781,  4866,   775,  4867,  1537,  2814,
    2874,  1697,   775,  2015,  1693,  1694,  1271,  2208,  2992,  3205,
    3206, -2398,  2213, -2398,  4652,  1697,  2395,   775,  2930,  1693,
    1694,  3270,  2802,  5815,  4503,  2000,  3275,  3413,  4680,  5011,
    1695,  5074,  1696,  2930,  4868,  3595,   688,   689,  5075,  2209,
    5420,  1337,  1710,  1274,  5023,  3171,  3172,  4256,  1693,  1694,
    1697,  1283,  3300,  1693,  1694,  3801,  2084,  1711,  1285,  3304,
    3305,  1693,  1694,  4869,  2326,  1292,  1697,  1538,  3939,  3456,
    5829,  5829,  1308,  2335,  5846,  4253,  1695,  5848,  1696,  1695,
    1713,  1696,   935,  4699,  2346,  5112,  3207,   790,   688,   689,
    2996,  2050,  2051,   775,  2997,  1695,  5113,  1696,  1294,  3802,
    1695,  3457,  1696,  5076,  2998,  1693,  1694,   830,  5862,  3004,
    1693,  1694,  1594,  4826,  3005,  1693,  1694,   879,   847,  3429,
    1693,  1694,  5852,   754,  4091,  2090,  1312,  3803, -2323,  1695,
    1609,  1696, -2711,  1695,  1712,  1696,  1613,  1614,  2015,  2932,
    4091,  2262,    31,  4538,  1829,  1539,  3173,  3131, -2717,  1697,
    2098,  1978,  1693,  1694,   958,  3417,  4095,  3419,  4549,  1314,
    4539,  3458,   935,   775, -2719,   668,   775,   936,  4095,   790,
     675,   790,   790,  1693,  1694,  4873, -2731,  1152,  1319,  1695,
    4875,  1696,  1693,  1694,   790,  2715,   965,  2843,  1830,  3459,
    1831,  1321,  4091,  4091,  1695,  1697,  1696,    38,  1697,  4870,
   -2739, -2740,  1772,   113,  1772,  4376,  2874,  5906,    40,  4091,
    2649,   935,  1357,  2504,  1697,  1933,   937, -2741,  2510,  1697,
    2512,  1938,  1939,  1695,  3804,  1696,  5052,  3009,  1695,  2725,
    1696,  2972,  4091,  1883,  3735,  4871,  1695,  1322,  1696,  1153,
   -2744,  2451,  2451,  2451,  2451,  1323,   977,   936,  1697,  1693,
    1694,  3010,  1697,  4130,   790,  1389,   790,  1306,  1307,  1393,
    1310,  4532,  1311,  3012,  1395,  2544,  4538,  4537,  1408,  2978,
    4554,  2979,  2112,  1427,   989,  2019,  2554,  4558,  2021,  2021,
    1695,  1167,  1696,  4539,  1832,  1419,  3460,  2567,  4471,  2989,
    1695,  1883,  1696,  4518,  4519,  1695,   936,  1696,  1697,  1425,
    4173,  4693,  2194,  2195,  4904,  3019,   800,  4194,  1715,  1426,
    2995,  2205,  1883,  1697,  5046,  5047,  2999, -2323,  1883,  5065,
    4791,  3033,  2053,  2053,  2053,  2053,  1432,  1695,  4117,  1696,
    1435,  4120,  3827,  1833,  4300,  3607,  5687,   733,  5689,  5690,
    1709,  1439,  1697,  2265,  3000,  2268,  1883,  1697,  1695,  3001,
    1696,  1883,  3007,  3688,  1883,  1697,  3436,  1695,  3437,  1696,
    2281,  2282,  2284,  4121,  1446,   723,   724,  1447,  4233,  2285,
    2286,  1007,  3585,  3488,  2715,  3489,  2298,  3943,  1458,  3945,
    3946,  2639,  1834,  4246,  1226,  3951,  1337,  1337,  3123,  3693,
    1226,  3694,  4126,  3959,  1475,  1530,  1351,  1477,  3966,  1697,
     113,  2725,   725,  4270,  1716,  3613,  1687,  1351,  1351,  1697,
    1360,  1486,  4131,  1689,  1697,  4247,  1483,  4550,  4036,  4132,
    1154,  1155,  1717,  2726,  1695,  4691,  1696,  3769,  1768,  3770,
    1156,   775,  1913, -2170, -2170,   790,   790,  2843,  5759,  5760,
    1488,  3979,  5763,  1485,   726,  2113,  1697,  3830,  1494,  3831,
    1710,   790,  1860,  1497,  4144,  4540,  2979,   113,  1361,  4133,
    5544,  2112,   111,  1362,   135,  1711,  4147,  1697,  1883,  4154,
    4134,  4155,  1835,  4541,    84,  4248,  1697,  1498,  3750,  1205,
    1981,  3307,  3791,  2745,  4135,  1182,  4161,   937,  1883,  4403,
    4165,  1982,  4166,  4481,  1836,  4482,   688,   689,  2668,  1500,
     172,   173,  1363,  4249,   937,  4530,   108,  2358,  1499,  3716,
    2129,  2130,   172,   173,  2131,  5814,  1715,  1502,  3701,  4143,
   -1051,  1540,  5038,  1401,  1401,  1401,  1401,  4953,  1508,  1693,
    1694,   113,  1531,  3702,  4953,  4149,  1550,  1547,   938,  3482,
     937,  1541,  1712,  1697,  3717,  4404,  2715,  1548,   937,   937,
     937,  1549,  1715,  2842,  2842,  1554,  2842,  2842,  1555,  3847,
    3848,   688,   689,  3849,  3850,  3851,  1556,  1772,  3189,  1557,
    4543,  4551,  2946,  3493,  4555,  2856,  2349,  2350,  4540,  1226,
    1605,  4559,  4999,  3190,  1558,  1512,   938,  1713,  1562,  2412,
    1772,  2669,  1564,   781,  5480,  2726,  4541,  3413,   775,  4569,
    4250,  4570,  1205,  4687,  4688,  4098,  3501,  1565,  4127,   775,
    1566,  4104,  1716,   775,  1567,  2965,  1401,  4109,  4152,   790,
    1568,  3502,  1986,   727,  4665,  2868,  1883,  2417,  4530,  4909,
    1717,  4910,  4705,  2112,  2113,  1653,  4911,  1157,  4912,  3839,
     728,   790,   790,  4913,  4989,  4914,  4992,  3503,  1716,   938,
     938,  5006,  1569,  1883,   935,  5152,  1570,  -821, -3308,  3504,
    5021,  5029,  5022,  1883,  4158,   729,  1717,  4159,  5481,  1571,
    3334,  3823,  3824,  3825,  3826,  1792,  3828,  3829,  1572,  3505,
      68,  1573,  5522,  4160,  1693,  1694,  1718,  1719,  4168,  1574,
    1575,   790,  5482,  5042,  5269,  5043,  3131,  5056,  3732,  5057,
    2765,  2766,  1576,  1579,  1695,   730,  1696,  3931,  5067,  1589,
    5068,  3506,  5103,  3507,  3770,  2778,  5223,  4169,  5224,  5545,
    1659,  4172,  1718,  1719,  3947,  3948,  5546,  3950,  1590,  3952,
    3953,  3954,  3955,  3956,  3957,  3958,  5225,  3960,  5224,   936,
    3965,  5547,  1591,  5195,  3968,  5228,  1592,  5229,  1693,  1694,
    2906,  1226,  1595,  3002,  5211,  2701,  4403,  1729,  5284,  3008,
    4260,  2701,   688,   689,  5483,   775, -2323,  4176,  1730,  5371,
     941,  5372,  2765,  2766,  4930,  1596,  4933,  1693,  1694,  5389,
    1597,  5306,  4189,  5421,  2834,  5422,  1715,  2778,  4596,  2029,
     790,   790,   790,   790,  1189,  4949,   775,  5425,  1598,  5422,
    1599,  2702,   935,   935,  1600,  4954,  2113,  2702,  5443,   958,
    3770,  3064,  4404,  2780,  2781, -1768,  5004,  4959,  1601,  2451,
    2451,  1602,   937,  1697,  5010,  4386,  5444,  4616,  3770, -1767,
    5557,  1793,  5422,  1603,  4977,  3189,   937,  1604,   963,  1693,
    1694,   965,  2703,  1158,  1159,  1160,  1161,  4826,  2703,  4542,
    3190,  1606,  4372,  4373,  4374,  1607,  3718,   969,   970,  1695,
    5598,  1696,  5599,  5628,  1749,  5629,  1608,  1731,  5019,  3508,
    1615,  5548,  2842,  2842,  2842,  2842,  2053,  5484,  5020,  1616,
    1617,  3509,  1716,  5024,  5549,  2780,  2781,   936,   936,  1794,
    1732,  5639,  4932,  5640,  1618,  1693,  1694,  4145,  1795,  4666,
    1717,   977,  1619,  3719,  5550,  1620,  3618,  4357,  4358,  1621,
    1622,  4359,  4360,  1623,  1301,  5025,  4405,  4361,  4362,  1624,
     983,  5402,  1625,  1695,  -821,  1696,  1628,  1179,   988,   989,
    5658,  4174,  3831,  1629,  1630,  1184,  5396,  1631,  1185,  1796,
    1186,  2149,  5682,  1632,  5043,  5459,  4492,  4495,  1633,  4498,
    1187,  5758,  1695,  4712,  1696,  3132,  1718,  1719,  5762,  5764,
    5422,  5422,  1634,  1637,  3157,  2704,  5765,  3720,  5422,  1638,
    4210,  2704,  4542,  5783,  1639,  5784,  -823,  2705,  1697,  4384,
    5792,  4323,  5793,  2705,   790,  1640,  3510,  5374,  3511,  1641,
    3186,   790,   790,   790,   790,  1713,  4231,  4230,  1642,  1722,
    1723,  1724,  1725,  1726,  1727,  2725,  5812,  4017,  5422,  1643,
    1715,  3721,  4241,  4242,  1695,  2014,  1696,  1005,  2936,  5251,
    5813,  2939,  5422,   937,   938,  1006,  1007,  1008,  1226,  5816,
    5819,  5422,  5043,  4626,  2902,  -823,  5847,  2951,  5422,   740,
    4406,  4262,  1697,  5551,  1188,  4627,  2790,  5893,  1644,  5894,
    2358,  2969,  1530,  1797,  4276,  1645,   113,  3241,  3189,  1646,
    1647,  4267,  5558,  1648,  3247,  4628,  5561,  1649,  1351,  1650,
    1695,  1697,  1696,  3190,  1351,  1651,  1652,  5317,  5318,  1798,
    5320,  2706,  1654,  1655,   790,  4810,  1656,  2706,  1735,  1351,
     775,   775,  4386, -2323,  1657,  1658,   781,  1737,  4790,  4629,
    4950,  1401,  1401,   937,  1660,  1661,  1716,  4801,  1662,  1663,
     775,   775,  3403,  3625,  1664,  1665,  4527,  4345,  4531,  1666,
    4098,  1669,  4098,  4966,  1717,  1670,  1673,  4969,  1674,  5613,
    4098,  1675,  1676,  1697,  5485,  4976,  1677,  4560,  1678,  4527,
    1679,  3512, -1051,  5262,  1680,  1736,  4098,  -823,  4407,  1733,
    2715,  5263,   937,  2707, -2573,  1715,  4098,  1752,  1741,  2707,
    4572,  1693,  1694,  1742,  1753,  1478,  4580,  3722,  3723,  3724,
    1754,  4650,  1755,  1762, -2601,  4098,  4527,  4527,  4588,  4589,
    1718,  1719,  1790,   688,   689,  1791, -2572,   741,  4630,  1697,
    5402,  1693,  1694,  4663,  5380,  1787, -2598, -2596,  5659,  2726,
    1693,  1694, -2600, -2595,  4605,  1720,  1721,  1722,  1723,  1724,
    1725,  1726,  1727,  5520,  1715, -2599,  5480,  1693,  1694,  4926,
    5632,  -823,  1479,  5496, -2593,  1480,  1807, -2597,  1810,  1361,
    1824,  2791,  5780,   935,  4472,  1351,  1825,  2112,  3426,  1826,
    1827,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  3513,
    5497,  1716,  1481,  4456,  1848,  4631,  1847,  1853,  1859,  2842,
    1482,  1693,  1694,  1865,  2238,  1871,  5576,  1883,  4470,  1717,
    3476,  1914,  1924,  3477,  1926,  3478,  1930,  3549,  1799,  1936,
    1937,  1943,  1944,  1948,  1946,  3480,  3551,  1952,  1966,  5450,
    5481,  5451,  5452,  1967,  3479,   938,  1968,  1978,  3514,   172,
     173,  1989,  1990,  3553,  1993,  2003,  2006,  4406,  2017,  4932,
    1716,   935,   938,  2016,  2032,  4386,  2038,  2042,   936, -1051,
    4499,  3515,  2044,  2047,  4502,  1718,  1719,  4504,  1717,  2048,
    1693,  1694,  4148,  2052,  2239,  2064,  1695,  2068,  1696,  2075,
    2092,  4806,  2098,  4808,   790,  4137,  4811,  3483,   938,  4815,
    2102,  5641,  4818,  4819,  1800,  1226,   938,   938,   938,  2104,
     688,   689,  1801,  2106,  2108,  5498,  1695,  2116,  1696,  5499,
    2123,  2122,  4632,  1980,  4633,  1695,  2125,  1696,  2126,  3481,
    2127,  2148,  1530,  2157,  1718,  1719,  5483,  2170,  4858,  2173,
    2172,  2174,  1695,  5480,  1696,  2177,   936,  1693,  1694,  2240,
    2178,  2241,   739,  3619,  2183,  2180,  2242,  2014,  2014,  5632,
    2113,  5527,  5528,  2181,  3309,  4407,  2190,  2191,  3500,  5665,
    2790,  2200,  5672,  2207,  2218,  5905,  4833,  4835,  4837,  2222,
    4595,  2250,  2261,  4842,  4843,  2262,  1695,  2263,  1696,  4848,
    2272,  2227,  2228,  2229,  2230,  2276,  3975,  4855,  1981,   740,
    2279,  4860,  2280,  2302,  2334,  1697,  2344,  2340,  5264,  1982,
    2354,  5265,  4874,  5728,  2365,  2369,  1983,  5481, -1081,  2387,
    5399,  2243,  2391,  2418,  2419,  1720,  1721,  1722,  1723,  1724,
    1725,  1726,  1727,  2444,  2443,  1697,  2445,  5261, -3045,  2448,
     941,  5482,  2449,  2457,  1697,  2231,  2232,  2233,  1984,  5484,
    2461,  2464,  2468,  3638,  3132,  1695,  2498,  1696,  2500,  2842,
    2501,  1697,  2521,  5129,  2244,  2536,  5132,  5133,  2537,  2538,
    2539,  2541,  4655,  5500,  2715,  5665,  4634,  4635,  2542,   958,
    4387,  2543,  5672, -2182,  2558,  2562,  2561,  2569,  2570,  4664,
    5301,  2571,  2572,  2579,  2589,  3791,  2580,  2590,  2593,  2234,
    2235,  2591,  4231,  4230,  2592,  1697,  2594,  5788,   963,  1985,
    2596,   965,  2597,  5483,  2603,  4210,  2604,  2607,  5619,   790,
     790,  2608,  1695,  5887,  1696,  4685,  4684,   969,   970,  3476,
    2612,  2617,  3477,  2624,  3478,  5826,  2628,  5897,  2648,  2650,
    1986,  1182,  1759,  5887,  3480,   937,  2666,   741,  4983,  5897,
    2651,  2358,  1190,  3479,  2245,  2791,  3310,  2664,  2652,  5207,
    2653,  2112,  3701,  4702,  4813,  2246, -2135,   113,  4710,  2656,
    2236,   977,  2665,   935,  1697,  5665,  5672,  2674,  2678,  2681,
     938,   742,  2679,  2682,  2688,  2690,  2693,  2694,  4388,  2700,
     983,   935,  2723, -2584,   938,  2738,  4719,  2746,   988,   989,
    2747,  3476,  3311,  2751,  3477,   775,  3478,  2752,  4470,  2754,
     775,  2755,  2792,  1530,  2787,  3839,  3480,  2804,  2807,  2808,
    3755,  2812,   761,  1363,  2816,  3479,  5484,  5788,  2819,   154,
    2822,  1351, -1422,  2825,  4636,  1351,  2837,  2832,  3481,  1122,
    3270,  1697,  2237,  5387,  2857,  2880,  1123,  2883,  2881,  2417,
    4917,  1722,  1723,  1724,  1725,  1726,  1727,  2898,   936,  4899,
     762,  2900,  1124,  2903,  2901,  2913,  4778,   790,  2920,  2015,
    2912,  4938,  1125,  1126,  1127,  2933,   936,  2914,  4098,  1226,
   -1422,  4470,  1128,  4849,  3312, -1422,  2917,  1005,  4807,  2918,
    2937,  4951,  2930,   937,   937,  1006,  1007,  1008,  4710,  2940,
    4956,  3041,  4823,  3025,  2949,  5140,  4958,   155,  2950,  4822,
    3481,  2358,  2952,  2953,  3059,  2954,  4970,   775,  2793,  4844,
    2958,  2966,  2970,  4840, -1422,  4978,  4979,  2994,  -848,  4845,
    4846,  2990,  2993,  3003,  2113,   790,  4710,  4862,  2238,  4863,
    4864,  3013,  3017,  3018,  3020,  4861,  3313,  1727,  3024,   935,
    3037,  5496, -1558,  5496,  3068,  3046,  4710,  3052,  3061,  3075,
   -1737,  3080,  4470,  4882,  1635,  3314,  3315,  1667,  4893,  4892,
    3316,  3317,  3318,  5511,   781,  1671,  3084,  3086,  5497,  4903,
    5497,   938,  3088,  3089,  2412,  3095,  5869,  1351,   113,  5333,
    1772,   152,  3103,  5502,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  3104,  3110,  3111,  3114,  5612,  3117,  2239,  3115,
    3118,  3116,   113,  5262,  3139,  3148,   763,   111,  4008,  4918,
     625,  5263,  3119,  1129,  3152,  3163,  3493,   172,   173,   172,
     173,  3160,  3195,  3164,   936,  3194,   790,  1130,  3319,  3223,
    1980,  3225,   790,  3226,  3227,  3229,  3230, -1051,  3280, -1051,
    1189,  3262,  3266,  3255,  1721,  1722,  1723,  1724,  1725,  1726,
    1727,   938,  3286,  3290,  2208,  4492,  3296,  4495,  3293,  4498,
    3297,  4964,   935,  2240,  3298,  2241,  3299,  3301,  3302,  3303,
    2242,  3354,  3357,  5485,  3360,  3364,   626,  3320,   688,   689,
     688,   689,  3370,  5498,  3394,  5498,  2209,  5499,  3367,  5499,
    3371,  2790,   935,  3372,  3373,  3402,  2227,  2228,  2229,  2230,
     938,  3374,  3801,  3395,  3375,  1981,  3376,   172,   173,  3377,
    3378,  5480,  3379,  5480,  3380,  3381,  1982,  3382,  3383,  3384,
    3418,  4932,  3385,  1983,  3386,  4983,  3387,  3388,  1131,  3389,
    3390,   743,  3391,  -823,  5711,  2243,  4384,   153, -2323,  3392,
    3420,  3393,  3421,  3443,  3433, -2135,  3802,   936,  3439,  -167,
    2231,  2232,  2233,  2085,  3444,  1984,  5061,  3424,  3445,  3441,
    3442,  4210,  3449,  3446,  3453,  1132,   627,  3454,  3267,  5748,
    3455,  3461,  3523,  5258,  3803,  3486,  3524,   936,  2244,  1133,
    3525,  3536,  3537, -3340,  3538,  5481,  3544,  5481,  4472, -1776,
    3557,  2358,  -823,  3598,   635,  2715,   740,  3596,  3599,  4276,
    3583,  3614,  3584,  3615,  2234,  2235,  3631,  3622,   790,  5482,
    3621,  5482,  4470,  3623,  3069,  3189,  1985,  3633,  3637,  3640,
     775,   744,   935,  3644,  3645,  3646,  3647,  3651,  3657,  3658,
    3190,  2483,  5592,   628,  5120,  5095,  2482,  5096,  5555,  5123,
    3679,  5500,  3665,  5500,  3670,  1772,   935,  1986,  2874,  3695,
      40,  2015,  2015,  3707,  3715,  3709,  3736,  3714,   154,  3737,
    5592,  3739,  3743,  3744,  3759,  3752,  3754,  3763,  2245,  5121,
    3760,  3804,  3268,  3764,  3797,  2236,  2791,  3798,  3842,  2246,
   -2084,  5483,  2112,  5483,  3789,  3843,  3844,  3929,  5131,  3933,
    3941,  3942,  3944,  4470,  4710,  4470,  4385,   790,  4470,  3973,
    4710,  3977,  4309,  4310,  -823,  4470,  4470,   936,  5146,  1980,
    4710,  3983,  1980,  3988,   937,  3992,  2817,  3996,  5264,  3997,
    3998,  5265,  1351,  1351,  4005,  4010,  4080,  4084,  4087,  4083,
    5266,   936,  4091,  2792,  4095,  5153,   155,  4099,  2725,  4102,
    4103,  4107,  4164,  4110,   741,  4470,  4111,  2237,  4112,  4710,
    4177,  4710,  4113,  4201,  4175,  4187,  4188,  4193,  4203, -3340,
    4204,  4213,  5501,  4192,  4211,  4214,  4215,  4218,  4217,  4221,
    5160,  4222,  4223,   775,  5555,  3482,  5194,  4236,  -823,  2790,
    4254,  5592,  4240,  4237,  1981,   156,  1886,  1981,   629,  5197,
    4259,  4260,   937,  5203,  5484,  1982,  5484,  4261,  1982,  5901,
    1226,  4263,  1983,  4264,  4527,  1983,  4265,  4271,  4266,  4279,
    4277,  4098,   113,  4297,   630,  4298,  5408,   777,  4299,  5219,
    4302,  4098,  4308,   935, -1864,  4572,  4321,  5241,  4343,  4351,
    4580, -1869,  4348,   157,  1984,  4352,  4355,  1984,  4365,  2793,
    4356,  4370,  4386,  2238,  4383,  3403,  4399,  4336,  4401,  4402,
    4340,  4411,  4413,  4414,  4430,  2113,  3272,  4425,  4435,  4433,
    4436,  4437,   631,  4440,  4439,  4448,  4477,  5242,  4449,  4450,
    4451,  5095,  4386,  4485,   932,  4459,  1116,  4505,  4506,   172,
     173,  4509,  4280,  2715,  4512,  4523,  4521,  5898,  4535,  4281,
     932,  3400,  4530,  4557,  4579,  1985,  1180,  1235,  1985,  4564,
    4582,  4592,  4593,  1116,  4604,  4282,  4608,  4611,   936,  4619,
    4612,  4620,  1886,  2239,  4657,  4283,  4284,  4285,  3029,  4182,
    4667,  2427,  1116,  3777,  4669,  4286,  1986,  4670,  5277,  1986,
    4673,  4983,  2726,  4674,  4677,  4704,  4703,  4655,  4711,  4716,
    4717,  4710,  4712,   938,  4718,  4721,  4733,  3869,  4745,  4746,
    5289,  5289,  5291,  -252,  4749,  4470,  4753,  4769,   -72,  2414,
    4780,  5502,  4782,  5502,  2791,  4755,  4781,  5095,  4794,  4792,
    2112,  4812,  4816,  4886,  4817,  4889,  4894,  4897,  2240,  4900,
    2241,  4901,  4907,  4908,   158,  2242,  4915,  3270,   159,  3270,
    4916,  4921,  4919,  4929,  4947,  4585,  4957,  4960,  4944,   632,
    4984,  4972,  4987,  4988,  4989,   172,   173,  4990,  5000,  5330,
    5007,  4992,  4995,  4996,  5008,  5015,  5335,   633,  5009,  4470,
    4470,  1887,  5018,  4470,  5013,  5027,  5028,  4470,  5030,  5347,
     160,  5432,   648,  5036,  5044,  2358,  5050,  5049,   775,  5053,
    5058,  1116,  5063,  5054,  4710,  5064,  5098,  5089,  5091,  5107,
    2243,  5485,  5097,  5485,  5108,  5109,  5117,  5100,  5102,   634,
     161,  5555,   635,  5110,  5118,  5116,  4287,  2824, -3340,  5119,
    5065,  5122,  5125,  5126,  5127,  5142,  5143,  5148,  5159,  5151,
    4288,  5154,  3927,  5200,  3482,  5068,  5217,  4387,  1226,   636,
    5196,   938,   938,  2244,  5218,  5198,  5220,   637,  5231,  5221,
    5232,  5244,  5245,  5246,   937,   775,  5249,  5247,  5257,  5260,
    1116,  5271,  5253,  5274,  5285,  5283,  4964,  5286,  5384,  5293,
    5254,   932,   937,   932,   932,   932,  5294,  5297,  5298,  5300,
     932,  5302,   932,  5304,  5314,  5319,  5306,  5321,  5322,  5324,
    5326,  5328,  5331,  2113,  5336,  5352,   935,  1887,  5357, -2713,
   -2712, -2716, -2720, -2721, -2723,  4795,  3482,  5377, -2725, -2726,
   -2727,  5375, -2732,  1116, -2733, -2734,  4289,  5385,  1116, -2738,
    5388,  5360,  5364,  5289,  5392,  5397,  1888,  5403,  5398,  5405,
    5404,  4290,  5407,  2245,  5418,  5430,  5409,  5419,  5424,   113,
    1889,  5441,  1890,  5095,  2246,  4388,  5468,  5426,  1116,  5469,
    5478,  5453,  5509,  5472,  5458,  5512,  5493,  5513,  1116,  5514,
    5493,  5523,  5530,  5539,  5540,  4470,  5543,  5560,  4291,  3875,
    4470,  5569,  5571,  1891,  5572,  5597,  5573,  5574,  5471,  5603,
    5582,   936,  4292,  5241,  5605,  5584,  5585,  5607,  1892,   775,
    5609,  5611,  5615,  5610,  5477,  5616,  5617,  5618,  1190,  5626,
    5642,  5508,  5623,  5636,  5646,  5649,  5654,  5657,  5627,  5515,
    5519,  5669,  5674,  5679,  5683,  5684,  5685,  4722,  5688,  5702,
    5710,  1893,  4734,  5242,  5694,  5715,  5703,  5730,  5741,  5752,
     937,  5753,  5757,  4472,  3876,  5761,  5755,  5766,  5800,  1894,
    5774,  3865,  5822,  5807,  5823,  5811,  5538,  1116,  1116,  1116,
    1116,  5824,  1888,  5835,  5850,  5849,  5856,  5838,  5851,  5289,
    5859,  1116,  5861,  5562,  5866,  5870,  1889,  5873,  1890,  5874,
    5888,  3654,  1532,  3967,  5900,  5210,  3193,  5208,  5570,  5868,
    5209,  2412,  1843,  3747,  5493,  5556,  4363,  5303,  5566,  5676,
    5809,  1332,  2043,  4741,  4750,  5578,  5243,  5429,  5226,  1891,
    5440,  5383,  5493,  5390,  5524,  4981,  3204,  2435,  4294,  5677,
    4086,  4511,  4927,  3369,  1892,   932,  2891,  2894,  4597,  2892,
    1895,  5606,  1438,  2893,  2089,  2737,  5428,  1896,  2821,  4831,
    5296,  4462,  5427,   790,  3910,  5150,  4676,  1897,  5273,  4681,
    5037,  3073,  5714,  5410,  5782,  5278,  5858,  1893,  5842,  5860,
    1898,  5656,  3233,   937,  4805,  4460,  5564,  4881,  2358,  5794,
    5634,  4467,  5124,   733,  5292,  1894,  5830,  5693,  5705,  5614,
    4638,  4553,  4591,  5707,  4939,  5712,  4179,  5345,  4945,  4662,
    5845,  1899,  4660,   937,  1900,  4658,   747,   748,  5818,  5817,
    5461,  5798,  5750,  5747,  5327,  5559,  5325,  4955,  4301,  4464,
    1901,  4879,   775,  2625,  1857,  3731,  5678,  5475,  2059,  5709,
    4276,  4276,  3363,  3730,  5344,  2789,   649,  3083,  5493,  5289,
    4007,  5289,  5289,   855,  3450,  3185,   776,  2024,  1359,  4522,
    3686,  5808,  1687,  3602,  1116,  1979,  5695,  1905,  5729,  1689,
    1757,  3788,  4507,  3648,  2023,  4672,  1895,  3560,  3558,  5701,
    5700,  2352,  4671,  1896,  1971,  4206,  2260,   856,  2197,  2673,
    1972,  2670,  1973,  1897,  2415,  1974,  5519,  1976,  5316,  5106,
    4696,  5680,   938,  5055,  3282,  5681,  1898,  5538,  2663,   858,
    2206,  4200,  3786,  2684,  4773,  5723,  5724,  4772,  4199,   859,
     790,  5268,  5635,  5350,  5048,  5259,  3787,  5279,  2018,  5742,
    4776,  1377,   758,  3274,  5493,  3416,  2564,  1899,  2031,   749,
    1900,  5751,  2150,   937,  3448,   860,  5756,  3704,  3429,  5051,
    5060,  5289,  5289,  3821,  4695,  5289,  1901,  4692,  5779,  1249,
    1450,   861,  2815,  3483,  1456,  3154,   862,   937,  1231,  2025,
    3155,  3198,   773,  1234,  3680,  2527,  5351,  2358,  5282,  2615,
     938,  2155,  4526,  5857,  5111,  5867,  5323,  5899,  5903,  1611,
    5789,  3167,   863,  5790,  3600,  4700,  4689,  3669,  1192,  3135,
     790,  3040,  1193,  5493,  5493,  3664,  5841,  3663,  2877,  2632,
    5904,  2456,  1151,  3641,  2147,  5806,  5805,  4371,  1751,  4779,
    5376,  3993,  5810,  3738,  4473,  1282,  3353,  1929,  5289,  3294,
    3295,   767,   751,   752,   753,  1116,  5310,  1116,   932,     0,
    5442,     0,     0,     0,     0,     0,  3306,     0,     0,     0,
       0,     0,     0,     0,     0,  5493,  3332,  3333,   790,     0,
       0,     0,   864,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5069,     0,     0,     0,     0,     0,  5844,   865,
       0,     0,     0,     0,     0,     0,     0,   866,     0,     0,
       0,     0,     0,  5890,     0,     0,     0,     0,     0,  5892,
       0,     0,     0,     0,     0,     0,     0,     0,  1116,     0,
    1116,     0,     0,     0,     0,     0,     0,     0,   867,     0,
       0,  3396,  3397,  3398,  3399,     0,     0,   868,   869,     0,
       0,     0,     0,     0,     0,     0,  1116,     0,     0,     0,
       0,  2358,     0,     0,   937,   790,     0,  1116,  1116,     0,
       0,   790,     0,  1116,     0,  2358,     0,  1116,  1116,  1116,
       0,  2358,     0,     0,     0,     0,     0,  2358,  1116,  1116,
       0,     0,     0,     0,  1116,     0,  1116,  1116,  1116,  1116,
    1116,     0,  1116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1116,     0,  1116,     0,     0,  1116,  1116,
       0,  1116,  1116,  1116,     0,  1116,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1116,  1116,  1116,  1116,  1116,  5161,  1116,  1116,  1116,     0,
       0,  1116,  1116,  1116,  1116,  1116,  1116,  1116,     0,  1116,
    1116,  1116,  1116,  1116,  1116,     0,  1116,  1116,     0,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,     0,     0,  1116,  1116,
    1116,  1116,     0,  1116,  1116,  1116,     0,  1116,     0,  1116,
       0,  1116,  3483,  2139,     0,  1116,  1116,  1116,  2140,     0,
    1116,  1116,  1116,  1116,  1116,     0,  1116,     0,     0,  2141,
       0,     0,   938,  1116,     0,     0,     0,     0,     0,     0,
    1116,  1116,  1116,  1116,     0,     0,     0,     0,     0,     0,
     938,  1116,  1116,     0,  1116,  1116,     0,     0,  1116,  1116,
    1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,  1116,
    1116,     0,     0,  1116,     0,     0,  3857,     0,  3858,  3859,
       0,  2159,     0,     0,  3483,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3860,     0,  3861,     0,     0,     0,     0,     0,
    3862,     0, -1951,     0,  1116,     0,     0,     0,     0,  1116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1116,
    2758,     0,  2032,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3863,     0,     0,     0,     0,     0,
   -1951, -1173,     0, -1951,     0,     0,     0,     0,     0,     0,
       0, -1951, -1173, -1951,     0,     0,     0,     0,     0,     0,
   -1951,     0,  2759,     0, -1951,     0,     0,     0,     0,     0,
       0,   172,   173,     0, -1951,     0,  3864, -1951,  2142,     0,
       0, -1951,     0, -1951,     0,     0,  1116,     0, -1951,     0,
       0,     0,     0,     0,     0, -1951,     0,   937,   938,  2143,
       0, -1951,  2760,     0,  2144,     0, -1951,  3865,     0,     0,
       0,     0,     0,     0,     0,     0,  1116,     0,  1116,     0,
       0,     0,     0,     0,     0,     0,     0, -1951,     0,     0,
       0,     0,     0,     0,     0,  2145,     0,     0,     0,     0,
   -1951,     0,  3866,     0,     0, -1951,  3867,     0,     0,     0,
       0,     0,  1116,     0,  3868,     0,     0,  3869,     0,     0,
       0,     0,     0,     0,     0, -1951,     0,  2146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3870,     0,     0,     0,     0,     0,     0,  5378, -1951,     0,
       0,     0,     0,     0,     0,     0,     0, -1951,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3871,  3872,  3873,     0, -1951,
       0,   938,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1116,     0, -1951,  3874,     0,
       0,     0,     0, -1951, -1951,     0,  4877,     0,  3858,     0,
       0,   938,     0,     0,     0,     0,     0, -1951,     0, -1951,
       0,     0, -1951,  3875,     0,     0,     0,     0,     0,     0,
    3810,  3811,  3860,  3813,  3815,     0,     0,     0,     0,     0,
    3862,     0,     0,     0,     0,     0,     0,  3876,     0,     0,
       0,     0,     0,     0,     0,  3877,     0,  3878,     0,     0,
       0,     0,  2032,     0,     0,     0,     0,   932,     0,     0,
       0,     0,     0,     0,  4878,     0,  3879,     0,     0,     0,
       0,  5473,     0,  3880,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3881,     0,     0,     0,     0,
       0,     0,  3882,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,   932,  3864,  3883,     0,     0,
       0,     0,     0,     0,  3974,     0,     0,  3884,     0,     0,
       0,  3885,  3886,     0,     0,     0,     0,     0,  3887,     0,
       0,   938,  3888,     0,  1116,     0,     0,  3865,     0,     0,
    3889,     0,     0,     0,  2858,     0,     0,     0,     0,     0,
       0,     0,  1116,     0,     0,   938,     0,     0,     0, -1951,
    3890,     0,     0,     0,     0,     0,     0,     0,   932,   932,
    1116,     0,  2761,  1116,     0,     0,  3867,     0,     0,     0,
       0,  1116,  1116,     0,  3868,     0,  3891,     0,     0,     0,
    3892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3893,     0,  2762,  2763,     0,  2764,  2765,  2766,  2767,  2768,
    3870,  2769,  2770,  2771,  2772,  2773,  2774,  2775,  2776,     0,
    2777,  2778,  2779,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3894,     0,     0,
       0,     0,     0,     0,     0,  3871,  3872,  3873,     0,     0,
    3895,     0,  3896,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3874,     0,
       0,     0,     0,  1116,  1116,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,  5675,     0,     0,     0,     0,     0,
       0,  3897,     0,  3875,     0,     0,     0,  3898,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3876,     0,  2780,
    2781,     0,     0,     0,  3899,  3877,     0,  3878,     0,     0,
       0,     0,   938,     0,     0,  3900,  3901,  3902,     0,     0,
       0,     0,     0,     0,     0,     0,  3879,     0,     0,  1116,
       0,     0,     0,     0,     0,     0,  3903,     0,     0,     0,
       0,     0,     0,  3904,     0,  3881,     0,     0,     0,     0,
    1116,     0,  3882,     0,  1116,  1116,     0,  1116,  1116,     0,
       0,     0,     0,     0,     0,     0,  1116,  3883,  1116, -1017,
       0, -1017,     0,     0,  3905,     0,     0,  3884,     0,     0,
       0,  3885,     0,     0,     0,     0,     0,     0,  3887,  3906,
    3907,     0,  3888,     0,     0,     0,  1116,     0,  2032,     0,
       0,     0,  3908,     0,     0,  3909,     0,     0,     0,     0,
    1116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3890,     0,     0,  1116,     0,     0,  1116,     0,     0,     0,
       0,     0, -1951,     0,     0,     0,     0,     0,     0,     0,
    1116,     0,     0,     0,     0,  2160,     0,   172,   173,     0,
    3892,     0,  3864,     0,  3122,  1116,     0,     0,     0,     0,
    3893,     0, -1951,     0, -1951,     0,     0, -1951, -1951, -1173,
       0,     0,     0,     0,     0,     0,     0,  1116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3895,     0,  3896,     0,     0,     0,     0,     0,  1116,     0,
       0,     0,     0,   932,     0,     0,     0,     0,     0,     0,
    3868,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3897,     0,     0,     0,     0,  4412,  3898,     0,  4415,
    1905,     0,  4421,  4422,  4423,  4424,     0,  4426,  4427,  4428,
    4429,     0,  4431,  4432,     0,  4434,     0,     0,     0,  4438,
       0,     0,     0,  4441,  4442,  4443,  4444,     0,  4446,  4447,
       0,  3871,  3872,  3873,  4452,  4453,     0,     0,  4457,  4458,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3874,     0,  3903,     0,     0,     0,
       0,     0,     0,  3904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   938,     0,     0,     0,  3875,
       0,     0,     0,     0,  1116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3905,     0,     0,     0,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3906,
    3907,  3877,     0,  3878,     0,     0,     0,     0,     0,     0,
       0,     0,  3908,     0,     0,     0,     0,     0,     0,     0,
   -1017,     0,  3879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3881,     0,     0,     0,  1116,     0,     0,  3882,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3888,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   932,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   932,     0,     0,     0,     0,  3892,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3893,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3474,   932,     0,     0,
       0,     0,     0,     0,     0,   932,   932,   932,     0,     0,
       0,     0,  1116,  3894,     0,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,  1116,     0,  3895,     0,     0,     0,
       0,     0,     0,  1116,     0,  1116,     0,  1116,     0,  1116,
    1116,  1116,  1116,  1116,  1116,     0,  1116,     0,     0,     0,
       0,     0,     0,     0,  1116,     0,  1116,     0,     0,  1116,
    1116,  1116,     0,     0,     0,     0,     0,  3897,  1116,  1116,
    1116,     0,  1116,  3898,  1116,     0,  1116,     0,  1116,     0,
    1116,     0,     0,     0,     0,     0,     0,     0,  1116,     0,
    1116,     0,  1116,  1116,  1116,  1116,  1116,     0,     0,  1116,
    1116,  1116,  2032,  1116,     0,     0,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1116,
       0,     0,     0,     0,  1116,     0,     0,  1116,     0,  1116,
    1116,  1116,  3903,     0,  1116,     0,     0,     0,     0,  3904,
    1116,     0,     0,     0,     0,  1116,     0,     0,     0,     0,
       0,   172,   173,  3122,  1116,     0,  3864,     0,     0,     0,
    1116,     0,  1116,     0,     0,  1116,     0,     1,     2,     0,
    3905,     0,     0,     0,     0,  1116,     0,  1116,     0,     0,
       0,     0,  1116,     0,     0,  3906,  3907,     3,     0,     4,
       0,     5,     0,     6,     0,     0,     0,     0,  3908,     0,
       0,     7,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1116,     0,
       0,     0,     0,     8,     0,     9,    10,     0,     0,     0,
       0,     0,     0,    11,  3868,     0,     0,     0,     0,     0,
      12,     0,     0,     0,     0,     0,     0,  1116,     0,     0,
       0,  1180,  4820,    13,     0,     0,     0,     0,     0,    14,
       0,  4737,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    15,     0,  4847,     0,     0,     0,  1116,   932,
      16,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    17,     0,   932,     0,  3871,  3872,  3873,     0,     0,
       0,     0,     0,     0,    18,     0,    19,  1116,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,  3874,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,     0,  3875,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,    23,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    24,    25,     0,     0,
       0,  1116,     0,     0,     0,  3877,     0,  3878,    26,    27,
      28,     0,    29,     0,     0,     0,     0,    30,     0,     0,
       0,     0,  1116,    31,     0,     0,  3879,    32,     0,     0,
       0,    33,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3881,     0,     0,     0,  3808,
       0,     0,  3882,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3883,     0,    35,
       0,    36,     0,    37,     0,  3808,  3808,  3884,    38,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,    40,
       0,     0,  3888,     0,     0,     0,    41,     0,     0,  3926,
       0,     0,     0,     0,     0,     0,    42,     0,     0,     0,
     932,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,    44,
       0,    45,     0,     0,     0,     0,     0,     0,    46,     0,
       0,  3808,  3808,     0,     0,    47,     0,     0,     0,     0,
    3892,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3893,     0,     0,     0,     0,     0,    48,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     932,    49,     0,     0,     0,     0,     0,  3894,     0,     0,
       0,     0,     0,    50,     0,     0,     0,     0,     0,     0,
    3895,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    51,     0,     0,     0,     0,     0,     0,     0,
    1116,     0,     0,     0,     0,     0,    52,     0,     0,   932,
    1116,     0,     0,  1116,     0,     0,     0,     0,     0,    53,
       0,  3897,    54,     0,     0,    55,     0,  3898,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1116,  1116,     0,
      56,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1116,     0,  1116,     0,  1116,     0,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3903,     0,     0,     0,
    1116,     0,     0,  3904,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1116,  1116,     0,     0,     0,     0,     0,  1116,     0,
    1116,     0,  1116,     0,  3905,     0,     0,  1116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3906,
    3907,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3908,     0,     0,     0,     0,    57,     0,     0,
       0,     0,     0,     0,     0,  1116,  1116,     0, -1017,     0,
   -1017,     0,     0,     0,     1,     2,     0,     0,     0,     0,
    1116,     0,     0,     0,     0,     0,    58,     0,     0,    59,
       0,     0,     0,     0,     3,     0,     4,  2032,     5,    60,
       6,  1116,     0,     0,     0,     0,     0,    61,     7,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       8,     0,     9,    10,     0,     0,     0,     0,     0,    63,
      11,     0,    64,     0,     0,     0,   172,   173,     0,     0,
       0,  3864,     0,     0,     0,     0,     0,     0,  3926,  3926,
      13,     0,     0,     0,     0,     0,    14,     0,     0,     0,
       0,     0,     0,     0,    65,     0,     0,     0,     0,    15,
    1116,     0,     0,     0,    66,     0,     0,    16,     0,     0,
    1116,     0,     0,     0,     0,     0,     0,     0,    17,     0,
       0,     0,  1116,     0,  1116,     0,     0,     0,     0,    67,
       0,    18,     0,    19,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3868,
       0,    68,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,    23,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    24,    25,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,    27,    28,     0,    29,
    3871,  3872,  3873,     0,    30,     0,     0,     0,     0,     0,
      31,     0,     0,     0,    32,     0,     0,     0,    33,    34,
       0,     0,     0,  3874,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3926,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3875,     0,
       0,     0,     0,     0,     0,     0,    35,     0,    36,     0,
      37,     0,   932,     0,     0,    38,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    39,    40,     0,     0,     0,
    3877,     0,  3878,    41,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    42,     0,     0,     0,  3808,     0, -1017,
       0,  3879,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1116,    43,    44,     0,    45,     0,
    3881,     0,     0,     0,     0,    46,     0,  3882,     0,     0,
       0,     0,    47,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3884,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3888,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    51,
     932,   932,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    52,     0,  3892,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3893,    53,     0,     0,    54,
       0,     0,    55,     0,     0,  1116,  1116,     0,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,    56,     0,  1116,
    1116,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3894,     0,  1116,     0,  1116,     0,  1116,     0,
    1116,     0,     0,     0,     0,  3895,     0,     0,     0,     0,
       0,     0,     0,  1116,  1116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1116,     0,     0,     0,     0,     0,  3897,  1116,     0,     1,
       2,     0,  3898,     0,     0,     0,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     3,
       0,     0,     0,     5,     0,     6,     0,     0,     0,     0,
       0,     0,     0,     7,     0,     0,     0,  1180,     0,     0,
       0,     0,     0,     0,    57,     0,     0,     0,     0,  1116,
       0,     0,     0,  1116,     0,     8,     0,     9,    10,     0,
       0,  3903,     0,     0,     0,    11,  5647,  5648,  3904,  5650,
    5651,  5652,  5653,    58,     0,     0,    59,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    60,     0,     0,     0,
       0,    14,     0,     0,    61,     0,     0,     0,     0,  3905,
       0,     0,     0,     0,     0,     0,    62,     0,     0,     0,
       0,  3926,    16,     0,  3906,  3907,     0,     0,     0,     0,
       0,     0,     0,    17,     0,     0,    63,  3908,     0,    64,
       0,     0,     0,     0,     0,     0,    18,     0,    19,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    65,     0,     0,     0,     0,     0,  5722,     0,     0,
    5725,    66,     0,    21,     0,     0,     0,     0,  5733,     0,
       0,     0,     0,  5743,     0,     0,     0,    22,    23,     0,
       0,     0,     0,     0,     0,     0,    67,     0,    24,    25,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      26,    27,     0,     0,    29,     0,     0,     0,    68,    30,
       0,     0,     0,     0,     0,    31,     0,     0,     0,    32,
       0,     0,     0,    33,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3926,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1116,  1116,     0,
       0,    35,     0,    36,     0,    37,     0,     0,     0,     0,
      38,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,     0,     0,     0,     0,    41,  4013,
    4014,     0,     0,     0,     0,  4015,  4016,     0,    42,     0,
       0,   932,     0,     0,     0,  4017,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      43,     0,     0,    45,     0,     0,     0,     0,     0,     0,
      46,  4018,     0,     0,     0,     0,     0,    47,     0,     0,
       0,     0,     0,  4019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    48,     0,
       0,     0,  3474,  4020,     0,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   932,
       0,     0,     0,    49,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1116,    50,     0,  4021,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    51,     0,     0,     0,     0,     0,
    4022,  4023,     0,  4024,     0,     0,     0,     0,    52,     0,
       0,  4025,  4026,  4027,     0,     0,     0,     0,     0,     0,
       0,    53,     0,     0,    54,     0,     0,    55,     0,     0,
       0,  4028,  1116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    56,     0,     0,     0,     0,     0,     0,     0,
    1116,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4029,     0,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
    4030,     0,     0,     0,     0,     0,  4031,     0,     0,     0,
    3926,     0,  3926,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1116,     0,  1116,     0,     0,
    4032,  4033,  4034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4035,  4036,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    58,     0,
       0,    59,     0,     0,     0,  4037,     0,  4038,  4039,     0,
       0,    60,     0,     0,     0,     0,     0,     0,     0,    61,
       0,     0,     0,  4040,     0,     0,     0,     0,     0,     0,
       0,    62,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4013,
    4014,    63,     0,     0,    64,  4015,  4016,     0,     0,     0,
    4041,  3474,  4042,     0,     0,  4017,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   932,     0,     0,     0,  4043,    65,     0,  1116,     0,
       0,  4018,     0,     0,     0,     0,    66,     0,     0,   932,
       0,     0,     0,  4019,  1118,     0,     0,     0,  4044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4045,
    4046,    67,     0,  4020,     0,     0,     0,     0,     0,     0,
       0,  1118,     0,  3474,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    68,     0,     0,     0,     0,     0,     0,
    1118,  4047,     0,     0,     0,     0,     0,  4021,     0,     0,
    4048,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1116,     0,
    4022,  4023,     0,  4024,     0,     0,     0,     0,     0,     0,
       0,  4025,  4026,  4027,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1116,     0,     0,  4049,  4050,  4051,     0,
       0,  4028,     0,     0,  4052,  4053,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4054,  4055,     0,     0,     0,     0,     0,     0, -1017,
       0, -1017,     0,     0,     0,     0,  4029,     0,     0,     0,
       0,     0,     0,     0,     0,  4056,  4057,   932,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2032,  1118,
    4030,     0,     0,     0,  4058,     0,  4031,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1116,     0,
    4032,  4033,  4034,     0,     0,     0,  4059,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   172,   173,     0,
       0,     0,  3864,     0,  4035,  4036,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,     0,
       0,     0,     0,  4311,     0,  4312,     0,  4313,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4060,     0,     0,  4061,
       0,     0,  4062,     0,     0,  4037,     0,  4038,  4039,  4063,
     932,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1118,     0,  4040,     0,  4064,  1118,     0,     0,     0,
    3868,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     932,     0,     0,     0,  4065,     0,     0,     0,     0,     0,
    1116,     0,     0,     0,     0,     0,  1118,     0,     0,  1588,
    4041,     0,  4042,     0,     0,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1116,     0,     0,
       0,     0,     0,     0,     0,  4043,     0,     0,     0,     0,
       0,  3871,  3872,  3873,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1588,     0,     0,     0,  4044,     0,
       0,     0,     0,     0,  3874,     0,     0,     0,     0,  4045,
    4046,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3875,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4047,     0,     0,     0,  1118,  1118,  1118,  1118,     0,
    4048,  1588,  5494,     0,     0,     0,  5494,     0,     0,  1118,
     932,  3877,     0,  3878,     0,     0,     0,  1116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1017,     0,  3879,     0,   932,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4049,  4050,  4051,     0,
       0,  3881,     0,     0,  4052,  4053,     0,     0,  3882,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4054,  4055,  3883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3884,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4056,  4057,     0,  3888,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5595,     0,  4058,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5494,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5595,     0,     0,     0,     0,     0,  5307,     0,  5494,     0,
       0,     0,  1116,     0,     0,     0,  3892,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3893,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,     0,     0,  1588,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5667,     0,  3894,  5667,     0,  4060,     0,     0,  4061,
       0,   932,  4062,     0,     0,     0,  3895,     0,     0,  5308,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1116,     0,     0,     0,  4064,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4065,     0,     0,  3897,     0,     0,
       0,     0,     0,  3898,  5494,     0,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1588,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5667,     0,     0,     0,     0,  5667,     0,     0,
       0,     0,     0,     0,  5667,     0,     0,     0,     0,     0,
       0,     0,  3903,     0,     0,     0,     0,     0,     0,  3904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5494,     0,     0,  1118,  1116,  1118,     0,     0,     0,     0,
    3905,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3906,  3907,     0,     0,     0,
    5667,     0,     0,     0,  5799,     0,     0,     0,  3908,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5667,     0,  5667,  5667,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1118,     0,  1118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1118,     0,  5667,     0,     0,  5667,
       0,     0,     0,     0,     0,  1118,  1118,     0,     0,     0,
       0,  1118,     0,     0,     0,  1118,  1118,  1118,     0,     0,
       0,  1116,     0,     0,     0,     0,  1118,  1118,  1588,     0,
    5667,     0,  1118,     0,  1118,  1118,  1118,  1118,  1118,     0,
    1118,     0,     0,  1588,  1588,     0,     0,     0,     0,     0,
       0,  1118,     0,  1118,     0,     0,  1118,  1118,     0,  1118,
    1118,  1118,     0,  1118,  1118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   932,     0,     0,     0,  1118,  1118,
    1118,  1118,  1118,     0,  1118,  1118,  1118,  1116,     0,  1118,
    1118,  1118,  1118,  1118,  1118,  1118,     0,  1118,  1118,  1118,
    1118,  1118,  1118,     0,  1118,  1118,     0,  1118,  1118,  1118,
    1118,  1118,  1118,  1118,     0,     0,  1118,  1118,  1118,  1118,
       0,  1118,  1118,  1118,     0,  1118,     0,  1118,     0,  1118,
       0,     0,     0,  1118,  1118,  1118,     0,     0,  1118,  1118,
    1118,  1118,  1118,     0,  1118,     0,     0,     0,     0,     0,
       0,  1118,     0,     0,     0,     0,     0,     0,  1118,  1118,
    1118,  1118,     0,     0,     0,     0,     0,     0,     0,  1118,
    1118,     0,  1118,  1118,     0,     0,  1118,  1118,  1118,  1118,
    1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,  1118,     0,
       0,  1118,     0,     0,     0,     0,  1588,     0,     0,     0,
       0,     0,     0,  1588,     0,     0,     0,     0,     0,  4013,
    4014,     0,     0,     0,     0,  4015,  4016,     0,     0,     0,
       0,     0,     0,     0,     0,  4017,     0,     0,     0,     0,
       0,     0,  1118,     0,     0,     0,     0,  1118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1118,     0,     0,
       0,  4018,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4019,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1118,     0,     0,  4021,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1194,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   655,
    4022,  4023,     0,  4024,  1118,     0,  1118,     0,     0,     0,
       0,  4025,  4026,  4027,  1167,     0,     0,     0,     0,     0,
       0,     0,  1195,  1196,     0,     0,     0,     0,  1588,     0,
       0,  4028,  1197,     0,     0,     0,     0,     0,     0,     0,
    1118,     0,     0,     0,     0,     0,     0,     9,    10,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4029,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4030,     0,   172,   173,     0,     0,  4031,  1198,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1199,     0,     0,     0,     0,     0,     0,     0,     0,
    4032,  4033,  4034,  1118,     0,     0,     0,     0,     0,     0,
       0,     0,  1588,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4035,  4036,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1200,     0,     0,
       0,     0,     0,     0,     0,  4037,     0,  4038,  4039,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4040,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1201,     0,     0,     0,     0,
    4041,     0,  4042,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,     0,  4043,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1118,     0,     0,     0,     0,  1202,     0,     0,  4044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,  4045,
    4046,  1118,     0,     0,  1203,     0,     0,     0,     0,  1118,
    1118,     0,     0,  1204,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1205,     0,     0,     0,     0,
       0,  4047,     0,     0,     0,     0,  1206,     0,     0,     0,
    4048,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1207,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1588,  1588,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4049,  4050,  4051,     0,
       0,     0, -2323,  1208,  4052,  4053,  1209,     0,  1210,     0,
       0,  1118,  1118,  1118,     0,     0,     0,     0,     0,     0,
       0,  4054,  4055,  1588,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1211,  1212,     0,     0,     0,     0,
       0,     0,  1213,  1214,     0,  4056,  4057,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1215,
       0,     0,     0,     0,  4058,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1588,     0,     0,     0,
       0,  1216,     0,     0,     0,     0,     0,  1118,     0,     0,
    1588,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1217,     0,     0,     0,     0,     0,  1118,     0,
       0,     0,  1118,  1118,     0,  1118,  1118,     0,     0,     0,
       0,     0,     0,     0,  1118,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1118,     0,  4060,     0,  1218,  4061,
       0,     0,  4062,     0,     0,     0,     0,     0,  1118,     0,
       0,     0,  1219,     0,     0,     0,     0,     0,     0,     0,
       0,  1118,     0,  1220,  1118,  4064,  1221,  1222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,     0,
       0,  1223,     0,     0,  4065,     0,     0,     0,     0,     0,
       0,     0,     0,  1118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1118,     0,  1224,     0,     0,
       0,     0,     0,     0,  1225,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -3090,     0,  1226,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -3090,     0,     0,     0,     0,
       0,  1227,  1588,     0,  1588,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,     0,     0,     0,     0,     0,  1588,
       0,     0,  1588,  1588,  1588,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1084,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1245,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1118,     0,     0,  1118,     0,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,     0,     0,     0,     0,     0,     0,
       0,  1118,     0,  1118,     0,  1118,     0,  1118,  1118,  1118,
    1118,  1118,  1118,     0,  1118,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,  1118,     0,     0,  1118,  1118,  1118,
       0,     0,     0,     0,     0,     0,  1118,  1118,  1118,     0,
    1118,     0,  1118,     0,  1118,     0,  1118,     0,  1118,     0,
       0,     0,     0,     0,     0,     0,  1118,     0,  1118,     0,
    1118,  1118,  1118,  1118,  1118,     0,     0,  1118,  1118,  1118,
       0,  1118,     0,     0,  1118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1118,     0,     0,
       0,     0,  1118,     0,     0,  1118,     0,  1118,  1118,  1118,
       0,     0,  1118,     0,     0,     0,  1437,     0,  1118,     0,
       0,     0,     0,  1118,     0,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,     0,     0,     0,     0,  1118,     0,
    1118,     0,     0,  1118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1118,  1588,  1118,     0,     0,     0,     0,
    1118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1588,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1501,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1551,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1578,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1593,     0,  1118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1118,     0,     0,     0,     0,  1688,     0,  1588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1588,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1884,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,     0,
       0,  1118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1118,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1118,     0,  1118,     0,  1118,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,     0,
       0,     0,     0,     0,  1588,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1118,
    1118,     0,     0,     0,     0,     0,  1118,     0,  1118,     0,
    1118,     0,     0,     0,     0,  1118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2072,     0,  2073,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1588,  1118,  1118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2153,     0,  2153,  1588,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2182,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2196,     0,
       0,     0,  2201,     0,  2203,     0,     0,     0,  1118,     0,
       0,     0,     0,  2219,  2220,     0,     0,     0,  1118,  2249,
       0,  2252,  2253,  2254,  2255,  2256,     0,  2258,     0,     0,
    1118,     0,  1118,     0,     0,     0,     0,     0,  2266,     0,
    2269,     0,     0,  2270,  2271,     0,  2273,  2274,     0,     0,
    2277,  2278,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2287,  2288,  2293,  2295,  2296,
       0,  2299,     0,  2301,     0,     0,  2303,  2304,  2305,  2308,
    2309,  2310,  2311,     0,  2312,  2313,  2314,  2315,  2316,     0,
       0,  2323,  2324,     0,     0,  2328,  2329,  2330,     0,     0,
       0,     0,     0,  2336,  2337,  2338,     0,     0,  2341,  2342,
    2343,     0,  2345,     0,  2347,     0,  2348,     0,     0,     0,
    2351,  2293,  2353,     0,     0,  2359,  2360,  2361,  2362,  2363,
       0,  2364,     0,     0,     0,     0,     0,     0,  2368,     0,
       0,     0,     0,     0,     0,  2373,  2374,  2375,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2470,
       0,     0,     0,     0,  2480,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,  2480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2548,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2581,     0,  2586,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1118,  1118,     0,  1118,  2609,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1118,  1118,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1118,     0,  1118,     0,  1118,     0,  1118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1118,  1118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1118,     0,
       0,     0,     0,     0,     0,  1118,     0,     0,     0,     0,
    2680,     0,     0,     0,  1118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1118,     0,     0,
       0,  1118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2850,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2878,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1245,     0,     0,  2897,     0,
       0,     0,     0,     0,     0,     0,  2904,  2905,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1118,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2960,  2962,
    2964,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3048,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3056,  1118,  3057,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3079,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3085,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3096,     0,
    1118,  2480,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1588,  1118,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3133,     0,     0,     0,     0,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1118,
       0,     0,  3143,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1118,     0,  1118,     0,     0,     0,     0,
       0,     0,     0,  2586,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3276,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3276,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3366,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1588,     0,     0,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3498,     0,     0,
    3499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1118,     0,  3526,     0,
       0,     0,  3528,     0,  3529,  3530,  3531,  3532,  3533,  3534,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3539,
       0,  3540,     0,     0,  3541,  3542,  3543,     0,     0,     0,
       0,     0,     0,  3545,  3546,  3547,     0,  3548,     0,  3550,
       0,  3552,     0,  3554,     0,  3556,     0,     0,     0,     0,
       0,     0,     0,  2305,     0,  3559,     0,  2305,     0,  3562,
    3563,  3564,     0,     0,  3565,  3566,  3568,     0,  3569,     0,
       0,  3570,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3571,     0,     0,     0,     0,     0,
       0,     0,  3578,     0,  3579,  3580,  3581,     0,     0,  3582,
       0,     0,     0,     0,     0,  3586,     0,     0,     0,     0,
    3597,     0,     0,     0,     0,     0,     0,     0,  1118,  3601,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3608,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3620,     0,     0,  1118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2480,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2586,     0,  1118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1588,  1588,     0,     0,     0,
       0,     0,  2586,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1588,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3782,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1588,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3940,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4085,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4089,     0,     0,  4090,     0,
       0,     0,  1118,     0,     0,     0,     0,     0,     0,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4115,  4116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4139,     0,  4140,
       0,  4141,     0,  4142,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4167,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4190,  4191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3276,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2480,  2480,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2480,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2586,     0,     0,     0,
       0,     0,     0,     0,     0,  1118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4342,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3276,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3276,     0,  4354,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4510,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4614,  4615,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4622,  4623,  4624,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4644,
       0,  4645,     0,  4646,     0,  4647,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4653,  4654,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2586,     0,     0,     0,  2586,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4895,  4896,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4971,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3276,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3276,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2480,  2480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2586,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2586,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5099,     0,  5101,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     0,   898,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   899,     0,     0,     0,     0,     0,    13,     0,
       0,     0,     0,   900,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   173,    15,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   901,     0,     0,     0,     0,     0,     0,   902,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    28,     0,     0,     0,     0,
     903,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5252,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3276,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    39,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,     0,   178,     0,   180,   181,
     182,     0,     0,     0,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,     0,   194,   195,   196,   197,   198,
     199,   200,   201,     0,   905,     0,     0,   205,   206,   207,
     208,   209,     0,     0,   212,   213,   214,   215,     0,     0,
       0,   219,   220,   221,   222,   223,   906,   225,   226,   227,
       0,   228,     0,  5332,     0,     0,     0,     0,   234,     0,
     236,     0,   238,   239,     0,   241,   242,   243,   244,   245,
     246,     0,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   263,   264,   265,
       0,   266,   267,   268,   269,   270,   271,   272,     0,   274,
     275,   276,   277,     0,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,     0,     0,   293,     0,
     907,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,     0,     0,     0,     0,     0,   308,   309,   310,   311,
     312,   313,   314,   315,     0,   317,   318,     0,   320,   321,
       0,     0,   323,     0,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,     0,   337,   338,   339,   340,
     341,   342,   343,   344,   345,  3276,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,     0,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   908,     0,     0,     0,   436,   437,     0,   439,   440,
     441,   442,     0,   444,   445,   446,   447,   448,   449,     0,
       0,     0,     0,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,     0,
     481,     0,   483,   484,     0,   486,   487,     0,   489,   490,
     491,   492,   493,   494,     0,   496,   497,   498,   499,   500,
     501,   502,     0,   504,   505,   506,     0,   508,   509,   510,
     511,     0,   513,   514,     0,     0,   517,     0,     0,   520,
     521,   522,     0,   524,     0,   526,   527,   528,   529,     0,
     530,   531,   532,   533,     0,   535,   536,     0,   538,     0,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
       0,   561,   562,   563,   564,   565,   566,   567,   568,     0,
     570,   571,   572,     0,   574,   575,   576,   577,     0,     0,
     580,   581,     0,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,     0,     0,   599,
     600,     0,     0,   602,     0,   604,   605,  5622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5386,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2476,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2477,
     941,   942,   943,   944,     0,     0,  1688,     0,     0,     0,
       0,   945,   946,     0,   947,     0,     0,     0,     0,     0,
       0,   948,   949,     0,     0,   950,   951,   952,   953,     0,
     954,   955,     0,   956,   957,     0,     0,     0,     0,   958,
       0,  5708,     0,  2478,     0,     0,   960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   961,   962,   963,     0,
     964,   965,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   966,   967,   968,     0,   969,   970,     0,
       0,     0,   971,   972,   973,     0,     0,     0,     0,     0,
       0,     0,   974,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2586,
       0,   977,     0,     0,     0,     0,   978,   979,     0,   980,
       0,     0,     0,     0,     0,   981,     0,   982,     0,     0,
     983,     0,     0,   984,   985,   986,     0,   987,   988,   989,
       0,   990,  2479,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
     992,   993,   994,     0,   995,     0,     0,     0,     0,     0,
       0,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,   999,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1000,     0,     0,     0,     0,     0,  1001,
    1002,     0,  1003,  1004,     0,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,     0,     0,     0,     0,  1012,     0,  1013,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,  1014,  1015,
    1016,   183,   184,   185,  1017,   187,   188,   189,   190,   191,
     192,  1018,   194,   195,   196,   197,   198,   199,   200,  1019,
     202,   203,  2586,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,  1020,   217,   218,   219,   220,
     221,   222,   223,   224,  1021,   226,  1022,  1023,   228,  1024,
    1025,  1026,  1027,  1028,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,  1029,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1030,  1031,  1032,   262,  1033,  1034,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,  1035,   308,   309,   310,   311,   312,  1036,   314,
    1037,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,  1038,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1039,  1040,   350,   351,   352,  1041,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1042,   392,  1043,
     394,   395,   396,   397,  1044,  1045,  1046,  1047,   402,   403,
     404,   405,   406,   407,   408,   409,   410,  1048,  1049,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,  1050,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,  1051,   443,
     444,   445,   446,   447,  1052,  1053,   450,   451,   452,   453,
     454,   455,  1054,   457,   458,   459,   460,   461,   462,  1055,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,  1056,
     494,   495,   496,   497,   498,  1057,  1058,   501,   502,   503,
     504,   505,  1059,   507,   508,   509,   510,   511,   512,  1060,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  1061,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,  1062,  1063,
    1064,  1065,   565,   566,   567,  1066,  1067,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
    1068,   584,  1069,   586,   587,   588,   589,   590,   591,   592,
     593,   594,  1070,  1071,   597,  1072,   599,   600,   601,     0,
     602,   603,   604,  1073,     0,     0,     0,     0,     0,     0,
       0,     0,  1074,  1075,     0,     0,     0,     0,  1076,     0,
       0,     0,  2382,  1077,     0,     0,     0,  1078,  1079,     0,
       0,  1080,  1081,   940,   941,   942,   943,   944,     0,     0,
       0,     0,     0,     0,     0,   945,   946,     0,   947,     0,
       0,     0,     0,     0,     0,   948,   949,     0,     0,   950,
     951,   952,   953,     0,   954,   955,     0,   956,   957,     0,
       0,     0,     0,   958,     0,     0,     0,   959,     0,     0,
     960,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     961,   962,   963,     0,   964,   965,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   966,   967,   968,
       0,   969,   970,     0,     0,     0,   971,   972,   973,     0,
       0,     0,     0,     0,     0,     0,   974,     0,   975,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   977,     0,     0,     0,     0,
     978,   979,     0,   980,     0,     0,     0,     0,     0,   981,
       0,   982,     0,     0,   983,     0,     0,   984,     0,   986,
       0,   987,   988,   989,     0,   990,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     991,     0,     0,     0,   992,   993,   994,     0,   995,     0,
       0,     0,     0,     0,     0,   996,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,   999,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1000,     0,     0,
       0,     0,     0,  1001,  1002,     0,  1003,  1004,     0,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,     0,     0,     0,     0,  1012,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,  1014,  1015,  1016,   183,   184,   185,  1017,   187,
     188,   189,   190,   191,  2383,  1018,   194,   195,   196,   197,
     198,   199,   200,  1019,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,  1020,
     217,   218,   219,   220,   221,   222,   223,   224,  1021,   226,
    1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,  1029,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1030,  1031,  1032,   262,  1033,  1034,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,  1035,   308,   309,   310,
     311,   312,  1036,   314,  1037,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,  1038,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1039,  1040,
     350,   351,   352,  1041,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,  1042,   392,  1043,   394,   395,   396,   397,  1044,  1045,
    1046,  1047,   402,   403,   404,   405,   406,   407,   408,   409,
     410,  1048,  1049,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,  1050,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1051,   443,   444,   445,   446,   447,  1052,  1053,
     450,   451,   452,   453,   454,   455,  1054,   457,   458,   459,
     460,   461,   462,  1055,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,  1056,   494,   495,   496,   497,   498,  1057,
    1058,   501,   502,   503,   504,   505,  1059,   507,   508,   509,
     510,   511,   512,  1060,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,  1061,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,  1062,  1063,  1064,  1065,   565,   566,   567,  1066,
    1067,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,  1068,   584,  1069,   586,   587,   588,
     589,   590,   591,   592,   593,   594,  1070,  1071,   597,  1072,
     599,   600,   601,     0,   602,   603,   604,  1073,     0,     0,
       0,   940,   941,   942,   943,   944,  1074,  1075,     0,     0,
       0,     0,  1076,   945,   946,     0,   947,  1077,     0,     0,
       0,  1078,  1079,   948,   949,  1080,  1081,   950,   951,   952,
     953,     0,   954,   955,     0,   956,   957,     0,     0,     0,
       0,   958,     0,     0,     0,   959,     0,     0,   960,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   961,   962,
     963,     0,   964,   965,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   966,   967,   968,     0,   969,
     970,     0,     0,     0,   971,   972,   973,     0,     0,     0,
       0,     0,     0,     0,   974,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   977,     0,     0,     0,     0,   978,   979,
       0,   980,     0,     0,     0,     0,     0,   981,     0,   982,
       0,     0,   983,     0,     0,   984,   985,   986,     0,   987,
     988,   989,     0,   990,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,     0,   992,   993,   994,     0,   995,     0,     0,     0,
       0,     0,     0,   996,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,   999,     0,    31,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1000,     0,     0,     0,     0,
       0,  1001,  1002,     0,  1003,  1004,     0,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,    38,     0,     0,     0,     0,  1012,     0,  1013,
       0,     0,     0,    40,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
    1014,  1015,  1016,   183,   184,   185,  1017,   187,   188,   189,
     190,   191,   192,  1018,   194,   195,   196,   197,   198,   199,
     200,  1019,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,  1020,   217,   218,
     219,   220,   221,   222,   223,   224,  1021,   226,  1022,  1023,
     228,  1024,  1025,  1026,  1027,  1028,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
    1029,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1030,  1031,  1032,   262,  1033,  1034,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,  1035,   308,   309,   310,   311,   312,
    1036,   314,  1037,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,  1038,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1039,  1040,   350,   351,
     352,  1041,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,  1042,
     392,  1043,   394,   395,   396,   397,  1044,  1045,  1046,  1047,
     402,   403,   404,   405,   406,   407,   408,   409,   410,  1048,
    1049,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,  1050,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
    1051,   443,   444,   445,   446,   447,  1052,  1053,   450,   451,
     452,   453,   454,   455,  1054,   457,   458,   459,   460,   461,
     462,  1055,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,  1056,   494,   495,   496,   497,   498,  1057,  1058,   501,
     502,   503,   504,   505,  1059,   507,   508,   509,   510,   511,
     512,  1060,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,  1061,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
    1062,  1063,  1064,  1065,   565,   566,   567,  1066,  1067,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,  1068,   584,  1069,   586,   587,   588,   589,   590,
     591,   592,   593,   594,  1070,  1071,   597,  1072,   599,   600,
     601,     0,   602,   603,   604,  1073,     0,     0,     0,   940,
     941,   942,   943,   944,  1074,  1075,     0,  2290,     0,     0,
    1076,   945,   946,     0,   947,  1077,     0,     0,     0,  1078,
    1079,   948,   949,  1080,  1081,   950,   951,   952,   953,     0,
     954,   955,     0,   956,   957,     0,     0,     0,     0,   958,
       0,     0,     0,   959,     0,     0,   960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   961,   962,   963,     0,
     964,   965,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   966,   967,   968,     0,   969,   970,     0,
       0,     0,   971,   972,   973,     0,     0,     0,     0,     0,
       0,     0,   974,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2291,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   977,     0,     0,     0,     0,   978,   979,     0,   980,
       0,     0,     0,     0,     0,   981,     0,   982,     0,     0,
     983,     0,     0,   984,   985,   986,     0,   987,   988,   989,
       0,   990,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
     992,   993,   994,     0,   995,     0,     0,     0,     0,     0,
       0,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,   999,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1000,     0,     0,     0,     0,     0,  1001,
    1002,     0,  1003,  1004,     0,     0,     0,  1005,     0,     0,
       0,     0,     0,  2292,     0,  1006,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,     0,     0,     0,     0,  1012,     0,  1013,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,  1014,  1015,
    1016,   183,   184,   185,  1017,   187,   188,   189,   190,   191,
     192,  1018,   194,   195,   196,   197,   198,   199,   200,  1019,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,  1020,   217,   218,   219,   220,
     221,   222,   223,   224,  1021,   226,  1022,  1023,   228,  1024,
    1025,  1026,  1027,  1028,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,  1029,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1030,  1031,  1032,   262,  1033,  1034,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,  1035,   308,   309,   310,   311,   312,  1036,   314,
    1037,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,  1038,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1039,  1040,   350,   351,   352,  1041,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1042,   392,  1043,
     394,   395,   396,   397,  1044,  1045,  1046,  1047,   402,   403,
     404,   405,   406,   407,   408,   409,   410,  1048,  1049,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,  1050,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,  1051,   443,
     444,   445,   446,   447,  1052,  1053,   450,   451,   452,   453,
     454,   455,  1054,   457,   458,   459,   460,   461,   462,  1055,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,  1056,
     494,   495,   496,   497,   498,  1057,  1058,   501,   502,   503,
     504,   505,  1059,   507,   508,   509,   510,   511,   512,  1060,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  1061,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,  1062,  1063,
    1064,  1065,   565,   566,   567,  1066,  1067,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
    1068,   584,  1069,   586,   587,   588,   589,   590,   591,   592,
     593,   594,  1070,  1071,   597,  1072,   599,   600,   601,     0,
     602,   603,   604,  1073,     0,     0,     0,   940,   941,   942,
     943,   944,  1074,  1075,     0,     0,     0,     0,  1076,   945,
     946,     0,   947,  1077,     0,     0,     0,  1078,  1079,   948,
     949,  1080,  1081,   950,   951,   952,   953,     0,   954,   955,
       0,   956,   957,     0,     0,     0,     0,   958,     0,     0,
       0,   959,     0,     0,   960,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   961,   962,   963,     0,   964,   965,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   966,   967,   968,     0,   969,   970,     0,     0,     0,
     971,   972,   973,     0,     0,     0,     0,     0,     0,     0,
     974,     0,   975,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   976,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   977,
       0,     0,     0,     0,   978,   979,     0,   980,     0,     0,
       0,     0,     0,   981,     0,   982,     0,     0,   983,     0,
       0,   984,   985,   986,     0,   987,   988,   989,     0,   990,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,     0,     0,     0,   992,   993,
     994,     0,   995,     0,     0,     0,     0,     0,     0,   996,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,   999,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1000,     0,     0,     0,     0,     0,  1001,  1002,     0,
    1003,  1004,     0,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,     0,
       0,     0,     0,  1012,     0,  1013,  1550,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,  1014,  1015,  1016,   183,
     184,   185,  1017,   187,   188,   189,   190,   191,   192,  1018,
     194,   195,   196,   197,   198,   199,   200,  1019,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,  1020,   217,   218,   219,   220,   221,   222,
     223,   224,  1021,   226,  1022,  1023,   228,  1024,  1025,  1026,
    1027,  1028,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,  1029,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1030,  1031,
    1032,   262,  1033,  1034,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
    1035,   308,   309,   310,   311,   312,  1036,   314,  1037,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
    1038,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,  1039,  1040,   350,   351,   352,  1041,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,  1042,   392,  1043,   394,   395,
     396,   397,  1044,  1045,  1046,  1047,   402,   403,   404,   405,
     406,   407,   408,   409,   410,  1048,  1049,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,  1050,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1051,   443,   444,   445,
     446,   447,  1052,  1053,   450,   451,   452,   453,   454,   455,
    1054,   457,   458,   459,   460,   461,   462,  1055,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,  1056,   494,   495,
     496,   497,   498,  1057,  1058,   501,   502,   503,   504,   505,
    1059,   507,   508,   509,   510,   511,   512,  1060,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,  1061,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,  1062,  1063,  1064,  1065,
     565,   566,   567,  1066,  1067,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,  1068,   584,
    1069,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    1070,  1071,   597,  1072,   599,   600,   601,     0,   602,   603,
     604,  1073,     0,     0,     0,   940,   941,   942,   943,   944,
    1074,  1075,     0,     0,     0,     0,  1076,   945,   946,     0,
     947,  1077,     0,     0,     0,  1078,  1079,   948,   949,  1080,
    1081,   950,   951,   952,   953,     0,   954,   955,     0,   956,
     957,     0,     0,     0,     0,   958,     0,     0,     0,  2583,
       0,     0,   960,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   961,   962,   963,     0,   964,   965,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
     967,   968,     0,   969,   970,     0,     0,     0,   971,   972,
     973,     0,  2584,     0,     0,     0,     0,     0,   974,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   977,     0,     0,
       0,     0,   978,   979,     0,   980,     0,     0,     0,     0,
       0,   981,     0,   982,     0,     0,   983,     0,     0,   984,
     985,   986,     0,   987,   988,   989,     0,   990,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   991,     0,     0,     0,   992,   993,   994,     0,
     995,     0,     0,     0,     0,     0,     0,   996,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,   999,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1000,
       0,     0,     0,     0,     0,  1001,  1002,     0,  1003,  1004,
       0,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,     0,     0,     0,
       0,  1012,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,  1014,  1015,  1016,   183,   184,   185,
    1017,   187,   188,   189,   190,   191,   192,  1018,   194,   195,
     196,   197,   198,   199,   200,  1019,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,  1020,   217,   218,   219,   220,   221,   222,   223,   224,
    1021,   226,  1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,  1029,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1030,  1031,  1032,   262,
    1033,  1034,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,  1035,   308,
     309,   310,   311,   312,  1036,   314,  1037,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,  1038,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1039,  1040,   350,   351,   352,  1041,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,  1042,   392,  1043,   394,   395,   396,   397,
    1044,  1045,  1046,  1047,   402,   403,   404,   405,   406,   407,
     408,   409,   410,  1048,  1049,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
    1050,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,  1051,   443,   444,   445,   446,   447,
    1052,  1053,   450,   451,   452,   453,   454,   455,  1054,   457,
     458,   459,   460,   461,   462,  1055,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,  1056,   494,   495,   496,   497,
     498,  1057,  1058,   501,   502,   503,   504,   505,  1059,   507,
     508,   509,   510,   511,   512,  1060,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,  1061,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,  1062,  1063,  1064,  1065,   565,   566,
     567,  1066,  1067,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,  1068,   584,  1069,   586,
     587,   588,   589,   590,   591,   592,   593,   594,  1070,  1071,
     597,  1072,   599,   600,   601,     0,   602,   603,   604,  1073,
       0,     0,     0,   940,   941,   942,   943,   944,  1074,  1075,
       0,     0,     0,     0,  1076,   945,   946,     0,   947,  1077,
       0,     0,     0,  1078,  1079,   948,   949,  1080,  1081,   950,
     951,   952,   953,     0,   954,   955,     0,   956,   957,     0,
       0,     0,     0,   958,     0,     0,     0,   959,     0,     0,
     960,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     961,   962,   963,     0,   964,   965,     0,     0,     0,     0,
       0,  2959,     0,     0,     0,     0,     0,   966,   967,   968,
       0,   969,   970,     0,     0,     0,   971,   972,   973,     0,
       0,     0,     0,     0,     0,     0,   974,     0,   975,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   977,     0,     0,     0,     0,
     978,   979,     0,   980,     0,     0,     0,     0,     0,   981,
       0,   982,     0,     0,   983,     0,     0,   984,   985,   986,
       0,   987,   988,   989,     0,   990,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     991,     0,     0,     0,   992,   993,   994,     0,   995,     0,
       0,     0,     0,     0,     0,   996,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,   999,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1000,     0,     0,
       0,     0,     0,  1001,  1002,     0,  1003,  1004,     0,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,     0,     0,     0,     0,  1012,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,  1014,  1015,  1016,   183,   184,   185,  1017,   187,
     188,   189,   190,   191,   192,  1018,   194,   195,   196,   197,
     198,   199,   200,  1019,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,  1020,
     217,   218,   219,   220,   221,   222,   223,   224,  1021,   226,
    1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,  1029,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1030,  1031,  1032,   262,  1033,  1034,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,  1035,   308,   309,   310,
     311,   312,  1036,   314,  1037,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,  1038,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1039,  1040,
     350,   351,   352,  1041,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,  1042,   392,  1043,   394,   395,   396,   397,  1044,  1045,
    1046,  1047,   402,   403,   404,   405,   406,   407,   408,   409,
     410,  1048,  1049,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,  1050,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1051,   443,   444,   445,   446,   447,  1052,  1053,
     450,   451,   452,   453,   454,   455,  1054,   457,   458,   459,
     460,   461,   462,  1055,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,  1056,   494,   495,   496,   497,   498,  1057,
    1058,   501,   502,   503,   504,   505,  1059,   507,   508,   509,
     510,   511,   512,  1060,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,  1061,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,  1062,  1063,  1064,  1065,   565,   566,   567,  1066,
    1067,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,  1068,   584,  1069,   586,   587,   588,
     589,   590,   591,   592,   593,   594,  1070,  1071,   597,  1072,
     599,   600,   601,     0,   602,   603,   604,  1073,     0,     0,
       0,   940,   941,   942,   943,   944,  1074,  1075,     0,     0,
       0,     0,  1076,   945,   946,     0,   947,  1077,     0,     0,
       0,  1078,  1079,   948,   949,  1080,  1081,   950,   951,   952,
     953,     0,   954,   955,     0,   956,   957,     0,     0,     0,
       0,   958,     0,     0,     0,   959,     0,     0,   960,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   961,   962,
     963,     0,   964,   965,     0,     0,     0,     0,     0,  2961,
       0,     0,     0,     0,     0,   966,   967,   968,     0,   969,
     970,     0,     0,     0,   971,   972,   973,     0,     0,     0,
       0,     0,     0,     0,   974,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   977,     0,     0,     0,     0,   978,   979,
       0,   980,     0,     0,     0,     0,     0,   981,     0,   982,
       0,     0,   983,     0,     0,   984,   985,   986,     0,   987,
     988,   989,     0,   990,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,     0,   992,   993,   994,     0,   995,     0,     0,     0,
       0,     0,     0,   996,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,   999,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1000,     0,     0,     0,     0,
       0,  1001,  1002,     0,  1003,  1004,     0,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,     0,     0,     0,     0,  1012,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
    1014,  1015,  1016,   183,   184,   185,  1017,   187,   188,   189,
     190,   191,   192,  1018,   194,   195,   196,   197,   198,   199,
     200,  1019,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,  1020,   217,   218,
     219,   220,   221,   222,   223,   224,  1021,   226,  1022,  1023,
     228,  1024,  1025,  1026,  1027,  1028,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
    1029,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1030,  1031,  1032,   262,  1033,  1034,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,  1035,   308,   309,   310,   311,   312,
    1036,   314,  1037,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,  1038,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1039,  1040,   350,   351,
     352,  1041,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,  1042,
     392,  1043,   394,   395,   396,   397,  1044,  1045,  1046,  1047,
     402,   403,   404,   405,   406,   407,   408,   409,   410,  1048,
    1049,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,  1050,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
    1051,   443,   444,   445,   446,   447,  1052,  1053,   450,   451,
     452,   453,   454,   455,  1054,   457,   458,   459,   460,   461,
     462,  1055,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,  1056,   494,   495,   496,   497,   498,  1057,  1058,   501,
     502,   503,   504,   505,  1059,   507,   508,   509,   510,   511,
     512,  1060,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,  1061,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
    1062,  1063,  1064,  1065,   565,   566,   567,  1066,  1067,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,  1068,   584,  1069,   586,   587,   588,   589,   590,
     591,   592,   593,   594,  1070,  1071,   597,  1072,   599,   600,
     601,     0,   602,   603,   604,  1073,     0,     0,     0,   940,
     941,   942,   943,   944,  1074,  1075,     0,     0,     0,     0,
    1076,   945,   946,     0,   947,  1077,     0,     0,     0,  1078,
    1079,   948,   949,  1080,  1081,   950,   951,   952,   953,     0,
     954,   955,     0,   956,   957,     0,     0,     0,     0,   958,
       0,     0,     0,   959,     0,     0,   960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   961,   962,   963,     0,
     964,   965,     0,     0,     0,     0,     0,  2963,     0,     0,
       0,     0,     0,   966,   967,   968,     0,   969,   970,     0,
       0,     0,   971,   972,   973,     0,     0,     0,     0,     0,
       0,     0,   974,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   977,     0,     0,     0,     0,   978,   979,     0,   980,
       0,     0,     0,     0,     0,   981,     0,   982,     0,     0,
     983,     0,     0,   984,   985,   986,     0,   987,   988,   989,
       0,   990,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
     992,   993,   994,     0,   995,     0,     0,     0,     0,     0,
       0,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,   999,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1000,     0,     0,     0,     0,     0,  1001,
    1002,     0,  1003,  1004,     0,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,     0,     0,     0,     0,  1012,     0,  1013,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,  1014,  1015,
    1016,   183,   184,   185,  1017,   187,   188,   189,   190,   191,
     192,  1018,   194,   195,   196,   197,   198,   199,   200,  1019,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,  1020,   217,   218,   219,   220,
     221,   222,   223,   224,  1021,   226,  1022,  1023,   228,  1024,
    1025,  1026,  1027,  1028,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,  1029,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1030,  1031,  1032,   262,  1033,  1034,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,  1035,   308,   309,   310,   311,   312,  1036,   314,
    1037,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,  1038,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1039,  1040,   350,   351,   352,  1041,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1042,   392,  1043,
     394,   395,   396,   397,  1044,  1045,  1046,  1047,   402,   403,
     404,   405,   406,   407,   408,   409,   410,  1048,  1049,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,  1050,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,  1051,   443,
     444,   445,   446,   447,  1052,  1053,   450,   451,   452,   453,
     454,   455,  1054,   457,   458,   459,   460,   461,   462,  1055,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,  1056,
     494,   495,   496,   497,   498,  1057,  1058,   501,   502,   503,
     504,   505,  1059,   507,   508,   509,   510,   511,   512,  1060,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  1061,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,  1062,  1063,
    1064,  1065,   565,   566,   567,  1066,  1067,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
    1068,   584,  1069,   586,   587,   588,   589,   590,   591,   592,
     593,   594,  1070,  1071,   597,  1072,   599,   600,   601,     0,
     602,   603,   604,  1073,     0,     0,     0,   940,   941,   942,
     943,   944,  1074,  1075,     0,     0,     0,     0,  1076,   945,
     946,     0,   947,  1077,     0,     0,     0,  1078,  1079,   948,
     949,  1080,  1081,   950,   951,   952,   953,     0,   954,   955,
       0,   956,   957,     0,     0,     0,     0,   958,     0,     0,
       0,  4694,     0,     0,   960,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   961,   962,   963,     0,   964,   965,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   966,   967,   968,     0,   969,   970,     0,     0,     0,
     971,   972,   973,     0,  2584,     0,     0,     0,     0,     0,
     974,     0,   975,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   976,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   977,
       0,     0,     0,     0,   978,   979,     0,   980,     0,     0,
       0,     0,     0,   981,     0,   982,     0,     0,   983,     0,
       0,   984,   985,   986,     0,   987,   988,   989,     0,   990,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,     0,     0,     0,   992,   993,
     994,     0,   995,     0,     0,     0,     0,     0,     0,   996,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,   999,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1000,     0,     0,     0,     0,     0,  1001,  1002,     0,
    1003,  1004,     0,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,     0,
       0,     0,     0,  1012,     0,  1013,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,  1014,  1015,  1016,   183,
     184,   185,  1017,   187,   188,   189,   190,   191,   192,  1018,
     194,   195,   196,   197,   198,   199,   200,  1019,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,  1020,   217,   218,   219,   220,   221,   222,
     223,   224,  1021,   226,  1022,  1023,   228,  1024,  1025,  1026,
    1027,  1028,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,  1029,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1030,  1031,
    1032,   262,  1033,  1034,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
    1035,   308,   309,   310,   311,   312,  1036,   314,  1037,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
    1038,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,  1039,  1040,   350,   351,   352,  1041,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,  1042,   392,  1043,   394,   395,
     396,   397,  1044,  1045,  1046,  1047,   402,   403,   404,   405,
     406,   407,   408,   409,   410,  1048,  1049,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,  1050,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1051,   443,   444,   445,
     446,   447,  1052,  1053,   450,   451,   452,   453,   454,   455,
    1054,   457,   458,   459,   460,   461,   462,  1055,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,  1056,   494,   495,
     496,   497,   498,  1057,  1058,   501,   502,   503,   504,   505,
    1059,   507,   508,   509,   510,   511,   512,  1060,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,  1061,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,  1062,  1063,  1064,  1065,
     565,   566,   567,  1066,  1067,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,  1068,   584,
    1069,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    1070,  1071,   597,  1072,   599,   600,   601,     0,   602,   603,
     604,  1073,     0,     0,     0,   940,   941,   942,   943,   944,
    1074,  1075,     0,     0,     0,     0,  1076,   945,   946,     0,
     947,  1077,     0,     0,     0,  1078,  1079,   948,   949,  1080,
    1081,   950,   951,   952,   953,     0,   954,   955,     0,   956,
     957,     0,     0,     0,     0,   958,     0,     0,     0,   959,
       0,     0,   960,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   961,   962,   963,     0,   964,   965,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
     967,   968,     0,   969,   970,     0,     0,     0,   971,   972,
     973,     0,     0,     0,     0,     0,     0,     0,   974,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   977,     0,     0,
       0,     0,   978,   979,     0,   980,     0,     0,     0,     0,
       0,   981,     0,   982,     0,     0,   983,     0,     0,   984,
     985,   986,     0,   987,   988,   989,     0,   990,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   991,     0,     0,     0,   992,   993,   994,     0,
     995,     0,     0,     0,     0,     0,     0,   996,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,   999,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1000,
       0,     0,     0,     0,     0,  1001,  1002,     0,  1003,  1004,
       0,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,     0,     0,     0,
       0,  1012,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,  1014,  1015,  1016,   183,   184,   185,
    1017,   187,   188,   189,   190,   191,   192,  1018,   194,   195,
     196,   197,   198,   199,   200,  1019,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,  1020,   217,   218,   219,   220,   221,   222,   223,   224,
    1021,   226,  1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,  1029,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1030,  1031,  1032,   262,
    1033,  1034,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,  1035,   308,
     309,   310,   311,   312,  1036,   314,  1037,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,  1038,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1039,  1040,   350,   351,   352,  1041,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,  1042,   392,  1043,   394,   395,   396,   397,
    1044,  1045,  1046,  1047,   402,   403,   404,   405,   406,   407,
     408,   409,   410,  1048,  1049,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
    1050,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,  1051,   443,   444,   445,   446,   447,
    1052,  1053,   450,   451,   452,   453,   454,   455,  1054,   457,
     458,   459,   460,   461,   462,  1055,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,  1056,   494,   495,   496,   497,
     498,  1057,  1058,   501,   502,   503,   504,   505,  1059,   507,
     508,   509,   510,   511,   512,  1060,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,  1061,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,  1062,  1063,  1064,  1065,   565,   566,
     567,  1066,  1067,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,  1068,   584,  1069,   586,
     587,   588,   589,   590,   591,   592,   593,   594,  1070,  1071,
     597,  1072,   599,   600,   601,     0,   602,   603,   604,  1073,
       0,     0,     0,   940,   941,   942,   943,   944,  1074,  1075,
       0,     0,     0,     0,  1076,   945,   946,     0,   947,  1077,
       0,     0,     0,  1078,  1079,   948,   949,  1080,  1081,   950,
     951,   952,   953,     0,   954,   955,     0,   956,   957,     0,
       0,     0,     0,   958,     0,     0,     0,   959,     0,     0,
     960,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     961,   962,   963,     0,   964,   965,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   966,   967,   968,
       0,   969,   970,     0,     0,     0,   971,   972,   973,     0,
       0,     0,     0,     0,     0,     0,   974,     0,   975,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   977,     0,     0,     0,     0,
     978,   979,     0,   980,     0,     0,     0,     0,     0,   981,
       0,   982,     0,     0,   983,     0,     0,   984,   985,   986,
       0,   987,   988,   989,     0,   990,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     991,     0,     0,     0,   992,   993,   994,     0,   995,     0,
       0,     0,     0,     0,     0,   996,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,   999,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1000,     0,     0,
       0,     0,     0,  1001,  1002,     0,  1003,  1004,     0,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,     0,     0,     0,     0,  1012,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,  1014,  1015,  1016,   183,   184,   185,  1017,   187,
     188,   189,   190,   191,   192,  1018,   194,   195,   196,   197,
     198,   199,   200,  1019,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,  1020,
     217,   218,   219,   220,   221,   222,   223,   224,  1021,   226,
    1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,  1029,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1030,  1031,  1032,   262,  1033,  1034,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,  1035,   308,   309,   310,
     311,   312,  1036,   314,  1037,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,  1038,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1039,  1040,
     350,   351,   352,  1041,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,  1042,   392,  1043,   394,   395,   396,   397,  1044,  1045,
    1046,  1047,   402,   403,   404,   405,   406,   407,   408,   409,
     410,  1048,  1049,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,  1050,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1051,   443,   444,   445,   446,   447,  1052,  1053,
     450,   451,   452,   453,   454,   455,  1054,   457,   458,   459,
     460,   461,   462,  1055,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,  1056,   494,   495,   496,   497,   498,  1057,
    1058,   501,   502,   503,   504,   505,  1059,   507,   508,   509,
     510,   511,   512,  1060,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,  1061,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,  1062,  1063,  1064,  1065,   565,   566,   567,  1066,
    1067,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,  1068,   584,  1069,   586,   587,   588,
     589,   590,   591,   592,   593,   594,  1070,  1071,   597,  1072,
     599,   600,   601,     0,   602,   603,   604,  1073,     0,     0,
       0,   940,   941,   942,   943,   944,  1074,  1075,     0,     0,
       0,     0,  1076,   945,   946,     0,   947,  1577,     0,     0,
       0,  1078,  1079,   948,   949,  1080,  1081,   950,   951,   952,
     953,     0,   954,   955,     0,   956,   957,     0,     0,     0,
       0,   958,     0,     0,     0,   959,     0,     0,   960,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   961,   962,
     963,     0,   964,   965,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   966,   967,   968,     0,   969,
     970,     0,     0,     0,   971,   972,   973,     0,     0,     0,
       0,     0,     0,     0,   974,     0,   975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   977,     0,     0,     0,     0,   978,   979,
       0,   980,     0,     0,     0,     0,     0,   981,     0,   982,
       0,     0,   983,     0,     0,   984,   985,   986,     0,   987,
     988,   989,     0,   990,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,     0,   992,   993,   994,     0,   995,     0,     0,     0,
       0,     0,     0,   996,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,   999,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1000,     0,     0,     0,     0,
       0,  1001,  1002,     0,  1003,  1004,     0,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,     0,     0,     0,     0,  1012,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
    1014,  1015,  1016,   183,   184,   185,  1017,   187,   188,   189,
     190,   191,   192,  1018,   194,   195,   196,   197,   198,   199,
     200,  1019,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,  1020,   217,   218,
     219,   220,   221,   222,   223,   224,  1021,   226,  1022,  1023,
     228,  1024,  1025,  1026,  1027,  1028,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
    1029,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1030,  1031,  1032,   262,  1033,  1034,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,  1035,   308,   309,   310,   311,   312,
    1036,   314,  1037,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,  1038,  2151,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1039,  1040,   350,   351,
     352,  1041,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,  1042,
     392,  1043,   394,   395,   396,   397,  1044,  1045,  1046,  1047,
     402,   403,   404,   405,   406,   407,   408,   409,   410,  1048,
    1049,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,  1050,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
    1051,   443,   444,   445,   446,   447,  1052,  1053,   450,   451,
     452,   453,   454,   455,  1054,   457,   458,   459,   460,   461,
     462,  1055,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,  1056,   494,   495,   496,   497,   498,  1057,  1058,   501,
     502,   503,   504,   505,  1059,   507,   508,   509,   510,   511,
     512,  1060,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,  1061,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
    1062,  1063,  1064,  1065,   565,   566,   567,  1066,  1067,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,  2152,   584,  1069,   586,   587,   588,   589,   590,
     591,   592,   593,   594,  1070,  1071,   597,  1072,   599,   600,
     601,     0,   602,   603,   604,  1073,     0,     0,     0,   940,
     941,   942,   943,   944,  1074,  1075,     0,     0,     0,     0,
    1076,   945,   946,     0,   947,  1077,     0,     0,     0,  1078,
    1079,   948,   949,  1080,  1081,   950,   951,   952,   953,     0,
     954,   955,     0,   956,   957,     0,     0,     0,     0,   958,
       0,     0,     0,   959,     0,     0,   960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   961,   962,   963,     0,
     964,   965,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   966,   967,   968,     0,   969,   970,     0,
       0,     0,   971,   972,   973,     0,     0,     0,     0,     0,
       0,     0,   974,     0,   975,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   977,     0,     0,     0,     0,   978,   979,     0,   980,
       0,     0,     0,     0,     0,   981,     0,   982,     0,     0,
     983,     0,     0,   984,   985,   986,     0,   987,   988,   989,
       0,   990,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
     992,   993,   994,     0,   995,     0,     0,     0,     0,     0,
       0,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,   999,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1000,     0,     0,     0,     0,     0,  1001,
    1002,     0,  1003,  1004,     0,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,     0,     0,     0,     0,  1012,     0,  1013,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,  1014,  1015,
    1016,   183,   184,   185,  1017,   187,   188,   189,   190,   191,
     192,  1018,   194,   195,   196,   197,   198,   199,   200,  1019,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,  1020,   217,   218,   219,   220,
     221,   222,   223,   224,  1021,   226,  1022,  1023,   228,  1024,
    1025,  1026,  1027,  1028,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,  1029,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1030,  1031,  1032,   262,  1033,  1034,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,  1035,   308,   309,   310,   311,   312,  1036,   314,
    1037,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,  1038,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1039,  1040,   350,   351,   352,  1041,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1042,   392,  1043,
     394,   395,   396,   397,  1044,  1045,  1046,  1047,   402,   403,
     404,   405,   406,   407,   408,   409,   410,  1048,  1049,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,  1050,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,  1051,   443,
     444,   445,   446,   447,  1052,  1053,   450,   451,   452,   453,
     454,   455,  1054,   457,   458,   459,   460,   461,   462,  1055,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,  1056,
     494,   495,   496,   497,   498,  1057,  1058,   501,   502,   503,
     504,   505,  1059,   507,   508,   509,   510,   511,   512,  1060,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  1061,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,  1062,  1063,
    1064,  1065,   565,   566,   567,  1066,  1067,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
    2152,   584,  1069,   586,   587,   588,   589,   590,   591,   592,
     593,   594,  1070,  1071,   597,  1072,   599,   600,   601,     0,
     602,   603,   604,  1073,     0,     0,     0,   940,   941,   942,
     943,   944,  1074,  1075,     0,     0,     0,     0,  1076,   945,
     946,     0,   947,  1077,     0,     0,     0,  1078,  1079,   948,
     949,  1080,  1081,   950,   951,   952,   953,     0,   954,   955,
       0,   956,   957,     0,     0,     0,     0,   958,     0,     0,
       0,   959,     0,     0,   960,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   961,   962,   963,     0,   964,   965,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   966,   967,   968,     0,   969,   970,     0,     0,     0,
     971,   972,   973,     0,     0,     0,     0,     0,     0,     0,
     974,     0,  3555,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   976,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   977,
       0,     0,     0,     0,   978,   979,     0,   980,     0,     0,
       0,     0,     0,   981,     0,   982,     0,     0,   983,     0,
       0,   984,   985,   986,     0,   987,   988,   989,     0,   990,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,     0,     0,     0,   992,   993,
     994,     0,   995,     0,     0,     0,     0,     0,     0,   996,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,   999,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1000,     0,     0,     0,     0,     0,  1001,  1002,     0,
    1003,  1004,     0,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,     0,
       0,     0,     0,  1012,     0,  1013,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,  1014,  1015,  1016,   183,
     184,   185,  1017,   187,   188,   189,   190,   191,   192,  1018,
     194,   195,   196,   197,   198,   199,   200,  1019,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,  1020,   217,   218,   219,   220,   221,   222,
     223,   224,  1021,   226,  1022,  1023,   228,  1024,  1025,  1026,
    1027,  1028,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,  1029,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1030,  1031,
    1032,   262,  1033,  1034,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
    1035,   308,   309,   310,   311,   312,  1036,   314,  1037,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
    1038,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,  1039,  1040,   350,   351,   352,  1041,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,  1042,   392,  1043,   394,   395,
     396,   397,  1044,  1045,  1046,  1047,   402,   403,   404,   405,
     406,   407,   408,   409,   410,  1048,  1049,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,  1050,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1051,   443,   444,   445,
     446,   447,  1052,  1053,   450,   451,   452,   453,   454,   455,
    1054,   457,   458,   459,   460,   461,   462,  1055,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,  1056,   494,   495,
     496,   497,   498,  1057,  1058,   501,   502,   503,   504,   505,
    1059,   507,   508,   509,   510,   511,   512,  1060,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,  1061,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,  1062,  1063,  1064,  1065,
     565,   566,   567,  1066,  1067,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,  1068,   584,
    1069,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    1070,  1071,   597,  1072,   599,   600,   601,     0,   602,   603,
     604,  1073,     0,     0,     0,   940,   941,   942,   943,   944,
    1074,  1075,     0,     0,     0,     0,  1076,   945,   946,     0,
     947,  1077,     0,     0,     0,  1078,  1079,   948,   949,  1080,
    1081,   950,   951,   952,   953,     0,   954,   955,     0,   956,
     957,     0,     0,     0,     0,   958,     0,     0,     0,   959,
       0,     0,   960,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   961,   962,   963,     0,   964,   965,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
     967,   968,     0,   969,   970,     0,     0,     0,   971,   972,
     973,     0,     0,     0,     0,     0,     0,     0,   974,     0,
    3577,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   977,     0,     0,
       0,     0,   978,   979,     0,   980,     0,     0,     0,     0,
       0,   981,     0,   982,     0,     0,   983,     0,     0,   984,
     985,   986,     0,   987,   988,   989,     0,   990,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   991,     0,     0,     0,   992,   993,   994,     0,
     995,     0,     0,     0,     0,     0,     0,   996,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,   999,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1000,
       0,     0,     0,     0,     0,  1001,  1002,     0,  1003,  1004,
       0,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,     0,     0,     0,
       0,  1012,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,  1014,  1015,  1016,   183,   184,   185,
    1017,   187,   188,   189,   190,   191,   192,  1018,   194,   195,
     196,   197,   198,   199,   200,  1019,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,  1020,   217,   218,   219,   220,   221,   222,   223,   224,
    1021,   226,  1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,  1029,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1030,  1031,  1032,   262,
    1033,  1034,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,  1035,   308,
     309,   310,   311,   312,  1036,   314,  1037,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,  1038,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1039,  1040,   350,   351,   352,  1041,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,  1042,   392,  1043,   394,   395,   396,   397,
    1044,  1045,  1046,  1047,   402,   403,   404,   405,   406,   407,
     408,   409,   410,  1048,  1049,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
    1050,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,  1051,   443,   444,   445,   446,   447,
    1052,  1053,   450,   451,   452,   453,   454,   455,  1054,   457,
     458,   459,   460,   461,   462,  1055,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,  1056,   494,   495,   496,   497,
     498,  1057,  1058,   501,   502,   503,   504,   505,  1059,   507,
     508,   509,   510,   511,   512,  1060,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,  1061,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,  1062,  1063,  1064,  1065,   565,   566,
     567,  1066,  1067,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,  1068,   584,  1069,   586,
     587,   588,   589,   590,   591,   592,   593,   594,  1070,  1071,
     597,  1072,   599,   600,   601,     0,   602,   603,   604,  1073,
       0,     0,     0,   940,   941,   942,   943,   944,  1074,  1075,
       0,     0,     0,     0,  1076,   945,   946,     0,   947,  1077,
       0,     0,     0,  1078,  1079,   948,   949,  1080,  1081,   950,
     951,   952,   953,     0,   954,   955,     0,   956,   957,     0,
       0,     0,     0,   958,     0,     0,     0,   959,     0,     0,
     960,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     961,   962,   963,     0,   964,   965,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   966,   967,   968,
       0,   969,   970,     0,     0,     0,   971,   972,   973,     0,
       0,     0,     0,     0,     0,     0,   974,     0,   975,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   977,     0,     0,     0,     0,
     978,   979,  5785,   980,     0,     0,     0,     0,     0,   981,
       0,   982,     0,     0,   983,     0,     0,   984,     0,   986,
       0,   987,   988,   989,     0,   990,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     991,     0,     0,     0,   992,   993,   994,     0,   995,     0,
       0,     0,     0,     0,     0,   996,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,   999,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1000,     0,     0,
       0,     0,     0,  1001,  1002,     0,  1003,  1004,     0,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,     0,     0,     0,     0,  1012,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,  1014,  1015,  1016,   183,   184,   185,  1017,   187,
     188,   189,   190,   191,   192,  1018,   194,   195,   196,   197,
     198,   199,   200,  1019,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,  1020,
     217,   218,   219,   220,   221,   222,   223,   224,  1021,   226,
    1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,  1029,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1030,  1031,  1032,   262,  1033,  1034,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,  1035,   308,   309,   310,
     311,   312,  1036,   314,  1037,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,  1038,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1039,  1040,
     350,   351,   352,  1041,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,  1042,   392,  1043,   394,   395,   396,   397,  1044,  1045,
    1046,  1047,   402,   403,   404,   405,   406,   407,   408,   409,
     410,  1048,  1049,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,  1050,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1051,   443,   444,   445,   446,   447,  1052,  1053,
     450,   451,   452,   453,   454,   455,  1054,   457,   458,   459,
     460,   461,   462,  1055,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,  1056,   494,   495,   496,   497,   498,  1057,
    1058,   501,   502,   503,   504,   505,  1059,   507,   508,   509,
     510,   511,   512,  1060,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,  1061,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,  1062,  1063,  1064,  1065,   565,   566,   567,  1066,
    1067,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,  1068,   584,  1069,   586,   587,   588,
     589,   590,   591,   592,   593,   594,  1070,  1071,   597,  1072,
     599,   600,   601,     0,   602,   603,   604,  1073,     0,     0,
       0,   940,   941,   942,   943,   944,  1074,  1075,     0,     0,
       0,     0,  1076,   945,   946,     0,   947,  1077,     0,     0,
       0,  1078,  1079,   948,   949,  1080,  1081,   950,   951,   952,
     953,     0,   954,   955,     0,   956,   957,     0,     0,     0,
       0,   958,     0,     0,     0,   959,     0,     0,   960,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   961,   962,
     963,     0,   964,   965,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   966,   967,   968,     0,   969,
     970,     0,     0,     0,   971,   972,   973,     0,     0,     0,
       0,     0,     0,     0,   974,     0,  1543,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   977,     0,     0,     0,     0,   978,   979,
       0,   980,     0,     0,     0,     0,     0,   981,     0,   982,
       0,     0,   983,     0,     0,   984,     0,   986,     0,   987,
     988,   989,     0,   990,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,     0,   992,   993,   994,     0,   995,     0,     0,     0,
       0,     0,     0,   996,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,   999,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1000,     0,     0,     0,     0,
       0,  1001,  1002,     0,  1003,  1004,     0,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,     0,     0,     0,     0,  1012,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
    1014,  1015,  1016,   183,   184,   185,  1017,   187,   188,   189,
     190,   191,   192,  1018,   194,   195,   196,   197,   198,   199,
     200,  1019,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,  1020,   217,   218,
     219,   220,   221,   222,   223,   224,  1021,   226,  1022,  1023,
     228,  1024,  1025,  1026,  1027,  1028,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
    1029,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1030,  1031,  1032,   262,  1033,  1034,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,  1035,   308,   309,   310,   311,   312,
    1036,   314,  1037,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,  1038,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1039,  1040,   350,   351,
     352,  1041,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,  1042,
     392,  1043,   394,   395,   396,   397,  1044,  1045,  1046,  1047,
     402,   403,   404,   405,   406,   407,   408,   409,   410,  1048,
    1049,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,  1050,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
    1051,   443,   444,   445,   446,   447,  1052,  1053,   450,   451,
     452,   453,   454,   455,  1054,   457,   458,   459,   460,   461,
     462,  1055,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,  1056,   494,   495,   496,   497,   498,  1057,  1058,   501,
     502,   503,   504,   505,  1059,   507,   508,   509,   510,   511,
     512,  1060,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,  1061,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
    1062,  1063,  1064,  1065,   565,   566,   567,  1066,  1067,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,  1068,   584,  1069,   586,   587,   588,   589,   590,
     591,   592,   593,   594,  1070,  1071,   597,  1072,   599,   600,
     601,     0,   602,   603,   604,  1073,     0,     0,     0,   940,
     941,   942,   943,   944,  1544,  1545,     0,     0,     0,     0,
    1076,   945,   946,     0,   947,  1077,     0,     0,     0,  1078,
    1079,   948,   949,  1080,  1081,   950,   951,   952,   953,     0,
     954,   955,     0,   956,   957,     0,     0,     0,     0,   958,
       0,     0,     0,   959,     0,     0,   960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   961,   962,   963,     0,
     964,   965,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   966,   967,   968,     0,   969,   970,     0,
       0,     0,   971,   972,   973,     0,     0,     0,     0,     0,
       0,     0,   974,     0,  1681,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   977,     0,     0,     0,     0,   978,   979,     0,   980,
       0,     0,     0,     0,     0,   981,     0,   982,     0,     0,
     983,     0,     0,   984,     0,   986,     0,   987,   988,   989,
       0,   990,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
     992,   993,   994,     0,   995,     0,     0,     0,     0,     0,
       0,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,   999,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1000,     0,     0,     0,     0,     0,  1001,
    1002,     0,  1003,  1004,     0,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,     0,     0,     0,     0,  1012,     0,  1013,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,  1014,  1015,
    1016,   183,   184,   185,  1017,   187,   188,   189,   190,   191,
     192,  1018,   194,   195,   196,   197,   198,   199,   200,  1019,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,  1020,   217,   218,   219,   220,
     221,   222,   223,   224,  1021,   226,  1022,  1023,   228,  1024,
    1025,  1026,  1027,  1028,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,  1029,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1030,  1031,  1032,   262,  1033,  1034,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,  1035,   308,   309,   310,   311,   312,  1036,   314,
    1037,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,  1038,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1039,  1040,   350,   351,   352,  1041,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1042,   392,  1043,
     394,   395,   396,   397,  1044,  1045,  1046,  1047,   402,   403,
     404,   405,   406,   407,   408,   409,   410,  1048,  1049,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,  1050,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,  1051,   443,
     444,   445,   446,   447,  1052,  1053,   450,   451,   452,   453,
     454,   455,  1054,   457,   458,   459,   460,   461,   462,  1055,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,  1056,
     494,   495,   496,   497,   498,  1057,  1058,   501,   502,   503,
     504,   505,  1059,   507,   508,   509,   510,   511,   512,  1060,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  1061,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,  1062,  1063,
    1064,  1065,   565,   566,   567,  1066,  1067,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
    1068,   584,  1069,   586,   587,   588,   589,   590,   591,   592,
     593,   594,  1070,  1071,   597,  1072,   599,   600,   601,     0,
     602,   603,   604,  1073,     0,     0,     0,   940,   941,   942,
     943,   944,  1544,  1545,     0,     0,     0,     0,  1076,   945,
     946,     0,   947,  1077,     0,     0,     0,  1078,  1079,   948,
     949,  1080,  1081,   950,   951,   952,   953,     0,   954,   955,
       0,   956,   957,     0,     0,     0,     0,   958,     0,     0,
       0,   959,     0,     0,   960,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   961,   962,   963,     0,   964,   965,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   966,   967,   968,     0,   969,   970,     0,     0,     0,
     971,   972,   973,     0,     0,     0,     0,     0,     0,     0,
     974,     0,  1683,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   976,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   977,
       0,     0,     0,     0,   978,   979,     0,   980,     0,     0,
       0,     0,     0,   981,     0,   982,     0,     0,   983,     0,
       0,   984,     0,   986,     0,   987,   988,   989,     0,   990,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,     0,     0,     0,   992,   993,
     994,     0,   995,     0,     0,     0,     0,     0,     0,   996,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     997,     0,     0,     0,     0,     0,     0,     0,   998,     0,
       0,   999,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1000,     0,     0,     0,     0,     0,  1001,  1002,     0,
    1003,  1004,     0,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1009,  1010,  1011,     0,     0,
       0,     0,     0,  1012,     0,  1013,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,  1014,  1015,  1016,   183,
     184,   185,  1017,   187,   188,   189,   190,   191,   192,  1018,
     194,   195,   196,   197,   198,   199,   200,  1019,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,  1020,   217,   218,   219,   220,   221,   222,
     223,   224,  1021,   226,  1022,  1023,   228,  1024,  1025,  1026,
    1027,  1028,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,  1029,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,  1030,  1031,
    1032,   262,  1033,  1034,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
    1035,   308,   309,   310,   311,   312,  1036,   314,  1037,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
    1038,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,  1039,  1040,   350,   351,   352,  1041,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,  1042,   392,  1043,   394,   395,
     396,   397,  1044,  1045,  1046,  1047,   402,   403,   404,   405,
     406,   407,   408,   409,   410,  1048,  1049,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,  1050,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1051,   443,   444,   445,
     446,   447,  1052,  1053,   450,   451,   452,   453,   454,   455,
    1054,   457,   458,   459,   460,   461,   462,  1055,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,  1056,   494,   495,
     496,   497,   498,  1057,  1058,   501,   502,   503,   504,   505,
    1059,   507,   508,   509,   510,   511,   512,  1060,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,  1061,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,  1062,  1063,  1064,  1065,
     565,   566,   567,  1066,  1067,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,  1068,   584,
    1069,   586,   587,   588,   589,   590,   591,   592,   593,   594,
    1070,  1071,   597,  1072,   599,   600,   601,     0,   602,   603,
     604,  1073,     0,     0,     0,   940,   941,   942,   943,   944,
    1544,  1545,     0,     0,     0,     0,  1076,   945,   946,     0,
     947,  1077,     0,     0,     0,  1078,  1079,   948,   949,  1080,
    1081,   950,   951,   952,   953,     0,   954,   955,     0,   956,
     957,     0,     0,     0,     0,   958,     0,     0,     0,   959,
       0,     0,   960,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   961,   962,   963,     0,   964,   965,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   966,
     967,   968,     0,   969,   970,     0,     0,     0,   971,   972,
     973,     0,     0,     0,     0,     0,     0,     0,   974,     0,
     975,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   976,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   977,     0,     0,
       0,     0,   978,   979,     0,   980,     0,     0,     0,     0,
       0,   981,     0,   982,     0,     0,   983,     0,     0,   984,
       0,   986,     0,   987,   988,   989,     0,   990,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   991,     0,     0,     0,   992,   993,   994,     0,
     995,     0,     0,     0,     0,     0,     0,   996,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   997,     0,
       0,     0,     0,     0,     0,     0,   998,     0,     0,   999,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1000,
       0,     0,     0,     0,     0,  1001,  1002,     0,  1003,  1004,
       0,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1009,  1010,  1011,     0,     0,     0,     0,
       0,  1012,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,  1014,  1015,  1016,   183,   184,   185,
    1017,   187,   188,   189,   190,   191,   192,  1018,   194,   195,
     196,   197,   198,   199,   200,  1019,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,  1020,   217,   218,   219,   220,   221,   222,   223,   224,
    1021,   226,  1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,  1029,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,  1030,  1031,  1032,   262,
    1033,  1034,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,  1035,   308,
     309,   310,   311,   312,  1036,   314,  1037,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,  1038,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1039,  1040,   350,   351,   352,  1041,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,  1042,   392,  1043,   394,   395,   396,   397,
    1044,  1045,  1046,  1047,   402,   403,   404,   405,   406,   407,
     408,   409,   410,  1048,  1049,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
    1050,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,  1051,   443,   444,   445,   446,   447,
    1052,  1053,   450,   451,   452,   453,   454,   455,  1054,   457,
     458,   459,   460,   461,   462,  1055,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,  1056,   494,   495,   496,   497,
     498,  1057,  1058,   501,   502,   503,   504,   505,  1059,   507,
     508,   509,   510,   511,   512,  1060,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,  1061,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,  1062,  1063,  1064,  1065,   565,   566,
     567,  1066,  1067,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,  1068,   584,  1069,   586,
     587,   588,   589,   590,   591,   592,   593,   594,  1070,  1071,
     597,  1072,   599,   600,   601,     0,   602,   603,   604,  1073,
       0,     0,     0,   940,   941,   942,   943,   944,  1074,  1075,
       0,     0,     0,     0,  1076,   945,   946,     0,   947,  1077,
       0,     0,     0,  1078,  1079,   948,   949,  1080,  1081,   950,
     951,   952,   953,     0,   954,   955,     0,   956,   957,     0,
       0,     0,     0,   958,     0,     0,     0,   959,     0,     0,
     960,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     961,   962,   963,     0,   964,   965,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   966,   967,   968,
       0,   969,   970,     0,     0,     0,   971,   972,   973,     0,
       0,     0,     0,     0,     0,     0,   974,     0,  2403,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   976,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   977,     0,     0,     0,     0,
     978,   979,     0,   980,     0,     0,     0,     0,     0,   981,
       0,   982,     0,     0,   983,     0,     0,   984,     0,   986,
       0,   987,   988,   989,     0,   990,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     991,     0,     0,     0,   992,   993,   994,     0,   995,     0,
       0,     0,     0,     0,     0,   996,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   997,     0,     0,     0,
       0,     0,     0,     0,   998,     0,     0,   999,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1000,     0,     0,
       0,     0,     0,  1001,  1002,     0,  1003,  1004,     0,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1009,  1010,  1011,     0,     0,     0,     0,     0,  1012,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,  1014,  1015,  1016,   183,   184,   185,  1017,   187,
     188,   189,   190,   191,   192,  1018,   194,   195,   196,   197,
     198,   199,   200,  1019,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,  1020,
     217,   218,   219,   220,   221,   222,   223,   224,  1021,   226,
    1022,  1023,   228,  1024,  1025,  1026,  1027,  1028,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,  1029,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,  1030,  1031,  1032,   262,  1033,  1034,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,  1035,   308,   309,   310,
     311,   312,  1036,   314,  1037,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,  1038,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1039,  1040,
     350,   351,   352,  1041,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,  1042,   392,  1043,   394,   395,   396,   397,  1044,  1045,
    1046,  1047,   402,   403,   404,   405,   406,   407,   408,   409,
     410,  1048,  1049,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,  1050,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1051,   443,   444,   445,   446,   447,  1052,  1053,
     450,   451,   452,   453,   454,   455,  1054,   457,   458,   459,
     460,   461,   462,  1055,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,  1056,   494,   495,   496,   497,   498,  1057,
    1058,   501,   502,   503,   504,   505,  1059,   507,   508,   509,
     510,   511,   512,  1060,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,  1061,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,  1062,  1063,  1064,  1065,   565,   566,   567,  1066,
    1067,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,  1068,   584,  1069,   586,   587,   588,
     589,   590,   591,   592,   593,   594,  1070,  1071,   597,  1072,
     599,   600,   601,     0,   602,   603,   604,  1073,     0,     0,
       0,   940,   941,   942,   943,   944,  1074,  1075,     0,     0,
       0,     0,  1076,   945,   946,     0,   947,  1077,     0,     0,
       0,  1078,  1079,   948,   949,  1080,  1081,   950,   951,   952,
     953,     0,   954,   955,     0,   956,   957,     0,     0,     0,
       0,   958,     0,     0,     0,   959,     0,     0,   960,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   961,   962,
     963,     0,   964,   965,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   966,   967,   968,     0,   969,
     970,     0,     0,     0,   971,   972,   973,     0,     0,     0,
       0,     0,     0,     0,   974,     0,  2405,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   976,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   977,     0,     0,     0,     0,   978,   979,
       0,   980,     0,     0,     0,     0,     0,   981,     0,   982,
       0,     0,   983,     0,     0,   984,     0,   986,     0,   987,
     988,   989,     0,   990,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   991,     0,
       0,     0,   992,   993,   994,     0,   995,     0,     0,     0,
       0,     0,     0,   996,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,     0,     0,     0,     0,     0,
       0,     0,   998,     0,     0,   999,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1000,     0,     0,     0,     0,
       0,  1001,  1002,     0,  1003,  1004,     0,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1009,
    1010,  1011,     0,     0,     0,     0,     0,  1012,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
    1014,  1015,  1016,   183,   184,   185,  1017,   187,   188,   189,
     190,   191,   192,  1018,   194,   195,   196,   197,   198,   199,
     200,  1019,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,  1020,   217,   218,
     219,   220,   221,   222,   223,   224,  1021,   226,  1022,  1023,
     228,  1024,  1025,  1026,  1027,  1028,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
    1029,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,  1030,  1031,  1032,   262,  1033,  1034,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,  1035,   308,   309,   310,   311,   312,
    1036,   314,  1037,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,  1038,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1039,  1040,   350,   351,
     352,  1041,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,  1042,
     392,  1043,   394,   395,   396,   397,  1044,  1045,  1046,  1047,
     402,   403,   404,   405,   406,   407,   408,   409,   410,  1048,
    1049,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,  1050,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
    1051,   443,   444,   445,   446,   447,  1052,  1053,   450,   451,
     452,   453,   454,   455,  1054,   457,   458,   459,   460,   461,
     462,  1055,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,  1056,   494,   495,   496,   497,   498,  1057,  1058,   501,
     502,   503,   504,   505,  1059,   507,   508,   509,   510,   511,
     512,  1060,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,  1061,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
    1062,  1063,  1064,  1065,   565,   566,   567,  1066,  1067,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,  1068,   584,  1069,   586,   587,   588,   589,   590,
     591,   592,   593,   594,  1070,  1071,   597,  1072,   599,   600,
     601,     0,   602,   603,   604,  1073,     0,     0,     0,     0,
     941,   942,   943,   944,  1074,  1075,     0,     0,     0,     0,
    1076,   945,   946,     0,   947,  1077,     0,     0,     0,  1078,
    1079,   948,   949,  1080,  1081,   950,   951,   952,   953,     0,
     954,   955,     0,   956,   957,     0,     0,     0,     0,   958,
       0,     0,     0,   959,     0,     0,   960,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   961,   962,   963,     0,
     964,   965,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   966,   967,   968,     0,   969,   970,     0,
       0,     0,   971,   972,   973,     0,     0,     0,     0,     0,
       0,     0,   974,     0,  1543,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   976,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   977,     0,     0,     0,     0,   978,   979,     0,   980,
       0,     0,     0,     0,     0,   981,     0,   982,     0,     0,
     983,     0,     0,     0,     0,   986,     0,   987,   988,   989,
       0,   990,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
     992,   993,   994,     0,   995,     0,     0,     0,     0,     0,
       0,   996,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   997,     0,     0,     0,     0,     0,     0,     0,
     998,     0,     0,   999,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1000,     0,     0,     0,     0,     0,  1001,
    1002,     0,  1003,  1004,     0,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1009,  1010,  1011,
       0,     0,     0,     0,     0,  1012,     0,  1013,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,  1014,  1015,
    1016,   183,   184,   185,  1017,   187,   188,   189,   190,   191,
     192,  1018,   194,   195,   196,   197,   198,   199,   200,  1019,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,  1020,   217,   218,   219,   220,
     221,   222,   223,   224,  1021,   226,  1022,  1023,   228,  1024,
    1025,  1026,  1027,  1028,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,  1029,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
    1030,  1031,  1032,   262,  1033,  1034,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,  1035,   308,   309,   310,   311,   312,  1036,   314,
    1037,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,  1038,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1039,  1040,   350,   351,   352,  1041,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,  1042,   392,  1043,
     394,   395,   396,   397,  1044,  1045,  1046,  1047,   402,   403,
     404,   405,   406,   407,   408,   409,   410,  1048,  1049,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,  1050,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,  1051,   443,
     444,   445,   446,   447,  1052,  1053,   450,   451,   452,   453,
     454,   455,  1054,   457,   458,   459,   460,   461,   462,  1055,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,  1056,
     494,   495,   496,   497,   498,  1057,  1058,   501,   502,   503,
     504,   505,  1059,   507,   508,   509,   510,   511,   512,  1060,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,  1061,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,  1062,  1063,
    1064,  1065,   565,   566,   567,  1066,  1067,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
    1068,   584,  1069,   586,   587,   588,   589,   590,   591,   592,
     593,   594,  1070,  1071,   597,  1072,   599,   600,   601,   941,
     602,   603,   604,  1073,     0,     0,     0,     0,     0,     0,
       0,     0,  5586,  5587,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5588,     0,     0,     0,     0,  1079,     0,
       0,  1080,  1081,     0,     0,     0,     0,     0,   958,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   963,     0,     0,
     965,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   969,   970,     0,     0,
       0,  1580,  1581,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     977,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   983,
       0,     0,     0,     0,     0,     0,     0,   988,   989,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1005,     0,     0,     0,
       0,     0,     0,     0,  1006,  1007,  1008,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,  1582,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    2436,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,  2840,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,  2437,   562,   563,
    2438,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1080,  1081,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,  3090,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,  2841,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     771,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,  1167,   602,
     603,   604,   605,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2841,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1168,     0,     0,
     771,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,  1169,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,  1170,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,  1171,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,  1172,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1173,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,  1174,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,  1175,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,  1176,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,  1177,   598,
     599,   600,   601,  1167,   602,   603,   604,   605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1168,     0,     0,     0,  1178,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,  1169,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,  1170,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
    1171,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
    1172,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,  1173,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,  1174,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,  1175,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,  1177,   598,   599,   600,   601,     0,   602,
     603,   604,   605,   854,   855,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1178,     0,     0,     0,     0,     0,     0,   856,     0,
       0,     0,     0,   857,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     858,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     859,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   860,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   172,   173,     0,
       0,     0,   861,     0,     0,     0,     0,   862,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   788,     0,     0,     0,
       0,     0,     0,   863,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   864,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     865,     0,     0,     0,     0,     0,     0,     0,   866,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   692,     0,     0,     0,     0,     0,     0,   867,
       0,     0,     0,     0,     0,     0,     0,     0,   868,   869,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   870,   288,   289,   290,   291,   871,
     293,     0,     0,   294,   295,   296,   297,   298,   299,   300,
     872,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   873,
     459,   460,   461,   874,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     875,   480,   481,   482,   483,   876,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   877,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   878,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,     0,   602,   603,   604,   605,  1145,
     855,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   856,     0,     0,     0,     0,   857,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   858,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   859,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   860,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   172,   173,     0,     0,     0,   861,     0,
       0,     0,     0,   862,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   788,     0,     0,     0,     0,     0,     0,   863,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   864,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   865,     0,     0,     0,
       0,     0,     0,     0,   866,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   692,     0,
       0,     0,     0,     0,     0,   867,     0,     0,     0,     0,
       0,     0,     0,     0,   868,   869,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,  1146,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     870,   288,   289,   290,   291,   871,   293,     0,     0,   294,
     295,   296,   297,   298,   299,   300,   872,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   873,   459,   460,   461,  1147,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   875,   480,   481,   482,
     483,   876,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   877,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,  1812,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   878,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     788,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   692,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,  1907,   602,
     603,   604,   605,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1580,  1581,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,   176,   177,   178,   179,   180,   181,   182,     0,
       0,     0,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,     0,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,     0,   228,
     229,   230,   231,   232,   233,     0,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,     0,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,     0,     0,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,     0,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,  4706,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
       0,   602,   603,   604,   605,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,  1908,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,  4725,   602,
     603,   604,   605,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   740,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,     0,     0,     0,  3189,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3190,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   741,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,  4726,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,  4228,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   173,     0,     0,     0,
       0,  4466,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     692,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,     0,
       0,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,  1765,   602,   603,   604,   605,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1766,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   173,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   788,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1767,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     692,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,     0,
       0,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,     0,   602,   603,   604,   605,  4013,  4014,     0,
    1768,     0,     0,  4015,  4016,     0,     0,     0,     0,     0,
       0,     0,     0,  4017,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4018,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4019,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4020,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4021,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4022,  4023,
       0,  4024,     0,     0,     0,     0,     0,     0,     0,  4025,
    4026,  4027,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4028,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4029,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4030,     0,
       0,     0,     0,     0,  4031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4032,  4033,
    4034,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4035,  4036,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,  5162,   206,  5163,  5164,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,  5165,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  5166,   259,
    5167,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,  5168,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,  5169,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,  5170,  5171,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,  5172,
     345,   346,   347,   348,   349,   350,   351,   352,  5173,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,  5174,  5175,  5176,   402,   403,   404,
     405,   406,  5177,  5178,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,  5179,
    5180,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,  5181,  5182,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,  5183,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,  5184,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,  5185,   559,   560,  5186,   562,   563,
    5187,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,  5188,   588,   589,   590,   591,   592,   593,
     594,   595,   596,  3466,   598,   599,   600,   601,  1781,   602,
     603,   604,  5189,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1782,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     788,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   692,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,  1765,   602,
     603,   604,   605,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1766,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     788,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   692,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,  1765,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   788,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   692,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,  1298,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1299,
    1300,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1301,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,  1399,   602,   603,   604,   605,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   692,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,     0,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     4,   602,   603,   604,   605,     0,     0,
       0,     0,   898,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1675,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -449,  -449,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   901,     0,     0,     0,     0,     0,     0,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   903,
     904,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   905,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   906,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,     0,   274,   275,
     276,   277,  -449,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   293,     0,   907,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
       0,     0,     0,     0,     0,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   317,   318,     0,   320,   321,     0,
       0,   323,     0,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,     0,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,     0,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     908,     0,     0,     0,   436,   437,     0,   439,   440,   441,
     442,     0,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,   481,
       0,   483,   484,     0,   486,   487,     0,   489,   490,   491,
     492,   493,   494,     0,   496,   497,   498,   499,   500,   501,
     502,     0,   504,   505,   506,     0,   508,   509,   510,   511,
       0,   513,   514,     0,     0,   517,     0,     0,   520,   521,
     522,     0,   524,     0,   526,   527,   528,   529,     0,   530,
     531,   532,   533,     0,   535,   536,     0,   538,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,     4,
     561,   562,   563,   564,   565,   566,   567,   568,   898,   570,
     571,   572,     0,   574,   575,   576,   577,     0,     0,   580,
     581,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,     0,     0,   599,   600,
       0,     0,   602,     0,   604,   605,  -469,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   901,     0,     0,
       0,     0,     0,     0,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,   903,   904,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -469,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,   905,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,   906,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,     0,   274,   275,   276,   277,  -469,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   293,     0,   907,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,     0,     0,     0,     0,
       0,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     317,   318,     0,   320,   321,     0,     0,   323,     0,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
       0,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,     0,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   908,     0,     0,     0,
     436,   437,     0,   439,   440,   441,   442,     0,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,   481,     0,   483,   484,     0,
     486,   487,     0,   489,   490,   491,   492,   493,   494,     0,
     496,   497,   498,   499,   500,   501,   502,     0,   504,   505,
     506,     0,   508,   509,   510,   511,     0,   513,   514,     0,
       0,   517,     0,     0,   520,   521,   522,     0,   524,     0,
     526,   527,   528,   529,     0,   530,   531,   532,   533,     0,
     535,   536,     0,   538,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,     4,   561,   562,   563,   564,
     565,   566,   567,   568,   898,   570,   571,   572,     0,   574,
     575,   576,   577,     0,     0,   580,   581,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,     0,     0,   599,   600,     0,     0,   602,     0,
     604,   605,  -466,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   901,     0,     0,     0,     0,     0,     0,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   903,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -466,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   905,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   906,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,     0,
     274,   275,   276,   277,  -466,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   293,
       0,   907,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,     0,     0,     0,     0,     0,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   317,   318,     0,   320,
     321,     0,     0,   323,     0,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,     0,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,     0,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   908,     0,     0,     0,   436,   437,     0,   439,
     440,   441,   442,     0,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,   481,     0,   483,   484,     0,   486,   487,     0,   489,
     490,   491,   492,   493,   494,     0,   496,   497,   498,   499,
     500,   501,   502,     0,   504,   505,   506,     0,   508,   509,
     510,   511,     0,   513,   514,     0,     0,   517,     0,     0,
     520,   521,   522,     0,   524,     0,   526,   527,   528,   529,
       0,   530,   531,   532,   533,     0,   535,   536,     0,   538,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,     4,   561,   562,   563,   564,   565,   566,   567,   568,
     898,   570,   571,   572,     0,   574,   575,   576,   577,     0,
       0,   580,   581,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,     0,     0,
     599,   600,     0,     0,   602,     0,   604,   605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   901,
       0,     0,     0,     0,     0,     0,   902,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   903,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   905,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   906,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,     0,   274,   275,   276,   277,
    1529,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   293,     0,   907,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,     0,     0,
       0,     0,     0,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   317,   318,     0,   320,   321,     0,     0,   323,
       0,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,     0,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   908,     0,
       0,     0,   436,   437,     0,   439,   440,   441,   442,     0,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,   481,     0,   483,
     484,     0,   486,   487,     0,   489,   490,   491,   492,   493,
     494,     0,   496,   497,   498,   499,   500,   501,   502,     0,
     504,   505,   506,     0,   508,   509,   510,   511,     0,   513,
     514,     0,     0,   517,     0,     0,   520,   521,   522,     0,
     524,     0,   526,   527,   528,   529,     0,   530,   531,   532,
     533,     0,   535,   536,     0,   538,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,     4,   561,   562,
     563,   564,   565,   566,   567,   568,   898,   570,   571,   572,
       0,   574,   575,   576,   577,     0,     0,   580,   581,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,     0,     0,   599,   600,     0,     0,
     602,     0,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   901,     0,     0,     0,     0,
       0,     0,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   903,   904,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   905,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   906,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,     0,   274,   275,   276,   277,  -471,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   293,     0,   907,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,     0,     0,     0,     0,     0,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   317,   318,
       0,   320,   321,     0,     0,   323,     0,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,     0,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
       0,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   908,     0,     0,     0,   436,   437,
       0,   439,   440,   441,   442,     0,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,   481,     0,   483,   484,     0,   486,   487,
       0,   489,   490,   491,   492,   493,   494,     0,   496,   497,
     498,   499,   500,   501,   502,     0,   504,   505,   506,     0,
     508,   509,   510,   511,     0,   513,   514,     0,     0,   517,
       0,     0,   520,   521,   522,     0,   524,     0,   526,   527,
     528,   529,     0,   530,   531,   532,   533,     0,   535,   536,
       0,   538,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,     4,   561,   562,   563,   564,   565,   566,
     567,   568,   898,   570,   571,   572,     0,   574,   575,   576,
     577,     0,     0,   580,   581,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
       0,     0,   599,   600,     0,     0,   602,     0,   604,   605,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   901,     0,     0,     0,     0,     0,     0,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   903,
     904,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   905,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   906,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,     0,   274,   275,
     276,   277,  3432,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   293,     0,   907,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
       0,     0,     0,     0,     0,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   317,   318,     0,   320,   321,     0,
       0,   323,     0,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,     0,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,     0,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     908,     0,     0,     0,   436,   437,     0,   439,   440,   441,
     442,     0,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,   481,
       0,   483,   484,     0,   486,   487,     0,   489,   490,   491,
     492,   493,   494,     0,   496,   497,   498,   499,   500,   501,
     502,     0,   504,   505,   506,     0,   508,   509,   510,   511,
       0,   513,   514,     0,     0,   517,     0,     0,   520,   521,
     522,     0,   524,     0,   526,   527,   528,   529,     0,   530,
     531,   532,   533,     0,   535,   536,     0,   538,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,     4,
     561,   562,   563,   564,   565,   566,   567,   568,   898,   570,
     571,   572,     0,   574,   575,   576,   577,     0,     0,   580,
     581,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,     0,     0,   599,   600,
       0,     0,   602,     0,   604,   605,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   901,     0,     0,
       0,     0,     0,     0,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,   903,   904,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,   905,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,   906,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,     0,   274,   275,   276,   277,  3484,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   293,     0,   907,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,     0,     0,     0,     0,
       0,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     317,   318,     0,   320,   321,     0,     0,   323,     0,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
       0,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,     0,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   908,     0,     0,     0,
     436,   437,     0,   439,   440,   441,   442,     0,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,   481,     0,   483,   484,     0,
     486,   487,     0,   489,   490,   491,   492,   493,   494,     0,
     496,   497,   498,   499,   500,   501,   502,     0,   504,   505,
     506,     0,   508,   509,   510,   511,     0,   513,   514,     0,
       0,   517,     0,     0,   520,   521,   522,     0,   524,     0,
     526,   527,   528,   529,     0,   530,   531,   532,   533,     0,
     535,   536,     0,   538,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,     4,   561,   562,   563,   564,
     565,   566,   567,   568,   898,   570,   571,   572,     0,   574,
     575,   576,   577,     0,     0,   580,   581,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,     0,     0,   599,   600,     0,     0,   602,     0,
     604,   605,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   901,     0,     0,     0,     0,     0,     0,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   903,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   905,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   906,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,     0,
     274,   275,   276,   277,  3692,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   293,
       0,   907,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,     0,     0,     0,     0,     0,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   317,   318,     0,   320,
     321,     0,     0,   323,     0,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,     0,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,     0,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   908,     0,     0,     0,   436,   437,     0,   439,
     440,   441,   442,     0,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,   481,     0,   483,   484,     0,   486,   487,     0,   489,
     490,   491,   492,   493,   494,     0,   496,   497,   498,   499,
     500,   501,   502,     0,   504,   505,   506,     0,   508,   509,
     510,   511,     0,   513,   514,     0,     0,   517,     0,     0,
     520,   521,   522,     0,   524,     0,   526,   527,   528,   529,
       0,   530,   531,   532,   533,     0,   535,   536,     0,   538,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,     4,   561,   562,   563,   564,   565,   566,   567,   568,
     898,   570,   571,   572,     0,   574,   575,   576,   577,     0,
       0,   580,   581,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,     0,     0,
     599,   600,     0,     0,   602,     0,   604,   605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   901,
       0,     0,     0,     0,     0,     0,   902,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   903,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   905,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   906,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,     0,   274,   275,   276,   277,
    3705,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   293,     0,   907,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,     0,     0,
       0,     0,     0,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   317,   318,     0,   320,   321,     0,     0,   323,
       0,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,     0,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   908,     0,
       0,     0,   436,   437,     0,   439,   440,   441,   442,     0,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,   481,     0,   483,
     484,     0,   486,   487,     0,   489,   490,   491,   492,   493,
     494,     0,   496,   497,   498,   499,   500,   501,   502,     0,
     504,   505,   506,     0,   508,   509,   510,   511,     0,   513,
     514,     0,     0,   517,     0,     0,   520,   521,   522,     0,
     524,     0,   526,   527,   528,   529,     0,   530,   531,   532,
     533,     0,   535,   536,     0,   538,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,     4,   561,   562,
     563,   564,   565,   566,   567,   568,   898,   570,   571,   572,
       0,   574,   575,   576,   577,     0,     0,   580,   581,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,     0,     0,   599,   600,     0,     0,
     602,     0,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   899,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,   900,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   901,     0,     0,     0,     0,
       0,     0,   902,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,     0,   903,   904,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,   905,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,   906,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,     0,   274,   275,   276,   277,  4088,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   293,     0,   907,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,     0,     0,     0,     0,     0,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   317,   318,
       0,   320,   321,     0,     0,   323,     0,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,     0,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
       0,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   908,     0,     0,     0,   436,   437,
       0,   439,   440,   441,   442,     0,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,   481,     0,   483,   484,     0,   486,   487,
       0,   489,   490,   491,   492,   493,   494,     0,   496,   497,
     498,   499,   500,   501,   502,     0,   504,   505,   506,     0,
     508,   509,   510,   511,     0,   513,   514,     0,     0,   517,
       0,     0,   520,   521,   522,     0,   524,     0,   526,   527,
     528,   529,     0,   530,   531,   532,   533,     0,   535,   536,
       0,   538,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,     4,   561,   562,   563,   564,   565,   566,
     567,   568,   898,   570,   571,   572,     0,   574,   575,   576,
     577,     0,     0,   580,   581,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
       0,     0,   599,   600,     0,     0,   602,     0,   604,   605,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   899,     0,     0,     0,     0,     0,    13,     0,     0,
       0,     0,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,    15,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   901,     0,     0,     0,     0,     0,     0,   902,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,   903,
     904,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,     0,   178,     0,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   194,   195,   196,   197,   198,   199,
     200,   201,     0,   905,     0,     0,   205,   206,   207,   208,
     209,     0,     0,   212,   213,   214,   215,     0,     0,     0,
     219,   220,   221,   222,   223,   906,   225,   226,   227,     0,
     228,     0,     0,     0,     0,     0,     0,   234,     0,   236,
       0,   238,   239,     0,   241,   242,   243,   244,   245,   246,
       0,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,     0,   274,   275,
     276,   277,  4986,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,     0,     0,   293,     0,   907,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
       0,     0,     0,     0,     0,   308,   309,   310,   311,   312,
     313,   314,   315,     0,   317,   318,     0,   320,   321,     0,
       0,   323,     0,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,     0,   337,   338,   339,   340,   341,
     342,   343,   344,   345,     0,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,     0,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     908,     0,     0,     0,   436,   437,     0,   439,   440,   441,
     442,     0,   444,   445,   446,   447,   448,   449,     0,     0,
       0,     0,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,     0,   481,
       0,   483,   484,     0,   486,   487,     0,   489,   490,   491,
     492,   493,   494,     0,   496,   497,   498,   499,   500,   501,
     502,     0,   504,   505,   506,     0,   508,   509,   510,   511,
       0,   513,   514,     0,     0,   517,     0,     0,   520,   521,
     522,     0,   524,     0,   526,   527,   528,   529,     0,   530,
     531,   532,   533,     0,   535,   536,     0,   538,     0,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,     4,
     561,   562,   563,   564,   565,   566,   567,   568,   898,   570,
     571,   572,     0,   574,   575,   576,   577,     0,     0,   580,
     581,     0,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,     0,     0,   599,   600,
       0,     0,   602,     0,   604,   605,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   899,     0,     0,
       0,     0,     0,    13,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,    15,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   901,     0,     0,
       0,     0,     0,     0,   902,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,   903,   904,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
       0,   178,     0,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     194,   195,   196,   197,   198,   199,   200,   201,     0,   905,
       0,     0,   205,   206,   207,   208,   209,     0,     0,   212,
     213,   214,   215,     0,     0,     0,   219,   220,   221,   222,
     223,   906,   225,   226,   227,     0,   228,     0,     0,     0,
       0,     0,     0,   234,     0,   236,     0,   238,   239,     0,
     241,   242,   243,   244,   245,   246,     0,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,     0,   274,   275,   276,   277,  -453,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,     0,     0,   293,     0,   907,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,     0,     0,     0,     0,
       0,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     317,   318,     0,   320,   321,     0,     0,   323,     0,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
       0,   337,   338,   339,   340,   341,   342,   343,   344,   345,
       0,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,     0,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   908,     0,     0,     0,
     436,   437,     0,   439,   440,   441,   442,     0,   444,   445,
     446,   447,   448,   449,     0,     0,     0,     0,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,     0,   481,     0,   483,   484,     0,
     486,   487,     0,   489,   490,   491,   492,   493,   494,     0,
     496,   497,   498,   499,   500,   501,   502,     0,   504,   505,
     506,     0,   508,   509,   510,   511,     0,   513,   514,     0,
       0,   517,     0,     0,   520,   521,   522,     0,   524,     0,
     526,   527,   528,   529,     0,   530,   531,   532,   533,     0,
     535,   536,     0,   538,     0,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,     4,   561,   562,   563,   564,
     565,   566,   567,   568,   898,   570,   571,   572,     0,   574,
     575,   576,   577,     0,     0,   580,   581,     0,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,     0,     0,   599,   600,     0,     0,   602,     0,
     604,   605,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   899,     0,     0,     0,     0,     0,    13,
       0,     0,     0,     0,   900,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   901,     0,     0,     0,     0,     0,     0,
     902,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,   903,   904,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,   905,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,   906,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,     0,
     274,   275,   276,   277,     0,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   293,
       0,   907,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,     0,     0,     0,     0,     0,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   317,   318,     0,   320,
     321,     0,     0,   323,     0,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,     0,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,     0,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   908,     0,     0,     0,   436,   437,     0,   439,
     440,   441,   442,     0,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,   481,     0,   483,   484,     0,   486,   487,     0,   489,
     490,   491,   492,   493,   494,     0,   496,   497,   498,   499,
     500,   501,   502,     0,   504,   505,   506,     0,   508,   509,
     510,   511,     0,   513,   514,     0,     0,   517,     0,     0,
     520,   521,   522,     0,   524,     0,   526,   527,   528,   529,
       0,   530,   531,   532,   533,     0,   535,   536,     0,   538,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,     4,   561,   562,   563,   564,   565,   566,   567,   568,
     898,   570,   571,   572,     0,   574,   575,   576,   577,     0,
       0,   580,   581,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,     0,     0,
     599,   600,     0,     0,   602,     0,   604,   605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
     900,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   901,
       0,     0,     0,     0,     0,     0,   902,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   903,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   905,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,   906,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,     0,   274,   275,   276,   277,
       0,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   293,     0,   907,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,     0,     0,
       0,     0,     0,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   317,   318,     0,   320,   321,     0,     0,   323,
       0,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,     0,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   908,     0,
       0,     0,   436,   437,     0,   439,   440,   441,   442,     0,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,   481,     0,   483,
     484,     0,   486,   487,     0,   489,   490,   491,   492,   493,
     494,     0,   496,   497,   498,   499,   500,   501,   502,     0,
     504,   505,   506,     0,   508,   509,   510,   511,     0,   513,
     514,     0,     0,   517,     0,     0,   520,   521,   522,     0,
     524,     0,   526,   527,   528,   529,     0,   530,   531,   532,
     533,     4,   535,   536,     0,   538,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,     0,   561,   562,
     563,   564,   565,   566,   567,   568,     0,   570,   571,   572,
       0,   574,   575,   576,   577,     0,     0,   580,  1750,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,     0,    13,   599,   600,     0,     0,
     602,     0,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,     0,     0,     0,     0,   903,   904,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,   905,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,     0,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,     0,   274,   275,   276,   277,
       0,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,     0,     0,
       0,     0,     0,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   317,   318,     0,   320,   321,     0,     0,   323,
       0,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,     0,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,     0,     0,
       0,     0,   436,   437,     0,   439,   440,   441,   442,     0,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,   481,     0,   483,
     484,     0,   486,   487,     0,   489,   490,   491,   492,   493,
     494,     0,   496,   497,   498,   499,   500,   501,   502,     0,
     504,   505,   506,     0,   508,   509,   510,   511,     0,   513,
     514,     0,     0,   517,     0,     0,   520,   521,   522,     0,
     524,     0,   526,   527,   528,   529,     0,   530,   531,   532,
     533,     0,   535,   536,     0,   538,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,     0,   561,   562,
     563,   564,   565,   566,   567,   568,     0,   570,   571,   572,
       0,   574,   575,   576,   577,  3462,  3463,   580,   581,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,     0,     0,   599,   600,     0,     0,
     602,     0,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,  3464,  3465,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
    3466,   598,   599,   600,   601,     0,   602,   603,   604,   605,
    1399,   857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   173,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   788,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     692,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   174,   175,   176,   177,   178,   179,   180,   181,
     182,     0,     0,     0,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,     0,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
       0,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
       0,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,     0,
       0,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,     0,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,     0,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,  1399,   602,   603,   604,   605,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   172,   173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   788,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   692,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,     0,     0,     0,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,     0,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,     0,   228,   229,   230,   231,   232,   233,     0,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,     0,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,     0,     0,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,     0,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,     0,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,  1334,   602,   603,   604,   605,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   857,   602,   603,
     604,   605,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1335,     0,     0,     0,     0,  1336,     0,     0,   771,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     788,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   692,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,  2208,     0,     0,     0,  4890,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3801,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3802,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3803,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   692,     0,     0,     0,     0,     0,     0,     0,     0,
    3804,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,  2208,     0,
       0,     0,  5698,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2209,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3801,     0,     0,     0,
       0,   172,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3802,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3803,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   692,     0,     0,     0,
       0,     0,     0,     0,     0,  3804,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
     176,   177,   178,   179,   180,   181,   182,     0,     0,     0,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,     0,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,     0,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,     0,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,     0,     0,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
       0,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     0,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,     0,   602,
     603,   604,   605,  2208,     0,     0,     0,  5803,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3801,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3802,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3803,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   692,     0,     0,     0,     0,     0,     0,     0,     0,
    3804,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,  3106,   602,   603,   604,   605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   788,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   692,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,  1758,
     602,   603,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,  1758,   602,   603,   604,   605,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,  2495,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,  3182,   602,   603,   604,   605,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,  4821,   602,   603,
     604,   605,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,  4839,   602,   603,   604,   605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,  3120,
     602,   603,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   692,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,     0,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     0,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
    3121,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2355,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5883,     0,     0,     0,     0,     0,     0,  2356,
    5884,   788,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   692,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1779,   788,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   692,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1996,   788,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   692,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2370,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,  2355,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
    1580,  1581,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2356,  5884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1908,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      38,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,  1580,  1581,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1335,     0,     0,     0,     0,     0,     0,
       0,   771,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,  1582,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1583,     0,     0,     0,     0,
       0,     0,     0,  1080,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,  1580,  1581,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1335,     0,     0,
       0,     0,  1336,     0,     0,   771,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,  1582,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1080,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2355,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2356,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1335,     0,     0,     0,     0,     0,     0,
       0,   771,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,  2841,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   771,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   172,   173,
    4787,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4465,     0,     0,
       0,     0,     0,     0,     0,  4466,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4466,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   768,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     769,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   770,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   771,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   771,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4466,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,  2873,   602,   603,   604,   605,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2414,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   688,
     689,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5235,   659,  5236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,  1517,   602,   603,   604,   605,
    1518,     0,     0,     0,     0,     0,     0,     0,     0,  2874,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,  1519,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,  1449,   602,   603,
     604,   605,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,  2817,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,  1580,  1581,
       0,     0,     0,     0,     0,     0,     0,     0,  3999,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
    4232,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,  1580,  1581,     0,     0,     0,     0,     0,     0,
       0,     0,  4701,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,  5045,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,  5280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1767,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   692,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,  1580,  1581,
       0,  1768,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2007,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2008,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   991,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2009,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,  2011,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
    1580,  1581,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2007,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2008,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   991,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3981,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,  2011,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,  1580,  1581,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2007,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   991,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2010,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,  2011,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   658,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   659,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   788,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   692,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   659,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
    1580,  1581,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1626,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4272,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   692,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5516,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   700,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,     0,   602,   603,
     604,   605,  1580,  1581,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,  1927,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2506,   175,   176,   177,   178,   179,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,     0,   228,   229,   230,   231,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,     0,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
       0,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,   602,   603,   604,   605,   172,   173,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,   177,   178,
     179,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,     0,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,     0,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,  3209,   303,   304,   305,   306,     0,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,  3210,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,     0,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,     0,   602,   603,   604,   605,
     172,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,   176,
     177,   178,   179,   180,   181,   182,     0,     0,     0,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,     0,   228,   229,   230,   231,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,     0,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,     0,     0,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,     0,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,     0,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,  3466,   598,   599,   600,   601,     0,   602,   603,
     604,   605,   172,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,     0,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,     0,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,     0,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,     0,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,     0,   598,   599,   600,   601,     0,
     602,   603,   604,   605,   172,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   692,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,   180,   181,   182,
       0,     0,     0,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,     0,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,     0,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,     0,     0,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,     0,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,     0,   318,   319,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,     0,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,     0,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,  3121,   598,   599,   600,
     601,     0,   602,   603,   604,   605,   172,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1515,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,   176,     0,   178,     0,   180,
     181,   182,     0,     0,     0,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   194,   195,   196,   197,
     198,   199,   200,   201,     0,     0,     0,     0,   205,   206,
     207,   208,   209,     0,     0,   212,   213,   214,   215,     0,
       0,     0,   219,   220,   221,   222,   223,     0,   225,   226,
     227,     0,   228,     0,     0,     0,     0,     0,     0,   234,
       0,   236,     0,   238,   239,     0,   241,   242,   243,   244,
     245,   246,     0,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   263,   264,
     265,     0,   266,   267,   268,   269,   270,   271,   272,     0,
     274,   275,   276,   277,     0,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,     0,     0,   293,
       0,     0,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,     0,     0,     0,     0,     0,   308,   309,   310,
     311,   312,   313,   314,   315,     0,   317,   318,     0,   320,
     321,     0,     0,   323,     0,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,     0,   337,   338,   339,
     340,   341,   342,   343,   344,   345,     0,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,     0,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   172,   173,     0,     0,   436,   437,     0,   439,
     440,   441,   442,     0,   444,   445,   446,   447,   448,   449,
       0,     0,     0,     0,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
       0,   481,     0,   483,   484,     0,   486,   487,     0,   489,
     490,   491,   492,   493,   494,     0,   496,   497,   498,   499,
     500,   501,   502,     0,   504,   505,   506,     0,   508,   509,
     510,   511,     0,   513,   514,     0,     0,   517,     0,     0,
     520,   521,   522,     0,   524,     0,   526,   527,   528,   529,
       0,   530,   531,   532,   533,     0,   535,   536,     0,   538,
       0,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,     0,   561,   562,   563,   564,   565,   566,   567,   568,
       0,   570,   571,   572,     0,   574,   575,   576,   577,     0,
       0,   580,   581,     0,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,     0,     0,
     599,   600,     0,     0,   602,     0,   604,   605,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1526,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,     0,   178,     0,   180,   181,   182,     0,     0,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   194,   195,   196,   197,   198,   199,   200,   201,
       0,     0,     0,     0,   205,   206,   207,   208,   209,     0,
       0,   212,   213,   214,   215,     0,     0,     0,   219,   220,
     221,   222,   223,     0,   225,   226,   227,     0,   228,     0,
       0,     0,     0,     0,     0,   234,     0,   236,     0,   238,
     239,     0,   241,   242,   243,   244,   245,   246,     0,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   263,   264,   265,     0,   266,   267,
     268,   269,   270,   271,   272,     0,   274,   275,   276,   277,
       0,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,     0,     0,   293,     0,     0,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,     0,     0,
       0,     0,     0,   308,   309,   310,   311,   312,   313,   314,
     315,     0,   317,   318,     0,   320,   321,     0,     0,   323,
       0,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,     0,   337,   338,   339,   340,   341,   342,   343,
     344,   345,     0,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,     0,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   172,   173,
       0,     0,   436,   437,     0,   439,   440,   441,   442,     0,
     444,   445,   446,   447,   448,   449,     0,     0,     0,     0,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,     0,   481,     0,   483,
     484,     0,   486,   487,     0,   489,   490,   491,   492,   493,
     494,     0,   496,   497,   498,   499,   500,   501,   502,     0,
     504,   505,   506,     0,   508,   509,   510,   511,     0,   513,
     514,     0,     0,   517,     0,     0,   520,   521,   522,     0,
     524,     0,   526,   527,   528,   529,     0,   530,   531,   532,
     533,     0,   535,   536,     0,   538,     0,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,     0,   561,   562,
     563,   564,   565,   566,   567,   568,     0,   570,   571,   572,
       0,   574,   575,   576,   577,     0,     0,   580,   581,     0,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,     0,     0,   599,   600,     0,     0,
     602,     0,   604,   605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,   176,     0,   178,
       0,   180,   181,   182,     0,     0,     0,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   194,   195,
     196,   197,   198,   199,   200,   201,     0,     0,     0,     0,
     205,   206,   207,   208,   209,     0,     0,   212,   213,   214,
     215,     0,     0,     0,   219,   220,   221,   222,   223,     0,
     225,   226,   227,     0,   228,     0,     0,     0,     0,     0,
       0,   234,     0,   236,     0,   238,   239,     0,   241,   242,
     243,   244,   245,   246,     0,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     263,   264,   265,     0,   266,   267,   268,   269,   270,   271,
     272,     0,   274,   275,   276,   277,     0,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,     0,
       0,   293,     0,     0,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,     0,     0,     0,     0,     0,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   317,   318,
       0,   320,   321,     0,     0,   323,     0,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,     0,   337,
     338,   339,   340,   341,   342,   343,   344,   345,     0,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
       0,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,     0,     0,     0,     0,   436,   437,
       0,   439,   440,   441,   442,     0,   444,   445,   446,   447,
     448,   449,     0,     0,     0,     0,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,     0,   481,     0,   483,   484,     0,   486,   487,
       0,   489,   490,   491,   492,   493,   494,     0,   496,   497,
     498,   499,   500,   501,   502,     0,   504,   505,   506,     0,
     508,   509,   510,   511,     0,   513,   514,     0,     0,   517,
       0,     0,   520,   521,   522,     0,   524,     0,   526,   527,
     528,   529,     0,   530,   531,   532,   533,     0,   535,   536,
       0,   538,     0,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,     0,   561,   562,   563,   564,   565,   566,
     567,   568,     0,   570,   571,   572,     0,   574,   575,   576,
     577,     0,     0,   580,   581,     0,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
       0,     0,   599,   600,     0,     0,   602,     0,   604,   605
};

static const yytype_int16 yycheck[] =
{
       3,    44,   163,    68,     0,   674,   673,   674,  1388,     0,
      21,     0,  1729,   171,   673,   909,   651,   673,   667,   673,
     161,     0,    25,  1562,  1361,  1676,    29,   754,  1361,   673,
     783,    34,   667,   898,    37,   900,   901,   902,   156,  1569,
    1749,    52,   907,    45,  1455,  2091,  3356,    58,    51,  3097,
    1227,   699,  1742,     0,    57,  1359,  1885,  2101,    61,  3356,
      30,  2575,  3431,  1786,  1857,  2893,  2894,  2695,  1788,  3391,
     640,  3306,    68,  3292,  2883,  1578,  3769,  3148,  3503,   640,
     978,  2907,  1353,  2909,  1295,  1497,  1392,  3741,  3272,  1600,
    1914,  1802,  1803,   716,   171,  2573,   719,  3332,  3333,  2069,
     670,   651,   739,   940,   159,  1392,   743,   744,  2633,   670,
    1807,  3295,  1742,  1907,  3162,  3294,  2033,   667,  2736,   847,
    2805,  3921,   125,   673,  4471,   171,   171,   171,  1140,  1826,
    2910,  2805,    27,  1467,   826,  2833,  3356,  1335,  2670,   135,
    2601,  3362,  3227,  3746,   135,  3857,   171,  1451,  3857,   152,
     153,  4476,    47,   156,  1851,  1852,   159,   160,  2660,  2661,
    4593,  3857,  4343,  3398,  3399,  2661,     6,     9,    10,  4741,
      28,     6,    26,  2736,     6,   171,  3869,    26,    11,    50,
     171,    60,   171,  4947,  1172,  1173,  1174,  2805,   135,     9,
      10,    11,    95,  1181,  1905,    93,     9,    10,  3858,  1985,
    3860,     6,     6,  3863,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,  1722,  1723,  1724,  1725,  1726,  1727,  1907,  1700,  1430,
      12,     9,    10,    63,   171,    93,  1708,  1709,    90,  1711,
    1712,  1940,     9,    10,  3013,   180,  3896,  1074,  1075,  1076,
      61,  2135,  2805,  2137,  2138,   185,    11,    80,  1142,  1206,
      11,  1088,   105,  4439,   197,     9,    10,  2045,    91,     9,
      10,   105,    61,   898,    61,   900,   901,   902,    80,  3072,
     265,  1228,   907,    65,   909,   170,    83,  1907,   766,    91,
     120,     9,    10,    80,   105,     9,    10,  2795,     9,    10,
     238,   146,     9,    10,    91,  1229,  3336,     9,    10,    61,
     238,  2089,     9,    10,   166,  2807,   105,  3378,    42,   115,
    2717,  2807,   783,  4575,   121,   265,  4023,  4024,   156,   251,
    4027,   197,     9,    10,    57,     9,    10,  4034,     9,    10,
     265,   750,   114,  4040,    11,    80,   105,   765,    61,     9,
      10,    95,   184,   105,   186,   978,    91,    61,   898,  2058,
     900,   901,   902,     6,  2728,    33,    89,   907,    32,   909,
       9,    10,  4485,    11,   184,   223,   186,   284,  3354,  3148,
     238,   184,   105,   186,   379,  4318,   263,  3321,  2856,    83,
       9,    10,   105,   117,   238,   804,   363,   174,    63,    93,
    1023,   105,   319,   233,   128,  5080,   184,  4858,   186,     9,
      10,   135,  3504,  5191,     9,    10,   180,   184,    10,   186,
    3501,  3502,    32,   105,   366,    12,   149,   121,  3405,  3510,
      86,  3512,    86,  3514,   279,   463,   152,     9,    10,    17,
     184,   180,   186,   167,   184,   448,   186,   141,     5,   105,
    1526,   281,   146,    80,   177,   120,   118,  1080,   288,   265,
     299,     9,    10,   125,    91,   278,   184,  1469,   186,   299,
     184,   303,   186,   184,    31,   186,   114,   184,    65,   186,
     277,   284,   184,   323,   186,   152,   316,   184,   247,   186,
    2189,   185,  1494,   303,   625,   211,   627,   628,   629,   630,
     303,   632,   633,   186,   228,   636,   637,   184,   180,   186,
     184,   137,   186,   184,   141,   186,    73,  1142,  2554,   270,
     105,  4311,   176,  4888,   184,   303,   186,   180,   190,     9,
      10,  2567,     9,    10,   128,   259,   303,    61,  3850,   325,
    3751,    63,   149,   180,   211,   184,   221,   186,   706,   284,
     591,   274,   710,   759,  1956,  3332,  3333,  4980,   764,   303,
     766,   374,   180,   303,   143,   184,  3627,   186,   233,  2453,
    2454,  2455,  2456,  1943,  1256,   520,    57,   265,  5670,   115,
     716,   410,  3620,   277,   184,   303,   186,     6,   417,   303,
     721,   722,   303,   596,   130,   640,   303,    86,   120,   237,
     396,   303,  1142,  4018,   444,  4020,   303,   233,    89,  3378,
    1223,   233,   184,  4028,   186,   172,   281,   273,  1335,   273,
     647,  3398,  3399,   288,   105,   670,   303,   619,   669,   303,
     623,  5306,   303,  4746,   299,   771,   184,    93,   186,  4054,
     668,   634,  1265,   303,  5736,   283,   639,   640,   693,    68,
     229,   316,   176,     9,    10,   212,   196,   299,  4073,     9,
      10,   706,   288,   114,   303,   329,   288,   453,   149,   586,
     297,   664,   284,   299,   487,  4465,  5454,   670,   238,  1567,
     673,   349,   171,   172,   303,  5136,   496,   176,   238,   353,
     146,   238,  1319,   686,  1321,  1583,   177,  1324,  1325,  1326,
     693,   152,  3912,   303,   184,   665,   186,   184,   303,   186,
     130,   233,   705,   706,   681,  4967,   708,  1544,  1545,   850,
     851,  2045,   499,   366,   716,   300,   301,   719,  3336,   142,
    3405,   303,   840,   841,   842,   620,  2555,  2033,  1361,   379,
    3262,  3405,   114,   353,  3266,   738,  1464,   299,   238,  3974,
    2463,  1753,   299,   638,  2464,   303,  2033,    17,  1440,   281,
     805,   754,  4396,  3255,   356,  2089,   288,   652,   238,  3255,
     156,  1773,    32,   299,    34,   652,   771,   299,   771,   765,
     152,  1759,   100,  3336,   273,  2109,   771,   263,  1470,  1977,
     783,   676,   785,   274,   316,   208,  1435,  3405,  1800,   294,
    1988,   846,  1780,   575,  4737,  3835,   307,   238,    80,   716,
    1435,   449,   805,  3747,   736,     9,    10,   755,   501,    91,
     697,   814,   691,   303,     9,    10,   303,   755,   184,   771,
     186,   499,   677,   826,   184,   828,   186,   797,   771,   774,
     780,   779,  3635,   836,   774,   838,   771,   840,   841,   842,
     843,   844,  3405,   846,  1742,   637,  4553,  2544,  3627,  1806,
    1542,  2675,  1809,     9,    10,  5619,  4587,   662,   662,   141,
    2363,  2364,   905,  1820,  5436,   736,  1823,  3853,  5054,  4576,
    1827,   774,    58,  4580,  2085,   845,   774,    80,   848,     9,
      10,  4588,  2668,  2669,   486,  1435,   735,   755,    91,     9,
      10,   753,  3400,  1730,   897,   771,   899,  1854,  1855,  1856,
    3307,   755,  1390,   906,  1465,   908,   710,  1555,   761,  2391,
    2392,   114,  2394,  2395,  1333,  1849,   774,   761,   914,  5100,
     923,  5102,   755,   914,  4015,   914,     9,    10,   772,  2717,
     774,   771,   520,   771,  1567,   777,   771,   303,   124,   771,
     761,     9,    10,   303,   750,   778,  2840,  1418,  2736,  1582,
    1583,     9,    10,  5386,   774,   771,  1384,   651,   110,   111,
    3334,   774,   761,   263,  5226,   772,   778,   914,   760,  4060,
    4061,  4062,  3450,   667,  4065,  5098,  1624,  4079,  5303,   673,
     184,   778,   186,  1710,   772,  5360,   774,  4078,  3975,   184,
     755,   186,   761,  1641,   755,   772,  1644,   774,  1646,   761,
     774,  1754,  1650,  1651,  1652,   698,  4806,  2795,  4808,  1907,
    1658,  4811,  1077,     9,    10,   297,   263,  2805,  4818,  4819,
     774,   747,   772,  2816,   774,   774,  1497,   213,   184,   633,
     186,  3810,  3811,   778,   464,  3814,  3815,    61,   761,   772,
     637,  3820,  3821,   777,   772,   612,   774,   761,   772,   723,
     774,   772,  4544,   774,   184,   772,   186,   774,  4858,   329,
     772,   725,   774,   391,   184,   772,   186,   774,   772,   761,
     747,  1824,  3851,   771,   624,   498,  1079,   347,   755,   284,
     772,  1077,   774,   353,  2170,   467,   688,   774,  1077,   774,
     774,  2177,   774,   774,  4586,   761,   771,   152,   122,   303,
     772,   184,  1735,   186,   774,     9,    10,   755,   303,  1742,
    4602,   774,  4333,   316,  4606,  4607,   184,  1172,   186,  1174,
     130,  2830,   774,  1178,  1179,   774,   184,   774,   186,   779,
    1857,  4350,   284,   680,  4353,   771,  4739,  1140,  1141,   771,
    2152,   778,   538,   760,   761,   774,   774,   303,   609,  3777,
     772,  4461,   774,  1208,  4798,  1792,  3644,  3645,  3646,  3647,
     418,  3789,   772,  1166,  4461,  4877,   761,   211,  4877,  1172,
     681,  1174,   378,   303,  1390,  1178,  1179,   772,   218,   774,
    2074,  4877,   233,   303,    28,   755,    93,  3974,   184,   774,
     186,   284,   774,  1763,   125,   755,  3090,   263,   755,     9,
      10,  4626,  1763,   424,   898,  1208,   900,   901,   902,   779,
    4258,   697,   774,   907,  4299,   909,   774,  3835,  4878,   779,
     303,  1223,   374,  1225,   774,  2568,   725,   609,  1271,  1387,
    1922,  3763,  3764,   114,   562,   303,  4471,   288,   774,   771,
      81,  4461,   292,  1246,   294,   303,  4977,  1250,   299,   263,
    1977,  5511,  1255,  1256,  3715,   755,    97,  3759,  3760,   375,
     265,  1988,  1989,  3759,  3760,  5612,   771,   366,  5068,  1272,
    1335,  4961,  3835,   696,  1907,   755,  1899,  4813,  1281,   779,
     184,   772,   186,  1754,   774,   126,  3080,   774,     9,    10,
    3975,   132,  1295,  1296,  3992,  1297,   333,     9,    10,   779,
    1355,  3975,  1925,  5650,  5651,  1870,  4354,   303,  1426,   363,
    1387,     9,    10,  1316,   755,    14,  3233,  2045,  4801,  5456,
       9,    10,  1959,  1960,    10,  2631,     9,    10,   169,  1966,
    1967,  1968,  1335,  1336,     9,    10,  5136,   489,   779,  1335,
    5140,  1387,  1387,  1387,  2631,   363,  1335,  1317,  1318,  3863,
     405,  2688,  1355,  1824,  2691,  2692,  4427,  3975,  2691,  2692,
    4539,  2089,  1387,  2540,  2262,  3194,    28,  1370,  4148,  1264,
    2037,   265,  4443,  4444,   184,   280,   186,   705,  2011,   223,
    1275,    14,  3105,  2717,   358,  1388,  1389,    32,  1384,   392,
    3080,  1387,  1395,   237,  1955,  3365,  1387,   697,  1387,   303,
     305,  5748,   283,  5093,   351,   652,  1409,  2818,   774,   189,
    1465,  3134,  3975,   214,   774,  1418,  1419,  5677,     9,    10,
     211,   679,  2933,  1426,  1427,  2837,   211,  1430,  2120,  2121,
     211,  2443,  2444,     9,    10,   265,   736,  1440,   265,  2074,
    1387,   478,   648,   635,  1447,   352,  1449,    69,  1142,    63,
    3080,  2649,    93,   723,   464,   187,  1459,  2655,  5165,   333,
    3157,  2795,  1465,   184,   469,   186,  1469,  1470,     9,    10,
     114,  2805,   184,  2122,   186,  4000,  4001,  4002,  4003,  2467,
    4515,  4516,  4517,  2471,   381,  1956,   184,  2122,   186,    12,
     527,  1494,   356,   303,  1497,   184,   778,   186,  4277,   685,
     615,   184,  2161,   186,   603,  2161,  2494,  2161,   299,   184,
      11,   186,  1577,   174,  1517,    61,  3046,  2161,   739,  3307,
    3171,    32,   562,    34,  2074,  5017,  2161,   146,  5328,   553,
    4008,    99,   439,    76,   441,  2746,  3075,  2186,  5505,  1542,
     152,  4632,    65,   165,   114,  4636,     9,    10,  3336,   115,
    2185,  2186,  2895,  3056,  3057,     9,    10,  5694,  3069,   562,
    2517,   223,  2519,  5642,   716,  3047,  5645,  3049,   449,   774,
     774,   270,  2122,  1569,   779,   778,  2533,    17,   346,   774,
     312,  1577,   303,   627,   270,   576,  2857,   779,  1577,  2546,
    2547,   303,    32,   184,    34,   186,     9,    10,   697,   574,
       9,    10,   263,   719,   478,   303,   721,  4826,   184,   653,
     186,  2161,  3400,   712,   303,   562,   439,  3405,   774,   152,
     303,  5157,   486,  2188,   531,  3418,  4810,   681,   303,  2262,
    2263,   697,     9,    10,   414,  2185,  2186,  1692,  5898,   283,
    2477,   439,  1645,   184,   774,   186,  5129,   292,  4427,  5132,
    5133,  1654,   571,   527,   774,   745,     9,    10,   299,  1702,
     439,   664,  1665,   681,  4443,  4444,  2393,   281,    17,  2302,
     736,     9,    10,  1676,  1729,  1793,   681,  1795,  1796,  1797,
    1798,   774,  5336,   697,  5338,    34,   779,  1805,   662,  1692,
     323,   774,   586,  1689,   110,   111,   464,  1858,  1689,   484,
       9,    10,   609,   484,  1822,  5784,   774,   326,  1763,  3420,
      49,   608,   303,   397,   728,   399,   774,  3426,   562,  4545,
     771,   184,  2355,   186,     9,    10,  1729,   303,  1731,   779,
     184,  5223,   186,  5225,  4222,  4223,  2369,   774,  1740,   192,
    5707,  1435,   572,   289,   290,  5435,   316,  3258,  5155,    63,
    1753,  1754,   205,   296,  5179,   660,   586,     9,    10,   586,
    1763,  1764,   303,     9,    10,   651,   110,   111,   380,   571,
    1773,   184,   747,   186,   705,   184,  5145,   186,   774,  4998,
    5473,   667,  4024,   284,  1787,  1788,   609,   673,   779,   450,
    1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,    73,
     171,   172,  1805,  1964,  1965,   449,   120,   184,  5462,   186,
     263,   609,    32,  2825,    34,     0,  5035,   716,  1821,  1822,
    2165,  1824,   140,   754,   688,  1827,   584,  2460,     9,    10,
     609,   184,  2491,   186,   681,  2491,   447,  2491,   499,   208,
     303,    61,   353,  1846,   330,   391,   184,  2491,   186,   303,
    5333,   448,  3156,  1908,  1857,   774,  2491,   533,  3397,  3688,
     229,    17,  3686,     9,    10,  1868,   391,   774,     9,    10,
     774,  4586,   405,     9,    10,   184,    32,   186,   646,  2449,
     779,  4395,  4396,   299,   566,  4920,   733,  4602,  2449,   329,
     303,  4606,  4607,  1948,   303,     9,    10,  1899,    80,   184,
    1955,   186,  1957,  4145,   192,  1908,   729,   347,  3212,    83,
     565,  2560,   167,   353,   755,   756,   757,   205,  2610,  1922,
     574,   467,  2649,  1925,  1927,  2560,   303,  3233,  2655,  3652,
    3653,   729,   184,   466,   186,   566,  5343,  2831,   184,   379,
     186,  1996,   428,  2670,  3667,  1948,  3233,   121,  4401,  3286,
     303,  5022,  1955,  1956,  1957,   452,   524,   525,   374,  1962,
     528,   529,   530,   237,   774,   303,   897,   281,  2601,   146,
    2603,  2594,   774,  3307,  1977,   263,   774,     9,    10,   297,
     502,     9,    10,  4611,   595,  1988,  1989,  2042,  4513,  2717,
    2884,     9,    10,  1996,   303,   774,     9,    10,   597,   596,
     453,     9,    10,   184,  2641,   186,  4459,  2644,  3419,  2676,
    2560,  2648,   898,   771,   900,   901,   902,    57,   303,   171,
     172,   907,   706,   909,   546,   709,   702,  2892,  2893,  2894,
     374,  3443,  3444,  3445,  3446,   772,   697,   774,   184,  2042,
     186,  4669,   520,   184,   720,   186,  2048,  3835,   184,    33,
     186,   303,  3703,   774,   425,  2688,   738,   303,  2691,  2692,
    2693,  2064,   774,   643,  3262,  2068,  3400,  2795,  3266,  5288,
     184,  3405,   186,   489,   772,    15,  3088,  2805,   211,  4888,
    5734,  5735,  2085,   738,  3421,   774,   583,    57,  3421,  2816,
     345,   774,  3104,   747,  5185,  5186,  5187,   772,  5189,  2102,
     404,  2104,   279,   277,   638,  2108,   412,   738,    92,   149,
     566,  3099,  3100,   140,     9,    10,   755,  2120,  2121,  3423,
      79,   252,   303,    82,  2127,  3607,   451,  3609,    42,   468,
     608,  2134,  2135,   353,  2137,  2138,  3124,   177,     9,    10,
     762,   763,   764,   765,   566,   489,   951,   952,   953,  2152,
       9,    10,   184,  2156,   186,   460,   184,   303,   186,   681,
     485,   755,   303,  2166,   661,   453,   184,   303,   186,  5359,
    2173,   184,   123,   186,  5393,     6,   184,   481,   186,   149,
    2183,  2184,  3080,   774,   662,   125,   122,  3975,   622,   303,
      93,   771,     9,    10,   499,   205,  2831,  5834,   774,  2848,
     140,     9,    10,   117,  1009,   141,     6,   177,     9,    10,
    1141,   112,   100,  2848,   128,     9,    10,  5854,     9,    10,
     204,   135,    18,   182,  2883,   356,   532,  2883,   361,  2883,
    2226,   171,   172,   774,   274,  2226,   561,    68,   265,  2883,
     579,   251,   676,  5022,  4758,   779,  4760,   586,  2883,  2884,
       9,    10,  2822,   167,   205,   594,  1142,  2892,  2893,  2894,
    2421,  2822,   272,  2911,  5586,  5587,  5697,  2612,    68,  2740,
     297,   303,  3166,   425,  2922,   303,   828,   217,  5057,     9,
      10,  2831,   738,   723,  4798,   303,  3180,     6,   112,   184,
     303,   186,   844,   716,   278,   303,   591,  5487,  2848,     9,
      10,   404,  5017,   204,   274,   264,     9,    10,    95,   105,
     106,   774,   478,   184,   228,   186,   738,   642,   774,  1250,
     774,     6,  2387,   755,  1255,   184,    11,   186,   667,    61,
      15,  2334,  2980,  2883,  2884,   404,  3089,  2340,   125,   779,
    5559,  2686,  2892,  2893,  2894,   259,     9,    10,   779,    68,
     655,    18,   774,  2356,  4807,   486,   779,     9,    10,    95,
     771,   774,     6,  3011,  4878,   774,  2837,   184,   779,   186,
    4823,     9,    10,     6,   669,   100,   184,  5612,   186,   444,
    2074,  3040,   265,   184,  3040,   186,  3040,   123,  2506,   728,
     184,  2387,   186,   184,  2449,   186,  3040,   774,  2387,   565,
    2518,   316,  5030,   128,  1335,  3040,     9,    10,   303,  4862,
      95,  4864,   481,  2468,  3062,  5650,  5651,   427,  5849,  5850,
     716,   774,     9,    10,    68,   184,   491,   186,  2122,   560,
    3063,  4260,   303,   296,   772,    68,  5746,   588,   105,   106,
    2443,  2444,  2445,   100,   303,    57,  2449,  3080,  5745,   352,
    2453,  2454,  2455,  2456,   184,    94,   186,     6,  2461,  2462,
     185,  2464,   149,   772,    15,  2468,   100,  2161,  5064,   265,
    5469,  3138,   149,   112,   184,   771,   186,    89,  1409,  3138,
    4014,   184,  3138,   186,  3138,    26,   303,   772,  1419,  2491,
     177,  2185,  2186,   105,  3138,   303,  1427,   562,  5497,  2502,
     177,  3678,   303,  2506,   123,     9,    10,   502,  5223,   303,
    5225,  2513,   303,  5748,  2569,  2518,  1447,   683,  1449,  2521,
     772,   184,  2640,   186,   730,  4245,   772,   152,  2646,  2647,
     237,  3166,   184,   684,   186,  3262,   439,   149,   441,  3266,
    4074,  4075,  2545,  4183,   303,  3180,   184,  4187,   186,  1435,
    3727,     9,    10,  3447,     9,    10,  1109,   688,  2561,  2562,
      94,   238,  2532,  5391,   771,   177,  2569,  2570,  2571,  2565,
       9,    10,   738,   303,   125,     9,    10,    10,   112,  3307,
     331,   184,    15,   186,  1137,  3997,   737,   661,  3138,   140,
      93,   772,  2594,   303,  1399,   669,  2599,   184,   265,   186,
     303,   675,  3496,  2606,     9,    10,  2608,  2610,     9,    10,
     418,    10,  4115,  4116,  4265,    35,  3166,   748,  3089,  5247,
     284,   771,   299,  2678,   408,  3637,   772,    47,   531,   779,
    3180,   772,  2635,  2636,  2637,  2638,   772,  2640,  4177,  4142,
     303,  3975,  2645,  2646,  2647,   377,  2649,   379,   151,  4693,
     761,   303,  2655,  3286,     9,    10,   112,    57,   772,   567,
     568,   772,   274,   774,  4167,   303,   217,  2670,   761,     9,
      10,  2674,  3400,  5762,  3978,  2678,  2679,  3405,  4217,   772,
     184,   118,   186,   761,   416,  3030,   171,   172,   125,    89,
    5286,  3418,   125,    95,   772,   136,   137,  3685,     9,    10,
     303,   738,  2704,     9,    10,   105,   609,   140,   663,  2711,
    2712,     9,    10,   445,  1645,   663,   303,   220,  3367,    57,
    5776,  5777,   450,  1654,  5813,  3682,   184,  5816,   186,   184,
     670,   186,  3367,  4263,  1665,   253,   644,  2740,   171,   172,
     772,  1412,  1413,  2746,   772,   184,   264,   186,   263,   149,
     184,    89,   186,   190,   772,     9,    10,   623,  5847,   772,
       9,    10,   986,  4414,   772,     9,    10,  2822,   634,  2824,
       9,    10,  5828,    95,   771,  1446,   772,   177,   421,   184,
    1004,   186,   779,   184,   217,   186,  1010,  1011,  3421,   772,
     771,   774,   233,    17,   343,   298,   237,  2491,   779,   303,
      93,    94,     9,    10,    57,  2808,   771,  2810,    32,   778,
      34,   149,  3447,  2816,   779,    29,  2819,  3367,   771,  2822,
      34,  2824,  2825,     9,    10,  4453,   779,     6,   656,   184,
    4458,   186,     9,    10,  2837,   478,    89,  2840,   387,   177,
     389,   115,   771,   771,   184,   303,   186,   288,   303,   581,
     779,   779,  2907,  2849,  2909,   760,   761,  5905,   299,   771,
     774,  3496,   297,  1794,   303,  1286,  2560,   779,  1799,   303,
    1801,  1292,  1293,   184,   274,   186,  4705,   772,   184,   333,
     186,   772,   771,   774,  3229,   617,   184,   115,   186,    68,
     779,  3644,  3645,  3646,  3647,   115,   149,  3447,   303,     9,
      10,   772,   303,  3536,  2907,   779,  2909,   726,   727,   727,
     729,  4016,   731,   772,   779,  1846,    17,  4022,    84,   772,
    4025,   774,   565,   736,   177,  1369,  1857,  4032,  1372,  1373,
     184,    32,   186,    34,   483,   263,   274,  1868,  3926,   772,
     184,   774,   186,    76,    77,   184,  3496,   186,   303,   651,
    3583,  4255,  1548,  1549,  4484,   772,   251,  3605,    69,   427,
     772,  1557,   774,   303,  4687,  4688,   772,   421,   774,    93,
      94,   772,  3443,  3444,  3445,  3446,   771,   184,   772,   186,
      76,   772,  3327,   532,  3737,    10,  5582,  3052,  5584,  5585,
      15,   270,   303,  1589,   772,  1591,   774,   303,   184,   772,
     186,   774,   772,  3164,   774,   303,   772,   184,   774,   186,
    1606,  1607,  1608,   772,     5,   339,   340,    95,  3651,  1615,
    1616,   274,  3025,   772,   478,   774,  1622,  3372,   112,  3374,
    3375,  1962,   581,    57,   683,  3380,  3763,  3764,  3040,   772,
     683,   774,   772,  3388,   601,  3939,  1977,   641,  3393,   303,
    3046,   333,   376,  4704,   165,  3058,  3052,  1988,  1989,   303,
      93,   578,   772,  3052,   303,    89,   771,   291,   292,   772,
     249,   250,   183,   527,   184,  4252,   186,   772,   755,   774,
     259,  3084,  3715,   760,   761,  3088,  3089,  3090,  5684,  5685,
     697,  4502,  5688,   467,   418,   738,   303,   772,   180,   774,
     125,  3104,   413,   270,   772,   329,   774,  3103,   141,   772,
     115,   565,  3103,   146,  3103,   140,   772,   303,   774,   772,
     772,   774,   671,   347,  3103,   149,   303,   180,  3246,   353,
     117,   774,  3293,  2064,   772,  3138,   772,  2831,   774,    36,
     772,   128,   774,   772,   693,   774,   171,   172,   135,   418,
     110,   111,   185,   177,  2848,   379,  3103,  3160,   774,    97,
    1489,  1490,   110,   111,  1493,  5761,    69,   114,  3171,   772,
     130,   339,  4675,  3644,  3645,  3646,  3647,  4557,   348,     9,
      10,  3177,   778,  3172,  4564,   772,   296,   771,  2074,  2883,
    2884,   781,   217,   303,   132,    92,   478,   771,  2892,  2893,
    2894,   771,    69,  2134,  2135,   771,  2137,  2138,   771,   524,
     525,   171,   172,   528,   529,   530,   771,  3272,   115,   771,
    4023,  4024,   125,  4088,  4027,  2156,  1669,  1670,   329,   683,
     197,  4034,  4612,   130,   771,  2166,  2122,   670,   771,  3294,
    3295,   228,   771,  3246,   204,   527,   347,  3975,  3251,   292,
     274,   294,   353,  4241,  4242,  3503,    17,   771,   125,  3262,
     771,  3509,   165,  3266,   771,    95,  3737,  3515,   772,  3272,
     771,    32,   259,   597,   772,  2161,   774,  3280,   379,   772,
     183,   774,  4270,   565,   738,   730,   772,   466,   774,  3344,
     614,  3294,  3295,   772,   772,   774,   774,    58,   165,  2185,
    2186,   772,   771,   774,  3939,  4844,   771,   204,    67,    70,
     772,   772,   774,   774,   772,   639,   183,   772,   278,   771,
     774,  3323,  3324,  3325,  3326,    49,  3328,  3329,   771,    90,
     771,   771,  5378,   772,     9,    10,   239,   240,   772,   771,
     771,  3344,   302,   772,  5034,   774,  3040,   772,   505,   774,
     507,   508,   771,   771,   184,   679,   186,  3360,   772,   771,
     774,   122,   772,   124,   774,   522,   772,   772,   774,   374,
     730,   772,   239,   240,  3376,  3377,   381,  3379,   771,  3381,
    3382,  3383,  3384,  3385,  3386,  3387,   772,  3389,   774,  3939,
    3392,   396,   771,  4896,  3396,   772,   771,   774,     9,    10,
      11,   683,   771,  2334,  4915,   164,    36,    34,   772,  2340,
     774,   164,   171,   172,   374,  3418,   421,   772,   166,   772,
      18,   774,   507,   508,  4529,   771,  4531,     9,    10,   772,
     771,   774,   772,   772,  3437,   774,    69,   522,  4087,  3442,
    3443,  3444,  3445,  3446,  3138,  4550,  3449,   772,   771,   774,
     771,   210,  4087,  4088,   771,  4560,   738,   210,   772,    57,
     774,  3622,    92,   620,   621,   191,   772,  4572,   771,  4222,
    4223,   771,  3166,   303,   772,   372,   772,  4125,   774,   191,
     772,   205,   774,   771,  4589,   115,  3180,   771,    86,     9,
      10,    89,   251,   672,   673,   674,   675,  5148,   251,   723,
     130,   771,  3847,  3848,  3849,   771,   444,   105,   106,   184,
     772,   186,   774,   772,  2445,   774,   771,   191,   772,   280,
     771,   526,  2453,  2454,  2455,  2456,  3997,   487,   772,   771,
     771,   292,   165,   772,   539,   620,   621,  4087,  4088,   263,
     191,   772,  4530,   774,   771,     9,    10,    11,   272,  4197,
     183,   149,   771,   491,   559,   771,  4204,  3810,  3811,   771,
     771,  3814,  3815,   771,   265,   772,   196,  3820,  3821,   771,
     168,  5261,   771,   184,   204,   186,   771,  4244,   176,   177,
     772,  3584,   774,   771,   771,  4244,   772,   771,  4244,   313,
    4244,   266,   772,   771,   774,   772,  3941,  3942,   771,  3944,
    4244,   772,   184,   774,   186,  2491,   239,   240,   772,   772,
     774,   774,   771,   771,  2545,   374,   772,   555,   774,   771,
    3623,   374,   723,   772,   771,   774,    33,   386,   303,    36,
     772,  3749,   774,   386,  3637,   771,   397,   270,   399,   771,
    2571,  3644,  3645,  3646,  3647,   670,  3649,  3649,   771,   760,
     761,   762,   763,   764,   765,   333,   772,    32,   774,   771,
      69,   599,  3665,  3666,   184,  5002,   186,   265,  2264,  5002,
     772,  2267,   774,  3367,  2560,   273,   274,   275,   683,   772,
     772,   774,   774,    58,   266,    92,   772,  2283,   774,    96,
     587,  3694,   303,   698,  4244,    70,   374,   772,   771,   774,
    3703,  2297,  4596,   427,  3707,   771,  3702,  2638,   115,   771,
     771,  3702,  5421,   771,  2645,    90,  5425,   771,  2649,   771,
     184,   303,   186,   130,  2655,   771,   771,  5107,  5108,   453,
    5110,   490,   771,   771,  3737,  4402,   771,   490,   779,  2670,
    3743,  3744,   372,   421,   771,   771,  3749,   197,  4385,   124,
    4553,  4222,  4223,  3447,   771,   771,   165,  4394,   771,   771,
    3763,  3764,   440,  5274,   771,   771,  4014,  3770,  4016,   771,
    4018,   771,  4020,  4576,   183,   771,   771,  4580,   771,  5496,
    4028,   771,   771,   303,   744,  4588,   771,  4035,   771,  4037,
     771,   552,   130,   391,   771,   771,  4044,   204,   695,   743,
     478,   399,  3496,   562,   197,    69,  4054,   578,   774,   562,
    4058,     9,    10,   755,   180,   641,  4064,   755,   756,   757,
      95,  4166,   180,   237,   779,  4073,  4074,  4075,  4076,  4077,
     239,   240,   663,   171,   172,   771,   779,   244,   213,   303,
    5530,     9,    10,  4188,  5224,   779,   779,   779,  5557,   527,
       9,    10,   779,   779,  4102,   758,   759,   760,   761,   762,
     763,   764,   765,  5374,    69,   779,   204,     9,    10,  4518,
    5521,   278,   698,    34,   779,   701,   681,   779,   426,   141,
      93,   559,  5711,  4518,  3927,  2816,   681,   565,  2819,   697,
     669,   758,   759,   760,   761,   762,   763,   764,   765,   660,
      61,   165,   728,  3906,   420,   280,   502,    93,   774,  2840,
     736,     9,    10,   123,   400,   774,  5455,   774,  3921,   183,
    4579,   576,   348,  4579,   774,  4579,    93,    95,   652,   382,
     774,   774,   573,   755,   692,  4579,    95,    80,   736,  5319,
     278,  5321,  5322,   453,  4579,  2831,   453,    94,   709,   110,
     111,   774,   196,    95,   265,   100,   281,   587,    26,  4947,
     165,  4596,  2848,   125,    61,   372,   396,   780,  4518,   130,
    3973,   732,     5,   577,  3977,   239,   240,  3980,   183,   395,
       9,    10,    11,     4,   470,   736,   184,   779,   186,   418,
      14,  4398,    93,  4400,  3997,    93,  4403,  2883,  2884,  4406,
     774,  5540,  4409,  4410,   728,   683,  2892,  2893,  2894,   779,
     171,   172,   736,    84,   779,   176,   184,   421,   186,   180,
     125,   413,   397,    42,   399,   184,   697,   186,   772,  4579,
     771,   112,  4926,   499,   239,   240,   374,   296,  4445,    95,
     555,   123,   184,   204,   186,   296,  4596,     9,    10,   535,
     771,   537,    49,  4686,   774,   151,   542,  5394,  5395,  5710,
     738,  5394,  5395,   778,   156,   695,   771,     6,   266,  5558,
     374,   418,  5561,   772,   772,  5904,  4421,  4422,  4423,   772,
    4083,    68,   324,  4428,  4429,   774,   184,   779,   186,  4434,
     772,    53,    54,    55,    56,   772,   774,  4442,   117,    96,
     772,  4446,   642,   779,    93,   303,   772,    93,   706,   128,
     772,   709,  4457,  5652,   772,   779,   135,   278,   115,   771,
     718,   607,   140,   771,   100,   758,   759,   760,   761,   762,
     763,   764,   765,   270,   774,   303,   774,    15,   781,   774,
      18,   302,    93,   762,   303,   107,   108,   109,   167,   487,
     779,   774,    34,  3084,  3040,   184,   774,   186,   681,  3090,
     762,   303,   125,  4800,   650,   482,  4803,  4804,   694,   442,
      93,   774,  4175,   334,   478,  5664,   551,   552,   426,    57,
     587,   681,  5671,   772,   771,   771,   774,   780,   125,  4192,
    5084,   774,   196,   351,   502,  4356,   218,   502,   348,   161,
     162,   502,  4205,  4205,   502,   303,   502,  5718,    86,   228,
     502,    89,   774,   374,   774,  4218,   755,    84,   379,  4222,
    4223,   669,   184,  5874,   186,  4228,  4228,   105,   106,  4888,
     270,     6,  4888,   666,  4888,  5774,   589,  5888,   736,   772,
     259,  4244,  4245,  5894,  4888,  3939,   188,   244,  4593,  5900,
     772,  4254,  3138,  4888,   740,   559,   348,   128,   772,  4908,
     772,   565,  4265,  4266,  4405,   751,   263,  4263,  4271,   772,
     232,   149,   128,  4908,   303,  5764,  5765,   771,   774,    26,
    3166,   278,   779,   104,   430,   229,   779,   658,   695,   409,
     168,  4926,   771,   472,  3180,   472,  4298,   774,   176,   177,
     588,  4960,   394,   772,  4960,  4308,  4960,   774,  4311,    29,
    4313,   296,   616,  5207,   727,  4370,  4960,   283,   696,   774,
    3251,   201,    83,   185,    95,  4960,   487,  5838,   180,   326,
     774,  3262,    93,   774,   709,  3266,   270,   637,  4888,   350,
    4343,   303,   304,  5237,   116,   123,   357,    59,   643,  4352,
    4508,   760,   761,   762,   763,   764,   765,   772,  4908,  4477,
     121,   772,   373,   418,   772,   762,  4368,  4370,    95,  5002,
     772,  4536,   383,   384,   385,   771,  4926,   772,  4626,   683,
     141,  4384,   393,  4438,   476,   146,   772,   265,  4399,   772,
     772,  4556,   761,  4087,  4088,   273,   274,   275,  4401,   772,
    4565,   238,  4413,   779,   772,  4812,  4571,   404,   772,  4412,
    4960,  4414,   772,   772,   196,   772,  4581,  4420,   722,  4430,
     772,   772,   772,  4426,   185,  4590,  4591,   772,    11,  4431,
    4432,   774,   774,   772,   738,  4438,  4439,  4448,   400,  4450,
    4451,   774,   774,   774,   772,  4447,   538,   765,   772,  5084,
     772,    34,   771,    34,   366,   771,  4459,   771,   771,   584,
     772,   755,  4465,  4466,   265,   557,   558,   265,  4471,  4471,
     562,   563,   564,  5367,  4477,   265,   270,    99,    61,  4482,
      61,  3367,    95,   774,  4539,   774,  5866,  3418,  4484,  5126,
    4545,    49,    93,   654,   758,   759,   760,   761,   762,   763,
     764,   765,    93,   771,   771,   496,  5494,   779,   470,   774,
     779,   774,  4508,   391,   772,    95,   277,  4508,  3449,  4508,
      49,   399,   779,   534,   608,   772,  5391,   110,   111,   110,
     111,   237,    62,   774,  5084,   774,  4539,   548,   630,     6,
      42,   663,  4545,   774,   726,   774,    93,   130,   742,   130,
    4244,   128,   128,   570,   759,   760,   761,   762,   763,   764,
     765,  3447,   430,   540,    57,  4910,   550,  4912,   771,  4914,
     251,  4574,  5207,   535,   251,   537,   651,   251,   251,   251,
     542,   299,   180,   744,   771,    93,   115,   679,   171,   172,
     171,   172,   755,   176,   774,   176,    89,   180,   266,   180,
     755,   374,  5237,   755,   755,   501,    53,    54,    55,    56,
    3496,   755,   105,   727,   755,   117,   755,   110,   111,   755,
     755,   204,   755,   204,   755,   755,   128,   755,   755,   755,
     284,  5619,   755,   135,   755,  4980,   755,   755,   649,   755,
     755,   638,   755,    33,  5632,   607,    36,   205,   421,   755,
     570,   755,   141,   270,   771,   652,   149,  5207,   321,   656,
     107,   108,   109,   774,   270,   167,  4721,   779,   270,   779,
     779,  4674,   774,   270,   747,   686,   205,   499,   180,  5667,
     380,   123,   772,  5028,   177,   778,   122,  5237,   650,   700,
     122,   779,   772,   251,   772,   278,   772,   278,  4741,   191,
     772,  4704,    92,   761,   701,   478,    96,   772,   761,  4712,
     779,    26,   779,   772,   161,   162,   690,   774,  4721,   302,
     772,   302,  4725,   771,   771,   115,   228,   326,   270,   578,
    4733,   728,  5367,    95,    95,    95,    95,   779,   265,   265,
     130,   484,  5469,   272,  4787,  4748,   211,  4749,  5417,  4792,
     177,   334,   779,   334,   774,  4810,  5391,   259,   761,    11,
     299,  5394,  5395,   771,   774,   755,   536,   755,   326,   321,
    5497,    92,   180,   180,    10,   771,   771,   128,   740,  4790,
     270,   274,   284,   128,   396,   232,   559,   396,   265,   751,
     772,   374,   565,   374,   774,   265,   265,   219,  4801,    11,
     771,   771,   771,  4806,  4807,  4808,   196,  4810,  4811,   100,
    4813,   779,  3743,  3744,   204,  4818,  4819,  5367,  4820,    42,
    4823,   224,    42,    93,  4518,    72,   762,   578,   706,   270,
     762,   709,  3763,  3764,   180,   114,   462,   778,   413,   774,
     718,  5391,   771,   616,   771,  4847,   404,   771,   333,    56,
     124,   124,   177,   772,   244,  4858,   772,   304,   772,  4862,
     771,  4864,   772,   185,   779,   774,   774,   772,   772,   427,
     771,   122,   455,   779,   772,    26,   771,   771,   755,   220,
    4883,    95,    95,  4886,  5553,  4579,  4889,   772,   278,   374,
     774,  5618,   211,   772,   117,   453,    17,   117,   427,  4901,
     772,   774,  4596,  4906,   487,   128,   487,   298,   128,  5897,
     683,   771,   135,   772,  5162,   135,   774,   771,   779,   211,
     771,  5169,  4918,   547,   453,   755,  5271,  4918,   774,  4932,
     396,  5179,   180,  5568,   284,  5183,   771,  4980,   771,    11,
    5188,   284,   366,   501,   167,   774,   772,   167,   265,   722,
     774,   186,   372,   400,   437,   440,   196,   180,   196,   270,
     180,   409,   196,    26,   196,   738,  5633,   734,   129,   409,
     698,   129,   501,   698,   196,   196,   270,  4980,   585,   196,
     196,  4984,   372,    11,   651,   196,   653,   430,   229,   110,
     111,   772,   350,   478,    99,   494,   415,  5891,   203,   357,
     667,   774,   379,   771,   570,   228,   673,   674,   228,   771,
      61,    93,    93,   680,   177,   373,   772,    26,  5568,   772,
     235,   299,    17,   470,   772,   383,   384,   385,   496,   637,
     185,   142,   699,   774,    26,   393,   259,   772,  5041,   259,
     772,  5386,   527,   774,   196,   774,   772,  5050,   772,   438,
     146,  5054,   774,  3939,   771,   746,   140,   196,   180,    11,
    5063,  5064,  5065,   772,   669,  5068,   284,   143,   597,   771,
     177,   654,   586,   654,   559,   284,   177,  5080,   734,   112,
     565,   130,   734,   216,   204,   779,   598,   180,   535,   180,
     537,   374,   477,   266,   652,   542,    95,  5100,   656,  5102,
     430,   299,   578,   123,   379,   294,   294,   570,    17,   638,
     771,   215,   772,   772,   772,   110,   111,   772,   141,  5122,
     490,   774,   772,   772,   540,    32,  5129,   656,   608,  5132,
    5133,   252,   772,  5136,   124,   772,   774,  5140,    26,  5142,
     698,  5302,   263,   772,   772,  5148,   779,   772,  5151,   772,
      10,   818,   771,   774,  5157,   771,    11,   648,   772,    26,
     607,   744,   772,   744,    26,    79,   437,   771,   771,   698,
     728,  5840,   701,    26,   177,   771,   534,  2116,   736,   319,
      93,   771,   771,   130,   130,    93,   130,   774,   772,   771,
     548,   299,   378,   299,  4888,   774,   130,   587,   683,   728,
     662,  4087,  4088,   650,   263,   413,   305,   736,   779,   280,
     755,    93,    93,   177,  4908,  5218,   772,   774,   772,   772,
     887,   678,   540,   771,   577,   410,  5229,   771,  5231,   772,
     436,   898,  4926,   900,   901,   902,    11,   772,   774,    67,
     907,   180,   909,   635,    93,    26,   774,    26,    26,   265,
     400,    84,    84,   738,   284,   263,  5891,   252,   771,   779,
     779,   779,   779,   779,   779,    33,  4960,   281,   779,   779,
     779,   578,   779,   940,   779,   779,   634,   177,   945,   779,
     451,   779,   779,  5286,   772,   772,   407,   643,   772,   431,
     596,   649,   596,   740,   354,    91,   771,   771,   771,  5295,
     421,   570,   423,  5306,   751,   695,    61,   771,   975,    61,
     154,   772,   678,   772,   774,   578,  5359,    33,   985,    33,
    5363,   779,    10,   772,   689,  5328,   704,   177,   686,   302,
    5333,   570,    26,   454,    26,   123,   771,   771,  5349,   180,
     771,  5891,   700,  5386,   130,   771,   771,   695,   469,  5352,
     734,   176,   281,   130,  5357,   327,    61,    11,  4244,   578,
     771,  5364,   419,   643,   409,   409,   771,   421,   578,  5372,
    5373,   772,   774,   779,   772,   771,   771,  4308,   771,   173,
     774,   502,  4313,  5386,   771,   771,   730,   690,   582,    93,
    5084,   413,   772,  5436,   326,   771,   779,   772,  5743,   520,
     771,   146,   320,   772,   180,   779,  5409,  1074,  1075,  1076,
    1077,   180,   407,   229,    63,   281,   472,   774,   772,  5422,
     772,  1088,    75,  5426,    26,   114,   421,   177,   423,   771,
     237,  3103,   914,  3394,   774,  4914,  2582,  4910,  5441,   643,
    4912,  5496,  1225,  3242,  5487,  5419,  3831,  5089,  5433,  5566,
    5753,   752,  1404,  4322,  4332,  5458,  4984,  5298,  4960,   454,
    5307,  5229,  5505,  5244,  5386,  4593,  2603,  1741,  3715,  5568,
    3489,  3992,  4519,  2756,   469,  1142,  2184,  2187,  4088,  2185,
     601,  5483,   819,  2186,  1445,  2051,  5296,   608,  2109,  4420,
    5073,  3920,  5295,  5496,  3356,  4830,  4214,   618,  5039,  4218,
    4674,  2429,  5640,  5274,  5713,  5043,  5838,   502,  5793,  5840,
     631,  5553,  2631,  5207,  4397,  3912,  5427,  4465,  5521,  5733,
    5523,  3921,  4793,  5588,  5068,   520,  5777,  5588,  5618,  5497,
    4145,  4024,  4079,  5621,  4538,  5633,  3588,  5138,  4546,  4187,
    5812,   662,  4184,  5237,   665,  4179,    90,    90,  5765,  5764,
    5334,  5737,  5671,  5664,  5119,  5422,  5117,  4564,  3738,  3920,
     681,  4461,  5565,  1937,  1240,  3226,  5569,  5356,  1423,  5629,
    5573,  5574,  2746,  3221,  5137,  2088,   697,  2445,  5621,  5582,
    3449,  5584,  5585,     7,  2856,  2571,   135,  1384,   758,  4009,
    3161,  5752,  5588,  3046,  1261,  1337,  5599,  1264,  5653,  5588,
    1163,  3290,  3983,  3095,  1373,  4205,   601,  2979,  2975,  5612,
    5612,  1673,  4204,   608,  1335,  3622,  1583,    41,  1551,  1989,
    1335,  1984,  1335,   618,  1731,  1335,  5629,  1335,  5105,  4762,
    4257,  5573,  4518,  4712,  2684,  5574,   631,  5640,  1979,    63,
    1557,  3614,  3282,  2005,  4352,  5647,  5648,  4351,  3612,    73,
    5653,  5034,  5530,  5148,  4693,  5030,  3286,  5048,  1365,  5661,
    4356,   764,   108,  2678,  5707,  2808,  1865,   662,  1391,    90,
     665,  5674,  1503,  5367,  2849,    99,  5679,  3177,  5733,  4704,
    4718,  5684,  5685,  3320,  4256,  5688,   681,  4254,  5710,   683,
     836,   115,  2102,  4579,   837,  2541,   120,  5391,   674,  1387,
    2542,  2597,   125,   674,  3155,  1813,  5151,  5710,  5057,  1926,
    4596,  1507,  4012,  5836,  4767,  5857,  5114,  5894,  5900,  1008,
    5722,  2561,   146,  5725,  3040,  4265,  4244,  3136,   673,  2495,
    5733,  2370,   673,  5776,  5777,  3116,  5791,  3115,  2166,  1955,
    5901,  1755,   670,  3088,  1499,  5748,  5748,  3846,  1145,  4370,
    5215,  3437,  5755,  3236,  3927,   712,  2740,  1282,  5761,  2698,
    2699,   114,    90,    90,    90,  1432,  5097,  1434,  1435,    -1,
    5310,    -1,    -1,    -1,    -1,    -1,  2715,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5828,  2725,  2726,  5791,    -1,
      -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4733,    -1,    -1,    -1,    -1,    -1,  5811,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
      -1,    -1,    -1,  5878,    -1,    -1,    -1,    -1,    -1,  5884,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1505,    -1,
    1507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,
      -1,  2790,  2791,  2792,  2793,    -1,    -1,   281,   282,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1533,    -1,    -1,    -1,
      -1,  5874,    -1,    -1,  5568,  5878,    -1,  1544,  1545,    -1,
      -1,  5884,    -1,  1550,    -1,  5888,    -1,  1554,  1555,  1556,
      -1,  5894,    -1,    -1,    -1,    -1,    -1,  5900,  1565,  1566,
      -1,    -1,    -1,    -1,  1571,    -1,  1573,  1574,  1575,  1576,
    1577,    -1,  1579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1590,    -1,  1592,    -1,    -1,  1595,  1596,
      -1,  1598,  1599,  1600,    -1,  1602,  1603,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1617,  1618,  1619,  1620,  1621,  4886,  1623,  1624,  1625,    -1,
      -1,  1628,  1629,  1630,  1631,  1632,  1633,  1634,    -1,  1636,
    1637,  1638,  1639,  1640,  1641,    -1,  1643,  1644,    -1,  1646,
    1647,  1648,  1649,  1650,  1651,  1652,    -1,    -1,  1655,  1656,
    1657,  1658,    -1,  1660,  1661,  1662,    -1,  1664,    -1,  1666,
      -1,  1668,  4888,   427,    -1,  1672,  1673,  1674,   432,    -1,
    1677,  1678,  1679,  1680,  1681,    -1,  1683,    -1,    -1,   443,
      -1,    -1,  4908,  1690,    -1,    -1,    -1,    -1,    -1,    -1,
    1697,  1698,  1699,  1700,    -1,    -1,    -1,    -1,    -1,    -1,
    4926,  1708,  1709,    -1,  1711,  1712,    -1,    -1,  1715,  1716,
    1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,
    1727,    -1,    -1,  1730,    -1,    -1,     5,    -1,     7,     8,
      -1,    11,    -1,    -1,  4960,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    33,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    42,    -1,  1771,    -1,    -1,    -1,    -1,  1776,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1786,
      71,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      80,    80,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    91,    93,    -1,    -1,    -1,    -1,    -1,    -1,
     100,    -1,   113,    -1,   104,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   114,    -1,   115,   117,   602,    -1,
      -1,   121,    -1,   123,    -1,    -1,  1853,    -1,   128,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,  5891,  5084,   623,
      -1,   141,   153,    -1,   628,    -1,   146,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1883,    -1,  1885,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   659,    -1,    -1,    -1,    -1,
     180,    -1,   181,    -1,    -1,   185,   185,    -1,    -1,    -1,
      -1,    -1,  1919,    -1,   193,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   205,    -1,   691,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     219,    -1,    -1,    -1,    -1,    -1,    -1,  5218,   228,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,   255,   256,    -1,   259,
      -1,  5207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2002,    -1,   277,   277,    -1,
      -1,    -1,    -1,   283,   284,    -1,     5,    -1,     7,    -1,
      -1,  5237,    -1,    -1,    -1,    -1,    -1,   297,    -1,   299,
      -1,    -1,   302,   302,    -1,    -1,    -1,    -1,    -1,    -1,
    3309,  3310,    31,  3312,  3313,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   334,    -1,   336,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,  2074,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,   355,    -1,    -1,    -1,
      -1,  5352,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   374,    -1,    -1,    -1,    -1,
      -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,  2122,   115,   396,    -1,    -1,
      -1,    -1,    -1,    -1,  3403,    -1,    -1,   406,    -1,    -1,
      -1,   410,   411,    -1,    -1,    -1,    -1,    -1,   417,    -1,
      -1,  5367,   421,    -1,  2151,    -1,    -1,   146,    -1,    -1,
     429,    -1,    -1,    -1,  2161,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2169,    -1,    -1,  5391,    -1,    -1,    -1,   449,
     449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2185,  2186,
    2187,    -1,   473,  2190,    -1,    -1,   185,    -1,    -1,    -1,
      -1,  2198,  2199,    -1,   193,    -1,   475,    -1,    -1,    -1,
     479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,    -1,   503,   504,    -1,   506,   507,   508,   509,   510,
     219,   512,   513,   514,   515,   516,   517,   518,   519,    -1,
     521,   522,   523,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,   255,   256,    -1,    -1,
     539,    -1,   541,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,    -1,    -1,  2290,  2291,  2292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5565,    -1,    -1,    -1,    -1,    -1,
      -1,   580,    -1,   302,    -1,    -1,    -1,   586,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,   620,
     621,    -1,    -1,    -1,   613,   334,    -1,   336,    -1,    -1,
      -1,    -1,  5568,    -1,    -1,   624,   625,   626,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,  2366,
      -1,    -1,    -1,    -1,    -1,    -1,   645,    -1,    -1,    -1,
      -1,    -1,    -1,   652,    -1,   374,    -1,    -1,    -1,    -1,
    2387,    -1,   381,    -1,  2391,  2392,    -1,  2394,  2395,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2403,   396,  2405,    32,
      -1,    34,    -1,    -1,   683,    -1,    -1,   406,    -1,    -1,
      -1,   410,    -1,    -1,    -1,    -1,    -1,    -1,   417,   698,
     699,    -1,   421,    -1,    -1,    -1,  2433,    -1,    61,    -1,
      -1,    -1,   711,    -1,    -1,   714,    -1,    -1,    -1,    -1,
    2447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     449,    -1,    -1,  2460,    -1,    -1,  2463,    -1,    -1,    -1,
      -1,    -1,   742,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2477,    -1,    -1,    -1,    -1,   755,    -1,   110,   111,    -1,
     479,    -1,   115,    -1,  2491,  2492,    -1,    -1,    -1,    -1,
     489,    -1,   772,    -1,   774,    -1,    -1,   777,   778,   778,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     539,    -1,   541,    -1,    -1,    -1,    -1,    -1,  2555,    -1,
      -1,    -1,    -1,  2560,    -1,    -1,    -1,    -1,    -1,    -1,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   580,    -1,    -1,    -1,    -1,  3865,   586,    -1,  3868,
    2597,    -1,  3871,  3872,  3873,  3874,    -1,  3876,  3877,  3878,
    3879,    -1,  3881,  3882,    -1,  3884,    -1,    -1,    -1,  3888,
      -1,    -1,    -1,  3892,  3893,  3894,  3895,    -1,  3897,  3898,
      -1,   254,   255,   256,  3903,  3904,    -1,    -1,  3907,  3908,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,    -1,   645,    -1,    -1,    -1,
      -1,    -1,    -1,   652,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5891,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,  2681,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   683,    -1,    -1,    -1,  2695,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   698,
     699,   334,    -1,   336,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   711,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     353,    -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   374,    -1,    -1,    -1,  2752,    -1,    -1,   381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   406,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2831,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2848,    -1,    -1,    -1,    -1,   479,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2883,  2884,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2892,  2893,  2894,    -1,    -1,
      -1,    -1,  2899,   526,    -1,  2902,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2911,    -1,   539,    -1,    -1,    -1,
      -1,    -1,    -1,  2920,    -1,  2922,    -1,  2924,    -1,  2926,
    2927,  2928,  2929,  2930,  2931,    -1,  2933,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2941,    -1,  2943,    -1,    -1,  2946,
    2947,  2948,    -1,    -1,    -1,    -1,    -1,   580,  2955,  2956,
    2957,    -1,  2959,   586,  2961,    -1,  2963,    -1,  2965,    -1,
    2967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2975,    -1,
    2977,    -1,  2979,  2980,  2981,  2982,  2983,    -1,    -1,  2986,
    2987,  2988,    61,  2990,    -1,    -1,  2993,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3006,
      -1,    -1,    -1,    -1,  3011,    -1,    -1,  3014,    -1,  3016,
    3017,  3018,   645,    -1,  3021,    -1,    -1,    -1,    -1,   652,
    3027,    -1,    -1,    -1,    -1,  3032,    -1,    -1,    -1,    -1,
      -1,   110,   111,  3040,  3041,    -1,   115,    -1,    -1,    -1,
    3047,    -1,  3049,    -1,    -1,  3052,    -1,     7,     8,    -1,
     683,    -1,    -1,    -1,    -1,  3062,    -1,  3064,    -1,    -1,
      -1,    -1,  3069,    -1,    -1,   698,   699,    27,    -1,    29,
      -1,    31,    -1,    33,    -1,    -1,    -1,    -1,   711,    -1,
      -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3105,    -1,
      -1,    -1,    -1,    63,    -1,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    73,   193,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    -1,    -1,    -1,    -1,    -1,  3134,    -1,    -1,
      -1,  3138,  4411,    93,    -1,    -1,    -1,    -1,    -1,    99,
      -1,   774,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   112,    -1,  4433,    -1,    -1,    -1,  3165,  3166,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,  3180,    -1,   254,   255,   256,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,   146,  3194,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   181,    -1,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   195,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   206,   207,    -1,    -1,
      -1,  3258,    -1,    -1,    -1,   334,    -1,   336,   218,   219,
     220,    -1,   222,    -1,    -1,    -1,    -1,   227,    -1,    -1,
      -1,    -1,  3279,   233,    -1,    -1,   355,   237,    -1,    -1,
      -1,   241,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   374,    -1,    -1,    -1,  3306,
      -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   396,    -1,   279,
      -1,   281,    -1,   283,    -1,  3332,  3333,   406,   288,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,   299,
      -1,    -1,   421,    -1,    -1,    -1,   306,    -1,    -1,  3356,
      -1,    -1,    -1,    -1,    -1,    -1,   316,    -1,    -1,    -1,
    3367,  3368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   338,   339,
      -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,
      -1,  3398,  3399,    -1,    -1,   355,    -1,    -1,    -1,    -1,
     479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3447,   401,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,   413,    -1,    -1,    -1,    -1,    -1,    -1,
     539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3487,    -1,    -1,    -1,    -1,    -1,   446,    -1,    -1,  3496,
    3497,    -1,    -1,  3500,    -1,    -1,    -1,    -1,    -1,   459,
      -1,   580,   462,    -1,    -1,   465,    -1,   586,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3524,  3525,    -1,
     480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3549,    -1,  3551,    -1,  3553,    -1,  3555,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   645,    -1,    -1,    -1,
    3577,    -1,    -1,   652,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3598,  3599,    -1,    -1,    -1,    -1,    -1,  3605,    -1,
    3607,    -1,  3609,    -1,   683,    -1,    -1,  3614,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   698,
     699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   711,    -1,    -1,    -1,    -1,   597,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3652,  3653,    -1,    32,    -1,
      34,    -1,    -1,    -1,     7,     8,    -1,    -1,    -1,    -1,
    3667,    -1,    -1,    -1,    -1,    -1,   626,    -1,    -1,   629,
      -1,    -1,    -1,    -1,    27,    -1,    29,    61,    31,   639,
      33,  3688,    -1,    -1,    -1,    -1,    -1,   647,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   659,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,   679,
      73,    -1,   682,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,  3745,  3746,
      93,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   714,    -1,    -1,    -1,    -1,   112,
    3767,    -1,    -1,    -1,   724,    -1,    -1,   120,    -1,    -1,
    3777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,    -1,  3789,    -1,  3791,    -1,    -1,    -1,    -1,   749,
      -1,   144,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
      -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,   207,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   218,   219,   220,    -1,   222,
     254,   255,   256,    -1,   227,    -1,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,   237,    -1,    -1,    -1,   241,   242,
      -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3912,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,   281,    -1,
     283,    -1,  3939,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   298,   299,    -1,    -1,    -1,
     334,    -1,   336,   306,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   316,    -1,    -1,    -1,  3974,    -1,   353,
      -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3991,   338,   339,    -1,   341,    -1,
     374,    -1,    -1,    -1,    -1,   348,    -1,   381,    -1,    -1,
      -1,    -1,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   406,   376,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     413,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   432,
    4087,  4088,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   446,    -1,   479,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   459,    -1,    -1,   462,
      -1,    -1,   465,    -1,    -1,  4122,  4123,    -1,  4125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   480,    -1,  4136,
    4137,  4138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   526,    -1,  4151,    -1,  4153,    -1,  4155,    -1,
    4157,    -1,    -1,    -1,    -1,   539,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4170,  4171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4197,    -1,    -1,    -1,    -1,    -1,   580,  4204,    -1,     7,
       8,    -1,   586,    -1,    -1,    -1,  4213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    31,    -1,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,  4244,    -1,    -1,
      -1,    -1,    -1,    -1,   597,    -1,    -1,    -1,    -1,  4256,
      -1,    -1,    -1,  4260,    -1,    63,    -1,    65,    66,    -1,
      -1,   645,    -1,    -1,    -1,    73,  5545,  5546,   652,  5548,
    5549,  5550,  5551,   626,    -1,    -1,   629,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   639,    -1,    -1,    -1,
      -1,    99,    -1,    -1,   647,    -1,    -1,    -1,    -1,   683,
      -1,    -1,    -1,    -1,    -1,    -1,   659,    -1,    -1,    -1,
      -1,  4318,   120,    -1,   698,   699,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   131,    -1,    -1,   679,   711,    -1,   682,
      -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   714,    -1,    -1,    -1,    -1,    -1,  5646,    -1,    -1,
    5649,   724,    -1,   181,    -1,    -1,    -1,    -1,  5657,    -1,
      -1,    -1,    -1,  5662,    -1,    -1,    -1,   195,   196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   749,    -1,   206,   207,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,    -1,    -1,   222,    -1,    -1,    -1,   771,   227,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,   237,
      -1,    -1,    -1,   241,   242,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4461,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4474,  4475,    -1,
      -1,   279,    -1,   281,    -1,   283,    -1,    -1,    -1,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,   306,    16,
      17,    -1,    -1,    -1,    -1,    22,    23,    -1,   316,    -1,
      -1,  4518,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     338,    -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,
     348,    58,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,
      -1,    -1,  4579,    90,    -1,  4582,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4596,
      -1,    -1,    -1,   401,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4611,   413,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,
     147,   148,    -1,   150,    -1,    -1,    -1,    -1,   446,    -1,
      -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   459,    -1,    -1,   462,    -1,    -1,   465,    -1,    -1,
      -1,   178,  4669,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4687,  4688,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,  4705,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
    4737,    -1,  4739,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4752,    -1,  4754,    -1,    -1,
     267,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   597,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   626,    -1,
      -1,   629,    -1,    -1,    -1,   342,    -1,   344,   345,    -1,
      -1,   639,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   647,
      -1,    -1,    -1,   360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      17,   679,    -1,    -1,   682,    22,    23,    -1,    -1,    -1,
     397,  4888,   399,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4908,    -1,    -1,    -1,   422,   714,    -1,  4915,    -1,
      -1,    58,    -1,    -1,    -1,    -1,   724,    -1,    -1,  4926,
      -1,    -1,    -1,    70,   653,    -1,    -1,    -1,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   456,
     457,   749,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   680,    -1,  4960,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,
     699,   488,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,
     497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5005,    -1,
     147,   148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5030,    -1,    -1,   543,   544,   545,    -1,
      -1,   178,    -1,    -1,   551,   552,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   568,   569,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      -1,    34,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   592,   593,  5084,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,   818,
     237,    -1,    -1,    -1,   611,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5125,    -1,
     267,   268,   269,    -1,    -1,    -1,   643,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,   115,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   887,    -1,
      -1,    -1,    -1,   136,    -1,   138,    -1,   140,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   703,    -1,    -1,   706,
      -1,    -1,   709,    -1,    -1,   342,    -1,   344,   345,   716,
    5207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   940,    -1,   360,    -1,   732,   945,    -1,    -1,    -1,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5237,    -1,    -1,    -1,   751,    -1,    -1,    -1,    -1,    -1,
    5247,    -1,    -1,    -1,    -1,    -1,   975,    -1,    -1,   978,
     397,    -1,   399,    -1,    -1,    -1,   985,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,
      -1,   254,   255,   256,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1023,    -1,    -1,    -1,   445,    -1,
      -1,    -1,    -1,    -1,   277,    -1,    -1,    -1,    -1,   456,
     457,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   488,    -1,    -1,    -1,  1074,  1075,  1076,  1077,    -1,
     497,  1080,  5359,    -1,    -1,    -1,  5363,    -1,    -1,  1088,
    5367,   334,    -1,   336,    -1,    -1,    -1,  5374,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     353,    -1,   355,    -1,  5391,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   543,   544,   545,    -1,
      -1,   374,    -1,    -1,   551,   552,    -1,    -1,   381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   568,   569,   396,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   406,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   592,   593,    -1,   421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5469,    -1,   611,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5497,    -1,    -1,    -1,    -1,    -1,   643,    -1,  5505,    -1,
      -1,    -1,  5509,    -1,    -1,    -1,   479,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1261,    -1,    -1,    -1,  1265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5558,    -1,   526,  5561,    -1,   703,    -1,    -1,   706,
      -1,  5568,   709,    -1,    -1,    -1,   539,    -1,    -1,   716,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5588,    -1,    -1,    -1,   732,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   751,    -1,    -1,   580,    -1,    -1,
      -1,    -1,    -1,   586,  5621,    -1,  5623,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5659,    -1,    -1,    -1,    -1,  5664,    -1,    -1,
      -1,    -1,    -1,    -1,  5671,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   645,    -1,    -1,    -1,    -1,    -1,    -1,   652,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5707,    -1,    -1,  1432,  5711,  1434,    -1,    -1,    -1,    -1,
     683,  5718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   698,   699,    -1,    -1,    -1,
    5737,    -1,    -1,    -1,  5741,    -1,    -1,    -1,   711,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5762,    -1,  5764,  5765,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1505,    -1,  1507,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1533,    -1,  5813,    -1,    -1,  5816,
      -1,    -1,    -1,    -1,    -1,  1544,  1545,    -1,    -1,    -1,
      -1,  1550,    -1,    -1,    -1,  1554,  1555,  1556,    -1,    -1,
      -1,  5838,    -1,    -1,    -1,    -1,  1565,  1566,  1567,    -1,
    5847,    -1,  1571,    -1,  1573,  1574,  1575,  1576,  1577,    -1,
    1579,    -1,    -1,  1582,  1583,    -1,    -1,    -1,    -1,    -1,
      -1,  1590,    -1,  1592,    -1,    -1,  1595,  1596,    -1,  1598,
    1599,  1600,    -1,  1602,  1603,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5891,    -1,    -1,    -1,  1617,  1618,
    1619,  1620,  1621,    -1,  1623,  1624,  1625,  5904,    -1,  1628,
    1629,  1630,  1631,  1632,  1633,  1634,    -1,  1636,  1637,  1638,
    1639,  1640,  1641,    -1,  1643,  1644,    -1,  1646,  1647,  1648,
    1649,  1650,  1651,  1652,    -1,    -1,  1655,  1656,  1657,  1658,
      -1,  1660,  1661,  1662,    -1,  1664,    -1,  1666,    -1,  1668,
      -1,    -1,    -1,  1672,  1673,  1674,    -1,    -1,  1677,  1678,
    1679,  1680,  1681,    -1,  1683,    -1,    -1,    -1,    -1,    -1,
      -1,  1690,    -1,    -1,    -1,    -1,    -1,    -1,  1697,  1698,
    1699,  1700,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1708,
    1709,    -1,  1711,  1712,    -1,    -1,  1715,  1716,  1717,  1718,
    1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,    -1,
      -1,  1730,    -1,    -1,    -1,    -1,  1735,    -1,    -1,    -1,
      -1,    -1,    -1,  1742,    -1,    -1,    -1,    -1,    -1,    16,
      17,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,  1771,    -1,    -1,    -1,    -1,  1776,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1786,    -1,    -1,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1853,    -1,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
     147,   148,    -1,   150,  1883,    -1,  1885,    -1,    -1,    -1,
      -1,   158,   159,   160,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    -1,    -1,    -1,  1907,    -1,
      -1,   178,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1919,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,   110,   111,    -1,    -1,   243,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     267,   268,   269,  2002,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2011,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   342,    -1,   344,   345,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   263,    -1,    -1,    -1,    -1,
     397,    -1,   399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2151,    -1,    -1,   422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2169,    -1,    -1,    -1,    -1,   313,    -1,    -1,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2187,   456,
     457,  2190,    -1,    -1,   332,    -1,    -1,    -1,    -1,  2198,
    2199,    -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   353,    -1,    -1,    -1,    -1,
      -1,   488,    -1,    -1,    -1,    -1,   364,    -1,    -1,    -1,
     497,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2262,  2263,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   543,   544,   545,    -1,
      -1,    -1,   420,   421,   551,   552,   424,    -1,   426,    -1,
      -1,  2290,  2291,  2292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   568,   569,  2302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   452,   453,    -1,    -1,    -1,    -1,
      -1,    -1,   460,   461,    -1,   592,   593,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,
      -1,    -1,    -1,    -1,   611,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2355,    -1,    -1,    -1,
      -1,   499,    -1,    -1,    -1,    -1,    -1,  2366,    -1,    -1,
    2369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   520,    -1,    -1,    -1,    -1,    -1,  2387,    -1,
      -1,    -1,  2391,  2392,    -1,  2394,  2395,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2403,    -1,  2405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2433,    -1,   703,    -1,   576,   706,
      -1,    -1,   709,    -1,    -1,    -1,    -1,    -1,  2447,    -1,
      -1,    -1,   590,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2460,    -1,   601,  2463,   732,   604,   605,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2477,    -1,
      -1,   619,    -1,    -1,   751,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2492,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2514,    -1,   655,    -1,    -1,
      -1,    -1,    -1,    -1,   662,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   681,    -1,   683,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2555,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   733,    -1,    -1,    -1,    -1,
      -1,   739,  2601,    -1,  2603,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2681,    -1,    -1,    -1,    -1,    -1,    -1,  2688,
      -1,    -1,  2691,  2692,  2693,    -1,  2695,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2752,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   680,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2899,    -1,    -1,  2902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2911,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2920,    -1,  2922,    -1,  2924,    -1,  2926,  2927,  2928,
    2929,  2930,  2931,    -1,  2933,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2941,    -1,  2943,    -1,    -1,  2946,  2947,  2948,
      -1,    -1,    -1,    -1,    -1,    -1,  2955,  2956,  2957,    -1,
    2959,    -1,  2961,    -1,  2963,    -1,  2965,    -1,  2967,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2975,    -1,  2977,    -1,
    2979,  2980,  2981,  2982,  2983,    -1,    -1,  2986,  2987,  2988,
      -1,  2990,    -1,    -1,  2993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3006,    -1,    -1,
      -1,    -1,  3011,    -1,    -1,  3014,    -1,  3016,  3017,  3018,
      -1,    -1,  3021,    -1,    -1,    -1,   818,    -1,  3027,    -1,
      -1,    -1,    -1,  3032,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3041,    -1,    -1,    -1,    -1,    -1,  3047,    -1,
    3049,    -1,    -1,  3052,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3062,  3063,  3064,    -1,    -1,    -1,    -1,
    3069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   887,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   945,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   975,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   985,    -1,  3194,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3258,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3279,    -1,    -1,    -1,    -1,  1077,    -1,  3286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3368,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1261,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3487,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3497,    -1,
      -1,  3500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3524,  3525,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3536,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3549,    -1,  3551,    -1,  3553,    -1,  3555,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3577,    -1,
      -1,    -1,    -1,    -1,  3583,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3598,
    3599,    -1,    -1,    -1,    -1,    -1,  3605,    -1,  3607,    -1,
    3609,    -1,    -1,    -1,    -1,  3614,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1432,    -1,  1434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3651,  3652,  3653,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3667,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1505,    -1,  1507,  3715,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1550,    -1,
      -1,    -1,  1554,    -1,  1556,    -1,    -1,    -1,  3767,    -1,
      -1,    -1,    -1,  1565,  1566,    -1,    -1,    -1,  3777,  1571,
      -1,  1573,  1574,  1575,  1576,  1577,    -1,  1579,    -1,    -1,
    3789,    -1,  3791,    -1,    -1,    -1,    -1,    -1,  1590,    -1,
    1592,    -1,    -1,  1595,  1596,    -1,  1598,  1599,    -1,    -1,
    1602,  1603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1617,  1618,  1619,  1620,  1621,
      -1,  1623,    -1,  1625,    -1,    -1,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,    -1,  1636,  1637,  1638,  1639,  1640,    -1,
      -1,  1643,  1644,    -1,    -1,  1647,  1648,  1649,    -1,    -1,
      -1,    -1,    -1,  1655,  1656,  1657,    -1,    -1,  1660,  1661,
    1662,    -1,  1664,    -1,  1666,    -1,  1668,    -1,    -1,    -1,
    1672,  1673,  1674,    -1,    -1,  1677,  1678,  1679,  1680,  1681,
      -1,  1683,    -1,    -1,    -1,    -1,    -1,    -1,  1690,    -1,
      -1,    -1,    -1,    -1,    -1,  1697,  1698,  1699,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1771,
      -1,    -1,    -1,    -1,  1776,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3991,    -1,  1786,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1883,    -1,  1885,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4122,  4123,    -1,  4125,  1919,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4136,  4137,  4138,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4151,    -1,  4153,    -1,  4155,    -1,  4157,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4170,  4171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4197,    -1,
      -1,    -1,    -1,    -1,    -1,  4204,    -1,    -1,    -1,    -1,
    2002,    -1,    -1,    -1,  4213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4256,    -1,    -1,
      -1,  4260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2169,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2187,    -1,    -1,  2190,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2198,  2199,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4474,  4475,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2290,  2291,
    2292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4582,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2387,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2403,  4611,  2405,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2447,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2460,    -1,
    4669,  2463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4686,  4687,  4688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2492,    -1,    -1,    -1,    -1,    -1,  4705,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4718,
      -1,    -1,  2514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4752,    -1,  4754,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2555,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2681,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2695,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4915,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5002,    -1,    -1,  5005,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5030,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2899,    -1,    -1,
    2902,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5125,    -1,  2920,    -1,
      -1,    -1,  2924,    -1,  2926,  2927,  2928,  2929,  2930,  2931,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2941,
      -1,  2943,    -1,    -1,  2946,  2947,  2948,    -1,    -1,    -1,
      -1,    -1,    -1,  2955,  2956,  2957,    -1,  2959,    -1,  2961,
      -1,  2963,    -1,  2965,    -1,  2967,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2975,    -1,  2977,    -1,  2979,    -1,  2981,
    2982,  2983,    -1,    -1,  2986,  2987,  2988,    -1,  2990,    -1,
      -1,  2993,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3006,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3014,    -1,  3016,  3017,  3018,    -1,    -1,  3021,
      -1,    -1,    -1,    -1,    -1,  3027,    -1,    -1,    -1,    -1,
    3032,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5247,  3041,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3064,    -1,    -1,  5274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3165,    -1,  5374,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5394,  5395,    -1,    -1,    -1,
      -1,    -1,  3194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3279,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5497,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3368,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5588,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5623,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3487,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3497,    -1,    -1,  3500,    -1,
      -1,    -1,  5711,    -1,    -1,    -1,    -1,    -1,    -1,  5718,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3524,  3525,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3549,    -1,  3551,
      -1,  3553,    -1,  3555,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3577,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3598,  3599,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3614,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5838,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3652,  3653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3667,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5904,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3767,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3777,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3789,    -1,  3791,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3991,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4122,  4123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4136,  4137,  4138,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4151,
      -1,  4153,    -1,  4155,    -1,  4157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4170,  4171,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4256,    -1,    -1,    -1,  4260,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4474,  4475,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4582,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4611,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4669,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4687,  4688,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4705,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4718,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4752,    -1,  4754,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
     225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5005,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5030,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,    -1,   339,    -1,    -1,   342,   343,   344,
     345,   346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,
      -1,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,    -1,  5125,    -1,    -1,    -1,    -1,   373,    -1,
     375,    -1,   377,   378,    -1,   380,   381,   382,   383,   384,
     385,    -1,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,    -1,   414,
     415,   416,   417,    -1,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,    -1,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,    -1,    -1,    -1,    -1,    -1,   451,   452,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,    -1,   463,   464,
      -1,    -1,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,   487,   488,   489,  5247,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,    -1,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,    -1,    -1,    -1,   580,   581,    -1,   583,   584,
     585,   586,    -1,   588,   589,   590,   591,   592,   593,    -1,
      -1,    -1,    -1,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,    -1,
     625,    -1,   627,   628,    -1,   630,   631,    -1,   633,   634,
     635,   636,   637,   638,    -1,   640,   641,   642,   643,   644,
     645,   646,    -1,   648,   649,   650,    -1,   652,   653,   654,
     655,    -1,   657,   658,    -1,    -1,   661,    -1,    -1,   664,
     665,   666,    -1,   668,    -1,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,    -1,   680,   681,    -1,   683,    -1,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
      -1,   706,   707,   708,   709,   710,   711,   712,   713,    -1,
     715,   716,   717,    -1,   719,   720,   721,   722,    -1,    -1,
     725,   726,    -1,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,    -1,    -1,   744,
     745,    -1,    -1,   748,    -1,   750,   751,  5509,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   774,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    -1,    -1,  5588,    -1,    -1,    -1,
      -1,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    -1,    -1,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,  5623,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5711,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,   180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,  5904,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   760,   761,    -1,    -1,    -1,    -1,   766,    -1,
      -1,    -1,     6,   771,    -1,    -1,    -1,   775,   776,    -1,
      -1,   779,   780,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    30,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    -1,    -1,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   760,   761,    -1,    -1,
      -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,
      -1,   775,   776,    39,    40,   779,   780,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,   233,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,   288,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   760,   761,    -1,    25,    -1,    -1,
     766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,
     776,    39,    40,   779,   780,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,   271,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,
      30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,
      40,   779,   780,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,
      32,   771,    -1,    -1,    -1,   775,   776,    39,    40,   779,
     780,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,   114,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   760,   761,
      -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,
      -1,    -1,    -1,   775,   776,    39,    40,   779,   780,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    95,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   760,   761,    -1,    -1,
      -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,
      -1,   775,   776,    39,    40,   779,   780,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    95,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,
     766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,
     776,    39,    40,   779,   780,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,
      30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,
      40,   779,   780,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,   114,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,
      32,   771,    -1,    -1,    -1,   775,   776,    39,    40,   779,
     780,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   760,   761,
      -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,
      -1,    -1,    -1,   775,   776,    39,    40,   779,   780,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   760,   761,    -1,    -1,
      -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,
      -1,   775,   776,    39,    40,   779,   780,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,
     766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,
     776,    39,    40,   779,   780,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,   172,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,
      30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,
      40,   779,   780,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,   172,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,
      32,   771,    -1,    -1,    -1,   775,   776,    39,    40,   779,
     780,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
     172,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   760,   761,
      -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,
      -1,    -1,    -1,   775,   776,    39,    40,   779,   780,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,   156,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   760,   761,    -1,    -1,
      -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,
      -1,   775,   776,    39,    40,   779,   780,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,
      18,    19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,
     766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,
     776,    39,    40,   779,   780,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,    -1,    -1,    -1,    17,    18,    19,
      20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,
      30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,
      40,   779,   780,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,
      -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,
      -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,
     200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,
     260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,
      -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,    -1,    -1,    -1,    17,    18,    19,    20,    21,
     760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,
      32,   771,    -1,    -1,    -1,   775,   776,    39,    40,   779,
     780,    43,    44,    45,    46,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,
      -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,
      -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,
     202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,
      -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    17,    18,    19,    20,    21,   760,   761,
      -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,
      -1,    -1,    -1,   775,   776,    39,    40,   779,   780,    43,
      44,    45,    46,    -1,    48,    49,    -1,    51,    52,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
     154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,
      -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,
      -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    -1,    -1,
      -1,    17,    18,    19,    20,    21,   760,   761,    -1,    -1,
      -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,
      -1,   775,   776,    39,    40,   779,   780,    43,    44,    45,
      46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,
      86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,
      -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,
      -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,
      -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,
      -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,
     286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,    -1,
      18,    19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,
     766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,
     776,    39,    40,   779,   780,    43,    44,    45,    46,    -1,
      48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,
      -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,
     168,    -1,    -1,    -1,    -1,   173,    -1,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
     198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,
     258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,
      -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    18,
     748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   760,   761,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,   776,    -1,
      -1,   779,   780,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    24,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     779,   780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    24,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   762,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    32,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   762,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
     779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    32,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,   780,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,     6,     7,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   780,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,   115,    -1,    -1,    -1,    -1,   120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,   282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    -1,   748,   749,   750,   751,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,    -1,
      -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   216,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   281,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,     6,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
      -1,   748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    35,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,     6,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
      -1,   748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,   780,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    36,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    11,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    17,   748,   749,   750,   751,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,   751,    16,    17,    -1,
     755,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,   148,
      -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   158,
     159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,   268,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   291,   292,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    17,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    17,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    17,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    18,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
     106,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    45,   748,   749,   750,   751,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,    -1,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    29,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,    -1,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,    -1,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,    -1,   463,   464,    -1,
      -1,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,   487,   488,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,    -1,    -1,    -1,   580,   581,    -1,   583,   584,   585,
     586,    -1,   588,   589,   590,   591,   592,   593,    -1,    -1,
      -1,    -1,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,    -1,   625,
      -1,   627,   628,    -1,   630,   631,    -1,   633,   634,   635,
     636,   637,   638,    -1,   640,   641,   642,   643,   644,   645,
     646,    -1,   648,   649,   650,    -1,   652,   653,   654,   655,
      -1,   657,   658,    -1,    -1,   661,    -1,    -1,   664,   665,
     666,    -1,   668,    -1,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,    -1,   680,   681,    -1,   683,    -1,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,    29,
     706,   707,   708,   709,   710,   711,   712,   713,    38,   715,
     716,   717,    -1,   719,   720,   721,   722,    -1,    -1,   725,
     726,    -1,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,    -1,    -1,   744,   745,
      -1,    -1,   748,    -1,   750,   751,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,    -1,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,    -1,    -1,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,    -1,   463,   464,    -1,    -1,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,    -1,    -1,    -1,
     580,   581,    -1,   583,   584,   585,   586,    -1,   588,   589,
     590,   591,   592,   593,    -1,    -1,    -1,    -1,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,    -1,   625,    -1,   627,   628,    -1,
     630,   631,    -1,   633,   634,   635,   636,   637,   638,    -1,
     640,   641,   642,   643,   644,   645,   646,    -1,   648,   649,
     650,    -1,   652,   653,   654,   655,    -1,   657,   658,    -1,
      -1,   661,    -1,    -1,   664,   665,   666,    -1,   668,    -1,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,    -1,
     680,   681,    -1,   683,    -1,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,    29,   706,   707,   708,   709,
     710,   711,   712,   713,    38,   715,   716,   717,    -1,   719,
     720,   721,   722,    -1,    -1,   725,   726,    -1,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,    -1,    -1,   744,   745,    -1,    -1,   748,    -1,
     750,   751,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   296,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,    -1,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,    -1,    -1,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,    -1,   463,
     464,    -1,    -1,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,    -1,    -1,    -1,   580,   581,    -1,   583,
     584,   585,   586,    -1,   588,   589,   590,   591,   592,   593,
      -1,    -1,    -1,    -1,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
      -1,   625,    -1,   627,   628,    -1,   630,   631,    -1,   633,
     634,   635,   636,   637,   638,    -1,   640,   641,   642,   643,
     644,   645,   646,    -1,   648,   649,   650,    -1,   652,   653,
     654,   655,    -1,   657,   658,    -1,    -1,   661,    -1,    -1,
     664,   665,   666,    -1,   668,    -1,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,    -1,   680,   681,    -1,   683,
      -1,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,    29,   706,   707,   708,   709,   710,   711,   712,   713,
      38,   715,   716,   717,    -1,   719,   720,   721,   722,    -1,
      -1,   725,   726,    -1,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,    -1,    -1,
     744,   745,    -1,    -1,   748,    -1,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,    -1,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,    -1,
      -1,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,    -1,   463,   464,    -1,    -1,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,    -1,
      -1,    -1,   580,   581,    -1,   583,   584,   585,   586,    -1,
     588,   589,   590,   591,   592,   593,    -1,    -1,    -1,    -1,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,    -1,   625,    -1,   627,
     628,    -1,   630,   631,    -1,   633,   634,   635,   636,   637,
     638,    -1,   640,   641,   642,   643,   644,   645,   646,    -1,
     648,   649,   650,    -1,   652,   653,   654,   655,    -1,   657,
     658,    -1,    -1,   661,    -1,    -1,   664,   665,   666,    -1,
     668,    -1,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,    -1,   680,   681,    -1,   683,    -1,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,    29,   706,   707,
     708,   709,   710,   711,   712,   713,    38,   715,   716,   717,
      -1,   719,   720,   721,   722,    -1,    -1,   725,   726,    -1,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,    -1,    -1,   744,   745,    -1,    -1,
     748,    -1,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
      -1,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,    -1,    -1,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
      -1,   463,   464,    -1,    -1,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,   487,   488,   489,    -1,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,    -1,    -1,    -1,   580,   581,
      -1,   583,   584,   585,   586,    -1,   588,   589,   590,   591,
     592,   593,    -1,    -1,    -1,    -1,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,    -1,   625,    -1,   627,   628,    -1,   630,   631,
      -1,   633,   634,   635,   636,   637,   638,    -1,   640,   641,
     642,   643,   644,   645,   646,    -1,   648,   649,   650,    -1,
     652,   653,   654,   655,    -1,   657,   658,    -1,    -1,   661,
      -1,    -1,   664,   665,   666,    -1,   668,    -1,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,    -1,   680,   681,
      -1,   683,    -1,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,    29,   706,   707,   708,   709,   710,   711,
     712,   713,    38,   715,   716,   717,    -1,   719,   720,   721,
     722,    -1,    -1,   725,   726,    -1,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
      -1,    -1,   744,   745,    -1,    -1,   748,    -1,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,    -1,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,    -1,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,    -1,   463,   464,    -1,
      -1,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,   487,   488,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,    -1,    -1,    -1,   580,   581,    -1,   583,   584,   585,
     586,    -1,   588,   589,   590,   591,   592,   593,    -1,    -1,
      -1,    -1,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,    -1,   625,
      -1,   627,   628,    -1,   630,   631,    -1,   633,   634,   635,
     636,   637,   638,    -1,   640,   641,   642,   643,   644,   645,
     646,    -1,   648,   649,   650,    -1,   652,   653,   654,   655,
      -1,   657,   658,    -1,    -1,   661,    -1,    -1,   664,   665,
     666,    -1,   668,    -1,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,    -1,   680,   681,    -1,   683,    -1,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,    29,
     706,   707,   708,   709,   710,   711,   712,   713,    38,   715,
     716,   717,    -1,   719,   720,   721,   722,    -1,    -1,   725,
     726,    -1,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,    -1,    -1,   744,   745,
      -1,    -1,   748,    -1,   750,   751,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,    -1,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,    -1,    -1,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,    -1,   463,   464,    -1,    -1,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,    -1,    -1,    -1,
     580,   581,    -1,   583,   584,   585,   586,    -1,   588,   589,
     590,   591,   592,   593,    -1,    -1,    -1,    -1,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,    -1,   625,    -1,   627,   628,    -1,
     630,   631,    -1,   633,   634,   635,   636,   637,   638,    -1,
     640,   641,   642,   643,   644,   645,   646,    -1,   648,   649,
     650,    -1,   652,   653,   654,   655,    -1,   657,   658,    -1,
      -1,   661,    -1,    -1,   664,   665,   666,    -1,   668,    -1,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,    -1,
     680,   681,    -1,   683,    -1,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,    29,   706,   707,   708,   709,
     710,   711,   712,   713,    38,   715,   716,   717,    -1,   719,
     720,   721,   722,    -1,    -1,   725,   726,    -1,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,    -1,    -1,   744,   745,    -1,    -1,   748,    -1,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,    -1,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,    -1,    -1,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,    -1,   463,
     464,    -1,    -1,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,    -1,    -1,    -1,   580,   581,    -1,   583,
     584,   585,   586,    -1,   588,   589,   590,   591,   592,   593,
      -1,    -1,    -1,    -1,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
      -1,   625,    -1,   627,   628,    -1,   630,   631,    -1,   633,
     634,   635,   636,   637,   638,    -1,   640,   641,   642,   643,
     644,   645,   646,    -1,   648,   649,   650,    -1,   652,   653,
     654,   655,    -1,   657,   658,    -1,    -1,   661,    -1,    -1,
     664,   665,   666,    -1,   668,    -1,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,    -1,   680,   681,    -1,   683,
      -1,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,    29,   706,   707,   708,   709,   710,   711,   712,   713,
      38,   715,   716,   717,    -1,   719,   720,   721,   722,    -1,
      -1,   725,   726,    -1,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,    -1,    -1,
     744,   745,    -1,    -1,   748,    -1,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,    -1,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,    -1,
      -1,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,    -1,   463,   464,    -1,    -1,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,    -1,
      -1,    -1,   580,   581,    -1,   583,   584,   585,   586,    -1,
     588,   589,   590,   591,   592,   593,    -1,    -1,    -1,    -1,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,    -1,   625,    -1,   627,
     628,    -1,   630,   631,    -1,   633,   634,   635,   636,   637,
     638,    -1,   640,   641,   642,   643,   644,   645,   646,    -1,
     648,   649,   650,    -1,   652,   653,   654,   655,    -1,   657,
     658,    -1,    -1,   661,    -1,    -1,   664,   665,   666,    -1,
     668,    -1,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,    -1,   680,   681,    -1,   683,    -1,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,    29,   706,   707,
     708,   709,   710,   711,   712,   713,    38,   715,   716,   717,
      -1,   719,   720,   721,   722,    -1,    -1,   725,   726,    -1,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,    -1,    -1,   744,   745,    -1,    -1,
     748,    -1,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,   225,   226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,   339,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
      -1,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,    -1,    -1,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
      -1,   463,   464,    -1,    -1,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,   487,   488,   489,    -1,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,    -1,    -1,    -1,   580,   581,
      -1,   583,   584,   585,   586,    -1,   588,   589,   590,   591,
     592,   593,    -1,    -1,    -1,    -1,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,    -1,   625,    -1,   627,   628,    -1,   630,   631,
      -1,   633,   634,   635,   636,   637,   638,    -1,   640,   641,
     642,   643,   644,   645,   646,    -1,   648,   649,   650,    -1,
     652,   653,   654,   655,    -1,   657,   658,    -1,    -1,   661,
      -1,    -1,   664,   665,   666,    -1,   668,    -1,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,    -1,   680,   681,
      -1,   683,    -1,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,    29,   706,   707,   708,   709,   710,   711,
     712,   713,    38,   715,   716,   717,    -1,   719,   720,   721,
     722,    -1,    -1,   725,   726,    -1,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
      -1,    -1,   744,   745,    -1,    -1,   748,    -1,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,   339,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,    -1,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,    -1,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,    -1,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,    -1,   463,   464,    -1,
      -1,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,   487,   488,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,    -1,    -1,    -1,   580,   581,    -1,   583,   584,   585,
     586,    -1,   588,   589,   590,   591,   592,   593,    -1,    -1,
      -1,    -1,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,    -1,   625,
      -1,   627,   628,    -1,   630,   631,    -1,   633,   634,   635,
     636,   637,   638,    -1,   640,   641,   642,   643,   644,   645,
     646,    -1,   648,   649,   650,    -1,   652,   653,   654,   655,
      -1,   657,   658,    -1,    -1,   661,    -1,    -1,   664,   665,
     666,    -1,   668,    -1,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,    -1,   680,   681,    -1,   683,    -1,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,    29,
     706,   707,   708,   709,   710,   711,   712,   713,    38,   715,
     716,   717,    -1,   719,   720,   721,   722,    -1,    -1,   725,
     726,    -1,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,    -1,    -1,   744,   745,
      -1,    -1,   748,    -1,   750,   751,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,   339,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,    -1,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,    -1,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,    -1,    -1,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,    -1,   463,   464,    -1,    -1,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,    -1,    -1,    -1,
     580,   581,    -1,   583,   584,   585,   586,    -1,   588,   589,
     590,   591,   592,   593,    -1,    -1,    -1,    -1,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,    -1,   625,    -1,   627,   628,    -1,
     630,   631,    -1,   633,   634,   635,   636,   637,   638,    -1,
     640,   641,   642,   643,   644,   645,   646,    -1,   648,   649,
     650,    -1,   652,   653,   654,   655,    -1,   657,   658,    -1,
      -1,   661,    -1,    -1,   664,   665,   666,    -1,   668,    -1,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,    -1,
     680,   681,    -1,   683,    -1,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,    29,   706,   707,   708,   709,
     710,   711,   712,   713,    38,   715,   716,   717,    -1,   719,
     720,   721,   722,    -1,    -1,   725,   726,    -1,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,    -1,    -1,   744,   745,    -1,    -1,   748,    -1,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   112,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,
      -1,   225,   226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,   339,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,    -1,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,    -1,    -1,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,    -1,   463,
     464,    -1,    -1,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,    -1,    -1,    -1,   580,   581,    -1,   583,
     584,   585,   586,    -1,   588,   589,   590,   591,   592,   593,
      -1,    -1,    -1,    -1,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
      -1,   625,    -1,   627,   628,    -1,   630,   631,    -1,   633,
     634,   635,   636,   637,   638,    -1,   640,   641,   642,   643,
     644,   645,   646,    -1,   648,   649,   650,    -1,   652,   653,
     654,   655,    -1,   657,   658,    -1,    -1,   661,    -1,    -1,
     664,   665,   666,    -1,   668,    -1,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,    -1,   680,   681,    -1,   683,
      -1,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,    29,   706,   707,   708,   709,   710,   711,   712,   713,
      38,   715,   716,   717,    -1,   719,   720,   721,   722,    -1,
      -1,   725,   726,    -1,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,    -1,    -1,
     744,   745,    -1,    -1,   748,    -1,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,    -1,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,    -1,
      -1,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,    -1,   463,   464,    -1,    -1,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,    -1,
      -1,    -1,   580,   581,    -1,   583,   584,   585,   586,    -1,
     588,   589,   590,   591,   592,   593,    -1,    -1,    -1,    -1,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,    -1,   625,    -1,   627,
     628,    -1,   630,   631,    -1,   633,   634,   635,   636,   637,
     638,    -1,   640,   641,   642,   643,   644,   645,   646,    -1,
     648,   649,   650,    -1,   652,   653,   654,   655,    -1,   657,
     658,    -1,    -1,   661,    -1,    -1,   664,   665,   666,    -1,
     668,    -1,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,    29,   680,   681,    -1,   683,    -1,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,    -1,   706,   707,
     708,   709,   710,   711,   712,   713,    -1,   715,   716,   717,
      -1,   719,   720,   721,   722,    -1,    -1,   725,   726,    -1,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,    -1,    93,   744,   745,    -1,    -1,
     748,    -1,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,   225,   226,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,   339,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,    -1,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,    -1,
      -1,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,    -1,   463,   464,    -1,    -1,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,    -1,    -1,
      -1,    -1,   580,   581,    -1,   583,   584,   585,   586,    -1,
     588,   589,   590,   591,   592,   593,    -1,    -1,    -1,    -1,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,    -1,   625,    -1,   627,
     628,    -1,   630,   631,    -1,   633,   634,   635,   636,   637,
     638,    -1,   640,   641,   642,   643,   644,   645,   646,    -1,
     648,   649,   650,    -1,   652,   653,   654,   655,    -1,   657,
     658,    -1,    -1,   661,    -1,    -1,   664,   665,   666,    -1,
     668,    -1,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,    -1,   680,   681,    -1,   683,    -1,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,    -1,   706,   707,
     708,   709,   710,   711,   712,   713,    -1,   715,   716,   717,
      -1,   719,   720,   721,   722,    37,    38,   725,   726,    -1,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,    -1,    -1,   744,   745,    -1,    -1,
     748,    -1,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    45,   748,   749,   750,   751,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    74,   748,   749,   750,   751,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    46,   748,   749,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   771,    -1,    -1,    -1,    -1,   776,    -1,    -1,   779,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    57,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    57,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    57,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    61,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    61,
     748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    61,   748,   749,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    61,   748,   749,   750,   751,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    61,   748,   749,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    61,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    61,
     748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,    -1,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,    -1,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   772,    -1,    -1,    -1,    -1,    -1,    -1,   779,
     780,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   780,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   780,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   780,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,   780,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,   776,    -1,    -1,   779,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   105,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,
     172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    95,   748,   749,   750,   751,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   761,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    95,   748,   749,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,   755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,    -1,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,    -1,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,    -1,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,    -1,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,    -1,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,    -1,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,    -1,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,    -1,    -1,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,    -1,   463,
     464,    -1,    -1,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   110,   111,    -1,    -1,   580,   581,    -1,   583,
     584,   585,   586,    -1,   588,   589,   590,   591,   592,   593,
      -1,    -1,    -1,    -1,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
      -1,   625,    -1,   627,   628,    -1,   630,   631,    -1,   633,
     634,   635,   636,   637,   638,    -1,   640,   641,   642,   643,
     644,   645,   646,    -1,   648,   649,   650,    -1,   652,   653,
     654,   655,    -1,   657,   658,    -1,    -1,   661,    -1,    -1,
     664,   665,   666,    -1,   668,    -1,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,    -1,   680,   681,    -1,   683,
      -1,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,    -1,   706,   707,   708,   709,   710,   711,   712,   713,
      -1,   715,   716,   717,    -1,   719,   720,   721,   722,    -1,
      -1,   725,   726,    -1,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,    -1,    -1,
     744,   745,    -1,    -1,   748,    -1,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,    -1,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
      -1,    -1,    -1,    -1,   342,   343,   344,   345,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    -1,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,   373,    -1,   375,    -1,   377,
     378,    -1,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,    -1,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,    -1,    -1,
      -1,    -1,    -1,   451,   452,   453,   454,   455,   456,   457,
     458,    -1,   460,   461,    -1,   463,   464,    -1,    -1,   467,
      -1,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   110,   111,
      -1,    -1,   580,   581,    -1,   583,   584,   585,   586,    -1,
     588,   589,   590,   591,   592,   593,    -1,    -1,    -1,    -1,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,    -1,   625,    -1,   627,
     628,    -1,   630,   631,    -1,   633,   634,   635,   636,   637,
     638,    -1,   640,   641,   642,   643,   644,   645,   646,    -1,
     648,   649,   650,    -1,   652,   653,   654,   655,    -1,   657,
     658,    -1,    -1,   661,    -1,    -1,   664,   665,   666,    -1,
     668,    -1,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,    -1,   680,   681,    -1,   683,    -1,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,    -1,   706,   707,
     708,   709,   710,   711,   712,   713,    -1,   715,   716,   717,
      -1,   719,   720,   721,   722,    -1,    -1,   725,   726,    -1,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,    -1,    -1,   744,   745,    -1,    -1,
     748,    -1,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
      -1,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,    -1,    -1,    -1,    -1,
     342,   343,   344,   345,   346,    -1,    -1,   349,   350,   351,
     352,    -1,    -1,    -1,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,   375,    -1,   377,   378,    -1,   380,   381,
     382,   383,   384,   385,    -1,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,    -1,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
      -1,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,    -1,    -1,    -1,    -1,    -1,   451,
     452,   453,   454,   455,   456,   457,   458,    -1,   460,   461,
      -1,   463,   464,    -1,    -1,   467,    -1,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,   487,   488,   489,    -1,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
      -1,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,    -1,    -1,    -1,    -1,   580,   581,
      -1,   583,   584,   585,   586,    -1,   588,   589,   590,   591,
     592,   593,    -1,    -1,    -1,    -1,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,    -1,   625,    -1,   627,   628,    -1,   630,   631,
      -1,   633,   634,   635,   636,   637,   638,    -1,   640,   641,
     642,   643,   644,   645,   646,    -1,   648,   649,   650,    -1,
     652,   653,   654,   655,    -1,   657,   658,    -1,    -1,   661,
      -1,    -1,   664,   665,   666,    -1,   668,    -1,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,    -1,   680,   681,
      -1,   683,    -1,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,    -1,   706,   707,   708,   709,   710,   711,
     712,   713,    -1,   715,   716,   717,    -1,   719,   720,   721,
     722,    -1,    -1,   725,   726,    -1,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
      -1,    -1,   744,   745,    -1,    -1,   748,    -1,   750,   751
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,     8,    27,    29,    31,    33,    41,    63,    65,
      66,    73,    80,    93,    99,   112,   120,   131,   144,   146,
     151,   181,   195,   196,   206,   207,   218,   219,   220,   222,
     227,   233,   237,   241,   242,   279,   281,   283,   288,   298,
     299,   306,   316,   338,   339,   341,   348,   355,   376,   401,
     413,   432,   446,   459,   462,   465,   480,   597,   626,   629,
     639,   647,   659,   679,   682,   714,   724,   749,   771,   783,
     786,   787,   788,   789,   790,   792,   798,   800,   813,   860,
     904,   905,   912,   913,   929,   930,   961,   982,  1001,  1061,
    1118,  1170,  1268,  1318,  1321,  1331,  1336,  1342,  1355,  1358,
    1364,  1367,  1372,  1379,  1391,  1394,  1397,  1398,  1400,  1403,
    1404,  1406,  1407,  1410,  1411,  1414,  1632,  1634,  1647,  1650,
    1685,  1693,  1708,  1715,  1729,  1733,  1734,  1738,  1748,  1755,
    1763,  1765,  1771,  1774,  1775,  1807,  1855,  1885,  1892,  1894,
    1903,  1906,  1946,  1948,  1953,  1954,  1955,  1956,  1986,  1995,
    1996,  1997,    49,   205,   326,   404,   453,   501,   652,   656,
     698,   728,  1269,  1960,  1961,  1962,  1963,   174,   450,   499,
    1366,  1736,   110,   111,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   366,   367,
     368,   369,   370,   371,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   748,   749,   750,   751,  1826,  1828,  1835,  1842,
    1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,   962,   520,
    1359,   186,   501,   698,  1694,    49,   115,   205,   272,   427,
     453,   501,   638,   656,   698,   701,   728,   736,  1646,  1004,
     852,   931,  1648,  1766,   115,   396,   750,  1780,   263,   697,
    1888,  1002,  1366,  1171,  1062,    17,   520,  1721,   237,   247,
     901,   906,   908,  1835,   647,   728,  1888,  1006,   906,   907,
     852,  1401,   680,  1856,  1716,   906,  1893,  1686,  1835,  1399,
    1003,   214,  1809,  1651,   146,   279,   677,  1749,   171,   172,
    1447,  1947,   265,   780,  1829,   115,  1888,   745,  1950,  1633,
     474,  1835,  1366,   391,   914,  1895,   799,   591,   669,  1835,
    1366,  1756,  1950,  1835,  1772,     6,   662,   710,     6,   662,
    1709,   591,   669,   339,   340,   376,   418,   597,   614,   639,
     679,  1989,  1400,  1407,  1410,     0,    80,   784,   597,    49,
      96,   244,   278,   638,   728,   831,  1247,  1248,  1249,  1646,
    1960,  1961,  1962,  1963,    95,   123,  1417,  1418,  1628,  1395,
    1392,    83,   121,   277,  1409,  1957,  1408,  1957,   439,   450,
     584,   779,  1735,  1736,  1823,  1835,  1404,  1406,  1286,  1835,
     854,  1835,   755,   755,   854,   100,   112,  1645,   139,  1829,
    1835,  1837,  1009,  1010,  1013,  1036,  1835,  1645,  1310,  1311,
     251,  1435,  1964,  1965,  1960,   755,  1888,  1391,  1394,  1647,
    1650,  1685,  1693,  1732,   779,   861,   296,   963,   964,   967,
     971,   811,   812,  1829,   736,  1356,  1888,   316,   100,  1011,
    1036,   114,   152,   467,   609,  1696,  1706,  1707,  1645,  1636,
    1645,  1645,  1645,  1645,   100,  1645,  1645,  1036,  1645,  1645,
     652,  1888,   985,  1835,     6,     7,    41,    46,    63,    73,
      99,   115,   120,   146,   216,   233,   241,   272,   281,   282,
     427,   432,   443,   602,   606,   623,   628,   659,   691,  1837,
    1907,  1911,  1912,  1914,  1916,  1917,   956,   957,   152,   405,
     466,  1653,   463,   668,  1767,   123,  1776,  1886,    38,    87,
      98,   127,   134,   225,   226,   339,   361,   435,   576,   879,
     927,   928,   929,   932,   933,   934,   935,   939,   940,   941,
     942,   943,   951,   952,   953,   954,   975,   977,   978,   980,
     988,   994,  1828,  1836,  1843,  1850,  1852,  1853,  1854,  1888,
      17,    18,    19,    20,    21,    29,    30,    32,    39,    40,
      43,    44,    45,    46,    48,    49,    51,    52,    57,    61,
      64,    84,    85,    86,    88,    89,   101,   102,   103,   105,
     106,   110,   111,   112,   120,   122,   135,   149,   154,   155,
     157,   163,   165,   168,   171,   172,   173,   175,   176,   177,
     179,   194,   198,   199,   200,   202,   209,   220,   228,   231,
     251,   257,   258,   260,   261,   265,   273,   274,   275,   285,
     286,   287,   293,   295,   316,   317,   318,   322,   329,   337,
     353,   362,   364,   365,   367,   368,   369,   370,   371,   386,
     398,   399,   400,   402,   403,   450,   456,   458,   470,   492,
     493,   497,   535,   537,   542,   543,   544,   545,   555,   556,
     572,   586,   592,   593,   600,   607,   637,   643,   644,   650,
     657,   687,   706,   707,   708,   709,   713,   714,   728,   730,
     740,   741,   743,   751,   760,   761,   766,   771,   775,   776,
     779,   780,  1410,  1416,  1441,  1442,  1443,  1444,  1448,  1460,
    1462,  1463,  1464,  1465,  1466,  1467,  1468,  1470,  1471,  1472,
    1473,  1481,  1485,  1486,  1487,  1488,  1489,  1491,  1494,  1799,
    1802,  1804,  1805,  1806,  1820,  1827,  1828,  1835,  1842,    26,
    1063,   502,   350,   357,   373,   383,   384,   385,   393,   534,
     548,   649,   686,   700,   909,   911,   730,   902,   908,  1835,
     852,  1368,   879,   991,   908,     6,   321,   606,  1904,  1905,
    1912,  1914,     6,    68,   249,   250,   259,   466,   672,   673,
     674,   675,  1420,  1427,  1428,  1959,  1857,    32,    61,   353,
     460,   499,   549,   586,   638,   655,   710,   742,   780,  1210,
    1828,  1833,  1835,  1846,  1847,  1848,  1849,  1851,  1852,  1853,
    1854,  1860,  1872,  1876,     6,    40,    41,    50,   115,   129,
     205,   263,   313,   332,   341,   353,   364,   388,   421,   424,
     426,   452,   453,   460,   461,   477,   499,   520,   576,   590,
     601,   604,   605,   619,   655,   662,   683,   739,  1210,  1246,
    1717,  1721,  1722,  1724,  1733,  1828,  1873,   908,  1888,   152,
    1692,   771,  1664,  1673,   989,  1441,  1808,   405,  1654,  1692,
    1750,  1835,   331,  1950,  1837,  1373,  1332,    10,  1951,  1441,
    1514,   793,   284,   795,  1739,   408,  1823,  1825,  1835,  1896,
    1837,   112,  1117,  1829,    95,  1337,   520,   608,   662,  1757,
    1758,   270,  1951,   738,  1773,   663,   811,   211,   299,  1322,
    1323,  1324,   663,   811,   263,  1710,  1645,  1645,    18,   105,
     106,   265,  1800,  1801,  1830,  1988,  1988,  1988,   450,  1987,
    1988,  1988,   772,   772,   778,  1835,  1117,  1117,  1117,   656,
     836,   115,   115,   115,   263,   652,   205,   272,   427,  1964,
     325,   853,   853,  1960,    74,   771,   776,  1416,  1419,  1520,
    1521,  1522,  1523,  1524,  1535,  1536,  1537,  1538,  1540,  1541,
    1542,  1823,   189,   414,  1623,  1624,  1629,   297,  1565,  1417,
      93,   141,   146,   185,  1429,  1590,  1595,  1601,  1602,  1606,
     205,  1605,  1618,  1628,     6,    68,  1958,  1601,  1603,  1410,
    1413,  1414,  1602,  1604,  1412,     6,  1835,  1731,  1730,   779,
    1396,  1393,  1271,   727,  1272,   779,   533,   702,   720,    45,
    1837,  1838,  1839,  1911,  1273,  1015,  1037,  1835,    84,  1278,
    1277,     5,    31,    73,   172,   212,   612,  1038,   852,   263,
     114,   575,  1312,  1313,  1314,   651,   427,   736,  1964,  1837,
    1343,  1835,   771,   864,   972,    76,   974,  1441,   971,   270,
    1357,  1639,  1640,  1823,  1014,  1037,     5,    95,  1697,    95,
    1697,  1698,  1699,  1703,  1704,  1835,  1706,  1835,   112,  1644,
     854,   854,   854,  1835,  1037,   852,  1837,  1047,  1722,   852,
    1637,  1645,  1645,  1005,   986,   601,  1915,   641,   641,   698,
     701,   728,   736,   771,  1440,   467,   578,  1919,   697,  1921,
    1918,    50,   736,  1920,   180,   358,   662,   270,   180,   774,
     418,  1441,   114,  1309,   381,   608,  1768,  1769,   348,   152,
     380,  1782,  1823,  1889,  1890,   296,  1836,    95,   100,   555,
    1835,  1836,  1836,  1836,   981,  1835,   296,  1836,  1835,   418,
     928,   778,   787,   936,   955,  1835,    93,   151,   220,   298,
     339,   781,  1365,   122,   760,   761,  1465,   771,   771,   771,
     296,  1441,  1517,  1518,   771,   771,   771,   771,   771,  1440,
    1440,  1440,   771,  1439,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,  1441,   771,
     110,   111,   365,   771,  1515,  1516,  1820,  1827,  1842,   771,
     771,   771,   771,  1441,  1439,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   197,   771,   771,   771,  1439,
     265,  1801,  1440,  1439,  1439,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   177,  1827,   771,   771,
     771,   771,   771,   771,   771,   265,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   730,   771,   771,   771,   771,   771,   730,
     771,   771,   771,   771,   771,   771,   771,   265,   771,   771,
     771,   265,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   122,  1465,   122,  1465,  1465,  1172,  1410,  1441,  1807,
    1835,  1827,  1495,     9,    10,   184,   186,   303,  1445,  1446,
      81,    97,   126,   132,   169,   755,   756,   757,  1449,    15,
     125,   140,   217,   670,  1447,    69,   165,   183,   239,   240,
     758,   759,   760,   761,   762,   763,   764,   765,  1465,    34,
     166,   191,   191,   743,  1830,   779,   771,   197,  1064,    14,
     270,   774,   755,  1830,  1369,  1838,  1840,  1370,  1371,  1823,
     726,  1915,   578,   180,    95,   180,  1402,  1428,    61,  1835,
    1859,  1875,   237,   638,   779,    17,    61,   238,   755,  1211,
    1212,  1667,  1837,    93,  1667,  1882,  1667,  1837,  1862,   780,
    1837,    17,    61,  1214,  1215,  1837,  1667,   779,  1863,  1861,
     663,   771,    49,   205,   263,   272,   313,   427,   453,   652,
     728,   736,   140,   297,  1728,   363,   681,   681,   307,   681,
     426,  1728,     6,  1129,  1837,  1594,  1595,  1596,    95,   125,
    1723,  1725,   363,   681,    93,   681,   697,   669,     6,   343,
     387,   389,   483,   532,   581,   671,   693,  1711,  1712,  1713,
     811,   469,   681,   812,  1596,  1728,  1725,   502,   420,   366,
     603,   697,   712,    93,  1434,   681,   733,  1309,  1674,   774,
     413,  1810,  1811,  1815,  1835,   123,  1655,  1656,  1657,  1823,
     983,   774,  1374,  1375,  1376,  1377,  1823,  1639,   351,   562,
     218,   562,  1952,   774,  1441,   796,    17,   252,   407,   421,
     423,   454,   469,   502,   520,   601,   608,   618,   631,   662,
     665,   681,  1740,  1745,  1746,  1828,  1888,    35,   780,   915,
     916,   917,   918,  1827,   576,   211,   361,  1447,  1835,   791,
     736,  1334,  1888,  1760,   348,  1759,   774,   647,  1835,  1952,
      93,  1325,  1326,  1325,   574,   747,   382,   774,  1325,  1325,
    1640,  1835,  1829,   774,   573,  1991,   692,  1992,   755,   128,
     633,  1990,    80,   785,  1835,   852,   852,  1117,  1117,   819,
     821,  1117,  1117,  1117,   826,   828,   736,   453,   453,  1964,
    1520,  1524,  1536,  1537,  1538,  1539,  1540,  1835,    94,  1425,
      42,   117,   128,   135,   167,   228,   259,  1531,  1532,   774,
     196,  1533,  1534,   265,  1831,  1831,   780,  1625,  1626,  1627,
    1835,  1837,  1566,   100,  1569,  1565,   281,   149,   177,   229,
     274,   365,  1597,  1598,  1802,  1827,   125,    26,  1594,  1429,
    1835,  1429,  1430,  1430,  1413,  1732,  1737,  1800,  1835,  1835,
    1602,  1605,    61,  1114,  1115,  1126,  1127,  1219,   396,   855,
    1835,  1440,   780,   855,     5,  1016,  1823,   577,   395,  1033,
    1033,  1033,     4,  1838,  1839,  1840,  1927,  1931,  1823,  1314,
     404,   481,   854,  1823,   736,  1344,  1345,  1640,   779,   862,
     865,   866,  1441,  1441,   879,   418,   965,   801,  1639,    93,
     352,   439,   441,   531,   609,   774,  1360,  1361,  1362,  1016,
    1033,  1823,    14,  1695,  1642,  1643,  1824,  1835,    93,  1423,
    1424,  1565,   774,  1700,   779,  1705,    84,  1835,   779,  1047,
    1910,  1912,   565,   738,  1048,  1049,   421,  1840,  1926,  1639,
    1638,  1635,   413,   125,   987,   697,   772,   771,  1935,  1935,
    1935,  1935,  1840,  1927,   192,   205,   263,   453,  1913,   427,
     432,   443,   602,   623,   628,   659,   691,  1917,   112,   266,
    1655,   471,   728,  1441,  1770,  1770,  1380,   499,  1781,    11,
     755,  1561,  1562,  1563,   566,   738,   774,  1887,   937,   938,
     296,  1835,   555,    95,   123,   880,   937,   296,   771,   950,
     151,   778,  1441,   774,   997,   995,  1000,   996,   979,  1639,
     771,     6,  1505,  1564,  1505,  1505,  1441,  1518,    76,   296,
     418,  1441,  1514,  1441,    68,  1505,  1564,   772,    57,    89,
     105,   149,   177,   274,   772,  1610,  1614,  1615,   772,  1441,
    1441,  1820,   772,  1405,  1406,  1415,  1807,    53,    54,    55,
      56,   107,   108,   109,   161,   162,   232,   304,   400,   470,
     535,   537,   542,   607,   650,   740,   751,  1558,  1559,  1441,
      68,  1497,  1441,  1441,  1441,  1441,  1441,  1558,  1441,  1827,
    1516,   324,   774,   779,    68,  1505,  1441,    68,  1505,  1441,
    1441,  1441,   772,  1441,  1441,  1444,   772,  1441,  1441,   772,
     642,  1505,  1505,    68,  1505,  1505,  1505,  1441,  1441,  1469,
      25,   133,   271,  1441,  1461,  1441,  1441,    68,  1505,  1441,
    1514,  1441,   779,  1441,  1441,  1441,  1457,  1458,  1441,  1441,
    1441,  1441,  1441,  1441,  1441,  1441,  1441,  1514,   397,   399,
     706,   709,  1560,  1441,  1441,  1514,  1823,  1514,  1441,  1441,
    1441,  1514,  1514,  1514,    93,  1823,  1441,  1441,  1441,  1514,
      93,  1441,  1441,  1441,   772,  1441,  1823,  1441,  1441,  1559,
    1559,  1441,  1461,  1441,   772,   365,   779,  1821,  1835,  1441,
    1441,  1441,  1441,  1441,  1441,   772,   774,  1406,  1441,   779,
     780,  1496,  1837,  1441,  1441,  1441,  1443,    86,   176,   273,
     725,  1447,     6,   328,  1443,  1450,  1443,   771,  1416,  1443,
    1443,   140,    15,   125,   140,   217,  1444,  1444,  1444,  1444,
    1444,  1444,  1444,   122,  1444,   122,  1444,  1444,  1444,  1444,
    1444,  1216,  1837,  1465,   771,  1493,  1575,  1835,   771,   100,
    1827,  1474,   451,   485,   561,   642,  1459,   142,   208,   498,
     696,  1065,  1069,  1764,  1829,   911,   399,   706,   709,   910,
    1494,  1804,  1820,   774,   270,   774,  1887,   992,   774,    93,
    1840,  1839,  1928,   192,   205,   453,  1913,   762,  1432,  1433,
    1435,   779,   779,  1667,   774,  1858,  1912,  1835,    34,  1217,
    1441,  1840,   265,   572,   586,  1883,     6,    17,    61,   180,
    1441,  1884,   211,   484,  1877,  1878,  1879,  1880,   460,   499,
     655,  1874,  1667,  1884,  1835,   710,  1864,  1875,   774,  1866,
     681,   762,  1117,   854,  1823,   854,   307,   854,   854,   854,
    1823,  1840,  1823,  1434,  1434,   854,  1728,  1723,   363,   681,
    1728,   125,  1726,   502,   546,   681,  1720,  1720,  1728,  1835,
     854,  1728,  1839,  1723,  1728,  1829,   482,   694,   442,    93,
    1714,   774,   426,   681,  1823,  1725,  1723,  1723,  1441,  1728,
    1728,  1728,  1521,  1684,  1823,  1435,  1676,  1678,   771,  1671,
     990,   774,   771,  1813,  1656,  1652,  1641,  1823,   880,   780,
     125,   774,   196,  1385,  1387,  1388,   439,   609,  1333,   351,
     218,  1441,   794,    61,   114,   797,  1441,  1679,  1680,   502,
     502,   502,   502,   348,   502,   811,   502,   774,  1434,  1741,
     910,   920,  1837,   774,   755,  1562,  1897,    84,   669,  1441,
    1335,  1639,   270,  1762,   811,  1758,  1835,     6,  1320,   622,
     676,  1327,  1328,  1319,   666,  1324,  1887,  1800,   589,  1993,
    1837,   823,  1910,  1927,  1837,   817,  1117,  1117,   814,  1823,
     827,  1435,  1973,   840,  1435,  1117,  1117,  1117,   736,   774,
     772,   772,   772,   772,   772,   774,   772,  1520,     6,    11,
      15,    95,  1426,  1563,   128,   128,   188,  1543,   135,   228,
    1531,  1543,  1520,  1522,   771,  1425,  1630,  1837,   774,   779,
    1441,    26,   104,  1567,  1569,   566,   738,  1431,   430,  1827,
     229,   571,   774,   779,   658,  1591,  1619,  1115,    34,  1210,
     409,   164,   210,   251,   374,   386,   490,   562,   857,   859,
    1837,   615,   721,  1034,  1035,   478,  1030,  1031,  1032,  1039,
    1047,  1049,  1279,   771,  1829,   333,   527,  1024,  1025,  1026,
    1039,  1040,  1041,  1047,  1049,  1017,  1018,  1024,   472,   221,
     774,  1938,  1887,  1276,  1275,  1823,   774,   588,  1346,  1835,
     864,   772,   774,   973,    29,   296,   966,   968,    71,   113,
     153,   473,   503,   504,   506,   507,   508,   509,   510,   512,
     513,   514,   515,   516,   517,   518,   519,   521,   522,   523,
     620,   621,   802,   803,   810,    93,  1363,   727,  1640,  1361,
     374,   559,   616,   722,  1027,  1028,  1029,  1039,  1043,  1044,
    1045,  1046,  1047,  1049,   283,  1012,  1533,   696,   774,  1701,
     779,  1705,   201,  1589,  1590,  1704,    95,   762,  1835,   180,
    1835,  1048,   774,  1667,  1668,   774,    28,   223,  1315,  1639,
    1639,   879,   637,   984,  1835,  1936,  1937,   270,   299,  1909,
      24,   762,  1823,  1835,  1925,  1925,  1925,  1925,   958,  1649,
    1441,  1840,  1381,  1382,  1383,  1384,  1823,   116,  1828,  1832,
    1841,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,   152,
     211,   747,  1891,   105,   761,  1607,  1609,  1890,  1441,   937,
     123,   643,  1835,    59,   878,   881,   937,   944,   945,   949,
    1835,   985,   988,   991,   989,   880,  1887,  1441,   772,  1506,
     772,   772,   266,   418,  1441,  1441,    11,   284,   772,   284,
     774,  1482,   772,   762,   772,   774,   774,   772,   772,  1406,
      95,   772,  1484,   772,   774,   772,   774,   774,   774,   774,
     761,   774,   772,   771,  1820,  1827,  1505,   772,   772,  1505,
     772,   774,   772,   774,   772,   772,   125,   774,   774,   772,
     772,  1505,   772,   772,   772,   774,    95,   774,   772,    95,
    1441,    95,  1441,    95,  1441,    95,   772,   774,   772,  1505,
     772,   772,   772,   772,  1827,   774,   772,   774,   772,   774,
     774,   774,   774,   774,   772,   772,   774,   774,   774,   772,
     774,   772,   772,   774,   772,   772,   772,   772,   772,   772,
     772,   772,  1823,   772,   772,   772,   774,   772,  1823,   772,
     772,   774,   772,   774,   774,   772,   774,   774,   774,   772,
     772,   774,  1827,  1835,   772,   779,   772,   774,    11,   496,
     774,  1235,   774,   772,  1558,  1558,  1514,   772,   777,  1827,
    1874,   238,    86,   176,   273,   725,   771,    10,  1441,   425,
    1443,  1443,   771,  1416,  1443,  1443,  1441,  1441,  1576,   196,
    1578,   771,   771,   779,  1435,  1478,  1479,  1480,   366,   771,
    1074,  1075,  1067,  1074,  1068,   584,  1077,   130,   464,  1441,
     755,  1840,  1840,  1371,   270,  1441,    99,  1912,    95,   774,
      24,  1925,  1925,  1925,  1925,   774,  1441,  1818,  1827,  1835,
    1835,  1884,  1875,    93,    93,  1667,    61,  1216,  1218,  1667,
     771,   771,   574,   747,   496,   774,   774,   779,   779,   779,
      61,   742,  1828,  1829,  1834,  1844,  1847,  1848,  1849,  1850,
    1851,  1853,  1854,  1441,  1667,  1877,  1865,  1867,  1868,   772,
    1835,   854,  1829,  1441,  1728,   854,  1728,  1829,    95,  1727,
     852,  1728,   608,  1596,  1713,  1726,  1723,  1823,  1728,  1728,
     237,  1533,  1680,   772,   774,  1672,   879,  1811,  1814,  1835,
    1812,   136,   137,   237,  1055,  1405,  1658,  1660,  1663,  1533,
     878,  1837,    61,  1378,  1835,  1376,  1823,  1060,  1387,   115,
     130,  1244,  1389,   795,   774,    62,  1751,   811,  1746,  1639,
    1747,   918,   921,   922,   917,   567,   568,   644,   919,   444,
     555,  1835,  1898,  1899,  1829,  1639,   439,   609,   729,  1338,
    1339,  1340,  1609,     6,  1761,   663,   774,   726,  1329,   774,
      93,  1994,  1113,  1114,   299,  1908,  1938,   837,  1835,  1835,
    1835,  1823,   816,   854,  1983,  1117,  1117,  1823,   854,  1835,
     854,  1117,  1520,  1520,   777,   570,   706,   710,  1421,  1422,
    1467,  1422,   128,  1543,  1543,  1535,   128,   180,   284,  1557,
    1835,  1562,  1210,  1213,  1626,  1835,  1441,  1570,  1819,  1568,
     742,  1572,  1567,  1609,  1598,  1599,   430,  1598,  1598,  1827,
     540,  1592,  1819,   771,  1668,  1668,   550,   251,   251,   651,
    1829,   251,   251,   251,  1829,  1829,  1668,   774,  1032,   156,
     348,   394,   476,   538,   557,   558,   562,   563,   564,   630,
     679,   833,   834,    49,   468,   579,   586,   594,   667,   728,
     838,   839,  1668,  1668,   774,  1026,  1019,  1020,  1039,  1040,
    1041,    26,   299,   735,  1929,   252,   356,   486,   560,   688,
     748,  1923,  1924,  1931,   299,  1941,  1270,   180,   848,  1283,
     771,  1966,  1274,  1345,    93,   863,  1441,   266,   969,   968,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   774,   727,  1668,  1668,  1668,  1668,
     774,  1029,   501,   440,  1021,  1022,  1023,  1039,  1040,  1041,
    1042,  1045,  1046,  1047,  1049,  1422,  1643,  1835,   284,  1835,
     570,   141,  1600,  1521,   779,  1705,  1823,  1912,  1128,  1837,
    1840,  1887,   418,   771,   944,   947,   772,   774,  1927,   321,
    1925,   779,   779,   270,   270,   270,   270,   879,  1658,   774,
    1385,  1387,  1831,   747,   499,   380,    57,    89,   149,   177,
     274,   123,    37,    38,   434,   435,   742,   887,   888,   889,
     891,   897,   924,   925,  1828,  1845,  1847,  1848,  1849,  1850,
    1851,  1852,  1853,  1854,   418,   928,   778,   946,   772,   774,
     998,   976,   993,  1836,   993,   993,   878,   774,  1441,  1441,
     266,    17,    32,    58,    70,    90,   122,   124,   280,   292,
     397,   399,   552,   660,   709,   732,  1507,  1511,  1512,  1211,
    1211,  1507,  1514,   772,   122,   122,  1441,  1514,  1441,  1441,
    1441,  1441,  1441,  1441,  1441,  1444,   779,   772,   772,  1441,
    1441,  1441,  1441,  1441,   772,  1441,  1441,  1441,  1441,    95,
    1441,    95,  1441,    95,  1441,   122,  1441,   772,  1458,  1441,
    1457,  1514,  1441,  1441,  1441,  1441,  1441,  1519,  1441,  1441,
    1441,  1441,  1514,   149,   760,  1607,  1611,   122,  1441,  1441,
    1441,  1441,  1441,   779,   779,  1835,  1441,    17,    32,  1230,
    1231,  1232,  1233,  1234,  1610,  1609,   772,  1441,   761,   761,
    1834,  1441,  1415,  1443,   772,   774,  1443,    10,  1441,   425,
    1558,  1558,  1577,  1835,    26,   772,  1490,  1513,  1514,  1827,
    1441,   772,   774,   771,  1083,  1444,  1075,   141,  1109,  1110,
    1610,   690,  1078,   326,  1070,  1066,   910,   270,  1823,   418,
     578,  1926,  1839,  1925,    95,    95,    95,    95,  1433,  1436,
    1436,   779,  1667,  1667,   786,  1840,  1884,   265,   265,   211,
     627,   653,  1881,  1879,  1878,   779,   779,  1667,  1884,  1866,
     774,  1870,  1872,  1876,   424,   739,  1607,  1612,  1718,   177,
    1727,  1565,  1723,  1688,  1689,  1821,  1423,  1436,  1435,  1675,
    1677,  1680,   418,   772,   774,    11,  1661,  1662,  1816,  1817,
    1821,  1835,  1807,  1659,  1663,   418,  1386,   771,  1680,   755,
      93,   299,  1742,  1743,   755,   774,    97,   132,   444,   491,
     555,   599,   755,   756,   757,  1900,  1902,  1565,    95,  1341,
    1339,  1328,   505,   810,  1330,  1609,   536,   321,  1941,    92,
     284,   716,  1257,   180,   180,   815,   832,   833,  1984,  1974,
     854,   824,   771,   635,   771,  1823,  1422,   265,  1444,    10,
     270,  1520,  1535,   128,   128,  1520,  1535,  1525,  1526,   772,
     774,  1552,  1553,  1212,  1631,   300,   301,   774,  1571,    12,
      65,  1593,  1441,  1493,  1573,  1574,  1572,  1599,  1431,   774,
    1593,  1435,  1620,  1621,  1622,  1218,  1212,   396,   396,   404,
     481,   105,   149,   177,   274,  1050,  1613,  1614,  1828,  1032,
    1668,  1668,    26,  1668,  1670,  1668,   156,   538,   299,  1668,
    1669,  1669,   834,  1829,  1829,  1829,  1829,  1609,  1829,  1829,
     772,   774,  1050,  1050,  1026,   774,  1020,   265,   586,  1837,
    1932,  1933,   265,   265,   265,    10,  1922,   524,   525,   528,
     529,   530,  1939,  1940,   319,   586,  1282,     5,     7,     8,
      31,    33,    39,    73,   115,   146,   181,   185,   193,   196,
     219,   254,   255,   256,   277,   302,   326,   334,   336,   355,
     362,   374,   381,   396,   406,   410,   411,   417,   421,   429,
     449,   475,   479,   489,   526,   539,   541,   580,   586,   613,
     624,   625,   626,   645,   652,   683,   698,   699,   711,   714,
    1058,  1120,  1122,  1125,  1126,  1127,  1287,  1291,  1293,  1296,
    1302,  1303,  1304,  1306,  1307,  1586,  1828,   378,   648,   219,
    1284,  1835,  1967,    11,  1966,     6,   366,  1347,   864,   879,
    1441,   771,   771,  1609,   771,  1609,  1609,  1829,  1829,  1612,
    1829,  1609,  1829,  1829,  1829,  1829,  1829,  1829,  1829,  1609,
    1829,   392,   562,   664,  1805,  1829,  1609,   803,  1829,  1610,
    1050,  1050,  1029,   100,  1668,   774,  1023,   779,  1521,  1705,
    1434,   229,  1598,   224,  1702,  1565,  1887,  1315,    93,   894,
     895,   948,    72,  1937,   299,  1943,   578,   270,   762,   762,
    1927,  1927,  1927,  1927,   959,   180,  1681,  1383,  1823,  1387,
     114,  1390,  1777,    16,    17,    22,    23,    32,    58,    70,
      90,   124,   147,   148,   150,   158,   159,   160,   178,   213,
     237,   243,   267,   268,   269,   291,   292,   342,   344,   345,
     360,   397,   399,   422,   445,   456,   457,   488,   497,   543,
     544,   545,   551,   552,   568,   569,   592,   593,   611,   643,
     703,   706,   709,   716,   732,   751,  1176,  1178,  1179,  1181,
    1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,
     462,    35,    47,   774,   778,  1441,   945,   413,   418,  1441,
    1441,   771,  1196,  1197,  1197,   771,  1193,  1194,  1196,   771,
    1194,  1199,    56,   124,  1196,  1197,  1197,   124,  1197,  1196,
     772,   772,   772,   772,  1483,  1441,  1441,   772,   185,  1499,
     772,   772,   774,   774,   772,   774,   772,   125,  1475,  1476,
    1827,   772,   772,   772,   772,   772,   774,    93,   774,  1441,
    1441,  1441,  1441,   772,   772,    11,  1451,   772,    11,   772,
     772,   774,   772,   774,   772,   774,   772,   774,   772,   772,
     772,   772,   149,   177,   177,   772,   774,  1441,   772,   772,
     774,   774,   772,  1827,  1835,   779,   772,   771,  1225,  1225,
      12,    65,   637,   760,  1227,  1228,  1229,   774,   774,   772,
    1441,  1441,   779,   772,  1514,  1443,   772,   774,  1443,  1578,
    1570,   185,  1492,   772,   771,  1436,  1480,  1071,  1072,  1073,
    1835,   772,  1612,   122,    26,   771,  1085,   755,   771,  1075,
    1840,   220,    95,    95,  1928,  1928,  1928,  1928,    11,  1437,
    1829,  1835,   762,  1827,  1884,  1884,   772,   772,   375,   719,
     211,  1835,  1835,  1884,  1869,  1871,    57,    89,   149,   177,
     274,  1596,  1719,  1728,   774,  1687,  1667,  1562,  1680,   772,
     774,   298,  1835,   771,   772,   774,   779,  1406,  1665,  1666,
    1821,   771,   204,  1554,  1555,  1556,  1835,   771,  1744,   211,
     350,   357,   373,   383,   384,   385,   393,   534,   548,   634,
     649,   686,   700,   923,   922,  1901,  1596,   547,   755,   774,
    1839,  1282,   396,   346,   464,   646,  1263,  1263,   180,  1823,
    1823,   136,   138,   140,  1051,  1053,  1119,  1121,  1122,  1134,
    1119,   771,   876,   854,   841,  1966,   830,    58,   124,   213,
     685,  1132,   829,   825,  1422,  1422,   180,  1528,  1535,  1535,
     180,  1530,  1441,   771,  1060,  1835,  1550,  1551,   366,  1784,
    1819,    11,   774,  1819,  1441,   772,   774,  1611,  1611,  1611,
    1611,  1611,  1611,   839,  1020,   265,    11,   284,  1930,  1934,
     186,  1923,  1609,  1609,  1609,  1805,   760,  1607,  1608,  1939,
     146,   279,  1280,   437,    36,   196,   372,   587,   695,  1138,
    1146,  1147,  1152,  1153,  1244,  1248,  1249,  1308,  1308,   196,
    1308,   196,   270,    36,    92,   196,   587,   695,  1151,  1244,
    1308,   409,  1668,   196,    26,  1668,  1060,    11,   270,   755,
    1317,  1668,  1668,  1668,  1668,   734,  1668,  1668,  1668,  1668,
     196,  1668,  1668,   409,  1668,   129,   698,   129,  1668,   196,
     698,  1668,  1668,  1668,  1668,  1308,  1668,  1668,   196,   585,
     196,   196,  1668,  1668,   412,   532,  1835,  1668,  1668,   196,
    1120,   774,  1057,  1058,  1291,   771,   779,  1137,  1154,  1822,
    1835,  1667,  1447,  1949,   330,   428,   842,   270,   410,   417,
     844,   772,   774,  1968,  1969,    11,     6,   771,  1348,   970,
     806,   807,  1609,   808,   809,  1609,   804,   805,  1609,  1835,
    1050,  1023,  1835,  1565,  1835,   430,   229,  1432,   896,   772,
    1441,   947,    99,  1927,  1938,  1938,  1938,  1938,    76,    77,
     960,   415,  1390,   494,   114,   316,  1783,  1196,  1198,  1197,
     379,  1196,  1203,  1204,  1193,   203,  1193,  1203,    17,    34,
     329,   347,   723,  1180,  1204,  1210,  1220,  1221,  1223,    32,
     291,  1180,  1186,  1188,  1203,  1180,  1193,   771,  1203,  1180,
    1196,  1198,  1180,  1197,   771,  1193,  1203,    32,   292,   292,
     294,  1193,  1196,   716,   771,   886,  1197,  1197,  1197,   570,
    1196,  1197,    61,   926,  1193,   294,  1198,  1198,  1196,  1196,
    1197,  1199,    93,    93,   890,  1835,   879,   976,    57,   149,
     177,   274,  1508,   177,   177,  1196,  1509,  1510,   772,  1558,
    1558,    26,   235,  1498,  1441,  1441,  1514,   167,   345,   772,
     299,  1477,  1441,  1441,  1441,  1558,    58,    70,    90,   124,
     213,   280,   397,   399,   551,   552,   709,  1186,  1187,  1452,
    1453,  1454,  1455,  1507,  1441,  1441,  1441,  1441,    86,   273,
    1609,  1617,  1558,  1441,  1441,  1835,  1610,   772,  1235,  1230,
    1228,  1230,  1231,  1609,  1835,   772,  1514,   185,  1579,    26,
     772,  1513,  1437,   772,   774,  1441,  1069,   196,  1086,  1087,
    1610,  1071,  1928,  1928,  1829,  1835,   779,  1667,  1667,  1870,
    1875,  1596,  1689,  1565,    61,  1679,  1552,  1436,  1680,  1405,
    1816,   762,  1835,   772,   774,  1667,     6,  1292,  1300,  1301,
    1835,   772,   774,  1612,  1752,  1753,   438,   146,   771,  1829,
     810,   746,  1823,   820,   822,    36,   587,  1135,  1136,  1137,
    1138,  1146,  1147,   140,  1823,  1056,  1057,   774,  1121,  1052,
     877,   856,    14,   323,  1007,   180,    11,   867,   868,   669,
     867,  1966,  1527,   284,  1529,   284,  1557,   114,   283,   449,
    1545,  1546,  1549,    79,    82,   182,   264,  1785,  1786,   143,
    1787,  1593,  1575,  1574,  1593,  1436,  1622,   586,  1829,  1932,
     177,   177,   586,    61,   122,   553,  1281,   112,  1266,  1822,
    1117,    94,   112,  1116,   734,    33,    92,   204,   278,  1150,
    1243,  1117,  1244,  1245,  1245,  1116,  1644,  1366,  1644,  1292,
    1210,  1644,   130,  1645,    94,  1644,   734,   204,  1644,  1644,
    1668,    61,  1835,  1366,  1587,  1588,  1821,    61,  1609,  1616,
    1059,  1823,    61,  1609,    61,  1609,    61,  1609,  1123,    61,
    1835,  1612,  1609,  1609,  1366,  1829,  1829,  1668,  1609,  1837,
    1301,   444,   491,   562,  1131,  1609,  1612,  1612,  1644,    61,
    1609,  1829,  1366,  1366,  1366,    61,   377,   379,   416,   445,
     581,   617,  1130,  1616,  1609,  1616,  1292,     5,    73,  1304,
    1133,  1135,  1835,   323,   444,  1316,   216,  1237,  1155,   779,
      61,  1613,  1829,  1835,   598,  1441,  1441,   180,   848,   854,
     180,   374,   849,  1835,  1405,  1968,  1349,   477,   266,   772,
     774,   772,   774,   772,   774,    95,   430,  1391,  1807,   578,
    1938,   299,  1942,  1942,  1942,  1942,   879,   956,  1682,   123,
    1203,  1202,  1667,  1203,   280,   305,   660,  1195,  1195,  1220,
    1218,  1222,  1223,  1211,    17,  1221,  1224,   379,  1205,  1203,
    1180,  1195,  1267,  1800,  1203,  1267,  1195,   294,  1195,  1203,
     570,   883,   884,   885,  1835,   926,  1180,   882,   924,  1180,
    1195,  1441,   215,  1192,  1222,  1224,  1180,  1203,  1195,  1195,
     892,   900,   901,  1609,   771,   893,   418,   772,   772,   772,
     772,  1222,   774,  1222,  1222,   772,   772,  1500,  1819,  1800,
     141,  1501,  1502,  1503,   772,   774,   772,   490,   540,   608,
     772,   772,  1193,   124,  1197,    32,  1197,  1456,   772,   772,
     772,   772,   774,   772,   772,   772,  1226,   772,   774,   772,
      26,   208,   229,  1580,  1581,  1819,   772,  1073,  1558,   130,
     464,  1088,   772,   774,   772,   762,  1884,  1884,  1589,   772,
     779,  1666,  1680,   772,   774,  1555,   772,   774,    10,  1754,
    1677,  1837,   818,   771,   771,    93,  1148,   772,   774,  1823,
    1054,  1783,  1121,  1119,   118,   125,   190,   872,   873,   874,
     875,   857,   858,  1949,  1985,    63,   120,   281,  1008,   648,
    1968,   772,   869,   870,   871,  1835,  1829,   772,    11,  1441,
     771,  1441,   771,   772,  1244,  1244,  1546,    26,    26,    79,
      26,  1786,   253,   264,  1788,  1789,   771,   437,   177,   319,
    1447,  1366,   771,  1447,  1148,   771,   130,   130,  1245,  1117,
    1266,  1835,  1117,  1117,  1822,  1292,  1822,  1289,  1212,  1822,
    1644,  1300,    93,   130,  1822,  1822,  1829,  1292,   774,  1593,
    1063,   771,  1610,  1829,   299,  1154,  1292,  1297,  1292,   772,
    1835,  1823,   342,   344,   345,   360,   397,   399,   422,   445,
     456,   457,   488,   497,   543,   544,   545,   551,   552,   568,
     569,   592,   593,   611,   654,   703,   706,   709,   732,   751,
     924,  1156,  1177,  1178,  1835,  1558,   662,  1829,   413,  1285,
     299,  1970,  1352,  1835,     6,   771,  1350,   879,   807,   809,
     805,  1444,  1942,    99,  1939,  1944,  1945,   130,   263,  1835,
     305,   280,  1202,   772,   774,   772,   882,  1176,   772,   774,
     926,   779,   755,  1224,   187,   246,   248,   898,   899,   900,
     903,  1447,  1835,   869,    93,    93,   177,   774,  1593,   772,
    1504,  1598,  1441,   540,   436,  1222,  1612,   772,  1609,  1592,
     772,    15,   391,   399,   706,   709,   718,  1582,  1583,  1804,
    1593,   678,  1111,  1070,   771,  1076,  1089,  1835,  1087,  1600,
     762,  1301,  1753,   410,   772,   577,   771,  1264,  1265,  1835,
    1264,  1835,  1136,   772,    11,  1112,  1056,   772,   774,   871,
      67,   928,   180,   842,   635,  1979,   774,   643,   716,  1176,
    1979,  1968,  1557,  1557,    93,  1544,  1544,  1800,  1800,    26,
    1800,    26,    26,  1789,   265,  1281,   400,  1280,    84,  1294,
    1835,    84,  1441,  1117,  1266,  1835,   284,  1256,   716,  1266,
    1266,    73,   237,  1154,  1360,  1217,  1822,  1835,  1315,  1288,
    1588,  1747,   263,  1316,  1298,  1300,  1290,   771,  1238,  1158,
     779,  1149,  1150,  1157,   779,   843,   850,   851,    33,   349,
     499,   772,   774,  1351,   270,   578,  1945,   281,  1823,  1222,
    1800,  1222,   926,   884,  1835,   177,   774,   928,   451,   772,
     895,   999,   772,  1819,   571,   774,   772,   772,   772,   718,
    1583,  1584,  1804,   643,   596,   431,  1585,   596,  1609,   771,
    1083,  1079,    61,   289,   290,   391,   467,  1090,   354,   771,
    1264,   772,   774,  1593,   771,   772,   771,  1055,  1054,   874,
      91,   835,  1435,   847,   848,  1980,   856,  1981,   871,   716,
     886,   570,  1981,   772,   772,   100,   128,   185,  1548,  1547,
    1800,  1800,  1800,   772,  1822,   584,   771,  1295,   774,   772,
    1266,  1256,   716,  1263,  1139,  1263,  1141,  1142,    61,    61,
    1316,  1366,   772,  1823,  1299,  1338,  1239,  1835,   154,  1240,
     204,   278,   302,   374,   487,   744,  1159,  1160,  1169,  1207,
    1208,  1209,  1236,  1447,  1828,  1178,    34,    61,   176,   180,
     334,   455,   654,  1163,  1165,  1200,  1201,  1208,  1835,   678,
     845,   928,   578,    33,    33,  1835,   204,  1353,  1354,  1835,
    1444,  1683,  1533,   779,   899,   993,  1593,  1598,  1598,   448,
      10,   448,   100,   391,   562,   705,  1081,  1082,  1835,   772,
     689,  1084,  1092,   704,   115,   374,   381,   396,   526,   539,
     559,   698,  1106,  1107,  1108,  1722,   838,   772,  1887,  1265,
     177,  1887,  1835,  1124,  1125,  1975,   844,  1176,  1982,   570,
    1835,    26,    26,   771,   771,  1150,  1610,  1086,  1835,  1145,
    1143,  1263,   771,  1140,   771,   771,   760,   761,   771,  1173,
    1174,  1175,  1416,  1462,  1803,  1828,  1060,   123,   772,   774,
     452,   583,   661,   180,  1241,   130,  1829,   695,  1208,   734,
     130,   176,  1667,  1216,  1175,   281,   327,    61,    11,   379,
    1201,  1206,  1441,   419,   846,   835,   578,   578,   772,   774,
    1690,  1691,  1821,  1778,  1835,  1584,   643,   187,   312,   772,
     774,  1610,   771,  1094,  1096,  1091,   409,  1668,  1668,   409,
    1668,  1668,  1668,  1668,   771,  1101,  1108,   421,   772,  1887,
     299,   374,   489,  1251,  1255,  1259,  1262,  1828,  1593,   772,
    1252,  1254,  1259,  1261,   774,  1823,   849,   927,  1835,   779,
    1554,  1556,   772,   772,   771,   771,  1144,  1264,   771,  1264,
    1264,  1805,  1805,  1172,   771,  1835,    63,   281,    61,  1613,
    1829,  1835,   173,   730,   643,  1173,  1202,  1200,  1441,  1354,
     774,  1667,  1213,  1080,  1082,   771,  1095,  1096,  1097,   156,
    1093,  1096,  1668,  1829,  1829,  1668,  1613,  1613,  1610,  1837,
     690,  1102,  1103,  1668,   284,   716,  1250,  1253,  1258,  1259,
    1260,   582,  1829,  1668,  1305,  1306,  1307,  1262,  1667,  1305,
    1261,  1835,    93,   413,   835,   779,  1835,   772,   772,  1264,
    1264,   771,   772,  1264,   772,   772,   772,  1086,    28,   223,
     237,   562,  1242,  1242,   771,  1438,   418,   679,  1164,  1691,
    1680,  1779,  1084,   772,   774,   156,  1099,  1100,  1444,  1829,
    1829,  1104,   772,   774,  1128,  1263,  1263,  1305,  1260,  1828,
    1609,  1307,  1306,    61,  1613,  1829,  1835,   772,  1435,   850,
    1835,   779,   772,   772,  1264,  1250,   772,  1251,  1252,   772,
      61,   176,   320,   180,   180,   772,  1610,  1161,  1162,  1207,
    1161,   588,   684,   737,  1166,   229,  1790,  1096,   774,  1098,
    1105,  1837,  1103,  1976,  1835,  1237,  1250,   772,  1250,   281,
      63,   772,  1207,  1167,  1168,  1169,   472,  1784,  1100,   772,
    1106,    75,  1250,  1242,  1242,  1169,    26,  1787,   643,  1800,
     114,  1791,  1977,   177,   771,  1793,   447,   595,  1971,  1972,
     143,   229,  1792,   772,   780,  1794,  1795,  1821,   237,  1796,
    1837,  1978,  1837,   772,   774,  1797,  1798,  1821,   928,  1795,
     774,  1667,   835,  1798,  1435,  1680,  1436
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   782,   783,   784,   783,   783,   785,   785,   786,   786,
     786,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     787,   787,   787,   787,   787,   787,   787,   787,   787,   787,
     788,   789,   789,   791,   790,   792,   793,   794,   792,   795,
     796,   795,   797,   797,   799,   798,   801,   800,   802,   802,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     803,   803,   803,   803,   803,   803,   803,   803,   803,   803,
     804,   804,   804,   805,   806,   806,   806,   807,   808,   808,
     808,   809,   810,   810,   810,   810,   810,   810,   810,   811,
     811,   812,   814,   815,   813,   816,   813,   817,   818,   813,
     819,   820,   813,   821,   822,   813,   823,   813,   824,   813,
     825,   813,   826,   813,   827,   813,   828,   813,   829,   813,
     830,   813,   813,   813,   813,   813,   813,   831,   813,   832,
     832,   833,   833,   834,   834,   834,   834,   834,   834,   834,
     834,   834,   834,   834,   834,   834,   834,   835,   835,   837,
     836,   838,   838,   839,   839,   839,   839,   839,   839,   839,
     841,   840,   843,   842,   842,   844,   844,   844,   844,   845,
     845,   846,   846,   847,   847,   848,   849,   849,   851,   850,
     852,   853,   853,   854,   854,   855,   855,   856,   856,   857,
     857,   857,   857,   857,   857,   857,   858,   858,   859,   859,
     861,   860,   862,   860,   863,   860,   864,   864,   865,   865,
     866,   866,   867,   868,   867,   869,   869,   870,   871,   871,
     871,   871,   871,   871,   872,   872,   873,   873,   874,   875,
     875,   875,   875,   877,   876,   878,   878,   879,   879,   880,
     880,   881,   882,   882,   882,   883,   884,   885,   885,   886,
     887,   888,   888,   888,   888,   889,   889,   889,   890,   889,
     892,   891,   893,   893,   894,   896,   895,   897,   897,   897,
     897,   898,   898,   899,   900,   900,   901,   902,   902,   903,
     903,   903,   903,   903,   903,   904,   904,   905,   906,   906,
     907,   907,   908,   908,   909,   909,   910,   910,   910,   911,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   912,   913,   914,   914,   915,   915,   916,   916,   917,
     918,   918,   919,   919,   919,   920,   921,   921,   922,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   924,   924,   925,   925,   926,   926,   927,   927,
     927,   927,   927,   928,   928,   928,   928,   928,   928,   928,
     928,   928,   928,   929,   929,   929,   929,   931,   930,   933,
     932,   934,   934,   936,   935,   935,   938,   937,   939,   939,
     939,   939,   940,   940,   940,   940,   941,   942,   943,   944,
     946,   945,   948,   947,   949,   949,   950,   950,   951,   952,
     952,   952,   953,   953,   954,   955,   955,   957,   958,   959,
     956,   960,   960,   960,   962,   961,   964,   965,   963,   963,
     966,   966,   967,   967,   969,   970,   968,   972,   973,   971,
     974,   974,   975,   976,   976,   977,   979,   978,   981,   980,
     983,   982,   984,   984,   986,   985,   987,   987,   987,   988,
     990,   989,   992,   991,   993,   995,   994,   996,   994,   997,
     998,   999,   994,  1000,   994,  1002,  1001,  1003,  1001,  1004,
    1005,  1001,  1006,  1001,  1007,  1007,  1008,  1008,  1008,  1009,
    1010,  1011,  1012,  1012,  1013,  1013,  1014,  1015,  1016,  1016,
    1018,  1017,  1019,  1019,  1019,  1020,  1020,  1020,  1021,  1022,
    1022,  1022,  1023,  1023,  1023,  1023,  1023,  1023,  1023,  1023,
    1024,  1025,  1025,  1025,  1026,  1026,  1026,  1026,  1026,  1027,
    1028,  1028,  1028,  1029,  1029,  1029,  1029,  1029,  1029,  1029,
    1030,  1031,  1031,  1031,  1032,  1032,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1038,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,  1046,  1047,  1048,  1048,  1049,  1049,  1050,  1050,
    1052,  1051,  1051,  1051,  1053,  1053,  1054,  1054,  1055,  1055,
    1056,  1057,  1057,  1059,  1058,  1060,  1062,  1061,  1064,  1063,
    1065,  1066,  1065,  1065,  1065,  1067,  1065,  1065,  1068,  1065,
    1069,  1069,  1070,  1070,  1071,  1071,  1072,  1072,  1073,  1074,
    1075,  1076,  1077,  1077,  1078,  1079,  1078,  1080,  1078,  1081,
    1081,  1082,  1083,  1084,  1084,  1085,  1085,  1086,  1086,  1088,
    1087,  1089,  1090,  1091,  1090,  1092,  1090,  1090,  1090,  1090,
    1093,  1093,  1094,  1094,  1095,  1095,  1097,  1098,  1096,  1099,
    1099,  1100,  1100,  1101,  1101,  1102,  1102,  1104,  1103,  1105,
    1106,  1106,  1107,  1107,  1108,  1108,  1108,  1108,  1108,  1108,
    1108,  1108,  1108,  1109,  1110,  1109,  1109,  1111,  1111,  1112,
    1112,  1113,  1113,  1114,  1114,  1115,  1115,  1116,  1116,  1117,
    1117,  1118,  1118,  1119,  1119,  1120,  1120,  1121,  1121,  1121,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1123,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,
    1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1122,  1124,
    1124,  1125,  1126,  1127,  1128,  1129,  1130,  1130,  1130,  1130,
    1130,  1130,  1130,  1131,  1131,  1131,  1132,  1132,  1132,  1132,
    1133,  1134,  1135,  1135,  1136,  1136,  1136,  1136,  1136,  1137,
    1137,  1139,  1138,  1140,  1138,  1141,  1138,  1142,  1138,  1143,
    1138,  1144,  1138,  1145,  1138,  1146,  1147,  1148,  1149,  1149,
    1150,  1151,  1151,  1152,  1152,  1153,  1155,  1154,  1157,  1156,
    1158,  1156,  1159,  1159,  1160,  1160,  1161,  1161,  1162,  1162,
    1163,  1163,  1163,  1163,  1164,  1163,  1163,  1163,  1165,  1165,
    1166,  1166,  1166,  1166,  1167,  1167,  1168,  1168,  1169,  1169,
    1169,  1169,  1171,  1170,  1172,  1172,  1173,  1173,  1174,  1174,
    1175,  1175,  1176,  1177,  1177,  1178,  1178,  1178,  1178,  1178,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1180,  1180,  1180,  1180,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1182,  1182,  1182,  1182,  1182,  1183,  1183,  1183,
    1183,  1183,  1183,  1183,  1183,  1183,  1183,  1183,  1183,  1183,
    1183,  1183,  1183,  1184,  1184,  1185,  1185,  1185,  1185,  1185,
    1185,  1185,  1185,  1186,  1187,  1187,  1188,  1188,  1189,  1189,
    1189,  1189,  1189,  1190,  1190,  1190,  1190,  1190,  1191,  1191,
    1191,  1192,  1192,  1193,  1193,  1193,  1194,  1195,  1195,  1195,
    1195,  1195,  1195,  1196,  1196,  1196,  1196,  1197,  1197,  1198,
    1198,  1199,  1199,  1200,  1200,  1201,  1201,  1201,  1201,  1201,
    1201,  1201,  1202,  1202,  1203,  1203,  1204,  1205,  1206,  1207,
    1207,  1207,  1208,  1208,  1208,  1208,  1208,  1208,  1209,  1209,
    1210,  1210,  1211,  1211,  1212,  1212,  1213,  1213,  1214,  1214,
    1215,  1215,  1216,  1217,  1217,  1218,  1218,  1219,  1219,  1220,
    1220,  1220,  1221,  1222,  1222,  1223,  1223,  1223,  1223,  1223,
    1223,  1224,  1224,  1226,  1225,  1227,  1227,  1228,  1229,  1229,
    1229,  1229,  1230,  1231,  1232,  1232,  1233,  1234,  1234,  1235,
    1235,  1236,  1236,  1237,  1238,  1238,  1239,  1239,  1240,  1240,
    1240,  1240,  1241,  1241,  1241,  1241,  1241,  1242,  1242,  1242,
    1242,  1242,  1243,  1243,  1244,  1244,  1245,  1245,  1246,  1246,
    1246,  1247,  1247,  1248,  1249,  1250,  1250,  1251,  1251,  1252,
    1252,  1253,  1253,  1254,  1254,  1255,  1255,  1256,  1256,  1257,
    1257,  1257,  1258,  1258,  1259,  1259,  1259,  1259,  1259,  1259,
    1260,  1260,  1261,  1262,  1262,  1263,  1263,  1263,  1264,  1264,
    1265,  1265,  1266,  1266,  1267,  1267,  1269,  1270,  1268,  1271,
    1268,  1268,  1272,  1268,  1273,  1268,  1274,  1268,  1275,  1268,
    1276,  1268,  1268,  1268,  1268,  1268,  1277,  1268,  1268,  1278,
    1279,  1268,  1280,  1280,  1281,  1281,  1281,  1281,  1282,  1282,
    1282,  1282,  1282,  1283,  1283,  1283,  1283,  1284,  1284,  1285,
    1285,  1286,  1286,  1287,  1287,  1287,  1287,  1287,  1287,  1287,
    1287,  1287,  1287,  1288,  1287,  1287,  1289,  1287,  1290,  1287,
    1287,  1287,  1287,  1287,  1291,  1292,  1292,  1294,  1293,  1295,
    1295,  1295,  1297,  1296,  1298,  1299,  1298,  1300,  1300,  1301,
    1302,  1302,  1303,  1304,  1304,  1304,  1304,  1304,  1304,  1304,
    1304,  1304,  1304,  1304,  1304,  1304,  1304,  1304,  1304,  1304,
    1304,  1304,  1304,  1304,  1304,  1304,  1304,  1304,  1304,  1304,
    1304,  1304,  1305,  1305,  1305,  1305,  1305,  1306,  1306,  1307,
    1307,  1308,  1308,  1309,  1309,  1311,  1310,  1312,  1312,  1313,
    1313,  1314,  1314,  1315,  1315,  1315,  1316,  1316,  1316,  1317,
    1317,  1317,  1317,  1319,  1318,  1320,  1318,  1318,  1318,  1321,
    1322,  1322,  1323,  1323,  1324,  1324,  1324,  1326,  1325,  1327,
    1327,  1328,  1328,  1328,  1329,  1329,  1329,  1330,  1330,  1332,
    1331,  1333,  1333,  1333,  1334,  1335,  1334,  1337,  1336,  1338,
    1338,  1339,  1339,  1340,  1340,  1340,  1341,  1341,  1343,  1342,
    1344,  1344,  1345,  1346,  1346,  1347,  1347,  1348,  1349,  1348,
    1350,  1351,  1350,  1352,  1352,  1352,  1353,  1353,  1353,  1354,
    1354,  1355,  1355,  1356,  1357,  1356,  1359,  1358,  1360,  1360,
    1361,  1361,  1362,  1362,  1362,  1362,  1362,  1362,  1363,  1363,
    1365,  1364,  1366,  1366,  1366,  1368,  1367,  1367,  1369,  1369,
    1370,  1370,  1371,  1373,  1372,  1374,  1374,  1375,  1375,  1376,
    1377,  1378,  1378,  1380,  1379,  1381,  1381,  1382,  1382,  1383,
    1384,  1386,  1385,  1388,  1387,  1389,  1389,  1390,  1390,  1392,
    1391,  1393,  1391,  1395,  1394,  1396,  1394,  1397,  1397,  1399,
    1398,  1401,  1402,  1400,  1403,  1404,  1405,  1405,  1406,  1406,
    1408,  1407,  1409,  1407,  1410,  1410,  1411,  1412,  1411,  1411,
    1413,  1413,  1414,  1415,  1416,  1416,  1417,  1417,  1418,  1419,
    1419,  1420,  1420,  1421,  1421,  1421,  1422,  1422,  1422,  1423,
    1424,  1424,  1425,  1425,  1426,  1426,  1426,  1426,  1427,  1427,
    1428,  1428,  1428,  1429,  1429,  1430,  1430,  1431,  1431,  1431,
    1432,  1432,  1432,  1433,  1433,  1434,  1435,  1436,  1437,  1437,
    1437,  1437,  1437,  1438,  1438,  1438,  1439,  1439,  1439,  1440,
    1440,  1441,  1441,  1441,  1441,  1441,  1442,  1442,  1442,  1442,
    1442,  1442,  1442,  1442,  1442,  1442,  1442,  1442,  1443,  1443,
    1443,  1443,  1443,  1443,  1443,  1443,  1443,  1443,  1443,  1443,
    1443,  1443,  1443,  1443,  1444,  1444,  1444,  1444,  1444,  1444,
    1444,  1444,  1444,  1444,  1444,  1444,  1444,  1444,  1444,  1444,
    1444,  1444,  1444,  1445,  1445,  1446,  1446,  1447,  1447,  1448,
    1448,  1449,  1449,  1449,  1449,  1449,  1449,  1450,  1450,  1451,
    1451,  1452,  1452,  1452,  1453,  1453,  1453,  1453,  1453,  1453,
    1454,  1454,  1454,  1456,  1455,  1455,  1457,  1458,  1458,  1459,
    1459,  1459,  1459,  1460,  1461,  1461,  1461,  1461,  1461,  1461,
    1461,  1461,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,
    1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,
    1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,  1462,
    1462,  1463,  1463,  1463,  1463,  1464,  1464,  1465,  1465,  1465,
    1465,  1465,  1465,  1466,  1466,  1467,  1467,  1468,  1468,  1468,
    1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,
    1468,  1468,  1468,  1468,  1468,  1468,  1468,  1468,  1469,  1469,
    1469,  1469,  1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,
    1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,
    1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,  1470,
    1470,  1471,  1471,  1471,  1471,  1471,  1471,  1471,  1471,  1471,
    1471,  1471,  1471,  1471,  1471,  1471,  1471,  1471,  1471,  1471,
    1471,  1471,  1471,  1471,  1471,  1471,  1471,  1471,  1472,  1472,
    1472,  1472,  1472,  1472,  1472,  1472,  1472,  1474,  1473,  1473,
    1473,  1475,  1475,  1476,  1476,  1477,  1477,  1478,  1478,  1479,
    1479,  1480,  1481,  1481,  1481,  1481,  1481,  1481,  1481,  1482,
    1483,  1481,  1481,  1481,  1481,  1481,  1481,  1481,  1481,  1481,
    1481,  1481,  1484,  1481,  1485,  1485,  1486,  1486,  1486,  1487,
    1487,  1487,  1487,  1487,  1487,  1487,  1487,  1487,  1487,  1487,
    1487,  1487,  1488,  1490,  1489,  1489,  1491,  1491,  1492,  1493,
    1495,  1494,  1496,  1496,  1496,  1496,  1497,  1497,  1498,  1498,
    1499,  1499,  1500,  1500,  1501,  1501,  1502,  1503,  1504,  1504,
    1504,  1506,  1505,  1507,  1508,  1507,  1509,  1507,  1510,  1507,
    1507,  1507,  1507,  1511,  1511,  1511,  1511,  1511,  1511,  1511,
    1511,  1512,  1512,  1512,  1512,  1513,  1513,  1514,  1514,  1515,
    1515,  1516,  1516,  1517,  1517,  1518,  1518,  1519,  1519,  1520,
    1520,  1521,  1522,  1522,  1523,  1523,  1524,  1525,  1524,  1526,
    1524,  1524,  1527,  1524,  1528,  1524,  1524,  1529,  1524,  1530,
    1524,  1524,  1531,  1531,  1531,  1532,  1532,  1533,  1533,  1534,
    1535,  1535,  1535,  1535,  1536,  1536,  1537,  1537,  1538,  1538,
    1539,  1539,  1540,  1540,  1541,  1542,  1543,  1543,  1544,  1544,
    1544,  1544,  1545,  1545,  1547,  1546,  1548,  1546,  1549,  1549,
    1550,  1551,  1550,  1553,  1552,  1554,  1554,  1555,  1555,  1556,
    1556,  1557,  1557,  1558,  1558,  1558,  1558,  1558,  1558,  1558,
    1558,  1558,  1558,  1558,  1558,  1559,  1559,  1559,  1559,  1559,
    1559,  1559,  1559,  1559,  1560,  1560,  1560,  1560,  1561,  1561,
    1561,  1562,  1562,  1563,  1564,  1564,  1565,  1566,  1565,  1567,
    1568,  1567,  1569,  1569,  1570,  1570,  1571,  1571,  1571,  1572,
    1572,  1573,  1573,  1574,  1576,  1575,  1577,  1577,  1578,  1578,
    1579,  1579,  1580,  1580,  1581,  1581,  1582,  1582,  1583,  1583,
    1583,  1584,  1584,  1584,  1585,  1585,  1585,  1585,  1585,  1585,
    1586,  1587,  1587,  1588,  1589,  1589,  1591,  1590,  1592,  1592,
    1593,  1593,  1593,  1594,  1594,  1595,  1595,  1595,  1596,  1597,
    1597,  1597,  1598,  1598,  1598,  1598,  1598,  1598,  1599,  1600,
    1600,  1600,  1600,  1601,  1601,  1601,  1602,  1602,  1603,  1604,
    1605,  1605,  1605,  1606,  1606,  1607,  1607,  1608,  1608,  1609,
    1609,  1609,  1609,  1609,  1609,  1610,  1610,  1610,  1610,  1610,
    1611,  1611,  1611,  1611,  1612,  1612,  1612,  1612,  1612,  1613,
    1613,  1613,  1613,  1613,  1614,  1615,  1615,  1616,  1616,  1617,
    1617,  1617,  1619,  1618,  1620,  1620,  1621,  1621,  1622,  1624,
    1623,  1625,  1625,  1626,  1627,  1627,  1627,  1628,  1630,  1631,
    1629,  1629,  1629,  1633,  1632,  1635,  1634,  1636,  1634,  1634,
    1634,  1634,  1634,  1634,  1634,  1637,  1634,  1634,  1634,  1634,
    1634,  1634,  1638,  1634,  1639,  1639,  1640,  1641,  1642,  1642,
    1643,  1644,  1644,  1645,  1645,  1646,  1646,  1648,  1649,  1647,
    1651,  1652,  1650,  1653,  1653,  1653,  1653,  1654,  1654,  1655,
    1655,  1657,  1656,  1658,  1658,  1659,  1658,  1660,  1661,  1661,
    1662,  1662,  1663,  1664,  1664,  1665,  1665,  1666,  1667,  1667,
    1668,  1668,  1669,  1669,  1670,  1670,  1672,  1671,  1674,  1673,
    1675,  1675,  1676,  1676,  1677,  1677,  1678,  1678,  1679,  1679,
    1680,  1680,  1681,  1682,  1683,  1681,  1684,  1684,  1686,  1687,
    1685,  1688,  1688,  1689,  1689,  1690,  1690,  1691,  1692,  1692,
    1694,  1693,  1695,  1695,  1696,  1696,  1697,  1698,  1699,  1700,
    1699,  1701,  1699,  1702,  1702,  1703,  1703,  1704,  1704,  1705,
    1705,  1706,  1706,  1707,  1707,  1707,  1709,  1708,  1710,  1710,
    1711,  1711,  1712,  1712,  1713,  1713,  1713,  1713,  1713,  1713,
    1713,  1713,  1713,  1714,  1714,  1716,  1715,  1717,  1717,  1717,
    1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,
    1717,  1718,  1717,  1719,  1717,  1717,  1717,  1717,  1717,  1717,
    1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,
    1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,
    1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,
    1717,  1717,  1717,  1717,  1717,  1717,  1717,  1717,  1720,  1720,
    1720,  1721,  1721,  1722,  1722,  1723,  1723,  1724,  1724,  1725,
    1725,  1726,  1726,  1727,  1727,  1728,  1728,  1728,  1730,  1729,
    1731,  1729,  1732,  1732,  1732,  1732,  1732,  1732,  1733,  1733,
    1734,  1735,  1735,  1735,  1735,  1736,  1736,  1737,  1737,  1737,
    1739,  1738,  1741,  1740,  1740,  1742,  1742,  1743,  1744,  1743,
    1745,  1745,  1746,  1746,  1746,  1746,  1746,  1746,  1746,  1746,
    1746,  1746,  1746,  1746,  1746,  1746,  1746,  1746,  1746,  1747,
    1747,  1748,  1749,  1750,  1749,  1749,  1751,  1751,  1752,  1752,
    1752,  1753,  1754,  1754,  1756,  1755,  1757,  1757,  1759,  1758,
    1760,  1758,  1758,  1761,  1761,  1762,  1762,  1763,  1764,  1763,
    1766,  1765,  1767,  1767,  1767,  1768,  1768,  1768,  1769,  1769,
    1770,  1770,  1772,  1771,  1773,  1773,  1774,  1776,  1777,  1778,
    1779,  1775,  1780,  1780,  1781,  1781,  1782,  1782,  1782,  1783,
    1783,  1783,  1784,  1784,  1785,  1785,  1786,  1786,  1786,  1786,
    1787,  1787,  1788,  1788,  1789,  1789,  1790,  1790,  1791,  1791,
    1792,  1792,  1793,  1793,  1793,  1794,  1794,  1795,  1795,  1796,
    1796,  1797,  1797,  1798,  1799,  1799,  1799,  1799,  1800,  1800,
    1801,  1801,  1801,  1802,  1802,  1802,  1803,  1803,  1804,  1804,
    1804,  1804,  1804,  1804,  1804,  1804,  1804,  1804,  1805,  1805,
    1805,  1805,  1805,  1806,  1806,  1806,  1808,  1807,  1809,  1809,
    1810,  1810,  1812,  1811,  1813,  1813,  1814,  1814,  1815,  1816,
    1816,  1817,  1817,  1818,  1818,  1819,  1820,  1820,  1820,  1820,
    1820,  1821,  1821,  1821,  1821,  1821,  1822,  1822,  1822,  1822,
    1823,  1823,  1823,  1824,  1824,  1825,  1826,  1826,  1827,  1827,
    1827,  1828,  1829,  1830,  1831,  1832,  1832,  1833,  1833,  1834,
    1834,  1834,  1835,  1835,  1836,  1836,  1837,  1837,  1837,  1838,
    1838,  1838,  1839,  1839,  1840,  1841,  1841,  1841,  1841,  1841,
    1841,  1841,  1841,  1842,  1842,  1842,  1842,  1842,  1842,  1842,
    1842,  1842,  1843,  1843,  1843,  1843,  1844,  1844,  1844,  1844,
    1844,  1844,  1844,  1844,  1845,  1845,  1845,  1845,  1845,  1845,
    1845,  1845,  1845,  1846,  1846,  1846,  1846,  1846,  1846,  1846,
    1846,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,
    1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,
    1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,
    1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,
    1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,  1847,
    1847,  1847,  1847,  1847,  1847,  1847,  1848,  1848,  1848,  1848,
    1848,  1848,  1849,  1849,  1849,  1849,  1849,  1849,  1849,  1849,
    1849,  1849,  1850,  1850,  1850,  1851,  1851,  1851,  1852,  1852,
    1852,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,
    1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,
    1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,  1853,
    1853,  1853,  1853,  1853,  1853,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,  1854,
    1854,  1854,  1856,  1855,  1857,  1858,  1855,  1859,  1859,  1861,
    1860,  1862,  1860,  1863,  1860,  1865,  1864,  1864,  1866,  1866,
    1868,  1867,  1869,  1867,  1871,  1870,  1870,  1872,  1872,  1872,
    1873,  1873,  1873,  1873,  1874,  1874,  1874,  1874,  1875,  1875,
    1875,  1876,  1876,  1876,  1876,  1876,  1876,  1876,  1876,  1876,
    1876,  1876,  1876,  1876,  1876,  1876,  1877,  1877,  1877,  1877,
    1878,  1879,  1880,  1880,  1881,  1881,  1881,  1881,  1882,  1882,
    1883,  1883,  1883,  1884,  1884,  1884,  1884,  1884,  1886,  1885,
    1887,  1887,  1887,  1888,  1888,  1889,  1889,  1890,  1891,  1891,
    1891,  1891,  1891,  1893,  1892,  1895,  1894,  1896,  1896,  1897,
    1896,  1898,  1898,  1899,  1899,  1900,  1900,  1900,  1900,  1901,
    1900,  1902,  1902,  1902,  1902,  1902,  1903,  1904,  1904,  1904,
    1904,  1904,  1904,  1904,  1904,  1905,  1905,  1906,  1907,  1907,
    1907,  1907,  1907,  1907,  1907,  1908,  1908,  1909,  1909,  1910,
    1910,  1911,  1912,  1912,  1913,  1913,  1914,  1914,  1915,  1915,
    1916,  1916,  1918,  1917,  1919,  1917,  1920,  1917,  1921,  1917,
    1917,  1917,  1917,  1917,  1917,  1917,  1917,  1917,  1917,  1917,
    1917,  1917,  1917,  1917,  1917,  1917,  1917,  1917,  1917,  1917,
    1917,  1917,  1917,  1917,  1917,  1917,  1917,  1922,  1922,  1923,
    1923,  1924,  1924,  1924,  1925,  1925,  1925,  1925,  1926,  1926,
    1927,  1927,  1928,  1928,  1929,  1929,  1930,  1930,  1931,  1931,
    1931,  1931,  1932,  1932,  1933,  1934,  1934,  1934,  1935,  1935,
    1936,  1936,  1937,  1938,  1938,  1938,  1938,  1938,  1939,  1939,
    1939,  1939,  1939,  1940,  1940,  1941,  1941,  1942,  1942,  1943,
    1943,  1944,  1944,  1945,  1945,  1947,  1946,  1948,  1949,  1949,
    1950,  1950,  1951,  1951,  1951,  1952,  1952,  1952,  1953,  1954,
    1954,  1954,  1955,  1956,  1957,  1957,  1957,  1958,  1958,  1958,
    1959,  1959,  1959,  1959,  1959,  1959,  1959,  1959,  1960,  1960,
    1961,  1962,  1963,  1963,  1963,  1964,  1964,  1965,  1965,  1966,
    1966,  1967,  1967,  1969,  1968,  1970,  1970,  1970,  1970,  1971,
    1971,  1972,  1972,  1974,  1975,  1976,  1977,  1978,  1973,  1980,
    1979,  1982,  1981,  1984,  1985,  1983,  1986,  1986,  1986,  1986,
    1986,  1986,  1987,  1987,  1988,  1988,  1988,  1989,  1989,  1989,
    1990,  1990,  1990,  1991,  1991,  1992,  1993,  1992,  1994,  1994,
    1995,  1995,  1996,  1996,  1997
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     4,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     0,     5,     3,     0,     0,     6,     0,
       0,     3,     1,     3,     0,     3,     0,     6,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     5,     5,     1,
       0,     1,     3,     1,     0,     1,     3,     1,     0,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     1,     0,     0,     8,     0,     8,     0,     0,    16,
       0,     0,    15,     0,     0,    15,     0,     6,     0,    10,
       0,    11,     0,     5,     0,     6,     0,     5,     0,    12,
       0,    12,    10,     8,     6,     4,     3,     0,     3,     0,
       1,     1,     2,     3,     2,     1,     3,     2,     1,     3,
       3,     3,     1,     1,     1,     1,     3,     0,     1,     0,
      12,     1,     3,     2,     2,     2,     2,     2,     2,     2,
       0,    12,     0,     6,     2,     0,     1,     3,     1,     0,
       2,     0,     2,     0,     1,     4,     0,     2,     0,     3,
       0,     0,     1,     3,     1,     0,     2,     0,     2,     2,
       2,     2,     2,     3,     3,     1,     1,     2,     3,     3,
       0,     4,     0,     6,     0,     8,     0,     3,     0,     1,
       3,     1,     0,     0,     2,     3,     1,     1,     2,     6,
       8,     5,     7,     3,     0,     1,     3,     1,     2,     0,
       1,     1,     1,     0,     4,     0,     3,     2,     3,     0,
       3,     2,     1,     3,     5,     1,     2,     1,     3,     3,
       1,     3,     5,     6,     4,     1,     4,     1,     0,     6,
       0,     6,     0,     3,     0,     0,     3,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     1,     1,     2,     3,     3,     1,     1,
       0,     1,     0,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     0,     1,     1,     3,     1,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     0,
       2,     1,     1,     0,     3,     1,     0,     2,     1,     2,
       3,     4,     1,     2,     3,     4,     2,     2,     2,     0,
       0,     3,     0,     3,     1,     3,     0,     3,     3,     3,
       4,     5,     2,     4,     2,     1,     3,     0,     0,     0,
       7,     0,     2,     2,     0,     6,     0,     0,     4,     1,
       1,     2,     1,     2,     0,     0,     6,     0,     0,     6,
       0,     2,     2,     0,     1,     1,     0,     7,     0,     5,
       0,     7,     0,     1,     0,     3,     5,     3,     5,     3,
       0,     6,     0,     6,     1,     0,     5,     0,     5,     0,
       0,     0,    11,     0,     5,     0,     3,     0,     3,     0,
       0,     8,     0,     3,     1,     1,     1,     1,     1,     2,
       4,     5,     0,     4,     4,     4,     3,     3,     2,     2,
       0,     2,     1,     2,     3,     1,     1,     1,     1,     1,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     2,     2,     2,
       1,     1,     1,     1,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       0,     5,     3,     1,     2,     4,     0,     4,     1,     4,
       1,     0,     1,     0,     4,     0,     0,     3,     0,     6,
       6,     0,     4,     2,     2,     0,     3,     2,     0,     3,
       0,     1,     0,     3,     0,     1,     1,     3,     1,     4,
       3,     3,     0,     2,     0,     0,     7,     0,    10,     1,
       3,     1,     1,     0,     2,     0,     3,     1,     3,     0,
       6,     1,     0,     0,     4,     0,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     0,     0,     5,     1,
       3,     1,     1,     0,     3,     1,     3,     0,     4,     1,
       0,     1,     2,     1,     3,     4,     3,     3,     3,     3,
       4,     4,     3,     0,     0,     5,     2,     0,     2,     0,
       1,     0,     1,     1,     2,     1,     1,     0,     3,     0,
       3,     1,     3,     0,     1,     1,     2,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       0,     6,     1,     1,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     0,
       1,     2,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     2,     1,
       2,     0,     9,     0,    10,     0,     9,     0,     9,     0,
      10,     0,    11,     0,    10,     2,     7,     7,     0,     1,
       4,     0,     1,     0,     1,     2,     0,     4,     0,     3,
       0,     3,     0,     1,     2,     1,     0,     1,     2,     1,
       0,     1,     2,     3,     0,     6,     5,     5,     0,     2,
       0,     1,     1,     1,     0,     1,     2,     1,     1,     2,
       2,     1,     0,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     3,     3,     2,     1,     1,     3,     3,     3,     3,
       0,     1,     2,     2,     3,     3,     2,     3,     3,     4,
       3,     3,     3,     1,     2,     2,     2,     2,     3,     3,
       2,     3,     2,     2,     3,     3,     2,     3,     2,     2,
       2,     2,     2,     5,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     1,
       2,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     0,     3,     0,     1,     1,     5,     0,     1,     1,
       1,     2,     2,     3,     3,     3,     3,     0,     1,     0,
       1,     0,     1,     2,     1,     1,     2,     4,     1,     3,
       2,     1,     0,     2,     0,     1,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     3,     3,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     0,     2,     1,     1,
       1,     1,     1,     0,     2,     1,     1,     0,     1,     2,
       1,     1,     2,     0,     1,     1,     2,     1,     2,     2,
       1,     0,     1,     0,     4,     1,     1,     1,     0,     1,
       2,     1,     1,     2,     1,     3,     3,     1,     1,     0,
       2,     0,     1,     5,     0,     3,     3,     1,     0,     2,
       2,     2,     0,     3,     3,     6,     6,     1,     1,     2,
       2,     2,     2,     2,     1,     1,     0,     1,     1,     1,
       1,     0,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     1,     2,     1,     2,     1,     2,     0,     2,     0,
       2,     2,     2,     2,     3,     2,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     1,     1,     1,     4,     2,
       1,     4,     0,     1,     1,     3,     0,     0,     8,     0,
       5,     7,     0,     5,     0,     5,     0,    10,     0,     9,
       0,    11,     3,     4,     3,     3,     0,     8,     8,     0,
       0,     7,     1,     1,     0,     1,     1,     3,     0,     2,
       3,     5,     5,     0,     3,     1,     4,     0,     3,     0,
       2,     0,     1,     0,     2,     2,     2,     2,     1,     1,
       1,     4,     4,     0,     6,     4,     0,     5,     0,     6,
       4,     3,     1,     7,     2,     1,     1,     0,     6,     0,
       3,     2,     0,     5,     0,     0,     6,     1,     3,     1,
       1,     3,     3,     3,     2,     2,     4,     4,     2,     7,
       6,     5,     5,     4,     5,     4,     4,     2,     2,     7,
       6,     3,     5,     1,     1,     1,     1,     1,     3,     3,
       3,     5,     0,     1,     1,     2,     2,     3,     3,     3,
       3,     0,     1,     0,     1,     0,     2,     0,     1,     2,
       1,     1,     1,     0,     1,     1,     0,     2,     1,     0,
       1,     1,     1,     0,     6,     0,     5,     4,     4,     3,
       0,     1,     1,     3,     3,     2,     2,     0,     2,     1,
       3,     0,     1,     1,     0,     2,     4,     1,     3,     0,
       5,     0,     1,     1,     3,     0,     4,     0,     4,     0,
       1,     1,     2,     1,     1,     1,     0,     2,     0,     5,
       1,     3,     2,     0,     3,     1,     4,     1,     0,     4,
       1,     0,     4,     0,     1,     3,     0,     1,     3,     1,
       1,     2,     6,     3,     0,     4,     0,     3,     0,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     0,     2,
       0,     6,     0,     1,     1,     0,     4,     4,     3,     5,
       1,     3,     4,     0,     6,     1,     1,     1,     3,     2,
       3,     1,     1,     0,     6,     1,     1,     1,     3,     3,
       4,     0,     6,     0,     2,     0,     4,     0,     2,     0,
       3,     0,     4,     0,     3,     0,     4,     1,     1,     0,
       3,     0,     0,     5,     6,     7,     1,     2,     1,     1,
       0,     3,     0,     3,     3,     3,     1,     0,     4,     3,
       1,     1,     1,     1,     1,     4,     0,     1,     2,     1,
       1,     0,     1,     0,     1,     1,     2,     1,     2,     9,
       0,     1,     0,     2,     3,     1,     4,     4,     2,     1,
       1,     1,     1,     3,     5,     0,     1,     0,     2,     1,
       3,     1,     1,     3,     4,     0,     0,     0,     0,     2,
       2,     1,     1,     0,     2,     3,     0,     2,     3,     0,
       2,     3,     3,     3,     2,     1,     3,     4,     3,     4,
       3,     4,     3,     4,     3,     3,     6,     1,     3,     4,
       5,     7,     6,     8,     5,     6,     4,     3,     5,     4,
       6,     3,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     6,     6,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       1,     2,     2,     0,     3,     1,     4,     1,     3,     1,
       1,     1,     1,     3,     1,     4,     4,     4,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     4,     4,     7,     6,     3,     4,
       6,     6,     4,     4,     4,     4,     4,     4,     6,     8,
      10,     1,     1,     3,     1,     1,     3,     1,     2,     2,
       2,     2,     2,     1,     3,     4,     6,     4,     6,     2,
       2,     4,     4,     4,    10,     6,     8,     6,     4,     4,
       6,     4,     3,     4,     1,     4,     3,     4,     5,     3,
       5,     3,     6,     8,     2,     2,     8,     8,     6,     8,
       6,     6,     6,     6,     2,     6,     6,     8,     4,     2,
       8,     8,     4,     2,     2,     2,     6,     6,     4,     4,
       8,     4,     4,     4,     4,     3,     8,     6,     8,     4,
       6,     4,     6,     4,     4,     4,     6,     8,     4,     3,
       6,     4,     6,     5,     8,     7,    10,     1,     6,     4,
       4,     4,     4,     4,     6,     4,     6,     0,     5,     6,
       8,     2,     3,     0,     4,     0,     3,     0,     1,     1,
       3,     4,     4,     5,     4,     4,     4,     5,     4,     0,
       0,     7,     4,     5,     4,     5,     4,     4,     4,     4,
       4,     5,     0,     9,     3,     3,     1,     1,     1,     3,
       3,     3,     3,     3,     4,     4,     4,     6,     4,     6,
       4,     6,     5,     0,     7,     4,     4,     4,     4,     1,
       0,     3,     3,     1,     3,     5,     0,     1,     0,     2,
       0,     3,     4,     2,     0,     1,     1,     2,     1,     3,
       3,     0,     3,     2,     0,     4,     0,     4,     0,     4,
       2,     1,     1,     1,     1,     2,     1,     2,     2,     1,
       2,     1,     2,     2,     3,     0,     1,     1,     3,     1,
       3,     1,     3,     4,     5,     1,     3,     3,     3,     1,
       1,     1,     1,     4,     1,     3,     3,     0,     6,     0,
       8,     4,     0,     8,     0,    10,     6,     0,     8,     0,
      10,     6,     1,     2,     1,     1,     2,     0,     1,     5,
       1,     1,     1,     1,     1,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     5,     3,     0,     1,     0,     2,
       3,     3,     1,     1,     0,     7,     0,     7,     1,     2,
       0,     0,     2,     0,     2,     0,     1,     1,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     1,     2,     0,     1,     0,     0,     3,     0,
       0,     3,     0,     4,     4,     2,     0,     1,     1,     0,
       2,     3,     1,     3,     0,     7,     0,     1,     0,     3,
       0,     3,     0,     3,     1,     1,     1,     4,     2,     2,
       2,     1,     2,     2,     0,     3,     2,     2,     3,     3,
       3,     3,     1,     2,     0,     1,     0,     4,     4,     2,
       0,     1,     1,     0,     1,     2,     5,     4,     1,     1,
       3,     3,     1,     3,     1,     1,     1,     1,     1,     0,
       2,     3,     4,     1,     2,     1,     0,     1,     1,     1,
       0,     2,     2,     2,     1,     0,     1,     2,     2,     2,
       1,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       2,     1,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     0,     1,     3,     1,     3,     0,
       2,     3,     1,     1,     2,     1,     3,     2,     0,     0,
       7,     2,     1,     0,     3,     0,     8,     0,     8,     4,
       6,     4,     4,     5,     5,     0,     6,     4,     4,     5,
       6,     4,     0,     6,     1,     3,     1,     2,     1,     3,
       1,     0,     2,     0,     2,     0,     1,     0,     0,     8,
       0,     0,     6,     0,     1,     1,     1,     1,     1,     2,
       1,     0,     2,     1,     2,     0,     3,     3,     0,     1,
       3,     1,     1,     3,     1,     3,     1,     3,     1,     1,
       0,     1,     1,     1,     1,     1,     0,     4,     0,     4,
       0,     1,     0,     1,     3,     1,     5,     3,     1,     1,
       1,     1,     0,     0,     0,     7,     5,     1,     0,     0,
      11,     3,     1,     3,     3,     3,     1,     3,     0,     1,
       0,     3,     0,     3,     2,     3,     3,     2,     5,     0,
       5,     0,     6,     0,     2,     1,     3,     2,     4,     0,
       2,     0,     2,     1,     1,     1,     0,     5,     0,     1,
       0,     1,     1,     3,     1,     1,     2,     2,     2,     1,
       1,     1,     1,     0,     3,     0,     3,     2,     4,     4,
       3,     4,     4,     1,     3,     3,     3,     3,     6,     2,
       2,     0,     6,     0,     7,     5,     2,     1,     1,     1,
       5,     5,     2,     2,     1,     4,     3,     2,     3,     2,
       2,     1,     4,     4,     3,     3,     3,     2,     3,     2,
       3,     3,     3,     3,     4,     3,     2,     3,     3,     3,
       3,     4,     3,     3,     4,     3,     3,     3,     1,     1,
       1,     1,     1,     0,     1,     0,     2,     0,     1,     1,
       1,     0,     2,     0,     2,     0,     3,     3,     0,     4,
       0,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     1,     1,     0,     3,     0,     1,     1,
       0,     4,     0,     4,     1,     0,     1,     4,     0,     3,
       3,     1,     2,     2,     2,     2,     3,     3,     2,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     0,
       1,     2,     2,     0,     3,     1,     0,     5,     0,     1,
       3,     1,     0,     3,     0,     3,     3,     1,     0,     4,
       0,     3,     2,     0,     1,     0,     2,     5,     0,     6,
       0,     4,     0,     1,     1,     2,     2,     3,     0,     1,
       1,     2,     0,     3,     0,     4,     2,     0,     0,     0,
       0,    22,     1,     1,     0,     1,     0,     1,     1,     0,
       1,     1,     0,     2,     2,     1,     3,     4,     3,     3,
       0,     2,     2,     1,     3,     3,     0,     4,     0,     3,
       1,     1,     0,     3,     2,     3,     1,     1,     2,     0,
       2,     3,     1,     5,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     2,     2,     0,     4,     0,     1,
       1,     3,     0,     7,     0,     3,     1,     3,     1,     1,
       1,     3,     5,     3,     5,     1,     1,     3,     4,     5,
       4,     1,     3,     4,     4,     5,     1,     5,     3,     2,
       1,     3,     2,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     3,     0,     0,     7,     1,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     2,     0,     2,
       0,     2,     0,     4,     0,     3,     1,     1,     1,     1,
       0,     1,     1,     1,     0,     2,     2,     2,     3,     5,
       5,     3,     5,     5,     4,     6,     8,     8,     2,     3,
       3,     3,     5,     2,     3,     3,     1,     1,     3,     3,
       1,     3,     2,     2,     2,     2,     2,     1,     1,     3,
       1,     4,     4,     1,     1,     1,     1,     1,     0,     5,
       0,     2,     1,     1,     1,     1,     3,     3,     1,     1,
       2,     2,     2,     0,     3,     0,     3,     3,     2,     0,
       6,     1,     2,     1,     1,     1,     1,     1,     1,     0,
       5,     1,     1,     1,     1,     1,     3,     6,     6,     6,
       6,     7,     7,     5,     3,     4,     1,     3,     8,     8,
       8,     8,     9,     6,     4,     0,     3,     0,     3,     1,
       3,     2,     1,     1,     0,     1,     1,     2,     0,     1,
       1,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     1,     1,     2,     2,     0,     1,     3,
       1,     2,     2,     2,     1,     3,     3,     1,     1,     3,
       1,     3,     1,     3,     1,     1,     1,     1,     4,     5,
       4,     1,     3,     1,     2,     0,     2,     5,     0,     3,
       3,     1,     1,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     0,     2,     0,     2,     0,
       3,     2,     1,     2,     1,     0,     3,     1,     0,     1,
       0,     1,     0,     3,     2,     0,     1,     2,     4,     4,
       5,     4,     2,     3,     2,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     3,     3,     3,     3,     0,     1,     3,     3,     0,
       3,     1,     3,     0,     3,     0,     3,     4,     4,     1,
       1,     0,     2,     0,     0,     0,     0,     0,    20,     0,
       3,     0,     4,     0,     0,     7,     4,     4,     3,     4,
       3,     3,     0,     3,     1,     3,     5,     1,     1,     1,
       0,     1,     1,     0,     2,     0,     0,     3,     0,     2,
       6,     3,     4,     4,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (thd, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, thd); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (thd);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, thd);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, THD *thd)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], thd);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, thd); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, THD *thd)
{
  YY_USE (yyvaluep);
  YY_USE (thd);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (THD *thd)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, thd);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* query: END_OF_INPUT  */
#line 2258 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!thd->bootstrap &&
              (!(thd->lex->lex_options & OPTION_LEX_FOUND_COMMENT)))
              my_yyabort_error((ER_EMPTY_QUERY, MYF(0)));

            thd->lex->sql_command= SQLCOM_EMPTY_QUERY;
            YYLIP->found_semicolon= NULL;
          }
#line 27428 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3: /* $@1: %empty  */
#line 2267 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_input_stream *lip = YYLIP;

            if ((thd->client_capabilities & CLIENT_MULTI_QUERIES) &&
                lip->multi_statements &&
                ! lip->eof())
            {
              /*
                We found a well formed query, and multi queries are allowed:
                - force the parser to stop after the ';'
                - mark the start of the next query for the next invocation
                  of the parser.
              */
              lip->next_state= MY_LEX_END;
              lip->found_semicolon= lip->get_ptr();
            }
            else
            {
              /* Single query, terminated. */
              lip->found_semicolon= NULL;
            }
          }
#line 27455 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 5: /* query: verb_clause END_OF_INPUT  */
#line 2292 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Single query, not terminated. */
            YYLIP->found_semicolon= NULL;
          }
#line 27464 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 70: /* deallocate: deallocate_or_drop PREPARE_SYM ident  */
#line 2374 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_deallocate_prepare((yyvsp[0].ident_sys));
          }
#line 27472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 73: /* $@2: %empty  */
#line 2386 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "PREPARE..FROM"; }
#line 27478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 74: /* prepare: PREPARE_SYM ident FROM $@2 expr  */
#line 2388 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_prepare((yyvsp[-3].ident_sys), (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 27488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 75: /* execute: EXECUTE_SYM ident execute_using  */
#line 2397 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_execute((yyvsp[-1].ident_sys), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 27497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 76: /* $@3: %empty  */
#line 2402 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE IMMEDIATE"; }
#line 27503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 77: /* $@4: %empty  */
#line 2404 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= NULL; }
#line 27509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 78: /* execute: EXECUTE_SYM IMMEDIATE_SYM $@3 expr $@4 execute_using  */
#line 2406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_execute_immediate((yyvsp[-2].item), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 27518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 79: /* execute_using: %empty  */
#line 2413 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.item_list)= NULL; }
#line 27524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 80: /* $@5: %empty  */
#line 2415 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE..USING"; }
#line 27530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 81: /* execute_using: USING $@5 execute_params  */
#line 2417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= (yyvsp[0].item_list);
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 27539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 82: /* execute_params: expr_or_ignore_or_default  */
#line 2425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 27548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 83: /* execute_params: execute_params ',' expr_or_ignore_or_default  */
#line 2430 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (((yyval.item_list)= (yyvsp[-2].item_list))->push_back((yyvsp[0].item), thd->mem_root))
              MYSQL_YYABORT;
          }
#line 27557 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 84: /* $@6: %empty  */
#line 2441 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HELP"));
          }
#line 27566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 85: /* help: HELP_SYM $@6 ident_or_text  */
#line 2446 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_HELP;
            lex->help_arg= (yyvsp[0].lex_str).str;
          }
#line 27576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 86: /* $@7: %empty  */
#line 2457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_CHANGE_MASTER;
          }
#line 27584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 87: /* change: CHANGE MASTER_SYM optional_connection_name TO_SYM $@7 master_defs  */
#line 2461 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 27590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 90: /* master_def: MASTER_HOST_SYM '=' TEXT_STRING_sys  */
#line 2471 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.host = (yyvsp[0].lex_str).str;
          }
#line 27598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 91: /* master_def: MASTER_USER_SYM '=' TEXT_STRING_sys  */
#line 2475 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.user = (yyvsp[0].lex_str).str;
          }
#line 27606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 92: /* master_def: MASTER_PASSWORD_SYM '=' TEXT_STRING_sys  */
#line 2479 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.password = (yyvsp[0].lex_str).str;
          }
#line 27614 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 93: /* master_def: MASTER_PORT_SYM '=' ulong_num  */
#line 2483 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.port = (yyvsp[0].ulong_num);
          }
#line 27622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 94: /* master_def: MASTER_CONNECT_RETRY_SYM '=' ulong_num  */
#line 2487 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.connect_retry = (yyvsp[0].ulong_num);
          }
#line 27630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 95: /* master_def: MASTER_DELAY_SYM '=' ulong_num  */
#line 2491 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].ulong_num) > MASTER_DELAY_MAX)
            {
              my_error(ER_MASTER_DELAY_VALUE_OUT_OF_RANGE, MYF(0),
                       (ulong) (yyvsp[0].ulong_num), (ulong) MASTER_DELAY_MAX);
            }
            else
              Lex->mi.sql_delay = (yyvsp[0].ulong_num);
          }
#line 27644 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 96: /* master_def: MASTER_SSL_SYM '=' ulong_num  */
#line 2501 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl= (yyvsp[0].ulong_num) ? 
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 27653 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 97: /* master_def: MASTER_SSL_CA_SYM '=' TEXT_STRING_sys  */
#line 2506 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_ca= (yyvsp[0].lex_str).str;
          }
#line 27661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 98: /* master_def: MASTER_SSL_CAPATH_SYM '=' TEXT_STRING_sys  */
#line 2510 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_capath= (yyvsp[0].lex_str).str;
          }
#line 27669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 99: /* master_def: MASTER_SSL_CERT_SYM '=' TEXT_STRING_sys  */
#line 2514 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_cert= (yyvsp[0].lex_str).str;
          }
#line 27677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 100: /* master_def: MASTER_SSL_CIPHER_SYM '=' TEXT_STRING_sys  */
#line 2518 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_cipher= (yyvsp[0].lex_str).str;
          }
#line 27685 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 101: /* master_def: MASTER_SSL_KEY_SYM '=' TEXT_STRING_sys  */
#line 2522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_key= (yyvsp[0].lex_str).str;
          }
#line 27693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 102: /* master_def: MASTER_SSL_VERIFY_SERVER_CERT_SYM '=' ulong_num  */
#line 2526 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_verify_server_cert= (yyvsp[0].ulong_num) ?
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 27702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 103: /* master_def: MASTER_SSL_CRL_SYM '=' TEXT_STRING_sys  */
#line 2531 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_crl= (yyvsp[0].lex_str).str;
          }
#line 27710 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 104: /* master_def: MASTER_SSL_CRLPATH_SYM '=' TEXT_STRING_sys  */
#line 2535 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.ssl_crlpath= (yyvsp[0].lex_str).str;
          }
#line 27718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 105: /* master_def: MASTER_HEARTBEAT_PERIOD_SYM '=' NUM_literal  */
#line 2540 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.heartbeat_period= (float) (yyvsp[0].item_num)->val_real();
            if (unlikely(Lex->mi.heartbeat_period >
                         SLAVE_MAX_HEARTBEAT_PERIOD) ||
                unlikely(Lex->mi.heartbeat_period < 0.0))
               my_yyabort_error((ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE, MYF(0),
                                 SLAVE_MAX_HEARTBEAT_PERIOD));

            if (unlikely(Lex->mi.heartbeat_period > slave_net_timeout))
            {
              push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                  ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX,
                                  ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX));
            }
            if (unlikely(Lex->mi.heartbeat_period < 0.001))
            {
              if (unlikely(Lex->mi.heartbeat_period != 0.0))
              {
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                    ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN,
                                    ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN));
                Lex->mi.heartbeat_period= 0.0;
              }
              Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_DISABLE;
            }
            Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27750 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 106: /* master_def: IGNORE_SERVER_IDS_SYM '=' '(' ignore_server_id_list ')'  */
#line 2568 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_ignore_server_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
           }
#line 27758 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 107: /* master_def: DO_DOMAIN_IDS_SYM '=' '(' do_domain_id_list ')'  */
#line 2572 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_do_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 108: /* master_def: IGNORE_DOMAIN_IDS_SYM '=' '(' ignore_domain_id_list ')'  */
#line 2576 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.repl_ignore_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 27774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 113: /* ignore_server_id: ulong_num  */
#line 2591 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_server_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 117: /* do_domain_id: ulong_num  */
#line 2604 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_do_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27790 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 121: /* ignore_domain_id: ulong_num  */
#line 2617 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 27798 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 122: /* master_file_def: MASTER_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2624 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.log_file_name = (yyvsp[0].lex_str).str;
          }
#line 27806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 123: /* master_file_def: MASTER_LOG_POS_SYM '=' ulonglong_num  */
#line 2628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* 
               If the user specified a value < BIN_LOG_HEADER_SIZE, adjust it
               instead of causing subsequent errors. 
               We need to do it in this file, because only there we know that 
               MASTER_LOG_POS has been explicitly specified. On the contrary
               in change_master() (sql_repl.cc) we cannot distinguish between 0
               (MASTER_LOG_POS explicitly specified as 0) and 0 (unspecified),
               whereas we want to distinguish (specified 0 means "read the binlog
               from 0" (4 in fact), unspecified means "don't change the position
               (keep the preceding value)").
            */
            Lex->mi.pos= MY_MAX(BIN_LOG_HEADER_SIZE, (yyvsp[0].ulonglong_number));
          }
#line 27825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 124: /* master_file_def: RELAY_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2643 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.relay_log_name = (yyvsp[0].lex_str).str;
          }
#line 27833 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 125: /* master_file_def: RELAY_LOG_POS_SYM '=' ulong_num  */
#line 2647 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.relay_log_pos = (yyvsp[0].ulong_num);
            /* Adjust if < BIN_LOG_HEADER_SIZE (same comment as Lex->mi.pos) */
            Lex->mi.relay_log_pos= MY_MAX(BIN_LOG_HEADER_SIZE, Lex->mi.relay_log_pos);
          }
#line 27843 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 126: /* master_file_def: MASTER_USE_GTID_SYM '=' CURRENT_POS_SYM  */
#line 2653 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_CURRENT_POS;
          }
#line 27853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 127: /* master_file_def: MASTER_USE_GTID_SYM '=' SLAVE_POS_SYM  */
#line 2659 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_SLAVE_POS;
          }
#line 27863 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 128: /* master_file_def: MASTER_USE_GTID_SYM '=' NO_SYM  */
#line 2665 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_NO;
          }
#line 27873 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 129: /* optional_connection_name: %empty  */
#line 2674 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
          }
#line 27882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 131: /* connection_name: TEXT_STRING_sys  */
#line 2683 "/home/buildbot/git/sql/sql_yacc.yy"
        {
           Lex->mi.connection_name= (yyvsp[0].lex_str);
#ifdef HAVE_REPLICATION
           if (unlikely(check_master_connection_name(&(yyvsp[0].lex_str))))
              my_yyabort_error((ER_WRONG_ARGUMENTS, MYF(0), "MASTER_CONNECTION_NAME"));
#endif
         }
#line 27894 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 132: /* $@8: %empty  */
#line 2696 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_table()))
              MYSQL_YYABORT;
            lex->create_info.init();
            if (lex->main_select_push())
              MYSQL_YYABORT;
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
            if (lex->set_command_with_check(SQLCOM_CREATE_TABLE, (yyvsp[-2].num), (yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
               MYSQL_YYABORT;
          }
#line 27910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 133: /* $@9: %empty  */
#line 2708 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            if (!lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                    TL_WRITE, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            lex->alter_info.reset();
            /*
              For CREATE TABLE we should not open the table even if it exists.
              If the table exists, we should either not create it or replace it
            */
            lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
            lex->create_info.default_table_charset= NULL;
            lex->name= null_clex_str;
            lex->create_last_non_select_table= lex->last_table();
            lex->inc_select_stack_outer_barrier();
          }
#line 27932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 134: /* create: create_or_replace opt_temporary TABLE_SYM opt_if_not_exists $@8 table_ident $@9 create_body  */
#line 2726 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 27942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 135: /* $@10: %empty  */
#line 2732 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           LEX *lex= thd->lex;
           if (lex->main_select_push())
             MYSQL_YYABORT;
           if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_sequence()))
              MYSQL_YYABORT;
           lex->create_info.init();
           if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_SEQUENCE, (yyvsp[-3].num),
                        (yyvsp[-4].object_ddl_options) | (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;

           if (!lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                   TL_WRITE, MDL_EXCLUSIVE))
             MYSQL_YYABORT;

               /*
                 For CREATE TABLE, an non-existing table is not an error.
                 Instruct open_tables() to just take an MDL lock if the
                 table does not exist.
               */
             lex->alter_info.reset();
             lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
             lex->name= null_clex_str;
             lex->create_last_non_select_table= lex->last_table();
             if (unlikely(!(lex->create_info.seq_create_info=
                            new (thd->mem_root) sequence_definition())))
               MYSQL_YYABORT;
         }
#line 27976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 136: /* create: create_or_replace opt_temporary SEQUENCE_SYM opt_if_not_exists table_ident $@10 opt_sequence opt_create_table_options  */
#line 2762 "/home/buildbot/git/sql/sql_yacc.yy"
         {
            LEX *lex= thd->lex;

            if (unlikely(lex->create_info.seq_create_info->check_and_adjust(1)))
            {
              my_error(ER_SEQUENCE_INVALID_DATA, MYF(0),
                       lex->first_select_lex()->table_list.first->db.str,
                       lex->first_select_lex()->table_list.first->
                         table_name.str);
              MYSQL_YYABORT;
            }

            /* No fields specified, generate them */
            if (unlikely(prepare_sequence_fields(thd,
                         &lex->alter_info.create_list)))
               MYSQL_YYABORT;

            /* CREATE SEQUENCE always creates a sequence */
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= 1;

            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 28005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 137: /* $@11: %empty  */
#line 2787 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28014 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 138: /* $@12: %empty  */
#line 2794 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-7].key_type), &(yyvsp[-3].ident_sys), (yyvsp[-2].key_alg), (yyvsp[-8].object_ddl_options) | (yyvsp[-5].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28025 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 139: /* create: create_or_replace opt_unique INDEX_SYM opt_if_not_exists $@11 ident opt_key_algorithm_clause ON table_ident $@12 '(' key_list ')' opt_lock_wait_timeout normal_key_options opt_index_lock_algorithm  */
#line 2802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 140: /* $@13: %empty  */
#line 2806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 141: /* $@14: %empty  */
#line 2812 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 142: /* create: create_or_replace fulltext INDEX_SYM $@13 opt_if_not_exists ident ON table_ident $@14 '(' key_list ')' opt_lock_wait_timeout fulltext_key_options opt_index_lock_algorithm  */
#line 2820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 143: /* $@15: %empty  */
#line 2824 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 28070 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 144: /* $@16: %empty  */
#line 2830 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28081 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 145: /* create: create_or_replace spatial INDEX_SYM $@15 opt_if_not_exists ident ON table_ident $@16 '(' key_list ')' opt_lock_wait_timeout spatial_key_options opt_index_lock_algorithm  */
#line 2838 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 146: /* $@17: %empty  */
#line 2842 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
          }
#line 28098 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 147: /* create: create_or_replace DATABASE opt_if_not_exists ident $@17 opt_create_database_options  */
#line 2847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_DB, 0,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
               MYSQL_YYABORT;
            lex->name= (yyvsp[-2].ident_sys);
          }
#line 28110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 148: /* $@18: %empty  */
#line 2856 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
            if (Lex->add_create_view(thd, (yyvsp[-5].object_ddl_options) | (yyvsp[-1].object_ddl_options),
                                     DTYPE_ALGORITHM_UNDEFINED, (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 28123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 149: /* create: create_or_replace definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@18 view_list_opt AS view_select  */
#line 2865 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 150: /* $@19: %empty  */
#line 2870 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_view(thd, (yyvsp[-6].object_ddl_options) | (yyvsp[-1].object_ddl_options), (yyvsp[-5].num), (yyvsp[-3].view_suid), (yyvsp[0].table))))
              MYSQL_YYABORT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
          }
#line 28143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 151: /* create: create_or_replace view_algorithm definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@19 view_list_opt AS view_select  */
#line 2878 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28151 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 152: /* $@20: %empty  */
#line 2882 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 28161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 153: /* create: create_or_replace definer_opt TRIGGER_SYM $@20 trigger_tail  */
#line 2888 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 154: /* $@21: %empty  */
#line 2892 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_procedure_start((yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 28178 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 155: /* create: create_or_replace definer_opt PROCEDURE_SYM opt_if_not_exists $@21 sp_tail  */
#line 2897 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 156: /* $@22: %empty  */
#line 2901 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 28196 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 157: /* create: create_or_replace definer_opt EVENT_SYM $@22 event_tail  */
#line 2907 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 28204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 158: /* $@23: %empty  */
#line 2912 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 28213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 159: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@23 sp_fdparam_list ')' sf_return_type sf_c_chistics_and_body  */
#line 2919 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28221 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 160: /* $@24: %empty  */
#line 2924 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 28230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 161: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@24 sp_fdparam_list ')' sf_return_type sf_c_chistics_and_body  */
#line 2931 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 28238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 162: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists ident RETURNS_SYM udf_type SONAME_SYM TEXT_STRING_sys  */
#line 2936 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_create_udf_function((yyvsp[-9].object_ddl_options) | (yyvsp[-5].object_ddl_options), (yyvsp[-7].sp_aggregate_type), (yyvsp[-4].ident_sys),
                                              (Item_result) (yyvsp[-2].num), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 28248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 163: /* create: create_or_replace USER_SYM opt_if_not_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 2943 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_USER,
                                                     (yyvsp[-7].object_ddl_options) | (yyvsp[-5].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 28258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 164: /* create: create_or_replace ROLE_SYM opt_if_not_exists clear_privileges role_list opt_with_admin  */
#line 2950 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_ROLE,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 28268 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 165: /* create: CREATE LOGFILE_SYM GROUP_SYM logfile_group_info  */
#line 2956 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_LOGFILE_GROUP;
          }
#line 28276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 166: /* create: CREATE TABLESPACE tablespace_info  */
#line 2960 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_TABLESPACE;
          }
#line 28284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 167: /* $@25: %empty  */
#line 2963 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->set_command(SQLCOM_CREATE_SERVER, (yyvsp[0].object_ddl_options)); }
#line 28290 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 168: /* create: create_or_replace $@25 server_def  */
#line 2965 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 28296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 169: /* opt_sequence: %empty  */
#line 2969 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 28302 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 173: /* sequence_def: MINVALUE_SYM opt_equal longlong_num  */
#line 2980 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.seq_create_info->min_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28311 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 174: /* sequence_def: NO_SYM MINVALUE_SYM  */
#line 2985 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 175: /* sequence_def: NOMINVALUE_SYM  */
#line 2991 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 28331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 176: /* sequence_def: MAXVALUE_SYM opt_equal longlong_num  */
#line 2997 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           if (unlikely(Lex->create_info.seq_create_info->used_fields &
               seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->max_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 177: /* sequence_def: NO_SYM MAXVALUE_SYM  */
#line 3005 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28353 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 178: /* sequence_def: NOMAXVALUE_SYM  */
#line 3011 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 28363 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 179: /* sequence_def: START_SYM opt_with longlong_num  */
#line 3017 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_start))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "START"));
            Lex->create_info.seq_create_info->start= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_start;
          }
#line 28375 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 180: /* sequence_def: INCREMENT_SYM opt_by longlong_num  */
#line 3025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_increment))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "INCREMENT"));
            Lex->create_info.seq_create_info->increment= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_increment;
          }
#line 28387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 181: /* sequence_def: CACHE_SYM opt_equal longlong_num  */
#line 3033 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 28399 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 182: /* sequence_def: NOCACHE_SYM  */
#line 3041 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 28411 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 183: /* sequence_def: CYCLE_SYM  */
#line 3049 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 1;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 28423 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 184: /* sequence_def: NOCYCLE_SYM  */
#line 3057 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 28435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 185: /* sequence_def: RESTART_SYM  */
#line 3065 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              MYSQL_YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart;
          }
#line 28451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 186: /* sequence_def: RESTART_SYM opt_with longlong_num  */
#line 3077 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              MYSQL_YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->restart= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart | seq_field_used_restart_value;
          }
#line 28468 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 187: /* force_lookahead: %empty  */
#line 3092 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 28474 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 188: /* force_lookahead: FORCE_LOOKAHEAD  */
#line 3092 "/home/buildbot/git/sql/sql_yacc.yy"
                                      {}
#line 28480 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 189: /* $@26: %empty  */
#line 3096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 28490 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 190: /* server_def: SERVER_SYM opt_if_not_exists ident_or_text $@26 FOREIGN DATA_SYM WRAPPER_SYM ident_or_text OPTIONS_SYM '(' server_options_list ')'  */
#line 3103 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->server_options.scheme= (yyvsp[-4].lex_str); }
#line 28496 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 193: /* server_option: USER_SYM TEXT_STRING_sys  */
#line 3113 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.username.str == 0);
            Lex->server_options.username= (yyvsp[0].lex_str);
          }
#line 28505 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 194: /* server_option: HOST_SYM TEXT_STRING_sys  */
#line 3118 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.host.str == 0);
            Lex->server_options.host= (yyvsp[0].lex_str);
          }
#line 28514 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 195: /* server_option: DATABASE TEXT_STRING_sys  */
#line 3123 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.db.str == 0);
            Lex->server_options.db= (yyvsp[0].lex_str);
          }
#line 28523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 196: /* server_option: OWNER_SYM TEXT_STRING_sys  */
#line 3128 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.owner.str == 0);
            Lex->server_options.owner= (yyvsp[0].lex_str);
          }
#line 28532 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 197: /* server_option: PASSWORD_SYM TEXT_STRING_sys  */
#line 3133 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.password.str == 0);
            Lex->server_options.password= (yyvsp[0].lex_str);
          }
#line 28541 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 198: /* server_option: SOCKET_SYM TEXT_STRING_sys  */
#line 3138 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.socket.str == 0);
            Lex->server_options.socket= (yyvsp[0].lex_str);
          }
#line 28550 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 199: /* server_option: PORT_SYM ulong_num  */
#line 3143 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->server_options.port= (yyvsp[0].ulong_num);
          }
#line 28558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 200: /* $@27: %empty  */
#line 3150 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->stmt_definition_begin= (yyvsp[-2].simple_string);
            if (unlikely(lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            if (unlikely(!(lex->event_parse_data=
                           Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            lex->event_parse_data->identifier= (yyvsp[0].spname);
            lex->event_parse_data->on_completion=
                                  Event_parse_data::ON_COMPLETION_DROP;

            lex->sql_command= SQLCOM_CREATE_EVENT;
            /* We need that for disallowing subqueries */
          }
#line 28579 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 201: /* event_tail: remember_name opt_if_not_exists sp_name $@27 ON SCHEDULE_SYM ev_schedule_time opt_ev_on_completion opt_ev_status opt_ev_comment DO_SYM ev_sql_stmt  */
#line 3171 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_CREATE_EVENT;
          }
#line 28591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 202: /* $@28: %empty  */
#line 3182 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_expression= (yyvsp[-1].item);
            Lex->event_parse_data->interval= (yyvsp[0].interval);
          }
#line 28600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 204: /* ev_schedule_time: AT_SYM expr  */
#line 3189 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_execute_at= (yyvsp[0].item);
          }
#line 28608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 205: /* opt_ev_status: %empty  */
#line 3195 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28614 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 206: /* opt_ev_status: ENABLE_SYM  */
#line 3197 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::ENABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 28624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 207: /* opt_ev_status: DISABLE_SYM ON SLAVE  */
#line 3203 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::SLAVESIDE_DISABLED;
            Lex->event_parse_data->status_changed= true; 
            (yyval.num)= 1;
          }
#line 28634 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 208: /* opt_ev_status: DISABLE_SYM  */
#line 3209 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::DISABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 28644 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 209: /* ev_starts: %empty  */
#line 3218 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, 0);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->event_parse_data->item_starts= item;
          }
#line 28655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 210: /* ev_starts: STARTS_SYM expr  */
#line 3225 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_starts= (yyvsp[0].item);
          }
#line 28663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 212: /* ev_ends: ENDS_SYM expr  */
#line 3233 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->item_ends= (yyvsp[0].item);
          }
#line 28671 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 213: /* opt_ev_on_completion: %empty  */
#line 3239 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 215: /* ev_on_completion: ON COMPLETION_SYM opt_not PRESERVE_SYM  */
#line 3245 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->event_parse_data->on_completion= (yyvsp[-1].num)
                                    ? Event_parse_data::ON_COMPLETION_DROP
                                    : Event_parse_data::ON_COMPLETION_PRESERVE;
            (yyval.num)= 1;
          }
#line 28688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 216: /* opt_ev_comment: %empty  */
#line 3254 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 28694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 217: /* opt_ev_comment: COMMENT_SYM TEXT_STRING_sys  */
#line 3256 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->comment= Lex->event_parse_data->comment= (yyvsp[0].lex_str);
            (yyval.num)= 1;
          }
#line 28703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 218: /* $@29: %empty  */
#line 3263 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            /*
              This stops the following :
              - CREATE EVENT ... DO CREATE EVENT ...;
              - ALTER  EVENT ... DO CREATE EVENT ...;
              - CREATE EVENT ... DO ALTER EVENT DO ....;
              - CREATE PROCEDURE ... BEGIN CREATE EVENT ... END|
              This allows:
              - CREATE EVENT ... DO DROP EVENT yyy;
              - CREATE EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO DROP EVENT yyy;
              - CREATE PROCEDURE ... BEGIN ALTER EVENT ... END|
                (the nested ALTER EVENT can have anything but DO clause)
              - CREATE PROCEDURE ... BEGIN DROP EVENT ... END|
            */
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_EVENT_RECURSION_FORBIDDEN, MYF(0)));
              
            if (unlikely(!lex->make_sp_head(thd,
                                            lex->event_parse_data->identifier,
                                            &sp_handler_procedure,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_ptr());
          }
#line 28740 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 219: /* ev_sql_stmt: $@29 sp_proc_stmt force_lookahead  */
#line 3296 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* return back to the original memory root ASAP */
            if (Lex->sp_body_finalize_event(thd))
              MYSQL_YYABORT;
          }
#line 28750 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 220: /* clear_privileges: %empty  */
#line 3305 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           LEX *lex=Lex;
           lex->users_list.empty();
           lex->columns.empty();
           lex->grant= lex->grant_tot_col= 0;
           lex->all_privileges= 0;
           lex->first_select_lex()->db= null_clex_str;
           lex->account_options.reset();
         }
#line 28764 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 221: /* opt_aggregate: %empty  */
#line 3317 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.sp_aggregate_type)= NOT_AGGREGATE; }
#line 28770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 222: /* opt_aggregate: AGGREGATE_SYM  */
#line 3318 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.sp_aggregate_type)= GROUP_AGGREGATE; }
#line 28776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 223: /* sp_name: ident '.' ident  */
#line 3323 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28785 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 224: /* sp_name: ident  */
#line 3328 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 225: /* sp_a_chistics: %empty  */
#line 3335 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 28800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 226: /* sp_a_chistics: sp_a_chistics sp_chistic  */
#line 3336 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 28806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 227: /* sp_c_chistics: %empty  */
#line 3340 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 28812 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 228: /* sp_c_chistics: sp_c_chistics sp_c_chistic  */
#line 3341 "/home/buildbot/git/sql/sql_yacc.yy"
                                     {}
#line 28818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 229: /* sp_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3347 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 28824 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 230: /* sp_chistic: LANGUAGE_SYM SQL_SYM  */
#line 3349 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* Just parse it, we only have one language for now. */ }
#line 28830 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 231: /* sp_chistic: NO_SYM SQL_SYM  */
#line 3351 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_NO_SQL; }
#line 28836 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 232: /* sp_chistic: CONTAINS_SYM SQL_SYM  */
#line 3353 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_CONTAINS_SQL; }
#line 28842 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 233: /* sp_chistic: READS_SYM SQL_SYM DATA_SYM  */
#line 3355 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_READS_SQL_DATA; }
#line 28848 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 234: /* sp_chistic: MODIFIES_SYM SQL_SYM DATA_SYM  */
#line 3357 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.daccess= SP_MODIFIES_SQL_DATA; }
#line 28854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 235: /* sp_chistic: sp_suid  */
#line 3359 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 28860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 236: /* sp_c_chistic: sp_chistic  */
#line 3364 "/home/buildbot/git/sql/sql_yacc.yy"
                                { }
#line 28866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 237: /* sp_c_chistic: opt_not DETERMINISTIC_SYM  */
#line 3365 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { Lex->sp_chistics.detistic= ! (yyvsp[-1].num); }
#line 28872 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 238: /* sp_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 3369 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.sp_suid)= SP_IS_SUID; }
#line 28878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 239: /* sp_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 3370 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.sp_suid)= SP_IS_NOT_SUID; }
#line 28884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 240: /* $@30: %empty  */
#line 3375 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28893 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 241: /* call: CALL_SYM ident $@30 opt_sp_cparam_list  */
#line 3380 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 242: /* $@31: %empty  */
#line 3385 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 243: /* call: CALL_SYM ident '.' ident $@31 opt_sp_cparam_list  */
#line 3390 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 244: /* $@32: %empty  */
#line 3395 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28929 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 245: /* call: CALL_SYM ident '.' ident '.' ident $@32 opt_sp_cparam_list  */
#line 3400 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28938 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 250: /* sp_cparams: sp_cparams ',' expr  */
#line 3419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
           Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 28946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 251: /* sp_cparams: expr  */
#line 3423 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 28954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 252: /* sp_fdparam_list: %empty  */
#line 3431 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
            Lex->sphead->m_param_end= Lex->sphead->m_param_begin;
          }
#line 28963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 253: /* $@33: %empty  */
#line 3436 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
          }
#line 28971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 254: /* sp_fdparam_list: $@33 sp_fdparams  */
#line 3440 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 28979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 257: /* sp_param_name: ident  */
#line 3452 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.spvar)= Lex->sp_param_init(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 258: /* sp_param_name_and_type: sp_param_name field_type  */
#line 3460 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_param_fill_definition((yyval.spvar)= (yyvsp[-1].spvar))))
              MYSQL_YYABORT;
          }
#line 28997 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 259: /* sp_param_name_and_type: sp_param_name TYPE_SYM OF_SYM ident '.' ident  */
#line 3465 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd,
                                                                (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-2].ident_sys),
                                                                (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 260: /* sp_param_name_and_type: sp_param_name TYPE_SYM OF_SYM ident '.' ident '.' ident  */
#line 3472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-7].spvar),
                                                                (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 261: /* sp_param_name_and_type: sp_param_name ROW_SYM TYPE_SYM OF_SYM ident  */
#line 3478 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-4].spvar), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 262: /* sp_param_name_and_type: sp_param_name ROW_SYM TYPE_SYM OF_SYM ident '.' ident  */
#line 3483 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-6].spvar), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 263: /* sp_param_name_and_type: sp_param_name ROW_SYM row_type_body  */
#line 3488 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyval.spvar)= (yyvsp[-2].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 29045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 268: /* sp_pdparam: sp_opt_inout sp_param_name_and_type  */
#line 3506 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { (yyvsp[0].spvar)->mode=(yyvsp[-1].spvar_mode); }
#line 29051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 269: /* sp_opt_inout: %empty  */
#line 3510 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 29057 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 270: /* sp_opt_inout: IN_SYM  */
#line 3511 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 29063 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 271: /* sp_opt_inout: OUT_SYM  */
#line 3512 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_OUT; }
#line 29069 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 272: /* sp_opt_inout: INOUT_SYM  */
#line 3513 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 29075 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 273: /* $@34: %empty  */
#line 3518 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start() + 1;
          }
#line 29083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 274: /* sp_parenthesized_pdparam_list: '(' $@34 sp_pdparam_list ')'  */
#line 3523 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 29091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 275: /* sp_proc_stmts: %empty  */
#line 3529 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 29097 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 277: /* sp_proc_stmts1: sp_proc_stmt ';'  */
#line 3534 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 29103 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 279: /* sp_decls: %empty  */
#line 3540 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spblock).init();
          }
#line 29111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 280: /* sp_decls: sp_decls sp_decl ';'  */
#line 3544 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* We check for declarations out of (standard) order this way
              because letting the grammar rules reflect it caused tricky
               shift/reduce conflicts with the wrong result. (And we get
               better error handling this way.) */
            if (unlikely(Lex->sp_declarations_join(&(yyval.spblock), (yyvsp[-2].spblock), (yyvsp[-1].spblock))))
              MYSQL_YYABORT;
          }
#line 29124 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 281: /* sp_decl: DECLARE_MARIADB_SYM sp_decl_body  */
#line 3555 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.spblock)= (yyvsp[0].spblock); }
#line 29130 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 282: /* optionally_qualified_column_ident: sp_decl_ident  */
#line 3561 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                         Qualified_column_ident(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29140 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 283: /* optionally_qualified_column_ident: sp_decl_ident '.' ident  */
#line 3567 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29150 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 284: /* optionally_qualified_column_ident: sp_decl_ident '.' ident '.' ident  */
#line 3573 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 29160 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 285: /* row_field_name: ident  */
#line 3582 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.spvar_definition)= Lex->row_field_name(thd, (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 287: /* row_field_definition_list: row_field_definition  */
#line 3594 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.spvar_definition_list)= Row_definition_list::make(thd->mem_root, (yyvsp[0].spvar_definition))))
              MYSQL_YYABORT;
          }
#line 29178 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 288: /* row_field_definition_list: row_field_definition_list ',' row_field_definition  */
#line 3599 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (((yyval.spvar_definition_list)= (yyvsp[-2].spvar_definition_list))->append_uniq(thd->mem_root, (yyvsp[0].spvar_definition)))
              MYSQL_YYABORT;
          }
#line 29187 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 289: /* row_type_body: '(' row_field_definition_list ')'  */
#line 3606 "/home/buildbot/git/sql/sql_yacc.yy"
                                            { (yyval.spvar_definition_list)= (yyvsp[-1].spvar_definition_list); }
#line 29193 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 290: /* sp_decl_idents_init_vars: sp_decl_idents  */
#line 3611 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_variable_declarations_init(thd, (yyvsp[0].num));
          }
#line 29201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 291: /* sp_decl_variable_list: sp_decl_idents_init_vars field_type sp_opt_default  */
#line 3620 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_finalize(thd, (yyvsp[-2].num),
                                                                &Lex->last_field[0],
                                                                (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-2].num));
          }
#line 29213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 292: /* sp_decl_variable_list: sp_decl_idents_init_vars TYPE_SYM OF_SYM optionally_qualified_column_ident sp_opt_default  */
#line 3630 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_with_ref_finalize(thd, (yyvsp[-4].num), (yyvsp[-1].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 29223 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 293: /* sp_decl_variable_list: sp_decl_idents_init_vars ROW_SYM TYPE_SYM OF_SYM optionally_qualified_column_ident sp_opt_default  */
#line 3638 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_rowtype_finalize(thd, (yyvsp[-5].num), (yyvsp[-1].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-5].num));
          }
#line 29233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 294: /* sp_decl_variable_list: sp_decl_idents_init_vars ROW_SYM row_type_body sp_opt_default  */
#line 3646 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_row_finalize(thd, (yyvsp[-3].num), (yyvsp[-1].spvar_definition_list), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-3].num));
          }
#line 29243 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 296: /* sp_decl_body: sp_decl_ident CONDITION_SYM FOR_SYM sp_cond  */
#line 3656 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-3].ident_sys), (yyvsp[0].spcondvalue))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 29254 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 298: /* $@35: %empty  */
#line 3664 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 29262 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 299: /* sp_decl_body: sp_decl_ident CURSOR_SYM $@35 opt_parenthesized_cursor_formal_parameters FOR_SYM sp_cursor_stmt  */
#line 3669 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            sp_pcontext *param_ctx= Lex->spcont;
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_declare_cursor(thd, &(yyvsp[-5].ident_sys), (yyvsp[0].sp_cursor_stmt), param_ctx, true)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).hndlrs= 0;
            (yyval.spblock).curs= 1;
          }
#line 29276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 300: /* $@36: %empty  */
#line 3682 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, (yyvsp[-2].num))))
              MYSQL_YYABORT;
          }
#line 29285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 301: /* sp_decl_handler: sp_handler_type HANDLER_SYM FOR_SYM $@36 sp_hcond_list sp_proc_stmt  */
#line 3687 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, (yyvsp[-5].num))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).curs= 0;
            (yyval.spblock).hndlrs= 1;
          }
#line 29296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 304: /* sp_cursor_stmt_lex: %empty  */
#line 3702 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->lex->sphead);
            if (unlikely(!((yyval.sp_cursor_stmt)= new (thd->mem_root)
                           sp_lex_cursor(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 29307 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 305: /* $@37: %empty  */
#line 3712 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].sp_cursor_stmt));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29318 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 306: /* sp_cursor_stmt: sp_cursor_stmt_lex $@37 select  */
#line 3719 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex == (yyvsp[-2].sp_cursor_stmt));
            Lex->pop_select(); //main select
            if (unlikely((yyvsp[-2].sp_cursor_stmt)->stmt_finalize(thd)) ||
                unlikely((yyvsp[-2].sp_cursor_stmt)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            (yyval.sp_cursor_stmt)= (yyvsp[-2].sp_cursor_stmt);
          }
#line 29331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 307: /* sp_handler_type: EXIT_MARIADB_SYM  */
#line 3730 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= sp_handler::EXIT; }
#line 29337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 308: /* sp_handler_type: CONTINUE_MARIADB_SYM  */
#line 3731 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= sp_handler::CONTINUE; }
#line 29343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 309: /* sp_handler_type: EXIT_ORACLE_SYM  */
#line 3732 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.num)= sp_handler::EXIT; }
#line 29349 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 310: /* sp_handler_type: CONTINUE_ORACLE_SYM  */
#line 3733 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.num)= sp_handler::CONTINUE; }
#line 29355 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 311: /* sp_hcond_list: sp_hcond_element  */
#line 3739 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 1; }
#line 29361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 312: /* sp_hcond_list: sp_hcond_list ',' sp_hcond_element  */
#line 3741 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)+= 1; }
#line 29367 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 313: /* sp_hcond_element: sp_hcond  */
#line 3746 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont->parent_context();

            if (unlikely(ctx->check_duplicate_handler((yyvsp[0].spcondvalue))))
              my_yyabort_error((ER_SP_DUP_HANDLER, MYF(0)));

            sp_instr_hpush_jump *i= (sp_instr_hpush_jump *)sp->last_instruction();
            i->add_condition((yyvsp[0].spcondvalue));
          }
#line 29383 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 314: /* sp_cond: ulong_num  */
#line 3761 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* mysql errno */
            if (unlikely((yyvsp[0].ulong_num) == 0))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "CONDITION", "0"));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].ulong_num));
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 316: /* sqlstate: SQLSTATE_SYM opt_value TEXT_STRING_literal  */
#line 3773 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* SQLSTATE */

            /*
              An error is triggered:
                - if the specified string is not a valid SQLSTATE,
                - or if it represents the completion condition -- it is not
                  allowed to SIGNAL, or declare a handler for the completion
                  condition.
            */
            if (unlikely(!is_sqlstate_valid(&(yyvsp[0].lex_str)) ||
                         is_sqlstate_completion((yyvsp[0].lex_str).str)))
              my_yyabort_error((ER_SP_BAD_SQLSTATE, MYF(0), (yyvsp[0].lex_str).str));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].lex_str).str);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29416 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 317: /* opt_value: %empty  */
#line 3792 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 29422 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 318: /* opt_value: VALUE_SYM  */
#line 3793 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 29428 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 319: /* sp_hcond: sp_cond  */
#line 3798 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= (yyvsp[0].spcondvalue);
          }
#line 29436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 320: /* sp_hcond: ident  */
#line 3802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= Lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely((yyval.spcondvalue) == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 29446 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 321: /* sp_hcond: SQLWARNING_SYM  */
#line 3808 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::WARNING);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29456 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 322: /* sp_hcond: not FOUND_SYM  */
#line 3814 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::NOT_FOUND);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29466 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 323: /* sp_hcond: SQLEXCEPTION_SYM  */
#line 3820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29476 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 324: /* sp_hcond: OTHERS_ORACLE_SYM  */
#line 3826 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 29486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 325: /* raise_stmt_oracle: RAISE_ORACLE_SYM opt_set_signal_information  */
#line 3836 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29495 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 326: /* raise_stmt_oracle: RAISE_ORACLE_SYM signal_value opt_set_signal_information  */
#line 3841 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 29504 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 327: /* signal_stmt: SIGNAL_SYM signal_value opt_set_signal_information  */
#line 3849 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue)))
              MYSQL_YYABORT;
          }
#line 29513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 328: /* signal_value: ident  */
#line 3857 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_condition_value *cond;

            /* SIGNAL foo cannot be used outside of stored programs */
            if (unlikely(lex->spcont == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            cond= lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely(cond == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            if (unlikely(cond->type != sp_condition_value::SQLSTATE))
              my_yyabort_error((ER_SIGNAL_BAD_CONDITION_TYPE, MYF(0)));
            (yyval.spcondvalue)= cond;
          }
#line 29532 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 329: /* signal_value: sqlstate  */
#line 3872 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 29538 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 330: /* opt_signal_value: %empty  */
#line 3877 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= NULL; }
#line 29544 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 331: /* opt_signal_value: signal_value  */
#line 3879 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 29550 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 332: /* opt_set_signal_information: %empty  */
#line 3884 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->m_parser_state->m_yacc.m_set_signal_info.clear();
          }
#line 29558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 334: /* signal_information_item_list: signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3892 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            info->clear();
            info->m_item[index]= (yyvsp[0].item);
          }
#line 29570 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 335: /* signal_information_item_list: signal_information_item_list ',' signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3901 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            if (unlikely(info->m_item[index] != NULL))
              my_yyabort_error((ER_DUP_SIGNAL_SET, MYF(0),
                                Diag_condition_item_names[index].str));
            info->m_item[index]= (yyvsp[0].item);
          }
#line 29584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 336: /* signal_allowed_expr: literal  */
#line 3917 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 337: /* signal_allowed_expr: variable  */
#line 3919 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].item)->type() == Item::FUNC_ITEM)
            {
              Item_func *item= (Item_func*) (yyvsp[0].item);
              if (unlikely(item->functype() == Item_func::SUSERVAR_FUNC))
              {
                /*
                  Don't allow the following syntax:
                    SIGNAL/RESIGNAL ...
                    SET <signal condition item name> = @foo := expr
                */
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            (yyval.item)= (yyvsp[0].item);
          }
#line 29612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 338: /* signal_allowed_expr: simple_ident  */
#line 3937 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 339: /* signal_condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3943 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CLASS_ORIGIN; }
#line 29624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 340: /* signal_condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3945 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_SUBCLASS_ORIGIN; }
#line 29630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 341: /* signal_condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3947 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_CATALOG; }
#line 29636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 342: /* signal_condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3949 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_SCHEMA; }
#line 29642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 343: /* signal_condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3951 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_NAME; }
#line 29648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 344: /* signal_condition_information_item_name: CATALOG_NAME_SYM  */
#line 3953 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CATALOG_NAME; }
#line 29654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 345: /* signal_condition_information_item_name: SCHEMA_NAME_SYM  */
#line 3955 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_SCHEMA_NAME; }
#line 29660 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 346: /* signal_condition_information_item_name: TABLE_NAME_SYM  */
#line 3957 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_TABLE_NAME; }
#line 29666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 347: /* signal_condition_information_item_name: COLUMN_NAME_SYM  */
#line 3959 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_COLUMN_NAME; }
#line 29672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 348: /* signal_condition_information_item_name: CURSOR_NAME_SYM  */
#line 3961 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_CURSOR_NAME; }
#line 29678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 349: /* signal_condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 3963 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_MESSAGE_TEXT; }
#line 29684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 350: /* signal_condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 3965 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_condition_item_name)= DIAG_MYSQL_ERRNO; }
#line 29690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 351: /* resignal_stmt: RESIGNAL_SYM opt_signal_value opt_set_signal_information  */
#line 3970 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 29699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 352: /* get_diagnostics: GET_SYM which_area DIAGNOSTICS_SYM diagnostics_information  */
#line 3978 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Diagnostics_information *info= (yyvsp[0].diag_info);

            info->set_which_da((yyvsp[-2].diag_area));

            Lex->sql_command= SQLCOM_GET_DIAGNOSTICS;
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_get_diagnostics(info);

            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 29715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 353: /* which_area: %empty  */
#line 3993 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 354: /* which_area: CURRENT_SYM  */
#line 3995 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 355: /* diagnostics_information: statement_information  */
#line 4000 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Statement_information((yyvsp[0].stmt_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 356: /* diagnostics_information: CONDITION_SYM condition_number condition_information  */
#line 4006 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Condition_information((yyvsp[-1].item), (yyvsp[0].cond_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 357: /* statement_information: statement_information_item  */
#line 4015 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.stmt_info_list)= new (thd->mem_root) List<Statement_information_item>;
            if (unlikely((yyval.stmt_info_list) == NULL) ||
                unlikely((yyval.stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29758 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 358: /* statement_information: statement_information ',' statement_information_item  */
#line 4022 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.stmt_info_list)= (yyvsp[-2].stmt_info_list);
          }
#line 29768 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 359: /* statement_information_item: simple_target_specification '=' statement_information_item_name  */
#line 4031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.stmt_info_item)= new (thd->mem_root) Statement_information_item((yyvsp[0].stmt_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.stmt_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 360: /* simple_target_specification: ident_cli  */
#line 4040 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= thd->lex->create_item_for_sp_var(&(yyvsp[0].ident_cli), NULL))))
              MYSQL_YYABORT;
          }
#line 29787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 361: /* simple_target_specification: '@' ident_or_text  */
#line 4045 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 29797 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 362: /* statement_information_item_name: NUMBER_MARIADB_SYM  */
#line 4054 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 363: /* statement_information_item_name: NUMBER_ORACLE_SYM  */
#line 4056 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29809 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 364: /* statement_information_item_name: ROW_COUNT_SYM  */
#line 4058 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::ROW_COUNT; }
#line 29815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 365: /* condition_number: signal_allowed_expr  */
#line 4067 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29821 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 366: /* condition_information: condition_information_item  */
#line 4072 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.cond_info_list)= new (thd->mem_root) List<Condition_information_item>;
            if (unlikely((yyval.cond_info_list) == NULL) ||
                unlikely((yyval.cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29832 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 367: /* condition_information: condition_information ',' condition_information_item  */
#line 4079 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.cond_info_list)= (yyvsp[-2].cond_info_list);
          }
#line 29842 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 368: /* condition_information_item: simple_target_specification '=' condition_information_item_name  */
#line 4088 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.cond_info_item)= new (thd->mem_root) Condition_information_item((yyvsp[0].cond_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.cond_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29852 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 369: /* condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 4097 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CLASS_ORIGIN; }
#line 29858 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 370: /* condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 4099 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SUBCLASS_ORIGIN; }
#line 29864 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 371: /* condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 4101 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_CATALOG; }
#line 29870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 372: /* condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 4103 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_SCHEMA; }
#line 29876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 373: /* condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 4105 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_NAME; }
#line 29882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 374: /* condition_information_item_name: CATALOG_NAME_SYM  */
#line 4107 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CATALOG_NAME; }
#line 29888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 375: /* condition_information_item_name: SCHEMA_NAME_SYM  */
#line 4109 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SCHEMA_NAME; }
#line 29894 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 376: /* condition_information_item_name: TABLE_NAME_SYM  */
#line 4111 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::TABLE_NAME; }
#line 29900 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 377: /* condition_information_item_name: COLUMN_NAME_SYM  */
#line 4113 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::COLUMN_NAME; }
#line 29906 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 378: /* condition_information_item_name: CURSOR_NAME_SYM  */
#line 4115 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CURSOR_NAME; }
#line 29912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 379: /* condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 4117 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MESSAGE_TEXT; }
#line 29918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 380: /* condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 4119 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MYSQL_ERRNO; }
#line 29924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 381: /* condition_information_item_name: RETURNED_SQLSTATE_SYM  */
#line 4121 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::RETURNED_SQLSTATE; }
#line 29930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 383: /* sp_decl_ident: keyword_sp_decl  */
#line 4127 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_ident_cli(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 29939 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 384: /* sp_decl_idents: sp_decl_ident  */
#line 4135 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= 1;
          }
#line 29955 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 385: /* sp_decl_idents: sp_decl_idents ',' ident  */
#line 4147 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= (yyvsp[-2].num) + 1;
          }
#line 29971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 386: /* sp_opt_default: %empty  */
#line 4161 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item) = NULL; }
#line 29977 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 387: /* sp_opt_default: DEFAULT expr  */
#line 4162 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 29983 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 407: /* $@38: %empty  */
#line 4204 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sphead->new_cont_backpatch(NULL);
          }
#line 29993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 408: /* sp_proc_stmt_if: IF_SYM $@38 sp_if END IF_SYM  */
#line 4210 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sphead->do_cont_backpatch(); }
#line 29999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 409: /* $@39: %empty  */
#line 4214 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            lex->sphead->reset_lex(thd);
            /*
              We should not push main select here, it will be done or not
              done by the statement, we just provide only a new LEX for the
              statement here as if it is start of parsing a new statement.
            */
            lex->sphead->m_tmp_query= lip->get_tok_start();
          }
#line 30016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 410: /* sp_proc_stmt_statement: $@39 statement  */
#line 4227 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->sp_proc_stmt_statement_finalize(thd, yychar == YYEMPTY) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 413: /* $@40: %empty  */
#line 4242 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 414: /* sp_proc_stmt_return: RETURN_ALLMODES_SYM $@40 expr  */
#line 4248 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
            if (unlikely(sp->m_handler->add_instr_freturn(thd, sp, lex->spcont,
                                                          (yyvsp[0].item), lex)) ||
                unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30052 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 415: /* sp_proc_stmt_return: RETURN_ORACLE_SYM  */
#line 4260 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            if (unlikely(sp->m_handler->add_instr_preturn(thd, sp,
                                                               lex->spcont)))
              MYSQL_YYABORT;
          }
#line 30064 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 416: /* $@41: %empty  */
#line 4270 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30074 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 417: /* reset_lex_expr: $@41 expr  */
#line 4276 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            (yyval.item)= (yyvsp[0].item);
          }
#line 30083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 418: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM  */
#line 4284 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 30092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 419: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident  */
#line 4289 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 30101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 420: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4294 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30111 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 421: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4300 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30121 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 422: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM  */
#line 4309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 30130 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 423: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident  */
#line 4314 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 30139 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 424: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4319 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 425: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4325 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item))) ||
                unlikely(Lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30159 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 426: /* sp_proc_stmt_leave: LEAVE_SYM label_ident  */
#line 4335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_leave_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30168 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 427: /* sp_proc_stmt_iterate: ITERATE_SYM label_ident  */
#line 4343 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_iterate_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 428: /* sp_proc_stmt_goto_oracle: GOTO_ORACLE_SYM label_ident  */
#line 4351 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_goto_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 429: /* assignment_source_lex: %empty  */
#line 4358 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->sphead);
            if (unlikely(!((yyval.assignment_lex)= new (thd->mem_root)
                           sp_assignment_lex(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 30197 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 430: /* $@42: %empty  */
#line 4368 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30208 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 431: /* assignment_source_expr: assignment_source_lex $@42 expr  */
#line 4375 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), thd->free_list);
            thd->free_list= NULL;
            Lex->pop_select(); //min select
            if ((yyval.assignment_lex)->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30223 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 432: /* $@43: %empty  */
#line 4389 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= FOR_LOOP_BOUND;
          }
#line 30234 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 433: /* for_loop_bound_expr: assignment_source_lex $@43 expr  */
#line 4396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), NULL);
            Lex->pop_select(); //main select
            if (unlikely((yyval.assignment_lex)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= NO_MATTER;
          }
#line 30249 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 434: /* cursor_actual_parameters: assignment_source_expr  */
#line 4410 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.sp_assignment_lex_list)= new (thd->mem_root) List<sp_assignment_lex>)))
              MYSQL_YYABORT;
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 30259 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 435: /* cursor_actual_parameters: cursor_actual_parameters ',' assignment_source_expr  */
#line 4416 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.sp_assignment_lex_list)= (yyvsp[-2].sp_assignment_lex_list);
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 30268 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 436: /* opt_parenthesized_cursor_actual_parameters: %empty  */
#line 4423 "/home/buildbot/git/sql/sql_yacc.yy"
                                             { (yyval.sp_assignment_lex_list)= NULL; }
#line 30274 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 437: /* opt_parenthesized_cursor_actual_parameters: '(' cursor_actual_parameters ')'  */
#line 4424 "/home/buildbot/git/sql/sql_yacc.yy"
                                             { (yyval.sp_assignment_lex_list)= (yyvsp[-1].sp_assignment_lex_list); }
#line 30280 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 438: /* sp_proc_stmt_open: OPEN_SYM ident opt_parenthesized_cursor_actual_parameters  */
#line 4429 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_open_cursor(thd, &(yyvsp[-1].ident_sys), (yyvsp[0].sp_assignment_lex_list))))
              MYSQL_YYABORT;
          }
#line 30289 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 439: /* sp_proc_stmt_fetch_head: FETCH_SYM ident INTO  */
#line 4437 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30298 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 440: /* sp_proc_stmt_fetch_head: FETCH_SYM FROM ident INTO  */
#line 4442 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30307 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 441: /* sp_proc_stmt_fetch_head: FETCH_SYM NEXT_SYM FROM ident INTO  */
#line 4447 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 30316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 442: /* sp_proc_stmt_fetch: sp_proc_stmt_fetch_head sp_fetch_list  */
#line 4454 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { }
#line 30322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 443: /* sp_proc_stmt_fetch: FETCH_SYM GROUP_SYM NEXT_SYM ROW_SYM  */
#line 4456 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           if (unlikely(Lex->sp_add_agg_cfetch()))
             MYSQL_YYABORT;
         }
#line 30331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 444: /* sp_proc_stmt_close: CLOSE_SYM ident  */
#line 4464 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint offset;
            sp_instr_cclose *i;

            if (unlikely(!lex->spcont->find_cursor(&(yyvsp[0].ident_sys), &offset, false)))
              my_yyabort_error((ER_SP_CURSOR_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            i= new (thd->mem_root)
              sp_instr_cclose(sp->instructions(), lex->spcont,  offset);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30350 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 445: /* sp_fetch_list: ident  */
#line 4482 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;

            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 30370 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 446: /* sp_fetch_list: sp_fetch_list ',' ident  */
#line 4498 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;

            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 30390 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 447: /* $@44: %empty  */
#line 4516 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 448: /* $@45: %empty  */
#line 4522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, ctx, (yyvsp[-1].item), lex);
            if (unlikely(i == NULL) ||
                unlikely(sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0))) ||
                unlikely(sp->add_cont_backpatch(i)) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30421 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 449: /* $@46: %empty  */
#line 4539 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            sp_head *sp= Lex->sphead;
            sp_pcontext *ctx= Lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, ctx);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            sp->backpatch(ctx->pop_label());
            sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0));
          }
#line 30437 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 450: /* sp_if: $@44 expr THEN_SYM $@45 sp_proc_stmts1 $@46 sp_elseifs  */
#line 4551 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sphead->backpatch(lex->spcont->pop_label());
          }
#line 30447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 454: /* $@47: %empty  */
#line 4566 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;

            /**
              An example of the CASE statement in use is
            <pre>
            CREATE PROCEDURE proc_19194_simple(i int)
            BEGIN
              DECLARE str CHAR(10);

              CASE i
                WHEN 1 THEN SET str="1";
                WHEN 2 THEN SET str="2";
                WHEN 3 THEN SET str="3";
                ELSE SET str="unknown";
              END CASE;

              SELECT str;
            END
            </pre>
              The actions are used to generate the following code:
            <pre>
            SHOW PROCEDURE CODE proc_19194_simple;
            Pos     Instruction
            0       set str@1 NULL
            1       set_case_expr (12) 0 i@0
            2       jump_if_not 5(12) (case_expr@0 = 1)
            3       set str@1 _latin1'1'
            4       jump 12
            5       jump_if_not 8(12) (case_expr@0 = 2)
            6       set str@1 _latin1'2'
            7       jump 12
            8       jump_if_not 11(12) (case_expr@0 = 3)
            9       set str@1 _latin1'3'
            10      jump 12
            11      set str@1 _latin1'unknown'
            12      stmt 0 "SELECT str"
            </pre>
            */

            Lex->sphead->new_cont_backpatch(NULL);

            /*
              BACKPATCH: Creating target label for the jump to after END CASE
              (instruction 12 in the example)
            */
            Lex->spcont->push_label(thd, &empty_clex_str, Lex->sphead->instructions());
          }
#line 30501 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 455: /* case_stmt_specification: CASE_SYM $@47 case_stmt_body else_clause_opt END CASE_SYM  */
#line 4619 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              BACKPATCH: Resolving forward jump from
              "case_stmt_action_then" to after END CASE
              (jump from instruction 4 to 12, 7 to 12 ... in the example)
            */
            Lex->sphead->backpatch(Lex->spcont->pop_label());

            if ((yyvsp[-3].num))
              Lex->spcont->pop_case_expr_id();

            Lex->sphead->do_cont_backpatch();
          }
#line 30519 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 456: /* $@48: %empty  */
#line 4635 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $2 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30529 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 457: /* $@49: %empty  */
#line 4641 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_expr((yyvsp[0].item))))
              MYSQL_YYABORT;

            Lex->pop_select(); //main select
            if (Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 30542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 458: /* case_stmt_body: $@48 expr $@49 simple_when_clause_list  */
#line 4650 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 1; }
#line 30548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 459: /* case_stmt_body: searched_when_clause_list  */
#line 4652 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 0; }
#line 30554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 464: /* $@50: %empty  */
#line 4667 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 465: /* $@51: %empty  */
#line 4673 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Simple case: <caseval> = <whenval> */

            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), true)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30580 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 466: /* simple_when_clause: WHEN_SYM $@50 expr $@51 THEN_SYM sp_proc_stmts1  */
#line 4686 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 30589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 467: /* $@52: %empty  */
#line 4694 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30599 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 468: /* $@53: %empty  */
#line 4700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), false)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 30613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 469: /* searched_when_clause: WHEN_SYM $@52 expr $@53 THEN_SYM sp_proc_stmts1  */
#line 4711 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 30622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 470: /* else_clause_opt: %empty  */
#line 4719 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint ip= sp->instructions();
            sp_instr_error *i= new (thd->mem_root)
              sp_instr_error(ip, lex->spcont, ER_SP_CASE_NOT_FOUND);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 472: /* sp_label: label_ident ':'  */
#line 4733 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)= (yyvsp[-1].ident_sys); }
#line 30643 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 473: /* sp_opt_label: %empty  */
#line 4737 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lex_str)= null_clex_str; }
#line 30649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 474: /* sp_opt_label: label_ident  */
#line 4738 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 30655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 475: /* sp_block_label: sp_label  */
#line 4743 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->spcont->block_label_declare(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[0].lex_str);
          }
#line 30665 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 476: /* $@54: %empty  */
#line 4753 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
          }
#line 30673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 477: /* sp_labeled_block: sp_block_label BEGIN_MARIADB_SYM $@54 sp_decls sp_proc_stmts END sp_opt_label  */
#line 4760 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-3].spblock), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 478: /* $@55: %empty  */
#line 4768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 30690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 479: /* sp_unlabeled_block: BEGIN_MARIADB_SYM $@55 sp_decls sp_proc_stmts END  */
#line 4774 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 30699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 480: /* $@56: %empty  */
#line 4782 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
          }
#line 30709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 481: /* sp_unlabeled_block_not_atomic: BEGIN_MARIADB_SYM not ATOMIC_SYM $@56 sp_decls sp_proc_stmts END  */
#line 4790 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 30718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 482: /* opt_sp_for_loop_direction: %empty  */
#line 4798 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= 1; }
#line 30724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 483: /* opt_sp_for_loop_direction: REVERSE_SYM  */
#line 4799 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= -1; }
#line 30730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 484: /* $@57: %empty  */
#line 4804 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30739 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 485: /* sp_for_loop_index_and_bounds: ident $@57 sp_for_loop_bounds  */
#line 4809 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (unlikely(Lex->sp_for_loop_declarations(thd, &(yyval.for_loop), &(yyvsp[-2].ident_sys), (yyvsp[0].for_loop_bounds))))
              MYSQL_YYABORT;
          }
#line 30749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 486: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr DOT_DOT_SYM for_loop_bound_expr  */
#line 4819 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.for_loop_bounds)= Lex_for_loop_bounds_intrange((yyvsp[-3].num), (yyvsp[-2].assignment_lex), (yyvsp[0].assignment_lex));
          }
#line 30757 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 487: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr  */
#line 4823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.for_loop_bounds).m_direction= (yyvsp[-1].num);
            (yyval.for_loop_bounds).m_index= (yyvsp[0].assignment_lex);
            (yyval.for_loop_bounds).m_target_bound= NULL;
            (yyval.for_loop_bounds).m_implicit_cursor= false;
          }
#line 30768 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 488: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction '(' sp_cursor_stmt ')'  */
#line 4830 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_implicit_cursor_statement(thd, &(yyval.for_loop_bounds),
                                                                    (yyvsp[-1].sp_cursor_stmt))))
              MYSQL_YYABORT;
          }
#line 30778 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 489: /* loop_body: sp_proc_stmts1 END LOOP_SYM  */
#line 4839 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump *i= new (thd->mem_root)
              sp_instr_jump(ip, lex->spcont, lab->ip);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 490: /* $@58: %empty  */
#line 4853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sp_while_loop_expression(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            if (lex->main_select_push(true))
               MYSQL_YYABORT;
          }
#line 30808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 491: /* while_body: expr DO_SYM $@58 sp_proc_stmts1 END WHILE_SYM  */
#line 4864 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_while_loop_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 30817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 492: /* $@59: %empty  */
#line 4872 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 493: /* repeat_body: sp_proc_stmts1 UNTIL_SYM $@59 expr END REPEAT_SYM  */
#line 4878 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, lex->spcont, (yyvsp[-2].item), lab->ip, lex);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            /* We can shortcut the cont_backpatch here */
            i->m_cont_dest= ip+1;
          }
#line 30847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 494: /* pop_sp_loop_label: sp_opt_label  */
#line 4897 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_pop_loop_label(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 495: /* $@60: %empty  */
#line 4905 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 496: /* sp_labeled_control: sp_label LOOP_SYM $@60 loop_body pop_sp_loop_label  */
#line 4910 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 497: /* $@61: %empty  */
#line 4912 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 498: /* sp_labeled_control: sp_label WHILE_SYM $@61 while_body pop_sp_loop_label  */
#line 4920 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 499: /* $@62: %empty  */
#line 4922 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 500: /* $@63: %empty  */
#line 4927 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-3].lex_str)))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30909 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 501: /* $@64: %empty  */
#line 4936 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 502: /* sp_labeled_control: sp_label FOR_SYM $@62 sp_for_loop_index_and_bounds $@63 DO_SYM sp_proc_stmts1 END FOR_SYM $@64 pop_sp_loop_label  */
#line 4941 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-7].for_loop))))
              MYSQL_YYABORT;
          }
#line 30927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 503: /* $@65: %empty  */
#line 4946 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 504: /* sp_labeled_control: sp_label REPEAT_SYM $@65 repeat_body pop_sp_loop_label  */
#line 4951 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 30942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 505: /* $@66: %empty  */
#line 4956 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 506: /* sp_unlabeled_control: LOOP_SYM $@66 loop_body  */
#line 4961 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30959 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 507: /* $@67: %empty  */
#line 4965 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 508: /* sp_unlabeled_control: WHILE_SYM $@67 while_body  */
#line 4973 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30979 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 509: /* $@68: %empty  */
#line 4977 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 510: /* $@69: %empty  */
#line 4984 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 31001 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 511: /* sp_unlabeled_control: FOR_SYM $@68 sp_for_loop_index_and_bounds $@69 DO_SYM sp_proc_stmts1 END FOR_SYM  */
#line 4993 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
            Lex->sp_pop_loop_empty_label(thd); // The inner WHILE block
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 31013 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 512: /* $@70: %empty  */
#line 5001 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 31022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 513: /* sp_unlabeled_control: REPEAT_SYM $@70 repeat_body  */
#line 5006 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 31030 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 514: /* trg_action_time: BEFORE_SYM  */
#line 5013 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_BEFORE; }
#line 31036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 515: /* trg_action_time: AFTER_SYM  */
#line 5015 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_AFTER; }
#line 31042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 516: /* trg_event: INSERT  */
#line 5020 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_INSERT; }
#line 31048 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 517: /* trg_event: UPDATE_SYM  */
#line 5022 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_UPDATE; }
#line 31054 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 518: /* trg_event: DELETE_SYM  */
#line 5024 "/home/buildbot/git/sql/sql_yacc.yy"
            { Lex->trg_chistics.event= TRG_EVENT_DELETE; }
#line 31060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 522: /* opt_logfile_group_name: %empty  */
#line 5058 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31066 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 523: /* opt_logfile_group_name: USE_SYM LOGFILE_SYM GROUP_SYM ident  */
#line 5060 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
          }
#line 31075 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 524: /* alter_tablespace_info: tablespace_name ADD ts_datafile alter_tablespace_option_list  */
#line 5070 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_ADD_FILE; 
          }
#line 31083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 525: /* alter_tablespace_info: tablespace_name DROP ts_datafile alter_tablespace_option_list  */
#line 5076 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_DROP_FILE; 
          }
#line 31091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 530: /* $@71: %empty  */
#line 5099 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31097 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 577: /* ts_datafile: DATAFILE_SYM TEXT_STRING_sys  */
#line 5193 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->data_file_name= (yyvsp[0].lex_str).str;
          }
#line 31106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 578: /* lg_undofile: UNDOFILE_SYM TEXT_STRING_sys  */
#line 5201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_file_name= (yyvsp[0].lex_str).str;
          }
#line 31115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 579: /* lg_redofile: REDOFILE_SYM TEXT_STRING_sys  */
#line 5209 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_file_name= (yyvsp[0].lex_str).str;
          }
#line 31124 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 580: /* tablespace_name: ident  */
#line 5217 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->tablespace_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 31138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 581: /* logfile_group_name: ident  */
#line 5230 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 31152 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 582: /* ts_access_mode: READ_ONLY_SYM  */
#line 5243 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_ONLY;
          }
#line 31161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 583: /* ts_access_mode: READ_WRITE_SYM  */
#line 5248 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_WRITE;
          }
#line 31170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 584: /* ts_access_mode: NOT_SYM ACCESSIBLE_SYM  */
#line 5253 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_NOT_ACCESSIBLE;
          }
#line 31179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 585: /* opt_ts_initial_size: INITIAL_SIZE_SYM opt_equal size_number  */
#line 5261 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->initial_size= (yyvsp[0].ulonglong_number);
          }
#line 31188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 586: /* opt_ts_autoextend_size: AUTOEXTEND_SIZE_SYM opt_equal size_number  */
#line 5269 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->autoextend_size= (yyvsp[0].ulonglong_number);
          }
#line 31197 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 587: /* opt_ts_max_size: MAX_SIZE_SYM opt_equal size_number  */
#line 5277 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->max_size= (yyvsp[0].ulonglong_number);
          }
#line 31206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 588: /* opt_ts_extent_size: EXTENT_SIZE_SYM opt_equal size_number  */
#line 5285 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->extent_size= (yyvsp[0].ulonglong_number);
          }
#line 31215 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 589: /* opt_ts_undo_buffer_size: UNDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5293 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 31224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 590: /* opt_ts_redo_buffer_size: REDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5301 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 31233 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 591: /* opt_ts_nodegroup: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 5309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->nodegroup_id != UNDEF_NODEGROUP))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NODEGROUP"));
            lex->alter_tablespace_info->nodegroup_id= (yyvsp[0].ulong_num);
          }
#line 31244 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 592: /* opt_ts_comment: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 5319 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->ts_comment != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"COMMENT"));
            lex->alter_tablespace_info->ts_comment= (yyvsp[0].lex_str).str;
          }
#line 31255 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 593: /* opt_ts_engine: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 5329 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->storage_engine != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE, MYF(0),
                                "STORAGE ENGINE"));
            lex->alter_tablespace_info->storage_engine= (yyvsp[0].db_type);
          }
#line 31267 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 596: /* ts_wait: WAIT_SYM  */
#line 5345 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->wait_until_completed= TRUE;
          }
#line 31276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 597: /* ts_wait: NO_WAIT_SYM  */
#line 5350 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!(lex->alter_tablespace_info->wait_until_completed)))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NO_WAIT"));
            lex->alter_tablespace_info->wait_until_completed= FALSE;
          }
#line 31287 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 598: /* size_number: real_ulonglong_num  */
#line 5359 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.ulonglong_number)= (yyvsp[0].ulonglong_number);}
#line 31293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 599: /* size_number: IDENT_sys  */
#line 5361 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].ident_sys).to_size_number(&(yyval.ulonglong_number)))
              MYSQL_YYABORT;
          }
#line 31302 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 600: /* $@72: %empty  */
#line 5373 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.option_list= NULL; }
#line 31308 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 601: /* create_body: create_field_list_parens $@72 opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5374 "/home/buildbot/git/sql/sql_yacc.yy"
                                                                             {}
#line 31314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 602: /* create_body: opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5375 "/home/buildbot/git/sql/sql_yacc.yy"
                                                                             {}
#line 31320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 603: /* create_body: create_like  */
#line 5377 "/home/buildbot/git/sql/sql_yacc.yy"
          {

            Lex->create_info.add(DDL_options_st::OPT_LIKE);
            TABLE_LIST *src_table= Lex->first_select_lex()->
              add_table_to_list(thd, (yyvsp[0].table), NULL, 0, TL_READ, MDL_SHARED_READ);
            if (unlikely(! src_table))
              MYSQL_YYABORT;
            /* CREATE TABLE ... LIKE is not allowed for views. */
            src_table->required_type= TABLE_TYPE_NORMAL;
          }
#line 31335 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 604: /* create_like: LIKE table_ident  */
#line 5390 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.table)= (yyvsp[0].table); }
#line 31341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 605: /* create_like: LEFT_PAREN_LIKE LIKE table_ident ')'  */
#line 5391 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.table)= (yyvsp[-1].table); }
#line 31347 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 606: /* opt_create_select: %empty  */
#line 5395 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31353 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 607: /* opt_create_select: opt_duplicate opt_as create_select_query_expression opt_versioning_option  */
#line 5398 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 31362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 608: /* create_select_query_expression: query_expression  */
#line 5406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_insert_select((yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 31371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 609: /* create_select_query_expression: LEFT_PAREN_WITH with_clause query_expression_no_with_clause ')'  */
#line 5411 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *first_select= (yyvsp[-1].select_lex_unit)->first_select();
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to(first_select);
            if (Lex->parsed_insert_select(first_select))
              MYSQL_YYABORT;
          }
#line 31383 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 610: /* opt_create_partitioning: opt_partitioning  */
#line 5422 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Remove all tables used in PARTITION clause from the global table
              list. Partitioning with subqueries is not allowed anyway.
            */
            TABLE_LIST *last_non_sel_table= Lex->create_last_non_select_table;
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;
          }
#line 31397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 611: /* opt_partitioning: %empty  */
#line 5458 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 613: /* $@73: %empty  */
#line 5464 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;
            if (lex->sql_command == SQLCOM_ALTER_TABLE)
            {
              lex->alter_info.partition_flags|= ALTER_PARTITION_INFO;
            }
          }
#line 31418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 615: /* have_partitioning: %empty  */
#line 5479 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef WITH_PARTITION_STORAGE_ENGINE
            LEX_CSTRING partition_name={STRING_WITH_LEN("partition")};
            if (unlikely(!plugin_is_ready(&partition_name, MYSQL_STORAGE_ENGINE_PLUGIN)))
              my_yyabort_error((ER_OPTION_PREVENTS_STATEMENT, MYF(0),
                                "--skip-partition"));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), "partitioning",
                              "--with-plugin-partition"));
#endif
          }
#line 31434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 616: /* $@74: %empty  */
#line 5494 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->part_info))
            {
              thd->parse_error(ER_PARTITION_ENTRY_ERROR);
              MYSQL_YYABORT;
            }
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              We enter here when opening the frm file to translate
              partition info string into part_info data structure.
            */
          }
#line 31452 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 617: /* partition_entry: PARTITION_SYM $@74 partition  */
#line 5508 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 31460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 618: /* $@75: %empty  */
#line 5515 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->safe_to_cache_query= 1; }
#line 31466 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 620: /* part_type_def: opt_linear KEY_SYM opt_key_algo '(' part_field_list ')'  */
#line 5521 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->list_of_part_fields= TRUE;
            part_info->column_list= FALSE;
            part_info->part_type= HASH_PARTITION;
          }
#line 31477 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 621: /* $@76: %empty  */
#line 5528 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= HASH_PARTITION; }
#line 31483 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 622: /* part_type_def: opt_linear HASH_SYM $@76 part_func  */
#line 5529 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 31489 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 623: /* part_type_def: RANGE_SYM part_func  */
#line 5531 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 31495 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 624: /* part_type_def: RANGE_SYM part_column_list  */
#line 5533 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 31501 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 625: /* $@77: %empty  */
#line 5535 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= IN_PART_FUNC;
          }
#line 31509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 626: /* part_type_def: LIST_SYM $@77 part_func  */
#line 5539 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
	    Lex->part_info->part_type= LIST_PARTITION; 
	    Select->parsing_place= NO_MATTER;
	  }
#line 31518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 627: /* part_type_def: LIST_SYM part_column_list  */
#line 5544 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->part_type= LIST_PARTITION; }
#line 31524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 628: /* $@78: %empty  */
#line 5546 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(Lex->part_info->vers_init_info(thd)))
               MYSQL_YYABORT;
          }
#line 31533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 630: /* opt_linear: %empty  */
#line 5554 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 631: /* opt_linear: LINEAR_SYM  */
#line 5556 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->linear_hash_ind= TRUE;}
#line 31545 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 632: /* opt_key_algo: %empty  */
#line 5561 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_NONE;}
#line 31551 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 633: /* opt_key_algo: ALGORITHM_SYM '=' real_ulong_num  */
#line 5563 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch ((yyvsp[0].ulong_num)) {
            case 1:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_51;
              break;
            case 2:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_55;
              break;
            default:
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 31569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 634: /* part_field_list: %empty  */
#line 5579 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 635: /* part_field_list: part_field_item_list  */
#line 5580 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 31581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 636: /* part_field_item_list: part_field_item  */
#line 5584 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31587 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 637: /* part_field_item_list: part_field_item_list ',' part_field_item  */
#line 5585 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   {}
#line 31593 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 638: /* part_field_item: ident  */
#line 5590 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_columns++;
            if (unlikely(part_info->part_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;
            if (unlikely(part_info->num_columns > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of partition fields"));
          }
#line 31608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 639: /* part_column_list: COLUMNS '(' part_field_list ')'  */
#line 5604 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->column_list= TRUE;
            part_info->list_of_part_fields= TRUE;
          }
#line 31618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 640: /* part_func: '(' part_func_expr ')'  */
#line 5614 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->set_part_expr(thd, (yyvsp[-1].item), FALSE)))
              MYSQL_YYABORT;
            part_info->num_columns= 1;
            part_info->column_list= FALSE;
          }
#line 31630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 641: /* sub_part_func: '(' part_func_expr ')'  */
#line 5625 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->part_info->set_part_expr(thd, (yyvsp[-1].item), TRUE)))
              MYSQL_YYABORT;
          }
#line 31639 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 642: /* opt_num_parts: %empty  */
#line 5633 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 643: /* opt_num_parts: PARTITIONS_SYM real_ulong_num  */
#line 5635 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            uint num_parts= (yyvsp[0].ulong_num);
            partition_info *part_info= Lex->part_info;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "partitions"));

            part_info->num_parts= num_parts;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 644: /* opt_sub_part: %empty  */
#line 5647 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31665 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 645: /* $@79: %empty  */
#line 5649 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->subpart_type= HASH_PARTITION; }
#line 31671 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 646: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear HASH_SYM sub_part_func $@79 opt_num_subparts  */
#line 5650 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 31677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 647: /* $@80: %empty  */
#line 5653 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->subpart_type= HASH_PARTITION;
            part_info->list_of_subpart_fields= TRUE;
          }
#line 31687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 648: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear KEY_SYM opt_key_algo '(' sub_part_field_list ')' $@80 opt_num_subparts  */
#line 5658 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 31693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 649: /* sub_part_field_list: sub_part_field_item  */
#line 5662 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 31699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 650: /* sub_part_field_list: sub_part_field_list ',' sub_part_field_item  */
#line 5663 "/home/buildbot/git/sql/sql_yacc.yy"
                                                      {}
#line 31705 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 651: /* sub_part_field_item: ident  */
#line 5668 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->subpart_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;

            if (unlikely(part_info->subpart_field_list.elements > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of subpartition fields"));
          }
#line 31720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 652: /* part_func_expr: bit_expr  */
#line 5682 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            (yyval.item)=(yyvsp[0].item);
          }
#line 31733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 653: /* opt_num_subparts: %empty  */
#line 5693 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 31739 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 654: /* opt_num_subparts: SUBPARTITIONS_SYM real_ulong_num  */
#line 5695 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            uint num_parts= (yyvsp[0].ulong_num);
            LEX *lex= Lex;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "subpartitions"));
            lex->part_info->num_subparts= num_parts;
            lex->part_info->use_default_num_subpartitions= FALSE;
          }
#line 31752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 655: /* part_defs: %empty  */
#line 5707 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == RANGE_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "RANGE"));
            if (unlikely(part_info->part_type == LIST_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "LIST"));
          }
#line 31766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 656: /* part_defs: '(' part_def_list ')'  */
#line 5717 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            uint count_curr_parts= part_info->partitions.elements;
            if (part_info->num_parts != 0)
            {
              if (unlikely(part_info->num_parts !=
                           count_curr_parts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_PART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (count_curr_parts > 0)
            {
              part_info->num_parts= count_curr_parts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31789 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 657: /* part_def_list: part_definition  */
#line 5738 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31795 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 658: /* part_def_list: part_def_list ',' part_definition  */
#line 5739 "/home/buildbot/git/sql/sql_yacc.yy"
                                            {}
#line 31801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 659: /* $@81: %empty  */
#line 5744 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= new (thd->mem_root) partition_element();

            if (unlikely(!p_elem) ||
                unlikely(part_info->partitions.push_back(p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            p_elem->part_state= PART_NORMAL;
            p_elem->id= part_info->partitions.elements - 1;
            part_info->curr_part_elem= p_elem;
            part_info->current_partition= p_elem;
            part_info->use_default_partitions= FALSE;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31821 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 660: /* part_definition: PARTITION_SYM $@81 part_name opt_part_values opt_part_options opt_sub_partition  */
#line 5763 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 31827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 661: /* part_name: ident  */
#line 5768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= part_info->curr_part_elem;
            if (unlikely(check_ident_length(&(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
            p_elem->partition_name= (yyvsp[0].ident_sys).str;
          }
#line 31839 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 662: /* opt_part_values: %empty  */
#line 5779 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->error_if_requires_values()))
                MYSQL_YYABORT;
              if (unlikely(part_info->part_type == VERSIONING_PARTITION))
                my_yyabort_error((ER_VERS_WRONG_PARTS, MYF(0),
                                  lex->create_last_non_select_table->
                                  table_name.str));
            }
            else
              part_info->part_type= HASH_PARTITION;
          }
#line 31859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 663: /* $@82: %empty  */
#line 5795 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != RANGE_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "RANGE", "LESS THAN"));
            }
            else
              part_info->part_type= RANGE_PARTITION;
          }
#line 31876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 664: /* opt_part_values: VALUES_LESS_SYM THAN_SYM $@82 part_func_max  */
#line 5807 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 31882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 665: /* $@83: %empty  */
#line 5809 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "IN"));
            }
            else
              part_info->part_type= LIST_PARTITION;
          }
#line 31899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 666: /* opt_part_values: VALUES_IN_SYM $@83 part_values_in  */
#line 5821 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 31905 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 667: /* opt_part_values: CURRENT_SYM  */
#line 5823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->part_values_current(thd))
              MYSQL_YYABORT;
          }
#line 31914 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 668: /* opt_part_values: HISTORY_SYM  */
#line 5828 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->part_values_history(thd))
              MYSQL_YYABORT;
          }
#line 31923 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 669: /* opt_part_values: DEFAULT  */
#line 5833 "/home/buildbot/git/sql/sql_yacc.yy"
         {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "DEFAULT"));
            }
            else
              part_info->part_type= LIST_PARTITION;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
         }
#line 31944 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 670: /* part_func_max: MAXVALUE_SYM  */
#line 5853 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;

            if (unlikely(part_info->num_columns &&
                         part_info->num_columns != 1U))
            {
              part_info->print_debug("Kilroy II", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            else
              part_info->num_columns= 1U;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 671: /* part_func_max: part_value_item  */
#line 5870 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 31972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 672: /* part_values_in: part_value_item  */
#line 5875 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            part_info->print_debug("part_values_in: part_value_item", NULL);

            if (part_info->num_columns != 1U)
            {
              if (unlikely(!lex->is_partition_management() ||
                           part_info->num_columns == 0 ||
                           part_info->num_columns > MAX_REF_PARTS))
              {
                part_info->print_debug("Kilroy III", NULL);
                thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
                MYSQL_YYABORT;
              }
              /*
                Reorganize the current large array into a list of small
                arrays with one entry in each array. This can happen
                in the first partition of an ALTER TABLE statement where
                we ADD or REORGANIZE partitions. Also can only happen
                for LIST partitions.
              */
              if (unlikely(part_info->reorganize_into_single_field_col_val(thd)))
                MYSQL_YYABORT;
            }
          }
#line 32003 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 673: /* part_values_in: '(' part_value_list ')'  */
#line 5902 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_columns < 2U))
            {
              thd->parse_error(ER_ROW_SINGLE_PARTITION_FIELD_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 32016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 674: /* part_value_list: part_value_item  */
#line 5913 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 32022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 675: /* part_value_list: part_value_list ',' part_value_item  */
#line 5914 "/home/buildbot/git/sql/sql_yacc.yy"
                                              {}
#line 32028 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 676: /* $@84: %empty  */
#line 5919 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug("( part_value_item", NULL);
            /* Initialisation code needed for each list of value expressions */
            if (unlikely(!(part_info->part_type == LIST_PARTITION &&
                           part_info->num_columns == 1U) &&
                           part_info->init_column_part(thd)))
              MYSQL_YYABORT;
          }
#line 32042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 677: /* $@85: %empty  */
#line 5928 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 32048 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 678: /* part_value_item: '(' $@84 part_value_item_list $@85 ')'  */
#line 5930 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug(") part_value_item", NULL);
            if (part_info->num_columns == 0)
              part_info->num_columns= part_info->curr_list_object;
            if (unlikely(part_info->num_columns != part_info->curr_list_object))
            {
              /*
                All value items lists must be of equal length, in some cases
                which is covered by the above if-statement we don't know yet
                how many columns is in the partition so the assignment above
                ensures that we only report errors when we know we have an
                error.
              */
              part_info->print_debug("Kilroy I", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            part_info->curr_list_object= 0;
          }
#line 32073 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 679: /* part_value_item_list: part_value_expr_item  */
#line 5953 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 32079 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 680: /* part_value_item_list: part_value_item_list ',' part_value_expr_item  */
#line 5954 "/home/buildbot/git/sql/sql_yacc.yy"
                                                        {}
#line 32085 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 681: /* part_value_expr_item: MAXVALUE_SYM  */
#line 5959 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == LIST_PARTITION))
            {
              thd->parse_error(ER_MAXVALUE_IN_VALUES_IN);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 32100 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 682: /* part_value_expr_item: bit_expr  */
#line 5970 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            Item *part_expr= (yyvsp[0].item);

            if (unlikely(!lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_column_list_value(thd, part_expr)))
              MYSQL_YYABORT;
          }
#line 32118 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 683: /* opt_sub_partition: %empty  */
#line 5988 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_subparts != 0 &&
                         !part_info->use_default_subpartitions))
            {
              /*
                We come here when we have defined subpartitions on the first
                partition but not on all the subsequent partitions. 
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 32136 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 684: /* opt_sub_partition: '(' sub_part_list ')'  */
#line 6002 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (part_info->num_subparts != 0)
            {
              if (unlikely(part_info->num_subparts !=
                           part_info->count_curr_subparts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (part_info->count_curr_subparts > 0)
            {
              if (unlikely(part_info->partitions.elements > 1))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
              part_info->num_subparts= part_info->count_curr_subparts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 32163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 685: /* sub_part_list: sub_part_definition  */
#line 6027 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 32169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 686: /* sub_part_list: sub_part_list ',' sub_part_definition  */
#line 6028 "/home/buildbot/git/sql/sql_yacc.yy"
                                                {}
#line 32175 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 687: /* $@86: %empty  */
#line 6033 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *curr_part= part_info->current_partition;
            partition_element *sub_p_elem= new (thd->mem_root)
                                           partition_element(curr_part);
            if (unlikely(part_info->use_default_subpartitions &&
                         part_info->partitions.elements >= 2))
            {
              /*
                create table t1 (a int)
                partition by list (a) subpartition by hash (a)
                (partition p0 values in (1),
                 partition p1 values in (2) subpartition sp11);
                causes use to arrive since we are on the second
                partition, but still use_default_subpartitions
                is set. When we come here we're processing at least
                the second partition (the current partition processed
                have already been put into the partitions list.
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(!sub_p_elem) ||
                unlikely(curr_part->subpartitions.push_back(sub_p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            sub_p_elem->id= curr_part->subpartitions.elements - 1;
            part_info->curr_part_elem= sub_p_elem;
            part_info->use_default_subpartitions= FALSE;
            part_info->use_default_num_subpartitions= FALSE;
            part_info->count_curr_subparts++;
          }
#line 32212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 688: /* sub_part_definition: SUBPARTITION_SYM $@86 sub_name opt_part_options  */
#line 6065 "/home/buildbot/git/sql/sql_yacc.yy"
                                    {}
#line 32218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 689: /* sub_name: ident_or_text  */
#line 6070 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(check_ident_length(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            Lex->part_info->curr_part_elem->partition_name= (yyvsp[0].lex_str).str;
          }
#line 32228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 690: /* opt_part_options: %empty  */
#line 6078 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 32234 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 691: /* opt_part_options: opt_part_option_list  */
#line 6079 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 32240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 692: /* opt_part_option_list: opt_part_option_list opt_part_option  */
#line 6083 "/home/buildbot/git/sql/sql_yacc.yy"
                                              {}
#line 32246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 693: /* opt_part_option_list: opt_part_option  */
#line 6084 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 32252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 694: /* opt_part_option: TABLESPACE opt_equal ident_or_text  */
#line 6089 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->tablespace_name= (yyvsp[0].lex_str).str; }
#line 32258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 695: /* opt_part_option: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 6091 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->curr_part_elem->engine_type= (yyvsp[0].db_type);
            part_info->default_engine_type= (yyvsp[0].db_type);
          }
#line 32268 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 696: /* opt_part_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6097 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info->curr_part_elem->connect_string.str= (yyvsp[0].lex_str).str;
            lex->part_info->curr_part_elem->connect_string.length= (yyvsp[0].lex_str).length;
          }
#line 32278 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 697: /* opt_part_option: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 6103 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->nodegroup_id= (uint16) (yyvsp[0].ulong_num); }
#line 32284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 698: /* opt_part_option: MAX_ROWS opt_equal real_ulonglong_num  */
#line 6105 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_max_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 32290 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 699: /* opt_part_option: MIN_ROWS opt_equal real_ulonglong_num  */
#line 6107 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_min_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 32296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 700: /* opt_part_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6109 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->data_file_name= (yyvsp[0].lex_str).str; }
#line 32302 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 701: /* opt_part_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6111 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->index_file_name= (yyvsp[0].lex_str).str; }
#line 32308 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 702: /* opt_part_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6113 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->part_info->curr_part_elem->part_comment= (yyvsp[0].lex_str).str; }
#line 32314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 703: /* opt_versioning_rotation: %empty  */
#line 6117 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 32320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 704: /* $@87: %empty  */
#line 6118 "/home/buildbot/git/sql/sql_yacc.yy"
         { Lex->clause_that_disallows_subselect= "INTERVAL"; }
#line 32326 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 705: /* opt_versioning_rotation: $@87 INTERVAL_SYM expr interval opt_versioning_interval_start  */
#line 6120 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           partition_info *part_info= Lex->part_info;
           if (unlikely(part_info->vers_set_interval(thd, (yyvsp[-2].item), (yyvsp[-1].interval), (yyvsp[0].ulong_num))))
             MYSQL_YYABORT;
         }
#line 32336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 706: /* opt_versioning_rotation: LIMIT ulonglong_num  */
#line 6126 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         partition_info *part_info= Lex->part_info;
         if (unlikely(part_info->vers_set_limit((yyvsp[0].ulonglong_number))))
         {
           my_error(ER_PART_WRONG_VALUE, MYF(0),
                    Lex->create_last_non_select_table->table_name.str,
                    "LIMIT");
           MYSQL_YYABORT;
         }
       }
#line 32351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 707: /* opt_versioning_interval_start: %empty  */
#line 6141 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           (yyval.ulong_num)= thd->query_start();
         }
#line 32359 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 708: /* opt_versioning_interval_start: STARTS_SYM ulong_num  */
#line 6145 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           /* only allowed from mysql_unpack_partition() */
           if (unlikely(!Lex->part_info->table))
           {
             thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].kwd).pos());
             MYSQL_YYABORT;
           }
           (yyval.ulong_num)= (ulong)(yyvsp[0].ulong_num);
         }
#line 32373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 709: /* opt_as: %empty  */
#line 6161 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 32379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 710: /* opt_as: AS  */
#line 6162 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 32385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 711: /* opt_create_database_options: %empty  */
#line 6166 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 32391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 712: /* opt_create_database_options: create_database_options  */
#line 6167 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 32397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 713: /* create_database_options: create_database_option  */
#line 6171 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 32403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 714: /* create_database_options: create_database_options create_database_option  */
#line 6172 "/home/buildbot/git/sql/sql_yacc.yy"
                                                         {}
#line 32409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 715: /* create_database_option: default_collation  */
#line 6176 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 32415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 716: /* create_database_option: default_charset  */
#line 6177 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 32421 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 717: /* opt_if_not_exists_table_element: %empty  */
#line 6182 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->check_exists= FALSE;
          }
#line 32429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 718: /* opt_if_not_exists_table_element: IF_SYM not EXISTS  */
#line 6186 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->check_exists= TRUE;
          }
#line 32437 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 719: /* opt_if_not_exists: %empty  */
#line 6193 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 32445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 720: /* opt_if_not_exists: IF_SYM not EXISTS  */
#line 6197 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_NOT_EXISTS);
          }
#line 32453 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 721: /* create_or_replace: CREATE  */
#line 6204 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 32461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 722: /* create_or_replace: CREATE OR_SYM REPLACE  */
#line 6208 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_OR_REPLACE);
          }
#line 32469 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 730: /* create_table_option: ENGINE_SYM opt_equal ident_or_text  */
#line 6231 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!lex->m_sql_cmd)
            {
              DBUG_ASSERT(lex->sql_command == SQLCOM_ALTER_TABLE);
              if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table()))
                MYSQL_YYABORT;
            }
            Storage_engine_name *opt=
              lex->m_sql_cmd->option_storage_engine_name();
            DBUG_ASSERT(opt); // Expect a proper Sql_cmd
            *opt= Storage_engine_name((yyvsp[0].lex_str));
            lex->create_info.used_fields|= HA_CREATE_USED_ENGINE;
          }
#line 32488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 731: /* create_table_option: MAX_ROWS opt_equal ulonglong_num  */
#line 6246 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.max_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MAX_ROWS;
          }
#line 32497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 732: /* create_table_option: MIN_ROWS opt_equal ulonglong_num  */
#line 6251 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.min_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MIN_ROWS;
          }
#line 32506 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 733: /* create_table_option: AVG_ROW_LENGTH opt_equal ulong_num  */
#line 6256 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.avg_row_length=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_AVG_ROW_LENGTH;
          }
#line 32515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 734: /* create_table_option: PASSWORD_SYM opt_equal TEXT_STRING_sys  */
#line 6261 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.password=(yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_PASSWORD;
          }
#line 32524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 735: /* create_table_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6266 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.comment=(yyvsp[0].lex_str);
            Lex->create_info.used_fields|= HA_CREATE_USED_COMMENT;
          }
#line 32533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 736: /* create_table_option: AUTO_INC opt_equal ulonglong_num  */
#line 6271 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.auto_increment_value=(yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_AUTO;
          }
#line 32542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 737: /* create_table_option: PACK_KEYS_SYM opt_equal ulong_num  */
#line 6276 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_PACK_KEYS;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_PACK_KEYS;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32561 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 738: /* create_table_option: PACK_KEYS_SYM opt_equal DEFAULT  */
#line 6291 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_PACK_KEYS | HA_OPTION_NO_PACK_KEYS);
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 739: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal ulong_num  */
#line 6297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_OFF;
                break;
            case 1:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_ON;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 740: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal DEFAULT  */
#line 6312 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_DEFAULT;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32599 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 741: /* create_table_option: STATS_PERSISTENT_SYM opt_equal ulong_num  */
#line 6317 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_STATS_PERSISTENT;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_STATS_PERSISTENT;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 742: /* create_table_option: STATS_PERSISTENT_SYM opt_equal DEFAULT  */
#line 6332 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_STATS_PERSISTENT | HA_OPTION_NO_STATS_PERSISTENT);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32628 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 743: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal ulong_num  */
#line 6338 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* From user point of view STATS_SAMPLE_PAGES can be specified as
            STATS_SAMPLE_PAGES=N (where 0<N<=65535, it does not make sense to
            scan 0 pages) or STATS_SAMPLE_PAGES=default. Internally we record
            =default as 0. See create_frm() in sql/table.cc, we use only two
            bytes for stats_sample_pages and this is why we do not allow
            larger values. 65535 pages, 16kb each means to sample 1GB, which
            is impractical. If at some point this needs to be extended, then
            we can store the higher bits from stats_sample_pages in .frm too. */
            if (unlikely((yyvsp[0].ulong_num) == 0 || (yyvsp[0].ulong_num) > 0xffff))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            Lex->create_info.stats_sample_pages=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 744: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal DEFAULT  */
#line 6356 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.stats_sample_pages=0;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 745: /* create_table_option: CHECKSUM_SYM opt_equal ulong_num  */
#line 6361 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
            Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 746: /* create_table_option: TABLE_CHECKSUM_SYM opt_equal ulong_num  */
#line 6366 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
             Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 747: /* create_table_option: PAGE_CHECKSUM_SYM opt_equal choice  */
#line 6371 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_PAGE_CHECKSUM;
            Lex->create_info.page_checksum= (yyvsp[0].choice);
          }
#line 32686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 748: /* create_table_option: DELAY_KEY_WRITE_SYM opt_equal ulong_num  */
#line 6376 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_DELAY_KEY_WRITE : HA_OPTION_NO_DELAY_KEY_WRITE;
            Lex->create_info.used_fields|= HA_CREATE_USED_DELAY_KEY_WRITE;
          }
#line 32695 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 749: /* create_table_option: ROW_FORMAT_SYM opt_equal row_types  */
#line 6381 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.row_type= (yyvsp[0].row_type);
            Lex->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
          }
#line 32704 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 750: /* $@88: %empty  */
#line 6386 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->first_select_lex()->table_list.save_and_clear(&Lex->save_list);
          }
#line 32712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 751: /* create_table_option: UNION_SYM opt_equal $@88 '(' opt_table_list ')'  */
#line 6390 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Move the union list to the merge_list and exclude its tables
              from the global list.
            */
            LEX *lex=Lex;
            lex->create_info.merge_list= lex->first_select_lex()->table_list.first;
            lex->first_select_lex()->table_list= lex->save_list;
            /*
              When excluding union list from the global list we assume that
              elements of the former immediately follow elements which represent
              table being created/altered and parent tables.
            */
            TABLE_LIST *last_non_sel_table= lex->create_last_non_select_table;
            DBUG_ASSERT(last_non_sel_table->next_global ==
                        lex->create_info.merge_list);
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;

            lex->create_info.used_fields|= HA_CREATE_USED_UNION;
          }
#line 32738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 754: /* create_table_option: INSERT_METHOD opt_equal merge_insert_types  */
#line 6414 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.merge_insert_method= (yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_INSERT_METHOD;
          }
#line 32747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 755: /* create_table_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.data_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_DATADIR;
          }
#line 32756 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 756: /* create_table_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6424 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.index_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_INDEXDIR;
          }
#line 32765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 757: /* create_table_option: TABLESPACE ident  */
#line 6429 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.tablespace= (yyvsp[0].ident_sys).str;}
#line 32771 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 758: /* create_table_option: STORAGE_SYM DISK_SYM  */
#line 6431 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.storage_media= HA_SM_DISK;}
#line 32777 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 759: /* create_table_option: STORAGE_SYM MEMORY_SYM  */
#line 6433 "/home/buildbot/git/sql/sql_yacc.yy"
          {Lex->create_info.storage_media= HA_SM_MEMORY;}
#line 32783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 760: /* create_table_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6435 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.connect_string.str= (yyvsp[0].lex_str).str;
            Lex->create_info.connect_string.length= (yyvsp[0].lex_str).length;
            Lex->create_info.used_fields|= HA_CREATE_USED_CONNECTION;
          }
#line 32793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 761: /* create_table_option: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 6441 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
            Lex->create_info.key_block_size= (yyvsp[0].ulong_num);
          }
#line 32802 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 762: /* create_table_option: TRANSACTIONAL_SYM opt_equal choice  */
#line 6446 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_TRANSACTIONAL;
            Lex->create_info.transactional= (yyvsp[0].choice);
          }
#line 32811 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 763: /* create_table_option: IDENT_sys equal TEXT_STRING_sys  */
#line 6451 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32824 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 764: /* create_table_option: IDENT_sys equal ident  */
#line 6460 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 765: /* create_table_option: IDENT_sys equal real_ulonglong_num  */
#line 6469 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->create_info.option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 32847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 766: /* create_table_option: IDENT_sys equal DEFAULT  */
#line 6475 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32857 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 767: /* create_table_option: SEQUENCE_SYM opt_equal choice  */
#line 6481 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= ((yyvsp[0].choice) == HA_CHOICE_YES);
	  }
#line 32866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 771: /* versioning_option: WITH_SYSTEM_SYM VERSIONING_SYM  */
#line 6495 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.options & HA_LEX_CREATE_TMP_TABLE))
            {
              if (DBUG_EVALUATE_IF("sysvers_force", 0, 1))
              {
                my_error(ER_VERS_NOT_SUPPORTED, MYF(0), "CREATE TEMPORARY TABLE");
                MYSQL_YYABORT;
              }
            }
            else
            {
              Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
              Lex->create_info.options|= HA_VERSIONED_TABLE;
            }
          }
#line 32886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 772: /* default_charset: opt_default charset opt_equal charset_name_or_default  */
#line 6514 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->create_info.add_table_option_default_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
          }
#line 32895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 773: /* default_collation: opt_default COLLATE_SYM opt_equal collation_name_or_default  */
#line 6522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            HA_CREATE_INFO *cinfo= &Lex->create_info;
            if (unlikely((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                         cinfo->default_table_charset && (yyvsp[0].charset) &&
                         !((yyvsp[0].charset)= merge_charset_and_collation(cinfo->default_table_charset,
                                                           (yyvsp[0].charset)))))
              MYSQL_YYABORT;

            Lex->create_info.default_table_charset= (yyvsp[0].charset);
            Lex->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
          }
#line 32911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 774: /* storage_engines: ident_or_text  */
#line 6537 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Storage_engine_name((yyvsp[0].lex_str)).
                 resolve_storage_engine_with_error(thd, &(yyval.db_type),
                                            thd->lex->create_info.tmp_table()))
              MYSQL_YYABORT;
          }
#line 32922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 775: /* known_storage_engines: ident_or_text  */
#line 6547 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            plugin_ref plugin;
            if (likely((plugin= ha_resolve_by_name(thd, &(yyvsp[0].lex_str), false))))
              (yyval.db_type)= plugin_hton(plugin);
            else
              my_yyabort_error((ER_UNKNOWN_STORAGE_ENGINE, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 32934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 776: /* row_types: DEFAULT  */
#line 6557 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_DEFAULT; }
#line 32940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 777: /* row_types: FIXED_SYM  */
#line 6558 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_FIXED; }
#line 32946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 778: /* row_types: DYNAMIC_SYM  */
#line 6559 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_DYNAMIC; }
#line 32952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 779: /* row_types: COMPRESSED_SYM  */
#line 6560 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPRESSED; }
#line 32958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 780: /* row_types: REDUNDANT_SYM  */
#line 6561 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_REDUNDANT; }
#line 32964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 781: /* row_types: COMPACT_SYM  */
#line 6562 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPACT; }
#line 32970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 782: /* row_types: PAGE_SYM  */
#line 6563 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.row_type)= ROW_TYPE_PAGE; }
#line 32976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 783: /* merge_insert_types: NO_SYM  */
#line 6567 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_DISABLED; }
#line 32982 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 784: /* merge_insert_types: FIRST_SYM  */
#line 6568 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_FIRST; }
#line 32988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 785: /* merge_insert_types: LAST_SYM  */
#line 6569 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_LAST; }
#line 32994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 786: /* udf_type: STRING_SYM  */
#line 6573 "/home/buildbot/git/sql/sql_yacc.yy"
                     {(yyval.num) = (int) STRING_RESULT; }
#line 33000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 787: /* udf_type: REAL  */
#line 6574 "/home/buildbot/git/sql/sql_yacc.yy"
               {(yyval.num) = (int) REAL_RESULT; }
#line 33006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 788: /* udf_type: DECIMAL_SYM  */
#line 6575 "/home/buildbot/git/sql/sql_yacc.yy"
                      {(yyval.num) = (int) DECIMAL_RESULT; }
#line 33012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 789: /* udf_type: INT_SYM  */
#line 6576 "/home/buildbot/git/sql/sql_yacc.yy"
                  {(yyval.num) = (int) INT_RESULT; }
#line 33018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 790: /* create_field_list: field_list  */
#line 6582 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 33026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 791: /* create_field_list_parens: LEFT_PAREN_ALT field_list ')'  */
#line 6589 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 33034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 794: /* field_list_item: column_def  */
#line 6600 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 33040 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 798: /* field_list_item: PERIOD_SYM period_for_application_time  */
#line 6604 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 { }
#line 33046 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 799: /* column_def: field_spec  */
#line 6609 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.create_field)= (yyvsp[0].create_field); }
#line 33052 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 800: /* column_def: field_spec references  */
#line 6611 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.create_field)= (yyvsp[-1].create_field); }
#line 33058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 801: /* $@89: %empty  */
#line 6616 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-1].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 802: /* key_def: key_or_index opt_if_not_exists opt_ident opt_USING_key_algorithm $@89 '(' key_list ')' normal_key_options  */
#line 6621 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33074 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 803: /* $@90: %empty  */
#line 6623 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-2].ident_sys), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 804: /* key_def: key_or_index opt_if_not_exists ident TYPE_SYM btree_or_rtree $@90 '(' key_list ')' normal_key_options  */
#line 6628 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 805: /* $@91: %empty  */
#line 6630 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33100 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 806: /* key_def: fulltext opt_key_or_index opt_if_not_exists opt_ident $@91 '(' key_list ')' fulltext_key_options  */
#line 6635 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { }
#line 33106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 807: /* $@92: %empty  */
#line 6637 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 808: /* key_def: spatial opt_key_or_index opt_if_not_exists opt_ident $@92 '(' key_list ')' spatial_key_options  */
#line 6642 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { }
#line 33122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 809: /* $@93: %empty  */
#line 6646 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), (yyvsp[-1].lex_str).str ? &(yyvsp[-1].lex_str) : &(yyvsp[-4].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33132 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 810: /* key_def: opt_constraint constraint_key_type opt_if_not_exists opt_ident opt_USING_key_algorithm $@93 '(' key_list ')' normal_key_options  */
#line 6651 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 811: /* $@94: %empty  */
#line 6654 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-4].key_type), (yyvsp[-2].ident_sys).str ? &(yyvsp[-2].ident_sys) : &(yyvsp[-5].lex_str), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 33148 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 812: /* key_def: opt_constraint constraint_key_type opt_if_not_exists ident TYPE_SYM btree_or_rtree $@94 '(' key_list ')' normal_key_options  */
#line 6659 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { }
#line 33154 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 813: /* $@95: %empty  */
#line 6661 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->check_add_key((yyvsp[-1].object_ddl_options))) ||
                unlikely(!(Lex->last_key= (new (thd->mem_root)
                                           Key(Key::MULTIPLE,
                                           (yyvsp[-4].lex_str).str ? &(yyvsp[-4].lex_str) : &(yyvsp[0].lex_str),
                                           HA_KEY_ALG_UNDEF, true, (yyvsp[-1].object_ddl_options))))))
              MYSQL_YYABORT;
            Lex->option_list= NULL;
          }
#line 33168 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 814: /* key_def: opt_constraint FOREIGN KEY_SYM opt_if_not_exists opt_ident $@95 '(' key_list ')' references  */
#line 6671 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Key *key= (new (thd->mem_root)
                       Foreign_key((yyvsp[-5].lex_str).str ? &(yyvsp[-5].lex_str) : &(yyvsp[-9].lex_str),
                                   &lex->last_key->columns,
                                   &(yyvsp[0].table)->db,
                                   &(yyvsp[0].table)->table,
                                   &lex->ref_list,
                                   lex->fk_delete_opt,
                                   lex->fk_update_opt,
                                   lex->fk_match_option,
                                    (yyvsp[-6].object_ddl_options)));
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            /*
              handle_if_exists_options() expectes the two keys in this order:
              the Foreign_key, followed by its auto-generated Key.
            */
            lex->alter_info.key_list.push_back(key, thd->mem_root);
            lex->alter_info.key_list.push_back(Lex->last_key, thd->mem_root);
            lex->option_list= NULL;

            /* Only used for ALTER TABLE. Ignored otherwise. */
            lex->alter_info.flags|= ALTER_ADD_FOREIGN_KEY;
          }
#line 33198 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 815: /* constraint_def: opt_constraint check_constraint  */
#line 6700 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), FALSE);
         }
#line 33206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 816: /* period_for_system_time: PERIOD_SYM FOR_SYSTEM_TIME_SYM '(' ident ',' ident ')'  */
#line 6708 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Vers_parse_info &info= Lex->vers_get_info();
            info.set_period((yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys));
          }
#line 33215 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 817: /* period_for_application_time: FOR_SYM ident '(' ident ',' ident ')'  */
#line 6716 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->add_period((yyvsp[-5].ident_sys), (yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys)))
              MYSQL_YYABORT;
          }
#line 33224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 818: /* opt_check_constraint: %empty  */
#line 6723 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.virtual_column)= (Virtual_column_info*) 0; }
#line 33230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 819: /* opt_check_constraint: check_constraint  */
#line 6724 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.virtual_column)= (yyvsp[0].virtual_column);}
#line 33236 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 820: /* check_constraint: CHECK_SYM '(' expr ')'  */
#line 6729 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33247 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 821: /* opt_constraint_no_id: %empty  */
#line 6738 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 33253 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 822: /* opt_constraint_no_id: CONSTRAINT  */
#line 6739 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 33259 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 823: /* opt_constraint: %empty  */
#line 6743 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 33265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 824: /* opt_constraint: constraint  */
#line 6744 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 33271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 825: /* constraint: CONSTRAINT opt_ident  */
#line 6748 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 33277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 826: /* @96: %empty  */
#line 6753 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Create_field *f= new (thd->mem_root) Create_field();

            if (unlikely(check_string_char_length(&(yyvsp[0].lex_str), 0, NAME_CHAR_LEN,
                                                  system_charset_info, 1)))
              my_yyabort_error((ER_TOO_LONG_IDENT, MYF(0), (yyvsp[0].lex_str).str));

            if (unlikely(!f))
              MYSQL_YYABORT;

            lex->init_last_field(f, &(yyvsp[0].lex_str), NULL);
            (yyval.create_field)= f;
            lex->parsing_options.lookup_keywords_after_qualifier= true;
          }
#line 33297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 827: /* field_spec: field_ident @96 field_type_or_serial opt_check_constraint  */
#line 6769 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->parsing_options.lookup_keywords_after_qualifier= false;
            (yyval.create_field)= (yyvsp[-2].create_field);

            (yyval.create_field)->check_constraint= (yyvsp[0].virtual_column);

            if (unlikely((yyval.create_field)->check(thd)))
              MYSQL_YYABORT;

            lex->alter_info.create_list.push_back((yyval.create_field), thd->mem_root);

            (yyval.create_field)->create_if_not_exists= Lex->check_exists;
            if ((yyval.create_field)->flags & PRI_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::PRIMARY, lex->check_exists);
            else if ((yyval.create_field)->flags & UNIQUE_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::UNIQUE, lex->check_exists);
          }
#line 33320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 828: /* $@97: %empty  */
#line 6790 "/home/buildbot/git/sql/sql_yacc.yy"
                                { Lex->last_field->set_attributes((yyvsp[0].Lex_field_type), Lex->charset); }
#line 33326 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 830: /* $@98: %empty  */
#line 6793 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->set_handler(&type_handler_longlong);
            Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG
                                     | UNSIGNED_FLAG | UNIQUE_KEY_FLAG;
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 832: /* opt_serial_attribute: %empty  */
#line 6803 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 833: /* opt_serial_attribute: opt_serial_attribute_list  */
#line 6804 "/home/buildbot/git/sql/sql_yacc.yy"
                                    {}
#line 33349 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 834: /* opt_serial_attribute_list: opt_serial_attribute_list serial_attribute  */
#line 6808 "/home/buildbot/git/sql/sql_yacc.yy"
                                                     {}
#line 33355 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 836: /* opt_asrow_attribute: %empty  */
#line 6813 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 837: /* opt_asrow_attribute: opt_asrow_attribute_list  */
#line 6814 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 33367 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 838: /* opt_asrow_attribute_list: opt_asrow_attribute_list asrow_attribute  */
#line 6818 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   {}
#line 33373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 840: /* field_def: %empty  */
#line 6823 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 33379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 844: /* $@99: %empty  */
#line 6828 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->last_field->vcol_info= (yyvsp[0].virtual_column);
           Lex->last_field->flags&= ~NOT_NULL_FLAG; // undo automatic NOT NULL for timestamps
         }
#line 33388 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 846: /* field_def: opt_generated_always AS ROW_SYM START_SYM opt_asrow_attribute  */
#line 6834 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->last_field_generated_always_as_row_start())
              MYSQL_YYABORT;
          }
#line 33397 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 847: /* field_def: opt_generated_always AS ROW_SYM END opt_asrow_attribute  */
#line 6839 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->last_field_generated_always_as_row_end())
              MYSQL_YYABORT;
          }
#line 33406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 848: /* opt_generated_always: %empty  */
#line 6846 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33412 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 849: /* opt_generated_always: GENERATED_SYM ALWAYS_SYM  */
#line 6847 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 33418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 850: /* vcol_opt_specifier: %empty  */
#line 6852 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 33426 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 851: /* vcol_opt_specifier: VIRTUAL_SYM  */
#line 6856 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 33434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 852: /* vcol_opt_specifier: PERSISTENT_SYM  */
#line 6860 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 33442 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 853: /* vcol_opt_specifier: STORED_SYM  */
#line 6864 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 33450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 854: /* vcol_opt_attribute: %empty  */
#line 6870 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 33456 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 855: /* vcol_opt_attribute: vcol_opt_attribute_list  */
#line 6871 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 33462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 856: /* vcol_opt_attribute_list: vcol_opt_attribute_list vcol_attribute  */
#line 6875 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 {}
#line 33468 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 858: /* vcol_attribute: UNIQUE_SYM  */
#line 6881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 859: /* vcol_attribute: UNIQUE_SYM KEY_SYM  */
#line 6887 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 860: /* vcol_attribute: COMMENT_SYM TEXT_STRING_sys  */
#line 6892 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->last_field->comment= (yyvsp[0].lex_str); }
#line 33494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 861: /* vcol_attribute: INVISIBLE_SYM  */
#line 6894 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->invisible= INVISIBLE_USER;
          }
#line 33502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 862: /* $@100: %empty  */
#line 6901 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              "PARSE_VCOL_EXPR" can only be used by the SQL server
              when reading a '*.frm' file.
              Prevent the end user from invoking this command.
            */
            MYSQL_YYABORT_UNLESS(Lex->parse_vcol_expr);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 33517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 863: /* parse_vcol_expr: PARSE_VCOL_EXPR_SYM $@100 expr  */
#line 6912 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[0].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            Lex->last_field->vcol_info= v;
            Lex->pop_select(); //main select
          }
#line 33529 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 865: /* parenthesized_expr: expr ',' expr_list  */
#line 6924 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[0].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 33540 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 866: /* virtual_column_func: '(' parenthesized_expr ')'  */
#line 6934 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Virtual_column_info *v=
              add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33552 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 867: /* virtual_column_func: subquery  */
#line 6942 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item;
            if (!(item= new (thd->mem_root) Item_singlerow_subselect(thd, (yyvsp[0].select_lex))))
              MYSQL_YYABORT;
            Virtual_column_info *v= add_virtual_expression(thd, item);
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33566 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 871: /* column_default_expr: expr_or_literal  */
#line 6958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.virtual_column)= add_virtual_expression(thd, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 33575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 872: /* field_type: field_type_all  */
#line 6965 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 33584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 873: /* qualified_field_type: field_type_all  */
#line 6973 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          }
#line 33592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 874: /* qualified_field_type: sp_decl_ident '.' field_type_all  */
#line 6977 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->map_data_type((yyvsp[-2].ident_sys), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type))))
              MYSQL_YYABORT;
          }
#line 33601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 880: /* field_type_numeric: int_type opt_field_length field_options  */
#line 6992 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].const_simple_string)); }
#line 33607 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 881: /* field_type_numeric: real_type opt_precision field_options  */
#line 6993 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].Lex_length_and_dec)); }
#line 33613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 882: /* field_type_numeric: FLOAT_SYM float_options field_options  */
#line 6995 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_float, (yyvsp[-1].Lex_length_and_dec));
            if ((yyvsp[-1].Lex_length_and_dec).length() && !(yyvsp[-1].Lex_length_and_dec).dec())
            {
              int err;
              ulonglong tmp_length= my_strtoll10((yyvsp[-1].Lex_length_and_dec).length(), NULL, &err);
              if (unlikely(err || tmp_length > PRECISION_FOR_DOUBLE))
                my_yyabort_error((ER_WRONG_FIELD_SPEC, MYF(0),
                                  Lex->last_field->field_name.str));
              if (tmp_length > PRECISION_FOR_FLOAT)
                (yyval.Lex_field_type).set(&type_handler_double);
              else
                (yyval.Lex_field_type).set(&type_handler_float);
            }
          }
#line 33633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 883: /* field_type_numeric: BIT_SYM opt_field_length_default_1  */
#line 7011 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_bit, (yyvsp[0].const_simple_string));
          }
#line 33641 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 884: /* field_type_numeric: BOOL_SYM  */
#line 7015 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33649 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 885: /* field_type_numeric: BOOLEAN_SYM  */
#line 7019 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 886: /* field_type_numeric: DECIMAL_SYM float_options field_options  */
#line 7023 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 887: /* field_type_numeric: NUMBER_ORACLE_SYM float_options field_options  */
#line 7025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].Lex_length_and_dec).length() != 0)
              (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));
            else
              (yyval.Lex_field_type).set(&type_handler_double);
          }
#line 33674 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 888: /* field_type_numeric: NUMERIC_SYM float_options field_options  */
#line 7032 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33680 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 889: /* field_type_numeric: FIXED_SYM float_options field_options  */
#line 7034 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 894: /* field_type_string: char opt_field_length_default_1 opt_binary  */
#line 7047 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
          }
#line 33694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 895: /* field_type_string: nchar opt_field_length_default_1 opt_bin_mod  */
#line 7051 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 896: /* field_type_string: BINARY opt_field_length_default_1  */
#line 7056 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[0].const_simple_string));
          }
#line 33712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 897: /* field_type_string: varchar field_length opt_binary_and_compression  */
#line 7061 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 898: /* field_type_string: VARCHAR2_ORACLE_SYM field_length opt_binary_and_compression  */
#line 7065 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 899: /* field_type_string: nvarchar field_length opt_compressed opt_bin_mod  */
#line 7069 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-2].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 900: /* field_type_string: VARBINARY field_length opt_compressed  */
#line 7074 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33746 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 901: /* field_type_string: RAW_ORACLE_SYM field_length opt_compressed  */
#line 7079 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 902: /* field_type_temporal: YEAR_SYM opt_field_length field_options  */
#line 7087 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].const_simple_string))
            {
              errno= 0;
              ulong length= strtoul((yyvsp[-1].const_simple_string), NULL, 10);
              if (errno == 0 && length <= MAX_FIELD_BLOBLENGTH && length != 4)
              {
                char buff[sizeof("YEAR()") + MY_INT64_NUM_DECIMAL_DIGITS + 1];
                my_snprintf(buff, sizeof(buff), "YEAR(%lu)", length);
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_NOTE,
                                    ER_WARN_DEPRECATED_SYNTAX,
                                    ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                    buff, "YEAR(4)");
              }
            }
            (yyval.Lex_field_type).set(&type_handler_year, (yyvsp[-1].const_simple_string));
          }
#line 33777 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 903: /* field_type_temporal: DATE_SYM  */
#line 7104 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.Lex_field_type).set(&type_handler_newdate); }
#line 33783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 904: /* field_type_temporal: TIME_SYM opt_field_length  */
#line 7106 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_time2) :
                   static_cast<const Type_handler*>(&type_handler_time),
                   (yyvsp[0].const_simple_string));
          }
#line 33794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 905: /* field_type_temporal: TIMESTAMP opt_field_length  */
#line 7113 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_timestamp2):
                   static_cast<const Type_handler*>(&type_handler_timestamp),
                   (yyvsp[0].const_simple_string));
          }
#line 33805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 906: /* field_type_temporal: DATETIME opt_field_length  */
#line 7120 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_field_type).set(thd->type_handler_for_datetime(), (yyvsp[0].const_simple_string));
          }
#line 33813 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 907: /* field_type_lob: TINYBLOB opt_compressed  */
#line 7128 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_tiny_blob);
          }
#line 33822 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 908: /* field_type_lob: BLOB_MARIADB_SYM opt_field_length opt_compressed  */
#line 7133 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33831 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 909: /* field_type_lob: BLOB_ORACLE_SYM field_length opt_compressed  */
#line 7138 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33840 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 910: /* field_type_lob: BLOB_ORACLE_SYM opt_compressed  */
#line 7143 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33849 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 911: /* field_type_lob: spatial_type float_options srid_option  */
#line 7148 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            Lex->charset=&my_charset_bin;
            Lex->last_field->geom_type= (yyvsp[-2].geom_type);
            (yyval.Lex_field_type).set(&type_handler_geometry, (yyvsp[-1].Lex_length_and_dec));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 33864 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 912: /* field_type_lob: MEDIUMBLOB opt_compressed  */
#line 7159 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33873 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 913: /* field_type_lob: LONGBLOB opt_compressed  */
#line 7164 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 914: /* field_type_lob: LONG_SYM VARBINARY opt_compressed  */
#line 7169 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33891 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 915: /* field_type_lob: LONG_SYM varchar opt_binary_and_compression  */
#line 7174 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33897 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 916: /* field_type_lob: TINYTEXT opt_binary_and_compression  */
#line 7176 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_tiny_blob); }
#line 33903 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 917: /* field_type_lob: TEXT_SYM opt_field_length opt_binary_and_compression  */
#line 7178 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string)); }
#line 33909 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 918: /* field_type_lob: MEDIUMTEXT opt_binary_and_compression  */
#line 7180 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33915 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 919: /* field_type_lob: LONGTEXT opt_binary_and_compression  */
#line 7182 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33921 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 920: /* field_type_lob: CLOB_ORACLE_SYM opt_binary_and_compression  */
#line 7184 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 921: /* field_type_lob: LONG_SYM opt_binary_and_compression  */
#line 7186 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33933 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 922: /* field_type_lob: JSON_SYM opt_compressed  */
#line 7188 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= &my_charset_utf8mb4_bin;
            (yyval.Lex_field_type).set(&type_handler_json_longtext);
          }
#line 33942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 923: /* field_type_misc: ENUM '(' string_list ')' opt_binary  */
#line 7196 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_enum); }
#line 33948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 924: /* field_type_misc: SET '(' string_list ')' opt_binary  */
#line 7198 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_field_type).set(&type_handler_set); }
#line 33954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 925: /* spatial_type: GEOMETRY_SYM  */
#line 7202 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRY; }
#line 33960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 926: /* spatial_type: GEOMETRYCOLLECTION  */
#line 7203 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRYCOLLECTION; }
#line 33966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 927: /* spatial_type: POINT_SYM  */
#line 7204 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_POINT; }
#line 33972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 928: /* spatial_type: MULTIPOINT  */
#line 7205 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOINT; }
#line 33978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 929: /* spatial_type: LINESTRING  */
#line 7206 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_LINESTRING; }
#line 33984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 930: /* spatial_type: MULTILINESTRING  */
#line 7207 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTILINESTRING; }
#line 33990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 931: /* spatial_type: POLYGON  */
#line 7208 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_POLYGON; }
#line 33996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 932: /* spatial_type: MULTIPOLYGON  */
#line 7209 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOLYGON; }
#line 34002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 933: /* char: CHAR_SYM  */
#line 7213 "/home/buildbot/git/sql/sql_yacc.yy"
                   {}
#line 34008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 934: /* nchar: NCHAR_SYM  */
#line 7217 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 34014 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 935: /* nchar: NATIONAL_SYM CHAR_SYM  */
#line 7218 "/home/buildbot/git/sql/sql_yacc.yy"
                                {}
#line 34020 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 936: /* varchar: char VARYING  */
#line 7222 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 937: /* varchar: VARCHAR  */
#line 7223 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 938: /* nvarchar: NATIONAL_SYM VARCHAR  */
#line 7227 "/home/buildbot/git/sql/sql_yacc.yy"
                               {}
#line 34038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 939: /* nvarchar: NVARCHAR_SYM  */
#line 7228 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 940: /* nvarchar: NCHAR_SYM VARCHAR  */
#line 7229 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 34050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 941: /* nvarchar: NATIONAL_SYM CHAR_SYM VARYING  */
#line 7230 "/home/buildbot/git/sql/sql_yacc.yy"
                                        {}
#line 34056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 942: /* nvarchar: NCHAR_SYM VARYING  */
#line 7231 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 34062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 943: /* int_type: INT_SYM  */
#line 7235 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_long; }
#line 34068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 944: /* int_type: TINYINT  */
#line 7236 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_tiny; }
#line 34074 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 945: /* int_type: SMALLINT  */
#line 7237 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_short; }
#line 34080 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 946: /* int_type: MEDIUMINT  */
#line 7238 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_int24; }
#line 34086 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 947: /* int_type: BIGINT  */
#line 7239 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.type_handler)= &type_handler_longlong; }
#line 34092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 948: /* real_type: REAL  */
#line 7244 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.type_handler)= thd->variables.sql_mode & MODE_REAL_AS_FLOAT ?
              static_cast<const Type_handler *>(&type_handler_float) :
              static_cast<const Type_handler *>(&type_handler_double);
          }
#line 34102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 949: /* real_type: DOUBLE_SYM  */
#line 7249 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 34108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 950: /* real_type: DOUBLE_SYM PRECISION  */
#line 7250 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 34114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 951: /* srid_option: %empty  */
#line 7255 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->srid= 0; }
#line 34120 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 952: /* srid_option: REF_SYSTEM_ID_SYM '=' NUM  */
#line 7258 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->srid=atoi((yyvsp[0].lex_str).str);
          }
#line 34128 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 953: /* float_options: %empty  */
#line 7264 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec).set(0, 0);  }
#line 34134 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 954: /* float_options: field_length  */
#line 7265 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), 0); }
#line 34140 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 955: /* float_options: precision  */
#line 7266 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 34146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 956: /* precision: '(' NUM ',' NUM ')'  */
#line 7270 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.Lex_length_and_dec).set((yyvsp[-3].lex_str).str, (yyvsp[-1].lex_str).str); }
#line 34152 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 957: /* field_options: %empty  */
#line 7274 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34158 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 958: /* field_options: SIGNED_SYM  */
#line 7275 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 34164 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 959: /* field_options: UNSIGNED  */
#line 7276 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG;}
#line 34170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 960: /* field_options: ZEROFILL  */
#line 7277 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 961: /* field_options: UNSIGNED ZEROFILL  */
#line 7278 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 962: /* field_options: ZEROFILL UNSIGNED  */
#line 7279 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 34188 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 963: /* field_length: '(' LONG_NUM ')'  */
#line 7283 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34194 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 964: /* field_length: '(' ULONGLONG_NUM ')'  */
#line 7284 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 965: /* field_length: '(' DECIMAL_NUM ')'  */
#line 7285 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 966: /* field_length: '(' NUM ')'  */
#line 7286 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 34212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 967: /* opt_field_length: %empty  */
#line 7290 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (char*) 0; /* use default length */ }
#line 34218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 968: /* opt_field_length: field_length  */
#line 7291 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 34224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 969: /* opt_field_length_default_1: %empty  */
#line 7295 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (char*) "1"; }
#line 34230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 970: /* opt_field_length_default_1: field_length  */
#line 7296 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 34236 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 971: /* opt_precision: %empty  */
#line 7300 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_length_and_dec).set(0, 0); }
#line 34242 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 972: /* opt_precision: precision  */
#line 7301 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 34248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 973: /* attribute_list: attribute_list attribute  */
#line 7306 "/home/buildbot/git/sql/sql_yacc.yy"
                                   {}
#line 34254 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 975: /* attribute: NULL_SYM  */
#line 7311 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags&= ~ NOT_NULL_FLAG; }
#line 34260 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 976: /* attribute: DEFAULT column_default_expr  */
#line 7312 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->last_field->default_value= (yyvsp[0].virtual_column); }
#line 34266 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 977: /* attribute: ON UPDATE_SYM NOW_SYM opt_default_time_precision  */
#line 7314 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->last_field->on_update= item;
          }
#line 34277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 978: /* attribute: AUTO_INC  */
#line 7320 "/home/buildbot/git/sql/sql_yacc.yy"
                   { Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG; }
#line 34283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 979: /* attribute: SERIAL_SYM DEFAULT VALUE_SYM  */
#line 7322 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 34293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 980: /* attribute: COLLATE_SYM collation_name  */
#line 7328 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->charset && !my_charset_same(Lex->charset,(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name,Lex->charset->csname));
            Lex->last_field->charset= (yyvsp[0].charset);
          }
#line 34304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 982: /* opt_compression_method: %empty  */
#line 7338 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.const_simple_string)= NULL; }
#line 34310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 983: /* opt_compression_method: equal ident  */
#line 7339 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.const_simple_string)= (yyvsp[0].ident_sys).str; }
#line 34316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 984: /* opt_compressed: %empty  */
#line 7343 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 985: /* opt_compressed: compressed  */
#line 7344 "/home/buildbot/git/sql/sql_yacc.yy"
                     { }
#line 34328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 986: /* compressed: COMPRESSED_SYM opt_compression_method  */
#line 7349 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->set_compressed((yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 987: /* compressed_deprecated_data_type_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7357 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->set_compressed_deprecated(thd, (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 988: /* compressed_deprecated_column_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7365 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->last_field->
                set_compressed_deprecated_column_attribute(thd, (yyvsp[-1].kwd).pos(), (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 34356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 989: /* asrow_attribute: not NULL_SYM  */
#line 7374 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->flags|= NOT_NULL_FLAG;
          }
#line 34364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 990: /* asrow_attribute: opt_primary KEY_SYM  */
#line 7378 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= PRI_KEY_FLAG | NOT_NULL_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 34374 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 993: /* serial_attribute: IDENT_sys equal TEXT_STRING_sys  */
#line 7389 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 994: /* serial_attribute: IDENT_sys equal ident  */
#line 7398 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 995: /* serial_attribute: IDENT_sys equal real_ulonglong_num  */
#line 7407 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->last_field->option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 34410 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 996: /* serial_attribute: IDENT_sys equal DEFAULT  */
#line 7413 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34420 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 997: /* serial_attribute: with_or_without_system VERSIONING_SYM  */
#line 7419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_field->versioning= (yyvsp[-1].vers_column_versioning);
            Lex->create_info.options|= HA_VERSIONED_TABLE;
            if (Lex->alter_info.flags & ALTER_DROP_SYSTEM_VERSIONING)
            {
              my_yyabort_error((ER_VERS_NOT_VERSIONED, MYF(0),
                       Lex->create_last_non_select_table->table_name.str));
            }
          }
#line 34434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 998: /* with_or_without_system: WITH_SYSTEM_SYM  */
#line 7432 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.versioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITH_VERSIONING;
          }
#line 34444 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 999: /* with_or_without_system: WITHOUT SYSTEM  */
#line 7438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.unversioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITHOUT_VERSIONING;
          }
#line 34454 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1000: /* charset: CHAR_SYM SET  */
#line 7447 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 34460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1001: /* charset: CHARSET  */
#line 7448 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34466 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1002: /* charset_name: ident_or_text  */
#line 7453 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34475 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1003: /* charset_name: BINARY  */
#line 7457 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34481 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1004: /* charset_name_or_default: charset_name  */
#line 7461 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.charset)=(yyvsp[0].charset);   }
#line 34487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1005: /* charset_name_or_default: DEFAULT  */
#line 7462 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34493 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1006: /* opt_load_data_charset: %empty  */
#line 7466 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.charset)= NULL; }
#line 34499 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1007: /* opt_load_data_charset: charset charset_name_or_default  */
#line 7467 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.charset)= (yyvsp[0].charset); }
#line 34505 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1008: /* old_or_new_charset_name: ident_or_text  */
#line 7472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,
                                                    MY_CS_PRIMARY,MYF(0))) &&
                         !((yyval.charset)=get_old_charset_by_name((yyvsp[0].lex_str).str))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34516 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1009: /* old_or_new_charset_name: BINARY  */
#line 7478 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34522 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1010: /* old_or_new_charset_name_or_default: old_or_new_charset_name  */
#line 7482 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.charset)=(yyvsp[0].charset);   }
#line 34528 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1011: /* old_or_new_charset_name_or_default: DEFAULT  */
#line 7483 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34534 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1012: /* collation_name: ident_or_text  */
#line 7488 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)= mysqld_collation_get_by_name((yyvsp[0].lex_str).str))))
              MYSQL_YYABORT;
          }
#line 34543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1013: /* opt_collate: %empty  */
#line 7495 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.charset)=NULL; }
#line 34549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1014: /* opt_collate: COLLATE_SYM collation_name_or_default  */
#line 7496 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.charset)=(yyvsp[0].charset); }
#line 34555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1015: /* collation_name_or_default: collation_name  */
#line 7500 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.charset)=(yyvsp[0].charset); }
#line 34561 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1016: /* collation_name_or_default: DEFAULT  */
#line 7501 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.charset)=NULL; }
#line 34567 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1017: /* opt_default: %empty  */
#line 7505 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34573 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1018: /* opt_default: DEFAULT  */
#line 7506 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34579 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1019: /* charset_or_alias: charset charset_name  */
#line 7510 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34585 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1020: /* charset_or_alias: ASCII_SYM  */
#line 7511 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.charset)= &my_charset_latin1; }
#line 34591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1021: /* charset_or_alias: UNICODE_SYM  */
#line 7513 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.charset)= get_charset_by_csname("ucs2", MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), "ucs2"));
          }
#line 34600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1022: /* collate: COLLATE_SYM collation_name_or_default  */
#line 7519 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1023: /* opt_binary: %empty  */
#line 7523 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(NULL, false); }
#line 34612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1024: /* opt_binary: binary  */
#line 7524 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 34618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1025: /* binary: BYTE_SYM  */
#line 7528 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(&my_charset_bin, false); }
#line 34624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1026: /* binary: charset_or_alias opt_bin_mod  */
#line 7529 "/home/buildbot/git/sql/sql_yacc.yy"
                                       { bincmp_collation((yyvsp[-1].charset), (yyvsp[0].num)); }
#line 34630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1027: /* binary: BINARY  */
#line 7530 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation(NULL, true); }
#line 34636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1028: /* binary: BINARY charset_or_alias  */
#line 7531 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { bincmp_collation((yyvsp[0].charset), true); }
#line 34642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1029: /* binary: charset_or_alias collate  */
#line 7533 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].charset))
              Lex->charset= (yyvsp[-1].charset); // CHARACTER SET cs COLLATE DEFAULT
            else
            {
              if (!my_charset_same((yyvsp[0].charset), (yyvsp[-1].charset)))
                my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                  (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
              Lex->charset= (yyvsp[0].charset);
            }
          }
#line 34658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1030: /* binary: collate  */
#line 7544 "/home/buildbot/git/sql/sql_yacc.yy"
                  { Lex->charset= (yyvsp[0].charset); }
#line 34664 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1031: /* opt_bin_mod: %empty  */
#line 7548 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= false; }
#line 34670 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1032: /* opt_bin_mod: BINARY  */
#line 7549 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= true; }
#line 34676 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1033: /* $@101: %empty  */
#line 7554 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely((yyvsp[0].ulong_num) == 0))
          {
            thd->parse_error();
            MYSQL_YYABORT;
          }
        }
#line 34688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1034: /* ws_nweights: '(' real_ulong_num $@101 ')'  */
#line 7562 "/home/buildbot/git/sql/sql_yacc.yy"
        { (yyval.ulong_num)= (yyvsp[-2].ulong_num); }
#line 34694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1035: /* ws_level_flag_desc: ASC  */
#line 7566 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.ulong_num)= 0; }
#line 34700 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1036: /* ws_level_flag_desc: DESC  */
#line 7567 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.ulong_num)= 1 << MY_STRXFRM_DESC_SHIFT; }
#line 34706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1037: /* ws_level_flag_reverse: REVERSE_SYM  */
#line 7571 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 1 << MY_STRXFRM_REVERSE_SHIFT; }
#line 34712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1038: /* ws_level_flags: %empty  */
#line 7574 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 0; }
#line 34718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1039: /* ws_level_flags: ws_level_flag_desc  */
#line 7575 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34724 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1040: /* ws_level_flags: ws_level_flag_desc ws_level_flag_reverse  */
#line 7576 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   { (yyval.ulong_num)= (yyvsp[-1].ulong_num) | (yyvsp[0].ulong_num); }
#line 34730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1041: /* ws_level_flags: ws_level_flag_reverse  */
#line 7577 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.ulong_num)= (yyvsp[0].ulong_num) ; }
#line 34736 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1042: /* ws_level_number: real_ulong_num  */
#line 7582 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.ulong_num)= (yyvsp[0].ulong_num) < 1 ? 1 : ((yyvsp[0].ulong_num) > MY_STRXFRM_NLEVELS ? MY_STRXFRM_NLEVELS : (yyvsp[0].ulong_num));
          (yyval.ulong_num)--;
        }
#line 34745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1043: /* ws_level_list_item: ws_level_number ws_level_flags  */
#line 7590 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.ulong_num)= (1 | (yyvsp[0].ulong_num)) << (yyvsp[-1].ulong_num);
        }
#line 34753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1044: /* ws_level_list: ws_level_list_item  */
#line 7596 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1045: /* ws_level_list: ws_level_list ',' ws_level_list_item  */
#line 7597 "/home/buildbot/git/sql/sql_yacc.yy"
                                               { (yyval.ulong_num)|= (yyvsp[0].ulong_num); }
#line 34765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1046: /* ws_level_range: ws_level_number '-' ws_level_number  */
#line 7602 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          uint start= (yyvsp[-2].ulong_num);
          uint end= (yyvsp[0].ulong_num);
          for ((yyval.ulong_num)= 0; start <= end; start++)
            (yyval.ulong_num)|= (1 << start);
        }
#line 34776 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1047: /* ws_level_list_or_range: ws_level_list  */
#line 7611 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1048: /* ws_level_list_or_range: ws_level_range  */
#line 7612 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1049: /* opt_ws_levels: %empty  */
#line 7616 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.ulong_num)= 0; }
#line 34794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1050: /* opt_ws_levels: LEVEL_SYM ws_level_list_or_range  */
#line 7617 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1053: /* references: REFERENCES table_ident opt_ref_list opt_match_clause opt_on_update_delete  */
#line 7631 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)=(yyvsp[-3].table);
          }
#line 34808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1054: /* opt_ref_list: %empty  */
#line 7638 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->ref_list.empty(); }
#line 34814 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1056: /* ref_list: ref_list ',' ident  */
#line 7644 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            Lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1057: /* ref_list: ident  */
#line 7651 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->ref_list.empty();
            lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1058: /* opt_match_clause: %empty  */
#line 7663 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_UNDEF; }
#line 34844 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1059: /* opt_match_clause: MATCH FULL  */
#line 7665 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_FULL; }
#line 34850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1060: /* opt_match_clause: MATCH PARTIAL  */
#line 7667 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_PARTIAL; }
#line 34856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1061: /* opt_match_clause: MATCH SIMPLE_SYM  */
#line 7669 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_SIMPLE; }
#line 34862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1062: /* opt_on_update_delete: %empty  */
#line 7674 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34872 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1063: /* opt_on_update_delete: ON UPDATE_SYM delete_option  */
#line 7680 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1064: /* opt_on_update_delete: ON DELETE_SYM delete_option  */
#line 7686 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1065: /* opt_on_update_delete: ON UPDATE_SYM delete_option ON DELETE_SYM delete_option  */
#line 7693 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[-3].m_fk_option);
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1066: /* opt_on_update_delete: ON DELETE_SYM delete_option ON UPDATE_SYM delete_option  */
#line 7700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= (yyvsp[-3].m_fk_option);
          }
#line 34912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1067: /* delete_option: RESTRICT  */
#line 7708 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_RESTRICT; }
#line 34918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1068: /* delete_option: CASCADE  */
#line 7709 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_CASCADE; }
#line 34924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1069: /* delete_option: SET NULL_SYM  */
#line 7710 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_NULL; }
#line 34930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1070: /* delete_option: NO_SYM ACTION  */
#line 7711 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_NO_ACTION; }
#line 34936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1071: /* delete_option: SET DEFAULT  */
#line 7712 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_DEFAULT; }
#line 34942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1072: /* constraint_key_type: PRIMARY_SYM KEY_SYM  */
#line 7716 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.key_type)= Key::PRIMARY; }
#line 34948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1073: /* constraint_key_type: UNIQUE_SYM opt_key_or_index  */
#line 7717 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { (yyval.key_type)= Key::UNIQUE; }
#line 34954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1074: /* key_or_index: KEY_SYM  */
#line 7721 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1075: /* key_or_index: INDEX_SYM  */
#line 7722 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 34966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1076: /* opt_key_or_index: %empty  */
#line 7726 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 34972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1078: /* keys_or_index: KEYS  */
#line 7731 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 34978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1079: /* keys_or_index: INDEX_SYM  */
#line 7732 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 34984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1080: /* keys_or_index: INDEXES  */
#line 7733 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 34990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1081: /* opt_unique: %empty  */
#line 7737 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::MULTIPLE; }
#line 34996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1082: /* opt_unique: UNIQUE_SYM  */
#line 7738 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::UNIQUE; }
#line 35002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1083: /* fulltext: FULLTEXT_SYM  */
#line 7742 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.key_type)= Key::FULLTEXT;}
#line 35008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1084: /* spatial: SPATIAL_SYM  */
#line 7747 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.key_type)= Key::SPATIAL;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 35021 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1085: /* normal_key_options: %empty  */
#line 7758 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1086: /* normal_key_options: normal_key_opts  */
#line 7759 "/home/buildbot/git/sql/sql_yacc.yy"
                          { Lex->last_key->option_list= Lex->option_list; }
#line 35033 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1087: /* fulltext_key_options: %empty  */
#line 7763 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35039 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1088: /* fulltext_key_options: fulltext_key_opts  */
#line 7764 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->last_key->option_list= Lex->option_list; }
#line 35045 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1089: /* spatial_key_options: %empty  */
#line 7768 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 35051 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1090: /* spatial_key_options: spatial_key_opts  */
#line 7769 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Lex->last_key->option_list= Lex->option_list; }
#line 35057 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1097: /* opt_USING_key_algorithm: %empty  */
#line 7788 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 35063 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1098: /* opt_USING_key_algorithm: USING btree_or_rtree  */
#line 7789 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35069 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1099: /* opt_key_algorithm_clause: %empty  */
#line 7794 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 35075 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1100: /* opt_key_algorithm_clause: USING btree_or_rtree  */
#line 7795 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35081 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1101: /* opt_key_algorithm_clause: TYPE_SYM btree_or_rtree  */
#line 7796 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 35087 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1102: /* key_using_alg: USING btree_or_rtree  */
#line 7801 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 35093 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1103: /* key_using_alg: TYPE_SYM btree_or_rtree  */
#line 7803 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 35099 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1104: /* all_key_opt: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 7808 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->key_create_info.block_size= (yyvsp[0].ulong_num);
            Lex->last_key->key_create_info.flags|= HA_USES_BLOCK_SIZE;
         }
#line 35108 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1105: /* all_key_opt: COMMENT_SYM TEXT_STRING_sys  */
#line 7813 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_key->key_create_info.comment= (yyvsp[0].lex_str); }
#line 35114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1106: /* all_key_opt: IDENT_sys equal TEXT_STRING_sys  */
#line 7815 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1107: /* all_key_opt: IDENT_sys equal ident  */
#line 7823 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1108: /* all_key_opt: IDENT_sys equal real_ulonglong_num  */
#line 7831 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                  engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->option_list,
                                      &Lex->option_list_last, thd->mem_root);
          }
#line 35148 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1109: /* all_key_opt: IDENT_sys equal DEFAULT  */
#line 7837 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 35158 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1114: /* fulltext_key_opt: WITH PARSER_SYM IDENT_sys  */
#line 7856 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (likely(plugin_is_ready(&(yyvsp[0].ident_sys), MYSQL_FTPARSER_PLUGIN)))
              Lex->last_key->key_create_info.parser_name= (yyvsp[0].ident_sys);
            else
              my_yyabort_error((ER_FUNCTION_NOT_DEFINED, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1115: /* btree_or_rtree: BTREE_SYM  */
#line 7865 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_BTREE; }
#line 35175 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1116: /* btree_or_rtree: RTREE_SYM  */
#line 7866 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_RTREE; }
#line 35181 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1117: /* btree_or_rtree: HASH_SYM  */
#line 7867 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_HASH; }
#line 35187 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1118: /* key_list: key_list ',' key_part order_dir  */
#line 7872 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 35195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1119: /* key_list: key_part order_dir  */
#line 7876 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 35203 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1120: /* key_part: ident  */
#line 7883 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 35213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1121: /* key_part: ident '(' NUM ')'  */
#line 7889 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int key_part_len= atoi((yyvsp[-1].lex_str).str);
            if (unlikely(!key_part_len))
              my_yyabort_error((ER_KEY_PART_0, MYF(0), (yyvsp[-3].ident_sys).str));
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[-3].ident_sys), (uint) key_part_len);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 35226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1122: /* opt_ident: %empty  */
#line 7900 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 35232 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1123: /* opt_ident: field_ident  */
#line 7901 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 35238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1124: /* string_list: text_string  */
#line 7906 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 35244 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1125: /* string_list: string_list ',' text_string  */
#line 7908 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 35250 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1126: /* $@102: %empty  */
#line 7917 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->name= null_clex_str;
            Lex->table_type= TABLE_TYPE_UNKNOWN;
            Lex->sql_command= SQLCOM_ALTER_TABLE;
            Lex->duplicates= DUP_ERROR;
            Lex->first_select_lex()->order_list.empty();
            Lex->create_info.init();
            Lex->create_info.row_type= ROW_TYPE_NOT_USED;
            Lex->alter_info.reset();
            Lex->no_write_to_binlog= 0;
            Lex->create_info.storage_media= HA_SM_DEFAULT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            DBUG_ASSERT(!Lex->m_sql_cmd);
          }
#line 35270 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1127: /* $@103: %empty  */
#line 7933 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                   TL_READ_NO_INSERT, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            Lex->first_select_lex()->db=
              (Lex->first_select_lex()->table_list.first)->db;
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->mark_first_table_as_inserting();
          }
#line 35285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1128: /* alter: ALTER $@102 alter_options TABLE_SYM table_ident opt_lock_wait_timeout $@103 alter_commands  */
#line 7944 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (likely(!Lex->m_sql_cmd))
            {
              /* Create a generic ALTER TABLE statment. */
              Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table();
              if (unlikely(Lex->m_sql_cmd == NULL))
                MYSQL_YYABORT;
            }
            Lex->pop_select(); //main select
          }
#line 35300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1129: /* $@104: %empty  */
#line 7955 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 35311 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1130: /* alter: ALTER DATABASE ident_or_empty $@104 create_database_options  */
#line 7962 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_ALTER_DB;
            lex->name= (yyvsp[-2].ident_sys);
            if (lex->name.str == NULL &&
                unlikely(lex->copy_db_to(&lex->name)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 35325 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1131: /* alter: ALTER DATABASE ident UPGRADE_SYM DATA_SYM DIRECTORY_SYM NAME_SYM  */
#line 7972 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "DATABASE"));
            lex->sql_command= SQLCOM_ALTER_DB_UPGRADE;
            lex->name= (yyvsp[-4].ident_sys);
          }
#line 35337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1132: /* $@105: %empty  */
#line 7980 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 35351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1133: /* alter: ALTER PROCEDURE_SYM sp_name $@105 sp_a_chistics  */
#line 7990 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_PROCEDURE;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35365 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1134: /* $@106: %empty  */
#line 8000 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 35379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1135: /* alter: ALTER FUNCTION_SYM sp_name $@106 sp_a_chistics  */
#line 8010 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_FUNCTION;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35393 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1136: /* $@107: %empty  */
#line 8020 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, (yyvsp[-4].num), (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 35404 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1137: /* alter: ALTER view_algorithm definer_opt opt_view_suid VIEW_SYM table_ident $@107 view_list_opt AS view_select  */
#line 8027 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35414 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1138: /* $@108: %empty  */
#line 8038 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, VIEW_ALGORITHM_INHERIT, (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 35425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1139: /* alter: ALTER definer_opt opt_view_suid VIEW_SYM table_ident $@108 view_list_opt AS view_select  */
#line 8045 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1140: /* $@109: %empty  */
#line 8051 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              It is safe to use Lex->spname because
              ALTER EVENT xxx RENATE TO yyy DO ALTER EVENT RENAME TO
              is not allowed. Lex->spname is used in the case of RENAME TO
              If it had to be supported spname had to be added to
              Event_parse_data.
            */

            if (unlikely(!(Lex->event_parse_data= Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            Lex->event_parse_data->identifier= (yyvsp[0].spname);

            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_begin= (yyvsp[-2].simple_string);
          }
#line 35458 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1141: /* alter: ALTER definer_opt remember_name EVENT_SYM sp_name $@109 ev_alter_on_schedule_completion opt_ev_rename_to opt_ev_status opt_ev_comment opt_ev_sql_stmt  */
#line 8074 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyvsp[-4].num) || (yyvsp[-3].num) || (yyvsp[-2].num) || (yyvsp[-1].num) || (yyvsp[0].num))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_end= (char*)YYLIP->get_cpp_ptr();

            Lex->pop_select(); //main select
          }
#line 35478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1142: /* alter: ALTER TABLESPACE alter_tablespace_info  */
#line 8090 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_TABLESPACE;
          }
#line 35487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1143: /* alter: ALTER LOGFILE_SYM GROUP_SYM alter_logfile_group_info  */
#line 8095 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_LOGFILE_GROUP;
          }
#line 35496 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1144: /* alter: ALTER TABLESPACE change_tablespace_info  */
#line 8100 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= CHANGE_FILE_TABLESPACE;
          }
#line 35505 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1145: /* alter: ALTER TABLESPACE change_tablespace_access  */
#line 8105 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_ACCESS_MODE_TABLESPACE;
          }
#line 35514 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1146: /* $@110: %empty  */
#line 8110 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_ALTER_SERVER;
            lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 35524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1147: /* alter: ALTER SERVER_SYM ident_or_text $@110 OPTIONS_SYM '(' server_options_list ')'  */
#line 8114 "/home/buildbot/git/sql/sql_yacc.yy"
                                                    { }
#line 35530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1148: /* alter: ALTER USER_SYM opt_if_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 8118 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_info.set((yyvsp[-5].object_ddl_options));
            Lex->sql_command= SQLCOM_ALTER_USER;
          }
#line 35539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1149: /* $@111: %empty  */
#line 8123 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->name= null_clex_str;
            lex->table_type= TABLE_TYPE_UNKNOWN;
            lex->sql_command= SQLCOM_ALTER_SEQUENCE;
            lex->create_info.init();
            lex->no_write_to_binlog= 0;
            DBUG_ASSERT(!lex->m_sql_cmd);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 35555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1150: /* $@112: %empty  */
#line 8135 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!(lex->create_info.seq_create_info= new (thd->mem_root)
                                                     sequence_definition()) ||
                !lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_SEQUENCE,
                                    TL_WRITE, MDL_EXCLUSIVE))
              MYSQL_YYABORT;
          }
#line 35569 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1151: /* alter: ALTER SEQUENCE_SYM opt_if_exists $@111 table_ident $@112 sequence_defs  */
#line 8145 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Create a generic ALTER SEQUENCE statment. */
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_sequence((yyvsp[-4].object_ddl_options));
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1152: /* account_locking_option: LOCK_SYM  */
#line 8158 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_LOCKED;
          }
#line 35591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1153: /* account_locking_option: UNLOCK_SYM  */
#line 8162 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_UNLOCKED;
          }
#line 35599 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1154: /* opt_password_expire_option: %empty  */
#line 8169 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NOW;
          }
#line 35607 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1155: /* opt_password_expire_option: NEVER_SYM  */
#line 8173 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NEVER;
          }
#line 35615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1156: /* opt_password_expire_option: DEFAULT  */
#line 8177 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_DEFAULT;
          }
#line 35623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1157: /* opt_password_expire_option: INTERVAL_SYM NUM DAY_SYM  */
#line 8181 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_INTERVAL;
            if (!(Lex->account_options.num_expiration_days= atoi((yyvsp[-1].lex_str).str)))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "DAY", (yyvsp[-1].lex_str).str));
          }
#line 35633 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1163: /* ev_alter_on_schedule_completion: %empty  */
#line 8197 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0;}
#line 35639 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1164: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time  */
#line 8198 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.num)= 1; }
#line 35645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1165: /* ev_alter_on_schedule_completion: ev_on_completion  */
#line 8199 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.num)= 1; }
#line 35651 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1166: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time ev_on_completion  */
#line 8200 "/home/buildbot/git/sql/sql_yacc.yy"
                                                            { (yyval.num)= 1; }
#line 35657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1167: /* opt_ev_rename_to: %empty  */
#line 8204 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0;}
#line 35663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1168: /* opt_ev_rename_to: RENAME TO_SYM sp_name  */
#line 8206 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Use lex's spname to hold the new name.
              The original name is in the Event_parse_data object
            */
            Lex->spname= (yyvsp[0].spname); 
            (yyval.num)= 1;
          }
#line 35676 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1169: /* opt_ev_sql_stmt: %empty  */
#line 8217 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.num)= 0;}
#line 35682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1170: /* opt_ev_sql_stmt: DO_SYM ev_sql_stmt  */
#line 8218 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= 1; }
#line 35688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1171: /* ident_or_empty: %empty  */
#line 8222 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.ident_sys)= Lex_ident_sys(); }
#line 35694 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1174: /* alter_commands: DISCARD TABLESPACE  */
#line 8229 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::DISCARD_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35706 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1175: /* alter_commands: IMPORT TABLESPACE  */
#line 8237 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::IMPORT_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1181: /* alter_commands: DROP PARTITION_SYM opt_if_exists alt_part_name_list  */
#line 8259 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_DROP;
            DBUG_ASSERT(!Lex->if_exists());
            Lex->create_info.add((yyvsp[-1].object_ddl_options));
          }
#line 35728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1182: /* alter_commands: REBUILD_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8266 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_REBUILD;
            lex->no_write_to_binlog= (yyvsp[-1].num);
          }
#line 35738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1183: /* $@113: %empty  */
#line 8273 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_optimize_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1185: /* alter_commands: ANALYZE_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8286 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_analyze_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
               MYSQL_YYABORT;
          }
#line 35768 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1186: /* $@114: %empty  */
#line 8297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_check_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1188: /* $@115: %empty  */
#line 8309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_repair_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35797 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1190: /* alter_commands: COALESCE PARTITION_SYM opt_no_write_to_binlog real_ulong_num  */
#line 8321 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_COALESCE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->alter_info.num_parts= (yyvsp[0].ulong_num);
          }
#line 35808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1191: /* alter_commands: TRUNCATE_SYM PARTITION_SYM all_or_alt_part_name_list  */
#line 8328 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_truncate_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35822 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1193: /* alter_commands: EXCHANGE_SYM PARTITION_SYM alt_part_name_item WITH TABLE_SYM table_ident have_partitioning  */
#line 8340 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_alter_table_exchange_partition((yyvsp[-1].table)))
              MYSQL_YYABORT;
          }
#line 35831 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1194: /* remove_partitioning: REMOVE_SYM PARTITIONING_SYM  */
#line 8348 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REMOVE;
          }
#line 35839 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1195: /* all_or_alt_part_name_list: ALL  */
#line 8355 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ALL;
          }
#line 35847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1197: /* $@116: %empty  */
#line 8364 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->alter_info.partition_flags|= ALTER_PARTITION_ADD;
            DBUG_ASSERT(!Lex->create_info.if_not_exists());
            lex->create_info.set((yyvsp[-1].object_ddl_options));
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35863 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1198: /* add_partition_rule: ADD PARTITION_SYM opt_if_not_exists opt_no_write_to_binlog $@116 add_part_extra  */
#line 8376 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 35869 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1200: /* add_part_extra: '(' part_def_list ')'  */
#line 8382 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info->num_parts= lex->part_info->partitions.elements;
          }
#line 35878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1201: /* add_part_extra: PARTITIONS_SYM real_ulong_num  */
#line 8387 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->part_info->num_parts= (yyvsp[0].ulong_num);
          }
#line 35886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1202: /* $@117: %empty  */
#line 8394 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1204: /* reorg_parts_rule: %empty  */
#line 8407 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_TABLE_REORG;
          }
#line 35907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1205: /* $@118: %empty  */
#line 8411 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REORGANIZE;
          }
#line 35915 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1206: /* reorg_parts_rule: alt_part_name_list $@118 INTO '(' part_def_list ')'  */
#line 8415 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_parts= part_info->partitions.elements;
          }
#line 35924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1207: /* alt_part_name_list: alt_part_name_item  */
#line 8422 "/home/buildbot/git/sql/sql_yacc.yy"
                             {}
#line 35930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1208: /* alt_part_name_list: alt_part_name_list ',' alt_part_name_item  */
#line 8423 "/home/buildbot/git/sql/sql_yacc.yy"
                                                    {}
#line 35936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1209: /* alt_part_name_item: ident  */
#line 8428 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.partition_names.push_back((yyvsp[0].ident_sys).str,
                                                                   thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 35946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1213: /* alter_list_item: add_column column_def opt_place  */
#line 8450 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->create_last_non_select_table= lex->last_table();
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1214: /* alter_list_item: ADD key_def  */
#line 8457 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1215: /* alter_list_item: ADD period_for_system_time  */
#line 8462 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_PERIOD;
          }
#line 35974 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1216: /* alter_list_item: ADD PERIOD_SYM opt_if_not_exists_table_element period_for_application_time  */
#line 8467 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_period_info &period= Lex->create_info.period_info;
            period.create_if_not_exists= Lex->check_exists;
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
          }
#line 35984 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1217: /* alter_list_item: add_column '(' create_field_list ')'  */
#line 8473 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            if (!lex->alter_info.key_list.is_empty())
              lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35995 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1218: /* alter_list_item: ADD constraint_def  */
#line 8480 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
	  }
#line 36003 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1219: /* alter_list_item: ADD CONSTRAINT IF_SYM not EXISTS field_ident check_constraint  */
#line 8484 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), TRUE);
         }
#line 36012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1220: /* alter_list_item: CHANGE opt_column opt_if_exists_table_element field_ident field_spec opt_place  */
#line 8490 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN | ALTER_RENAME_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-2].lex_str);
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 36023 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1221: /* alter_list_item: MODIFY_SYM opt_column opt_if_exists_table_element field_spec opt_place  */
#line 8498 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-1].create_field)->field_name;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 36034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1222: /* alter_list_item: DROP opt_column opt_if_exists_table_element field_ident opt_restrict  */
#line 8505 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::COLUMN, (yyvsp[-1].lex_str).str, (yyvsp[-2].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_PARSER_DROP_COLUMN;
          }
#line 36048 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1223: /* alter_list_item: DROP CONSTRAINT opt_if_exists_table_element field_ident  */
#line 8515 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::CHECK_CONSTRAINT,
                                        (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 36063 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1224: /* alter_list_item: DROP FOREIGN KEY_SYM opt_if_exists_table_element field_ident  */
#line 8526 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::FOREIGN_KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_FOREIGN_KEY;
          }
#line 36077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1225: /* alter_list_item: DROP opt_constraint_no_id PRIMARY_SYM KEY_SYM  */
#line 8536 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, primary_key_name,
                                        FALSE));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 36092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1226: /* alter_list_item: DROP key_or_index opt_if_exists_table_element field_ident  */
#line 8547 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 36106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1227: /* alter_list_item: DISABLE_SYM KEYS  */
#line 8557 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::DISABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 36116 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1228: /* alter_list_item: ENABLE_SYM KEYS  */
#line 8563 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::ENABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 36126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1229: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident SET DEFAULT column_default_expr  */
#line 8569 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (check_expression((yyvsp[0].virtual_column), &(yyvsp[-3].lex_str), VCOL_DEFAULT))
              MYSQL_YYABORT;
            if (unlikely(Lex->add_alter_list((yyvsp[-3].lex_str).str, (yyvsp[0].virtual_column), (yyvsp[-4].num))))
              MYSQL_YYABORT;
          }
#line 36137 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1230: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident DROP DEFAULT  */
#line 8576 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_alter_list((yyvsp[-2].lex_str).str, (Virtual_column_info*) 0,
                                             (yyvsp[-3].num))))
              MYSQL_YYABORT;
          }
#line 36147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1231: /* alter_list_item: RENAME opt_to table_ident  */
#line 8582 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->db= (yyvsp[0].table)->db;
            if (lex->first_select_lex()->db.str == NULL &&
                lex->copy_db_to(&lex->first_select_lex()->db))
              MYSQL_YYABORT;
            if (unlikely(check_table_name((yyvsp[0].table)->table.str,(yyvsp[0].table)->table.length,
                                          FALSE)) ||
                ((yyvsp[0].table)->db.str && unlikely(check_db_name((LEX_STRING*) &(yyvsp[0].table)->db))))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[0].table)->table.str));
            lex->name= (yyvsp[0].table)->table;
            lex->alter_info.flags|= ALTER_RENAME;
          }
#line 36165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1232: /* alter_list_item: CONVERT_SYM TO_SYM charset charset_name_or_default opt_collate  */
#line 8596 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[-1].charset))
            {
              (yyvsp[-1].charset)= thd->variables.collation_database;
            }
            (yyvsp[0].charset)= (yyvsp[0].charset) ? (yyvsp[0].charset) : (yyvsp[-1].charset);
            if (unlikely(!my_charset_same((yyvsp[-1].charset),(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
            if (unlikely(Lex->create_info.add_alter_list_item_convert_to_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
            Lex->alter_info.flags|= ALTER_CONVERT_TO;
          }
#line 36183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1233: /* alter_list_item: create_table_options_space_separated  */
#line 8610 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_OPTIONS;
          }
#line 36192 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1234: /* alter_list_item: FORCE_SYM  */
#line 8615 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_RECREATE;
          }
#line 36200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1235: /* alter_list_item: alter_order_clause  */
#line 8619 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_ORDER;
          }
#line 36209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1238: /* alter_list_item: ADD SYSTEM VERSIONING_SYM  */
#line 8626 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
            Lex->create_info.options|= HA_VERSIONED_TABLE;
          }
#line 36218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1239: /* alter_list_item: DROP SYSTEM VERSIONING_SYM  */
#line 8631 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_SYSTEM_VERSIONING;
            Lex->create_info.options&= ~HA_VERSIONED_TABLE;
          }
#line 36227 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1240: /* alter_list_item: DROP PERIOD_SYM FOR_SYSTEM_TIME_SYM  */
#line 8636 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_PERIOD;
          }
#line 36235 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1241: /* alter_list_item: DROP PERIOD_SYM opt_if_exists_table_element FOR_SYM ident  */
#line 8640 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Alter_drop *ad= new Alter_drop(Alter_drop::PERIOD, (yyvsp[0].ident_sys).str, (yyvsp[-2].num));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            Lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            Lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 36247 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1247: /* alter_algorithm_option: ALGORITHM_SYM opt_equal DEFAULT  */
#line 8659 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.set_requested_algorithm(
              Alter_info::ALTER_TABLE_ALGORITHM_DEFAULT);
          }
#line 36256 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1248: /* alter_algorithm_option: ALGORITHM_SYM opt_equal ident  */
#line 8664 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_algorithm(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_ALGORITHM, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 36265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1249: /* alter_lock_option: LOCK_SYM opt_equal DEFAULT  */
#line 8672 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_DEFAULT;
          }
#line 36274 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1250: /* alter_lock_option: LOCK_SYM opt_equal ident  */
#line 8677 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_lock(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_LOCK, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 36283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1251: /* opt_column: %empty  */
#line 8684 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 36289 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1252: /* opt_column: COLUMN_SYM  */
#line 8685 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 36295 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1253: /* opt_ignore: %empty  */
#line 8689 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->ignore= 0;}
#line 36301 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1254: /* opt_ignore: IGNORE_SYM  */
#line 8690 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1;}
#line 36307 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1255: /* $@119: %empty  */
#line 8694 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->ignore= 0;}
#line 36313 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1261: /* alter_option: IGNORE_SYM  */
#line 8708 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1;}
#line 36319 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1262: /* alter_option: ONLINE_SYM  */
#line 8710 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_NONE;
          }
#line 36328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1263: /* opt_restrict: %empty  */
#line 8717 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_DEFAULT; }
#line 36334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1264: /* opt_restrict: RESTRICT  */
#line 8718 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_RESTRICT; }
#line 36340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1265: /* opt_restrict: CASCADE  */
#line 8719 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->drop_mode= DROP_CASCADE; }
#line 36346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1266: /* opt_place: %empty  */
#line 8723 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.lex_str)= null_clex_str; }
#line 36352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1267: /* opt_place: AFTER_SYM ident  */
#line 8725 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str)= (yyvsp[0].ident_sys);
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 36361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1268: /* opt_place: FIRST_SYM  */
#line 8730 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str).str=    first_keyword;
	    (yyval.lex_str).length= 5; /* Length of "first" */
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 36371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1269: /* opt_to: %empty  */
#line 8738 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 36377 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1270: /* opt_to: TO_SYM  */
#line 8739 "/home/buildbot/git/sql/sql_yacc.yy"
                 {}
#line 36383 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1271: /* opt_to: '='  */
#line 8740 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36389 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1272: /* opt_to: AS  */
#line 8741 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 36395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1273: /* $@120: %empty  */
#line 8746 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_START;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE START too */
          }
#line 36406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1274: /* slave: START_SYM SLAVE optional_connection_name slave_thread_opts $@120 slave_until  */
#line 8753 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36412 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1275: /* $@121: %empty  */
#line 8755 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_START;
            lex->type = 0;
            /* If you change this code don't forget to update STOP SLAVE too */
          }
#line 36423 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1276: /* slave: START_SYM ALL SLAVES slave_thread_opts $@121  */
#line 8761 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1277: /* slave: STOP_SYM SLAVE optional_connection_name slave_thread_opts  */
#line 8763 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1278: /* slave: STOP_SYM ALL SLAVES slave_thread_opts  */
#line 8770 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1279: /* start: START_SYM TRANSACTION_SYM opt_start_transaction_option_list  */
#line 8780 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_BEGIN;
            /* READ ONLY and READ WRITE are mutually exclusive. */
            if (unlikely(((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_WRITE) &&
                         ((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_ONLY)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            lex->start_transaction_opt= (yyvsp[0].num);
          }
#line 36468 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1280: /* opt_start_transaction_option_list: %empty  */
#line 8796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= 0;
          }
#line 36476 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1281: /* opt_start_transaction_option_list: start_transaction_option_list  */
#line 8800 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36484 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1282: /* start_transaction_option_list: start_transaction_option  */
#line 8807 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36492 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1283: /* start_transaction_option_list: start_transaction_option_list ',' start_transaction_option  */
#line 8811 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (yyvsp[-2].num) | (yyvsp[0].num);
          }
#line 36500 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1284: /* start_transaction_option: WITH CONSISTENT_SYM SNAPSHOT_SYM  */
#line 8818 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_WITH_CONS_SNAPSHOT;
          }
#line 36508 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1285: /* start_transaction_option: READ_SYM ONLY_SYM  */
#line 8822 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_ONLY;
          }
#line 36516 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1286: /* start_transaction_option: READ_SYM WRITE_SYM  */
#line 8826 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_WRITE;
          }
#line 36524 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1287: /* $@122: %empty  */
#line 8832 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->slave_thd_opt= 0; }
#line 36530 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1288: /* slave_thread_opts: $@122 slave_thread_opt_list  */
#line 8834 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36536 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1291: /* slave_thread_opt: %empty  */
#line 8843 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 36542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1292: /* slave_thread_opt: SQL_THREAD  */
#line 8844 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->slave_thd_opt|=SLAVE_SQL; }
#line 36548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1293: /* slave_thread_opt: RELAY_THREAD  */
#line 8845 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->slave_thd_opt|=SLAVE_IO; }
#line 36554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1294: /* slave_until: %empty  */
#line 8849 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 36560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1295: /* slave_until: UNTIL_SYM slave_until_opts  */
#line 8851 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(((lex->mi.log_file_name || lex->mi.pos) &&
                         (lex->mi.relay_log_name || lex->mi.relay_log_pos)) ||
                         !((lex->mi.log_file_name && lex->mi.pos) ||
                           (lex->mi.relay_log_name && lex->mi.relay_log_pos))))
               my_yyabort_error((ER_BAD_SLAVE_UNTIL_COND, MYF(0)));
          }
#line 36573 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1296: /* slave_until: UNTIL_SYM MASTER_GTID_POS_SYM '=' TEXT_STRING_sys  */
#line 8860 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->mi.gtid_pos_str = (yyvsp[0].lex_str);
          }
#line 36581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1299: /* $@123: %empty  */
#line 8872 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_CHECKSUM;
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1300: /* checksum: CHECKSUM_SYM table_or_tables $@123 table_list opt_checksum_type  */
#line 8879 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1301: /* opt_checksum_type: %empty  */
#line 8883 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= 0; }
#line 36604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1302: /* opt_checksum_type: QUICK  */
#line 8884 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= T_QUICK; }
#line 36610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1303: /* opt_checksum_type: EXTENDED_SYM  */
#line 8885 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->check_opt.flags= T_EXTEND; }
#line 36616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1305: /* $@124: %empty  */
#line 8891 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1307: /* $@125: %empty  */
#line 8897 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPAIR;
            lex->no_write_to_binlog= (yyvsp[0].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1308: /* repair: REPAIR opt_no_write_to_binlog $@125 repair_table_or_view  */
#line 8907 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_repair_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1309: /* opt_mi_repair_type: %empty  */
#line 8917 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1310: /* opt_mi_repair_type: mi_repair_types  */
#line 8918 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 36660 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1311: /* mi_repair_types: mi_repair_type  */
#line 8922 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 36666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1312: /* mi_repair_types: mi_repair_type mi_repair_types  */
#line 8923 "/home/buildbot/git/sql/sql_yacc.yy"
                                         {}
#line 36672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1313: /* mi_repair_type: QUICK  */
#line 8927 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.flags|= T_QUICK; }
#line 36678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1314: /* mi_repair_type: EXTENDED_SYM  */
#line 8928 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.flags|= T_EXTEND; }
#line 36684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1315: /* mi_repair_type: USE_FRM  */
#line 8929 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->check_opt.sql_flags|= TT_USEFRM; }
#line 36690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1316: /* opt_view_repair_type: %empty  */
#line 8933 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 36696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1317: /* opt_view_repair_type: FROM MYSQL_SYM  */
#line 8934 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->check_opt.sql_flags|= TT_FROM_MYSQL; }
#line 36702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1318: /* $@126: %empty  */
#line 8939 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_ANALYZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36716 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1319: /* analyze: ANALYZE_SYM opt_no_write_to_binlog table_or_tables $@126 analyze_table_list  */
#line 8949 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_analyze_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1323: /* opt_persistent_stat_clause: %empty  */
#line 8969 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36734 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1324: /* opt_persistent_stat_clause: PERSISTENT_SYM FOR_SYM persistent_stat_spec  */
#line 8971 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            thd->lex->with_persistent_for_clause= TRUE;
          }
#line 36742 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1325: /* persistent_stat_spec: ALL  */
#line 8978 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36748 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1326: /* persistent_stat_spec: COLUMNS persistent_column_stat_spec INDEXES persistent_index_stat_spec  */
#line 8980 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1327: /* persistent_column_stat_spec: ALL  */
#line 8984 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1328: /* $@127: %empty  */
#line 8986 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX* lex= thd->lex;
            lex->column_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->column_list == NULL))
              MYSQL_YYABORT;
          }
#line 36771 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1329: /* persistent_column_stat_spec: '(' $@127 table_column_list ')'  */
#line 8994 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 36777 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1330: /* persistent_index_stat_spec: ALL  */
#line 8998 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 36783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1331: /* $@128: %empty  */
#line 9000 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX* lex= thd->lex;
            lex->index_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->index_list == NULL))
              MYSQL_YYABORT;
          }
#line 36794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1332: /* persistent_index_stat_spec: '(' $@128 table_index_list ')'  */
#line 9008 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 36800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1333: /* table_column_list: %empty  */
#line 9013 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1334: /* table_column_list: ident  */
#line 9015 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1335: /* table_column_list: table_column_list ',' ident  */
#line 9020 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36824 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1336: /* table_index_list: %empty  */
#line 9028 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 36830 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1339: /* table_index_name: ident  */
#line 9035 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->index_list->push_back((LEX_STRING*)
                                       thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)),
                                       thd->mem_root);
          }
#line 36840 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1340: /* table_index_name: PRIMARY_SYM  */
#line 9042 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_STRING str= {(char*) "PRIMARY", 7};
            Lex->index_list->push_back((LEX_STRING*)
                                        thd->memdup(&str, sizeof(LEX_STRING)),
                                        thd->mem_root);
          }
#line 36851 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1341: /* binlog_base64_event: BINLOG_SYM TEXT_STRING_sys  */
#line 9052 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[0].lex_str);
            Lex->ident.str=    NULL;
            Lex->ident.length= 0;
          }
#line 36862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1342: /* binlog_base64_event: BINLOG_SYM '@' ident_or_text ',' '@' ident_or_text  */
#line 9060 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[-3].lex_str);
            Lex->ident=   (yyvsp[0].lex_str);
          }
#line 36872 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1344: /* $@129: %empty  */
#line 9070 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1346: /* $@130: %empty  */
#line 9075 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->sql_command = SQLCOM_CHECK;
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1347: /* check: CHECK_SYM $@130 check_view_or_table  */
#line 9085 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "CHECK"));
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_check_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36906 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1348: /* opt_mi_check_type: %empty  */
#line 9097 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36912 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1349: /* opt_mi_check_type: mi_check_types  */
#line 9098 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 36918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1350: /* mi_check_types: mi_check_type  */
#line 9102 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 36924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1351: /* mi_check_types: mi_check_type mi_check_types  */
#line 9103 "/home/buildbot/git/sql/sql_yacc.yy"
                                       {}
#line 36930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1352: /* mi_check_type: QUICK  */
#line 9107 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_QUICK; }
#line 36936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1353: /* mi_check_type: FAST_SYM  */
#line 9108 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_FAST; }
#line 36942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1354: /* mi_check_type: MEDIUM_SYM  */
#line 9109 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_MEDIUM; }
#line 36948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1355: /* mi_check_type: EXTENDED_SYM  */
#line 9110 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_EXTEND; }
#line 36954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1356: /* mi_check_type: CHANGED  */
#line 9111 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.flags|= T_CHECK_ONLY_CHANGED; }
#line 36960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1357: /* mi_check_type: FOR_SYM UPGRADE_SYM  */
#line 9112 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1358: /* opt_view_check_type: %empty  */
#line 9116 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 36972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1359: /* opt_view_check_type: FOR_SYM UPGRADE_SYM  */
#line 9117 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1360: /* $@131: %empty  */
#line 9122 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_OPTIMIZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36992 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1361: /* optimize: OPTIMIZE opt_no_write_to_binlog table_or_tables $@131 table_list opt_lock_wait_timeout  */
#line 9132 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_optimize_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 37004 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1362: /* opt_no_write_to_binlog: %empty  */
#line 9142 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 37010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1363: /* opt_no_write_to_binlog: NO_WRITE_TO_BINLOG  */
#line 9143 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= 1; }
#line 37016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1364: /* opt_no_write_to_binlog: LOCAL_SYM  */
#line 9144 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= 1; }
#line 37022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1365: /* $@132: %empty  */
#line 9149 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_RENAME_TABLE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 37032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1366: /* rename: RENAME table_or_tables $@132 table_to_table_list  */
#line 9155 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 37040 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1367: /* rename: RENAME USER_SYM clear_privileges rename_list  */
#line 9159 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_RENAME_USER;
          }
#line 37048 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1368: /* rename_list: user TO_SYM user  */
#line 9166 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 37058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1369: /* rename_list: rename_list ',' user TO_SYM user  */
#line 9172 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 37068 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1372: /* table_to_table: table_ident opt_lock_wait_timeout TO_SYM table_ident  */
#line 9186 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            SELECT_LEX *sl= lex->current_select;
            if (unlikely(!sl->add_table_to_list(thd, (yyvsp[-3].table),NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)) ||
                unlikely(!sl->add_table_to_list(thd, (yyvsp[0].table), NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)))
              MYSQL_YYABORT;
          }
#line 37084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1373: /* $@133: %empty  */
#line 9201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.reset();
          }
#line 37092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1374: /* keycache: CACHE_SYM INDEX_SYM $@133 keycache_list_or_parts IN_SYM key_cache_name  */
#line 9205 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ASSIGN_TO_KEYCACHE;
            lex->ident= (yyvsp[0].lex_str);
          }
#line 37102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1379: /* assign_to_keycache: table_ident cache_keys_spec  */
#line 9224 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37114 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1380: /* assign_to_keycache_parts: table_ident adm_partition cache_keys_spec  */
#line 9235 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37126 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1381: /* key_cache_name: ident  */
#line 9245 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 37132 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1382: /* key_cache_name: DEFAULT  */
#line 9246 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str) = default_key_cache_base; }
#line 37138 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1383: /* $@134: %empty  */
#line 9251 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_PRELOAD_KEYS;
            lex->alter_info.reset();
            if (lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 37150 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1384: /* preload: LOAD INDEX_SYM INTO CACHE_SYM $@134 preload_list_or_parts  */
#line 9259 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 37158 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1389: /* preload_keys: table_ident cache_keys_spec opt_ignore_leaves  */
#line 9276 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1390: /* preload_keys_parts: table_ident adm_partition cache_keys_spec opt_ignore_leaves  */
#line 9287 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-3].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 37182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1391: /* $@135: %empty  */
#line 9298 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ADMIN;
          }
#line 37190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1393: /* $@136: %empty  */
#line 9305 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->first_select_lex()->alloc_index_hints(thd);
            Select->set_index_hint_type(INDEX_HINT_USE,
                                        INDEX_HINT_MASK_ALL);
          }
#line 37200 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1395: /* cache_key_list_or_empty: %empty  */
#line 9314 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 37206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1397: /* opt_ignore_leaves: %empty  */
#line 9320 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= 0; }
#line 37212 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1398: /* opt_ignore_leaves: IGNORE_SYM LEAVES  */
#line 9321 "/home/buildbot/git/sql/sql_yacc.yy"
                            { (yyval.num)= TL_OPTION_IGNORE_LEAVES; }
#line 37218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1399: /* $@137: %empty  */
#line 9331 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 37229 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1400: /* select: query_expression_no_with_clause $@137 opt_procedure_or_into  */
#line 9338 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause(NULL);
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 37240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1401: /* $@138: %empty  */
#line 9345 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 37251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1402: /* select: with_clause query_expression_no_with_clause $@138 opt_procedure_or_into  */
#line 9352 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex_unit)->first_select());
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 37263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1403: /* $@139: %empty  */
#line 9363 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 37272 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1404: /* select_into: select_into_query_specification $@139 opt_order_limit_lock  */
#line 9368 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 37286 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1405: /* $@140: %empty  */
#line 9379 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 37295 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1406: /* select_into: with_clause select_into_query_specification $@140 opt_order_limit_lock  */
#line 9384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            unit->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 37311 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1407: /* simple_table: query_specification  */
#line 9398 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37317 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1408: /* simple_table: table_value_constructor  */
#line 9399 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37323 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1409: /* $@141: %empty  */
#line 9404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_TVC_start())
              MYSQL_YYABORT;
	  }
#line 37332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1410: /* table_value_constructor: VALUES $@141 values_list  */
#line 9409 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_TVC_end()))
	      MYSQL_YYABORT;
	  }
#line 37341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1411: /* $@142: %empty  */
#line 9417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel;
            LEX *lex= Lex;
            if (!(sel= lex->alloc_select(TRUE)) ||
                  lex->push_select(sel))
              MYSQL_YYABORT;
            sel->init_select();
            sel->braces= FALSE;
          }
#line 37355 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1412: /* $@143: %empty  */
#line 9427 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= SELECT_LIST;
          }
#line 37363 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1413: /* query_specification_start: SELECT_SYM $@142 select_options $@143 select_item_list  */
#line 9431 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
          }
#line 37371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1414: /* query_specification: query_specification_start opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9443 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 37379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1415: /* select_into_query_specification: query_specification_start into opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9456 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 37387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1416: /* query_expression: query_expression_no_with_clause  */
#line 9514 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause(NULL);
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 37396 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1417: /* query_expression: with_clause query_expression_no_with_clause  */
#line 9520 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause((yyvsp[-1].with_clause));
            (yyvsp[-1].with_clause)->attach_to((yyvsp[0].select_lex_unit)->first_select());
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 37406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1418: /* query_expression_no_with_clause: query_expression_body_ext  */
#line 9533 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37412 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1419: /* query_expression_no_with_clause: query_expression_body_ext_parens  */
#line 9534 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1420: /* $@144: %empty  */
#line 9549 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[0].select_lex_unit)->first_select()->next_select())
            {
              if (Lex->parsed_multi_operand_query_expression_body((yyvsp[0].select_lex_unit)))
                MYSQL_YYABORT;
            }
          }
#line 37430 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1421: /* query_expression_body_ext: query_expression_body $@144 opt_query_expression_tail  */
#line 9557 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].order_limit_lock))
              (yyval.select_lex_unit)= (yyvsp[-2].select_lex_unit);
            else
              (yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock));
          }
#line 37441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1422: /* $@145: %empty  */
#line 9564 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->push_select(!(yyvsp[0].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[0].select_lex_unit)->first_select() : (yyvsp[0].select_lex_unit)->fake_select_lex);
          }
#line 37450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1423: /* query_expression_body_ext: query_expression_body_ext_parens $@145 query_expression_tail  */
#line 9569 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body_ext_parens((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock))))
               MYSQL_YYABORT;
          }
#line 37459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1424: /* query_expression_body_ext_parens: '(' query_expression_body_ext_parens ')'  */
#line 9577 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit); }
#line 37465 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1425: /* query_expression_body_ext_parens: '(' query_expression_body_ext ')'  */
#line 9579 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= (yyvsp[-1].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[-1].select_lex_unit)->fake_select_lex : (yyvsp[-1].select_lex_unit)->first_select();
            sel->braces= true;
            (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit);
          }
#line 37476 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1426: /* query_expression_body: query_simple  */
#line 9594 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->push_select((yyvsp[0].select_lex));
            if (!((yyval.select_lex_unit)= Lex->create_unit((yyvsp[0].select_lex))))
              MYSQL_YYABORT;
          }
#line 37486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1427: /* $@146: %empty  */
#line 9601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[-1].select_lex_unit)->first_select()->next_select())
            {
              Lex->pop_select();
            }
          }
#line 37497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1428: /* query_expression_body: query_expression_body unit_type_decl $@146 query_primary  */
#line 9608 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body((yyvsp[-3].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-2].unit_operation).unit_type,
                                                                (yyvsp[-2].unit_operation).distinct,
                                                                FALSE)))
              MYSQL_YYABORT;
          }
#line 37509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1429: /* query_expression_body: query_expression_body_ext_parens unit_type_decl query_primary  */
#line 9618 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body_ext_parens(
                                                                (yyvsp[-2].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-1].unit_operation).unit_type,
                                                                (yyvsp[-1].unit_operation).distinct)))
              MYSQL_YYABORT;
          }
#line 37521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1430: /* query_primary: query_simple  */
#line 9634 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37527 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1431: /* query_primary: query_expression_body_ext_parens  */
#line 9636 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex_unit)->first_select(); }
#line 37533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1432: /* query_simple: simple_table  */
#line 9645 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.select_lex)= (yyvsp[0].select_lex);}
#line 37539 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1433: /* subselect: query_expression  */
#line 9650 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37548 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1434: /* subquery: query_expression_body_ext_parens  */
#line 9691 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!(yyvsp[0].select_lex_unit)->fake_select_lex)
              (yyvsp[0].select_lex_unit)->first_select()->braces= false;
            else
              (yyvsp[0].select_lex_unit)->fake_select_lex->braces= false;
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37561 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1435: /* subquery: '(' with_clause query_expression_no_with_clause ')'  */
#line 9700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to((yyvsp[-1].select_lex_unit)->first_select());
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[-1].select_lex_unit))))
              MYSQL_YYABORT;
          }
#line 37572 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1439: /* table_reference_list: join_table_list  */
#line 9719 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->context.table_list=
              Select->context.first_name_resolution_table=
                Select->table_list.first;
          }
#line 37582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1442: /* select_options: select_option_list  */
#line 9734 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((Select->options & SELECT_DISTINCT) &&
                         (Select->options & SELECT_ALL)))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "ALL", "DISTINCT"));
          }
#line 37592 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1443: /* opt_history_unit: %empty  */
#line 9743 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_UNDEFINED;
          }
#line 37600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1444: /* opt_history_unit: TRANSACTION_SYM  */
#line 9747 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_TRX_ID;
          }
#line 37608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1445: /* opt_history_unit: TIMESTAMP  */
#line 9751 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_range_unit)= VERS_TIMESTAMP;
          }
#line 37616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1446: /* history_point: TIMESTAMP TEXT_STRING  */
#line 9758 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item;
            if (!(item= type_handler_datetime.create_literal_item(thd,
                                                     (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                     YYCSCL, true)))
              MYSQL_YYABORT;
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, item);
          }
#line 37629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1447: /* history_point: function_call_keyword_timestamp  */
#line 9767 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item));
          }
#line 37637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1448: /* history_point: opt_history_unit bit_expr  */
#line 9771 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.vers_history_point)= Vers_history_point((yyvsp[-1].vers_range_unit), (yyvsp[0].item));
          }
#line 37645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1449: /* for_portion_of_time_clause: FOR_SYM PORTION_SYM OF_SYM remember_tok_start ident FROM bit_expr TO_SYM bit_expr  */
#line 9779 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(0 == strcasecmp((yyvsp[-4].ident_sys).str, "SYSTEM_TIME")))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-5].simple_string));
              MYSQL_YYABORT;
            }
            Lex->period_conditions.init(SYSTEM_TIME_FROM_TO,
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[-2].item)),
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item)),
                                        (yyvsp[-4].ident_sys));
          }
#line 37661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1450: /* opt_for_portion_of_time_clause: %empty  */
#line 9794 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= false;
          }
#line 37669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1451: /* opt_for_portion_of_time_clause: for_portion_of_time_clause  */
#line 9798 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= true;
          }
#line 37677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1452: /* opt_for_system_time_clause: %empty  */
#line 9805 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= false;
          }
#line 37685 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1453: /* opt_for_system_time_clause: FOR_SYSTEM_TIME_SYM system_time_expr  */
#line 9809 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= true;
          }
#line 37693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1454: /* system_time_expr: AS OF_SYM history_point  */
#line 9816 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_AS_OF, (yyvsp[0].vers_history_point));
          }
#line 37701 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1455: /* system_time_expr: ALL  */
#line 9820 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 37709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1456: /* system_time_expr: FROM history_point TO_SYM history_point  */
#line 9824 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_FROM_TO, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1457: /* system_time_expr: BETWEEN_SYM history_point AND_SYM history_point  */
#line 9828 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BETWEEN, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37725 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1461: /* select_option: SQL_NO_CACHE_SYM  */
#line 9841 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_NO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_NO_CACHE"));
            Select->options|= OPTION_NO_QUERY_CACHE;
          }
#line 37738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1462: /* select_option: SQL_CACHE_SYM  */
#line 9850 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_TO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_CACHE"));
            Select->options|= OPTION_TO_QUERY_CACHE;
          }
#line 37751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1463: /* select_lock_type: FOR_SYM UPDATE_SYM opt_lock_wait_timeout_new  */
#line 9863 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= TRUE;
          }
#line 37761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1464: /* select_lock_type: LOCK_SYM IN_SYM SHARE_SYM MODE_SYM opt_lock_wait_timeout_new  */
#line 9869 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= FALSE;
          }
#line 37771 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1465: /* opt_select_lock_type: %empty  */
#line 9879 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37779 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1466: /* opt_select_lock_type: select_lock_type  */
#line 9883 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock)= (yyvsp[0].select_lock);
        }
#line 37787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1467: /* opt_lock_wait_timeout_new: %empty  */
#line 9891 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37795 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1468: /* opt_lock_wait_timeout_new: WAIT_SYM ulong_num  */
#line 9895 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= (yyvsp[0].ulong_num);
        }
#line 37804 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1469: /* opt_lock_wait_timeout_new: NOWAIT_SYM  */
#line 9900 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= 0;
        }
#line 37813 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1472: /* select_item_list: '*'  */
#line 9910 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root)
                          Item_field(thd, &thd->lex->current_select->context,
                                     NULL, NULL, &star_clex_str);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_item_to_list(thd, item)))
              MYSQL_YYABORT;
            (thd->lex->current_select->with_wild)++;
          }
#line 37828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1473: /* select_item: remember_name select_sublist_qualified_asterisk remember_end  */
#line 9924 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_item_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
          }
#line 37837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1474: /* select_item: remember_name expr remember_end select_alias  */
#line 9929 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT((yyvsp[-3].simple_string) < (yyvsp[-1].simple_string));

            if (unlikely(add_item_to_list(thd, (yyvsp[-2].item))))
              MYSQL_YYABORT;
            if ((yyvsp[0].lex_str).str)
            {
              if (unlikely(Lex->sql_command == SQLCOM_CREATE_VIEW &&
                          check_column_name((yyvsp[0].lex_str).str)))
                my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), (yyvsp[0].lex_str).str));
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            else if (!(yyvsp[-2].item)->name.str || (yyvsp[-2].item)->name.str == item_empty_name)
            {
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            }
          }
#line 37860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1475: /* remember_tok_start: %empty  */
#line 9950 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_tok_start();
          }
#line 37868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1476: /* remember_name: %empty  */
#line 9956 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_start();
          }
#line 37876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1477: /* remember_end: %empty  */
#line 9962 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1478: /* select_alias: %empty  */
#line 9968 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str)=null_clex_str;}
#line 37890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1479: /* select_alias: AS ident  */
#line 9969 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1480: /* select_alias: AS TEXT_STRING_sys  */
#line 9970 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1481: /* select_alias: ident  */
#line 9971 "/home/buildbot/git/sql/sql_yacc.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37908 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1482: /* select_alias: TEXT_STRING_sys  */
#line 9972 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37914 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1483: /* opt_default_time_precision: %empty  */
#line 9976 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1484: /* opt_default_time_precision: '(' ')'  */
#line 9977 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37926 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1485: /* opt_default_time_precision: '(' real_ulong_num ')'  */
#line 9978 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1486: /* opt_time_precision: %empty  */
#line 9982 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= 0;  }
#line 37938 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1487: /* opt_time_precision: '(' ')'  */
#line 9983 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= 0;  }
#line 37944 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1488: /* opt_time_precision: '(' real_ulong_num ')'  */
#line 9984 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37950 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1489: /* optional_braces: %empty  */
#line 9988 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 37956 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1490: /* optional_braces: '(' ')'  */
#line 9989 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 37962 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1491: /* expr: expr or expr  */
#line 9995 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Design notes:
              Do not use a manually maintained stack like thd->lex->xxx_list,
              but use the internal bison stack ($$, $1 and $3) instead.
              Using the bison stack is:
              - more robust to changes in the grammar,
              - guaranteed to be in sync with the parser state,
              - better for performances (no memory allocation).
            */
            Item_cond_or *item1;
            Item_cond_or *item3;
            if (is_cond_or((yyvsp[-2].item)))
            {
              item1= (Item_cond_or*) (yyvsp[-2].item);
              if (is_cond_or((yyvsp[0].item)))
              {
                item3= (Item_cond_or*) (yyvsp[0].item);
                /*
                  (X1 OR X2) OR (Y1 OR Y2) ==> OR (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 OR X2) OR Y ==> OR (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_or((yyvsp[0].item)))
            {
              item3= (Item_cond_or*) (yyvsp[0].item);
              /*
                X OR (Y1 OR Y2) ==> OR (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X OR Y */
              (yyval.item)= new (thd->mem_root) Item_cond_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 38017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1492: /* expr: expr XOR expr  */
#line 10046 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* XOR is a proprietary extension */
            (yyval.item)= new (thd->mem_root) Item_func_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38028 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1493: /* expr: expr and expr  */
#line 10053 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* See comments in rule expr: expr or expr */
            Item_cond_and *item1;
            Item_cond_and *item3;
            if (is_cond_and((yyvsp[-2].item)))
            {
              item1= (Item_cond_and*) (yyvsp[-2].item);
              if (is_cond_and((yyvsp[0].item)))
              {
                item3= (Item_cond_and*) (yyvsp[0].item);
                /*
                  (X1 AND X2) AND (Y1 AND Y2) ==> AND (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 AND X2) AND Y ==> AND (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_and((yyvsp[0].item)))
            {
              item3= (Item_cond_and*) (yyvsp[0].item);
              /*
                X AND (Y1 AND Y2) ==> AND (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X AND Y */
              (yyval.item)= new (thd->mem_root) Item_cond_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 38075 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1494: /* expr: NOT_SYM expr  */
#line 10096 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38085 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1496: /* boolean_test: boolean_test IS TRUE_SYM  */
#line 10106 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_istrue(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1497: /* boolean_test: boolean_test IS not TRUE_SYM  */
#line 10112 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnottrue(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38105 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1498: /* boolean_test: boolean_test IS FALSE_SYM  */
#line 10118 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isfalse(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1499: /* boolean_test: boolean_test IS not FALSE_SYM  */
#line 10124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotfalse(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38125 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1500: /* boolean_test: boolean_test IS UNKNOWN_SYM  */
#line 10130 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38135 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1501: /* boolean_test: boolean_test IS not UNKNOWN_SYM  */
#line 10136 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1502: /* boolean_test: boolean_test IS NULL_SYM  */
#line 10142 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38155 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1503: /* boolean_test: boolean_test IS not NULL_SYM  */
#line 10148 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1504: /* boolean_test: boolean_test EQUAL_SYM predicate  */
#line 10154 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_equal(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38175 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1505: /* boolean_test: boolean_test comp_op predicate  */
#line 10160 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (*(yyvsp[-1].boolfunc2creator))(0)->create(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1506: /* boolean_test: boolean_test comp_op all_or_any '(' subselect ')'  */
#line 10166 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= all_any_subquery_creator(thd, (yyvsp[-5].item), (yyvsp[-4].boolfunc2creator), (yyvsp[-3].num), (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1508: /* predicate: predicate IN_SYM subquery  */
#line 10176 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-2].item), (yyvsp[0].select_lex));
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38205 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1509: /* predicate: predicate not IN_SYM subquery  */
#line 10182 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-3].item), (yyvsp[0].select_lex));
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38218 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1510: /* predicate: predicate IN_SYM '(' expr ')'  */
#line 10191 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-4].item), true, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1511: /* predicate: predicate IN_SYM '(' expr ',' expr_list ')'  */
#line 10197 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-6].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1512: /* predicate: predicate not IN_SYM '(' expr ')'  */
#line 10205 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-5].item), false, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38250 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1513: /* predicate: predicate not IN_SYM '(' expr ',' expr_list ')'  */
#line 10211 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-7].item), thd->mem_root);
            Item_func_in *item= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1514: /* predicate: predicate BETWEEN_SYM predicate AND_SYM predicate  */
#line 10220 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_between(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1515: /* predicate: predicate not BETWEEN_SYM predicate AND_SYM predicate  */
#line 10226 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_func_between *item;
            item= new (thd->mem_root) Item_func_between(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1516: /* predicate: predicate SOUNDS_SYM LIKE predicate  */
#line 10234 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item1= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[-3].item));
            Item *item4= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[0].item));
            if (unlikely(item1 == NULL) || unlikely(item4 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_eq(thd, item1, item4);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38299 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1517: /* predicate: predicate LIKE predicate  */
#line 10244 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-2].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1518: /* predicate: predicate LIKE predicate ESCAPE_SYM predicate  */
#line 10250 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->escape_used= true;
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 38320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1519: /* predicate: predicate not LIKE predicate  */
#line 10257 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-3].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38331 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1520: /* predicate: predicate not LIKE predicate ESCAPE_SYM predicate  */
#line 10264 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->escape_used= true;
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 38343 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1521: /* predicate: predicate REGEXP predicate  */
#line 10272 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38353 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1522: /* predicate: predicate not REGEXP predicate  */
#line 10278 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-3].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1524: /* bit_expr: bit_expr '|' bit_expr  */
#line 10291 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1525: /* bit_expr: bit_expr '&' bit_expr  */
#line 10297 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38386 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1526: /* bit_expr: bit_expr SHIFT_LEFT bit_expr  */
#line 10303 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_left(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38396 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1527: /* bit_expr: bit_expr SHIFT_RIGHT bit_expr  */
#line 10309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_right(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1528: /* bit_expr: bit_expr ORACLE_CONCAT_SYM bit_expr  */
#line 10315 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat_operator_oracle(thd,
                                                                     (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38417 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1529: /* bit_expr: bit_expr '+' bit_expr  */
#line 10322 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_plus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1530: /* bit_expr: bit_expr '-' bit_expr  */
#line 10328 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38437 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1531: /* bit_expr: bit_expr '+' INTERVAL_SYM expr interval  */
#line 10334 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1532: /* bit_expr: bit_expr '-' INTERVAL_SYM expr interval  */
#line 10340 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38457 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1533: /* bit_expr: INTERVAL_SYM expr interval '+' expr  */
#line 10347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1534: /* bit_expr: '+' INTERVAL_SYM expr interval '+' expr  */
#line 10353 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38477 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1535: /* bit_expr: '-' INTERVAL_SYM expr interval '+' expr  */
#line 10359 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1536: /* bit_expr: bit_expr '*' bit_expr  */
#line 10365 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mul(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1537: /* bit_expr: bit_expr '/' bit_expr  */
#line 10371 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38507 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1538: /* bit_expr: bit_expr '%' bit_expr  */
#line 10377 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1539: /* bit_expr: bit_expr DIV_SYM bit_expr  */
#line 10383 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_int_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38527 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1540: /* bit_expr: bit_expr MOD_SYM bit_expr  */
#line 10389 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38537 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1541: /* bit_expr: bit_expr '^' bit_expr  */
#line 10395 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1551: /* comp_op: '='  */
#line 10424 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.boolfunc2creator) = &comp_eq_creator; }
#line 38553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1552: /* comp_op: GE  */
#line 10425 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_ge_creator; }
#line 38559 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1553: /* comp_op: '>'  */
#line 10426 "/home/buildbot/git/sql/sql_yacc.yy"
              { (yyval.boolfunc2creator) = &comp_gt_creator; }
#line 38565 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1554: /* comp_op: LE  */
#line 10427 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_le_creator; }
#line 38571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1555: /* comp_op: '<'  */
#line 10428 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.boolfunc2creator) = &comp_lt_creator; }
#line 38577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1556: /* comp_op: NE  */
#line 10429 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.boolfunc2creator) = &comp_ne_creator; }
#line 38583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1557: /* all_or_any: ALL  */
#line 10433 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.num) = 1; }
#line 38589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1558: /* all_or_any: ANY_SYM  */
#line 10434 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.num) = 0; }
#line 38595 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1559: /* opt_dyncol_type: %empty  */
#line 10439 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_NULL); /* automatic type */
            Lex->charset= NULL;
	  }
#line 38604 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1560: /* opt_dyncol_type: AS dyncol_type  */
#line 10443 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1561: /* dyncol_type: numeric_dyncol_type  */
#line 10447 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38616 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1562: /* dyncol_type: temporal_dyncol_type  */
#line 10448 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38622 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1563: /* dyncol_type: string_dyncol_type  */
#line 10449 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38628 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1564: /* numeric_dyncol_type: INT_SYM  */
#line 10453 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_INT); }
#line 38634 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1565: /* numeric_dyncol_type: UNSIGNED INT_SYM  */
#line 10454 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_UINT);  }
#line 38640 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1566: /* numeric_dyncol_type: DOUBLE_SYM  */
#line 10455 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE);  }
#line 38646 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1567: /* numeric_dyncol_type: REAL  */
#line 10456 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38652 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1568: /* numeric_dyncol_type: FLOAT_SYM  */
#line 10457 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1569: /* numeric_dyncol_type: DECIMAL_SYM float_options  */
#line 10458 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DECIMAL, (yyvsp[0].Lex_length_and_dec)); }
#line 38664 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1570: /* temporal_dyncol_type: DATE_SYM  */
#line 10462 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATE); }
#line 38670 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1571: /* temporal_dyncol_type: TIME_SYM opt_field_length  */
#line 10463 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_TIME, 0, (yyvsp[0].const_simple_string)); }
#line 38676 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1572: /* temporal_dyncol_type: DATETIME opt_field_length  */
#line 10464 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATETIME, 0, (yyvsp[0].const_simple_string)); }
#line 38682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1573: /* $@147: %empty  */
#line 10469 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 38688 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1574: /* string_dyncol_type: char $@147 opt_binary  */
#line 10471 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
          }
#line 38696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1575: /* string_dyncol_type: nchar  */
#line 10475 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
            Lex->charset= national_charset_info;
          }
#line 38705 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1576: /* dyncall_create_element: expr ',' expr opt_dyncol_type  */
#line 10483 "/home/buildbot/git/sql/sql_yacc.yy"
   {
     LEX *lex= Lex;
     (yyval.dyncol_def)= (DYNCALL_CREATE_DEF *)
       alloc_root(thd->mem_root, sizeof(DYNCALL_CREATE_DEF));
     if (unlikely((yyval.dyncol_def) == NULL))
       MYSQL_YYABORT;
     (yyval.dyncol_def)->key= (yyvsp[-3].item);
     (yyval.dyncol_def)->value= (yyvsp[-1].item);
     (yyval.dyncol_def)->type= (DYNAMIC_COLUMN_TYPE)(yyvsp[0].Lex_dyncol_type).dyncol_type();
     (yyval.dyncol_def)->cs= lex->charset;
     if ((yyvsp[0].Lex_dyncol_type).length())
       (yyval.dyncol_def)->len= strtoul((yyvsp[0].Lex_dyncol_type).length(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
     if ((yyvsp[0].Lex_dyncol_type).dec())
       (yyval.dyncol_def)->frac= strtoul((yyvsp[0].Lex_dyncol_type).dec(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
   }
#line 38729 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1577: /* dyncall_create_list: dyncall_create_element  */
#line 10506 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         (yyval.dyncol_def_list)= new (thd->mem_root) List<DYNCALL_CREATE_DEF>;
         if (unlikely((yyval.dyncol_def_list) == NULL))
           MYSQL_YYABORT;
         (yyval.dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
       }
#line 38740 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1578: /* dyncall_create_list: dyncall_create_list ',' dyncall_create_element  */
#line 10513 "/home/buildbot/git/sql/sql_yacc.yy"
       {
         (yyvsp[-2].dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
         (yyval.dyncol_def_list)= (yyvsp[-2].dyncol_def_list);
       }
#line 38749 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1579: /* plsql_cursor_attr: ISOPEN_SYM  */
#line 10521 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ISOPEN; }
#line 38755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1580: /* plsql_cursor_attr: FOUND_SYM  */
#line 10522 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_FOUND; }
#line 38761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1581: /* plsql_cursor_attr: NOTFOUND_SYM  */
#line 10523 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_NOTFOUND; }
#line 38767 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1582: /* plsql_cursor_attr: ROWCOUNT_SYM  */
#line 10524 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ROWCOUNT; }
#line 38773 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1583: /* explicit_cursor_attr: ident PERCENT_ORACLE_SYM plsql_cursor_attr  */
#line 10529 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_plsql_cursor_attr(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].plsql_cursor_attr)))))
              MYSQL_YYABORT;
          }
#line 38782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1584: /* trim_operands: expr  */
#line 10537 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1585: /* trim_operands: LEADING expr FROM expr  */
#line 10538 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[-2].item), (yyvsp[0].item));  }
#line 38794 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1586: /* trim_operands: TRAILING expr FROM expr  */
#line 10539 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[-2].item), (yyvsp[0].item)); }
#line 38800 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1587: /* trim_operands: BOTH expr FROM expr  */
#line 10540 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1588: /* trim_operands: LEADING FROM expr  */
#line 10541 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[0].item));      }
#line 38812 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1589: /* trim_operands: TRAILING FROM expr  */
#line 10542 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[0].item));     }
#line 38818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1590: /* trim_operands: BOTH FROM expr  */
#line 10543 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38824 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1591: /* trim_operands: expr FROM expr  */
#line 10544 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38830 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1598: /* column_default_non_parenthesized_expr: param_marker  */
#line 10582 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item)= (yyvsp[0].item_param); }
#line 38836 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1600: /* column_default_non_parenthesized_expr: sum_expr  */
#line 10585 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->select_stack_top)
            {
              my_error(ER_INVALID_GROUP_FUNC_USE, MYF(0));
              MYSQL_YYABORT;
            }
          }
#line 38848 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1601: /* column_default_non_parenthesized_expr: window_func_expr  */
#line 10593 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!Lex->select_stack_top)
            {
               my_error(ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION, MYF(0));
               MYSQL_YYABORT;
            }
          }
#line 38860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1603: /* column_default_non_parenthesized_expr: ROW_SYM '(' expr ',' expr_list ')'  */
#line 10602 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1604: /* column_default_non_parenthesized_expr: EXISTS '(' subselect ')'  */
#line 10609 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_exists_subselect(thd, (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1605: /* column_default_non_parenthesized_expr: '{' ident expr '}'  */
#line 10615 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].item)->make_odbc_literal(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 38890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1606: /* column_default_non_parenthesized_expr: MATCH ident_list_arg AGAINST '(' bit_expr fulltext_options ')'  */
#line 10620 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-5].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            Item_func_match *i1= new (thd->mem_root) Item_func_match(thd, *(yyvsp[-5].item_list),
                                                                     (yyvsp[-1].num));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            Select->add_ftfunc_to_list(thd, i1);
            (yyval.item)= i1;
          }
#line 38904 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1607: /* column_default_non_parenthesized_expr: CAST_SYM '(' expr AS cast_type ')'  */
#line 10630 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1608: /* column_default_non_parenthesized_expr: CASE_SYM when_list_opt_else END  */
#line 10635 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= new(thd->mem_root) Item_func_case_searched(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1609: /* column_default_non_parenthesized_expr: CASE_SYM expr when_list_opt_else END  */
#line 10640 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_case_simple(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1610: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr ',' cast_type ')'  */
#line 10646 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38941 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1611: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr USING charset_name ')'  */
#line 10651 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_conv_charset(thd, (yyvsp[-3].item), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1612: /* column_default_non_parenthesized_expr: DEFAULT '(' simple_ident ')'  */
#line 10657 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_splocal *il= (yyvsp[-1].item)->get_item_splocal();
            if (unlikely(il))
              my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), il->my_name()->str));
            (yyval.item)= new (thd->mem_root) Item_default_value(thd, Lex->current_context(),
                                                         (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->default_used= TRUE;
          }
#line 38966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1613: /* column_default_non_parenthesized_expr: VALUE_SYM '(' simple_ident_nospvar ')'  */
#line 10668 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_insert_value(thd, Lex->current_context(),
                                                        (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38977 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1614: /* column_default_non_parenthesized_expr: NEXT_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10675 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 38986 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1615: /* column_default_non_parenthesized_expr: NEXTVAL_SYM '(' table_ident ')'  */
#line 10680 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 38995 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1616: /* column_default_non_parenthesized_expr: PREVIOUS_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10685 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 39004 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1617: /* column_default_non_parenthesized_expr: LASTVAL_SYM '(' table_ident ')'  */
#line 10690 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 39013 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1618: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ')'  */
#line 10695 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-3].table), (yyvsp[-1].longlong_number), 0, 1))))
              MYSQL_YYABORT;
          }
#line 39022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1619: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ')'  */
#line 10700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-5].table), (yyvsp[-3].longlong_number), 0, (yyvsp[-1].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 39031 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1620: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ',' ulonglong_num ')'  */
#line 10705 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-7].table), (yyvsp[-5].longlong_number), (yyvsp[-1].ulonglong_number), (yyvsp[-3].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 39040 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1623: /* primary_expr: '(' parenthesized_expr ')'  */
#line 10714 "/home/buildbot/git/sql/sql_yacc.yy"
                                     { (yyval.item)= (yyvsp[-1].item); }
#line 39046 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1624: /* primary_expr: subquery  */
#line 10716 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.item)= Lex->create_item_query_expression(thd, (yyvsp[0].select_lex)->master_unit())))
              MYSQL_YYABORT;
          }
#line 39055 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1626: /* string_factor_expr: string_factor_expr COLLATE_SYM collation_name  */
#line 10725 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_set_collation(thd, (yyvsp[-2].item), (yyvsp[0].charset)))))
              MYSQL_YYABORT;
          }
#line 39064 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1628: /* simple_expr: BINARY simple_expr  */
#line 10734 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Type_cast_attributes at(&my_charset_bin);
            if (unlikely(!((yyval.item)= type_handler_long_blob.create_typecast_item(thd, (yyvsp[0].item), at))))
              MYSQL_YYABORT;
          }
#line 39074 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1629: /* simple_expr: '+' simple_expr  */
#line 10740 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 39082 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1630: /* simple_expr: '-' simple_expr  */
#line 10744 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item)->neg(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39092 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1631: /* simple_expr: '~' simple_expr  */
#line 10750 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_neg(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1632: /* simple_expr: not2 simple_expr  */
#line 10756 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39112 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1634: /* mysql_concatenation_expr: mysql_concatenation_expr MYSQL_CONCAT_SYM simple_expr  */
#line 10766 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1635: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ')'  */
#line 10775 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_datetime_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1636: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ',' expr ')'  */
#line 10782 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1637: /* function_call_keyword: CHAR_SYM '(' expr_list ')'  */
#line 10796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1638: /* function_call_keyword: CHAR_SYM '(' expr_list USING charset_name ')'  */
#line 10802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-3].item_list), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39163 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1639: /* function_call_keyword: CURRENT_USER optional_braces  */
#line 10808 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_user(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1640: /* function_call_keyword: CURRENT_ROLE optional_braces  */
#line 10817 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_role(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39189 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1641: /* function_call_keyword: DATE_SYM '(' expr ')'  */
#line 10826 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_typecast(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39199 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1642: /* function_call_keyword: DAY_SYM '(' expr ')'  */
#line 10832 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dayofmonth(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1643: /* function_call_keyword: HOUR_SYM '(' expr ')'  */
#line 10838 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_hour(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39219 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1644: /* function_call_keyword: INSERT '(' expr ',' expr ',' expr ',' expr ')'  */
#line 10844 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_insert(thd, (yyvsp[-7].item), (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39229 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1645: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ')'  */
#line 10850 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            if (unlikely(list->push_front((yyvsp[-1].item), thd->mem_root)) ||
                unlikely(list->push_front((yyvsp[-3].item), thd->mem_root)))
              MYSQL_YYABORT;
            Item_row *item= new (thd->mem_root) Item_row(thd, *list);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1646: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ',' expr_list ')'  */
#line 10865 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-5].item), thd->mem_root);
            Item_row *item= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1647: /* function_call_keyword: LEFT '(' expr ',' expr ')'  */
#line 10876 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_left(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1648: /* function_call_keyword: MINUTE_SYM '(' expr ')'  */
#line 10882 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minute(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1649: /* function_call_keyword: MONTH_SYM '(' expr ')'  */
#line 10888 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_month(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39293 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1650: /* function_call_keyword: RIGHT '(' expr ',' expr ')'  */
#line 10894 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_right(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1651: /* function_call_keyword: SECOND_SYM '(' expr ')'  */
#line 10900 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_second(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39313 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1652: /* function_call_keyword: SQL_SYM PERCENT_ORACLE_SYM ROWCOUNT_SYM  */
#line 10906 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_oracle_sql_rowcount(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39325 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1653: /* function_call_keyword: TIME_SYM '(' expr ')'  */
#line 10914 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_time_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39336 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1654: /* function_call_keyword: function_call_keyword_timestamp  */
#line 10921 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 39344 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1655: /* function_call_keyword: TRIM '(' trim_operands ')'  */
#line 10925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_trim(thd, (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 39354 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1656: /* function_call_keyword: USER_SYM '(' ')'  */
#line 10931 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_user(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query=0;
          }
#line 39366 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1657: /* function_call_keyword: YEAR_SYM '(' expr ')'  */
#line 10939 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_year(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39376 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1658: /* substring_operands: expr ',' expr ',' expr  */
#line 10948 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39384 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1659: /* substring_operands: expr ',' expr  */
#line 10952 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39392 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1660: /* substring_operands: expr FROM expr FOR_SYM expr  */
#line 10956 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1661: /* substring_operands: expr FROM expr  */
#line 10960 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1662: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' expr ')'  */
#line 10980 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39419 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1663: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 10987 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39429 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1664: /* function_call_nonkeyword: CURDATE optional_braces  */
#line 10993 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_local(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1665: /* function_call_nonkeyword: CURTIME opt_time_precision  */
#line 11000 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1666: /* function_call_nonkeyword: DATE_ADD_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11007 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1667: /* function_call_nonkeyword: DATE_SUB_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11013 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1668: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ')'  */
#line 11019 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39481 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1669: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11025 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1670: /* function_call_nonkeyword: DECODE_MARIADB_SYM '(' expr ',' expr ')'  */
#line 11031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_decode(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39501 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1671: /* function_call_nonkeyword: DECODE_ORACLE_SYM '(' expr ',' decode_when_list_oracle ')'  */
#line 11037 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_decode_oracle(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1672: /* function_call_nonkeyword: EXTRACT_SYM '(' interval FROM expr ')'  */
#line 11043 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_extract(thd, (yyvsp[-3].interval), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1673: /* function_call_nonkeyword: GET_FORMAT '(' date_time_type ',' expr ')'  */
#line 11049 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_format(thd, (yyvsp[-3].date_time_type), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39531 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1674: /* function_call_nonkeyword: NOW_SYM opt_time_precision  */
#line 11055 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1675: /* function_call_nonkeyword: POSITION_SYM '(' bit_expr IN_SYM expr ')'  */
#line 11062 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_locate(thd, (yyvsp[-1].item), (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39552 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1676: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' expr ')'  */
#line 11068 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39563 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1677: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11075 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39573 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1678: /* function_call_nonkeyword: SUBSTRING '(' substring_operands ')'  */
#line 11081 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_substr(thd, (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 39583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1679: /* function_call_nonkeyword: SYSDATE opt_time_precision  */
#line 11087 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Unlike other time-related functions, SYSDATE() is
              replication-unsafe because it is not affected by the
              TIMESTAMP variable.  It is unsafe even if
              sysdate_is_now=1, because the slave may have
              sysdate_is_now=0.
            */
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            if (global_system_variables.sysdate_is_now == 0)
              (yyval.item)= new (thd->mem_root) Item_func_sysdate_local(thd, (yyvsp[0].num));
            else
              (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1680: /* function_call_nonkeyword: TIMESTAMP_ADD '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11105 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-1].item), (yyvsp[-3].item), (yyvsp[-5].interval_time_st), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1681: /* function_call_nonkeyword: TIMESTAMP_DIFF '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11111 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp_diff(thd, (yyvsp[-3].item), (yyvsp[-1].item), (yyvsp[-5].interval_time_st));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39625 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1682: /* function_call_nonkeyword: TRIM_ORACLE '(' trim_operands ')'  */
#line 11117 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].trim).make_item_func_trim_oracle(thd))))
              MYSQL_YYABORT;
          }
#line 39634 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1683: /* function_call_nonkeyword: UTC_DATE_SYM optional_braces  */
#line 11122 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_utc(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1684: /* function_call_nonkeyword: UTC_TIME_SYM opt_time_precision  */
#line 11129 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39656 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1685: /* function_call_nonkeyword: UTC_TIMESTAMP_SYM opt_time_precision  */
#line 11136 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1686: /* function_call_nonkeyword: COLUMN_ADD_SYM '(' expr ',' dyncall_create_list ')'  */
#line 11144 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_add(thd, (yyvsp[-3].item), *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1687: /* function_call_nonkeyword: COLUMN_DELETE_SYM '(' expr ',' expr_list ')'  */
#line 11151 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_delete(thd, (yyvsp[-3].item), *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1688: /* function_call_nonkeyword: COLUMN_CHECK_SYM '(' expr ')'  */
#line 11158 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dyncol_check(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1689: /* function_call_nonkeyword: COLUMN_CREATE_SYM '(' dyncall_create_list ')'  */
#line 11165 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= create_func_dyncol_create(thd, *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39707 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1690: /* function_call_nonkeyword: COLUMN_GET_SYM '(' expr ',' expr AS cast_type ')'  */
#line 11172 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            (yyval.item)= create_func_dyncol_get(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].Lex_cast_type).type_handler(),
                                        (yyvsp[-1].Lex_cast_type).length(), (yyvsp[-1].Lex_cast_type).dec(),
                                        lex->charset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39720 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1691: /* function_call_conflict: ASCII_SYM '(' expr ')'  */
#line 11189 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_ascii(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1692: /* function_call_conflict: CHARSET '(' expr ')'  */
#line 11195 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_charset(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39740 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1693: /* function_call_conflict: COALESCE '(' expr_list ')'  */
#line 11201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_coalesce(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39750 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1694: /* function_call_conflict: COLLATION_SYM '(' expr ')'  */
#line 11207 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_collation(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1695: /* function_call_conflict: DATABASE '(' ')'  */
#line 11213 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_database(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39771 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1696: /* function_call_conflict: IF_SYM '(' expr ',' expr ',' expr ')'  */
#line 11220 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_if(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1697: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ')'  */
#line 11226 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39791 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1698: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11232 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1699: /* function_call_conflict: LAST_VALUE '(' expr ')'  */
#line 11241 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            list->push_back((yyvsp[-1].item), thd->mem_root);

            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *list);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1700: /* function_call_conflict: LAST_VALUE '(' expr_list ',' expr ')'  */
#line 11252 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-3].item_list)->push_back((yyvsp[-1].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *(yyvsp[-3].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39827 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1701: /* function_call_conflict: MICROSECOND_SYM '(' expr ')'  */
#line 11259 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_microsecond(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1702: /* function_call_conflict: MOD_SYM '(' expr ',' expr ')'  */
#line 11265 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1703: /* function_call_conflict: OLD_PASSWORD_SYM '(' expr ')'  */
#line 11271 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=  new (thd->mem_root)
              Item_func_password(thd, (yyvsp[-1].item), Item_func_password::OLD);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39858 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1704: /* function_call_conflict: PASSWORD_SYM '(' expr ')'  */
#line 11278 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item* i1;
            i1= new (thd->mem_root) Item_func_password(thd, (yyvsp[-1].item));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= i1;
          }
#line 39870 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1705: /* function_call_conflict: QUARTER_SYM '(' expr ')'  */
#line 11286 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_quarter(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1706: /* function_call_conflict: REPEAT_SYM '(' expr ',' expr ')'  */
#line 11292 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_repeat(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1707: /* function_call_conflict: REPLACE '(' expr ',' expr ',' expr ')'  */
#line 11298 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_replace(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item)))))
              MYSQL_YYABORT;
          }
#line 39900 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1708: /* function_call_conflict: REVERSE_SYM '(' expr ')'  */
#line 11304 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_reverse(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1709: /* function_call_conflict: ROW_COUNT_SYM '(' ')'  */
#line 11310 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_row_count(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1710: /* function_call_conflict: TRUNCATE_SYM '(' expr ',' expr ')'  */
#line 11318 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_round(thd, (yyvsp[-3].item), (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39932 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1711: /* function_call_conflict: WEEK_SYM '(' expr ')'  */
#line 11324 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1712: /* function_call_conflict: WEEK_SYM '(' expr ',' expr ')'  */
#line 11330 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1713: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr opt_ws_levels ')'  */
#line 11336 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-2].item), 0, 0, (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39962 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1714: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS CHAR_SYM ws_nweights opt_ws_levels ')'  */
#line 11342 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, (yyvsp[-5].item), 0, (yyvsp[-2].ulong_num),
                                        (yyvsp[-1].ulong_num) | MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39974 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1715: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS BINARY ws_nweights ')'  */
#line 11350 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_char_typecast(thd, (yyvsp[-4].item), (yyvsp[-1].ulong_num),
                                                               &my_charset_bin);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, item, 0, (yyvsp[-1].ulong_num),
                                        MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1716: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr ',' ulong_num ',' ulong_num ',' ulong_num ')'  */
#line 11362 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-7].item), (yyvsp[-5].ulong_num), (yyvsp[-3].ulong_num),
                                                            (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40001 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1717: /* function_call_conflict: geometry_function  */
#line 11369 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.item)= (yyvsp[0].item);
            /* $1 may be NULL, GEOM_NEW not tested for out of memory */
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 40017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1718: /* geometry_function: CONTAINS_SYM '(' expr ',' expr ')'  */
#line 11384 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                 Item_func::SP_CONTAINS_FUNC));
          }
#line 40027 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1719: /* geometry_function: GEOMETRYCOLLECTION '(' expr_list ')'  */
#line 11390 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_geometrycollection,
                           Geometry::wkb_point));
          }
#line 40038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1720: /* geometry_function: LINESTRING '(' expr_list ')'  */
#line 11397 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_linestring,
                           Geometry::wkb_point));
          }
#line 40049 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1721: /* geometry_function: MULTILINESTRING '(' expr_list ')'  */
#line 11404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multilinestring,
                           Geometry::wkb_linestring));
          }
#line 40060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1722: /* geometry_function: MULTIPOINT '(' expr_list ')'  */
#line 11411 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipoint,
                           Geometry::wkb_point));
          }
#line 40071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1723: /* geometry_function: MULTIPOLYGON '(' expr_list ')'  */
#line 11418 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipolygon,
                           Geometry::wkb_polygon));
          }
#line 40082 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1724: /* geometry_function: POINT_SYM '(' expr ',' expr ')'  */
#line 11425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_point(thd, (yyvsp[-3].item), (yyvsp[-1].item)));
          }
#line 40090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1725: /* geometry_function: POLYGON '(' expr_list ')'  */
#line 11429 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_polygon,
                           Geometry::wkb_linestring));
          }
#line 40101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1726: /* geometry_function: WITHIN '(' expr ',' expr ')'  */
#line 11436 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                    Item_func::SP_WITHIN_FUNC));
          }
#line 40110 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1727: /* @148: %empty  */
#line 11453 "/home/buildbot/git/sql/sql_yacc.yy"
          {
#ifdef HAVE_DLOPEN
            udf_func *udf= 0;
            LEX *lex= Lex;
            if (using_udf_functions &&
                (udf= find_udf((yyvsp[-1].ident_sys).str, (yyvsp[-1].ident_sys).length)) &&
                udf->type == UDFTYPE_AGGREGATE)
            {
              if (unlikely(lex->current_select->inc_in_sum_expr()))
              {
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            /* Temporary placing the result of find_udf in $3 */
            (yyval.udf)= udf;
#endif
          }
#line 40133 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1728: /* function_call_generic: IDENT_sys '(' @148 opt_udf_expr_list ')'  */
#line 11472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Create_func *builder;
            Item *item= NULL;

            if (unlikely(check_routine_name(&(yyvsp[-4].ident_sys))))
              MYSQL_YYABORT;

            /*
              Implementation note:
              names are resolved with the following order:
              - MySQL native functions,
              - User Defined Functions,
              - Stored Functions (assuming the current <use> database)

              This will be revised with WL#2128 (SQL PATH)
            */
            builder= find_native_function_builder(thd, &(yyvsp[-4].ident_sys));
            if (builder)
            {
              item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
            }
            else
            {
#ifdef HAVE_DLOPEN
              /* Retrieving the result of find_udf */
              udf_func *udf= (yyvsp[-2].udf);

              if (udf)
              {
                if (udf->type == UDFTYPE_AGGREGATE)
                {
                  Select->in_sum_expr--;
                }

                item= Create_udf_func::s_singleton.create(thd, udf, (yyvsp[-1].item_list));
              }
              else
#endif
              {
                builder= find_qualified_function_builder(thd);
                DBUG_ASSERT(builder);
                item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
              }
            }

            if (unlikely(! ((yyval.item)= item)))
              MYSQL_YYABORT;
          }
#line 40186 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1729: /* function_call_generic: ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11521 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1730: /* function_call_generic: ident_cli '.' ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11526 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-7].ident_cli), &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 40204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1731: /* fulltext_options: opt_natural_language_mode opt_query_expansion  */
#line 11534 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= (yyvsp[-1].num) | (yyvsp[0].num); }
#line 40210 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1732: /* fulltext_options: IN_SYM BOOLEAN_SYM MODE_SYM  */
#line 11536 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.num)= FT_BOOL; }
#line 40216 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1733: /* opt_natural_language_mode: %empty  */
#line 11540 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_NL; }
#line 40222 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1734: /* opt_natural_language_mode: IN_SYM NATURAL LANGUAGE_SYM MODE_SYM  */
#line 11541 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_NL; }
#line 40228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1735: /* opt_query_expansion: %empty  */
#line 11545 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= 0;         }
#line 40234 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1736: /* opt_query_expansion: WITH QUERY_SYM EXPANSION_SYM  */
#line 11546 "/home/buildbot/git/sql/sql_yacc.yy"
                                                { (yyval.num)= FT_EXPAND; }
#line 40240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1737: /* opt_udf_expr_list: %empty  */
#line 11550 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item_list)= NULL; }
#line 40246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1738: /* opt_udf_expr_list: udf_expr_list  */
#line 11551 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item_list)= (yyvsp[0].item_list); }
#line 40252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1739: /* udf_expr_list: udf_expr  */
#line 11556 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root);
          }
#line 40263 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1740: /* udf_expr_list: udf_expr_list ',' udf_expr  */
#line 11563 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40272 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1741: /* udf_expr: remember_name expr remember_end select_alias  */
#line 11571 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
             Use Item::name as a storage for the attribute value of user
             defined function argument. It is safe to use Item::name
             because the syntax will not allow having an explicit name here.
             See WL#1017 re. udf attributes.
            */
            if ((yyvsp[0].lex_str).str)
            {
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            /* 
               A field has to have its proper name in order for name
               resolution to work, something we are only guaranteed if we
               parse it out. If we hijack the input stream with
               remember_name we may get quoted or escaped names.
            */
            else if ((yyvsp[-2].item)->type() != Item::FIELD_ITEM &&
                     (yyvsp[-2].item)->type() != Item::REF_ITEM /* For HAVING */ )
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            (yyval.item)= (yyvsp[-2].item);
          }
#line 40300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1742: /* sum_expr: AVG_SYM '(' in_sum_expr ')'  */
#line 11598 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1743: /* sum_expr: AVG_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11604 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40320 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1744: /* sum_expr: BIT_AND '(' in_sum_expr ')'  */
#line 11610 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_and(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40330 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1745: /* sum_expr: BIT_OR '(' in_sum_expr ')'  */
#line 11616 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_or(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1746: /* sum_expr: BIT_XOR '(' in_sum_expr ')'  */
#line 11622 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_xor(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40350 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1747: /* sum_expr: COUNT_SYM '(' opt_all '*' ')'  */
#line 11628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *item= new (thd->mem_root) Item_int(thd, (int32) 0L, 1);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40363 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1748: /* sum_expr: COUNT_SYM '(' in_sum_expr ')'  */
#line 11637 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1749: /* $@149: %empty  */
#line 11643 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr++; }
#line 40379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1750: /* $@150: %empty  */
#line 11645 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr--; }
#line 40385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1751: /* sum_expr: COUNT_SYM '(' DISTINCT $@149 expr_list $@150 ')'  */
#line 11647 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, *(yyvsp[-2].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1752: /* sum_expr: MIN_SYM '(' in_sum_expr ')'  */
#line 11653 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40405 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1753: /* sum_expr: MIN_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11664 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1754: /* sum_expr: MAX_SYM '(' in_sum_expr ')'  */
#line 11670 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1755: /* sum_expr: MAX_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11676 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1756: /* sum_expr: STD_SYM '(' in_sum_expr ')'  */
#line 11682 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1757: /* sum_expr: VARIANCE_SYM '(' in_sum_expr ')'  */
#line 11688 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40455 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1758: /* sum_expr: STDDEV_SAMP_SYM '(' in_sum_expr ')'  */
#line 11694 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40465 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1759: /* sum_expr: VAR_SAMP_SYM '(' in_sum_expr ')'  */
#line 11700 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40475 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1760: /* sum_expr: SUM_SYM '(' in_sum_expr ')'  */
#line 11706 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1761: /* sum_expr: SUM_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11712 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40495 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1762: /* $@151: %empty  */
#line 11718 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->in_sum_expr++; }
#line 40501 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1763: /* sum_expr: GROUP_CONCAT_SYM '(' opt_distinct $@151 expr_list opt_gorder_clause opt_gconcat_separator opt_glimit_clause ')'  */
#line 11722 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->in_sum_expr--;
            (yyval.item)= new (thd->mem_root)
                  Item_func_group_concat(thd, Lex->current_context(),
                                        (yyvsp[-6].num), (yyvsp[-4].item_list),
                                        sel->gorder_list, (yyvsp[-2].string), (yyvsp[-1].num),
                                        sel->select_limit,
                                        sel->offset_limit);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            sel->select_limit= NULL;
            sel->offset_limit= NULL;
            sel->explicit_limit= 0;
            (yyvsp[-4].item_list)->empty();
            sel->gorder_list.empty();
          }
#line 40523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1764: /* window_func_expr: window_func OVER_SYM window_name  */
#line 11743 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item), (yyvsp[0].lex_str_ptr));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40535 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1765: /* window_func_expr: window_func OVER_SYM window_spec  */
#line 11752 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 lex->win_frame)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item),
                                                      thd->lex->win_spec); 
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40554 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1768: /* window_func: function_call_generic  */
#line 11774 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item* item = (Item*)(yyvsp[0].item);
            /* Only UDF aggregate here possible */
            if ((item == NULL) ||
                (item->type() != Item::SUM_FUNC_ITEM)
                || (((Item_sum *)item)->sum_func() != Item_sum::UDF_SUM_FUNC))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40570 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1769: /* simple_window_func: ROW_NUMBER_SYM '(' ')'  */
#line 11789 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_row_number(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40580 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1770: /* simple_window_func: RANK_SYM '(' ')'  */
#line 11796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1771: /* simple_window_func: DENSE_RANK_SYM '(' ')'  */
#line 11803 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_dense_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40600 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1772: /* simple_window_func: PERCENT_RANK_SYM '(' ')'  */
#line 11810 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percent_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40610 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1773: /* simple_window_func: CUME_DIST_SYM '(' ')'  */
#line 11817 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_cume_dist(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1774: /* simple_window_func: NTILE_SYM '(' expr ')'  */
#line 11824 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_ntile(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1775: /* simple_window_func: FIRST_VALUE_SYM '(' expr ')'  */
#line 11831 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_first_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40640 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1776: /* simple_window_func: LAST_VALUE '(' expr ')'  */
#line 11838 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_last_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1777: /* simple_window_func: NTH_VALUE_SYM '(' expr ',' expr ')'  */
#line 11845 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_nth_value(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40660 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1778: /* simple_window_func: LEAD_SYM '(' expr ')'  */
#line 11852 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40674 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1779: /* simple_window_func: LEAD_SYM '(' expr ',' expr ')'  */
#line 11863 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1780: /* simple_window_func: LAG_SYM '(' expr ')'  */
#line 11870 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40698 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1781: /* simple_window_func: LAG_SYM '(' expr ',' expr ')'  */
#line 11881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1782: /* inverse_distribution_function: percentile_function OVER_SYM '(' opt_window_partition_clause ')'  */
#line 11893 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 NULL)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-4].item),
                                                     thd->lex->win_spec);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1783: /* $@152: %empty  */
#line 11911 "/home/buildbot/git/sql/sql_yacc.yy"
           { Select->prepare_add_window_spec(thd); }
#line 40733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1784: /* percentile_function: inverse_distribution_function_def WITHIN GROUP_SYM '(' $@152 order_by_single_element_list ')'  */
#line 11913 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             (yyval.item)= (yyvsp[-6].item);
           }
#line 40741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1785: /* percentile_function: MEDIAN_SYM '(' expr ')'  */
#line 11917 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *args= new (thd->mem_root) Item_decimal(thd, "0.5", 3,
                                                   thd->charset());
            if (unlikely(args == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
            Select->prepare_add_window_spec(thd);
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),FALSE)))
              MYSQL_YYABORT;

            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, args);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40759 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1786: /* inverse_distribution_function_def: PERCENTILE_CONT_SYM '(' expr ')'  */
#line 11934 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40769 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1787: /* inverse_distribution_function_def: PERCENTILE_DISC_SYM '(' expr ')'  */
#line 11940 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_disc(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40779 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1788: /* order_by_single_element_list: ORDER_SYM BY order_ident order_dir  */
#line 11949 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
          }
#line 40788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1789: /* window_name: ident  */
#line 11958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 40798 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1790: /* $@153: %empty  */
#line 11967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(! Lex->parsing_options.allows_variable))
              my_yyabort_error((ER_VIEW_SELECT_VARIABLE, MYF(0)));
          }
#line 40807 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1791: /* variable: '@' $@153 variable_aux  */
#line 11972 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 40815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1792: /* variable_aux: ident_or_text SET_VAR expr  */
#line 11979 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_func_set_user_var *item;
            (yyval.item)= item= new (thd->mem_root) Item_func_set_user_var(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            lex->set_var_list.push_back(item, thd->mem_root);
          }
#line 40829 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1793: /* variable_aux: ident_or_text  */
#line 11989 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 40841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1794: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name  */
#line 11997 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-1].var_type), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1795: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name '.' ident  */
#line 12002 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1796: /* opt_distinct: %empty  */
#line 12009 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 0; }
#line 40865 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1797: /* opt_distinct: DISTINCT  */
#line 12010 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 1; }
#line 40871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1798: /* opt_gconcat_separator: %empty  */
#line 12015 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string)= new (thd->mem_root) String(",", 1, &my_charset_latin1);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 40881 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1799: /* opt_gconcat_separator: SEPARATOR_SYM text_string  */
#line 12020 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.string) = (yyvsp[0].string); }
#line 40887 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1802: /* gorder_list: gorder_list ',' order_ident order_dir  */
#line 12030 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1803: /* gorder_list: order_ident order_dir  */
#line 12035 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40905 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1804: /* opt_glimit_clause: %empty  */
#line 12042 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) = 0; }
#line 40911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1805: /* opt_glimit_clause: glimit_clause  */
#line 12043 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num) = 1; }
#line 40917 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1806: /* glimit_clause_init: LIMIT  */
#line 12047 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 40923 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1807: /* glimit_clause: glimit_clause_init glimit_options  */
#line 12052 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 40931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1808: /* glimit_options: limit_option  */
#line 12059 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= 0;
            sel->explicit_limit= 1;
          }
#line 40942 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1809: /* glimit_options: limit_option ',' limit_option  */
#line 12066 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= (yyvsp[-2].item);
            sel->explicit_limit= 1;
          }
#line 40953 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1810: /* glimit_options: limit_option OFFSET_SYM limit_option  */
#line 12073 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[-2].item);
            sel->offset_limit= (yyvsp[0].item);
            sel->explicit_limit= 1;
          }
#line 40964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1811: /* $@154: %empty  */
#line 12085 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->current_select->inc_in_sum_expr()))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40977 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1812: /* in_sum_expr: opt_all $@154 expr  */
#line 12094 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->in_sum_expr--;
            (yyval.item)= (yyvsp[0].item);
          }
#line 40986 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1813: /* cast_type: BINARY opt_field_length  */
#line 12102 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string)); Lex->charset= &my_charset_bin; }
#line 40992 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1814: /* $@155: %empty  */
#line 12104 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40998 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1815: /* cast_type: CHAR_SYM opt_field_length $@155 opt_binary  */
#line 12106 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41004 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1816: /* $@156: %empty  */
#line 12108 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1817: /* cast_type: VARCHAR field_length $@156 opt_binary  */
#line 12110 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1818: /* $@157: %empty  */
#line 12112 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 41022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1819: /* cast_type: VARCHAR2_ORACLE_SYM field_length $@157 opt_binary  */
#line 12114 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 41028 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1820: /* cast_type: NCHAR_SYM opt_field_length  */
#line 12116 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->charset= national_charset_info;
            (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string), 0);
          }
#line 41037 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1821: /* cast_type: cast_type_numeric  */
#line 12120 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 41043 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1822: /* cast_type: cast_type_temporal  */
#line 12121 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 41049 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1823: /* cast_type_numeric: INT_SYM  */
#line 12125 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41055 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1824: /* cast_type_numeric: SIGNED_SYM  */
#line 12126 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41061 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1825: /* cast_type_numeric: SIGNED_SYM INT_SYM  */
#line 12127 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 41067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1826: /* cast_type_numeric: UNSIGNED  */
#line 12128 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 41073 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1827: /* cast_type_numeric: UNSIGNED INT_SYM  */
#line 12129 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 41079 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1828: /* cast_type_numeric: DECIMAL_SYM float_options  */
#line 12130 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdecimal, (yyvsp[0].Lex_length_and_dec)); }
#line 41085 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1829: /* cast_type_numeric: FLOAT_SYM  */
#line 12131 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_float); }
#line 41091 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1830: /* cast_type_numeric: DOUBLE_SYM opt_precision  */
#line 12132 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_double, (yyvsp[0].Lex_length_and_dec));  }
#line 41097 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1831: /* cast_type_temporal: DATE_SYM  */
#line 12136 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdate); }
#line 41103 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1832: /* cast_type_temporal: TIME_SYM opt_field_length  */
#line 12137 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_time2, 0, (yyvsp[0].const_simple_string)); }
#line 41109 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1833: /* cast_type_temporal: DATETIME opt_field_length  */
#line 12138 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_datetime2, 0, (yyvsp[0].const_simple_string)); }
#line 41115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1834: /* cast_type_temporal: INTERVAL_SYM DAY_SECOND_SYM field_length  */
#line 12140 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.Lex_cast_type).set(&type_handler_interval_DDhhmmssff, 0, (yyvsp[0].const_simple_string));
          }
#line 41123 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1835: /* opt_expr_list: %empty  */
#line 12146 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item_list)= NULL; }
#line 41129 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1836: /* opt_expr_list: expr_list  */
#line 12147 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.item_list)= (yyvsp[0].item_list);}
#line 41135 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1837: /* expr_list: expr  */
#line 12152 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 41144 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1838: /* expr_list: expr_list ',' expr  */
#line 12157 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1839: /* ident_list_arg: ident_list  */
#line 12164 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.item_list)= (yyvsp[0].item_list); }
#line 41159 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1840: /* ident_list_arg: '(' ident_list ')'  */
#line 12165 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.item_list)= (yyvsp[-1].item_list); }
#line 41165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1841: /* ident_list: simple_ident  */
#line 12170 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 41176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1842: /* ident_list: ident_list ',' simple_ident  */
#line 12177 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1843: /* when_list: WHEN_SYM expr THEN_SYM expr  */
#line 12185 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            if (unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 41198 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1844: /* when_list: when_list WHEN_SYM expr THEN_SYM expr  */
#line 12194 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-4].item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyvsp[-4].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-4].item_list);
          }
#line 41209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1846: /* when_list_opt_else: when_list ELSE expr  */
#line 12205 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 41219 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1847: /* decode_when_list_oracle: expr ',' expr  */
#line 12214 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;

          }
#line 41232 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1848: /* decode_when_list_oracle: decode_when_list_oracle ',' expr  */
#line 12223 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_list)= (yyvsp[-2].item_list);
            if (unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 41242 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1849: /* table_ref: table_factor  */
#line 12234 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41248 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1850: /* table_ref: join_table  */
#line 12236 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->nest_last_join(thd))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41261 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1851: /* join_table_list: derived_table_list  */
#line 12247 "/home/buildbot/git/sql/sql_yacc.yy"
                             { MYSQL_YYABORT_UNLESS((yyval.table_list)=(yyvsp[0].table_list)); }
#line 41267 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1852: /* esc_table_ref: table_ref  */
#line 12258 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.table_list)=(yyvsp[0].table_list); }
#line 41273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1853: /* esc_table_ref: '{' ident table_ref '}'  */
#line 12259 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { (yyval.table_list)=(yyvsp[-1].table_list); }
#line 41279 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1854: /* derived_table_list: esc_table_ref  */
#line 12266 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table_list)=(yyvsp[0].table_list);
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1855: /* derived_table_list: derived_table_list ',' esc_table_ref  */
#line 12271 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1856: /* join_table: table_ref normal_join table_ref  */
#line 12285 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            if (unlikely(Select->add_cross_joined_table((yyvsp[-2].table_list), (yyvsp[0].table_list), (yyvsp[-1].num))))
              MYSQL_YYABORT;
          }
#line 41307 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1857: /* $@158: %empty  */
#line 12292 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-3].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1858: /* join_table: table_ref normal_join table_ref ON $@158 expr  */
#line 12302 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[-3].table_list)->straight=(yyvsp[-4].num);
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 41332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1859: /* $@159: %empty  */
#line 12310 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
          }
#line 41342 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1860: /* join_table: table_ref normal_join table_ref USING $@159 '(' using_list ')'  */
#line 12316 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    (yyvsp[-5].table_list)->straight=(yyvsp[-6].num);
            add_join_natural((yyvsp[-7].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
	    (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 41352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1861: /* join_table: table_ref NATURAL inner_join table_factor  */
#line 12322 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
	    (yyvsp[0].table_list)->straight=(yyvsp[-1].num);
            add_join_natural((yyvsp[-3].table_list),(yyvsp[0].table_list),NULL,Select);
          }
#line 41364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1862: /* $@160: %empty  */
#line 12333 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1863: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_ref ON $@160 expr  */
#line 12343 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            (yyvsp[-3].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[-3].table_list);
            Select->parsing_place= NO_MATTER;
          }
#line 41390 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1864: /* $@161: %empty  */
#line 12351 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1865: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_factor $@161 USING '(' using_list ')'  */
#line 12357 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            add_join_natural((yyvsp[-9].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
            (yyvsp[-5].table_list)->outer_join|=JOIN_TYPE_LEFT; 
            (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 41410 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1866: /* join_table: table_ref NATURAL LEFT opt_outer JOIN_SYM table_factor  */
#line 12363 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[-5].table_list),(yyvsp[0].table_list),NULL,Select);
            (yyvsp[0].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[0].table_list);
          }
#line 41423 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1867: /* $@162: %empty  */
#line 12375 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41437 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1868: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_ref ON $@162 expr  */
#line 12385 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_on(thd, (yyval.table_list), (yyvsp[0].item));
            (yyvsp[-7].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 41450 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1869: /* $@163: %empty  */
#line 12394 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41460 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1870: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_factor $@163 USING '(' using_list ')'  */
#line 12400 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_natural((yyval.table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select);
          }
#line 41471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1871: /* join_table: table_ref NATURAL RIGHT opt_outer JOIN_SYM table_factor  */
#line 12407 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[0].table_list),(yyvsp[-5].table_list),NULL,Select);
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
          }
#line 41485 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1872: /* inner_join: JOIN_SYM  */
#line 12420 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41491 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1873: /* inner_join: INNER_SYM JOIN_SYM  */
#line 12421 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41497 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1874: /* inner_join: STRAIGHT_JOIN  */
#line 12422 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 1; }
#line 41503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1875: /* normal_join: inner_join  */
#line 12426 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = (yyvsp[0].num); }
#line 41509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1876: /* normal_join: CROSS JOIN_SYM  */
#line 12427 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num) = 0; }
#line 41515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1877: /* opt_use_partition: %empty  */
#line 12435 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.string_list)= 0;}
#line 41521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1879: /* use_partition: PARTITION_SYM '(' using_list ')' have_partitioning  */
#line 12441 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string_list)= (yyvsp[-2].string_list);
            Select->parsing_place= Select->save_parsing_place;
            Select->save_parsing_place= NO_MATTER;
          }
#line 41531 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1880: /* table_factor: table_primary_ident_opt_parens  */
#line 12449 "/home/buildbot/git/sql/sql_yacc.yy"
                                         { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41537 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1881: /* table_factor: table_primary_derived_opt_parens  */
#line 12450 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1882: /* table_factor: join_table_parens  */
#line 12452 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyvsp[0].table_list)->nested_join->nest_type= 0;
            (yyval.table_list)= (yyvsp[0].table_list);
          }
#line 41552 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1883: /* table_factor: table_reference_list_parens  */
#line 12456 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41558 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1884: /* table_primary_ident_opt_parens: table_primary_ident  */
#line 12460 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41564 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1885: /* table_primary_ident_opt_parens: '(' table_primary_ident_opt_parens ')'  */
#line 12461 "/home/buildbot/git/sql/sql_yacc.yy"
                                                 { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41570 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1886: /* table_primary_derived_opt_parens: table_primary_derived  */
#line 12465 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41576 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1887: /* table_primary_derived_opt_parens: '(' table_primary_derived_opt_parens ')'  */
#line 12466 "/home/buildbot/git/sql/sql_yacc.yy"
                                                   { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41582 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1888: /* table_reference_list_parens: '(' table_reference_list_parens ')'  */
#line 12470 "/home/buildbot/git/sql/sql_yacc.yy"
                                              { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41588 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1889: /* table_reference_list_parens: '(' nested_table_reference_list ')'  */
#line 12472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.table_list)= Select->end_nested_join(thd)))
              MYSQL_YYABORT;
          }
#line 41597 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1890: /* nested_table_reference_list: table_ref ',' table_ref  */
#line 12480 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Select->init_nested_join(thd))
              MYSQL_YYABORT;
            Select->add_joined_table((yyvsp[-2].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list)->embedding;
          }
#line 41609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1891: /* nested_table_reference_list: nested_table_reference_list ',' table_ref  */
#line 12488 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list);
          }
#line 41618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1892: /* join_table_parens: '(' join_table_parens ')'  */
#line 12495 "/home/buildbot/git/sql/sql_yacc.yy"
                                    { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1893: /* join_table_parens: '(' join_table ')'  */
#line 12497 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->nest_last_join(thd)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1894: /* table_primary_ident: table_ident opt_use_partition opt_for_system_time_clause opt_table_alias_clause opt_key_definition  */
#line 12511 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            if ((yyvsp[-2].num))
              (yyval.table_list)->vers_conditions= Lex->vers_conditions;
          }
#line 41655 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1895: /* table_primary_derived: subquery opt_for_system_time_clause table_alias_clause  */
#line 12529 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!((yyval.table_list)= Lex->parsed_derived_table((yyvsp[-2].select_lex)->master_unit(), (yyvsp[-1].num), (yyvsp[0].lex_str_ptr))))
              MYSQL_YYABORT;
          }
#line 41664 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1896: /* opt_outer: %empty  */
#line 12536 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 41670 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1897: /* opt_outer: OUTER  */
#line 12537 "/home/buildbot/git/sql/sql_yacc.yy"
                {}
#line 41676 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1898: /* index_hint_clause: %empty  */
#line 12542 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= thd->variables.old_mode ?  INDEX_HINT_MASK_JOIN : INDEX_HINT_MASK_ALL; 
          }
#line 41684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1899: /* index_hint_clause: FOR_SYM JOIN_SYM  */
#line 12545 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_JOIN;  }
#line 41690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1900: /* index_hint_clause: FOR_SYM ORDER_SYM BY  */
#line 12546 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_ORDER; }
#line 41696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1901: /* index_hint_clause: FOR_SYM GROUP_SYM BY  */
#line 12547 "/home/buildbot/git/sql/sql_yacc.yy"
                                { (yyval.num)= INDEX_HINT_MASK_GROUP; }
#line 41702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1902: /* index_hint_type: FORCE_SYM  */
#line 12551 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.index_hint)= INDEX_HINT_FORCE; }
#line 41708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1903: /* index_hint_type: IGNORE_SYM  */
#line 12552 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.index_hint)= INDEX_HINT_IGNORE; }
#line 41714 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1904: /* $@164: %empty  */
#line 12557 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_index_hint_type((yyvsp[-2].index_hint), (yyvsp[0].num));
          }
#line 41722 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1906: /* $@165: %empty  */
#line 12562 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_index_hint_type(INDEX_HINT_USE, (yyvsp[0].num));
          }
#line 41730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1911: /* $@166: %empty  */
#line 12575 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->alloc_index_hints(thd); }
#line 41736 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1913: /* $@167: %empty  */
#line 12579 "/home/buildbot/git/sql/sql_yacc.yy"
          {  Select->clear_index_hints(); }
#line 41742 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1915: /* opt_key_usage_list: %empty  */
#line 12584 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Select->add_index_hint(thd, NULL, 0); }
#line 41748 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1916: /* opt_key_usage_list: key_usage_list  */
#line 12585 "/home/buildbot/git/sql/sql_yacc.yy"
                         {}
#line 41754 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1917: /* key_usage_element: ident  */
#line 12590 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->add_index_hint(thd, (yyvsp[0].ident_sys).str, (yyvsp[0].ident_sys).length); }
#line 41760 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1918: /* key_usage_element: PRIMARY_SYM  */
#line 12592 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->add_index_hint(thd, "PRIMARY", 7); }
#line 41766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1921: /* using_list: ident  */
#line 12602 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.string_list)= new (thd->mem_root) List<String>)))
              MYSQL_YYABORT;
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            (yyval.string_list)->push_back(s, thd->mem_root);
          }
#line 41781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1922: /* using_list: using_list ',' ident  */
#line 12613 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            if (unlikely((yyvsp[-2].string_list)->push_back(s, thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.string_list)= (yyvsp[-2].string_list);
          }
#line 41796 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1923: /* interval: interval_time_stamp  */
#line 12626 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 41802 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1924: /* interval: DAY_HOUR_SYM  */
#line 12627 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_HOUR; }
#line 41808 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1925: /* interval: DAY_MICROSECOND_SYM  */
#line 12628 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MICROSECOND; }
#line 41814 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1926: /* interval: DAY_MINUTE_SYM  */
#line 12629 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MINUTE; }
#line 41820 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1927: /* interval: DAY_SECOND_SYM  */
#line 12630 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_DAY_SECOND; }
#line 41826 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1928: /* interval: HOUR_MICROSECOND_SYM  */
#line 12631 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MICROSECOND; }
#line 41832 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1929: /* interval: HOUR_MINUTE_SYM  */
#line 12632 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MINUTE; }
#line 41838 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1930: /* interval: HOUR_SECOND_SYM  */
#line 12633 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_SECOND; }
#line 41844 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1931: /* interval: MINUTE_MICROSECOND_SYM  */
#line 12634 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_MICROSECOND; }
#line 41850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1932: /* interval: MINUTE_SECOND_SYM  */
#line 12635 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_SECOND; }
#line 41856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1933: /* interval: SECOND_MICROSECOND_SYM  */
#line 12636 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_SECOND_MICROSECOND; }
#line 41862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1934: /* interval: YEAR_MONTH_SYM  */
#line 12637 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.interval)=INTERVAL_YEAR_MONTH; }
#line 41868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1935: /* interval_time_stamp: DAY_SYM  */
#line 12641 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_DAY; }
#line 41874 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1936: /* interval_time_stamp: WEEK_SYM  */
#line 12642 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_WEEK; }
#line 41880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1937: /* interval_time_stamp: HOUR_SYM  */
#line 12643 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_HOUR; }
#line 41886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1938: /* interval_time_stamp: MINUTE_SYM  */
#line 12644 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MINUTE; }
#line 41892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1939: /* interval_time_stamp: MONTH_SYM  */
#line 12645 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MONTH; }
#line 41898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1940: /* interval_time_stamp: QUARTER_SYM  */
#line 12646 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_QUARTER; }
#line 41904 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1941: /* interval_time_stamp: SECOND_SYM  */
#line 12647 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_SECOND; }
#line 41910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1942: /* interval_time_stamp: MICROSECOND_SYM  */
#line 12648 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_MICROSECOND; }
#line 41916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1943: /* interval_time_stamp: YEAR_SYM  */
#line 12649 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.interval_time_st)=INTERVAL_YEAR; }
#line 41922 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1944: /* date_time_type: DATE_SYM  */
#line 12653 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATE;}
#line 41928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1945: /* date_time_type: TIME_SYM  */
#line 12654 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_TIME;}
#line 41934 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1946: /* date_time_type: DATETIME  */
#line 12655 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41940 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1947: /* date_time_type: TIMESTAMP  */
#line 12656 "/home/buildbot/git/sql/sql_yacc.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41946 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1951: /* opt_table_alias_clause: %empty  */
#line 12666 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lex_str_ptr)=0; }
#line 41952 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1952: /* opt_table_alias_clause: table_alias_clause  */
#line 12667 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.lex_str_ptr)= (yyvsp[0].lex_str_ptr); }
#line 41958 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1953: /* table_alias_clause: table_alias ident_table_alias  */
#line 12672 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING*) thd->memdup(&(yyvsp[0].ident_sys),sizeof(LEX_STRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 41968 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1956: /* opt_where_clause: %empty  */
#line 12685 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Select->where= 0; }
#line 41974 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1957: /* $@168: %empty  */
#line 12687 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= IN_WHERE;
          }
#line 41982 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1958: /* opt_where_clause: WHERE $@168 expr  */
#line 12691 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *select= Select;
            select->where= normalize_cond(thd, (yyvsp[0].item));
            select->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 41994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1960: /* $@169: %empty  */
#line 12703 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= IN_HAVING;
          }
#line 42002 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1961: /* opt_having_clause: HAVING $@169 expr  */
#line 12707 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->having= normalize_cond(thd, (yyvsp[0].item));
            sel->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 42014 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1964: /* group_list: group_list ',' order_ident order_dir  */
#line 12727 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
               MYSQL_YYABORT;
           }
#line 42023 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1965: /* group_list: order_ident order_dir  */
#line 12732 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 42032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1966: /* olap_opt: %empty  */
#line 12739 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1967: /* olap_opt: WITH_CUBE_SYM  */
#line 12741 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              'WITH CUBE' is reserved in the MySQL syntax, but not implemented,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH CUBE
              SQL-2003: GROUP BY ... CUBE(col1, col2, col3)
            */
            LEX *lex=Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH CUBE",
                                "global union parameters"));
            lex->current_select->olap= CUBE_TYPE;

            my_yyabort_error((ER_NOT_SUPPORTED_YET, MYF(0), "CUBE"));
          }
#line 42059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1968: /* olap_opt: WITH_ROLLUP_SYM  */
#line 12758 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              'WITH ROLLUP' is needed for backward compatibility,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH ROLLUP
              SQL-2003: GROUP BY ... ROLLUP(col1, col2, col3)
            */
            LEX *lex= Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH ROLLUP",
                                "global union parameters"));
            lex->current_select->olap= ROLLUP_TYPE;
          }
#line 42078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1969: /* opt_window_clause: %empty  */
#line 12780 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1970: /* opt_window_clause: WINDOW_SYM window_def_list  */
#line 12783 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1973: /* window_def: window_name AS window_spec  */
#line 12793 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(Select->add_window_def(thd, (yyvsp[-2].lex_str_ptr), lex->win_ref,
                                                Select->group_list,
                                                Select->order_list,
                                                lex->win_frame)))
              MYSQL_YYABORT;
          }
#line 42103 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1974: /* $@170: %empty  */
#line 12805 "/home/buildbot/git/sql/sql_yacc.yy"
          { Select->prepare_add_window_spec(thd); }
#line 42109 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1975: /* window_spec: '(' $@170 opt_window_ref opt_window_partition_clause opt_window_order_clause opt_window_frame_clause ')'  */
#line 12809 "/home/buildbot/git/sql/sql_yacc.yy"
          { }
#line 42115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1976: /* opt_window_ref: %empty  */
#line 12813 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42121 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1977: /* opt_window_ref: ident  */
#line 12815 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->lex->win_ref= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely(thd->lex->win_ref == NULL))
              MYSQL_YYABORT;
          }
#line 42131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1978: /* opt_window_partition_clause: %empty  */
#line 12823 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 42137 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1980: /* opt_window_order_clause: %empty  */
#line 12828 "/home/buildbot/git/sql/sql_yacc.yy"
                      { }
#line 42143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1981: /* opt_window_order_clause: ORDER_SYM BY order_list  */
#line 12829 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Select->order_list= *((yyvsp[0].select_order)); }
#line 42149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1982: /* opt_window_frame_clause: %empty  */
#line 12833 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42155 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1983: /* opt_window_frame_clause: window_frame_units window_frame_extent opt_window_frame_exclusion  */
#line 12835 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->win_frame=
              new (thd->mem_root) Window_frame((yyvsp[-2].frame_units),
                                               lex->frame_top_bound,
                                               lex->frame_bottom_bound,
                                               (yyvsp[0].frame_exclusion));
            if (unlikely(lex->win_frame == NULL))
              MYSQL_YYABORT;
          }
#line 42170 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1984: /* window_frame_units: ROWS_SYM  */
#line 12848 "/home/buildbot/git/sql/sql_yacc.yy"
                   { (yyval.frame_units)= Window_frame::UNITS_ROWS; }
#line 42176 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1985: /* window_frame_units: RANGE_SYM  */
#line 12849 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.frame_units)= Window_frame::UNITS_RANGE; }
#line 42182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1986: /* window_frame_extent: window_frame_start  */
#line 12854 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[0].window_frame_bound);
            lex->frame_bottom_bound=
              new (thd->mem_root)
                Window_frame_bound(Window_frame_bound::CURRENT, NULL);
            if (unlikely(lex->frame_bottom_bound == NULL))
              MYSQL_YYABORT;
          }
#line 42196 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1987: /* window_frame_extent: BETWEEN_SYM window_frame_bound AND_SYM window_frame_bound  */
#line 12864 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[-2].window_frame_bound);
            lex->frame_bottom_bound= (yyvsp[0].window_frame_bound);
          }
#line 42206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1988: /* window_frame_start: UNBOUNDED_SYM PRECEDING_SYM  */
#line 12873 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root) 
                  Window_frame_bound(Window_frame_bound::PRECEDING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42217 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1989: /* window_frame_start: CURRENT_SYM ROW_SYM  */
#line 12880 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::CURRENT, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1990: /* window_frame_start: literal PRECEDING_SYM  */
#line 12887 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::PRECEDING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42239 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1991: /* window_frame_bound: window_frame_start  */
#line 12896 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.window_frame_bound)= (yyvsp[0].window_frame_bound); }
#line 42245 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1992: /* window_frame_bound: UNBOUNDED_SYM FOLLOWING_SYM  */
#line 12898 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42256 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1993: /* window_frame_bound: literal FOLLOWING_SYM  */
#line 12905 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 42267 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1994: /* opt_window_frame_exclusion: %empty  */
#line 12914 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42273 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1995: /* opt_window_frame_exclusion: EXCLUDE_SYM CURRENT_SYM ROW_SYM  */
#line 12916 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_CURRENT_ROW; }
#line 42279 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1996: /* opt_window_frame_exclusion: EXCLUDE_SYM GROUP_SYM  */
#line 12918 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_GROUP; }
#line 42285 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1997: /* opt_window_frame_exclusion: EXCLUDE_SYM TIES_SYM  */
#line 12920 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_TIES; }
#line 42291 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1998: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_MARIADB_SYM  */
#line 12922 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42297 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 1999: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_ORACLE_SYM  */
#line 12924 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 42303 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2003: /* alter_order_item: simple_ident_nospvar order_dir  */
#line 12942 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            bool ascending= ((yyvsp[0].num) == 1) ? true : false;
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item), ascending)))
              MYSQL_YYABORT;
          }
#line 42313 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2004: /* opt_order_clause: %empty  */
#line 12955 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_order)= NULL; }
#line 42319 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2005: /* opt_order_clause: order_clause  */
#line 12957 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_order)= (yyvsp[0].select_order); }
#line 42325 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2006: /* $@171: %empty  */
#line 12962 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thd->where= "ORDER clause";
          }
#line 42333 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2007: /* order_clause: ORDER_SYM BY $@171 order_list  */
#line 12966 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= (yyvsp[0].select_order);
          }
#line 42341 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2008: /* order_list: order_list ',' order_ident order_dir  */
#line 12973 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= (yyvsp[-3].select_order);
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item),(bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 42351 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2009: /* order_list: order_ident order_dir  */
#line 12979 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_order)= new (thd->mem_root) SQL_I_List<ORDER>();
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item), (bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 42361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2010: /* order_dir: %empty  */
#line 12987 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num) =  1; }
#line 42367 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2011: /* order_dir: ASC  */
#line 12988 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.num) =1; }
#line 42373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2012: /* order_dir: DESC  */
#line 12989 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.num) =0; }
#line 42379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2013: /* opt_limit_clause: %empty  */
#line 12994 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_limit).empty(); }
#line 42385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2014: /* opt_limit_clause: limit_clause  */
#line 12996 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.select_limit)= (yyvsp[0].select_limit); }
#line 42391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2015: /* limit_clause: LIMIT limit_options  */
#line 13001 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit)= (yyvsp[0].select_limit);
            if (!(yyval.select_limit).select_limit->basic_const_item() ||
                (yyval.select_limit).select_limit->val_int() > 0)
              Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42402 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2016: /* limit_clause: LIMIT limit_options ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13009 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit)= (yyvsp[-3].select_limit);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42411 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2017: /* limit_clause: LIMIT ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13014 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= 0;
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 0;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42422 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2018: /* opt_global_limit_clause: opt_limit_clause  */
#line 13024 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->explicit_limit= (yyvsp[0].select_limit).explicit_limit;
            Select->select_limit= (yyvsp[0].select_limit).select_limit;
            Select->offset_limit= (yyvsp[0].select_limit).offset_limit;
          }
#line 42432 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2019: /* limit_options: limit_option  */
#line 13033 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42442 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2020: /* limit_options: limit_option ',' limit_option  */
#line 13039 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= (yyvsp[-2].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42452 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2021: /* limit_options: limit_option OFFSET_SYM limit_option  */
#line 13045 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[-2].item);
            (yyval.select_limit).offset_limit= (yyvsp[0].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42462 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2022: /* limit_option: ident_cli  */
#line 13054 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42471 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2023: /* limit_option: ident_cli '.' ident_cli  */
#line 13059 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42480 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2024: /* limit_option: param_marker  */
#line 13064 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_param)->limit_clause_param= TRUE;
          }
#line 42488 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2025: /* limit_option: ULONGLONG_NUM  */
#line 13068 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42498 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2026: /* limit_option: LONG_NUM  */
#line 13074 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42508 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2027: /* limit_option: NUM  */
#line 13080 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42518 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2028: /* limit_rows_option: limit_option  */
#line 13089 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex=Lex;
            lex->limit_rows_examined= (yyvsp[0].item);
          }
#line 42527 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2029: /* delete_limit_clause: %empty  */
#line 13097 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->current_select->select_limit= 0;
          }
#line 42536 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2030: /* delete_limit_clause: LIMIT limit_option  */
#line 13102 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
            sel->explicit_limit= 1;
          }
#line 42547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2031: /* delete_limit_clause: LIMIT ROWS_SYM EXAMINED_SYM  */
#line 13108 "/home/buildbot/git/sql/sql_yacc.yy"
                                     { thd->parse_error(); MYSQL_YYABORT; }
#line 42553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2032: /* delete_limit_clause: LIMIT limit_option ROWS_SYM EXAMINED_SYM  */
#line 13109 "/home/buildbot/git/sql/sql_yacc.yy"
                                                  { thd->parse_error(); MYSQL_YYABORT; }
#line 42559 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2033: /* order_limit_lock: order_or_limit  */
#line 13114 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock);
            (yyval.order_limit_lock)->lock.empty();
          }
#line 42568 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2034: /* order_limit_lock: order_or_limit select_lock_type  */
#line 13119 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[-1].order_limit_lock);
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2035: /* order_limit_lock: select_lock_type  */
#line 13124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit.empty();
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2036: /* opt_order_limit_lock: %empty  */
#line 13136 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select();
            (yyval.order_limit_lock)= NULL;
          }
#line 42599 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2037: /* opt_order_limit_lock: order_limit_lock  */
#line 13140 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock); }
#line 42605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2040: /* opt_procedure_or_into: %empty  */
#line 13153 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock).empty();
          }
#line 42613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2041: /* opt_procedure_or_into: procedure_clause opt_select_lock_type  */
#line 13157 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2042: /* opt_procedure_or_into: into opt_select_lock_type  */
#line 13161 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                ER_WARN_DEPRECATED_SYNTAX,
                                ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                "<select expression> INTO <destination>;",
                                "'SELECT <select list> INTO <destination>"
                                " FROM...'");
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42635 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2043: /* order_or_limit: order_clause opt_limit_clause  */
#line 13174 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= (yyvsp[-1].select_order);
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42647 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2044: /* order_or_limit: limit_clause  */
#line 13182 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_order_limit_lock *op= (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            op->order_list= NULL;
            op->limit= (yyvsp[0].select_limit);
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2047: /* int_num: opt_plus NUM  */
#line 13200 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.num)= (int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2048: /* int_num: '-' NUM  */
#line 13201 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.num)= -(int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2049: /* ulong_num: opt_plus NUM  */
#line 13205 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2050: /* ulong_num: HEX_NUM  */
#line 13206 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42685 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2051: /* ulong_num: opt_plus LONG_NUM  */
#line 13207 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42691 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2052: /* ulong_num: opt_plus ULONGLONG_NUM  */
#line 13208 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42697 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2053: /* ulong_num: opt_plus DECIMAL_NUM  */
#line 13209 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2054: /* ulong_num: opt_plus FLOAT_NUM  */
#line 13210 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2055: /* real_ulong_num: NUM  */
#line 13214 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2056: /* real_ulong_num: HEX_NUM  */
#line 13215 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2057: /* real_ulong_num: LONG_NUM  */
#line 13216 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42727 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2058: /* real_ulong_num: ULONGLONG_NUM  */
#line 13217 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42733 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2059: /* real_ulong_num: dec_num_error  */
#line 13218 "/home/buildbot/git/sql/sql_yacc.yy"
                        { MYSQL_YYABORT; }
#line 42739 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2060: /* longlong_num: opt_plus NUM  */
#line 13222 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2061: /* longlong_num: LONG_NUM  */
#line 13223 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42751 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2062: /* longlong_num: '-' NUM  */
#line 13224 "/home/buildbot/git/sql/sql_yacc.yy"
                          { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42757 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2063: /* longlong_num: '-' LONG_NUM  */
#line 13225 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42763 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2064: /* ulonglong_num: opt_plus NUM  */
#line 13229 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42769 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2065: /* ulonglong_num: opt_plus ULONGLONG_NUM  */
#line 13230 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42775 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2066: /* ulonglong_num: opt_plus LONG_NUM  */
#line 13231 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42781 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2067: /* ulonglong_num: opt_plus DECIMAL_NUM  */
#line 13232 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2068: /* ulonglong_num: opt_plus FLOAT_NUM  */
#line 13233 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2069: /* real_ulonglong_num: NUM  */
#line 13237 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42799 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2070: /* real_ulonglong_num: ULONGLONG_NUM  */
#line 13238 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2071: /* real_ulonglong_num: HEX_NUM  */
#line 13239 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ulonglong_number)= strtoull((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42811 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2072: /* real_ulonglong_num: LONG_NUM  */
#line 13240 "/home/buildbot/git/sql/sql_yacc.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2073: /* real_ulonglong_num: dec_num_error  */
#line 13241 "/home/buildbot/git/sql/sql_yacc.yy"
                        { MYSQL_YYABORT; }
#line 42823 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2074: /* dec_num_error: dec_num  */
#line 13246 "/home/buildbot/git/sql/sql_yacc.yy"
          { thd->parse_error(ER_ONLY_INTEGERS_ALLOWED); }
#line 42829 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2077: /* choice: ulong_num  */
#line 13255 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.choice)= (yyvsp[0].ulong_num) != 0 ? HA_CHOICE_YES : HA_CHOICE_NO; }
#line 42835 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2078: /* choice: DEFAULT  */
#line 13256 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.choice)= HA_CHOICE_UNDEF; }
#line 42841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2079: /* bool: ulong_num  */
#line 13260 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= (yyvsp[0].ulong_num) != 0; }
#line 42847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2080: /* bool: TRUE_SYM  */
#line 13261 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 1; }
#line 42853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2081: /* bool: FALSE_SYM  */
#line 13262 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.ulong_num)= 0; }
#line 42859 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2082: /* $@172: %empty  */
#line 13267 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;

            lex->proc_list.elements=0;
            lex->proc_list.first=0;
            lex->proc_list.next= &lex->proc_list.first;
            Item_field *item= new (thd->mem_root)
                                Item_field(thd, &lex->current_select->context,
                                           NULL, NULL, &(yyvsp[0].ident_sys));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_proc_to_list(thd, item)))
              MYSQL_YYABORT;
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);

            /*
              PROCEDURE CLAUSE cannot handle subquery as one of its parameter,
              so disallow any subqueries further.
              Alow subqueries back once the parameters are reduced.
            */
            Lex->clause_that_disallows_subselect= "PROCEDURE";
            Select->options|= OPTION_PROCEDURE_CLAUSE;
          }
#line 42887 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2083: /* procedure_clause: PROCEDURE_SYM ident $@172 '(' procedure_list ')'  */
#line 13291 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* Subqueries are allowed from now.*/
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 42896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2084: /* procedure_list: %empty  */
#line 13298 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 42902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2085: /* procedure_list: procedure_list2  */
#line 13299 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 42908 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2088: /* procedure_item: remember_name expr remember_end  */
#line 13309 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(add_proc_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 42919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2089: /* $@173: %empty  */
#line 13318 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe &&
                unlikely((!(lex->result= new (thd->mem_root)
                            select_dumpvar(thd)))))
              MYSQL_YYABORT;
          }
#line 42931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2090: /* select_var_list_init: $@173 select_var_list  */
#line 13326 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42937 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2092: /* select_var_list: select_var_ident  */
#line 13331 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 42943 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2093: /* select_var_ident: select_outvar  */
#line 13335 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->result)
            {
              if (unlikely((yyvsp[0].myvar) == NULL))
                MYSQL_YYABORT;
              ((select_dumpvar *)Lex->result)->var_list.push_back((yyvsp[0].myvar), thd->mem_root);
            }
            else
            {
              /*
                The parser won't create select_result instance only
                if it's an EXPLAIN.
              */
              DBUG_ASSERT(Lex->describe);
            }
          }
#line 42964 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2094: /* select_outvar: '@' ident_or_text  */
#line 13355 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.myvar) = Lex->result ? new (thd->mem_root) my_var_user(&(yyvsp[0].lex_str)) : NULL;
          }
#line 42972 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2095: /* select_outvar: ident_or_text  */
#line 13359 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[0].lex_str))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2096: /* select_outvar: ident '.' ident  */
#line 13364 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42990 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2097: /* into: INTO into_destination  */
#line 13372 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 42996 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2098: /* $@174: %empty  */
#line 13377 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            if (unlikely(!(lex->exchange=
                         new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str, 0))) ||
                unlikely(!(lex->result=
                         new (thd->mem_root)
                         select_export(thd, lex->exchange))))
              MYSQL_YYABORT;
          }
#line 43011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2099: /* $@175: %empty  */
#line 13388 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 43017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2101: /* into_destination: DUMPFILE TEXT_STRING_filesystem  */
#line 13391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe)
            {
              lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
              if (unlikely(!(lex->exchange=
                             new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str,1))))
                MYSQL_YYABORT;
              if (unlikely(!(lex->result=
                           new (thd->mem_root)
                           select_dump(thd, lex->exchange))))
                MYSQL_YYABORT;
            }
          }
#line 43036 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2102: /* into_destination: select_var_list_init  */
#line 13406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 43044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2103: /* $@176: %empty  */
#line 13417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_DO;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 43056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2104: /* do: DO_SYM $@176 expr_list  */
#line 13425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->insert_list= (yyvsp[0].item_list);
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2105: /* $@177: %empty  */
#line 13439 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_TABLE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2106: /* drop: DROP opt_temporary table_or_tables opt_if_exists $@177 table_list opt_lock_wait_timeout opt_restrict  */
#line 13446 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2107: /* $@178: %empty  */
#line 13448 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 43093 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2108: /* drop: DROP INDEX_SYM $@178 opt_if_exists_table_element ident ON table_ident opt_lock_wait_timeout  */
#line 13453 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[-3].ident_sys).str, (yyvsp[-4].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->sql_command= SQLCOM_DROP_INDEX;
            lex->alter_info.reset();
            lex->alter_info.flags= ALTER_DROP_INDEX;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            if (unlikely(!lex->current_select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           TL_READ_NO_INSERT,
                                           MDL_SHARED_UPGRADABLE)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 43115 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2109: /* drop: DROP DATABASE opt_if_exists ident  */
#line 13471 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_DB, (yyvsp[-1].object_ddl_options));
            lex->name= (yyvsp[0].ident_sys);
          }
#line 43125 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2110: /* drop: DROP FUNCTION_SYM opt_if_exists ident '.' ident  */
#line 13477 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            sp_name *spname;
            if (unlikely((yyvsp[-2].ident_sys).str && check_db_name((LEX_STRING*) &(yyvsp[-2].ident_sys))))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-3].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), true);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 43143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2111: /* drop: DROP FUNCTION_SYM opt_if_exists ident  */
#line 13491 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            LEX_CSTRING db= {0, 0};
            sp_name *spname;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (thd->db.str && unlikely(lex->copy_db_to(&db)))
              MYSQL_YYABORT;
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-1].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&db, &(yyvsp[0].ident_sys), false);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 43162 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2112: /* drop: DROP PROCEDURE_SYM opt_if_exists sp_name  */
#line 13506 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            lex->set_command(SQLCOM_DROP_PROCEDURE, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 43174 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2113: /* drop: DROP USER_SYM opt_if_exists clear_privileges user_list  */
#line 13514 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_USER, (yyvsp[-2].object_ddl_options));
          }
#line 43182 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2114: /* drop: DROP ROLE_SYM opt_if_exists clear_privileges role_list  */
#line 13518 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_ROLE, (yyvsp[-2].object_ddl_options));
          }
#line 43190 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2115: /* $@179: %empty  */
#line 13522 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_VIEW, (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2116: /* drop: DROP VIEW_SYM opt_if_exists $@179 table_list opt_restrict  */
#line 13529 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2117: /* drop: DROP EVENT_SYM opt_if_exists sp_name  */
#line 13531 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->set_command(SQLCOM_DROP_EVENT, (yyvsp[-1].object_ddl_options));
          }
#line 43216 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2118: /* drop: DROP TRIGGER_SYM opt_if_exists sp_name  */
#line 13536 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_TRIGGER, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 43226 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2119: /* drop: DROP TABLESPACE tablespace_name opt_ts_engine opt_ts_wait  */
#line 13542 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_TABLESPACE;
          }
#line 43235 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2120: /* drop: DROP LOGFILE_SYM GROUP_SYM logfile_group_name opt_ts_engine opt_ts_wait  */
#line 13547 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_LOGFILE_GROUP;
          }
#line 43244 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2121: /* drop: DROP SERVER_SYM opt_if_exists ident_or_text  */
#line 13552 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_DROP_SERVER, (yyvsp[-1].object_ddl_options));
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 43253 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2122: /* $@180: %empty  */
#line 13558 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_SEQUENCE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            lex->table_type= TABLE_TYPE_SEQUENCE;
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2123: /* drop: DROP opt_temporary SEQUENCE_SYM opt_if_exists $@180 table_list  */
#line 13566 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 43271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2126: /* table_name: table_ident  */
#line 13576 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (!thd->lex->current_select_or_default()->
                                           add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type))
              MYSQL_YYABORT;
          }
#line 43284 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2127: /* table_name_with_opt_use_partition: table_ident opt_use_partition  */
#line 13588 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                    TL_OPTION_UPDATING,
                                                    YYPS->m_lock_type,
                                                    YYPS->m_mdl_type,
                                                    NULL,
                                                    (yyvsp[0].string_list))))
              MYSQL_YYABORT;
          }
#line 43298 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2130: /* table_alias_ref: table_ident_opt_wild  */
#line 13606 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2131: /* opt_if_exists_table_element: %empty  */
#line 13619 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->check_exists= FALSE;
          (yyval.num)= 0;
        }
#line 43321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2132: /* opt_if_exists_table_element: IF_SYM EXISTS  */
#line 13624 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->check_exists= TRUE;
          (yyval.num)= 1;
        }
#line 43330 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2133: /* opt_if_exists: %empty  */
#line 13632 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_NONE);
        }
#line 43338 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2134: /* opt_if_exists: IF_SYM EXISTS  */
#line 13636 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_EXISTS);
        }
#line 43346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2135: /* opt_temporary: %empty  */
#line 13642 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)= 0; }
#line 43352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2136: /* opt_temporary: TEMPORARY  */
#line 13643 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= HA_LEX_CREATE_TMP_TABLE; }
#line 43358 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2137: /* $@181: %empty  */
#line 13651 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_INSERT;
            lex->duplicates= DUP_ERROR;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->inc_select_stack_outer_barrier();
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2138: /* $@182: %empty  */
#line 13663 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_lock_for_tables((yyvsp[-2].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43382 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2139: /* insert: INSERT $@181 insert_lock_option opt_ignore insert2 $@182 insert_field_spec opt_insert_update  */
#line 13668 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43393 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2140: /* $@183: %empty  */
#line 13678 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPLACE;
            lex->duplicates= DUP_REPLACE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->inc_select_stack_outer_barrier();
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43408 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2141: /* $@184: %empty  */
#line 13689 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->set_lock_for_tables((yyvsp[-1].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43417 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2142: /* replace: REPLACE $@183 replace_lock_option insert2 $@184 insert_field_spec  */
#line 13694 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43428 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2143: /* insert_lock_option: %empty  */
#line 13704 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              If it is SP we do not allow insert optimisation when result of
              insert visible only after the table unlocking but everyone can
              read table.
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 43441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2144: /* insert_lock_option: LOW_PRIORITY  */
#line 13712 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2145: /* insert_lock_option: DELAYED_SYM  */
#line 13714 "/home/buildbot/git/sql/sql_yacc.yy"
        {
         // QQ: why was +1?
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43458 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2146: /* insert_lock_option: HIGH_PRIORITY  */
#line 13720 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.lock_type)= TL_WRITE; }
#line 43464 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2147: /* replace_lock_option: opt_low_priority  */
#line 13724 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lock_type)= (yyvsp[0].lock_type); }
#line 43470 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2148: /* replace_lock_option: DELAYED_SYM  */
#line 13726 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43480 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2149: /* insert2: INTO insert_table  */
#line 13734 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 43486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2150: /* insert2: insert_table  */
#line 13735 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 43492 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2151: /* $@185: %empty  */
#line 13739 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->save_parsing_place= Select->parsing_place;
          }
#line 43500 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2152: /* insert_table: $@185 table_name_with_opt_use_partition  */
#line 13743 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            //lex->field_list.empty();
            lex->many_values.empty();
            lex->insert_list=0;
          }
#line 43511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2153: /* insert_field_spec: insert_values  */
#line 13752 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 43517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2154: /* insert_field_spec: insert_field_list insert_values  */
#line 13753 "/home/buildbot/git/sql/sql_yacc.yy"
                                          {}
#line 43523 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2155: /* $@186: %empty  */
#line 13755 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)) ||
                unlikely(lex->many_values.push_back(lex->insert_list,
                         thd->mem_root)))
              MYSQL_YYABORT;
            lex->current_select->parsing_place= NO_MATTER;
          }
#line 43536 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2157: /* insert_field_list: LEFT_PAREN_ALT opt_fields ')'  */
#line 13768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->current_select->parsing_place= AFTER_LIST;
          }
#line 43544 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2160: /* fields: fields ',' insert_ident  */
#line 13780 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43550 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2161: /* fields: insert_ident  */
#line 13781 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43556 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2162: /* insert_values: create_select_query_expression  */
#line 13787 "/home/buildbot/git/sql/sql_yacc.yy"
                                        {}
#line 43562 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2167: /* ident_eq_value: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 13802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->field_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely(lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43573 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2168: /* equal: '='  */
#line 13811 "/home/buildbot/git/sql/sql_yacc.yy"
              {}
#line 43579 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2169: /* equal: SET_VAR  */
#line 13812 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 43585 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2170: /* opt_equal: %empty  */
#line 13816 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43591 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2171: /* opt_equal: equal  */
#line 13817 "/home/buildbot/git/sql/sql_yacc.yy"
                {}
#line 43597 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2172: /* opt_with: opt_equal  */
#line 13821 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 43603 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2173: /* opt_with: WITH  */
#line 13822 "/home/buildbot/git/sql/sql_yacc.yy"
               {}
#line 43609 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2174: /* opt_by: opt_equal  */
#line 13826 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 43615 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2175: /* opt_by: BY  */
#line 13827 "/home/buildbot/git/sql/sql_yacc.yy"
             {}
#line 43621 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2176: /* $@187: %empty  */
#line 13832 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2177: /* no_braces: '(' $@187 opt_values ')'  */
#line 13837 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43641 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2178: /* $@188: %empty  */
#line 13847 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2179: /* no_braces_with_names: '(' $@188 opt_values_with_names ')'  */
#line 13852 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43661 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2180: /* opt_values: %empty  */
#line 13861 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43667 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2182: /* opt_values_with_names: %empty  */
#line 13866 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 43673 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2184: /* values: values ',' expr_or_ignore_or_default  */
#line 13872 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43682 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2185: /* values: expr_or_ignore_or_default  */
#line 13877 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43691 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2186: /* values_with_names: values_with_names ',' remember_name expr_or_ignore_or_default remember_end  */
#line 13885 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
           }
#line 43703 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2187: /* values_with_names: remember_name expr_or_ignore_or_default remember_end  */
#line 13893 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 43715 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2188: /* expr_or_ignore: expr  */
#line 13903 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)= (yyvsp[0].item);}
#line 43721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2189: /* expr_or_ignore: IGNORE_SYM  */
#line 13905 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_ignore_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43731 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2190: /* expr_or_ignore_or_default: expr_or_ignore  */
#line 13913 "/home/buildbot/git/sql/sql_yacc.yy"
                         { (yyval.item)= (yyvsp[0].item);}
#line 43737 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2191: /* expr_or_ignore_or_default: DEFAULT  */
#line 13915 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_default_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43747 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2193: /* $@189: %empty  */
#line 13924 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Lex->duplicates= DUP_UPDATE; }
#line 43753 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2194: /* $@190: %empty  */
#line 13926 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= IN_UPDATE_ON_DUP_KEY;
          }
#line 43761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2195: /* opt_insert_update: ON DUPLICATE_SYM $@189 KEY_SYM UPDATE_SYM $@190 insert_update_list  */
#line 13930 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    Select->parsing_place= NO_MATTER;
          }
#line 43769 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2196: /* update_table_list: table_ident opt_use_partition for_portion_of_time_clause opt_table_alias_clause opt_key_definition  */
#line 13938 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            (yyval.table_list)->period_conditions= Lex->period_conditions;
          }
#line 43786 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2197: /* update_table_list: join_table_list  */
#line 13950 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.table_list)= (yyvsp[0].table_list); }
#line 43792 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2198: /* $@191: %empty  */
#line 13957 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->sql_command= SQLCOM_UPDATE;
            lex->duplicates= DUP_ERROR; 
          }
#line 43805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2199: /* $@192: %empty  */
#line 13967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            SELECT_LEX *slex= Lex->first_select_lex();
            if (slex->table_list.elements > 1)
              Lex->sql_command= SQLCOM_UPDATE_MULTI;
            else if (slex->get_table_list()->derived)
            {
              /* it is single table update and it is update of derived table */
              my_error(ER_NON_UPDATABLE_TABLE, MYF(0),
                       slex->get_table_list()->alias.str, "UPDATE");
              MYSQL_YYABORT;
            }
            /*
              In case of multi-update setting write lock for all tables may
              be too pessimistic. We will decrease lock level if possible in
              mysql_multi_update().
            */
            slex->set_lock_for_tables((yyvsp[-4].lock_type), slex->table_list.elements == 1);
          }
#line 43828 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2200: /* update: UPDATE_SYM $@191 opt_low_priority opt_ignore update_table_list SET update_list $@192 opt_where_clause opt_order_clause delete_limit_clause  */
#line 13986 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-1].select_order))
              Select->order_list= *((yyvsp[-1].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43840 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2203: /* update_elem: simple_ident_nospvar equal DEFAULT  */
#line 14002 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *def= new (thd->mem_root) Item_default_value(thd,
                                             Lex->current_context(), (yyvsp[-2].item), 1);
            if (!def || add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, def))
              MYSQL_YYABORT;
          }
#line 43851 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2204: /* update_elem: simple_ident_nospvar equal expr_or_ignore  */
#line 14009 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 43860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2207: /* insert_update_elem: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 14022 "/home/buildbot/git/sql/sql_yacc.yy"
          {
          LEX *lex= Lex;
          if (unlikely(lex->update_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
              unlikely(lex->value_list.push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2208: /* opt_low_priority: %empty  */
#line 14031 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 43877 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2209: /* opt_low_priority: LOW_PRIORITY  */
#line 14032 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2210: /* $@193: %empty  */
#line 14039 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_DELETE;
            YYPS->m_lock_type= TL_WRITE_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_WRITE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->ignore= 0;
            lex->first_select_lex()->order_list.empty();
          }
#line 43899 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2211: /* delete: DELETE_SYM $@193 delete_part2  */
#line 14051 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43908 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2212: /* opt_delete_system_time: %empty  */
#line 14059 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_HISTORY);
          }
#line 43916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2213: /* opt_delete_system_time: BEFORE_SYM SYSTEM_TIME_SYM history_point  */
#line 14063 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BEFORE, (yyvsp[0].vers_history_point));
          }
#line 43924 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2214: /* delete_part2: opt_delete_options single_multi  */
#line 14069 "/home/buildbot/git/sql/sql_yacc.yy"
                                          {}
#line 43930 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2215: /* delete_part2: HISTORY_SYM delete_single_table opt_delete_system_time  */
#line 14071 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->last_table()->vers_conditions= Lex->vers_conditions;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43941 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2216: /* delete_single_table: FROM table_ident opt_use_partition  */
#line 14081 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type,
                                           NULL,
                                           (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2217: /* delete_single_table_for_period: delete_single_table opt_for_portion_of_time_clause  */
#line 14096 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if ((yyvsp[0].num))
            Lex->last_table()->period_conditions= Lex->period_conditions;
        }
#line 43966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2218: /* single_multi: delete_single_table_for_period opt_where_clause opt_order_clause delete_limit_clause opt_select_expressions  */
#line 14108 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if ((yyvsp[-2].select_order))
              Select->order_list= *((yyvsp[-2].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2219: /* $@194: %empty  */
#line 14116 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2220: /* single_multi: table_wild_list $@194 FROM join_table_list opt_where_clause  */
#line 14122 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2221: /* $@195: %empty  */
#line 14130 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 44010 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2222: /* single_multi: FROM table_alias_ref_list $@195 USING join_table_list opt_where_clause  */
#line 14136 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 44022 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2227: /* table_wild_one: ident opt_wild  */
#line 14157 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 44041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2228: /* table_wild_one: ident '.' ident opt_wild  */
#line 14172 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 44060 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2229: /* opt_wild: %empty  */
#line 14189 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 44066 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2230: /* opt_wild: '.' '*'  */
#line 14190 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 44072 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2231: /* opt_delete_options: %empty  */
#line 14194 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 44078 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2232: /* opt_delete_options: opt_delete_option opt_delete_options  */
#line 14195 "/home/buildbot/git/sql/sql_yacc.yy"
                                               {}
#line 44084 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2233: /* opt_delete_option: QUICK  */
#line 14199 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Select->options|= OPTION_QUICK; }
#line 44090 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2234: /* opt_delete_option: LOW_PRIORITY  */
#line 14200 "/home/buildbot/git/sql/sql_yacc.yy"
                       { YYPS->m_lock_type= TL_WRITE_LOW_PRIORITY; }
#line 44096 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2235: /* opt_delete_option: IGNORE_SYM  */
#line 14201 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->ignore= 1; }
#line 44102 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2236: /* $@196: %empty  */
#line 14206 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= Lex;
            lex->sql_command= SQLCOM_TRUNCATE;
            lex->alter_info.reset();
            lex->first_select_lex()->options= 0;
            lex->sql_cache= LEX::SQL_CACHE_UNSPECIFIED;
            lex->first_select_lex()->order_list.empty();
            YYPS->m_lock_type= TL_WRITE;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 44117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2237: /* truncate: TRUNCATE_SYM $@196 opt_table_sym table_name opt_lock_wait_timeout  */
#line 14217 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_truncate_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 44129 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2244: /* profile_def: CPU_SYM  */
#line 14241 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_CPU;
    }
#line 44137 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2245: /* profile_def: MEMORY_SYM  */
#line 14245 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_MEMORY;
    }
#line 44145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2246: /* profile_def: BLOCK_SYM IO_SYM  */
#line 14249 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_BLOCK_IO;
    }
#line 44153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2247: /* profile_def: CONTEXT_SYM SWITCHES_SYM  */
#line 14253 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_CONTEXT;
    }
#line 44161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2248: /* profile_def: PAGE_SYM FAULTS_SYM  */
#line 14257 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_PAGE_FAULTS;
    }
#line 44169 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2249: /* profile_def: IPC_SYM  */
#line 14261 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_IPC;
    }
#line 44177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2250: /* profile_def: SWAPS_SYM  */
#line 14265 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_SWAPS;
    }
#line 44185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2251: /* profile_def: SOURCE_SYM  */
#line 14269 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_SOURCE;
    }
#line 44193 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2252: /* profile_def: ALL  */
#line 14273 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_options|= PROFILE_ALL;
    }
#line 44201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2253: /* opt_profile_args: %empty  */
#line 14280 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_query_id= 0;
    }
#line 44209 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2254: /* opt_profile_args: FOR_SYM QUERY_SYM NUM  */
#line 14284 "/home/buildbot/git/sql/sql_yacc.yy"
    {
      Lex->profile_query_id= atoi((yyvsp[0].lex_str).str);
    }
#line 44217 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2255: /* $@197: %empty  */
#line 14293 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->wild=0;
            lex->ident= null_clex_str;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->create_info.init();
          }
#line 44232 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2256: /* show: SHOW $@197 show_param  */
#line 14304 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44241 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2257: /* show_param: DATABASES wild_and_where  */
#line 14312 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_DATABASES;
             if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SCHEMATA)))
               MYSQL_YYABORT;
           }
#line 44252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2258: /* show_param: opt_full TABLES opt_db wild_and_where  */
#line 14319 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLES;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLE_NAMES))
               MYSQL_YYABORT;
           }
#line 44264 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2259: /* show_param: opt_full TRIGGERS_SYM opt_db wild_and_where  */
#line 14327 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TRIGGERS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TRIGGERS))
               MYSQL_YYABORT;
           }
#line 44276 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2260: /* show_param: EVENTS_SYM opt_db wild_and_where  */
#line 14335 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_EVENTS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_EVENTS))
               MYSQL_YYABORT;
           }
#line 44288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2261: /* show_param: TABLE_SYM STATUS_SYM opt_db wild_and_where  */
#line 14343 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLE_STATUS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLES))
               MYSQL_YYABORT;
           }
#line 44300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2262: /* show_param: OPEN_SYM TABLES opt_db wild_and_where  */
#line 14351 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_OPEN_TABLES;
            lex->first_select_lex()->db= (yyvsp[-1].lex_str);
            if (prepare_schema_table(thd, lex, 0, SCH_OPEN_TABLES))
              MYSQL_YYABORT;
          }
#line 44312 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2263: /* show_param: PLUGINS_SYM  */
#line 14359 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44323 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2264: /* show_param: PLUGINS_SYM SONAME_SYM TEXT_STRING_sys  */
#line 14366 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->ident= (yyvsp[0].lex_str);
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2265: /* show_param: PLUGINS_SYM SONAME_SYM wild_and_where  */
#line 14373 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 44344 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2266: /* show_param: ENGINE_SYM known_storage_engines show_engine_param  */
#line 14379 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.db_type= (yyvsp[-1].db_type); }
#line 44350 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2267: /* show_param: ENGINE_SYM ALL show_engine_param  */
#line 14381 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->create_info.db_type= NULL; }
#line 44356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2268: /* show_param: opt_full COLUMNS from_or_in table_ident opt_db wild_and_where  */
#line 14383 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44369 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2269: /* show_param: master_or_binary LOGS_SYM  */
#line 14392 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_BINLOGS;
          }
#line 44377 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2270: /* show_param: SLAVE HOSTS_SYM  */
#line 14396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_HOSTS;
          }
#line 44385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2271: /* $@198: %empty  */
#line 14400 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_BINLOG_EVENTS;
          }
#line 44394 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2273: /* $@199: %empty  */
#line 14406 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_RELAYLOG_EVENTS;
          }
#line 44403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2275: /* show_param: keys_or_index from_or_in table_ident opt_db opt_where_clause  */
#line 14412 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_KEYS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_STATISTICS)))
              MYSQL_YYABORT;
          }
#line 44416 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2276: /* show_param: opt_storage ENGINES_SYM  */
#line 14421 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_STORAGE_ENGINES;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_ENGINES)))
              MYSQL_YYABORT;
          }
#line 44427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2277: /* show_param: AUTHORS_SYM  */
#line 14428 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_AUTHORS;
          }
#line 44436 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2278: /* show_param: CONTRIBUTORS_SYM  */
#line 14433 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_CONTRIBUTORS;
          }
#line 44445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2279: /* show_param: PRIVILEGES  */
#line 14438 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_PRIVILEGES;
          }
#line 44454 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2280: /* show_param: COUNT_SYM '(' '*' ')' WARNINGS  */
#line 14443 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("warning_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44463 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2281: /* show_param: COUNT_SYM '(' '*' ')' ERRORS  */
#line 14448 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("error_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44472 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2282: /* show_param: WARNINGS opt_global_limit_clause  */
#line 14453 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_WARNS;}
#line 44478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2283: /* show_param: ERRORS opt_global_limit_clause  */
#line 14455 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_ERRORS;}
#line 44484 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2284: /* show_param: PROFILES_SYM  */
#line 14457 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command = SQLCOM_SHOW_PROFILES; }
#line 44490 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2285: /* show_param: PROFILE_SYM opt_profile_defs opt_profile_args opt_global_limit_clause  */
#line 14459 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PROFILE;
            if (unlikely(prepare_schema_table(thd, lex, NULL, SCH_PROFILES)))
              MYSQL_YYABORT;
          }
#line 44501 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2286: /* show_param: opt_var_type STATUS_SYM wild_and_where  */
#line 14466 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_STATUS)))
              MYSQL_YYABORT;
          }
#line 44513 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2287: /* show_param: opt_full PROCESSLIST_SYM  */
#line 14474 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_PROCESSLIST;}
#line 44519 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2288: /* show_param: opt_var_type VARIABLES wild_and_where  */
#line 14476 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_VARIABLES;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_VARIABLES)))
              MYSQL_YYABORT;
          }
#line 44531 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2289: /* show_param: charset wild_and_where  */
#line 14484 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CHARSETS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_CHARSETS)))
              MYSQL_YYABORT;
          }
#line 44542 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2290: /* show_param: COLLATION_SYM wild_and_where  */
#line 14491 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_COLLATIONS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_COLLATIONS)))
              MYSQL_YYABORT;
          }
#line 44553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2291: /* show_param: GRANTS  */
#line 14498 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_GRANTS;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user_and_current_role;
          }
#line 44565 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2292: /* show_param: GRANTS FOR_SYM user_or_role clear_privileges  */
#line 14506 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_GRANTS;
            lex->grant_user=(yyvsp[-1].lex_user);
          }
#line 44575 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2293: /* show_param: CREATE DATABASE opt_if_not_exists ident  */
#line 14512 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->set_command(SQLCOM_SHOW_CREATE_DB, (yyvsp[-1].object_ddl_options));
            Lex->name= (yyvsp[0].ident_sys);
          }
#line 44584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2294: /* show_param: CREATE TABLE_SYM table_ident  */
#line 14517 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL,0))
              MYSQL_YYABORT;
            lex->create_info.storage_media= HA_SM_DEFAULT;
          }
#line 44596 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2295: /* show_param: CREATE VIEW_SYM table_ident  */
#line 14525 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_VIEW;
          }
#line 44608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2296: /* show_param: CREATE SEQUENCE_SYM table_ident  */
#line 14533 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_SEQUENCE;
          }
#line 44620 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2297: /* show_param: MASTER_SYM STATUS_SYM  */
#line 14541 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_MASTER_STAT;
          }
#line 44628 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2298: /* show_param: ALL SLAVES STATUS_SYM  */
#line 14545 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 1;
          }
#line 44637 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2299: /* show_param: SLAVE STATUS_SYM  */
#line 14550 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
            lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            lex->verbose= 0;
          }
#line 44648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2300: /* show_param: SLAVE connection_name STATUS_SYM  */
#line 14557 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 0;
          }
#line 44657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2301: /* show_param: CREATE PROCEDURE_SYM sp_name  */
#line 14562 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_PROC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2302: /* show_param: CREATE FUNCTION_SYM sp_name  */
#line 14569 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_FUNC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44679 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2303: /* show_param: CREATE PACKAGE_MARIADB_SYM sp_name  */
#line 14576 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE;
            lex->spname= (yyvsp[0].spname);
          }
#line 44689 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2304: /* show_param: CREATE PACKAGE_MARIADB_SYM BODY_MARIADB_SYM sp_name  */
#line 14582 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE_BODY;
            lex->spname= (yyvsp[0].spname);
          }
#line 44699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2305: /* show_param: CREATE TRIGGER_SYM sp_name  */
#line 14588 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CREATE_TRIGGER;
            lex->spname= (yyvsp[0].spname);
          }
#line 44709 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2306: /* show_param: CREATE USER_SYM  */
#line 14594 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user;
          }
#line 44721 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2307: /* show_param: CREATE USER_SYM user  */
#line 14602 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
             Lex->grant_user= (yyvsp[0].lex_user);
          }
#line 44730 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2308: /* show_param: PROCEDURE_SYM STATUS_SYM wild_and_where  */
#line 14607 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PROC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2309: /* show_param: FUNCTION_SYM STATUS_SYM wild_and_where  */
#line 14614 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_FUNC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44752 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2310: /* show_param: PACKAGE_MARIADB_SYM STATUS_SYM wild_and_where  */
#line 14621 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44763 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2311: /* show_param: PACKAGE_MARIADB_SYM BODY_MARIADB_SYM STATUS_SYM wild_and_where  */
#line 14628 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE_BODY;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44774 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2312: /* show_param: PROCEDURE_SYM CODE_SYM sp_name  */
#line 14635 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PROC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2313: /* show_param: FUNCTION_SYM CODE_SYM sp_name  */
#line 14640 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_FUNC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44792 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2314: /* show_param: PACKAGE_MARIADB_SYM BODY_MARIADB_SYM CODE_SYM sp_name  */
#line 14645 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PACKAGE_BODY_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2315: /* show_param: CREATE EVENT_SYM sp_name  */
#line 14650 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->sql_command = SQLCOM_SHOW_CREATE_EVENT;
          }
#line 44810 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2316: /* show_param: describe_command FOR_SYM expr  */
#line 14655 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_EXPLAIN;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_EXPLAIN)))
              MYSQL_YYABORT;
            add_value_to_list(thd, (yyvsp[0].item));
          }
#line 44821 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2317: /* show_param: IDENT_sys remember_tok_start wild_and_where  */
#line 14662 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             LEX *lex= Lex;
             bool in_plugin;
             lex->sql_command= SQLCOM_SHOW_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-2].ident_sys), &in_plugin);
             if (unlikely(!table || !table->old_format || !in_plugin))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(lex->wild && table->idx_field1 < 0))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(make_schema_select(thd, Lex->current_select, table)))
               MYSQL_YYABORT;
           }
#line 44844 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2318: /* show_engine_param: STATUS_SYM  */
#line 14684 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_STATUS; }
#line 44850 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2319: /* show_engine_param: MUTEX_SYM  */
#line 14686 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_MUTEX; }
#line 44856 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2320: /* show_engine_param: LOGS_SYM  */
#line 14688 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_LOGS; }
#line 44862 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2325: /* opt_db: %empty  */
#line 14702 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lex_str)= null_clex_str; }
#line 44868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2326: /* opt_db: from_or_in ident  */
#line 14703 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 44874 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2327: /* opt_full: %empty  */
#line 14707 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->verbose=0; }
#line 44880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2328: /* opt_full: FULL  */
#line 14708 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->verbose=1; }
#line 44886 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2331: /* binlog_in: %empty  */
#line 14717 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { Lex->mi.log_file_name = 0; }
#line 44892 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2332: /* binlog_in: IN_SYM TEXT_STRING_sys  */
#line 14718 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { Lex->mi.log_file_name = (yyvsp[0].lex_str).str; }
#line 44898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2333: /* binlog_from: %empty  */
#line 14722 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->mi.pos = 4; /* skip magic number */ }
#line 44904 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2334: /* binlog_from: FROM ulonglong_num  */
#line 14723 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->mi.pos = (yyvsp[0].ulonglong_number); }
#line 44910 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2335: /* wild_and_where: %empty  */
#line 14727 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.simple_string)= 0; }
#line 44916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2336: /* wild_and_where: LIKE remember_tok_start TEXT_STRING_sys  */
#line 14729 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->wild= new (thd->mem_root) String((yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44928 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2337: /* wild_and_where: WHERE remember_tok_start expr  */
#line 14737 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->where= normalize_cond(thd, (yyvsp[0].item));
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44939 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2338: /* $@200: %empty  */
#line 14748 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            lex->first_select_lex()->db= null_clex_str;
            lex->verbose= 0;
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[0].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44956 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2339: /* describe: describe_command table_ident $@200 opt_describe_column  */
#line 14761 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44965 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2340: /* $@201: %empty  */
#line 14766 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->describe|= DESCRIBE_NORMAL; }
#line 44971 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2341: /* describe: describe_command opt_extended_describe $@201 explainable_command  */
#line 14768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->options|= SELECT_DESCRIBE;
          }
#line 44980 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2350: /* analyze_stmt_command: ANALYZE_SYM opt_format_json explainable_command  */
#line 14790 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->analyze_stmt= true;
          }
#line 44988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2351: /* opt_extended_describe: EXTENDED_SYM  */
#line 14796 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->describe|= DESCRIBE_EXTENDED; }
#line 44994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2352: /* opt_extended_describe: EXTENDED_SYM ALL  */
#line 14798 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->describe|= DESCRIBE_EXTENDED | DESCRIBE_EXTENDED2; }
#line 45000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2353: /* opt_extended_describe: PARTITIONS_SYM  */
#line 14799 "/home/buildbot/git/sql/sql_yacc.yy"
                         { Lex->describe|= DESCRIBE_PARTITIONS; }
#line 45006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2354: /* opt_extended_describe: opt_format_json  */
#line 14800 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 45012 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2355: /* opt_format_json: %empty  */
#line 14804 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45018 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2356: /* opt_format_json: FORMAT_SYM '=' ident_or_text  */
#line 14806 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("JSON")))
              Lex->explain_json= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("TRADITIONAL")))
              DBUG_ASSERT(Lex->explain_json==false);
            else
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0), "EXPLAIN",
                               (yyvsp[0].lex_str).str));
          }
#line 45032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2357: /* opt_describe_column: %empty  */
#line 14818 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45038 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2358: /* opt_describe_column: text_string  */
#line 14819 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->wild= (yyvsp[0].string); }
#line 45044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2359: /* opt_describe_column: ident  */
#line 14821 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->wild= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
          }
#line 45056 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2360: /* $@202: %empty  */
#line 14835 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_FLUSH;
            lex->type= 0;
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 45067 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2361: /* flush: FLUSH_SYM opt_no_write_to_binlog $@202 flush_options  */
#line 14841 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 45073 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2362: /* $@203: %empty  */
#line 14846 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->type|= REFRESH_TABLES;
            /*
              Set type of metadata and table locks for
              FLUSH TABLES table_list [WITH READ LOCK].
            */
            YYPS->m_lock_type= TL_READ_NO_INSERT;
            YYPS->m_mdl_type= MDL_SHARED_HIGH_PRIO;
          }
#line 45087 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2363: /* flush_options: table_or_tables $@203 opt_table_list opt_flush_lock  */
#line 14856 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45093 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2364: /* flush_options: flush_options_list  */
#line 14858 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45099 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2365: /* opt_flush_lock: %empty  */
#line 14862 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45105 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2366: /* opt_flush_lock: flush_lock  */
#line 14864 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          TABLE_LIST *tables= Lex->query_tables;
          for (; tables; tables= tables->next_global)
          {
            tables->mdl_request.set_type(MDL_SHARED_NO_WRITE);
            /* Don't try to flush views. */
            tables->required_type= TABLE_TYPE_NORMAL;
            /* Ignore temporary tables. */
            tables->open_type= OT_BASE_ONLY;
          }
        }
#line 45121 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2367: /* flush_lock: WITH READ_SYM LOCK_SYM optional_flush_tables_arguments  */
#line 14879 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_READ_LOCK | (yyvsp[0].num); }
#line 45127 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2368: /* $@204: %empty  */
#line 14881 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->query_tables == NULL))
            {
              // Table list can't be empty
              thd->parse_error(ER_NO_TABLES_USED);
              MYSQL_YYABORT;
            } 
            Lex->type|= REFRESH_FOR_EXPORT;
          }
#line 45141 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2369: /* flush_lock: FOR_SYM $@204 EXPORT_SYM  */
#line 14889 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 45147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2371: /* flush_options_list: flush_option  */
#line 14895 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45153 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2372: /* flush_option: ERROR_SYM LOGS_SYM  */
#line 14900 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_ERROR_LOG; }
#line 45159 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2373: /* flush_option: ENGINE_SYM LOGS_SYM  */
#line 14902 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_ENGINE_LOG; }
#line 45165 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2374: /* flush_option: GENERAL LOGS_SYM  */
#line 14904 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_GENERAL_LOG; }
#line 45171 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2375: /* flush_option: SLOW LOGS_SYM  */
#line 14906 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_SLOW_LOG; }
#line 45177 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2376: /* flush_option: BINARY LOGS_SYM opt_delete_gtid_domain  */
#line 14908 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_BINARY_LOG; }
#line 45183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2377: /* flush_option: RELAY LOGS_SYM optional_connection_name  */
#line 14910 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_RELAY_LOG))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH", "RELAY LOGS"));
            lex->type|= REFRESH_RELAY_LOG;
            lex->relay_log_connection_name= lex->mi.connection_name;
           }
#line 45195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2378: /* flush_option: QUERY_SYM CACHE_SYM  */
#line 14918 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_QUERY_CACHE_FREE; }
#line 45201 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2379: /* flush_option: HOSTS_SYM  */
#line 14920 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_HOSTS; }
#line 45207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2380: /* flush_option: PRIVILEGES  */
#line 14922 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_GRANT; }
#line 45213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2381: /* flush_option: LOGS_SYM  */
#line 14924 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->type|= REFRESH_LOG;
            Lex->relay_log_connection_name= empty_clex_str;
          }
#line 45222 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2382: /* flush_option: STATUS_SYM  */
#line 14929 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_STATUS; }
#line 45228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2383: /* flush_option: SLAVE optional_connection_name  */
#line 14931 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_SLAVE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH","SLAVE"));
            lex->type|= REFRESH_SLAVE;
            lex->reset_slave_info.all= false;
          }
#line 45240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2384: /* flush_option: MASTER_SYM  */
#line 14939 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_MASTER; }
#line 45246 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2385: /* flush_option: DES_KEY_FILE  */
#line 14941 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_DES_KEY_FILE; }
#line 45252 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2386: /* flush_option: RESOURCES  */
#line 14943 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_USER_RESOURCES; }
#line 45258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2387: /* flush_option: SSL_SYM  */
#line 14945 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->type|= REFRESH_SSL;}
#line 45264 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2388: /* flush_option: IDENT_sys remember_tok_start  */
#line 14947 "/home/buildbot/git/sql/sql_yacc.yy"
           {
             Lex->type|= REFRESH_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-1].ident_sys));
             if (unlikely(!table || !table->reset_table))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(Lex->view_list.push_back((LEX_CSTRING*)
                                                   thd->memdup(&(yyvsp[-1].ident_sys), sizeof(LEX_CSTRING)),
                                                   thd->mem_root)))
               MYSQL_YYABORT;
           }
#line 45282 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2389: /* opt_table_list: %empty  */
#line 14963 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 45288 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2390: /* opt_table_list: table_list  */
#line 14964 "/home/buildbot/git/sql/sql_yacc.yy"
                     {}
#line 45294 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2391: /* backup: BACKUP_SYM backup_statements  */
#line 14968 "/home/buildbot/git/sql/sql_yacc.yy"
                                     {}
#line 45300 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2392: /* backup_statements: STAGE_SYM ident  */
#line 14973 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          int type;
          if (unlikely(Lex->sphead))
            my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP STAGE"));
          if ((type= find_type((yyvsp[0].ident_sys).str, &backup_stage_names,
                               FIND_TYPE_NO_PREFIX)) <= 0)
            my_yyabort_error((ER_BACKUP_UNKNOWN_STAGE, MYF(0), (yyvsp[0].ident_sys).str));
          Lex->sql_command= SQLCOM_BACKUP;
          Lex->backup_stage= (backup_stages) (type-1);
          break;
        }
#line 45316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2393: /* $@205: %empty  */
#line 14985 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP LOCK"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 45327 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2394: /* backup_statements: LOCK_SYM $@205 table_ident  */
#line 14992 "/home/buildbot/git/sql/sql_yacc.yy"
          {
	    if (unlikely(!Select->add_table_to_list(thd, (yyvsp[0].table), NULL, 0,
                                                    TL_READ, MDL_SHARED_HIGH_PRIO)))
             MYSQL_YYABORT;
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
            Lex->pop_select(); //main select
          }
#line 45339 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2395: /* backup_statements: UNLOCK_SYM  */
#line 15000 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP UNLOCK"));
	    /* Table list is empty for unlock */
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
          }
#line 45350 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2396: /* opt_delete_gtid_domain: %empty  */
#line 15009 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45356 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2397: /* opt_delete_gtid_domain: DELETE_DOMAIN_ID_SYM '=' '(' delete_domain_id_list ')'  */
#line 15011 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45362 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2401: /* delete_domain_id: ulonglong_num  */
#line 15021 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            uint32 value= (uint32) (yyvsp[0].ulonglong_number);
            if ((yyvsp[0].ulonglong_number) > UINT_MAX32)
            {
              my_printf_error(ER_BINLOG_CANT_DELETE_GTID_DOMAIN,
                              "The value of gtid domain being deleted ('%llu') "
                              "exceeds its maximum size "
                              "of 32 bit unsigned integer", MYF(0), (yyvsp[0].ulonglong_number));
              MYSQL_YYABORT;
            }
            insert_dynamic(&Lex->delete_gtid_domain, (uchar*) &value);
          }
#line 45379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2402: /* optional_flush_tables_arguments: %empty  */
#line 15036 "/home/buildbot/git/sql/sql_yacc.yy"
                             {(yyval.num)= 0;}
#line 45385 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2403: /* optional_flush_tables_arguments: AND_SYM DISABLE_SYM CHECKPOINT_SYM  */
#line 15037 "/home/buildbot/git/sql/sql_yacc.yy"
                                             {(yyval.num)= REFRESH_CHECKPOINT; }
#line 45391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2404: /* $@206: %empty  */
#line 15042 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RESET; lex->type=0;
          }
#line 45400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2405: /* reset: RESET_SYM $@206 reset_options  */
#line 15047 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 45406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2408: /* $@207: %empty  */
#line 15056 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->type|= REFRESH_SLAVE; }
#line 45412 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2409: /* reset_option: SLAVE $@207 optional_connection_name slave_reset_options  */
#line 15058 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 45418 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2410: /* $@208: %empty  */
#line 15060 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             Lex->type|= REFRESH_MASTER;
             Lex->next_binlog_file_number= 0;
          }
#line 45427 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2412: /* reset_option: QUERY_SYM CACHE_SYM  */
#line 15065 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->type|= REFRESH_QUERY_CACHE;}
#line 45433 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2413: /* slave_reset_options: %empty  */
#line 15069 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->reset_slave_info.all= false; }
#line 45439 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2414: /* slave_reset_options: ALL  */
#line 15070 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->reset_slave_info.all= true; }
#line 45445 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2415: /* master_reset_options: %empty  */
#line 15074 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45451 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2416: /* master_reset_options: TO_SYM ulong_num  */
#line 15076 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->next_binlog_file_number = (yyvsp[0].ulong_num);
          }
#line 45459 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2417: /* purge: PURGE master_or_binary LOGS_SYM TO_SYM TEXT_STRING_sys  */
#line 15083 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_purge_to((yyvsp[0].lex_str));
          }
#line 45467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2418: /* $@209: %empty  */
#line 15087 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->clause_that_disallows_subselect= "PURGE..BEFORE"; }
#line 45473 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2419: /* purge: PURGE master_or_binary LOGS_SYM BEFORE_SYM $@209 expr  */
#line 15089 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_purge_before((yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 45483 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2420: /* $@210: %empty  */
#line 15101 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->value_list.empty();
            lex->users_list.empty();
            lex->sql_command= SQLCOM_KILL;
            lex->kill_type= KILL_TYPE_ID;
          }
#line 45495 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2421: /* kill: KILL_SYM $@210 kill_type kill_option  */
#line 15109 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->kill_signal= (killed_state) ((yyvsp[-1].num) | (yyvsp[0].num));
          }
#line 45503 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2422: /* kill_type: %empty  */
#line 15115 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45509 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2423: /* kill_type: HARD_SYM  */
#line 15116 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45515 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2424: /* kill_type: SOFT_SYM  */
#line 15117 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 0; }
#line 45521 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2425: /* kill_option: opt_connection kill_expr  */
#line 15121 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.num)= (int) KILL_CONNECTION; }
#line 45527 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2426: /* kill_option: QUERY_SYM kill_expr  */
#line 15122 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.num)= (int) KILL_QUERY; }
#line 45533 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2427: /* kill_option: QUERY_SYM ID_SYM expr  */
#line 15124 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (int) KILL_QUERY;
            Lex->kill_type= KILL_TYPE_QUERY;
            Lex->value_list.push_front((yyvsp[0].item), thd->mem_root);
          }
#line 45543 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2428: /* opt_connection: %empty  */
#line 15132 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 45549 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2429: /* opt_connection: CONNECTION_SYM  */
#line 15133 "/home/buildbot/git/sql/sql_yacc.yy"
                         { }
#line 45555 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2430: /* kill_expr: expr  */
#line 15138 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->value_list.push_front((yyval.item), thd->mem_root);
         }
#line 45563 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2431: /* kill_expr: USER_SYM user  */
#line 15142 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root);
            Lex->kill_type= KILL_TYPE_USER;
          }
#line 45572 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2432: /* $@211: %empty  */
#line 15149 "/home/buildbot/git/sql/sql_yacc.yy"
                 { Lex->sql_command= SQLCOM_SHUTDOWN; }
#line 45578 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2433: /* shutdown: SHUTDOWN $@211 shutdown_option  */
#line 15150 "/home/buildbot/git/sql/sql_yacc.yy"
                        {}
#line 45584 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2434: /* shutdown_option: %empty  */
#line 15154 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->is_shutdown_wait_for_slaves= false; }
#line 45590 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2435: /* shutdown_option: WAIT_SYM FOR_SYM ALL SLAVES  */
#line 15156 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          Lex->is_shutdown_wait_for_slaves= true;
        }
#line 45598 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2436: /* use: USE_SYM ident  */
#line 15165 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_CHANGE_DB;
            lex->first_select_lex()->db= (yyvsp[0].ident_sys);
          }
#line 45608 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2437: /* $@212: %empty  */
#line 15176 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;

            if (unlikely(lex->sphead))
            {
              my_error(ER_SP_BADSTATEMENT, MYF(0), 
                       (yyvsp[0].filetype) == FILETYPE_CSV ? "LOAD DATA" : "LOAD XML");
              MYSQL_YYABORT;
            }
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 45626 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2438: /* $@213: %empty  */
#line 15190 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_LOAD;
            lex->local_file=  (yyvsp[-2].num);
            lex->duplicates= DUP_ERROR;
            lex->ignore= 0;
            if (unlikely(!(lex->exchange= new (thd->mem_root)
                         sql_exchange((yyvsp[0].lex_str).str, 0, (yyvsp[-5].filetype)))))
              MYSQL_YYABORT;
          }
#line 45641 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2439: /* $@214: %empty  */
#line 15201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                   TL_OPTION_UPDATING,
                                                   (yyvsp[-9].lock_type), MDL_SHARED_WRITE,
                                                   NULL, (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            lex->field_list.empty();
            lex->update_list.empty();
            lex->value_list.empty();
            lex->many_values.empty();
          }
#line 45658 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2440: /* $@215: %empty  */
#line 15214 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 45664 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2441: /* load: LOAD data_or_xml $@212 load_data_lock opt_local INFILE TEXT_STRING_filesystem $@213 opt_duplicate INTO TABLE_SYM table_ident opt_use_partition $@214 opt_load_data_charset $@215 opt_xml_rows_identified_by opt_field_term opt_line_term opt_ignore_lines opt_field_or_var_spec opt_load_data_set_spec  */
#line 15218 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 45675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2442: /* data_or_xml: DATA_SYM  */
#line 15227 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.filetype)= FILETYPE_CSV; }
#line 45681 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2443: /* data_or_xml: XML_SYM  */
#line 15228 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.filetype)= FILETYPE_XML; }
#line 45687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2444: /* opt_local: %empty  */
#line 15232 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)=0;}
#line 45693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2445: /* opt_local: LOCAL_SYM  */
#line 15233 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=1;}
#line 45699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2446: /* load_data_lock: %empty  */
#line 15237 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 45705 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2447: /* load_data_lock: CONCURRENT  */
#line 15239 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              Ignore this option in SP to avoid problem with query cache and
              triggers with non default priority locks
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 45717 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2448: /* load_data_lock: LOW_PRIORITY  */
#line 15246 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 45723 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2449: /* opt_duplicate: %empty  */
#line 15250 "/home/buildbot/git/sql/sql_yacc.yy"
                      { Lex->duplicates=DUP_ERROR; }
#line 45729 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2450: /* opt_duplicate: REPLACE  */
#line 15251 "/home/buildbot/git/sql/sql_yacc.yy"
                  { Lex->duplicates=DUP_REPLACE; }
#line 45735 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2451: /* opt_duplicate: IGNORE_SYM  */
#line 15252 "/home/buildbot/git/sql/sql_yacc.yy"
                     { Lex->ignore= 1; }
#line 45741 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2456: /* field_term: TERMINATED BY text_string  */
#line 15267 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->field_term= (yyvsp[0].string);
          }
#line 45750 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2457: /* field_term: OPTIONALLY ENCLOSED BY text_string  */
#line 15272 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->exchange != 0);
            lex->exchange->enclosed= (yyvsp[0].string);
            lex->exchange->opt_enclosed= 1;
          }
#line 45761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2458: /* field_term: ENCLOSED BY text_string  */
#line 15279 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->enclosed= (yyvsp[0].string);
          }
#line 45770 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2459: /* field_term: ESCAPED BY text_string  */
#line 15284 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->escaped= (yyvsp[0].string);
          }
#line 45779 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2464: /* line_term: TERMINATED BY text_string  */
#line 15302 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_term= (yyvsp[0].string);
          }
#line 45788 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2465: /* line_term: STARTING BY text_string  */
#line 15307 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_start= (yyvsp[0].string);
          }
#line 45797 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2466: /* opt_xml_rows_identified_by: %empty  */
#line 15314 "/home/buildbot/git/sql/sql_yacc.yy"
                    { }
#line 45803 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2467: /* opt_xml_rows_identified_by: ROWS_SYM IDENTIFIED_SYM BY text_string  */
#line 15316 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->exchange->line_term = (yyvsp[0].string); }
#line 45809 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2469: /* opt_ignore_lines: IGNORE_SYM NUM lines_or_rows  */
#line 15322 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->skip_lines= atol((yyvsp[-1].lex_str).str);
          }
#line 45818 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2470: /* lines_or_rows: LINES  */
#line 15329 "/home/buildbot/git/sql/sql_yacc.yy"
                { }
#line 45824 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2471: /* lines_or_rows: ROWS_SYM  */
#line 15330 "/home/buildbot/git/sql/sql_yacc.yy"
                   { }
#line 45830 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2472: /* opt_field_or_var_spec: %empty  */
#line 15334 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45836 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2473: /* opt_field_or_var_spec: '(' fields_or_vars ')'  */
#line 15335 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 45842 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2474: /* opt_field_or_var_spec: '(' ')'  */
#line 15336 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 45848 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2475: /* fields_or_vars: fields_or_vars ',' field_or_var  */
#line 15341 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2476: /* fields_or_vars: field_or_var  */
#line 15343 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45860 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2477: /* field_or_var: simple_ident_nospvar  */
#line 15347 "/home/buildbot/git/sql/sql_yacc.yy"
                               {(yyval.item)= (yyvsp[0].item);}
#line 45866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2478: /* field_or_var: '@' ident_or_text  */
#line 15349 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_user_var_as_out_param(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45876 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2479: /* opt_load_data_set_spec: %empty  */
#line 15357 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 45882 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2480: /* opt_load_data_set_spec: SET load_data_set_list  */
#line 15358 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 45888 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2483: /* load_data_set_elem: simple_ident_nospvar equal remember_name expr_or_ignore_or_default remember_end  */
#line 15368 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->update_list.push_back((yyvsp[-4].item), thd->mem_root)) ||
                unlikely(lex->value_list.push_back((yyvsp[-1].item), thd->mem_root)))
                MYSQL_YYABORT;
            (yyvsp[-1].item)->set_name_no_truncate(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 45900 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2484: /* text_literal: TEXT_STRING  */
#line 15381 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45909 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2485: /* text_literal: NCHAR_STRING  */
#line 15386 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_nchar((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45918 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2486: /* text_literal: UNDERSCORE_CHARSET TEXT_STRING  */
#line 15391 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_charset((yyvsp[0].lex_string_with_metadata), (yyvsp[-1].charset)))))
              MYSQL_YYABORT;
          }
#line 45927 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2487: /* text_literal: text_literal TEXT_STRING_literal  */
#line 15396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= (yyvsp[-1].item_basic_constant)->make_string_literal_concat(thd, &(yyvsp[0].lex_str)))))
              MYSQL_YYABORT;
          }
#line 45936 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2488: /* text_string: TEXT_STRING_literal  */
#line 15404 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.string)= new (thd->mem_root) String((yyvsp[0].lex_str).str,
                                             (yyvsp[0].lex_str).length,
                                             thd->variables.collation_connection);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 45948 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2489: /* text_string: hex_or_bin_String  */
#line 15411 "/home/buildbot/git/sql/sql_yacc.yy"
                              { (yyval.string)= (yyvsp[0].string); }
#line 45954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2490: /* hex_or_bin_String: HEX_NUM  */
#line 15417 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45966 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2491: /* hex_or_bin_String: HEX_STRING  */
#line 15425 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45978 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2492: /* hex_or_bin_String: BIN_NUM  */
#line 15433 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item *tmp= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2493: /* param_marker: PARAM_MARKER  */
#line 15448 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &param_clex_str,
                                                    YYLIP->get_tok_start(),
                                                    YYLIP->get_tok_start() + 1))))
              MYSQL_YYABORT;
          }
#line 46005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2494: /* param_marker: COLON_ORACLE_SYM ident_cli  */
#line 15455 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(), (yyvsp[0].ident_cli).end()))))
              MYSQL_YYABORT;
          }
#line 46015 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2495: /* param_marker: COLON_ORACLE_SYM NUM  */
#line 15461 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(),
                                                    YYLIP->get_ptr()))))
              MYSQL_YYABORT;
          }
#line 46026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2496: /* signed_literal: '+' NUM_literal  */
#line 15470 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.item) = (yyvsp[0].item_num); }
#line 46032 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2497: /* signed_literal: '-' NUM_literal  */
#line 15472 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].item_num)->max_length++;
            (yyval.item)= (yyvsp[0].item_num)->neg(thd);
          }
#line 46041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2498: /* literal: text_literal  */
#line 15479 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.item) = (yyvsp[0].item_basic_constant); }
#line 46047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2499: /* literal: NUM_literal  */
#line 15480 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.item) = (yyvsp[0].item_num); }
#line 46053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2500: /* literal: temporal_literal  */
#line 15481 "/home/buildbot/git/sql/sql_yacc.yy"
                           { (yyval.item)= (yyvsp[0].item); }
#line 46059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2501: /* literal: NULL_SYM  */
#line 15483 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              For the digest computation, in this context only,
              NULL is considered a literal, hence reduced to '?'
              REDUCE:
                TOK_GENERIC_VALUE := NULL_SYM
            */
            YYLIP->reduce_digest_token(TOK_GENERIC_VALUE, NULL_SYM);
            (yyval.item)= new (thd->mem_root) Item_null(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            YYLIP->next_state= MY_LEX_OPERATOR_OR_IDENT;
          }
#line 46077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2502: /* literal: FALSE_SYM  */
#line 15497 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "FALSE",0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46087 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2503: /* literal: TRUE_SYM  */
#line 15503 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "TRUE",1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46097 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2504: /* literal: HEX_NUM  */
#line 15509 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46107 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2505: /* literal: HEX_STRING  */
#line 15515 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2506: /* literal: BIN_NUM  */
#line 15521 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 46127 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2507: /* literal: UNDERSCORE_CHARSET hex_or_bin_String  */
#line 15527 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Item_string_with_introducer *item_str;
            /*
              Pass NULL as name. Name will be set in the "select_item" rule and
              will include the introducer and the original hex/bin notation.
            */
            item_str= new (thd->mem_root)
               Item_string_with_introducer(thd, NULL, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(),
                                           (yyvsp[-1].charset));
            if (unlikely(!item_str ||
                         !item_str->check_well_formed_result(true)))
              MYSQL_YYABORT;

            (yyval.item)= item_str;
          }
#line 46147 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2508: /* NUM_literal: NUM  */
#line 15546 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2509: /* NUM_literal: LONG_NUM  */
#line 15556 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46175 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2510: /* NUM_literal: ULONGLONG_NUM  */
#line 15566 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 46185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2511: /* NUM_literal: DECIMAL_NUM  */
#line 15572 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_decimal(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                   thd->charset());
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 46196 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2512: /* NUM_literal: FLOAT_NUM  */
#line 15579 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_float(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 46206 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2513: /* temporal_literal: DATE_SYM TEXT_STRING  */
#line 15589 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_newdate.create_literal_item(thd,
                                                           (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                           YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46217 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2514: /* temporal_literal: TIME_SYM TEXT_STRING  */
#line 15596 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_time2.create_literal_item(thd,
                                                         (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                         YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46228 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2515: /* temporal_literal: TIMESTAMP TEXT_STRING  */
#line 15603 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_datetime.create_literal_item(thd,
                                                            (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                            YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 46239 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2516: /* $@216: %empty  */
#line 15613 "/home/buildbot/git/sql/sql_yacc.yy"
          {
             LEX *lex= Lex;
             With_clause *with_clause=
             new With_clause((yyvsp[0].num), Lex->curr_with_clause);
             if (unlikely(with_clause == NULL))
               MYSQL_YYABORT;
             lex->derived_tables|= DERIVED_WITH;
             lex->with_cte_resolution= true;
             lex->curr_with_clause= with_clause;
             with_clause->add_to_list(&lex->with_clauses_list,
                                      lex->with_clauses_list_last_next);
             if (lex->current_select &&
                 lex->current_select->parsing_place == BEFORE_OPT_LIST)
               lex->current_select->parsing_place= NO_MATTER;
          }
#line 46259 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2517: /* with_clause: WITH opt_recursive $@216 with_list  */
#line 15629 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.with_clause)= Lex->curr_with_clause;
            Lex->curr_with_clause= Lex->curr_with_clause->pop();
          }
#line 46268 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2518: /* opt_recursive: %empty  */
#line 15637 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)= 0; }
#line 46274 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2519: /* opt_recursive: RECURSIVE_SYM  */
#line 15638 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.num)= 1; }
#line 46280 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2522: /* $@217: %empty  */
#line 15651 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyvsp[0].lex_str_list)= new List<LEX_CSTRING> (Lex->with_column_list);
            if (unlikely((yyvsp[0].lex_str_list) == NULL))
              MYSQL_YYABORT;
            Lex->with_column_list.empty();
          }
#line 46291 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2523: /* with_list_element: with_element_head opt_with_column_list $@217 AS '(' query_expression ')'  */
#line 15658 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            const char *query_start= lex->sphead ? lex->sphead->m_tmp_query
                                                 : thd->query();
            const char *spec_start= (yyvsp[-2].kwd).pos() + 1;
            With_element *elem= new With_element((yyvsp[-6].with_element_head), *(yyvsp[-5].lex_str_list), (yyvsp[-1].select_lex_unit));
	    if (elem == NULL || Lex->curr_with_clause->add_with_element(elem))
	      MYSQL_YYABORT;
            if (elem->set_unparsed_spec(thd, spec_start, (yyvsp[0].kwd).pos(),
                                        spec_start - query_start))
              MYSQL_YYABORT;
            elem->set_tables_end_pos(lex->query_tables_last);
	  }
#line 46309 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2524: /* opt_with_column_list: %empty  */
#line 15676 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.lex_str_list)= NULL; }
#line 46315 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2525: /* opt_with_column_list: '(' with_column_list ')'  */
#line 15678 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.lex_str_list)= NULL; }
#line 46321 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2526: /* with_column_list: ident  */
#line 15684 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
	  }
#line 46330 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2527: /* with_column_list: with_column_list ',' ident  */
#line 15689 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
          }
#line 46339 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2528: /* with_element_head: ident  */
#line 15698 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING *name=
              (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            (yyval.with_element_head)= new (thd->mem_root) With_element_head(name);
            if (unlikely(name == NULL || (yyval.with_element_head) == NULL))
              MYSQL_YYABORT;
            (yyval.with_element_head)->tables_pos.set_start_pos(Lex->query_tables_last);
          }
#line 46352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2529: /* insert_ident: simple_ident_nospvar  */
#line 15715 "/home/buildbot/git/sql/sql_yacc.yy"
                               { (yyval.item)=(yyvsp[0].item); }
#line 46358 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2530: /* insert_ident: table_wild  */
#line 15716 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.item)=(yyvsp[0].item); }
#line 46364 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2531: /* table_wild: ident '.' '*'  */
#line 15721 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46373 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2532: /* table_wild: ident '.' ident '.' '*'  */
#line 15726 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46382 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2533: /* select_sublist_qualified_asterisk: ident_cli '.' '*'  */
#line 15734 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2534: /* select_sublist_qualified_asterisk: ident_cli '.' ident_cli '.' '*'  */
#line 15739 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46400 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2535: /* order_ident: expr  */
#line 15746 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 46406 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2536: /* simple_ident: ident_cli  */
#line 15752 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2537: /* simple_ident: ident_cli '.' ident_cli  */
#line 15757 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46424 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2538: /* simple_ident: '.' ident_cli '.' ident_cli  */
#line 15762 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_ident_cli empty((yyvsp[-2].ident_cli).pos(), 0);
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &empty, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2539: /* simple_ident: ident_cli '.' ident_cli '.' ident_cli  */
#line 15768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46443 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2540: /* simple_ident: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15773 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46452 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2541: /* simple_ident_nospvar: ident  */
#line 15781 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nosp(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46461 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2542: /* simple_ident_nospvar: ident '.' ident  */
#line 15786 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nospvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46470 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2543: /* simple_ident_nospvar: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15791 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46479 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2544: /* simple_ident_nospvar: '.' ident '.' ident  */
#line 15796 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex_ident_sys none;
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &none, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46489 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2545: /* simple_ident_nospvar: ident '.' ident '.' ident  */
#line 15802 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46498 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2546: /* field_ident: ident  */
#line 15809 "/home/buildbot/git/sql/sql_yacc.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46504 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2547: /* field_ident: ident '.' ident '.' ident  */
#line 15811 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-4].ident_sys).str,
                                       table->db.str)))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-4].ident_sys).str));
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                                       table->table_name.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46519 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2548: /* field_ident: ident '.' ident  */
#line 15822 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                         table->alias.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46531 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2549: /* field_ident: '.' ident  */
#line 15829 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46537 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2550: /* table_ident: ident  */
#line 15834 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2551: /* table_ident: ident '.' ident  */
#line 15840 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46557 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2552: /* table_ident: '.' ident  */
#line 15846 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /* For Delphi */
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46568 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2553: /* table_ident_opt_wild: ident opt_wild  */
#line 15856 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46578 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2554: /* table_ident_opt_wild: ident '.' ident opt_wild  */
#line 15862 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46588 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2555: /* table_ident_nodb: ident  */
#line 15871 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX_CSTRING db={(char*) any_db,3};
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &db, &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46599 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2560: /* ident_cli: keyword_ident  */
#line 15887 "/home/buildbot/git/sql/sql_yacc.yy"
                        { (yyval.ident_cli)= (yyvsp[0].kwd); }
#line 46605 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2561: /* IDENT_sys: IDENT_cli  */
#line 15892 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(thd->to_ident_sys_alloc(&(yyval.ident_sys), &(yyvsp[0].ident_cli))))
              MYSQL_YYABORT;
          }
#line 46614 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2562: /* TEXT_STRING_sys: TEXT_STRING  */
#line 15900 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_sys(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2563: /* TEXT_STRING_literal: TEXT_STRING  */
#line 15908 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_connection(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46632 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2564: /* TEXT_STRING_filesystem: TEXT_STRING  */
#line 15916 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (thd->make_text_string_filesystem(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46641 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2566: /* ident_table_alias: keyword_table_alias  */
#line 15925 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46650 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2568: /* ident_set_usual_case: keyword_set_usual_case  */
#line 15934 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46659 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2570: /* ident_sysvar_name: keyword_sysvar_name  */
#line 15943 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46668 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2571: /* ident_sysvar_name: TEXT_STRING_sys  */
#line 15948 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_sys(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 46677 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2573: /* ident: keyword_ident  */
#line 15958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46686 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2575: /* label_ident: keyword_label  */
#line 15967 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46695 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2576: /* ident_or_text: ident  */
#line 15974 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46701 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2577: /* ident_or_text: TEXT_STRING_sys  */
#line 15975 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46707 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2578: /* ident_or_text: LEX_HOSTNAME  */
#line 15976 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46713 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2579: /* user_maybe_role: ident_or_text  */
#line 15981 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  system_charset_info, 0)))
              MYSQL_YYABORT;
          }
#line 46728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2580: /* user_maybe_role: ident_or_text '@' ident_or_text  */
#line 15992 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[-2].lex_str); (yyval.lex_user)->host=(yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                 system_charset_info, 0)) ||
                unlikely(check_host_name(&(yyval.lex_user)->host)))
              MYSQL_YYABORT;
            if ((yyval.lex_user)->host.str[0])
            {
              /*
                Convert hostname part of username to lowercase.
                It's OK to use in-place lowercase as long as
                the character set is utf8.
              */
              my_casedn_str(system_charset_info, (char*) (yyval.lex_user)->host.str);
            }
            else
            {
              /*
                fix historical undocumented convention that empty host is the
                same as '%'
              */
              (yyval.lex_user)->host= host_not_specified;
            }
          }
#line 46761 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2581: /* user_maybe_role: CURRENT_USER optional_braces  */
#line 16021 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*)thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_user;
            (yyval.lex_user)->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46772 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 2584: /* user: user_maybe_role  */
#line 16032 "/home/buildbot/git/sql/sql_yacc.yy"
         {
           if ((yyvsp[0].lex_user)->user.str != current_user.str && (yyvsp[0].lex_user)->host.str == 0)
             (yyvsp[0].lex_user)->host= host_not_specified;
           (yyval.lex_user)= (yyvsp[0].lex_user);
         }
#line 46782 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3062: /* $@218: %empty  */
#line 16642 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46796 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3063: /* set: SET $@218 start_option_value_list  */
#line 16652 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46806 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3064: /* $@219: %empty  */
#line 16658 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->set_stmt_init();
          }
#line 46816 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3065: /* $@220: %empty  */
#line 16664 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->table_or_sp_used()))
              my_yyabort_error((ER_SUBQUERIES_NOT_SUPPORTED, MYF(0), "SET STATEMENT"));
            lex->stmt_var_list= lex->var_list;
            lex->var_list.empty();
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46831 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3066: /* set: SET STATEMENT_SYM $@219 set_stmt_option_value_following_option_type_list $@220 FOR_SYM verb_clause  */
#line 16675 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 46837 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3069: /* $@221: %empty  */
#line 16691 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46846 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3071: /* $@222: %empty  */
#line 16697 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= OPT_DEFAULT;
          }
#line 46854 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3072: /* start_option_value_list: TRANSACTION_SYM $@222 transaction_characteristics  */
#line 16701 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46863 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3073: /* $@223: %empty  */
#line 16706 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46871 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3075: /* $@224: %empty  */
#line 16716 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46880 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3077: /* start_option_value_list_following_option_type: TRANSACTION_SYM transaction_characteristics  */
#line 16722 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3080: /* $@225: %empty  */
#line 16736 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46898 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3081: /* option_value_list: $@225 option_value  */
#line 16741 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3082: /* $@226: %empty  */
#line 16746 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46916 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3083: /* option_value_list: option_value_list ',' $@226 option_value  */
#line 16751 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3084: /* $@227: %empty  */
#line 16760 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46933 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3087: /* option_type: GLOBAL_SYM  */
#line 16768 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46939 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3088: /* option_type: LOCAL_SYM  */
#line 16769 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46945 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3089: /* option_type: SESSION_SYM  */
#line 16770 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3090: /* opt_var_type: %empty  */
#line 16774 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46957 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3091: /* opt_var_type: GLOBAL_SYM  */
#line 16775 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46963 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3092: /* opt_var_type: LOCAL_SYM  */
#line 16776 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46969 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3093: /* opt_var_type: SESSION_SYM  */
#line 16777 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46975 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3094: /* opt_var_ident_type: %empty  */
#line 16781 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_DEFAULT; }
#line 46981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3095: /* opt_var_ident_type: GLOBAL_SYM '.'  */
#line 16782 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_GLOBAL; }
#line 46987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3096: /* opt_var_ident_type: LOCAL_SYM '.'  */
#line 16783 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3097: /* opt_var_ident_type: SESSION_SYM '.'  */
#line 16784 "/home/buildbot/git/sql/sql_yacc.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3098: /* option_value_following_option_type: ident equal set_expr_or_default  */
#line 16790 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47008 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3099: /* option_value_following_option_type: ident '.' ident equal set_expr_or_default  */
#line 16795 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, Lex->option_type, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3100: /* option_value_following_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 16800 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47026 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3101: /* option_value_no_option_type: ident_set_usual_case equal set_expr_or_default  */
#line 16809 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47035 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3102: /* option_value_no_option_type: ident '.' ident equal set_expr_or_default  */
#line 16814 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47044 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3103: /* option_value_no_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 16819 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3104: /* option_value_no_option_type: '@' ident_or_text equal expr  */
#line 16824 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_user_variable(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47062 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3105: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name equal set_expr_or_default  */
#line 16829 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable((yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3106: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name '.' ident equal set_expr_or_default  */
#line 16834 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, (yyvsp[-5].var_type), &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47080 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3107: /* option_value_no_option_type: '@' '@' opt_var_ident_type DEFAULT '.' ident equal set_expr_or_default  */
#line 16839 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_default_system_variable((yyvsp[-5].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3108: /* option_value_no_option_type: charset old_or_new_charset_name_or_default  */
#line 16844 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            CHARSET_INFO *cs2;
            cs2= (yyvsp[0].charset) ? (yyvsp[0].charset): global_system_variables.character_set_client;
            set_var_collation_client *var;
            var= (new (thd->mem_root)
                  set_var_collation_client(cs2,
                                           thd->variables.collation_database,
                                            cs2));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            lex->var_list.push_back(var, thd->mem_root);
          }
#line 47107 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3109: /* option_value_no_option_type: NAMES_SYM equal expr  */
#line 16858 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING names= { STRING_WITH_LEN("names") };
            if (unlikely(spc && spc->find_variable(&names, false)))
              my_error(ER_SP_BAD_VAR_SHADOW, MYF(0), names.str);
            else
              thd->parse_error();
            MYSQL_YYABORT;
          }
#line 47122 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3110: /* option_value_no_option_type: NAMES_SYM charset_name_or_default opt_collate  */
#line 16869 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            CHARSET_INFO *cs2;
            CHARSET_INFO *cs3;
            cs2= (yyvsp[-1].charset) ? (yyvsp[-1].charset) : global_system_variables.character_set_client;
            cs3= (yyvsp[0].charset) ? (yyvsp[0].charset) : cs2;
            if (unlikely(!my_charset_same(cs2, cs3)))
            {
              my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                       cs3->name, cs2->csname);
              MYSQL_YYABORT;
            }
            set_var_collation_client *var;
            var= new (thd->mem_root) set_var_collation_client(cs3, cs3, cs3);
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47145 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3111: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role  */
#line 16888 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            LEX_USER *user;
            if (unlikely(!(user=(LEX_USER *) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            user->user= current_user;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role(user,
                                                             (yyvsp[0].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;

            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47167 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3112: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role FOR_SYM user  */
#line 16906 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role((yyvsp[0].lex_user), (yyvsp[-2].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3113: /* option_value_no_option_type: ROLE_SYM ident_or_text  */
#line 16918 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_role *var= new (thd->mem_root) set_var_role((yyvsp[0].lex_str));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47195 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3114: /* option_value_no_option_type: ROLE_SYM equal set_expr_or_default  */
#line 16926 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].kwd), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 47204 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3115: /* option_value_no_option_type: PASSWORD_SYM opt_for_user text_or_password  */
#line 16931 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex = Lex;
            set_var_password *var= (new (thd->mem_root)
                                    set_var_password(lex->definer));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 47220 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3120: /* transaction_access_mode: transaction_access_mode_types  */
#line 16954 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_read_only"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            if (unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47240 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3121: /* isolation_level: ISOLATION LEVEL_SYM isolation_types  */
#line 16973 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].tx_isolation));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_isolation"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47259 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3122: /* transaction_access_mode_types: READ_SYM ONLY_SYM  */
#line 16990 "/home/buildbot/git/sql/sql_yacc.yy"
                            { (yyval.num)= true; }
#line 47265 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3123: /* transaction_access_mode_types: READ_SYM WRITE_SYM  */
#line 16991 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.num)= false; }
#line 47271 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3124: /* isolation_types: READ_SYM UNCOMMITTED_SYM  */
#line 16995 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_READ_UNCOMMITTED; }
#line 47277 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3125: /* isolation_types: READ_SYM COMMITTED_SYM  */
#line 16996 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_READ_COMMITTED; }
#line 47283 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3126: /* isolation_types: REPEATABLE_SYM READ_SYM  */
#line 16997 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_REPEATABLE_READ; }
#line 47289 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3127: /* isolation_types: SERIALIZABLE_SYM  */
#line 16998 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.tx_isolation)= ISO_SERIALIZABLE; }
#line 47295 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3128: /* opt_for_user: equal  */
#line 17003 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING pw= { STRING_WITH_LEN("password") };

            if (unlikely(spc && spc->find_variable(&pw, false)))
              my_yyabort_error((ER_SP_BAD_VAR_SHADOW, MYF(0), pw.str));
            if (unlikely(!(lex->definer= (LEX_USER*)
                           thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            lex->definer->user= current_user;
            lex->definer->auth= new (thd->mem_root) USER_AUTH();
          }
#line 47313 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3129: /* opt_for_user: FOR_SYM user equal  */
#line 17016 "/home/buildbot/git/sql/sql_yacc.yy"
                             { Lex->definer= (yyvsp[-1].lex_user); }
#line 47319 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3130: /* text_or_password: TEXT_STRING  */
#line 17021 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 47328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3131: /* text_or_password: PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17026 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
          }
#line 47337 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3132: /* text_or_password: OLD_PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17031 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
            Lex->definer->auth->auth_str.str= Item_func_password::alloc(thd,
                                   (yyvsp[-1].lex_string_with_metadata).str, (yyvsp[-1].lex_string_with_metadata).length, Item_func_password::OLD);
            Lex->definer->auth->auth_str.length=  SCRAMBLED_PASSWORD_CHAR_LENGTH_323;
          }
#line 47349 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3133: /* set_expr_or_default: expr  */
#line 17041 "/home/buildbot/git/sql/sql_yacc.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 47355 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3134: /* set_expr_or_default: DEFAULT  */
#line 17042 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.item)=0; }
#line 47361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3135: /* set_expr_or_default: ON  */
#line 17044 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ON",  2);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47371 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3136: /* set_expr_or_default: ALL  */
#line 17050 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ALL", 3);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47381 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3137: /* set_expr_or_default: BINARY  */
#line 17056 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "binary", 6);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47391 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3138: /* $@228: %empty  */
#line 17067 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "LOCK"));
            lex->sql_command= SQLCOM_LOCK_TABLES;
          }
#line 47403 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3139: /* lock: LOCK_SYM table_or_tables $@228 table_lock_list opt_lock_wait_timeout  */
#line 17075 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47409 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3140: /* opt_lock_wait_timeout: %empty  */
#line 17080 "/home/buildbot/git/sql/sql_yacc.yy"
        {}
#line 47415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3141: /* opt_lock_wait_timeout: WAIT_SYM ulong_num  */
#line 17082 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), (yyvsp[0].ulong_num))) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), (yyvsp[0].ulong_num))))
            MYSQL_YYABORT;
        }
#line 47425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3142: /* opt_lock_wait_timeout: NOWAIT_SYM  */
#line 17088 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), 0)) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), 0)))
            MYSQL_YYABORT;
        }
#line 47435 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3143: /* table_or_tables: TABLE_SYM  */
#line 17096 "/home/buildbot/git/sql/sql_yacc.yy"
                           { }
#line 47441 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3144: /* table_or_tables: TABLES  */
#line 17097 "/home/buildbot/git/sql/sql_yacc.yy"
                           { }
#line 47447 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3147: /* table_lock: table_ident opt_table_alias_clause lock_option  */
#line 17107 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            thr_lock_type lock_type= (thr_lock_type) (yyvsp[0].num);
            bool lock_for_write= (lock_type >= TL_WRITE_ALLOW_WRITE);
            ulong table_options= lock_for_write ? TL_OPTION_UPDATING : 0;
            enum_mdl_type mdl_type= !lock_for_write
                                    ? MDL_SHARED_READ
                                    : lock_type == TL_WRITE_CONCURRENT_INSERT
                                      ? MDL_SHARED_WRITE
                                      : MDL_SHARED_NO_READ_WRITE;

            if (unlikely(!Lex->current_select_or_default()->
                         add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[-1].lex_str_ptr), table_options,
                                           lock_type, mdl_type)))
              MYSQL_YYABORT;
          }
#line 47467 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3148: /* lock_option: READ_SYM  */
#line 17125 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_READ_NO_INSERT; }
#line 47473 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3149: /* lock_option: WRITE_SYM  */
#line 17126 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_WRITE_DEFAULT; }
#line 47479 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3150: /* lock_option: WRITE_SYM CONCURRENT  */
#line 17128 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.num)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 47487 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3151: /* lock_option: LOW_PRIORITY WRITE_SYM  */
#line 17132 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_WRITE_LOW_PRIORITY; }
#line 47493 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3152: /* lock_option: READ_SYM LOCAL_SYM  */
#line 17133 "/home/buildbot/git/sql/sql_yacc.yy"
                                 { (yyval.num)= TL_READ; }
#line 47499 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3153: /* $@229: %empty  */
#line 17138 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "UNLOCK"));
            lex->sql_command= SQLCOM_UNLOCK_TABLES;
          }
#line 47511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3154: /* unlock: UNLOCK_SYM $@229 table_or_tables  */
#line 17146 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47517 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3155: /* $@230: %empty  */
#line 17155 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 47526 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3156: /* handler: HANDLER_SYM $@230 handler_tail  */
#line 17160 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->pop_select(); //main select
          }
#line 47534 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3157: /* handler_tail: table_ident OPEN_SYM opt_table_alias_clause  */
#line 17167 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_OPEN;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[0].lex_str_ptr), 0))
              MYSQL_YYABORT;
          }
#line 47547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3158: /* handler_tail: table_ident_nodb CLOSE_SYM  */
#line 17176 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_CLOSE;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47560 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3159: /* $@231: %empty  */
#line 17185 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->clause_that_disallows_subselect= "HANDLER..READ";
            lex->sql_command = SQLCOM_HA_READ;
            lex->ha_rkey_mode= HA_READ_KEY_EXACT; /* Avoid purify warnings */
            Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
            if (unlikely(one == NULL))
              MYSQL_YYABORT;
            lex->current_select->select_limit= one;
            lex->current_select->offset_limit= 0;
            lex->limit_rows_examined= 0;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47581 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3160: /* handler_tail: table_ident_nodb READ_SYM $@231 handler_read_or_scan opt_where_clause opt_global_limit_clause  */
#line 17202 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->clause_that_disallows_subselect= NULL;
            if (!lex->current_select->explicit_limit)
            {
              Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
              if (one == NULL)
                MYSQL_YYABORT;
              lex->current_select->select_limit= one;
              lex->current_select->offset_limit= 0;
              lex->limit_rows_examined= 0;
            }
            /* Stored functions are not supported for HANDLER READ. */
            if (lex->uses_stored_routines())
            {
              my_error(ER_NOT_SUPPORTED_YET, MYF(0),
                       "stored functions in HANDLER ... READ");
              MYSQL_YYABORT;
            }
          }
#line 47606 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3161: /* handler_read_or_scan: handler_scan_function  */
#line 17225 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->ident= null_clex_str; }
#line 47612 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3162: /* handler_read_or_scan: ident handler_rkey_function  */
#line 17226 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->ident= (yyvsp[-1].ident_sys); }
#line 47618 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3163: /* handler_scan_function: FIRST_SYM  */
#line 17230 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47624 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3164: /* handler_scan_function: NEXT_SYM  */
#line 17231 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47630 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3165: /* handler_rkey_function: FIRST_SYM  */
#line 17235 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47636 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3166: /* handler_rkey_function: NEXT_SYM  */
#line 17236 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47642 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3167: /* handler_rkey_function: PREV_SYM  */
#line 17237 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RPREV;  }
#line 47648 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3168: /* handler_rkey_function: LAST_SYM  */
#line 17238 "/home/buildbot/git/sql/sql_yacc.yy"
                    { Lex->ha_read_mode = RLAST;  }
#line 47654 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3169: /* $@232: %empty  */
#line 17240 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->ha_read_mode = RKEY;
            lex->ha_rkey_mode=(yyvsp[0].ha_rkey_mode);
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 47666 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3170: /* handler_rkey_function: handler_rkey_mode $@232 '(' values ')'  */
#line 17248 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47672 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3171: /* handler_rkey_mode: '='  */
#line 17252 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_KEY_EXACT;   }
#line 47678 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3172: /* handler_rkey_mode: GE  */
#line 17253 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_NEXT; }
#line 47684 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3173: /* handler_rkey_mode: LE  */
#line 17254 "/home/buildbot/git/sql/sql_yacc.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_PREV; }
#line 47690 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3174: /* handler_rkey_mode: '>'  */
#line 17255 "/home/buildbot/git/sql/sql_yacc.yy"
              { (yyval.ha_rkey_mode)=HA_READ_AFTER_KEY;   }
#line 47696 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3175: /* handler_rkey_mode: '<'  */
#line 17256 "/home/buildbot/git/sql/sql_yacc.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_BEFORE_KEY;  }
#line 47702 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3176: /* revoke: REVOKE clear_privileges revoke_command  */
#line 17263 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47708 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3177: /* revoke_command: grant_privileges ON opt_table grant_ident FROM user_and_role_list  */
#line 17268 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= 0;
          }
#line 47718 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3178: /* revoke_command: grant_privileges ON FUNCTION_SYM grant_ident FROM user_and_role_list  */
#line 17274 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47728 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3179: /* revoke_command: grant_privileges ON PROCEDURE_SYM grant_ident FROM user_and_role_list  */
#line 17280 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                         TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47738 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3180: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17287 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47748 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3181: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17294 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47758 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3182: /* revoke_command: ALL opt_privileges ',' GRANT OPTION FROM user_and_role_list  */
#line 17300 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_REVOKE_ALL;
          }
#line 47766 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3183: /* revoke_command: PROXY_SYM ON user FROM user_list  */
#line 17304 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-2].lex_user));
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47777 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3184: /* revoke_command: admin_option_for_role FROM user_and_role_list  */
#line 17311 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_REVOKE_ROLE;
            if (unlikely(Lex->users_list.push_front((yyvsp[-2].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47787 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3185: /* admin_option_for_role: ADMIN_SYM OPTION FOR_SYM grant_role  */
#line 17320 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->with_admin_option= true; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47793 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3186: /* admin_option_for_role: grant_role  */
#line 17322 "/home/buildbot/git/sql/sql_yacc.yy"
        { Lex->with_admin_option= false; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47799 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3187: /* grant: GRANT clear_privileges grant_command  */
#line 17327 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 47805 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3188: /* grant_command: grant_privileges ON opt_table grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17333 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT;
            lex->type= 0;
          }
#line 47815 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3189: /* grant_command: grant_privileges ON FUNCTION_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17340 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47825 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3190: /* grant_command: grant_privileges ON PROCEDURE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17347 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47835 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3191: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17354 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47845 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3192: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17361 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47855 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3193: /* grant_command: PROXY_SYM ON user TO_SYM grant_list opt_grant_option  */
#line 17367 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-3].lex_user));
            lex->sql_command= SQLCOM_GRANT;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47866 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3194: /* grant_command: grant_role TO_SYM grant_list opt_with_admin_option  */
#line 17374 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT_ROLE;
            /* The first role is the one that is granted */
            if (unlikely(Lex->users_list.push_front((yyvsp[-3].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47878 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3195: /* opt_with_admin: %empty  */
#line 17385 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->definer = 0; }
#line 47884 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3196: /* opt_with_admin: WITH ADMIN_SYM user_or_role  */
#line 17386 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->definer = (yyvsp[0].lex_user); }
#line 47890 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3197: /* opt_with_admin_option: %empty  */
#line 17390 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->with_admin_option= false; }
#line 47896 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3198: /* opt_with_admin_option: WITH ADMIN_SYM OPTION  */
#line 17391 "/home/buildbot/git/sql/sql_yacc.yy"
                                      { Lex->with_admin_option= true; }
#line 47902 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3199: /* role_list: grant_role  */
#line 17396 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47911 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3200: /* role_list: role_list ',' grant_role  */
#line 17401 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47920 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3201: /* current_role: CURRENT_ROLE optional_braces  */
#line 17409 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_role;
            (yyval.lex_user)->auth= NULL;
          }
#line 47931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3202: /* grant_role: ident_or_text  */
#line 17419 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            CHARSET_INFO *cs= system_charset_info;
            /* trim end spaces (as they'll be lost in mysql.user anyway) */
            (yyvsp[0].lex_str).length= cs->cset->lengthsp(cs, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            ((char*) (yyvsp[0].lex_str).str)[(yyvsp[0].lex_str).length] = '\0';
            if (unlikely((yyvsp[0].lex_str).length == 0))
              my_yyabort_error((ER_INVALID_ROLE, MYF(0), ""));
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= (yyvsp[0].lex_str);
            (yyval.lex_user)->host= empty_clex_str;
            (yyval.lex_user)->auth= NULL;

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  cs, 0)))
              MYSQL_YYABORT;
          }
#line 47954 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3206: /* grant_privileges: object_privilege_list  */
#line 17446 "/home/buildbot/git/sql/sql_yacc.yy"
                                {}
#line 47960 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3207: /* grant_privileges: ALL opt_privileges  */
#line 17448 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            Lex->all_privileges= 1; 
            Lex->grant= GLOBAL_ACLS;
          }
#line 47969 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3212: /* $@233: %empty  */
#line 17466 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = SELECT_ACL;}
#line 47975 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3213: /* object_privilege: SELECT_SYM $@233 opt_column_list  */
#line 17467 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 47981 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3214: /* $@234: %empty  */
#line 17469 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = INSERT_ACL;}
#line 47987 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3215: /* object_privilege: INSERT $@234 opt_column_list  */
#line 17470 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 47993 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3216: /* $@235: %empty  */
#line 17472 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = UPDATE_ACL; }
#line 47999 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3217: /* object_privilege: UPDATE_SYM $@235 opt_column_list  */
#line 17473 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48005 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3218: /* $@236: %empty  */
#line 17475 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->which_columns = REFERENCES_ACL;}
#line 48011 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3219: /* object_privilege: REFERENCES $@236 opt_column_list  */
#line 17476 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48017 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3220: /* object_privilege: DELETE_SYM  */
#line 17477 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DELETE_ACL;}
#line 48023 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3221: /* object_privilege: USAGE  */
#line 17478 "/home/buildbot/git/sql/sql_yacc.yy"
                                  {}
#line 48029 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3222: /* object_privilege: INDEX_SYM  */
#line 17479 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= INDEX_ACL;}
#line 48035 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3223: /* object_privilege: ALTER  */
#line 17480 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= ALTER_ACL;}
#line 48041 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3224: /* object_privilege: CREATE  */
#line 17481 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_ACL;}
#line 48047 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3225: /* object_privilege: DROP  */
#line 17482 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DROP_ACL;}
#line 48053 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3226: /* object_privilege: EXECUTE_SYM  */
#line 17483 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= EXECUTE_ACL;}
#line 48059 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3227: /* object_privilege: RELOAD  */
#line 17484 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= RELOAD_ACL;}
#line 48065 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3228: /* object_privilege: SHUTDOWN  */
#line 17485 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHUTDOWN_ACL;}
#line 48071 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3229: /* object_privilege: PROCESS  */
#line 17486 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= PROCESS_ACL;}
#line 48077 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3230: /* object_privilege: FILE_SYM  */
#line 17487 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= FILE_ACL;}
#line 48083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3231: /* object_privilege: GRANT OPTION  */
#line 17488 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= GRANT_ACL;}
#line 48089 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3232: /* object_privilege: SHOW DATABASES  */
#line 17489 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHOW_DB_ACL;}
#line 48095 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3233: /* object_privilege: SUPER_SYM  */
#line 17490 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SUPER_ACL;}
#line 48101 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3234: /* object_privilege: CREATE TEMPORARY TABLES  */
#line 17491 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_TMP_ACL;}
#line 48107 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3235: /* object_privilege: LOCK_SYM TABLES  */
#line 17492 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= LOCK_TABLES_ACL; }
#line 48113 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3236: /* object_privilege: REPLICATION SLAVE  */
#line 17493 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= REPL_SLAVE_ACL; }
#line 48119 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3237: /* object_privilege: REPLICATION CLIENT_SYM  */
#line 17494 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= REPL_CLIENT_ACL; }
#line 48125 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3238: /* object_privilege: CREATE VIEW_SYM  */
#line 17495 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_VIEW_ACL; }
#line 48131 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3239: /* object_privilege: SHOW VIEW_SYM  */
#line 17496 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= SHOW_VIEW_ACL; }
#line 48137 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3240: /* object_privilege: CREATE ROUTINE_SYM  */
#line 17497 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_PROC_ACL; }
#line 48143 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3241: /* object_privilege: ALTER ROUTINE_SYM  */
#line 17498 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= ALTER_PROC_ACL; }
#line 48149 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3242: /* object_privilege: CREATE USER_SYM  */
#line 17499 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_USER_ACL; }
#line 48155 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3243: /* object_privilege: EVENT_SYM  */
#line 17500 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= EVENT_ACL;}
#line 48161 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3244: /* object_privilege: TRIGGER_SYM  */
#line 17501 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= TRIGGER_ACL; }
#line 48167 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3245: /* object_privilege: CREATE TABLESPACE  */
#line 17502 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= CREATE_TABLESPACE_ACL; }
#line 48173 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3246: /* object_privilege: DELETE_SYM HISTORY_SYM  */
#line 17503 "/home/buildbot/git/sql/sql_yacc.yy"
                                  { Lex->grant |= DELETE_HISTORY_ACL; }
#line 48179 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3247: /* opt_and: %empty  */
#line 17507 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48185 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3248: /* opt_and: AND_SYM  */
#line 17508 "/home/buildbot/git/sql/sql_yacc.yy"
                  {}
#line 48191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3251: /* require_list_element: SUBJECT_SYM TEXT_STRING  */
#line 17518 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_subject.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SUBJECT"));
            lex->account_options.x509_subject= (yyvsp[0].lex_string_with_metadata);
          }
#line 48202 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3252: /* require_list_element: ISSUER_SYM TEXT_STRING  */
#line 17525 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_issuer.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "ISSUER"));
            lex->account_options.x509_issuer= (yyvsp[0].lex_string_with_metadata);
          }
#line 48213 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3253: /* require_list_element: CIPHER_SYM TEXT_STRING  */
#line 17532 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.ssl_cipher.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CIPHER"));
            lex->account_options.ssl_cipher= (yyvsp[0].lex_string_with_metadata);
          }
#line 48224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3254: /* grant_ident: '*'  */
#line 17542 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->copy_db_to(&lex->first_select_lex()->db)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48238 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3255: /* grant_ident: ident '.' '*'  */
#line 17552 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= (yyvsp[-2].ident_sys);
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48251 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3256: /* grant_ident: '*' '.' '*'  */
#line 17561 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= null_clex_str;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant= GLOBAL_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 48264 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3257: /* grant_ident: table_ident  */
#line 17570 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!lex->first_select_lex()->
                         add_table_to_list(thd, (yyvsp[0].table),NULL,
                                           TL_OPTION_UPDATING)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant =  TABLE_ACLS & ~GRANT_ACL;
          }
#line 48278 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3258: /* user_list: user  */
#line 17583 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48287 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3259: /* user_list: user_list ',' user  */
#line 17588 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48296 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3260: /* grant_list: grant_user  */
#line 17596 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48305 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3261: /* grant_list: grant_list ',' grant_user  */
#line 17601 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48314 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3262: /* user_and_role_list: user_or_role  */
#line 17609 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48323 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3263: /* user_and_role_list: user_and_role_list ',' user_or_role  */
#line 17614 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48332 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3268: /* grant_user: user IDENTIFIED_SYM BY TEXT_STRING  */
#line 17625 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-3].lex_user)->auth->pwtext= (yyvsp[0].lex_string_with_metadata);
          }
#line 48342 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3269: /* grant_user: user IDENTIFIED_SYM BY PASSWORD_SYM TEXT_STRING  */
#line 17631 "/home/buildbot/git/sql/sql_yacc.yy"
          { 
            (yyval.lex_user)= (yyvsp[-4].lex_user); 
            (yyvsp[-4].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-4].lex_user)->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 48352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3270: /* grant_user: user IDENTIFIED_SYM via_or_with auth_expression  */
#line 17637 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= (yyvsp[0].user_auth);
          }
#line 48361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3271: /* grant_user: user_or_role  */
#line 17642 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.lex_user)= (yyvsp[0].lex_user);
          }
#line 48369 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3272: /* auth_expression: auth_token OR_SYM auth_expression  */
#line 17649 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.user_auth)= (yyvsp[-2].user_auth);
            DBUG_ASSERT((yyval.user_auth)->next == NULL);
            (yyval.user_auth)->next= (yyvsp[0].user_auth);
          }
#line 48379 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3273: /* auth_expression: auth_token  */
#line 17655 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            (yyval.user_auth)= (yyvsp[0].user_auth);
          }
#line 48387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3274: /* auth_token: ident_or_text opt_auth_str  */
#line 17662 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          (yyval.user_auth)= (yyvsp[0].user_auth);
          (yyval.user_auth)->plugin= (yyvsp[-1].lex_str);
        }
#line 48396 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3275: /* opt_auth_str: %empty  */
#line 17670 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
        }
#line 48405 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3276: /* opt_auth_str: using_or_as TEXT_STRING_sys  */
#line 17675 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->auth_str= (yyvsp[0].lex_str);
        }
#line 48415 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3277: /* opt_auth_str: using_or_as PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17681 "/home/buildbot/git/sql/sql_yacc.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->pwtext= (yyvsp[-1].lex_string_with_metadata);
        }
#line 48425 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3278: /* opt_column_list: %empty  */
#line 17690 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->grant |= lex->which_columns;
          }
#line 48434 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3279: /* opt_column_list: '(' column_list ')'  */
#line 17694 "/home/buildbot/git/sql/sql_yacc.yy"
                              { }
#line 48440 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3282: /* column_list_id: ident  */
#line 17704 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            String *new_str= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,(yyvsp[0].ident_sys).length,system_charset_info);
            if (unlikely(new_str == NULL))
              MYSQL_YYABORT;
            List_iterator <LEX_COLUMN> iter(Lex->columns);
            class LEX_COLUMN *point;
            LEX *lex=Lex;
            while ((point=iter++))
            {
              if (!my_strcasecmp(system_charset_info,
                                 point->column.c_ptr(), new_str->c_ptr()))
                break;
            }
            lex->grant_tot_col|= lex->which_columns;
            if (point)
              point->rights |= lex->which_columns;
            else
            {
              LEX_COLUMN *col= (new (thd->mem_root)
                                LEX_COLUMN(*new_str,lex->which_columns));
              if (unlikely(col == NULL))
                MYSQL_YYABORT;
              lex->columns.push_back(col, thd->mem_root);
            }
          }
#line 48470 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3284: /* opt_require_clause: REQUIRE_SYM require_list  */
#line 17734 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_SPECIFIED;
          }
#line 48478 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3285: /* opt_require_clause: REQUIRE_SYM SSL_SYM  */
#line 17738 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_ANY;
          }
#line 48486 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3286: /* opt_require_clause: REQUIRE_SYM X509_SYM  */
#line 17742 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_X509;
          }
#line 48494 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3287: /* opt_require_clause: REQUIRE_SYM NONE_SYM  */
#line 17746 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_NONE;
          }
#line 48502 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3288: /* resource_option: MAX_QUERIES_PER_HOUR ulong_num  */
#line 17753 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.questions=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::QUERIES_PER_HOUR;
          }
#line 48511 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3289: /* resource_option: MAX_UPDATES_PER_HOUR ulong_num  */
#line 17758 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.updates=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::UPDATES_PER_HOUR;
          }
#line 48520 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3290: /* resource_option: MAX_CONNECTIONS_PER_HOUR ulong_num  */
#line 17763 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.conn_per_hour= (yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::CONNECTIONS_PER_HOUR;
          }
#line 48529 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3291: /* resource_option: MAX_USER_CONNECTIONS_SYM int_num  */
#line 17768 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.user_conn= (yyvsp[0].num);
            Lex->account_options.specified_limits|= USER_RESOURCES::USER_CONNECTIONS;
          }
#line 48538 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3292: /* resource_option: MAX_STATEMENT_TIME_SYM NUM_literal  */
#line 17773 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->account_options.max_statement_time= (yyvsp[0].item_num)->val_real();
            Lex->account_options.specified_limits|= USER_RESOURCES::MAX_STATEMENT_TIME;
          }
#line 48547 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3293: /* resource_option_list: resource_option_list resource_option  */
#line 17780 "/home/buildbot/git/sql/sql_yacc.yy"
                                               {}
#line 48553 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3294: /* resource_option_list: resource_option  */
#line 17781 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48559 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3295: /* opt_resource_options: %empty  */
#line 17785 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48565 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3297: /* opt_grant_options: %empty  */
#line 17791 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48571 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3298: /* opt_grant_options: WITH grant_option_list  */
#line 17792 "/home/buildbot/git/sql/sql_yacc.yy"
                                 {}
#line 48577 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3299: /* opt_grant_option: %empty  */
#line 17796 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48583 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3300: /* opt_grant_option: WITH GRANT OPTION  */
#line 17797 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->grant |= GRANT_ACL;}
#line 48589 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3301: /* grant_option_list: grant_option_list grant_option  */
#line 17801 "/home/buildbot/git/sql/sql_yacc.yy"
                                         {}
#line 48595 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3302: /* grant_option_list: grant_option  */
#line 17802 "/home/buildbot/git/sql/sql_yacc.yy"
                       {}
#line 48601 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3303: /* grant_option: GRANT OPTION  */
#line 17806 "/home/buildbot/git/sql/sql_yacc.yy"
                       { Lex->grant |= GRANT_ACL;}
#line 48607 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3304: /* grant_option: resource_option  */
#line 17807 "/home/buildbot/git/sql/sql_yacc.yy"
                          {}
#line 48613 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3305: /* $@237: %empty  */
#line 17812 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_BEGIN;
            lex->start_transaction_opt= 0;
          }
#line 48623 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3306: /* begin_stmt_mariadb: BEGIN_MARIADB_SYM $@237 opt_work  */
#line 17817 "/home/buildbot/git/sql/sql_yacc.yy"
                   {}
#line 48629 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3307: /* compound_statement: sp_proc_stmt_compound_ok  */
#line 17822 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command= SQLCOM_COMPOUND;
            if (Lex->sp_body_finalize_procedure(thd))
              MYSQL_YYABORT;
          }
#line 48639 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3308: /* opt_not: %empty  */
#line 17830 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 0; }
#line 48645 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3309: /* opt_not: not  */
#line 17831 "/home/buildbot/git/sql/sql_yacc.yy"
                       { (yyval.num)= 1; }
#line 48651 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3310: /* opt_work: %empty  */
#line 17835 "/home/buildbot/git/sql/sql_yacc.yy"
                      {}
#line 48657 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3311: /* opt_work: WORK_SYM  */
#line 17836 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 48663 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3312: /* opt_chain: %empty  */
#line 17841 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48669 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3313: /* opt_chain: AND_SYM NO_SYM CHAIN_SYM  */
#line 17842 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48675 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3314: /* opt_chain: AND_SYM CHAIN_SYM  */
#line 17843 "/home/buildbot/git/sql/sql_yacc.yy"
                                   { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48681 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3315: /* opt_release: %empty  */
#line 17848 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48687 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3316: /* opt_release: RELEASE_SYM  */
#line 17849 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48693 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3317: /* opt_release: NO_SYM RELEASE_SYM  */
#line 17850 "/home/buildbot/git/sql/sql_yacc.yy"
                             { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48699 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3318: /* commit: COMMIT_SYM opt_work opt_chain opt_release  */
#line 17855 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_COMMIT;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48712 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3319: /* rollback: ROLLBACK_SYM opt_work opt_chain opt_release  */
#line 17867 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48725 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3320: /* rollback: ROLLBACK_SYM opt_work TO_SYM SAVEPOINT_SYM ident  */
#line 17876 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48735 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3321: /* rollback: ROLLBACK_SYM opt_work TO_SYM ident  */
#line 17882 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48745 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3322: /* savepoint: SAVEPOINT_SYM ident  */
#line 17891 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48755 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3323: /* release: RELEASE_SYM SAVEPOINT_SYM ident  */
#line 17900 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RELEASE_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48765 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3324: /* unit_type_decl: UNION_SYM union_option  */
#line 17913 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= UNION_TYPE; (yyval.unit_operation).distinct= (yyvsp[0].num); }
#line 48771 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3325: /* unit_type_decl: INTERSECT_SYM  */
#line 17915 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= INTERSECT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48777 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3326: /* unit_type_decl: EXCEPT_SYM  */
#line 17917 "/home/buildbot/git/sql/sql_yacc.yy"
          { (yyval.unit_operation).unit_type= EXCEPT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48783 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3327: /* union_option: %empty  */
#line 17924 "/home/buildbot/git/sql/sql_yacc.yy"
                      { (yyval.num)=1; }
#line 48789 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3328: /* union_option: DISTINCT  */
#line 17925 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=1; }
#line 48795 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3329: /* union_option: ALL  */
#line 17926 "/home/buildbot/git/sql/sql_yacc.yy"
                    { (yyval.num)=0; }
#line 48801 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3330: /* query_expression_option: STRAIGHT_JOIN  */
#line 17930 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Select->options|= SELECT_STRAIGHT_JOIN; }
#line 48807 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3331: /* query_expression_option: HIGH_PRIORITY  */
#line 17932 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            YYPS->m_lock_type= TL_READ_HIGH_PRIORITY;
            YYPS->m_mdl_type= MDL_SHARED_READ;
            Select->options|= SELECT_HIGH_PRIORITY;
          }
#line 48817 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3332: /* query_expression_option: DISTINCT  */
#line 17937 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48823 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3333: /* query_expression_option: SQL_SMALL_RESULT  */
#line 17938 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_SMALL_RESULT; }
#line 48829 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3334: /* query_expression_option: SQL_BIG_RESULT  */
#line 17939 "/home/buildbot/git/sql/sql_yacc.yy"
                           { Select->options|= SELECT_BIG_RESULT; }
#line 48835 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3335: /* query_expression_option: SQL_BUFFER_RESULT  */
#line 17940 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Select->options|= OPTION_BUFFER_RESULT; }
#line 48841 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3336: /* query_expression_option: SQL_CALC_FOUND_ROWS  */
#line 17941 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Select->options|= OPTION_FOUND_ROWS; }
#line 48847 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3337: /* query_expression_option: ALL  */
#line 17942 "/home/buildbot/git/sql/sql_yacc.yy"
              { Select->options|= SELECT_ALL; }
#line 48853 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3340: /* no_definer: %empty  */
#line 17958 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            /*
              We have to distinguish missing DEFINER-clause from case when
              CURRENT_USER specified as definer explicitly in order to properly
              handle CREATE TRIGGER statements which come to replication thread
              from older master servers (i.e. to create non-suid trigger in this
              case).
            */
            thd->lex->definer= 0;
          }
#line 48868 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3341: /* definer: DEFINER_SYM '=' user_or_role  */
#line 17972 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->definer= (yyvsp[0].lex_user);
            Lex->account_options.reset();
          }
#line 48877 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3342: /* view_algorithm: ALGORITHM_SYM '=' UNDEFINED_SYM  */
#line 17985 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= DTYPE_ALGORITHM_UNDEFINED; }
#line 48883 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3343: /* view_algorithm: ALGORITHM_SYM '=' MERGE_SYM  */
#line 17986 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_MERGE; }
#line 48889 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3344: /* view_algorithm: ALGORITHM_SYM '=' TEMPTABLE_SYM  */
#line 17987 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_TMPTABLE; }
#line 48895 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3345: /* opt_view_suid: %empty  */
#line 17991 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFAULT; }
#line 48901 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3346: /* opt_view_suid: view_suid  */
#line 17992 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= (yyvsp[0].view_suid); }
#line 48907 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3347: /* view_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 17996 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFINER; }
#line 48913 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3348: /* view_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 17997 "/home/buildbot/git/sql/sql_yacc.yy"
                                           { (yyval.view_suid)= VIEW_SUID_INVOKER; }
#line 48919 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3349: /* view_list_opt: %empty  */
#line 18002 "/home/buildbot/git/sql/sql_yacc.yy"
          {}
#line 48925 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3350: /* view_list_opt: '(' view_list ')'  */
#line 18003 "/home/buildbot/git/sql/sql_yacc.yy"
                            { }
#line 48931 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3351: /* view_list: ident  */
#line 18008 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48941 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3352: /* view_list: view_list ',' ident  */
#line 18014 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48951 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3353: /* $@238: %empty  */
#line 18022 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->parsing_options.allows_variable= FALSE;
            lex->create_view->select.str= (char *) YYLIP->get_cpp_ptr();
          }
#line 48961 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3354: /* view_select: $@238 query_expression view_check_option  */
#line 18029 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->parsed_create_view((yyvsp[-1].select_lex_unit), (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 48970 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3355: /* view_check_option: %empty  */
#line 18036 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_NONE; }
#line 48976 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3356: /* view_check_option: WITH CHECK_SYM OPTION  */
#line 18037 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48982 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3357: /* view_check_option: WITH CASCADED CHECK_SYM OPTION  */
#line 18038 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48988 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3358: /* view_check_option: WITH LOCAL_SYM CHECK_SYM OPTION  */
#line 18039 "/home/buildbot/git/sql/sql_yacc.yy"
                                          { (yyval.num)= VIEW_CHECK_LOCAL; }
#line 48994 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3359: /* trigger_action_order: FOLLOWS_SYM  */
#line 18050 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_FOLLOWS; }
#line 49000 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3360: /* trigger_action_order: PRECEDES_SYM  */
#line 18052 "/home/buildbot/git/sql/sql_yacc.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_PRECEDES; }
#line 49006 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3361: /* trigger_follows_precedes_clause: %empty  */
#line 18057 "/home/buildbot/git/sql/sql_yacc.yy"
            {
              (yyval.trg_execution_order).ordering_clause= TRG_ORDER_NONE;
              (yyval.trg_execution_order).anchor_trigger_name.str= NULL;
              (yyval.trg_execution_order).anchor_trigger_name.length= 0;
            }
#line 49016 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3362: /* trigger_follows_precedes_clause: trigger_action_order ident_or_text  */
#line 18064 "/home/buildbot/git/sql/sql_yacc.yy"
            {
              (yyval.trg_execution_order).ordering_clause= (yyvsp[-1].trigger_action_order_type);
              (yyval.trg_execution_order).anchor_trigger_name= (yyvsp[0].lex_str);
            }
#line 49025 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3363: /* $@239: %empty  */
#line 18073 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[0].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 49034 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3364: /* $@240: %empty  */
#line 18082 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $9 */
            Lex->raw_trg_on_table_name_begin= YYLIP->get_tok_start();
          }
#line 49042 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3365: /* $@241: %empty  */
#line 18088 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $13 */
            Lex->raw_trg_on_table_name_end= YYLIP->get_tok_start();
          }
#line 49050 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3366: /* $@242: %empty  */
#line 18093 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->trg_chistics.ordering_clause_begin= YYLIP->get_cpp_ptr();
          }
#line 49058 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3367: /* $@243: %empty  */
#line 18097 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $18 */
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_RECURSIVE_CREATE, MYF(0), "TRIGGER"));

            lex->stmt_definition_begin= (yyvsp[-16].simple_string);
            lex->ident.str= (yyvsp[-9].simple_string);
            lex->ident.length= (yyvsp[-5].simple_string) - (yyvsp[-9].simple_string);
            lex->spname= (yyvsp[-13].spname);
            (*static_cast<st_trg_execution_order*>(&lex->trg_chistics))= ((yyvsp[0].trg_execution_order));
            lex->trg_chistics.ordering_clause_end= lip->get_cpp_ptr();

            if (unlikely(!lex->make_sp_head(thd, (yyvsp[-13].spname), &sp_handler_trigger,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_tok_start());
          }
#line 49083 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3368: /* trigger_tail: remember_name opt_if_not_exists $@239 sp_name trg_action_time trg_event ON remember_name $@240 table_ident FOR_SYM remember_name $@241 EACH_SYM ROW_SYM $@242 trigger_follows_precedes_clause $@243 sp_proc_stmt force_lookahead  */
#line 18118 "/home/buildbot/git/sql/sql_yacc.yy"
          { /* $21 */
            LEX *lex= Lex;

            lex->sql_command= SQLCOM_CREATE_TRIGGER;
            if (lex->sp_body_finalize_trigger(thd))
              MYSQL_YYABORT;

            /*
              We have to do it after parsing trigger body, because some of
              sp_proc_stmt alternatives are not saving/restoring LEX, so
              lex->query_tables can be wiped out.
            */
            if (!lex->first_select_lex()->
                 add_table_to_list(thd, (yyvsp[-10].table), (LEX_CSTRING*) 0,
                                   TL_OPTION_UPDATING, TL_READ_NO_INSERT,
                                   MDL_SHARED_NO_WRITE))
              MYSQL_YYABORT;
          }
#line 49106 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3369: /* $@244: %empty  */
#line 18147 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= Lex;
            lex->init_last_field(&lex->sphead->m_return_field_def,
                                 &empty_clex_str,
                                 thd->variables.collation_database);
          }
#line 49117 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3370: /* sf_return_type: RETURNS_SYM $@244 field_type  */
#line 18154 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sphead->fill_field_definition(thd,
                                                            Lex->last_field)))
              MYSQL_YYABORT;
          }
#line 49127 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3371: /* $@245: %empty  */
#line 18163 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            LEX *lex= thd->lex;
            lex->sphead->set_c_chistics(lex->sp_chistics);
            lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 49137 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3372: /* sf_c_chistics_and_body: sp_c_chistics $@245 sp_proc_stmt_in_returns_clause force_lookahead  */
#line 18169 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_body_finalize_function(thd)))
              MYSQL_YYABORT;
          }
#line 49146 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3373: /* $@246: %empty  */
#line 18178 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(!Lex->make_sp_head_no_recursive(thd, (yyvsp[0].spname),
                                                         &sp_handler_procedure,
                                                         DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
          }
#line 49157 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3374: /* $@247: %empty  */
#line 18186 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sphead->set_c_chistics(Lex->sp_chistics);
            Lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 49166 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3375: /* sp_tail: sp_name $@246 sp_parenthesized_pdparam_list sp_c_chistics $@247 sp_proc_stmt force_lookahead  */
#line 18191 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (unlikely(Lex->sp_body_finalize_procedure(thd)))
              MYSQL_YYABORT;
          }
#line 49175 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3376: /* xa: XA_SYM begin_or_start xid opt_join_or_resume  */
#line 18201 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_START;
          }
#line 49183 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3377: /* xa: XA_SYM END xid opt_suspend  */
#line 18205 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_END;
          }
#line 49191 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3378: /* xa: XA_SYM PREPARE_SYM xid  */
#line 18209 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_PREPARE;
          }
#line 49199 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3379: /* xa: XA_SYM COMMIT_SYM xid opt_one_phase  */
#line 18213 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_COMMIT;
          }
#line 49207 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3380: /* xa: XA_SYM ROLLBACK_SYM xid  */
#line 18217 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_ROLLBACK;
          }
#line 49215 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3381: /* xa: XA_SYM RECOVER_SYM opt_format_xid  */
#line 18221 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->sql_command = SQLCOM_XA_RECOVER;
            Lex->verbose= (yyvsp[0].num);
          }
#line 49224 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3382: /* opt_format_xid: %empty  */
#line 18228 "/home/buildbot/git/sql/sql_yacc.yy"
                     { (yyval.num)= false; }
#line 49230 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3383: /* opt_format_xid: FORMAT_SYM '=' ident_or_text  */
#line 18230 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("SQL")))
              (yyval.num)= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("RAW")))
              (yyval.num)= false;
            else
            {
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0),
                               "XA RECOVER", (yyvsp[0].lex_str).str));
              (yyval.num)= false;
            }
          }
#line 49247 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3384: /* xid: text_string  */
#line 18246 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[0].string)->length() <= MAXGTRIDSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(), 0, 0);
          }
#line 49258 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3385: /* xid: text_string ',' text_string  */
#line 18253 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].string)->length() <= MAXGTRIDSIZE && (yyvsp[0].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length(), (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length());
          }
#line 49269 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3386: /* xid: text_string ',' text_string ',' ulong_num  */
#line 18260 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].string)->length() <= MAXGTRIDSIZE && (yyvsp[-2].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set((yyvsp[0].ulong_num), (yyvsp[-4].string)->ptr(), (yyvsp[-4].string)->length(), (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length());
          }
#line 49280 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3387: /* begin_or_start: BEGIN_MARIADB_SYM  */
#line 18269 "/home/buildbot/git/sql/sql_yacc.yy"
                            {}
#line 49286 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3388: /* begin_or_start: BEGIN_ORACLE_SYM  */
#line 18270 "/home/buildbot/git/sql/sql_yacc.yy"
                           {}
#line 49292 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3389: /* begin_or_start: START_SYM  */
#line 18271 "/home/buildbot/git/sql/sql_yacc.yy"
                    {}
#line 49298 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3390: /* opt_join_or_resume: %empty  */
#line 18275 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_NONE;        }
#line 49304 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3391: /* opt_join_or_resume: JOIN_SYM  */
#line 18276 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_JOIN;        }
#line 49310 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3392: /* opt_join_or_resume: RESUME_SYM  */
#line 18277 "/home/buildbot/git/sql/sql_yacc.yy"
                        { Lex->xa_opt=XA_RESUME;      }
#line 49316 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3393: /* opt_one_phase: %empty  */
#line 18281 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->xa_opt=XA_NONE;        }
#line 49322 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3394: /* opt_one_phase: ONE_SYM PHASE_SYM  */
#line 18282 "/home/buildbot/git/sql/sql_yacc.yy"
                            { Lex->xa_opt=XA_ONE_PHASE;   }
#line 49328 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3395: /* opt_suspend: %empty  */
#line 18287 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->xa_opt=XA_NONE;        }
#line 49334 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3396: /* $@248: %empty  */
#line 18289 "/home/buildbot/git/sql/sql_yacc.yy"
          { Lex->xa_opt=XA_SUSPEND;     }
#line 49340 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3398: /* opt_migrate: %empty  */
#line 18294 "/home/buildbot/git/sql/sql_yacc.yy"
                              {}
#line 49346 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3399: /* opt_migrate: FOR_SYM MIGRATE_SYM  */
#line 18295 "/home/buildbot/git/sql/sql_yacc.yy"
                              { Lex->xa_opt=XA_FOR_MIGRATE; }
#line 49352 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3400: /* install: INSTALL_SYM PLUGIN_SYM opt_if_not_exists ident SONAME_SYM TEXT_STRING_sys  */
#line 18300 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_install_plugin((yyvsp[-3].object_ddl_options), (yyvsp[-2].ident_sys), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49361 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3401: /* install: INSTALL_SYM SONAME_SYM TEXT_STRING_sys  */
#line 18305 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            Lex->stmt_install_plugin((yyvsp[0].lex_str));
          }
#line 49369 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3402: /* uninstall: UNINSTALL_SYM PLUGIN_SYM opt_if_exists ident  */
#line 18312 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_name((yyvsp[-1].object_ddl_options), (yyvsp[0].ident_sys)))
              MYSQL_YYABORT;
          }
#line 49378 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3403: /* uninstall: UNINSTALL_SYM SONAME_SYM opt_if_exists TEXT_STRING_sys  */
#line 18317 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_soname((yyvsp[-1].object_ddl_options), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49387 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;

  case 3404: /* keep_gcc_happy: IMPOSSIBLE_ACTION  */
#line 18326 "/home/buildbot/git/sql/sql_yacc.yy"
          {
            YYERROR;
          }
#line 49395 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"
    break;


#line 49399 "/home/buildbot/git/mkdist/sql/sql_yacc.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (thd, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, thd);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, thd);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (thd, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, thd);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, thd);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

