/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ORAparse
#define yylex           ORAlex
#define yyerror         ORAerror
#define yydebug         ORAdebug
#define yynerrs         ORAnerrs

/* First part of user prologue.  */
#line 25 "/home/buildbot/git/sql/sql_yacc_ora.yy"

#define YYLIP  (& thd->m_parser_state->m_lip)
#define YYPS   (& thd->m_parser_state->m_yacc)
#define YYCSCL (thd->variables.character_set_client)

#define MYSQL_YACC
#define YYINITDEPTH 100
#define YYMAXDEPTH 3200                        /* Because of 64K stack */
#define Lex (thd->lex)

#define Select Lex->current_select
#include "mariadb.h"
#include "sql_priv.h"
#include "sql_parse.h"                        /* comp_*_creator */
#include "sql_table.h"                        /* primary_key_name */
#include "sql_partition.h"  /* partition_info, HASH_PARTITION */
#include "sql_acl.h"                          /* *_ACL */
#include "sql_class.h"      /* Key_part_spec, enum_filetype, Diag_condition_item_name */
#include "slave.h"
#include "lex_symbol.h"
#include "item_create.h"
#include "sp_head.h"
#include "sp_rcontext.h"
#include "sp.h"
#include "sql_show.h"
#include "sql_alter.h"                         // Sql_cmd_alter_table*
#include "sql_truncate.h"                      // Sql_cmd_truncate_table
#include "sql_admin.h"                         // Sql_cmd_analyze/Check..._table
#include "sql_partition_admin.h"               // Sql_cmd_alter_table_*_part.
#include "sql_handler.h"                       // Sql_cmd_handler_*
#include "sql_signal.h"
#include "sql_get_diagnostics.h"               // Sql_cmd_get_diagnostics
#include "sql_cte.h"
#include "sql_window.h"
#include "item_windowfunc.h"
#include "event_parse_data.h"
#include "create_options.h"
#include <myisam.h>
#include <myisammrg.h>
#include "keycaches.h"
#include "set_var.h"
#include "rpl_mi.h"
#include "lex_token.h"
#include "sql_lex.h"
#include "sql_sequence.h"
#include "my_base.h"
#include "sql_type_json.h"

/* this is to get the bison compilation windows warnings out */
#ifdef _MSC_VER
/* warning C4065: switch statement contains 'default' but no 'case' labels */
/* warning C4102: 'yyexhaustedlab': unreferenced label */
#pragma warning (disable : 4065 4102)
#endif
#ifdef __GNUC__
#pragma GCC diagnostic ignored "-Wunused-label" /* yyexhaustedlab: */
#endif

int yylex(void *yylval, void *yythd);

#define yyoverflow(A,B,C,D,E,F)               \
  {                                           \
    size_t val= *(F);                          \
    if (unlikely(my_yyoverflow((B), (D), &val))) \
    {                                         \
      yyerror(thd, (char*) (A));              \
      return 2;                               \
    }                                         \
    else                                      \
    {                                         \
      *(F)= (YYSIZE_T)val;                    \
    }                                         \
  }

#define MYSQL_YYABORT                         \
  do                                          \
  {                                           \
    LEX::cleanup_lex_after_parse_error(thd);  \
    YYABORT;                                  \
  } while (0)

#define MYSQL_YYABORT_UNLESS(A)                  \
  if (unlikely(!(A)))                            \
  {                                              \
    thd->parse_error();                          \
    MYSQL_YYABORT;                               \
  }

#define my_yyabort_error(A)                      \
  do { my_error A; MYSQL_YYABORT; } while(0)

#ifndef DBUG_OFF
#define YYDEBUG 1
#else
#define YYDEBUG 0
#endif


static Item* escape(THD *thd)
{
  thd->lex->escape_used= false;
  const char *esc= thd->variables.sql_mode & MODE_NO_BACKSLASH_ESCAPES ? "" : "\\";
  return new (thd->mem_root) Item_string_ascii(thd, esc, MY_TEST(esc[0]));
}


/**
  @brief Bison callback to report a syntax/OOM error

  This function is invoked by the bison-generated parser
  when a syntax error, a parse error or an out-of-memory
  condition occurs. This function is not invoked when the
  parser is requested to abort by semantic action code
  by means of YYABORT or YYACCEPT macros. This is why these
  macros should not be used (use MYSQL_YYABORT/MYSQL_YYACCEPT
  instead).

  The parser will abort immediately after invoking this callback.

  This function is not for use in semantic actions and is internal to
  the parser, as it performs some pre-return cleanup. 
  In semantic actions, please use thd->parse_error() or my_error to
  push an error into the error stack and MYSQL_YYABORT
  to abort from the parser.
*/

void ORAerror(THD *thd, const char *s)
{
  /*
    Restore the original LEX if it was replaced when parsing
    a stored procedure. We must ensure that a parsing error
    does not leave any side effects in the THD.
  */
  LEX::cleanup_lex_after_parse_error(thd);

  /* "parse error" changed into "syntax error" between bison 1.75 and 1.875 */
  if (strcmp(s,"parse error") == 0 || strcmp(s,"syntax error") == 0)
    s= ER_THD(thd, ER_SYNTAX_ERROR);
  thd->parse_error(s, 0);
}




#define bincmp_collation(X,Y)           \
  do                                    \
  {                                     \
     if (unlikely(Lex->set_bincmp(X,Y))) \
       MYSQL_YYABORT;                   \
  } while(0)


#line 229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "sql_yacc_ora.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ABORT_SYM = 3,                  /* ABORT_SYM  */
  YYSYMBOL_ACCESSIBLE_SYM = 4,             /* ACCESSIBLE_SYM  */
  YYSYMBOL_ADD = 5,                        /* ADD  */
  YYSYMBOL_ALL = 6,                        /* ALL  */
  YYSYMBOL_ALTER = 7,                      /* ALTER  */
  YYSYMBOL_ANALYZE_SYM = 8,                /* ANALYZE_SYM  */
  YYSYMBOL_AND_AND_SYM = 9,                /* AND_AND_SYM  */
  YYSYMBOL_AND_SYM = 10,                   /* AND_SYM  */
  YYSYMBOL_AS = 11,                        /* AS  */
  YYSYMBOL_ASC = 12,                       /* ASC  */
  YYSYMBOL_ASENSITIVE_SYM = 13,            /* ASENSITIVE_SYM  */
  YYSYMBOL_BEFORE_SYM = 14,                /* BEFORE_SYM  */
  YYSYMBOL_BETWEEN_SYM = 15,               /* BETWEEN_SYM  */
  YYSYMBOL_BIGINT = 16,                    /* BIGINT  */
  YYSYMBOL_BINARY = 17,                    /* BINARY  */
  YYSYMBOL_BIN_NUM = 18,                   /* BIN_NUM  */
  YYSYMBOL_BIT_AND = 19,                   /* BIT_AND  */
  YYSYMBOL_BIT_OR = 20,                    /* BIT_OR  */
  YYSYMBOL_BIT_XOR = 21,                   /* BIT_XOR  */
  YYSYMBOL_BLOB_MARIADB_SYM = 22,          /* BLOB_MARIADB_SYM  */
  YYSYMBOL_BLOB_ORACLE_SYM = 23,           /* BLOB_ORACLE_SYM  */
  YYSYMBOL_BODY_ORACLE_SYM = 24,           /* BODY_ORACLE_SYM  */
  YYSYMBOL_BOTH = 25,                      /* BOTH  */
  YYSYMBOL_BY = 26,                        /* BY  */
  YYSYMBOL_CALL_SYM = 27,                  /* CALL_SYM  */
  YYSYMBOL_CASCADE = 28,                   /* CASCADE  */
  YYSYMBOL_CASE_SYM = 29,                  /* CASE_SYM  */
  YYSYMBOL_CAST_SYM = 30,                  /* CAST_SYM  */
  YYSYMBOL_CHANGE = 31,                    /* CHANGE  */
  YYSYMBOL_CHAR_SYM = 32,                  /* CHAR_SYM  */
  YYSYMBOL_CHECK_SYM = 33,                 /* CHECK_SYM  */
  YYSYMBOL_COLLATE_SYM = 34,               /* COLLATE_SYM  */
  YYSYMBOL_CONDITION_SYM = 35,             /* CONDITION_SYM  */
  YYSYMBOL_CONSTRAINT = 36,                /* CONSTRAINT  */
  YYSYMBOL_CONTINUE_MARIADB_SYM = 37,      /* CONTINUE_MARIADB_SYM  */
  YYSYMBOL_CONTINUE_ORACLE_SYM = 38,       /* CONTINUE_ORACLE_SYM  */
  YYSYMBOL_CONVERT_SYM = 39,               /* CONVERT_SYM  */
  YYSYMBOL_COUNT_SYM = 40,                 /* COUNT_SYM  */
  YYSYMBOL_CREATE = 41,                    /* CREATE  */
  YYSYMBOL_CROSS = 42,                     /* CROSS  */
  YYSYMBOL_CUME_DIST_SYM = 43,             /* CUME_DIST_SYM  */
  YYSYMBOL_CURDATE = 44,                   /* CURDATE  */
  YYSYMBOL_CURRENT_USER = 45,              /* CURRENT_USER  */
  YYSYMBOL_CURRENT_ROLE = 46,              /* CURRENT_ROLE  */
  YYSYMBOL_CURSOR_SYM = 47,                /* CURSOR_SYM  */
  YYSYMBOL_CURTIME = 48,                   /* CURTIME  */
  YYSYMBOL_DATABASE = 49,                  /* DATABASE  */
  YYSYMBOL_DATABASES = 50,                 /* DATABASES  */
  YYSYMBOL_DATE_ADD_INTERVAL = 51,         /* DATE_ADD_INTERVAL  */
  YYSYMBOL_DATE_SUB_INTERVAL = 52,         /* DATE_SUB_INTERVAL  */
  YYSYMBOL_DAY_HOUR_SYM = 53,              /* DAY_HOUR_SYM  */
  YYSYMBOL_DAY_MICROSECOND_SYM = 54,       /* DAY_MICROSECOND_SYM  */
  YYSYMBOL_DAY_MINUTE_SYM = 55,            /* DAY_MINUTE_SYM  */
  YYSYMBOL_DAY_SECOND_SYM = 56,            /* DAY_SECOND_SYM  */
  YYSYMBOL_DECIMAL_NUM = 57,               /* DECIMAL_NUM  */
  YYSYMBOL_DECIMAL_SYM = 58,               /* DECIMAL_SYM  */
  YYSYMBOL_DECLARE_MARIADB_SYM = 59,       /* DECLARE_MARIADB_SYM  */
  YYSYMBOL_DECLARE_ORACLE_SYM = 60,        /* DECLARE_ORACLE_SYM  */
  YYSYMBOL_DEFAULT = 61,                   /* DEFAULT  */
  YYSYMBOL_DELETE_DOMAIN_ID_SYM = 62,      /* DELETE_DOMAIN_ID_SYM  */
  YYSYMBOL_DELETE_SYM = 63,                /* DELETE_SYM  */
  YYSYMBOL_DENSE_RANK_SYM = 64,            /* DENSE_RANK_SYM  */
  YYSYMBOL_DESC = 65,                      /* DESC  */
  YYSYMBOL_DESCRIBE = 66,                  /* DESCRIBE  */
  YYSYMBOL_DETERMINISTIC_SYM = 67,         /* DETERMINISTIC_SYM  */
  YYSYMBOL_DISTINCT = 68,                  /* DISTINCT  */
  YYSYMBOL_DIV_SYM = 69,                   /* DIV_SYM  */
  YYSYMBOL_DOUBLE_SYM = 70,                /* DOUBLE_SYM  */
  YYSYMBOL_DO_DOMAIN_IDS_SYM = 71,         /* DO_DOMAIN_IDS_SYM  */
  YYSYMBOL_DOT_DOT_SYM = 72,               /* DOT_DOT_SYM  */
  YYSYMBOL_DROP = 73,                      /* DROP  */
  YYSYMBOL_DUAL_SYM = 74,                  /* DUAL_SYM  */
  YYSYMBOL_EACH_SYM = 75,                  /* EACH_SYM  */
  YYSYMBOL_ELSE = 76,                      /* ELSE  */
  YYSYMBOL_ELSEIF_MARIADB_SYM = 77,        /* ELSEIF_MARIADB_SYM  */
  YYSYMBOL_ELSIF_ORACLE_SYM = 78,          /* ELSIF_ORACLE_SYM  */
  YYSYMBOL_ENCLOSED = 79,                  /* ENCLOSED  */
  YYSYMBOL_END_OF_INPUT = 80,              /* END_OF_INPUT  */
  YYSYMBOL_EQUAL_SYM = 81,                 /* EQUAL_SYM  */
  YYSYMBOL_ESCAPED = 82,                   /* ESCAPED  */
  YYSYMBOL_EXCEPT_SYM = 83,                /* EXCEPT_SYM  */
  YYSYMBOL_EXISTS = 84,                    /* EXISTS  */
  YYSYMBOL_EXTRACT_SYM = 85,               /* EXTRACT_SYM  */
  YYSYMBOL_FALSE_SYM = 86,                 /* FALSE_SYM  */
  YYSYMBOL_FETCH_SYM = 87,                 /* FETCH_SYM  */
  YYSYMBOL_FIRST_VALUE_SYM = 88,           /* FIRST_VALUE_SYM  */
  YYSYMBOL_FLOAT_NUM = 89,                 /* FLOAT_NUM  */
  YYSYMBOL_FLOAT_SYM = 90,                 /* FLOAT_SYM  */
  YYSYMBOL_FORCE_LOOKAHEAD = 91,           /* FORCE_LOOKAHEAD  */
  YYSYMBOL_FOREIGN = 92,                   /* FOREIGN  */
  YYSYMBOL_FOR_SYM = 93,                   /* FOR_SYM  */
  YYSYMBOL_FOR_SYSTEM_TIME_SYM = 94,       /* FOR_SYSTEM_TIME_SYM  */
  YYSYMBOL_FROM = 95,                      /* FROM  */
  YYSYMBOL_FULLTEXT_SYM = 96,              /* FULLTEXT_SYM  */
  YYSYMBOL_GE = 97,                        /* GE  */
  YYSYMBOL_GOTO_ORACLE_SYM = 98,           /* GOTO_ORACLE_SYM  */
  YYSYMBOL_GRANT = 99,                     /* GRANT  */
  YYSYMBOL_GROUP_SYM = 100,                /* GROUP_SYM  */
  YYSYMBOL_GROUP_CONCAT_SYM = 101,         /* GROUP_CONCAT_SYM  */
  YYSYMBOL_LAG_SYM = 102,                  /* LAG_SYM  */
  YYSYMBOL_LEAD_SYM = 103,                 /* LEAD_SYM  */
  YYSYMBOL_HAVING = 104,                   /* HAVING  */
  YYSYMBOL_HEX_NUM = 105,                  /* HEX_NUM  */
  YYSYMBOL_HEX_STRING = 106,               /* HEX_STRING  */
  YYSYMBOL_HOUR_MICROSECOND_SYM = 107,     /* HOUR_MICROSECOND_SYM  */
  YYSYMBOL_HOUR_MINUTE_SYM = 108,          /* HOUR_MINUTE_SYM  */
  YYSYMBOL_HOUR_SECOND_SYM = 109,          /* HOUR_SECOND_SYM  */
  YYSYMBOL_IDENT = 110,                    /* IDENT  */
  YYSYMBOL_IDENT_QUOTED = 111,             /* IDENT_QUOTED  */
  YYSYMBOL_IF_SYM = 112,                   /* IF_SYM  */
  YYSYMBOL_IGNORE_DOMAIN_IDS_SYM = 113,    /* IGNORE_DOMAIN_IDS_SYM  */
  YYSYMBOL_IGNORE_SYM = 114,               /* IGNORE_SYM  */
  YYSYMBOL_INDEX_SYM = 115,                /* INDEX_SYM  */
  YYSYMBOL_INFILE = 116,                   /* INFILE  */
  YYSYMBOL_INNER_SYM = 117,                /* INNER_SYM  */
  YYSYMBOL_INOUT_SYM = 118,                /* INOUT_SYM  */
  YYSYMBOL_INSENSITIVE_SYM = 119,          /* INSENSITIVE_SYM  */
  YYSYMBOL_INSERT = 120,                   /* INSERT  */
  YYSYMBOL_INTERSECT_SYM = 121,            /* INTERSECT_SYM  */
  YYSYMBOL_INTERVAL_SYM = 122,             /* INTERVAL_SYM  */
  YYSYMBOL_INTO = 123,                     /* INTO  */
  YYSYMBOL_INT_SYM = 124,                  /* INT_SYM  */
  YYSYMBOL_IN_SYM = 125,                   /* IN_SYM  */
  YYSYMBOL_IS = 126,                       /* IS  */
  YYSYMBOL_ITERATE_SYM = 127,              /* ITERATE_SYM  */
  YYSYMBOL_JOIN_SYM = 128,                 /* JOIN_SYM  */
  YYSYMBOL_KEYS = 129,                     /* KEYS  */
  YYSYMBOL_KEY_SYM = 130,                  /* KEY_SYM  */
  YYSYMBOL_KILL_SYM = 131,                 /* KILL_SYM  */
  YYSYMBOL_LE = 132,                       /* LE  */
  YYSYMBOL_LEADING = 133,                  /* LEADING  */
  YYSYMBOL_LEAVE_SYM = 134,                /* LEAVE_SYM  */
  YYSYMBOL_LEFT = 135,                     /* LEFT  */
  YYSYMBOL_LEFT_PAREN_ALT = 136,           /* LEFT_PAREN_ALT  */
  YYSYMBOL_LEFT_PAREN_WITH = 137,          /* LEFT_PAREN_WITH  */
  YYSYMBOL_LEFT_PAREN_LIKE = 138,          /* LEFT_PAREN_LIKE  */
  YYSYMBOL_LEX_HOSTNAME = 139,             /* LEX_HOSTNAME  */
  YYSYMBOL_LIKE = 140,                     /* LIKE  */
  YYSYMBOL_LIMIT = 141,                    /* LIMIT  */
  YYSYMBOL_LINEAR_SYM = 142,               /* LINEAR_SYM  */
  YYSYMBOL_LINES = 143,                    /* LINES  */
  YYSYMBOL_LOAD = 144,                     /* LOAD  */
  YYSYMBOL_LOCATOR_SYM = 145,              /* LOCATOR_SYM  */
  YYSYMBOL_LOCK_SYM = 146,                 /* LOCK_SYM  */
  YYSYMBOL_LONGBLOB = 147,                 /* LONGBLOB  */
  YYSYMBOL_LONGTEXT = 148,                 /* LONGTEXT  */
  YYSYMBOL_LONG_NUM = 149,                 /* LONG_NUM  */
  YYSYMBOL_LONG_SYM = 150,                 /* LONG_SYM  */
  YYSYMBOL_LOOP_SYM = 151,                 /* LOOP_SYM  */
  YYSYMBOL_LOW_PRIORITY = 152,             /* LOW_PRIORITY  */
  YYSYMBOL_MASTER_SSL_VERIFY_SERVER_CERT_SYM = 153, /* MASTER_SSL_VERIFY_SERVER_CERT_SYM  */
  YYSYMBOL_MATCH = 154,                    /* MATCH  */
  YYSYMBOL_MAX_SYM = 155,                  /* MAX_SYM  */
  YYSYMBOL_MAXVALUE_SYM = 156,             /* MAXVALUE_SYM  */
  YYSYMBOL_MEDIAN_SYM = 157,               /* MEDIAN_SYM  */
  YYSYMBOL_MEDIUMBLOB = 158,               /* MEDIUMBLOB  */
  YYSYMBOL_MEDIUMINT = 159,                /* MEDIUMINT  */
  YYSYMBOL_MEDIUMTEXT = 160,               /* MEDIUMTEXT  */
  YYSYMBOL_MINUTE_MICROSECOND_SYM = 161,   /* MINUTE_MICROSECOND_SYM  */
  YYSYMBOL_MINUTE_SECOND_SYM = 162,        /* MINUTE_SECOND_SYM  */
  YYSYMBOL_MIN_SYM = 163,                  /* MIN_SYM  */
  YYSYMBOL_MODIFIES_SYM = 164,             /* MODIFIES_SYM  */
  YYSYMBOL_MOD_SYM = 165,                  /* MOD_SYM  */
  YYSYMBOL_MYSQL_CONCAT_SYM = 166,         /* MYSQL_CONCAT_SYM  */
  YYSYMBOL_NATURAL = 167,                  /* NATURAL  */
  YYSYMBOL_NCHAR_STRING = 168,             /* NCHAR_STRING  */
  YYSYMBOL_NE = 169,                       /* NE  */
  YYSYMBOL_NEG = 170,                      /* NEG  */
  YYSYMBOL_NOT2_SYM = 171,                 /* NOT2_SYM  */
  YYSYMBOL_NOT_SYM = 172,                  /* NOT_SYM  */
  YYSYMBOL_NOW_SYM = 173,                  /* NOW_SYM  */
  YYSYMBOL_NO_WRITE_TO_BINLOG = 174,       /* NO_WRITE_TO_BINLOG  */
  YYSYMBOL_NTILE_SYM = 175,                /* NTILE_SYM  */
  YYSYMBOL_NULL_SYM = 176,                 /* NULL_SYM  */
  YYSYMBOL_NUM = 177,                      /* NUM  */
  YYSYMBOL_NUMERIC_SYM = 178,              /* NUMERIC_SYM  */
  YYSYMBOL_NTH_VALUE_SYM = 179,            /* NTH_VALUE_SYM  */
  YYSYMBOL_ON = 180,                       /* ON  */
  YYSYMBOL_OPTIMIZE = 181,                 /* OPTIMIZE  */
  YYSYMBOL_OPTIONALLY = 182,               /* OPTIONALLY  */
  YYSYMBOL_ORACLE_CONCAT_SYM = 183,        /* ORACLE_CONCAT_SYM  */
  YYSYMBOL_OR2_SYM = 184,                  /* OR2_SYM  */
  YYSYMBOL_ORDER_SYM = 185,                /* ORDER_SYM  */
  YYSYMBOL_OR_SYM = 186,                   /* OR_SYM  */
  YYSYMBOL_OTHERS_ORACLE_SYM = 187,        /* OTHERS_ORACLE_SYM  */
  YYSYMBOL_OUTER = 188,                    /* OUTER  */
  YYSYMBOL_OUTFILE = 189,                  /* OUTFILE  */
  YYSYMBOL_OUT_SYM = 190,                  /* OUT_SYM  */
  YYSYMBOL_OVER_SYM = 191,                 /* OVER_SYM  */
  YYSYMBOL_PACKAGE_ORACLE_SYM = 192,       /* PACKAGE_ORACLE_SYM  */
  YYSYMBOL_PAGE_CHECKSUM_SYM = 193,        /* PAGE_CHECKSUM_SYM  */
  YYSYMBOL_PARAM_MARKER = 194,             /* PARAM_MARKER  */
  YYSYMBOL_PARSE_VCOL_EXPR_SYM = 195,      /* PARSE_VCOL_EXPR_SYM  */
  YYSYMBOL_PARTITION_SYM = 196,            /* PARTITION_SYM  */
  YYSYMBOL_PERCENT_ORACLE_SYM = 197,       /* PERCENT_ORACLE_SYM  */
  YYSYMBOL_PERCENT_RANK_SYM = 198,         /* PERCENT_RANK_SYM  */
  YYSYMBOL_PERCENTILE_CONT_SYM = 199,      /* PERCENTILE_CONT_SYM  */
  YYSYMBOL_PERCENTILE_DISC_SYM = 200,      /* PERCENTILE_DISC_SYM  */
  YYSYMBOL_PORTION_SYM = 201,              /* PORTION_SYM  */
  YYSYMBOL_POSITION_SYM = 202,             /* POSITION_SYM  */
  YYSYMBOL_PRECISION = 203,                /* PRECISION  */
  YYSYMBOL_PRIMARY_SYM = 204,              /* PRIMARY_SYM  */
  YYSYMBOL_PROCEDURE_SYM = 205,            /* PROCEDURE_SYM  */
  YYSYMBOL_PURGE = 206,                    /* PURGE  */
  YYSYMBOL_RAISE_ORACLE_SYM = 207,         /* RAISE_ORACLE_SYM  */
  YYSYMBOL_RANGE_SYM = 208,                /* RANGE_SYM  */
  YYSYMBOL_RANK_SYM = 209,                 /* RANK_SYM  */
  YYSYMBOL_READS_SYM = 210,                /* READS_SYM  */
  YYSYMBOL_READ_SYM = 211,                 /* READ_SYM  */
  YYSYMBOL_READ_WRITE_SYM = 212,           /* READ_WRITE_SYM  */
  YYSYMBOL_REAL = 213,                     /* REAL  */
  YYSYMBOL_RECURSIVE_SYM = 214,            /* RECURSIVE_SYM  */
  YYSYMBOL_REF_SYSTEM_ID_SYM = 215,        /* REF_SYSTEM_ID_SYM  */
  YYSYMBOL_REFERENCES = 216,               /* REFERENCES  */
  YYSYMBOL_REGEXP = 217,                   /* REGEXP  */
  YYSYMBOL_RELEASE_SYM = 218,              /* RELEASE_SYM  */
  YYSYMBOL_RENAME = 219,                   /* RENAME  */
  YYSYMBOL_REPEAT_SYM = 220,               /* REPEAT_SYM  */
  YYSYMBOL_REQUIRE_SYM = 221,              /* REQUIRE_SYM  */
  YYSYMBOL_RESIGNAL_SYM = 222,             /* RESIGNAL_SYM  */
  YYSYMBOL_RESTRICT = 223,                 /* RESTRICT  */
  YYSYMBOL_RETURNING_SYM = 224,            /* RETURNING_SYM  */
  YYSYMBOL_RETURN_MARIADB_SYM = 225,       /* RETURN_MARIADB_SYM  */
  YYSYMBOL_RETURN_ORACLE_SYM = 226,        /* RETURN_ORACLE_SYM  */
  YYSYMBOL_REVOKE = 227,                   /* REVOKE  */
  YYSYMBOL_RIGHT = 228,                    /* RIGHT  */
  YYSYMBOL_ROWS_SYM = 229,                 /* ROWS_SYM  */
  YYSYMBOL_ROWTYPE_ORACLE_SYM = 230,       /* ROWTYPE_ORACLE_SYM  */
  YYSYMBOL_ROW_NUMBER_SYM = 231,           /* ROW_NUMBER_SYM  */
  YYSYMBOL_SECOND_MICROSECOND_SYM = 232,   /* SECOND_MICROSECOND_SYM  */
  YYSYMBOL_SELECT_SYM = 233,               /* SELECT_SYM  */
  YYSYMBOL_SENSITIVE_SYM = 234,            /* SENSITIVE_SYM  */
  YYSYMBOL_SEPARATOR_SYM = 235,            /* SEPARATOR_SYM  */
  YYSYMBOL_SERVER_OPTIONS = 236,           /* SERVER_OPTIONS  */
  YYSYMBOL_SET = 237,                      /* SET  */
  YYSYMBOL_SET_VAR = 238,                  /* SET_VAR  */
  YYSYMBOL_SHIFT_LEFT = 239,               /* SHIFT_LEFT  */
  YYSYMBOL_SHIFT_RIGHT = 240,              /* SHIFT_RIGHT  */
  YYSYMBOL_SHOW = 241,                     /* SHOW  */
  YYSYMBOL_SIGNAL_SYM = 242,               /* SIGNAL_SYM  */
  YYSYMBOL_SMALLINT = 243,                 /* SMALLINT  */
  YYSYMBOL_SPATIAL_SYM = 244,              /* SPATIAL_SYM  */
  YYSYMBOL_SPECIFIC_SYM = 245,             /* SPECIFIC_SYM  */
  YYSYMBOL_SQLEXCEPTION_SYM = 246,         /* SQLEXCEPTION_SYM  */
  YYSYMBOL_SQLSTATE_SYM = 247,             /* SQLSTATE_SYM  */
  YYSYMBOL_SQLWARNING_SYM = 248,           /* SQLWARNING_SYM  */
  YYSYMBOL_SQL_BIG_RESULT = 249,           /* SQL_BIG_RESULT  */
  YYSYMBOL_SQL_SMALL_RESULT = 250,         /* SQL_SMALL_RESULT  */
  YYSYMBOL_SQL_SYM = 251,                  /* SQL_SYM  */
  YYSYMBOL_SSL_SYM = 252,                  /* SSL_SYM  */
  YYSYMBOL_STARTING = 253,                 /* STARTING  */
  YYSYMBOL_STATS_AUTO_RECALC_SYM = 254,    /* STATS_AUTO_RECALC_SYM  */
  YYSYMBOL_STATS_PERSISTENT_SYM = 255,     /* STATS_PERSISTENT_SYM  */
  YYSYMBOL_STATS_SAMPLE_PAGES_SYM = 256,   /* STATS_SAMPLE_PAGES_SYM  */
  YYSYMBOL_STDDEV_SAMP_SYM = 257,          /* STDDEV_SAMP_SYM  */
  YYSYMBOL_STD_SYM = 258,                  /* STD_SYM  */
  YYSYMBOL_STRAIGHT_JOIN = 259,            /* STRAIGHT_JOIN  */
  YYSYMBOL_SUM_SYM = 260,                  /* SUM_SYM  */
  YYSYMBOL_SYSDATE = 261,                  /* SYSDATE  */
  YYSYMBOL_TABLE_REF_PRIORITY = 262,       /* TABLE_REF_PRIORITY  */
  YYSYMBOL_TABLE_SYM = 263,                /* TABLE_SYM  */
  YYSYMBOL_TERMINATED = 264,               /* TERMINATED  */
  YYSYMBOL_TEXT_STRING = 265,              /* TEXT_STRING  */
  YYSYMBOL_THEN_SYM = 266,                 /* THEN_SYM  */
  YYSYMBOL_TINYBLOB = 267,                 /* TINYBLOB  */
  YYSYMBOL_TINYINT = 268,                  /* TINYINT  */
  YYSYMBOL_TINYTEXT = 269,                 /* TINYTEXT  */
  YYSYMBOL_TO_SYM = 270,                   /* TO_SYM  */
  YYSYMBOL_TRAILING = 271,                 /* TRAILING  */
  YYSYMBOL_TRIGGER_SYM = 272,              /* TRIGGER_SYM  */
  YYSYMBOL_TRUE_SYM = 273,                 /* TRUE_SYM  */
  YYSYMBOL_ULONGLONG_NUM = 274,            /* ULONGLONG_NUM  */
  YYSYMBOL_UNDERSCORE_CHARSET = 275,       /* UNDERSCORE_CHARSET  */
  YYSYMBOL_UNDO_SYM = 276,                 /* UNDO_SYM  */
  YYSYMBOL_UNION_SYM = 277,                /* UNION_SYM  */
  YYSYMBOL_UNIQUE_SYM = 278,               /* UNIQUE_SYM  */
  YYSYMBOL_UNLOCK_SYM = 279,               /* UNLOCK_SYM  */
  YYSYMBOL_UNSIGNED = 280,                 /* UNSIGNED  */
  YYSYMBOL_UPDATE_SYM = 281,               /* UPDATE_SYM  */
  YYSYMBOL_USAGE = 282,                    /* USAGE  */
  YYSYMBOL_USE_SYM = 283,                  /* USE_SYM  */
  YYSYMBOL_USING = 284,                    /* USING  */
  YYSYMBOL_UTC_DATE_SYM = 285,             /* UTC_DATE_SYM  */
  YYSYMBOL_UTC_TIMESTAMP_SYM = 286,        /* UTC_TIMESTAMP_SYM  */
  YYSYMBOL_UTC_TIME_SYM = 287,             /* UTC_TIME_SYM  */
  YYSYMBOL_VALUES = 288,                   /* VALUES  */
  YYSYMBOL_VALUES_IN_SYM = 289,            /* VALUES_IN_SYM  */
  YYSYMBOL_VALUES_LESS_SYM = 290,          /* VALUES_LESS_SYM  */
  YYSYMBOL_VARBINARY = 291,                /* VARBINARY  */
  YYSYMBOL_VARCHAR = 292,                  /* VARCHAR  */
  YYSYMBOL_VARIANCE_SYM = 293,             /* VARIANCE_SYM  */
  YYSYMBOL_VARYING = 294,                  /* VARYING  */
  YYSYMBOL_VAR_SAMP_SYM = 295,             /* VAR_SAMP_SYM  */
  YYSYMBOL_WHEN_SYM = 296,                 /* WHEN_SYM  */
  YYSYMBOL_WHERE = 297,                    /* WHERE  */
  YYSYMBOL_WHILE_SYM = 298,                /* WHILE_SYM  */
  YYSYMBOL_WITH = 299,                     /* WITH  */
  YYSYMBOL_WITH_CUBE_SYM = 300,            /* WITH_CUBE_SYM  */
  YYSYMBOL_WITH_ROLLUP_SYM = 301,          /* WITH_ROLLUP_SYM  */
  YYSYMBOL_WITH_SYSTEM_SYM = 302,          /* WITH_SYSTEM_SYM  */
  YYSYMBOL_XOR = 303,                      /* XOR  */
  YYSYMBOL_YEAR_MONTH_SYM = 304,           /* YEAR_MONTH_SYM  */
  YYSYMBOL_ZEROFILL = 305,                 /* ZEROFILL  */
  YYSYMBOL_IMPOSSIBLE_ACTION = 306,        /* IMPOSSIBLE_ACTION  */
  YYSYMBOL_BODY_MARIADB_SYM = 307,         /* BODY_MARIADB_SYM  */
  YYSYMBOL_ELSEIF_ORACLE_SYM = 308,        /* ELSEIF_ORACLE_SYM  */
  YYSYMBOL_ELSIF_MARIADB_SYM = 309,        /* ELSIF_MARIADB_SYM  */
  YYSYMBOL_EXCEPTION_ORACLE_SYM = 310,     /* EXCEPTION_ORACLE_SYM  */
  YYSYMBOL_GOTO_MARIADB_SYM = 311,         /* GOTO_MARIADB_SYM  */
  YYSYMBOL_OTHERS_MARIADB_SYM = 312,       /* OTHERS_MARIADB_SYM  */
  YYSYMBOL_PACKAGE_MARIADB_SYM = 313,      /* PACKAGE_MARIADB_SYM  */
  YYSYMBOL_RAISE_MARIADB_SYM = 314,        /* RAISE_MARIADB_SYM  */
  YYSYMBOL_ROWTYPE_MARIADB_SYM = 315,      /* ROWTYPE_MARIADB_SYM  */
  YYSYMBOL_REPLACE = 316,                  /* REPLACE  */
  YYSYMBOL_SUBSTRING = 317,                /* SUBSTRING  */
  YYSYMBOL_TRIM = 318,                     /* TRIM  */
  YYSYMBOL_ACCOUNT_SYM = 319,              /* ACCOUNT_SYM  */
  YYSYMBOL_ACTION = 320,                   /* ACTION  */
  YYSYMBOL_ADMIN_SYM = 321,                /* ADMIN_SYM  */
  YYSYMBOL_ADDDATE_SYM = 322,              /* ADDDATE_SYM  */
  YYSYMBOL_AFTER_SYM = 323,                /* AFTER_SYM  */
  YYSYMBOL_AGAINST = 324,                  /* AGAINST  */
  YYSYMBOL_AGGREGATE_SYM = 325,            /* AGGREGATE_SYM  */
  YYSYMBOL_ALGORITHM_SYM = 326,            /* ALGORITHM_SYM  */
  YYSYMBOL_ALWAYS_SYM = 327,               /* ALWAYS_SYM  */
  YYSYMBOL_ANY_SYM = 328,                  /* ANY_SYM  */
  YYSYMBOL_ASCII_SYM = 329,                /* ASCII_SYM  */
  YYSYMBOL_AT_SYM = 330,                   /* AT_SYM  */
  YYSYMBOL_ATOMIC_SYM = 331,               /* ATOMIC_SYM  */
  YYSYMBOL_AUTHORS_SYM = 332,              /* AUTHORS_SYM  */
  YYSYMBOL_AUTOEXTEND_SIZE_SYM = 333,      /* AUTOEXTEND_SIZE_SYM  */
  YYSYMBOL_AUTO_INC = 334,                 /* AUTO_INC  */
  YYSYMBOL_AUTO_SYM = 335,                 /* AUTO_SYM  */
  YYSYMBOL_AVG_ROW_LENGTH = 336,           /* AVG_ROW_LENGTH  */
  YYSYMBOL_AVG_SYM = 337,                  /* AVG_SYM  */
  YYSYMBOL_BACKUP_SYM = 338,               /* BACKUP_SYM  */
  YYSYMBOL_BEGIN_MARIADB_SYM = 339,        /* BEGIN_MARIADB_SYM  */
  YYSYMBOL_BEGIN_ORACLE_SYM = 340,         /* BEGIN_ORACLE_SYM  */
  YYSYMBOL_BINLOG_SYM = 341,               /* BINLOG_SYM  */
  YYSYMBOL_BIT_SYM = 342,                  /* BIT_SYM  */
  YYSYMBOL_BLOCK_SYM = 343,                /* BLOCK_SYM  */
  YYSYMBOL_BOOL_SYM = 344,                 /* BOOL_SYM  */
  YYSYMBOL_BOOLEAN_SYM = 345,              /* BOOLEAN_SYM  */
  YYSYMBOL_BTREE_SYM = 346,                /* BTREE_SYM  */
  YYSYMBOL_BYTE_SYM = 347,                 /* BYTE_SYM  */
  YYSYMBOL_CACHE_SYM = 348,                /* CACHE_SYM  */
  YYSYMBOL_CASCADED = 349,                 /* CASCADED  */
  YYSYMBOL_CATALOG_NAME_SYM = 350,         /* CATALOG_NAME_SYM  */
  YYSYMBOL_CHAIN_SYM = 351,                /* CHAIN_SYM  */
  YYSYMBOL_CHANGED = 352,                  /* CHANGED  */
  YYSYMBOL_CHARSET = 353,                  /* CHARSET  */
  YYSYMBOL_CHECKPOINT_SYM = 354,           /* CHECKPOINT_SYM  */
  YYSYMBOL_CHECKSUM_SYM = 355,             /* CHECKSUM_SYM  */
  YYSYMBOL_CIPHER_SYM = 356,               /* CIPHER_SYM  */
  YYSYMBOL_CLASS_ORIGIN_SYM = 357,         /* CLASS_ORIGIN_SYM  */
  YYSYMBOL_CLIENT_SYM = 358,               /* CLIENT_SYM  */
  YYSYMBOL_CLOB_MARIADB_SYM = 359,         /* CLOB_MARIADB_SYM  */
  YYSYMBOL_CLOB_ORACLE_SYM = 360,          /* CLOB_ORACLE_SYM  */
  YYSYMBOL_CLOSE_SYM = 361,                /* CLOSE_SYM  */
  YYSYMBOL_COALESCE = 362,                 /* COALESCE  */
  YYSYMBOL_CODE_SYM = 363,                 /* CODE_SYM  */
  YYSYMBOL_COLLATION_SYM = 364,            /* COLLATION_SYM  */
  YYSYMBOL_COLON_ORACLE_SYM = 365,         /* COLON_ORACLE_SYM  */
  YYSYMBOL_COLUMNS = 366,                  /* COLUMNS  */
  YYSYMBOL_COLUMN_ADD_SYM = 367,           /* COLUMN_ADD_SYM  */
  YYSYMBOL_COLUMN_CHECK_SYM = 368,         /* COLUMN_CHECK_SYM  */
  YYSYMBOL_COLUMN_CREATE_SYM = 369,        /* COLUMN_CREATE_SYM  */
  YYSYMBOL_COLUMN_DELETE_SYM = 370,        /* COLUMN_DELETE_SYM  */
  YYSYMBOL_COLUMN_GET_SYM = 371,           /* COLUMN_GET_SYM  */
  YYSYMBOL_COLUMN_SYM = 372,               /* COLUMN_SYM  */
  YYSYMBOL_COLUMN_NAME_SYM = 373,          /* COLUMN_NAME_SYM  */
  YYSYMBOL_COMMENT_SYM = 374,              /* COMMENT_SYM  */
  YYSYMBOL_COMMITTED_SYM = 375,            /* COMMITTED_SYM  */
  YYSYMBOL_COMMIT_SYM = 376,               /* COMMIT_SYM  */
  YYSYMBOL_COMPACT_SYM = 377,              /* COMPACT_SYM  */
  YYSYMBOL_COMPLETION_SYM = 378,           /* COMPLETION_SYM  */
  YYSYMBOL_COMPRESSED_SYM = 379,           /* COMPRESSED_SYM  */
  YYSYMBOL_CONCURRENT = 380,               /* CONCURRENT  */
  YYSYMBOL_CONNECTION_SYM = 381,           /* CONNECTION_SYM  */
  YYSYMBOL_CONSISTENT_SYM = 382,           /* CONSISTENT_SYM  */
  YYSYMBOL_CONSTRAINT_CATALOG_SYM = 383,   /* CONSTRAINT_CATALOG_SYM  */
  YYSYMBOL_CONSTRAINT_NAME_SYM = 384,      /* CONSTRAINT_NAME_SYM  */
  YYSYMBOL_CONSTRAINT_SCHEMA_SYM = 385,    /* CONSTRAINT_SCHEMA_SYM  */
  YYSYMBOL_CONTAINS_SYM = 386,             /* CONTAINS_SYM  */
  YYSYMBOL_CONTEXT_SYM = 387,              /* CONTEXT_SYM  */
  YYSYMBOL_CONTRIBUTORS_SYM = 388,         /* CONTRIBUTORS_SYM  */
  YYSYMBOL_CPU_SYM = 389,                  /* CPU_SYM  */
  YYSYMBOL_CUBE_SYM = 390,                 /* CUBE_SYM  */
  YYSYMBOL_CURRENT_SYM = 391,              /* CURRENT_SYM  */
  YYSYMBOL_CURRENT_POS_SYM = 392,          /* CURRENT_POS_SYM  */
  YYSYMBOL_CURSOR_NAME_SYM = 393,          /* CURSOR_NAME_SYM  */
  YYSYMBOL_CYCLE_SYM = 394,                /* CYCLE_SYM  */
  YYSYMBOL_DATAFILE_SYM = 395,             /* DATAFILE_SYM  */
  YYSYMBOL_DATA_SYM = 396,                 /* DATA_SYM  */
  YYSYMBOL_DATETIME = 397,                 /* DATETIME  */
  YYSYMBOL_DATE_FORMAT_SYM = 398,          /* DATE_FORMAT_SYM  */
  YYSYMBOL_DATE_SYM = 399,                 /* DATE_SYM  */
  YYSYMBOL_DAY_SYM = 400,                  /* DAY_SYM  */
  YYSYMBOL_DEALLOCATE_SYM = 401,           /* DEALLOCATE_SYM  */
  YYSYMBOL_DECODE_MARIADB_SYM = 402,       /* DECODE_MARIADB_SYM  */
  YYSYMBOL_DECODE_ORACLE_SYM = 403,        /* DECODE_ORACLE_SYM  */
  YYSYMBOL_DEFINER_SYM = 404,              /* DEFINER_SYM  */
  YYSYMBOL_DELAYED_SYM = 405,              /* DELAYED_SYM  */
  YYSYMBOL_DELAY_KEY_WRITE_SYM = 406,      /* DELAY_KEY_WRITE_SYM  */
  YYSYMBOL_DES_KEY_FILE = 407,             /* DES_KEY_FILE  */
  YYSYMBOL_DIAGNOSTICS_SYM = 408,          /* DIAGNOSTICS_SYM  */
  YYSYMBOL_DIRECTORY_SYM = 409,            /* DIRECTORY_SYM  */
  YYSYMBOL_DISABLE_SYM = 410,              /* DISABLE_SYM  */
  YYSYMBOL_DISCARD = 411,                  /* DISCARD  */
  YYSYMBOL_DISK_SYM = 412,                 /* DISK_SYM  */
  YYSYMBOL_DO_SYM = 413,                   /* DO_SYM  */
  YYSYMBOL_DUMPFILE = 414,                 /* DUMPFILE  */
  YYSYMBOL_DUPLICATE_SYM = 415,            /* DUPLICATE_SYM  */
  YYSYMBOL_DYNAMIC_SYM = 416,              /* DYNAMIC_SYM  */
  YYSYMBOL_ENABLE_SYM = 417,               /* ENABLE_SYM  */
  YYSYMBOL_END = 418,                      /* END  */
  YYSYMBOL_ENDS_SYM = 419,                 /* ENDS_SYM  */
  YYSYMBOL_ENGINES_SYM = 420,              /* ENGINES_SYM  */
  YYSYMBOL_ENGINE_SYM = 421,               /* ENGINE_SYM  */
  YYSYMBOL_ENUM = 422,                     /* ENUM  */
  YYSYMBOL_ERROR_SYM = 423,                /* ERROR_SYM  */
  YYSYMBOL_ERRORS = 424,                   /* ERRORS  */
  YYSYMBOL_ESCAPE_SYM = 425,               /* ESCAPE_SYM  */
  YYSYMBOL_EVENTS_SYM = 426,               /* EVENTS_SYM  */
  YYSYMBOL_EVENT_SYM = 427,                /* EVENT_SYM  */
  YYSYMBOL_EVERY_SYM = 428,                /* EVERY_SYM  */
  YYSYMBOL_EXCHANGE_SYM = 429,             /* EXCHANGE_SYM  */
  YYSYMBOL_EXAMINED_SYM = 430,             /* EXAMINED_SYM  */
  YYSYMBOL_EXCLUDE_SYM = 431,              /* EXCLUDE_SYM  */
  YYSYMBOL_EXECUTE_SYM = 432,              /* EXECUTE_SYM  */
  YYSYMBOL_EXCEPTION_MARIADB_SYM = 433,    /* EXCEPTION_MARIADB_SYM  */
  YYSYMBOL_EXIT_MARIADB_SYM = 434,         /* EXIT_MARIADB_SYM  */
  YYSYMBOL_EXIT_ORACLE_SYM = 435,          /* EXIT_ORACLE_SYM  */
  YYSYMBOL_EXPANSION_SYM = 436,            /* EXPANSION_SYM  */
  YYSYMBOL_EXPIRE_SYM = 437,               /* EXPIRE_SYM  */
  YYSYMBOL_EXPORT_SYM = 438,               /* EXPORT_SYM  */
  YYSYMBOL_EXTENDED_SYM = 439,             /* EXTENDED_SYM  */
  YYSYMBOL_EXTENT_SIZE_SYM = 440,          /* EXTENT_SIZE_SYM  */
  YYSYMBOL_FAST_SYM = 441,                 /* FAST_SYM  */
  YYSYMBOL_FAULTS_SYM = 442,               /* FAULTS_SYM  */
  YYSYMBOL_FILE_SYM = 443,                 /* FILE_SYM  */
  YYSYMBOL_FIRST_SYM = 444,                /* FIRST_SYM  */
  YYSYMBOL_FIXED_SYM = 445,                /* FIXED_SYM  */
  YYSYMBOL_FLUSH_SYM = 446,                /* FLUSH_SYM  */
  YYSYMBOL_FOLLOWS_SYM = 447,              /* FOLLOWS_SYM  */
  YYSYMBOL_FOLLOWING_SYM = 448,            /* FOLLOWING_SYM  */
  YYSYMBOL_FORCE_SYM = 449,                /* FORCE_SYM  */
  YYSYMBOL_FORMAT_SYM = 450,               /* FORMAT_SYM  */
  YYSYMBOL_FOUND_SYM = 451,                /* FOUND_SYM  */
  YYSYMBOL_FULL = 452,                     /* FULL  */
  YYSYMBOL_FUNCTION_SYM = 453,             /* FUNCTION_SYM  */
  YYSYMBOL_GENERAL = 454,                  /* GENERAL  */
  YYSYMBOL_GENERATED_SYM = 455,            /* GENERATED_SYM  */
  YYSYMBOL_GEOMETRYCOLLECTION = 456,       /* GEOMETRYCOLLECTION  */
  YYSYMBOL_GEOMETRY_SYM = 457,             /* GEOMETRY_SYM  */
  YYSYMBOL_GET_FORMAT = 458,               /* GET_FORMAT  */
  YYSYMBOL_GET_SYM = 459,                  /* GET_SYM  */
  YYSYMBOL_GLOBAL_SYM = 460,               /* GLOBAL_SYM  */
  YYSYMBOL_GRANTS = 461,                   /* GRANTS  */
  YYSYMBOL_HANDLER_SYM = 462,              /* HANDLER_SYM  */
  YYSYMBOL_HARD_SYM = 463,                 /* HARD_SYM  */
  YYSYMBOL_HASH_SYM = 464,                 /* HASH_SYM  */
  YYSYMBOL_HELP_SYM = 465,                 /* HELP_SYM  */
  YYSYMBOL_HIGH_PRIORITY = 466,            /* HIGH_PRIORITY  */
  YYSYMBOL_HISTORY_SYM = 467,              /* HISTORY_SYM  */
  YYSYMBOL_HOST_SYM = 468,                 /* HOST_SYM  */
  YYSYMBOL_HOSTS_SYM = 469,                /* HOSTS_SYM  */
  YYSYMBOL_HOUR_SYM = 470,                 /* HOUR_SYM  */
  YYSYMBOL_ID_SYM = 471,                   /* ID_SYM  */
  YYSYMBOL_IDENTIFIED_SYM = 472,           /* IDENTIFIED_SYM  */
  YYSYMBOL_IGNORE_SERVER_IDS_SYM = 473,    /* IGNORE_SERVER_IDS_SYM  */
  YYSYMBOL_IMMEDIATE_SYM = 474,            /* IMMEDIATE_SYM  */
  YYSYMBOL_IMPORT = 475,                   /* IMPORT  */
  YYSYMBOL_INCREMENT_SYM = 476,            /* INCREMENT_SYM  */
  YYSYMBOL_INDEXES = 477,                  /* INDEXES  */
  YYSYMBOL_INITIAL_SIZE_SYM = 478,         /* INITIAL_SIZE_SYM  */
  YYSYMBOL_INSERT_METHOD = 479,            /* INSERT_METHOD  */
  YYSYMBOL_INSTALL_SYM = 480,              /* INSTALL_SYM  */
  YYSYMBOL_INVOKER_SYM = 481,              /* INVOKER_SYM  */
  YYSYMBOL_IO_SYM = 482,                   /* IO_SYM  */
  YYSYMBOL_IPC_SYM = 483,                  /* IPC_SYM  */
  YYSYMBOL_ISOLATION = 484,                /* ISOLATION  */
  YYSYMBOL_ISOPEN_SYM = 485,               /* ISOPEN_SYM  */
  YYSYMBOL_ISSUER_SYM = 486,               /* ISSUER_SYM  */
  YYSYMBOL_INVISIBLE_SYM = 487,            /* INVISIBLE_SYM  */
  YYSYMBOL_JSON_SYM = 488,                 /* JSON_SYM  */
  YYSYMBOL_KEY_BLOCK_SIZE = 489,           /* KEY_BLOCK_SIZE  */
  YYSYMBOL_LANGUAGE_SYM = 490,             /* LANGUAGE_SYM  */
  YYSYMBOL_LAST_SYM = 491,                 /* LAST_SYM  */
  YYSYMBOL_LAST_VALUE = 492,               /* LAST_VALUE  */
  YYSYMBOL_LASTVAL_SYM = 493,              /* LASTVAL_SYM  */
  YYSYMBOL_LEAVES = 494,                   /* LEAVES  */
  YYSYMBOL_LESS_SYM = 495,                 /* LESS_SYM  */
  YYSYMBOL_LEVEL_SYM = 496,                /* LEVEL_SYM  */
  YYSYMBOL_LINESTRING = 497,               /* LINESTRING  */
  YYSYMBOL_LIST_SYM = 498,                 /* LIST_SYM  */
  YYSYMBOL_LOCAL_SYM = 499,                /* LOCAL_SYM  */
  YYSYMBOL_LOCKS_SYM = 500,                /* LOCKS_SYM  */
  YYSYMBOL_LOGFILE_SYM = 501,              /* LOGFILE_SYM  */
  YYSYMBOL_LOGS_SYM = 502,                 /* LOGS_SYM  */
  YYSYMBOL_MASTER_CONNECT_RETRY_SYM = 503, /* MASTER_CONNECT_RETRY_SYM  */
  YYSYMBOL_MASTER_DELAY_SYM = 504,         /* MASTER_DELAY_SYM  */
  YYSYMBOL_MASTER_GTID_POS_SYM = 505,      /* MASTER_GTID_POS_SYM  */
  YYSYMBOL_MASTER_HOST_SYM = 506,          /* MASTER_HOST_SYM  */
  YYSYMBOL_MASTER_LOG_FILE_SYM = 507,      /* MASTER_LOG_FILE_SYM  */
  YYSYMBOL_MASTER_LOG_POS_SYM = 508,       /* MASTER_LOG_POS_SYM  */
  YYSYMBOL_MASTER_PASSWORD_SYM = 509,      /* MASTER_PASSWORD_SYM  */
  YYSYMBOL_MASTER_PORT_SYM = 510,          /* MASTER_PORT_SYM  */
  YYSYMBOL_MASTER_SERVER_ID_SYM = 511,     /* MASTER_SERVER_ID_SYM  */
  YYSYMBOL_MASTER_SSL_CAPATH_SYM = 512,    /* MASTER_SSL_CAPATH_SYM  */
  YYSYMBOL_MASTER_SSL_CA_SYM = 513,        /* MASTER_SSL_CA_SYM  */
  YYSYMBOL_MASTER_SSL_CERT_SYM = 514,      /* MASTER_SSL_CERT_SYM  */
  YYSYMBOL_MASTER_SSL_CIPHER_SYM = 515,    /* MASTER_SSL_CIPHER_SYM  */
  YYSYMBOL_MASTER_SSL_CRL_SYM = 516,       /* MASTER_SSL_CRL_SYM  */
  YYSYMBOL_MASTER_SSL_CRLPATH_SYM = 517,   /* MASTER_SSL_CRLPATH_SYM  */
  YYSYMBOL_MASTER_SSL_KEY_SYM = 518,       /* MASTER_SSL_KEY_SYM  */
  YYSYMBOL_MASTER_SSL_SYM = 519,           /* MASTER_SSL_SYM  */
  YYSYMBOL_MASTER_SYM = 520,               /* MASTER_SYM  */
  YYSYMBOL_MASTER_USER_SYM = 521,          /* MASTER_USER_SYM  */
  YYSYMBOL_MASTER_USE_GTID_SYM = 522,      /* MASTER_USE_GTID_SYM  */
  YYSYMBOL_MASTER_HEARTBEAT_PERIOD_SYM = 523, /* MASTER_HEARTBEAT_PERIOD_SYM  */
  YYSYMBOL_MAX_CONNECTIONS_PER_HOUR = 524, /* MAX_CONNECTIONS_PER_HOUR  */
  YYSYMBOL_MAX_QUERIES_PER_HOUR = 525,     /* MAX_QUERIES_PER_HOUR  */
  YYSYMBOL_MAX_ROWS = 526,                 /* MAX_ROWS  */
  YYSYMBOL_MAX_SIZE_SYM = 527,             /* MAX_SIZE_SYM  */
  YYSYMBOL_MAX_UPDATES_PER_HOUR = 528,     /* MAX_UPDATES_PER_HOUR  */
  YYSYMBOL_MAX_STATEMENT_TIME_SYM = 529,   /* MAX_STATEMENT_TIME_SYM  */
  YYSYMBOL_MAX_USER_CONNECTIONS_SYM = 530, /* MAX_USER_CONNECTIONS_SYM  */
  YYSYMBOL_MEDIUM_SYM = 531,               /* MEDIUM_SYM  */
  YYSYMBOL_MEMORY_SYM = 532,               /* MEMORY_SYM  */
  YYSYMBOL_MERGE_SYM = 533,                /* MERGE_SYM  */
  YYSYMBOL_MESSAGE_TEXT_SYM = 534,         /* MESSAGE_TEXT_SYM  */
  YYSYMBOL_MICROSECOND_SYM = 535,          /* MICROSECOND_SYM  */
  YYSYMBOL_MIGRATE_SYM = 536,              /* MIGRATE_SYM  */
  YYSYMBOL_MINUTE_SYM = 537,               /* MINUTE_SYM  */
  YYSYMBOL_MINVALUE_SYM = 538,             /* MINVALUE_SYM  */
  YYSYMBOL_MIN_ROWS = 539,                 /* MIN_ROWS  */
  YYSYMBOL_MODE_SYM = 540,                 /* MODE_SYM  */
  YYSYMBOL_MODIFY_SYM = 541,               /* MODIFY_SYM  */
  YYSYMBOL_MONTH_SYM = 542,                /* MONTH_SYM  */
  YYSYMBOL_MULTILINESTRING = 543,          /* MULTILINESTRING  */
  YYSYMBOL_MULTIPOINT = 544,               /* MULTIPOINT  */
  YYSYMBOL_MULTIPOLYGON = 545,             /* MULTIPOLYGON  */
  YYSYMBOL_MUTEX_SYM = 546,                /* MUTEX_SYM  */
  YYSYMBOL_MYSQL_SYM = 547,                /* MYSQL_SYM  */
  YYSYMBOL_MYSQL_ERRNO_SYM = 548,          /* MYSQL_ERRNO_SYM  */
  YYSYMBOL_NAMES_SYM = 549,                /* NAMES_SYM  */
  YYSYMBOL_NAME_SYM = 550,                 /* NAME_SYM  */
  YYSYMBOL_NATIONAL_SYM = 551,             /* NATIONAL_SYM  */
  YYSYMBOL_NCHAR_SYM = 552,                /* NCHAR_SYM  */
  YYSYMBOL_NEVER_SYM = 553,                /* NEVER_SYM  */
  YYSYMBOL_NEW_SYM = 554,                  /* NEW_SYM  */
  YYSYMBOL_NEXT_SYM = 555,                 /* NEXT_SYM  */
  YYSYMBOL_NEXTVAL_SYM = 556,              /* NEXTVAL_SYM  */
  YYSYMBOL_NOCACHE_SYM = 557,              /* NOCACHE_SYM  */
  YYSYMBOL_NOCYCLE_SYM = 558,              /* NOCYCLE_SYM  */
  YYSYMBOL_NODEGROUP_SYM = 559,            /* NODEGROUP_SYM  */
  YYSYMBOL_NONE_SYM = 560,                 /* NONE_SYM  */
  YYSYMBOL_NOTFOUND_SYM = 561,             /* NOTFOUND_SYM  */
  YYSYMBOL_NO_SYM = 562,                   /* NO_SYM  */
  YYSYMBOL_NOMAXVALUE_SYM = 563,           /* NOMAXVALUE_SYM  */
  YYSYMBOL_NOMINVALUE_SYM = 564,           /* NOMINVALUE_SYM  */
  YYSYMBOL_NO_WAIT_SYM = 565,              /* NO_WAIT_SYM  */
  YYSYMBOL_NOWAIT_SYM = 566,               /* NOWAIT_SYM  */
  YYSYMBOL_NUMBER_MARIADB_SYM = 567,       /* NUMBER_MARIADB_SYM  */
  YYSYMBOL_NUMBER_ORACLE_SYM = 568,        /* NUMBER_ORACLE_SYM  */
  YYSYMBOL_NVARCHAR_SYM = 569,             /* NVARCHAR_SYM  */
  YYSYMBOL_OF_SYM = 570,                   /* OF_SYM  */
  YYSYMBOL_OFFSET_SYM = 571,               /* OFFSET_SYM  */
  YYSYMBOL_OLD_PASSWORD_SYM = 572,         /* OLD_PASSWORD_SYM  */
  YYSYMBOL_ONE_SYM = 573,                  /* ONE_SYM  */
  YYSYMBOL_ONLY_SYM = 574,                 /* ONLY_SYM  */
  YYSYMBOL_ONLINE_SYM = 575,               /* ONLINE_SYM  */
  YYSYMBOL_OPEN_SYM = 576,                 /* OPEN_SYM  */
  YYSYMBOL_OPTIONS_SYM = 577,              /* OPTIONS_SYM  */
  YYSYMBOL_OPTION = 578,                   /* OPTION  */
  YYSYMBOL_OWNER_SYM = 579,                /* OWNER_SYM  */
  YYSYMBOL_PACK_KEYS_SYM = 580,            /* PACK_KEYS_SYM  */
  YYSYMBOL_PAGE_SYM = 581,                 /* PAGE_SYM  */
  YYSYMBOL_PARSER_SYM = 582,               /* PARSER_SYM  */
  YYSYMBOL_PARTIAL = 583,                  /* PARTIAL  */
  YYSYMBOL_PARTITIONS_SYM = 584,           /* PARTITIONS_SYM  */
  YYSYMBOL_PARTITIONING_SYM = 585,         /* PARTITIONING_SYM  */
  YYSYMBOL_PASSWORD_SYM = 586,             /* PASSWORD_SYM  */
  YYSYMBOL_PERIOD_SYM = 587,               /* PERIOD_SYM  */
  YYSYMBOL_PERSISTENT_SYM = 588,           /* PERSISTENT_SYM  */
  YYSYMBOL_PHASE_SYM = 589,                /* PHASE_SYM  */
  YYSYMBOL_PLUGINS_SYM = 590,              /* PLUGINS_SYM  */
  YYSYMBOL_PLUGIN_SYM = 591,               /* PLUGIN_SYM  */
  YYSYMBOL_POINT_SYM = 592,                /* POINT_SYM  */
  YYSYMBOL_POLYGON = 593,                  /* POLYGON  */
  YYSYMBOL_PORT_SYM = 594,                 /* PORT_SYM  */
  YYSYMBOL_PRECEDES_SYM = 595,             /* PRECEDES_SYM  */
  YYSYMBOL_PRECEDING_SYM = 596,            /* PRECEDING_SYM  */
  YYSYMBOL_PREPARE_SYM = 597,              /* PREPARE_SYM  */
  YYSYMBOL_PRESERVE_SYM = 598,             /* PRESERVE_SYM  */
  YYSYMBOL_PREV_SYM = 599,                 /* PREV_SYM  */
  YYSYMBOL_PREVIOUS_SYM = 600,             /* PREVIOUS_SYM  */
  YYSYMBOL_PRIVILEGES = 601,               /* PRIVILEGES  */
  YYSYMBOL_PROCESS = 602,                  /* PROCESS  */
  YYSYMBOL_PROCESSLIST_SYM = 603,          /* PROCESSLIST_SYM  */
  YYSYMBOL_PROFILE_SYM = 604,              /* PROFILE_SYM  */
  YYSYMBOL_PROFILES_SYM = 605,             /* PROFILES_SYM  */
  YYSYMBOL_PROXY_SYM = 606,                /* PROXY_SYM  */
  YYSYMBOL_QUARTER_SYM = 607,              /* QUARTER_SYM  */
  YYSYMBOL_QUERY_SYM = 608,                /* QUERY_SYM  */
  YYSYMBOL_QUICK = 609,                    /* QUICK  */
  YYSYMBOL_RAW_MARIADB_SYM = 610,          /* RAW_MARIADB_SYM  */
  YYSYMBOL_RAW_ORACLE_SYM = 611,           /* RAW_ORACLE_SYM  */
  YYSYMBOL_READ_ONLY_SYM = 612,            /* READ_ONLY_SYM  */
  YYSYMBOL_REBUILD_SYM = 613,              /* REBUILD_SYM  */
  YYSYMBOL_RECOVER_SYM = 614,              /* RECOVER_SYM  */
  YYSYMBOL_REDOFILE_SYM = 615,             /* REDOFILE_SYM  */
  YYSYMBOL_REDO_BUFFER_SIZE_SYM = 616,     /* REDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_REDUNDANT_SYM = 617,            /* REDUNDANT_SYM  */
  YYSYMBOL_RELAY = 618,                    /* RELAY  */
  YYSYMBOL_RELAYLOG_SYM = 619,             /* RELAYLOG_SYM  */
  YYSYMBOL_RELAY_LOG_FILE_SYM = 620,       /* RELAY_LOG_FILE_SYM  */
  YYSYMBOL_RELAY_LOG_POS_SYM = 621,        /* RELAY_LOG_POS_SYM  */
  YYSYMBOL_RELAY_THREAD = 622,             /* RELAY_THREAD  */
  YYSYMBOL_RELOAD = 623,                   /* RELOAD  */
  YYSYMBOL_REMOVE_SYM = 624,               /* REMOVE_SYM  */
  YYSYMBOL_REORGANIZE_SYM = 625,           /* REORGANIZE_SYM  */
  YYSYMBOL_REPAIR = 626,                   /* REPAIR  */
  YYSYMBOL_REPEATABLE_SYM = 627,           /* REPEATABLE_SYM  */
  YYSYMBOL_REPLICATION = 628,              /* REPLICATION  */
  YYSYMBOL_RESET_SYM = 629,                /* RESET_SYM  */
  YYSYMBOL_RESTART_SYM = 630,              /* RESTART_SYM  */
  YYSYMBOL_RESOURCES = 631,                /* RESOURCES  */
  YYSYMBOL_RESTORE_SYM = 632,              /* RESTORE_SYM  */
  YYSYMBOL_RESUME_SYM = 633,               /* RESUME_SYM  */
  YYSYMBOL_RETURNED_SQLSTATE_SYM = 634,    /* RETURNED_SQLSTATE_SYM  */
  YYSYMBOL_RETURNS_SYM = 635,              /* RETURNS_SYM  */
  YYSYMBOL_REUSE_SYM = 636,                /* REUSE_SYM  */
  YYSYMBOL_REVERSE_SYM = 637,              /* REVERSE_SYM  */
  YYSYMBOL_ROLE_SYM = 638,                 /* ROLE_SYM  */
  YYSYMBOL_ROLLBACK_SYM = 639,             /* ROLLBACK_SYM  */
  YYSYMBOL_ROLLUP_SYM = 640,               /* ROLLUP_SYM  */
  YYSYMBOL_ROUTINE_SYM = 641,              /* ROUTINE_SYM  */
  YYSYMBOL_ROWCOUNT_SYM = 642,             /* ROWCOUNT_SYM  */
  YYSYMBOL_ROW_SYM = 643,                  /* ROW_SYM  */
  YYSYMBOL_ROW_COUNT_SYM = 644,            /* ROW_COUNT_SYM  */
  YYSYMBOL_ROW_FORMAT_SYM = 645,           /* ROW_FORMAT_SYM  */
  YYSYMBOL_RTREE_SYM = 646,                /* RTREE_SYM  */
  YYSYMBOL_SAVEPOINT_SYM = 647,            /* SAVEPOINT_SYM  */
  YYSYMBOL_SCHEDULE_SYM = 648,             /* SCHEDULE_SYM  */
  YYSYMBOL_SCHEMA_NAME_SYM = 649,          /* SCHEMA_NAME_SYM  */
  YYSYMBOL_SECOND_SYM = 650,               /* SECOND_SYM  */
  YYSYMBOL_SECURITY_SYM = 651,             /* SECURITY_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 652,             /* SEQUENCE_SYM  */
  YYSYMBOL_SERIALIZABLE_SYM = 653,         /* SERIALIZABLE_SYM  */
  YYSYMBOL_SERIAL_SYM = 654,               /* SERIAL_SYM  */
  YYSYMBOL_SESSION_SYM = 655,              /* SESSION_SYM  */
  YYSYMBOL_SERVER_SYM = 656,               /* SERVER_SYM  */
  YYSYMBOL_SETVAL_SYM = 657,               /* SETVAL_SYM  */
  YYSYMBOL_SHARE_SYM = 658,                /* SHARE_SYM  */
  YYSYMBOL_SHUTDOWN = 659,                 /* SHUTDOWN  */
  YYSYMBOL_SIGNED_SYM = 660,               /* SIGNED_SYM  */
  YYSYMBOL_SIMPLE_SYM = 661,               /* SIMPLE_SYM  */
  YYSYMBOL_SLAVE = 662,                    /* SLAVE  */
  YYSYMBOL_SLAVES = 663,                   /* SLAVES  */
  YYSYMBOL_SLAVE_POS_SYM = 664,            /* SLAVE_POS_SYM  */
  YYSYMBOL_SLOW = 665,                     /* SLOW  */
  YYSYMBOL_SNAPSHOT_SYM = 666,             /* SNAPSHOT_SYM  */
  YYSYMBOL_SOCKET_SYM = 667,               /* SOCKET_SYM  */
  YYSYMBOL_SOFT_SYM = 668,                 /* SOFT_SYM  */
  YYSYMBOL_SONAME_SYM = 669,               /* SONAME_SYM  */
  YYSYMBOL_SOUNDS_SYM = 670,               /* SOUNDS_SYM  */
  YYSYMBOL_SOURCE_SYM = 671,               /* SOURCE_SYM  */
  YYSYMBOL_SQL_BUFFER_RESULT = 672,        /* SQL_BUFFER_RESULT  */
  YYSYMBOL_SQL_CACHE_SYM = 673,            /* SQL_CACHE_SYM  */
  YYSYMBOL_SQL_CALC_FOUND_ROWS = 674,      /* SQL_CALC_FOUND_ROWS  */
  YYSYMBOL_SQL_NO_CACHE_SYM = 675,         /* SQL_NO_CACHE_SYM  */
  YYSYMBOL_SQL_THREAD = 676,               /* SQL_THREAD  */
  YYSYMBOL_STAGE_SYM = 677,                /* STAGE_SYM  */
  YYSYMBOL_STARTS_SYM = 678,               /* STARTS_SYM  */
  YYSYMBOL_START_SYM = 679,                /* START_SYM  */
  YYSYMBOL_STATEMENT_SYM = 680,            /* STATEMENT_SYM  */
  YYSYMBOL_STATUS_SYM = 681,               /* STATUS_SYM  */
  YYSYMBOL_STOP_SYM = 682,                 /* STOP_SYM  */
  YYSYMBOL_STORAGE_SYM = 683,              /* STORAGE_SYM  */
  YYSYMBOL_STORED_SYM = 684,               /* STORED_SYM  */
  YYSYMBOL_STRING_SYM = 685,               /* STRING_SYM  */
  YYSYMBOL_SUBCLASS_ORIGIN_SYM = 686,      /* SUBCLASS_ORIGIN_SYM  */
  YYSYMBOL_SUBDATE_SYM = 687,              /* SUBDATE_SYM  */
  YYSYMBOL_SUBJECT_SYM = 688,              /* SUBJECT_SYM  */
  YYSYMBOL_SUBPARTITIONS_SYM = 689,        /* SUBPARTITIONS_SYM  */
  YYSYMBOL_SUBPARTITION_SYM = 690,         /* SUBPARTITION_SYM  */
  YYSYMBOL_SUPER_SYM = 691,                /* SUPER_SYM  */
  YYSYMBOL_SUSPEND_SYM = 692,              /* SUSPEND_SYM  */
  YYSYMBOL_SWAPS_SYM = 693,                /* SWAPS_SYM  */
  YYSYMBOL_SWITCHES_SYM = 694,             /* SWITCHES_SYM  */
  YYSYMBOL_SYSTEM = 695,                   /* SYSTEM  */
  YYSYMBOL_SYSTEM_TIME_SYM = 696,          /* SYSTEM_TIME_SYM  */
  YYSYMBOL_TABLES = 697,                   /* TABLES  */
  YYSYMBOL_TABLESPACE = 698,               /* TABLESPACE  */
  YYSYMBOL_TABLE_CHECKSUM_SYM = 699,       /* TABLE_CHECKSUM_SYM  */
  YYSYMBOL_TABLE_NAME_SYM = 700,           /* TABLE_NAME_SYM  */
  YYSYMBOL_TEMPORARY = 701,                /* TEMPORARY  */
  YYSYMBOL_TEMPTABLE_SYM = 702,            /* TEMPTABLE_SYM  */
  YYSYMBOL_TEXT_SYM = 703,                 /* TEXT_SYM  */
  YYSYMBOL_THAN_SYM = 704,                 /* THAN_SYM  */
  YYSYMBOL_TIES_SYM = 705,                 /* TIES_SYM  */
  YYSYMBOL_TIMESTAMP = 706,                /* TIMESTAMP  */
  YYSYMBOL_TIMESTAMP_ADD = 707,            /* TIMESTAMP_ADD  */
  YYSYMBOL_TIMESTAMP_DIFF = 708,           /* TIMESTAMP_DIFF  */
  YYSYMBOL_TIME_SYM = 709,                 /* TIME_SYM  */
  YYSYMBOL_TRANSACTION_SYM = 710,          /* TRANSACTION_SYM  */
  YYSYMBOL_TRANSACTIONAL_SYM = 711,        /* TRANSACTIONAL_SYM  */
  YYSYMBOL_TRIGGERS_SYM = 712,             /* TRIGGERS_SYM  */
  YYSYMBOL_TRIM_ORACLE = 713,              /* TRIM_ORACLE  */
  YYSYMBOL_TRUNCATE_SYM = 714,             /* TRUNCATE_SYM  */
  YYSYMBOL_TYPES_SYM = 715,                /* TYPES_SYM  */
  YYSYMBOL_TYPE_SYM = 716,                 /* TYPE_SYM  */
  YYSYMBOL_UDF_RETURNS_SYM = 717,          /* UDF_RETURNS_SYM  */
  YYSYMBOL_UNBOUNDED_SYM = 718,            /* UNBOUNDED_SYM  */
  YYSYMBOL_UNCOMMITTED_SYM = 719,          /* UNCOMMITTED_SYM  */
  YYSYMBOL_UNDEFINED_SYM = 720,            /* UNDEFINED_SYM  */
  YYSYMBOL_UNDOFILE_SYM = 721,             /* UNDOFILE_SYM  */
  YYSYMBOL_UNDO_BUFFER_SIZE_SYM = 722,     /* UNDO_BUFFER_SIZE_SYM  */
  YYSYMBOL_UNICODE_SYM = 723,              /* UNICODE_SYM  */
  YYSYMBOL_UNINSTALL_SYM = 724,            /* UNINSTALL_SYM  */
  YYSYMBOL_UNKNOWN_SYM = 725,              /* UNKNOWN_SYM  */
  YYSYMBOL_UNTIL_SYM = 726,                /* UNTIL_SYM  */
  YYSYMBOL_UPGRADE_SYM = 727,              /* UPGRADE_SYM  */
  YYSYMBOL_USER_SYM = 728,                 /* USER_SYM  */
  YYSYMBOL_USE_FRM = 729,                  /* USE_FRM  */
  YYSYMBOL_VALUE_SYM = 730,                /* VALUE_SYM  */
  YYSYMBOL_VARCHAR2_MARIADB_SYM = 731,     /* VARCHAR2_MARIADB_SYM  */
  YYSYMBOL_VARCHAR2_ORACLE_SYM = 732,      /* VARCHAR2_ORACLE_SYM  */
  YYSYMBOL_VARIABLES = 733,                /* VARIABLES  */
  YYSYMBOL_VERSIONING_SYM = 734,           /* VERSIONING_SYM  */
  YYSYMBOL_VIA_SYM = 735,                  /* VIA_SYM  */
  YYSYMBOL_VIEW_SYM = 736,                 /* VIEW_SYM  */
  YYSYMBOL_VIRTUAL_SYM = 737,              /* VIRTUAL_SYM  */
  YYSYMBOL_WAIT_SYM = 738,                 /* WAIT_SYM  */
  YYSYMBOL_WARNINGS = 739,                 /* WARNINGS  */
  YYSYMBOL_WEEK_SYM = 740,                 /* WEEK_SYM  */
  YYSYMBOL_WEIGHT_STRING_SYM = 741,        /* WEIGHT_STRING_SYM  */
  YYSYMBOL_WINDOW_SYM = 742,               /* WINDOW_SYM  */
  YYSYMBOL_WITHIN = 743,                   /* WITHIN  */
  YYSYMBOL_WITHOUT = 744,                  /* WITHOUT  */
  YYSYMBOL_WORK_SYM = 745,                 /* WORK_SYM  */
  YYSYMBOL_WRAPPER_SYM = 746,              /* WRAPPER_SYM  */
  YYSYMBOL_WRITE_SYM = 747,                /* WRITE_SYM  */
  YYSYMBOL_X509_SYM = 748,                 /* X509_SYM  */
  YYSYMBOL_XA_SYM = 749,                   /* XA_SYM  */
  YYSYMBOL_XML_SYM = 750,                  /* XML_SYM  */
  YYSYMBOL_YEAR_SYM = 751,                 /* YEAR_SYM  */
  YYSYMBOL_CONDITIONLESS_JOIN = 752,       /* CONDITIONLESS_JOIN  */
  YYSYMBOL_ON_SYM = 753,                   /* ON_SYM  */
  YYSYMBOL_PREC_BELOW_NOT = 754,           /* PREC_BELOW_NOT  */
  YYSYMBOL_755_ = 755,                     /* '='  */
  YYSYMBOL_756_ = 756,                     /* '>'  */
  YYSYMBOL_757_ = 757,                     /* '<'  */
  YYSYMBOL_758_ = 758,                     /* '|'  */
  YYSYMBOL_759_ = 759,                     /* '&'  */
  YYSYMBOL_760_ = 760,                     /* '-'  */
  YYSYMBOL_761_ = 761,                     /* '+'  */
  YYSYMBOL_762_ = 762,                     /* '*'  */
  YYSYMBOL_763_ = 763,                     /* '/'  */
  YYSYMBOL_764_ = 764,                     /* '%'  */
  YYSYMBOL_765_ = 765,                     /* '^'  */
  YYSYMBOL_766_ = 766,                     /* '~'  */
  YYSYMBOL_SUBQUERY_AS_EXPR = 767,         /* SUBQUERY_AS_EXPR  */
  YYSYMBOL_PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE = 768, /* PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE  */
  YYSYMBOL_USER = 769,                     /* USER  */
  YYSYMBOL_PREC_BELOW_CONTRACTION_TOKEN2 = 770, /* PREC_BELOW_CONTRACTION_TOKEN2  */
  YYSYMBOL_771_ = 771,                     /* '('  */
  YYSYMBOL_772_ = 772,                     /* ')'  */
  YYSYMBOL_EMPTY_FROM_CLAUSE = 773,        /* EMPTY_FROM_CLAUSE  */
  YYSYMBOL_774_ = 774,                     /* ','  */
  YYSYMBOL_775_ = 775,                     /* '!'  */
  YYSYMBOL_776_ = 776,                     /* '{'  */
  YYSYMBOL_777_ = 777,                     /* '}'  */
  YYSYMBOL_778_ = 778,                     /* ';'  */
  YYSYMBOL_779_ = 779,                     /* '.'  */
  YYSYMBOL_780_ = 780,                     /* '@'  */
  YYSYMBOL_YYACCEPT = 781,                 /* $accept  */
  YYSYMBOL_query = 782,                    /* query  */
  YYSYMBOL_783_1 = 783,                    /* $@1  */
  YYSYMBOL_opt_end_of_input = 784,         /* opt_end_of_input  */
  YYSYMBOL_verb_clause = 785,              /* verb_clause  */
  YYSYMBOL_statement = 786,                /* statement  */
  YYSYMBOL_deallocate = 787,               /* deallocate  */
  YYSYMBOL_deallocate_or_drop = 788,       /* deallocate_or_drop  */
  YYSYMBOL_prepare = 789,                  /* prepare  */
  YYSYMBOL_790_2 = 790,                    /* $@2  */
  YYSYMBOL_execute = 791,                  /* execute  */
  YYSYMBOL_792_3 = 792,                    /* $@3  */
  YYSYMBOL_793_4 = 793,                    /* $@4  */
  YYSYMBOL_execute_using = 794,            /* execute_using  */
  YYSYMBOL_795_5 = 795,                    /* $@5  */
  YYSYMBOL_execute_params = 796,           /* execute_params  */
  YYSYMBOL_help = 797,                     /* help  */
  YYSYMBOL_798_6 = 798,                    /* $@6  */
  YYSYMBOL_change = 799,                   /* change  */
  YYSYMBOL_800_7 = 800,                    /* $@7  */
  YYSYMBOL_master_defs = 801,              /* master_defs  */
  YYSYMBOL_master_def = 802,               /* master_def  */
  YYSYMBOL_ignore_server_id_list = 803,    /* ignore_server_id_list  */
  YYSYMBOL_ignore_server_id = 804,         /* ignore_server_id  */
  YYSYMBOL_do_domain_id_list = 805,        /* do_domain_id_list  */
  YYSYMBOL_do_domain_id = 806,             /* do_domain_id  */
  YYSYMBOL_ignore_domain_id_list = 807,    /* ignore_domain_id_list  */
  YYSYMBOL_ignore_domain_id = 808,         /* ignore_domain_id  */
  YYSYMBOL_master_file_def = 809,          /* master_file_def  */
  YYSYMBOL_optional_connection_name = 810, /* optional_connection_name  */
  YYSYMBOL_connection_name = 811,          /* connection_name  */
  YYSYMBOL_create = 812,                   /* create  */
  YYSYMBOL_813_8 = 813,                    /* $@8  */
  YYSYMBOL_814_9 = 814,                    /* $@9  */
  YYSYMBOL_815_10 = 815,                   /* $@10  */
  YYSYMBOL_816_11 = 816,                   /* $@11  */
  YYSYMBOL_817_12 = 817,                   /* $@12  */
  YYSYMBOL_818_13 = 818,                   /* $@13  */
  YYSYMBOL_819_14 = 819,                   /* $@14  */
  YYSYMBOL_820_15 = 820,                   /* $@15  */
  YYSYMBOL_821_16 = 821,                   /* $@16  */
  YYSYMBOL_822_17 = 822,                   /* $@17  */
  YYSYMBOL_823_18 = 823,                   /* $@18  */
  YYSYMBOL_824_19 = 824,                   /* $@19  */
  YYSYMBOL_825_20 = 825,                   /* $@20  */
  YYSYMBOL_826_21 = 826,                   /* $@21  */
  YYSYMBOL_827_22 = 827,                   /* $@22  */
  YYSYMBOL_828_23 = 828,                   /* $@23  */
  YYSYMBOL_829_24 = 829,                   /* $@24  */
  YYSYMBOL_830_25 = 830,                   /* $@25  */
  YYSYMBOL_831_26 = 831,                   /* $@26  */
  YYSYMBOL_832_27 = 832,                   /* $@27  */
  YYSYMBOL_833_28 = 833,                   /* $@28  */
  YYSYMBOL_834_29 = 834,                   /* $@29  */
  YYSYMBOL_835_30 = 835,                   /* $@30  */
  YYSYMBOL_836_31 = 836,                   /* $@31  */
  YYSYMBOL_package_implementation_executable_section = 837, /* package_implementation_executable_section  */
  YYSYMBOL_package_implementation_declare_section = 838, /* package_implementation_declare_section  */
  YYSYMBOL_package_implementation_declare_section_list1 = 839, /* package_implementation_declare_section_list1  */
  YYSYMBOL_package_implementation_declare_section_list2 = 840, /* package_implementation_declare_section_list2  */
  YYSYMBOL_package_routine_lex = 841,      /* package_routine_lex  */
  YYSYMBOL_package_specification_function = 842, /* package_specification_function  */
  YYSYMBOL_843_32 = 843,                   /* $@32  */
  YYSYMBOL_package_specification_procedure = 844, /* package_specification_procedure  */
  YYSYMBOL_845_33 = 845,                   /* $@33  */
  YYSYMBOL_package_implementation_routine_definition = 846, /* package_implementation_routine_definition  */
  YYSYMBOL_package_implementation_function_body = 847, /* package_implementation_function_body  */
  YYSYMBOL_848_34 = 848,                   /* $@34  */
  YYSYMBOL_package_implementation_procedure_body = 849, /* package_implementation_procedure_body  */
  YYSYMBOL_850_35 = 850,                   /* $@35  */
  YYSYMBOL_package_implementation_item_declaration = 851, /* package_implementation_item_declaration  */
  YYSYMBOL_opt_package_specification_element_list = 852, /* opt_package_specification_element_list  */
  YYSYMBOL_package_specification_element_list = 853, /* package_specification_element_list  */
  YYSYMBOL_package_specification_element = 854, /* package_specification_element  */
  YYSYMBOL_opt_sequence = 855,             /* opt_sequence  */
  YYSYMBOL_sequence_defs = 856,            /* sequence_defs  */
  YYSYMBOL_sequence_def = 857,             /* sequence_def  */
  YYSYMBOL_force_lookahead = 858,          /* force_lookahead  */
  YYSYMBOL_server_def = 859,               /* server_def  */
  YYSYMBOL_860_36 = 860,                   /* $@36  */
  YYSYMBOL_server_options_list = 861,      /* server_options_list  */
  YYSYMBOL_server_option = 862,            /* server_option  */
  YYSYMBOL_event_tail = 863,               /* event_tail  */
  YYSYMBOL_864_37 = 864,                   /* $@37  */
  YYSYMBOL_ev_schedule_time = 865,         /* ev_schedule_time  */
  YYSYMBOL_866_38 = 866,                   /* $@38  */
  YYSYMBOL_opt_ev_status = 867,            /* opt_ev_status  */
  YYSYMBOL_ev_starts = 868,                /* ev_starts  */
  YYSYMBOL_ev_ends = 869,                  /* ev_ends  */
  YYSYMBOL_opt_ev_on_completion = 870,     /* opt_ev_on_completion  */
  YYSYMBOL_ev_on_completion = 871,         /* ev_on_completion  */
  YYSYMBOL_opt_ev_comment = 872,           /* opt_ev_comment  */
  YYSYMBOL_ev_sql_stmt = 873,              /* ev_sql_stmt  */
  YYSYMBOL_874_39 = 874,                   /* $@39  */
  YYSYMBOL_clear_privileges = 875,         /* clear_privileges  */
  YYSYMBOL_opt_aggregate = 876,            /* opt_aggregate  */
  YYSYMBOL_sp_name = 877,                  /* sp_name  */
  YYSYMBOL_opt_sp_name = 878,              /* opt_sp_name  */
  YYSYMBOL_sp_a_chistics = 879,            /* sp_a_chistics  */
  YYSYMBOL_sp_c_chistics = 880,            /* sp_c_chistics  */
  YYSYMBOL_sp_chistic = 881,               /* sp_chistic  */
  YYSYMBOL_create_package_chistic = 882,   /* create_package_chistic  */
  YYSYMBOL_create_package_chistics = 883,  /* create_package_chistics  */
  YYSYMBOL_opt_create_package_chistics = 884, /* opt_create_package_chistics  */
  YYSYMBOL_opt_create_package_chistics_init = 885, /* opt_create_package_chistics_init  */
  YYSYMBOL_886_40 = 886,                   /* $@40  */
  YYSYMBOL_sp_c_chistic = 887,             /* sp_c_chistic  */
  YYSYMBOL_sp_suid = 888,                  /* sp_suid  */
  YYSYMBOL_call = 889,                     /* call  */
  YYSYMBOL_890_41 = 890,                   /* $@41  */
  YYSYMBOL_891_42 = 891,                   /* $@42  */
  YYSYMBOL_892_43 = 892,                   /* $@43  */
  YYSYMBOL_opt_sp_cparam_list = 893,       /* opt_sp_cparam_list  */
  YYSYMBOL_opt_sp_cparams = 894,           /* opt_sp_cparams  */
  YYSYMBOL_sp_cparams = 895,               /* sp_cparams  */
  YYSYMBOL_sp_fdparam_list = 896,          /* sp_fdparam_list  */
  YYSYMBOL_897_44 = 897,                   /* $@44  */
  YYSYMBOL_sp_fdparams = 898,              /* sp_fdparams  */
  YYSYMBOL_sp_param_name = 899,            /* sp_param_name  */
  YYSYMBOL_sp_param_name_and_type = 900,   /* sp_param_name_and_type  */
  YYSYMBOL_sp_pdparam_list = 901,          /* sp_pdparam_list  */
  YYSYMBOL_sp_pdparams = 902,              /* sp_pdparams  */
  YYSYMBOL_sp_pdparam = 903,               /* sp_pdparam  */
  YYSYMBOL_sp_opt_inout = 904,             /* sp_opt_inout  */
  YYSYMBOL_sp_parenthesized_pdparam_list = 905, /* sp_parenthesized_pdparam_list  */
  YYSYMBOL_906_45 = 906,                   /* $@45  */
  YYSYMBOL_sp_no_param = 907,              /* sp_no_param  */
  YYSYMBOL_opt_sp_parenthesized_fdparam_list = 908, /* opt_sp_parenthesized_fdparam_list  */
  YYSYMBOL_opt_sp_parenthesized_pdparam_list = 909, /* opt_sp_parenthesized_pdparam_list  */
  YYSYMBOL_sp_proc_stmts = 910,            /* sp_proc_stmts  */
  YYSYMBOL_sp_proc_stmts1 = 911,           /* sp_proc_stmts1  */
  YYSYMBOL_sp_proc_stmts1_implicit_block = 912, /* sp_proc_stmts1_implicit_block  */
  YYSYMBOL_913_46 = 913,                   /* $@46  */
  YYSYMBOL_opt_sp_decl_body_list = 914,    /* opt_sp_decl_body_list  */
  YYSYMBOL_sp_decl_body_list = 915,        /* sp_decl_body_list  */
  YYSYMBOL_916_47 = 916,                   /* $@47  */
  YYSYMBOL_sp_decl_non_handler_list = 917, /* sp_decl_non_handler_list  */
  YYSYMBOL_sp_decl_handler_list = 918,     /* sp_decl_handler_list  */
  YYSYMBOL_opt_sp_decl_handler_list = 919, /* opt_sp_decl_handler_list  */
  YYSYMBOL_optionally_qualified_column_ident = 920, /* optionally_qualified_column_ident  */
  YYSYMBOL_row_field_name = 921,           /* row_field_name  */
  YYSYMBOL_row_field_definition = 922,     /* row_field_definition  */
  YYSYMBOL_row_field_definition_list = 923, /* row_field_definition_list  */
  YYSYMBOL_row_type_body = 924,            /* row_type_body  */
  YYSYMBOL_sp_decl_idents_init_vars = 925, /* sp_decl_idents_init_vars  */
  YYSYMBOL_sp_decl_vars = 926,             /* sp_decl_vars  */
  YYSYMBOL_sp_decl_non_handler = 927,      /* sp_decl_non_handler  */
  YYSYMBOL_928_48 = 928,                   /* $@48  */
  YYSYMBOL_sp_decl_handler = 929,          /* sp_decl_handler  */
  YYSYMBOL_930_49 = 930,                   /* $@49  */
  YYSYMBOL_opt_parenthesized_cursor_formal_parameters = 931, /* opt_parenthesized_cursor_formal_parameters  */
  YYSYMBOL_sp_cursor_stmt_lex = 932,       /* sp_cursor_stmt_lex  */
  YYSYMBOL_sp_cursor_stmt = 933,           /* sp_cursor_stmt  */
  YYSYMBOL_934_50 = 934,                   /* $@50  */
  YYSYMBOL_sp_handler_type = 935,          /* sp_handler_type  */
  YYSYMBOL_sp_hcond_list = 936,            /* sp_hcond_list  */
  YYSYMBOL_sp_hcond_element = 937,         /* sp_hcond_element  */
  YYSYMBOL_sp_cond = 938,                  /* sp_cond  */
  YYSYMBOL_sqlstate = 939,                 /* sqlstate  */
  YYSYMBOL_opt_value = 940,                /* opt_value  */
  YYSYMBOL_sp_hcond = 941,                 /* sp_hcond  */
  YYSYMBOL_raise_stmt_oracle = 942,        /* raise_stmt_oracle  */
  YYSYMBOL_signal_stmt = 943,              /* signal_stmt  */
  YYSYMBOL_signal_value = 944,             /* signal_value  */
  YYSYMBOL_opt_signal_value = 945,         /* opt_signal_value  */
  YYSYMBOL_opt_set_signal_information = 946, /* opt_set_signal_information  */
  YYSYMBOL_signal_information_item_list = 947, /* signal_information_item_list  */
  YYSYMBOL_signal_allowed_expr = 948,      /* signal_allowed_expr  */
  YYSYMBOL_signal_condition_information_item_name = 949, /* signal_condition_information_item_name  */
  YYSYMBOL_resignal_stmt = 950,            /* resignal_stmt  */
  YYSYMBOL_get_diagnostics = 951,          /* get_diagnostics  */
  YYSYMBOL_which_area = 952,               /* which_area  */
  YYSYMBOL_diagnostics_information = 953,  /* diagnostics_information  */
  YYSYMBOL_statement_information = 954,    /* statement_information  */
  YYSYMBOL_statement_information_item = 955, /* statement_information_item  */
  YYSYMBOL_simple_target_specification = 956, /* simple_target_specification  */
  YYSYMBOL_statement_information_item_name = 957, /* statement_information_item_name  */
  YYSYMBOL_condition_number = 958,         /* condition_number  */
  YYSYMBOL_condition_information = 959,    /* condition_information  */
  YYSYMBOL_condition_information_item = 960, /* condition_information_item  */
  YYSYMBOL_condition_information_item_name = 961, /* condition_information_item_name  */
  YYSYMBOL_sp_decl_ident = 962,            /* sp_decl_ident  */
  YYSYMBOL_sp_decl_idents = 963,           /* sp_decl_idents  */
  YYSYMBOL_sp_opt_default = 964,           /* sp_opt_default  */
  YYSYMBOL_sp_proc_stmt = 965,             /* sp_proc_stmt  */
  YYSYMBOL_sp_labelable_stmt = 966,        /* sp_labelable_stmt  */
  YYSYMBOL_sp_proc_stmt_compound_ok = 967, /* sp_proc_stmt_compound_ok  */
  YYSYMBOL_sp_proc_stmt_if = 968,          /* sp_proc_stmt_if  */
  YYSYMBOL_969_51 = 969,                   /* $@51  */
  YYSYMBOL_sp_statement = 970,             /* sp_statement  */
  YYSYMBOL_971_52 = 971,                   /* $@52  */
  YYSYMBOL_972_53 = 972,                   /* $@53  */
  YYSYMBOL_973_54 = 973,                   /* $@54  */
  YYSYMBOL_sp_proc_stmt_statement = 974,   /* sp_proc_stmt_statement  */
  YYSYMBOL_975_55 = 975,                   /* $@55  */
  YYSYMBOL_RETURN_ALLMODES_SYM = 976,      /* RETURN_ALLMODES_SYM  */
  YYSYMBOL_sp_proc_stmt_return = 977,      /* sp_proc_stmt_return  */
  YYSYMBOL_978_56 = 978,                   /* $@56  */
  YYSYMBOL_reset_lex_expr = 979,           /* reset_lex_expr  */
  YYSYMBOL_980_57 = 980,                   /* $@57  */
  YYSYMBOL_sp_proc_stmt_exit_oracle = 981, /* sp_proc_stmt_exit_oracle  */
  YYSYMBOL_sp_proc_stmt_continue_oracle = 982, /* sp_proc_stmt_continue_oracle  */
  YYSYMBOL_sp_proc_stmt_leave = 983,       /* sp_proc_stmt_leave  */
  YYSYMBOL_sp_proc_stmt_iterate = 984,     /* sp_proc_stmt_iterate  */
  YYSYMBOL_sp_proc_stmt_goto_oracle = 985, /* sp_proc_stmt_goto_oracle  */
  YYSYMBOL_remember_lex = 986,             /* remember_lex  */
  YYSYMBOL_assignment_source_lex = 987,    /* assignment_source_lex  */
  YYSYMBOL_assignment_source_expr = 988,   /* assignment_source_expr  */
  YYSYMBOL_989_58 = 989,                   /* $@58  */
  YYSYMBOL_for_loop_bound_expr = 990,      /* for_loop_bound_expr  */
  YYSYMBOL_991_59 = 991,                   /* $@59  */
  YYSYMBOL_cursor_actual_parameters = 992, /* cursor_actual_parameters  */
  YYSYMBOL_opt_parenthesized_cursor_actual_parameters = 993, /* opt_parenthesized_cursor_actual_parameters  */
  YYSYMBOL_sp_proc_stmt_open = 994,        /* sp_proc_stmt_open  */
  YYSYMBOL_sp_proc_stmt_fetch_head = 995,  /* sp_proc_stmt_fetch_head  */
  YYSYMBOL_sp_proc_stmt_fetch = 996,       /* sp_proc_stmt_fetch  */
  YYSYMBOL_sp_proc_stmt_close = 997,       /* sp_proc_stmt_close  */
  YYSYMBOL_sp_fetch_list = 998,            /* sp_fetch_list  */
  YYSYMBOL_sp_if = 999,                    /* sp_if  */
  YYSYMBOL_1000_60 = 1000,                 /* $@60  */
  YYSYMBOL_1001_61 = 1001,                 /* $@61  */
  YYSYMBOL_1002_62 = 1002,                 /* $@62  */
  YYSYMBOL_sp_elseifs = 1003,              /* sp_elseifs  */
  YYSYMBOL_case_stmt_specification = 1004, /* case_stmt_specification  */
  YYSYMBOL_1005_63 = 1005,                 /* $@63  */
  YYSYMBOL_case_stmt_body = 1006,          /* case_stmt_body  */
  YYSYMBOL_1007_64 = 1007,                 /* $@64  */
  YYSYMBOL_1008_65 = 1008,                 /* $@65  */
  YYSYMBOL_simple_when_clause_list = 1009, /* simple_when_clause_list  */
  YYSYMBOL_searched_when_clause_list = 1010, /* searched_when_clause_list  */
  YYSYMBOL_simple_when_clause = 1011,      /* simple_when_clause  */
  YYSYMBOL_1012_66 = 1012,                 /* $@66  */
  YYSYMBOL_1013_67 = 1013,                 /* $@67  */
  YYSYMBOL_searched_when_clause = 1014,    /* searched_when_clause  */
  YYSYMBOL_1015_68 = 1015,                 /* $@68  */
  YYSYMBOL_1016_69 = 1016,                 /* $@69  */
  YYSYMBOL_else_clause_opt = 1017,         /* else_clause_opt  */
  YYSYMBOL_sp_opt_label = 1018,            /* sp_opt_label  */
  YYSYMBOL_sp_block_label = 1019,          /* sp_block_label  */
  YYSYMBOL_sp_labeled_block = 1020,        /* sp_labeled_block  */
  YYSYMBOL_1021_70 = 1021,                 /* $@70  */
  YYSYMBOL_1022_71 = 1022,                 /* $@71  */
  YYSYMBOL_1023_72 = 1023,                 /* $@72  */
  YYSYMBOL_opt_not_atomic = 1024,          /* opt_not_atomic  */
  YYSYMBOL_sp_unlabeled_block = 1025,      /* sp_unlabeled_block  */
  YYSYMBOL_1026_73 = 1026,                 /* $@73  */
  YYSYMBOL_1027_74 = 1027,                 /* $@74  */
  YYSYMBOL_1028_75 = 1028,                 /* $@75  */
  YYSYMBOL_sp_instr_addr = 1029,           /* sp_instr_addr  */
  YYSYMBOL_sp_body = 1030,                 /* sp_body  */
  YYSYMBOL_1031_76 = 1031,                 /* $@76  */
  YYSYMBOL_1032_77 = 1032,                 /* $@77  */
  YYSYMBOL_1033_78 = 1033,                 /* $@78  */
  YYSYMBOL_sp_block_statements_and_exceptions = 1034, /* sp_block_statements_and_exceptions  */
  YYSYMBOL_1035_79 = 1035,                 /* $@79  */
  YYSYMBOL_opt_exception_clause = 1036,    /* opt_exception_clause  */
  YYSYMBOL_exception_handlers = 1037,      /* exception_handlers  */
  YYSYMBOL_exception_handler = 1038,       /* exception_handler  */
  YYSYMBOL_1039_80 = 1039,                 /* $@80  */
  YYSYMBOL_opt_sp_for_loop_direction = 1040, /* opt_sp_for_loop_direction  */
  YYSYMBOL_sp_for_loop_index_and_bounds = 1041, /* sp_for_loop_index_and_bounds  */
  YYSYMBOL_1042_81 = 1042,                 /* $@81  */
  YYSYMBOL_sp_for_loop_bounds = 1043,      /* sp_for_loop_bounds  */
  YYSYMBOL_loop_body = 1044,               /* loop_body  */
  YYSYMBOL_while_body = 1045,              /* while_body  */
  YYSYMBOL_1046_82 = 1046,                 /* $@82  */
  YYSYMBOL_repeat_body = 1047,             /* repeat_body  */
  YYSYMBOL_1048_83 = 1048,                 /* $@83  */
  YYSYMBOL_pop_sp_loop_label = 1049,       /* pop_sp_loop_label  */
  YYSYMBOL_sp_labeled_control = 1050,      /* sp_labeled_control  */
  YYSYMBOL_1051_84 = 1051,                 /* $@84  */
  YYSYMBOL_1052_85 = 1052,                 /* $@85  */
  YYSYMBOL_1053_86 = 1053,                 /* $@86  */
  YYSYMBOL_1054_87 = 1054,                 /* $@87  */
  YYSYMBOL_1055_88 = 1055,                 /* $@88  */
  YYSYMBOL_1056_89 = 1056,                 /* $@89  */
  YYSYMBOL_sp_unlabeled_control = 1057,    /* sp_unlabeled_control  */
  YYSYMBOL_1058_90 = 1058,                 /* $@90  */
  YYSYMBOL_1059_91 = 1059,                 /* $@91  */
  YYSYMBOL_1060_92 = 1060,                 /* $@92  */
  YYSYMBOL_1061_93 = 1061,                 /* $@93  */
  YYSYMBOL_1062_94 = 1062,                 /* $@94  */
  YYSYMBOL_trg_action_time = 1063,         /* trg_action_time  */
  YYSYMBOL_trg_event = 1064,               /* trg_event  */
  YYSYMBOL_change_tablespace_access = 1065, /* change_tablespace_access  */
  YYSYMBOL_change_tablespace_info = 1066,  /* change_tablespace_info  */
  YYSYMBOL_tablespace_info = 1067,         /* tablespace_info  */
  YYSYMBOL_opt_logfile_group_name = 1068,  /* opt_logfile_group_name  */
  YYSYMBOL_alter_tablespace_info = 1069,   /* alter_tablespace_info  */
  YYSYMBOL_logfile_group_info = 1070,      /* logfile_group_info  */
  YYSYMBOL_alter_logfile_group_info = 1071, /* alter_logfile_group_info  */
  YYSYMBOL_add_log_file = 1072,            /* add_log_file  */
  YYSYMBOL_change_ts_option_list = 1073,   /* change_ts_option_list  */
  YYSYMBOL_1074_95 = 1074,                 /* $@95  */
  YYSYMBOL_change_ts_options = 1075,       /* change_ts_options  */
  YYSYMBOL_change_ts_option = 1076,        /* change_ts_option  */
  YYSYMBOL_tablespace_option_list = 1077,  /* tablespace_option_list  */
  YYSYMBOL_tablespace_options = 1078,      /* tablespace_options  */
  YYSYMBOL_tablespace_option = 1079,       /* tablespace_option  */
  YYSYMBOL_alter_tablespace_option_list = 1080, /* alter_tablespace_option_list  */
  YYSYMBOL_alter_tablespace_options = 1081, /* alter_tablespace_options  */
  YYSYMBOL_alter_tablespace_option = 1082, /* alter_tablespace_option  */
  YYSYMBOL_logfile_group_option_list = 1083, /* logfile_group_option_list  */
  YYSYMBOL_logfile_group_options = 1084,   /* logfile_group_options  */
  YYSYMBOL_logfile_group_option = 1085,    /* logfile_group_option  */
  YYSYMBOL_alter_logfile_group_option_list = 1086, /* alter_logfile_group_option_list  */
  YYSYMBOL_alter_logfile_group_options = 1087, /* alter_logfile_group_options  */
  YYSYMBOL_alter_logfile_group_option = 1088, /* alter_logfile_group_option  */
  YYSYMBOL_ts_datafile = 1089,             /* ts_datafile  */
  YYSYMBOL_lg_undofile = 1090,             /* lg_undofile  */
  YYSYMBOL_lg_redofile = 1091,             /* lg_redofile  */
  YYSYMBOL_tablespace_name = 1092,         /* tablespace_name  */
  YYSYMBOL_logfile_group_name = 1093,      /* logfile_group_name  */
  YYSYMBOL_ts_access_mode = 1094,          /* ts_access_mode  */
  YYSYMBOL_opt_ts_initial_size = 1095,     /* opt_ts_initial_size  */
  YYSYMBOL_opt_ts_autoextend_size = 1096,  /* opt_ts_autoextend_size  */
  YYSYMBOL_opt_ts_max_size = 1097,         /* opt_ts_max_size  */
  YYSYMBOL_opt_ts_extent_size = 1098,      /* opt_ts_extent_size  */
  YYSYMBOL_opt_ts_undo_buffer_size = 1099, /* opt_ts_undo_buffer_size  */
  YYSYMBOL_opt_ts_redo_buffer_size = 1100, /* opt_ts_redo_buffer_size  */
  YYSYMBOL_opt_ts_nodegroup = 1101,        /* opt_ts_nodegroup  */
  YYSYMBOL_opt_ts_comment = 1102,          /* opt_ts_comment  */
  YYSYMBOL_opt_ts_engine = 1103,           /* opt_ts_engine  */
  YYSYMBOL_opt_ts_wait = 1104,             /* opt_ts_wait  */
  YYSYMBOL_ts_wait = 1105,                 /* ts_wait  */
  YYSYMBOL_size_number = 1106,             /* size_number  */
  YYSYMBOL_create_body = 1107,             /* create_body  */
  YYSYMBOL_1108_96 = 1108,                 /* $@96  */
  YYSYMBOL_create_like = 1109,             /* create_like  */
  YYSYMBOL_opt_create_select = 1110,       /* opt_create_select  */
  YYSYMBOL_create_select_query_expression = 1111, /* create_select_query_expression  */
  YYSYMBOL_opt_create_partitioning = 1112, /* opt_create_partitioning  */
  YYSYMBOL_opt_partitioning = 1113,        /* opt_partitioning  */
  YYSYMBOL_partitioning = 1114,            /* partitioning  */
  YYSYMBOL_1115_97 = 1115,                 /* $@97  */
  YYSYMBOL_have_partitioning = 1116,       /* have_partitioning  */
  YYSYMBOL_partition_entry = 1117,         /* partition_entry  */
  YYSYMBOL_1118_98 = 1118,                 /* $@98  */
  YYSYMBOL_partition = 1119,               /* partition  */
  YYSYMBOL_1120_99 = 1120,                 /* $@99  */
  YYSYMBOL_part_type_def = 1121,           /* part_type_def  */
  YYSYMBOL_1122_100 = 1122,                /* $@100  */
  YYSYMBOL_1123_101 = 1123,                /* $@101  */
  YYSYMBOL_1124_102 = 1124,                /* $@102  */
  YYSYMBOL_opt_linear = 1125,              /* opt_linear  */
  YYSYMBOL_opt_key_algo = 1126,            /* opt_key_algo  */
  YYSYMBOL_part_field_list = 1127,         /* part_field_list  */
  YYSYMBOL_part_field_item_list = 1128,    /* part_field_item_list  */
  YYSYMBOL_part_field_item = 1129,         /* part_field_item  */
  YYSYMBOL_part_column_list = 1130,        /* part_column_list  */
  YYSYMBOL_part_func = 1131,               /* part_func  */
  YYSYMBOL_sub_part_func = 1132,           /* sub_part_func  */
  YYSYMBOL_opt_num_parts = 1133,           /* opt_num_parts  */
  YYSYMBOL_opt_sub_part = 1134,            /* opt_sub_part  */
  YYSYMBOL_1135_103 = 1135,                /* $@103  */
  YYSYMBOL_1136_104 = 1136,                /* $@104  */
  YYSYMBOL_sub_part_field_list = 1137,     /* sub_part_field_list  */
  YYSYMBOL_sub_part_field_item = 1138,     /* sub_part_field_item  */
  YYSYMBOL_part_func_expr = 1139,          /* part_func_expr  */
  YYSYMBOL_opt_num_subparts = 1140,        /* opt_num_subparts  */
  YYSYMBOL_part_defs = 1141,               /* part_defs  */
  YYSYMBOL_part_def_list = 1142,           /* part_def_list  */
  YYSYMBOL_part_definition = 1143,         /* part_definition  */
  YYSYMBOL_1144_105 = 1144,                /* $@105  */
  YYSYMBOL_part_name = 1145,               /* part_name  */
  YYSYMBOL_opt_part_values = 1146,         /* opt_part_values  */
  YYSYMBOL_1147_106 = 1147,                /* $@106  */
  YYSYMBOL_1148_107 = 1148,                /* $@107  */
  YYSYMBOL_part_func_max = 1149,           /* part_func_max  */
  YYSYMBOL_part_values_in = 1150,          /* part_values_in  */
  YYSYMBOL_part_value_list = 1151,         /* part_value_list  */
  YYSYMBOL_part_value_item = 1152,         /* part_value_item  */
  YYSYMBOL_1153_108 = 1153,                /* $@108  */
  YYSYMBOL_1154_109 = 1154,                /* $@109  */
  YYSYMBOL_part_value_item_list = 1155,    /* part_value_item_list  */
  YYSYMBOL_part_value_expr_item = 1156,    /* part_value_expr_item  */
  YYSYMBOL_opt_sub_partition = 1157,       /* opt_sub_partition  */
  YYSYMBOL_sub_part_list = 1158,           /* sub_part_list  */
  YYSYMBOL_sub_part_definition = 1159,     /* sub_part_definition  */
  YYSYMBOL_1160_110 = 1160,                /* $@110  */
  YYSYMBOL_sub_name = 1161,                /* sub_name  */
  YYSYMBOL_opt_part_options = 1162,        /* opt_part_options  */
  YYSYMBOL_opt_part_option_list = 1163,    /* opt_part_option_list  */
  YYSYMBOL_opt_part_option = 1164,         /* opt_part_option  */
  YYSYMBOL_opt_versioning_rotation = 1165, /* opt_versioning_rotation  */
  YYSYMBOL_1166_111 = 1166,                /* $@111  */
  YYSYMBOL_opt_versioning_interval_start = 1167, /* opt_versioning_interval_start  */
  YYSYMBOL_opt_as = 1168,                  /* opt_as  */
  YYSYMBOL_opt_create_database_options = 1169, /* opt_create_database_options  */
  YYSYMBOL_create_database_options = 1170, /* create_database_options  */
  YYSYMBOL_create_database_option = 1171,  /* create_database_option  */
  YYSYMBOL_opt_if_not_exists_table_element = 1172, /* opt_if_not_exists_table_element  */
  YYSYMBOL_opt_if_not_exists = 1173,       /* opt_if_not_exists  */
  YYSYMBOL_create_or_replace = 1174,       /* create_or_replace  */
  YYSYMBOL_opt_create_table_options = 1175, /* opt_create_table_options  */
  YYSYMBOL_create_table_options_space_separated = 1176, /* create_table_options_space_separated  */
  YYSYMBOL_create_table_options = 1177,    /* create_table_options  */
  YYSYMBOL_create_table_option = 1178,     /* create_table_option  */
  YYSYMBOL_1179_112 = 1179,                /* $@112  */
  YYSYMBOL_opt_versioning_option = 1180,   /* opt_versioning_option  */
  YYSYMBOL_versioning_option = 1181,       /* versioning_option  */
  YYSYMBOL_default_charset = 1182,         /* default_charset  */
  YYSYMBOL_default_collation = 1183,       /* default_collation  */
  YYSYMBOL_storage_engines = 1184,         /* storage_engines  */
  YYSYMBOL_known_storage_engines = 1185,   /* known_storage_engines  */
  YYSYMBOL_row_types = 1186,               /* row_types  */
  YYSYMBOL_merge_insert_types = 1187,      /* merge_insert_types  */
  YYSYMBOL_udf_type = 1188,                /* udf_type  */
  YYSYMBOL_create_field_list = 1189,       /* create_field_list  */
  YYSYMBOL_create_field_list_parens = 1190, /* create_field_list_parens  */
  YYSYMBOL_field_list = 1191,              /* field_list  */
  YYSYMBOL_field_list_item = 1192,         /* field_list_item  */
  YYSYMBOL_column_def = 1193,              /* column_def  */
  YYSYMBOL_key_def = 1194,                 /* key_def  */
  YYSYMBOL_1195_113 = 1195,                /* $@113  */
  YYSYMBOL_1196_114 = 1196,                /* $@114  */
  YYSYMBOL_1197_115 = 1197,                /* $@115  */
  YYSYMBOL_1198_116 = 1198,                /* $@116  */
  YYSYMBOL_1199_117 = 1199,                /* $@117  */
  YYSYMBOL_1200_118 = 1200,                /* $@118  */
  YYSYMBOL_1201_119 = 1201,                /* $@119  */
  YYSYMBOL_constraint_def = 1202,          /* constraint_def  */
  YYSYMBOL_period_for_system_time = 1203,  /* period_for_system_time  */
  YYSYMBOL_period_for_application_time = 1204, /* period_for_application_time  */
  YYSYMBOL_opt_check_constraint = 1205,    /* opt_check_constraint  */
  YYSYMBOL_check_constraint = 1206,        /* check_constraint  */
  YYSYMBOL_opt_constraint_no_id = 1207,    /* opt_constraint_no_id  */
  YYSYMBOL_opt_constraint = 1208,          /* opt_constraint  */
  YYSYMBOL_constraint = 1209,              /* constraint  */
  YYSYMBOL_field_spec = 1210,              /* field_spec  */
  YYSYMBOL_1211_120 = 1211,                /* @120  */
  YYSYMBOL_field_type_or_serial = 1212,    /* field_type_or_serial  */
  YYSYMBOL_1213_121 = 1213,                /* $@121  */
  YYSYMBOL_1214_122 = 1214,                /* $@122  */
  YYSYMBOL_opt_serial_attribute = 1215,    /* opt_serial_attribute  */
  YYSYMBOL_opt_serial_attribute_list = 1216, /* opt_serial_attribute_list  */
  YYSYMBOL_opt_asrow_attribute = 1217,     /* opt_asrow_attribute  */
  YYSYMBOL_opt_asrow_attribute_list = 1218, /* opt_asrow_attribute_list  */
  YYSYMBOL_field_def = 1219,               /* field_def  */
  YYSYMBOL_1220_123 = 1220,                /* $@123  */
  YYSYMBOL_opt_generated_always = 1221,    /* opt_generated_always  */
  YYSYMBOL_vcol_opt_specifier = 1222,      /* vcol_opt_specifier  */
  YYSYMBOL_vcol_opt_attribute = 1223,      /* vcol_opt_attribute  */
  YYSYMBOL_vcol_opt_attribute_list = 1224, /* vcol_opt_attribute_list  */
  YYSYMBOL_vcol_attribute = 1225,          /* vcol_attribute  */
  YYSYMBOL_parse_vcol_expr = 1226,         /* parse_vcol_expr  */
  YYSYMBOL_1227_124 = 1227,                /* $@124  */
  YYSYMBOL_parenthesized_expr = 1228,      /* parenthesized_expr  */
  YYSYMBOL_virtual_column_func = 1229,     /* virtual_column_func  */
  YYSYMBOL_expr_or_literal = 1230,         /* expr_or_literal  */
  YYSYMBOL_column_default_expr = 1231,     /* column_default_expr  */
  YYSYMBOL_field_type = 1232,              /* field_type  */
  YYSYMBOL_qualified_field_type = 1233,    /* qualified_field_type  */
  YYSYMBOL_field_type_all = 1234,          /* field_type_all  */
  YYSYMBOL_sp_param_field_type = 1235,     /* sp_param_field_type  */
  YYSYMBOL_field_type_numeric = 1236,      /* field_type_numeric  */
  YYSYMBOL_opt_binary_and_compression = 1237, /* opt_binary_and_compression  */
  YYSYMBOL_field_type_string = 1238,       /* field_type_string  */
  YYSYMBOL_sp_param_field_type_string = 1239, /* sp_param_field_type_string  */
  YYSYMBOL_field_type_temporal = 1240,     /* field_type_temporal  */
  YYSYMBOL_field_type_lob = 1241,          /* field_type_lob  */
  YYSYMBOL_field_type_misc = 1242,         /* field_type_misc  */
  YYSYMBOL_spatial_type = 1243,            /* spatial_type  */
  YYSYMBOL_char = 1244,                    /* char  */
  YYSYMBOL_nchar = 1245,                   /* nchar  */
  YYSYMBOL_varchar = 1246,                 /* varchar  */
  YYSYMBOL_nvarchar = 1247,                /* nvarchar  */
  YYSYMBOL_int_type = 1248,                /* int_type  */
  YYSYMBOL_real_type = 1249,               /* real_type  */
  YYSYMBOL_srid_option = 1250,             /* srid_option  */
  YYSYMBOL_float_options = 1251,           /* float_options  */
  YYSYMBOL_precision = 1252,               /* precision  */
  YYSYMBOL_field_options = 1253,           /* field_options  */
  YYSYMBOL_field_length = 1254,            /* field_length  */
  YYSYMBOL_opt_field_length = 1255,        /* opt_field_length  */
  YYSYMBOL_opt_field_length_default_1 = 1256, /* opt_field_length_default_1  */
  YYSYMBOL_opt_field_length_default_sp_param_varchar = 1257, /* opt_field_length_default_sp_param_varchar  */
  YYSYMBOL_opt_field_length_default_sp_param_char = 1258, /* opt_field_length_default_sp_param_char  */
  YYSYMBOL_opt_precision = 1259,           /* opt_precision  */
  YYSYMBOL_attribute_list = 1260,          /* attribute_list  */
  YYSYMBOL_attribute = 1261,               /* attribute  */
  YYSYMBOL_opt_compression_method = 1262,  /* opt_compression_method  */
  YYSYMBOL_opt_compressed = 1263,          /* opt_compressed  */
  YYSYMBOL_compressed = 1264,              /* compressed  */
  YYSYMBOL_compressed_deprecated_data_type_attribute = 1265, /* compressed_deprecated_data_type_attribute  */
  YYSYMBOL_compressed_deprecated_column_attribute = 1266, /* compressed_deprecated_column_attribute  */
  YYSYMBOL_asrow_attribute = 1267,         /* asrow_attribute  */
  YYSYMBOL_serial_attribute = 1268,        /* serial_attribute  */
  YYSYMBOL_with_or_without_system = 1269,  /* with_or_without_system  */
  YYSYMBOL_sp_param_type = 1270,           /* sp_param_type  */
  YYSYMBOL_charset = 1271,                 /* charset  */
  YYSYMBOL_charset_name = 1272,            /* charset_name  */
  YYSYMBOL_charset_name_or_default = 1273, /* charset_name_or_default  */
  YYSYMBOL_opt_load_data_charset = 1274,   /* opt_load_data_charset  */
  YYSYMBOL_old_or_new_charset_name = 1275, /* old_or_new_charset_name  */
  YYSYMBOL_old_or_new_charset_name_or_default = 1276, /* old_or_new_charset_name_or_default  */
  YYSYMBOL_collation_name = 1277,          /* collation_name  */
  YYSYMBOL_opt_collate = 1278,             /* opt_collate  */
  YYSYMBOL_collation_name_or_default = 1279, /* collation_name_or_default  */
  YYSYMBOL_opt_default = 1280,             /* opt_default  */
  YYSYMBOL_charset_or_alias = 1281,        /* charset_or_alias  */
  YYSYMBOL_collate = 1282,                 /* collate  */
  YYSYMBOL_opt_binary = 1283,              /* opt_binary  */
  YYSYMBOL_binary = 1284,                  /* binary  */
  YYSYMBOL_opt_bin_mod = 1285,             /* opt_bin_mod  */
  YYSYMBOL_ws_nweights = 1286,             /* ws_nweights  */
  YYSYMBOL_1287_125 = 1287,                /* $@125  */
  YYSYMBOL_ws_level_flag_desc = 1288,      /* ws_level_flag_desc  */
  YYSYMBOL_ws_level_flag_reverse = 1289,   /* ws_level_flag_reverse  */
  YYSYMBOL_ws_level_flags = 1290,          /* ws_level_flags  */
  YYSYMBOL_ws_level_number = 1291,         /* ws_level_number  */
  YYSYMBOL_ws_level_list_item = 1292,      /* ws_level_list_item  */
  YYSYMBOL_ws_level_list = 1293,           /* ws_level_list  */
  YYSYMBOL_ws_level_range = 1294,          /* ws_level_range  */
  YYSYMBOL_ws_level_list_or_range = 1295,  /* ws_level_list_or_range  */
  YYSYMBOL_opt_ws_levels = 1296,           /* opt_ws_levels  */
  YYSYMBOL_opt_primary = 1297,             /* opt_primary  */
  YYSYMBOL_references = 1298,              /* references  */
  YYSYMBOL_opt_ref_list = 1299,            /* opt_ref_list  */
  YYSYMBOL_ref_list = 1300,                /* ref_list  */
  YYSYMBOL_opt_match_clause = 1301,        /* opt_match_clause  */
  YYSYMBOL_opt_on_update_delete = 1302,    /* opt_on_update_delete  */
  YYSYMBOL_delete_option = 1303,           /* delete_option  */
  YYSYMBOL_constraint_key_type = 1304,     /* constraint_key_type  */
  YYSYMBOL_key_or_index = 1305,            /* key_or_index  */
  YYSYMBOL_opt_key_or_index = 1306,        /* opt_key_or_index  */
  YYSYMBOL_keys_or_index = 1307,           /* keys_or_index  */
  YYSYMBOL_opt_unique = 1308,              /* opt_unique  */
  YYSYMBOL_fulltext = 1309,                /* fulltext  */
  YYSYMBOL_spatial = 1310,                 /* spatial  */
  YYSYMBOL_normal_key_options = 1311,      /* normal_key_options  */
  YYSYMBOL_fulltext_key_options = 1312,    /* fulltext_key_options  */
  YYSYMBOL_spatial_key_options = 1313,     /* spatial_key_options  */
  YYSYMBOL_normal_key_opts = 1314,         /* normal_key_opts  */
  YYSYMBOL_spatial_key_opts = 1315,        /* spatial_key_opts  */
  YYSYMBOL_fulltext_key_opts = 1316,       /* fulltext_key_opts  */
  YYSYMBOL_opt_USING_key_algorithm = 1317, /* opt_USING_key_algorithm  */
  YYSYMBOL_opt_key_algorithm_clause = 1318, /* opt_key_algorithm_clause  */
  YYSYMBOL_key_using_alg = 1319,           /* key_using_alg  */
  YYSYMBOL_all_key_opt = 1320,             /* all_key_opt  */
  YYSYMBOL_normal_key_opt = 1321,          /* normal_key_opt  */
  YYSYMBOL_spatial_key_opt = 1322,         /* spatial_key_opt  */
  YYSYMBOL_fulltext_key_opt = 1323,        /* fulltext_key_opt  */
  YYSYMBOL_btree_or_rtree = 1324,          /* btree_or_rtree  */
  YYSYMBOL_key_list = 1325,                /* key_list  */
  YYSYMBOL_key_part = 1326,                /* key_part  */
  YYSYMBOL_opt_ident = 1327,               /* opt_ident  */
  YYSYMBOL_string_list = 1328,             /* string_list  */
  YYSYMBOL_alter = 1329,                   /* alter  */
  YYSYMBOL_1330_126 = 1330,                /* $@126  */
  YYSYMBOL_1331_127 = 1331,                /* $@127  */
  YYSYMBOL_1332_128 = 1332,                /* $@128  */
  YYSYMBOL_1333_129 = 1333,                /* $@129  */
  YYSYMBOL_1334_130 = 1334,                /* $@130  */
  YYSYMBOL_1335_131 = 1335,                /* $@131  */
  YYSYMBOL_1336_132 = 1336,                /* $@132  */
  YYSYMBOL_1337_133 = 1337,                /* $@133  */
  YYSYMBOL_1338_134 = 1338,                /* $@134  */
  YYSYMBOL_1339_135 = 1339,                /* $@135  */
  YYSYMBOL_1340_136 = 1340,                /* $@136  */
  YYSYMBOL_account_locking_option = 1341,  /* account_locking_option  */
  YYSYMBOL_opt_password_expire_option = 1342, /* opt_password_expire_option  */
  YYSYMBOL_opt_account_locking_and_opt_password_expiration = 1343, /* opt_account_locking_and_opt_password_expiration  */
  YYSYMBOL_ev_alter_on_schedule_completion = 1344, /* ev_alter_on_schedule_completion  */
  YYSYMBOL_opt_ev_rename_to = 1345,        /* opt_ev_rename_to  */
  YYSYMBOL_opt_ev_sql_stmt = 1346,         /* opt_ev_sql_stmt  */
  YYSYMBOL_ident_or_empty = 1347,          /* ident_or_empty  */
  YYSYMBOL_alter_commands = 1348,          /* alter_commands  */
  YYSYMBOL_1349_137 = 1349,                /* $@137  */
  YYSYMBOL_1350_138 = 1350,                /* $@138  */
  YYSYMBOL_1351_139 = 1351,                /* $@139  */
  YYSYMBOL_remove_partitioning = 1352,     /* remove_partitioning  */
  YYSYMBOL_all_or_alt_part_name_list = 1353, /* all_or_alt_part_name_list  */
  YYSYMBOL_add_partition_rule = 1354,      /* add_partition_rule  */
  YYSYMBOL_1355_140 = 1355,                /* $@140  */
  YYSYMBOL_add_part_extra = 1356,          /* add_part_extra  */
  YYSYMBOL_reorg_partition_rule = 1357,    /* reorg_partition_rule  */
  YYSYMBOL_1358_141 = 1358,                /* $@141  */
  YYSYMBOL_reorg_parts_rule = 1359,        /* reorg_parts_rule  */
  YYSYMBOL_1360_142 = 1360,                /* $@142  */
  YYSYMBOL_alt_part_name_list = 1361,      /* alt_part_name_list  */
  YYSYMBOL_alt_part_name_item = 1362,      /* alt_part_name_item  */
  YYSYMBOL_alter_list = 1363,              /* alter_list  */
  YYSYMBOL_add_column = 1364,              /* add_column  */
  YYSYMBOL_alter_list_item = 1365,         /* alter_list_item  */
  YYSYMBOL_opt_index_lock_algorithm = 1366, /* opt_index_lock_algorithm  */
  YYSYMBOL_alter_algorithm_option = 1367,  /* alter_algorithm_option  */
  YYSYMBOL_alter_lock_option = 1368,       /* alter_lock_option  */
  YYSYMBOL_opt_column = 1369,              /* opt_column  */
  YYSYMBOL_opt_ignore = 1370,              /* opt_ignore  */
  YYSYMBOL_alter_options = 1371,           /* alter_options  */
  YYSYMBOL_1372_143 = 1372,                /* $@143  */
  YYSYMBOL_alter_options_part2 = 1373,     /* alter_options_part2  */
  YYSYMBOL_alter_option_list = 1374,       /* alter_option_list  */
  YYSYMBOL_alter_option = 1375,            /* alter_option  */
  YYSYMBOL_opt_restrict = 1376,            /* opt_restrict  */
  YYSYMBOL_opt_place = 1377,               /* opt_place  */
  YYSYMBOL_opt_to = 1378,                  /* opt_to  */
  YYSYMBOL_slave = 1379,                   /* slave  */
  YYSYMBOL_1380_144 = 1380,                /* $@144  */
  YYSYMBOL_1381_145 = 1381,                /* $@145  */
  YYSYMBOL_start = 1382,                   /* start  */
  YYSYMBOL_opt_start_transaction_option_list = 1383, /* opt_start_transaction_option_list  */
  YYSYMBOL_start_transaction_option_list = 1384, /* start_transaction_option_list  */
  YYSYMBOL_start_transaction_option = 1385, /* start_transaction_option  */
  YYSYMBOL_slave_thread_opts = 1386,       /* slave_thread_opts  */
  YYSYMBOL_1387_146 = 1387,                /* $@146  */
  YYSYMBOL_slave_thread_opt_list = 1388,   /* slave_thread_opt_list  */
  YYSYMBOL_slave_thread_opt = 1389,        /* slave_thread_opt  */
  YYSYMBOL_slave_until = 1390,             /* slave_until  */
  YYSYMBOL_slave_until_opts = 1391,        /* slave_until_opts  */
  YYSYMBOL_checksum = 1392,                /* checksum  */
  YYSYMBOL_1393_147 = 1393,                /* $@147  */
  YYSYMBOL_opt_checksum_type = 1394,       /* opt_checksum_type  */
  YYSYMBOL_repair_table_or_view = 1395,    /* repair_table_or_view  */
  YYSYMBOL_1396_148 = 1396,                /* $@148  */
  YYSYMBOL_repair = 1397,                  /* repair  */
  YYSYMBOL_1398_149 = 1398,                /* $@149  */
  YYSYMBOL_opt_mi_repair_type = 1399,      /* opt_mi_repair_type  */
  YYSYMBOL_mi_repair_types = 1400,         /* mi_repair_types  */
  YYSYMBOL_mi_repair_type = 1401,          /* mi_repair_type  */
  YYSYMBOL_opt_view_repair_type = 1402,    /* opt_view_repair_type  */
  YYSYMBOL_analyze = 1403,                 /* analyze  */
  YYSYMBOL_1404_150 = 1404,                /* $@150  */
  YYSYMBOL_analyze_table_list = 1405,      /* analyze_table_list  */
  YYSYMBOL_analyze_table_elem_spec = 1406, /* analyze_table_elem_spec  */
  YYSYMBOL_opt_persistent_stat_clause = 1407, /* opt_persistent_stat_clause  */
  YYSYMBOL_persistent_stat_spec = 1408,    /* persistent_stat_spec  */
  YYSYMBOL_persistent_column_stat_spec = 1409, /* persistent_column_stat_spec  */
  YYSYMBOL_1410_151 = 1410,                /* $@151  */
  YYSYMBOL_persistent_index_stat_spec = 1411, /* persistent_index_stat_spec  */
  YYSYMBOL_1412_152 = 1412,                /* $@152  */
  YYSYMBOL_table_column_list = 1413,       /* table_column_list  */
  YYSYMBOL_table_index_list = 1414,        /* table_index_list  */
  YYSYMBOL_table_index_name = 1415,        /* table_index_name  */
  YYSYMBOL_binlog_base64_event = 1416,     /* binlog_base64_event  */
  YYSYMBOL_check_view_or_table = 1417,     /* check_view_or_table  */
  YYSYMBOL_1418_153 = 1418,                /* $@153  */
  YYSYMBOL_check = 1419,                   /* check  */
  YYSYMBOL_1420_154 = 1420,                /* $@154  */
  YYSYMBOL_opt_mi_check_type = 1421,       /* opt_mi_check_type  */
  YYSYMBOL_mi_check_types = 1422,          /* mi_check_types  */
  YYSYMBOL_mi_check_type = 1423,           /* mi_check_type  */
  YYSYMBOL_opt_view_check_type = 1424,     /* opt_view_check_type  */
  YYSYMBOL_optimize = 1425,                /* optimize  */
  YYSYMBOL_1426_155 = 1426,                /* $@155  */
  YYSYMBOL_opt_no_write_to_binlog = 1427,  /* opt_no_write_to_binlog  */
  YYSYMBOL_rename = 1428,                  /* rename  */
  YYSYMBOL_1429_156 = 1429,                /* $@156  */
  YYSYMBOL_rename_list = 1430,             /* rename_list  */
  YYSYMBOL_table_to_table_list = 1431,     /* table_to_table_list  */
  YYSYMBOL_table_to_table = 1432,          /* table_to_table  */
  YYSYMBOL_keycache = 1433,                /* keycache  */
  YYSYMBOL_1434_157 = 1434,                /* $@157  */
  YYSYMBOL_keycache_list_or_parts = 1435,  /* keycache_list_or_parts  */
  YYSYMBOL_keycache_list = 1436,           /* keycache_list  */
  YYSYMBOL_assign_to_keycache = 1437,      /* assign_to_keycache  */
  YYSYMBOL_assign_to_keycache_parts = 1438, /* assign_to_keycache_parts  */
  YYSYMBOL_key_cache_name = 1439,          /* key_cache_name  */
  YYSYMBOL_preload = 1440,                 /* preload  */
  YYSYMBOL_1441_158 = 1441,                /* $@158  */
  YYSYMBOL_preload_list_or_parts = 1442,   /* preload_list_or_parts  */
  YYSYMBOL_preload_list = 1443,            /* preload_list  */
  YYSYMBOL_preload_keys = 1444,            /* preload_keys  */
  YYSYMBOL_preload_keys_parts = 1445,      /* preload_keys_parts  */
  YYSYMBOL_adm_partition = 1446,           /* adm_partition  */
  YYSYMBOL_1447_159 = 1447,                /* $@159  */
  YYSYMBOL_cache_keys_spec = 1448,         /* cache_keys_spec  */
  YYSYMBOL_1449_160 = 1449,                /* $@160  */
  YYSYMBOL_cache_key_list_or_empty = 1450, /* cache_key_list_or_empty  */
  YYSYMBOL_opt_ignore_leaves = 1451,       /* opt_ignore_leaves  */
  YYSYMBOL_select = 1452,                  /* select  */
  YYSYMBOL_1453_161 = 1453,                /* $@161  */
  YYSYMBOL_1454_162 = 1454,                /* $@162  */
  YYSYMBOL_select_into = 1455,             /* select_into  */
  YYSYMBOL_1456_163 = 1456,                /* $@163  */
  YYSYMBOL_1457_164 = 1457,                /* $@164  */
  YYSYMBOL_simple_table = 1458,            /* simple_table  */
  YYSYMBOL_table_value_constructor = 1459, /* table_value_constructor  */
  YYSYMBOL_1460_165 = 1460,                /* $@165  */
  YYSYMBOL_query_specification_start = 1461, /* query_specification_start  */
  YYSYMBOL_1462_166 = 1462,                /* $@166  */
  YYSYMBOL_1463_167 = 1463,                /* $@167  */
  YYSYMBOL_query_specification = 1464,     /* query_specification  */
  YYSYMBOL_select_into_query_specification = 1465, /* select_into_query_specification  */
  YYSYMBOL_query_expression = 1466,        /* query_expression  */
  YYSYMBOL_query_expression_no_with_clause = 1467, /* query_expression_no_with_clause  */
  YYSYMBOL_query_expression_body_ext = 1468, /* query_expression_body_ext  */
  YYSYMBOL_1469_168 = 1469,                /* $@168  */
  YYSYMBOL_1470_169 = 1470,                /* $@169  */
  YYSYMBOL_query_expression_body_ext_parens = 1471, /* query_expression_body_ext_parens  */
  YYSYMBOL_query_expression_body = 1472,   /* query_expression_body  */
  YYSYMBOL_1473_170 = 1473,                /* $@170  */
  YYSYMBOL_query_primary = 1474,           /* query_primary  */
  YYSYMBOL_query_simple = 1475,            /* query_simple  */
  YYSYMBOL_subselect = 1476,               /* subselect  */
  YYSYMBOL_subquery = 1477,                /* subquery  */
  YYSYMBOL_opt_from_clause = 1478,         /* opt_from_clause  */
  YYSYMBOL_from_clause = 1479,             /* from_clause  */
  YYSYMBOL_table_reference_list = 1480,    /* table_reference_list  */
  YYSYMBOL_select_options = 1481,          /* select_options  */
  YYSYMBOL_opt_history_unit = 1482,        /* opt_history_unit  */
  YYSYMBOL_history_point = 1483,           /* history_point  */
  YYSYMBOL_for_portion_of_time_clause = 1484, /* for_portion_of_time_clause  */
  YYSYMBOL_opt_for_portion_of_time_clause = 1485, /* opt_for_portion_of_time_clause  */
  YYSYMBOL_opt_for_system_time_clause = 1486, /* opt_for_system_time_clause  */
  YYSYMBOL_system_time_expr = 1487,        /* system_time_expr  */
  YYSYMBOL_select_option_list = 1488,      /* select_option_list  */
  YYSYMBOL_select_option = 1489,           /* select_option  */
  YYSYMBOL_select_lock_type = 1490,        /* select_lock_type  */
  YYSYMBOL_opt_select_lock_type = 1491,    /* opt_select_lock_type  */
  YYSYMBOL_opt_lock_wait_timeout_new = 1492, /* opt_lock_wait_timeout_new  */
  YYSYMBOL_select_item_list = 1493,        /* select_item_list  */
  YYSYMBOL_select_item = 1494,             /* select_item  */
  YYSYMBOL_remember_tok_start = 1495,      /* remember_tok_start  */
  YYSYMBOL_remember_name = 1496,           /* remember_name  */
  YYSYMBOL_remember_end = 1497,            /* remember_end  */
  YYSYMBOL_remember_end_opt = 1498,        /* remember_end_opt  */
  YYSYMBOL_select_alias = 1499,            /* select_alias  */
  YYSYMBOL_opt_default_time_precision = 1500, /* opt_default_time_precision  */
  YYSYMBOL_opt_time_precision = 1501,      /* opt_time_precision  */
  YYSYMBOL_optional_braces = 1502,         /* optional_braces  */
  YYSYMBOL_expr = 1503,                    /* expr  */
  YYSYMBOL_boolean_test = 1504,            /* boolean_test  */
  YYSYMBOL_predicate = 1505,               /* predicate  */
  YYSYMBOL_bit_expr = 1506,                /* bit_expr  */
  YYSYMBOL_or = 1507,                      /* or  */
  YYSYMBOL_and = 1508,                     /* and  */
  YYSYMBOL_not = 1509,                     /* not  */
  YYSYMBOL_not2 = 1510,                    /* not2  */
  YYSYMBOL_comp_op = 1511,                 /* comp_op  */
  YYSYMBOL_all_or_any = 1512,              /* all_or_any  */
  YYSYMBOL_opt_dyncol_type = 1513,         /* opt_dyncol_type  */
  YYSYMBOL_dyncol_type = 1514,             /* dyncol_type  */
  YYSYMBOL_numeric_dyncol_type = 1515,     /* numeric_dyncol_type  */
  YYSYMBOL_temporal_dyncol_type = 1516,    /* temporal_dyncol_type  */
  YYSYMBOL_string_dyncol_type = 1517,      /* string_dyncol_type  */
  YYSYMBOL_1518_171 = 1518,                /* $@171  */
  YYSYMBOL_dyncall_create_element = 1519,  /* dyncall_create_element  */
  YYSYMBOL_dyncall_create_list = 1520,     /* dyncall_create_list  */
  YYSYMBOL_plsql_cursor_attr = 1521,       /* plsql_cursor_attr  */
  YYSYMBOL_explicit_cursor_attr = 1522,    /* explicit_cursor_attr  */
  YYSYMBOL_trim_operands = 1523,           /* trim_operands  */
  YYSYMBOL_column_default_non_parenthesized_expr = 1524, /* column_default_non_parenthesized_expr  */
  YYSYMBOL_primary_expr = 1525,            /* primary_expr  */
  YYSYMBOL_string_factor_expr = 1526,      /* string_factor_expr  */
  YYSYMBOL_simple_expr = 1527,             /* simple_expr  */
  YYSYMBOL_mysql_concatenation_expr = 1528, /* mysql_concatenation_expr  */
  YYSYMBOL_function_call_keyword_timestamp = 1529, /* function_call_keyword_timestamp  */
  YYSYMBOL_function_call_keyword = 1530,   /* function_call_keyword  */
  YYSYMBOL_substring_operands = 1531,      /* substring_operands  */
  YYSYMBOL_function_call_nonkeyword = 1532, /* function_call_nonkeyword  */
  YYSYMBOL_function_call_conflict = 1533,  /* function_call_conflict  */
  YYSYMBOL_geometry_function = 1534,       /* geometry_function  */
  YYSYMBOL_function_call_generic = 1535,   /* function_call_generic  */
  YYSYMBOL_1536_172 = 1536,                /* @172  */
  YYSYMBOL_fulltext_options = 1537,        /* fulltext_options  */
  YYSYMBOL_opt_natural_language_mode = 1538, /* opt_natural_language_mode  */
  YYSYMBOL_opt_query_expansion = 1539,     /* opt_query_expansion  */
  YYSYMBOL_opt_udf_expr_list = 1540,       /* opt_udf_expr_list  */
  YYSYMBOL_udf_expr_list = 1541,           /* udf_expr_list  */
  YYSYMBOL_udf_expr = 1542,                /* udf_expr  */
  YYSYMBOL_sum_expr = 1543,                /* sum_expr  */
  YYSYMBOL_1544_173 = 1544,                /* $@173  */
  YYSYMBOL_1545_174 = 1545,                /* $@174  */
  YYSYMBOL_1546_175 = 1546,                /* $@175  */
  YYSYMBOL_window_func_expr = 1547,        /* window_func_expr  */
  YYSYMBOL_window_func = 1548,             /* window_func  */
  YYSYMBOL_simple_window_func = 1549,      /* simple_window_func  */
  YYSYMBOL_inverse_distribution_function = 1550, /* inverse_distribution_function  */
  YYSYMBOL_percentile_function = 1551,     /* percentile_function  */
  YYSYMBOL_1552_176 = 1552,                /* $@176  */
  YYSYMBOL_inverse_distribution_function_def = 1553, /* inverse_distribution_function_def  */
  YYSYMBOL_order_by_single_element_list = 1554, /* order_by_single_element_list  */
  YYSYMBOL_window_name = 1555,             /* window_name  */
  YYSYMBOL_variable = 1556,                /* variable  */
  YYSYMBOL_1557_177 = 1557,                /* $@177  */
  YYSYMBOL_variable_aux = 1558,            /* variable_aux  */
  YYSYMBOL_opt_distinct = 1559,            /* opt_distinct  */
  YYSYMBOL_opt_gconcat_separator = 1560,   /* opt_gconcat_separator  */
  YYSYMBOL_opt_gorder_clause = 1561,       /* opt_gorder_clause  */
  YYSYMBOL_gorder_list = 1562,             /* gorder_list  */
  YYSYMBOL_opt_glimit_clause = 1563,       /* opt_glimit_clause  */
  YYSYMBOL_glimit_clause_init = 1564,      /* glimit_clause_init  */
  YYSYMBOL_glimit_clause = 1565,           /* glimit_clause  */
  YYSYMBOL_glimit_options = 1566,          /* glimit_options  */
  YYSYMBOL_in_sum_expr = 1567,             /* in_sum_expr  */
  YYSYMBOL_1568_178 = 1568,                /* $@178  */
  YYSYMBOL_cast_type = 1569,               /* cast_type  */
  YYSYMBOL_1570_179 = 1570,                /* $@179  */
  YYSYMBOL_1571_180 = 1571,                /* $@180  */
  YYSYMBOL_1572_181 = 1572,                /* $@181  */
  YYSYMBOL_cast_type_numeric = 1573,       /* cast_type_numeric  */
  YYSYMBOL_cast_type_temporal = 1574,      /* cast_type_temporal  */
  YYSYMBOL_opt_expr_list = 1575,           /* opt_expr_list  */
  YYSYMBOL_expr_list = 1576,               /* expr_list  */
  YYSYMBOL_ident_list_arg = 1577,          /* ident_list_arg  */
  YYSYMBOL_ident_list = 1578,              /* ident_list  */
  YYSYMBOL_when_list = 1579,               /* when_list  */
  YYSYMBOL_when_list_opt_else = 1580,      /* when_list_opt_else  */
  YYSYMBOL_decode_when_list_oracle = 1581, /* decode_when_list_oracle  */
  YYSYMBOL_table_ref = 1582,               /* table_ref  */
  YYSYMBOL_join_table_list = 1583,         /* join_table_list  */
  YYSYMBOL_esc_table_ref = 1584,           /* esc_table_ref  */
  YYSYMBOL_derived_table_list = 1585,      /* derived_table_list  */
  YYSYMBOL_join_table = 1586,              /* join_table  */
  YYSYMBOL_1587_182 = 1587,                /* $@182  */
  YYSYMBOL_1588_183 = 1588,                /* $@183  */
  YYSYMBOL_1589_184 = 1589,                /* $@184  */
  YYSYMBOL_1590_185 = 1590,                /* $@185  */
  YYSYMBOL_1591_186 = 1591,                /* $@186  */
  YYSYMBOL_1592_187 = 1592,                /* $@187  */
  YYSYMBOL_inner_join = 1593,              /* inner_join  */
  YYSYMBOL_normal_join = 1594,             /* normal_join  */
  YYSYMBOL_opt_use_partition = 1595,       /* opt_use_partition  */
  YYSYMBOL_use_partition = 1596,           /* use_partition  */
  YYSYMBOL_table_factor = 1597,            /* table_factor  */
  YYSYMBOL_table_primary_ident_opt_parens = 1598, /* table_primary_ident_opt_parens  */
  YYSYMBOL_table_primary_derived_opt_parens = 1599, /* table_primary_derived_opt_parens  */
  YYSYMBOL_table_reference_list_parens = 1600, /* table_reference_list_parens  */
  YYSYMBOL_nested_table_reference_list = 1601, /* nested_table_reference_list  */
  YYSYMBOL_join_table_parens = 1602,       /* join_table_parens  */
  YYSYMBOL_table_primary_ident = 1603,     /* table_primary_ident  */
  YYSYMBOL_table_primary_derived = 1604,   /* table_primary_derived  */
  YYSYMBOL_opt_outer = 1605,               /* opt_outer  */
  YYSYMBOL_index_hint_clause = 1606,       /* index_hint_clause  */
  YYSYMBOL_index_hint_type = 1607,         /* index_hint_type  */
  YYSYMBOL_index_hint_definition = 1608,   /* index_hint_definition  */
  YYSYMBOL_1609_188 = 1609,                /* $@188  */
  YYSYMBOL_1610_189 = 1610,                /* $@189  */
  YYSYMBOL_index_hints_list = 1611,        /* index_hints_list  */
  YYSYMBOL_opt_index_hints_list = 1612,    /* opt_index_hints_list  */
  YYSYMBOL_1613_190 = 1613,                /* $@190  */
  YYSYMBOL_opt_key_definition = 1614,      /* opt_key_definition  */
  YYSYMBOL_1615_191 = 1615,                /* $@191  */
  YYSYMBOL_opt_key_usage_list = 1616,      /* opt_key_usage_list  */
  YYSYMBOL_key_usage_element = 1617,       /* key_usage_element  */
  YYSYMBOL_key_usage_list = 1618,          /* key_usage_list  */
  YYSYMBOL_using_list = 1619,              /* using_list  */
  YYSYMBOL_interval = 1620,                /* interval  */
  YYSYMBOL_interval_time_stamp = 1621,     /* interval_time_stamp  */
  YYSYMBOL_date_time_type = 1622,          /* date_time_type  */
  YYSYMBOL_table_alias = 1623,             /* table_alias  */
  YYSYMBOL_opt_table_alias_clause = 1624,  /* opt_table_alias_clause  */
  YYSYMBOL_table_alias_clause = 1625,      /* table_alias_clause  */
  YYSYMBOL_opt_all = 1626,                 /* opt_all  */
  YYSYMBOL_opt_where_clause = 1627,        /* opt_where_clause  */
  YYSYMBOL_1628_192 = 1628,                /* $@192  */
  YYSYMBOL_opt_having_clause = 1629,       /* opt_having_clause  */
  YYSYMBOL_1630_193 = 1630,                /* $@193  */
  YYSYMBOL_opt_group_clause = 1631,        /* opt_group_clause  */
  YYSYMBOL_group_list = 1632,              /* group_list  */
  YYSYMBOL_olap_opt = 1633,                /* olap_opt  */
  YYSYMBOL_opt_window_clause = 1634,       /* opt_window_clause  */
  YYSYMBOL_window_def_list = 1635,         /* window_def_list  */
  YYSYMBOL_window_def = 1636,              /* window_def  */
  YYSYMBOL_window_spec = 1637,             /* window_spec  */
  YYSYMBOL_1638_194 = 1638,                /* $@194  */
  YYSYMBOL_opt_window_ref = 1639,          /* opt_window_ref  */
  YYSYMBOL_opt_window_partition_clause = 1640, /* opt_window_partition_clause  */
  YYSYMBOL_opt_window_order_clause = 1641, /* opt_window_order_clause  */
  YYSYMBOL_opt_window_frame_clause = 1642, /* opt_window_frame_clause  */
  YYSYMBOL_window_frame_units = 1643,      /* window_frame_units  */
  YYSYMBOL_window_frame_extent = 1644,     /* window_frame_extent  */
  YYSYMBOL_window_frame_start = 1645,      /* window_frame_start  */
  YYSYMBOL_window_frame_bound = 1646,      /* window_frame_bound  */
  YYSYMBOL_opt_window_frame_exclusion = 1647, /* opt_window_frame_exclusion  */
  YYSYMBOL_alter_order_clause = 1648,      /* alter_order_clause  */
  YYSYMBOL_alter_order_list = 1649,        /* alter_order_list  */
  YYSYMBOL_alter_order_item = 1650,        /* alter_order_item  */
  YYSYMBOL_opt_order_clause = 1651,        /* opt_order_clause  */
  YYSYMBOL_order_clause = 1652,            /* order_clause  */
  YYSYMBOL_1653_195 = 1653,                /* $@195  */
  YYSYMBOL_order_list = 1654,              /* order_list  */
  YYSYMBOL_order_dir = 1655,               /* order_dir  */
  YYSYMBOL_opt_limit_clause = 1656,        /* opt_limit_clause  */
  YYSYMBOL_limit_clause = 1657,            /* limit_clause  */
  YYSYMBOL_opt_global_limit_clause = 1658, /* opt_global_limit_clause  */
  YYSYMBOL_limit_options = 1659,           /* limit_options  */
  YYSYMBOL_limit_option = 1660,            /* limit_option  */
  YYSYMBOL_limit_rows_option = 1661,       /* limit_rows_option  */
  YYSYMBOL_delete_limit_clause = 1662,     /* delete_limit_clause  */
  YYSYMBOL_order_limit_lock = 1663,        /* order_limit_lock  */
  YYSYMBOL_opt_order_limit_lock = 1664,    /* opt_order_limit_lock  */
  YYSYMBOL_query_expression_tail = 1665,   /* query_expression_tail  */
  YYSYMBOL_opt_query_expression_tail = 1666, /* opt_query_expression_tail  */
  YYSYMBOL_opt_procedure_or_into = 1667,   /* opt_procedure_or_into  */
  YYSYMBOL_order_or_limit = 1668,          /* order_or_limit  */
  YYSYMBOL_opt_plus = 1669,                /* opt_plus  */
  YYSYMBOL_int_num = 1670,                 /* int_num  */
  YYSYMBOL_ulong_num = 1671,               /* ulong_num  */
  YYSYMBOL_real_ulong_num = 1672,          /* real_ulong_num  */
  YYSYMBOL_longlong_num = 1673,            /* longlong_num  */
  YYSYMBOL_ulonglong_num = 1674,           /* ulonglong_num  */
  YYSYMBOL_real_ulonglong_num = 1675,      /* real_ulonglong_num  */
  YYSYMBOL_dec_num_error = 1676,           /* dec_num_error  */
  YYSYMBOL_dec_num = 1677,                 /* dec_num  */
  YYSYMBOL_choice = 1678,                  /* choice  */
  YYSYMBOL_bool = 1679,                    /* bool  */
  YYSYMBOL_procedure_clause = 1680,        /* procedure_clause  */
  YYSYMBOL_1681_196 = 1681,                /* $@196  */
  YYSYMBOL_procedure_list = 1682,          /* procedure_list  */
  YYSYMBOL_procedure_list2 = 1683,         /* procedure_list2  */
  YYSYMBOL_procedure_item = 1684,          /* procedure_item  */
  YYSYMBOL_select_var_list_init = 1685,    /* select_var_list_init  */
  YYSYMBOL_1686_197 = 1686,                /* $@197  */
  YYSYMBOL_select_var_list = 1687,         /* select_var_list  */
  YYSYMBOL_select_var_ident = 1688,        /* select_var_ident  */
  YYSYMBOL_select_outvar = 1689,           /* select_outvar  */
  YYSYMBOL_into = 1690,                    /* into  */
  YYSYMBOL_into_destination = 1691,        /* into_destination  */
  YYSYMBOL_1692_198 = 1692,                /* $@198  */
  YYSYMBOL_1693_199 = 1693,                /* $@199  */
  YYSYMBOL_do = 1694,                      /* do  */
  YYSYMBOL_1695_200 = 1695,                /* $@200  */
  YYSYMBOL_drop = 1696,                    /* drop  */
  YYSYMBOL_1697_201 = 1697,                /* $@201  */
  YYSYMBOL_1698_202 = 1698,                /* $@202  */
  YYSYMBOL_1699_203 = 1699,                /* $@203  */
  YYSYMBOL_1700_204 = 1700,                /* $@204  */
  YYSYMBOL_table_list = 1701,              /* table_list  */
  YYSYMBOL_table_name = 1702,              /* table_name  */
  YYSYMBOL_table_name_with_opt_use_partition = 1703, /* table_name_with_opt_use_partition  */
  YYSYMBOL_table_alias_ref_list = 1704,    /* table_alias_ref_list  */
  YYSYMBOL_table_alias_ref = 1705,         /* table_alias_ref  */
  YYSYMBOL_opt_if_exists_table_element = 1706, /* opt_if_exists_table_element  */
  YYSYMBOL_opt_if_exists = 1707,           /* opt_if_exists  */
  YYSYMBOL_opt_temporary = 1708,           /* opt_temporary  */
  YYSYMBOL_insert = 1709,                  /* insert  */
  YYSYMBOL_1710_205 = 1710,                /* $@205  */
  YYSYMBOL_1711_206 = 1711,                /* $@206  */
  YYSYMBOL_replace = 1712,                 /* replace  */
  YYSYMBOL_1713_207 = 1713,                /* $@207  */
  YYSYMBOL_1714_208 = 1714,                /* $@208  */
  YYSYMBOL_insert_lock_option = 1715,      /* insert_lock_option  */
  YYSYMBOL_replace_lock_option = 1716,     /* replace_lock_option  */
  YYSYMBOL_insert2 = 1717,                 /* insert2  */
  YYSYMBOL_insert_table = 1718,            /* insert_table  */
  YYSYMBOL_1719_209 = 1719,                /* $@209  */
  YYSYMBOL_insert_field_spec = 1720,       /* insert_field_spec  */
  YYSYMBOL_1721_210 = 1721,                /* $@210  */
  YYSYMBOL_insert_field_list = 1722,       /* insert_field_list  */
  YYSYMBOL_opt_fields = 1723,              /* opt_fields  */
  YYSYMBOL_fields = 1724,                  /* fields  */
  YYSYMBOL_insert_values = 1725,           /* insert_values  */
  YYSYMBOL_values_list = 1726,             /* values_list  */
  YYSYMBOL_ident_eq_list = 1727,           /* ident_eq_list  */
  YYSYMBOL_ident_eq_value = 1728,          /* ident_eq_value  */
  YYSYMBOL_equal = 1729,                   /* equal  */
  YYSYMBOL_opt_equal = 1730,               /* opt_equal  */
  YYSYMBOL_opt_with = 1731,                /* opt_with  */
  YYSYMBOL_opt_by = 1732,                  /* opt_by  */
  YYSYMBOL_no_braces = 1733,               /* no_braces  */
  YYSYMBOL_1734_211 = 1734,                /* $@211  */
  YYSYMBOL_no_braces_with_names = 1735,    /* no_braces_with_names  */
  YYSYMBOL_1736_212 = 1736,                /* $@212  */
  YYSYMBOL_opt_values = 1737,              /* opt_values  */
  YYSYMBOL_opt_values_with_names = 1738,   /* opt_values_with_names  */
  YYSYMBOL_values = 1739,                  /* values  */
  YYSYMBOL_values_with_names = 1740,       /* values_with_names  */
  YYSYMBOL_expr_or_ignore = 1741,          /* expr_or_ignore  */
  YYSYMBOL_expr_or_ignore_or_default = 1742, /* expr_or_ignore_or_default  */
  YYSYMBOL_opt_insert_update = 1743,       /* opt_insert_update  */
  YYSYMBOL_1744_213 = 1744,                /* $@213  */
  YYSYMBOL_1745_214 = 1745,                /* $@214  */
  YYSYMBOL_update_table_list = 1746,       /* update_table_list  */
  YYSYMBOL_update = 1747,                  /* update  */
  YYSYMBOL_1748_215 = 1748,                /* $@215  */
  YYSYMBOL_1749_216 = 1749,                /* $@216  */
  YYSYMBOL_update_list = 1750,             /* update_list  */
  YYSYMBOL_update_elem = 1751,             /* update_elem  */
  YYSYMBOL_insert_update_list = 1752,      /* insert_update_list  */
  YYSYMBOL_insert_update_elem = 1753,      /* insert_update_elem  */
  YYSYMBOL_opt_low_priority = 1754,        /* opt_low_priority  */
  YYSYMBOL_delete = 1755,                  /* delete  */
  YYSYMBOL_1756_217 = 1756,                /* $@217  */
  YYSYMBOL_opt_delete_system_time = 1757,  /* opt_delete_system_time  */
  YYSYMBOL_delete_part2 = 1758,            /* delete_part2  */
  YYSYMBOL_delete_single_table = 1759,     /* delete_single_table  */
  YYSYMBOL_delete_single_table_for_period = 1760, /* delete_single_table_for_period  */
  YYSYMBOL_single_multi = 1761,            /* single_multi  */
  YYSYMBOL_1762_218 = 1762,                /* $@218  */
  YYSYMBOL_1763_219 = 1763,                /* $@219  */
  YYSYMBOL_opt_select_expressions = 1764,  /* opt_select_expressions  */
  YYSYMBOL_table_wild_list = 1765,         /* table_wild_list  */
  YYSYMBOL_table_wild_one = 1766,          /* table_wild_one  */
  YYSYMBOL_opt_wild = 1767,                /* opt_wild  */
  YYSYMBOL_opt_delete_options = 1768,      /* opt_delete_options  */
  YYSYMBOL_opt_delete_option = 1769,       /* opt_delete_option  */
  YYSYMBOL_truncate = 1770,                /* truncate  */
  YYSYMBOL_1771_220 = 1771,                /* $@220  */
  YYSYMBOL_1772_221 = 1772,                /* $@221  */
  YYSYMBOL_opt_truncate_table_storage_clause = 1773, /* opt_truncate_table_storage_clause  */
  YYSYMBOL_opt_table_sym = 1774,           /* opt_table_sym  */
  YYSYMBOL_opt_profile_defs = 1775,        /* opt_profile_defs  */
  YYSYMBOL_profile_defs = 1776,            /* profile_defs  */
  YYSYMBOL_profile_def = 1777,             /* profile_def  */
  YYSYMBOL_opt_profile_args = 1778,        /* opt_profile_args  */
  YYSYMBOL_show = 1779,                    /* show  */
  YYSYMBOL_1780_222 = 1780,                /* $@222  */
  YYSYMBOL_show_param = 1781,              /* show_param  */
  YYSYMBOL_1782_223 = 1782,                /* $@223  */
  YYSYMBOL_1783_224 = 1783,                /* $@224  */
  YYSYMBOL_show_engine_param = 1784,       /* show_engine_param  */
  YYSYMBOL_master_or_binary = 1785,        /* master_or_binary  */
  YYSYMBOL_opt_storage = 1786,             /* opt_storage  */
  YYSYMBOL_opt_db = 1787,                  /* opt_db  */
  YYSYMBOL_opt_full = 1788,                /* opt_full  */
  YYSYMBOL_from_or_in = 1789,              /* from_or_in  */
  YYSYMBOL_binlog_in = 1790,               /* binlog_in  */
  YYSYMBOL_binlog_from = 1791,             /* binlog_from  */
  YYSYMBOL_wild_and_where = 1792,          /* wild_and_where  */
  YYSYMBOL_describe = 1793,                /* describe  */
  YYSYMBOL_1794_225 = 1794,                /* $@225  */
  YYSYMBOL_1795_226 = 1795,                /* $@226  */
  YYSYMBOL_explainable_command = 1796,     /* explainable_command  */
  YYSYMBOL_describe_command = 1797,        /* describe_command  */
  YYSYMBOL_analyze_stmt_command = 1798,    /* analyze_stmt_command  */
  YYSYMBOL_opt_extended_describe = 1799,   /* opt_extended_describe  */
  YYSYMBOL_opt_format_json = 1800,         /* opt_format_json  */
  YYSYMBOL_opt_describe_column = 1801,     /* opt_describe_column  */
  YYSYMBOL_flush = 1802,                   /* flush  */
  YYSYMBOL_1803_227 = 1803,                /* $@227  */
  YYSYMBOL_flush_options = 1804,           /* flush_options  */
  YYSYMBOL_1805_228 = 1805,                /* $@228  */
  YYSYMBOL_opt_flush_lock = 1806,          /* opt_flush_lock  */
  YYSYMBOL_flush_lock = 1807,              /* flush_lock  */
  YYSYMBOL_1808_229 = 1808,                /* $@229  */
  YYSYMBOL_flush_options_list = 1809,      /* flush_options_list  */
  YYSYMBOL_flush_option = 1810,            /* flush_option  */
  YYSYMBOL_opt_table_list = 1811,          /* opt_table_list  */
  YYSYMBOL_backup = 1812,                  /* backup  */
  YYSYMBOL_backup_statements = 1813,       /* backup_statements  */
  YYSYMBOL_1814_230 = 1814,                /* $@230  */
  YYSYMBOL_opt_delete_gtid_domain = 1815,  /* opt_delete_gtid_domain  */
  YYSYMBOL_delete_domain_id_list = 1816,   /* delete_domain_id_list  */
  YYSYMBOL_delete_domain_id = 1817,        /* delete_domain_id  */
  YYSYMBOL_optional_flush_tables_arguments = 1818, /* optional_flush_tables_arguments  */
  YYSYMBOL_reset = 1819,                   /* reset  */
  YYSYMBOL_1820_231 = 1820,                /* $@231  */
  YYSYMBOL_reset_options = 1821,           /* reset_options  */
  YYSYMBOL_reset_option = 1822,            /* reset_option  */
  YYSYMBOL_1823_232 = 1823,                /* $@232  */
  YYSYMBOL_1824_233 = 1824,                /* $@233  */
  YYSYMBOL_slave_reset_options = 1825,     /* slave_reset_options  */
  YYSYMBOL_master_reset_options = 1826,    /* master_reset_options  */
  YYSYMBOL_purge = 1827,                   /* purge  */
  YYSYMBOL_1828_234 = 1828,                /* $@234  */
  YYSYMBOL_kill = 1829,                    /* kill  */
  YYSYMBOL_1830_235 = 1830,                /* $@235  */
  YYSYMBOL_kill_type = 1831,               /* kill_type  */
  YYSYMBOL_kill_option = 1832,             /* kill_option  */
  YYSYMBOL_opt_connection = 1833,          /* opt_connection  */
  YYSYMBOL_kill_expr = 1834,               /* kill_expr  */
  YYSYMBOL_shutdown = 1835,                /* shutdown  */
  YYSYMBOL_1836_236 = 1836,                /* $@236  */
  YYSYMBOL_shutdown_option = 1837,         /* shutdown_option  */
  YYSYMBOL_use = 1838,                     /* use  */
  YYSYMBOL_load = 1839,                    /* load  */
  YYSYMBOL_1840_237 = 1840,                /* $@237  */
  YYSYMBOL_1841_238 = 1841,                /* $@238  */
  YYSYMBOL_1842_239 = 1842,                /* $@239  */
  YYSYMBOL_1843_240 = 1843,                /* $@240  */
  YYSYMBOL_data_or_xml = 1844,             /* data_or_xml  */
  YYSYMBOL_opt_local = 1845,               /* opt_local  */
  YYSYMBOL_load_data_lock = 1846,          /* load_data_lock  */
  YYSYMBOL_opt_duplicate = 1847,           /* opt_duplicate  */
  YYSYMBOL_opt_field_term = 1848,          /* opt_field_term  */
  YYSYMBOL_field_term_list = 1849,         /* field_term_list  */
  YYSYMBOL_field_term = 1850,              /* field_term  */
  YYSYMBOL_opt_line_term = 1851,           /* opt_line_term  */
  YYSYMBOL_line_term_list = 1852,          /* line_term_list  */
  YYSYMBOL_line_term = 1853,               /* line_term  */
  YYSYMBOL_opt_xml_rows_identified_by = 1854, /* opt_xml_rows_identified_by  */
  YYSYMBOL_opt_ignore_lines = 1855,        /* opt_ignore_lines  */
  YYSYMBOL_lines_or_rows = 1856,           /* lines_or_rows  */
  YYSYMBOL_opt_field_or_var_spec = 1857,   /* opt_field_or_var_spec  */
  YYSYMBOL_fields_or_vars = 1858,          /* fields_or_vars  */
  YYSYMBOL_field_or_var = 1859,            /* field_or_var  */
  YYSYMBOL_opt_load_data_set_spec = 1860,  /* opt_load_data_set_spec  */
  YYSYMBOL_load_data_set_list = 1861,      /* load_data_set_list  */
  YYSYMBOL_load_data_set_elem = 1862,      /* load_data_set_elem  */
  YYSYMBOL_text_literal = 1863,            /* text_literal  */
  YYSYMBOL_text_string = 1864,             /* text_string  */
  YYSYMBOL_hex_or_bin_String = 1865,       /* hex_or_bin_String  */
  YYSYMBOL_param_marker = 1866,            /* param_marker  */
  YYSYMBOL_signed_literal = 1867,          /* signed_literal  */
  YYSYMBOL_literal = 1868,                 /* literal  */
  YYSYMBOL_NUM_literal = 1869,             /* NUM_literal  */
  YYSYMBOL_temporal_literal = 1870,        /* temporal_literal  */
  YYSYMBOL_with_clause = 1871,             /* with_clause  */
  YYSYMBOL_1872_241 = 1872,                /* $@241  */
  YYSYMBOL_opt_recursive = 1873,           /* opt_recursive  */
  YYSYMBOL_with_list = 1874,               /* with_list  */
  YYSYMBOL_with_list_element = 1875,       /* with_list_element  */
  YYSYMBOL_1876_242 = 1876,                /* $@242  */
  YYSYMBOL_opt_with_column_list = 1877,    /* opt_with_column_list  */
  YYSYMBOL_with_column_list = 1878,        /* with_column_list  */
  YYSYMBOL_with_element_head = 1879,       /* with_element_head  */
  YYSYMBOL_insert_ident = 1880,            /* insert_ident  */
  YYSYMBOL_table_wild = 1881,              /* table_wild  */
  YYSYMBOL_select_sublist_qualified_asterisk = 1882, /* select_sublist_qualified_asterisk  */
  YYSYMBOL_order_ident = 1883,             /* order_ident  */
  YYSYMBOL_simple_ident = 1884,            /* simple_ident  */
  YYSYMBOL_simple_ident_nospvar = 1885,    /* simple_ident_nospvar  */
  YYSYMBOL_field_ident = 1886,             /* field_ident  */
  YYSYMBOL_table_ident = 1887,             /* table_ident  */
  YYSYMBOL_table_ident_opt_wild = 1888,    /* table_ident_opt_wild  */
  YYSYMBOL_table_ident_nodb = 1889,        /* table_ident_nodb  */
  YYSYMBOL_IDENT_cli = 1890,               /* IDENT_cli  */
  YYSYMBOL_ident_cli = 1891,               /* ident_cli  */
  YYSYMBOL_IDENT_sys = 1892,               /* IDENT_sys  */
  YYSYMBOL_TEXT_STRING_sys = 1893,         /* TEXT_STRING_sys  */
  YYSYMBOL_TEXT_STRING_literal = 1894,     /* TEXT_STRING_literal  */
  YYSYMBOL_TEXT_STRING_filesystem = 1895,  /* TEXT_STRING_filesystem  */
  YYSYMBOL_ident_table_alias = 1896,       /* ident_table_alias  */
  YYSYMBOL_ident_set_usual_case = 1897,    /* ident_set_usual_case  */
  YYSYMBOL_ident_sysvar_name = 1898,       /* ident_sysvar_name  */
  YYSYMBOL_ident = 1899,                   /* ident  */
  YYSYMBOL_ident_directly_assignable = 1900, /* ident_directly_assignable  */
  YYSYMBOL_label_ident = 1901,             /* label_ident  */
  YYSYMBOL_labels_declaration_oracle = 1902, /* labels_declaration_oracle  */
  YYSYMBOL_label_declaration_oracle = 1903, /* label_declaration_oracle  */
  YYSYMBOL_ident_or_text = 1904,           /* ident_or_text  */
  YYSYMBOL_user_maybe_role = 1905,         /* user_maybe_role  */
  YYSYMBOL_user_or_role = 1906,            /* user_or_role  */
  YYSYMBOL_user = 1907,                    /* user  */
  YYSYMBOL_keyword_table_alias = 1908,     /* keyword_table_alias  */
  YYSYMBOL_keyword_ident = 1909,           /* keyword_ident  */
  YYSYMBOL_keyword_label = 1910,           /* keyword_label  */
  YYSYMBOL_keyword_sysvar_name = 1911,     /* keyword_sysvar_name  */
  YYSYMBOL_keyword_sp_decl = 1912,         /* keyword_sp_decl  */
  YYSYMBOL_keyword_set_usual_case = 1913,  /* keyword_set_usual_case  */
  YYSYMBOL_keyword_directly_assignable = 1914, /* keyword_directly_assignable  */
  YYSYMBOL_keyword_sp_var_not_label = 1915, /* keyword_sp_var_not_label  */
  YYSYMBOL_keyword_sp_head = 1916,         /* keyword_sp_head  */
  YYSYMBOL_keyword_verb_clause = 1917,     /* keyword_verb_clause  */
  YYSYMBOL_keyword_set_special_case = 1918, /* keyword_set_special_case  */
  YYSYMBOL_keyword_sp_block_section = 1919, /* keyword_sp_block_section  */
  YYSYMBOL_keyword_sysvar_type = 1920,     /* keyword_sysvar_type  */
  YYSYMBOL_keyword_data_type = 1921,       /* keyword_data_type  */
  YYSYMBOL_keyword_sp_var_and_label = 1922, /* keyword_sp_var_and_label  */
  YYSYMBOL_set = 1923,                     /* set  */
  YYSYMBOL_1924_243 = 1924,                /* $@243  */
  YYSYMBOL_1925_244 = 1925,                /* $@244  */
  YYSYMBOL_1926_245 = 1926,                /* $@245  */
  YYSYMBOL_set_assign = 1927,              /* set_assign  */
  YYSYMBOL_1928_246 = 1928,                /* $@246  */
  YYSYMBOL_1929_247 = 1929,                /* $@247  */
  YYSYMBOL_1930_248 = 1930,                /* $@248  */
  YYSYMBOL_set_stmt_option_value_following_option_type_list = 1931, /* set_stmt_option_value_following_option_type_list  */
  YYSYMBOL_start_option_value_list = 1932, /* start_option_value_list  */
  YYSYMBOL_1933_249 = 1933,                /* $@249  */
  YYSYMBOL_1934_250 = 1934,                /* $@250  */
  YYSYMBOL_1935_251 = 1935,                /* $@251  */
  YYSYMBOL_start_option_value_list_following_option_type = 1936, /* start_option_value_list_following_option_type  */
  YYSYMBOL_1937_252 = 1937,                /* $@252  */
  YYSYMBOL_option_value_list_continued = 1938, /* option_value_list_continued  */
  YYSYMBOL_option_value_list = 1939,       /* option_value_list  */
  YYSYMBOL_1940_253 = 1940,                /* $@253  */
  YYSYMBOL_1941_254 = 1941,                /* $@254  */
  YYSYMBOL_option_value = 1942,            /* option_value  */
  YYSYMBOL_1943_255 = 1943,                /* $@255  */
  YYSYMBOL_option_type = 1944,             /* option_type  */
  YYSYMBOL_opt_var_type = 1945,            /* opt_var_type  */
  YYSYMBOL_opt_var_ident_type = 1946,      /* opt_var_ident_type  */
  YYSYMBOL_option_value_following_option_type = 1947, /* option_value_following_option_type  */
  YYSYMBOL_option_value_no_option_type = 1948, /* option_value_no_option_type  */
  YYSYMBOL_transaction_characteristics = 1949, /* transaction_characteristics  */
  YYSYMBOL_transaction_access_mode = 1950, /* transaction_access_mode  */
  YYSYMBOL_isolation_level = 1951,         /* isolation_level  */
  YYSYMBOL_transaction_access_mode_types = 1952, /* transaction_access_mode_types  */
  YYSYMBOL_isolation_types = 1953,         /* isolation_types  */
  YYSYMBOL_opt_for_user = 1954,            /* opt_for_user  */
  YYSYMBOL_text_or_password = 1955,        /* text_or_password  */
  YYSYMBOL_set_expr_or_default = 1956,     /* set_expr_or_default  */
  YYSYMBOL_lock = 1957,                    /* lock  */
  YYSYMBOL_1958_256 = 1958,                /* $@256  */
  YYSYMBOL_opt_lock_wait_timeout = 1959,   /* opt_lock_wait_timeout  */
  YYSYMBOL_table_or_tables = 1960,         /* table_or_tables  */
  YYSYMBOL_table_lock_list = 1961,         /* table_lock_list  */
  YYSYMBOL_table_lock = 1962,              /* table_lock  */
  YYSYMBOL_lock_option = 1963,             /* lock_option  */
  YYSYMBOL_unlock = 1964,                  /* unlock  */
  YYSYMBOL_1965_257 = 1965,                /* $@257  */
  YYSYMBOL_handler = 1966,                 /* handler  */
  YYSYMBOL_1967_258 = 1967,                /* $@258  */
  YYSYMBOL_handler_tail = 1968,            /* handler_tail  */
  YYSYMBOL_1969_259 = 1969,                /* $@259  */
  YYSYMBOL_handler_read_or_scan = 1970,    /* handler_read_or_scan  */
  YYSYMBOL_handler_scan_function = 1971,   /* handler_scan_function  */
  YYSYMBOL_handler_rkey_function = 1972,   /* handler_rkey_function  */
  YYSYMBOL_1973_260 = 1973,                /* $@260  */
  YYSYMBOL_handler_rkey_mode = 1974,       /* handler_rkey_mode  */
  YYSYMBOL_revoke = 1975,                  /* revoke  */
  YYSYMBOL_revoke_command = 1976,          /* revoke_command  */
  YYSYMBOL_admin_option_for_role = 1977,   /* admin_option_for_role  */
  YYSYMBOL_grant = 1978,                   /* grant  */
  YYSYMBOL_grant_command = 1979,           /* grant_command  */
  YYSYMBOL_opt_with_admin = 1980,          /* opt_with_admin  */
  YYSYMBOL_opt_with_admin_option = 1981,   /* opt_with_admin_option  */
  YYSYMBOL_role_list = 1982,               /* role_list  */
  YYSYMBOL_current_role = 1983,            /* current_role  */
  YYSYMBOL_grant_role = 1984,              /* grant_role  */
  YYSYMBOL_opt_table = 1985,               /* opt_table  */
  YYSYMBOL_grant_privileges = 1986,        /* grant_privileges  */
  YYSYMBOL_opt_privileges = 1987,          /* opt_privileges  */
  YYSYMBOL_object_privilege_list = 1988,   /* object_privilege_list  */
  YYSYMBOL_object_privilege = 1989,        /* object_privilege  */
  YYSYMBOL_1990_261 = 1990,                /* $@261  */
  YYSYMBOL_1991_262 = 1991,                /* $@262  */
  YYSYMBOL_1992_263 = 1992,                /* $@263  */
  YYSYMBOL_1993_264 = 1993,                /* $@264  */
  YYSYMBOL_opt_and = 1994,                 /* opt_and  */
  YYSYMBOL_require_list = 1995,            /* require_list  */
  YYSYMBOL_require_list_element = 1996,    /* require_list_element  */
  YYSYMBOL_grant_ident = 1997,             /* grant_ident  */
  YYSYMBOL_user_list = 1998,               /* user_list  */
  YYSYMBOL_grant_list = 1999,              /* grant_list  */
  YYSYMBOL_user_and_role_list = 2000,      /* user_and_role_list  */
  YYSYMBOL_via_or_with = 2001,             /* via_or_with  */
  YYSYMBOL_using_or_as = 2002,             /* using_or_as  */
  YYSYMBOL_grant_user = 2003,              /* grant_user  */
  YYSYMBOL_auth_expression = 2004,         /* auth_expression  */
  YYSYMBOL_auth_token = 2005,              /* auth_token  */
  YYSYMBOL_opt_auth_str = 2006,            /* opt_auth_str  */
  YYSYMBOL_opt_column_list = 2007,         /* opt_column_list  */
  YYSYMBOL_column_list = 2008,             /* column_list  */
  YYSYMBOL_column_list_id = 2009,          /* column_list_id  */
  YYSYMBOL_opt_require_clause = 2010,      /* opt_require_clause  */
  YYSYMBOL_resource_option = 2011,         /* resource_option  */
  YYSYMBOL_resource_option_list = 2012,    /* resource_option_list  */
  YYSYMBOL_opt_resource_options = 2013,    /* opt_resource_options  */
  YYSYMBOL_opt_grant_options = 2014,       /* opt_grant_options  */
  YYSYMBOL_opt_grant_option = 2015,        /* opt_grant_option  */
  YYSYMBOL_grant_option_list = 2016,       /* grant_option_list  */
  YYSYMBOL_grant_option = 2017,            /* grant_option  */
  YYSYMBOL_begin_stmt_mariadb = 2018,      /* begin_stmt_mariadb  */
  YYSYMBOL_2019_265 = 2019,                /* $@265  */
  YYSYMBOL_compound_statement = 2020,      /* compound_statement  */
  YYSYMBOL_opt_not = 2021,                 /* opt_not  */
  YYSYMBOL_opt_work = 2022,                /* opt_work  */
  YYSYMBOL_opt_chain = 2023,               /* opt_chain  */
  YYSYMBOL_opt_release = 2024,             /* opt_release  */
  YYSYMBOL_commit = 2025,                  /* commit  */
  YYSYMBOL_rollback = 2026,                /* rollback  */
  YYSYMBOL_savepoint = 2027,               /* savepoint  */
  YYSYMBOL_release = 2028,                 /* release  */
  YYSYMBOL_unit_type_decl = 2029,          /* unit_type_decl  */
  YYSYMBOL_union_option = 2030,            /* union_option  */
  YYSYMBOL_query_expression_option = 2031, /* query_expression_option  */
  YYSYMBOL_definer_opt = 2032,             /* definer_opt  */
  YYSYMBOL_no_definer = 2033,              /* no_definer  */
  YYSYMBOL_definer = 2034,                 /* definer  */
  YYSYMBOL_view_algorithm = 2035,          /* view_algorithm  */
  YYSYMBOL_opt_view_suid = 2036,           /* opt_view_suid  */
  YYSYMBOL_view_suid = 2037,               /* view_suid  */
  YYSYMBOL_view_list_opt = 2038,           /* view_list_opt  */
  YYSYMBOL_view_list = 2039,               /* view_list  */
  YYSYMBOL_view_select = 2040,             /* view_select  */
  YYSYMBOL_2041_266 = 2041,                /* $@266  */
  YYSYMBOL_view_check_option = 2042,       /* view_check_option  */
  YYSYMBOL_trigger_action_order = 2043,    /* trigger_action_order  */
  YYSYMBOL_trigger_follows_precedes_clause = 2044, /* trigger_follows_precedes_clause  */
  YYSYMBOL_trigger_tail = 2045,            /* trigger_tail  */
  YYSYMBOL_2046_267 = 2046,                /* $@267  */
  YYSYMBOL_2047_268 = 2047,                /* $@268  */
  YYSYMBOL_2048_269 = 2048,                /* $@269  */
  YYSYMBOL_2049_270 = 2049,                /* $@270  */
  YYSYMBOL_2050_271 = 2050,                /* $@271  */
  YYSYMBOL_sf_return_type = 2051,          /* sf_return_type  */
  YYSYMBOL_2052_272 = 2052,                /* $@272  */
  YYSYMBOL_sf_c_chistics_and_body_standalone = 2053, /* sf_c_chistics_and_body_standalone  */
  YYSYMBOL_2054_273 = 2054,                /* $@273  */
  YYSYMBOL_sp_tail_standalone = 2055,      /* sp_tail_standalone  */
  YYSYMBOL_2056_274 = 2056,                /* $@274  */
  YYSYMBOL_2057_275 = 2057,                /* $@275  */
  YYSYMBOL_opt_package_routine_end_name = 2058, /* opt_package_routine_end_name  */
  YYSYMBOL_sp_tail_is = 2059,              /* sp_tail_is  */
  YYSYMBOL_xa = 2060,                      /* xa  */
  YYSYMBOL_opt_format_xid = 2061,          /* opt_format_xid  */
  YYSYMBOL_xid = 2062,                     /* xid  */
  YYSYMBOL_begin_or_start = 2063,          /* begin_or_start  */
  YYSYMBOL_opt_join_or_resume = 2064,      /* opt_join_or_resume  */
  YYSYMBOL_opt_one_phase = 2065,           /* opt_one_phase  */
  YYSYMBOL_opt_suspend = 2066,             /* opt_suspend  */
  YYSYMBOL_2067_276 = 2067,                /* $@276  */
  YYSYMBOL_opt_migrate = 2068,             /* opt_migrate  */
  YYSYMBOL_install = 2069,                 /* install  */
  YYSYMBOL_uninstall = 2070,               /* uninstall  */
  YYSYMBOL_keep_gcc_happy = 2071           /* keep_gcc_happy  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 304 "/home/buildbot/git/sql/sql_yacc_ora.yy"

bool my_yyoverflow(short **a, YYSTYPE **b, size_t *yystacksize);

#line 2338 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  753
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   95757

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  781
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  1291
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3556
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6148

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   1014


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   775,     2,     2,     2,   764,   759,     2,
     771,   772,   762,   761,   774,   760,   779,   763,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   778,
     757,   755,   756,     2,   780,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   765,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   776,   758,   777,   766,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     767,   768,   769,   770,   773
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1758,  1758,  1768,  1767,  1792,  1799,  1801,  1805,  1806,
    1807,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,
    1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,
    1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,
    1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,
    1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,
    1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,
    1871,  1875,  1882,  1883,  1888,  1887,  1898,  1904,  1906,  1903,
    1915,  1917,  1916,  1926,  1931,  1943,  1942,  1959,  1958,  1967,
    1968,  1972,  1976,  1980,  1984,  1988,  1992,  2002,  2007,  2011,
    2015,  2019,  2023,  2027,  2032,  2036,  2041,  2069,  2073,  2077,
    2082,  2085,  2087,  2088,  2092,  2098,  2100,  2101,  2105,  2111,
    2113,  2114,  2118,  2125,  2129,  2144,  2148,  2154,  2160,  2166,
    2176,  2180,  2184,  2198,  2210,  2197,  2233,  2232,  2288,  2295,
    2287,  2307,  2313,  2306,  2325,  2331,  2324,  2343,  2342,  2357,
    2355,  2371,  2369,  2383,  2382,  2393,  2392,  2402,  2401,  2413,
    2411,  2426,  2424,  2440,  2438,  2453,  2451,  2465,  2472,  2479,
    2486,  2490,  2494,  2494,  2501,  2497,  2521,  2533,  2538,  2517,
    2551,  2557,  2565,  2566,  2567,  2573,  2574,  2580,  2581,  2587,
    2598,  2597,  2625,  2624,  2651,  2660,  2669,  2675,  2674,  2693,
    2692,  2711,  2714,  2716,  2720,  2721,  2725,  2732,  2743,  2744,
    2748,  2749,  2753,  2758,  2764,  2770,  2778,  2784,  2790,  2798,
    2806,  2814,  2822,  2830,  2838,  2850,  2866,  2866,  2870,  2869,
    2881,  2882,  2886,  2891,  2896,  2901,  2906,  2911,  2916,  2924,
    2923,  2956,  2955,  2962,  2969,  2970,  2976,  2982,  2992,  2998,
    3004,  3006,  3013,  3014,  3018,  3028,  3029,  3037,  3037,  3079,
    3091,  3092,  3096,  3101,  3109,  3110,  3114,  3115,  3119,  3120,
    3125,  3127,  3129,  3131,  3133,  3135,  3137,  3142,  3144,  3149,
    3150,  3153,  3155,  3159,  3159,  3165,  3166,  3170,  3171,  3176,
    3175,  3186,  3185,  3196,  3195,  3208,  3210,  3213,  3215,  3219,
    3223,  3232,  3237,  3237,  3247,  3248,  3252,  3260,  3265,  3270,
    3275,  3280,  3285,  3293,  3295,  3299,  3300,  3304,  3310,  3316,
    3322,  3328,  3334,  3343,  3344,  3345,  3346,  3347,  3352,  3351,
    3364,  3371,  3372,  3376,  3377,  3381,  3382,  3386,  3387,  3391,
    3391,  3403,  3406,  3411,  3410,  3419,  3423,  3424,  3431,  3432,
    3439,  3440,  3444,  3450,  3456,  3465,  3473,  3477,  3482,  3490,
    3494,  3501,  3511,  3519,  3527,  3538,  3539,  3546,  3557,  3556,
    3575,  3574,  3588,  3590,  3595,  3605,  3604,  3623,  3624,  3625,
    3626,  3631,  3633,  3638,  3653,  3661,  3665,  3685,  3686,  3690,
    3694,  3700,  3706,  3712,  3718,  3728,  3733,  3741,  3749,  3764,
    3770,  3771,  3777,  3780,  3784,  3792,  3809,  3811,  3829,  3835,
    3837,  3839,  3841,  3843,  3845,  3847,  3849,  3851,  3853,  3855,
    3857,  3862,  3870,  3886,  3887,  3892,  3898,  3907,  3914,  3923,
    3932,  3937,  3946,  3948,  3950,  3959,  3964,  3971,  3980,  3989,
    3991,  3993,  3995,  3997,  3999,  4001,  4003,  4005,  4007,  4009,
    4011,  4013,  4018,  4019,  4027,  4039,  4054,  4055,  4056,  4060,
    4061,  4062,  4063,  4064,  4065,  4069,  4070,  4071,  4072,  4073,
    4074,  4075,  4076,  4077,  4078,  4079,  4080,  4081,  4085,  4086,
    4087,  4088,  4093,  4092,  4103,  4105,  4104,  4116,  4115,  4126,
    4125,  4138,  4138,  4160,  4161,  4166,  4165,  4183,  4194,  4194,
    4207,  4212,  4217,  4223,  4232,  4237,  4242,  4248,  4258,  4266,
    4274,  4283,  4289,  4299,  4298,  4320,  4319,  4340,  4346,  4354,
    4355,  4359,  4367,  4372,  4377,  4385,  4386,  4394,  4412,  4427,
    4445,  4451,  4468,  4445,  4487,  4489,  4490,  4495,  4494,  4564,
    4570,  4564,  4580,  4585,  4586,  4590,  4591,  4596,  4602,  4595,
    4623,  4629,  4622,  4648,  4658,  4662,  4663,  4667,  4678,  4676,
    4692,  4696,  4690,  4711,  4713,  4718,  4717,  4732,  4738,  4731,
    4753,  4757,  4761,  4767,  4757,  4778,  4776,  4791,  4792,  4796,
    4797,  4802,  4801,  4817,  4818,  4823,  4822,  4836,  4841,  4848,
    4857,  4872,  4871,  4891,  4890,  4915,  4924,  4923,  4931,  4930,
    4941,  4946,  4955,  4940,  4965,  4964,  4975,  4974,  4984,  4983,
    4996,  5003,  4995,  5020,  5019,  5031,  5033,  5038,  5040,  5042,
    5059,  5064,  5070,  5077,  5078,  5086,  5092,  5101,  5107,  5113,
    5114,  5118,  5118,  5123,  5124,  5125,  5129,  5130,  5131,  5135,
    5139,  5140,  5141,  5145,  5146,  5147,  5148,  5149,  5150,  5151,
    5152,  5156,  5160,  5161,  5162,  5166,  5167,  5168,  5169,  5170,
    5174,  5178,  5179,  5180,  5184,  5185,  5186,  5187,  5188,  5189,
    5190,  5194,  5198,  5199,  5200,  5204,  5205,  5206,  5211,  5219,
    5227,  5235,  5248,  5261,  5266,  5271,  5279,  5287,  5295,  5303,
    5311,  5319,  5327,  5337,  5347,  5357,  5359,  5363,  5368,  5378,
    5379,  5392,  5391,  5394,  5395,  5409,  5410,  5414,  5415,  5424,
    5429,  5440,  5477,  5478,  5483,  5482,  5498,  5513,  5512,  5535,
    5534,  5540,  5548,  5547,  5550,  5552,  5555,  5554,  5563,  5566,
    5565,  5574,  5575,  5581,  5582,  5599,  5600,  5604,  5605,  5609,
    5623,  5633,  5644,  5653,  5654,  5667,  5669,  5668,  5673,  5671,
    5682,  5683,  5687,  5701,  5713,  5714,  5727,  5736,  5758,  5759,
    5764,  5763,  5787,  5799,  5815,  5814,  5829,  5828,  5842,  5847,
    5852,  5872,  5890,  5894,  5921,  5933,  5934,  5939,  5948,  5938,
    5973,  5974,  5978,  5989,  6008,  6021,  6047,  6048,  6053,  6052,
    6089,  6098,  6099,  6103,  6104,  6108,  6110,  6116,  6122,  6124,
    6126,  6128,  6130,  6132,  6137,  6138,  6138,  6145,  6161,  6164,
    6181,  6182,  6186,  6187,  6191,  6192,  6196,  6197,  6202,  6205,
    6213,  6216,  6223,  6227,  6233,  6235,  6239,  6240,  6244,  6245,
    6246,  6250,  6265,  6270,  6275,  6280,  6285,  6290,  6295,  6310,
    6316,  6331,  6336,  6351,  6357,  6375,  6380,  6385,  6390,  6395,
    6400,  6406,  6405,  6431,  6432,  6433,  6438,  6443,  6448,  6450,
    6452,  6454,  6460,  6465,  6470,  6479,  6488,  6494,  6500,  6505,
    6508,  6510,  6514,  6533,  6541,  6556,  6566,  6577,  6578,  6579,
    6580,  6581,  6582,  6583,  6587,  6588,  6589,  6593,  6594,  6595,
    6596,  6601,  6608,  6615,  6616,  6620,  6621,  6622,  6623,  6624,
    6628,  6630,  6636,  6635,  6643,  6642,  6650,  6649,  6657,  6656,
    6666,  6663,  6674,  6672,  6681,  6680,  6719,  6727,  6735,  6743,
    6744,  6748,  6758,  6759,  6763,  6764,  6768,  6773,  6772,  6810,
    6810,  6813,  6812,  6823,  6824,  6828,  6829,  6833,  6834,  6838,
    6839,  6843,  6844,  6845,  6846,  6848,  6847,  6853,  6858,  6866,
    6867,  6872,  6875,  6879,  6883,  6890,  6891,  6895,  6896,  6900,
    6906,  6912,  6913,  6921,  6920,  6942,  6943,  6953,  6961,  6973,
    6973,  6976,  6977,  6984,  6992,  6996,  7004,  7005,  7006,  7007,
    7008,  7013,  7014,  7015,  7016,  7017,  7022,  7023,  7024,  7040,
    7044,  7048,  7052,  7054,  7061,  7063,  7068,  7070,  7071,  7072,
    7076,  7080,  7085,  7090,  7094,  7098,  7103,  7108,  7117,  7121,
    7126,  7131,  7135,  7139,  7144,  7149,  7158,  7176,  7177,  7184,
    7191,  7199,  7204,  7209,  7214,  7219,  7230,  7235,  7240,  7245,
    7247,  7249,  7251,  7253,  7255,  7257,  7259,  7267,  7269,  7274,
    7275,  7276,  7277,  7278,  7279,  7280,  7281,  7285,  7289,  7290,
    7294,  7295,  7299,  7300,  7301,  7302,  7303,  7307,  7308,  7309,
    7310,  7311,  7315,  7321,  7322,  7327,  7329,  7336,  7337,  7338,
    7342,  7346,  7347,  7348,  7349,  7350,  7351,  7355,  7356,  7357,
    7358,  7362,  7363,  7367,  7368,  7389,  7390,  7394,  7395,  7399,
    7400,  7405,  7406,  7410,  7411,  7412,  7419,  7420,  7426,  7433,
    7437,  7438,  7442,  7443,  7447,  7455,  7463,  7472,  7476,  7482,
    7486,  7487,  7496,  7505,  7511,  7517,  7530,  7536,  7546,  7554,
    7555,  7559,  7564,  7568,  7569,  7573,  7574,  7578,  7585,  7589,
    7590,  7594,  7602,  7603,  7607,  7608,  7612,  7613,  7617,  7618,
    7619,  7626,  7630,  7631,  7635,  7636,  7637,  7638,  7639,  7651,
    7655,  7656,  7661,  7660,  7673,  7674,  7678,  7681,  7682,  7683,
    7684,  7688,  7696,  7703,  7704,  7708,  7718,  7719,  7723,  7724,
    7727,  7729,  7733,  7745,  7746,  7750,  7757,  7770,  7771,  7773,
    7775,  7781,  7786,  7792,  7798,  7805,  7815,  7816,  7817,  7818,
    7819,  7823,  7824,  7828,  7829,  7833,  7834,  7838,  7839,  7840,
    7844,  7845,  7849,  7853,  7865,  7866,  7870,  7871,  7875,  7876,
    7880,  7881,  7885,  7886,  7890,  7891,  7895,  7896,  7901,  7902,
    7903,  7907,  7909,  7914,  7919,  7921,  7929,  7937,  7943,  7952,
    7953,  7957,  7961,  7962,  7972,  7973,  7974,  7978,  7982,  7989,
    7995,  8007,  8008,  8012,  8014,  8024,  8040,  8023,  8062,  8061,
    8078,  8087,  8086,  8107,  8106,  8127,  8126,  8145,  8139,  8158,
    8157,  8196,  8201,  8206,  8211,  8217,  8216,  8223,  8230,  8242,
    8229,  8264,  8268,  8276,  8279,  8283,  8287,  8295,  8297,  8298,
    8299,  8300,  8304,  8305,  8306,  8307,  8311,  8312,  8324,  8325,
    8329,  8330,  8333,  8335,  8343,  8351,  8353,  8355,  8356,  8364,
    8365,  8371,  8380,  8378,  8391,  8404,  8403,  8416,  8414,  8427,
    8434,  8444,  8445,  8454,  8461,  8465,  8471,  8469,  8486,  8488,
    8493,  8501,  8500,  8514,  8518,  8517,  8529,  8530,  8534,  8547,
    8548,  8552,  8556,  8563,  8568,  8572,  8579,  8586,  8590,  8595,
    8603,  8611,  8621,  8632,  8642,  8653,  8663,  8669,  8675,  8682,
    8688,  8702,  8716,  8721,  8725,  8730,  8731,  8732,  8737,  8742,
    8746,  8756,  8758,  8759,  8760,  8761,  8765,  8770,  8778,  8783,
    8791,  8792,  8796,  8797,  8801,  8801,  8804,  8806,  8810,  8811,
    8815,  8816,  8824,  8825,  8826,  8830,  8831,  8836,  8845,  8846,
    8847,  8848,  8853,  8852,  8862,  8861,  8869,  8876,  8886,  8903,
    8906,  8913,  8917,  8924,  8928,  8932,  8939,  8939,  8945,  8946,
    8950,  8951,  8952,  8956,  8957,  8966,  8973,  8974,  8979,  8978,
    8990,  8991,  8992,  8996,  8998,  8997,  9004,  9003,  9024,  9025,
    9029,  9030,  9034,  9035,  9036,  9040,  9041,  9046,  9045,  9066,
    9067,  9071,  9076,  9077,  9084,  9086,  9091,  9093,  9092,  9105,
    9107,  9106,  9120,  9121,  9126,  9135,  9136,  9137,  9141,  9148,
    9158,  9166,  9175,  9177,  9176,  9182,  9181,  9204,  9205,  9209,
    9210,  9214,  9215,  9216,  9217,  9218,  9219,  9223,  9224,  9229,
    9228,  9249,  9250,  9251,  9256,  9255,  9265,  9272,  9278,  9287,
    9288,  9292,  9308,  9307,  9320,  9321,  9325,  9326,  9330,  9341,
    9352,  9353,  9358,  9357,  9372,  9373,  9377,  9378,  9382,  9393,
    9405,  9404,  9412,  9412,  9421,  9422,  9427,  9428,  9437,  9436,
    9451,  9450,  9470,  9469,  9486,  9484,  9506,  9507,  9512,  9511,
    9525,  9535,  9524,  9545,  9557,  9621,  9626,  9641,  9642,  9657,
    9656,  9672,  9671,  9684,  9686,  9701,  9709,  9707,  9723,  9741,
    9743,  9753,  9757,  9798,  9807,  9817,  9818,  9822,  9826,  9832,
    9839,  9841,  9850,  9854,  9858,  9865,  9874,  9878,  9885,  9902,
    9905,  9913,  9916,  9923,  9927,  9931,  9935,  9942,  9943,  9947,
    9948,  9957,  9970,  9976,  9986,  9989,  9997, 10000, 10005, 10013,
   10014, 10015, 10029, 10034, 10056, 10062, 10068, 10074, 10083, 10084,
   10085, 10086, 10087, 10091, 10092, 10093, 10097, 10098, 10099, 10103,
   10104, 10109, 10160, 10167, 10210, 10216, 10220, 10226, 10232, 10238,
   10244, 10250, 10256, 10262, 10268, 10274, 10280, 10286, 10290, 10296,
   10305, 10311, 10319, 10325, 10334, 10340, 10348, 10358, 10364, 10371,
   10378, 10386, 10392, 10401, 10405, 10411, 10417, 10423, 10429, 10436,
   10442, 10448, 10454, 10460, 10467, 10473, 10479, 10485, 10491, 10497,
   10503, 10509, 10515, 10519, 10520, 10524, 10525, 10529, 10530, 10534,
   10535, 10539, 10540, 10541, 10542, 10543, 10544, 10548, 10549, 10554,
   10558, 10562, 10563, 10564, 10568, 10569, 10570, 10571, 10572, 10573,
   10577, 10578, 10579, 10584, 10583, 10589, 10597, 10620, 10627, 10636,
   10637, 10638, 10639, 10643, 10652, 10653, 10654, 10655, 10656, 10657,
   10658, 10659, 10691, 10692, 10693, 10694, 10695, 10696, 10697, 10698,
   10699, 10707, 10715, 10716, 10723, 10729, 10734, 10744, 10749, 10754,
   10760, 10765, 10771, 10782, 10789, 10794, 10799, 10804, 10809, 10814,
   10819, 10827, 10828, 10829, 10830, 10838, 10839, 10847, 10848, 10854,
   10858, 10864, 10870, 10879, 10880, 10889, 10896, 10910, 10916, 10922,
   10931, 10940, 10946, 10952, 10958, 10964, 10979, 10990, 10996, 11002,
   11008, 11014, 11020, 11028, 11035, 11039, 11045, 11053, 11062, 11066,
   11070, 11074, 11094, 11101, 11107, 11114, 11121, 11127, 11133, 11139,
   11145, 11151, 11157, 11163, 11169, 11176, 11182, 11189, 11195, 11201,
   11219, 11225, 11231, 11236, 11243, 11250, 11258, 11265, 11272, 11279,
   11286, 11303, 11309, 11315, 11321, 11327, 11334, 11340, 11346, 11355,
   11366, 11373, 11379, 11385, 11392, 11400, 11406, 11412, 11418, 11424,
   11432, 11438, 11444, 11450, 11456, 11464, 11476, 11483, 11498, 11504,
   11511, 11518, 11525, 11532, 11539, 11543, 11550, 11568, 11567, 11635,
   11640, 11648, 11650, 11655, 11656, 11660, 11661, 11665, 11666, 11670,
   11677, 11685, 11712, 11718, 11724, 11730, 11736, 11742, 11751, 11758,
   11760, 11757, 11767, 11778, 11784, 11790, 11796, 11802, 11808, 11814,
   11820, 11826, 11833, 11832, 11857, 11866, 11884, 11886, 11888, 11903,
   11910, 11917, 11924, 11931, 11938, 11945, 11952, 11959, 11966, 11977,
   11984, 11995, 12006, 12026, 12025, 12031, 12048, 12054, 12063, 12072,
   12082, 12081, 12093, 12103, 12111, 12116, 12124, 12125, 12130, 12135,
   12138, 12140, 12144, 12149, 12157, 12158, 12162, 12166, 12173, 12180,
   12187, 12200, 12199, 12216, 12219, 12218, 12223, 12222, 12227, 12226,
   12230, 12235, 12236, 12240, 12241, 12242, 12243, 12244, 12245, 12246,
   12247, 12251, 12252, 12253, 12254, 12261, 12262, 12266, 12271, 12279,
   12280, 12284, 12291, 12299, 12308, 12318, 12319, 12328, 12337, 12349,
   12350, 12362, 12373, 12374, 12380, 12385, 12399, 12407, 12405, 12425,
   12423, 12436, 12448, 12446, 12466, 12465, 12477, 12490, 12488, 12509,
   12508, 12521, 12535, 12536, 12537, 12541, 12542, 12550, 12551, 12555,
   12564, 12565, 12566, 12571, 12575, 12576, 12580, 12581, 12585, 12586,
   12594, 12602, 12610, 12611, 12624, 12642, 12652, 12653, 12658, 12661,
   12662, 12663, 12667, 12668, 12673, 12672, 12678, 12677, 12685, 12686,
   12689, 12691, 12691, 12695, 12695, 12700, 12701, 12705, 12707, 12712,
   12713, 12717, 12728, 12742, 12743, 12744, 12745, 12746, 12747, 12748,
   12749, 12750, 12751, 12752, 12753, 12757, 12758, 12759, 12760, 12761,
   12762, 12763, 12764, 12765, 12769, 12770, 12771, 12772, 12775, 12777,
   12778, 12782, 12783, 12787, 12795, 12797, 12801, 12803, 12802, 12816,
   12819, 12818, 12836, 12838, 12842, 12847, 12855, 12856, 12873, 12896,
   12897, 12903, 12904, 12908, 12921, 12920, 12929, 12930, 12939, 12940,
   12944, 12945, 12949, 12950, 12964, 12965, 12969, 12979, 12988, 12995,
   13002, 13012, 13013, 13020, 13030, 13031, 13033, 13035, 13037, 13039,
   13048, 13052, 13053, 13057, 13071, 13072, 13078, 13077, 13088, 13094,
   13103, 13104, 13105, 13110, 13111, 13116, 13123, 13129, 13139, 13148,
   13154, 13160, 13169, 13174, 13179, 13183, 13189, 13195, 13204, 13213,
   13217, 13224, 13225, 13229, 13234, 13239, 13251, 13255, 13259, 13263,
   13268, 13271, 13275, 13289, 13297, 13310, 13312, 13316, 13317, 13321,
   13322, 13323, 13324, 13325, 13326, 13330, 13331, 13332, 13333, 13334,
   13338, 13339, 13340, 13341, 13345, 13346, 13347, 13348, 13349, 13353,
   13354, 13355, 13356, 13357, 13361, 13366, 13367, 13371, 13372, 13376,
   13377, 13378, 13383, 13382, 13414, 13415, 13419, 13420, 13424, 13434,
   13434, 13446, 13447, 13450, 13470, 13474, 13479, 13487, 13493, 13504,
   13492, 13506, 13521, 13533, 13532, 13555, 13554, 13564, 13563, 13586,
   13592, 13600, 13608, 13622, 13637, 13645, 13649, 13654, 13653, 13662,
   13667, 13673, 13678, 13683, 13690, 13688, 13702, 13703, 13707, 13719,
   13732, 13733, 13737, 13751, 13755, 13764, 13767, 13774, 13775, 13783,
   13794, 13782, 13809, 13819, 13808, 13834, 13842, 13843, 13850, 13854,
   13855, 13864, 13865, 13869, 13869, 13882, 13883, 13885, 13884, 13897,
   13903, 13905, 13909, 13911, 13917, 13921, 13922, 13926, 13927, 13931,
   13941, 13942, 13946, 13947, 13951, 13952, 13956, 13957, 13962, 13961,
   13977, 13976, 13991, 13992, 13996, 13997, 14001, 14006, 14014, 14022,
   14033, 14034, 14043, 14044, 14052, 14054, 14056, 14054, 14066, 14080,
   14087, 14097, 14086, 14126, 14127, 14131, 14138, 14146, 14147, 14151,
   14161, 14162, 14169, 14168, 14189, 14192, 14199, 14200, 14210, 14225,
   14233, 14246, 14245, 14260, 14259, 14275, 14277, 14281, 14282, 14286,
   14301, 14319, 14320, 14324, 14325, 14329, 14330, 14331, 14336, 14347,
   14335, 14357, 14359, 14360, 14363, 14365, 14368, 14370, 14373, 14374,
   14377, 14381, 14385, 14389, 14393, 14397, 14401, 14405, 14409, 14417,
   14420, 14430, 14429, 14448, 14455, 14463, 14471, 14479, 14487, 14495,
   14502, 14509, 14515, 14517, 14519, 14528, 14532, 14537, 14536, 14543,
   14542, 14548, 14557, 14564, 14569, 14574, 14579, 14584, 14589, 14591,
   14593, 14595, 14602, 14610, 14612, 14620, 14627, 14634, 14642, 14648,
   14653, 14661, 14669, 14677, 14681, 14686, 14693, 14698, 14705, 14712,
   14718, 14724, 14730, 14738, 14743, 14750, 14757, 14764, 14771, 14776,
   14781, 14786, 14791, 14798, 14820, 14822, 14824, 14829, 14830, 14833,
   14835, 14839, 14840, 14844, 14845, 14849, 14850, 14854, 14855, 14859,
   14860, 14864, 14865, 14873, 14885, 14884, 14903, 14902, 14912, 14913,
   14914, 14915, 14916, 14917, 14921, 14922, 14926, 14933, 14934, 14936,
   14937, 14941, 14942, 14955, 14956, 14957, 14972, 14971, 14983, 14982,
   14994, 14999, 15000, 15015, 15018, 15017, 15030, 15031, 15036, 15038,
   15040, 15042, 15044, 15046, 15054, 15056, 15058, 15060, 15065, 15067,
   15075, 15077, 15079, 15081, 15083, 15100, 15101, 15105, 15109, 15122,
   15121, 15134, 15142, 15143, 15146, 15148, 15149, 15153, 15169, 15170,
   15175, 15174, 15184, 15185, 15189, 15189, 15193, 15192, 15198, 15202,
   15203, 15207, 15208, 15215, 15220, 15219, 15234, 15233, 15248, 15249,
   15250, 15254, 15255, 15256, 15265, 15266, 15270, 15274, 15282, 15282,
   15287, 15288, 15296, 15308, 15322, 15333, 15346, 15307, 15359, 15360,
   15364, 15365, 15369, 15370, 15378, 15382, 15383, 15384, 15387, 15389,
   15393, 15394, 15398, 15403, 15410, 15415, 15422, 15424, 15428, 15429,
   15433, 15438, 15446, 15447, 15451, 15453, 15461, 15462, 15466, 15467,
   15468, 15472, 15474, 15479, 15480, 15489, 15490, 15494, 15495, 15499,
   15512, 15517, 15522, 15527, 15535, 15543, 15548, 15556, 15564, 15579,
   15586, 15592, 15602, 15603, 15611, 15612, 15613, 15614, 15628, 15634,
   15640, 15646, 15652, 15658, 15677, 15687, 15697, 15703, 15710, 15720,
   15727, 15734, 15745, 15744, 15769, 15770, 15775, 15776, 15783, 15781,
   15808, 15809, 15815, 15820, 15829, 15847, 15848, 15852, 15857, 15865,
   15870, 15878, 15883, 15888, 15893, 15899, 15904, 15912, 15917, 15922,
   15927, 15933, 15941, 15942, 15953, 15961, 15965, 15971, 15977, 15987,
   15993, 16002, 16012, 16013, 16017, 16018, 16019, 16023, 16031, 16039,
   16047, 16055, 16056, 16064, 16065, 16073, 16074, 16079, 16088, 16089,
   16097, 16098, 16107, 16108, 16116, 16117, 16121, 16130, 16131, 16132,
   16136, 16147, 16176, 16185, 16185, 16187, 16197, 16198, 16199, 16200,
   16201, 16202, 16203, 16204, 16205, 16210, 16211, 16212, 16213, 16214,
   16215, 16216, 16217, 16218, 16219, 16227, 16228, 16229, 16230, 16231,
   16232, 16236, 16237, 16238, 16239, 16240, 16241, 16242, 16243, 16244,
   16248, 16249, 16250, 16251, 16252, 16253, 16254, 16258, 16259, 16260,
   16261, 16262, 16263, 16264, 16265, 16266, 16270, 16271, 16272, 16273,
   16274, 16275, 16276, 16289, 16290, 16291, 16292, 16293, 16294, 16295,
   16296, 16297, 16298, 16299, 16300, 16301, 16302, 16303, 16304, 16305,
   16306, 16307, 16308, 16309, 16310, 16311, 16312, 16313, 16314, 16315,
   16316, 16317, 16318, 16319, 16320, 16321, 16322, 16323, 16324, 16325,
   16326, 16327, 16328, 16329, 16330, 16331, 16332, 16333, 16334, 16335,
   16336, 16337, 16338, 16339, 16340, 16341, 16342, 16343, 16384, 16385,
   16386, 16387, 16388, 16389, 16400, 16401, 16402, 16403, 16404, 16405,
   16406, 16407, 16408, 16409, 16413, 16414, 16415, 16422, 16423, 16424,
   16428, 16429, 16430, 16439, 16440, 16441, 16442, 16443, 16444, 16445,
   16446, 16447, 16448, 16449, 16450, 16451, 16452, 16453, 16454, 16455,
   16456, 16457, 16458, 16459, 16460, 16461, 16462, 16463, 16464, 16465,
   16466, 16467, 16468, 16469, 16470, 16471, 16472, 16480, 16481, 16482,
   16483, 16484, 16485, 16486, 16487, 16488, 16489, 16490, 16491, 16492,
   16493, 16494, 16495, 16496, 16497, 16498, 16499, 16500, 16501, 16502,
   16503, 16504, 16505, 16506, 16507, 16508, 16509, 16510, 16511, 16512,
   16513, 16514, 16515, 16516, 16517, 16518, 16519, 16520, 16521, 16522,
   16523, 16524, 16525, 16526, 16531, 16532, 16533, 16534, 16535, 16536,
   16537, 16538, 16539, 16540, 16541, 16542, 16543, 16544, 16545, 16546,
   16547, 16548, 16549, 16550, 16551, 16552, 16553, 16554, 16555, 16556,
   16557, 16558, 16559, 16560, 16561, 16562, 16563, 16564, 16565, 16566,
   16567, 16568, 16569, 16570, 16571, 16572, 16573, 16574, 16575, 16576,
   16577, 16578, 16579, 16580, 16581, 16582, 16583, 16584, 16585, 16586,
   16587, 16588, 16589, 16590, 16591, 16592, 16593, 16594, 16595, 16596,
   16597, 16598, 16599, 16600, 16601, 16602, 16603, 16604, 16605, 16606,
   16607, 16608, 16609, 16610, 16611, 16612, 16613, 16614, 16615, 16616,
   16617, 16618, 16619, 16620, 16621, 16622, 16623, 16624, 16625, 16626,
   16627, 16628, 16629, 16630, 16631, 16632, 16633, 16634, 16635, 16636,
   16637, 16638, 16639, 16640, 16641, 16642, 16643, 16644, 16645, 16646,
   16647, 16648, 16649, 16650, 16651, 16652, 16653, 16654, 16655, 16656,
   16657, 16658, 16659, 16660, 16661, 16662, 16663, 16664, 16665, 16666,
   16667, 16668, 16669, 16670, 16671, 16672, 16673, 16674, 16675, 16676,
   16677, 16678, 16679, 16680, 16681, 16682, 16683, 16684, 16685, 16686,
   16687, 16688, 16689, 16690, 16691, 16692, 16693, 16694, 16695, 16696,
   16697, 16698, 16699, 16700, 16701, 16702, 16703, 16704, 16705, 16706,
   16707, 16708, 16709, 16710, 16711, 16712, 16713, 16714, 16715, 16716,
   16717, 16718, 16719, 16720, 16721, 16722, 16723, 16724, 16725, 16726,
   16727, 16728, 16729, 16730, 16731, 16732, 16733, 16734, 16735, 16736,
   16737, 16738, 16739, 16740, 16741, 16742, 16743, 16744, 16745, 16746,
   16747, 16748, 16749, 16750, 16751, 16752, 16753, 16754, 16755, 16756,
   16757, 16758, 16759, 16760, 16761, 16762, 16763, 16764, 16765, 16766,
   16767, 16768, 16769, 16770, 16771, 16772, 16773, 16774, 16775, 16776,
   16777, 16778, 16779, 16780, 16781, 16782, 16783, 16784, 16785, 16786,
   16787, 16788, 16789, 16790, 16791, 16792, 16793, 16794, 16795, 16796,
   16797, 16798, 16799, 16811, 16810, 16827, 16833, 16826, 16849, 16848,
   16863, 16862, 16879, 16878, 16906, 16907, 16913, 16912, 16919, 16918,
   16928, 16927, 16938, 16937, 16943, 16951, 16953, 16958, 16958, 16968,
   16967, 16982, 16981, 16986, 16990, 16991, 16992, 16996, 16997, 16998,
   16999, 17003, 17004, 17005, 17006, 17011, 17016, 17021, 17030, 17035,
   17040, 17045, 17050, 17055, 17060, 17065, 17079, 17090, 17109, 17127,
   17139, 17147, 17152, 17168, 17169, 17170, 17171, 17175, 17194, 17212,
   17213, 17217, 17218, 17219, 17220, 17224, 17238, 17242, 17247, 17252,
   17263, 17264, 17265, 17271, 17277, 17289, 17288, 17302, 17303, 17309,
   17318, 17319, 17323, 17324, 17328, 17347, 17348, 17349, 17354, 17355,
   17360, 17359, 17377, 17376, 17388, 17397, 17407, 17406, 17447, 17448,
   17452, 17453, 17457, 17458, 17459, 17460, 17462, 17461, 17474, 17475,
   17476, 17477, 17478, 17484, 17489, 17495, 17501, 17507, 17514, 17521,
   17525, 17532, 17541, 17543, 17548, 17553, 17560, 17567, 17574, 17581,
   17588, 17595, 17607, 17608, 17612, 17613, 17617, 17622, 17630, 17640,
   17659, 17662, 17664, 17668, 17669, 17676, 17678, 17682, 17683, 17688,
   17687, 17691, 17690, 17694, 17693, 17697, 17696, 17699, 17700, 17701,
   17702, 17703, 17704, 17705, 17706, 17707, 17708, 17709, 17710, 17711,
   17712, 17713, 17714, 17715, 17716, 17717, 17718, 17719, 17720, 17721,
   17722, 17723, 17724, 17725, 17729, 17730, 17734, 17735, 17739, 17746,
   17753, 17763, 17773, 17782, 17791, 17804, 17809, 17817, 17822, 17830,
   17835, 17842, 17842, 17843, 17843, 17846, 17852, 17858, 17863, 17870,
   17876, 17883, 17892, 17896, 17902, 17912, 17916, 17920, 17921, 17925,
   17953, 17955, 17959, 17963, 17967, 17974, 17979, 17984, 17989, 17994,
   18002, 18003, 18007, 18008, 18013, 18014, 18018, 18019, 18023, 18024,
   18028, 18029, 18034, 18033, 18043, 18052, 18053, 18057, 18058, 18063,
   18064, 18065, 18070, 18071, 18072, 18076, 18088, 18097, 18103, 18112,
   18121, 18134, 18136, 18138, 18146, 18147, 18148, 18152, 18153, 18159,
   18160, 18161, 18162, 18163, 18164, 18165, 18175, 18176, 18181, 18194,
   18208, 18209, 18210, 18214, 18215, 18219, 18220, 18225, 18226, 18230,
   18236, 18245, 18245, 18259, 18260, 18261, 18262, 18272, 18274, 18280,
   18286, 18296, 18305, 18311, 18316, 18320, 18294, 18368, 18368, 18384,
   18383, 18399, 18407, 18398, 18422, 18423, 18427, 18428, 18434, 18438,
   18442, 18446, 18450, 18454, 18462, 18463, 18479, 18486, 18493, 18503,
   18504, 18505, 18509, 18510, 18511, 18515, 18516, 18521, 18523, 18522,
   18528, 18529, 18533, 18538, 18545, 18550, 18559
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ABORT_SYM",
  "ACCESSIBLE_SYM", "ADD", "ALL", "ALTER", "ANALYZE_SYM", "AND_AND_SYM",
  "AND_SYM", "AS", "ASC", "ASENSITIVE_SYM", "BEFORE_SYM", "BETWEEN_SYM",
  "BIGINT", "BINARY", "BIN_NUM", "BIT_AND", "BIT_OR", "BIT_XOR",
  "BLOB_MARIADB_SYM", "BLOB_ORACLE_SYM", "BODY_ORACLE_SYM", "BOTH", "BY",
  "CALL_SYM", "CASCADE", "CASE_SYM", "CAST_SYM", "CHANGE", "CHAR_SYM",
  "CHECK_SYM", "COLLATE_SYM", "CONDITION_SYM", "CONSTRAINT",
  "CONTINUE_MARIADB_SYM", "CONTINUE_ORACLE_SYM", "CONVERT_SYM",
  "COUNT_SYM", "CREATE", "CROSS", "CUME_DIST_SYM", "CURDATE",
  "CURRENT_USER", "CURRENT_ROLE", "CURSOR_SYM", "CURTIME", "DATABASE",
  "DATABASES", "DATE_ADD_INTERVAL", "DATE_SUB_INTERVAL", "DAY_HOUR_SYM",
  "DAY_MICROSECOND_SYM", "DAY_MINUTE_SYM", "DAY_SECOND_SYM", "DECIMAL_NUM",
  "DECIMAL_SYM", "DECLARE_MARIADB_SYM", "DECLARE_ORACLE_SYM", "DEFAULT",
  "DELETE_DOMAIN_ID_SYM", "DELETE_SYM", "DENSE_RANK_SYM", "DESC",
  "DESCRIBE", "DETERMINISTIC_SYM", "DISTINCT", "DIV_SYM", "DOUBLE_SYM",
  "DO_DOMAIN_IDS_SYM", "DOT_DOT_SYM", "DROP", "DUAL_SYM", "EACH_SYM",
  "ELSE", "ELSEIF_MARIADB_SYM", "ELSIF_ORACLE_SYM", "ENCLOSED",
  "END_OF_INPUT", "EQUAL_SYM", "ESCAPED", "EXCEPT_SYM", "EXISTS",
  "EXTRACT_SYM", "FALSE_SYM", "FETCH_SYM", "FIRST_VALUE_SYM", "FLOAT_NUM",
  "FLOAT_SYM", "FORCE_LOOKAHEAD", "FOREIGN", "FOR_SYM",
  "FOR_SYSTEM_TIME_SYM", "FROM", "FULLTEXT_SYM", "GE", "GOTO_ORACLE_SYM",
  "GRANT", "GROUP_SYM", "GROUP_CONCAT_SYM", "LAG_SYM", "LEAD_SYM",
  "HAVING", "HEX_NUM", "HEX_STRING", "HOUR_MICROSECOND_SYM",
  "HOUR_MINUTE_SYM", "HOUR_SECOND_SYM", "IDENT", "IDENT_QUOTED", "IF_SYM",
  "IGNORE_DOMAIN_IDS_SYM", "IGNORE_SYM", "INDEX_SYM", "INFILE",
  "INNER_SYM", "INOUT_SYM", "INSENSITIVE_SYM", "INSERT", "INTERSECT_SYM",
  "INTERVAL_SYM", "INTO", "INT_SYM", "IN_SYM", "IS", "ITERATE_SYM",
  "JOIN_SYM", "KEYS", "KEY_SYM", "KILL_SYM", "LE", "LEADING", "LEAVE_SYM",
  "LEFT", "LEFT_PAREN_ALT", "LEFT_PAREN_WITH", "LEFT_PAREN_LIKE",
  "LEX_HOSTNAME", "LIKE", "LIMIT", "LINEAR_SYM", "LINES", "LOAD",
  "LOCATOR_SYM", "LOCK_SYM", "LONGBLOB", "LONGTEXT", "LONG_NUM",
  "LONG_SYM", "LOOP_SYM", "LOW_PRIORITY",
  "MASTER_SSL_VERIFY_SERVER_CERT_SYM", "MATCH", "MAX_SYM", "MAXVALUE_SYM",
  "MEDIAN_SYM", "MEDIUMBLOB", "MEDIUMINT", "MEDIUMTEXT",
  "MINUTE_MICROSECOND_SYM", "MINUTE_SECOND_SYM", "MIN_SYM", "MODIFIES_SYM",
  "MOD_SYM", "MYSQL_CONCAT_SYM", "NATURAL", "NCHAR_STRING", "NE", "NEG",
  "NOT2_SYM", "NOT_SYM", "NOW_SYM", "NO_WRITE_TO_BINLOG", "NTILE_SYM",
  "NULL_SYM", "NUM", "NUMERIC_SYM", "NTH_VALUE_SYM", "ON", "OPTIMIZE",
  "OPTIONALLY", "ORACLE_CONCAT_SYM", "OR2_SYM", "ORDER_SYM", "OR_SYM",
  "OTHERS_ORACLE_SYM", "OUTER", "OUTFILE", "OUT_SYM", "OVER_SYM",
  "PACKAGE_ORACLE_SYM", "PAGE_CHECKSUM_SYM", "PARAM_MARKER",
  "PARSE_VCOL_EXPR_SYM", "PARTITION_SYM", "PERCENT_ORACLE_SYM",
  "PERCENT_RANK_SYM", "PERCENTILE_CONT_SYM", "PERCENTILE_DISC_SYM",
  "PORTION_SYM", "POSITION_SYM", "PRECISION", "PRIMARY_SYM",
  "PROCEDURE_SYM", "PURGE", "RAISE_ORACLE_SYM", "RANGE_SYM", "RANK_SYM",
  "READS_SYM", "READ_SYM", "READ_WRITE_SYM", "REAL", "RECURSIVE_SYM",
  "REF_SYSTEM_ID_SYM", "REFERENCES", "REGEXP", "RELEASE_SYM", "RENAME",
  "REPEAT_SYM", "REQUIRE_SYM", "RESIGNAL_SYM", "RESTRICT", "RETURNING_SYM",
  "RETURN_MARIADB_SYM", "RETURN_ORACLE_SYM", "REVOKE", "RIGHT", "ROWS_SYM",
  "ROWTYPE_ORACLE_SYM", "ROW_NUMBER_SYM", "SECOND_MICROSECOND_SYM",
  "SELECT_SYM", "SENSITIVE_SYM", "SEPARATOR_SYM", "SERVER_OPTIONS", "SET",
  "SET_VAR", "SHIFT_LEFT", "SHIFT_RIGHT", "SHOW", "SIGNAL_SYM", "SMALLINT",
  "SPATIAL_SYM", "SPECIFIC_SYM", "SQLEXCEPTION_SYM", "SQLSTATE_SYM",
  "SQLWARNING_SYM", "SQL_BIG_RESULT", "SQL_SMALL_RESULT", "SQL_SYM",
  "SSL_SYM", "STARTING", "STATS_AUTO_RECALC_SYM", "STATS_PERSISTENT_SYM",
  "STATS_SAMPLE_PAGES_SYM", "STDDEV_SAMP_SYM", "STD_SYM", "STRAIGHT_JOIN",
  "SUM_SYM", "SYSDATE", "TABLE_REF_PRIORITY", "TABLE_SYM", "TERMINATED",
  "TEXT_STRING", "THEN_SYM", "TINYBLOB", "TINYINT", "TINYTEXT", "TO_SYM",
  "TRAILING", "TRIGGER_SYM", "TRUE_SYM", "ULONGLONG_NUM",
  "UNDERSCORE_CHARSET", "UNDO_SYM", "UNION_SYM", "UNIQUE_SYM",
  "UNLOCK_SYM", "UNSIGNED", "UPDATE_SYM", "USAGE", "USE_SYM", "USING",
  "UTC_DATE_SYM", "UTC_TIMESTAMP_SYM", "UTC_TIME_SYM", "VALUES",
  "VALUES_IN_SYM", "VALUES_LESS_SYM", "VARBINARY", "VARCHAR",
  "VARIANCE_SYM", "VARYING", "VAR_SAMP_SYM", "WHEN_SYM", "WHERE",
  "WHILE_SYM", "WITH", "WITH_CUBE_SYM", "WITH_ROLLUP_SYM",
  "WITH_SYSTEM_SYM", "XOR", "YEAR_MONTH_SYM", "ZEROFILL",
  "IMPOSSIBLE_ACTION", "BODY_MARIADB_SYM", "ELSEIF_ORACLE_SYM",
  "ELSIF_MARIADB_SYM", "EXCEPTION_ORACLE_SYM", "GOTO_MARIADB_SYM",
  "OTHERS_MARIADB_SYM", "PACKAGE_MARIADB_SYM", "RAISE_MARIADB_SYM",
  "ROWTYPE_MARIADB_SYM", "REPLACE", "SUBSTRING", "TRIM", "ACCOUNT_SYM",
  "ACTION", "ADMIN_SYM", "ADDDATE_SYM", "AFTER_SYM", "AGAINST",
  "AGGREGATE_SYM", "ALGORITHM_SYM", "ALWAYS_SYM", "ANY_SYM", "ASCII_SYM",
  "AT_SYM", "ATOMIC_SYM", "AUTHORS_SYM", "AUTOEXTEND_SIZE_SYM", "AUTO_INC",
  "AUTO_SYM", "AVG_ROW_LENGTH", "AVG_SYM", "BACKUP_SYM",
  "BEGIN_MARIADB_SYM", "BEGIN_ORACLE_SYM", "BINLOG_SYM", "BIT_SYM",
  "BLOCK_SYM", "BOOL_SYM", "BOOLEAN_SYM", "BTREE_SYM", "BYTE_SYM",
  "CACHE_SYM", "CASCADED", "CATALOG_NAME_SYM", "CHAIN_SYM", "CHANGED",
  "CHARSET", "CHECKPOINT_SYM", "CHECKSUM_SYM", "CIPHER_SYM",
  "CLASS_ORIGIN_SYM", "CLIENT_SYM", "CLOB_MARIADB_SYM", "CLOB_ORACLE_SYM",
  "CLOSE_SYM", "COALESCE", "CODE_SYM", "COLLATION_SYM", "COLON_ORACLE_SYM",
  "COLUMNS", "COLUMN_ADD_SYM", "COLUMN_CHECK_SYM", "COLUMN_CREATE_SYM",
  "COLUMN_DELETE_SYM", "COLUMN_GET_SYM", "COLUMN_SYM", "COLUMN_NAME_SYM",
  "COMMENT_SYM", "COMMITTED_SYM", "COMMIT_SYM", "COMPACT_SYM",
  "COMPLETION_SYM", "COMPRESSED_SYM", "CONCURRENT", "CONNECTION_SYM",
  "CONSISTENT_SYM", "CONSTRAINT_CATALOG_SYM", "CONSTRAINT_NAME_SYM",
  "CONSTRAINT_SCHEMA_SYM", "CONTAINS_SYM", "CONTEXT_SYM",
  "CONTRIBUTORS_SYM", "CPU_SYM", "CUBE_SYM", "CURRENT_SYM",
  "CURRENT_POS_SYM", "CURSOR_NAME_SYM", "CYCLE_SYM", "DATAFILE_SYM",
  "DATA_SYM", "DATETIME", "DATE_FORMAT_SYM", "DATE_SYM", "DAY_SYM",
  "DEALLOCATE_SYM", "DECODE_MARIADB_SYM", "DECODE_ORACLE_SYM",
  "DEFINER_SYM", "DELAYED_SYM", "DELAY_KEY_WRITE_SYM", "DES_KEY_FILE",
  "DIAGNOSTICS_SYM", "DIRECTORY_SYM", "DISABLE_SYM", "DISCARD", "DISK_SYM",
  "DO_SYM", "DUMPFILE", "DUPLICATE_SYM", "DYNAMIC_SYM", "ENABLE_SYM",
  "END", "ENDS_SYM", "ENGINES_SYM", "ENGINE_SYM", "ENUM", "ERROR_SYM",
  "ERRORS", "ESCAPE_SYM", "EVENTS_SYM", "EVENT_SYM", "EVERY_SYM",
  "EXCHANGE_SYM", "EXAMINED_SYM", "EXCLUDE_SYM", "EXECUTE_SYM",
  "EXCEPTION_MARIADB_SYM", "EXIT_MARIADB_SYM", "EXIT_ORACLE_SYM",
  "EXPANSION_SYM", "EXPIRE_SYM", "EXPORT_SYM", "EXTENDED_SYM",
  "EXTENT_SIZE_SYM", "FAST_SYM", "FAULTS_SYM", "FILE_SYM", "FIRST_SYM",
  "FIXED_SYM", "FLUSH_SYM", "FOLLOWS_SYM", "FOLLOWING_SYM", "FORCE_SYM",
  "FORMAT_SYM", "FOUND_SYM", "FULL", "FUNCTION_SYM", "GENERAL",
  "GENERATED_SYM", "GEOMETRYCOLLECTION", "GEOMETRY_SYM", "GET_FORMAT",
  "GET_SYM", "GLOBAL_SYM", "GRANTS", "HANDLER_SYM", "HARD_SYM", "HASH_SYM",
  "HELP_SYM", "HIGH_PRIORITY", "HISTORY_SYM", "HOST_SYM", "HOSTS_SYM",
  "HOUR_SYM", "ID_SYM", "IDENTIFIED_SYM", "IGNORE_SERVER_IDS_SYM",
  "IMMEDIATE_SYM", "IMPORT", "INCREMENT_SYM", "INDEXES",
  "INITIAL_SIZE_SYM", "INSERT_METHOD", "INSTALL_SYM", "INVOKER_SYM",
  "IO_SYM", "IPC_SYM", "ISOLATION", "ISOPEN_SYM", "ISSUER_SYM",
  "INVISIBLE_SYM", "JSON_SYM", "KEY_BLOCK_SIZE", "LANGUAGE_SYM",
  "LAST_SYM", "LAST_VALUE", "LASTVAL_SYM", "LEAVES", "LESS_SYM",
  "LEVEL_SYM", "LINESTRING", "LIST_SYM", "LOCAL_SYM", "LOCKS_SYM",
  "LOGFILE_SYM", "LOGS_SYM", "MASTER_CONNECT_RETRY_SYM",
  "MASTER_DELAY_SYM", "MASTER_GTID_POS_SYM", "MASTER_HOST_SYM",
  "MASTER_LOG_FILE_SYM", "MASTER_LOG_POS_SYM", "MASTER_PASSWORD_SYM",
  "MASTER_PORT_SYM", "MASTER_SERVER_ID_SYM", "MASTER_SSL_CAPATH_SYM",
  "MASTER_SSL_CA_SYM", "MASTER_SSL_CERT_SYM", "MASTER_SSL_CIPHER_SYM",
  "MASTER_SSL_CRL_SYM", "MASTER_SSL_CRLPATH_SYM", "MASTER_SSL_KEY_SYM",
  "MASTER_SSL_SYM", "MASTER_SYM", "MASTER_USER_SYM", "MASTER_USE_GTID_SYM",
  "MASTER_HEARTBEAT_PERIOD_SYM", "MAX_CONNECTIONS_PER_HOUR",
  "MAX_QUERIES_PER_HOUR", "MAX_ROWS", "MAX_SIZE_SYM",
  "MAX_UPDATES_PER_HOUR", "MAX_STATEMENT_TIME_SYM",
  "MAX_USER_CONNECTIONS_SYM", "MEDIUM_SYM", "MEMORY_SYM", "MERGE_SYM",
  "MESSAGE_TEXT_SYM", "MICROSECOND_SYM", "MIGRATE_SYM", "MINUTE_SYM",
  "MINVALUE_SYM", "MIN_ROWS", "MODE_SYM", "MODIFY_SYM", "MONTH_SYM",
  "MULTILINESTRING", "MULTIPOINT", "MULTIPOLYGON", "MUTEX_SYM",
  "MYSQL_SYM", "MYSQL_ERRNO_SYM", "NAMES_SYM", "NAME_SYM", "NATIONAL_SYM",
  "NCHAR_SYM", "NEVER_SYM", "NEW_SYM", "NEXT_SYM", "NEXTVAL_SYM",
  "NOCACHE_SYM", "NOCYCLE_SYM", "NODEGROUP_SYM", "NONE_SYM",
  "NOTFOUND_SYM", "NO_SYM", "NOMAXVALUE_SYM", "NOMINVALUE_SYM",
  "NO_WAIT_SYM", "NOWAIT_SYM", "NUMBER_MARIADB_SYM", "NUMBER_ORACLE_SYM",
  "NVARCHAR_SYM", "OF_SYM", "OFFSET_SYM", "OLD_PASSWORD_SYM", "ONE_SYM",
  "ONLY_SYM", "ONLINE_SYM", "OPEN_SYM", "OPTIONS_SYM", "OPTION",
  "OWNER_SYM", "PACK_KEYS_SYM", "PAGE_SYM", "PARSER_SYM", "PARTIAL",
  "PARTITIONS_SYM", "PARTITIONING_SYM", "PASSWORD_SYM", "PERIOD_SYM",
  "PERSISTENT_SYM", "PHASE_SYM", "PLUGINS_SYM", "PLUGIN_SYM", "POINT_SYM",
  "POLYGON", "PORT_SYM", "PRECEDES_SYM", "PRECEDING_SYM", "PREPARE_SYM",
  "PRESERVE_SYM", "PREV_SYM", "PREVIOUS_SYM", "PRIVILEGES", "PROCESS",
  "PROCESSLIST_SYM", "PROFILE_SYM", "PROFILES_SYM", "PROXY_SYM",
  "QUARTER_SYM", "QUERY_SYM", "QUICK", "RAW_MARIADB_SYM", "RAW_ORACLE_SYM",
  "READ_ONLY_SYM", "REBUILD_SYM", "RECOVER_SYM", "REDOFILE_SYM",
  "REDO_BUFFER_SIZE_SYM", "REDUNDANT_SYM", "RELAY", "RELAYLOG_SYM",
  "RELAY_LOG_FILE_SYM", "RELAY_LOG_POS_SYM", "RELAY_THREAD", "RELOAD",
  "REMOVE_SYM", "REORGANIZE_SYM", "REPAIR", "REPEATABLE_SYM",
  "REPLICATION", "RESET_SYM", "RESTART_SYM", "RESOURCES", "RESTORE_SYM",
  "RESUME_SYM", "RETURNED_SQLSTATE_SYM", "RETURNS_SYM", "REUSE_SYM",
  "REVERSE_SYM", "ROLE_SYM", "ROLLBACK_SYM", "ROLLUP_SYM", "ROUTINE_SYM",
  "ROWCOUNT_SYM", "ROW_SYM", "ROW_COUNT_SYM", "ROW_FORMAT_SYM",
  "RTREE_SYM", "SAVEPOINT_SYM", "SCHEDULE_SYM", "SCHEMA_NAME_SYM",
  "SECOND_SYM", "SECURITY_SYM", "SEQUENCE_SYM", "SERIALIZABLE_SYM",
  "SERIAL_SYM", "SESSION_SYM", "SERVER_SYM", "SETVAL_SYM", "SHARE_SYM",
  "SHUTDOWN", "SIGNED_SYM", "SIMPLE_SYM", "SLAVE", "SLAVES",
  "SLAVE_POS_SYM", "SLOW", "SNAPSHOT_SYM", "SOCKET_SYM", "SOFT_SYM",
  "SONAME_SYM", "SOUNDS_SYM", "SOURCE_SYM", "SQL_BUFFER_RESULT",
  "SQL_CACHE_SYM", "SQL_CALC_FOUND_ROWS", "SQL_NO_CACHE_SYM", "SQL_THREAD",
  "STAGE_SYM", "STARTS_SYM", "START_SYM", "STATEMENT_SYM", "STATUS_SYM",
  "STOP_SYM", "STORAGE_SYM", "STORED_SYM", "STRING_SYM",
  "SUBCLASS_ORIGIN_SYM", "SUBDATE_SYM", "SUBJECT_SYM", "SUBPARTITIONS_SYM",
  "SUBPARTITION_SYM", "SUPER_SYM", "SUSPEND_SYM", "SWAPS_SYM",
  "SWITCHES_SYM", "SYSTEM", "SYSTEM_TIME_SYM", "TABLES", "TABLESPACE",
  "TABLE_CHECKSUM_SYM", "TABLE_NAME_SYM", "TEMPORARY", "TEMPTABLE_SYM",
  "TEXT_SYM", "THAN_SYM", "TIES_SYM", "TIMESTAMP", "TIMESTAMP_ADD",
  "TIMESTAMP_DIFF", "TIME_SYM", "TRANSACTION_SYM", "TRANSACTIONAL_SYM",
  "TRIGGERS_SYM", "TRIM_ORACLE", "TRUNCATE_SYM", "TYPES_SYM", "TYPE_SYM",
  "UDF_RETURNS_SYM", "UNBOUNDED_SYM", "UNCOMMITTED_SYM", "UNDEFINED_SYM",
  "UNDOFILE_SYM", "UNDO_BUFFER_SIZE_SYM", "UNICODE_SYM", "UNINSTALL_SYM",
  "UNKNOWN_SYM", "UNTIL_SYM", "UPGRADE_SYM", "USER_SYM", "USE_FRM",
  "VALUE_SYM", "VARCHAR2_MARIADB_SYM", "VARCHAR2_ORACLE_SYM", "VARIABLES",
  "VERSIONING_SYM", "VIA_SYM", "VIEW_SYM", "VIRTUAL_SYM", "WAIT_SYM",
  "WARNINGS", "WEEK_SYM", "WEIGHT_STRING_SYM", "WINDOW_SYM", "WITHIN",
  "WITHOUT", "WORK_SYM", "WRAPPER_SYM", "WRITE_SYM", "X509_SYM", "XA_SYM",
  "XML_SYM", "YEAR_SYM", "CONDITIONLESS_JOIN", "ON_SYM", "PREC_BELOW_NOT",
  "'='", "'>'", "'<'", "'|'", "'&'", "'-'", "'+'", "'*'", "'/'", "'%'",
  "'^'", "'~'", "SUBQUERY_AS_EXPR",
  "PREC_BELOW_IDENTIFIER_OPT_SPECIAL_CASE", "USER",
  "PREC_BELOW_CONTRACTION_TOKEN2", "'('", "')'", "EMPTY_FROM_CLAUSE",
  "','", "'!'", "'{'", "'}'", "';'", "'.'", "'@'", "$accept", "query",
  "$@1", "opt_end_of_input", "verb_clause", "statement", "deallocate",
  "deallocate_or_drop", "prepare", "$@2", "execute", "$@3", "$@4",
  "execute_using", "$@5", "execute_params", "help", "$@6", "change", "$@7",
  "master_defs", "master_def", "ignore_server_id_list", "ignore_server_id",
  "do_domain_id_list", "do_domain_id", "ignore_domain_id_list",
  "ignore_domain_id", "master_file_def", "optional_connection_name",
  "connection_name", "create", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "$@14", "$@15", "$@16", "$@17", "$@18", "$@19", "$@20", "$@21",
  "$@22", "$@23", "$@24", "$@25", "$@26", "$@27", "$@28", "$@29", "$@30",
  "$@31", "package_implementation_executable_section",
  "package_implementation_declare_section",
  "package_implementation_declare_section_list1",
  "package_implementation_declare_section_list2", "package_routine_lex",
  "package_specification_function", "$@32",
  "package_specification_procedure", "$@33",
  "package_implementation_routine_definition",
  "package_implementation_function_body", "$@34",
  "package_implementation_procedure_body", "$@35",
  "package_implementation_item_declaration",
  "opt_package_specification_element_list",
  "package_specification_element_list", "package_specification_element",
  "opt_sequence", "sequence_defs", "sequence_def", "force_lookahead",
  "server_def", "$@36", "server_options_list", "server_option",
  "event_tail", "$@37", "ev_schedule_time", "$@38", "opt_ev_status",
  "ev_starts", "ev_ends", "opt_ev_on_completion", "ev_on_completion",
  "opt_ev_comment", "ev_sql_stmt", "$@39", "clear_privileges",
  "opt_aggregate", "sp_name", "opt_sp_name", "sp_a_chistics",
  "sp_c_chistics", "sp_chistic", "create_package_chistic",
  "create_package_chistics", "opt_create_package_chistics",
  "opt_create_package_chistics_init", "$@40", "sp_c_chistic", "sp_suid",
  "call", "$@41", "$@42", "$@43", "opt_sp_cparam_list", "opt_sp_cparams",
  "sp_cparams", "sp_fdparam_list", "$@44", "sp_fdparams", "sp_param_name",
  "sp_param_name_and_type", "sp_pdparam_list", "sp_pdparams", "sp_pdparam",
  "sp_opt_inout", "sp_parenthesized_pdparam_list", "$@45", "sp_no_param",
  "opt_sp_parenthesized_fdparam_list", "opt_sp_parenthesized_pdparam_list",
  "sp_proc_stmts", "sp_proc_stmts1", "sp_proc_stmts1_implicit_block",
  "$@46", "opt_sp_decl_body_list", "sp_decl_body_list", "$@47",
  "sp_decl_non_handler_list", "sp_decl_handler_list",
  "opt_sp_decl_handler_list", "optionally_qualified_column_ident",
  "row_field_name", "row_field_definition", "row_field_definition_list",
  "row_type_body", "sp_decl_idents_init_vars", "sp_decl_vars",
  "sp_decl_non_handler", "$@48", "sp_decl_handler", "$@49",
  "opt_parenthesized_cursor_formal_parameters", "sp_cursor_stmt_lex",
  "sp_cursor_stmt", "$@50", "sp_handler_type", "sp_hcond_list",
  "sp_hcond_element", "sp_cond", "sqlstate", "opt_value", "sp_hcond",
  "raise_stmt_oracle", "signal_stmt", "signal_value", "opt_signal_value",
  "opt_set_signal_information", "signal_information_item_list",
  "signal_allowed_expr", "signal_condition_information_item_name",
  "resignal_stmt", "get_diagnostics", "which_area",
  "diagnostics_information", "statement_information",
  "statement_information_item", "simple_target_specification",
  "statement_information_item_name", "condition_number",
  "condition_information", "condition_information_item",
  "condition_information_item_name", "sp_decl_ident", "sp_decl_idents",
  "sp_opt_default", "sp_proc_stmt", "sp_labelable_stmt",
  "sp_proc_stmt_compound_ok", "sp_proc_stmt_if", "$@51", "sp_statement",
  "$@52", "$@53", "$@54", "sp_proc_stmt_statement", "$@55",
  "RETURN_ALLMODES_SYM", "sp_proc_stmt_return", "$@56", "reset_lex_expr",
  "$@57", "sp_proc_stmt_exit_oracle", "sp_proc_stmt_continue_oracle",
  "sp_proc_stmt_leave", "sp_proc_stmt_iterate", "sp_proc_stmt_goto_oracle",
  "remember_lex", "assignment_source_lex", "assignment_source_expr",
  "$@58", "for_loop_bound_expr", "$@59", "cursor_actual_parameters",
  "opt_parenthesized_cursor_actual_parameters", "sp_proc_stmt_open",
  "sp_proc_stmt_fetch_head", "sp_proc_stmt_fetch", "sp_proc_stmt_close",
  "sp_fetch_list", "sp_if", "$@60", "$@61", "$@62", "sp_elseifs",
  "case_stmt_specification", "$@63", "case_stmt_body", "$@64", "$@65",
  "simple_when_clause_list", "searched_when_clause_list",
  "simple_when_clause", "$@66", "$@67", "searched_when_clause", "$@68",
  "$@69", "else_clause_opt", "sp_opt_label", "sp_block_label",
  "sp_labeled_block", "$@70", "$@71", "$@72", "opt_not_atomic",
  "sp_unlabeled_block", "$@73", "$@74", "$@75", "sp_instr_addr", "sp_body",
  "$@76", "$@77", "$@78", "sp_block_statements_and_exceptions", "$@79",
  "opt_exception_clause", "exception_handlers", "exception_handler",
  "$@80", "opt_sp_for_loop_direction", "sp_for_loop_index_and_bounds",
  "$@81", "sp_for_loop_bounds", "loop_body", "while_body", "$@82",
  "repeat_body", "$@83", "pop_sp_loop_label", "sp_labeled_control", "$@84",
  "$@85", "$@86", "$@87", "$@88", "$@89", "sp_unlabeled_control", "$@90",
  "$@91", "$@92", "$@93", "$@94", "trg_action_time", "trg_event",
  "change_tablespace_access", "change_tablespace_info", "tablespace_info",
  "opt_logfile_group_name", "alter_tablespace_info", "logfile_group_info",
  "alter_logfile_group_info", "add_log_file", "change_ts_option_list",
  "$@95", "change_ts_options", "change_ts_option",
  "tablespace_option_list", "tablespace_options", "tablespace_option",
  "alter_tablespace_option_list", "alter_tablespace_options",
  "alter_tablespace_option", "logfile_group_option_list",
  "logfile_group_options", "logfile_group_option",
  "alter_logfile_group_option_list", "alter_logfile_group_options",
  "alter_logfile_group_option", "ts_datafile", "lg_undofile",
  "lg_redofile", "tablespace_name", "logfile_group_name", "ts_access_mode",
  "opt_ts_initial_size", "opt_ts_autoextend_size", "opt_ts_max_size",
  "opt_ts_extent_size", "opt_ts_undo_buffer_size",
  "opt_ts_redo_buffer_size", "opt_ts_nodegroup", "opt_ts_comment",
  "opt_ts_engine", "opt_ts_wait", "ts_wait", "size_number", "create_body",
  "$@96", "create_like", "opt_create_select",
  "create_select_query_expression", "opt_create_partitioning",
  "opt_partitioning", "partitioning", "$@97", "have_partitioning",
  "partition_entry", "$@98", "partition", "$@99", "part_type_def", "$@100",
  "$@101", "$@102", "opt_linear", "opt_key_algo", "part_field_list",
  "part_field_item_list", "part_field_item", "part_column_list",
  "part_func", "sub_part_func", "opt_num_parts", "opt_sub_part", "$@103",
  "$@104", "sub_part_field_list", "sub_part_field_item", "part_func_expr",
  "opt_num_subparts", "part_defs", "part_def_list", "part_definition",
  "$@105", "part_name", "opt_part_values", "$@106", "$@107",
  "part_func_max", "part_values_in", "part_value_list", "part_value_item",
  "$@108", "$@109", "part_value_item_list", "part_value_expr_item",
  "opt_sub_partition", "sub_part_list", "sub_part_definition", "$@110",
  "sub_name", "opt_part_options", "opt_part_option_list",
  "opt_part_option", "opt_versioning_rotation", "$@111",
  "opt_versioning_interval_start", "opt_as", "opt_create_database_options",
  "create_database_options", "create_database_option",
  "opt_if_not_exists_table_element", "opt_if_not_exists",
  "create_or_replace", "opt_create_table_options",
  "create_table_options_space_separated", "create_table_options",
  "create_table_option", "$@112", "opt_versioning_option",
  "versioning_option", "default_charset", "default_collation",
  "storage_engines", "known_storage_engines", "row_types",
  "merge_insert_types", "udf_type", "create_field_list",
  "create_field_list_parens", "field_list", "field_list_item",
  "column_def", "key_def", "$@113", "$@114", "$@115", "$@116", "$@117",
  "$@118", "$@119", "constraint_def", "period_for_system_time",
  "period_for_application_time", "opt_check_constraint",
  "check_constraint", "opt_constraint_no_id", "opt_constraint",
  "constraint", "field_spec", "@120", "field_type_or_serial", "$@121",
  "$@122", "opt_serial_attribute", "opt_serial_attribute_list",
  "opt_asrow_attribute", "opt_asrow_attribute_list", "field_def", "$@123",
  "opt_generated_always", "vcol_opt_specifier", "vcol_opt_attribute",
  "vcol_opt_attribute_list", "vcol_attribute", "parse_vcol_expr", "$@124",
  "parenthesized_expr", "virtual_column_func", "expr_or_literal",
  "column_default_expr", "field_type", "qualified_field_type",
  "field_type_all", "sp_param_field_type", "field_type_numeric",
  "opt_binary_and_compression", "field_type_string",
  "sp_param_field_type_string", "field_type_temporal", "field_type_lob",
  "field_type_misc", "spatial_type", "char", "nchar", "varchar",
  "nvarchar", "int_type", "real_type", "srid_option", "float_options",
  "precision", "field_options", "field_length", "opt_field_length",
  "opt_field_length_default_1",
  "opt_field_length_default_sp_param_varchar",
  "opt_field_length_default_sp_param_char", "opt_precision",
  "attribute_list", "attribute", "opt_compression_method",
  "opt_compressed", "compressed",
  "compressed_deprecated_data_type_attribute",
  "compressed_deprecated_column_attribute", "asrow_attribute",
  "serial_attribute", "with_or_without_system", "sp_param_type", "charset",
  "charset_name", "charset_name_or_default", "opt_load_data_charset",
  "old_or_new_charset_name", "old_or_new_charset_name_or_default",
  "collation_name", "opt_collate", "collation_name_or_default",
  "opt_default", "charset_or_alias", "collate", "opt_binary", "binary",
  "opt_bin_mod", "ws_nweights", "$@125", "ws_level_flag_desc",
  "ws_level_flag_reverse", "ws_level_flags", "ws_level_number",
  "ws_level_list_item", "ws_level_list", "ws_level_range",
  "ws_level_list_or_range", "opt_ws_levels", "opt_primary", "references",
  "opt_ref_list", "ref_list", "opt_match_clause", "opt_on_update_delete",
  "delete_option", "constraint_key_type", "key_or_index",
  "opt_key_or_index", "keys_or_index", "opt_unique", "fulltext", "spatial",
  "normal_key_options", "fulltext_key_options", "spatial_key_options",
  "normal_key_opts", "spatial_key_opts", "fulltext_key_opts",
  "opt_USING_key_algorithm", "opt_key_algorithm_clause", "key_using_alg",
  "all_key_opt", "normal_key_opt", "spatial_key_opt", "fulltext_key_opt",
  "btree_or_rtree", "key_list", "key_part", "opt_ident", "string_list",
  "alter", "$@126", "$@127", "$@128", "$@129", "$@130", "$@131", "$@132",
  "$@133", "$@134", "$@135", "$@136", "account_locking_option",
  "opt_password_expire_option",
  "opt_account_locking_and_opt_password_expiration",
  "ev_alter_on_schedule_completion", "opt_ev_rename_to", "opt_ev_sql_stmt",
  "ident_or_empty", "alter_commands", "$@137", "$@138", "$@139",
  "remove_partitioning", "all_or_alt_part_name_list", "add_partition_rule",
  "$@140", "add_part_extra", "reorg_partition_rule", "$@141",
  "reorg_parts_rule", "$@142", "alt_part_name_list", "alt_part_name_item",
  "alter_list", "add_column", "alter_list_item",
  "opt_index_lock_algorithm", "alter_algorithm_option",
  "alter_lock_option", "opt_column", "opt_ignore", "alter_options",
  "$@143", "alter_options_part2", "alter_option_list", "alter_option",
  "opt_restrict", "opt_place", "opt_to", "slave", "$@144", "$@145",
  "start", "opt_start_transaction_option_list",
  "start_transaction_option_list", "start_transaction_option",
  "slave_thread_opts", "$@146", "slave_thread_opt_list",
  "slave_thread_opt", "slave_until", "slave_until_opts", "checksum",
  "$@147", "opt_checksum_type", "repair_table_or_view", "$@148", "repair",
  "$@149", "opt_mi_repair_type", "mi_repair_types", "mi_repair_type",
  "opt_view_repair_type", "analyze", "$@150", "analyze_table_list",
  "analyze_table_elem_spec", "opt_persistent_stat_clause",
  "persistent_stat_spec", "persistent_column_stat_spec", "$@151",
  "persistent_index_stat_spec", "$@152", "table_column_list",
  "table_index_list", "table_index_name", "binlog_base64_event",
  "check_view_or_table", "$@153", "check", "$@154", "opt_mi_check_type",
  "mi_check_types", "mi_check_type", "opt_view_check_type", "optimize",
  "$@155", "opt_no_write_to_binlog", "rename", "$@156", "rename_list",
  "table_to_table_list", "table_to_table", "keycache", "$@157",
  "keycache_list_or_parts", "keycache_list", "assign_to_keycache",
  "assign_to_keycache_parts", "key_cache_name", "preload", "$@158",
  "preload_list_or_parts", "preload_list", "preload_keys",
  "preload_keys_parts", "adm_partition", "$@159", "cache_keys_spec",
  "$@160", "cache_key_list_or_empty", "opt_ignore_leaves", "select",
  "$@161", "$@162", "select_into", "$@163", "$@164", "simple_table",
  "table_value_constructor", "$@165", "query_specification_start", "$@166",
  "$@167", "query_specification", "select_into_query_specification",
  "query_expression", "query_expression_no_with_clause",
  "query_expression_body_ext", "$@168", "$@169",
  "query_expression_body_ext_parens", "query_expression_body", "$@170",
  "query_primary", "query_simple", "subselect", "subquery",
  "opt_from_clause", "from_clause", "table_reference_list",
  "select_options", "opt_history_unit", "history_point",
  "for_portion_of_time_clause", "opt_for_portion_of_time_clause",
  "opt_for_system_time_clause", "system_time_expr", "select_option_list",
  "select_option", "select_lock_type", "opt_select_lock_type",
  "opt_lock_wait_timeout_new", "select_item_list", "select_item",
  "remember_tok_start", "remember_name", "remember_end",
  "remember_end_opt", "select_alias", "opt_default_time_precision",
  "opt_time_precision", "optional_braces", "expr", "boolean_test",
  "predicate", "bit_expr", "or", "and", "not", "not2", "comp_op",
  "all_or_any", "opt_dyncol_type", "dyncol_type", "numeric_dyncol_type",
  "temporal_dyncol_type", "string_dyncol_type", "$@171",
  "dyncall_create_element", "dyncall_create_list", "plsql_cursor_attr",
  "explicit_cursor_attr", "trim_operands",
  "column_default_non_parenthesized_expr", "primary_expr",
  "string_factor_expr", "simple_expr", "mysql_concatenation_expr",
  "function_call_keyword_timestamp", "function_call_keyword",
  "substring_operands", "function_call_nonkeyword",
  "function_call_conflict", "geometry_function", "function_call_generic",
  "@172", "fulltext_options", "opt_natural_language_mode",
  "opt_query_expansion", "opt_udf_expr_list", "udf_expr_list", "udf_expr",
  "sum_expr", "$@173", "$@174", "$@175", "window_func_expr", "window_func",
  "simple_window_func", "inverse_distribution_function",
  "percentile_function", "$@176", "inverse_distribution_function_def",
  "order_by_single_element_list", "window_name", "variable", "$@177",
  "variable_aux", "opt_distinct", "opt_gconcat_separator",
  "opt_gorder_clause", "gorder_list", "opt_glimit_clause",
  "glimit_clause_init", "glimit_clause", "glimit_options", "in_sum_expr",
  "$@178", "cast_type", "$@179", "$@180", "$@181", "cast_type_numeric",
  "cast_type_temporal", "opt_expr_list", "expr_list", "ident_list_arg",
  "ident_list", "when_list", "when_list_opt_else",
  "decode_when_list_oracle", "table_ref", "join_table_list",
  "esc_table_ref", "derived_table_list", "join_table", "$@182", "$@183",
  "$@184", "$@185", "$@186", "$@187", "inner_join", "normal_join",
  "opt_use_partition", "use_partition", "table_factor",
  "table_primary_ident_opt_parens", "table_primary_derived_opt_parens",
  "table_reference_list_parens", "nested_table_reference_list",
  "join_table_parens", "table_primary_ident", "table_primary_derived",
  "opt_outer", "index_hint_clause", "index_hint_type",
  "index_hint_definition", "$@188", "$@189", "index_hints_list",
  "opt_index_hints_list", "$@190", "opt_key_definition", "$@191",
  "opt_key_usage_list", "key_usage_element", "key_usage_list",
  "using_list", "interval", "interval_time_stamp", "date_time_type",
  "table_alias", "opt_table_alias_clause", "table_alias_clause", "opt_all",
  "opt_where_clause", "$@192", "opt_having_clause", "$@193",
  "opt_group_clause", "group_list", "olap_opt", "opt_window_clause",
  "window_def_list", "window_def", "window_spec", "$@194",
  "opt_window_ref", "opt_window_partition_clause",
  "opt_window_order_clause", "opt_window_frame_clause",
  "window_frame_units", "window_frame_extent", "window_frame_start",
  "window_frame_bound", "opt_window_frame_exclusion", "alter_order_clause",
  "alter_order_list", "alter_order_item", "opt_order_clause",
  "order_clause", "$@195", "order_list", "order_dir", "opt_limit_clause",
  "limit_clause", "opt_global_limit_clause", "limit_options",
  "limit_option", "limit_rows_option", "delete_limit_clause",
  "order_limit_lock", "opt_order_limit_lock", "query_expression_tail",
  "opt_query_expression_tail", "opt_procedure_or_into", "order_or_limit",
  "opt_plus", "int_num", "ulong_num", "real_ulong_num", "longlong_num",
  "ulonglong_num", "real_ulonglong_num", "dec_num_error", "dec_num",
  "choice", "bool", "procedure_clause", "$@196", "procedure_list",
  "procedure_list2", "procedure_item", "select_var_list_init", "$@197",
  "select_var_list", "select_var_ident", "select_outvar", "into",
  "into_destination", "$@198", "$@199", "do", "$@200", "drop", "$@201",
  "$@202", "$@203", "$@204", "table_list", "table_name",
  "table_name_with_opt_use_partition", "table_alias_ref_list",
  "table_alias_ref", "opt_if_exists_table_element", "opt_if_exists",
  "opt_temporary", "insert", "$@205", "$@206", "replace", "$@207", "$@208",
  "insert_lock_option", "replace_lock_option", "insert2", "insert_table",
  "$@209", "insert_field_spec", "$@210", "insert_field_list", "opt_fields",
  "fields", "insert_values", "values_list", "ident_eq_list",
  "ident_eq_value", "equal", "opt_equal", "opt_with", "opt_by",
  "no_braces", "$@211", "no_braces_with_names", "$@212", "opt_values",
  "opt_values_with_names", "values", "values_with_names", "expr_or_ignore",
  "expr_or_ignore_or_default", "opt_insert_update", "$@213", "$@214",
  "update_table_list", "update", "$@215", "$@216", "update_list",
  "update_elem", "insert_update_list", "insert_update_elem",
  "opt_low_priority", "delete", "$@217", "opt_delete_system_time",
  "delete_part2", "delete_single_table", "delete_single_table_for_period",
  "single_multi", "$@218", "$@219", "opt_select_expressions",
  "table_wild_list", "table_wild_one", "opt_wild", "opt_delete_options",
  "opt_delete_option", "truncate", "$@220", "$@221",
  "opt_truncate_table_storage_clause", "opt_table_sym", "opt_profile_defs",
  "profile_defs", "profile_def", "opt_profile_args", "show", "$@222",
  "show_param", "$@223", "$@224", "show_engine_param", "master_or_binary",
  "opt_storage", "opt_db", "opt_full", "from_or_in", "binlog_in",
  "binlog_from", "wild_and_where", "describe", "$@225", "$@226",
  "explainable_command", "describe_command", "analyze_stmt_command",
  "opt_extended_describe", "opt_format_json", "opt_describe_column",
  "flush", "$@227", "flush_options", "$@228", "opt_flush_lock",
  "flush_lock", "$@229", "flush_options_list", "flush_option",
  "opt_table_list", "backup", "backup_statements", "$@230",
  "opt_delete_gtid_domain", "delete_domain_id_list", "delete_domain_id",
  "optional_flush_tables_arguments", "reset", "$@231", "reset_options",
  "reset_option", "$@232", "$@233", "slave_reset_options",
  "master_reset_options", "purge", "$@234", "kill", "$@235", "kill_type",
  "kill_option", "opt_connection", "kill_expr", "shutdown", "$@236",
  "shutdown_option", "use", "load", "$@237", "$@238", "$@239", "$@240",
  "data_or_xml", "opt_local", "load_data_lock", "opt_duplicate",
  "opt_field_term", "field_term_list", "field_term", "opt_line_term",
  "line_term_list", "line_term", "opt_xml_rows_identified_by",
  "opt_ignore_lines", "lines_or_rows", "opt_field_or_var_spec",
  "fields_or_vars", "field_or_var", "opt_load_data_set_spec",
  "load_data_set_list", "load_data_set_elem", "text_literal",
  "text_string", "hex_or_bin_String", "param_marker", "signed_literal",
  "literal", "NUM_literal", "temporal_literal", "with_clause", "$@241",
  "opt_recursive", "with_list", "with_list_element", "$@242",
  "opt_with_column_list", "with_column_list", "with_element_head",
  "insert_ident", "table_wild", "select_sublist_qualified_asterisk",
  "order_ident", "simple_ident", "simple_ident_nospvar", "field_ident",
  "table_ident", "table_ident_opt_wild", "table_ident_nodb", "IDENT_cli",
  "ident_cli", "IDENT_sys", "TEXT_STRING_sys", "TEXT_STRING_literal",
  "TEXT_STRING_filesystem", "ident_table_alias", "ident_set_usual_case",
  "ident_sysvar_name", "ident", "ident_directly_assignable", "label_ident",
  "labels_declaration_oracle", "label_declaration_oracle", "ident_or_text",
  "user_maybe_role", "user_or_role", "user", "keyword_table_alias",
  "keyword_ident", "keyword_label", "keyword_sysvar_name",
  "keyword_sp_decl", "keyword_set_usual_case",
  "keyword_directly_assignable", "keyword_sp_var_not_label",
  "keyword_sp_head", "keyword_verb_clause", "keyword_set_special_case",
  "keyword_sp_block_section", "keyword_sysvar_type", "keyword_data_type",
  "keyword_sp_var_and_label", "set", "$@243", "$@244", "$@245",
  "set_assign", "$@246", "$@247", "$@248",
  "set_stmt_option_value_following_option_type_list",
  "start_option_value_list", "$@249", "$@250", "$@251",
  "start_option_value_list_following_option_type", "$@252",
  "option_value_list_continued", "option_value_list", "$@253", "$@254",
  "option_value", "$@255", "option_type", "opt_var_type",
  "opt_var_ident_type", "option_value_following_option_type",
  "option_value_no_option_type", "transaction_characteristics",
  "transaction_access_mode", "isolation_level",
  "transaction_access_mode_types", "isolation_types", "opt_for_user",
  "text_or_password", "set_expr_or_default", "lock", "$@256",
  "opt_lock_wait_timeout", "table_or_tables", "table_lock_list",
  "table_lock", "lock_option", "unlock", "$@257", "handler", "$@258",
  "handler_tail", "$@259", "handler_read_or_scan", "handler_scan_function",
  "handler_rkey_function", "$@260", "handler_rkey_mode", "revoke",
  "revoke_command", "admin_option_for_role", "grant", "grant_command",
  "opt_with_admin", "opt_with_admin_option", "role_list", "current_role",
  "grant_role", "opt_table", "grant_privileges", "opt_privileges",
  "object_privilege_list", "object_privilege", "$@261", "$@262", "$@263",
  "$@264", "opt_and", "require_list", "require_list_element",
  "grant_ident", "user_list", "grant_list", "user_and_role_list",
  "via_or_with", "using_or_as", "grant_user", "auth_expression",
  "auth_token", "opt_auth_str", "opt_column_list", "column_list",
  "column_list_id", "opt_require_clause", "resource_option",
  "resource_option_list", "opt_resource_options", "opt_grant_options",
  "opt_grant_option", "grant_option_list", "grant_option",
  "begin_stmt_mariadb", "$@265", "compound_statement", "opt_not",
  "opt_work", "opt_chain", "opt_release", "commit", "rollback",
  "savepoint", "release", "unit_type_decl", "union_option",
  "query_expression_option", "definer_opt", "no_definer", "definer",
  "view_algorithm", "opt_view_suid", "view_suid", "view_list_opt",
  "view_list", "view_select", "$@266", "view_check_option",
  "trigger_action_order", "trigger_follows_precedes_clause",
  "trigger_tail", "$@267", "$@268", "$@269", "$@270", "$@271",
  "sf_return_type", "$@272", "sf_c_chistics_and_body_standalone", "$@273",
  "sp_tail_standalone", "$@274", "$@275", "opt_package_routine_end_name",
  "sp_tail_is", "xa", "opt_format_xid", "xid", "begin_or_start",
  "opt_join_or_resume", "opt_one_phase", "opt_suspend", "$@276",
  "opt_migrate", "install", "uninstall", "keep_gcc_happy", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-5342)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3494)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const int yypact[] =
{
   18274,  4398,  1450, 88938, -5342,   -16, -5342,  1022, -5342, -5342,
   -5342, -5342,  4614, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,   333,   917, -5342,  1120, -5342, -5342,   554, 84444,  -140,
    1058, -5342, 85728, -5342, -5342,  -170, -5342, 85728, -5342, -5342,
   88938, -5342, -5342,   393, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,   486, -5342,  2528,    87, -5342, -5342, -5342,
   -5342, -5342, -5342,   434, -5342, -5342, -5342, -5342, -5342,   917,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, 88938, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  -111, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342,   885, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, 89580, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,  1520, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,  2467, -5342, -5342, -5342, -5342, -5342,
    1229, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,   -91, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, 88938, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  1120, -5342, -5342,  1808,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  -111,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, 88938, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,   234, -5342,
   -5342,   279, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,  1899, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342,  2841, -5342, -5342,
     514,  1492,  1459, -5342, -5342,   932, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342,  3575, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
    1974, -5342, -5342, -5342, -5342,  4409,  2220, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, 73510, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342,   514, -5342, -5342,
      60, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, 88938, 88938,  1018,  1217, 88938,  1926,
    1928, 85086, 88938,  1928, -5342,    98, -5342, -5342,  1875, -5342,
    1331, -5342,   917,   495, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342,  1530, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342,  2028,  2149,   482,  2239,  2458, 88938, 52868,  1289,
    1928, -5342,  2254,  1928,  1928,  1928,  1928,  2461,  1928,  1928,
   88938, -5342,  1928,  1928,   560, 93432, 40202, -5342,  1515,    16,
    2448, -5342, -5342, -5342, -5342, -5342, -5342,  8379,   917, 26403,
    2577, -5342, -5342,  2117,  4554,  2015, -5342,  2414, -5342, -5342,
   88938, -5342, -5342,  8379, -5342,  2414, 40948,  2854, -5342, 38741,
    7664,  2414,   917,  2596, -5342,  2007, 26403, -5342, -5342,  1172,
   -5342, -5342, 88938, -5342,  -111, -5342, -5342, -5342,  2486, -5342,
   85086, -5342, -5342, -5342,  2019, -5342,  2804, 26403,   250,  2560,
   -5342, -5342,  2462, 74152, 85086,  2744,  2149,  2802, -5342,  1869,
    1751, -5342,  2169,  2271,  2149,  2095,  2288,  2149,  2656,  1928,
    1928, -5342, -5342,  1993,  1993,  1993,  2504,  1993, -5342,  1993,
    2891,  2198,   244, -5342, -5342,  2217, 88938,  2744, -5342, -5342,
   -5342,  2744,  2744,  2354,  2909,  2925,  2932,   122,  2962,   174,
     174,  1875, 54950,   297,  2756, -5342,  2891,  2487,   409, -5342,
   -5342,  2432,  2487,   514,  2487, -5342,   330,  1331,  2016, 88938,
   -5342, -5342, -5342,  2308, -5342, -5342, -5342, 88938, -5342,  2331,
   -5342,  2318,  1707, 53575, -5342, 88938,  3021, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342,  2766, -5342, -5342,  2837,   288,
    2460,  2687,  2384, -5342,  2866, 85086, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, 88938,  2373, -5342,  3051, 26403,  2028,
   -5342,  2878, -5342, -5342, -5342, -5342, 74152, -5342, 88938, -5342,
    3151, -5342, -5342, 93432, -5342, -5342,  1392, -5342, -5342, 56351,
    1579, 45836, -5342,  2385,  2395,  2717, -5342,  2416,  1802,  1809,
   -5342,  1854, -5342, -5342,  1877,  1881,  1884, -5342, -5342,  3101,
   -5342, -5342, 77382,   668, 88938,  3097,  1928, 88938, 88938, 88938,
   88938, 88938, 88938, -5342, 85086,  2523, -5342, -5342,  1928,  1928,
   -5342, -5342,  2619,  2599,  3235,  2512,  2808, -5342,  2708, -5342,
   -5342,  2609, -5342, -5342,   206, -5342, -5342, -5342,    99,   116,
     265,   361,  3110,   374,   967,   386,   397, -5342, -5342, -5342,
    3039,  3135,  2556, -5342,  2903, 26403, -5342, -5342, -5342,  3222,
   -5342, -5342,  1554,  3002,   278, 74152, 94074, 76730, 95006, 95006,
   95006, -5342, -5342,   180, 95006, 88938, 94540, 88938,  6600,  2598,
   -5342, -5342, -5342, 19764, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, 88938, -5342, -5342, -5342,   351, -5342, -5342, -5342,
   -5342, -5342,  8414, -5342, -5342, 31569, -5342,  2600,  2611,  2614,
   21975,  2617,  2624,  2626,  2648,  2661,  2512,  2512,  2512,  2666,
    2670,  2671,  2678, -5342,  2722,  2723,  2743,  2754, -5342,  2767,
   -5342,  2776,  2781,  2784, -5342, -5342,   112,   124,  2792,  2793,
   27141,  2805, -5342, 68374,  2812,  2831,  2836,  2842, -5342, -5342,
   26403,  2666,  2844, -5342, -5342,  2851, -5342,  2852,  2870,  2871,
    2887,  2898,  2902,  2906,  2918,  3291,  2922,  2929,  2948,  2666,
   -5342, -5342, -5342,  2351,  2512,  2666,  2666,  2953,  2956,  2981,
    2984,  2991,  2995,  3011,  3023,  3026,  3044,  3060, 86370,  3070,
    3074,  3092,  3111,  3129,  3136,  3144,   359,  3147,  3150,  3155,
    3157,  3166,  3169,  3173,  3201,  3202,  3206,  3210,  3220,  3226,
    3238,  3241,  3247,  2856,  3252,  3255,  3266,  3274,  3279,  2859,
    3294,  3295,  3297,  3299,  3302,  3303,  3313,   485,  3315,  3323,
     493,  3326,  3328,  3332,  3336,  3337,  3339,  3340,  3342, 32307,
   33045, 31569, 20499, -5342, 88938, 90222, -5342, -5342, -5342,  3976,
    2637,  2579,  3906, 31569, -5342, -5342, -5342,  3574, -5342,  3427,
   -5342, -5342, -5342, -5342, -5342,  3421,  3495, -5342,  3532, -5342,
   -5342,  3546,  3033, -5342,  3612, -5342, -5342, -5342, -5342, -5342,
    3030,  3345,  3627,  3725, -5342, -5342,  1382, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  3178,
    3258, -5342,  3612, -5342, -5342, 54277, 74152,  5148, -5342, -5342,
    2619,  3477,  3937, -5342,  4024, -5342,  3942, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  2854,
   -5342, -5342, 59808,  3889,  -143,   421,  3359,   441,   499, 45100,
     344, 81876,   550,  1092,  3361, 64522, 48758,  3364,   107,  3368,
   -5342,  3370,  3371,  3373,  3375,  3376,  3379,  3380, -5342, -5342,
   -5342,  3498,  3392,  1966,  2134, -5342, -5342,   283,    61,  3483,
   -5342,  3740, -5342,  2134, -5342, 41616,  4031,  2632, -5342,   923,
   -5342,  4082, -5342, -5342,  3497,  3482,  3512, -5342,  3778, -5342,
    2149, -5342,   985, -5342,  4031,  2134,  2632, -5342,  3685,  3770,
     916,  4098, -5342,  1916, -5342, -5342, -5342,  3222, -5342,  3418,
   -5342, -5342,  3544, 88938, -5342,  4070, -5342, 74152, -5342, -5342,
   -5342, -5342,  3424, 74152, 74152, 88938,  1010,   270,  3976,  3426,
   26403, -5342, -5342,  5571, 42328,  3619,   267,  1316, -5342, -5342,
    2528, 88938, -5342, -5342,   532, -5342,  3856, -5342,  3434, -5342,
   90864,   270,  4117, -5342, -5342, -5342,  1386,  3833, -5342,  3442,
   -5342, -5342, -5342, -5342, 74152, 88938,  2149, -5342, -5342, -5342,
   -5342,  3443, -5342, -5342,  3645,  3529, -5342,  3467, -5342, -5342,
     534, -5342, -5342,  4144, -5342, 88938, -5342, -5342,  2744, -5342,
    2744, -5342, -5342,  2744,  2744,  2514,  2744, -5342, -5342,  3489,
   -5342,  3773,  3787,  2866, -5342, 67732, 88938,  4147, -5342,  3636,
   -5342, -5342,  3470, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  4049,  3985,  3985, -5342, 65164, -5342, -5342,  4152,  2756,
    3973, 82518,  4130,  4230, -5342,  4031, -5342, -5342, -5342,  1375,
   88938, -5342,  1375,  1375, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,   514, -5342, -5342,   495, 50801, 88938,
    2487,   409, 16755,  4022,  4203,  3871, -5342, 88938, -5342, -5342,
   -5342,  2512,  3491, -5342, -5342, -5342, -5342, -5342,  4268, -5342,
   -5342, 74152,  3697,  3880,  3880,  3880,  4273, -5342, -5342, -5342,
   53575, 74152, -5342, -5342, -5342,   288, -5342,  1026, 88938, 74152,
    3542, -5342, 74152,  3503, 26403, -5342, 26403, -5342,  3866,  3976,
   -5342, -5342, 74152,  1158, -5342, -5342, -5342,  4268,  3880, -5342,
    3945,  1579,  3508,  3509, -5342,  3523,  3523,    -2, -5342,  3524,
    4093,  3524, -5342,  3918,  1110,  3099,  3918, -5342,  1110,  3524,
   -5342,  3531, -5342,  3918, -5342,  1110,  3523, -5342,  3523, -5342,
   -5342,  1110,  3523, -5342,  3534,  3524, -5342, -5342,  3918, -5342,
   -5342, -5342, -5342,  1909,  2398,  3524, -5342, -5342, -5342,  3523,
    3535,  3523,  3523,  3523,  3523, -5342,  3523,  4112,  3536,  1349,
   -5342, -5342, -5342, -5342, -5342, -5342,  3524,   282,  3523,  3523,
    3523,  3523,  3540, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
    4224, 88938,  4226, -5342, 74152,  4306, 74152,  4228,  2756, -5342,
    3549, -5342,  3550, -5342, -5342,  4241, 88938, 88938, -5342, -5342,
   -5342, -5342,  3552,  2523, 55651, -5342,  1472,  3907, 54277, 74152,
   -5342, -5342,  4181,  4208, -5342, -5342, -5342, -5342, -5342,  3637,
   -5342, -5342,  3564, -5342, -5342, -5342,  3566, -5342,  3566,  3566,
   -5342, -5342,  3566, 54277, -5342, -5342, 53575,  1964,  5644,  4233,
    2320, -5342,  4070, -5342, 27879, -5342, 28617, -5342, -5342, -5342,
    3839,   215,  1627, -5342, -5342, -5342, -5342, -5342,  4046, -5342,
   -5342, -5342, -5342, -5342, 88938,  3791,  4253,  4227, -5342, -5342,
   -5342,  4109, -5342, -5342,  4055,  3581,  4202,  3577, -5342, -5342,
   -5342,    96, 26403,  3582, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, 74152,  3586, 31569, 31569, -5342,  4352,  4352,
    4352, 26403,  3624,   357,  3957, 26403, 26403, 26403,  2537,  3588,
   -5342, -5342, -5342,   702, -5342,  3604, 26403, 26403, 69658,  3605,
     431,  5135, 26403,  4314, 26403, 26403, 26403, 26403, 20499,  3939,
   26403, -5342, -5342, 90222, 69658,  4059,  3614, -5342,  3617, -5342,
    2623, 26403,  2853, 26403, -5342, -5342, 26403, 26403,  3621, 26403,
   26403, 33783,  3628, 26403, 26403,  3640,  3771,  4352,  4352,  2863,
   -5342, -5342, -5342, -5342, -5342, -5342,  4352,  4352, 26403, 26403,
   21237, 26403, 26403,  2874, 26403, 26403, 26403, -5342,  3639, 26403,
   26403, 26403, 26403, 26403, 26403, 26403, -5342, 26403, 26403, 26403,
   26403, 26403, 26403,  1586, 26403, 26403, 74152, 26403, 26403, 26403,
   26403, 26403, 26403, 26403,  4322, 74152, 26403, 26403, 26403, 26403,
    4326, 26403, 26403, 26403,  3650, 26403, 74152, 26403, -5342, 26403,
    3133,  3133, -5342, 26403, 21237, 26403,  3654, 70300, 26403, 26403,
   26403, 26403, 27141, -5342, 27141, -5342, -5342,  3659,  2172,   349,
     514, 26403,  3656, 65806, -5342, -5342, -5342, -5342, 26403, 26403,
   26403, 33783, -5342,  1325, -5342, -5342, -5342, -5342, -5342, 17519,
   33783,  3665, 33783, 33783,  4297,  3035, 33783, 33783, 33783, 33783,
   33783, 33783, 33783, 34521, 35259, 33783, 33783, 33783, 33783, -5342,
   85086, 31569, 75436,  3668,  4342, -5342, 90222, -5342,  2069,   674,
   -5342,  2149,  4554, 36726, -5342,  3698, -5342,  4196,  3701, -5342,
    1617, -5342,  3705,  4390, 54277, 53575,  1998,  3724, -5342,  3709,
     552,  3715, -5342, -5342, 55651, 88938, -5342, -5342, -5342, -5342,
   -5342,  4456, 26403, -5342, 54277, -5342,  1458, 16755, -5342,  1226,
    1575,   107, -5342, -5342, -5342, -5342, -5342, 16755, 88938, 60494,
    3719,  3813,  3734,  2744, 51451, 88938, 74152, 88938, 88938, 88938,
   74152, 54277, 74152, -5342, -5342, -5342,   927,  2134, 88938,  2134,
    2632,  4372, -5342,  2130,  2130, -5342, -5342, -5342, -5342, -5342,
   -5342,  2134, 88938, 88938,  2134, 53575, -5342,  2632,  2494, -5342,
    4016,  3806, -5342, -5342, -5342,  4063, -5342, -5342,  4413,  3733,
   -5342,  4087, -5342, -5342,  3827, -5342, -5342, 74152, -5342, -5342,
    2632, -5342,  2632,  2632, 26403,  2134,  2134,  2134, 69016,  3742,
    3744, -5342,  3743, -5342,  3745, -5342, -5342, -5342, -5342, 74152,
   -5342, -5342,  4100,  3741,  4399,  3749, -5342, -5342,  4329,  1543,
    4288, -5342,  4176, -5342,  4313, -5342, 26403,  3976, 22713,  4034,
   -5342, -5342,  4037,  4040,  4041, -5342, -5342, -5342, -5342,  4197,
    4047, -5342,  2149,  4050, -5342, -5342,  3774, -5342, -5342, -5342,
   36726, 85086, -5342,  3782, -5342,  3802, -5342,   197, -5342, -5342,
    4474,  3890, 26403, -5342, -5342, 74152,  4291, -5342,  2149,  1869,
   88938, -5342, -5342,  4559, -5342,  -153, -5342, -5342, -5342,  3900,
    2095, -5342, -5342,  1617, -5342, -5342,  1993,  3979, -5342, -5342,
   -5342, 85086, -5342, -5342, -5342, -5342, -5342, -5342, 55651, 53575,
   85086, -5342,  2744,  2744, -5342, 74152,  2744, 88938, -5342, -5342,
   -5342,  2744,  2744,  2744,  3837,  1210,  3803,  3804,  3805,  3807,
    2208,  3808, 70942,  2815,   243,  4446,  4455, -5342,  4402,  2785,
    4402, -5342, -5342, 70942, 69016,  3815,  4147, -5342, -5342, -5342,
   -5342, 85086,  3817, -5342, -5342,  3816, -5342, 26403,  4561,  4488,
    4152,  1682, -5342, -5342,  4166, -5342, 86370,  4368,  1350, -5342,
    3819,  3941, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, 31569,  2722,
   -5342,  3976, -5342, -5342, -5342,   259, -5342, -5342, -5342,  1351,
    4192,  3251, -5342, -5342, 85086,  3251,  -112,  1648, -5342,  3831,
    2149,  3073, -5342,  3073, -5342,  4132, -5342,  4134,   114, -5342,
    1617, -5342, -5342, -5342, -5342, -5342, 74152,  3835, -5342,  4023,
   88938,  2373,  3840,  3841,  3976,  3976, -5342,  8379,  4578,  4317,
    5708,   219,  3887, -5342, -5342, -5342, -5342, -5342, 74152, -5342,
   -5342,  1983,  3300,  4333,  3846, -5342,  1579, -5342, -5342, -5342,
    1300, -5342, -5342, -5342,  3918,   107,  3918, -5342, -5342,  1944,
    1180, -5342, -5342, -5342,  1180, -5342,   354, 59122, -5342, -5342,
   -5342, -5342,   578, 50145,  2865, -5342,  4239,  3889,  3918, -5342,
    4325,  1110, -5342, -5342,  1180,  1993, -5342, -5342,  3918, -5342,
   -5342, -5342,  1993,  1180, -5342,  4328, -5342, -5342, -5342,  1180,
    3918, 93432,  1349,  1110, -5342, -5342,  1110,  1180,   390, 88938,
   26403, 26403, -5342,  4411, -5342,   578,  4612,  1110,  3918,  1180,
    4457, -5342,  1180, -5342, -5342,   303,  4049,  3940, -5342,  3861,
   -5342, -5342,   470,  4437, -5342, -5342,  4454, 88938,  4545, 78024,
   -5342, -5342,  4461, -5342, 88938,  1472,  3872, -5342, -5342, -5342,
   -5342, -5342,   107, -5342,  3873,   233, 74152, 74152,  8379,  4008,
   -5342, -5342, -5342, 88938, -5342, -5342, -5342, -5342,  4388,   500,
   37376, 71584, -5342, 71584, 71584, -5342, -5342, -5342, -5342, -5342,
     967, -5342, -5342, -5342, -5342, -5342, -5342, 26403, 52153,  3976,
   -5342, -5342, 74152, -5342,  4543, -5342, -5342, 92148,   315, -5342,
   -5342,   145, 74152, -5342, -5342, 26403, -5342,  4537,  4018, 88938,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, 88938,  2373,
    3976, 88938, 52868, -5342, 93432,  8379,  8379, 26403,  1811, 26403,
   -5342,  3903, -5342,  3904,  3905,  3159,  4244, 26403, 26403, -5342,
    3559,   558,   280, -5342,  3919,  3910, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,  3921, -5342, -5342, -5342,   453,   464,
    3922, -5342, -5342, -5342,  3924,   514, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  4583, -5342,   565, -5342,
   -5342,   296,   301,   481,   509,   515,  3943,   518,  3639,  2316,
    3927, 69658, 90222,  4352,  3928,   753,  4352,  3933,   538,  1908,
     591, -5342,  1977,  2053,  3474, -5342,   631,   729, -5342, -5342,
    3934,  3935,  4352,  3936,  3938,  3947,   871,   328,  3948, 23451,
   24189, 24927,  3920,  3949,   919,  2101,  4352,  3951,  2139,  2367,
    2156, 90222,  1149,  2212,  1250, -5342,  2452,  1286,  1340,  1346,
    1449,  2216,  2224,  1652,  1659,  1699,  2453, -5342, -5342, -5342,
   -5342,  3952,  2244,  2260,  3953,  3958,  2464,  2274,  2279,  2292,
    2482,  2483,  2507, 74152,  3960,  2317,  2324,  1709,  2565, 74152,
    2366,  2381,  1750, -5342,  2426,  3961,  1756,   360,  3962,  3966,
    2489,  3969,  1768, -5342, 90222, 88938,  3971,  3932,   369,   212,
    1843,  2547,  3939,  3939, -5342, 26403,  3972,   228, 90222,  1575,
   -5342,  4475,  3064,  1677, -5342,  2579, -5342, -5342, -5342, -5342,
     192, -5342,  3944,  2579,  3946,  2990, 20499, -5342,  1774,  2528,
   33783, 33783,  3954, 33783, 33783,  3987,  3987,   553,  2199,  2199,
    3692,  3603, 27141,   553, 27141,   553,  3987,  3987,  3987, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342,  4518,  3984,  2286,
    3978, -5342, -5342, -5342, -5342, -5342, -5342,   879,  4391, -5342,
    4175,  1196, 26403, -5342,  4003,  4495,  4496,  4497, -5342, -5342,
   -5342, -5342, 54277, 54277, 74152,  4498, 26403,  4666, 55651,  4671,
   -5342,  3997, 38026, 71584, 71584, 71584, -5342,  3998, -5342, 26403,
   88938, 88938, 16755, 59808,  4680,  4681,   107, 59122, -5342,  3976,
     107, -5342,  4004,  4005, -5342, -5342,  1599,  4281, -5342,  4006,
    4009, -5342,  3999,  4000,  4007, 63238, 26403, -5342,   107,  1226,
   -5342, -5342, -5342, -5342, -5342,  4013, 88938, 88938, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342,  2149, 26403, 88938,
    2134, -5342, -5342, -5342,  2134,  2149,  4687, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342,  2134, -5342, -5342,
   -5342, -5342, -5342,  4179,  4031,  3778,  4372, -5342,  2632, 74152,
    2134,  2134,  3976, -5342, -5342, -5342, -5342,  4552,  4049, 22713,
    4025,  4017, -5342, -5342,  8379, 88938, 88938, -5342, -5342,  1840,
   -5342,  4049,  6476, -5342, 85086, 61180, 74152, -5342, -5342, -5342,
    1413, -5342, -5342, -5342, -5342, -5342, -5342,  3976,  2560,  2722,
   -5342,  4027,  3976, -5342, -5342,  4734, -5342, -5342, -5342, -5342,
    2149, -5342, -5342,  5642, -5342, 74152, -5342, 67090, -5342, 67090,
    2359, -5342, 91506, -5342,  2149,  3976, 74152,  1457,   145, -5342,
    4792, -5342, -5342,  4140, -5342, -5342, -5342,  4030, -5342,  4073,
   -5342, -5342, -5342,  4033, -5342,  4712, -5342,  1984,   523,   114,
   -5342, 88938, 88938, 88938, 74152, -5342, 88938, -5342, 88938,  2744,
   -5342, -5342,  2744, 74152, 88938, 88938,  2744, 70942, -5342, -5342,
   -5342, -5342, -5342, 70942, -5342,   385, -5342,  4238,  1567,  1567,
   -5342, -5342, -5342, -5342, -5342,  4682,  4402,  4402, 70942,  4684,
    4453, -5342, 88938,  4989,  1362, -5342, 65164, 88938,  3976, 26403,
   -5342,  4071,  4488, -5342,   145, -5342, 83802, -5342,  4384, 83802,
   83802, 90222,  4275, 26403,  4045, 16755, -5342,   107,   107,  4267,
    4569,  4570,  4172,  2149,  4576,  4584,  4585, -5342, -5342, -5342,
    2149,  2149, -5342, -5342,   107, -5342,  1785, -5342, -5342, -5342,
   -5342,  4700,   780, -5342,   107,   107, -5342,  2203, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342,  1975, -5342,   237,  1334, 53575,
    4530, -5342,  4654,  4066, -5342, 74152,  4750, -5342, -5342, -5342,
   -5342, 26403,  4579,  6325, -5342, -5342,  4317, -5342,  4089,  4094,
    4097,  4106,  4113,  4114,  4115,  4116,  4119,  4122,  4123,  4126,
    4127,  4128,  4133,  4137,  4138,  4141,  4150,  4151,  4154,  4155,
    4159,  4160,  4074, -5342, -5342,  4162, -5342, -5342, -5342, -5342,
     107,   107,   107,   107, -5342,  3242, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,  4354,  3240, 88938,  4727,  4449,  4092,
    4135,  4163,  4168, -5342, -5342, 88938, -5342,  2593,  4590,  4622,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,   107, -5342, -5342, -5342, -5342,  2673, -5342,
   -5342,  2697, -5342, -5342, -5342, -5342,  6138, -5342,  2698, -5342,
   -5342, -5342, -5342, -5342,  1349,  1349,  4145,  3976,  3976,  4161,
   -5342, -5342, -5342, -5342,  4612, -5342,  4149, -5342, 76078, -5342,
   -5342, -5342, -5342,  3407, -5342, -5342,  1567, 88938,  4642, 78024,
   -5342,  4362,  4793, -5342, -5342, 69016, -5342,  4164, 74152, -5342,
   -5342, 55651, -5342, 85086, 54277, -5342, -5342, -5342,  4167,  1811,
    6680, -5342,  4177, -5342,  2702, -5342, 53575,  4630, -5342, 71584,
    4173, -5342,  4178,  4683,  4685,  4686,  4688, -5342,  1840,  3976,
   -5342, -5342,  4180, -5342, -5342,  4329,  3985, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  4214,
    4463,  4586, -5342, -5342, -5342,  3976, -5342, -5342, -5342,  4842,
   -5342, -5342, -5342,  2732,   370, -5342, -5342, -5342,  4550, -5342,
   95006, 95006, 95006, -5342,  1848, -5342, 26403, -5342, -5342, 26403,
   -5342,  3976,  3499,  3560, 50145, -5342, 50145,  3560, 26403, -5342,
    4198, -5342,  4847,  4850, -5342, -5342, -5342, 26403, -5342, 26403,
   -5342, 26403, -5342, 26403, 26403, 26403, 26403, 26403, 26403, -5342,
   33783, -5342,  4195,  4201, -5342, -5342,  4211, -5342, 26403, -5342,
   26403, -5342, -5342, 26403, 26403, 26403, -5342, -5342,  4212, -5342,
   -5342, -5342, 26403, 26403, 26403, -5342, 26403,  4010, 26403,  4019,
   26403,  4044, 26403, -5342, 29355, -5342,  4213, -5342, -5342, -5342,
   -5342, -5342, 26403, -5342, 26403, -5342, 26403, 26403, 26403, 26403,
   26403, -5342, -5342, 26403, 26403, 26403, -5342, 26403, -5342,  4785,
   26403, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, 26403, -5342, -5342, -5342, -5342, 26403, -5342,
     132, 30093, -5342, 26403, 26403, 26403, -5342, -5342, 26403,  4210,
    4216, -5342, 88938, -5342, 26403,  2849,  2383,   145,  4218, 26403,
   -5342,  4231,  4232,  3426, -5342, -5342, -5342, 92790, 26403, -5342,
   -5342, -5342, -5342,   431, 33783,   410, 33783,  2528,  3365, 20499,
   -5342,  1827,  2528,  3939,  3939, 88938,  4965,  4225, -5342, 26403,
   90222, 26403,  4234,  4222, -5342,  4236, 33783, -5342, -5342,  4240,
   -5342,   439,  2383,  4308,  4676, -5342,  3976, 36726,  4739, -5342,
   -5342, 74152,  3127,  4426, -5342, 54277, 53575, 71584,  4915,  4920,
    4921,  4923, -5342,  3976, -5342,  4249,   107,   107, -5342, -5342,
   19019, 54277, 16755, -5342, -5342,  4754,  4767, -5342, -5342,  1050,
    4551,  4825, -5342, -5342, -5342,  4258, -5342, -5342, -5342, -5342,
     567, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  3976,
   16755, -5342,  3719,  4264, 39456,   887, -5342, -5342, -5342,  3976,
   -5342, -5342, -5342, -5342,  4278, -5342, -5342, -5342,  4863, -5342,
   -5342,  4687,  2756,  2632, -5342, -5342, 70300,  3090, -5342, -5342,
   -5342, 22713,  6684, -5342,  2750, -5342,  5032, 70300,  4746, -5342,
   -5342, -5342, -5342,   355, -5342, -5342,  4271,  4736, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  4276, -5342,
   16755, -5342, 22713,  4296, -5342, -5342, -5342,  4167,   382,  4298,
    4285, -5342, -5342, -5342, -5342, -5342, -5342,   612,   629,  1374,
    2756, -5342, -5342,   218, -5342, -5342, -5342, -5342, -5342,   889,
   -5342, -5342, -5342, -5342,  -153,  2977, -5342,   416,   145,  4516,
   -5342, -5342,  1984,  4749, -5342,  4530,  4968,   906,  4891,  4894,
   -5342,  4700, -5342,  1917,  1107, -5342, -5342, -5342, 88938, -5342,
     105,  1726,   131, 74152,  3636,  3636, -5342,  1567,   508, -5342,
   33783,  5065, -5342,  4806, 70942,  4949,  4950, -5342, 70942, -5342,
   -5342,  2760, -5342, -5342, 49488, -5342, -5342, -5342,  3976,   526,
    2601, 26403, 88938, -5342,  4071, -5342, -5342, -5342, 83802, -5342,
   -5342, -5342,  1682,  4307,  2601,  4311, -5342, 59122, 49488, -5342,
    4689,  4691,  2103, -5342, -5342, -5342, -5342, -5342, -5342,  4423,
    1648, -5342,   107,   107, -5342,   216,   107, -5342, -5342,  1135,
   -5342, -5342,  2641,   102,  4700, -5342,  2149,  2149,  2149,  2149,
     145,  2149,  2149,  2768, -5342,  4423,  4423,  3073, -5342,  1053,
   -5342, -5342, -5342, -5342,  1275, -5342, -5342, 85086, -5342,  4819,
    4826, -5342,  4827, -5342, -5342,   379, -5342,  3081,  1240,  6885,
     994, -5342,  4871, 88938,  5084,  4066, -5342,   367,  2373,  3976,
   -5342, 26403, -5342,  4327,  4330,   145,  4337,   145,   145,  2149,
    2149,  4278,  2149,   145,  2149,  2149,  2149,  2149,  2149,  2149,
    2149,   145,  2149,   942,  3862,  2149,   145,  5708, -5342,  2149,
    2383,  4423,  4423,  3300, -5342,  4997,   107, -5342,  4204, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  2772, 46572,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  4922,
   -5342, -5342, -5342,   578,  1993,   578, -5342, -5342, 93432, -5342,
   -5342, 88938,  4927, -5342, -5342, -5342, -5342,  3909, -5342, -5342,
   -5342,  4649, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
    4332, 69016,   502, -5342, 83160,  4885,  2756,  4356, -5342,  1617,
   -5342, -5342, -5342, -5342,  1981,  4963, -5342, -5342,  5044, -5342,
   88938,   858,  4542,  4852,  4361, 78666, 53575, 53575, 53575, 53575,
   -5342,  4945, 74152, -5342,  5013, -5342, -5342, -5342, -5342, -5342,
   26403, -5342, -5342, 88938,  2373,  4788, 95006,  4981, -5342, -5342,
   -5342, -5342, -5342, 26403,  3976,  3976, 26403,  3523,  3523,  3524,
    3540, -5342,  5077, -5342,  5015,  3523,  3523, -5342,  3523,  5016,
    3523,  3523,  4365, -5342, -5342,  4369,  4370,  4373,  3426, -5342,
   26403, 26403,  2591,   171,  2636,  2649,  1894,  1897,   433, -5342,
    2652,  3892, 90222, -5342, -5342,  2668,  2688,  2714,  2728,  2731,
   -5342,  1905,  3883,  1921,  3976, 26403,  3976, 26403,  3976, 26403,
    3976, 27141,  2746, -5342,  2788,  3990, -5342,  2800,  4279,  2795,
     437,  2799,  1929,  2807,   449,  2803,  2806,  2818,  2847, -5342,
    2625,  4967,  2879, 27141,  2822,  2868,  1941,  1948,  2875, 90222,
   88938,  4371,  2915,  4376,  4376,   261, -5342,  4375, -5342, -5342,
   -5342,  4378, -5342,  2926, 26403, 26403,  4374,  3976,  4382,  2579,
   -5342, 26403,  2528, 33783,   461, 33783, -5342, -5342,  4518, -5342,
   26403, -5342,  4970,  4387,  3426,  4389,  3976, -5342, -5342, 88938,
    4392,  3906, -5342,  4278, -5342,  5039, -5342,  5136,  4394,  4408,
    4395,  4240, -5342, 54277, -5342,  4951,  5075,  3873, -5342,  5078,
   53575, 53575, 53575, 53575, -5342, 44370, -5342, 79308, 16755, 16755,
   -5342, -5342, -5342,  4400,  4406,   829,  4969, -5342, -5342, -5342,
   -5342, 88938, 88938, 16755, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342,  4080, -5342,  4031, -5342, -5342, -5342,  2134,  4405,
   -5342,   107,   308, -5342, 22713,  4410,  4407, -5342,  5034, -5342,
   88938,  4412,  4415,  4418, -5342, -5342, -5342,  4416,   514, 70300,
   -5342, -5342,  4900, -5342,  4428, 87012, -5342, -5342,  4431, -5342,
    4986, -5342, -5342,  5041, 67090, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  4031,  4653, -5342, -5342,
   -5342,  4450, -5342,  4430,  4526,  4527, -5342, -5342, -5342, 53575,
    1240,  4816,   115,   115,  5033, 74152, 74152,  8241,  7777,  4700,
    1917, -5342, -5342, -5342,  2149, -5342,  1107, -5342, -5342,  4443,
   88938, -5342,  4066, -5342, -5342,   329, -5342, -5342, -5342, -5342,
   -5342,  3906,  1567,  1567,  4705,  4931, 70942, 70942,  4877,  4935,
   26403,  4452, -5342, 88938, -5342,  1539, -5342,  4854, -5342, -5342,
   26403, -5342, -5342, -5342, -5342,  3976,  5210,  4451, -5342, -5342,
   -5342, -5342, 26403, -5342, 26403,  4458,  4459, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,   132,   132, -5342, -5342,   132,   132, -5342,
   -5342, -5342, -5342,   132,   132, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,   780, -5342, -5342, -5342,  1975, -5342,
   -5342,  4959,  1509, -5342,  5042, -5342, -5342, -5342, -5342,  1052,
     145,   145,   145,  3862,  2454, -5342,  3081,  1763,  4790, -5342,
    4588,  4857,  5035,  4857,  5036,  4966,  3400,  4828,   107,  5043,
    5219,   107, -5342,   213,   107,   107,   107,   107,  4515,   107,
     107,   107,   107,  5054,   107,   107,  4844,   107,  5122,  4557,
    5127,   107,  5063, -5342,  4563,   107,   107,   107,   107,  4857,
     107,   107,  5069,  4692,  5071,  5072,   107,   107,    84, 88938,
     107,   107,  5073, -5342, -5342,  7777, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,   147, 72226, -5342, -5342, -5342, -5342,   107,
    2528,  1089,  5001,  2225, -5342,  2880, -5342,  5263, -5342,   208,
   -5342, -5342, -5342,  3976,   452,   621, -5342,   741, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, 88938,  4423,  3240, -5342,
   -5342, 88938,  3523,  3523,  3523,  3535,  3523,    95, -5342, -5342,
   -5342, -5342, -5342, -5342,   282,  3523,  3523,  3523, -5342, -5342,
   -5342,  4504, -5342, -5342, -5342, -5342, -5342, -5342, 76078, -5342,
   -5342, 78024,  2756, -5342, 88938,  4848,  5050,  3724, -5342, -5342,
   -5342, -5342, -5342,  4509, 26403, -5342, -5342,  5186, -5342, -5342,
   53575, -5342, -5342,   114,   114,   114,   114,  2952,  4874, -5342,
   -5342, -5342,  5013,  4796, -5342,   335,  3976, -5342, -5342, -5342,
   -5342, -5342,  8379,   433,  3976, -5342, -5342, -5342, -5342,  3523,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  4521,  3939,  3939, -5342,  5268,  5060, -5342, -5342, 26403,
   26403, -5342, 26403, -5342,  1759,  4528,  5002, -5342, -5342, -5342,
   -5342, -5342, -5342, 26403, 26403, 26403,  3976,  3976,  3976,  3939,
   -5342, -5342,  4429, -5342, -5342,  3560, -5342, -5342, 26403, -5342,
   26403, -5342, 26403, -5342, 26403, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,   256,  3939, -5342, -5342, 26403, 26403, -5342,
   -5342, -5342, 88938, -5342,  2383,  4532,  4809, -5342, -5342, -5342,
    2383,  4665, -5342, -5342,  2383,   145, -5342, -5342, -5342, 88938,
   -5342,  2892,  2579, -5342, 26403,  2528,  5121,  4533,  5282,  4538,
   -5342, 26403, 44370, -5342,  4539,  4535, -5342, -5342, -5342, -5342,
   26403,  5171,  5118, -5342,  2383, 88938, -5342, -5342, -5342, 53575,
   53575,  3997,  3997,  3997,  3997, 87654, -5342, -5342, -5342, -5342,
    2312, -5342, -5342, -5342, -5342, -5342, -5342, -5342,   107,   107,
   -5342, 39456, 59808, -5342, -5342, -5342, -5342, -5342, -5342,  4031,
   -5342, 70300,  2756, 25665, -5342, -5342, -5342, 22713, -5342, -5342,
     431, -5342, 70300, 79950,  4544,  4546, -5342,   107, -5342,  4900,
   -5342, 42996, -5342,  4549, -5342,  4548, -5342,  2248,  4879,  5172,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342,  4556, -5342, -5342,  2149,  3154,
   -5342, -5342, -5342, -5342,  4577, -5342, -5342, -5342, -5342, -5342,
   74152, -5342, -5342, 43707,  5185, 74152, -5342, -5342,  5132, -5342,
    4148, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  1328,  5149,  5320, -5342,  4560, -5342, -5342, -5342, -5342,
    4664, -5342,  4560,  4066, -5342, -5342, -5342,  5051, -5342, -5342,
   -5342,  5052,  3976, 88938, -5342, -5342, -5342,  1691,  2944,  5191,
    2601,  4567, 88938,  2601,  3976, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  1319, -5342,
   85086, -5342, -5342, -5342, -5342, -5342,  5162,  5163, -5342, -5342,
   -5342, -5342,  4755,   749, 72868,  2744, -5342,  1934,  4609, -5342,
   -5342, -5342,  2008, -5342,  2744,  1413,  1413,  5232,  3097,  1120,
    3097, 42996,  1362,  2159,  5215,  1928,  2594,  4615,  5142,  3097,
    3097,   107, 61866,  1120, 70300,   186, -5342, -5342, -5342, -5342,
   74152,   190,   290,   310, -5342, -5342, 62552,  4278,   145,   145,
    1120,  2149,  2149,   107,   145, -5342, -5342, -5342, 85086, 88938,
   -5342,  2356,   145,  4278,  4278,  3097,   311,  2149,  1120, -5342,
    1120,  1120,  1067,   186, -5342, -5342, -5342,   145,   186, 42996,
   -5342,  7912, -5342, -5342, -5342, 43707, 88938,   137,  5137, -5342,
    4573, 57046, -5342,  4756, 26403, 26403,  5175, 88938,  5176, -5342,
    4983, -5342, 88938, -5342,   431, -5342, -5342, -5342,  4881,  5095,
    2893, -5342, -5342,  2920, -5342, -5342,  2936, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,   578,
    5133, 88938,   578,  4612,   578,  4612,   431, -5342, -5342,  4164,
   -5342,  5267, -5342,  4934,  3998, -5342,  3976, -5342,  4787,   114,
    5067,  5067,  5067,  5067, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342,  5247,  2373,  4953,  7385,   578, -5342,   578,   578,
   -5342,  4600,  4603, 26403,  1993,  5235,  2959,  1969,  2943,  4887,
    4838, -5342,  4772, -5342,  2963,  3976,  3976,  2129,  3524, -5342,
   -5342, -5342, -5342,  5257,  3523, -5342,  5350, -5342,  3523, -5342,
   -5342, -5342, -5342, -5342, -5342,  4611,  2966,  3976,  3976,  2988,
   -5342, -5342, -5342,  2960,  2144,  3005,  3009, -5342, -5342, -5342,
    4613, -5342, -5342,   268, -5342,  4616, -5342, -5342,  2970,  5362,
    2256, 26403, -5342,  4617, -5342, -5342, 88938,  3939,  1257, -5342,
    2974, -5342, -5342,  4620,  3997,  3997, -5342, -5342, 80592, 16755,
   16755, -5342, -5342, -5342, -5342,  4454,  2722, -5342, -5342, -5342,
   -5342,  4624, -5342, -5342,  4618, -5342, 70300, 22713, 76078, -5342,
   -5342,  4629,  4628, -5342, -5342, -5342, 87012, -5342,  2975, -5342,
   -5342,  5384, 22713, -5342, -5342, 85086, -5342,  4632,  4633, 74794,
    3208,  3013, -5342, -5342, -5342, -5342, -5342, 74152, -5342,   425,
   -5342,  7034, -5342,  7777, -5342,   204, 88938,  3377, -5342, -5342,
    2078,  4758, -5342, -5342,  7309,  4635, 88938,  2149, -5342,  4636,
    5398, 26403,  4640, 26403,  4641,  3016, -5342,  1413, -5342,  1413,
   -5342,  1691,  5387,  5389,  5338,  5393,  2944, -5342,  2703, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  4650, -5342, -5342, -5342,
   -5342,  4990, -5342,  5243, -5342,  5104,  2528, -5342, -5342,  1120,
    4657,  2528,  5337, -5342,  4660,  5302,  5303,  1413, -5342,  2744,
   74794, -5342,  2744,  2744, -5342, 74794, 42996, 74794, -5342, 49488,
   74794,  3097, 88938, -5342,  5342, -5342,  5306, 74794, 74794,  2149,
   -5342, -5342, 42996,  4663, -5342,  2601, -5342, -5342, -5342,  2577,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342,  4669, -5342, -5342,
   -5342, -5342, -5342,  2383, -5342, -5342,  2149, -5342, -5342,  5143,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, 74794, -5342, -5342,
   -5342, 42996, -5342, 42996, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  4829,  3596, -5342,  4672,
    4667, -5342, 88938, -5342, -5342, 74152, -5342, 47308, 88938, -5342,
   -5342, -5342, -5342, -5342,  3976,  3939,  5070, -5342, -5342,  4781,
    2149,  5037, -5342,  5150, -5342, 88938,   235, -5342, -5342,   145,
   -5342,   145, -5342,   145, -5342, -5342,   232, -5342, -5342, -5342,
   -5342, -5342,   514, 33783, -5342, -5342,  5067,  1988, -5342, -5342,
   -5342, -5342, -5342, -5342,  5317,  5188, -5342, 95006,  5301, -5342,
   -5342, -5342, -5342, -5342,  4679,  2601, -5342, -5342,  4690, 83802,
   -5342, -5342, 26403, -5342,  4914, -5342,  5019, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,   578, -5342, -5342, -5342, -5342,  4278,
   -5342, -5342, -5342,  4693, -5342,   145, -5342, 26403, -5342, -5342,
    4694,  4752,  2601, -5342, -5342,  4778,  4676,  4697, 88938, -5342,
    5118, -5342, -5342, -5342, -5342,  4793, -5342, 81234, -5342, -5342,
     419, -5342, 88938, -5342, -5342,  4278,  5047, -5342,  3032,  4882,
    4698, 88938, 88938, 88938, -5342, -5342, 43707,  4701, -5342,  5449,
   -5342,  5132, 15895, -5342, -5342,  5045,   204, -5342,  2549,  4702,
    4706, -5342, -5342, -5342,  5397,  1917, -5342, -5342, -5342,  5295,
    1089, -5342,  3377, 88938, -5342,  5256,  4710, -5342, 88938,  5259,
   -5342,  3976, 88938,  3976, 88938, -5342,  5396,  5396, -5342,  1993,
    1993,  5460,  1993, -5342,  5464,  5465,  2703, -5342,  5227,   749,
    5093,  1763,  5410, -5342, 88938,  5412, -5342, 26403,  2744, -5342,
   -5342, 74794,  5213,  -176, 74794, 74794,  2184, -5342, 74794,  1983,
    4456, -5342, 74794,  4628, 88938, -5342, -5342,  1981, -5342, -5342,
   70300, -5342, -5342, 74152, -5342, -5342,  5236,   137, -5342, 88938,
   -5342, -5342, -5342,  4729, -5342,  4722,  5469, -5342, -5342,  4724,
   -5342, -5342, -5342, -5342, -5342,  1165, -5342,  3040, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,   542, 88938,  3318, -5342,
    4928, -5342,  1988, -5342,  5224, 74152, -5342, -5342, 26403, -5342,
   -5342, -5342,  1376,  3067, -5342, -5342, -5342,  4735, -5342,  4738,
    4307, -5342,  4194,  4865,  4495,  4496,  4497,  4916,  5080, -5342,
    4917, -5342,   145, -5342,  4743, 33783, -5342,  2602, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342,  5161, -5342,  4751, 88938,  3049,
    2601,  4757,  3053,  4759, -5342, -5342, -5342,   355,   425, -5342,
   -5342, -5342, 15895,  1157, -5342, -5342, -5342,  4745,  4747, -5342,
    4748, -5342, -5342, -5342, -5342,  5327, -5342, 48044, -5342, 88938,
   -5342, -5342, -5342,  5175,  1917, -5342, -5342, -5342, -5342, -5342,
   -5342,  3072,  3076,  2470, -5342, -5342, -5342, -5342,  1993, -5342,
    1993,  1993, -5342,  4760, -5342, -5342, -5342, 74794,   787,  4753,
   -5342,  3109, 74794,  5213,  1874,   115, -5342,   115, -5342, -5342,
    5468,  5472,   137, -5342, -5342, -5342, -5342, -5342,  1120, -5342,
    4762, 74152, -5342, -5342,  4628,   889, 88938,  5382,  4269,  6138,
   -5342, -5342,  3455, 88938,  4859, -5342,  8379,  4960,  5507,  5508,
   -5342, 88938, 88296, -5342, -5342,  5345, 33783, -5342, -5342, -5342,
    4049, 95006,  2601, 83802, 83802, -5342, -5342, -5342,   956, -5342,
    5533,  1720, -5342, -5342,   182, -5342, -5342, -5342, 88938,  4773,
    4855, -5342, -5342,  4843, -5342, -5342,  2468, -5342, -5342,   780,
    3077,  1617, 88938, -5342,  5373,  1617, 88938,  5249, -5342,   175,
     202,  2189,  1157, -5342, -5342, -5342, -5342, 88938, -5342, 88938,
   88938, -5342,  3535,   255, -5342, -5342, 88938, 52868, -5342,  2225,
   -5342, -5342, -5342, -5342, -5342, -5342,  5527, -5342,  5528,  4784,
    4786, -5342, -5342, -5342, -5342,  5469,  2383,  5118, -5342, 88938,
   -5342, -5342, -5342,   115, -5342,  4791, -5342,  4794,  4798, -5342,
   35997, -5342, -5342, -5342, -5342,  5433, -5342,  3082, -5342,  1867,
    5378, -5342,  5431, -5342,  2149, -5342,  4868, -5342,  4269, -5342,
   -5342, -5342,  4833,  5440,  5400,   107, -5342, 85086, 35997, -5342,
    5291, -5342,  5246,  5513, -5342,  5566,  3794, -5342, -5342, -5342,
   26403,  5159,  5490, -5342,  5006,  5007, -5342, -5342,  3094, -5342,
   -5342,  4875,  3906, 70300, -5342, -5342, -5342, -5342, -5342, -5342,
    4194, -5342, -5342,  4944,  2389, -5342,  3100, -5342, -5342, -5342,
    2383, -5342,  4821, -5342,  5181,   107,   107,  5184,   107,   107,
     107,   107,  4824,  2468, -5342,  5177,  3106,  1617,  1885,  2601,
    4831,  1482,  4822, -5342, -5342,  4823, -5342,  4830, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  5367, 88938, -5342, -5342,
   74152,  4983,  5490, 88938, 88938, -5342, -5342, 87012, 87012, -5342,
   -5342,  3124,  4832,  4835,  4836, -5342, 88938,  4839, 88938, 88938,
    3862,  3862, 20499, -5342, -5342, -5342, -5342, -5342, -5342,  3345,
   -5342,  4840, -5342, 88938, -5342, -5342, -5342,  1898, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, 57741, -5342, -5342,  5426,
   -5342,  4870,  1347,   107, -5342,  4136,  3976, 26403, -5342, -5342,
   -5342, -5342, -5342, -5342, 88296, -5342,  4841, -5342,   107,  1362,
   -5342, -5342, -5342, -5342, -5342, 88938, -5342,  4845, -5342, -5342,
     169,   107,  2149,  2149,   107,  3346,  3346,  2383, 85086,  4919,
   -5342, -5342,   107, -5342,  2171,  5038,  2149,   107,  1817,  1885,
   -5342, -5342,   107, -5342, -5342,  1817,  1482, -5342, -5342, 88938,
   -5342, -5342, -5342, -5342,  5196, -5342,  4443,  4851, -5342,   271,
    5278,  5526,  5211, -5342, -5342, -5342,  4853,  3181, -5342, -5342,
   88938, 88938,  4858,  3188, 88938,  3232,  3236, -5342, -5342,  4856,
    5118, -5342,   577,   577, -5342, -5342, -5342, -5342,  4860, -5342,
     -19, -5342, -5342,  4136,  3976, -5342, 70300, 22713, -5342,  4855,
   -5342, -5342,  3253, -5342, 30831, -5342, -5342, -5342,  2149, -5342,
   -5342,  2149, -5342, -5342, -5342, -5342, -5342,  3259, -5342, 85086,
     115,   115,  1817,  2171, -5342, -5342, -5342,  3215, -5342,   145,
   -5342,  5477,  5300, -5342, 58436, -5342, -5342,  4861, -5342, -5342,
   -5342, 88938, -5342,  4560, -5342,  5404,   628, 88938, -5342, -5342,
   -5342, -5342, -5342,  3260,  3268, 88938,  2171,  3277,  1885,  1482,
   -5342,  3284, -5342, -5342,  2029,  5312,  5454,  5456,  1024, -5342,
    2466,  2466,  1796, -5342, -5342,  5408, -5342, -5342,  4845, -5342,
    4866, -5342,  3906, -5342, -5342, 85086, -5342,  4919, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, 88938, 88938, -5342,  3377,  4867, -5342, -5342, -5342,
    5444, -5342, -5342, -5342,  5137,  2171,  3289, -5342,  2171, -5342,
   -5342, -5342, -5342, -5342, -5342,  5361,  5580, -5342,  4878, -5342,
    2466, -5342, -5342, -5342, -5342, -5342,  1687,  5182,  4854, -5342,
   30831,  4883,  2468, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
    4933,  5229,  5582, -5342, -5342,  2171, -5342,   577,   577, -5342,
   -5342, -5342,  1687, -5342,  5632,  5191, -5342, -5342, -5342,  3377,
   -5342, -5342,  5018, -5342, -5342, -5342, -5342,  1993,  5548, -5342,
   -5342,  5486,  4896,  1891,  2263, 63880,  5428, -5342, -5342, 85086,
   -5342, -5342, -5342, -5342, -5342, 85086,  3290, -5342, -5342, 70300,
   -5342, -5342,  8379, -5342, -5342, 66448,  4895, -5342,   107,  5490,
   -5342, 70300, -5342, -5342, -5342, 22713, -5342, -5342
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,  1245,  2481,     0,   537,     0,  1465,   822,   567,  2332,
    2474,  2475,  2257,     2,   610,   259,  2682,  2683,   482,  2259,
    2546,     0,     0,   606,  1481,   963,   717,     0,   402,     0,
       0,   613,   400,   259,  1530,  3203,  2381,     0,  3300,  2320,
       0,  1528,   608,  2644,  3556,  2906,  2954,  2955,  2983,  2800,
    3078,  3100,  3126,  2262,  2888,  2887,  2890,  2889,  2891,  2892,
    2893,  2894,  2895,  2896,  2773,  2897,  2898,  2899,  2901,  2900,
    2902,  2903,  2904,  2774,  3452,   563,  2775,  2853,  2905,  2855,
    2854,  2907,  2776,  2777,  2908,  2909,  2910,  2911,  2779,  2778,
    2912,  2914,  2913,  2856,  2857,  2915,  2916,  2917,     0,  2919,
    2780,  2781,  2782,  2783,  2784,  2918,  2785,  2920,  3457,  2921,
    2922,  2786,  2923,  2924,  2925,  2926,  2928,  2927,  2929,  2930,
    2932,  2933,  2934,  2931,  2935,  2936,  2938,  2937,  2859,  2939,
    2858,  2940,  2787,  2941,  2942,  2943,  2944,  2945,  2946,  2947,
    2948,  2949,  2950,  2223,  2951,  2952,  2953,  2975,  2956,  2958,
    2957,  2860,  2959,  2960,  2961,  2963,  2962,  2964,  2966,  2788,
    2789,  2790,  2965,  2967,  2968,  2969,  2970,  2971,  2973,  2972,
    2977,  2978,  2861,  1481,  2792,  2793,  2974,  2976,  2771,  2979,
    2980,  2862,  2863,  2981,  2794,  2850,  2982,  3302,  2985,  2984,
      85,  2986,  2796,  2987,  2988,  2989,  2990,  2991,  2993,  2995,
    2992,  2996,  2997,  3003,  2797,  2994,  2998,  2999,  3000,  3001,
    3002,  3004,  2864,  3005,  3007,  3006,  3008,  3009,  3010,  3011,
    2865,  3012,  2851,  3013,  3014,  3015,  3028,  3029,  3019,  3020,
    3022,  3023,  3026,  3021,  3027,  3032,  3031,  3033,  3034,  3035,
    3036,  3037,  3030,  3017,  3024,  3025,  3018,  3038,  3039,  3016,
    3040,  3042,  3041,  3043,  2866,  3044,  3045,  3046,  3047,  3048,
    3049,  3050,  3051,  3053,  3052,  3054,  2867,  2868,  2869,  3055,
    3056,  3057,  2844,  3058,  2870,  2871,  3061,  3062,  3059,  3060,
    3063,  3064,  3069,  3070,  3071,  3066,  3065,  3067,  3068,  2872,
    2873,  2874,  3072,  3073,  3074,  3075,  3077,  3076,  2799,  2798,
    2801,  3079,  3080,  2802,  3081,  3083,  3082,  2846,  2803,  3084,
    3085,  3087,  3086,  2875,  2876,  2804,  2805,  2806,  3088,  3089,
    3090,  3091,  3092,  3093,  3094,  3095,  3096,  3097,  3098,  3099,
    2877,  2878,  3101,  3102,  3103,  3105,  3104,  3106,  3107,  3108,
    3109,  3110,  3111,  3112,  2807,  3113,  1481,  3114,  3115,  2808,
    3117,  3116,  2809,  3118,  3119,  3120,  3121,  3122,  2845,  3457,
    3123,  3124,  3125,  2879,  3127,  3128,  3129,     0,  3130,  3131,
    3132,  2810,  3133,  3134,  2880,  2852,  2811,  3135,  3137,  2558,
    2812,  3136,  2814,  2815,  3138,  3139,  3140,  2813,  3141,  2816,
    3142,  3143,  3145,  3144,  3146,  3147,  3148,  3149,  2817,  3150,
    3151,  2818,  3152,  2819,  3153,  3154,  3155,  3156,  3158,  3157,
    3159,  3160,  3161,  3162,  3163,  3164,  3166,  3168,  3167,  3165,
    3169,  3170,  2881,  3171,  2820,  2882,  3176,  3177,  2883,  3172,
    3173,  3174,  3175,  2358,  3178,  3179,  3180,  2823,  3181,  3182,
    3184,  3183,  2821,  2822,  3185,  3186,  2827,  3187,  3188,  3193,
    2884,  2885,  3189,  3190,  3202,  3191,  3192,  3195,  3194,  3196,
    3197,  2772,  2824,  3198,  3199,  2825,  3200,  2826,  3201,  2886,
       0,     0,     3,     8,    22,     0,    44,    27,    32,    17,
      21,    16,    46,    60,    52,    29,  3454,   478,   479,   480,
     481,    42,  3488,    41,    11,    63,    64,    19,    49,    12,
      15,    18,    40,    48,    36,    43,    56,    57,  1551,  1527,
    1555,  1526,  1522,  1518,  1537,  1538,  1539,  1545,    25,    26,
      33,    50,    68,    23,    65,    61,    24,  2481,    13,    28,
      14,    51,    45,    37,    62,    69,    38,     0,  2687,  2700,
       0,  2701,  2769,  2767,  2770,  2766,  2768,    58,    59,    39,
      67,    31,    53,    30,     9,    10,    20,    54,    55,    47,
      70,    34,    66,    35,  1290,     0,     0,     0,     0,     0,
    2255,     0,     0,  2255,  1374,  1595,  3486,  3487,  3488,  1482,
       0,  1483,     0,     0,  2848,  2774,  2847,  2775,  2777,  2831,
    2778,  2834,  2835,  2828,  2787,  2836,  2849,  2790,  2791,  2832,
    2733,  2794,  2837,  2795,  2797,  2829,  2830,  2838,  2833,  2806,
    2839,  2808,  2840,  2841,  2842,  2817,  2818,  2843,  2822,  2734,
    2826,  2698,   289,  2699,  2730,  2728,  2732,  2726,  2727,  2731,
    2725,  2729,   539,   130,     0,     0,     0,     0,   341,  2353,
    2255,  2227,  2255,  2255,  2255,  2255,  2255,     0,  2255,  2255,
       0,  2258,  2255,  2255,     0,     0,     0,   530,  2265,  2548,
       0,  2568,  2569,  2563,  3290,  3291,  3285,   491,     0,     0,
       0,  2448,  2447,     0,     0,   387,   399,   402,   395,   398,
       0,   259,  1484,   491,   401,   402,     0,  1560,  3205,     0,
    2453,   402,     0,  2330,  2562,     0,     0,  2645,  2642,  2330,
    2519,  2521,     0,  2517,  3457,  1668,  1667,   565,     0,  2688,
       0,  1460,  1492,  1418,     0,  3458,  3459,     0,    77,    80,
    2486,   424,     0,     0,     0,   820,     0,     0,  1426,     0,
    3459,  3469,  2560,     0,   130,  1399,     0,   130,  2364,  2255,
    2255,  3539,  3540,     0,     0,     0,  3534,     0,  3541,     0,
    1555,     0,  1541,     1,     5,     0,     0,   820,  1202,  1203,
    1201,   820,   820,     0,     0,     0,     0,     0,  3493,  3486,
    3487,  3488,     0,  2209,  2076,  1556,  1555,  2156,  2160,  3473,
    3472,  3474,     0,     0,  2156,  1546,  2970,  2793,  3083,     0,
    2466,  2480,  2464,  2676,  1524,  1520,  3208,     0,  1248,  1291,
    1251,   263,     0,     0,  1253,     0,     0,  1268,  2709,  2708,
    2707,  1265,  1264,  1263,  1261,     0,   681,   259,     0,  1376,
       0,     0,     0,  3494,  3493,     0,  1437,  2468,  2469,  2470,
    2471,  2472,  2473,  2476,     0,   295,   550,   553,     0,   542,
     545,     0,   131,   132,  1463,  1466,     0,   823,     0,   171,
       0,   378,   380,     0,   377,   379,  2756,   568,   342,   343,
     345,     0,   365,     0,     0,     0,   454,   360,   452,     0,
     453,  2753,  2750,  2755,  2751,  2754,  2752,  2357,  2356,     0,
    2355,  2333,     0,  2353,     0,  2253,  2255,     0,     0,     0,
       0,     0,     0,   259,     0,  2449,   259,  2237,  2255,  2255,
     611,   585,  3355,  3370,  3371,  1609,  3367,  3372,     0,  3369,
    3361,     0,  3365,  3359,     0,  3391,  3363,  3368,  2962,  2790,
    2977,  3092,  3096,  3112,  3115,  2842,  3159,  3349,  3334,  3350,
       0,     0,  3353,  3357,     0,     0,  2266,  2267,  2268,  1372,
    2549,  2550,  2554,     0,  2572,     0,   504,     0,     0,     0,
       0,   477,   493,   494,     0,     0,   500,     0,   491,     0,
     463,   475,   465,     0,   495,   474,   467,   466,   468,   469,
     470,   471,     0,   472,   473,   476,     0,   459,   460,   607,
     461,   462,   491,  2704,  1479,     0,  2632,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1609,  1609,  1609,  1606,
       0,     0,     0,  2637,     0,     0,     0,     0,  2628,     0,
    2638,     0,     0,     0,  2630,  2631,  2684,  2685,     0,     0,
       0,     0,  2635,     0,     0,     0,     0,     0,  2611,  1670,
       0,  1606,     0,  2627,  2634,     0,  2619,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1606,
    2610,  2629,  2636,     0,  1609,  1606,  1606,     0,     0,     0,
       0,     0,  2889,  2773,  2904,  2831,  2915,  2917,     0,  2780,
    2781,  2782,  2783,  2784,  2828,  2939,  2858,  2940,  2941,  2942,
    2793,  2862,  2981,  2988,  3006,  3008,  2865,  3047,  3049,  3054,
    2867,  2868,  2869,  3059,  3060,  3074,  2846,  2875,  2876,  3090,
    3097,  3122,  2879,  3127,  3132,  3135,  3155,  2882,  3176,  3177,
    2883,  3175,  2843,  3187,  3193,  3196,  3197,  2824,  2886,     0,
       0,     0,     0,  1669,     0,     0,  1910,  1553,  1744,   964,
    1615,  1627,  1643,     0,  1742,  1741,  1745,  1747,  1753,  1662,
    1774,  1713,  1714,  1716,  1837,  1715,  1720,  1721,     0,  1886,
    1722,     0,     0,  1719,  2624,  1718,  1717,  2625,  2626,  1712,
    2662,  2698,     0,  2686,   719,   718,     0,   414,   409,   417,
     411,   413,   412,   418,   419,   420,   415,   410,   416,   403,
       0,   388,     0,   396,  3470,     0,     0,   491,   614,   421,
    3355,  2890,  3096,  3323,     0,  3333,     0,  3485,  3479,  3482,
    3481,  3477,  3480,  3478,  3483,  1581,  3484,  1580,  1531,  1561,
    1578,  1579,     0,     0,     0,  1120,  2764,  3234,  3235,  2844,
    2846,  2845,  3236,  3172,  2765,     0,     0,  2693,     0,     0,
    2694,  2761,  2759,  2763,  2758,  2762,  2757,  2760,  3204,  3220,
    3216,     0,     0,     0,  2461,  1198,  1197,     0,     0,     0,
    2403,     0,  1120,  2461,  2404,     0,  2133,  2451,  2454,     0,
    3238,  2417,  1199,  3239,  2447,     0,  2389,  2405,  2366,  2410,
     130,  3240,     0,  2450,  2133,  2461,     0,  2382,     0,     0,
       0,     0,  1594,     0,   397,  3301,  2331,  1372,  2300,  1529,
    2286,   609,     0,     0,  2270,  2273,  2269,     0,  2518,  3453,
     570,   564,     0,     0,     0,     0,     0,  3462,  1957,  2224,
       0,    81,    76,     0,     0,     0,     0,  2681,  3303,    86,
       0,     0,  3553,    74,     0,  2536,     0,  2534,  2531,  2533,
       0,  3462,     0,  2559,  1406,  1406,     0,     0,  1398,  1400,
    1401,  1406,  1406,  2365,     0,     0,     0,  2618,  2616,  2617,
    2689,  3536,  2615,  2614,  3545,  3547,  3530,     0,  3533,  3532,
    3542,  1544,  1543,     6,    71,     0,   259,   259,   820,   173,
     820,   141,   144,   820,   820,   820,   820,   153,   157,     0,
     261,     0,     0,  3493,  1559,     0,     0,  1571,  1557,  1972,
    1558,  1974,  1971,  1970,  1969,  2000,  2001,  2003,  2002,  2004,
    2006,  1997,     0,     0,  2222,     0,  2217,  2077,  2082,  2076,
       0,     0,     0,     0,  2155,  2133,  2164,  2157,  1523,  2153,
       0,  1519,  1584,  1584,  3476,  3475,  3471,  2158,  1542,  1550,
    1548,  1549,  2159,  1540,     0,  2478,  2678,     0,  2483,     0,
    2156,  2160,     0,     0,  1136,     0,   266,     0,  3491,  3492,
    3490,  1609,  2710,  2713,  3489,  2714,   266,  1262,     0,   682,
    2256,     0,     0,     0,     0,     0,     0,   684,   683,   620,
       0,     0,  1380,  1381,  1375,  1377,  1379,     0,     0,     0,
       0,  2482,     0,   291,   297,   290,     0,   339,     0,   540,
     546,    87,     0,  1467,  2246,  2248,   170,     0,     0,   368,
       0,   350,     0,     0,  1061,  1083,  1081,  1102,  1047,  1067,
    1063,  1067,  1057,  1102,   996,   996,  1102,  1060,   996,  1067,
    1062,     0,  1059,  1102,  1058,   996,     0,  1051,  1083,   990,
     991,   996,  1081,  1017,     0,  1067,  1040,  1039,  1102,  1043,
    1044,  1042,  1046,     0,  1048,  1067,  1053,  1041,  1045,     0,
       0,  1081,  1081,  1081,     0,  2756,  1081,     0,   352,   456,
     973,   976,   978,   977,   979,   980,  1067,  1083,  1083,     0,
       0,  1081,  1089,   452,  2753,  2751,  2754,  2752,   346,   348,
       0,     0,     0,   367,     0,  2334,     0,  1569,  2076,  2336,
    2341,  2347,  2351,  2354,  2229,     0,     0,     0,  2230,  2234,
    2240,  2239,  2233,  2449,     0,  2243,   695,     0,     0,     0,
    2244,  2225,     0,     0,  3356,  3354,  3388,  3387,  3392,     0,
    3389,  3385,     0,  3348,  3393,  3378,  3425,  3382,  3425,  3425,
    3379,  3386,  3425,     0,  3384,  3383,     0,  3351,     0,     0,
       0,  1373,  2273,  2555,     0,  2547,     0,  1502,  2574,  2573,
    2570,  2068,  3287,  3292,   498,  2740,  2739,  2702,   505,  2703,
    2736,  2738,  2735,  2737,     0,     0,  3059,     0,   510,   509,
     508,     0,   527,   498,   501,   519,     0,     0,   337,   484,
     492,   485,     0,   525,   528,   560,   558,   600,   596,   604,
     598,   464,  2705,     0,     0,     0,     0,  1748,  2074,  2074,
    2074,     0,     0,  1965,     0,     0,     0,     0,  2074,     0,
    1784,  1759,  1760,     0,  1785,     0,     0,     0,     0,     0,
       0,     0,     0,  1916,     0,     0,     0,     0,     0,     0,
       0,  2684,  2685,     0,     0,     0,  1959,  1961,  2662,  2686,
    2074,     0,  2074,     0,  1614,  1794,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2074,  2074,  2074,
    1799,  2612,  2633,  1803,  1805,  1804,  2074,  2074,     0,     0,
       0,     0,     0,  2074,     0,     0,     0,  2621,  2620,     0,
       0,     0,     0,     0,     0,     0,  2639,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2641,     0,
       0,     0,  2640,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1750,     0,  1749,  1751,     0,  1553,   965,
       0,     0,     0,     0,  1666,  1665,  1664,  1663,     0,     0,
       0,     0,  1672,     0,  1674,  1676,  1671,  1673,  1675,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1752,
       0,     0,     0,     0,     0,  2613,     0,  1847,     0,   731,
    2544,     0,     0,     0,   386,  1486,  2715,     0,  1485,  1489,
    3287,   593,  3354,     0,     0,     0,  3351,  1595,  1577,     0,
       0,  3206,  3214,  1119,     0,     0,  1122,  1124,  2291,  2290,
    1123,  1132,     0,  1121,     0,  3275,     0,     0,  3260,     0,
    3241,     0,  1128,  1130,  1129,  3255,  1127,     0,     0,     0,
    3225,     0,     0,   820,     0,     0,     0,     0,     0,     0,
       0,  2432,     0,  1594,  1594,  2383,     0,  2461,     0,  2461,
    2451,  2457,  2416,     0,     0,   876,  2138,  2134,  2409,  2455,
    2456,  2461,     0,     0,  2461,     0,  2423,  2451,  2461,  2378,
       0,     0,  2370,  2375,  2371,     0,  2377,  2376,  2379,  2367,
    2368,     0,  2396,  2425,     0,  2408,  2415,     0,  2395,  2402,
       0,  2413,  2451,  2451,     0,  2461,  2461,  2461,     0,  1595,
       0,   591,  2643,  2646,  2650,  2654,  2273,  2263,  2272,     0,
    2520,   335,     0,     0,     0,  1494,  1496,  1495,  1512,  1420,
       0,  3461,     0,  3463,     0,  3465,     0,    78,     0,     0,
    2513,  2511,     0,     0,     0,  2505,  2507,  2510,  2506,     0,
       0,  2512,   130,     0,  2508,  2487,  2490,  2497,  1594,  2488,
       0,     0,   422,   425,   427,     0,   430,  2068,  3306,  3305,
       0,     0,     0,  1424,  1427,     0,  2541,  2538,   130,     0,
    2841,  3468,  3466,     0,  1394,  1410,  1392,  1404,  1405,     0,
       0,  1397,  1396,  3287,  3554,  3555,     0,     0,  3531,  3548,
    3529,     0,  3543,  3544,  3528,     7,     4,   147,     0,     0,
       0,   138,   820,   820,   133,     0,   820,     0,   155,  1595,
    1595,   820,   820,   820,     0,     0,  1970,  2000,  2001,  2003,
       0,  2002,     0,     0,  2068,     0,     0,  1992,  2016,     0,
    2016,  1994,  1995,     0,     0,     0,  1571,  1998,  2690,  2218,
    2221,     0,  2210,  2212,  2213,  2707,  2215,     0,     0,  2079,
    2082,  1586,  2146,  2147,     0,  2145,     0,  2135,  2139,  2144,
    2142,     0,  2126,  2163,  2154,  2202,  1585,  2161,  2162,  1547,
    2467,  2465,  2484,  2485,  2677,  1525,  1521,  3283,  3284,  3281,
    3282,  3280,  3209,  3210,  1137,  1136,   814,   817,   816,     0,
       0,  1252,   262,  2712,     0,  1254,     0,  2449,  1269,     0,
       0,  2449,   631,  2449,   685,  2713,  3418,     0,  3430,  3407,
    3287,  1378,  3495,  3496,  1259,  1257,     0,  1438,  1439,  1442,
       0,   295,     0,   298,   300,   551,   554,   491,     0,     0,
       0,  1477,     0,  1475,  1474,  1472,  1473,  1471,     0,  1462,
    1468,  1469,  2449,   623,   372,   570,   351,   344,   347,   349,
       0,  1084,  1002,  1082,  1102,  1100,  1102,  1024,  1103,     0,
    1071,  1069,  1068,  1064,  1071,  1027,  1146,     0,  1139,  1144,
    1140,  1033,  1142,     0,  1150,  1149,   997,  1047,  1102,  1035,
       0,   996,  1026,  1032,  1071,     0,  1021,  1030,  1102,   989,
    1034,  1020,     0,  1071,  1036,  1049,  1052,  1054,  1056,  1071,
    1102,     0,   456,   996,  1019,  1018,   996,  1071,     0,     0,
       0,     0,   361,  1065,  1050,  1142,  1150,   996,  1102,  1071,
       0,  1090,  1071,   370,   455,  2165,  1997,     0,  2337,  2343,
    2250,  2252,  2676,     0,  1570,  2339,  2124,     0,     0,     0,
    2349,  2254,     0,  2231,     0,   695,  2236,  3346,   698,   697,
    2241,   696,  2292,  3405,  2235,  1382,     0,     0,   491,   583,
     586,  3381,  1610,     0,  3362,  3366,  3360,  3364,     0,  3344,
       0,     0,  3352,     0,     0,  3390,  3373,  3377,  3376,  3374,
       0,  3375,  3380,  3358,   483,   531,  2260,  2989,  3187,  2556,
    2552,  2551,     0,  2571,     0,  2069,  2070,     0,     0,  2072,
    3289,  2165,     0,  3286,   506,     0,   498,     0,     0,     0,
     522,  2706,   502,   498,   512,   521,   590,   338,     0,   295,
     496,     0,   341,   570,     0,   491,   491,     0,  3287,     0,
    2075,     0,  1931,     0,     0,     0,     0,     0,     0,  1728,
       0,     0,     0,  1869,     0,  1931,  1893,  2195,  2196,  2176,
    2177,  2175,  2178,  1607,     0,  2179,  2194,  1815,     0,     0,
       0,  1891,  1552,  1535,     0,     0,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2057,  2062,
    2058,  2059,  2060,  2061,  2056,  2063,     0,  2043,     0,  1917,
    1882,     0,     0,     0,     0,   965,     0,     0,     0,     0,
       0,     0,     0,  2074,     0,     0,  2074,     0,     0,     0,
       0,  1892,     0,     0,     0,  1890,     0,     0,  1889,  1772,
       0,     0,  2074,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1704,     0,     0,     0,  2074,     0,     0,     0,
       0,     0,     0,     0,     0,  1697,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2066,  2064,  2067,
    2065,     0,     0,  1957,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1829,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1776,     0,     0,     0,  2667,     0,  1168,
       0,     0,     0,     0,  1743,     0,     0,     0,     0,  3241,
    1911,  1913,  1612,  1611,  1613,  1624,  1618,  1622,  1616,  1620,
       0,  1677,  2896,  1625,     0,     0,     0,  1628,  1637,  1641,
       0,     0,     0,     0,     0,  1659,  1660,  1648,  1646,  1647,
    1644,  1645,     0,  1650,     0,  1649,  1656,  1657,  1658,  1661,
    1746,  1131,  1754,  2094,  1884,  1885,  1909,  2098,     0,  2663,
    1595,  1700,  1699,  1701,  1702,  1703,   732,     0,   726,   729,
     743,     0,     0,  2543,     0,  2858,  2882,  2883,   404,   407,
     406,   408,     0,     0,     0,     0,     0,     0,     0,     0,
    3409,  3331,     0,     0,     0,     0,  1591,  1532,  1590,     0,
       0,     0,     0,     0,     0,  3258,     0,     0,  3257,  3256,
       0,  3277,     0,     0,  3262,  3261,     0,     0,  3219,  3263,
    3264,  3267,     0,     0,     0,     0,     0,  3248,     0,  3172,
    3221,  3222,  3227,  3217,  2424,     0,     0,     0,  2429,  2427,
    2420,  2431,  2441,  2428,  2422,  2433,  2421,     0,     0,     0,
    2461,  2436,  2438,  2434,  2461,     0,  2459,  2446,  2445,  2444,
    2393,  2392,  2386,  2452,  2439,  2435,   259,  2461,  2391,  2390,
    2372,  2373,  2374,     0,  2133,     0,  2457,  2426,  2451,     0,
    2461,  2461,  2442,  2443,  2412,  2414,  2319,     0,  1997,     0,
       0,  2305,  2298,  2285,   491,     0,     0,  2648,  2271,     0,
    2274,  1997,   491,   566,     0,     0,     0,   716,  1512,  1498,
    1514,  1422,  1421,  1419,  3212,  3460,  3464,  1958,    80,  2313,
    2311,    82,  2310,  2312,    83,  2522,  2499,  2498,  2500,  2504,
     130,  2509,  2501,     0,  2514,  2515,   435,     0,   431,     0,
       0,  3304,     0,   821,     0,    75,     0,  1428,  2165,  2537,
    2539,  2532,  3467,     0,  1395,  1412,  1411,  1407,  1408,  1413,
    1403,  1402,  2359,  3537,  3546,  3550,  3535,   812,  3342,  3430,
     228,     0,     0,     0,     0,   136,     0,   283,     0,   820,
     154,   158,   820,     0,     0,     0,   820,     0,  2013,  2005,
    2007,  2008,  2009,     0,  2012,     0,  1574,     0,  1562,  1562,
    1572,  2015,  1996,  1993,  2017,     0,  2016,  2016,     0,     0,
    1976,  1975,     0,  2068,  1125,  2214,     0,     0,  2078,     0,
    2080,  2089,  2079,  1588,  2165,  1582,     0,  2620,     0,     0,
       0,     0,     0,     0,     0,     0,   815,  2292,  2292,     0,
       0,     0,     0,     0,     0,     0,     0,   267,   276,  2711,
       0,     0,   629,   630,  2292,   628,   671,   672,   675,   676,
     677,     0,     0,   678,  2292,  2292,   625,   651,   652,   655,
     656,   657,   658,   659,   621,     0,   626,     0,     0,     0,
    3442,  1246,  1282,  3497,  1255,     0,     0,  1441,   293,   292,
     296,     0,     0,   491,   538,   547,   541,   543,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    88,    89,   110,     0,  1464,  1476,  2247,  1470,
    2292,  2292,  2292,  2292,   627,   660,   661,   664,   665,   666,
     667,   670,   668,   669,     0,  2449,     0,     0,     0,     0,
       0,     0,     0,  1022,  1104,     0,  1023,     0,  1073,  1074,
    1072,   992,   988,  1147,  1135,  1134,  1141,   999,  1143,  1138,
    1151,  1148,  1145,  1100,   998,  1028,  1029,   994,     0,  1243,
    1006,     0,   995,  1055,   993,  1007,     0,   357,     0,   355,
     364,  1031,  1004,  1016,   456,   456,   353,   457,   458,     0,
    1025,  1000,  1001,  1003,  1150,   986,     0,   987,  2165,  2170,
    2166,   366,   385,     0,   384,  2338,  1562,     0,     0,     0,
    2679,     0,  2149,  2125,  2348,     0,  2352,  2351,     0,  2232,
    2242,     0,  2293,     0,     0,  1384,  1383,  2238,  2245,  3287,
     491,   584,   512,  3429,     0,  3428,     0,     0,  3341,     0,
    3401,  3404,  2676,     0,     0,     0,     0,   339,     0,  2553,
    2557,  1503,  1505,  1506,  1504,  1512,     0,  2724,  2691,  2073,
    2692,  2721,  2719,  2723,  2717,  2718,  2722,  2716,  2720,     0,
    3295,  3296,  3294,  3288,  3293,   499,   507,   523,   526,     0,
     503,   513,   517,     0,   487,   486,   529,   561,     0,   601,
     555,   555,   555,  1480,     0,  1864,     0,  1865,  1866,     0,
    1729,  1966,     0,     0,     0,  1757,     0,     0,     0,  1868,
       0,  1608,     0,     0,  1732,  1724,  1536,     0,  1895,     0,
    1900,     0,  1898,     0,     0,     0,     0,     0,     0,  1960,
       0,  1962,  2663,     0,  1874,  1905,     0,  1872,     0,  1894,
       0,  1906,  1907,     0,     0,     0,  1878,  1876,     0,  1880,
    1877,  1879,     0,     0,     0,  1798,     0,     0,     0,     0,
       0,     0,     0,  1775,     0,  1811,     0,  1862,  1812,  1813,
    1814,  2666,     0,  1808,     0,  1809,     0,     0,     0,     0,
       0,  1761,  1762,     0,     0,     0,  1839,     0,  1763,  1819,
       0,  1737,  1840,  1821,  1768,  1769,  1841,  1842,  1843,  1734,
    1735,  1823,  1824,     0,  1845,  1736,  1825,  1828,     0,  1771,
    2165,     0,  1755,     0,     0,     0,  1773,  1802,     0,     0,
       0,  1733,     0,  1831,     0,     0,     0,  2165,     0,     0,
    1777,     0,     0,   966,  1554,  1725,  2664,     0,     0,  1619,
    1623,  1617,  1621,     0,     0,     0,     0,  1636,     0,     0,
    1629,  1639,  1642,     0,     0,  2096,     0,     0,  1903,  1955,
       0,     0,     0,  1858,  1859,     0,     0,   725,   724,     0,
     728,   804,     0,   745,   733,   722,  2545,     0,     0,  1487,
    1490,     0,     0,     0,  3332,     0,     0,     0,     0,     0,
       0,     0,  1595,  1596,  1596,  2662,     0,     0,  3245,  3215,
       0,     0,     0,  1133,  3276,     0,     0,  3269,  3270,     0,
       0,     0,  3242,  3243,  3244,     0,  2748,  2749,  2695,  2697,
       0,  2696,  2746,  2744,  2747,  2742,  2743,  2741,  2745,  3251,
       0,  3224,  3225,  3226,     0,     0,  2419,  2430,  2462,  2463,
    2440,  2437,  2387,  2458,  2165,  2397,  2418,  2388,     0,  2411,
    2369,  2459,  2076,  2451,  2384,  2385,     0,  1571,  1596,  2301,
    1595,  2302,   491,  2647,     0,  2652,     0,  2280,     0,  2277,
    2284,   709,  2264,     0,  2275,  2249,     0,   577,  1461,  1501,
    1493,  1500,  1497,  1512,  1510,  1499,  1194,  1193,     0,  1513,
       0,    79,     0,     0,  2502,  2503,  2496,  2516,  2491,     0,
     426,   436,   428,   432,   433,   434,   429,  2978,  3059,     0,
    2076,  3308,  3552,  1435,  1433,  1432,  1434,  1423,  1429,  1430,
    2542,  2540,  2535,  2561,  1410,     0,  1393,  2361,  2165,     0,
    3549,   148,   813,     0,   169,  3442,     0,  1218,     0,     0,
     134,   208,   283,     0,   281,  3521,   156,  3511,     0,   149,
       0,   263,     0,     0,  2010,  2011,  1973,  1562,  1564,  1563,
       0,     0,  1566,     0,     0,     0,     0,  1981,     0,  1977,
    1979,     0,  2041,  2033,     0,  2219,  2211,  2216,  2661,  2086,
    2130,     0,     0,  1533,  2089,  1587,  2148,  2137,     0,  2141,
    2140,  2143,  1586,  2127,  2130,  1595,  3211,     0,     0,  1250,
       0,     0,     0,   270,   273,   271,   272,   680,   679,     0,
    2449,   673,  2292,  2292,   222,  2292,  2292,   221,   223,     0,
     217,   214,   224,  2292,  1270,   210,     0,     0,     0,     0,
    2165,     0,     0,     0,   230,     0,     0,  2449,   653,   632,
     633,   636,   637,   638,     0,  3412,  3411,     0,  3432,     0,
       0,  3434,     0,  3433,  3431,  3397,  3408,     0,  1277,  1136,
       0,  1284,  1286,     0,     0,  3497,  1440,     0,   295,   299,
     339,     0,   544,     0,     0,  2165,     0,  2165,  2165,     0,
       0,  2165,     0,  2165,     0,     0,     0,     0,     0,     0,
       0,  2165,     0,     0,     0,     0,  2165,     0,  1478,     0,
       0,     0,     0,  2449,   662,     0,  2292,   622,   639,   640,
     643,   644,   645,   646,   647,   650,   648,   649,     0,     0,
     305,   306,   374,   569,  1079,  1077,  1080,  1078,  1101,     0,
    1075,  1076,  1105,  1142,     0,  1142,   356,   359,     0,   363,
     362,     0,     0,  1005,   394,   393,   391,   491,   381,   389,
     383,     0,   390,  2173,  2174,  2171,  2169,  2172,  2335,  2251,
    2351,     0,  2677,  1594,     0,  2345,  2076,     0,  2350,  3287,
    3347,   694,   875,  3406,  1382,     0,   374,   515,   588,  3426,
       0,  3446,     0,     0,     0,     0,     0,     0,     0,     0,
     532,  2314,     0,  1512,  1516,  2564,  3298,  3299,  3297,   524,
       0,   520,   512,     0,   295,     0,   555,     0,   595,   597,
     556,   605,   599,     0,  1932,  1963,     0,  1081,  1081,  1067,
    1089,  1949,     0,  1943,  1946,     0,  1081,  1951,  1081,  1944,
    1081,     0,     0,  1941,  1942,     0,     0,     0,  1870,  1867,
       0,     0,     0,  1920,     0,     0,     0,     0,     0,  1653,
       0,  1853,     0,  1875,  1873,     0,     0,     0,     0,     0,
    1881,     0,  1781,  1779,  1710,     0,  1708,     0,  1709,     0,
    1711,     0,     0,  1863,     0,  1679,  1698,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1958,     0,     0,  2181,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2668,     0,     0,     0,  1157,  1163,  1166,  1167,  1169,
    1161,     0,  1833,     0,     0,     0,  1914,  1912,     0,  1634,
    1630,     0,  1638,     0,     0,     0,  1652,  1651,  2098,  2097,
       0,  1902,     0,     0,  1956,  2665,  1596,  1848,  1595,   735,
       0,   753,   727,  2165,   730,     0,   744,     0,   756,     0,
       0,     0,   405,     0,  1491,     0,     0,  3330,  3410,     0,
       0,     0,     0,     0,  1589,  1598,  1592,     0,     0,     0,
    3207,  3259,  3250,     0,     0,     0,     0,  3274,  3268,  3265,
    3266,     0,     0,     0,  3249,  3223,  3229,  3228,  3231,  3233,
    2407,  2406,     0,  2460,  2133,  2380,  2399,  2401,  2461,  2321,
    2324,     0,  2068,  2309,     0,     0,  2303,  2307,     0,  2651,
       0,     0,     0,  2281,  2283,  2656,  2655,  2667,     0,     0,
    2276,   336,     0,   576,     0,  2035,  3213,    84,     0,  2494,
       0,  2489,  2492,     0,     0,  3319,  3320,  3312,  3315,  3313,
    3314,  3318,  3321,  3322,  3309,  3316,  2133,     0,  1425,  1431,
    1409,     0,  1416,  1414,     0,     0,  2360,  3538,  3551,     0,
    1277,     0,     0,     0,     0,     0,     0,   824,   824,   209,
       0,  3527,  3526,  1595,     0,   279,   282,   284,   278,   330,
       0,   239,  3497,   163,   165,     0,   159,   161,   151,  1573,
    1565,  1567,  1562,  1562,     0,  1969,     0,     0,     0,  1969,
       0,     0,   716,     0,  2014,  2030,  1126,  2578,  2087,  2088,
       0,  2083,  2131,  2132,  2085,  2081,     0,  2090,  2092,  1534,
    2136,  1583,     0,  2129,     0,     0,  2205,  2207,   874,   873,
     275,   274,   287,   288,  2191,  2192,  2189,  2190,   686,   699,
    2193,   700,   674,  2165,  2165,  2297,  2296,  2165,  2165,   216,
     213,  2295,  2294,  2165,  2165,   211,   234,   233,   235,   236,
     238,   237,   232,  1266,     0,   687,   688,   654,     0,   634,
    3415,     0,  3422,  3417,  3420,  3400,  3399,  3398,  3395,     0,
    2165,  2165,  2165,     0,  2165,  3441,  3443,     0,     0,  1267,
    1370,  1370,     0,  1370,     0,     0,  1370,     0,  2292,     0,
       0,  2292,   716,  1388,  2292,  2292,  2292,  2292,     0,  2292,
    2292,  2292,  2292,     0,  2292,  2292,     0,  2292,     0,     0,
       0,  2292,     0,  1353,     0,  2292,  2292,  2292,  2292,  1370,
    2292,  2292,     0,     0,     0,     0,  2292,  2292,     0,     0,
    2292,  2292,     0,  1298,  1352,   826,   869,   853,   854,  1247,
    1297,  1299,  1311,   712,     0,  1329,  1355,  1356,  1354,     0,
    3455,     0,     0,   244,  3499,     0,  3501,     0,  1444,     0,
    1443,   294,   552,   548,  2165,  2165,   103,  2165,    95,    96,
      91,   123,   124,    93,    94,    99,    98,   100,   101,   104,
     105,   102,    97,    92,   127,   129,   128,   106,   125,   126,
      90,   693,   692,   691,   690,   663,     0,     0,  2449,   641,
     373,     0,  1087,  1085,  1085,     0,  1085,     0,  1118,   981,
     983,   982,   984,   985,  1087,  1087,  1085,  1085,   307,   375,
     369,     0,  1038,  1244,  1037,   358,   354,  1066,  2165,   371,
     392,     0,  2076,  2680,     0,     0,  2150,  1595,  2340,  2342,
    2228,  2226,   612,     0,     0,   512,  3427,     0,  3340,  3345,
       0,  3403,  3402,  3430,  3430,  3430,  3430,   534,     0,  2261,
    1507,  1512,  1516,     0,  1508,  2575,   514,   518,   489,   488,
     570,   559,   491,     0,  1964,  1933,  1934,  1948,  1950,     0,
    1947,  1936,  1953,  1940,  1945,  1952,  1938,  1727,  1758,  1731,
    1730,     0,     0,     0,  1792,     0,  1918,  1901,  1899,     0,
       0,  1765,     0,  1767,     0,     0,  1855,  2665,  1822,  1897,
    1795,  1826,  1770,     0,     0,     0,  1707,  1705,  1706,     0,
    1782,  1806,     0,  1696,  1807,     0,  1838,  1788,     0,  1790,
       0,  1791,     0,  1817,     0,  1793,  1820,  1844,  1723,  2183,
    2182,  2180,  1738,  2165,     0,  1796,  1756,     0,     0,  1830,
    2669,  2670,     0,  1832,     0,     0,  1168,  1154,  1155,  1156,
       0,  1158,  1160,  1162,     0,  2165,  1846,  1655,  1654,     0,
    1626,     0,  1635,  1632,     0,  1640,  2100,  2099,     0,     0,
    1849,  1955,  1598,  1860,     0,   736,   737,   739,   741,   807,
       0,   731,     0,   720,     0,   735,   723,  1488,   594,     0,
       0,  3327,  3326,  3325,  3324,     0,  1593,  1602,  1601,  2659,
    2663,  3247,  3246,  3279,  3278,  3272,  3271,  3273,     0,     0,
    3252,     0,     0,  2187,  2188,  2186,  2184,  2185,  2398,  2133,
    2394,     0,  2076,     0,  2033,  1596,  2299,     0,   592,  2653,
       0,  2279,     0,     0,     0,  2278,  2288,     0,   581,   578,
     579,     0,  2038,     0,  2039,  2036,  2037,  2165,     0,     0,
     444,   439,   447,   441,   443,   442,   448,   449,   450,   451,
     445,   440,   446,   438,   437,     0,  3307,  1436,     0,     0,
    2362,  2363,  3343,   168,     0,  1234,  1236,  1235,  1219,  1220,
       0,   142,   145,   924,     0,     0,   135,   704,   712,   825,
     828,   701,   137,  1595,   174,   277,   280,   328,   334,   333,
     268,     0,     0,     0,  3517,   302,   889,   890,   888,   887,
       0,  3517,   302,  3497,  1576,  1575,  1982,     0,  1986,  1991,
    1987,     0,  1978,     0,  1999,  2042,  2034,     0,     0,  2586,
    2130,     0,     0,  2130,  1596,  2203,  1595,   215,   220,   219,
     212,   225,   218,   231,   635,  3416,  3414,  3413,     0,  3421,
       0,  3396,  3437,  3435,  3436,  3439,     0,     0,  3438,  3440,
    1271,  1272,  1278,  1273,  1241,   820,  1371,   818,     0,  1333,
    1337,  1334,     0,   925,   820,  1195,  1195,   818,  2253,  1481,
    2253,     0,     0,  2253,     0,  2255,  2253,     0,     0,  2253,
    2253,  2292,     0,  1481,     0,  2165,   714,  1391,  1389,  1390,
       0,  2165,  2165,  2165,   851,   872,     0,  2165,  2165,  2165,
    1481,     0,     0,  2292,  2165,  1346,  1293,  1347,     0,     0,
    1294,     0,  2165,  2165,  2165,  2253,  2165,     0,  1481,  1313,
    1481,  1481,     0,  2165,   859,   860,   858,  2165,  2165,     0,
     827,  1136,  1295,   713,  1296,   924,     0,  1385,   900,   927,
    2672,     0,  3456,     0,     0,     0,  1283,     0,   247,   245,
     255,  3498,     0,  1258,     0,  3501,  1446,  1447,     0,     0,
       0,   116,   118,     0,   120,   122,     0,   112,   114,   624,
     689,   642,   304,  1088,  1010,  1086,  1014,  1015,   312,  1142,
       0,     0,  1142,  1150,  1142,  1150,     0,  1070,   382,  2351,
    2344,     0,  2151,     0,  2346,   589,   516,   587,     0,  3430,
    3444,  3444,  3444,  3444,   339,   530,   533,  2315,  1509,  1517,
    2577,  2576,     0,   295,     0,   491,  1142,  1954,  1142,  1142,
    1871,     0,     0,     0,     0,  1924,     0,     0,     0,     0,
       0,  1726,     0,  1851,     0,  1780,  1778,     0,  1067,  1686,
    1688,  1684,  1687,     0,  1081,  1690,     0,  1048,  1081,  1693,
    1695,  1680,  1681,  1682,  1683,     0,     0,  1967,  1968,     0,
    2201,  2200,  2199,     0,     0,     0,     0,  2671,  1152,  1835,
       0,  1165,  1159,  1157,  1164,     0,  1915,  1631,     0,     0,
    2102,     0,  1904,     0,  1861,   740,     0,     0,     0,   760,
       0,   758,   734,     0,  3329,  3328,  1600,  1599,     0,     0,
       0,  3230,  3232,  2400,  2323,  2124,  2325,  2326,  2318,  2308,
    2306,     0,  2282,  2657,  2668,   710,     0,     0,  2165,   580,
    1314,     0,  1315,  1326,  1328,  1515,     0,  2527,     0,  2525,
    2495,  2528,     0,  1415,  1417,     0,   139,     0,     0,  1241,
    2803,     0,   893,   895,   896,   897,   898,     0,   705,  2575,
     711,  1136,   829,   824,   176,   202,   313,  3522,   615,   616,
       0,     0,  3501,   268,     0,     0,     0,     0,   268,     0,
       0,     0,     0,     0,     0,     0,  2023,     0,  2022,     0,
    2028,  2032,     0,     0,     0,     0,  2579,  2581,     0,  2220,
    2084,  2093,  2091,  2128,  2208,  2206,     0,  3423,  3419,  2168,
    2167,     0,  1275,     0,  1274,  1279,     0,   926,  1242,  1481,
       0,     0,     0,  1357,     0,     0,     0,  1195,   916,   820,
    1241,  1196,   820,   820,  1331,     0,     0,     0,  1305,     0,
       0,  2253,     0,  1359,     0,  1358,     0,     0,     0,     0,
    1368,  1369,     0,  2120,  2122,  2130,  2198,  2197,   848,     0,
    1350,   841,   840,   843,   842,   845,   844,     0,  1366,  1367,
     837,   834,   846,     0,   836,   861,     0,   849,   831,     0,
     885,   886,   884,   855,   862,   832,   833,     0,   839,   838,
     835,     0,  1321,     0,   877,   882,   880,   879,   878,   883,
     881,   850,   868,   847,   863,  1310,  1370,  1370,  1330,     0,
     891,  2675,     0,  1387,  1332,     0,   901,     0,     0,   867,
     866,   864,   865,   254,   243,     0,     0,  1285,  1287,     0,
       0,  1288,  3500,  3503,  1256,  1452,     0,   339,   108,  2165,
     109,  2165,   107,  2165,  1012,   310,     0,  1008,  1009,  1011,
    1013,   376,     0,     0,  2152,  3447,  3444,     0,  3338,  3337,
    3336,  3335,   536,   535,     0,     0,   490,   555,     0,  1935,
    1937,  1939,  1786,  1787,  1921,  2130,  1919,  1926,     0,     0,
    1925,  1816,     0,  1766,     0,  1852,     0,  1827,  1783,  1689,
    1685,  1692,  1049,  1691,  1142,  1810,  1789,  1818,  1739,  2165,
    1797,  1800,  1801,     0,  1834,  2165,  1633,     0,  2105,  2104,
       0,     0,  2130,  1850,   738,   808,   733,     0,     0,   757,
       0,   721,  2660,  3254,  3253,  2149,  2649,     0,  2287,  2289,
       0,  1511,     0,  2040,  2523,  2165,     0,  2493,     0,     0,
       0,     0,     0,     0,   899,   892,   924,     0,   703,   810,
     830,   712,     0,   511,   511,     0,   203,   204,   323,     0,
     314,   316,   285,   269,     0,     0,   619,   617,   618,     0,
       0,   150,  3519,   264,  3518,     0,   303,   167,   264,     0,
    3501,  1983,     0,  1988,     0,  1980,  2018,  2018,  2029,     0,
       0,     0,     0,  2580,     0,     0,  2587,  2589,     0,  1273,
       0,     0,     0,  1316,     0,     0,  1335,     0,   820,  1191,
    1192,  1241,  1216,  2672,  1241,  1241,     0,  1304,     0,  1467,
    1132,  1342,     0,  1300,     0,  1344,  1345,  1382,   857,  1302,
       0,  2123,   715,  2515,  1309,   856,     0,  1385,  1301,  1323,
    1307,  1336,  1386,  1173,   931,     0,   919,   929,   974,  2674,
     241,   246,   256,   257,  1260,     0,  3502,     0,  1453,  1449,
    1450,  1445,   549,   117,   121,   113,     0,     0,     0,  3339,
       0,  3451,  3445,  3449,     0,     0,   562,   602,     0,  1923,
    1883,  1927,  1928,     0,  1854,  1856,  1694,     0,  1153,     0,
    2101,  2095,     0,     0,     0,     0,     0,     0,  2114,  2106,
       0,  1908,  2165,   806,     0,     0,   746,   763,   762,   759,
    2322,  2658,   339,  1327,  2526,     0,  3317,     0,     0,     0,
    2130,  1239,     0,     0,   894,   706,   811,     0,  2575,   511,
     511,   177,   182,   183,   187,   185,   196,     0,     0,   189,
       0,   189,  1597,   205,   326,   324,   325,     0,   329,     0,
     286,   571,  1595,   252,     0,   265,   164,  3517,   160,  3517,
     152,     0,     0,     0,  2026,  2024,  2584,  2585,     0,  2582,
       0,     0,  2588,     0,  1280,  1276,  1281,     0,  1318,     0,
     819,     0,  1241,  1216,  2672,     0,   902,     0,   906,   908,
       0,     0,  1385,  1306,  1351,  1343,  1360,  1341,  1481,  2121,
       0,     0,  1340,  1322,  1324,  1428,     0,  1177,   933,     0,
     928,   920,   941,     0,   248,  1289,   491,     0,     0,     0,
    1448,     0,  1455,   311,   308,     0,     0,  3450,  3448,  2316,
    1997,   555,  2130,     0,     0,  1764,  1740,  1836,     0,  2111,
       0,     0,  2109,  2108,     0,  2103,  2110,   809,     0,     0,
     754,   770,   766,     0,   768,   769,   791,   582,  2529,     0,
       0,  3287,     0,  1238,     0,  3287,     0,   870,   702,     0,
       0,     0,   184,   186,   188,   201,   207,     0,   206,     0,
     264,   327,     0,     0,   317,   315,   264,   341,  3512,   244,
     253,   571,   268,   268,  1985,  1990,     0,  2019,     0,     0,
       0,  2583,  2591,  2590,  3424,     0,     0,     0,  1317,     0,
     921,   914,   910,     0,  1217,     0,   904,     0,     0,  1349,
       0,  1339,  1303,   852,   716,     0,  1308,     0,  1176,     0,
    1181,  1171,   959,  1116,     0,   962,     0,   932,   934,  1109,
    1110,   936,     0,     0,     0,     0,   975,     0,     0,  1093,
       0,  1096,     0,     0,   930,     0,   942,  1092,  1099,  2673,
       0,   250,   226,  3504,     0,     0,  1454,  1459,     0,  1456,
    1458,     0,  1568,     0,  2565,   603,  1922,  1930,  1929,  2112,
       0,  2113,  2116,     0,     0,  2117,     0,   750,   752,   742,
       0,   747,     0,   764,     0,  2292,  2292,     0,  2292,  2292,
    2292,  2292,   784,   792,   794,     0,     0,  3287,  1206,  2130,
       0,  1208,     0,   708,   871,     0,   511,     0,   511,   570,
     180,   178,   192,   190,   175,   322,     0,     0,  3523,   572,
       0,   255,   226,   264,   264,  2021,  2020,  2035,     0,  1338,
    1320,     0,     0,     0,     0,   912,     0,     0,     0,     0,
       0,     0,     0,   971,   972,  1348,   968,   969,   970,     0,
    1312,     0,  1174,     0,  1178,  1179,  1180,     0,  1172,   960,
     961,  1117,   935,  1115,  1108,  1107,     0,  1098,  1094,     0,
     950,     0,     0,  1100,  1091,   943,   249,     0,   242,   227,
     258,  3505,  3506,  1451,     0,   309,  2317,  2328,     0,  1125,
    2107,  2115,  2119,  2118,   748,     0,   755,   777,   767,   773,
       0,  2292,     0,     0,  2292,     0,     0,     0,     0,     0,
     761,   793,  2292,   229,  1204,     0,     0,  2292,  1361,  1207,
    1232,  1214,     0,  1237,  1240,  1361,  1209,  1231,  1212,     0,
     195,   199,   194,   197,     0,  1597,   330,   330,   320,     0,
       0,     0,     0,  3520,   166,   162,     0,     0,  1319,   917,
       0,     0,     0,     0,     0,     0,     0,  2623,  2622,     0,
       0,  1175,     0,     0,  1114,  1113,  1111,  1112,  1603,  1097,
       0,   945,  1106,   944,   251,  1457,     0,     0,  2566,   754,
     751,   777,     0,   775,     0,   771,   765,   772,     0,   803,
     797,     0,   799,   800,   798,   795,   788,     0,   786,     0,
       0,     0,  1361,  1205,  1230,  1229,  1210,     0,  1224,  2165,
     143,  1363,  1362,  1215,     0,   146,  1213,     0,   571,   571,
     181,   264,   268,   302,   331,     0,     0,     0,   570,  1595,
     257,  2027,  2025,     0,     0,     0,  1204,     0,  1206,  1208,
     967,     0,  1187,  1186,     0,     0,  1183,  1182,     0,  1095,
     937,   937,   951,  2327,  2329,  2592,   749,   774,     0,   782,
     778,   780,   783,   802,   801,     0,   785,     0,   796,  1221,
    1222,   140,  1211,  1233,  1223,  1365,  1364,  1228,  1227,  1225,
    1226,   918,  3524,  3524,   179,   193,     0,  3517,   321,   318,
       0,   573,  3513,   240,     0,  1204,     0,   903,  1204,   907,
     909,  1325,  1190,  1188,  1189,     0,     0,  1604,     0,   948,
     938,   940,   947,   953,   954,   952,   955,     0,  2578,   776,
       0,     0,   791,   790,   787,  3525,   200,   198,   332,   268,
       0,     0,     0,   915,   911,  1204,   905,     0,     0,  1605,
     939,   946,   956,   958,     0,  2586,   781,   779,   789,   191,
     319,   574,     0,   913,  1185,  1184,   957,     0,  2594,  3514,
    2593,     0,  2598,  3509,     0,     0,  2605,  3507,  3508,     0,
    3515,  2596,  2597,  2595,  2600,     0,     0,  2602,  2603,     0,
    2567,  3510,   491,  2604,  2599,     0,  2606,  2608,     0,   226,
    2601,     0,  1595,  3516,  2607,     0,  1596,  2609
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5342, -5342, -5342, -5342,  2253,  4711, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,  2840, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  1959, -5342,   496, -5342,   501, -5342,   503, -3373,  -599,
    4417, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,   211,
     210,   217, -5342,   223, -5342, -3356, -5342, -5342, -5342, -5342,
     221, -5342, -5342, -3669, -5342,  2133, -2398, -5341, -5342, -5342,
     100,  1511, -5342, -5342,   387, -5342,    69, -5342, -5342, -5342,
   -4474,   -69,  -277, -5342,    31,  4936,  -483, -3863,  4252, -4496,
     142,  1609, -5342, -5342,  2147, -5342, -5342, -3211, -5342, -5342,
   -5342, -5342, -2177, -5342, -5342, -4493, -5342,   694, -4312,  1383,
   -5342, -5342,   222, -5342, -5342, -5342,  -174, -5342,  -171, -5342,
    -632, -3092, -5342, -2385, -5342, -5342, -5342,  4215, -5342, -5342,
   -5342,  1960, -5342, -4177, -5342, -3222,  4862, -5342,  -707, -5342,
   -5342, -5342,  1923, -5342, -5342,   752,  1364,  3388,  3038, -5342,
   -5342, -5342, -5342,  2437, -5342,  2348, -5342, -1910,  3834, -5342,
   -5342, -5342, -5342, -5342,  2876, -2681, -5342, -5342, -5342,  1674,
   -5342,  -856, -5342, -2102,  -948,  4763, -5342,    23, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -1415, -5342,
   -5342, -5342, -5342, -5342, -5342, -3733, -2991,  1907, -5342,  1355,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,   878, -5342,
   -5342, -5342, -5342,    28, -5342, -5342, -5342, -5342, -5342, -5342,
    2729, -5342, -5342,  4897, -5342, -5342, -5342, -3680, -5342, -5342,
   -5342, -5342, -5342, -5342,    37, -5342, -5342, -5342, -5342, -4338,
   -5342, -5342, -5342, -2224, -5342, -5342, -5342,  1155, -5342, -5342,
    3304, -5342, -5342,  3305,  3309, -5342,  3301, -5342, -3117, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,    39, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  4242, -5342, -5342, -5342, -3129, -5342, -5342, -3424,  3537,
   -5342, -2743, -5342, -5342, -2780, -5342, -5342, -2697,  1547, -5342,
   -5342,  2116,  1816, -5342, -1775, -2828, -2812, -5342, -5342, -5342,
   -2900, -2895,  -860,  3394, -1546, -3162, -5342, -5342, -5342,   286,
     289,   456,  1489,  2086, -5342, -3986, -5342, -5342,   670, -5342,
   -5342, -5342, -5342, -5342,  1251,   517,  1249, -5342,   839,  3098,
   -2817, -5342, -5342, -5342, -5342, -5342, -5342,   -68,   336,  -149,
   -5342, -5212,   524, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -3071, -5342, -5342, -5342,  -284, -5342, -5342,  -230, -5342,
   -5342,  -283, -5342,    45, -5342, -5342, -5342, -5342, -5342,  2914,
   -2047,  1077,  -700, -5342, -3905,  1531, -4276, -3510, -5342, -5342,
     191, -1343, -1317,  -152, -5342, -5342, -5342, -5342, -5342, -5342,
    1014,   516,  1526, -4034, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -4030, -4029,   739, -5342, -3500, -5342, -5342, -5342, -3763,
   -5342, -5342, -5342, -5342, -5342, -5342,  -198, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -4027, -5342, -5342,    12,   -14, -5342,
     117,  2713, -5342, -3804, -5342, -3608, -1231, -5342, -5342, -3600,
   -3597, -3590, -5342, -1503, -3596, -1497, -3585, -5342, -5342, -5342,
   -1477, -1482,  1824, -1252, -1465,  1380, -1142,  -998,  1971,   -13,
   -3964, -3028, -1113, -1097, -5342, -5342, -3539, -5072, -5342, -4337,
    -681, -2115, -3454,   -25, -5342, -5342, -1855,   455, -2510, -5342,
    3541,  3538, -2260, -1074, -2254,  1892, -5342, -5342,  1327, -5342,
   -2015,  1326, -5342, -5342, -5342,  1333, -5342,  -220, -5342, -5342,
   -5342, -5342, -3562, -5342, -2722, -4261, -5342, -5342,  5334,  5336,
   -3152,  -159,  -158, -5342, -5342, -5342,   307, -5342, -5342, -3023,
    -121,   -43,   -34, -3983, -4221,   238, -3385,  3539, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
     498,   497,  1757, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  1569, -2350, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -4669, -4371, -5342, -5342,  1062, -3331, -3595, -3613, -3941,  4558,
   -5342, -5342, -5342, -5342,  4377, -3692, -3975, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,  3754,  1835, -5342, -5342,  2302, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,   302,  2309,
   -5342, -5342, -5342, -5342, -5342,  2858, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,    20, -5342, -5342, -5342, -5342, -5342,
     492,  3606, -5342, -5342, -5342, -5342,   -17, -5342, -5342, -5342,
   -5342,  3161, -5342, -5342, -5342, -5342,  3042, -5342, -5342, -5342,
   -5342, -5342, -5342,  2044, -5342,  2684, -5342, -2703, -5342, -5342,
    1470,  -568, -5342, -5342,  -394, -5342, -5342, -5342, -5342, -5342,
      19, -5342, -5342, -5342,  5328, -1682,     6,  -466, -5342, -5342,
      14, -5342, -5342,  4432,  -399,  2505,  -743,  5094, -5342, -5342,
   -5342, -5342, -2732,  2394, -5342,  4485, -5342, -5342,  4670,  1995,
    4460,  2261,  1513,  2469, -1840,  -574, -3366,    -7,  1370, -5342,
    2109,   605, 11045, -5342, -1631, -1672, -5342, -5342,   -32, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  2588,  2595,
   -5342, -5342,  4064, -2859, -5342, -5342,  -773, -5342, -2734, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  1931, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342,  4011, -1761, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -1376, -5342, -3064, -5342,
   -5342, -5342, -5342, -5342,  1379,  -614, -5342,  4158, -5342,  4200,
   -5342, -1288, -1901,  3753, -5342,  4519, -5342, -5342, -5342, -5342,
   -5342, -5342,  3764, -5342, -2300, -5342, -2685,  4520,  4522,  4523,
   -5342,  4524, -5342, -5342, -1929,   579, -5342,   880, -5342, -5342,
   -5342, -5342, -5342,  1348, -5342,   133,   937,   136, -4433, -1702,
    1535, -5342, -5342, -1968,  3781,  4209, -1363, -5342,  2986, -5342,
    3759,  1970, -5342,  2325, -5342,  1252,  1259, -5342, -5342,  1973,
   -5342, -5342, -5342, -5342,   671,   220, -5342, -5342, -5342,   561,
     977, -2290, -5342,   686, -3504,  4529,  -276, -1211, -5342, -1385,
    2328,   672,  5157,  -346, -5342, -5342,  4500, -5342, -2116, -5342,
   -1706, -1700,   260, -3338, -4624, -3477, -5342, -1869, -5342, -5342,
   -5342, -5342, -5342,  1266, -5342, -5342, -5342,  3017, -5342,  5435,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
    -712, -1179, -5342, -5342,  2819, -2013,  -524,  5455,  -393, -5342,
   -5342,  -392, -5342, -5342, -5342, -5342,  4309,  3950, -5342,  2780,
   -5342, -5342, -5342, -5342,  2456, -5342, -5342,   984, -1150,   160,
    2311, -5342, -5342, -5342, -5342, -5342, -5342, -5342,   970, -5342,
    1393, -2021, -5342, -5342, -5342, -5342,  -391, -5342, -5342, -5342,
    1394, -5342,    32,  5260,  -390, -5342, -5342, -5342,  5081, -5342,
   -5342, -5342, -5342, -5342, -5342,  3613, -1562,  5079, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  3179, -5342, -5342, -5342,
   -5342, -5342, -5342,  4001,  5277,  -688, -1815, -5342, -1092,  3185,
    2501, -1170, -5342, -5342, -5342,  4536,  5284, -5342, -5342,  5448,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,  3137,
     603, -5342, -5342, -5342, -5342, -5342,   706, -5342, -5342, -5342,
   -5342,  3908, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342,  4336, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342,  1588,   -84, -5342,   949,
    -104, -5342,   657, -5342, -5342, -5342, -5342, -5342,  -139, -5342,
   -5342,  -146, -5342, -1418,  4946, -1389, -5342, -1841, -3610, -5342,
       3, -5342, -5342, -5342,  3192, -5342, -5342, -5342, -5342,  1426,
   -5342, -5342, -2867,  -915, -1811, -4039,  5205, -5342, -5342, -5342,
    -587,     0,    -3,  1713, -1294, -5342, -5342,  2643,  4174,    33,
    2368, -5342,  5020,  -539,  -621,  -750, -1111, -5342,  8624, -5342,
   -5342, -5342, -5342, -5342,    59,  -597,  -593,   130,  -668,    77,
     141,    11, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342,  2552, -5342, -5342,
   -5342,  1454, -5342,  5318, -5342,  3387, -1859,  5319,  3270,  2581,
    2580, -5342, -5342, -5342, -5342, -1887, -5342, -5342, -1876,   350,
   -5342,  3601, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342,  3911,  -575,  -563,  4110,  5329,  4834, -5342,  4380, -5342,
   -5342, -5342, -5342, -5342,  1821, -5342, -2135,  2616, -1592, -2283,
   -5342, -5342,  3034,  1336, -5342, -5342,  1639, -5342,  2229, -2746,
   -3140, -5342,  2475, -3484, -5342, -5342,   619, -5342, -5342, -5342,
    1752,    17,  5304,  4704, -5342, -5342, -5342, -5342,  5517, -5342,
   -5342,   958,  5544,  5545,  5546,  -259, -5342, -3515, -5342, -4220,
   -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -4500, -5342, -4392, -5342, -5342, -5342, -5342,     8, -3953, -5342,
   -5342,  2660, -5342, -5342, -5342, -5342, -5342, -5342, -5342, -5342,
   -5342
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   471,   755,  2106,   472,   473,   474,   475,   476,  2072,
     477,  1310,  2828,  1312,  2038,  2831,   478,   724,   479,  2240,
    3032,  3033,  4816,  4817,  4810,  4811,  4813,  4814,  3034,   841,
     842,   480,  2884,  4087,  3561,  2881,  5280,  2112,  4987,  2113,
    4988,  2877,  4102,  4653,  2119,  2888,  2120,  4651,  4652,  4644,
    4645,   763,  5005,  5292,  5611,  5885,  5761,  5471,  5472,  5473,
    5617,  5480,  5887,  5478,  5886,  5474,  5757,  5969,  5755,  5968,
    5475,  5295,  5296,  5476,  4088,  3644,  3645,  5830,  1369,  3556,
    3653,  3654,  2891,  4642,  4796,  5554,  4800,  5701,  5828,  5629,
    3681,  5171,  5555,  5556,   656,  1381,  5495,  5496,  2201,  5312,
    5302,  4095,  4096,  4097,  3563,  3564,  5303,  2958,   481,   835,
    2231,  3688,  1485,  2232,  2233,  5015,  5016,  3738,  3739,  3740,
    5299,  5300,  5301,  5487,  4638,  5006,  4639,  5975,  4640,  2812,
     958,  2236,  2237,   857,   858,  1501,   859,   860,  2257,  1557,
    3096,  3097,  3098,  2312,   861,   862,   863,  2254,   864,  3118,
    3057,  4349,  4350,  4836,   865,  3767,  3768,  3769,  3122,  1182,
    3770,   482,   483,   677,   685,   678,  1179,  2688,  1180,   484,
     485,   722,  2062,  2063,  2064,  2065,  3526,  2847,  3520,  3521,
    4603,   866,   867,  2322,   959,   960,   486,   961,   657,  1680,
    2429,  3824,  4863,   962,   963,   964,   965,  1682,  2414,  2415,
     966,   967,   968,   969,   970,  5479,  3201,  3202,  3820,  3798,
    4374,  3203,  2425,   971,   972,   973,   974,  1683,   934,   935,
    3167,  4387,  4856,   975,   632,   837,   838,  2239,  3006,   839,
    3007,  3691,  4809,   840,  1486,  3002,  1488,  3828,   976,   977,
    2433,  2432,  3825,   707,   978,  1300,   638,  1500,  2021,  5626,
    5627,  5890,  6081,  2022,  3497,  4043,  4579,  4580,  4968,  3152,
     900,  1613,  2370,   979,  1291,  2804,  1188,  2696,  3829,   980,
    2435,  2437,  2434,  3827,  5571,  2436,   981,   667,   696,   655,
    1612,   683,  5010,  5309,   812,   813,   849,  3055,   814,  1496,
    1457,  2207,  2984,  2985,  3659,  3660,  3727,  3728,  3729,  2976,
    2977,  2978,  3044,  3045,  3046,  2965,  2966,  2967,  2211,  2962,
    2963,   815,  1458,  1469,  2979,  2980,  2981,  3733,  3048,  3049,
    3050,  3051,  2982,  2360,  2983,  4158,  4626,  5003,  4627,  5288,
    3490,  4999,  5000,  4783,  5099,  3504,   491,   670,  1165,  1889,
    2680,  3971,  3389,  3391,  2681,  3970,  4514,  4515,  4516,  3387,
    3388,  5446,  3393,  3968,  5590,  5929,  5726,  5727,  3960,  5731,
    4523,  4940,  4941,  5258,  5447,  5596,  5850,  5732,  5936,  5848,
    5932,  5849,  5934,  6071,  6010,  6011,  5860,  5947,  5948,  6015,
    6072,  5742,  5743,  5744,  3964,  3965,  5443,  5467,  3551,  2195,
    2196,  5062,  1321,   492,  4628,  4264,  4629,  4630,  5107,  5753,
    4266,  4267,  4268,  3791,  1964,  5141,  5123,  4650,  5149,  4631,
    4991,  4992,  4993,  4994,  5655,  5787,  5657,  5658,  5784,  5902,
    5783,  4995,  4996,  5284,  5550,  5068,  4728,  4712,  4713,  4788,
    5157,  5386,  5552,  5548,  5677,  5678,  6059,  6060,  5694,  6002,
    5695,  6066,  6091,  6092,  5679,   493,   669,  1837,  5793,  5794,
    5795,  1559,  5387,  1560,  4338,  1561,  2281,  1562,  4340,  1563,
    1564,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  3110,
    2270,  2271,  3071,  2263,  2264,  2262,  4826,  4824,  2332,  5696,
    5697,  3064,  2267,  2268,  3084,  5825,  5680,  5698,  5682,  4348,
    2283,  1920,  1921,  3595,  1934,  1935,  3075,  2718,  3076,  2199,
    2284,  2285,  3077,  3078,  3082,  4485,  5243,  4491,  4492,  4493,
    3925,  3926,  3927,  3928,  3929,  3348,  5683,  5156,  5547,  5667,
    5670,  5808,  5996,  5069,  4714,  5072,  1276,   764,  4715,  4716,
    5952,  5868,  5875,  5953,  5876,  5869,  5526,  4084,  5954,  5955,
    5956,  5878,  5871,  4618,  5459,  5460,  5057,  3088,   494,   574,
    3679,  1444,  1446,  1456,  3685,  2993,  2992,  1462,  1461,  2971,
    4702,  5055,  4209,  3682,  4283,  5394,   798,  4269,  5538,  5359,
    5545,  4270,  4971,  4271,  5518,  5648,  4272,  5379,  5543,  5665,
    4972,  4973,  4273,  4274,  4275,  5960,  5961,  5962,  4717,  1642,
     818,   819,  1474,  1475,  1476,  3147,  5154,  4740,   495,  2869,
    2864,   496,  1338,  1339,  1340,  2084,  2085,  2867,  2868,  3546,
    4073,   497,  1304,  2823,  2074,  2856,   498,  1324,  3537,  3538,
    3539,  4068,   499,  1482,  2227,  2228,  2997,  4290,  4808,  5175,
    5401,  5562,  5397,  5708,  5709,   500,   845,  1492,   501,   634,
    2249,  2250,  2251,  3036,   502,  1693,   582,   503,  1186,  1895,
    1898,  1899,   504,  1303,  2024,  2025,  2026,  2027,  3500,   505,
    2402,  3171,  3172,  3173,  3174,  2818,  4044,  2819,  2820,  3509,
    4394,   506,   778,  1441,   507,   777,  1440,   508,   509,   695,
     750,   687,  1907,   511,   512,  3491,  2473,   514,   784,   782,
    1127,   516,  1434,  1430,   517,  2474,  1128,   774,   775,  1388,
    1208,  3580,  3581,  2344,  2345,  2923,  2910,  1209,  1210,  1414,
    2177,  2935,  2707,  2708,  2005,  2709,  3985,  5620,  4536,  5999,
    1714,  1623,  1308,  1130,  1131,  1132,  1849,  1850,  1865,  1133,
    1859,  2634,  4453,  4901,  4902,  4903,  4904,  5234,  2555,  2556,
    2675,  1134,  2543,  1135,  1136,  1137,  1138,  1139,  1140,  1141,
    2538,  1142,  1143,  1144,  1145,  2670,  4435,  4436,  4883,  3382,
    3383,  3384,  1146,  3228,  4421,  3239,  1147,  1148,  1149,  1150,
    1151,  3952,  1152,  4509,  4136,  1153,  1843,  2620,  2500,  4875,
    4426,  5214,  5218,  5219,  5220,  5421,  2441,  3216,  3852,  4866,
    4868,  4869,  3853,  3854,  3953,  3353,  1735,  1736,  1703,  1704,
    3903,  1389,  1390,  1391,  1392,  1393,  4120,  4121,  5021,  4657,
    5023,  4661,  2142,  2143,  2146,  2147,  1394,  1395,  1396,  1397,
    2130,  1398,  1399,  1400,  2915,  5504,  5029,  5030,  5640,  5639,
    5031,  4666,  4667,  4124,  4125,  4583,  4584,  4585,  3591,  2496,
    2497,  2571,  2407,  2408,  2409,  2442,  1408,  2157,  2931,  3601,
    2159,  3599,  4131,  3603,  4137,  4138,  2665,  3375,  3948,  3377,
    4930,  5250,  5251,  5438,  5579,  5580,  5585,  4278,  5093,  5094,
    3132,  1415,  2943,  3613,  4134,  1966,  1967,  1968,  2167,  3606,
    3607,  3785,  1417,  1418,  1428,  1433,  1421,  1419,  3123,  4698,
    3124,  3930,  3912,  4977,  4159,  2465,  2466,  5098,  4913,  1422,
    2944,  4145,  4146,  4147,  1404,  1405,  2152,  2153,  2154,  1423,
    1406,  2924,  4127,   518,   717,   519,  2367,   885,  1609,  2366,
    3517,  1494,  2810,  2339,  2340,  1596,   807,   654,   520,   658,
    3168,   521,   699,  2809,   939,  1295,  2017,  2018,  2019,  3492,
    4039,  3493,  4032,  4033,  3494,  1289,  4575,  4576,  3142,  4172,
    4173,  4167,  2803,  3481,  1290,  2009,  4025,  2800,  4026,  2801,
    2833,  4027,  4389,  5204,  5713,  2797,   522,   693,  4562,  4019,
    4020,  5836,  5837,  1287,   523,   639,  2338,   881,  1585,  1588,
    1589,  2348,  3128,  4368,  1590,  1591,  3130,   882,   883,   524,
     738,  3547,  4076,  1344,  1988,  1989,  1990,  2784,   525,   690,
    1277,  4014,  4559,  2770,   673,  1607,  1971,  1280,  1972,  2766,
    3465,  1955,   526,  1438,  1437,   833,   527,   528,   790,   583,
    2181,   529,  1313,  2055,  2845,  4051,  4052,  4588,  2056,  2057,
    3518,   530,   703,  1297,  3514,  4978,  4979,  5277,   531,   729,
    1328,  1329,  2078,  2076,  3542,  2859,   532,  2682,   533,   659,
     942,  1645,  1646,  2400,   534,   732,  1333,   535,   536,   944,
    4395,  5839,  6005,   663,  2404,  1650,  5289,  4669,  5036,  5037,
    5039,  5336,  5337,  6068,  6112,  6123,  6116,  6126,  6127,  6130,
    6136,  6137,  1154,  1351,  1352,  1155,  5798,  1156,  1157,  1158,
    2475,  1293,   698,  2012,  2013,  3486,  2807,  3484,  2014,  4034,
    4035,  3414,  3600,  1159,  4021,  5058,  1495,  2341,  1316,   538,
    1160,   621,   809,  1353,  2149,  3179,  1228,  3440,  1162,   869,
    3830,   982,   983,  1452,  1896,  2216,  2217,  3180,   623,  1659,
    3441,   870,  1230,   541,   624,   625,   626,   627,   628,   629,
     630,   631,   547,   689,  1212,  2714,   548,  1442,  2945,  3510,
    1911,  1238,  1940,  1929,  1939,  2740,  3452,  2743,  3453,  3454,
    4551,  4007,  4552,  4008,  1283,  2735,  1912,  4009,  2728,  2729,
    2730,  2731,  3998,  1926,  2724,  2192,   549,   945,  2413,   666,
    1652,  1653,  3192,   550,   692,   551,   723,  1318,  2852,  3530,
    3531,  4064,  4605,  4065,   552,  1193,  1194,   553,   928,  3554,
    3158,  2356,  1455,  2357,  2384,   931,  1615,   932,   933,  1629,
    1626,  1632,  1628,  4199,  3674,  3675,  3163,  2364,  2218,  2701,
    3667,  4688,  2219,  4193,  4194,  4689,  2374,  3154,  3155,  2990,
    5411,  4206,  3678,  5198,  4378,  5412,  5413,   554,   704,   555,
    5304,   716,  1307,  2035,   556,   557,   558,   559,   783,  1426,
    1211,   575,   576,   577,   578,   822,   823,  3684,  4285,  4803,
    4804,  5396,  6119,  6120,  2890,  4100,  5770,  6082,  6113,  6132,
    5013,  5014,  5313,  5494,  3566,  4099,  5305,  6076,  4093,   560,
    1358,  1354,   749,  2104,  2098,  2100,  2875,  3550,   561,   562,
     563
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     539,   821,  1279,   537,   751,  1558,   513,   668,  1226,  1275,
    1677,   546,  2290,  2464,   515,   827,  2606,  2834,  2291,   510,
    2182,  1234,  2169,   487,  2695,  2660,  2168,  2506,   488,  1387,
    2350,  3058,   811,   540,  2274,  1606,  3125,   489,  2472,   490,
    2725,   872,  2294,   708,  2379,   873,  2160,  3207,  3986,   817,
    2737,  1187,  2690,  1454,  2999,  3752,  3133,  1365,  2303,   542,
    2361,  1366,  1367,  1995,   686,  3111,  4277,  2301,  2309,  1922,
    1925,  1927,  3112,   711,  1897,  3810,  3614,   544,  1937,  2524,
    2741,   929,   800,  1962,  4276,   804,  2313,  2314,  2315,  2323,
    2331,  2317,  1232,   930,  3831,  3832,  1233,  2125,  3508,  2851,
    4619,  2197,  4371,  1309,  4317,  1996,  2329,  2796,  1737,  2150,
    4143,   929,  4023,  2757,  2758,  3505,   884,   927,   887,   888,
     889,   890,   891,  1195,   893,   894,  4013,  2198,   896,   897,
     543,  4339,  2689,  3555,  1493,  1335,  4664,  4633,  1342,  4341,
    4126,   545,  4342,  4345,  5007,  2764,  4401,   927,  2946,  4343,
    2846,  5018,  4160,  1503,  4347,  3734,   720,  3662,  4828,  5019,
    3735,  3797,  2777,  3857,  4149,  2093,  3519,  5160,  3079,  4265,
    4287,  1302,  4072,  3663,  3582,  3582,  4709,  3583,  4160,  4160,
    4710,  4711,  1453,  4632,  1997,  1319,  4091,  2790,  2791,   828,
     829,   830,   831,   832,  2645,  2646,  2647,  2648,  2649,  2650,
    2651,  2653,  2655,  2656,  2657,  2658,  2659,  3423,  2405,  3208,
    3100,  2919,  1697,  4091,  4806,  1345,  1346,  2872,  2844,  2690,
    2625,  1844,  1845,  3345,  4737,  2346,  2405,  3731,  2633,  2635,
    5025,  2638,  2639,  3587,  3658,  4789,  4736,  1844,  1845,  1677,
     733,  5399,  4165,  3732,  4160,  4160,  3164,  5096,  3165,  3166,
    3119,  5101,  3205,  2261,  2405,  2266,  1630,  2272,  2422,  2272,
    -497,  3145,   872,  3664,   872,  3724,   873,  2272,   873,  3631,
    4718,  -497,  4720,  4487,  2298,  4730,  2261, -2071,  3359, -3390,
    4487,  3909,  5722,  2272,  2289,   736,  1481,  2293, -2071,  1844,
    1845,  3119,  4830,  2272,  2297,  3119, -3373,  2310,   796,  2689,
    2300,  4092,  2316,  2229,  4329,  1844,  1845,  1956,  4765, -2682,
    1844,  1845,  3035,  4067,  2272,  2261,  2261,  2327,  2328,  2405,
    2194, -2683,  5167,  2443,  2444,  5935,  4488,   779,  4092,   728,
   -2993,  4103,  2454,  4488,   796,  2988,  1435,  1844,  1845, -1249,
    1918, -2993,  4910,  4222,  2991,  1918,  1833,  1835,  1836,   820,
   -1249,  5103,   709,  4098,  5002,  1605,  4425,  4106,  1844,  1845,
    1879,  3119,  1597,  4302,  2514,   780,  2517, -2071,  3360,  1844,
    1845,  5105,  5128,  4288,  1610,  1611,   730,  2265,  1844,  1845,
     682,  2530,  2531,  2533,  1431,  1373,  1213,  4646,  5119,  4198,
    2534,  2535,  3582, -2477,  3778,  3119,  1846,  2547,  1847,  6000,
    2275,  4171,  1472,  2292,  1598,  1599,  1600,  1601,  3119,  5293,
    2296,  1685,  1846,  5363,  1847,  3119,  3119,  2282,  2282,  1844,
    1845,  2282, -2071,  3273,  1958,  2304, -2071,  2135,  2282,  5406,
    1648,  5893,  2968,  2447,  2282,  5781,  1738,  1924,  1432,   713,
    2286,  2286,  1844,  1845,  2286, -3377,  1844,  1845,   660,  4860,
   -2477,  2286,  5766,  4647,  1918,  5073,  3146,  2286,  1844,  1845,
    5152,  4615,  1844,  1845,  1846,  3361,  1847,  3189,  5976,  2865,
    1844,  1845,  3814,  1844,  1845,  4049,  5681,  3047,  2068,   940,
    1846,  1778,  1847,  4738,   752,  1846,  1402,  1847,  2033,  4074,
    1844,  1845,  3488,  4185,  4186,  1914,  4774,  2363,  3477,  1380,
     725,  1416,  2136,  2960,   633,  -707,  1416,   680,  1416,  1379,
     688,  3495,  1846,  2137,  1847,  1848,  -707,  2879,  1844,  1845,
    2138,   781,  2378,  2866,  1844,  1845,  3190,  1844,  1845,  4911,
    4189,  1848,   773,  1846, -2993,  1847,  3665,  4205,  1842,  4860,
    5527, -3376,  4648,   795,  1846, -2071,  1847,  1844,  1845,   712,
     675,   515,  2139,  1846, -3374,  1847,   510,  3119,     9,  4323,
    4324,  -805,  3213, -2477,  3226,  1480, -3375,  3408,  3409,  3410,
    3411,   671,  3962,  5723,  1844,  1845,  2324, -3380,   726,  4616,
    3963,  5153,  1918,  1848,  4789,  5174,   537,  4643,    34,   513,
    4512, -2071,  2029,  4695,  1846,  2276,  1847,   515,  4292,  1848,
    1844,  1845,   510,  5158,  1848,  5992,  5812,   697,  2193,  2961,
    1213, -2477,  2277,  2140,  1420,    19,  4775,  1846, -2477,  1847,
    3104,  1846,  1866,  1847,  1786,  4519,  5318,  -260,  2069, -2477,
     843,  1848,   700,  1846,   715,  1847,  1915,  1846,   868,  1847,
    1844,  1845,  1387,    41,  2141,  1846, -2477,  1847,  1846,   876,
    1847,  4861,  1848,  2448,    43,   539,   751,  5294,  1649, -2831,
    6001,  2970,  2102,  1848,    34,  1846,   546,  1847,  2110,  1161,
    2111,  1991,  1848,  2114,  2115,  2117,  2118,  5314,  2873, -2850,
    1923,  4050,  1928,  2278,   941,  5452,  1931,  1936,   901,  1227,
    1282,  1686, -3310,  1846,  5298,  1847,  1161,   871,  5991,  1846,
    1237,  1847,  1846, -3310,  1847,  3193,  3053,  1252,  3346, -3311,
    5544,  1403,  1185,  1848,   542,   875,  1965,  1161,  1867,    41,
   -3311,  1299,  1846,  1322,  1847,  5290,  3119,  2066,    34,   661,
      43,   843,   544,  4289,   843, -3394,  1848, -2851,  1844,  1845,
    1848,  4861,  1959,  2355,  5724,   664,  4789,    34,  1231,  1846,
    1818,  1847,  1848, -3310, -2351,  4265,  1848, -2071,  1822,  2457,
    2712,  4617,  1844,  1845,  1848,   701,  1235,  1848,   874,  2260,
   -3311,  4253,  5563,  4110,  1374,  1846,    39,  1847,  3478,   545,
    2241,  2736,   877,    41,  1848,   543, -2351,  2761, -2852,  2763,
    1918,  2458,  5311,  2699,    43,   664,   545,  1429,  6143,  3157,
    5993,  2772,    41,  2470,  2775,  1918,  5350,  2459,  2778,  2361,
    5052,    53,  1848,  2720,  5994,  1846,  2676,  1847,  1848,  1737,
     878,  1848,  3553,   664,  2170,  3418,  4128,  4129,  3734,  3646,
    1236,  3662,  2034,  3735, -3493,  2793,  2794,  2795,  1161,   797,
    2755,  1848,  3224,  3582,  2905,  4109,  3119,  3663,  1470,  2215,
    4160,  2460,  2197,   539,  3419,  2920,  4900,  1919,  6038,   868,
    3763,  1573,  1919,  1473,   546, -3394,  2156,   710,  1848,   827,
     876,  5053,  1577, -3390,  4831,  2428,  4104,  3089,  2198,  2461,
    1844,  1845,  2677, -2682,  3089,  4098,  1499,  5725,  2989,  5501,
   -3373,  5502,  3910,  3120,  1848, -2683,   734,  2365,  4489,  4115,
    3731,  5453,  4107,  4119,  4821,  4489,  3120,  2278,  2789, -3310,
    3351,  3352,   542,  1846,  4187,  1847,  3732,  3362,   871,   751,
    1574,  4781,  1833,  1835,  1604,  2279, -3311,  1608,  1844,  1845,
     544,  1252,   826,  4162,  1848,  1161,   875,  1846,  1576,  1847,
    5931,   737,  1631,  4325,   735,  2036,  1657,  3120,  1657,  1657,
    1657,  3120,  2406,  5616,  1657,  3593,  1657,  1663,  -497,  1663,
    1663,  1663, -2071,   539,  1957,  1663,   537,  1663,  4739,   513,
    2406,  1919,  3666,  3472,   546, -2071,  2462,   515,  2691,  4807,
    5618,  2438,   510,   543,   846,  1161,  3347,  3585,  3586,   874,
    1161,  1575,  2248,  2248,   545,  2224,  1681,  5632,  2406,  5633,
     545,  3196,  3759,  3760,   899,  3355,  5400,  2248,  3200,  3367,
    3368,  5407,  3371,  3372,  4649,  2215,  1362,  3120,   984,  5630,
    1161,  4490,   542,  1661,  3803,  1661,  1661,  1661, -2993,   929,
    1161,  1661,  1848,  1661,  5767,  1431,  5356, -1249,  5358, -3377,
     544,  5361,  1285,   828,   829,   830,   831,   832,  5366,  5367,
    5977,  3120,  4075,  2260,  3227,  1846,  1848,  1847,  3616,  4684,
    3086,  5462,  3191,  2406,  3120,   927,  4699, -3394,  3240,  3038,
    3241,  3120,  3120,  3242,   672,  3243,  1660,  2280,  1660,  1660,
    1660,  2457,  3101,   662,  1660,  3102,  1660,  1662,  4789,  1662,
    1662,  1662,  2451,   543,  2185,  1662,  3113,  1662,  5291,  1919,
    5500, -2477,  3274,  1846,   545,  1847,  3105,  4148,  2662,  3855,
    4392,  3856,  4709,  2458,  2353,  3065,  4710,  4711,  2637,  1161,
    1161,  1161,  1161,  2615,  2124,  1840,   470,  2276,  5134,  2459,
    1787,  1738,  3332,  1161,  3333, -3376,  1838,  3253,  5020,  5995,
    3256,  3343,  1213,  3344,  2277,  2691,  2508,  1738, -3374,  3823,
    5624,  3063,  3540,  3066,  4526,  2700,  3268,  4377,  1844,  1845,
   -3375,  2549,  3576,   702,  1416,  4820,  5040,  2103,  4277,  5043,
    3286, -3380,  2678,  2460,  1848,  3085, -2831,  5298,  2566,   665,
     664,  2574,  3940,  2576,  3941,  3090,  4276,  2580,  2581,  2582,
    4082,  2968,  5915,  4358,  2282,  2588, -2850,  3095,  5557,  4959,
   -2831,  2461,   470,  -707,  4545,  4431,  4730,  4432,   635,  4457,
    3661,  4458,   898,  3120,  3911,  3114,  2282,  2286,   844,  2282,
   -2850,  4463,  1848,  4464,  -115,  2776,  -115,  3232,  3605,   665,
    2282,  5942,  5943,  4503,  3786,  4504,  4984,  5600,  3233,  2286,
    5773,  5774,  2286,  2746, -2351,  3385,  4175,  4789,  3647,  3129,
     709,  2242,  2135,  2286, -2851,  3244,  1819,   665,  5564,  1844,
    1845,  3995,   751,  4670,  1823,  1387,   470,   843,  2073,   843,
    3047,  4265,  3979,  3794,  2989,  4673, -2351,   880, -2851,  1819,
    3730,  3787,  2000,  3245,  1453,   470,  1973,  3170,  2070,  3246,
    2759,  4169,  3248,  5772,   579,  1844,  1845,  3141,  2462,  2669,
    4130,  2280,  5054, -3218,  2621, -2852,  1738,  1919,  5044, -2795,
    1161,  4010,  3258,  2058,  4160,  1875,  1876,  1877,  1878,  4789,
   -2795,   664,  1919,  5535,  1286,  1634,  3394,  2136,  3534, -2852,
    3225,  2711,  2036,  1846,  4314,  1847,  5297,  3238,  2137,   929,
    6028,  2661,  5008,  2095,  6039,  2138,  4002,  2969,  4012,  1844,
    1845,  2715,  5491,  5388,  1453,  1844,  1845,  3059,  2952,  3648,
    3662,  2031,  5469,  2857,  5377,  3260,  3649,  5199,  5200,  5201,
    2679,  5646,  4280,  3519,  3650,   927,  3663,  2139,  3582,  3582,
    4654,  4655,  3120,  1213,  3797,  2947,  2974,  5256,  1840,  1387,
   -3310,  4905,  3052,  -119,  1213,  -119,  1890,  2108,  2109,  1838,
    1387,  1387,  5542,   877,  5719,  3264,  4339, -3311,  3669,  5110,
    2320,  2626,  2882,  2883,  4341,  1697,  2886,  4342,  4345,  4794,
    2970,  2893,  2894,  2895,  4343,  5125,  5126, -2772,  3734,  4347,
    2222,  4658,  4659,  3735,  1846,  2799,  1847,  2726,  2140,  2278,
     537,   878,  1161,   513,  5135,  5765,  5136,  3651,  1429,  3060,
     768,   515,  1848,  2841,  1992,  5498,   510,  2279,  1844,  1845,
    3068,  2748,  2749,  1252,  2751,  2752,  2753, -2795,  1410,  2141,
    1846,  4055,  1847,  1738,  2463,  2762,  6035,  3061,  5645,  2860,
    6036,  4094,   -72,  5137,  1161,  3069,  1161,  3972,  2215,  2265,
    2774,  4047,   753,  4352,  4729,  4354,   705,   706,  3535,  3053,
    3731,  2627,  3120,  3265,  4315,  2946,  4056,  2223,  3652,  3737,
    2243,  4291,  5138,  -111,  5558,  -111,  3732,  4795,  2948,  2001,
    4686,  1412,  2848,   636,  1846,  3255,  1847,  5416,  3506,   756,
    1846,  2964,  1847,   929,  2197,  3992,   824,  6079,  3670,   754,
    4190,  5631,  5654,  3507,  5656,  2889,  2892,  2169,  4546,  1503,
    2169,  2169,  5583,  1848,  3609,  3610,  2690,  5661,  5647,  4207,
    2198,  5481,  2876,  4004,  3801,  5903,  3422,  5905,  5906,   927,
    3424,  2880,  2032,  3469,  3062,  3788, -3218,  1294,  3871,  2937,
    2975,  3398,  3399,  6099,   709,  4012,  3668,  2321,  3450,  1848,
    3461,  5371,    16,    17,  3462,  5532,  3251,  2244,  2628,  2245,
   -2791,  1710,  1711,  1712,  1974,  3003,  4316,  3467,  2760,  3574,
    5470, -2791,  2925,  2002,   665,  3575,   851,   852,  3536,   581,
    3474,  3475,  4083,  4046,   579,  5360,  4011,  5483,  2003,  1635,
    6032,  6033,  2989,  1846,  2887,  1847,  2689,  4850,  4851,  4852,
    4853,  3931,  4281,  1848,  1161,  3272,  1161,  4399,  5139,  1848,
    3386,  5009,  1891, -2031,  3148,  3149,  5756,  5758,  4018,  1763,
    3395,  1844,  1845,  2059,  5559,  2959,  1993,   936,  1844,  1845,
    5785,  3946,  3947,  4170,  2075,  5537,  4036,  3996,  5800,  5983,
    5984,  2472,  1161,  5987,  5140,  5352,  1844,  1845,  3814,  2246,
    3669,  4175,  3966,  3284,   579,  1161,  1161,  4531,  4532,  4533,
    4534,  1161, -2772,  3997,  1252,  1161,  1161,  1161,  1844,  1845,
    2727,  5419,  5409, -1481,  3961,  1252,  1161,  1161,  1844,  1845,
     637,  5257,  1161,  2721,  1161,  1161,  1161,  1161,  1161,  1383,
    1161,  1840,  5824,  3939,   515,  3942,  3150,  5481,  2661,  3185,
    3672,  1161,  1838,  1161,  1923,  5686,  1161,  1161,  5441,  1161,
    1161,  1161,  1848,  1161,  1161,   665,   879,  5764, -2791,  1844,
    1845,  1306,  5202,  5768,  6046,  1844,  1845,  2247,  1161,  1161,
    1161,  1161,  1161,   802,  1161,  1161,  1161,  1844,  1845,  1161,
    1161,  1161,  1161,  1161,  1161,  1161,   681,  1161,  1161,  1161,
    1161,  1161,  1161,  4687,  1161,  1161,  6057,  1161,  1161,  1161,
    1161,  1161,  1161,  1161,  1187,  5026,  1161,  1161,  1161,  1161,
    3182,  1161,  1161,  1161,  3183,  1161,  2229,  1161,  4057,  1161,
    3670,  2630, -2031,  1161,  1161,  1161,  4208,  4188,  1161,  1161,
    1161,  1161,  1161,  2280,  1161,   872,  1846, -2700,  1847,   873,
    3070,  1161,  4077,  1846,  1582,  1847,  2616,  4012,  1161,  1161,
    1161,  1161,  1844,  1845,   515,  2968,  5866,  1844,  1845,  1161,
    1161,  4191,  1161,  1161,  3496,  4058,  1161,  1161,  1161,  1161,
    1161,  1161,  1161,  1161,  1161,  1161,  1161,  1161,  1161,  4339,
    4362,  1161,  3815,  1846,  3661,  1847,  5551,  4341,  2683, -2769,
    4342,  4345, -2676,  1846,  3671,  1847,  3534,  4343,   880,  3370,
     580,  5427,  4347,  1844,  1845,  5046,  1844,  1845,  4111,  4700,
    5894,  5895, -2767,  4370,  1844,  1845, -2770,  1844,  1845, -2768,
     937,  2939,  1161,  3292,  1738,  3252,  4879,  1161,  4091,  4059,
    1844,  1845,  2248,  3065,  1846,  1643,  1847,  1161,  1844,  1845,
    1846,  2305,  1847,  4364,  4180,   705,   706,  5573,  3047,   581,
    1844,  1845,  1846,  3730,  1847,  1848,  5603,  1844,  1845,  5824,
    2087,  5912,  1848,  4218,  3291,  5672,  5523,  6019,  6020,  5528,
    5529,  5867,   803,  4060,  5027,  2779,  3487,  3488,  1844,  1845,
    1848,   938,  2821,  2567,  2897,  2568,  1844,  1845, -2031,  4296,
    5920,  4298,  4299,  5071,  5071,    16,    17,  4304,   705,   706,
   -2795,  3059,  1848,  4565,  1161,  4312,  5215, -2795, -2795,  3145,
    4319,  1347,  1848,   854,   855,  1943, -1136,  3339, -1136,   581,
    4322,  1330,  3672,  5881,  3294,  5883,   805,  1846,  5060,  1847,
    2722,  3356,  1846,  3793,  1847,  2732,  1161,  2358,  1161,  6093,
     806,  5064,  4701,  4092,  2723,  2194,  5061,  3911,  3911,   843,
    2629,  3911,  3911,  1848,  4564,  1677,  2203,  3911,  3911,  1848,
    3297,  5674,  1844,  1845,  5252,  6106,  3535,  3446,  5716,   772,
    5477,  1848,  1161,    34,  2733,   843,  2242,  3489,  1846, -2479,
    1847,  1846,  3673,  1847,  2970,  5402,   825,  5410,  4697,  1846,
    6052,  1847,  1846,  3060,  1847,  1439,  3381,   773,  1348,  1349,
    5065,  4541,  4542,  5196,  4880,  1846,  2969,  1847,  6034,  4017,
    1844,  1845, -2700,  1846,  3298,  1847,  4550,  5614,  5792,  1583,
    3299,  3067,  3415,   929,  2940,  1846,  2964,  1847,    41,  4061,
    4062,  4063,  1846,  2088,  1847,  3404, -2479,  5651,  3443,    43,
    5028,  5306,  3444,  4229,  3533,  5779,  1848, -1481,  1844,  1845,
    5574,  1848,  2822,  1846,  1387,  1847,  2380,  1161,  1944,   927,
    1387,  1846,  1644,  1847, -2769,  1844,  1845,  4066,  5721,  2381,
     751,  1945,  3482,  3427,  5675,  1387,  4864,  3053,  2661,  5913,
    5907,  5908,  3737,  2410,  5865,  3052,  3536, -2767,  1161,  3567,
    2702, -2770,  3568,  2410, -2768,  3736,  3573,  1848,  5307,  3366,
    1848,  2306,  1677,  2703,  3146,  6053, -2449,  2973,  1848,  2197,
    2359,  1848,  5066,  2358,  4383,  4384,  4385,  4386,  3062,  2169,
    4363,  1844,  1845,  3300,  1848,  1844,  1845,  2382,  4577,  1946,
    2734,  2248,  1848,  1844,  1845,  2198,  4344,  1846,  1947,  1847,
    1448,  3515,  4346,  3594,  1848,  5873,  4944,  4945,  2933, -2479,
    5477,  1848,  3945,  1844,  1845,   779,  5614,  5530,  1350,  5866,
    2066,  2382,  2066,  2964,  3457, -1541,  3988,  3989,  1866,  1844,
    1845,  1595,  1848,  3578,  1953,  3498,  3460,  3579,   886,   567,
    1848,    16,    17,  1844,  1845,  1846,  5067,  1847,  1844,  1845,
    4003, -2791,  2569,   780,  2363,  2570,  4114, -2479, -2791, -2791,
    4118,  1844,  1845,   779, -2479,  5326,  1336,  5327,  2974,   834,
    3991,   539,  4502, -1541,  4505, -2479,  5586,  2248, -1541,  5804,
    1161,  1161,   546,  1846,   836,  1847,  1844,  1845, -2530,  1844,
    1845,  1273, -2479,  1844,  1845,  2243,  4353, -1136,  6117,  4160,
    1846,   780,  1847,  2957,  3099,  5071,  3428,  2957,  6025,  2170,
    2358,  5997,  2170,  2170,  3611,  2411,  1848, -1541,  2331,  5308,
    5597,  4105,  4407,  -923,  1867,  2411,   806,  6026,  2215,  1347,
     542,  5078,  4405,  4406,  5867,  1844,  1845,  2410,  4160,  4160,
    3614,  4412,  1868,  4413,  6063,  4415,  2359,  2156,   544,  1325,
    1844,  1845,  1387,  1948,  1337,  2169,  1846,  1161,  1847,  4366,
    1846,  2412,  1847,  3562,  1848,  3565,  6121,  3178,  1846,  1449,
    1847,  3570,  3572,  3661,   709,  1161, -2530,  2383,  3188,  1949,
    2934,  5531,  2244,  4369,  2245,  4729,  3303,  1450,  1846,  5145,
    1847,  1954,   868,  3304,   539,  1844,  1845,  1161,  1424,  1161,
    2457,   543,  1848,   876,  1846,   546,  1847,  1161,  1161,   781,
    5805,  2704,   545,  2964,  5715,  5950,  1348,  1349,  1846,  1848,
    1847,  6061,  6061,  1846,  5248,  1847,  3181,   901,  1273,   684,
   -2530,  4012,  2458,  3305,   691,  4921,  1846,  1326,  1847,  4923,
    6064,  3236,  2691,  3323,  3186,  5249,  6118,  4160,  2459,   515,
     739,   871,  6122,   542,  4692,  4693,  4694,   781,  1844,  1845,
    1425,  1846,  2975,  1847,  1846,  1447,  1847,  4152,  1846,   875,
    1847,   544,  4200,  4201,  2246,  1848,  4202,  4203,  4204,  1848,
    2671,  6090,  3143,  2359,  3328,  6104,  6105,  1848,  5806,  5759,
    3331,  1327,  2460,  6065,  1677,  2215,  2974,  3184,  2116,  1161,
    1161,  1161,  3338,  2440,  5965,  5866,  4960,  1848,  3187,  2411,
    1846,  5572,  1847,  3730,  2672,   847,  1844,  1845,   848,  3630,
    2461,   892,   874,  1848,   543,  1846,   929,  1847,   740,  5184,
    5636,   943,  5187,   545,  5189,   545,  5842,  1848,  3790,  5188,
    1410,  5190,  1848,  5734,  4153,  2248,  2395,  2272,  4812,  4815,
    5653,  4818,  2247,  4411,  1860,  1848, -1170,  2006,  5637,  4416,
    1844,  1845,   927,  1164,  3792,  2453,  5209,  5760,  5210,  5211,
    1846,   470,  1847,  4132,  3858,  1161,  1761,  3349,  1950,  1166,
    1848,  6021,  3833,  1848, -2449,  3863,  1320,  1848,  1411,  2440,
    2673,  4012,  2767,  1412,  1953,  4798,  1161,   705,   706,  1840,
    1161,  1161,  4799,  1161,  1161,  1844,  1845,  4012,  4012,  2007,
    1838,   674,  1161,  5158,  1161,  5638,  3978,  2462,  1844,  1845,
    5867,  1844,  1845,  5591,  1497,  3133,  4133,  5484,  4429,  1848,
    5671,  4430,  1413,  1846,  5485,  1847,  2768,  1844,  1845,  4443,
    3259,  2964,  1161,  3897,  1848,  1923,  5206,  1923,  5083,  3446,
    2307,  2513,  2308,  4952,  1951,  4445,  1161,  1844,  1845,   705,
     706,  5843,  1952,  4460,  1861,  5075,  1595,  5077,  1603,  1161,
    5080,  2674,  1161,  5084,  3908,  4477,  5087,  5088,  1851,  1862,
    4871,  4872,  4478,  1844,  1845,  5870,  5357,  1969,  5877,  1848,
    2975,  1846,  3439,  1847,  1852,  3438,  1161,  1844,  1845,  5486,
    1844,  1845,  5369,  5222,  5672,  1181,  3448,  4887,  1286,  3261,
     705,   706,  5127,   850,  3458,  1844,  1845,  1970,  1161,   709,
    3443,  4036,  3463,  1853,  3444,  3954,   895,  4912,  2358,  1854,
    2969,  1463,  4914,  1226,  4469,  1846,  5933,  1847,  1288,  5937,
    6147,  5378,  3737,  5380,  4918,  1453,  1234, -2479,  4849,  4925,
   -2292,  1954,  1848,  3955,  3442,  5922,  1863,  1464,  1305,  1161,
    5120,  5797,  4470,  4558,  1844,  1845,  1855,  3466,  1844,  1845,
    1738,  2769,  1844,  1845,  1306,  1844,  1845,  1301, -2292,  4359,
    1846,  2906,  1847,   515,  4942,  3262,  2907,  1844,  1845,  5797,
    2908,  1844,  1845,  1846,  6047,  1847,  1846,   843,  1847,  1465,
    5674,  1387,  5735,  2058,  1311,  1387,  5870,  5121,  4560,  5736,
    1848,  3532,  1846,  5877,  1847,  4606,  1320,  1232,   721,  2440,
    1197,  1233,  4527,  3052,  5737,  3445,  3923,  1885,  3736,  2440,
    1314,  4563,  1846,  3285,  1847,  -423,  3447,  1844,  1845,  1918,
    2440,  3924,  3080,  4337,  1844,  1845,  1273,  5951,  4961, -2449,
    3247,  5592,  5593,  6084,  1848,  1894,  6086,  1323,  1846,  2277,
    1847,  5228,  2136,   751,  5142,  3247,  4024,  1332,  2299,  5144,
    2909,  3288,  1846,  2137,  1847,  1846,  5240,  1847,  5122,  1343,
    2916,  2516,  1198,  5095,  1844,  1845,  3523,  3524,  3290,  1161,
    1846,  2532,  1847,  6103,  1334,  1844,  1845,  6069,  1466,  1848,
    4171,  2359,  2546,  1161,  1362,  1161,  5269,  2325,  2326,  4899,
    3623,  1341,  1848,  5675,  1357,  1848,  5334,  3627,  3628,  1873,
    1874,  1875,  1876,  1877,  1878,  5870,  5877,  5335,  1844,  1845,
    1361,  1848,  1844,  1845,  5426,  1844,  1845,  3657,  1467,  1846,
    2902,  1847,  2903,  1846,  3293,  1847,   772,  1846,  3301,  1847,
    1846,  1848,  1847,  5594,  5738,  1363,  3302,  1844,  1845,  4840,
    3364,  1161,  1846,  3525,  1847,  1860,  1846,  5739,  1847,  3120,
    1368,  2212,  2213,  2917,  1844,  1845,  3308,  1848,  1844,  1845,
   -2524,  2170, -2524,  5032,  1370,  1183,  5033,  5740,  4854,  5097,
    4855,  1848,  3309,  1189,  1848,  5102,  5104,  5106,  1387,  1284,
    1371,  4144,  5111,  5112,  2141,  2253,  3313,  1372,  5117,  1848,
    2641,  3314,  1846,  1407,  1847,  1923,  5124,  3379,  1445,  1846,
    5129,  1847,  5263,  5264,  3315,  3380,   676,  5097,  5362,  5595,
     676,  5143,  5097,  1844,  1845,   676,  1844,  1845,  2661,  1923,
    4823,  4825,  4825,  3379,  4825,  4101,  3771,  1439,  3249,  3321,
    2511,  4948,  4823,  4823,  4825,  4825,  3322,  1447,  1848,  1846,
    1471,  1847,  1848,  1199,  1200,  1460,  1848,  3617,  3618,  1848,
    1846,  1477,  1847,  1201,  1478,  1861,  2276,   820,  1844,  1845,
    1479,  1848,  5173,  4012,  3629,  1848,  5034,  1487,  4192,  4791,
    1862,  2287,  1202,  2277,  3655,  3656,  1844,  1845,  3326,  3289,
    1745,  2036,   872,  1846,  1484,  1847,   873,  1846,  1491,  1847,
    1846,  1273,  1847,  3327,  1375,  4577,  1498,  4867,  1760,  4012,
    2642,   705,   706,  1578,  1764,  1765,  5741,  1376,  1844,  1845,
    2086,  1848,  1846,  1579,  1847,  2643,  2091,  2092,  1848,  1580,
     741,   742,   515,  2343,  2133,  2215,  2215,  2215,  2215,  1846,
    1581,  1847,  4827,  1846,  4829,  1847,  1584,  2170,  3329,  4955,
    3719,  3720,  3721,  3722,  4834,  4835,  1273,  1863,  5035,  1595,
    1657,  1657,  1657,   820,  4696,  3120,  1161,   743,  1848,  1161,
    1614,  1663,  1663,  1663,  3295,  3306,  3296,  2036,  1161,  1848,
    2700,  2700,  2700,  2700,  1377,  5255,  3312,  1161,  2036,  1161,
    1616,  1161,  5769,  1161,  1161,  1161,  1161,  1161,  1161,  1864,
    1161,  1846,  2644,  1847,  3316,  3317,  2036,  2036,  1161,   744,
    1161,  3336,  1848,  1161,  1161,  1161,  1848,  2375,  2376,  1848,
    5714,  2377,  1161,  1161,  1161,  1624,  1161,  4363,  1161,  3318,
    1161,  2036,  1161,  1622,  1161,  4437,  1625,  1661,  1661,  1661,
    1633,  1848,  1161,  1846,  1161,  1847,  1161,  1161,  1161,  1161,
    1161,  5283,  5060,  1161,  1161,  1161,  1627,  1161,  1848,  1636,
    1161,  1846,  1848,  1847,  1658,  1637,  1668,  1669,  1670,  3350,
    1203,  1639,  1671,  1161,  1674,    16,    17,  4501,  1161,  4612,
    1638,  1161,  4480,  1161,  1161,  1161,  1641,  3324,  1161,  2036,
    1660,  1660,  1660,  1846,  1161,  1847,  4832,  4833,  4953,  1161,
    1647,  1662,  1662,  1662,  3439,  2598,  2599,  3438,  1161,  1453,
    1453,  1453,  1453,  4424,  1161,  3746,  1161,  3749,  3448,  1161,
    1848,  1698,  1840,  1387,  1387,  3943,  1678,   515,  1468,  1161,
    1860,  1161,  1699,  1838,  3381,  1700,  1161,  1866,  1705,  1378,
    2288,  1527,  1856,  1857,  1858,  1706,  1919,  1707,  4949,  4950,
    4540, -2292, -2292,  2457,  1355,  1356,  2974,  1359,  4427,  1360,
    5440,  5229,  1848,  5374,  2174,  2950,  3442,  2176,  2176,  1708,
     539,  4428,  1161,   537,  4433,  3219,   513,  4967,  2278,  5231,
    1848,   546,  1709,  5233,   515,  2458,  4723,  1713,   745,   510,
    4438,  1715,  1716,   487, -3455,  3753,  2279,  3754,   488,  1717,
    1161,  4154,  1252,   540,  1227,   746,  5216,   489,  1453,   490,
    4439,  2951,  1848,  5390,  3773,  1237,  -949,  2066,  3736,  3755,
    3757,  3754,  3758,  4812,  3799,  4815,  3800,  4818,  2265,   542,
     747,  1161,  4071,  1867,  3015,  3016,  4440,  3445,  1756,  5687,
    1861,  4038,  4724,  1718,  1719,  4155,  3774,   544,  3447,  3028,
    4441,  1868,  2952,  4442,  3821,  1862,  3822,   515,  1844,  1845,
    1161,  4344,  1161,  1231,  1720,  3506,  5688,  4346,  4450,  4634,
     748,  5408,  4029,  4156,  4030,  1721,  1204,  1205,  1206,  1207,
    3507,  1235,  4122,  2487,  4123,  5884,   705,   706,  1722,  5429,
    4183,  2950,  4184,  1866,  4330,  3975,  4331,  1723,   705,   706,
     543,  2964,  1724,  1844,  1845,  1725,  3775,  1869,  1870,  5095,
    4451,   545,  3296,  1726,  1727,    16,    17,  4456,  1844,  1845,
    3223,  4459,  4454,  2974,  2036,  4465,  1730,  3837,  4466,  4461,
    1161,  4462,  1863,  1740,  3776, -1170,  1804,  2951,  5566,  1810,
    4467,  5581,  3838,  1881,  4475,  1236,  4725,  3030,  3031,  3263,
    2975,  1161,  1741,  2488,  -922,  4200,  4201,  1742,  1880,  4202,
    4203,  4204, -1888,  1743,  3040,  1746,  3040,  4641,  3839,  4468,
    4157,  2036,  1747,  1748,   757,  2953,   705,   706,  2952,  4161,
    3840,  5689,  4723,  1844,  1845,  5690,  2272,  2954,  2358,  1867,
    4476,  1749,  1750,  4176,  4177,  4178,  4179,  4479,  4181,  4182,
    3841,  4472,  4801,  4473,  4802,  4161,  4161,  1868,  1751,  5671,
    1864,  3015,  3016, -2449,  4927,  5178,  2036,  5179,  2489,  1752,
    2490,   758,  1866,  1753,  3040,  2491,  3028,  1754,  2135,  4279,
    3726,  3777,  3842,  1846,  3843,  1847, -1887,  4483,  4724,  1755,
   -1200,  1161,  5180,  1757,  5181,  2011,  4300,  4301,  4496,  4303,
    1758,  4305,  4306,  4307,  4308,  4309,  4310,  4311,  5182,  4313,
    5183,  3506,  4318,  1869,  1870,  5223,  4321,  2036,  2964,  1759,
    2964,  4161,  4161,  1882,  1766,  5748,  3507,  1767,  1846,  5751,
    1847,  5221,  5238,  5672,  5239,  5227,  5587,  1883,  5236,  1573,
    2492,  2955,  5246,  1846,  2036,  1847,  5259,  5274,  5260,  5275,
    1577,  2953,  1768,  2136,  6041,  1769,  1273,  5673,   539,  2215,
    5237,  1866,  1770,  2954,  2137,  3836,  1771,  2975,  1867,   546,
    4865,  2138,  4706,  3961,  3030,  3031,  1884,  5241,  2964,  2700,
    2700,  5242,  1772,  2493,  1979,  5285,  1868,  5286,  5325,  5691,
    4123,  3099,  4163,  4164,  1773,  4166,  4168,  1774,  1574,  3041,
    -922,  3041,  1848,  2139,  5456,  2358,  4567,  2358,  1846,  1886,
    1847,  2359,  5560,  2956,  5561,  1775,  1576,   542,  4878,   759,
    1161,  5601,  2280,  5602,  1888,  5605,  1657,  5602,  5687,  5674,
    2169,  1776,  5817,  1161,  5422,   544,  1161,  1663, -2257,  5575,
    3844,  1779,  1869,  1870,  5634,  1780,  4123,  1848,  5635,  5747,
    4123,  5602,  3845,   760,  5802,  5688,  5803,  1867,  3042,  3041,
    1161,  1161,  1848,  1781,  2140,  2358,  5833,  2955,  5834,  1575,
    1226,  5864,  5844,  2494,  5845,  1868,  1617,  1350,  5863,  5581,
    4184,  5650,  1782,  1234,  2495,  1161,  4327,  1161,   543,  1161,
    4928,  1161,  1844,  1845,  5712,  2141,  5898,  3954,  5260,   545,
    1783,   566,  5838,  1661,    16,    17,  6004,  1784,  1453,  1453,
    5692,  5506,  5507,  1161,  5509,  1785,  3042,  1677,  1788,  1003,
    1701,  1789, -2699,  1273, -1170,  1273,  1790,  1848,  1791,  1844,
    1845,  1869,  1870,  1618,  1161,  1161,  1619,  1792,     4,  2956,
    1793,  1161,  5675,  1161,  1794,  1161,  5780,   946,  1844,  1845,
    1161,  1010,  1892,  5982,  1232,  4976,  1660,  3846,  1233,  3847,
    5986,  1866,  5602,  1620,  3043,   705,   706,  1662,  4706,     8,
    5689,  1621,  1795,  1796,  5690,  1866,  4444,  1797,  2359,   567,
    2359,  1798,  4537,  1273,  4344,  1844,  1845,  4726,  1161,  1161,
    4346,  1799,  2476,  2477,  2478,  2479,   947,  1800,  5671,  1844,
    1845,  4452,    14,  1161,  5988,  5059,  5602,   948,  5989,  1801,
    5602,  1022,  1802,  1893,  5070,  3282,  3723,  4434,  1803,  1844,
    1845,    18,  3043,  1805,  1161,  6007,  1806,  6008,  1844,  1845,
    5846,  6016,  6044,  6017,  5602,  1864,   949,  1807,  2359,  1034,
    6045,  5079,  5602,   950,  4574,  1808,  2480,  2481,  2482,  6048,
    1809,  5602,   515,  1844,  1845,  1903,  6051,  1867,  5260,  5004,
      23,  6085,  6134,  5602,  6135,  1811,  1812,  1846,  1813,  1847,
    1814,  1867,  5672,  1815,  1816,  1868,  1871,  1872,  1873,  1874,
    1875,  1876,  1877,  1878,  1817,   951,  1820,  4279,  4279,  1868,
    5641,  4635,  5642,  5643,  1821,  4727,  5673,  1824,  3072,  1825,
    2483,  2484,  4144,  1826,  1846,  3885,  1847,  1827,  1828,  5693,
    1829,  1830,  3848,  1831,  3887,  5838,  1887,  1904,  3087,  1905,
    1161,  1980,  1906,  1846,  6146,  1847,  1913,  3092,  5691,    31,
    1161,  1869,  1870,  3094,   952,   953,  1052,  4553, -2733,  3889,
   -2734,  3103,  1161, -2698,  1161,  1869,  1870,  1938,   954, -2730,
   -2728,  4192, -2732,  3115, -2727, -2731,  3117,  5944, -2725, -2729,
    1846,  1941,  1847,  1942,  1960,  1981,  1961,  1982,  5674,  4554,
    5687,  2485,  1411,  5823,  1846,  1975,  1847,   622,  1976,  1977,
   -1136,  1978, -1136,  4726,  2169,  2169,  1848,  1998,  5717,  5718,
    1999,  2004,  2010,  2016,  1846,  2067,  1847,  5688,  2023,  5676,
    2036,  5082,   679,  1846,  2077,  1847,   679,    42,  2079,  2194,
    2083,   679,   986,   761,   694,  2089,  2090,  2096,  2097,  5118,
    3849,  2099,  2101,  1848,  2105,  2121,  2122, -2257,  1846,  4555,
    1847,  -172,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,
    2123,  2133,  1848,  2486,  2144,  2145,    16,    17,  4792,    75,
    2148,  1003,  2158,  6024,  2161,  2171,  2172,  4556,    16,    17,
    2193,  1983,  6012,  4217,  2194,  4279, -1170,  2200,  5191,  3850,
     955,  2204,   714,  2206,  2209,  2210,   651,  2214,  2226,  1848,
    1008,  5675,  2230,  1010,  2238,  2255,  2258,  2259,  1844,  1845,
    4455,  4727,  3851,  1848,  2260,  2269,  2273,  2265,  6058,  1014,
    1015,  5385,  2295,   762,  6128,  2302,  2311,   705,   706,  2318,
    1984,  2330,  5689,  1848,  5168,  2319,  5690,  2333,  6138,  2335,
    2337,  2343,  1848,  2347,  6128,  2351,  3771,  4161,  2362,  2349,
    6138,  2354,  2368,  2369,  2371,   719,  2372,  2373,  2403,  2487,
    5671,  4221,  2416,  1022,   956,  2394,  2418,  1848,  2419,  2421,
    2420,  2423,  2424,  2426,  4557,  2427,  2431,  2439,  2440,  1985,
    2456,  3955,  1028,  1873,  1874,  1875,  1876,  1877,  1878,  5351,
    1033,  1034,  5354,  5355,  1161,  2449,  2467,  2471,  4732,    16,
      17,  4735,  2499,  2510,  4741,  4742,  4743,  4744,  2511,  4746,
    4747,  4748,  4749,  2521,  4751,  4752,  2512,  4754,  6012, -1170,
    2525,  4758,  4224,  4225,  4226,  4761,  4762,  4763,  4764,  2488,
    4766,  4767,  2528,  2529,  5672,  2583,  4772,  4773,  2551,  2589,
    4777,  4778,  2593,  4677,  4678,  4227,  2603,  4679,  4680,  1161,
    1161,  2614,  1161,  4681,  4682,  2618,  2636,  2640,  5673,  2667,
     705,   706,  2668,  1161,  1161,  1161,  5279,   564,  5693,  1986,
    4228,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1161,  1050,
    1161,  1508,  1161,  1846,  1161,  1847,  2693,  1051,  1052,  1053,
    5691,  1987,  2692,  5671,  2489,  2694,  2490,  1161,  1161,  2697,
    2457,  2491,  4230,  2698,  4231,   957,  2706,  4888,  2710,  2713,
    2717,   727,   779,  2742,  2744,  2135,  2745,  2765,  2780,  4889,
    2781, -1136, -1541,  4232,  1161,  2782,  2783,  2785,  2787,  4537,
    5674,  1161,  2458,  2786, -2304,  2802,  2806,  2805,  2813,  4890,
    1161,  2814,  4234,  2816,  2815,  2817,  2824,  2825,  4154,  4235,
     780,  2826,  4946,    16,    17,  5816,  2835,  2974,  5676,  2836,
    1923,   731,  2837,  2838,  4236,  2839,  2492,  5672,  2843,  2840,
   -1541,  1227,  2842,  4891,  4237, -1541,  2849,  2850,  2853,  2854,
     872,  2858,  1237,  1161,   873,  2863,  2870,  1161,  2874,  4241,
    2136,  5673,  4155,  2896,  2912,  2898,  2899,  2900,  3040,  2901,
    2904,  2137,  1848,  2913,   515,  5433,  2922,  2929,  2138,  2493,
    2914,  2926,  2930,  5434, -1541,  2927,  2936,  2938,  2941,  2942,
    4156,  2949,  2972,   565, -2715,  4983,  2987,  3004,  5702,  2995,
    1231,  2996,  3000,  3005,  3037,  3001,  3054,  3056,  3083,  2324,
    2139,  -924,  3093,  5675,  4704, -2449,  3109,  4245,  1235,  3080,
    4279,  5623,  2170,  3589,  3116,  3127,  3126,  4246,  3131,  1413,
    3135,  3138,  4892,  5674,  3726,  3151,  3141,  3144,  5522, -3488,
    1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  3156,  3176,
    3197,  3198,  3220,   640,  1871,  1872,  1873,  1874,  1875,  1876,
    1877,  1878,  3230,  3065,  4247,  3215,  3217,  3218,  3237,  2494,
    -924,  2140,  2964,  4358,   758,  5047,   781,  4248,  5927,  6110,
    2495,  3229,  1236,  3231,  3234,   872,  3235,  4157,  3250,   873,
    3254,   793,  5076,  3506,  3247,  3257,  3266,  3267,  3269,  4893,
    3270,  3342,  2141,  3358,  3376, -1678,  5092,  3363,  3507,  3271,
    3275,  3283,  5964,  3287,   566,  3369,  3307,  3310,  4250,   641,
    3311,  2975,  3320,  5113,  4251,  3330,  3334,  3590,   799,   801,
    3335,  3337,   801,  3341,  3354,   810,   816,  2135,  5114,  5115,
   -1857,  5131,  1878,  5132,  5133,  3378,  5675,  3385,  3397,  3392,
    1786,  1818,  1822,  3041,  5130,  3403,  3405,  5432,  3401,  2358,
     986,  3406,  3412,  3420,  3421,  3425,  3426,  3429,  3432,  3433,
    3430,  4279,  3464,  3431,  4705,  3455,  3434,  3468,  5161,  3476,
    5693,  3480,  -924,  4256,  1161,  1161,  3513,  3479,  3541,  3545,
    4257,  3512,   567,  3543,  3544,  3549,   642,  3548,  3577,  1003,
    3584,   816,  3588,  3602,  3608,  3612,  3615,  3619,   515,   643,
    3620,  3621,  2136,  3622,   816, -3488,  4894,  3624,  4895,  3677,
     810,  4258,   759,  2137,  3680,  3625,  3626,  3683,  1008,  5192,
    2138,  1010,   513,  3687,  3693,  3690,  4259,  4260,  3717,  3694,
     515,   568,  3695,  3742,  1184,  3725,  3632,  1014,  1015,  4261,
     810,  3696,  -924,  1229,  3744,  4704,  -924,  3743,  3697,  3698,
    3699,  3700,  2139,  1161,  3701,   872,  1298,  3702,  3703,   873,
    5676,  3704,  3705,  3706,   810,  4656,   644,  1273,  3707,  3718,
     872,  5089,  3708,  3709,   873,  3750,  3710,  1317,   810,   569,
    5435,  1022,  3751,  5436,  1167,  3711,  3712,  3745,  5745,  3713,
    3714,  1168,  5578,  5116,  3715,  3716,  3762,  5796,  5628,  2135,
    1028,  -924,  5001,  3749,  3761,   758,  3781,  1169,  1033,  1034,
    1364,  1161,  3783,  2140,  3784,  3746,  3771,  1170,  1171,  1172,
    3747,  2248,  2359,  3787,  3506,  5796,   793,  1173,  3796,  1161,
    1161,  3802,  3804,  3806,  3812,  3807,  3808,  3805,  3809,  3507,
    4706,  3816,  3817,  1436,  2141,  3819,  3818,  1161,  3826,  3860,
    3859,  1443,  3861,  3873,  3872,  4792, -1896,   810,  4328,  1459,
    4896,  4897,  1161,  3874,  3880,  3893,  2170,  2170,  6142,  3919,
    3932,  3950,  3934,  3935,  2136,  3920,  3958,  3951,  3967,   810,
    2405,  4279,  3969,  4279,  3976,  2137,  3957,  3959,  1483,  3973,
    3980,  3386,  2138,  5676,  5317,  3981,  3982,  1050,  3983,  3993,
     793,  1161,  1459,  1161,  5342,  1051,  1052,  1053,  3987,  5345,
     872, -2071,  3994,  -924,   873,  2727,  2726,  4001,  4006,  3120,
    4015,   645,  5343,  4031,  2139,    43,  4042,  4045,  3633,  4041,
     570,  4048,  4078,  4053,   571,  5745,  1592,  4660,  1594,  4054,
    4081,   801,   801,   801,   801,  1602,  1459,   646,   810, -2071,
    4079,  4085, -2071,   759,  4086,  4112,  4113,  4116,  4117,  5796,
   -2071,  4142, -2071, -2204,  4195,  4150,  5368,  4151,  1174, -2071,
    4282,  4196,  4197, -2071,  3634,  4286,   572,  4326,  4294,  4351,
    4360,  4295,  1175, -2071,  4357,  2140, -2071,  -924,  4297,  4367,
   -2071,  4361, -2071,  5375,  4372,   647,  4375, -2071,  3136,   793,
    4379,  1667,  4380,  4381, -2071,  4388,   573,  4393,  4400,  1672,
   -2071,  1675,  4402,  4409, -3488, -2071,  2141,  4417,  4898,  4410,
    4414,  4418,  4419,  5433,  4471,  4420,  1684,  4484,  2661,  4494,
    4482,  5434,  4495,  4499,  4500,  4508, -2071,  1573,  3594,  4510,
    4511,  4520,  4521,  4524,  4518,  4522,  4525,  5392,  1577, -2071,
    4529,  4528,  4543,  4530, -2071,  4707,  3635,     4,  4544,  4561,
    4547,  4567,  4566,  4570,  6139,  4568,   946,  4571,  2476,  2477,
    2478,  2479,  4572,  1161, -2071,  4573,  4578,  4589,   795,  4581,
    4607,  4706,  4587,  1176,  4609,  4608,   515,  1657,     8,  4610,
    4611,   -73,  4614,  4620,  4637, -1984,  1574, -2071,  1663, -1989,
    4668,  4671,  1161,  4663,  4685,  4672, -2071,  4703,  4690,  4706,
    4675,  4719,  4721,  4676,  1576,   947,  4722,  4731,  3636,  4733,
    1177,    14,  2480,  2481,  2482,  4734,   948,  1161, -2071,  4745,
    4750,  4755,   648,  4753,  1178,  4756,  4757,  3637,  3638,  4759,
      18,  4760,  3639,  3640,  3641,  4768, -2071,  4770,  4771,  4779,
     649,  4797, -2071, -2071,  4805,   949,  4837,  4769,  4842,  4843,
    4792,  4845,   950,  4708,  1661,  4848, -2071,  1575, -2071,  4857,
    4859, -2071,  1573,  4870,  4873,  4874,  2483,  2484,  1841,    23,
    4881,  4882,  4489,  1577,  4919,  3346,  4929,  4130,  4931,  4936,
    4932,  4935,   650,  2676,  4939,   651,  4965,  4980,  4981,  5945,
    4966,  4975,  4976,  4985,   951,  4997,   751,  4982,  4222,  5011,
    3642,  5012,  -301,  5017,  5038,  5022,  5024,  1660,  2663,  5049,
    5050,  5051,   652,  5063,  5061,  5081,  5086,  1161,  1662,  5085,
     653,  1574,  5158,  5155,  5163,  5166,  5169,  5170,  5176,   810,
     793,  5177,  5193,  5185,  5194,  5195,  5197,  2485,    31,  1576,
    5205,  5207,  5212,   952,   953,  5213,  5217,  5224,  5225,  3643,
    5226,  5230,  5232,  5235,  5745,  5244,  1910,   954,  5247,  5253,
    5245,  4590,  5261,   810,  5276,   810,  5266,  5267,  4591,   810,
     810,  5271,  5272,  5281,  5282,  6042,  5310,  5315,  5319,  5320,
    3792,  5322,  5324,  5329,  4592,  5330,  4707,  5331,  1161,  5332,
    5340,  5338,  1575,  5341,  4593,  4594,  4595,  5339,  5344,   810,
    5283,  5347,  5348,  5349,  4596,  5364,  5365,  5370, -2071,  2486,
    5373,  5286,  5376,  5391,  5381,  1161,    42,  5414,  4280,  5395,
    5393,  5415,  5417,  5418,  5424,  5425,  5442,  5455,  5435,  5457,
    5466,  5436,  5420,  5482,  5490,  5428,  5431,  2015,  5445,  5458,
    5437,   793,  1573,  5465,  5488,  5492,  6073,   793,   793,  2030,
    5489,   515,  5497,  1577,  4331,  5499,  5508,  1573,    75,  5503,
    5510,  5511,  5513,  5515,  5517,  2071,  5520,  5525,  1577,  5541,
    5546,  5549,  5064,  5553,  2081,  5569,  5567,  5576,  5582,   955,
    5577,  5584,  5583,  5586,  5588,  5598,  5684,  5621,   793,  2094,
    5684,  5662,  5599,  5615,  4708,  5616,  5618,  5649,  5604,  5659,
    5606,  1574,  5644,  5660,  5663,  2487,  5669,  5700,  5703,  2107,
    5704,  5705,  5711,  5720,  5730,  5729,  1574,  5733,  5685,  1576,
    5750,  4228,  5685,  5775,  5776,  5777,  5801,  5778,  5807,   793,
    2132,  5809,  5786,  5811,  1576,  5788,  1161,  5813,  6145,  5789,
    5814,  1657,  5819,  5820,  5821,  4597,  5815,  5822,  5827,  2155,
    6131,  5829,  1663,   956,  5831,  5832,  6133,  5841,  2039,  4598,
    5851,  5835,  5847,  5854,  2175,  5859,  5879,  5888,  5862,  5918,
    5919,  5880,  1575,  5874,  5899,  2488,  5900,  5901,  5882,  5946,
    5904,  5910,  2183,  2184,  5970,  5926,  5931,  1575,  5978,  5979,
    5957,  2202,  5973,  4218,  5980,  5981,  4229,   868,  5990,  5985,
    6037,  5998,  6054,  6031,  6055,   793,  6056,  6067,   876,  6078,
    6070,  6080,  6087,  6088,   810,   793,  5684,  6101,  1661,  6100,
    6089,   903,   801,   793,  6094,  6097,   793,  6102,  6107,  2039,
    5799,  6109,  6111,  6114,  5684,  6129,   793,  6115,  3511,  6141,
    2489,  5810,  2490,  3990,  1679,  4599,  4320,  2491,  5685,  5405,
    5403,    16,    17,  5612,  5404,   904,   871,  5610,  5799,  1994,
    4600,  5619,  5609,  5613,  4089,  4683,  5685,  5493,  5771,  5746,
    1161,  1660,  5892,  6043,   875,  4636,  1382,   906,  2205,  4090,
    5316,  5625,  1662,  5974,  4822,  5972,  2256,   907,  4355,  4373,
    5270,  1502,  4838,  3121,   957,  3522,  2684,  4601,  4604,  4397,
    4847, -2071,   792,  5203,  4969,  3692,  1490,  3211,  3209,  2252,
    3210,  4602,  2492,   908,  2406,  1691,  3212,  5468,  5872,  3140,
    2986,  5872,    16,    17,  5608,  2334,  5607,   874,   793,   909,
    2342, -2071,  4782, -2071,   910,  4263, -2071, -2071,   545,  5372,
    2352,   801,  4938,  5444,  4943,  5254,  3390,  5930,   810,  3008,
    6006,  5589,   810,   793,  5449,  2493,  6096,  6074,  5861,  6098,
     911,  3552,  1161,  5684,  5074,  1840,  4780,  6018,  5754,  5150,
    4787,  5346,  5464,  6062,  5909,  5818,  1838,   810,  5921,  3756,
     810,  4408,  5923,  5916,  5928,  5534,  4486,  3073,  4922,  4920,
    4924,  3009,  3081,  2040,  6083,  5685,   765,  1161,   766,  6049,
    5652,  6050,  6022,  5966,   664,  5963,  5514,  4613,  2417,  5516,
    5749,  3091,  4784,  5148,  2871,  2008,  4070,  5666,  4069,  5939,
    5940,  5533,  2221,  3686,  5925,  3400,  4390,  3039,  3502,  3813,
     912,  3010,  4858,  5958,  5872,   794,  2179,   793,  3938,  5872,
    1409,  4022,  2134,  4141,  1901,  2494,  5872,   913,  5971,  1908,
    4844,  3984,  4934,  2178,  3896,   914,  2495,  3894,  2601,  4513,
    4933,  5684,  2509,  2664,  2040,  5852,  5853,  2921,  5855,  5856,
    5857,  5858,  2446,  2918,  2126,  2127,  5505,  2128,  2129,  2131,
    5896,  5328,  4958,  5273,  5897,  2911,   915,  2455,  3604,  2932,
    4507,  4506,  5439,  5685,  5042,   916,   917,  1161,  1315,  4139,
    5041,  5539,  5265,  5430,  1161,  6013,  4140,  5450,  6014,  1427,
    5840,  2186,  5045,  3596,  2173,   776,  3779,   767,  3811,  4040,
    5268,  2396,  5278,  5872,  4174,  4954,  4957,  6023,  6003,  1296,
    3134,  6029,  1593,  1587,  3470,  2771,  2808,  1278,  5684,  5684,
     793,  3471,  4016,  2180,  1281,   791,  5540,  1401,  2041,   793,
    3516,  5454,  2401,  4862,  6095,  5333,  5872,  2861,  5872,  5872,
     793,  6108,  2042,  5512,  2043,  6144,  6140,  3483,  4962,  1762,
    3936,  2607,  1692,  4792,  4005,  4951,  3357,  1239,  1240,  3451,
    3999,  5938,  4000,  3194,  5941,  1196,  2705,   810,  2393,  2878,
    4691,  3977,  5949,  3676,  1902,  2044,  5048,  5959,  5684,  4376,
    4080,  5568,  4793,   785,  1331,  2082,   769,   770,   771,     0,
    2045,  6077,     0,     0,     0,  5872,     0,     0,  5872,  2041,
       0,     0,     0,     0,   810,     0,  2666,     0,     0,     0,
       0,     0,     0,  2042,     0,  2043,     0,  4792,     0,     0,
    1161,  2385,     0,  2046,     0,     0,  2386,     0,   810,   810,
       0,     0,     0,     0,     0,  5872,     0,  2387,   810,  2716,
       0,  2047,     0,     0,     0,     0,  2044,     0,   810,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2045,  2738,  1910,     0,     0,     0,     0,   801,   801,
     793,   801,   801,   801,   793,   810,   793,     0,     0,     0,
       0,     0,   801,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2046,  1161,  2773,   801,     0,   810,
    1651,     0,     0,     0,  1504,  1505,     0,     0,     0,     0,
    1506,  1507,  2047,     0,     0,     0,     0,     0,     0,     0,
    1508,   793,  2048,     0,     0,     0,     0,     0,     0,  2049,
       0,  3011,   793,     0,     0,     0,     0,     0,     0,  2050,
       0,     0,     0,   793,     0,     0,  1509,     0,     0,     0,
       0,     0,  2051,     0,     0,     0,     0,     0,  1510,     0,
       0,  3012,  3013,     0,  3014,  3015,  3016,  3017,  3018,     0,
    3019,  3020,  3021,  3022,  3023,  3024,  3025,  3026,  1511,  3027,
    3028,  3029,     0,  2052,     0,   810,  2053,     0,     0,     0,
       0,     0,     0,  2048,     0,     0,  2388,     0,     0,   793,
    2049,     0,  2054,     0,  2862,     0,     0,     0,     0,     0,
    2050,     0,  1512,     0,     0,     0,     0,  2389,   665,     0,
       0,     0,  2390,  2051,     0,   810,     0,     0,     0,     0,
       0,     0,   810,   810,   810,  1513,  1514,     0,  1515,   793,
       0,   801,     0,     0,     0,     0,  1516,  1517,  1518,     0,
       0,     0,     0,  2391,  2052,     0,   793,  2053,     0,     0,
       0,     0,     0,     0,     0,     0,  1519,   793,   793,     0,
       0,     0,     0,  2054,     0,   810,     0,     0,  3030,  3031,
       0,     0,     0,     0,     0,  2392,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1520,     0,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     0,   946,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,   810,     0,
       0,  1522,     0,     0,     0,     8,     0,     0,     0,     0,
       0,  1900,     0,     0,     0,     0,     0,     0,     0,     0,
     793,  -340,     0,  -340,  2998,  1523,  1524,  1525,     0,     0,
       0,     0,   947,     0,     0,     0,     0,     0,    14,     0,
       0,     0,   793,   948,     0,     0,     0,     0,     0,  1526,
    1527,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,   949,     0,     0,     0,     0,   810,     0,   950,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    23,     0,     0,     0,
    1528,     0,  1529,  1530,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3106,     0,     0,     0,     0,  1531,     0,
       0,   951,  2020,     0,     0,     4,     0,     0,  2028,     0,
       0,     0,     0,     0,   946,     0,     0,     0,     0,     0,
       0,  1592,     0,  3137,     0,     0,     0,     0,  3139,     0,
       0,     0,     0,     0,     0,  1532,     8,  1533,     0,     0,
     793,   793,     0,     0,     0,    31,     0,  3153,     0,     0,
     952,   953,     0,     0,  3162,  3162,     0,  3162,  3162,     0,
    1534,     0,     0,   947,   954,     0,     0,     0,     0,    14,
       0,     0,   810,     0,   948,     0,   793,     0,     0,     0,
       0,     0,     0,  1535,     0,     0,   793,     0,    18,     0,
    1401,     0,     0,  3199,  1536,  1537,     0,     0,     0,     0,
       0,     0,  3204,   949,     0,  3206,     0,     0,     0,     0,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -340,     0,    42,     0,     0,  1538,    23,     0,     4,
       0,     0,     0,     0,     0,  1539,     0,     0,   946,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   951,     0,     0,     0,     0,     0,     0,     0,
       8,     0,     0,     0,     0,    75,  2208,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2220,     0,     0,     0,
       0,  1540,  1541,  1542,  2225,     0,   955,   947,     0,  1543,
    1544,     0,     0,    14,     0,     0,    31,     0,   948,     0,
       0,   952,   953,     0,     0,     0,  1545,  1546,     0,     4,
       0,     0,    18,     4,     0,   954,     0,     0,   946,     0,
       0,     0,   946,     0,     0,     0,     0,   949,     0,     0,
    1547,  1548,     0,     0,   950,     0,     0,     0,     0,     0,
       8,     0,     0,  -340,     8,     0,     0,     0,     0,  1549,
       0,    23,     0,     0,     0,     0,     0,   793,     0,     0,
     956,     0,     0,   793,     0,     0,     0,   947,     0,     0,
       0,   947,     0,    14,    42,     0,   951,    14,   948,  3340,
       0,     0,   948,     0,     0,     0,  -575,     0,     0,  2336,
       0,  2336,    18,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   949,     0,     0,
       0,   949,     0,     0,   950,     0,    75,     0,   950,     0,
      31,     0,     0,     0,     0,   952,   953,     0,     0,     0,
       0,    23,     0,     0,     0,    23,     0,   955,     0,   954,
       0,  1551,     0,     0,  1552,     0,     0,  1553,     0,     0,
       0,     0,     0,     0,     0,     0,   951,     0,     0,     0,
     951,     0,     0,     0,     0,     0,   810,   810,   793,     0,
    1554,     0,   810,     0,     0,     0,  3162,  3162,  3162,  3162,
       0,     0,     0,     0,  3416,  3417,     0,  1910,     0,  1556,
    4210,   810,  4211,  4212,  -575,     0,     0,     0,    42,     0,
      31,   957,     0,     0,    31,   952,   953,     0,     0,   952,
     953,   956,     0,     0,     0,     0,  4213,     0,  4214,   954,
    3456,   801,     0,   954,  4215,     0,     0,     0,     0,     0,
       0,     0,     0,   801,     0,     0,     0,     0,     0,     0,
      75,     0,     0,     0,     0,     0,  2194,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4216,     0,
       0,   955,     0,   793,     0, -1292,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -1292,     0,    42,  2015,
    3485,     0,    42,     0,     0,     0,     0,     0,   810,  3501,
     793,     0,     0,     0,     0,    16,    17,     0,     0,     0,
    4217,  2575,     0,     0,     0,     0,     0,     0,     0,     0,
    2584,     0,     0,     0,     0,     0,     0,     0,  1676,   793,
      75,  2595,     0,     0,    75,     0,  3529,     0,     0,     0,
     793,  4218,     0,     0,     0,   956,     0,     0,     0,     0,
       0,   955,     0,     0,     0,   955,     0,     0,     0,     0,
       0,     0,   957,     0,     0,  3557,  3558,  3559,   793,     0,
     801,     0,   801,     0,     0,     0,  4219,   793,  3571,   801,
    4220,   793,     0,     0,     0,     0,     0,   793,  4221,     0,
       0,  4222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   793,     0,     0,  2194,  3592,     0,  3795,     0,
    2155,  3597,  4028,     0,  4223,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   956,     0,     0,     0,   956,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4224,
    4225,  4226,     0,     0,    16,    17,     0,     0,     0,  4217,
       0,  2750,     0,     0,     0,  2754,     0,  2756,     0,     0,
       0,     0,  4227,   810,     0,     0,     0,     0,     0,   793,
       0,     0,     0,     0,     0,     0,   957,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4228,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2788,     0,     0,     0,     0,     0,     0,     0,
       0,  4229,     0,  2798,     0,     0,     0,     0,     0,  4230,
       0,  4231,     0,     0,  2811,     0,     0,  4221,     0,     0,
    3741,     0,     0,     0,     0,     0,     0,     0,     0,  3748,
    4232,     0,     0,     0,     0,     0,     0,  4233,     0,     0,
       0,     0,     0,     0,     0,     0,   957,     0,     0,  4234,
     957,     0,     0,     0,     0,     0,  4235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4236,     0,     0,     0,     0,     0,     0,  4224,  4225,
    4226,  4237,  3772,     0,     0,  4238,  4239,     0,     0,     0,
       0,  3780,  4240,  3782,     0,     0,  4241,     0,     0,   793,
       0,  4227,   793,     0,  4242,   810,     0,   810,   810,     0,
    2885,     0,     0,     0,     0,  1504,  4332,     0,     0,     0,
     810,  1506,  1507,  3162,  4243,     0,  4228,  1401,     0,     0,
       0,  1508,     0,     0,     0,     0,     0,     0,  1401,  1401,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4244,     0,     0,     0,  4245,     0,     0,  1509,  4230,     0,
    4231,     0,     0,     0,  4246,     0,     0,     0,     0,  1510,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4232,
       0,     0,     0,     0,     0,     0,     0,     0,   810,  1511,
     810,     0,     0,     0,     0,     0,     0,     0,  4234,     0,
       0,  4247,     0,     0,     4,  4235,     0,     0,     0,     0,
       0,     0,     0,   946,  4248,     0,  4249,     0,     0,     0,
    4236,  2994,     0,  1512,     0,     0,     0,     0,     0,     0,
    4237,     0,     0,     0,     0,     8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4241,  1513,  1514,     0,  1515,
       0,     0,     0,     0,     0,  4250,     0,  1516,  1517,  1518,
       0,  4251,   947,     0,     0,     0,     0,     0,    14,     0,
       0,     0,     0,   948,     0,     0,     0,  1519,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,  4252,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4253,
    4254,  4255,   949,  4245,     0,     0,  3921,     0,     0,   950,
       0,     0,  1520,  4246,     0,     0,     0,     0,     0,     0,
    4256,     0,     0,     0,     0,     0,    23,  4257,     0,     0,
       0,     0,     0,     0,     0,     0,  1521,     0,     0,  3949,
       0,     0,  1522,     0,     0,     0,     0,     0,     0,     0,
    4247,   951,     0,     0,     0,     0,     0,     0,  4258,     0,
       0,     0,     0,  4248,     0,   793,  1523,  1524,  1525,   810,
     810,  3162,     0,  4259,  4260,  3161,  3161,     0,  3161,  3161,
       0,     0,     0,     0,     0,   810,  4261,     0,     0,  4262,
    4333,  1527,     0,     0,     0,    31,     0,  3175,     0,     0,
     952,   953,     0,     0,  4250,     0,     0,  1651,     0,     0,
    4251,     0,     0,     0,   954,     0,     0,     0,  1229,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2607,  1528,     0,  1529,  1530,     0,     0,     0,     0,     0,
       0,  4037,     0, -1292,     0,     0,     0,     0,     0,  1531,
    1241,     0,     0,     0,     0,     0,     0,     0,     0,  4256,
       0,   671,     0,    42,     0,     0,  4257,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1213,     0,     0,     0,
       0,     0,     0,     0,  1242,  1243,  1532,     0,  1533,     0,
       0,     0,     0,     0,  1244,     0,     0,  4258,     0,     0,
       0,     0,     0,     0,     0,    75,     0,     0,     0,    10,
      11,  1534,  4259,  4260,     0,     0,     0,     0,     0,     0,
       0,     0,   801,     0,     0,  4261,   955,   793,     0,     0,
       0,     0,     0,     0,  1535,     0,     0,     0,   793,     0,
       0,     0,   793,     0,     0,  1536,  1537,     0,   810,     0,
       0,     0,     0,     0,    16,    17,  2666,     0,     0,  1245,
       0,     0,     0,     0,     0,     0,     0,     0,  3319,     0,
       0,   810,   810,  1246,  3325,     0,     0,  1538,     0,     0,
       0,     0,     0,  5208,     0,     0,  1539,     0,     0, -1136,
       0, -1136,     0,     0,     0,     0,     0,     0,     0,     0,
     956,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2194,     0,
       0,   810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1540,  1541,  1542,     0,  1247,  4284,     0,     0,
    1543,  1544,     0,     0,     0,     0,     0,     0,     0,  1248,
       0,     0,     0,     0,     0,     0,     0,  1545,  1546,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,  4217,     0,     0,     0,     0,     0,     0,  1900,
       0,  1547,  1548,     0,     0,     0,     0,  3161,  3161,  3161,
    3161,     0,     0,     0,     0,     0,     0,  5146,     0,  4211,
    4334,     0,     0,     0,     0,     0,     0,  1249,     0,     0,
       0,     0,     0,     0,     0,  4356,     0,     0,     0,     0,
       0,     0,     0,  4213,     0,     0,     0,     0,     0,     0,
       0,  4215,     0,     0,     0,   793,     0,     0,     0,     0,
       0,   957,     0,     0,     0,     0,     0,     0,     0,     0,
    4221,     0,     0,  2194,  3153,     0,     0,     0,     0,  2184,
     810,   810,   810,   810,     0,  5147,   793,     0,     0,     0,
       0,     0,     0,     0,  3473,     0,  1250,  4398,     0,     0,
       0,     0,     0,     0,     0,  1251,     0,     0,     0,     0,
       0,     0,  1551,     0,     0,  1552,     0,  1252,  1553,     0,
       0,  3503,    16,    17,     0,     0,     0,  4217,  1253,     0,
       0,  4224,  4225,  4226,     0,     0,     0,     0,     0,     0,
       0,  4336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1254,     0,  4227,     0,     0,     0,  4218,     0,
    1556,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4228,
       0,     0,     0,     0, -2449,  1255,     0,     0,  1256,  3560,
    1257,     0,     0,     0,  4481,     0,     0,  4220,  3569,     0,
       0,     0,  1401,     0,     0,  4221,     0,     0,  1401,     0,
       0,  4230,     0,  4231,     0,     0,  1258,  1259,     0,     0,
       0,     0,     0,  1401,  1260,  1261,     0,     0,     0,     0,
   -1136,  4223,  4232,  4517,     0,     0,     0,     0,     0,     0,
       0,  1262,     0,     0,     0,     0,     0,   810,     0,     0,
       0,  4234,     0,     0,   810,   810,   810,   810,  4235,  4538,
       0,     0,     0,  1263,     0,     0,  4224,  4225,  4226,     0,
       0,     0,     0,  4236,     0,  4548,  4549,     0,     0,     0,
       0,     0,     0,  4237,  1264,     0,     0,     0,     0,  4227,
       0,     0,     0,     0,     0,     0,     0,     0,  4241,     0,
       0,     0,     0,     0,  4569,     0,     0,     0,     0,     0,
       0,     0,     0,  2607,  4228,     0,     0,     0,     0,  4586,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4229,     0,
    1265,     0,     0,     0,     0,     0,  4230,     0,  4231,     0,
       0,     0,     0,   810,  1266,     0,  4245,     0,     0,   793,
     793,     0,     0,     0,     0,  1267,  4246,  4232,  1268,  1269,
       0,     0,     0, -1136,   801, -1136,     0,     0,     0,     0,
       0,     0,     0,  1270,     0,     0,  4234,     0,     0,     0,
     793,   793,     0,  4235,     0,     0,     0,  4665,     0,     0,
       0,     0,  2194,  4247,     0,     0,     0,     0,  4236,     0,
       0,     0,     0,     0,     0,     0,  4248,     0,  4237,  1271,
       0,     0,  4238,     0,     0,     0,  1272,     0,     0,  4240,
       0,     0,     0,  4241,     0,     0,     0,     0,     0,     0,
    1401,     0,     0,  3789,     0, -3237,     0,  1273,     0,     0,
       0,    16,    17,     0,     0,     0,  4217,  4250,     0,     0,
       0,  4243,     0,  4251,  3161,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4623,     0,  4624,
       0,  4625,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4245,     0,     0,     0,     0,     0, -3237,     0,     0,
       0,  4246,     0,  1274,     0,     0,     0,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     0,   946,     0,     0,
       0,     0,  4256,     0,     0,     0,     0,     0,     0,  4257,
       0,     0,     0,  4776,  4221,     0,     0,     0,  4247,     8,
       0,     0,     0,     4,     0,     0,     0,     0,  4790,     0,
       0,  4248,   946,  4249,     0,     0,     0,     0,     0,     0,
    4258,     0,     0,     0,     0,     0,   947,     0,     0,     0,
       0,     0,    14,     0,  -557,  4259,  4260,   948,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4261,     0,
       0,    18,  4250,     0,     0,  4224,  4225,  4226,  4251,     0,
    4819,   947,     0,     0,     0,  3741,   949,  1687,     0,     0,
       0,     0,   948,   950,     0,     0,     0,     0,  4227,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
      23,     0,  3772,     0,     0,  4839,     0,     0,  4841,     0,
       0,   949,     0,  4228,     0,     0,     0,     0,   950,     0,
       0,     0,     0,     0,   810,   951,     0,  4256,     0,     0,
       0,     0,     0,     0,  4257,  1688,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4230,     0,  4231,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     951,     0,     0,     0, -1136,  4258,  4232,     0,     0,    31,
       0,     0,     0,     0,   952,   953,  3974,     0,     0,     0,
    4259,  4260,  3161,     0,     0,  4234,     0,     0,   954,     0,
       0,     0,  4235,  4261,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1689,     0,     0,  4236,     0,   952,
     953,     0,     0,     0,     0,     0,     0,  4237,     0,     0,
       0,     0,     0,   954,     0,     0,  4917,     0,     0,     0,
       0,     0,  4241,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4926,     0,     0,     0,    42,     0,     0,
       0,     0,     0,     0,     0,     0,  4538,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4517,
       0,     0,     0,   810,   810,     0,     0,     0,     0,  4947,
       0,     0,  1690,     0,     0,     0,     0,     0,     0,    75,
    4245,     0,     0,     0,     0,  1229,  1910,     0,     0,     0,
    4246,     0,     0,     0,     0,  2607,     0,     0,     0,     0,
     955,     0,     0,     0,     0,     0,  4037,  4964,     0,     0,
       0,     0,     0,     0,  -557,  4974,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4247,     0,     0,
       0,     0,     0,     0,     0,   955,     0,     0,  4108,     0,
    4248,     0,     0,     0,     0,     0,     0,     0,     0,  1401,
       0,     0,     0,  1401,   793,     0,     0,  4790,     0,   793,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   956,     0,     0,     0,     0,     0,
       0,  4250,     0,     0,     0,     0,     0,  4251,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3592,     0,     0,
       0,     0,     0,     0,     0,     0,  2666,     0,     0,   956,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   810,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4790,     0,
       0,     0,     0,     0,     0,     0,  4256,     0,     0,     0,
       0,     0,     0,  4257,     0,  4974,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5091,     0,  2607,     0,
       0,     0,     0,     0,   793,     0,     0,     0,     0,     0,
    5109,     0,     0,     0,  4258,     0,     0,     0,     0,     0,
       0,     0,   810,  4974,     0,     0,     0,     0,     0,  4259,
    4260,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4261,  4974,     0,   957,     0,     0,     0,  4790,
    5151,     0,     0,     0,     0,  5162,     0,     0,     0,     0,
       0,   801,     0,     0,     0,     0,  5172,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1401,     0,     0,     0,
     957,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4391,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4517,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2607,     0,  3772,     0,     0,     0,     0,     0,     0,     0,
    4586,     0,     0,     0,     0,     0,     0,     0,     0,   810,
       0,     0,     0,  4790,     0,     0,     0,     0,     0,     0,
       0,   793,     0,     0,     0,     0,     0,     0,     0,     0,
    3741,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3741,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5353,     0,     0,     0,     0,  4790,
    4974,  4790,     0,   810,  4790,     0,  4974,     0,     0,     0,
       0,  4790,  4790,     0,     0,     0,  4974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4621,  4622,     0,  1163,     0,     0,     0,     0,     0,     0,
       0,  4790,     0,     0,     0,  4974,     0,  4974,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,  1401,  1401,     0,     0,     0,  5382,     0,     0,   793,
       0,     0,  5389,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,  5398,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5448,     0,     0,     0,     0,     0,     0,     0,
       0,  4917,     0,     0,     0,     0,  4974,     0,     0,     0,
       0,     0,     0,     0,     0,  5461,  5461,  5463,     0,     0,
    4790,     0,  1163,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   801,     0,     0,
       0,     0,   801,     0,     0,     0,  3592,     0,  3592,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5519,     0,
       0,     0,     0,     0,     0,  5524,     0,     0,  4790,  4790,
       0,     0,  4790,     0,     0,     0,  4790,     0,  5536,     0,
       0,     0,     0,     0,  2607,     0,     0,   793,     0,     0,
       0,     0,     0,  4974,     0,     0,     0,     0,     0,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5565,     0,     0,     0,     0,     0,     0,     0,   793,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5461,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,  1739,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,  3741,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4790,  1739,     0,     0,     0,  4790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   793,     0,     0,     0,     0,
    5668,     0,     0,     0,     0,     0,     0,  5699,     0,     0,
       0,     0,     0,     0,     0,  5706,  5710,     0,     0,     0,
       0,     0,     0,  1163,  1163,  1163,  1163,     0,     0,  1739,
       0,     0,     0,     0,     0,     0,     0,  1163,     0,     0,
       0,     0,  5728,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5461,     0,     0,     0,
    5752,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5762,     0,  5763,   801,     0,     0,     0,     0,     0,
     801,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5782,     0,  4986,     0,     0,     0,     0,
    4998,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   810,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2607,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,     0,  1739,     0,
       0,  5889,     0,     0,   793,  5100,     0,   801,   801,     0,
       0,  4586,  4586,     0,     0,     0,     0,     0,     0,     0,
    5461,     0,  5461,  5461,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5911,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5917,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5710,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5728,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   810,     0,     0,  1739,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5967,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,  5461,  5461,     0,     0,  5461,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2607,     0,     0,     0,     0,     0,     0,     0,  1163,     0,
    1163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6030,     0,
       0,     0,     0,     0,     0,   801,     0,     0,     0,     0,
       0,  6040,     0,     0,     0,     0,     0,     0,     0,  5461,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   810,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5287,     0,     0,     0,  6075,  6075,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1163,     0,
    1163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2607,
       0,     0,     0,   810,     0,     0,     0,     0,     0,   810,
       0,     0,     0,  2607,     0,     0,  1163,     0,     0,  2607,
       0,     0,     0,     0,     0,  2607,     0,     0,     0,  1163,
    1163,     0,     0,     0,     0,  1163,     0,     0,     0,  1163,
    1163,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,  1163,  1739,     0,     0,     0,  1163,     0,  1163,  1163,
    1163,  1163,  1163,     0,  1163,     0,     0,  1739,  1739,     0,
    5383,     0,     0,     0,     0,  1163,     0,  1163,     0,     0,
    1163,  1163,     0,  1163,  1163,  1163,     0,  1163,  1163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1163,  1163,  1163,  1163,  1163,     0,  1163,  1163,
    1163,     0,     0,  1163,  1163,  1163,  1163,  1163,  1163,  1163,
       0,  1163,  1163,  1163,  1163,  1163,  1163,     0,  1163,  1163,
       0,  1163,  1163,  1163,  1163,  1163,  1163,  1163,     0,     0,
    1163,  1163,  1163,  1163,     0,  1163,  1163,  1163,     0,  1163,
       0,  1163,     0,  1163,     0,     0,     0,  1163,  1163,  1163,
       0,     0,  1163,  1163,  1163,  1163,  1163,     0,  1163,     0,
       0,     0,     0,     0,     0,  1163,     0,     0,     0,     0,
       0,     0,  1163,  1163,  1163,  1163,     0,     0,     0,     0,
       0,     0,     0,  1163,  1163,     0,  1163,  1163,     0,     0,
    1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,  1163,
    1163,  1163,  1163,     0,     0,  1163,     0,     0,     0,     0,
    1739,     0,     0,     0,     0,     0,     0,  1739,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5570,     0,     0,     0,     0,     0,     0,     0,  1163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,     0,  1163,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1739,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5664,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
    1739,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1163,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,  1163,     0,     0,     0,     0,     0,     0,
       0,  1163,  1163,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1739,  1739,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1163,  1163,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1739,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,  1739,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,     0,     0,     0,  1163,  1163,     0,  1163,  1163,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,  1163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1163,     0,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1163,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1739,     0,  1739,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1163,     0,     0,     0,     0,     0,     0,
    1739,     0,     0,  1739,  1739,  1739,     0,  1163,     0,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1129,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1292,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,     0,     0,  1163,     0,     0,     0,     0,     0,     0,
       0,     0,  1163,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,  1163,     0,  1163,     0,  1163,  1163,  1163,
    1163,  1163,  1163,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,  1163,  1489,  1163,     0,     0,  1163,  1163,  1163,
       0,     0,     0,     0,     0,     0,  1163,  1163,  1163,     0,
    1163,     0,  1163,     0,  1163,     0,  1163,     0,  1163,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,  1163,     0,
    1163,  1163,  1163,  1163,  1163,     0,     0,  1163,  1163,  1163,
       0,  1163,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1163,     0,     0,
       0,     0,  1163,     0,     0,  1163,     0,  1163,  1163,  1163,
       0,     0,  1163,     0,     0,     0,     0,     0,  1163,     0,
       0,     0,     0,  1163,     0,     0,     0,     0,     0,     0,
    1640,     0,  1163,     0,     0,     0,     0,     0,  1163,     0,
    1163,     0,     0,  1163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1163,  1739,  1163,     0,     0,     0,     0,
    1163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1739,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1702,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1729,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,  1744,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1839,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1163,     0,     0,     0,     0,
       0,     0,  1739,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2037,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1163,     0,     0,
    1163,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,  1163,     0,  2191,     0,     0,
       0,     0,     0,     0,     0,     0,  1739,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,  1163,     0,  1163,     0,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2234,
       0,  2235,     0,     0,     0,     0,     0,  1163,     0,     0,
       0,     0,     0,  1739,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1163,  1163,
       0,     0,     0,     0,     0,  1163,     0,  1163,     0,  1163,
       0,     0,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1739,  1163,  1163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2399,
       0,  2399,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,  2445,     0,     0,     0,
    2450,     0,  2452,     0,  1163,     0,     0,     0,     0,     0,
       0,  2468,  2469,     0,     0,     0,  1163,  2498,  1163,  2501,
    2502,  2503,  2504,  2505,     0,  2507,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2515,     0,  2518,     0,
       0,  2519,  2520,     0,  2522,  2523,     0,     0,  2526,  2527,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2536,  2537,  2542,  2544,  2545,     0,  2548,
       0,  2550,     0,     0,  2552,  2553,  2554,  2557,  2558,  2559,
    2560,     0,  2561,  2562,  2563,  2564,  2565,     0,     0,  2572,
    2573,     0,     0,  2577,  2578,  2579,     0,     0,     0,     0,
       0,  2585,  2586,  2587,     0,     0,  2590,  2591,  2592,     0,
    2594,     0,  2596,     0,  2597,     0,     0,     0,  2600,  2542,
    2602,     0,     0,  2608,  2609,  2610,  2611,  2612,     0,  2613,
       0,     0,     0,     0,     0,     0,  2617,     0,     0,     0,
       0,     0,     0,  2622,  2623,  2624,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2719,     0,     0,
       0,     0,  2191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2792,
       0,     0,     0,  1163,  1163,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1163,  1163,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2827,  1163,  2832,  1163,     0,  1163,     0,  1163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,  1163,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2855,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1163,     0,
       0,     0,     0,     0,     0,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1163,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2928,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3107,  3108,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1163,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3169,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3195,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1292,     0,  3214,     0,     0,     0,     0,     0,
       0,     0,  3221,  3222,     0,     0,     0,  1163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1739,  1163,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3277,  3279,  3281,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1163,     0,  1163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3365,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3373,     0,  3374,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3396,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3402,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3413,     0,     0,  2191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3449,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3459,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1739,  2832,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,  3598,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3598,     0,
    2191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1163,     0,     0,     0,  3689,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1163,     0,     0,     0,     0,     0,     0,  1739,  1739,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3834,     0,     0,  3835,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3862,     0,  1739,     0,  3864,     0,  3865,  3866,
    3867,  3868,  3869,  3870,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3875,     0,  3876,     0,     0,  3877,  3878,
    3879,     0,  1739,     0,     0,     0,     0,  3881,  3882,  3883,
       0,  3884,     0,  3886,  1163,  3888,     0,  3890,     0,  3892,
       0,     0,     0,     0,     0,     0,     0,  2554,     0,  3895,
       0,  2554,     0,  3898,  3899,  3900,     0,     0,  3901,  3902,
    3904,     0,  3905,     0,     0,  3906,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3907,     0,
       0,     0,     0,     0,     0,     0,  3914,     0,  3915,  3916,
    3917,     0,     0,  3918,     0,     0,     0,     0,     0,  3922,
       0,     0,     0,     0,  3933,     0,     0,     0,     0,     0,
       0,     0,     0,  3937,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3944,     0,  1163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3956,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2191,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2832,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1163,     0,     0,     0,  2191,     0,  2832,  1163,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4135,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1163,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4396,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4403,     0,
       0,  4404,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4422,  4423,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4446,     0,  4447,     0,  4448,     0,  4449,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4497,
    4498,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3598,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2191,  2191,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2191,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2832,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4662,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3598,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3598,     0,  4674,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4846,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4876,  4877,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4884,  4885,
    4886,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4906,     0,  4907,     0,  4908,     0,  4909,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4915,  4916,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4937,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2832,     0,
       0,     0,  2832,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5164,
    5165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3598,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3598,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2191,  2191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,  2832,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2832,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5321,     0,  5323,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5469,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,     0,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   585,     0,     0,   587,     0,    78,     0,
       0,    81,    82,   588,    84,    85,    86,    87,   589,    88,
     590,    90,    91,    92,     0,     0,   591,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,  5423,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   593,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,  3598,   129,     0,   131,   594,   133,   134,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,     0,   148,   149,   150,     0,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
       0,   598,   599,   174,     0,   175,   176,   177,  5470,   179,
     180,     0,     0,   183,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,     0,   213,   605,   214,   215,   216,   217,
     218,   219,  5521,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,     0,     0,
       0,   269,   270,   271,   272,   273,     0,     0,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,     0,  3598,     0,   292,   293,   294,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,     0,   315,
     608,   316,   609,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,     0,     0,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   612,   360,   361,   362,     0,   364,
     365,   366,   613,   368,   369,   370,   371,   372,   373,     0,
     375,   376,   377,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,     0,   423,
     424,     0,   426,   427,     0,   429,   430,   431,   432,   617,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,   447,   448,   449,     0,     0,   452,   453,
     454,   455,   456,   457,   458,   459,   460,  1555,   462,   463,
     464,   465,     0,   466,   620,   468,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5826,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2187,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2188,   986,   987,   988,   989,     0,     0,     0,
       0,     0,     0,     0,   990,   991,     0,   992,     0,     0,
       0,     0,     0,     0,   993,   994,     0,     0,   995,   996,
     997,   998,     0,   999,  1000,     0,  1001,  1002,     0,     0,
       0,     0,  1003,     0,     0,     0,  2189,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1839,     0,  1006,
    1007,  1008,     0,  1009,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1011,  1012,  1013,     0,
    1014,  1015,     0,     0,     0,  1016,  1017,  1018,     0,     0,
       0,     0,  5924,     0,     0,  1019,     0,  1020,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,  1023,
    1024,     0,  1025,     0,     0,     0,     0,     0,  1026,     0,
    1027,     0,     0,  1028,     0,     0,  1029,  1030,  1031,     0,
    1032,  1033,  1034,     0,  1035,  2190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1036,
       0,     0,     0,  1037,  1038,  1039,     0,  1040,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,     0,     0,     0,
       0,     0,  2832,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,  1044,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1045,     0,     0,     0,
       0,     0,  1046,  1047,     0,  1048,  1049,     0,     0,     0,
    1050,     0,     0,     0,     0,     0,     0,     0,  1051,  1052,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1054,  1055,  1056,     0,     0,     0,     0,     0,  1057,     0,
    1058,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   584,    48,    49,    50,    51,
      52,  1059,  1060,  1061,    54,    55,    56,  1062,    58,    59,
      60,    61,    62,    63,  1063,    65,    66,    67,    68,    69,
      70,    71,  1064,   585,     0,   586,   587,    77,    78,    79,
      80,    81,    82,   588,    84,    85,    86,    87,  1065,    88,
     590,    90,    91,    92,    93,    94,   591,  1066,    96,  1067,
    1068,    99,  1069,  1070,  1071,  1072,  1073,     0,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,  1074,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,  1075,  1076,  1077,   594,  1078,  1079,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,   596,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
    2832,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   598,   599,   174,     0,  1080,   176,   177,   600,   179,
     180,  1081,   182,  1082,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,  1083,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   605,   214,  1084,  1085,   217,
     218,   219,  1086,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1087,   259,  1088,   261,   262,   263,   264,  1089,  1090,  1091,
    1092,   269,   270,   271,   272,   273,   274,   275,   276,   277,
    1093,  1094,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,   289,   290,   291,   292,   293,  1095,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,  1096,   308,   309,   310,   311,   312,  1097,  1098,   315,
     608,   316,   609,   318,   319,  1099,   321,   322,   323,   324,
     325,   326,  1100,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,  1101,   358,   612,   360,   361,   362,  1102,  1103,
     365,   366,   613,   368,   369,  1104,   371,   372,   373,   374,
     375,   376,  1105,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,  1106,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,  1107,  1108,  1109,  1110,   429,   430,   431,  1111,  1112,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,  1113,   448,  1114,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  1115,  1116,   619,  1117,   463,
     464,   465,     0,   466,   620,   468,  1118,     0,     0,     0,
       0,     0,     0,     0,     0,  1119,  1120,     0,     0,     0,
       0,  1121,     0,     0,     0,  2631,  1122,     0,     0,     0,
    1123,  1124,     0,     0,  1125,  1126,   985,   986,   987,   988,
     989,     0,     0,     0,     0,     0,     0,     0,   990,   991,
       0,   992,     0,     0,     0,     0,     0,     0,   993,   994,
       0,     0,   995,   996,   997,   998,     0,   999,  1000,     0,
    1001,  1002,     0,     0,     0,     0,  1003,     0,     0,     0,
    1004,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,  1009,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1011,  1012,  1013,     0,  1014,  1015,     0,     0,     0,  1016,
    1017,  1018,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,  1020,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,  1023,  1024,     0,  1025,     0,     0,     0,
       0,     0,  1026,     0,  1027,     0,     0,  1028,     0,     0,
    1029,     0,  1031,     0,  1032,  1033,  1034,     0,  1035,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1036,     0,     0,     0,  1037,  1038,  1039,
       0,  1040,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
    1044,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1045,     0,     0,     0,     0,     0,  1046,  1047,     0,  1048,
    1049,     0,     0,     0,  1050,     0,     0,     0,     0,     0,
       0,     0,  1051,  1052,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1054,  1055,  1056,     0,     0,     0,
       0,     0,  1057,     0,  1058,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   584,
      48,    49,    50,    51,    52,  1059,  1060,  1061,    54,    55,
      56,  1062,    58,    59,    60,    61,    62,  2632,  1063,    65,
      66,    67,    68,    69,    70,    71,  1064,   585,     0,   586,
     587,    77,    78,    79,    80,    81,    82,   588,    84,    85,
      86,    87,  1065,    88,   590,    90,    91,    92,    93,    94,
     591,  1066,    96,  1067,  1068,    99,  1069,  1070,  1071,  1072,
    1073,     0,   105,   106,   107,   592,   109,   110,   111,   112,
     113,   114,   115,   116,   117,  1074,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,  1075,  1076,  1077,
     594,  1078,  1079,   135,     0,   136,   137,   138,   139,   140,
     141,   142,   595,   144,   145,   146,   147,   596,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   597,   162,     0,     0,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   598,   599,   174,     0,  1080,
     176,   177,   600,   179,   180,  1081,   182,  1082,   601,   185,
     186,   602,   188,   189,   603,     0,   191,   192,   193,  1083,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   604,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   605,
     214,  1084,  1085,   217,   218,   219,  1086,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1087,   259,  1088,   261,   262,   263,
     264,  1089,  1090,  1091,  1092,   269,   270,   271,   272,   273,
     274,   275,   276,   277,  1093,  1094,   280,   281,   282,   283,
     284,   606,   285,   286,   287,   288,   289,   290,   291,   292,
     293,  1095,   295,   296,   297,   607,   298,   299,   300,   301,
     302,   303,   304,   305,   306,  1096,   308,   309,   310,   311,
     312,  1097,  1098,   315,   608,   316,   609,   318,   319,  1099,
     321,   322,   323,   324,   325,   326,  1100,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   610,   347,   348,   611,   350,
     351,   352,   353,   354,   355,   356,  1101,   358,   612,   360,
     361,   362,  1102,  1103,   365,   366,   613,   368,   369,  1104,
     371,   372,   373,   374,   375,   376,  1105,   378,   614,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   615,   399,
     400,   616,   402,   403,   404,   405,  1106,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1107,  1108,  1109,  1110,   429,
     430,   431,  1111,  1112,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   618,   444,   445,   446,  1113,   448,  1114,
     450,   451,   452,   453,   454,   455,   456,   457,   458,  1115,
    1116,   619,  1117,   463,   464,   465,     0,   466,   620,   468,
    1118,     0,     0,     0,     0,     0,     0,     0,     0,  1119,
    1120,     1,     2,     0,     0,  1121,     0,     0,     0,     0,
    1122,     0,     0,     0,  1123,  1124,     0,     0,  1125,  1126,
       0,     3,     0,     4,     0,     5,     0,     6,     0,     0,
       0,     0,     0,     0,     0,     7,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     8,     0,     0,     9,     0,    10,
      11,     0,     0,     0,     0,     0,     0,    12,     0,     0,
       0,     0,     0,     0,    13,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    14,     0,     0,
       0,     0,     0,    15,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,    17,    18,     0,     0,     0,
       0,     0,     0,     0,    19,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
      22,     0,     0,     0,     0,    23,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    25,
      26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,    28,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    29,    30,    31,     0,    32,     0,     0,     0,
       0,    33,     0,     0,     0,     0,     0,    34,     0,     0,
       0,    35,     0,     0,     0,    36,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    38,     0,    39,     0,    40,     0,     0,
       0,     0,    41,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    42,    43,     0,     0,     0,     0,     0,     0,
      44,    45,    46,    47,     0,    48,    49,    50,    51,    52,
      53,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     0,    88,    89,
      90,    91,    92,    93,    94,     0,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
       0,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,     0,   174,     0,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,     0,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,     0,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,     0,   466,   467,   468,   469,     1,     2,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   470,     3,     0,     4,     0,
       5,     0,     6,     0,     0,     0,     0,     0,     0,     0,
       7,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     8,
       0,     0,     9,     0,    10,    11,     0,     0,     0,     0,
       0,     0,    12,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    14,     0,     0,     0,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
      17,    18,     0,     0,     0,     0,     0,     0,     0,    19,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    21,     0,    22,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      24,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,    26,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    27,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    29,    30,    31,
       0,    32,     0,     0,     0,     0,    33,     0,     0,     0,
       0,     0,    34,     0,     0,     0,    35,     0,     0,     0,
      36,    37,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    38,     0,
      39,     0,    40,     0,     0,     0,     0,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    42,    43,     0,
       0,     0,     0,     0,     0,    44,    45,    46,    47,     0,
      48,    49,    50,    51,    52,    53,     0,     0,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     0,    88,    89,    90,    91,    92,    93,    94,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,     0,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,     0,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,     0,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,     0,     0,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,     0,   174,     0,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,     0,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,     0,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,     0,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,     0,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,     0,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,     0,   466,   467,   468,
     469,     1,     2,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     470,     3,     0,     0,     0,     5,     0,     6,     0,     0,
       0,     0,     0,     0,     0,     7,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,     0,    10,
      11,     0,     0,     0,     0,     0,     0,    12,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    15,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,    19,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,     0,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    24,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    25,
      26,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,    28,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    29,    30,     0,     0,    32,     0,     0,     0,
       0,    33,     0,     0,     0,     0,     0,    34,     0,     0,
       0,    35,     0,     0,     0,    36,    37,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    38,     0,    39,     0,    40,     0,     0,
       0,     0,    41,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,     0,     0,     0,     0,
      44,    45,    46,    47,     0,    48,    49,    50,    51,    52,
      53,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,     0,     0,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,     0,    88,    89,
      90,    91,    92,    93,    94,     0,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
       0,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,     0,   174,     0,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,     0,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,     0,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
       0,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,     0,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,     0,   466,   467,   468,   469,   985,   986,   987,   988,
     989,     0,     0,     0,     0,     0,     0,     0,   990,   991,
       0,   992,     0,     0,     0,   470,     0,     0,   993,   994,
       0,     0,   995,   996,   997,   998,     0,   999,  1000,     0,
    1001,  1002,     0,     0,     0,     0,  1003,     0,     0,     0,
    1004,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,  1009,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1011,  1012,  1013,     0,  1014,  1015,     0,     0,     0,  1016,
    1017,  1018,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,  1020,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,  1023,  1024,     0,  1025,     0,     0,     0,
       0,     0,  1026,     0,  1027,     0,     0,  1028,     0,     0,
    1029,  1030,  1031,     0,  1032,  1033,  1034,     0,  1035,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1036,     0,     0,     0,  1037,  1038,  1039,
       0,  1040,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
    1044,     0,    34,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1045,     0,     0,     0,     0,     0,  1046,  1047,     0,  1048,
    1049,     0,     0,     0,  1050,     0,     0,     0,     0,     0,
       0,     0,  1051,  1052,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1054,  1055,  1056,    41,     0,     0,
       0,     0,  1057,     0,  1058,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   584,
      48,    49,    50,    51,    52,  1059,  1060,  1061,    54,    55,
      56,  1062,    58,    59,    60,    61,    62,    63,  1063,    65,
      66,    67,    68,    69,    70,    71,  1064,   585,     0,   586,
     587,    77,    78,    79,    80,    81,    82,   588,    84,    85,
      86,    87,  1065,    88,   590,    90,    91,    92,    93,    94,
     591,  1066,    96,  1067,  1068,    99,  1069,  1070,  1071,  1072,
    1073,     0,   105,   106,   107,   592,   109,   110,   111,   112,
     113,   114,   115,   116,   117,  1074,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,  1075,  1076,  1077,
     594,  1078,  1079,   135,     0,   136,   137,   138,   139,   140,
     141,   142,   595,   144,   145,   146,   147,   596,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   597,   162,     0,     0,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   598,   599,   174,     0,  1080,
     176,   177,   600,   179,   180,  1081,   182,  1082,   601,   185,
     186,   602,   188,   189,   603,     0,   191,   192,   193,  1083,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   604,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   605,
     214,  1084,  1085,   217,   218,   219,  1086,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1087,   259,  1088,   261,   262,   263,
     264,  1089,  1090,  1091,  1092,   269,   270,   271,   272,   273,
     274,   275,   276,   277,  1093,  1094,   280,   281,   282,   283,
     284,   606,   285,   286,   287,   288,   289,   290,   291,   292,
     293,  1095,   295,   296,   297,   607,   298,   299,   300,   301,
     302,   303,   304,   305,   306,  1096,   308,   309,   310,   311,
     312,  1097,  1098,   315,   608,   316,   609,   318,   319,  1099,
     321,   322,   323,   324,   325,   326,  1100,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   610,   347,   348,   611,   350,
     351,   352,   353,   354,   355,   356,  1101,   358,   612,   360,
     361,   362,  1102,  1103,   365,   366,   613,   368,   369,  1104,
     371,   372,   373,   374,   375,   376,  1105,   378,   614,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   615,   399,
     400,   616,   402,   403,   404,   405,  1106,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1107,  1108,  1109,  1110,   429,
     430,   431,  1111,  1112,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   618,   444,   445,   446,  1113,   448,  1114,
     450,   451,   452,   453,   454,   455,   456,   457,   458,  1115,
    1116,   619,  1117,   463,   464,   465,     0,   466,   620,   468,
    1118,     0,     0,     0,   985,   986,   987,   988,   989,  1119,
    1120,     0,  2539,     0,     0,  1121,   990,   991,     0,   992,
    1122,     0,     0,     0,  1123,  1124,   993,   994,  1125,  1126,
     995,   996,   997,   998,     0,   999,  1000,     0,  1001,  1002,
       0,     0,     0,     0,  1003,     0,     0,     0,  1004,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,  1009,  1010,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1011,  1012,
    1013,     0,  1014,  1015,     0,     0,     0,  1016,  1017,  1018,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,  1020,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2540,     0,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,  1023,  1024,     0,  1025,     0,     0,     0,     0,     0,
    1026,     0,  1027,     0,     0,  1028,     0,     0,  1029,  1030,
    1031,     0,  1032,  1033,  1034,     0,  1035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1036,     0,     0,     0,  1037,  1038,  1039,     0,  1040,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,  1044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1045,     0,
       0,     0,     0,     0,  1046,  1047,     0,  1048,  1049,     0,
       0,     0,  1050,     0,     0,     0,     0,     0,  2541,     0,
    1051,  1052,  1053,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1054,  1055,  1056,     0,     0,     0,     0,     0,
    1057,     0,  1058,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   584,    48,    49,
      50,    51,    52,  1059,  1060,  1061,    54,    55,    56,  1062,
      58,    59,    60,    61,    62,    63,  1063,    65,    66,    67,
      68,    69,    70,    71,  1064,   585,     0,   586,   587,    77,
      78,    79,    80,    81,    82,   588,    84,    85,    86,    87,
    1065,    88,   590,    90,    91,    92,    93,    94,   591,  1066,
      96,  1067,  1068,    99,  1069,  1070,  1071,  1072,  1073,     0,
     105,   106,   107,   592,   109,   110,   111,   112,   113,   114,
     115,   116,   117,  1074,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,  1075,  1076,  1077,   594,  1078,
    1079,   135,     0,   136,   137,   138,   139,   140,   141,   142,
     595,   144,   145,   146,   147,   596,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   597,
     162,     0,     0,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   598,   599,   174,     0,  1080,   176,   177,
     600,   179,   180,  1081,   182,  1082,   601,   185,   186,   602,
     188,   189,   603,     0,   191,   192,   193,  1083,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   604,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   605,   214,  1084,
    1085,   217,   218,   219,  1086,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1087,   259,  1088,   261,   262,   263,   264,  1089,
    1090,  1091,  1092,   269,   270,   271,   272,   273,   274,   275,
     276,   277,  1093,  1094,   280,   281,   282,   283,   284,   606,
     285,   286,   287,   288,   289,   290,   291,   292,   293,  1095,
     295,   296,   297,   607,   298,   299,   300,   301,   302,   303,
     304,   305,   306,  1096,   308,   309,   310,   311,   312,  1097,
    1098,   315,   608,   316,   609,   318,   319,  1099,   321,   322,
     323,   324,   325,   326,  1100,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   610,   347,   348,   611,   350,   351,   352,
     353,   354,   355,   356,  1101,   358,   612,   360,   361,   362,
    1102,  1103,   365,   366,   613,   368,   369,  1104,   371,   372,
     373,   374,   375,   376,  1105,   378,   614,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   615,   399,   400,   616,
     402,   403,   404,   405,  1106,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,  1107,  1108,  1109,  1110,   429,   430,   431,
    1111,  1112,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   618,   444,   445,   446,  1113,   448,  1114,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1115,  1116,   619,
    1117,   463,   464,   465,     0,   466,   620,   468,  1118,     0,
       0,     0,   985,   986,   987,   988,   989,  1119,  1120,     0,
       0,     0,     0,  1121,   990,   991,     0,   992,  1122,     0,
       0,     0,  1123,  1124,   993,   994,  1125,  1126,   995,   996,
     997,   998,     0,   999,  1000,     0,  1001,  1002,     0,     0,
       0,     0,  1003,     0,     0,     0,  1004,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,  1009,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1011,  1012,  1013,     0,
    1014,  1015,     0,     0,     0,  1016,  1017,  1018,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,  1020,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,  1023,
    1024,     0,  1025,     0,     0,     0,     0,     0,  1026,     0,
    1027,     0,     0,  1028,     0,     0,  1029,  1030,  1031,     0,
    1032,  1033,  1034,     0,  1035,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1036,
       0,     0,     0,  1037,  1038,  1039,     0,  1040,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,  1044,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1045,     0,     0,     0,
       0,     0,  1046,  1047,     0,  1048,  1049,     0,     0,     0,
    1050,     0,     0,     0,     0,     0,     0,     0,  1051,  1052,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1054,  1055,  1056,     0,     0,     0,     0,     0,  1057,     0,
    1058,  1701,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   584,    48,    49,    50,    51,
      52,  1059,  1060,  1061,    54,    55,    56,  1062,    58,    59,
      60,    61,    62,    63,  1063,    65,    66,    67,    68,    69,
      70,    71,  1064,   585,     0,   586,   587,    77,    78,    79,
      80,    81,    82,   588,    84,    85,    86,    87,  1065,    88,
     590,    90,    91,    92,    93,    94,   591,  1066,    96,  1067,
    1068,    99,  1069,  1070,  1071,  1072,  1073,     0,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,  1074,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,  1075,  1076,  1077,   594,  1078,  1079,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,   596,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   598,   599,   174,     0,  1080,   176,   177,   600,   179,
     180,  1081,   182,  1082,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,  1083,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   605,   214,  1084,  1085,   217,
     218,   219,  1086,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1087,   259,  1088,   261,   262,   263,   264,  1089,  1090,  1091,
    1092,   269,   270,   271,   272,   273,   274,   275,   276,   277,
    1093,  1094,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,   289,   290,   291,   292,   293,  1095,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,  1096,   308,   309,   310,   311,   312,  1097,  1098,   315,
     608,   316,   609,   318,   319,  1099,   321,   322,   323,   324,
     325,   326,  1100,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,  1101,   358,   612,   360,   361,   362,  1102,  1103,
     365,   366,   613,   368,   369,  1104,   371,   372,   373,   374,
     375,   376,  1105,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,  1106,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,  1107,  1108,  1109,  1110,   429,   430,   431,  1111,  1112,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,  1113,   448,  1114,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  1115,  1116,   619,  1117,   463,
     464,   465,     0,   466,   620,   468,  1118,     0,     0,     0,
     985,   986,   987,   988,   989,  1119,  1120,     0,     0,     0,
       0,  1121,   990,   991,     0,   992,  1122,     0,     0,     0,
    1123,  1124,   993,   994,  1125,  1126,   995,   996,   997,   998,
       0,   999,  1000,     0,  1001,  1002,     0,     0,     0,     0,
    1003,     0,     0,     0,  2829,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,  1009,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1011,  1012,  1013,     0,  1014,  1015,
       0,     0,     0,  1016,  1017,  1018,     0,  2830,     0,     0,
       0,     0,     0,  1019,     0,  1020,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,  1023,  1024,     0,
    1025,     0,     0,     0,     0,     0,  1026,     0,  1027,     0,
       0,  1028,     0,     0,  1029,  1030,  1031,     0,  1032,  1033,
    1034,     0,  1035,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1036,     0,     0,
       0,  1037,  1038,  1039,     0,  1040,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,  1044,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1045,     0,     0,     0,     0,     0,
    1046,  1047,     0,  1048,  1049,     0,     0,     0,  1050,     0,
       0,     0,     0,     0,     0,     0,  1051,  1052,  1053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1054,  1055,
    1056,     0,     0,     0,     0,     0,  1057,     0,  1058,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   584,    48,    49,    50,    51,    52,  1059,
    1060,  1061,    54,    55,    56,  1062,    58,    59,    60,    61,
      62,    63,  1063,    65,    66,    67,    68,    69,    70,    71,
    1064,   585,     0,   586,   587,    77,    78,    79,    80,    81,
      82,   588,    84,    85,    86,    87,  1065,    88,   590,    90,
      91,    92,    93,    94,   591,  1066,    96,  1067,  1068,    99,
    1069,  1070,  1071,  1072,  1073,     0,   105,   106,   107,   592,
     109,   110,   111,   112,   113,   114,   115,   116,   117,  1074,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,  1075,  1076,  1077,   594,  1078,  1079,   135,     0,   136,
     137,   138,   139,   140,   141,   142,   595,   144,   145,   146,
     147,   596,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   597,   162,     0,     0,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   598,
     599,   174,     0,  1080,   176,   177,   600,   179,   180,  1081,
     182,  1082,   601,   185,   186,   602,   188,   189,   603,     0,
     191,   192,   193,  1083,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   604,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   605,   214,  1084,  1085,   217,   218,   219,
    1086,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  1087,   259,
    1088,   261,   262,   263,   264,  1089,  1090,  1091,  1092,   269,
     270,   271,   272,   273,   274,   275,   276,   277,  1093,  1094,
     280,   281,   282,   283,   284,   606,   285,   286,   287,   288,
     289,   290,   291,   292,   293,  1095,   295,   296,   297,   607,
     298,   299,   300,   301,   302,   303,   304,   305,   306,  1096,
     308,   309,   310,   311,   312,  1097,  1098,   315,   608,   316,
     609,   318,   319,  1099,   321,   322,   323,   324,   325,   326,
    1100,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   610,
     347,   348,   611,   350,   351,   352,   353,   354,   355,   356,
    1101,   358,   612,   360,   361,   362,  1102,  1103,   365,   366,
     613,   368,   369,  1104,   371,   372,   373,   374,   375,   376,
    1105,   378,   614,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   615,   399,   400,   616,   402,   403,   404,   405,
    1106,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,  1107,
    1108,  1109,  1110,   429,   430,   431,  1111,  1112,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   618,   444,   445,
     446,  1113,   448,  1114,   450,   451,   452,   453,   454,   455,
     456,   457,   458,  1115,  1116,   619,  1117,   463,   464,   465,
       0,   466,   620,   468,  1118,     0,     0,     0,   985,   986,
     987,   988,   989,  1119,  1120,     0,     0,     0,     0,  1121,
     990,   991,     0,   992,  1122,     0,     0,     0,  1123,  1124,
     993,   994,  1125,  1126,   995,   996,   997,   998,     0,   999,
    1000,     0,  1001,  1002,     0,     0,     0,     0,  1003,     0,
       0,     0,  1004,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,  1009,
    1010,     0,     0,     0,     0,     0,  3276,     0,     0,     0,
       0,     0,  1011,  1012,  1013,     0,  1014,  1015,     0,     0,
       0,  1016,  1017,  1018,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,  1020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,     0,     0,  1023,  1024,     0,  1025,     0,
       0,     0,     0,     0,  1026,     0,  1027,     0,     0,  1028,
       0,     0,  1029,  1030,  1031,     0,  1032,  1033,  1034,     0,
    1035,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1036,     0,     0,     0,  1037,
    1038,  1039,     0,  1040,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,  1044,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1045,     0,     0,     0,     0,     0,  1046,  1047,
       0,  1048,  1049,     0,     0,     0,  1050,     0,     0,     0,
       0,     0,     0,     0,  1051,  1052,  1053,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1054,  1055,  1056,     0,
       0,     0,     0,     0,  1057,     0,  1058,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,  1059,  1060,  1061,
      54,    55,    56,  1062,    58,    59,    60,    61,    62,    63,
    1063,    65,    66,    67,    68,    69,    70,    71,  1064,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,  1065,    88,   590,    90,    91,    92,
      93,    94,   591,  1066,    96,  1067,  1068,    99,  1069,  1070,
    1071,  1072,  1073,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,  1074,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,  1075,
    1076,  1077,   594,  1078,  1079,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,  1080,   176,   177,   600,   179,   180,  1081,   182,  1082,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,  1083,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,  1084,  1085,   217,   218,   219,  1086,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1087,   259,  1088,   261,
     262,   263,   264,  1089,  1090,  1091,  1092,   269,   270,   271,
     272,   273,   274,   275,   276,   277,  1093,  1094,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,  1095,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,  1096,   308,   309,
     310,   311,   312,  1097,  1098,   315,   608,   316,   609,   318,
     319,  1099,   321,   322,   323,   324,   325,   326,  1100,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,  1101,   358,
     612,   360,   361,   362,  1102,  1103,   365,   366,   613,   368,
     369,  1104,   371,   372,   373,   374,   375,   376,  1105,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,  1106,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1107,  1108,  1109,
    1110,   429,   430,   431,  1111,  1112,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,  1113,
     448,  1114,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1115,  1116,   619,  1117,   463,   464,   465,     0,   466,
     620,   468,  1118,     0,     0,     0,   985,   986,   987,   988,
     989,  1119,  1120,     0,     0,     0,     0,  1121,   990,   991,
       0,   992,  1122,     0,     0,     0,  1123,  1124,   993,   994,
    1125,  1126,   995,   996,   997,   998,     0,   999,  1000,     0,
    1001,  1002,     0,     0,     0,     0,  1003,     0,     0,     0,
    1004,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,  1009,  1010,     0,
       0,     0,     0,     0,  3278,     0,     0,     0,     0,     0,
    1011,  1012,  1013,     0,  1014,  1015,     0,     0,     0,  1016,
    1017,  1018,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,  1020,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,  1023,  1024,     0,  1025,     0,     0,     0,
       0,     0,  1026,     0,  1027,     0,     0,  1028,     0,     0,
    1029,  1030,  1031,     0,  1032,  1033,  1034,     0,  1035,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1036,     0,     0,     0,  1037,  1038,  1039,
       0,  1040,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
    1044,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1045,     0,     0,     0,     0,     0,  1046,  1047,     0,  1048,
    1049,     0,     0,     0,  1050,     0,     0,     0,     0,     0,
       0,     0,  1051,  1052,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1054,  1055,  1056,     0,     0,     0,
       0,     0,  1057,     0,  1058,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   584,
      48,    49,    50,    51,    52,  1059,  1060,  1061,    54,    55,
      56,  1062,    58,    59,    60,    61,    62,    63,  1063,    65,
      66,    67,    68,    69,    70,    71,  1064,   585,     0,   586,
     587,    77,    78,    79,    80,    81,    82,   588,    84,    85,
      86,    87,  1065,    88,   590,    90,    91,    92,    93,    94,
     591,  1066,    96,  1067,  1068,    99,  1069,  1070,  1071,  1072,
    1073,     0,   105,   106,   107,   592,   109,   110,   111,   112,
     113,   114,   115,   116,   117,  1074,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,  1075,  1076,  1077,
     594,  1078,  1079,   135,     0,   136,   137,   138,   139,   140,
     141,   142,   595,   144,   145,   146,   147,   596,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   597,   162,     0,     0,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   598,   599,   174,     0,  1080,
     176,   177,   600,   179,   180,  1081,   182,  1082,   601,   185,
     186,   602,   188,   189,   603,     0,   191,   192,   193,  1083,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   604,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   605,
     214,  1084,  1085,   217,   218,   219,  1086,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1087,   259,  1088,   261,   262,   263,
     264,  1089,  1090,  1091,  1092,   269,   270,   271,   272,   273,
     274,   275,   276,   277,  1093,  1094,   280,   281,   282,   283,
     284,   606,   285,   286,   287,   288,   289,   290,   291,   292,
     293,  1095,   295,   296,   297,   607,   298,   299,   300,   301,
     302,   303,   304,   305,   306,  1096,   308,   309,   310,   311,
     312,  1097,  1098,   315,   608,   316,   609,   318,   319,  1099,
     321,   322,   323,   324,   325,   326,  1100,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   610,   347,   348,   611,   350,
     351,   352,   353,   354,   355,   356,  1101,   358,   612,   360,
     361,   362,  1102,  1103,   365,   366,   613,   368,   369,  1104,
     371,   372,   373,   374,   375,   376,  1105,   378,   614,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   615,   399,
     400,   616,   402,   403,   404,   405,  1106,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1107,  1108,  1109,  1110,   429,
     430,   431,  1111,  1112,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   618,   444,   445,   446,  1113,   448,  1114,
     450,   451,   452,   453,   454,   455,   456,   457,   458,  1115,
    1116,   619,  1117,   463,   464,   465,     0,   466,   620,   468,
    1118,     0,     0,     0,   985,   986,   987,   988,   989,  1119,
    1120,     0,     0,     0,     0,  1121,   990,   991,     0,   992,
    1122,     0,     0,     0,  1123,  1124,   993,   994,  1125,  1126,
     995,   996,   997,   998,     0,   999,  1000,     0,  1001,  1002,
       0,     0,     0,     0,  1003,     0,     0,     0,  1004,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,  1009,  1010,     0,     0,     0,
       0,     0,  3280,     0,     0,     0,     0,     0,  1011,  1012,
    1013,     0,  1014,  1015,     0,     0,     0,  1016,  1017,  1018,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,  1020,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,  1023,  1024,     0,  1025,     0,     0,     0,     0,     0,
    1026,     0,  1027,     0,     0,  1028,     0,     0,  1029,  1030,
    1031,     0,  1032,  1033,  1034,     0,  1035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1036,     0,     0,     0,  1037,  1038,  1039,     0,  1040,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,  1044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1045,     0,
       0,     0,     0,     0,  1046,  1047,     0,  1048,  1049,     0,
       0,     0,  1050,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,  1053,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1054,  1055,  1056,     0,     0,     0,     0,     0,
    1057,     0,  1058,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   584,    48,    49,
      50,    51,    52,  1059,  1060,  1061,    54,    55,    56,  1062,
      58,    59,    60,    61,    62,    63,  1063,    65,    66,    67,
      68,    69,    70,    71,  1064,   585,     0,   586,   587,    77,
      78,    79,    80,    81,    82,   588,    84,    85,    86,    87,
    1065,    88,   590,    90,    91,    92,    93,    94,   591,  1066,
      96,  1067,  1068,    99,  1069,  1070,  1071,  1072,  1073,     0,
     105,   106,   107,   592,   109,   110,   111,   112,   113,   114,
     115,   116,   117,  1074,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,  1075,  1076,  1077,   594,  1078,
    1079,   135,     0,   136,   137,   138,   139,   140,   141,   142,
     595,   144,   145,   146,   147,   596,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   597,
     162,     0,     0,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   598,   599,   174,     0,  1080,   176,   177,
     600,   179,   180,  1081,   182,  1082,   601,   185,   186,   602,
     188,   189,   603,     0,   191,   192,   193,  1083,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   604,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   605,   214,  1084,
    1085,   217,   218,   219,  1086,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1087,   259,  1088,   261,   262,   263,   264,  1089,
    1090,  1091,  1092,   269,   270,   271,   272,   273,   274,   275,
     276,   277,  1093,  1094,   280,   281,   282,   283,   284,   606,
     285,   286,   287,   288,   289,   290,   291,   292,   293,  1095,
     295,   296,   297,   607,   298,   299,   300,   301,   302,   303,
     304,   305,   306,  1096,   308,   309,   310,   311,   312,  1097,
    1098,   315,   608,   316,   609,   318,   319,  1099,   321,   322,
     323,   324,   325,   326,  1100,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   610,   347,   348,   611,   350,   351,   352,
     353,   354,   355,   356,  1101,   358,   612,   360,   361,   362,
    1102,  1103,   365,   366,   613,   368,   369,  1104,   371,   372,
     373,   374,   375,   376,  1105,   378,   614,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   615,   399,   400,   616,
     402,   403,   404,   405,  1106,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,  1107,  1108,  1109,  1110,   429,   430,   431,
    1111,  1112,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   618,   444,   445,   446,  1113,   448,  1114,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1115,  1116,   619,
    1117,   463,   464,   465,     0,   466,   620,   468,  1118,     0,
       0,     0,   985,   986,   987,   988,   989,  1119,  1120,     0,
       0,     0,     0,  1121,   990,   991,     0,   992,  1122,     0,
       0,     0,  1123,  1124,   993,   994,  1125,  1126,   995,   996,
     997,   998,     0,   999,  1000,     0,  1001,  1002,     0,     0,
       0,     0,  1003,     0,     0,     0,  4956,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,  1009,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1011,  1012,  1013,     0,
    1014,  1015,     0,     0,     0,  1016,  1017,  1018,     0,  2830,
       0,     0,     0,     0,     0,  1019,     0,  1020,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,  1023,
    1024,     0,  1025,     0,     0,     0,     0,     0,  1026,     0,
    1027,     0,     0,  1028,     0,     0,  1029,  1030,  1031,     0,
    1032,  1033,  1034,     0,  1035,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1036,
       0,     0,     0,  1037,  1038,  1039,     0,  1040,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,  1044,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1045,     0,     0,     0,
       0,     0,  1046,  1047,     0,  1048,  1049,     0,     0,     0,
    1050,     0,     0,     0,     0,     0,     0,     0,  1051,  1052,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1054,  1055,  1056,     0,     0,     0,     0,     0,  1057,     0,
    1058,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   584,    48,    49,    50,    51,
      52,  1059,  1060,  1061,    54,    55,    56,  1062,    58,    59,
      60,    61,    62,    63,  1063,    65,    66,    67,    68,    69,
      70,    71,  1064,   585,     0,   586,   587,    77,    78,    79,
      80,    81,    82,   588,    84,    85,    86,    87,  1065,    88,
     590,    90,    91,    92,    93,    94,   591,  1066,    96,  1067,
    1068,    99,  1069,  1070,  1071,  1072,  1073,     0,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,  1074,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,  1075,  1076,  1077,   594,  1078,  1079,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,   596,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   598,   599,   174,     0,  1080,   176,   177,   600,   179,
     180,  1081,   182,  1082,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,  1083,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   605,   214,  1084,  1085,   217,
     218,   219,  1086,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1087,   259,  1088,   261,   262,   263,   264,  1089,  1090,  1091,
    1092,   269,   270,   271,   272,   273,   274,   275,   276,   277,
    1093,  1094,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,   289,   290,   291,   292,   293,  1095,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,  1096,   308,   309,   310,   311,   312,  1097,  1098,   315,
     608,   316,   609,   318,   319,  1099,   321,   322,   323,   324,
     325,   326,  1100,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,  1101,   358,   612,   360,   361,   362,  1102,  1103,
     365,   366,   613,   368,   369,  1104,   371,   372,   373,   374,
     375,   376,  1105,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,  1106,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,  1107,  1108,  1109,  1110,   429,   430,   431,  1111,  1112,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,  1113,   448,  1114,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  1115,  1116,   619,  1117,   463,
     464,   465,     0,   466,   620,   468,  1118,     0,     0,     0,
     985,   986,   987,   988,   989,  1119,  1120,     0,     0,     0,
       0,  1121,   990,   991,     0,   992,  1122,     0,     0,     0,
    1123,  1124,   993,   994,  1125,  1126,   995,   996,   997,   998,
       0,   999,  1000,     0,  1001,  1002,     0,     0,     0,     0,
    1003,     0,     0,     0,  1004,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,  1009,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1011,  1012,  1013,     0,  1014,  1015,
       0,     0,     0,  1016,  1017,  1018,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,  1020,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,  1023,  1024,     0,
    1025,     0,     0,     0,     0,     0,  1026,     0,  1027,     0,
       0,  1028,     0,     0,  1029,  1030,  1031,     0,  1032,  1033,
    1034,     0,  1035,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1036,     0,     0,
       0,  1037,  1038,  1039,     0,  1040,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,  1044,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1045,     0,     0,     0,     0,     0,
    1046,  1047,     0,  1048,  1049,     0,     0,     0,  1050,     0,
       0,     0,     0,     0,     0,     0,  1051,  1052,  1053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1054,  1055,
    1056,     0,     0,     0,     0,     0,  1057,     0,  1058,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   584,    48,    49,    50,    51,    52,  1059,
    1060,  1061,    54,    55,    56,  1062,    58,    59,    60,    61,
      62,    63,  1063,    65,    66,    67,    68,    69,    70,    71,
    1064,   585,     0,   586,   587,    77,    78,    79,    80,    81,
      82,   588,    84,    85,    86,    87,  1065,    88,   590,    90,
      91,    92,    93,    94,   591,  1066,    96,  1067,  1068,    99,
    1069,  1070,  1071,  1072,  1073,     0,   105,   106,   107,   592,
     109,   110,   111,   112,   113,   114,   115,   116,   117,  1074,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,  1075,  1076,  1077,   594,  1078,  1079,   135,     0,   136,
     137,   138,   139,   140,   141,   142,   595,   144,   145,   146,
     147,   596,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   597,   162,     0,     0,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   598,
     599,   174,     0,  1080,   176,   177,   600,   179,   180,  1081,
     182,  1082,   601,   185,   186,   602,   188,   189,   603,     0,
     191,   192,   193,  1083,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   604,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   605,   214,  1084,  1085,   217,   218,   219,
    1086,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  1087,   259,
    1088,   261,   262,   263,   264,  1089,  1090,  1091,  1092,   269,
     270,   271,   272,   273,   274,   275,   276,   277,  1093,  1094,
     280,   281,   282,   283,   284,   606,   285,   286,   287,   288,
     289,   290,   291,   292,   293,  1095,   295,   296,   297,   607,
     298,   299,   300,   301,   302,   303,   304,   305,   306,  1096,
     308,   309,   310,   311,   312,  1097,  1098,   315,   608,   316,
     609,   318,   319,  1099,   321,   322,   323,   324,   325,   326,
    1100,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   610,
     347,   348,   611,   350,   351,   352,   353,   354,   355,   356,
    1101,   358,   612,   360,   361,   362,  1102,  1103,   365,   366,
     613,   368,   369,  1104,   371,   372,   373,   374,   375,   376,
    1105,   378,   614,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   615,   399,   400,   616,   402,   403,   404,   405,
    1106,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,  1107,
    1108,  1109,  1110,   429,   430,   431,  1111,  1112,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   618,   444,   445,
     446,  1113,   448,  1114,   450,   451,   452,   453,   454,   455,
     456,   457,   458,  1115,  1116,   619,  1117,   463,   464,   465,
       0,   466,   620,   468,  1118,     0,     0,     0,   985,   986,
     987,   988,   989,  1119,  1120,     0,     0,     0,     0,  1121,
     990,   991,     0,   992,  1122,     0,     0,     0,  1123,  1124,
     993,   994,  1125,  1126,   995,   996,   997,   998,     0,   999,
    1000,     0,  1001,  1002,     0,     0,     0,     0,  1003,     0,
       0,     0,  1004,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,  1009,
    1010,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1011,  1012,  1013,     0,  1014,  1015,     0,     0,
       0,  1016,  1017,  1018,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,  1020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,     0,     0,  1023,  1024,     0,  1025,     0,
       0,     0,     0,     0,  1026,     0,  1027,     0,     0,  1028,
       0,     0,  1029,  1030,  1031,     0,  1032,  1033,  1034,     0,
    1035,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1036,     0,     0,     0,  1037,
    1038,  1039,     0,  1040,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,  1044,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1045,     0,     0,     0,     0,     0,  1046,  1047,
       0,  1048,  1049,     0,     0,     0,  1050,     0,     0,     0,
       0,     0,     0,     0,  1051,  1052,  1053,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1054,  1055,  1056,     0,
       0,     0,     0,     0,  1057,     0,  1058,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,  1059,  1060,  1061,
      54,    55,    56,  1062,    58,    59,    60,    61,    62,    63,
    1063,    65,    66,    67,    68,    69,    70,    71,  1064,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,  1065,    88,   590,    90,    91,    92,
      93,    94,   591,  1066,    96,  1067,  1068,    99,  1069,  1070,
    1071,  1072,  1073,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,  1074,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,  1075,
    1076,  1077,   594,  1078,  1079,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,  1080,   176,   177,   600,   179,   180,  1081,   182,  1082,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,  1083,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,  1084,  1085,   217,   218,   219,  1086,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1087,   259,  1088,   261,
     262,   263,   264,  1089,  1090,  1091,  1092,   269,   270,   271,
     272,   273,   274,   275,   276,   277,  1093,  1094,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,  1095,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,  1096,   308,   309,
     310,   311,   312,  1097,  1098,   315,   608,   316,   609,   318,
     319,  1099,   321,   322,   323,   324,   325,   326,  1100,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,  1101,   358,
     612,   360,   361,   362,  1102,  1103,   365,   366,   613,   368,
     369,  1104,   371,   372,   373,   374,   375,   376,  1105,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,  1106,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1107,  1108,  1109,
    1110,   429,   430,   431,  1111,  1112,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,  1113,
     448,  1114,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1115,  1116,   619,  1117,   463,   464,   465,     0,   466,
     620,   468,  1118,     0,     0,     0,   985,   986,   987,   988,
     989,  1119,  1120,     0,     0,     0,     0,  1121,   990,   991,
       0,   992,  1728,     0,     0,     0,  1123,  1124,   993,   994,
    1125,  1126,   995,   996,   997,   998,     0,   999,  1000,     0,
    1001,  1002,     0,     0,     0,     0,  1003,     0,     0,     0,
    1004,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,  1009,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1011,  1012,  1013,     0,  1014,  1015,     0,     0,     0,  1016,
    1017,  1018,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,  1020,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,  1023,  1024,     0,  1025,     0,     0,     0,
       0,     0,  1026,     0,  1027,     0,     0,  1028,     0,     0,
    1029,  1030,  1031,     0,  1032,  1033,  1034,     0,  1035,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1036,     0,     0,     0,  1037,  1038,  1039,
       0,  1040,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
    1044,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1045,     0,     0,     0,     0,     0,  1046,  1047,     0,  1048,
    1049,     0,     0,     0,  1050,     0,     0,     0,     0,     0,
       0,     0,  1051,  1052,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1054,  1055,  1056,     0,     0,     0,
       0,     0,  1057,     0,  1058,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   584,
      48,    49,    50,    51,    52,  1059,  1060,  1061,    54,    55,
      56,  1062,    58,    59,    60,    61,    62,    63,  1063,    65,
      66,    67,    68,    69,    70,    71,  1064,   585,     0,   586,
     587,    77,    78,    79,    80,    81,    82,   588,    84,    85,
      86,    87,  1065,    88,   590,    90,    91,    92,    93,    94,
     591,  1066,    96,  1067,  1068,    99,  1069,  1070,  1071,  1072,
    1073,     0,   105,   106,   107,   592,   109,   110,   111,   112,
     113,   114,   115,   116,   117,  1074,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,  1075,  1076,  1077,
     594,  1078,  1079,   135,     0,   136,   137,   138,   139,   140,
     141,   142,   595,   144,   145,   146,   147,   596,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   597,   162,     0,     0,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   598,   599,   174,     0,  1080,
     176,   177,   600,   179,   180,  1081,   182,  1082,   601,   185,
     186,   602,   188,   189,   603,     0,   191,   192,   193,  1083,
    2397,   196,   197,   198,   199,   200,   201,   202,   203,   604,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   605,
     214,  1084,  1085,   217,   218,   219,  1086,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1087,   259,  1088,   261,   262,   263,
     264,  1089,  1090,  1091,  1092,   269,   270,   271,   272,   273,
     274,   275,   276,   277,  1093,  1094,   280,   281,   282,   283,
     284,   606,   285,   286,   287,   288,   289,   290,   291,   292,
     293,  1095,   295,   296,   297,   607,   298,   299,   300,   301,
     302,   303,   304,   305,   306,  1096,   308,   309,   310,   311,
     312,  1097,  1098,   315,   608,   316,   609,   318,   319,  1099,
     321,   322,   323,   324,   325,   326,  1100,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   610,   347,   348,   611,   350,
     351,   352,   353,   354,   355,   356,  1101,   358,   612,   360,
     361,   362,  1102,  1103,   365,   366,   613,   368,   369,  1104,
     371,   372,   373,   374,   375,   376,  1105,   378,   614,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   615,   399,
     400,   616,   402,   403,   404,   405,  1106,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1107,  1108,  1109,  1110,   429,
     430,   431,  1111,  1112,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   618,   444,   445,   446,  2398,   448,  1114,
     450,   451,   452,   453,   454,   455,   456,   457,   458,  1115,
    1116,   619,  1117,   463,   464,   465,     0,   466,   620,   468,
    1118,     0,     0,     0,   985,   986,   987,   988,   989,  1119,
    1120,     0,     0,     0,     0,  1121,   990,   991,     0,   992,
    1122,     0,     0,     0,  1123,  1124,   993,   994,  1125,  1126,
     995,   996,   997,   998,     0,   999,  1000,     0,  1001,  1002,
       0,     0,     0,     0,  1003,     0,     0,     0,  1004,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,  1009,  1010,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1011,  1012,
    1013,     0,  1014,  1015,     0,     0,     0,  1016,  1017,  1018,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,  1020,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,  1023,  1024,     0,  1025,     0,     0,     0,     0,     0,
    1026,     0,  1027,     0,     0,  1028,     0,     0,  1029,  1030,
    1031,     0,  1032,  1033,  1034,     0,  1035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1036,     0,     0,     0,  1037,  1038,  1039,     0,  1040,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,  1044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1045,     0,
       0,     0,     0,     0,  1046,  1047,     0,  1048,  1049,     0,
       0,     0,  1050,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,  1053,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1054,  1055,  1056,     0,     0,     0,     0,     0,
    1057,     0,  1058,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   584,    48,    49,
      50,    51,    52,  1059,  1060,  1061,    54,    55,    56,  1062,
      58,    59,    60,    61,    62,    63,  1063,    65,    66,    67,
      68,    69,    70,    71,  1064,   585,     0,   586,   587,    77,
      78,    79,    80,    81,    82,   588,    84,    85,    86,    87,
    1065,    88,   590,    90,    91,    92,    93,    94,   591,  1066,
      96,  1067,  1068,    99,  1069,  1070,  1071,  1072,  1073,     0,
     105,   106,   107,   592,   109,   110,   111,   112,   113,   114,
     115,   116,   117,  1074,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,  1075,  1076,  1077,   594,  1078,
    1079,   135,     0,   136,   137,   138,   139,   140,   141,   142,
     595,   144,   145,   146,   147,   596,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   597,
     162,     0,     0,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   598,   599,   174,     0,  1080,   176,   177,
     600,   179,   180,  1081,   182,  1082,   601,   185,   186,   602,
     188,   189,   603,     0,   191,   192,   193,  1083,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   604,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   605,   214,  1084,
    1085,   217,   218,   219,  1086,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1087,   259,  1088,   261,   262,   263,   264,  1089,
    1090,  1091,  1092,   269,   270,   271,   272,   273,   274,   275,
     276,   277,  1093,  1094,   280,   281,   282,   283,   284,   606,
     285,   286,   287,   288,   289,   290,   291,   292,   293,  1095,
     295,   296,   297,   607,   298,   299,   300,   301,   302,   303,
     304,   305,   306,  1096,   308,   309,   310,   311,   312,  1097,
    1098,   315,   608,   316,   609,   318,   319,  1099,   321,   322,
     323,   324,   325,   326,  1100,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   610,   347,   348,   611,   350,   351,   352,
     353,   354,   355,   356,  1101,   358,   612,   360,   361,   362,
    1102,  1103,   365,   366,   613,   368,   369,  1104,   371,   372,
     373,   374,   375,   376,  1105,   378,   614,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   615,   399,   400,   616,
     402,   403,   404,   405,  1106,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,  1107,  1108,  1109,  1110,   429,   430,   431,
    1111,  1112,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   618,   444,   445,   446,  2398,   448,  1114,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1115,  1116,   619,
    1117,   463,   464,   465,     0,   466,   620,   468,  1118,     0,
       0,     0,   985,   986,   987,   988,   989,  1119,  1120,     0,
       0,     0,     0,  1121,   990,   991,     0,   992,  1122,     0,
       0,     0,  1123,  1124,   993,   994,  1125,  1126,   995,   996,
     997,   998,     0,   999,  1000,     0,  1001,  1002,     0,     0,
       0,     0,  1003,     0,     0,     0,  1004,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,  1009,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1011,  1012,  1013,     0,
    1014,  1015,     0,     0,     0,  1016,  1017,  1018,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,  3891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,  1023,
    1024,     0,  1025,     0,     0,     0,     0,     0,  1026,     0,
    1027,     0,     0,  1028,     0,     0,  1029,  1030,  1031,     0,
    1032,  1033,  1034,     0,  1035,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1036,
       0,     0,     0,  1037,  1038,  1039,     0,  1040,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,  1044,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1045,     0,     0,     0,
       0,     0,  1046,  1047,     0,  1048,  1049,     0,     0,     0,
    1050,     0,     0,     0,     0,     0,     0,     0,  1051,  1052,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1054,  1055,  1056,     0,     0,     0,     0,     0,  1057,     0,
    1058,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   584,    48,    49,    50,    51,
      52,  1059,  1060,  1061,    54,    55,    56,  1062,    58,    59,
      60,    61,    62,    63,  1063,    65,    66,    67,    68,    69,
      70,    71,  1064,   585,     0,   586,   587,    77,    78,    79,
      80,    81,    82,   588,    84,    85,    86,    87,  1065,    88,
     590,    90,    91,    92,    93,    94,   591,  1066,    96,  1067,
    1068,    99,  1069,  1070,  1071,  1072,  1073,     0,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,  1074,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,  1075,  1076,  1077,   594,  1078,  1079,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,   596,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   598,   599,   174,     0,  1080,   176,   177,   600,   179,
     180,  1081,   182,  1082,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,  1083,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   605,   214,  1084,  1085,   217,
     218,   219,  1086,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1087,   259,  1088,   261,   262,   263,   264,  1089,  1090,  1091,
    1092,   269,   270,   271,   272,   273,   274,   275,   276,   277,
    1093,  1094,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,   289,   290,   291,   292,   293,  1095,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,  1096,   308,   309,   310,   311,   312,  1097,  1098,   315,
     608,   316,   609,   318,   319,  1099,   321,   322,   323,   324,
     325,   326,  1100,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,  1101,   358,   612,   360,   361,   362,  1102,  1103,
     365,   366,   613,   368,   369,  1104,   371,   372,   373,   374,
     375,   376,  1105,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,  1106,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,  1107,  1108,  1109,  1110,   429,   430,   431,  1111,  1112,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,  1113,   448,  1114,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  1115,  1116,   619,  1117,   463,
     464,   465,     0,   466,   620,   468,  1118,     0,     0,     0,
     985,   986,   987,   988,   989,  1119,  1120,     0,     0,     0,
       0,  1121,   990,   991,     0,   992,  1122,     0,     0,     0,
    1123,  1124,   993,   994,  1125,  1126,   995,   996,   997,   998,
       0,   999,  1000,     0,  1001,  1002,     0,     0,     0,     0,
    1003,     0,     0,     0,  1004,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,  1009,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1011,  1012,  1013,     0,  1014,  1015,
       0,     0,     0,  1016,  1017,  1018,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,  3913,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,  1023,  1024,     0,
    1025,     0,     0,     0,     0,     0,  1026,     0,  1027,     0,
       0,  1028,     0,     0,  1029,  1030,  1031,     0,  1032,  1033,
    1034,     0,  1035,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1036,     0,     0,
       0,  1037,  1038,  1039,     0,  1040,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,  1044,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1045,     0,     0,     0,     0,     0,
    1046,  1047,     0,  1048,  1049,     0,     0,     0,  1050,     0,
       0,     0,     0,     0,     0,     0,  1051,  1052,  1053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1054,  1055,
    1056,     0,     0,     0,     0,     0,  1057,     0,  1058,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   584,    48,    49,    50,    51,    52,  1059,
    1060,  1061,    54,    55,    56,  1062,    58,    59,    60,    61,
      62,    63,  1063,    65,    66,    67,    68,    69,    70,    71,
    1064,   585,     0,   586,   587,    77,    78,    79,    80,    81,
      82,   588,    84,    85,    86,    87,  1065,    88,   590,    90,
      91,    92,    93,    94,   591,  1066,    96,  1067,  1068,    99,
    1069,  1070,  1071,  1072,  1073,     0,   105,   106,   107,   592,
     109,   110,   111,   112,   113,   114,   115,   116,   117,  1074,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,  1075,  1076,  1077,   594,  1078,  1079,   135,     0,   136,
     137,   138,   139,   140,   141,   142,   595,   144,   145,   146,
     147,   596,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   597,   162,     0,     0,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   598,
     599,   174,     0,  1080,   176,   177,   600,   179,   180,  1081,
     182,  1082,   601,   185,   186,   602,   188,   189,   603,     0,
     191,   192,   193,  1083,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   604,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   605,   214,  1084,  1085,   217,   218,   219,
    1086,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  1087,   259,
    1088,   261,   262,   263,   264,  1089,  1090,  1091,  1092,   269,
     270,   271,   272,   273,   274,   275,   276,   277,  1093,  1094,
     280,   281,   282,   283,   284,   606,   285,   286,   287,   288,
     289,   290,   291,   292,   293,  1095,   295,   296,   297,   607,
     298,   299,   300,   301,   302,   303,   304,   305,   306,  1096,
     308,   309,   310,   311,   312,  1097,  1098,   315,   608,   316,
     609,   318,   319,  1099,   321,   322,   323,   324,   325,   326,
    1100,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   610,
     347,   348,   611,   350,   351,   352,   353,   354,   355,   356,
    1101,   358,   612,   360,   361,   362,  1102,  1103,   365,   366,
     613,   368,   369,  1104,   371,   372,   373,   374,   375,   376,
    1105,   378,   614,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   615,   399,   400,   616,   402,   403,   404,   405,
    1106,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,  1107,
    1108,  1109,  1110,   429,   430,   431,  1111,  1112,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   618,   444,   445,
     446,  1113,   448,  1114,   450,   451,   452,   453,   454,   455,
     456,   457,   458,  1115,  1116,   619,  1117,   463,   464,   465,
       0,   466,   620,   468,  1118,     0,     0,     0,   985,   986,
     987,   988,   989,  1119,  1120,     0,     0,     0,     0,  1121,
     990,   991,     0,   992,  1122,     0,     0,     0,  1123,  1124,
     993,   994,  1125,  1126,   995,   996,   997,   998,     0,   999,
    1000,     0,  1001,  1002,     0,     0,     0,     0,  1003,     0,
       0,     0,  1004,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,  1009,
    1010,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1011,  1012,  1013,     0,  1014,  1015,     0,     0,
       0,  1016,  1017,  1018,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,  1020,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,     0,     0,  1023,  1024,  6009,  1025,     0,
       0,     0,     0,     0,  1026,     0,  1027,     0,     0,  1028,
       0,     0,  1029,     0,  1031,     0,  1032,  1033,  1034,     0,
    1035,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1036,     0,     0,     0,  1037,
    1038,  1039,     0,  1040,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,  1044,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1045,     0,     0,     0,     0,     0,  1046,  1047,
       0,  1048,  1049,     0,     0,     0,  1050,     0,     0,     0,
       0,     0,     0,     0,  1051,  1052,  1053,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1054,  1055,  1056,     0,
       0,     0,     0,     0,  1057,     0,  1058,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,  1059,  1060,  1061,
      54,    55,    56,  1062,    58,    59,    60,    61,    62,    63,
    1063,    65,    66,    67,    68,    69,    70,    71,  1064,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,  1065,    88,   590,    90,    91,    92,
      93,    94,   591,  1066,    96,  1067,  1068,    99,  1069,  1070,
    1071,  1072,  1073,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,  1074,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,  1075,
    1076,  1077,   594,  1078,  1079,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,  1080,   176,   177,   600,   179,   180,  1081,   182,  1082,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,  1083,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,  1084,  1085,   217,   218,   219,  1086,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1087,   259,  1088,   261,
     262,   263,   264,  1089,  1090,  1091,  1092,   269,   270,   271,
     272,   273,   274,   275,   276,   277,  1093,  1094,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,  1095,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,  1096,   308,   309,
     310,   311,   312,  1097,  1098,   315,   608,   316,   609,   318,
     319,  1099,   321,   322,   323,   324,   325,   326,  1100,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,  1101,   358,
     612,   360,   361,   362,  1102,  1103,   365,   366,   613,   368,
     369,  1104,   371,   372,   373,   374,   375,   376,  1105,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,  1106,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1107,  1108,  1109,
    1110,   429,   430,   431,  1111,  1112,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,  1113,
     448,  1114,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1115,  1116,   619,  1117,   463,   464,   465,     0,   466,
     620,   468,  1118,     0,     0,     0,   985,   986,   987,   988,
     989,  1119,  1120,     0,     0,     0,     0,  1121,   990,   991,
       0,   992,  1122,     0,     0,     0,  1123,  1124,   993,   994,
    1125,  1126,   995,   996,   997,   998,     0,   999,  1000,     0,
    1001,  1002,     0,     0,     0,     0,  1003,     0,     0,     0,
    1004,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,  1009,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1011,  1012,  1013,     0,  1014,  1015,     0,     0,     0,  1016,
    1017,  1018,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,  1694,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,  1023,  1024,     0,  1025,     0,     0,     0,
       0,     0,  1026,     0,  1027,     0,     0,  1028,     0,     0,
    1029,     0,  1031,     0,  1032,  1033,  1034,     0,  1035,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1036,     0,     0,     0,  1037,  1038,  1039,
       0,  1040,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
    1044,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1045,     0,     0,     0,     0,     0,  1046,  1047,     0,  1048,
    1049,     0,     0,     0,  1050,     0,     0,     0,     0,     0,
       0,     0,  1051,  1052,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1054,  1055,  1056,     0,     0,     0,
       0,     0,  1057,     0,  1058,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   584,
      48,    49,    50,    51,    52,  1059,  1060,  1061,    54,    55,
      56,  1062,    58,    59,    60,    61,    62,    63,  1063,    65,
      66,    67,    68,    69,    70,    71,  1064,   585,     0,   586,
     587,    77,    78,    79,    80,    81,    82,   588,    84,    85,
      86,    87,  1065,    88,   590,    90,    91,    92,    93,    94,
     591,  1066,    96,  1067,  1068,    99,  1069,  1070,  1071,  1072,
    1073,     0,   105,   106,   107,   592,   109,   110,   111,   112,
     113,   114,   115,   116,   117,  1074,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,  1075,  1076,  1077,
     594,  1078,  1079,   135,     0,   136,   137,   138,   139,   140,
     141,   142,   595,   144,   145,   146,   147,   596,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   597,   162,     0,     0,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   598,   599,   174,     0,  1080,
     176,   177,   600,   179,   180,  1081,   182,  1082,   601,   185,
     186,   602,   188,   189,   603,     0,   191,   192,   193,  1083,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   604,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   605,
     214,  1084,  1085,   217,   218,   219,  1086,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1087,   259,  1088,   261,   262,   263,
     264,  1089,  1090,  1091,  1092,   269,   270,   271,   272,   273,
     274,   275,   276,   277,  1093,  1094,   280,   281,   282,   283,
     284,   606,   285,   286,   287,   288,   289,   290,   291,   292,
     293,  1095,   295,   296,   297,   607,   298,   299,   300,   301,
     302,   303,   304,   305,   306,  1096,   308,   309,   310,   311,
     312,  1097,  1098,   315,   608,   316,   609,   318,   319,  1099,
     321,   322,   323,   324,   325,   326,  1100,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   610,   347,   348,   611,   350,
     351,   352,   353,   354,   355,   356,  1101,   358,   612,   360,
     361,   362,  1102,  1103,   365,   366,   613,   368,   369,  1104,
     371,   372,   373,   374,   375,   376,  1105,   378,   614,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   615,   399,
     400,   616,   402,   403,   404,   405,  1106,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1107,  1108,  1109,  1110,   429,
     430,   431,  1111,  1112,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   618,   444,   445,   446,  1113,   448,  1114,
     450,   451,   452,   453,   454,   455,   456,   457,   458,  1115,
    1116,   619,  1117,   463,   464,   465,     0,   466,   620,   468,
    1118,     0,     0,     0,   985,   986,   987,   988,   989,  1695,
    1696,     0,     0,     0,     0,  1121,   990,   991,     0,   992,
    1122,     0,     0,     0,  1123,  1124,   993,   994,  1125,  1126,
     995,   996,   997,   998,     0,   999,  1000,     0,  1001,  1002,
       0,     0,     0,     0,  1003,     0,     0,     0,  1004,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,  1009,  1010,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1011,  1012,
    1013,     0,  1014,  1015,     0,     0,     0,  1016,  1017,  1018,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,  1832,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,  1023,  1024,     0,  1025,     0,     0,     0,     0,     0,
    1026,     0,  1027,     0,     0,  1028,     0,     0,  1029,     0,
    1031,     0,  1032,  1033,  1034,     0,  1035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1036,     0,     0,     0,  1037,  1038,  1039,     0,  1040,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,  1044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1045,     0,
       0,     0,     0,     0,  1046,  1047,     0,  1048,  1049,     0,
       0,     0,  1050,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,  1053,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1054,  1055,  1056,     0,     0,     0,     0,     0,
    1057,     0,  1058,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   584,    48,    49,
      50,    51,    52,  1059,  1060,  1061,    54,    55,    56,  1062,
      58,    59,    60,    61,    62,    63,  1063,    65,    66,    67,
      68,    69,    70,    71,  1064,   585,     0,   586,   587,    77,
      78,    79,    80,    81,    82,   588,    84,    85,    86,    87,
    1065,    88,   590,    90,    91,    92,    93,    94,   591,  1066,
      96,  1067,  1068,    99,  1069,  1070,  1071,  1072,  1073,     0,
     105,   106,   107,   592,   109,   110,   111,   112,   113,   114,
     115,   116,   117,  1074,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,  1075,  1076,  1077,   594,  1078,
    1079,   135,     0,   136,   137,   138,   139,   140,   141,   142,
     595,   144,   145,   146,   147,   596,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   597,
     162,     0,     0,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   598,   599,   174,     0,  1080,   176,   177,
     600,   179,   180,  1081,   182,  1082,   601,   185,   186,   602,
     188,   189,   603,     0,   191,   192,   193,  1083,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   604,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   605,   214,  1084,
    1085,   217,   218,   219,  1086,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1087,   259,  1088,   261,   262,   263,   264,  1089,
    1090,  1091,  1092,   269,   270,   271,   272,   273,   274,   275,
     276,   277,  1093,  1094,   280,   281,   282,   283,   284,   606,
     285,   286,   287,   288,   289,   290,   291,   292,   293,  1095,
     295,   296,   297,   607,   298,   299,   300,   301,   302,   303,
     304,   305,   306,  1096,   308,   309,   310,   311,   312,  1097,
    1098,   315,   608,   316,   609,   318,   319,  1099,   321,   322,
     323,   324,   325,   326,  1100,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   610,   347,   348,   611,   350,   351,   352,
     353,   354,   355,   356,  1101,   358,   612,   360,   361,   362,
    1102,  1103,   365,   366,   613,   368,   369,  1104,   371,   372,
     373,   374,   375,   376,  1105,   378,   614,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   615,   399,   400,   616,
     402,   403,   404,   405,  1106,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,  1107,  1108,  1109,  1110,   429,   430,   431,
    1111,  1112,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   618,   444,   445,   446,  1113,   448,  1114,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1115,  1116,   619,
    1117,   463,   464,   465,     0,   466,   620,   468,  1118,     0,
       0,     0,   985,   986,   987,   988,   989,  1695,  1696,     0,
       0,     0,     0,  1121,   990,   991,     0,   992,  1122,     0,
       0,     0,  1123,  1124,   993,   994,  1125,  1126,   995,   996,
     997,   998,     0,   999,  1000,     0,  1001,  1002,     0,     0,
       0,     0,  1003,     0,     0,     0,  1004,     0,     0,  1005,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1006,
    1007,  1008,     0,  1009,  1010,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1011,  1012,  1013,     0,
    1014,  1015,     0,     0,     0,  1016,  1017,  1018,     0,     0,
       0,     0,     0,     0,     0,  1019,     0,  1834,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1021,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1022,     0,     0,     0,     0,  1023,
    1024,     0,  1025,     0,     0,     0,     0,     0,  1026,     0,
    1027,     0,     0,  1028,     0,     0,  1029,     0,  1031,     0,
    1032,  1033,  1034,     0,  1035,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1036,
       0,     0,     0,  1037,  1038,  1039,     0,  1040,     0,     0,
       0,     0,     0,     0,  1041,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1042,     0,     0,     0,     0,
       0,     0,     0,  1043,     0,     0,  1044,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1045,     0,     0,     0,
       0,     0,  1046,  1047,     0,  1048,  1049,     0,     0,     0,
    1050,     0,     0,     0,     0,     0,     0,     0,  1051,  1052,
    1053,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1054,  1055,  1056,     0,     0,     0,     0,     0,  1057,     0,
    1058,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   584,    48,    49,    50,    51,
      52,  1059,  1060,  1061,    54,    55,    56,  1062,    58,    59,
      60,    61,    62,    63,  1063,    65,    66,    67,    68,    69,
      70,    71,  1064,   585,     0,   586,   587,    77,    78,    79,
      80,    81,    82,   588,    84,    85,    86,    87,  1065,    88,
     590,    90,    91,    92,    93,    94,   591,  1066,    96,  1067,
    1068,    99,  1069,  1070,  1071,  1072,  1073,     0,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,  1074,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,  1075,  1076,  1077,   594,  1078,  1079,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,   596,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   598,   599,   174,     0,  1080,   176,   177,   600,   179,
     180,  1081,   182,  1082,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,  1083,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   605,   214,  1084,  1085,   217,
     218,   219,  1086,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1087,   259,  1088,   261,   262,   263,   264,  1089,  1090,  1091,
    1092,   269,   270,   271,   272,   273,   274,   275,   276,   277,
    1093,  1094,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,   289,   290,   291,   292,   293,  1095,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,  1096,   308,   309,   310,   311,   312,  1097,  1098,   315,
     608,   316,   609,   318,   319,  1099,   321,   322,   323,   324,
     325,   326,  1100,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,  1101,   358,   612,   360,   361,   362,  1102,  1103,
     365,   366,   613,   368,   369,  1104,   371,   372,   373,   374,
     375,   376,  1105,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,  1106,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,  1107,  1108,  1109,  1110,   429,   430,   431,  1111,  1112,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,  1113,   448,  1114,   450,   451,   452,   453,
     454,   455,   456,   457,   458,  1115,  1116,   619,  1117,   463,
     464,   465,     0,   466,   620,   468,  1118,     0,     0,     0,
     985,   986,   987,   988,   989,  1695,  1696,     0,     0,     0,
       0,  1121,   990,   991,     0,   992,  1122,     0,     0,     0,
    1123,  1124,   993,   994,  1125,  1126,   995,   996,   997,   998,
       0,   999,  1000,     0,  1001,  1002,     0,     0,     0,     0,
    1003,     0,     0,     0,  1004,     0,     0,  1005,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1006,  1007,  1008,
       0,  1009,  1010,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1011,  1012,  1013,     0,  1014,  1015,
       0,     0,     0,  1016,  1017,  1018,     0,     0,     0,     0,
       0,     0,     0,  1019,     0,  1020,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1021,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,  1023,  1024,     0,
    1025,     0,     0,     0,     0,     0,  1026,     0,  1027,     0,
       0,  1028,     0,     0,  1029,     0,  1031,     0,  1032,  1033,
    1034,     0,  1035,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1036,     0,     0,
       0,  1037,  1038,  1039,     0,  1040,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1042,     0,     0,     0,     0,     0,     0,
       0,  1043,     0,     0,  1044,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1045,     0,     0,     0,     0,     0,
    1046,  1047,     0,  1048,  1049,     0,     0,     0,  1050,     0,
       0,     0,     0,     0,     0,     0,  1051,  1052,  1053,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1054,  1055,
    1056,     0,     0,     0,     0,     0,  1057,     0,  1058,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   584,    48,    49,    50,    51,    52,  1059,
    1060,  1061,    54,    55,    56,  1062,    58,    59,    60,    61,
      62,    63,  1063,    65,    66,    67,    68,    69,    70,    71,
    1064,   585,     0,   586,   587,    77,    78,    79,    80,    81,
      82,   588,    84,    85,    86,    87,  1065,    88,   590,    90,
      91,    92,    93,    94,   591,  1066,    96,  1067,  1068,    99,
    1069,  1070,  1071,  1072,  1073,     0,   105,   106,   107,   592,
     109,   110,   111,   112,   113,   114,   115,   116,   117,  1074,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,  1075,  1076,  1077,   594,  1078,  1079,   135,     0,   136,
     137,   138,   139,   140,   141,   142,   595,   144,   145,   146,
     147,   596,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   597,   162,     0,     0,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   598,
     599,   174,     0,  1080,   176,   177,   600,   179,   180,  1081,
     182,  1082,   601,   185,   186,   602,   188,   189,   603,     0,
     191,   192,   193,  1083,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   604,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   605,   214,  1084,  1085,   217,   218,   219,
    1086,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  1087,   259,
    1088,   261,   262,   263,   264,  1089,  1090,  1091,  1092,   269,
     270,   271,   272,   273,   274,   275,   276,   277,  1093,  1094,
     280,   281,   282,   283,   284,   606,   285,   286,   287,   288,
     289,   290,   291,   292,   293,  1095,   295,   296,   297,   607,
     298,   299,   300,   301,   302,   303,   304,   305,   306,  1096,
     308,   309,   310,   311,   312,  1097,  1098,   315,   608,   316,
     609,   318,   319,  1099,   321,   322,   323,   324,   325,   326,
    1100,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   610,
     347,   348,   611,   350,   351,   352,   353,   354,   355,   356,
    1101,   358,   612,   360,   361,   362,  1102,  1103,   365,   366,
     613,   368,   369,  1104,   371,   372,   373,   374,   375,   376,
    1105,   378,   614,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,     0,   394,   395,
     396,   397,   615,   399,   400,   616,   402,   403,   404,   405,
    1106,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,  1107,
    1108,  1109,  1110,   429,   430,   431,  1111,  1112,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   618,   444,   445,
     446,  1113,   448,  1114,   450,   451,   452,   453,   454,   455,
     456,   457,   458,  1115,  1116,   619,  1117,   463,   464,   465,
       0,   466,   620,   468,  1118,     0,     0,     0,   985,   986,
     987,   988,   989,  1119,  1120,     0,     0,     0,     0,  1121,
     990,   991,     0,   992,  1122,     0,     0,     0,  1123,  1124,
     993,   994,  1125,  1126,   995,   996,   997,   998,     0,   999,
    1000,     0,  1001,  1002,     0,     0,     0,     0,  1003,     0,
       0,     0,  1004,     0,     0,  1005,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1006,  1007,  1008,     0,  1009,
    1010,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1011,  1012,  1013,     0,  1014,  1015,     0,     0,
       0,  1016,  1017,  1018,     0,     0,     0,     0,     0,     0,
       0,  1019,     0,  2652,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1021,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1022,     0,     0,     0,     0,  1023,  1024,     0,  1025,     0,
       0,     0,     0,     0,  1026,     0,  1027,     0,     0,  1028,
       0,     0,  1029,     0,  1031,     0,  1032,  1033,  1034,     0,
    1035,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1036,     0,     0,     0,  1037,
    1038,  1039,     0,  1040,     0,     0,     0,     0,     0,     0,
    1041,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1042,     0,     0,     0,     0,     0,     0,     0,  1043,
       0,     0,  1044,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1045,     0,     0,     0,     0,     0,  1046,  1047,
       0,  1048,  1049,     0,     0,     0,  1050,     0,     0,     0,
       0,     0,     0,     0,  1051,  1052,  1053,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1054,  1055,  1056,     0,
       0,     0,     0,     0,  1057,     0,  1058,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,  1059,  1060,  1061,
      54,    55,    56,  1062,    58,    59,    60,    61,    62,    63,
    1063,    65,    66,    67,    68,    69,    70,    71,  1064,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,  1065,    88,   590,    90,    91,    92,
      93,    94,   591,  1066,    96,  1067,  1068,    99,  1069,  1070,
    1071,  1072,  1073,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,  1074,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,  1075,
    1076,  1077,   594,  1078,  1079,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,  1080,   176,   177,   600,   179,   180,  1081,   182,  1082,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,  1083,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,  1084,  1085,   217,   218,   219,  1086,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1087,   259,  1088,   261,
     262,   263,   264,  1089,  1090,  1091,  1092,   269,   270,   271,
     272,   273,   274,   275,   276,   277,  1093,  1094,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,  1095,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,  1096,   308,   309,
     310,   311,   312,  1097,  1098,   315,   608,   316,   609,   318,
     319,  1099,   321,   322,   323,   324,   325,   326,  1100,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,  1101,   358,
     612,   360,   361,   362,  1102,  1103,   365,   366,   613,   368,
     369,  1104,   371,   372,   373,   374,   375,   376,  1105,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,  1106,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,  1107,  1108,  1109,
    1110,   429,   430,   431,  1111,  1112,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,  1113,
     448,  1114,   450,   451,   452,   453,   454,   455,   456,   457,
     458,  1115,  1116,   619,  1117,   463,   464,   465,     0,   466,
     620,   468,  1118,     0,     0,     0,   985,   986,   987,   988,
     989,  1119,  1120,     0,     0,     0,     0,  1121,   990,   991,
       0,   992,  1122,     0,     0,     0,  1123,  1124,   993,   994,
    1125,  1126,   995,   996,   997,   998,     0,   999,  1000,     0,
    1001,  1002,     0,     0,     0,     0,  1003,     0,     0,     0,
    1004,     0,     0,  1005,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1006,  1007,  1008,     0,  1009,  1010,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1011,  1012,  1013,     0,  1014,  1015,     0,     0,     0,  1016,
    1017,  1018,     0,     0,     0,     0,     0,     0,     0,  1019,
       0,  2654,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1021,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1022,     0,
       0,     0,     0,  1023,  1024,     0,  1025,     0,     0,     0,
       0,     0,  1026,     0,  1027,     0,     0,  1028,     0,     0,
    1029,     0,  1031,     0,  1032,  1033,  1034,     0,  1035,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1036,     0,     0,     0,  1037,  1038,  1039,
       0,  1040,     0,     0,     0,     0,     0,     0,  1041,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,  1043,     0,     0,
    1044,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1045,     0,     0,     0,     0,     0,  1046,  1047,     0,  1048,
    1049,     0,     0,     0,  1050,     0,     0,     0,     0,     0,
       0,     0,  1051,  1052,  1053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1054,  1055,  1056,     0,     0,     0,
       0,     0,  1057,     0,  1058,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    45,    46,    47,   584,
      48,    49,    50,    51,    52,  1059,  1060,  1061,    54,    55,
      56,  1062,    58,    59,    60,    61,    62,    63,  1063,    65,
      66,    67,    68,    69,    70,    71,  1064,   585,     0,   586,
     587,    77,    78,    79,    80,    81,    82,   588,    84,    85,
      86,    87,  1065,    88,   590,    90,    91,    92,    93,    94,
     591,  1066,    96,  1067,  1068,    99,  1069,  1070,  1071,  1072,
    1073,     0,   105,   106,   107,   592,   109,   110,   111,   112,
     113,   114,   115,   116,   117,  1074,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,  1075,  1076,  1077,
     594,  1078,  1079,   135,     0,   136,   137,   138,   139,   140,
     141,   142,   595,   144,   145,   146,   147,   596,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   597,   162,     0,     0,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   598,   599,   174,     0,  1080,
     176,   177,   600,   179,   180,  1081,   182,  1082,   601,   185,
     186,   602,   188,   189,   603,     0,   191,   192,   193,  1083,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   604,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   605,
     214,  1084,  1085,   217,   218,   219,  1086,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1087,   259,  1088,   261,   262,   263,
     264,  1089,  1090,  1091,  1092,   269,   270,   271,   272,   273,
     274,   275,   276,   277,  1093,  1094,   280,   281,   282,   283,
     284,   606,   285,   286,   287,   288,   289,   290,   291,   292,
     293,  1095,   295,   296,   297,   607,   298,   299,   300,   301,
     302,   303,   304,   305,   306,  1096,   308,   309,   310,   311,
     312,  1097,  1098,   315,   608,   316,   609,   318,   319,  1099,
     321,   322,   323,   324,   325,   326,  1100,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   610,   347,   348,   611,   350,
     351,   352,   353,   354,   355,   356,  1101,   358,   612,   360,
     361,   362,  1102,  1103,   365,   366,   613,   368,   369,  1104,
     371,   372,   373,   374,   375,   376,  1105,   378,   614,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,     0,   394,   395,   396,   397,   615,   399,
     400,   616,   402,   403,   404,   405,  1106,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,  1107,  1108,  1109,  1110,   429,
     430,   431,  1111,  1112,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   618,   444,   445,   446,  1113,   448,  1114,
     450,   451,   452,   453,   454,   455,   456,   457,   458,  1115,
    1116,   619,  1117,   463,   464,   465,     0,   466,   620,   468,
    1118,     0,     0,     0,     0,   986,   987,   988,   989,  1119,
    1120,     0,     0,     0,     0,  1121,   990,   991,     0,   992,
    1122,     0,     0,     0,  1123,  1124,   993,   994,  1125,  1126,
     995,   996,   997,   998,     0,   999,  1000,     0,  1001,  1002,
       0,     0,     0,     0,  1003,     0,     0,     0,  1004,     0,
       0,  1005,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1006,  1007,  1008,     0,  1009,  1010,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1011,  1012,
    1013,     0,  1014,  1015,     0,     0,     0,  1016,  1017,  1018,
       0,     0,     0,     0,     0,     0,     0,  1019,     0,  1694,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1022,     0,     0,     0,
       0,  1023,  1024,     0,  1025,     0,     0,     0,     0,     0,
    1026,     0,  1027,     0,     0,  1028,     0,     0,     0,     0,
    1031,     0,  1032,  1033,  1034,     0,  1035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1036,     0,     0,     0,  1037,  1038,  1039,     0,  1040,
       0,     0,     0,     0,     0,     0,  1041,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1042,     0,     0,
       0,     0,     0,     0,     0,  1043,     0,     0,  1044,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1045,     0,
       0,     0,     0,     0,  1046,  1047,     0,  1048,  1049,     0,
       0,     0,  1050,     0,     0,     0,     0,     0,     0,     0,
    1051,  1052,  1053,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1054,  1055,  1056,     0,     0,     0,     0,     0,
    1057,     0,  1058,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   584,    48,    49,
      50,    51,    52,  1059,  1060,  1061,    54,    55,    56,  1062,
      58,    59,    60,    61,    62,    63,  1063,    65,    66,    67,
      68,    69,    70,    71,  1064,   585,     0,   586,   587,    77,
      78,    79,    80,    81,    82,   588,    84,    85,    86,    87,
    1065,    88,   590,    90,    91,    92,    93,    94,   591,  1066,
      96,  1067,  1068,    99,  1069,  1070,  1071,  1072,  1073,     0,
     105,   106,   107,   592,   109,   110,   111,   112,   113,   114,
     115,   116,   117,  1074,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,  1075,  1076,  1077,   594,  1078,
    1079,   135,     0,   136,   137,   138,   139,   140,   141,   142,
     595,   144,   145,   146,   147,   596,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   597,
     162,     0,     0,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   598,   599,   174,     0,  1080,   176,   177,
     600,   179,   180,  1081,   182,  1082,   601,   185,   186,   602,
     188,   189,   603,     0,   191,   192,   193,  1083,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   604,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   605,   214,  1084,
    1085,   217,   218,   219,  1086,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1087,   259,  1088,   261,   262,   263,   264,  1089,
    1090,  1091,  1092,   269,   270,   271,   272,   273,   274,   275,
     276,   277,  1093,  1094,   280,   281,   282,   283,   284,   606,
     285,   286,   287,   288,   289,   290,   291,   292,   293,  1095,
     295,   296,   297,   607,   298,   299,   300,   301,   302,   303,
     304,   305,   306,  1096,   308,   309,   310,   311,   312,  1097,
    1098,   315,   608,   316,   609,   318,   319,  1099,   321,   322,
     323,   324,   325,   326,  1100,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   610,   347,   348,   611,   350,   351,   352,
     353,   354,   355,   356,  1101,   358,   612,   360,   361,   362,
    1102,  1103,   365,   366,   613,   368,   369,  1104,   371,   372,
     373,   374,   375,   376,  1105,   378,   614,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   615,   399,   400,   616,
     402,   403,   404,   405,  1106,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,  1107,  1108,  1109,  1110,   429,   430,   431,
    1111,  1112,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   618,   444,   445,   446,  1113,   448,  1114,   450,   451,
     452,   453,   454,   455,   456,   457,   458,  1115,  1116,   619,
    1117,   463,   464,   465,   986,   466,   620,   468,  1118,     0,
       0,     0,     0,     0,     0,     0,     0,  5790,  5791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5792,     0,
       0,     0,     0,  1124,     0,     0,  1125,  1126,     0,     0,
       0,     0,     0,  1003,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1008,     0,     0,  1010,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,  1015,     0,     0,     0,  1731,  1732,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,     0,     0,
       0,     0,  1033,  1034,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1050,     0,     0,     0,     0,     0,     0,     0,  1051,
    1052,  1053,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,  1733,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,  2685,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
    3159,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,  2686,   426,   427,  2687,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1125,  1126,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
    3407,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,  3160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   789,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,  1213,   466,   620,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1214,     0,     0,   789,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,  1215,    88,   590,    90,    91,    92,
      93,    94,   591,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   593,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   594,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,   175,   176,   177,  1216,   179,   180,   181,   182,   183,
     601,  1217,   186,   602,   188,   189,   603,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,   215,   216,   217,   218,   219,   220,   221,
    1218,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
    1219,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,  1220,   308,   309,
     310,   311,   312,   313,   314,   315,   608,   316,   609,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,   357,  1221,
     612,   360,   361,   362,   363,   364,   365,   366,   613,   368,
     369,   370,   371,   372,   373,   374,  1222,   376,   377,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,  1223,   430,   431,   432,   617,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,  1224,   462,   463,   464,   465,  1213,   466,
     620,   468,   469,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1214,     0,     0,
       0,  1225,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,  1215,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,  1216,
     179,   180,   181,   182,   183,   601,  1217,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,  1218,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,  1219,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,  1220,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,  1221,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,  1222,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,  1224,   462,
     463,   464,   465,     0,   466,   620,   468,   469,   902,   903,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1225,     0,     0,     0,
       0,     0,     0,   904,     0,     0,     0,     0,   905,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   906,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   907,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   908,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,    17,     0,     0,     0,   909,     0,     0,
       0,     0,   910,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   808,     0,     0,     0,     0,     0,     0,   911,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   912,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   913,     0,     0,     0,     0,
       0,     0,     0,   914,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   709,     0,     0,
       0,     0,     0,     0,   915,     0,     0,     0,     0,     0,
       0,     0,     0,   916,   917,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   918,
     157,   158,   159,   160,   919,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   920,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   921,   323,   324,   325,   922,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   923,   344,   345,   610,   347,
     924,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   925,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   926,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,  1190,   903,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   904,
       0,     0,     0,     0,   905,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   906,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   907,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   908,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,   909,     0,     0,     0,     0,   910,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   808,     0,     0,
       0,     0,     0,     0,   911,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   912,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   913,     0,     0,     0,     0,     0,     0,     0,   914,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   709,     0,     0,     0,     0,     0,     0,
     915,     0,     0,     0,     0,     0,     0,     0,     0,   916,
     917,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,  1191,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   918,   157,   158,   159,   160,
     919,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   920,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     921,   323,   324,   325,  1192,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   923,   344,   345,   610,   347,   924,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   925,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,  1963,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   926,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   709,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,  2060,   466,   620,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1731,  1732,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,  4970,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,  2061,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,  4989,   466,   620,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   758,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,  3506,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3507,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   584,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   585,     0,   586,   587,    77,
      78,    79,    80,    81,    82,   588,    84,    85,    86,    87,
     589,    88,   590,    90,    91,    92,    93,    94,   591,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   592,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   593,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   594,   133,
     134,   135,     0,   136,   137,   138,   139,   140,   141,   142,
     595,   144,   145,   146,   147,   596,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   597,
     162,     0,     0,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   598,   599,   174,     0,   175,   176,   177,
     600,   179,   180,   181,   182,   183,   601,   185,   186,   602,
     188,   189,   603,     0,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   604,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   605,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   606,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   607,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,  4990,   309,   310,   311,   312,   313,
     314,   315,   608,   316,   609,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   610,   347,   348,   611,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   612,   360,   361,   362,
     363,   364,   365,   366,   613,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   614,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,  4535,   394,   395,   396,   397,   615,   399,   400,   616,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   617,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   618,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   619,
     462,   463,   464,   465,     0,   466,   620,   468,   469,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,  4786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   709,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,  1916,   466,   620,
     468,   469,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1917,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1918,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   709,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,  1504,  1505,     0,  1919,     0,     0,  1506,  1507,
       0,     0,     0,     0,     0,     0,     0,     0,  1508,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1509,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1510,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1511,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1512,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1513,  1514,     0,  1515,     0,     0,     0,
       0,     0,     0,     0,  1516,  1517,  1518,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1519,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1520,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1521,     0,     0,     0,     0,     0,  1522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1523,  1524,  1525,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1526,  1527,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,     0,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,     0,   587,  1528,    78,
    1529,  1530,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,     0,  1531,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,  1532,   129,  1533,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,     0,   148,   149,   150,  1534,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,  1535,   598,   599,   174,     0,   175,   176,   177,     0,
     179,   180,  1536,  1537,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,  1538,   213,   605,   214,   215,   216,
     217,   218,   219,  1539,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,  1540,
    1541,  1542,   269,   270,   271,   272,   273,  1543,  1544,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,     0,  1545,  1546,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,  1547,  1548,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,     0,  1549,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,  1550,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
       0,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,  1551,
     423,   424,  1552,   426,   427,  1553,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,     0,  1554,   452,
     453,   454,   455,   456,   457,   458,   459,   460,  1555,   462,
     463,   464,   465,     0,   466,   620,   468,  1556,  1504,  4332,
       0,     0,     0,     0,  1506,  1507,     0,     0,     0,     0,
       0,     0,     0,     0,  1508,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1509,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1510,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1511,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1512,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1513,
    1514,     0,  1515,     0,     0,     0,     0,     0,     0,     0,
    1516,  1517,  1518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1519,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1520,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1521,
       0,     0,     0,     0,     0,  1522,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1523,
    1524,  1525,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4333,  1527,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,     0,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,     0,   587,  1528,    78,  1529,  1530,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,     0,  1531,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,  1532,
     129,  1533,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
       0,   148,   149,   150,  1534,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,  1535,   598,   599,
     174,     0,   175,   176,   177,     0,   179,   180,  1536,  1537,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
    1538,   213,   605,   214,   215,   216,   217,   218,   219,  1539,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,  1540,  1541,  1542,   269,   270,
     271,   272,   273,  1543,  1544,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,     0,
    1545,  1546,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,  1547,  1548,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,     0,  4334,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,  4335,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,     0,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,  1551,   423,   424,  1552,   426,
     427,  1553,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,     0,  4336,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1555,   462,   463,   464,   465,     0,
     466,   620,   468,  1556,  1504,  1505,     0,     0,     0,     0,
    1506,  1507,     0,     0,     0,     0,     0,     0,     0,     0,
    1508,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1509,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1510,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1511,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1512,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1513,  1514,     0,  1515,     0,
       0,     0,     0,     0,     0,     0,  1516,  1517,  1518,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1519,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1520,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1521,     0,     0,     0,     0,
       0,  1522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1523,  1524,  1525,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1526,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,     0,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,     0,   587,
    1528,    78,  1529,  1530,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,     0,  1531,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,  1532,   129,  1533,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,     0,   148,   149,   150,
    1534,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,  1535,   598,   599,   174,     0,   175,   176,
     177,     0,   179,   180,  1536,  1537,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,  1538,   213,   605,   214,
     215,   216,   217,   218,   219,  1539,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,  1540,  1541,  1542,   269,   270,   271,   272,   273,  1543,
    1544,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,     0,  1545,  1546,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
    1547,  1548,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,     0,  1549,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,     0,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,  5384,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,  1551,   423,   424,  1552,   426,   427,  1553,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,     0,
    1554,   452,   453,   454,   455,   456,   457,   458,   459,   460,
    1555,   462,   463,   464,   465,     0,   466,   620,   468,  1556,
    1504,  4332,     0,     0,     0,     0,  1506,  1507,     0,     0,
       0,     0,     0,     0,     0,     0,  1508,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1509,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1510,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1511,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1512,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1513,  1514,     0,  1515,     0,     0,     0,     0,     0,
       0,     0,  1516,  1517,  1518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1519,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1520,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1521,     0,     0,     0,     0,     0,  1522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1523,  1524,  1525,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4333,  1527,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,     0,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,     0,   587,  1528,    78,  1529,  1530,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,     0,  1531,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,  1532,   129,  1533,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,     0,   148,   149,   150,  1534,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,  1535,
     598,   599,   174,     0,   175,   176,   177,     0,   179,   180,
    1536,  1537,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,  1538,   213,   605,   214,   215,   216,   217,   218,
     219,  1539,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,  1540,  1541,  1542,
     269,   270,   271,   272,   273,  1543,  1544,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,     0,  1545,  1546,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  1547,  1548,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,     0,  4334,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,  5622,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,     0,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,  1551,   423,   424,
    1552,   426,   427,  1553,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,  1932,  4336,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1555,   462,   463,   464,
     465,     0,   466,   620,   468,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1933,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   808,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   709,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,  1916,   466,   620,   468,   469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1917,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   808,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   709,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,  1916,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   808,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     709,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   584,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   585,     0,   586,   587,    77,    78,    79,
      80,    81,    82,   588,    84,    85,    86,    87,   589,    88,
     590,    90,    91,    92,    93,    94,   591,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   593,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   594,   133,   134,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,   596,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   598,   599,   174,     0,   175,   176,   177,   600,   179,
     180,   181,   182,   183,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   605,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     608,   316,   609,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   612,   360,   361,   362,   363,   364,
     365,   366,   613,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,  1347,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   617,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   619,   462,   463,
     464,   465,     0,   466,   620,   468,   469,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1348,  1349,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1350,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,   589,    88,   590,    90,    91,    92,
      93,    94,   591,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   593,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   594,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,   175,   176,   177,   600,   179,   180,   181,   182,   183,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   608,   316,   609,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     612,   360,   361,   362,   363,   364,   365,   366,   613,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,  2747,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   617,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   619,   462,   463,   464,   465,     0,   466,
     620,   468,   469,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,   589,    88,   590,    90,    91,    92,
      93,    94,   591,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   593,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   594,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,   175,   176,   177,   600,   179,   180,   181,   182,   183,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   608,   316,   609,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     612,   360,   361,   362,   363,   364,   365,   366,   613,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   617,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   619,   462,   463,   464,   465,  1451,   466,
     620,   468,   469,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,    17,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   808,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   709,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,    46,    47,   584,    48,    49,    50,    51,    52,     0,
       0,     0,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,   585,     0,   586,   587,    77,    78,    79,    80,    81,
      82,   588,    84,    85,    86,    87,   589,    88,   590,    90,
      91,    92,    93,    94,   591,    95,    96,    97,     0,    99,
     100,   101,   102,   103,   104,     0,   105,   106,   107,   592,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   593,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   594,   133,   134,   135,     0,   136,
     137,   138,   139,   140,   141,   142,   595,   144,   145,   146,
     147,   596,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   597,   162,     0,     0,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   598,
     599,   174,     0,   175,   176,   177,   600,   179,   180,   181,
     182,   183,   601,   185,   186,   602,   188,   189,   603,     0,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   604,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   605,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   606,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   607,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   608,   316,
     609,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   610,
     347,   348,   611,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   612,   360,   361,   362,   363,   364,   365,   366,
     613,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   614,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,     0,   391,   392,   393,     0,   394,   395,
     396,   397,   615,   399,   400,   616,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   617,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   618,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   619,   462,   463,   464,   465,
       0,   466,   620,   468,   469,   851,   852,     0,     0,     0,
       0,     0,     0,     0,     0,   853,     0,     0,     0,     0,
       0,     0,     0,     0,  1826,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,     0,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,     0,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,     0,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,   854,   855,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     856,   462,   463,   464,   465,     0,   466,   620,   468,   469,
    1451,   905,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   808,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     709,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    45,    46,    47,   584,    48,    49,    50,    51,
      52,     0,     0,     0,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   585,     0,   586,   587,    77,    78,    79,
      80,    81,    82,   588,    84,    85,    86,    87,   589,    88,
     590,    90,    91,    92,    93,    94,   591,    95,    96,    97,
       0,    99,   100,   101,   102,   103,   104,     0,   105,   106,
     107,   592,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   593,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   594,   133,   134,   135,
       0,   136,   137,   138,   139,   140,   141,   142,   595,   144,
     145,   146,   147,   596,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   597,   162,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   598,   599,   174,     0,   175,   176,   177,   600,   179,
     180,   181,   182,   183,   601,   185,   186,   602,   188,   189,
     603,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   604,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   605,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   606,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   607,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     608,   316,   609,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   610,   347,   348,   611,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   612,   360,   361,   362,   363,   364,
     365,   366,   613,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   614,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,     0,
     394,   395,   396,   397,   615,   399,   400,   616,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   617,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   618,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   619,   462,   463,
     464,   465,  1451,   466,   620,   468,   469,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,    17,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   808,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   709,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    45,    46,    47,   584,    48,    49,
      50,    51,    52,     0,     0,     0,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,   585,     0,   586,   587,    77,
      78,    79,    80,    81,    82,   588,    84,    85,    86,    87,
     589,    88,   590,    90,    91,    92,    93,    94,   591,    95,
      96,    97,     0,    99,   100,   101,   102,   103,   104,     0,
     105,   106,   107,   592,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   593,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   594,   133,
     134,   135,     0,   136,   137,   138,   139,   140,   141,   142,
     595,   144,   145,   146,   147,   596,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   597,
     162,     0,     0,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   598,   599,   174,     0,   175,   176,   177,
     600,   179,   180,   181,   182,   183,   601,   185,   186,   602,
     188,   189,   603,     0,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   604,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   605,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   606,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   607,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   608,   316,   609,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   610,   347,   348,   611,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   612,   360,   361,   362,
     363,   364,   365,   366,   613,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   614,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,     0,   394,   395,   396,   397,   615,   399,   400,   616,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   617,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   618,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   619,
     462,   463,   464,   465,  1384,   466,   620,   468,   469,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,   905,   466,   620,
     468,   469,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1385,     0,     0,     0,     0,  1386,     0,     0,   789,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     808,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   709,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,   589,    88,   590,    90,    91,    92,
      93,    94,   591,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   593,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   594,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,   175,   176,   177,   600,   179,   180,   181,   182,   183,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   608,   316,   609,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     612,   360,   361,   362,   363,   364,   365,   366,   613,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   617,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   619,   462,   463,   464,   465,   853,   466,
     620,   468,   469,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,     0,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   585,
       0,     0,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,   589,    88,   590,    90,    91,    92,
      93,    94,   591,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   593,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   594,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,     0,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   608,   316,   609,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     612,   360,   361,   362,   363,   364,   365,   366,   613,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   617,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   856,   462,   463,   464,   465,     0,   466,
     620,   468,   469,  2457,     0,     0,     0,  5159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2458,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4154,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4155,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4156,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   709,     0,     0,     0,     0,     0,     0,     0,     0,
    4157,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,  2457,     0,
       0,     0,  5914,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2458,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4154,     0,     0,     0,
       0,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4155,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4156,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   709,     0,     0,     0,
       0,     0,     0,     0,     0,  4157,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,   584,    48,    49,    50,    51,    52,     0,     0,     0,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,   585,
       0,   586,   587,    77,    78,    79,    80,    81,    82,   588,
      84,    85,    86,    87,   589,    88,   590,    90,    91,    92,
      93,    94,   591,    95,    96,    97,     0,    99,   100,   101,
     102,   103,   104,     0,   105,   106,   107,   592,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   593,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   594,   133,   134,   135,     0,   136,   137,   138,
     139,   140,   141,   142,   595,   144,   145,   146,   147,   596,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   597,   162,     0,     0,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   598,   599,   174,
       0,   175,   176,   177,   600,   179,   180,   181,   182,   183,
     601,   185,   186,   602,   188,   189,   603,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   604,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   605,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   606,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   607,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   608,   316,   609,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   610,   347,   348,
     611,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     612,   360,   361,   362,   363,   364,   365,   366,   613,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     614,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   394,   395,   396,   397,
     615,   399,   400,   616,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   617,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   618,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   619,   462,   463,   464,   465,     0,   466,
     620,   468,   469,  2457,     0,     0,     0,  6027,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2458,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4154,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4155,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4156,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   709,     0,     0,     0,     0,     0,     0,     0,     0,
    4157,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,  3074,   466,   620,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   808,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   709,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,  1909,
     466,   620,   468,   469,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,  1909,   466,   620,   468,   469,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,  2739,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,  3499,   466,   620,   468,   469,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,  5090,   466,   620,
     468,   469,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,  5108,   466,   620,   468,   469,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,  3435,
     466,   620,   468,   469,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   709,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,  3436,   179,   180,   181,   182,   183,   601,     0,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,     0,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,     0,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
    3437,   462,   463,   464,   465,     0,   466,   620,   468,   469,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,  2604,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6124,     0,     0,     0,     0,     0,     0,  2605,
    6125,   808,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   709,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1930,   808,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   709,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2151,   808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   709,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2619,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,  2604,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
    1731,  1732,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2605,  6125,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2061,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      41,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,  1731,  1732,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1385,     0,     0,     0,     0,     0,     0,
       0,   789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,  1733,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1734,     0,     0,     0,     0,
       0,     0,     0,  1125,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,  1731,  1732,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1385,     0,     0,
       0,     0,  1386,     0,     0,   789,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,  1733,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1125,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,  2604,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2605,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1385,     0,     0,     0,     0,     0,     0,
       0,   789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,  3160,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   789,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,    16,    17,
    5056,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4785,     0,     0,
       0,     0,     0,     0,     0,  4786,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4786,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   786,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     787,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   788,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   789,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   789,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4786,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,  3119,   466,   620,   468,   469,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2663,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   705,
     706,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3764,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3765,   675,  3766,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,  1664,   466,   620,   468,   469,
    1665,     0,     0,     0,     0,     0,     0,     0,     0,  3120,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,  1666,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,  1586,   466,   620,
     468,   469,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,  3136,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,  1731,  1732,
       0,     0,     0,     0,     0,     0,     0,     0,  4382,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
    4539,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,  1731,  1732,     0,     0,     0,     0,     0,     0,
       0,     0,  4963,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,  5262,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,  5451,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1918,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   709,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,  1731,  1732,
       0,  1919,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2162,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2163,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1036,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,  2166,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
    1731,  1732,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2162,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2163,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1036,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4365,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,  2166,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,  1731,  1732,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2162,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2163,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1036,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,  2166,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   674,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   675,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   808,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   709,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   675,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
    1731,  1732,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1777,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4582,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   709,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,   613,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,   600,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     619,   462,   463,   464,   465,     0,   466,   620,   468,   469,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,   600,   179,   180,   181,   182,   183,   601,
     185,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   718,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   619,   462,   463,   464,   465,     0,   466,   620,
     468,   469,  1731,  1732,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,   584,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,   586,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,   589,    88,   590,    90,    91,
      92,    93,    94,   591,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,   592,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   593,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,   595,   144,   145,   146,   147,
     596,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,   599,
     174,     0,   175,   176,   177,   600,   179,   180,   181,   182,
     183,   601,   185,   186,   602,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   605,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   606,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   607,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   608,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   610,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   612,   360,   361,   362,   363,   364,   365,   366,   613,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   614,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   617,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   619,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,   584,    48,    49,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,   585,     0,   586,   587,    77,    78,    79,    80,
      81,    82,   588,    84,    85,    86,    87,   589,    88,   590,
      90,    91,    92,    93,    94,   591,    95,    96,    97,     0,
      99,   100,   101,   102,   103,   104,     0,   105,   106,   107,
     592,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     593,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   594,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,   595,   144,   145,
     146,   147,   596,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   597,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     598,   599,   174,     0,   175,   176,   177,   600,   179,   180,
     181,   182,   183,   601,   185,   186,   602,   188,   189,   603,
       0,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   604,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   605,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   606,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     607,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   608,
     316,   609,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     610,   347,   348,   611,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   612,   360,   361,   362,   363,   364,   365,
     366,  2080,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   614,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,     0,   394,
     395,   396,   397,   615,   399,   400,   616,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   617,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   618,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   619,   462,   463,   464,
     465,     0,   466,   620,   468,   469,    16,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,   584,    48,    49,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,   585,     0,   586,   587,    77,    78,
      79,    80,    81,    82,   588,    84,    85,    86,    87,   589,
      88,   590,    90,    91,    92,    93,    94,   591,    95,    96,
      97,     0,    99,   100,   101,   102,   103,   104,     0,   105,
     106,   107,   592,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   593,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   594,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,   595,
     144,   145,   146,   147,   596,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   597,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
    3527,   172,   598,   599,   174,     0,   175,   176,   177,   600,
     179,   180,   181,   182,   183,   601,   185,   186,   602,   188,
     189,   603,     0,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   604,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   605,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,  3528,   279,   280,   281,   282,   283,   284,   606,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   607,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   608,   316,   609,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   610,   347,   348,   611,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   612,   360,   361,   362,   363,
     364,   365,   366,   613,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   614,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       0,   394,   395,   396,   397,   615,   399,   400,   616,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     617,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     618,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   619,   462,
     463,   464,   465,     0,   466,   620,   468,   469,    16,    17,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,    47,   584,    48,
      49,    50,    51,    52,     0,     0,     0,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   585,     0,   586,   587,
      77,    78,    79,    80,    81,    82,   588,    84,    85,    86,
      87,   589,    88,   590,    90,    91,    92,    93,    94,   591,
      95,    96,    97,     0,    99,   100,   101,   102,   103,   104,
       0,   105,   106,   107,   592,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   593,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   594,
     133,   134,   135,     0,   136,   137,   138,   139,   140,   141,
     142,   595,   144,   145,   146,   147,   596,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     597,   162,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   598,   599,   174,     0,   175,   176,
     177,  3177,   179,   180,   181,   182,   183,   601,   185,   186,
     602,   188,   189,   603,     0,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   604,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   605,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     606,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   607,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   608,   316,   609,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   610,   347,   348,   611,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   612,   360,   361,
     362,   363,   364,   365,   366,   613,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   614,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,     0,   394,   395,   396,   397,   615,   399,   400,
     616,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   617,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   618,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
       0,   462,   463,   464,   465,     0,   466,   620,   468,   469,
      16,    17,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   709,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
     584,    48,    49,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,   585,     0,
     586,   587,    77,    78,    79,    80,    81,    82,   588,    84,
      85,    86,    87,   589,    88,   590,    90,    91,    92,    93,
      94,   591,    95,    96,    97,     0,    99,   100,   101,   102,
     103,   104,     0,   105,   106,   107,   592,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   593,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   594,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,   595,   144,   145,   146,   147,   596,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   597,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   598,   599,   174,     0,
     175,   176,   177,  3436,   179,   180,   181,   182,   183,   601,
       0,   186,   602,   188,   189,   603,     0,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     604,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     605,   214,   215,   216,   217,   218,   219,   220,   221,     0,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   606,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   607,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   608,   316,   609,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   610,   347,   348,   611,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   612,
     360,   361,   362,   363,   364,   365,   366,   613,   368,   369,
     370,   371,   372,   373,   374,     0,   376,   377,   378,   614,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,     0,   394,   395,   396,   397,   615,
     399,   400,   616,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   617,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   618,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,  3437,   462,   463,   464,   465,     0,   466,   620,
     468,   469,    16,    17,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
      46,    47,     0,    48,    49,    50,    51,    52,     0,     0,
       0,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
     585,     0,     0,   587,    77,    78,    79,    80,    81,    82,
     588,    84,    85,    86,    87,     0,    88,   590,    90,    91,
      92,    93,    94,     0,    95,    96,    97,     0,    99,   100,
     101,   102,   103,   104,     0,   105,   106,   107,     0,   109,
     110,   111,   112,   113,   114,   115,   116,   117,     0,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   594,   133,   134,   135,     0,   136,   137,
     138,   139,   140,   141,   142,     0,   144,   145,   146,   147,
       0,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   597,   162,     0,     0,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   598,     0,
     174,     0,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   601,   185,   186,     0,   188,   189,   603,     0,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   604,   205,   206,   207,   208,   209,   210,   211,
     212,   213,     0,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,     0,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,     0,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,     0,   316,   609,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,     0,   347,
     348,   611,   350,   351,   352,   353,   354,   355,   356,   357,
     358,     0,   360,   361,   362,   363,   364,   365,   366,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,     0,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,     0,   394,   395,   396,
     397,   615,   399,   400,   616,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,     0,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   618,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,     0,
     466,   620,   468,   469,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1654,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,    46,    47,     0,    48,     0,    50,    51,    52,
       0,     0,     0,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,     0,    65,    66,    67,    68,    69,    70,
      71,    72,     0,     0,     0,     0,    77,    78,    79,    80,
      81,     0,     0,    84,    85,    86,    87,     0,     0,     0,
      90,    91,    92,    93,    94,     0,    95,    96,    97,     0,
      99,     0,     0,     0,     0,     0,     0,   105,     0,   107,
       0,   109,   110,  1655,   112,   113,   114,   115,   116,   117,
       0,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,     0,   133,   134,   135,     0,
     136,   137,   138,   139,   140,   141,   142,     0,   144,   145,
     146,   147,     0,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,     0,     0,     0,   162,     0,     0,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,     0,     0,     0,   176,   177,  1656,   179,   180,
     181,   182,   183,     0,   185,   186,     0,   188,   189,     0,
       0,   191,     0,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,     0,   205,   206,   207,   208,   209,
     210,   211,   212,   213,     0,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,     0,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
      16,    17,     0,     0,   301,   302,     0,   304,   305,   306,
     307,     0,   309,   310,   311,   312,   313,   314,     0,     0,
       0,     0,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,     0,   345,
       0,   347,   348,     0,   350,   351,     0,   353,   354,   355,
     356,   357,   358,     0,   360,   361,   362,   363,   364,   365,
     366,     0,   368,   369,   370,     0,   372,   373,   374,   375,
       0,   377,   378,     0,     0,   381,     0,     0,   384,   385,
     386,     0,   388,     0,   390,   391,   392,   393,     0,   394,
     395,   396,   397,     0,   399,   400,     0,   402,     0,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,     0,
     425,   426,   427,   428,   429,   430,   431,   432,     0,   434,
     435,   436,     0,   438,   439,   440,   441,     0,     0,   444,
     445,     0,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,     0,     0,   463,   464,
       0,     0,   466,     0,   468,   469,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1673,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,    46,    47,
       0,    48,     0,    50,    51,    52,     0,     0,     0,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,     0,
      65,    66,    67,    68,    69,    70,    71,    72,     0,     0,
       0,     0,    77,    78,    79,    80,    81,     0,     0,    84,
      85,    86,    87,     0,     0,     0,    90,    91,    92,    93,
      94,     0,    95,    96,    97,     0,    99,     0,     0,     0,
       0,     0,     0,   105,     0,   107,     0,   109,   110,  1655,
     112,   113,   114,   115,   116,   117,     0,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,     0,   133,   134,   135,     0,   136,   137,   138,   139,
     140,   141,   142,     0,   144,   145,   146,   147,     0,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
       0,     0,     0,   162,     0,     0,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,     0,     0,
       0,   176,   177,  1656,   179,   180,   181,   182,   183,     0,
     185,   186,     0,   188,   189,     0,     0,   191,     0,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
       0,   205,   206,   207,   208,   209,   210,   211,   212,   213,
       0,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,     0,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,    16,    17,     0,     0,
     301,   302,     0,   304,   305,   306,   307,     0,   309,   310,
     311,   312,   313,   314,     0,     0,     0,     0,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,     0,   345,     0,   347,   348,     0,
     350,   351,     0,   353,   354,   355,   356,   357,   358,     0,
     360,   361,   362,   363,   364,   365,   366,     0,   368,   369,
     370,     0,   372,   373,   374,   375,     0,   377,   378,     0,
       0,   381,     0,     0,   384,   385,   386,     0,   388,     0,
     390,   391,   392,   393,     0,   394,   395,   396,   397,     0,
     399,   400,     0,   402,     0,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,     0,   425,   426,   427,   428,
     429,   430,   431,   432,     0,   434,   435,   436,     0,   438,
     439,   440,   441,     0,     0,   444,   445,     0,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,     0,   463,   464,     0,     0,   466,     0,
     468,   469,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,    46,    47,     0,    48,     0,    50,
      51,    52,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,     0,    65,    66,    67,    68,
      69,    70,    71,    72,     0,     0,     0,     0,    77,    78,
      79,    80,    81,     0,     0,    84,    85,    86,    87,     0,
       0,     0,    90,    91,    92,    93,    94,     0,    95,    96,
      97,     0,    99,     0,     0,     0,     0,     0,     0,   105,
       0,   107,     0,   109,   110,  1655,   112,   113,   114,   115,
     116,   117,     0,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,     0,   133,   134,
     135,     0,   136,   137,   138,   139,   140,   141,   142,     0,
     144,   145,   146,   147,     0,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,     0,     0,     0,   162,
       0,     0,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,     0,     0,     0,   176,   177,  1656,
     179,   180,   181,   182,   183,     0,   185,   186,     0,   188,
     189,     0,     0,   191,     0,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,     0,   205,   206,   207,
     208,   209,   210,   211,   212,   213,     0,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,     0,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,     0,     0,     0,     0,   301,   302,     0,   304,
     305,   306,   307,     0,   309,   310,   311,   312,   313,   314,
       0,     0,     0,     0,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
       0,   345,     0,   347,   348,     0,   350,   351,     0,   353,
     354,   355,   356,   357,   358,     0,   360,   361,   362,   363,
     364,   365,   366,     0,   368,   369,   370,     0,   372,   373,
     374,   375,     0,   377,   378,     0,     0,   381,     0,     0,
     384,   385,   386,     0,   388,     0,   390,   391,   392,   393,
       0,   394,   395,   396,   397,     0,   399,   400,     0,   402,
       0,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
       0,   434,   435,   436,     0,   438,   439,   440,   441,     0,
       0,   444,   445,     0,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,     0,
     463,   464,     0,     0,   466,     0,   468,   469
};

static const yytype_int16 yycheck[] =
{
       0,   575,   690,     0,   470,   861,     0,    24,   689,   690,
     958,     0,  1515,  1713,     0,   583,  1827,  2038,  1515,     0,
    1438,   689,  1411,     0,  1900,  1880,  1411,  1729,     0,   772,
    1592,  2255,   571,     0,  1511,   895,  2336,     0,  1720,     0,
    1927,   638,  1519,    75,  1636,   638,  1409,  2432,  3414,   573,
    1937,   683,  1893,   803,  2231,  3083,  2346,   757,  1535,     0,
    1606,   761,   762,  1274,    33,  2325,  3679,  1532,  1545,  1219,
    1220,  1221,  2326,    76,  1185,  3167,  2943,     0,  1228,  1751,
    1939,   656,   565,  1253,  3679,   568,  1551,  1552,  1553,  1566,
    1572,  1556,   689,   656,  3211,  3212,   689,  1385,  2820,  2067,
    4083,  1444,  3794,   717,  3714,  1275,  1571,  2008,  1023,  1403,
    3614,   686,  3478,  1953,  1954,  2818,   640,   656,   642,   643,
     644,   645,   646,   686,   648,   649,  3464,  1444,   652,   653,
       0,  3739,  1893,  2879,   846,   734,  4122,  4090,   737,  3739,
    3594,     0,  3739,  3739,  4640,  1960,  3826,   686,  2195,  3739,
    2060,  4651,  3629,   860,  3739,  3055,   173,  2985,  4335,  4652,
    3055,  3152,  1977,  3227,  3618,  1344,  2847,  4791,  2283,  3679,
    3685,   710,  3545,  2985,  2908,  2909,  4210,  2909,  3655,  3656,
    4210,  4210,   803,  4088,  1276,   724,    11,  2002,  2003,   583,
     583,   583,   583,   583,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  2717,    11,  2433,
    2312,  2140,   985,    11,     6,   739,   740,  2093,  2058,  2060,
    1851,     9,    10,    11,    11,  1588,    11,  3055,  1859,  1860,
    4663,  1862,  1863,  2918,  2977,  4274,  4222,     9,    10,  1187,
       6,     6,    26,  3055,  3721,  3722,  2381,    61,  2383,  2384,
     105,    61,  2429,  1505,    11,  1507,    50,  1509,  1673,  1511,
      80,    28,   859,    26,   861,  3045,   859,  1519,   861,  2966,
    4211,    91,  4213,    12,  1526,  4216,  1528,    80,    86,   180,
      12,   149,   100,  1535,  1515,     6,   825,  1518,    91,     9,
      10,   105,   197,  1545,  1525,   105,   180,  1549,   238,  2060,
    1531,   126,  1554,  1482,  3728,     9,    10,    24,  4249,   197,
       9,    10,    93,    95,  1566,  1567,  1568,  1569,  1570,    11,
      61,   197,  4796,  1699,  1700,   156,    65,    83,   126,   346,
      80,   226,  1708,    65,   238,   221,     6,     9,    10,    80,
     238,    91,    86,   196,  2220,   238,  1119,  1120,  1121,   251,
      91,    61,   265,  3564,  4630,   894,   185,   226,     9,    10,
    1133,   105,   886,  3701,  1740,   121,  1742,   152,   176,     9,
      10,    61,    61,     6,   898,   899,   359,   379,     9,    10,
      30,  1757,  1758,  1759,   783,   263,    32,    58,  4759,    10,
    1766,  1767,  3126,    63,  3126,   105,   184,  1773,   186,   418,
    1513,   299,   114,  1516,   887,   888,   889,   890,   105,   205,
    1523,    60,   184,  5082,   186,   105,   105,  1514,  1515,     9,
      10,  1518,   114,    95,   363,  1538,   211,    42,  1525,   197,
     152,  5772,  2207,    76,  1531,  5647,  1023,    93,   784,    89,
    1514,  1515,     9,    10,  1518,   180,     9,    10,   115,   114,
     120,  1525,   197,   124,   238,  4716,   223,  1531,     9,    10,
     323,   346,     9,    10,   184,   273,   186,   152,   197,   622,
       9,    10,  3175,     9,    10,    93,  5548,  2252,   211,   463,
     184,  1068,   186,   270,   470,   184,   189,   186,   218,    73,
       9,    10,   137,  3655,  3656,   638,   412,  1608,  2798,   325,
     591,   777,   117,   615,   520,    80,   782,   647,   784,   768,
     680,  2811,   184,   128,   186,   303,    91,  2109,     9,    10,
     135,   277,  1633,   676,     9,    10,   211,     9,    10,   273,
    3659,   303,   123,   184,   284,   186,   299,  3677,  1125,   114,
     716,   180,   213,   537,   184,   237,   186,     9,    10,   115,
     247,   537,   167,   184,   180,   186,   537,   105,    63,  3721,
    3722,   122,  2438,   233,   284,   824,   180,  2702,  2703,  2704,
    2705,    17,  3389,   391,     9,    10,   294,   180,   669,   464,
     141,   444,   238,   303,  4623,  4805,   583,  4102,   233,   583,
    3956,   283,  1304,  4203,   184,    17,   186,   583,  3690,   303,
       9,    10,   583,   779,   303,    28,  5678,   214,   238,   721,
      32,   281,    34,   228,   205,   120,   532,   184,   288,   186,
     230,   184,    69,   186,   265,  3963,  5018,   453,   361,   299,
     633,   303,   146,   184,   745,   186,   779,   184,   638,   186,
       9,    10,  1385,   288,   259,   184,   316,   186,   184,   638,
     186,   316,   303,   296,   299,   655,  1122,   453,   380,   238,
     679,  2207,   128,   303,   233,   184,   655,   186,  1368,   669,
    1370,  1270,   303,  1373,  1374,  1375,  1376,  5014,  2096,   238,
    1219,   299,  1221,   329,   668,   266,  1225,  1226,   655,   689,
     690,   340,    80,   184,  5006,   186,   696,   638,  5910,   184,
     689,   186,   184,    91,   186,  2411,  2252,   353,   496,    80,
    5379,   414,   681,   303,   655,   638,  1255,   717,   165,   288,
      91,   704,   184,   726,   186,  5001,   105,  1314,   233,   396,
     299,   734,   655,   366,   737,   356,   303,   238,     9,    10,
     303,   316,   681,  1603,   562,   263,  4785,   233,   689,   184,
     265,   186,   303,   141,   284,  4265,   303,   449,   265,    57,
    1910,   646,     9,    10,   303,   279,   689,   303,   638,   771,
     141,   624,   230,   265,   652,   184,   281,   186,  2799,   638,
    1492,  1931,   114,   288,   303,   655,   284,  1957,   238,  1959,
     238,    89,  5012,  1904,   299,   263,   655,   783,  6139,   299,
     223,  1971,   288,  1718,  1974,   238,  5067,   105,  1978,  2355,
      61,   316,   303,  1924,   237,   184,   142,   186,   303,  1734,
     152,   303,   299,   263,  1411,  2712,   300,   301,  3728,    49,
     689,  3659,   562,  3728,   736,  2005,  2006,  2007,   838,   779,
    1951,   303,   284,  3577,  2132,  3577,   105,  3659,   817,  1470,
    4327,   149,  2195,   853,  2713,  2143,  4452,   755,   230,   859,
    3114,   861,   755,   575,   853,   486,  1405,   780,   303,  1437,
     859,   122,   861,   774,   779,   779,   771,  2295,  2195,   177,
       9,    10,   208,   771,  2302,  4096,   853,   705,   774,  5322,
     774,  5324,   760,   761,   303,   771,   662,  1609,   637,  3584,
    3728,  5272,   771,  3588,  4328,   637,   761,   329,  2000,   297,
    2612,  2613,   853,   184,  3657,   186,  3728,   725,   859,  1385,
     861,   774,  1695,  1696,   893,   347,   297,   896,     9,    10,
     853,   353,   582,  3630,   303,   935,   859,   184,   861,   186,
     771,   662,   736,  3723,   710,   774,   946,   761,   948,   949,
     950,   761,   755,   778,   954,  2923,   956,   946,   778,   948,
     949,   950,   747,   963,   681,   954,   963,   956,   755,   963,
     755,   755,   735,  2788,   963,   778,   274,   963,  1893,   771,
     778,  1693,   963,   853,   634,   985,   774,  2916,  2917,   859,
     990,   861,   774,   774,   853,  1478,   963,  5497,   755,  5499,
     859,  2416,  3104,  3105,   654,   777,   771,   774,  2423,  2640,
    2641,   779,  2643,  2644,   685,  1636,   772,   761,   668,  5493,
    1020,   760,   963,   946,  3159,   948,   949,   950,   778,  1604,
    1030,   954,   303,   956,   779,  1434,  5075,   778,  5077,   774,
     963,  5080,   692,  1437,  1437,  1437,  1437,  1437,  5087,  5088,
     779,   761,   636,   771,   774,   184,   303,   186,  2945,  4188,
    2291,  5282,   747,   755,   761,  1604,  4206,   688,   772,  2248,
     774,   761,   761,   772,   520,   774,   946,   723,   948,   949,
     950,    57,  2313,   750,   954,  2316,   956,   946,  5127,   948,
     949,   950,  1706,   963,  1440,   954,  2327,   956,  5003,   755,
    5320,   771,   774,   184,   963,   186,   716,  3617,  1881,  3224,
    3813,  3226,  5146,    89,  1597,  2265,  5146,  5146,  1861,  1119,
    1120,  1121,  1122,   774,  1383,  1122,   771,    17,    61,   105,
     771,  1718,   772,  1133,   774,   774,  1122,  2513,  4653,   562,
    2516,   772,    32,   774,    34,  2060,  1733,  1734,   774,   779,
    5487,  2264,  2858,  2266,  3971,  1905,  2532,   299,     9,    10,
     774,  1775,   777,   677,  1440,  4327,  4670,   633,  4781,  4673,
    2546,   774,   498,   149,   303,  2288,   755,  5489,  1792,   697,
     263,  1795,   772,  1797,   774,  2298,  4781,  1801,  1802,  1803,
     284,  2966,  5816,   774,  2291,  1809,   755,  2310,    33,  4565,
     779,   177,   771,   778,   375,   772,  5147,   774,   186,   772,
    2985,   774,   652,   761,  3330,  2328,  2313,  2291,   736,  2316,
     779,   772,   303,   774,   772,  1975,   774,   774,  2934,   697,
    2327,  5855,  5856,   772,  3135,   774,  4609,  5458,   774,  2313,
    5632,  5633,  2316,  1943,   774,   366,  3644,  5286,   468,   779,
     265,    93,    42,  2327,   755,   774,   771,   697,   716,     9,
      10,   211,  1728,  4130,   771,  2008,   771,  1270,   736,  1272,
    3045,  4781,  3407,  3149,   774,  4142,   774,   609,   779,   771,
    3055,   779,   366,   774,  1905,   771,   363,  2398,  1320,   774,
     363,   156,   774,  5631,   174,     9,    10,   774,   274,  1886,
     774,   723,   553,   211,  1843,   755,  1893,   755,  4674,    80,
    1310,   424,   774,  1313,  4791,   762,   763,   764,   765,  5358,
      91,   263,   755,  5362,   152,   358,   130,   117,   439,   779,
     772,   779,   774,   184,   392,   186,  5005,   772,   128,  1914,
    5964,  1880,    14,  1346,   716,   135,   779,  2207,  3464,     9,
      10,  1914,  5305,  5157,  1975,     9,    10,    57,   251,   579,
    4188,   351,   205,  2075,  5127,   774,   586,  4851,  4852,  4853,
     696,   584,   378,  4054,   594,  1914,  4188,   167,  4112,  4113,
    4112,  4113,   761,    32,  4375,    34,   333,   130,  1385,  2132,
     778,  4455,  2252,   772,    32,   774,    14,  1366,  1367,  1385,
    2143,  2144,  5377,   114,   448,   774,  5014,   778,   356,  4747,
      61,    86,  2112,  2113,  5014,  2188,  2116,  5014,  5014,   330,
    2966,  2121,  2122,  2123,  5014,  4763,  4764,    35,  4328,  5014,
     404,  4116,  4117,  4328,   184,  2009,   186,   211,   228,   329,
    1437,   152,  1442,  1437,   377,  5622,   379,   667,  1434,   149,
     492,  1437,   303,  2052,   469,  5318,  1437,   347,     9,    10,
     280,  1944,  1945,   353,  1947,  1948,  1949,   238,    93,   259,
     184,    97,   186,  2060,   772,  1958,  5972,   177,  5517,  2078,
    5973,   374,   597,   416,  1484,   305,  1486,  3397,  2109,   379,
    1973,  3512,     0,  3753,  4216,  3755,   171,   172,   609,  3045,
    4328,   176,   761,   774,   562,  3552,   132,   481,   728,  3055,
     352,  3688,   445,   772,   349,   774,  4328,   428,  2199,   603,
      11,   146,  2061,   501,   184,   772,   186,  5207,   115,   597,
     184,   478,   186,  2108,  2877,  3422,   578,  6037,   486,    80,
     265,  5494,  5525,   130,  5527,  2119,  2120,  2936,   719,  2256,
    2939,  2940,   596,   303,  2939,  2940,  3397,  5532,   771,   319,
    2877,  5294,  2101,  3450,  3156,  5786,  2716,  5788,  5789,  2108,
    2720,  2110,   562,  2784,   274,  3137,   484,   405,  3250,  2166,
     527,  2692,  2693,  6079,   265,  3701,   252,   238,  2738,   303,
    2760,  5095,   110,   111,  2764,  5358,  2511,   439,   273,   441,
      80,   996,   997,   998,   681,  2237,   664,  2777,   681,  2897,
     453,    91,  2151,   697,   697,  2903,    37,    38,   729,   499,
    2790,  2791,   716,  3510,   174,  5079,   739,  5296,   712,   662,
    5968,  5969,   774,   184,  2117,   186,  3397,  4383,  4384,  4385,
    4386,  3347,   648,   303,  1644,   774,  1646,  3824,   581,   303,
     771,   323,   270,   114,  2366,  2367,  5609,  5610,  3473,  1054,
     464,     9,    10,  1313,   499,  2204,   681,   152,     9,    10,
    5653,  3373,  3374,   538,  1324,  5367,  3487,   627,  5664,  5900,
    5901,  3363,  1682,  5904,   617,  5070,     9,    10,  4391,   531,
     356,  4089,  3392,   774,   174,  1695,  1696,  3980,  3981,  3982,
    3983,  1701,   310,   653,   353,  1705,  1706,  1707,     9,    10,
     484,  5215,  5196,   263,  3386,   353,  1716,  1717,     9,    10,
     698,   464,  1722,   265,  1724,  1725,  1726,  1727,  1728,   771,
    1730,  1728,  5696,  3364,  1720,  3366,  2368,  5470,  2277,  2407,
     688,  1741,  1728,  1743,  2283,  5549,  1746,  1747,  5252,  1749,
    1750,  1751,   303,  1753,  1754,   697,   467,  5620,   238,     9,
      10,    10,  4854,  5626,  5985,     9,    10,   609,  1768,  1769,
    1770,  1771,  1772,   755,  1774,  1775,  1776,     9,    10,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,   728,  1787,  1788,  1789,
    1790,  1791,  1792,   284,  1794,  1795,   772,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  2436,   114,  1806,  1807,  1808,  1809,
    2407,  1811,  1812,  1813,  2407,  1815,  2995,  1817,   444,  1819,
     486,  1853,   283,  1823,  1824,  1825,   586,   774,  1828,  1829,
    1830,  1831,  1832,   723,  1834,  2432,   184,    35,   186,  2432,
     660,  1841,  3548,   184,    35,   186,  1840,  3963,  1848,  1849,
    1850,  1851,     9,    10,  1840,  3630,   374,     9,    10,  1859,
    1860,   586,  1862,  1863,  2812,   491,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  5487,
    3781,  1881,  3176,   184,  3659,   186,  5386,  5487,  1891,    35,
    5487,  5487,   576,   184,   560,   186,   439,  5487,   609,  2642,
     450,  5239,  5487,     9,    10,   586,     9,    10,  3580,   146,
    5773,  5774,    35,  3789,     9,    10,    35,     9,    10,    35,
     405,   571,  1922,   774,  2511,  2512,   167,  1927,    11,   555,
       9,    10,   774,  3083,   184,   381,   186,  1937,     9,    10,
     184,    32,   186,  3783,  3650,   171,   172,   571,  3723,   499,
       9,    10,   184,  3728,   186,   303,  5460,     9,    10,  5923,
     574,    63,   303,   146,  2551,   278,  5351,  5950,  5951,  5354,
    5355,   489,   755,   599,   283,  1978,   136,   137,     9,    10,
     303,   466,   439,   397,   774,   399,     9,    10,   449,  3695,
     643,  3697,  3698,  4715,  4716,   110,   111,  3703,   171,   172,
     771,    57,   303,  4024,  2004,  3711,  4873,   778,   779,    28,
    3716,    18,   303,   434,   435,    49,    32,  2604,    34,   499,
    3720,   270,   688,  5756,   774,  5758,   100,   184,    94,   186,
     572,  2618,   184,  3144,   186,   460,  2036,   565,  2038,  6066,
     112,    33,   279,   126,   586,    61,   112,  4163,  4164,  2052,
     725,  4167,  4168,   303,  4022,  3003,  1451,  4173,  4174,   303,
     774,   374,     9,    10,  4931,  6092,   609,  2735,  5572,    95,
    5292,   303,  2072,   233,   499,  2078,    93,   237,   184,    63,
     186,   184,   748,   186,  3630,  5177,   755,    99,  4204,   184,
      61,   186,   184,   149,   186,   779,  2670,   123,   105,   106,
      92,  3988,  3989,  4849,   345,   184,  2966,   186,  5971,  3472,
       9,    10,   310,   184,   774,   186,  4003,  5473,   771,   310,
     774,   177,  2709,  2698,   774,   184,   478,   186,   288,   755,
     756,   757,   184,   747,   186,  2698,   120,  5522,  2735,   299,
     449,    63,  2735,   326,  2856,  5645,   303,   697,     9,    10,
     774,   303,   609,   184,  2897,   186,   192,  2157,   192,  2698,
    2903,   184,   608,   186,   310,     9,    10,  3530,   448,   205,
    2636,   205,  2804,   574,   487,  2918,  4400,  3723,  2717,   281,
    5790,  5791,  3728,   566,   299,  3045,   729,   310,  2188,  2889,
     192,   310,  2892,   566,   310,  3055,  2896,   303,   120,   425,
     303,   292,  3150,   205,   223,   176,   421,  2210,   303,  3552,
     738,   303,   204,   565,  3806,  3807,  3808,  3809,   274,  3608,
    3782,     9,    10,   774,   303,     9,    10,   263,  4039,   263,
     655,   774,   303,     9,    10,  3552,  3739,   184,   272,   186,
     533,  2840,  3739,  2924,   303,  5749,  4529,  4530,   566,   233,
    5472,   303,   425,     9,    10,    83,  5612,    73,   265,   374,
    2847,   263,  2849,   478,  2747,    93,  3416,  3417,    69,     9,
      10,   112,   303,   706,   140,  2814,  2759,   710,    24,   404,
     303,   110,   111,     9,    10,   184,   278,   186,     9,    10,
    3440,   771,   706,   121,  3405,   709,  3584,   281,   778,   779,
    3588,     9,    10,    83,   288,  5027,   211,  5029,   333,   779,
    3421,  2311,  3943,   141,  3945,   299,   596,   774,   146,   452,
    2320,  2321,  2311,   184,   296,   186,     9,    10,   520,     9,
      10,   683,   316,     9,    10,   352,  3754,   353,   447,  5816,
     184,   121,   186,  2201,  2311,  5067,   747,  2205,  5961,  2936,
     565,  5913,  2939,  2940,  2941,   738,   303,   185,  3840,   281,
    5452,   635,  3839,   204,   165,   738,   112,  5962,  2989,    18,
    2311,  4721,  3837,  3838,   489,     9,    10,   566,  5855,  5856,
    5247,  3846,   183,  3848,   588,  3850,   738,  2926,  2311,   520,
       9,    10,  3135,   427,   299,  3784,   184,  2397,   186,  3784,
     184,   774,   186,  2886,   303,  2888,   143,  2407,   184,   702,
     186,  2894,  2895,  4188,   265,  2415,   608,   453,  2407,   453,
     738,   237,   439,  3786,   441,  5147,   774,   720,   184,  4779,
     186,   297,  2432,   774,  2434,     9,    10,  2437,     6,  2439,
      57,  2311,   303,  2432,   184,  2434,   186,  2447,  2448,   277,
     583,   453,  2311,   478,  5571,   284,   105,   106,   184,   303,
     186,  6000,  6001,   184,   208,   186,  2407,  2434,   683,    32,
     662,  4587,    89,   774,    37,  4490,   184,   608,   186,  4494,
     684,  2475,  3397,   774,  2407,   229,   595,  5964,   105,  2475,
     591,  2432,   229,  2434,  4200,  4201,  4202,   277,     9,    10,
      68,   184,   527,   186,   184,   779,   186,   404,   184,  2432,
     186,  2434,   524,   525,   531,   303,   528,   529,   530,   303,
     451,  6060,  2362,   738,   774,  6087,  6088,   303,   661,   340,
     774,   662,   149,   737,  3482,  3156,   333,  2407,    24,  2539,
    2540,  2541,   774,     6,  5875,   374,  4567,   303,  2407,   738,
     184,  5418,   186,  4328,   485,   316,     9,    10,   100,   774,
     177,   100,  2432,   303,  2434,   184,  3141,   186,   669,  4829,
     100,   123,  4832,  2432,  4834,  2434,   187,   303,  3141,  4833,
      93,  4835,   303,   115,   481,   774,   266,  3839,  4294,  4295,
     716,  4297,   609,  3845,    15,   303,   130,   681,   128,  3851,
       9,    10,  3141,    26,  3143,    68,  4866,   418,  4868,  4869,
     184,   771,   186,    12,  3228,  2615,   265,   774,   652,   502,
     303,  5952,   774,   303,   421,  3239,   112,   303,   141,     6,
     561,  4747,   502,   146,   140,   410,  2636,   171,   172,  2636,
    2640,  2641,   417,  2643,  2644,     9,    10,  4763,  4764,   733,
    2636,   237,  2652,   779,  2654,   185,  3406,   274,     9,    10,
     489,     9,    10,    61,   848,  4955,    65,   118,   774,   303,
     204,   774,   185,   184,   125,   186,   546,     9,    10,   774,
     772,   478,  2682,  3297,   303,  3224,  4863,  3226,    94,  3357,
     292,    68,   294,  4552,   728,   774,  2696,     9,    10,   171,
     172,   312,   736,   774,   125,  4718,   112,  4720,   892,  2709,
    4723,   642,  2712,  4726,  3328,   774,  4729,  4730,    81,   140,
    4422,  4423,   774,     9,    10,  5748,  5076,    95,  5751,   303,
     527,   184,  2735,   186,    97,  2735,  2736,     9,    10,   190,
       9,    10,  5092,   774,   278,   730,  2735,  4449,   152,   772,
     171,   172,  4765,   637,  2757,     9,    10,   125,  2758,   265,
    3357,  4572,  2765,   126,  3357,  3379,   650,  4473,   565,   132,
    3630,     5,  4474,  3454,   149,   184,  5847,   186,   771,  5850,
    6146,  5131,  4328,  5133,  4484,  3406,  3454,   771,  4380,  4495,
     149,   297,   303,  3380,  2735,  5823,   217,    31,   779,  2799,
     444,  5660,   177,  4014,     9,    10,   169,  2776,     9,    10,
    3397,   681,     9,    10,    10,     9,    10,   331,   177,  3767,
     184,     6,   186,  2809,  4524,   772,    11,     9,    10,  5688,
      15,     9,    10,   184,  5986,   186,   184,  2840,   186,    73,
     374,  3584,   374,  2843,   284,  3588,  5869,   491,  4018,   381,
     303,  2854,   184,  5876,   186,  4066,   112,  3454,   391,     6,
       6,  3454,  3973,  3723,   396,  2735,    17,  1154,  3728,     6,
     408,  4021,   184,   772,   186,   408,  2735,     9,    10,   238,
       6,    32,    17,  3739,     9,    10,   683,   716,  4570,   421,
     761,   289,   290,  6045,   303,  1182,  6048,    95,   184,    34,
     186,   772,   117,  3369,  4773,   761,  3480,   738,  1528,  4778,
      95,   772,   184,   128,   186,   184,   772,   186,   562,   263,
     135,    68,    68,  4734,     9,    10,   567,   568,   772,  2929,
     184,    68,   186,  6085,   663,     9,    10,  6008,   172,   303,
     299,   738,    68,  2943,   772,  2945,  4967,  1567,  1568,  4452,
    2953,   663,   303,   487,   450,   303,   253,  2960,  2961,   760,
     761,   762,   763,   764,   765,  5988,  5989,   264,     9,    10,
     772,   303,     9,    10,  5234,     9,    10,   774,   212,   184,
     772,   186,   774,   184,   772,   186,    95,   184,   772,   186,
     184,   303,   186,   391,   526,   778,   772,     9,    10,  4362,
      10,  3001,   184,   644,   186,    15,   184,   539,   186,   761,
     656,  1464,  1465,   228,     9,    10,   772,   303,     9,    10,
     772,  3608,   774,    79,   115,   677,    82,   559,    76,  4735,
      78,   303,   772,   685,   303,  4741,  4742,  4743,  3781,   691,
     115,  3615,  4748,  4749,   259,  1498,   772,   115,  4754,   303,
      15,   772,   184,   297,   186,  3594,  4762,   771,   727,   184,
    4766,   186,  4949,  4950,   772,   779,    28,  4773,  5081,   467,
      32,  4777,  4778,     9,    10,    37,     9,    10,  3617,  3618,
    4332,  4333,  4334,   771,  4336,  3568,  3118,   779,   772,   772,
     774,   779,  4344,  4345,  4346,  4347,   772,   779,   303,   184,
     263,   186,   303,   249,   250,    84,   303,  2947,  2948,   303,
     184,   651,   186,   259,   427,   125,    17,   251,     9,    10,
     736,   303,  4804,  5239,  2964,   303,   182,    76,  3667,  4279,
     140,    32,   278,    34,  2974,  2975,     9,    10,   772,   772,
    1031,   774,  3739,   184,   771,   186,  3739,   184,   270,   186,
     184,   683,   186,   772,   192,  4966,     5,  4409,  1049,  5275,
     125,   171,   172,   778,  1055,  1056,   698,   205,     9,    10,
    1335,   303,   184,   778,   186,   140,  1341,  1342,   303,   462,
     339,   340,  3168,    93,    94,  3806,  3807,  3808,  3809,   184,
     774,   186,  4334,   184,  4336,   186,    95,  3784,   772,  4562,
    3040,  3041,  3042,  3043,  4346,  4347,   683,   217,   264,   112,
    3210,  3211,  3212,   251,   760,   761,  3216,   376,   303,  3219,
     601,  3210,  3211,  3212,   772,   772,   774,   774,  3228,   303,
    3980,  3981,  3982,  3983,   272,  4937,   772,  3237,   774,  3239,
     641,  3241,  5627,  3243,  3244,  3245,  3246,  3247,  3248,   670,
    3250,   184,   217,   186,   772,   772,   774,   774,  3258,   418,
    3260,   772,   303,  3263,  3264,  3265,   303,  1628,  1629,   303,
    5570,  1632,  3272,  3273,  3274,   467,  3276,  4839,  3278,   772,
    3280,   774,  3282,   771,  3284,  3872,   578,  3210,  3211,  3212,
     180,   303,  3292,   184,  3294,   186,  3296,  3297,  3298,  3299,
    3300,    93,    94,  3303,  3304,  3305,   697,  3307,   303,   270,
    3310,   184,   303,   186,   946,   180,   948,   949,   950,   772,
     466,   418,   954,  3323,   956,   110,   111,  3941,  3328,  4079,
     774,  3331,  3919,  3333,  3334,  3335,   114,   772,  3338,   774,
    3210,  3211,  3212,   184,  3344,   186,  4344,  4345,  4559,  3349,
     348,  3210,  3211,  3212,  3357,  1820,  1821,  3357,  3358,  3980,
    3981,  3982,  3983,   772,  3364,   772,  3366,   774,  3357,  3369,
     303,   771,  3369,  4116,  4117,    10,   778,  3363,   612,  3379,
      15,  3381,   771,  3369,  3958,   771,  3386,    69,   771,   427,
     291,   292,   755,   756,   757,   771,   755,   771,  4548,  4549,
    3987,   760,   761,    57,   744,   745,   333,   747,   772,   749,
    5251,  4888,   303,  5113,  1419,   164,  3357,  1422,  1423,   771,
    3420,   772,  3422,  3420,   772,   266,  3420,  4577,   329,  4894,
     303,  3420,   771,  4898,  3420,    89,    36,   771,   597,  3420,
     772,   771,   771,  3420,    67,   772,   347,   774,  3420,   771,
    3450,   105,   353,  3420,  3454,   614,  4874,  3420,  4079,  3420,
     772,   210,   303,  5165,    57,  3454,    11,  4054,  4328,   772,
     772,   774,   774,  5179,   772,  5181,   774,  5183,   379,  3420,
     639,  3481,   505,   165,   507,   508,   772,  3357,   197,    34,
     125,  3488,    92,   771,   771,   149,    89,  3420,  3357,   522,
     772,   183,   251,   772,   772,   140,   774,  3493,     9,    10,
    3510,  5014,  3512,  3454,   771,   115,    61,  5014,   772,  4093,
     679,  5193,   772,   177,   774,   771,   672,   673,   674,   675,
     130,  3454,   772,   400,   774,  5759,   171,   172,   771,  5245,
     772,   164,   774,    69,   772,   418,   774,   771,   171,   172,
    3420,   478,   771,     9,    10,   771,   149,   239,   240,  5370,
     772,  3420,   774,   771,   771,   110,   111,   772,     9,    10,
      11,   772,   772,   333,   774,   772,   771,    17,   772,   772,
    3580,   774,   217,   771,   177,   130,   730,   210,   270,   730,
     772,  5432,    32,   166,   772,  3454,   196,   620,   621,   125,
     527,  3601,   771,   470,   204,   524,   525,   771,    34,   528,
     529,   530,   191,   771,   374,   771,   374,  4100,    58,   772,
     274,   774,   771,   771,    49,   374,   171,   172,   251,  3629,
      70,   176,    36,     9,    10,   180,  4888,   386,   565,   165,
     772,   771,   771,  3646,  3647,  3648,  3649,   772,  3651,  3652,
      90,   772,   772,   774,   774,  3655,  3656,   183,   771,   204,
     670,   507,   508,   421,   772,   772,   774,   774,   535,   771,
     537,    96,    69,   771,   374,   542,   522,   771,    42,  3679,
     440,   274,   122,   184,   124,   186,   191,   772,    92,   771,
     115,  3691,   772,   771,   774,   151,  3699,  3700,   772,  3702,
     771,  3704,  3705,  3706,  3707,  3708,  3709,  3710,   772,  3712,
     774,   115,  3715,   239,   240,   772,  3719,   774,   478,   771,
     478,  3721,  3722,   191,   771,  5601,   130,   771,   184,  5605,
     186,   772,   772,   278,   774,   772,  5442,   191,   772,  3739,
     607,   490,   772,   184,   774,   186,   772,   772,   774,   774,
    3739,   374,   771,   117,  5978,   771,   683,   302,  3758,  4380,
     772,    69,   771,   386,   128,   266,   771,   527,   165,  3758,
    4402,   135,   372,  5445,   620,   621,   743,   772,   478,  4529,
    4530,   772,   771,   650,     6,   772,   183,   774,   772,   334,
     774,  3758,  3632,  3633,   771,  3635,  3636,   771,  3739,   559,
     204,   559,   303,   167,   772,   565,   774,   565,   184,   779,
     186,   738,   772,   562,   774,   771,  3739,  3758,  4432,   244,
    3820,   772,   723,   774,   197,   772,  3826,   774,    34,   374,
    5219,   771,  5687,  3833,  5219,  3758,  3836,  3826,   263,   772,
     280,   771,   239,   240,   772,   771,   774,   303,   772,   772,
     774,   774,   292,   278,   772,    61,   774,   165,   616,   559,
    3860,  3861,   303,   771,   228,   565,   772,   490,   774,  3739,
    4551,  5747,   772,   740,   774,   183,   641,   265,   772,  5720,
     774,   772,   771,  4551,   751,  3885,  3726,  3887,  3758,  3889,
    4504,  3891,     9,    10,  5566,   259,   772,  4511,   774,  3758,
     771,   326,  5713,  3826,   110,   111,  5927,   771,  4529,  4530,
     455,  5329,  5330,  3913,  5332,   771,   616,  4865,   771,    57,
     296,   771,   197,   683,   130,   683,   771,   303,   771,     9,
      10,   239,   240,   698,  3934,  3935,   701,   771,    29,   562,
     771,  3941,   487,  3943,   771,  3945,  5646,    38,     9,    10,
    3950,    89,   774,   772,  4551,   774,  3826,   397,  4551,   399,
     772,    69,   774,   728,   722,   171,   172,  3826,   372,    60,
     176,   736,   771,   771,   180,    69,    93,   771,   738,   404,
     738,   771,  3985,   683,  5487,     9,    10,   587,  3988,  3989,
    5487,   771,    53,    54,    55,    56,    87,   771,   204,     9,
      10,    11,    93,  4003,   772,  4705,   774,    98,   772,   771,
     774,   149,   771,   755,  4714,    95,   774,   125,   771,     9,
      10,   112,   722,   771,  4024,   772,   771,   774,     9,    10,
    5730,   772,   772,   774,   774,   670,   127,   771,   738,   177,
     772,  4722,   774,   134,  4038,   771,   107,   108,   109,   772,
     771,   774,  4038,     9,    10,   578,   772,   165,   774,  4633,
     151,   772,   772,   774,   774,   771,   771,   184,   771,   186,
     771,   165,   278,   771,   771,   183,   758,   759,   760,   761,
     762,   763,   764,   765,   771,   176,   771,  4087,  4088,   183,
    5508,  4094,  5510,  5511,   771,   695,   302,   771,  2274,   771,
     161,   162,  4676,   771,   184,    95,   186,   771,   771,   654,
     771,   771,   552,   771,    95,  5926,   771,   180,  2294,    95,
    4120,   343,   180,   184,  6145,   186,   237,  2303,   334,   220,
    4130,   239,   240,  2309,   225,   226,   274,    57,   779,    95,
     779,  2317,  4142,   779,  4144,   239,   240,   779,   239,   779,
     779,  4690,   779,  2329,   779,   779,  2332,  5857,   779,   779,
     184,   663,   186,   771,   681,   387,   426,   389,   374,    89,
      34,   232,   141,   379,   184,    93,   186,     3,   681,   697,
      32,   669,    34,   587,  5573,  5574,   303,   502,  5573,  5574,
     420,    93,   774,   123,   184,   576,   186,    61,   774,   744,
     774,  4725,    28,   184,   348,   186,    32,   298,   774,    61,
      93,    37,    18,   638,    40,   382,   774,   774,   573,  4758,
     660,   692,   755,   303,    80,   736,   453,   652,   184,   149,
     186,   656,   758,   759,   760,   761,   762,   763,   764,   765,
     453,    94,   303,   304,   774,   196,   110,   111,  4280,   340,
     265,    57,   100,  5959,   281,   125,    26,   177,   110,   111,
     238,   483,  5934,   115,    61,  4265,   130,   396,  4836,   709,
     361,   780,    98,     5,   577,   395,   701,     4,   736,   303,
      86,   487,   779,    89,   418,   340,   778,   778,     9,    10,
      11,   695,   732,   303,   771,   771,   203,   379,  5998,   105,
     106,  5157,   771,   728,  6115,   771,   771,   171,   172,   197,
     532,   771,   176,   303,  4797,   779,   180,    93,  6129,    93,
      14,    93,   303,   774,  6135,    84,  4358,  4327,   421,   779,
    6141,   779,   151,   125,   697,   161,   772,   771,   499,   400,
     204,   193,   296,   149,   435,   112,   555,   303,    95,   240,
     123,   296,   771,   151,   274,   778,   774,   771,     6,   581,
     772,  4948,   168,   760,   761,   762,   763,   764,   765,  5069,
     176,   177,  5072,  5073,  4374,   418,   772,   772,  4218,   110,
     111,  4221,    68,   324,  4224,  4225,  4226,  4227,   774,  4229,
    4230,  4231,  4232,   772,  4234,  4235,   779,  4237,  6070,   130,
     772,  4241,   254,   255,   256,  4245,  4246,  4247,  4248,   470,
    4250,  4251,   772,   642,   278,    93,  4256,  4257,   779,    93,
    4260,  4261,   772,  4163,  4164,   277,   772,  4167,  4168,  4429,
    4430,   772,  4432,  4173,  4174,   779,   771,   140,   302,   771,
     171,   172,   100,  4443,  4444,  4445,  4985,    49,   654,   671,
     302,   759,   760,   761,   762,   763,   764,   765,  4458,   265,
    4460,    32,  4462,   184,  4464,   186,   270,   273,   274,   275,
     334,   693,   774,   204,   535,   774,   537,  4477,  4478,   774,
      57,   542,   334,    93,   336,   576,   762,    58,   779,   774,
      34,   317,    83,   774,   681,    42,   762,   125,   482,    70,
     694,   353,    93,   355,  4504,   442,    93,   774,   681,  4512,
     374,  4511,    89,   426,   772,   771,   771,   774,   418,    90,
    4520,   780,   374,   774,   125,   196,   238,   351,   105,   381,
     121,   218,  4535,   110,   111,  5685,   502,   333,   744,   502,
    5079,   367,   502,   502,   396,   348,   607,   278,   774,   502,
     141,  4551,   502,   124,   406,   146,   774,   755,    84,   669,
    5157,   270,  4551,  4563,  5157,     6,   666,  4567,   589,   421,
     117,   302,   149,   736,   128,   772,   772,   772,   374,   772,
     772,   128,   303,   128,  4570,   391,   771,    26,   135,   650,
     188,   774,   104,   399,   185,   779,   430,   229,   779,   658,
     177,   409,   771,   205,   472,  4608,   472,    29,  5556,   774,
    4551,   588,   772,   296,   727,   774,   283,   771,   379,   294,
     167,    33,   294,   487,    36,   421,   215,   479,  4551,    17,
    4630,  5487,  5219,   180,   177,   774,   696,   489,   201,   185,
      95,   180,   213,   374,   440,   637,   774,   774,  5348,   251,
     758,   759,   760,   761,   762,   763,   764,   765,   270,   116,
     123,   643,   418,    49,   758,   759,   760,   761,   762,   763,
     764,   765,   762,  5823,   526,   772,   772,   772,    95,   740,
      92,   228,   478,   774,    96,  4688,   277,   539,  5838,  6107,
     751,   772,  4551,   772,   772,  5292,   772,   274,   771,  5292,
     772,   527,  4719,   115,   761,   772,   772,   772,   772,   280,
     772,   779,   259,   238,   196,   771,  4733,   771,   130,   772,
     772,   772,  5872,   772,   326,   771,   774,   774,   580,   115,
     772,   527,   772,  4750,   586,   774,   774,   284,   564,   565,
     774,   772,   568,   772,   772,   571,   572,    42,  4751,  4752,
     772,  4768,   765,  4770,  4771,   771,   487,   366,   755,   584,
     265,   265,   265,   559,  4767,    99,    95,    15,   270,   565,
      18,   774,   774,    93,    93,   771,   771,   496,   779,   779,
     774,  4781,    95,   774,   196,   772,   779,   608,  4791,   237,
     654,   774,   204,   645,  4794,  4795,    62,   772,     6,   726,
     652,   774,   404,   663,   774,    93,   192,   774,   570,    57,
     128,   637,   128,   742,   430,   540,   771,   550,  4804,   205,
     251,   251,   117,   651,   650,   427,   397,   251,   399,   299,
     656,   683,   244,   128,   180,   251,   251,   771,    86,  4836,
     135,    89,  4836,    93,   755,   266,   698,   699,   774,   755,
    4836,   453,   755,   126,   680,   501,   156,   105,   106,   711,
     686,   755,    33,   689,   772,    36,   278,   418,   755,   755,
     755,   755,   167,  4873,   755,  5472,   702,   755,   755,  5472,
     744,   755,   755,   755,   710,   180,   272,   683,   755,   727,
    5487,  4731,   755,   755,  5487,   305,   755,   723,   724,   501,
     706,   149,   280,   709,   350,   755,   755,   772,  5596,   755,
     755,   357,   718,  4753,   755,   755,   755,  5660,  5492,    42,
     168,    92,   774,   774,   779,    96,   284,   373,   176,   177,
     756,  4931,   570,   228,   141,   772,  4968,   383,   384,   385,
     772,   774,   738,   779,   115,  5688,   772,   393,   771,  4949,
    4950,   321,   779,   270,   774,   270,   270,   779,   270,   130,
     372,   747,   499,   789,   259,   123,   380,  4967,   418,   122,
     772,   797,   122,   772,   779,  5007,   191,   803,   774,   805,
     551,   552,  4982,   772,   772,   772,  5573,  5574,  6138,   779,
     772,    26,   761,   761,   117,   779,   774,   772,   690,   825,
      11,  5001,   326,  5003,   578,   128,   772,   771,   834,   270,
      95,   771,   135,   744,  5017,    95,    95,   265,    95,   265,
     846,  5021,   848,  5023,  5056,   273,   274,   275,   779,  5061,
    5627,    42,   265,   204,  5627,   484,   211,   779,   774,   761,
     177,   427,  5059,    11,   167,   299,   310,   771,   348,   778,
     652,   755,   536,   755,   656,  5743,   882,   180,   884,   774,
      92,   887,   888,   889,   890,   891,   892,   453,   894,    80,
     321,   180,    83,   244,   180,    10,   270,   128,   128,  5822,
      91,   774,    93,   772,   265,   396,  5089,   396,   534,   100,
     219,   265,   265,   104,   394,    11,   698,   100,   771,   177,
     451,   771,   548,   114,   177,   228,   117,   278,   771,   224,
     121,   779,   123,  5116,   151,   501,    72,   128,   762,   945,
     578,   947,   270,   762,   135,   180,   728,   114,   340,   955,
     141,   957,   151,    56,   736,   146,   259,   772,   709,   124,
     124,   772,   772,   391,   177,   772,   972,   771,  5687,   774,
     779,   399,   774,   779,   772,   185,   167,  5157,  5839,   772,
     771,   122,    26,   755,   772,   771,   771,  5170,  5157,   180,
      95,   220,   772,    95,   185,   587,   476,    29,   772,   774,
     211,   774,   772,   771,  6132,   151,    38,   772,    53,    54,
      55,    56,   774,  5193,   205,   779,   296,   211,  5192,   771,
     547,   372,   771,   649,   774,   755,  5192,  5207,    60,   683,
     683,   597,   396,   180,   771,   284,  5157,   228,  5207,   284,
     366,    11,  5222,   771,   265,   774,   237,   437,   186,   372,
     772,   196,   196,   774,  5157,    87,   270,   409,   538,   196,
     686,    93,   107,   108,   109,    26,    98,  5247,   259,   734,
     196,   129,   638,   409,   700,   698,   129,   557,   558,   196,
     112,   698,   562,   563,   564,   196,   277,   196,   196,   196,
     656,   270,   283,   284,    11,   127,   772,   585,   430,   229,
    5312,   772,   134,   695,  5207,    99,   297,  5157,   299,   415,
     494,   302,  5292,   772,    26,   235,   161,   162,  1124,   151,
     772,   299,   637,  5292,   772,   496,   185,   774,    26,   774,
     772,   772,   698,   142,   196,   701,   772,   438,   146,  5858,
     774,   772,   774,   746,   176,   140,  5792,   771,   196,   180,
     630,    11,   772,   669,   143,   284,   284,  5207,   771,   177,
     177,   586,   728,   734,   112,   130,   204,  5347,  5207,   734,
     736,  5292,   779,   216,   598,   180,   180,   374,   477,  1185,
    1186,   266,    95,   230,   430,   578,   299,   232,   220,  5292,
     123,   418,   772,   225,   226,   772,   141,   490,   540,   679,
     608,   124,    32,   772,  6072,   772,  1212,   239,    26,   772,
     774,   350,   772,  1219,    10,  1221,   772,   779,   357,  1225,
    1226,   772,   774,   771,   771,  5979,   648,   772,   772,    11,
    5949,   771,   771,    26,   373,    26,   587,    79,  5418,    26,
     177,   771,  5292,   319,   383,   384,   385,   437,   771,  1255,
      93,   771,   130,   130,   393,    93,   130,   774,   449,   304,
     771,   774,   299,   662,   772,  5445,   298,   130,   378,   299,
     413,   263,   151,   774,   540,   436,   678,   410,   706,   577,
      11,   709,   772,   418,    67,   772,   772,  1293,   771,   771,
     718,  1297,  5472,   772,   772,   180,  6015,  1303,  1304,  1305,
     774,  5467,   226,  5472,   774,   226,    26,  5487,   340,    93,
      26,    26,   265,   400,    84,  1321,    84,   284,  5487,   263,
     771,   779,    33,   779,  1330,   281,   578,   772,   643,   361,
     772,   431,   596,   596,   771,   354,  5548,   190,  1344,  1345,
    5552,  5538,   771,   778,   695,   778,   778,   774,   771,    61,
     771,  5472,   772,    61,   772,   400,   154,   678,   578,  1365,
      33,    33,   197,    10,   689,   772,  5487,   704,  5548,  5472,
     177,   302,  5552,    26,    26,   771,   123,   771,   180,  1385,
    1386,   130,   771,   695,  5487,   771,  5566,   734,  6142,   771,
     130,  5571,   281,   327,    61,   534,   176,    11,   419,  1405,
    6119,    91,  5571,   435,   578,   578,  6125,   643,    17,   548,
     409,   716,   771,   409,  1420,   771,   774,   230,   421,   173,
     730,   778,  5472,   772,   772,   470,   771,   771,   778,   690,
     771,   771,  1438,  1439,   418,   774,   771,  5487,   340,    93,
     582,  1447,   771,   146,   413,   772,   326,  5627,   772,   771,
     226,   771,   320,   772,   180,  1461,   180,   229,  5627,   772,
     774,   197,   281,    63,  1470,  1471,  5678,   418,  5571,   716,
     772,     7,  1478,  1479,   472,   772,  1482,    75,    26,    17,
    5660,   643,   114,   177,  5696,   237,  1492,   771,  2828,   774,
     535,  5674,   537,  3420,   963,   634,  3717,   542,  5678,  5183,
    5179,   110,   111,  5472,  5181,    41,  5627,  5470,  5688,  1272,
     649,  5481,  5469,  5472,  3561,  4184,  5696,  5310,  5629,  5599,
    5700,  5571,  5771,  5980,  5627,  4096,   770,    63,  1456,  3562,
    5016,  5489,  5571,  5887,  4331,  5886,  1501,    73,  3758,  3796,
    4968,   859,  4358,  2335,   576,  2849,  1892,   686,  4054,  3822,
    4375,   742,   527,  4855,  4579,  3006,   839,  2436,  2434,  1497,
    2435,   700,   607,    99,   755,   982,  2437,  5291,  5748,  2355,
    2213,  5751,   110,   111,  5468,  1581,  5467,  5627,  1584,   115,
    1586,   772,  4273,   774,   120,  3679,   777,   778,  5627,  5099,
    1596,  1597,  4521,  5256,  4525,  4936,  2678,  5845,  1604,    71,
    5929,  5445,  1608,  1609,  5260,   650,  6070,  6017,  5743,  6072,
     146,  2877,  5792,  5825,  4717,  5792,  4265,  5949,  5607,  4785,
    4274,  5062,  5286,  6001,  5792,  5688,  5792,  1633,  5822,  3096,
    1636,  3840,  5825,  5816,  5839,  5360,  3924,  2276,  4491,  4486,
    4494,   113,  2284,   252,  6044,  5825,   492,  5827,   492,  5988,
    5523,  5989,  5953,  5876,   263,  5869,  5339,  4080,  1664,  5341,
    5602,  2302,  4273,  4781,  2090,  1287,  3544,  5545,  3539,  5852,
    5853,  5359,  1475,  2995,  5834,  2694,  3812,  2251,  2816,  3175,
     216,   153,  4392,  5866,  5864,   537,  1434,  1693,  3363,  5869,
     776,  3477,  1387,  3612,   726,   740,  5876,   233,  5885,  1209,
    4367,  3412,  4512,  1423,  3296,   241,   751,  3292,  1824,  3958,
    4511,  5923,  1734,  1882,   252,  5735,  5736,  2144,  5738,  5739,
    5740,  5741,  1702,  2139,  1385,  1385,  5327,  1385,  1385,  1385,
    5777,  5031,  4564,  4976,  5778,  2134,   272,  1708,  2932,  2160,
    3950,  3948,  5251,  5923,  4672,   281,   282,  5927,   723,  3604,
    4671,  5370,  4955,  5247,  5934,  5938,  3608,  5265,  5941,   782,
    5720,  1441,  4676,  2926,  1415,   510,  3127,   492,  3168,  3493,
    4966,  1642,  4982,  5953,  3643,  4561,  4563,  5957,  5926,   699,
    2347,  5964,   883,   882,  2785,  1964,  2016,   690,  6000,  6001,
    1796,  2786,  3471,  1437,   690,   527,  5373,   772,   407,  1805,
    2843,  5275,  1646,  4395,  6068,  5036,  5986,  2079,  5988,  5989,
    1816,  6095,   421,  5336,   423,  6141,  6135,  2805,  4572,  1053,
    3357,  1827,   982,  6035,  3452,  4551,  2619,   689,   689,  2739,
    3430,  5851,  3431,  2412,  5854,   686,  1906,  1843,  1638,  2108,
    4199,  3405,  5862,  2989,  1190,   454,  4690,  5867,  6060,  3800,
    3555,  5412,  4280,   516,   730,  1331,   492,   492,   492,    -1,
     469,  6033,    -1,    -1,    -1,  6045,    -1,    -1,  6048,   407,
      -1,    -1,    -1,    -1,  1880,    -1,  1882,    -1,    -1,    -1,
      -1,    -1,    -1,   421,    -1,   423,    -1,  6099,    -1,    -1,
    6070,   427,    -1,   502,    -1,    -1,   432,    -1,  1904,  1905,
      -1,    -1,    -1,    -1,    -1,  6085,    -1,   443,  1914,  1915,
      -1,   520,    -1,    -1,    -1,    -1,   454,    -1,  1924,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   469,  1938,  1939,    -1,    -1,    -1,    -1,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,    -1,    -1,    -1,
      -1,    -1,  1958,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,  6145,  1972,  1973,    -1,  1975,
     945,    -1,    -1,    -1,    16,    17,    -1,    -1,    -1,    -1,
      22,    23,   520,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,  1997,   601,    -1,    -1,    -1,    -1,    -1,    -1,   608,
      -1,   473,  2008,    -1,    -1,    -1,    -1,    -1,    -1,   618,
      -1,    -1,    -1,  2019,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,   631,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,   503,   504,    -1,   506,   507,   508,   509,   510,    -1,
     512,   513,   514,   515,   516,   517,   518,   519,    90,   521,
     522,   523,    -1,   662,    -1,  2061,   665,    -1,    -1,    -1,
      -1,    -1,    -1,   601,    -1,    -1,   602,    -1,    -1,  2075,
     608,    -1,   681,    -1,  2080,    -1,    -1,    -1,    -1,    -1,
     618,    -1,   124,    -1,    -1,    -1,    -1,   623,   697,    -1,
      -1,    -1,   628,   631,    -1,  2101,    -1,    -1,    -1,    -1,
      -1,    -1,  2108,  2109,  2110,   147,   148,    -1,   150,  2115,
      -1,  2117,    -1,    -1,    -1,    -1,   158,   159,   160,    -1,
      -1,    -1,    -1,   659,   662,    -1,  2132,   665,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,  2143,  2144,    -1,
      -1,    -1,    -1,   681,    -1,  2151,    -1,    -1,   620,   621,
      -1,    -1,    -1,    -1,    -1,   691,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   213,    -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,  2204,    -1,
      -1,   243,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
      -1,  1186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2226,    76,    -1,    78,  2230,   267,   268,   269,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,  2248,    98,    -1,    -1,    -1,    -1,    -1,   291,
     292,    -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2277,   127,    -1,    -1,    -1,    -1,  2283,    -1,   134,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
     342,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2319,    -1,    -1,    -1,    -1,   360,    -1,
      -1,   176,  1297,    -1,    -1,    29,    -1,    -1,  1303,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      -1,  2347,    -1,  2349,    -1,    -1,    -1,    -1,  2354,    -1,
      -1,    -1,    -1,    -1,    -1,   397,    60,   399,    -1,    -1,
    2366,  2367,    -1,    -1,    -1,   220,    -1,  2373,    -1,    -1,
     225,   226,    -1,    -1,  2380,  2381,    -1,  2383,  2384,    -1,
     422,    -1,    -1,    87,   239,    -1,    -1,    -1,    -1,    93,
      -1,    -1,  2398,    -1,    98,    -1,  2402,    -1,    -1,    -1,
      -1,    -1,    -1,   445,    -1,    -1,  2412,    -1,   112,    -1,
    1385,    -1,    -1,  2419,   456,   457,    -1,    -1,    -1,    -1,
      -1,    -1,  2428,   127,    -1,  2431,    -1,    -1,    -1,    -1,
     134,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,   298,    -1,    -1,   488,   151,    -1,    29,
      -1,    -1,    -1,    -1,    -1,   497,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    -1,    -1,    -1,    -1,   340,  1461,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1471,    -1,    -1,    -1,
      -1,   543,   544,   545,  1479,    -1,   361,    87,    -1,   551,
     552,    -1,    -1,    93,    -1,    -1,   220,    -1,    98,    -1,
      -1,   225,   226,    -1,    -1,    -1,   568,   569,    -1,    29,
      -1,    -1,   112,    29,    -1,   239,    -1,    -1,    38,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,   127,    -1,    -1,
     592,   593,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      60,    -1,    -1,   418,    60,    -1,    -1,    -1,    -1,   611,
      -1,   151,    -1,    -1,    -1,    -1,    -1,  2583,    -1,    -1,
     435,    -1,    -1,  2589,    -1,    -1,    -1,    87,    -1,    -1,
      -1,    87,    -1,    93,   298,    -1,   176,    93,    98,  2605,
      -1,    -1,    98,    -1,    -1,    -1,   310,    -1,    -1,  1584,
      -1,  1586,   112,    -1,    -1,    -1,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,
      -1,   127,    -1,    -1,   134,    -1,   340,    -1,   134,    -1,
     220,    -1,    -1,    -1,    -1,   225,   226,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,   151,    -1,   361,    -1,   239,
      -1,   703,    -1,    -1,   706,    -1,    -1,   709,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   176,    -1,    -1,    -1,
     176,    -1,    -1,    -1,    -1,    -1,  2692,  2693,  2694,    -1,
     732,    -1,  2698,    -1,    -1,    -1,  2702,  2703,  2704,  2705,
      -1,    -1,    -1,    -1,  2710,  2711,    -1,  2713,    -1,   751,
       5,  2717,     7,     8,   418,    -1,    -1,    -1,   298,    -1,
     220,   576,    -1,    -1,   220,   225,   226,    -1,    -1,   225,
     226,   435,    -1,    -1,    -1,    -1,    31,    -1,    33,   239,
    2746,  2747,    -1,   239,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2759,    -1,    -1,    -1,    -1,    -1,    -1,
     340,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      -1,   361,    -1,  2789,    -1,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    -1,   298,  2805,
    2806,    -1,   298,    -1,    -1,    -1,    -1,    -1,  2814,  2815,
    2816,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
     115,  1796,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1805,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   418,  2845,
     340,  1816,    -1,    -1,   340,    -1,  2852,    -1,    -1,    -1,
    2856,   146,    -1,    -1,    -1,   435,    -1,    -1,    -1,    -1,
      -1,   361,    -1,    -1,    -1,   361,    -1,    -1,    -1,    -1,
      -1,    -1,   576,    -1,    -1,  2881,  2882,  2883,  2884,    -1,
    2886,    -1,  2888,    -1,    -1,    -1,   181,  2893,  2894,  2895,
     185,  2897,    -1,    -1,    -1,    -1,    -1,  2903,   193,    -1,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2918,    -1,    -1,    61,  2922,    -1,   418,    -1,
    2926,  2927,   418,    -1,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   435,    -1,    -1,    -1,   435,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
     255,   256,    -1,    -1,   110,   111,    -1,    -1,    -1,   115,
      -1,  1946,    -1,    -1,    -1,  1950,    -1,  1952,    -1,    -1,
      -1,    -1,   277,  2989,    -1,    -1,    -1,    -1,    -1,  2995,
      -1,    -1,    -1,    -1,    -1,    -1,   576,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,  2008,    -1,    -1,    -1,    -1,    -1,   334,
      -1,   336,    -1,    -1,  2019,    -1,    -1,   193,    -1,    -1,
    3056,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3065,
     355,    -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   576,    -1,    -1,   374,
     576,    -1,    -1,    -1,    -1,    -1,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   396,    -1,    -1,    -1,    -1,    -1,    -1,   254,   255,
     256,   406,  3118,    -1,    -1,   410,   411,    -1,    -1,    -1,
      -1,  3127,   417,  3129,    -1,    -1,   421,    -1,    -1,  3135,
      -1,   277,  3138,    -1,   429,  3141,    -1,  3143,  3144,    -1,
    2115,    -1,    -1,    -1,    -1,    16,    17,    -1,    -1,    -1,
    3156,    22,    23,  3159,   449,    -1,   302,  2132,    -1,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,  2143,  2144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     475,    -1,    -1,    -1,   479,    -1,    -1,    58,   334,    -1,
     336,    -1,    -1,    -1,   489,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3224,    90,
    3226,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   374,    -1,
      -1,   526,    -1,    -1,    29,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    38,   539,    -1,   541,    -1,    -1,    -1,
     396,  2226,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,
     406,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   421,   147,   148,    -1,   150,
      -1,    -1,    -1,    -1,    -1,   580,    -1,   158,   159,   160,
      -1,   586,    87,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   178,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,   613,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   624,
     625,   626,   127,   479,    -1,    -1,  3342,    -1,    -1,   134,
      -1,    -1,   213,   489,    -1,    -1,    -1,    -1,    -1,    -1,
     645,    -1,    -1,    -1,    -1,    -1,   151,   652,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,  3375,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     526,   176,    -1,    -1,    -1,    -1,    -1,    -1,   683,    -1,
      -1,    -1,    -1,   539,    -1,  3401,   267,   268,   269,  3405,
    3406,  3407,    -1,   698,   699,  2380,  2381,    -1,  2383,  2384,
      -1,    -1,    -1,    -1,    -1,  3421,   711,    -1,    -1,   714,
     291,   292,    -1,    -1,    -1,   220,    -1,  2402,    -1,    -1,
     225,   226,    -1,    -1,   580,    -1,    -1,  2412,    -1,    -1,
     586,    -1,    -1,    -1,   239,    -1,    -1,    -1,  3454,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3476,   342,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,
      -1,  3487,    -1,   778,    -1,    -1,    -1,    -1,    -1,   360,
       6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   645,
      -1,    17,    -1,   298,    -1,    -1,   652,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,   397,    -1,   399,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,   683,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   340,    -1,    -1,    -1,    65,
      66,   422,   698,   699,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3568,    -1,    -1,   711,   361,  3573,    -1,    -1,
      -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,  3584,    -1,
      -1,    -1,  3588,    -1,    -1,   456,   457,    -1,  3594,    -1,
      -1,    -1,    -1,    -1,   110,   111,  3602,    -1,    -1,   115,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2583,    -1,
      -1,  3617,  3618,   129,  2589,    -1,    -1,   488,    -1,    -1,
      -1,    -1,    -1,   418,    -1,    -1,   497,    -1,    -1,    32,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     435,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      -1,  3667,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   543,   544,   545,    -1,   192,  3683,    -1,    -1,
     551,   552,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   568,   569,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,  2694,
      -1,   592,   593,    -1,    -1,    -1,    -1,  2702,  2703,  2704,
    2705,    -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,     7,
     611,    -1,    -1,    -1,    -1,    -1,    -1,   263,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3761,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    -1,    -1,    -1,  3781,    -1,    -1,    -1,    -1,
      -1,   576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     193,    -1,    -1,    61,  3800,    -1,    -1,    -1,    -1,  3805,
    3806,  3807,  3808,  3809,    -1,    73,  3812,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2789,    -1,   332,  3823,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,
      -1,    -1,   703,    -1,    -1,   706,    -1,   353,   709,    -1,
      -1,  2816,   110,   111,    -1,    -1,    -1,   115,   364,    -1,
      -1,   254,   255,   256,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   388,    -1,   277,    -1,    -1,    -1,   146,    -1,
     751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,
      -1,    -1,    -1,    -1,   420,   421,    -1,    -1,   424,  2884,
     426,    -1,    -1,    -1,  3920,    -1,    -1,   185,  2893,    -1,
      -1,    -1,  2897,    -1,    -1,   193,    -1,    -1,  2903,    -1,
      -1,   334,    -1,   336,    -1,    -1,   452,   453,    -1,    -1,
      -1,    -1,    -1,  2918,   460,   461,    -1,    -1,    -1,    -1,
     353,   219,   355,  3959,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   477,    -1,    -1,    -1,    -1,    -1,  3973,    -1,    -1,
      -1,   374,    -1,    -1,  3980,  3981,  3982,  3983,   381,  3985,
      -1,    -1,    -1,   499,    -1,    -1,   254,   255,   256,    -1,
      -1,    -1,    -1,   396,    -1,  4001,  4002,    -1,    -1,    -1,
      -1,    -1,    -1,   406,   520,    -1,    -1,    -1,    -1,   277,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,
      -1,    -1,    -1,    -1,  4030,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4039,   302,    -1,    -1,    -1,    -1,  4045,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,
     576,    -1,    -1,    -1,    -1,    -1,   334,    -1,   336,    -1,
      -1,    -1,    -1,  4079,   590,    -1,   479,    -1,    -1,  4085,
    4086,    -1,    -1,    -1,    -1,   601,   489,   355,   604,   605,
      -1,    -1,    -1,    32,  4100,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   619,    -1,    -1,   374,    -1,    -1,    -1,
    4116,  4117,    -1,   381,    -1,    -1,    -1,  4123,    -1,    -1,
      -1,    -1,    61,   526,    -1,    -1,    -1,    -1,   396,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   539,    -1,   406,   655,
      -1,    -1,   410,    -1,    -1,    -1,   662,    -1,    -1,   417,
      -1,    -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,
    3135,    -1,    -1,  3138,    -1,   681,    -1,   683,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,   115,   580,    -1,    -1,
      -1,   449,    -1,   586,  3159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,    -1,   138,
      -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   479,    -1,    -1,    -1,    -1,    -1,   733,    -1,    -1,
      -1,   489,    -1,   739,    -1,    -1,    -1,    -1,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,
      -1,    -1,   645,    -1,    -1,    -1,    -1,    -1,    -1,   652,
      -1,    -1,    -1,  4259,   193,    -1,    -1,    -1,   526,    60,
      -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,  4274,    -1,
      -1,   539,    38,   541,    -1,    -1,    -1,    -1,    -1,    -1,
     683,    -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    60,   698,   699,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   711,    -1,
      -1,   112,   580,    -1,    -1,   254,   255,   256,   586,    -1,
    4326,    87,    -1,    -1,    -1,  4331,   127,    93,    -1,    -1,
      -1,    -1,    98,   134,    -1,    -1,    -1,    -1,   277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     151,    -1,  4358,    -1,    -1,  4361,    -1,    -1,  4364,    -1,
      -1,   127,    -1,   302,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,  4380,   176,    -1,   645,    -1,    -1,
      -1,    -1,    -1,    -1,   652,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   334,    -1,   336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     176,    -1,    -1,    -1,   353,   683,   355,    -1,    -1,   220,
      -1,    -1,    -1,    -1,   225,   226,  3401,    -1,    -1,    -1,
     698,   699,  3407,    -1,    -1,   374,    -1,    -1,   239,    -1,
      -1,    -1,   381,   711,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,   396,    -1,   225,
     226,    -1,    -1,    -1,    -1,    -1,    -1,   406,    -1,    -1,
      -1,    -1,    -1,   239,    -1,    -1,  4482,    -1,    -1,    -1,
      -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4499,    -1,    -1,    -1,   298,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4512,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4525,
      -1,    -1,    -1,  4529,  4530,    -1,    -1,    -1,    -1,  4535,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,   340,
     479,    -1,    -1,    -1,    -1,  4551,  4552,    -1,    -1,    -1,
     489,    -1,    -1,    -1,    -1,  4561,    -1,    -1,    -1,    -1,
     361,    -1,    -1,    -1,    -1,    -1,  4572,  4573,    -1,    -1,
      -1,    -1,    -1,    -1,   340,  4581,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   361,    -1,    -1,  3573,    -1,
     539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3584,
      -1,    -1,    -1,  3588,  4620,    -1,    -1,  4623,    -1,  4625,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   435,    -1,    -1,    -1,    -1,    -1,
      -1,   580,    -1,    -1,    -1,    -1,    -1,   586,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4663,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4672,    -1,    -1,   435,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4690,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4704,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   645,    -1,    -1,    -1,
      -1,    -1,    -1,   652,    -1,  4721,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4732,    -1,  4734,    -1,
      -1,    -1,    -1,    -1,  4740,    -1,    -1,    -1,    -1,    -1,
    4746,    -1,    -1,    -1,   683,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4758,  4759,    -1,    -1,    -1,    -1,    -1,   698,
     699,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   711,  4779,    -1,   576,    -1,    -1,    -1,  4785,
    4786,    -1,    -1,    -1,    -1,  4791,    -1,    -1,    -1,    -1,
      -1,  4797,    -1,    -1,    -1,    -1,  4802,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3781,    -1,    -1,    -1,
     576,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4831,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3812,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4936,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4966,    -1,  4968,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4985,
      -1,    -1,    -1,  4989,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4997,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5006,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5016,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5070,    -1,    -1,    -1,    -1,  5075,
    5076,  5077,    -1,  5079,  5080,    -1,  5082,    -1,    -1,    -1,
      -1,  5087,  5088,    -1,    -1,    -1,  5092,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4085,  4086,    -1,   669,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5127,    -1,    -1,    -1,  5131,    -1,  5133,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     696,  4116,  4117,    -1,    -1,    -1,  5152,    -1,    -1,  5155,
      -1,    -1,  5158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   717,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5175,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5267,    -1,    -1,    -1,    -1,  5272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5281,  5282,  5283,    -1,    -1,
    5286,    -1,   838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5313,    -1,    -1,
      -1,    -1,  5318,    -1,    -1,    -1,  5322,    -1,  5324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5344,    -1,
      -1,    -1,    -1,    -1,    -1,  5351,    -1,    -1,  5354,  5355,
      -1,    -1,  5358,    -1,    -1,    -1,  5362,    -1,  5364,    -1,
      -1,    -1,    -1,    -1,  5370,    -1,    -1,  5373,    -1,    -1,
      -1,    -1,    -1,  5379,    -1,    -1,    -1,    -1,    -1,   935,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5415,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   985,
      -1,    -1,    -1,    -1,   990,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1020,    -1,    -1,  1023,    -1,    -1,
      -1,    -1,    -1,    -1,  1030,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5489,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5517,  1068,    -1,    -1,    -1,  5522,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5541,    -1,    -1,    -1,    -1,
    5546,    -1,    -1,    -1,    -1,    -1,    -1,  5553,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5561,  5562,    -1,    -1,    -1,
      -1,    -1,    -1,  1119,  1120,  1121,  1122,    -1,    -1,  1125,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1133,    -1,    -1,
      -1,    -1,  5588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5602,    -1,    -1,    -1,
    5606,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5617,    -1,  5619,  5620,    -1,    -1,    -1,    -1,    -1,
    5626,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5649,    -1,  4620,    -1,    -1,    -1,    -1,
    4625,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5687,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5713,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1310,    -1,    -1,    -1,  1314,    -1,
      -1,  5767,    -1,    -1,  5770,  4740,    -1,  5773,  5774,    -1,
      -1,  5777,  5778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5786,    -1,  5788,  5789,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5803,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5834,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5845,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5858,    -1,    -1,  1411,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5879,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1442,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5900,  5901,    -1,    -1,  5904,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5926,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1484,    -1,
    1486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5949,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5964,    -1,
      -1,    -1,    -1,    -1,    -1,  5971,    -1,    -1,    -1,    -1,
      -1,  5977,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5985,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6015,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4997,    -1,    -1,    -1,  6032,  6033,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1644,    -1,
    1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6115,
      -1,    -1,    -1,  6119,    -1,    -1,    -1,    -1,    -1,  6125,
      -1,    -1,    -1,  6129,    -1,    -1,  1682,    -1,    -1,  6135,
      -1,    -1,    -1,    -1,    -1,  6141,    -1,    -1,    -1,  1695,
    1696,    -1,    -1,    -1,    -1,  1701,    -1,    -1,    -1,  1705,
    1706,  1707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1716,  1717,  1718,    -1,    -1,    -1,  1722,    -1,  1724,  1725,
    1726,  1727,  1728,    -1,  1730,    -1,    -1,  1733,  1734,    -1,
    5155,    -1,    -1,    -1,    -1,  1741,    -1,  1743,    -1,    -1,
    1746,  1747,    -1,  1749,  1750,  1751,    -1,  1753,  1754,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1768,  1769,  1770,  1771,  1772,    -1,  1774,  1775,
    1776,    -1,    -1,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
      -1,  1787,  1788,  1789,  1790,  1791,  1792,    -1,  1794,  1795,
      -1,  1797,  1798,  1799,  1800,  1801,  1802,  1803,    -1,    -1,
    1806,  1807,  1808,  1809,    -1,  1811,  1812,  1813,    -1,  1815,
      -1,  1817,    -1,  1819,    -1,    -1,    -1,  1823,  1824,  1825,
      -1,    -1,  1828,  1829,  1830,  1831,  1832,    -1,  1834,    -1,
      -1,    -1,    -1,    -1,    -1,  1841,    -1,    -1,    -1,    -1,
      -1,    -1,  1848,  1849,  1850,  1851,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1859,  1860,    -1,  1862,  1863,    -1,    -1,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,    -1,    -1,  1881,    -1,    -1,    -1,    -1,
    1886,    -1,    -1,    -1,    -1,    -1,    -1,  1893,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1922,    -1,    -1,    -1,
      -1,  1927,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2004,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2036,    -1,  2038,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2060,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2072,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5541,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2320,  2321,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5770,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2415,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2437,    -1,  2439,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2447,  2448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2511,  2512,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2539,  2540,  2541,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2551,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2604,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2615,
      -1,    -1,  2618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2636,    -1,    -1,    -1,  2640,  2641,    -1,  2643,  2644,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2652,    -1,  2654,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2682,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2709,    -1,    -1,  2712,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2758,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2799,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2847,    -1,  2849,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2929,    -1,    -1,    -1,    -1,    -1,    -1,
    2936,    -1,    -1,  2939,  2940,  2941,    -1,  2943,    -1,  2945,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3001,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   669,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3216,    -1,    -1,  3219,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3237,    -1,  3239,    -1,  3241,    -1,  3243,  3244,  3245,
    3246,  3247,  3248,    -1,  3250,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3258,   838,  3260,    -1,    -1,  3263,  3264,  3265,
      -1,    -1,    -1,    -1,    -1,    -1,  3272,  3273,  3274,    -1,
    3276,    -1,  3278,    -1,  3280,    -1,  3282,    -1,  3284,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3292,    -1,  3294,    -1,
    3296,  3297,  3298,  3299,  3300,    -1,    -1,  3303,  3304,  3305,
      -1,  3307,    -1,    -1,  3310,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3323,    -1,    -1,
      -1,    -1,  3328,    -1,    -1,  3331,    -1,  3333,  3334,  3335,
      -1,    -1,  3338,    -1,    -1,    -1,    -1,    -1,  3344,    -1,
      -1,    -1,    -1,  3349,    -1,    -1,    -1,    -1,    -1,    -1,
     935,    -1,  3358,    -1,    -1,    -1,    -1,    -1,  3364,    -1,
    3366,    -1,    -1,  3369,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3379,  3380,  3381,    -1,    -1,    -1,    -1,
    3386,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   990,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1020,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3450,  1030,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3481,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3510,    -1,  3512,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3580,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3601,    -1,    -1,    -1,    -1,
      -1,    -1,  3608,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3691,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3784,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3820,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3833,    -1,    -1,
    3836,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3860,  3861,    -1,  1442,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3872,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3885,
      -1,  3887,    -1,  3889,    -1,  3891,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1484,
      -1,  1486,    -1,    -1,    -1,    -1,    -1,  3913,    -1,    -1,
      -1,    -1,    -1,  3919,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3934,  3935,
      -1,    -1,    -1,    -1,    -1,  3941,    -1,  3943,    -1,  3945,
      -1,    -1,    -1,    -1,  3950,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3987,  3988,  3989,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4003,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4024,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4054,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1644,
      -1,  1646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1682,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4120,    -1,  1701,    -1,    -1,    -1,
    1705,    -1,  1707,    -1,  4130,    -1,    -1,    -1,    -1,    -1,
      -1,  1716,  1717,    -1,    -1,    -1,  4142,  1722,  4144,  1724,
    1725,  1726,  1727,  1728,    -1,  1730,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1741,    -1,  1743,    -1,
      -1,  1746,  1747,    -1,  1749,  1750,    -1,    -1,  1753,  1754,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1768,  1769,  1770,  1771,  1772,    -1,  1774,
      -1,  1776,    -1,    -1,  1779,  1780,  1781,  1782,  1783,  1784,
    1785,    -1,  1787,  1788,  1789,  1790,  1791,    -1,    -1,  1794,
    1795,    -1,    -1,  1798,  1799,  1800,    -1,    -1,    -1,    -1,
      -1,  1806,  1807,  1808,    -1,    -1,  1811,  1812,  1813,    -1,
    1815,    -1,  1817,    -1,  1819,    -1,    -1,    -1,  1823,  1824,
    1825,    -1,    -1,  1828,  1829,  1830,  1831,  1832,    -1,  1834,
      -1,    -1,    -1,    -1,    -1,    -1,  1841,    -1,    -1,    -1,
      -1,    -1,    -1,  1848,  1849,  1850,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1922,    -1,    -1,
      -1,    -1,  1927,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1937,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4374,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2004,
      -1,    -1,    -1,  4429,  4430,    -1,  4432,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4443,  4444,  4445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2036,  4458,  2038,  4460,    -1,  4462,    -1,  4464,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4477,  4478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2072,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4504,    -1,
      -1,    -1,    -1,    -1,    -1,  4511,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4520,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4563,    -1,    -1,
      -1,  4567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2320,  2321,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4794,  4795,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2397,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2437,    -1,  2439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2447,  2448,    -1,    -1,    -1,  4873,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4931,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4948,  4949,  4950,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2539,  2540,  2541,    -1,    -1,    -1,
      -1,  4967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4982,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5021,    -1,  5023,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2652,    -1,  2654,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2682,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2709,    -1,    -1,  2712,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2758,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5219,  2799,    -1,  5222,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5347,    -1,    -1,  2929,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2943,    -1,
    2945,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5418,    -1,    -1,    -1,  3001,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5566,    -1,    -1,    -1,    -1,    -1,    -1,  5573,  5574,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3216,    -1,    -1,  3219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3237,    -1,  5660,    -1,  3241,    -1,  3243,  3244,
    3245,  3246,  3247,  3248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3258,    -1,  3260,    -1,    -1,  3263,  3264,
    3265,    -1,  5688,    -1,    -1,    -1,    -1,  3272,  3273,  3274,
      -1,  3276,    -1,  3278,  5700,  3280,    -1,  3282,    -1,  3284,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3292,    -1,  3294,
      -1,  3296,    -1,  3298,  3299,  3300,    -1,    -1,  3303,  3304,
    3305,    -1,  3307,    -1,    -1,  3310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3331,    -1,  3333,  3334,
    3335,    -1,    -1,  3338,    -1,    -1,    -1,    -1,    -1,  3344,
      -1,    -1,    -1,    -1,  3349,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3358,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3369,    -1,  5792,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5827,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3422,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3450,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3481,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5927,    -1,    -1,    -1,  3510,    -1,  3512,  5934,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3601,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6070,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3691,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6145,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3820,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3833,    -1,
      -1,  3836,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3860,  3861,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3885,    -1,  3887,    -1,  3889,    -1,  3891,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3913,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3934,
    3935,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3950,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3988,  3989,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4003,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4024,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4120,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4142,    -1,  4144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4374,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4429,  4430,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4443,  4444,
    4445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4458,    -1,  4460,    -1,  4462,    -1,  4464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4477,  4478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4520,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4563,    -1,
      -1,    -1,  4567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4794,
    4795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4873,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4931,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4949,  4950,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,  4967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4982,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5021,    -1,  5023,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,    -1,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,    -1,   341,    -1,   343,    -1,
      -1,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,  5222,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,  5247,   398,    -1,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,    -1,   489,   490,   491,   492,   493,   494,
     495,   496,  5347,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,    -1,    -1,
      -1,   546,   547,   548,   549,   550,    -1,    -1,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,    -1,  5418,    -1,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,    -1,    -1,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,    -1,    -1,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,    -1,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,    -1,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,    -1,   704,
     705,    -1,   707,   708,    -1,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,    -1,    -1,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5700,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    29,    30,    -1,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    -1,    -1,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5792,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,  5827,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,   180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5927,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
    6145,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   760,   761,    -1,    -1,    -1,
      -1,   766,    -1,    -1,    -1,     6,   771,    -1,    -1,    -1,
     775,   776,    -1,    -1,   779,   780,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,    -1,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,    -1,   748,   749,   750,
     751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   760,
     761,     7,     8,    -1,    -1,   766,    -1,    -1,    -1,    -1,
     771,    -1,    -1,    -1,   775,   776,    -1,    -1,   779,   780,
      -1,    27,    -1,    29,    -1,    31,    -1,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    -1,    -1,    63,    -1,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,
     146,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   195,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     206,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   218,   219,   220,    -1,   222,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   279,    -1,   281,    -1,   283,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,   299,    -1,    -1,    -1,    -1,    -1,    -1,
     306,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
      -1,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,     7,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   771,    27,    -1,    29,    -1,
      31,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      -1,    -1,    63,    -1,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,    -1,   146,    -1,    -1,    -1,    -1,
     151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   195,   196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   206,   207,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,   220,
      -1,   222,    -1,    -1,    -1,    -1,   227,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,    -1,   237,    -1,    -1,    -1,
     241,   242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,
     281,    -1,   283,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,   299,    -1,
      -1,    -1,    -1,    -1,    -1,   306,   307,   308,   309,    -1,
     311,   312,   313,   314,   315,   316,    -1,    -1,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,    -1,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,    -1,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,    -1,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,    -1,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,    -1,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,    -1,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,    -1,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,    -1,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,    -1,   748,   749,   750,
     751,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     771,    27,    -1,    -1,    -1,    31,    -1,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   195,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     206,   207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   218,   219,    -1,    -1,   222,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,
      -1,   237,    -1,    -1,    -1,   241,   242,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   279,    -1,   281,    -1,   283,    -1,    -1,
      -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,
     306,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
     316,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,    -1,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
      -1,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,    -1,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,    17,    18,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,
      -1,    32,    -1,    -1,    -1,   771,    -1,    -1,    39,    40,
      -1,    -1,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,   288,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,   299,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,    -1,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,    -1,   748,   749,   750,
     751,    -1,    -1,    -1,    17,    18,    19,    20,    21,   760,
     761,    -1,    25,    -1,    -1,   766,    29,    30,    -1,    32,
     771,    -1,    -1,    -1,   775,   776,    39,    40,   779,   780,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     133,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,   271,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    -1,   748,   749,   750,   751,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   760,   761,    -1,
      -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,
      -1,    -1,   775,   776,    39,    40,   779,   780,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,   296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   760,   761,    -1,    -1,    -1,
      -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,
     775,   776,    39,    40,   779,   780,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,   114,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,    -1,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
      -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,
      29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,
      39,    40,   779,   780,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,
      -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,    40,
     779,   780,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,    -1,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,    -1,   748,   749,   750,
     751,    -1,    -1,    -1,    17,    18,    19,    20,    21,   760,
     761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,
     771,    -1,    -1,    -1,   775,   776,    39,    40,   779,   780,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    -1,   748,   749,   750,   751,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   760,   761,    -1,
      -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,
      -1,    -1,   775,   776,    39,    40,   779,   780,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,   114,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   760,   761,    -1,    -1,    -1,
      -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,
     775,   776,    39,    40,   779,   780,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,    -1,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
      -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,
      29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,
      39,    40,   779,   780,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,   172,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,
      -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,    40,
     779,   780,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,   172,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,    -1,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,    -1,   748,   749,   750,
     751,    -1,    -1,    -1,    17,    18,    19,    20,    21,   760,
     761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,
     771,    -1,    -1,    -1,   775,   776,    39,    40,   779,   780,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,   172,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    -1,   748,   749,   750,   751,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   760,   761,    -1,
      -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,
      -1,    -1,   775,   776,    39,    40,   779,   780,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,   172,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   760,   761,    -1,    -1,    -1,
      -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,
     775,   776,    39,    40,   779,   780,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,   172,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,    -1,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
      -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,
      29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,
      39,    40,   779,   780,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,   156,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,
      -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,    40,
     779,   780,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,    -1,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,    -1,   748,   749,   750,
     751,    -1,    -1,    -1,    17,    18,    19,    20,    21,   760,
     761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,
     771,    -1,    -1,    -1,   775,   776,    39,    40,   779,   780,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,   171,    -1,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    -1,   748,   749,   750,   751,    -1,
      -1,    -1,    17,    18,    19,    20,    21,   760,   761,    -1,
      -1,    -1,    -1,   766,    29,    30,    -1,    32,   771,    -1,
      -1,    -1,   775,   776,    39,    40,   779,   780,    43,    44,
      45,    46,    -1,    48,    49,    -1,    51,    52,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    61,    -1,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      85,    86,    -1,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,    -1,
     105,   106,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,
     155,    -1,   157,    -1,    -1,    -1,    -1,    -1,   163,    -1,
     165,    -1,    -1,   168,    -1,    -1,   171,    -1,   173,    -1,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,    -1,   198,   199,   200,    -1,   202,    -1,    -1,
      -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,   258,    -1,   260,   261,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     285,   286,   287,    -1,    -1,    -1,    -1,    -1,   293,    -1,
     295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,
      17,    18,    19,    20,    21,   760,   761,    -1,    -1,    -1,
      -1,   766,    29,    30,    -1,    32,   771,    -1,    -1,    -1,
     775,   776,    39,    40,   779,   780,    43,    44,    45,    46,
      -1,    48,    49,    -1,    51,    52,    -1,    -1,    -1,    -1,
      57,    -1,    -1,    -1,    61,    -1,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    85,    86,
      -1,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   101,   102,   103,    -1,   105,   106,
      -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,   155,    -1,
     157,    -1,    -1,    -1,    -1,    -1,   163,    -1,   165,    -1,
      -1,   168,    -1,    -1,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,
      -1,   198,   199,   200,    -1,   202,    -1,    -1,    -1,    -1,
      -1,    -1,   209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
     257,   258,    -1,   260,   261,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   285,   286,
     287,    -1,    -1,    -1,    -1,    -1,   293,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,    -1,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
      -1,   748,   749,   750,   751,    -1,    -1,    -1,    17,    18,
      19,    20,    21,   760,   761,    -1,    -1,    -1,    -1,   766,
      29,    30,    -1,    32,   771,    -1,    -1,    -1,   775,   776,
      39,    40,   779,   780,    43,    44,    45,    46,    -1,    48,
      49,    -1,    51,    52,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    61,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    84,    85,    86,    -1,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,   155,    -1,   157,    -1,
      -1,    -1,    -1,    -1,   163,    -1,   165,    -1,    -1,   168,
      -1,    -1,   171,    -1,   173,    -1,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,   198,
     199,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,
     209,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,   258,
      -1,   260,   261,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   273,   274,   275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,   293,    -1,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    17,    18,    19,    20,
      21,   760,   761,    -1,    -1,    -1,    -1,   766,    29,    30,
      -1,    32,   771,    -1,    -1,    -1,   775,   776,    39,    40,
     779,   780,    43,    44,    45,    46,    -1,    48,    49,    -1,
      51,    52,    -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,
      61,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    84,    85,    86,    -1,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,    -1,   105,   106,    -1,    -1,    -1,   110,
     111,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,    -1,   154,   155,    -1,   157,    -1,    -1,    -1,
      -1,    -1,   163,    -1,   165,    -1,    -1,   168,    -1,    -1,
     171,    -1,   173,    -1,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,   198,   199,   200,
      -1,   202,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   257,   258,    -1,   260,
     261,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   273,   274,   275,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   285,   286,   287,    -1,    -1,    -1,
      -1,    -1,   293,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,    -1,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,    -1,    -1,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,    -1,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,    -1,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,    -1,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,    -1,   748,   749,   750,
     751,    -1,    -1,    -1,    -1,    18,    19,    20,    21,   760,
     761,    -1,    -1,    -1,    -1,   766,    29,    30,    -1,    32,
     771,    -1,    -1,    -1,   775,   776,    39,    40,   779,   780,
      43,    44,    45,    46,    -1,    48,    49,    -1,    51,    52,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,    -1,   105,   106,    -1,    -1,    -1,   110,   111,   112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,   155,    -1,   157,    -1,    -1,    -1,    -1,    -1,
     163,    -1,   165,    -1,    -1,   168,    -1,    -1,    -1,    -1,
     173,    -1,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,   198,   199,   200,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,   257,   258,    -1,   260,   261,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     273,   274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   285,   286,   287,    -1,    -1,    -1,    -1,    -1,
     293,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    18,   748,   749,   750,   751,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   760,   761,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,
      -1,    -1,    -1,   776,    -1,    -1,   779,   780,    -1,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   176,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,
     274,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      24,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   779,   780,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      24,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    32,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    -1,   779,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    32,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,   780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,     6,     7,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   780,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
      -1,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   216,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   281,   282,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,     6,     7,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,    -1,    -1,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
     272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   281,
     282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,     6,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    35,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,     6,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,   780,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    36,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   244,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    11,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    -1,   748,   749,   750,   751,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,   779,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    17,   748,   749,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,    16,    17,    -1,   755,    -1,    -1,    22,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   147,   148,    -1,   150,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   158,   159,   160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,   243,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   267,   268,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,   292,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,    -1,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,    -1,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,    -1,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,    -1,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
      -1,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,    -1,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    16,    17,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,
     148,    -1,   150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     158,   159,   160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,
      -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,
     268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   291,   292,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,    -1,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,    -1,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,    -1,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,    -1,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,    -1,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,    -1,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,    -1,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,    16,    17,    -1,    -1,    -1,    -1,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   147,   148,    -1,   150,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   158,   159,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,
      -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   267,   268,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,
     292,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,    -1,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,    -1,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,    -1,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,    -1,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,    -1,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,    -1,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      16,    17,    -1,    -1,    -1,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   124,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   147,   148,    -1,   150,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   158,   159,   160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   267,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   291,   292,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,    -1,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,    -1,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,    -1,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,    -1,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,    -1,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,    -1,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,    17,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    17,   748,   749,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    17,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    18,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    -1,   748,   749,   750,   751,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   106,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    24,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    45,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,   312,   313,   314,   315,    -1,
      -1,    -1,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,    -1,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,    -1,    -1,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,    -1,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,    -1,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,    -1,   671,   672,   673,    -1,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
      -1,   748,   749,   750,   751,    37,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,    -1,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,    -1,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
      45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
     315,    -1,    -1,    -1,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,    -1,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
      -1,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,    -1,
      -1,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,    -1,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,    -1,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,    -1,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,    45,   748,   749,   750,   751,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,   315,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,    -1,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,    -1,    -1,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,    -1,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,    -1,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,    -1,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,    74,   748,   749,   750,   751,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    46,   748,   749,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   771,    -1,    -1,    -1,    -1,   776,    -1,    -1,   779,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    47,   748,
     749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,    -1,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,    -1,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    57,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,    57,    -1,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,
      -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,   315,    -1,    -1,    -1,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,    -1,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,    -1,    -1,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
      -1,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,    -1,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,    -1,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,    -1,   748,
     749,   750,   751,    57,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    61,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    61,
     748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    61,   748,   749,   750,   751,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    61,   748,   749,   750,   751,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    61,   748,   749,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    61,   748,   749,   750,   751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    61,
     748,   749,   750,   751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,    -1,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,    -1,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,    -1,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   772,    -1,    -1,    -1,    -1,    -1,    -1,   779,
     780,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   780,   139,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   780,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   780,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,   780,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,   776,    -1,    -1,   779,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   105,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   171,
     172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    95,   748,   749,   750,   751,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   761,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    95,   748,   749,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   762,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,   755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   139,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,    -1,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,    -1,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
      -1,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,    -1,   748,   749,   750,   751,   110,   111,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,    -1,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,    -1,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,    -1,   748,   749,   750,   751,   110,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,   308,   309,   310,   311,
     312,   313,   314,   315,    -1,    -1,    -1,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,    -1,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,    -1,    -1,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,    -1,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,    -1,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,    -1,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
      -1,   743,   744,   745,   746,    -1,   748,   749,   750,   751,
     110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,    -1,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
      -1,   461,   462,   463,   464,   465,    -1,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,    -1,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,    -1,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,    -1,   748,   749,
     750,   751,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,
     308,   309,    -1,   311,   312,   313,   314,   315,    -1,    -1,
      -1,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,    -1,    -1,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,    -1,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,    -1,   377,
     378,   379,   380,   381,   382,   383,   384,   385,    -1,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,    -1,   406,   407,
     408,   409,   410,   411,   412,    -1,   414,   415,   416,   417,
      -1,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,    -1,    -1,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,    -1,
     448,    -1,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,    -1,   463,   464,   465,    -1,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,    -1,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,    -1,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,    -1,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,    -1,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,    -1,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,    -1,   640,   641,   642,   643,   644,   645,   646,    -1,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,    -1,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,    -1,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,    -1,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,    -1,
     748,   749,   750,   751,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,   308,   309,    -1,   311,    -1,   313,   314,   315,
      -1,    -1,    -1,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,    -1,    -1,    -1,    -1,   342,   343,   344,   345,
     346,    -1,    -1,   349,   350,   351,   352,    -1,    -1,    -1,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,    -1,
     366,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,   375,
      -1,   377,   378,   379,   380,   381,   382,   383,   384,   385,
      -1,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,    -1,
     406,   407,   408,   409,   410,   411,   412,    -1,   414,   415,
     416,   417,    -1,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,    -1,   433,    -1,    -1,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
      -1,    -1,    -1,    -1,    -1,   451,   452,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,    -1,   463,   464,    -1,
      -1,   467,    -1,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,   487,   488,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,    -1,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     110,   111,    -1,    -1,   580,   581,    -1,   583,   584,   585,
     586,    -1,   588,   589,   590,   591,   592,   593,    -1,    -1,
      -1,    -1,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,    -1,   625,
      -1,   627,   628,    -1,   630,   631,    -1,   633,   634,   635,
     636,   637,   638,    -1,   640,   641,   642,   643,   644,   645,
     646,    -1,   648,   649,   650,    -1,   652,   653,   654,   655,
      -1,   657,   658,    -1,    -1,   661,    -1,    -1,   664,   665,
     666,    -1,   668,    -1,   670,   671,   672,   673,    -1,   675,
     676,   677,   678,    -1,   680,   681,    -1,   683,    -1,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,    -1,
     706,   707,   708,   709,   710,   711,   712,   713,    -1,   715,
     716,   717,    -1,   719,   720,   721,   722,    -1,    -1,   725,
     726,    -1,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,    -1,    -1,   744,   745,
      -1,    -1,   748,    -1,   750,   751,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,   308,   309,
      -1,   311,    -1,   313,   314,   315,    -1,    -1,    -1,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,    -1,    -1,
      -1,    -1,   342,   343,   344,   345,   346,    -1,    -1,   349,
     350,   351,   352,    -1,    -1,    -1,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,   375,    -1,   377,   378,   379,
     380,   381,   382,   383,   384,   385,    -1,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,    -1,   406,   407,   408,   409,
     410,   411,   412,    -1,   414,   415,   416,   417,    -1,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,    -1,   433,    -1,    -1,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,    -1,    -1,    -1,    -1,
      -1,   451,   452,   453,   454,   455,   456,   457,   458,    -1,
     460,   461,    -1,   463,   464,    -1,    -1,   467,    -1,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,   487,   488,   489,
      -1,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,    -1,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   110,   111,    -1,    -1,
     580,   581,    -1,   583,   584,   585,   586,    -1,   588,   589,
     590,   591,   592,   593,    -1,    -1,    -1,    -1,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,    -1,   625,    -1,   627,   628,    -1,
     630,   631,    -1,   633,   634,   635,   636,   637,   638,    -1,
     640,   641,   642,   643,   644,   645,   646,    -1,   648,   649,
     650,    -1,   652,   653,   654,   655,    -1,   657,   658,    -1,
      -1,   661,    -1,    -1,   664,   665,   666,    -1,   668,    -1,
     670,   671,   672,   673,    -1,   675,   676,   677,   678,    -1,
     680,   681,    -1,   683,    -1,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,    -1,   706,   707,   708,   709,
     710,   711,   712,   713,    -1,   715,   716,   717,    -1,   719,
     720,   721,   722,    -1,    -1,   725,   726,    -1,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,    -1,    -1,   744,   745,    -1,    -1,   748,    -1,
     750,   751,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   307,   308,   309,    -1,   311,    -1,   313,
     314,   315,    -1,    -1,    -1,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,    -1,    -1,    -1,    -1,   342,   343,
     344,   345,   346,    -1,    -1,   349,   350,   351,   352,    -1,
      -1,    -1,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,   375,    -1,   377,   378,   379,   380,   381,   382,   383,
     384,   385,    -1,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,    -1,   406,   407,   408,   409,   410,   411,   412,    -1,
     414,   415,   416,   417,    -1,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,    -1,   433,
      -1,    -1,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,    -1,    -1,    -1,    -1,    -1,   451,   452,   453,
     454,   455,   456,   457,   458,    -1,   460,   461,    -1,   463,
     464,    -1,    -1,   467,    -1,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,   487,   488,   489,    -1,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,    -1,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,    -1,    -1,    -1,    -1,   580,   581,    -1,   583,
     584,   585,   586,    -1,   588,   589,   590,   591,   592,   593,
      -1,    -1,    -1,    -1,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
      -1,   625,    -1,   627,   628,    -1,   630,   631,    -1,   633,
     634,   635,   636,   637,   638,    -1,   640,   641,   642,   643,
     644,   645,   646,    -1,   648,   649,   650,    -1,   652,   653,
     654,   655,    -1,   657,   658,    -1,    -1,   661,    -1,    -1,
     664,   665,   666,    -1,   668,    -1,   670,   671,   672,   673,
      -1,   675,   676,   677,   678,    -1,   680,   681,    -1,   683,
      -1,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,    -1,   706,   707,   708,   709,   710,   711,   712,   713,
      -1,   715,   716,   717,    -1,   719,   720,   721,   722,    -1,
      -1,   725,   726,    -1,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,    -1,    -1,
     744,   745,    -1,    -1,   748,    -1,   750,   751
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,     8,    27,    29,    31,    33,    41,    60,    63,
      65,    66,    73,    80,    93,    99,   110,   111,   112,   120,
     131,   144,   146,   151,   181,   195,   196,   206,   207,   218,
     219,   220,   222,   227,   233,   237,   241,   242,   279,   281,
     283,   288,   298,   299,   306,   307,   308,   309,   311,   312,
     313,   314,   315,   316,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   354,   355,
     356,   357,   358,   359,   360,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   448,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   748,   749,   750,   751,
     771,   782,   785,   786,   787,   788,   789,   791,   797,   799,
     812,   889,   942,   943,   950,   951,   967,   968,  1004,  1025,
    1057,  1117,  1174,  1226,  1329,  1379,  1382,  1392,  1397,  1403,
    1416,  1419,  1425,  1428,  1433,  1440,  1452,  1455,  1458,  1459,
    1461,  1464,  1465,  1467,  1468,  1471,  1472,  1475,  1694,  1696,
    1709,  1712,  1747,  1755,  1770,  1779,  1793,  1797,  1798,  1802,
    1812,  1819,  1827,  1829,  1835,  1838,  1839,  1871,  1890,  1892,
    1900,  1914,  1915,  1918,  1920,  1921,  1922,  1923,  1927,  1957,
    1964,  1966,  1975,  1978,  2018,  2020,  2025,  2026,  2027,  2028,
    2060,  2069,  2070,  2071,    49,   205,   326,   404,   453,   501,
     652,   656,   698,   728,  1330,  2032,  2033,  2034,  2035,   174,
     450,   499,  1427,  1800,   310,   338,   340,   341,   348,   353,
     355,   361,   376,   386,   401,   413,   418,   432,   446,   447,
     453,   459,   462,   465,   480,   490,   562,   576,   595,   597,
     626,   629,   639,   647,   659,   679,   682,   714,   724,   742,
     749,  1892,  1899,  1909,  1915,  1916,  1917,  1918,  1919,  1920,
    1921,  1922,  1005,   520,  1420,   186,   501,   698,  1027,  1756,
      49,   115,   192,   205,   272,   427,   453,   501,   638,   656,
     698,   701,   728,   736,  1708,  1060,   875,   969,  1710,  1830,
     115,   396,   750,  1844,   263,   697,  1960,  1058,  1427,  1227,
    1118,    17,   520,  1785,   237,   247,   939,   944,   946,  1899,
     647,   728,  1960,  1062,   944,   945,   875,  1462,   680,  1924,
    1780,   944,  1965,  1748,  1899,  1460,  1059,   214,  1873,  1713,
     146,   279,   677,  1813,  2019,   171,   172,  1024,  1509,   265,
     780,  1893,   115,  1960,  1899,   745,  2022,  1695,   474,  1899,
    1427,   391,   952,  1967,   798,   591,   669,  1899,  1427,  1820,
    2022,  1899,  1836,     6,   662,   710,     6,   662,  1771,   591,
     669,   339,   340,   376,   418,   597,   614,   639,   679,  2063,
    1461,  1468,  1471,     0,    80,   783,   597,    49,    96,   244,
     278,   638,   728,   832,  1308,  1309,  1310,  1708,  2032,  2033,
    2034,  2035,    95,   123,  1478,  1479,  1690,  1456,  1453,    83,
     121,   277,  1470,  2029,  1469,  2029,   439,   450,   584,   779,
    1799,  1800,  1887,  1899,  1465,  1467,   238,   779,  1347,  1899,
     877,  1899,   755,   755,   877,   100,   112,  1707,   139,  1893,
    1899,  1904,  1065,  1066,  1069,  1092,  1899,  1707,  1371,  1372,
     251,  1496,  2036,  2037,  2032,   755,  1960,  1452,  1455,  1709,
    1712,  1747,  1755,  1796,   779,   890,   296,  1006,  1007,  1010,
    1014,   810,   811,  1893,   736,  1417,  1960,   316,   100,  1067,
    1092,    37,    38,    47,   434,   435,   742,   914,   915,   917,
     918,   925,   926,   927,   929,   935,   962,   963,  1892,  1900,
    1912,  1915,  1916,  1917,  1918,  1920,  1922,   114,   152,   467,
     609,  1758,  1768,  1769,  1707,  1698,    24,  1707,  1707,  1707,
    1707,  1707,   100,  1707,  1707,  1092,  1707,  1707,   652,  1960,
    1041,  1900,     6,     7,    41,    46,    63,    73,    99,   115,
     120,   146,   216,   233,   241,   272,   281,   282,   427,   432,
     443,   602,   606,   623,   628,   659,   691,  1904,  1979,  1983,
    1984,  1986,  1988,  1989,   999,  1000,   152,   405,   466,  1715,
     463,   668,  1831,   123,  1840,  1958,    38,    87,    98,   127,
     134,   176,   225,   226,   239,   361,   435,   576,   911,   965,
     966,   968,   974,   975,   976,   977,   981,   982,   983,   984,
     985,   994,   995,   996,   997,  1004,  1019,  1020,  1025,  1044,
    1050,  1057,  1902,  1903,  1960,    17,    18,    19,    20,    21,
      29,    30,    32,    39,    40,    43,    44,    45,    46,    48,
      49,    51,    52,    57,    61,    64,    84,    85,    86,    88,
      89,   101,   102,   103,   105,   106,   110,   111,   112,   120,
     122,   135,   149,   154,   155,   157,   163,   165,   168,   171,
     172,   173,   175,   176,   177,   179,   194,   198,   199,   200,
     202,   209,   220,   228,   231,   251,   257,   258,   260,   261,
     265,   273,   274,   275,   285,   286,   287,   293,   295,   316,
     317,   318,   322,   329,   337,   353,   362,   364,   365,   367,
     368,   369,   370,   371,   386,   398,   399,   400,   402,   403,
     450,   456,   458,   470,   492,   493,   497,   535,   537,   542,
     543,   544,   545,   555,   556,   572,   586,   592,   593,   600,
     607,   637,   643,   644,   650,   657,   687,   706,   707,   708,
     709,   713,   714,   728,   730,   740,   741,   743,   751,   760,
     761,   766,   771,   775,   776,   779,   780,  1471,  1477,  1503,
    1504,  1505,  1506,  1510,  1522,  1524,  1525,  1526,  1527,  1528,
    1529,  1530,  1532,  1533,  1534,  1535,  1543,  1547,  1548,  1549,
    1550,  1551,  1553,  1556,  1863,  1866,  1868,  1869,  1870,  1884,
    1891,  1892,  1899,  1909,    26,  1119,   502,   350,   357,   373,
     383,   384,   385,   393,   534,   548,   649,   686,   700,   947,
     949,   730,   940,   946,  1899,   875,  1429,   911,  1047,   946,
       6,   321,   606,  1976,  1977,  1984,  1986,     6,    68,   249,
     250,   259,   278,   466,   672,   673,   674,   675,  1481,  1488,
    1489,  2031,  1925,    32,    61,   353,   453,   460,   499,   549,
     586,   638,   655,   710,   742,   780,  1271,  1892,  1897,  1899,
    1913,  1915,  1916,  1917,  1919,  1920,  1921,  1922,  1932,  1944,
    1948,     6,    40,    41,    50,   115,   129,   192,   205,   263,
     332,   341,   353,   364,   388,   421,   424,   426,   452,   453,
     460,   461,   477,   499,   520,   576,   590,   601,   604,   605,
     619,   655,   662,   683,   739,  1271,  1307,  1781,  1785,  1786,
    1788,  1797,  1892,  1945,   946,  1960,   152,  1754,   771,  1726,
    1735,  1045,  1503,  1872,   405,  1716,  1754,  1814,  1899,  2022,
    1026,   331,  1904,  1434,  1393,   779,    10,  2023,  1503,  1576,
     792,   284,   794,  1803,   408,  1887,  1889,  1899,  1968,  1904,
     112,  1173,  1893,    95,  1398,   520,   608,   662,  1821,  1822,
     270,  2023,   738,  1837,   663,   810,   211,   299,  1383,  1384,
    1385,   663,   810,   263,  1774,  1707,  1707,    18,   105,   106,
     265,  1864,  1865,  1894,  2062,  2062,  2062,   450,  2061,  2062,
    2062,   772,   772,   778,  1899,  1173,  1173,  1173,   656,   859,
     115,   115,   115,   263,   652,   192,   205,   272,   427,  2036,
     325,   876,   876,  2032,    74,   771,   776,  1477,  1480,  1582,
    1583,  1584,  1585,  1586,  1597,  1598,  1599,  1600,  1602,  1603,
    1604,  1887,   189,   414,  1685,  1686,  1691,   297,  1627,  1478,
      93,   141,   146,   185,  1490,  1652,  1657,  1663,  1664,  1668,
     205,  1667,  1680,  1690,     6,    68,  2030,  1663,  1665,  1471,
    1474,  1475,  1664,  1666,  1473,     6,  1899,  1795,  1794,   779,
    1457,  1454,  1928,  1899,  1332,   727,  1333,   779,   533,   702,
     720,    45,  1904,  1905,  1906,  1983,  1334,  1071,  1093,  1899,
      84,  1339,  1338,     5,    31,    73,   172,   212,   612,  1094,
     875,   263,   114,   575,  1373,  1374,  1375,   651,   427,   736,
    2036,  1904,  1404,  1899,   771,   893,  1015,    76,  1017,  1503,
    1014,   270,  1418,  1701,  1702,  1887,  1070,  1093,     5,  1900,
    1028,   916,   927,   929,    16,    17,    22,    23,    32,    58,
      70,    90,   124,   147,   148,   150,   158,   159,   160,   178,
     213,   237,   243,   267,   268,   269,   291,   292,   342,   344,
     345,   360,   397,   399,   422,   445,   456,   457,   488,   497,
     543,   544,   545,   551,   552,   568,   569,   592,   593,   611,
     643,   703,   706,   709,   732,   742,   751,   920,   962,  1232,
    1234,  1236,  1238,  1240,  1241,  1242,  1243,  1244,  1245,  1246,
    1247,  1248,  1249,  1892,  1915,  1918,  1920,  1922,   778,   778,
     462,   774,    35,   310,    95,  1759,    95,  1759,  1760,  1761,
    1765,  1766,  1899,  1768,  1899,   112,  1706,  1707,   877,   877,
     877,   877,  1899,  1093,   875,  1904,  1103,  1786,   875,  1699,
    1707,  1707,  1061,  1042,   601,  1987,   641,   641,   698,   701,
     728,   736,   771,  1502,   467,   578,  1991,   697,  1993,  1990,
      50,   736,  1992,   180,   358,   662,   270,   180,   774,   418,
    1503,   114,  1370,   381,   608,  1832,  1833,   348,   152,   380,
    1846,  1887,  1961,  1962,   296,   379,   453,  1892,  1901,  1910,
    1918,  1920,  1921,  1922,    95,   100,   555,  1899,  1901,  1901,
    1901,  1901,  1899,   296,  1901,  1899,   418,   965,   778,   786,
     970,  1900,   978,   998,  1899,    60,   340,    93,   151,   220,
     298,   966,  1903,  1426,   122,   760,   761,  1527,   771,   771,
     771,   296,  1503,  1579,  1580,   771,   771,   771,   771,   771,
    1502,  1502,  1502,   771,  1501,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,  1503,
     771,   110,   111,   365,   771,  1577,  1578,  1884,  1891,  1909,
     771,   771,   771,   771,  1503,  1501,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   197,   771,   771,   771,
    1501,   265,  1865,  1502,  1501,  1501,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   177,  1891,   771,
     771,   771,   771,   771,   771,   771,   265,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   730,   771,   771,   771,   771,   771,
     730,   771,   771,   771,   771,   771,   771,   771,   265,   771,
     771,   771,   265,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   122,  1527,   122,  1527,  1527,  1228,  1471,  1503,
    1871,  1899,  1891,  1557,     9,    10,   184,   186,   303,  1507,
    1508,    81,    97,   126,   132,   169,   755,   756,   757,  1511,
      15,   125,   140,   217,   670,  1509,    69,   165,   183,   239,
     240,   758,   759,   760,   761,   762,   763,   764,   765,  1527,
      34,   166,   191,   191,   743,  1894,   779,   771,   197,  1120,
      14,   270,   774,   755,  1894,  1430,  1905,  1907,  1431,  1432,
    1887,   726,  1987,   578,   180,    95,   180,  1463,  1489,    61,
    1899,  1931,  1947,   237,   638,   779,    17,    61,   238,   755,
    1272,  1273,  1729,  1904,    93,  1729,  1954,  1729,  1904,  1934,
     780,  1904,    17,    61,  1275,  1276,  1904,  1729,   779,  1935,
    1933,   663,   771,    49,   192,   205,   263,   272,   427,   453,
     652,   728,   736,   140,   297,  1792,    24,   681,   363,   681,
     681,   426,  1792,     6,  1185,  1904,  1656,  1657,  1658,    95,
     125,  1787,  1789,   363,   681,    93,   681,   697,   669,     6,
     343,   387,   389,   483,   532,   581,   671,   693,  1775,  1776,
    1777,   810,   469,   681,   811,  1658,  1792,  1789,   502,   420,
     366,   603,   697,   712,    93,  1495,   681,   733,  1370,  1736,
     774,   151,  1874,  1875,  1879,  1899,   123,  1717,  1718,  1719,
    1887,  1029,  1034,   774,  1435,  1436,  1437,  1438,  1887,  1701,
    1899,   351,   562,   218,   562,  2024,   774,  1503,   795,    17,
     252,   407,   421,   423,   454,   469,   502,   520,   601,   608,
     618,   631,   662,   665,   681,  1804,  1809,  1810,  1892,  1960,
      35,   780,   953,   954,   955,   956,  1891,   576,   211,   361,
    1509,  1899,   790,   736,  1395,  1960,  1824,   348,  1823,   774,
     647,  1899,  2024,    93,  1386,  1387,  1386,   574,   747,   382,
     774,  1386,  1386,  1702,  1899,  1893,   774,   573,  2065,   692,
    2066,   755,   128,   633,  2064,    80,   784,  1899,   875,   875,
    1173,  1173,   818,   820,  1173,  1173,    24,  1173,  1173,   825,
     827,   736,   453,   453,  2036,  1582,  1586,  1598,  1599,  1600,
    1601,  1602,  1899,    94,  1486,    42,   117,   128,   135,   167,
     228,   259,  1593,  1594,   774,   196,  1595,  1596,   265,  1895,
    1895,   780,  1687,  1688,  1689,  1899,  1904,  1628,   100,  1631,
    1627,   281,   149,   177,   229,   274,   365,  1659,  1660,  1866,
    1891,   125,    26,  1656,  1490,  1899,  1490,  1491,  1491,  1474,
    1796,  1801,  1864,  1899,  1899,  1664,  1667,     6,    17,    61,
     180,  1503,  1956,   238,    61,  1170,  1171,  1182,  1183,  1280,
     396,   879,  1899,  1502,   780,   879,     5,  1072,  1887,   577,
     395,  1089,  1089,  1089,     4,  1905,  1906,  1907,  1999,  2003,
    1887,  1375,   404,   481,   877,  1887,   736,  1405,  1406,  1702,
     779,   891,   894,   895,  1503,  1503,   912,   913,   418,  1008,
     800,  1701,    93,   352,   439,   441,   531,   609,   774,  1421,
    1422,  1423,  1072,  1089,   928,   340,   918,   919,   778,   778,
     771,  1254,  1256,  1254,  1255,   379,  1254,  1263,  1264,   771,
    1251,  1252,  1254,   203,  1251,  1263,    17,    34,   329,   347,
     723,  1237,  1264,  1271,  1281,  1282,  1284,    32,   291,  1237,
    1244,  1246,  1263,  1237,  1251,   771,  1263,  1237,  1254,  1256,
    1237,  1255,   771,  1251,  1263,    32,   292,   292,   294,  1251,
    1254,   771,   924,  1255,  1255,  1255,  1254,  1255,   197,   779,
      61,   238,   964,  1251,   294,  1256,  1256,  1254,  1254,  1255,
     771,  1252,  1259,    93,  1899,    93,  1887,    14,  1757,  1704,
    1705,  1888,  1899,    93,  1484,  1485,  1627,   774,  1762,   779,
    1767,    84,  1899,   877,   779,  1103,  1982,  1984,   565,   738,
    1104,  1105,   421,  1907,  1998,  1701,  1700,  1697,   151,   125,
    1043,   697,   772,   771,  2007,  2007,  2007,  2007,  1907,  1999,
     192,   205,   263,   453,  1985,   427,   432,   443,   602,   623,
     628,   659,   691,  1989,   112,   266,  1717,   471,   728,  1503,
    1834,  1834,  1441,   499,  1845,    11,   755,  1623,  1624,  1625,
     566,   738,   774,  1959,   979,   980,   296,  1899,   555,    95,
     123,   240,   979,   296,   771,   993,   151,   778,   779,   971,
    1503,   774,  1022,  1021,  1053,  1051,  1056,  1052,  1701,   771,
       6,  1567,  1626,  1567,  1567,  1503,  1580,    76,   296,   418,
    1503,  1576,  1503,    68,  1567,  1626,   772,    57,    89,   105,
     149,   177,   274,   772,  1672,  1676,  1677,   772,  1503,  1503,
    1884,   772,  1466,  1467,  1476,  1871,    53,    54,    55,    56,
     107,   108,   109,   161,   162,   232,   304,   400,   470,   535,
     537,   542,   607,   650,   740,   751,  1620,  1621,  1503,    68,
    1559,  1503,  1503,  1503,  1503,  1503,  1620,  1503,  1891,  1578,
     324,   774,   779,    68,  1567,  1503,    68,  1567,  1503,  1503,
    1503,   772,  1503,  1503,  1506,   772,  1503,  1503,   772,   642,
    1567,  1567,    68,  1567,  1567,  1567,  1503,  1503,  1531,    25,
     133,   271,  1503,  1523,  1503,  1503,    68,  1567,  1503,  1576,
    1503,   779,  1503,  1503,  1503,  1519,  1520,  1503,  1503,  1503,
    1503,  1503,  1503,  1503,  1503,  1503,  1576,   397,   399,   706,
     709,  1622,  1503,  1503,  1576,  1887,  1576,  1503,  1503,  1503,
    1576,  1576,  1576,    93,  1887,  1503,  1503,  1503,  1576,    93,
    1503,  1503,  1503,   772,  1503,  1887,  1503,  1503,  1621,  1621,
    1503,  1523,  1503,   772,   365,   779,  1885,  1899,  1503,  1503,
    1503,  1503,  1503,  1503,   772,   774,  1467,  1503,   779,   780,
    1558,  1904,  1503,  1503,  1503,  1505,    86,   176,   273,   725,
    1509,     6,   328,  1505,  1512,  1505,   771,  1477,  1505,  1505,
     140,    15,   125,   140,   217,  1506,  1506,  1506,  1506,  1506,
    1506,  1506,   122,  1506,   122,  1506,  1506,  1506,  1506,  1506,
    1277,  1904,  1527,   771,  1555,  1637,  1899,   771,   100,  1891,
    1536,   451,   485,   561,   642,  1521,   142,   208,   498,   696,
    1121,  1125,  1828,  1893,   949,   399,   706,   709,   948,  1556,
    1868,  1884,   774,   270,   774,  1959,  1048,   774,    93,  1907,
    1906,  2000,   192,   205,   453,  1985,   762,  1493,  1494,  1496,
     779,   779,  1729,   774,  1926,  1984,  1899,    34,  1278,  1503,
    1907,   265,   572,   586,  1955,  1956,   211,   484,  1949,  1950,
    1951,  1952,   460,   499,   655,  1946,  1729,  1956,  1899,   710,
    1936,  1947,   774,  1938,   681,   762,  1173,    24,   877,   877,
    1887,   877,   877,   877,  1887,  1907,  1887,  1495,  1495,   363,
     681,  1792,   877,  1792,  1787,   125,  1790,   502,   546,   681,
    1784,  1784,  1792,  1899,   877,  1792,  1906,  1787,  1792,  1893,
     482,   694,   442,    93,  1778,   774,   426,   681,  1887,  1789,
    1787,  1787,  1503,  1792,  1792,  1792,  1583,  1746,  1887,  1496,
    1738,  1740,   771,  1733,  1046,   774,   771,  1877,  1718,  1714,
    1703,  1887,   910,   418,   780,   125,   774,   196,  1446,  1448,
    1449,   439,   609,  1394,   238,   351,   218,  1503,   793,    61,
     114,   796,  1503,  1741,  1742,   502,   502,   502,   502,   348,
     502,   810,   502,   774,  1495,  1805,   948,   958,  1904,   774,
     755,  1624,  1969,    84,   669,  1503,  1396,  1701,   270,  1826,
     810,  1822,  1899,     6,  1381,   622,   676,  1388,  1389,  1380,
     666,  1385,  1959,  1864,   589,  2067,  1904,   822,  1982,  1999,
    1904,   816,  1173,  1173,   813,  1887,  1173,   877,   826,  1496,
    2045,   863,  1496,  1173,  1173,  1173,   736,   774,   772,   772,
     772,   772,   772,   774,   772,  1582,     6,    11,    15,    95,
    1487,  1625,   128,   128,   188,  1605,   135,   228,  1593,  1605,
    1582,  1584,   771,  1486,  1692,  1904,   774,   779,  1503,    26,
     104,  1629,  1631,   566,   738,  1492,   430,  1891,   229,   571,
     774,   779,   658,  1653,  1681,  1929,  1171,    34,  1271,   409,
     164,   210,   251,   374,   386,   490,   562,   881,   888,  1904,
     615,   721,  1090,  1091,   478,  1086,  1087,  1088,  1095,  1103,
    1105,  1340,   771,  1893,   333,   527,  1080,  1081,  1082,  1095,
    1096,  1097,  1103,  1105,  1073,  1074,  1080,   472,   221,   774,
    2010,  1959,  1337,  1336,  1887,   774,   588,  1407,  1899,   893,
     772,   774,  1016,   911,    29,   296,  1009,  1011,    71,   113,
     153,   473,   503,   504,   506,   507,   508,   509,   510,   512,
     513,   514,   515,   516,   517,   518,   519,   521,   522,   523,
     620,   621,   801,   802,   809,    93,  1424,   727,  1702,  1422,
     374,   559,   616,   722,  1083,  1084,  1085,  1095,  1099,  1100,
    1101,  1102,  1103,  1105,   283,  1068,   771,   931,  1034,    57,
     149,   177,   274,  1263,  1262,  1729,  1263,   177,   280,   305,
     660,  1253,  1253,  1281,    61,  1277,  1279,  1283,  1284,  1272,
      17,  1282,  1285,   379,  1265,  1263,  1237,  1253,  1328,  1864,
    1263,  1328,  1253,   294,  1253,  1263,   921,   922,   923,  1900,
     964,  1237,  1237,  1253,   230,   716,  1899,  1503,  1503,   215,
    1250,  1283,  1285,  1237,  1263,  1253,   177,  1253,   930,   105,
     761,   938,   939,  1669,  1671,  1595,   696,   774,  1763,   779,
    1767,   201,  1651,  1652,  1766,    95,   762,  1899,   180,  1899,
    1104,   774,  1729,  1730,   774,    28,   223,  1376,  1701,  1701,
     911,   637,  1040,  1899,  2008,  2009,   270,   299,  1981,    24,
     762,  1887,  1899,  1997,  1997,  1997,  1997,  1001,  1711,  1503,
    1907,  1442,  1443,  1444,  1445,  1887,   116,   453,  1892,  1896,
    1908,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,   152,
     211,   747,  1963,  1671,  1962,  1503,   979,   123,   643,  1899,
     979,   987,   988,   992,  1899,   893,  1899,   914,  1034,  1041,
    1044,  1047,  1045,  1959,  1503,   772,  1568,   772,   772,   266,
     418,  1503,  1503,    11,   284,   772,   284,   774,  1544,   772,
     762,   772,   774,   774,   772,   772,  1467,    95,   772,  1546,
     772,   774,   772,   774,   774,   774,   774,   761,   774,   772,
     771,  1884,  1891,  1567,   772,   772,  1567,   772,   774,   772,
     774,   772,   772,   125,   774,   774,   772,   772,  1567,   772,
     772,   772,   774,    95,   774,   772,    95,  1503,    95,  1503,
      95,  1503,    95,   772,   774,   772,  1567,   772,   772,   772,
     772,  1891,   774,   772,   774,   772,   774,   774,   774,   774,
     774,   772,   772,   774,   774,   774,   772,   774,   772,   772,
     774,   772,   772,   772,   772,   772,   772,   772,   772,  1887,
     772,   772,   772,   774,   772,  1887,   772,   772,   774,   772,
     774,   774,   772,   774,   774,   774,   772,   772,   774,  1891,
    1899,   772,   779,   772,   774,    11,   496,   774,  1296,   774,
     772,  1620,  1620,  1576,   772,   777,  1891,  1946,   238,    86,
     176,   273,   725,   771,    10,  1503,   425,  1505,  1505,   771,
    1477,  1505,  1505,  1503,  1503,  1638,   196,  1640,   771,   771,
     779,  1496,  1540,  1541,  1542,   366,   771,  1130,  1131,  1123,
    1130,  1124,   584,  1133,   130,   464,  1503,   755,  1907,  1907,
    1432,   270,  1503,    99,  1984,    95,   774,    24,  1997,  1997,
    1997,  1997,   774,  1503,  1882,  1891,  1899,  1899,  1956,  1947,
      93,    93,  1729,  1279,  1729,   771,   771,   574,   747,   496,
     774,   774,   779,   779,   779,    61,   453,   742,  1892,  1893,
    1898,  1911,  1915,  1916,  1917,  1918,  1919,  1921,  1922,  1503,
    1729,  1949,  1937,  1939,  1940,   772,  1899,   877,  1893,  1503,
     877,  1792,  1792,  1893,    95,  1791,   875,  1792,   608,  1658,
    1777,  1790,  1787,  1887,  1792,  1792,   237,  1595,  1742,   772,
     774,  1734,   911,  1875,  1878,  1899,  1876,   136,   137,   237,
    1111,  1466,  1720,  1722,  1725,  1595,   965,  1035,  1904,    61,
    1439,  1899,  1437,  1887,  1116,  1448,   115,   130,  1305,  1450,
    1930,   794,   774,    62,  1815,   810,  1810,  1701,  1811,   956,
     959,   960,   955,   567,   568,   644,   957,   444,   555,  1899,
    1970,  1971,  1893,  1701,   439,   609,   729,  1399,  1400,  1401,
    1671,     6,  1825,   663,   774,   726,  1390,  1772,   774,    93,
    2068,  1169,  1170,   299,  1980,  2010,   860,  1899,  1899,  1899,
    1887,   815,   877,   885,   886,   877,  2055,  1173,  1173,  1887,
     877,  1899,   877,  1173,  1582,  1582,   777,   570,   706,   710,
    1482,  1483,  1529,  1483,   128,  1605,  1605,  1597,   128,   180,
     284,  1619,  1899,  1624,  1271,  1274,  1688,  1899,  1503,  1632,
    1883,  1630,   742,  1634,  1629,  1671,  1660,  1661,   430,  1660,
    1660,  1891,   540,  1654,  1883,   771,  1956,  1730,  1730,   550,
     251,   251,   651,  1893,   251,   251,   251,  1893,  1893,  1730,
     774,  1088,   156,   348,   394,   476,   538,   557,   558,   562,
     563,   564,   630,   679,   856,   857,    49,   468,   579,   586,
     594,   667,   728,   861,   862,  1730,  1730,   774,  1082,  1075,
    1076,  1095,  1096,  1097,    26,   299,   735,  2001,   252,   356,
     486,   560,   688,   748,  1995,  1996,  2003,   299,  2013,  1331,
     180,   871,  1344,   771,  2038,  1335,  1406,    93,   892,  1503,
     266,  1012,  1011,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   755,   755,   755,
     755,   755,   755,   755,   755,   755,   755,   774,   727,  1730,
    1730,  1730,  1730,   774,  1085,   501,   440,  1077,  1078,  1079,
    1095,  1096,  1097,  1098,  1101,  1102,  1103,  1105,   898,   899,
     900,  1899,   126,   418,   772,   772,   772,   772,  1899,   774,
     305,   280,  1262,   772,   774,   772,  1232,   772,   774,   964,
     964,   779,   755,  1285,   187,   246,   248,   936,   937,   938,
     941,  1509,  1899,    57,    89,   149,   177,   274,  1483,  1705,
    1899,   284,  1899,   570,   141,  1662,  1583,   779,  1767,  1887,
    1984,  1184,  1904,  1907,  1959,   418,   771,   987,   990,   772,
     774,  1999,   321,  1997,   779,   779,   270,   270,   270,   270,
     912,  1720,   774,  1446,  1448,  1895,   747,   499,   380,   123,
     989,   772,   774,   779,   972,  1023,   418,  1054,  1018,  1049,
    1901,  1049,  1049,   774,  1503,  1503,   266,    17,    32,    58,
      70,    90,   122,   124,   280,   292,   397,   399,   552,   660,
     709,   732,  1569,  1573,  1574,  1272,  1272,  1569,  1576,   772,
     122,   122,  1503,  1576,  1503,  1503,  1503,  1503,  1503,  1503,
    1503,  1506,   779,   772,   772,  1503,  1503,  1503,  1503,  1503,
     772,  1503,  1503,  1503,  1503,    95,  1503,    95,  1503,    95,
    1503,   122,  1503,   772,  1520,  1503,  1519,  1576,  1503,  1503,
    1503,  1503,  1503,  1581,  1503,  1503,  1503,  1503,  1576,   149,
     760,  1669,  1673,   122,  1503,  1503,  1503,  1503,  1503,   779,
     779,  1899,  1503,    17,    32,  1291,  1292,  1293,  1294,  1295,
    1672,  1671,   772,  1503,   761,   761,  1898,  1503,  1476,  1505,
     772,   774,  1505,    10,  1503,   425,  1620,  1620,  1639,  1899,
      26,   772,  1552,  1575,  1576,  1891,  1503,   772,   774,   771,
    1139,  1506,  1131,   141,  1165,  1166,  1672,   690,  1134,   326,
    1126,  1122,   948,   270,  1887,   418,   578,  1998,  1906,  1997,
      95,    95,    95,    95,  1494,  1497,  1497,   779,  1729,  1729,
     785,  1907,  1956,   265,   265,   211,   627,   653,  1953,  1951,
    1950,   779,   779,  1729,  1956,  1938,   774,  1942,  1944,  1948,
     424,   739,  1669,  1674,  1782,   177,  1791,  1627,  1787,  1750,
    1751,  1885,  1484,  1497,  1496,  1737,  1739,  1742,   418,   772,
     774,    11,  1723,  1724,  1880,  1881,  1885,  1899,  1871,  1721,
    1725,   778,   310,  1036,  1447,   771,  1956,  1742,   755,    93,
     299,  1806,  1807,   755,   774,    97,   132,   444,   491,   555,
     599,   755,   756,   757,  1972,  1974,  1627,    95,  1402,  1400,
    1389,   505,   809,  1391,    73,   636,  1773,  1671,   536,   321,
    2013,    92,   284,   716,  1318,   180,   180,   814,   855,   856,
     885,    11,   126,  2059,   374,   882,   883,   884,   888,  2056,
    2046,   877,   823,   226,   771,   635,   226,   771,  1887,  1483,
     265,  1506,    10,   270,  1582,  1597,   128,   128,  1582,  1597,
    1587,  1588,   772,   774,  1614,  1615,  1273,  1693,   300,   301,
     774,  1633,    12,    65,  1655,  1503,  1555,  1635,  1636,  1634,
    1661,  1492,   774,  1655,  1496,  1682,  1683,  1684,  1279,  1273,
     396,   396,   404,   481,   105,   149,   177,   274,  1106,  1675,
    1676,  1892,  1088,  1730,  1730,    26,  1730,  1732,  1730,   156,
     538,   299,  1730,  1731,  1731,   857,  1893,  1893,  1893,  1893,
    1671,  1893,  1893,   772,   774,  1106,  1106,  1082,   774,  1076,
     265,   586,  1904,  2004,  2005,   265,   265,   265,    10,  1994,
     524,   525,   528,   529,   530,  2011,  2012,   319,   586,  1343,
       5,     7,     8,    31,    33,    39,    73,   115,   146,   181,
     185,   193,   196,   219,   254,   255,   256,   277,   302,   326,
     334,   336,   355,   362,   374,   381,   396,   406,   410,   411,
     417,   421,   429,   449,   475,   479,   489,   526,   539,   541,
     580,   586,   613,   624,   625,   626,   645,   652,   683,   698,
     699,   711,   714,  1114,  1176,  1178,  1181,  1182,  1183,  1348,
    1352,  1354,  1357,  1363,  1364,  1365,  1367,  1368,  1648,  1892,
     378,   648,   219,  1345,  1899,  2039,    11,  2038,     6,   366,
    1408,   893,   912,  1503,   771,   771,  1671,   771,  1671,  1671,
    1893,  1893,  1674,  1893,  1671,  1893,  1893,  1893,  1893,  1893,
    1893,  1893,  1671,  1893,   392,   562,   664,  1869,  1893,  1671,
     802,  1893,  1672,  1106,  1106,  1085,   100,  1730,   774,  1079,
     772,   774,    17,   291,   611,   643,   732,   962,  1235,  1236,
    1239,  1240,  1241,  1242,  1244,  1245,  1246,  1247,  1270,   932,
     933,   177,  1283,  1864,  1283,   922,  1899,   177,   774,   965,
     451,   779,  1583,  1767,  1495,   229,  1660,   224,  1764,  1627,
    1959,  1376,   151,   933,   991,    72,  2009,   299,  2015,   578,
     270,   762,   762,  1999,  1999,  1999,  1999,  1002,   180,  1743,
    1444,  1887,  1448,   114,  1451,  1841,  1503,   988,  1899,   893,
     340,  1018,   151,  1503,  1503,  1255,  1255,  1251,  1259,    56,
     124,  1254,  1255,  1255,   124,  1255,  1254,   772,   772,   772,
     772,  1545,  1503,  1503,   772,   185,  1561,   772,   772,   774,
     774,   772,   774,   772,   125,  1537,  1538,  1891,   772,   772,
     772,   772,   772,   774,    93,   774,  1503,  1503,  1503,  1503,
     772,   772,    11,  1513,   772,    11,   772,   772,   774,   772,
     774,   772,   774,   772,   774,   772,   772,   772,   772,   149,
     177,   177,   772,   774,  1503,   772,   772,   774,   774,   772,
    1891,  1899,   779,   772,   771,  1286,  1286,    12,    65,   637,
     760,  1288,  1289,  1290,   774,   774,   772,  1503,  1503,   779,
     772,  1576,  1505,   772,   774,  1505,  1640,  1632,   185,  1554,
     772,   771,  1497,  1542,  1127,  1128,  1129,  1899,   772,  1674,
     122,    26,   771,  1141,   755,   771,  1131,  1907,   220,    95,
      95,  2000,  2000,  2000,  2000,    11,  1499,  1893,  1899,   762,
    1891,  1956,  1956,   772,   772,   375,   719,   211,  1899,  1899,
    1956,  1941,  1943,    57,    89,   149,   177,   274,  1658,  1783,
    1792,   774,  1749,  1729,  1624,  1742,   772,   774,   151,  1899,
     771,   772,   774,   779,  1467,  1727,  1728,  1885,   296,  1037,
    1038,   771,   204,  1616,  1617,  1618,  1899,   771,  1808,   211,
     350,   357,   373,   383,   384,   385,   393,   534,   548,   634,
     649,   686,   700,   961,   960,  1973,  1658,   547,   755,   774,
     683,   683,  1906,  1343,   396,   346,   464,   646,  1324,  1324,
     180,  1887,  1887,   136,   138,   140,  1107,  1109,  1175,  1177,
    1178,  1190,  1175,  2059,  1496,  1893,   882,   771,   905,   907,
     909,   877,   864,  2038,   830,   831,    58,   124,   213,   685,
    1188,   828,   829,   824,  1483,  1483,   180,  1590,  1597,  1597,
     180,  1592,  1503,   771,  1116,  1899,  1612,  1613,   366,  1848,
    1883,    11,   774,  1883,  1503,   772,   774,  1673,  1673,  1673,
    1673,  1673,  1673,   862,  1076,   265,    11,   284,  2002,  2006,
     186,  1995,  1671,  1671,  1671,  1869,   760,  1669,  1670,  2011,
     146,   279,  1341,   437,    36,   196,   372,   587,   695,  1194,
    1202,  1203,  1208,  1209,  1305,  1309,  1310,  1369,  1369,   196,
    1369,   196,   270,    36,    92,   196,   587,   695,  1207,  1305,
    1369,   409,  1730,   196,    26,  1730,  1116,    11,   270,   755,
    1378,  1730,  1730,  1730,  1730,   734,  1730,  1730,  1730,  1730,
     196,  1730,  1730,   409,  1730,   129,   698,   129,  1730,   196,
     698,  1730,  1730,  1730,  1730,  1369,  1730,  1730,   196,   585,
     196,   196,  1730,  1730,   412,   532,  1899,  1730,  1730,   196,
    1176,   774,  1113,  1114,  1352,   771,   779,  1193,  1210,  1886,
    1899,  1729,  1509,  2021,   330,   428,   865,   270,   410,   417,
     867,   772,   774,  2040,  2041,    11,     6,   771,  1409,  1013,
     805,   806,  1671,   807,   808,  1671,   803,   804,  1671,  1899,
    1106,  1079,   900,  1254,  1258,  1254,  1257,  1257,   924,  1257,
     197,   779,  1258,  1258,  1257,  1257,   934,   772,   937,  1899,
    1627,  1899,   430,   229,  1493,   772,  1503,   990,    99,  1999,
    2010,  2010,  2010,  2010,    76,    78,  1003,   415,  1451,   494,
     114,   316,  1847,   973,  1034,   911,  1570,  1254,  1571,  1572,
     772,  1620,  1620,    26,   235,  1560,  1503,  1503,  1576,   167,
     345,   772,   299,  1539,  1503,  1503,  1503,  1620,    58,    70,
      90,   124,   213,   280,   397,   399,   551,   552,   709,  1244,
    1245,  1514,  1515,  1516,  1517,  1569,  1503,  1503,  1503,  1503,
      86,   273,  1671,  1679,  1620,  1503,  1503,  1899,  1672,   772,
    1296,  1291,  1289,  1291,  1292,  1671,  1899,   772,  1576,   185,
    1641,    26,   772,  1575,  1499,   772,   774,  1503,  1125,   196,
    1142,  1143,  1672,  1127,  2000,  2000,  1893,  1899,   779,  1729,
    1729,  1942,  1947,  1658,  1751,  1627,    61,  1741,  1614,  1497,
    1742,  1466,  1880,   762,  1899,   772,   774,  1729,  1039,  1038,
       6,  1353,  1361,  1362,  1899,   772,   774,  1674,  1816,  1817,
     438,   146,   771,  1893,   809,   746,  1887,   819,   821,    36,
     587,  1191,  1192,  1193,  1194,  1202,  1203,   140,  1887,  1112,
    1113,   774,  1177,  1108,  1496,   833,   906,   880,    14,   323,
    1063,   180,    11,  2051,  2052,   896,   897,   669,  2051,   896,
    2038,  1589,   284,  1591,   284,  1619,   114,   283,   449,  1607,
    1608,  1611,    79,    82,   182,   264,  1849,  1850,   143,  1851,
    1655,  1637,  1636,  1655,  1497,  1684,   586,  1893,  2004,   177,
     177,   586,    61,   122,   553,  1342,   112,  1327,  1886,  1173,
      94,   112,  1172,   734,    33,    92,   204,   278,  1206,  1304,
    1173,  1305,  1306,  1306,  1172,  1706,  1427,  1706,  1353,  1271,
    1706,   130,  1707,    94,  1706,   734,   204,  1706,  1706,  1730,
      61,  1899,  1427,  1649,  1650,  1885,    61,  1671,  1678,  1115,
    1887,    61,  1671,    61,  1671,    61,  1671,  1179,    61,  1899,
    1674,  1671,  1671,  1427,  1893,  1893,  1730,  1671,  1904,  1362,
     444,   491,   562,  1187,  1671,  1674,  1674,  1706,    61,  1671,
    1893,  1427,  1427,  1427,    61,   377,   379,   416,   445,   581,
     617,  1186,  1678,  1671,  1678,  1353,     5,    73,  1365,  1189,
    1191,  1899,   323,   444,  1377,   216,  1298,  1211,   779,    61,
    1675,  1893,  1899,   598,  1503,  1503,   180,   871,   877,   180,
     374,   872,  1899,  1466,  2040,  1410,   477,   266,   772,   774,
     772,   774,   772,   774,  1283,   230,  1899,  1283,  1285,  1283,
    1285,  1452,  1871,    95,   430,   578,  2010,   299,  2014,  2014,
    2014,  2014,   912,   999,  1744,   123,   893,   418,   418,  1283,
    1283,  1283,   772,   772,  1562,  1883,  1864,   141,  1563,  1564,
    1565,   772,   774,   772,   490,   540,   608,   772,   772,  1251,
     124,  1255,    32,  1255,  1518,   772,   772,   772,   772,   774,
     772,   772,   772,  1287,   772,   774,   772,    26,   208,   229,
    1642,  1643,  1883,   772,  1129,  1620,   130,   464,  1144,   772,
     774,   772,   762,  1956,  1956,  1651,   772,   779,  1728,  1742,
     936,   772,   774,  1617,   772,   774,    10,  1818,  1739,  1904,
     817,   771,   771,    93,  1204,   772,   774,  1887,  1110,  1847,
    1177,  1175,   834,   205,   453,   852,   853,   854,   899,   901,
     902,   903,   881,   887,  2021,  2057,    63,   120,   281,  1064,
     648,  2040,   880,  2053,  1270,   772,   898,  1893,  2053,   772,
      11,  1503,   771,  1503,   771,   772,  1305,  1305,  1608,    26,
      26,    79,    26,  1850,   253,   264,  1852,  1853,   771,   437,
     177,   319,  1509,  1427,   771,  1509,  1204,   771,   130,   130,
    1306,  1173,  1327,  1899,  1173,  1173,  1886,  1353,  1886,  1350,
    1273,  1886,  1706,  1361,    93,   130,  1886,  1886,  1893,  1353,
     774,  1655,  1119,   771,  1672,  1893,   299,  1210,  1353,  1358,
    1353,   772,  1899,  1887,   654,   962,  1212,  1233,  1234,  1899,
    1620,   662,  1893,   413,  1346,   299,  2042,  1413,  1899,     6,
     771,  1411,   912,   806,   808,   804,   197,   779,  1506,  2014,
      99,  2011,  2016,  2017,   130,   263,  1018,   151,   774,  1655,
     772,  1566,  1660,  1503,   540,   436,  1283,  1674,   772,  1671,
    1654,   772,    15,   391,   399,   706,   709,   718,  1644,  1645,
    1868,  1655,   678,  1167,  1126,   771,  1132,  1145,  1899,  1143,
    1662,   762,   266,  1362,  1817,   410,   772,   577,   771,  1325,
    1326,  1899,  1325,  1899,  1192,   772,    11,  1168,  1112,   205,
     453,   838,   839,   840,   846,   851,   854,   926,   844,   986,
     842,   986,   418,   854,   118,   125,   190,   904,   772,   774,
      67,  2059,   180,   865,  2054,   877,   878,   226,   878,   226,
    2040,  1619,  1619,    93,  1606,  1606,  1864,  1864,    26,  1864,
      26,    26,  1853,   265,  1342,   400,  1341,    84,  1355,  1899,
      84,  1503,  1173,  1327,  1899,   284,  1317,   716,  1327,  1327,
      73,   237,  1210,  1421,  1278,  1886,  1899,  1376,  1349,  1650,
    1811,   263,  1377,  1359,  1361,  1351,   771,  1299,  1214,   779,
    1205,  1206,  1213,   779,   866,   873,   874,    33,   349,   499,
     772,   774,  1412,   230,   716,  1899,   270,   578,  2017,   281,
    1887,  1055,  1883,   571,   774,   772,   772,   772,   718,  1645,
    1646,  1868,   643,   596,   431,  1647,   596,  1671,   771,  1139,
    1135,    61,   289,   290,   391,   467,  1146,   912,   354,   771,
    1325,   772,   774,  1655,   771,   772,   771,  1111,  1110,   844,
     842,   835,   840,   851,   846,   778,   778,   841,   778,   841,
    1498,   190,   643,   962,  1270,   903,  1030,  1031,  1496,   870,
     871,  2059,  2051,  2051,   772,   772,   100,   128,   185,  1610,
    1609,  1864,  1864,  1864,   772,  1886,   584,   771,  1356,   774,
     772,  1327,  1317,   716,  1324,  1195,  1324,  1197,  1198,    61,
      61,  1377,  1427,   772,  1887,  1360,  1399,  1300,  1899,   154,
    1301,   204,   278,   302,   374,   487,   744,  1215,  1216,  1225,
    1267,  1268,  1269,  1297,  1509,  1892,  1234,    34,    61,   176,
     180,   334,   455,   654,  1219,  1221,  1260,  1261,  1268,  1899,
     678,   868,   965,   578,    33,    33,  1899,   204,  1414,  1415,
    1899,   197,  1506,  1745,  1595,  1049,  1655,  1660,  1660,   448,
      10,   448,   100,   391,   562,   705,  1137,  1138,  1899,   772,
     689,  1140,  1148,   704,   115,   374,   381,   396,   526,   539,
     559,   698,  1162,  1163,  1164,  1786,   861,   772,  1959,  1326,
     177,  1959,  1899,  1180,  1181,   849,  2059,   847,  2059,   340,
     418,   837,  1899,  1899,   878,   924,   197,   779,   878,   914,
    2047,   867,  1030,  2053,  2053,    26,    26,   771,   771,  1206,
    1672,  1142,  1899,  1201,  1199,  1324,   771,  1196,   771,   771,
     760,   761,   771,  1229,  1230,  1231,  1477,  1524,  1867,  1892,
    1116,   123,   772,   774,   452,   583,   661,   180,  1302,   130,
    1893,   695,  1268,   734,   130,   176,  1729,  1277,  1231,   281,
     327,    61,    11,   379,  1261,  1266,  1503,   419,   869,    91,
     858,   578,   578,   772,   774,   716,  1752,  1753,  1885,  1842,
    1646,   643,   187,   312,   772,   774,  1672,   771,  1150,  1152,
    1147,   409,  1730,  1730,   409,  1730,  1730,  1730,  1730,   771,
    1157,  1164,   421,   772,  1959,   299,   374,   489,  1312,  1316,
    1320,  1323,  1892,  1655,   772,  1313,  1315,  1320,  1322,   774,
     778,   986,   778,   986,  1034,   836,   845,   843,   230,  1899,
    1032,  1887,   872,   858,   878,   878,  1616,  1618,   772,   772,
     771,   771,  1200,  1325,   771,  1325,  1325,  1869,  1869,  1228,
     771,  1899,    63,   281,    61,  1675,  1893,  1899,   173,   730,
     643,  1229,  1262,  1260,  1503,  1415,   774,  1729,  1274,  1136,
    1138,   771,  1151,  1152,  1153,   156,  1149,  1152,  1730,  1893,
    1893,  1730,  1675,  1675,  1672,  1904,   690,  1158,  1159,  1730,
     284,   716,  1311,  1314,  1319,  1320,  1321,   582,  1893,  1730,
    1366,  1367,  1368,  1323,  1729,  1366,  1322,  1899,   850,   848,
     418,  1498,   909,   771,   907,   908,   197,   779,   340,    93,
     413,   772,   772,  1325,  1325,   771,   772,  1325,   772,   772,
     772,  1142,    28,   223,   237,   562,  1303,  1303,   771,  1500,
     418,   679,  1220,  1753,  1742,  1843,  1140,   772,   774,   156,
    1155,  1156,  1506,  1893,  1893,  1160,   772,   774,  1184,  1324,
    1324,  1366,  1321,  1892,  1671,  1368,  1367,    61,  1675,  1893,
    1899,   772,  1030,  1030,   878,   880,   896,   226,   230,   716,
    1899,  1034,  1496,   873,   772,   772,  1325,  1311,   772,  1312,
    1313,   772,    61,   176,   320,   180,   180,   772,  1672,  1217,
    1218,  1267,  1217,   588,   684,   737,  1222,   229,  1854,  1152,
     774,  1154,  1161,  1904,  1159,  1899,  2058,  2058,   772,  2051,
     197,  1033,  2048,  1298,  1311,   772,  1311,   281,    63,   772,
    1267,  1223,  1224,  1225,   472,  1848,  1156,   772,  1162,   880,
     716,   418,    75,  1311,  1303,  1303,  1225,    26,  1851,   643,
    1864,   114,  1855,  2049,   177,   771,  1857,   447,   595,  2043,
    2044,   143,   229,  1856,   772,   780,  1858,  1859,  1885,   237,
    1860,  1904,  2050,  1904,   772,   774,  1861,  1862,  1885,   965,
    1859,   774,  1729,   858,  1862,  1496,  1742,  1497
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   781,   782,   783,   782,   782,   784,   784,   785,   785,
     785,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   787,   788,   788,   790,   789,   791,   792,   793,   791,
     794,   795,   794,   796,   796,   798,   797,   800,   799,   801,
     801,   802,   802,   802,   802,   802,   802,   802,   802,   802,
     802,   802,   802,   802,   802,   802,   802,   802,   802,   802,
     802,   803,   803,   803,   804,   805,   805,   805,   806,   807,
     807,   807,   808,   809,   809,   809,   809,   809,   809,   809,
     810,   810,   811,   813,   814,   812,   815,   812,   816,   817,
     812,   818,   819,   812,   820,   821,   812,   822,   812,   823,
     812,   824,   812,   825,   812,   826,   812,   827,   812,   828,
     812,   829,   812,   830,   812,   831,   812,   812,   812,   812,
     812,   812,   832,   812,   833,   812,   834,   835,   836,   812,
     837,   837,   838,   838,   838,   839,   839,   840,   840,   841,
     843,   842,   845,   844,   846,   846,   846,   848,   847,   850,
     849,   851,   852,   852,   853,   853,   854,   854,   855,   855,
     856,   856,   857,   857,   857,   857,   857,   857,   857,   857,
     857,   857,   857,   857,   857,   857,   858,   858,   860,   859,
     861,   861,   862,   862,   862,   862,   862,   862,   862,   864,
     863,   866,   865,   865,   867,   867,   867,   867,   868,   868,
     869,   869,   870,   870,   871,   872,   872,   874,   873,   875,
     876,   876,   877,   877,   878,   878,   879,   879,   880,   880,
     881,   881,   881,   881,   881,   881,   881,   882,   882,   883,
     883,   884,   884,   886,   885,   887,   887,   888,   888,   890,
     889,   891,   889,   892,   889,   893,   893,   894,   894,   895,
     895,   896,   897,   896,   898,   898,   899,   900,   900,   900,
     900,   900,   900,   901,   901,   902,   902,   903,   903,   903,
     903,   903,   903,   904,   904,   904,   904,   904,   906,   905,
     907,   908,   908,   909,   909,   910,   910,   911,   911,   913,
     912,   914,   914,   916,   915,   915,   917,   917,   918,   918,
     919,   919,   920,   920,   920,   921,   922,   923,   923,   924,
     925,   926,   926,   926,   926,   927,   927,   927,   928,   927,
     930,   929,   931,   931,   932,   934,   933,   935,   935,   935,
     935,   936,   936,   937,   938,   938,   939,   940,   940,   941,
     941,   941,   941,   941,   941,   942,   942,   943,   944,   944,
     945,   945,   946,   946,   947,   947,   948,   948,   948,   949,
     949,   949,   949,   949,   949,   949,   949,   949,   949,   949,
     949,   950,   951,   952,   952,   953,   953,   954,   954,   955,
     956,   956,   957,   957,   957,   958,   959,   959,   960,   961,
     961,   961,   961,   961,   961,   961,   961,   961,   961,   961,
     961,   961,   962,   962,   963,   963,   964,   964,   964,   965,
     965,   965,   965,   965,   965,   966,   966,   966,   966,   966,
     966,   966,   966,   966,   966,   966,   966,   966,   967,   967,
     967,   967,   969,   968,   970,   971,   970,   972,   970,   973,
     970,   975,   974,   976,   976,   978,   977,   977,   980,   979,
     981,   981,   981,   981,   982,   982,   982,   982,   983,   984,
     985,   986,   987,   989,   988,   991,   990,   992,   992,   993,
     993,   994,   995,   995,   995,   996,   996,   997,   998,   998,
    1000,  1001,  1002,   999,  1003,  1003,  1003,  1005,  1004,  1007,
    1008,  1006,  1006,  1009,  1009,  1010,  1010,  1012,  1013,  1011,
    1015,  1016,  1014,  1017,  1017,  1018,  1018,  1019,  1021,  1020,
    1022,  1023,  1020,  1024,  1024,  1026,  1025,  1027,  1028,  1025,
    1029,  1031,  1032,  1033,  1030,  1035,  1034,  1036,  1036,  1037,
    1037,  1039,  1038,  1040,  1040,  1042,  1041,  1043,  1043,  1043,
    1044,  1046,  1045,  1048,  1047,  1049,  1051,  1050,  1052,  1050,
    1053,  1054,  1055,  1050,  1056,  1050,  1058,  1057,  1059,  1057,
    1060,  1061,  1057,  1062,  1057,  1063,  1063,  1064,  1064,  1064,
    1065,  1066,  1067,  1068,  1068,  1069,  1069,  1070,  1071,  1072,
    1072,  1074,  1073,  1075,  1075,  1075,  1076,  1076,  1076,  1077,
    1078,  1078,  1078,  1079,  1079,  1079,  1079,  1079,  1079,  1079,
    1079,  1080,  1081,  1081,  1081,  1082,  1082,  1082,  1082,  1082,
    1083,  1084,  1084,  1084,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1086,  1087,  1087,  1087,  1088,  1088,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1094,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1104,  1105,  1105,  1106,
    1106,  1108,  1107,  1107,  1107,  1109,  1109,  1110,  1110,  1111,
    1111,  1112,  1113,  1113,  1115,  1114,  1116,  1118,  1117,  1120,
    1119,  1121,  1122,  1121,  1121,  1121,  1123,  1121,  1121,  1124,
    1121,  1125,  1125,  1126,  1126,  1127,  1127,  1128,  1128,  1129,
    1130,  1131,  1132,  1133,  1133,  1134,  1135,  1134,  1136,  1134,
    1137,  1137,  1138,  1139,  1140,  1140,  1141,  1141,  1142,  1142,
    1144,  1143,  1145,  1146,  1147,  1146,  1148,  1146,  1146,  1146,
    1146,  1149,  1149,  1150,  1150,  1151,  1151,  1153,  1154,  1152,
    1155,  1155,  1156,  1156,  1157,  1157,  1158,  1158,  1160,  1159,
    1161,  1162,  1162,  1163,  1163,  1164,  1164,  1164,  1164,  1164,
    1164,  1164,  1164,  1164,  1165,  1166,  1165,  1165,  1167,  1167,
    1168,  1168,  1169,  1169,  1170,  1170,  1171,  1171,  1172,  1172,
    1173,  1173,  1174,  1174,  1175,  1175,  1176,  1176,  1177,  1177,
    1177,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1179,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1180,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1186,  1186,
    1186,  1186,  1186,  1186,  1187,  1187,  1187,  1188,  1188,  1188,
    1188,  1189,  1190,  1191,  1191,  1192,  1192,  1192,  1192,  1192,
    1193,  1193,  1195,  1194,  1196,  1194,  1197,  1194,  1198,  1194,
    1199,  1194,  1200,  1194,  1201,  1194,  1202,  1203,  1204,  1205,
    1205,  1206,  1207,  1207,  1208,  1208,  1209,  1211,  1210,  1213,
    1212,  1214,  1212,  1215,  1215,  1216,  1216,  1217,  1217,  1218,
    1218,  1219,  1219,  1219,  1219,  1220,  1219,  1219,  1219,  1221,
    1221,  1222,  1222,  1222,  1222,  1223,  1223,  1224,  1224,  1225,
    1225,  1225,  1225,  1227,  1226,  1228,  1228,  1229,  1229,  1230,
    1230,  1231,  1231,  1232,  1233,  1233,  1234,  1234,  1234,  1234,
    1234,  1235,  1235,  1235,  1235,  1235,  1236,  1236,  1236,  1236,
    1236,  1236,  1236,  1236,  1236,  1236,  1237,  1237,  1237,  1237,
    1238,  1238,  1238,  1238,  1238,  1238,  1238,  1238,  1239,  1239,
    1239,  1239,  1239,  1239,  1239,  1239,  1240,  1240,  1240,  1240,
    1240,  1241,  1241,  1241,  1241,  1241,  1241,  1241,  1241,  1241,
    1241,  1241,  1241,  1241,  1241,  1241,  1241,  1242,  1242,  1243,
    1243,  1243,  1243,  1243,  1243,  1243,  1243,  1244,  1245,  1245,
    1246,  1246,  1247,  1247,  1247,  1247,  1247,  1248,  1248,  1248,
    1248,  1248,  1249,  1249,  1249,  1250,  1250,  1251,  1251,  1251,
    1252,  1253,  1253,  1253,  1253,  1253,  1253,  1254,  1254,  1254,
    1254,  1255,  1255,  1256,  1256,  1257,  1257,  1258,  1258,  1259,
    1259,  1260,  1260,  1261,  1261,  1261,  1261,  1261,  1261,  1261,
    1262,  1262,  1263,  1263,  1264,  1265,  1266,  1267,  1267,  1267,
    1268,  1268,  1268,  1268,  1268,  1268,  1269,  1269,  1270,  1271,
    1271,  1272,  1272,  1273,  1273,  1274,  1274,  1275,  1275,  1276,
    1276,  1277,  1278,  1278,  1279,  1279,  1280,  1280,  1281,  1281,
    1281,  1282,  1283,  1283,  1284,  1284,  1284,  1284,  1284,  1284,
    1285,  1285,  1287,  1286,  1288,  1288,  1289,  1290,  1290,  1290,
    1290,  1291,  1292,  1293,  1293,  1294,  1295,  1295,  1296,  1296,
    1297,  1297,  1298,  1299,  1299,  1300,  1300,  1301,  1301,  1301,
    1301,  1302,  1302,  1302,  1302,  1302,  1303,  1303,  1303,  1303,
    1303,  1304,  1304,  1305,  1305,  1306,  1306,  1307,  1307,  1307,
    1308,  1308,  1309,  1310,  1311,  1311,  1312,  1312,  1313,  1313,
    1314,  1314,  1315,  1315,  1316,  1316,  1317,  1317,  1318,  1318,
    1318,  1319,  1319,  1320,  1320,  1320,  1320,  1320,  1320,  1321,
    1321,  1322,  1323,  1323,  1324,  1324,  1324,  1325,  1325,  1326,
    1326,  1327,  1327,  1328,  1328,  1330,  1331,  1329,  1332,  1329,
    1329,  1333,  1329,  1334,  1329,  1335,  1329,  1336,  1329,  1337,
    1329,  1329,  1329,  1329,  1329,  1338,  1329,  1329,  1339,  1340,
    1329,  1341,  1341,  1342,  1342,  1342,  1342,  1343,  1343,  1343,
    1343,  1343,  1344,  1344,  1344,  1344,  1345,  1345,  1346,  1346,
    1347,  1347,  1348,  1348,  1348,  1348,  1348,  1348,  1348,  1348,
    1348,  1348,  1349,  1348,  1348,  1350,  1348,  1351,  1348,  1348,
    1348,  1348,  1348,  1352,  1353,  1353,  1355,  1354,  1356,  1356,
    1356,  1358,  1357,  1359,  1360,  1359,  1361,  1361,  1362,  1363,
    1363,  1364,  1365,  1365,  1365,  1365,  1365,  1365,  1365,  1365,
    1365,  1365,  1365,  1365,  1365,  1365,  1365,  1365,  1365,  1365,
    1365,  1365,  1365,  1365,  1365,  1365,  1365,  1365,  1365,  1365,
    1365,  1366,  1366,  1366,  1366,  1366,  1367,  1367,  1368,  1368,
    1369,  1369,  1370,  1370,  1372,  1371,  1373,  1373,  1374,  1374,
    1375,  1375,  1376,  1376,  1376,  1377,  1377,  1377,  1378,  1378,
    1378,  1378,  1380,  1379,  1381,  1379,  1379,  1379,  1382,  1383,
    1383,  1384,  1384,  1385,  1385,  1385,  1387,  1386,  1388,  1388,
    1389,  1389,  1389,  1390,  1390,  1390,  1391,  1391,  1393,  1392,
    1394,  1394,  1394,  1395,  1396,  1395,  1398,  1397,  1399,  1399,
    1400,  1400,  1401,  1401,  1401,  1402,  1402,  1404,  1403,  1405,
    1405,  1406,  1407,  1407,  1408,  1408,  1409,  1410,  1409,  1411,
    1412,  1411,  1413,  1413,  1413,  1414,  1414,  1414,  1415,  1415,
    1416,  1416,  1417,  1418,  1417,  1420,  1419,  1421,  1421,  1422,
    1422,  1423,  1423,  1423,  1423,  1423,  1423,  1424,  1424,  1426,
    1425,  1427,  1427,  1427,  1429,  1428,  1428,  1430,  1430,  1431,
    1431,  1432,  1434,  1433,  1435,  1435,  1436,  1436,  1437,  1438,
    1439,  1439,  1441,  1440,  1442,  1442,  1443,  1443,  1444,  1445,
    1447,  1446,  1449,  1448,  1450,  1450,  1451,  1451,  1453,  1452,
    1454,  1452,  1456,  1455,  1457,  1455,  1458,  1458,  1460,  1459,
    1462,  1463,  1461,  1464,  1465,  1466,  1466,  1467,  1467,  1469,
    1468,  1470,  1468,  1471,  1471,  1472,  1473,  1472,  1472,  1474,
    1474,  1475,  1476,  1477,  1477,  1478,  1478,  1479,  1480,  1480,
    1481,  1481,  1482,  1482,  1482,  1483,  1483,  1483,  1484,  1485,
    1485,  1486,  1486,  1487,  1487,  1487,  1487,  1488,  1488,  1489,
    1489,  1489,  1490,  1490,  1491,  1491,  1492,  1492,  1492,  1493,
    1493,  1493,  1494,  1494,  1495,  1496,  1497,  1498,  1499,  1499,
    1499,  1499,  1499,  1500,  1500,  1500,  1501,  1501,  1501,  1502,
    1502,  1503,  1503,  1503,  1503,  1503,  1504,  1504,  1504,  1504,
    1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1505,  1505,
    1505,  1505,  1505,  1505,  1505,  1505,  1505,  1505,  1505,  1505,
    1505,  1505,  1505,  1505,  1506,  1506,  1506,  1506,  1506,  1506,
    1506,  1506,  1506,  1506,  1506,  1506,  1506,  1506,  1506,  1506,
    1506,  1506,  1506,  1507,  1507,  1508,  1508,  1509,  1509,  1510,
    1510,  1511,  1511,  1511,  1511,  1511,  1511,  1512,  1512,  1513,
    1513,  1514,  1514,  1514,  1515,  1515,  1515,  1515,  1515,  1515,
    1516,  1516,  1516,  1518,  1517,  1517,  1519,  1520,  1520,  1521,
    1521,  1521,  1521,  1522,  1523,  1523,  1523,  1523,  1523,  1523,
    1523,  1523,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,
    1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,
    1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,  1524,
    1524,  1525,  1525,  1525,  1525,  1526,  1526,  1527,  1527,  1527,
    1527,  1527,  1527,  1528,  1528,  1529,  1529,  1530,  1530,  1530,
    1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,
    1530,  1530,  1530,  1530,  1530,  1530,  1530,  1530,  1531,  1531,
    1531,  1531,  1532,  1532,  1532,  1532,  1532,  1532,  1532,  1532,
    1532,  1532,  1532,  1532,  1532,  1532,  1532,  1532,  1532,  1532,
    1532,  1532,  1532,  1532,  1532,  1532,  1532,  1532,  1532,  1532,
    1532,  1533,  1533,  1533,  1533,  1533,  1533,  1533,  1533,  1533,
    1533,  1533,  1533,  1533,  1533,  1533,  1533,  1533,  1533,  1533,
    1533,  1533,  1533,  1533,  1533,  1533,  1533,  1533,  1534,  1534,
    1534,  1534,  1534,  1534,  1534,  1534,  1534,  1536,  1535,  1535,
    1535,  1537,  1537,  1538,  1538,  1539,  1539,  1540,  1540,  1541,
    1541,  1542,  1543,  1543,  1543,  1543,  1543,  1543,  1543,  1544,
    1545,  1543,  1543,  1543,  1543,  1543,  1543,  1543,  1543,  1543,
    1543,  1543,  1546,  1543,  1547,  1547,  1548,  1548,  1548,  1549,
    1549,  1549,  1549,  1549,  1549,  1549,  1549,  1549,  1549,  1549,
    1549,  1549,  1550,  1552,  1551,  1551,  1553,  1553,  1554,  1555,
    1557,  1556,  1558,  1558,  1558,  1558,  1559,  1559,  1560,  1560,
    1561,  1561,  1562,  1562,  1563,  1563,  1564,  1565,  1566,  1566,
    1566,  1568,  1567,  1569,  1570,  1569,  1571,  1569,  1572,  1569,
    1569,  1569,  1569,  1573,  1573,  1573,  1573,  1573,  1573,  1573,
    1573,  1574,  1574,  1574,  1574,  1575,  1575,  1576,  1576,  1577,
    1577,  1578,  1578,  1579,  1579,  1580,  1580,  1581,  1581,  1582,
    1582,  1583,  1584,  1584,  1585,  1585,  1586,  1587,  1586,  1588,
    1586,  1586,  1589,  1586,  1590,  1586,  1586,  1591,  1586,  1592,
    1586,  1586,  1593,  1593,  1593,  1594,  1594,  1595,  1595,  1596,
    1597,  1597,  1597,  1597,  1598,  1598,  1599,  1599,  1600,  1600,
    1601,  1601,  1602,  1602,  1603,  1604,  1605,  1605,  1606,  1606,
    1606,  1606,  1607,  1607,  1609,  1608,  1610,  1608,  1611,  1611,
    1612,  1613,  1612,  1615,  1614,  1616,  1616,  1617,  1617,  1618,
    1618,  1619,  1619,  1620,  1620,  1620,  1620,  1620,  1620,  1620,
    1620,  1620,  1620,  1620,  1620,  1621,  1621,  1621,  1621,  1621,
    1621,  1621,  1621,  1621,  1622,  1622,  1622,  1622,  1623,  1623,
    1623,  1624,  1624,  1625,  1626,  1626,  1627,  1628,  1627,  1629,
    1630,  1629,  1631,  1631,  1632,  1632,  1633,  1633,  1633,  1634,
    1634,  1635,  1635,  1636,  1638,  1637,  1639,  1639,  1640,  1640,
    1641,  1641,  1642,  1642,  1643,  1643,  1644,  1644,  1645,  1645,
    1645,  1646,  1646,  1646,  1647,  1647,  1647,  1647,  1647,  1647,
    1648,  1649,  1649,  1650,  1651,  1651,  1653,  1652,  1654,  1654,
    1655,  1655,  1655,  1656,  1656,  1657,  1657,  1657,  1658,  1659,
    1659,  1659,  1660,  1660,  1660,  1660,  1660,  1660,  1661,  1662,
    1662,  1662,  1662,  1663,  1663,  1663,  1664,  1664,  1665,  1666,
    1667,  1667,  1667,  1668,  1668,  1669,  1669,  1670,  1670,  1671,
    1671,  1671,  1671,  1671,  1671,  1672,  1672,  1672,  1672,  1672,
    1673,  1673,  1673,  1673,  1674,  1674,  1674,  1674,  1674,  1675,
    1675,  1675,  1675,  1675,  1676,  1677,  1677,  1678,  1678,  1679,
    1679,  1679,  1681,  1680,  1682,  1682,  1683,  1683,  1684,  1686,
    1685,  1687,  1687,  1688,  1689,  1689,  1689,  1690,  1692,  1693,
    1691,  1691,  1691,  1695,  1694,  1697,  1696,  1698,  1696,  1696,
    1696,  1696,  1696,  1696,  1696,  1696,  1696,  1699,  1696,  1696,
    1696,  1696,  1696,  1696,  1700,  1696,  1701,  1701,  1702,  1703,
    1704,  1704,  1705,  1706,  1706,  1707,  1707,  1708,  1708,  1710,
    1711,  1709,  1713,  1714,  1712,  1715,  1715,  1715,  1715,  1716,
    1716,  1717,  1717,  1719,  1718,  1720,  1720,  1721,  1720,  1722,
    1723,  1723,  1724,  1724,  1725,  1726,  1726,  1727,  1727,  1728,
    1729,  1729,  1730,  1730,  1731,  1731,  1732,  1732,  1734,  1733,
    1736,  1735,  1737,  1737,  1738,  1738,  1739,  1739,  1740,  1740,
    1741,  1741,  1742,  1742,  1743,  1744,  1745,  1743,  1746,  1746,
    1748,  1749,  1747,  1750,  1750,  1751,  1751,  1752,  1752,  1753,
    1754,  1754,  1756,  1755,  1757,  1757,  1758,  1758,  1759,  1760,
    1761,  1762,  1761,  1763,  1761,  1764,  1764,  1765,  1765,  1766,
    1766,  1767,  1767,  1768,  1768,  1769,  1769,  1769,  1771,  1772,
    1770,  1773,  1773,  1773,  1774,  1774,  1775,  1775,  1776,  1776,
    1777,  1777,  1777,  1777,  1777,  1777,  1777,  1777,  1777,  1778,
    1778,  1780,  1779,  1781,  1781,  1781,  1781,  1781,  1781,  1781,
    1781,  1781,  1781,  1781,  1781,  1781,  1781,  1782,  1781,  1783,
    1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,
    1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,
    1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,
    1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,  1781,
    1781,  1781,  1781,  1781,  1784,  1784,  1784,  1785,  1785,  1786,
    1786,  1787,  1787,  1788,  1788,  1789,  1789,  1790,  1790,  1791,
    1791,  1792,  1792,  1792,  1794,  1793,  1795,  1793,  1796,  1796,
    1796,  1796,  1796,  1796,  1797,  1797,  1798,  1799,  1799,  1799,
    1799,  1800,  1800,  1801,  1801,  1801,  1803,  1802,  1805,  1804,
    1804,  1806,  1806,  1807,  1808,  1807,  1809,  1809,  1810,  1810,
    1810,  1810,  1810,  1810,  1810,  1810,  1810,  1810,  1810,  1810,
    1810,  1810,  1810,  1810,  1810,  1811,  1811,  1812,  1813,  1814,
    1813,  1813,  1815,  1815,  1816,  1816,  1816,  1817,  1818,  1818,
    1820,  1819,  1821,  1821,  1823,  1822,  1824,  1822,  1822,  1825,
    1825,  1826,  1826,  1827,  1828,  1827,  1830,  1829,  1831,  1831,
    1831,  1832,  1832,  1832,  1833,  1833,  1834,  1834,  1836,  1835,
    1837,  1837,  1838,  1840,  1841,  1842,  1843,  1839,  1844,  1844,
    1845,  1845,  1846,  1846,  1846,  1847,  1847,  1847,  1848,  1848,
    1849,  1849,  1850,  1850,  1850,  1850,  1851,  1851,  1852,  1852,
    1853,  1853,  1854,  1854,  1855,  1855,  1856,  1856,  1857,  1857,
    1857,  1858,  1858,  1859,  1859,  1860,  1860,  1861,  1861,  1862,
    1863,  1863,  1863,  1863,  1864,  1864,  1865,  1865,  1865,  1866,
    1866,  1866,  1867,  1867,  1868,  1868,  1868,  1868,  1868,  1868,
    1868,  1868,  1868,  1868,  1869,  1869,  1869,  1869,  1869,  1870,
    1870,  1870,  1872,  1871,  1873,  1873,  1874,  1874,  1876,  1875,
    1877,  1877,  1878,  1878,  1879,  1880,  1880,  1881,  1881,  1882,
    1882,  1883,  1884,  1884,  1884,  1884,  1884,  1885,  1885,  1885,
    1885,  1885,  1886,  1886,  1886,  1886,  1887,  1887,  1887,  1888,
    1888,  1889,  1890,  1890,  1891,  1891,  1891,  1892,  1893,  1894,
    1895,  1896,  1896,  1897,  1897,  1898,  1898,  1898,  1899,  1899,
    1900,  1900,  1901,  1901,  1902,  1902,  1903,  1904,  1904,  1904,
    1905,  1905,  1905,  1906,  1906,  1907,  1908,  1908,  1908,  1908,
    1908,  1908,  1908,  1908,  1908,  1909,  1909,  1909,  1909,  1909,
    1909,  1909,  1909,  1909,  1909,  1910,  1910,  1910,  1910,  1910,
    1910,  1911,  1911,  1911,  1911,  1911,  1911,  1911,  1911,  1911,
    1912,  1912,  1912,  1912,  1912,  1912,  1912,  1913,  1913,  1913,
    1913,  1913,  1913,  1913,  1913,  1913,  1914,  1914,  1914,  1914,
    1914,  1914,  1914,  1915,  1915,  1915,  1915,  1915,  1915,  1915,
    1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,
    1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,
    1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,
    1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,
    1915,  1915,  1915,  1915,  1915,  1915,  1915,  1915,  1916,  1916,
    1916,  1916,  1916,  1916,  1917,  1917,  1917,  1917,  1917,  1917,
    1917,  1917,  1917,  1917,  1918,  1918,  1918,  1919,  1919,  1919,
    1920,  1920,  1920,  1921,  1921,  1921,  1921,  1921,  1921,  1921,
    1921,  1921,  1921,  1921,  1921,  1921,  1921,  1921,  1921,  1921,
    1921,  1921,  1921,  1921,  1921,  1921,  1921,  1921,  1921,  1921,
    1921,  1921,  1921,  1921,  1921,  1921,  1921,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,
    1922,  1922,  1922,  1924,  1923,  1925,  1926,  1923,  1928,  1927,
    1929,  1927,  1930,  1927,  1931,  1931,  1933,  1932,  1934,  1932,
    1935,  1932,  1937,  1936,  1936,  1938,  1938,  1940,  1939,  1941,
    1939,  1943,  1942,  1942,  1944,  1944,  1944,  1945,  1945,  1945,
    1945,  1946,  1946,  1946,  1946,  1947,  1947,  1947,  1948,  1948,
    1948,  1948,  1948,  1948,  1948,  1948,  1948,  1948,  1948,  1948,
    1948,  1948,  1948,  1949,  1949,  1949,  1949,  1950,  1951,  1952,
    1952,  1953,  1953,  1953,  1953,  1954,  1954,  1955,  1955,  1955,
    1956,  1956,  1956,  1956,  1956,  1958,  1957,  1959,  1959,  1959,
    1960,  1960,  1961,  1961,  1962,  1963,  1963,  1963,  1963,  1963,
    1965,  1964,  1967,  1966,  1968,  1968,  1969,  1968,  1970,  1970,
    1971,  1971,  1972,  1972,  1972,  1972,  1973,  1972,  1974,  1974,
    1974,  1974,  1974,  1975,  1976,  1976,  1976,  1976,  1976,  1976,
    1976,  1976,  1977,  1977,  1978,  1979,  1979,  1979,  1979,  1979,
    1979,  1979,  1980,  1980,  1981,  1981,  1982,  1982,  1983,  1984,
    1984,  1985,  1985,  1986,  1986,  1987,  1987,  1988,  1988,  1990,
    1989,  1991,  1989,  1992,  1989,  1993,  1989,  1989,  1989,  1989,
    1989,  1989,  1989,  1989,  1989,  1989,  1989,  1989,  1989,  1989,
    1989,  1989,  1989,  1989,  1989,  1989,  1989,  1989,  1989,  1989,
    1989,  1989,  1989,  1989,  1994,  1994,  1995,  1995,  1996,  1996,
    1996,  1997,  1997,  1997,  1997,  1998,  1998,  1999,  1999,  2000,
    2000,  2001,  2001,  2002,  2002,  2003,  2003,  2003,  2003,  2004,
    2004,  2005,  2006,  2006,  2006,  2007,  2007,  2008,  2008,  2009,
    2010,  2010,  2010,  2010,  2010,  2011,  2011,  2011,  2011,  2011,
    2012,  2012,  2013,  2013,  2014,  2014,  2015,  2015,  2016,  2016,
    2017,  2017,  2019,  2018,  2020,  2021,  2021,  2022,  2022,  2023,
    2023,  2023,  2024,  2024,  2024,  2025,  2026,  2026,  2026,  2027,
    2028,  2029,  2029,  2029,  2030,  2030,  2030,  2031,  2031,  2031,
    2031,  2031,  2031,  2031,  2031,  2031,  2032,  2032,  2033,  2034,
    2035,  2035,  2035,  2036,  2036,  2037,  2037,  2038,  2038,  2039,
    2039,  2041,  2040,  2042,  2042,  2042,  2042,  2043,  2043,  2044,
    2044,  2046,  2047,  2048,  2049,  2050,  2045,  2052,  2051,  2054,
    2053,  2056,  2057,  2055,  2058,  2058,  2059,  2059,  2060,  2060,
    2060,  2060,  2060,  2060,  2061,  2061,  2062,  2062,  2062,  2063,
    2063,  2063,  2064,  2064,  2064,  2065,  2065,  2066,  2067,  2066,
    2068,  2068,  2069,  2069,  2070,  2070,  2071
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     4,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     0,     5,     3,     0,     0,     6,
       0,     0,     3,     1,     3,     0,     3,     0,     6,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     5,     5,
       1,     0,     1,     3,     1,     0,     1,     3,     1,     0,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     1,     0,     0,     8,     0,     8,     0,     0,
      16,     0,     0,    15,     0,     0,    15,     0,     6,     0,
      10,     0,    11,     0,     5,     0,     6,     0,     5,     0,
      11,     0,    14,     0,    11,     0,    14,    10,     8,     6,
       4,     3,     0,     3,     0,    13,     0,     0,     0,    16,
       1,     3,     1,     1,     2,     1,     2,     1,     2,     0,
       0,     8,     0,     6,     4,     4,     1,     0,     5,     0,
       5,     2,     0,     1,     1,     2,     3,     3,     0,     1,
       1,     2,     3,     2,     1,     3,     2,     1,     3,     3,
       3,     1,     1,     1,     1,     3,     0,     1,     0,    12,
       1,     3,     2,     2,     2,     2,     2,     2,     2,     0,
      12,     0,     6,     2,     0,     1,     3,     1,     0,     2,
       0,     2,     0,     1,     4,     0,     2,     0,     3,     0,
       0,     1,     3,     1,     0,     1,     0,     2,     0,     2,
       2,     2,     2,     2,     3,     3,     1,     2,     1,     1,
       2,     0,     1,     0,     2,     1,     2,     3,     3,     0,
       4,     0,     6,     0,     8,     0,     3,     0,     1,     3,
       1,     0,     0,     2,     3,     1,     1,     2,     6,     8,
       4,     6,     3,     0,     1,     3,     1,     3,     7,     9,
       5,     7,     4,     0,     1,     1,     1,     2,     0,     4,
       0,     1,     3,     1,     1,     0,     3,     2,     3,     0,
       2,     0,     1,     0,     3,     1,     2,     3,     2,     3,
       0,     1,     1,     3,     5,     1,     2,     1,     3,     3,
       1,     3,     5,     5,     4,     1,     4,     2,     0,     6,
       0,     6,     0,     3,     0,     0,     3,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     2,     1,     1,     2,     3,     3,     1,     1,
       0,     1,     0,     2,     3,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     4,     0,     1,     1,     3,     1,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     0,     2,     2,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     5,     1,     0,     3,     0,     5,     0,
       7,     0,     2,     1,     1,     0,     3,     1,     0,     2,
       1,     2,     3,     4,     1,     2,     3,     4,     2,     2,
       2,     0,     0,     0,     3,     0,     3,     1,     3,     0,
       3,     3,     3,     4,     5,     2,     4,     2,     1,     3,
       0,     0,     0,     7,     0,     2,     2,     0,     6,     0,
       0,     4,     1,     1,     2,     1,     2,     0,     0,     6,
       0,     0,     6,     0,     2,     0,     1,     1,     0,     6,
       0,     0,     9,     0,     2,     0,     5,     0,     0,     7,
       0,     0,     0,     0,     7,     0,     4,     0,     2,     1,
       2,     0,     5,     0,     1,     0,     3,     5,     3,     5,
       3,     0,     6,     0,     6,     1,     0,     5,     0,     5,
       0,     0,     0,    11,     0,     5,     0,     3,     0,     3,
       0,     0,     8,     0,     3,     1,     1,     1,     1,     1,
       2,     4,     5,     0,     4,     4,     4,     3,     3,     2,
       2,     0,     2,     1,     2,     3,     1,     1,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     0,     1,     1,     1,     1,
       1,     0,     5,     3,     1,     2,     4,     0,     4,     1,
       4,     1,     0,     1,     0,     4,     0,     0,     3,     0,
       6,     6,     0,     4,     2,     2,     0,     3,     2,     0,
       3,     0,     1,     0,     3,     0,     1,     1,     3,     1,
       4,     3,     3,     0,     2,     0,     0,     7,     0,    10,
       1,     3,     1,     1,     0,     2,     0,     3,     1,     3,
       0,     6,     1,     0,     0,     4,     0,     3,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     0,     0,     5,
       1,     3,     1,     1,     0,     3,     1,     3,     0,     4,
       1,     0,     1,     2,     1,     3,     4,     3,     3,     3,
       3,     4,     4,     3,     0,     0,     5,     2,     0,     2,
       0,     1,     0,     1,     1,     2,     1,     1,     0,     3,
       0,     3,     1,     3,     0,     1,     1,     2,     1,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     0,     6,     1,     1,     3,     4,     4,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       0,     1,     2,     4,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     2,
       1,     2,     0,     9,     0,    10,     0,     9,     0,     9,
       0,    10,     0,    11,     0,    10,     2,     7,     7,     0,
       1,     4,     0,     1,     0,     1,     2,     0,     4,     0,
       3,     0,     3,     0,     1,     2,     1,     0,     1,     2,
       1,     0,     1,     2,     3,     0,     6,     5,     5,     0,
       2,     0,     1,     1,     1,     0,     1,     2,     1,     1,
       2,     2,     1,     0,     3,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     2,
       1,     1,     3,     3,     3,     3,     0,     1,     2,     2,
       3,     3,     2,     3,     3,     4,     3,     3,     3,     3,
       2,     3,     3,     3,     2,     2,     3,     1,     2,     2,
       2,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       2,     3,     2,     2,     2,     2,     2,     5,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     2,     1,     2,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     2,     0,     3,     0,     1,     1,
       5,     0,     1,     1,     1,     2,     2,     3,     3,     3,
       3,     0,     1,     0,     1,     0,     1,     0,     1,     0,
       1,     2,     1,     1,     2,     4,     1,     3,     2,     1,
       0,     2,     0,     1,     2,     2,     2,     2,     2,     1,
       1,     3,     3,     3,     3,     2,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     0,     2,     1,     1,     0,     1,     2,     1,
       1,     2,     0,     1,     1,     2,     1,     2,     2,     1,
       0,     1,     0,     4,     1,     1,     1,     0,     1,     2,
       1,     1,     2,     1,     3,     3,     1,     1,     0,     2,
       0,     1,     5,     0,     3,     3,     1,     0,     2,     2,
       2,     0,     3,     3,     6,     6,     1,     1,     2,     2,
       2,     2,     2,     1,     1,     0,     1,     1,     1,     1,
       0,     1,     1,     1,     0,     1,     0,     1,     0,     1,
       1,     2,     1,     2,     1,     2,     0,     2,     0,     2,
       2,     2,     2,     3,     2,     3,     3,     3,     3,     1,
       1,     1,     1,     3,     1,     1,     1,     4,     2,     1,
       4,     0,     1,     1,     3,     0,     0,     8,     0,     5,
       7,     0,     5,     0,     5,     0,    10,     0,     9,     0,
      11,     3,     4,     3,     3,     0,     8,     8,     0,     0,
       7,     1,     1,     0,     1,     1,     3,     0,     2,     3,
       5,     5,     0,     3,     1,     4,     0,     3,     0,     2,
       0,     1,     0,     2,     2,     2,     2,     1,     1,     1,
       4,     4,     0,     6,     4,     0,     5,     0,     6,     4,
       3,     1,     7,     2,     1,     1,     0,     6,     0,     3,
       2,     0,     5,     0,     0,     6,     1,     3,     1,     1,
       3,     3,     3,     2,     2,     4,     4,     2,     7,     6,
       5,     5,     4,     5,     4,     4,     2,     2,     7,     6,
       3,     5,     1,     1,     1,     1,     1,     3,     3,     3,
       5,     0,     1,     1,     2,     2,     3,     3,     3,     3,
       0,     1,     0,     1,     0,     2,     0,     1,     2,     1,
       1,     1,     0,     1,     1,     0,     2,     1,     0,     1,
       1,     1,     0,     6,     0,     5,     4,     4,     3,     0,
       1,     1,     3,     3,     2,     2,     0,     2,     1,     3,
       0,     1,     1,     0,     2,     4,     1,     3,     0,     5,
       0,     1,     1,     3,     0,     4,     0,     4,     0,     1,
       1,     2,     1,     1,     1,     0,     2,     0,     5,     1,
       3,     2,     0,     3,     1,     4,     1,     0,     4,     1,
       0,     4,     0,     1,     3,     0,     1,     3,     1,     1,
       2,     6,     3,     0,     4,     0,     3,     0,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     0,     2,     0,
       6,     0,     1,     1,     0,     4,     4,     3,     5,     1,
       3,     4,     0,     6,     1,     1,     1,     3,     2,     3,
       1,     1,     0,     6,     1,     1,     1,     3,     3,     4,
       0,     6,     0,     2,     0,     4,     0,     2,     0,     3,
       0,     4,     0,     3,     0,     4,     1,     1,     0,     3,
       0,     0,     5,     6,     7,     1,     2,     1,     1,     0,
       3,     0,     3,     3,     3,     1,     0,     4,     3,     1,
       1,     1,     1,     1,     4,     0,     1,     2,     1,     1,
       0,     1,     0,     1,     1,     2,     1,     2,     9,     0,
       1,     0,     2,     3,     1,     4,     4,     2,     1,     1,
       1,     1,     3,     5,     0,     1,     0,     2,     1,     3,
       1,     1,     3,     4,     0,     0,     0,     0,     0,     2,
       2,     1,     1,     0,     2,     3,     0,     2,     3,     0,
       2,     3,     3,     3,     2,     1,     3,     4,     3,     4,
       3,     4,     3,     4,     3,     3,     6,     1,     3,     4,
       5,     7,     6,     8,     5,     6,     4,     3,     5,     4,
       6,     3,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     6,     6,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     2,
       1,     2,     2,     0,     3,     1,     4,     1,     3,     1,
       1,     1,     1,     3,     1,     4,     4,     4,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     4,     4,     7,     6,     3,     4,
       6,     6,     4,     4,     4,     4,     4,     4,     6,     8,
      10,     1,     1,     3,     1,     1,     3,     1,     2,     2,
       2,     2,     2,     1,     3,     4,     6,     4,     6,     2,
       2,     4,     4,     4,    10,     6,     8,     6,     4,     4,
       6,     4,     3,     4,     1,     4,     3,     4,     5,     3,
       5,     3,     6,     8,     2,     2,     8,     8,     6,     8,
       6,     6,     6,     6,     2,     6,     6,     8,     4,     2,
       8,     8,     4,     2,     2,     2,     6,     6,     4,     4,
       8,     4,     4,     4,     4,     3,     8,     6,     8,     4,
       6,     4,     6,     4,     4,     4,     6,     8,     4,     3,
       6,     4,     6,     5,     8,     7,    10,     1,     6,     4,
       4,     4,     4,     4,     6,     4,     6,     0,     5,     6,
       8,     2,     3,     0,     4,     0,     3,     0,     1,     1,
       3,     4,     4,     5,     4,     4,     4,     5,     4,     0,
       0,     7,     4,     5,     4,     5,     4,     4,     4,     4,
       4,     5,     0,     9,     3,     3,     1,     1,     1,     3,
       3,     3,     3,     3,     4,     4,     4,     6,     4,     6,
       4,     6,     5,     0,     7,     4,     4,     4,     4,     1,
       0,     3,     3,     1,     3,     5,     0,     1,     0,     2,
       0,     3,     4,     2,     0,     1,     1,     2,     1,     3,
       3,     0,     3,     2,     0,     4,     0,     4,     0,     4,
       2,     1,     1,     1,     1,     2,     1,     2,     2,     1,
       2,     1,     2,     2,     3,     0,     1,     1,     3,     1,
       3,     1,     3,     4,     5,     1,     3,     3,     3,     1,
       1,     1,     1,     4,     1,     3,     3,     0,     6,     0,
       8,     4,     0,     8,     0,    10,     6,     0,     8,     0,
      10,     6,     1,     2,     1,     1,     2,     0,     1,     5,
       1,     1,     1,     1,     1,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     5,     3,     0,     1,     0,     2,
       3,     3,     1,     1,     0,     7,     0,     7,     1,     2,
       0,     0,     2,     0,     2,     0,     1,     1,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     1,     2,     0,     1,     0,     0,     3,     0,
       0,     3,     0,     4,     4,     2,     0,     1,     1,     0,
       2,     3,     1,     3,     0,     7,     0,     1,     0,     3,
       0,     3,     0,     3,     1,     1,     1,     4,     2,     2,
       2,     1,     2,     2,     0,     3,     2,     2,     3,     3,
       3,     3,     1,     2,     0,     1,     0,     4,     4,     2,
       0,     1,     1,     0,     1,     2,     5,     4,     1,     1,
       3,     3,     1,     3,     1,     1,     1,     1,     1,     0,
       2,     3,     4,     1,     2,     1,     0,     1,     1,     1,
       0,     2,     2,     2,     1,     0,     1,     2,     2,     2,
       1,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       2,     1,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     0,     1,     3,     1,     3,     0,
       2,     3,     1,     1,     2,     1,     3,     2,     0,     0,
       7,     2,     1,     0,     3,     0,     8,     0,     8,     4,
       4,     5,     6,     4,     4,     5,     5,     0,     6,     4,
       4,     5,     6,     4,     0,     6,     1,     3,     1,     2,
       1,     3,     1,     0,     2,     0,     2,     0,     1,     0,
       0,     8,     0,     0,     6,     0,     1,     1,     1,     1,
       1,     2,     1,     0,     2,     1,     2,     0,     3,     3,
       0,     1,     3,     1,     1,     3,     1,     3,     1,     3,
       1,     1,     0,     1,     1,     1,     1,     1,     0,     4,
       0,     4,     0,     1,     0,     1,     3,     1,     5,     3,
       1,     1,     1,     1,     0,     0,     0,     7,     5,     1,
       0,     0,    11,     3,     1,     3,     3,     3,     1,     3,
       0,     1,     0,     3,     0,     3,     2,     3,     3,     2,
       5,     0,     5,     0,     6,     0,     2,     1,     3,     2,
       4,     0,     2,     0,     2,     1,     1,     1,     0,     0,
       7,     0,     2,     2,     0,     1,     0,     1,     1,     3,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     0,
       3,     0,     3,     2,     4,     4,     3,     4,     4,     1,
       3,     3,     3,     3,     6,     2,     2,     0,     6,     0,
       7,     5,     2,     1,     1,     1,     5,     5,     2,     2,
       1,     4,     3,     2,     3,     2,     2,     1,     4,     4,
       3,     3,     3,     2,     3,     2,     3,     3,     3,     3,
       4,     3,     2,     3,     3,     3,     3,     4,     3,     3,
       4,     3,     3,     3,     1,     1,     1,     1,     1,     0,
       1,     0,     2,     0,     1,     1,     1,     0,     2,     0,
       2,     0,     3,     3,     0,     4,     0,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     2,     1,
       1,     0,     3,     0,     1,     1,     0,     4,     0,     4,
       1,     0,     1,     4,     0,     3,     3,     1,     2,     2,
       2,     2,     3,     3,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     2,     0,     1,     2,     2,     0,
       3,     1,     0,     5,     0,     1,     3,     1,     0,     3,
       0,     3,     3,     1,     0,     4,     0,     3,     2,     0,
       1,     0,     2,     5,     0,     6,     0,     4,     0,     1,
       1,     2,     2,     3,     0,     1,     1,     2,     0,     3,
       0,     4,     2,     0,     0,     0,     0,    22,     1,     1,
       0,     1,     0,     1,     1,     0,     1,     1,     0,     2,
       2,     1,     3,     4,     3,     3,     0,     2,     2,     1,
       3,     3,     0,     4,     0,     3,     1,     1,     0,     3,
       2,     3,     1,     1,     2,     0,     2,     3,     1,     5,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     2,
       2,     2,     0,     4,     0,     1,     1,     3,     0,     7,
       0,     3,     1,     3,     1,     1,     1,     3,     5,     3,
       5,     1,     1,     3,     4,     5,     4,     1,     3,     4,
       4,     5,     1,     5,     3,     2,     1,     3,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     3,     1,     1,     1,
       1,     3,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     3,     0,     0,     7,     0,     4,
       0,     6,     0,     7,     1,     3,     0,     3,     0,     3,
       0,     3,     0,     3,     2,     0,     2,     0,     2,     0,
       4,     0,     3,     1,     1,     1,     1,     0,     1,     1,
       1,     0,     2,     2,     2,     3,     5,     5,     3,     5,
       5,     4,     6,     8,     8,     2,     3,     3,     3,     5,
       2,     3,     3,     1,     1,     3,     3,     1,     3,     2,
       2,     2,     2,     2,     1,     1,     3,     1,     4,     4,
       1,     1,     1,     1,     1,     0,     5,     0,     2,     1,
       1,     1,     1,     3,     3,     1,     1,     2,     2,     2,
       0,     3,     0,     3,     3,     2,     0,     6,     1,     2,
       1,     1,     1,     1,     1,     1,     0,     5,     1,     1,
       1,     1,     1,     3,     6,     6,     6,     6,     7,     7,
       5,     3,     4,     1,     3,     8,     8,     8,     8,     9,
       6,     4,     0,     3,     0,     3,     1,     3,     2,     1,
       1,     0,     1,     1,     2,     0,     1,     1,     3,     0,
       3,     0,     3,     0,     3,     0,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     2,     2,     0,     1,     3,     1,     2,     2,
       2,     1,     3,     3,     1,     1,     3,     1,     3,     1,
       3,     1,     1,     1,     1,     4,     5,     4,     1,     3,
       1,     2,     0,     2,     5,     0,     3,     3,     1,     1,
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     0,     2,     0,     2,     0,     3,     2,     1,
       2,     1,     0,     3,     1,     0,     1,     0,     1,     0,
       3,     2,     0,     1,     2,     4,     4,     5,     4,     2,
       3,     2,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     3,
       3,     3,     3,     0,     1,     3,     3,     0,     3,     1,
       3,     0,     3,     0,     3,     4,     4,     1,     1,     0,
       2,     0,     0,     0,     0,     0,    20,     0,     2,     0,
       5,     0,     0,     8,     0,     1,     1,     1,     4,     4,
       3,     4,     3,     3,     0,     3,     1,     3,     5,     1,
       1,     1,     0,     1,     1,     0,     2,     0,     0,     3,
       0,     2,     6,     3,     4,     4,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (thd, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, thd); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (thd);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, THD *thd)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, thd);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, THD *thd)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], thd);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, thd); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, THD *thd)
{
  YY_USE (yyvaluep);
  YY_USE (thd);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (THD *thd)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, thd);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* query: END_OF_INPUT  */
#line 1759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!thd->bootstrap &&
              (!(thd->lex->lex_options & OPTION_LEX_FOUND_COMMENT)))
              my_yyabort_error((ER_EMPTY_QUERY, MYF(0)));

            thd->lex->sql_command= SQLCOM_EMPTY_QUERY;
            YYLIP->found_semicolon= NULL;
          }
#line 26219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3: /* $@1: %empty  */
#line 1768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_input_stream *lip = YYLIP;

            if ((thd->client_capabilities & CLIENT_MULTI_QUERIES) &&
                lip->multi_statements &&
                ! lip->eof())
            {
              /*
                We found a well formed query, and multi queries are allowed:
                - force the parser to stop after the ';'
                - mark the start of the next query for the next invocation
                  of the parser.
              */
              lip->next_state= MY_LEX_END;
              lip->found_semicolon= lip->get_ptr();
            }
            else
            {
              /* Single query, terminated. */
              lip->found_semicolon= NULL;
            }
          }
#line 26246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 5: /* query: verb_clause END_OF_INPUT  */
#line 1793 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Single query, not terminated. */
            YYLIP->found_semicolon= NULL;
          }
#line 26255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 71: /* deallocate: deallocate_or_drop PREPARE_SYM ident  */
#line 1876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_deallocate_prepare((yyvsp[0].ident_sys));
          }
#line 26263 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 74: /* $@2: %empty  */
#line 1888 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "PREPARE..FROM"; }
#line 26269 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 75: /* prepare: PREPARE_SYM ident FROM $@2 expr  */
#line 1890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_prepare((yyvsp[-3].ident_sys), (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 26279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 76: /* execute: EXECUTE_SYM ident execute_using  */
#line 1899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_execute((yyvsp[-1].ident_sys), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 26288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 77: /* $@3: %empty  */
#line 1904 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE IMMEDIATE"; }
#line 26294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 78: /* $@4: %empty  */
#line 1906 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= NULL; }
#line 26300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 79: /* execute: EXECUTE_SYM IMMEDIATE_SYM $@3 expr $@4 execute_using  */
#line 1908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_execute_immediate((yyvsp[-2].item), (yyvsp[0].item_list)))
              MYSQL_YYABORT;
          }
#line 26309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 80: /* execute_using: %empty  */
#line 1915 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.item_list)= NULL; }
#line 26315 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 81: /* $@5: %empty  */
#line 1917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "EXECUTE..USING"; }
#line 26321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 82: /* execute_using: USING $@5 execute_params  */
#line 1919 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= (yyvsp[0].item_list);
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 26330 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 83: /* execute_params: expr_or_ignore_or_default  */
#line 1927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 26339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 84: /* execute_params: execute_params ',' expr_or_ignore_or_default  */
#line 1932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (((yyval.item_list)= (yyvsp[-2].item_list))->push_back((yyvsp[0].item), thd->mem_root))
              MYSQL_YYABORT;
          }
#line 26348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 85: /* $@6: %empty  */
#line 1943 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HELP"));
          }
#line 26357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 86: /* help: HELP_SYM $@6 ident_or_text  */
#line 1948 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_HELP;
            lex->help_arg= (yyvsp[0].lex_str).str;
          }
#line 26367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 87: /* $@7: %empty  */
#line 1959 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_CHANGE_MASTER;
          }
#line 26375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 88: /* change: CHANGE MASTER_SYM optional_connection_name TO_SYM $@7 master_defs  */
#line 1963 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 26381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 91: /* master_def: MASTER_HOST_SYM '=' TEXT_STRING_sys  */
#line 1973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.host = (yyvsp[0].lex_str).str;
          }
#line 26389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 92: /* master_def: MASTER_USER_SYM '=' TEXT_STRING_sys  */
#line 1977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.user = (yyvsp[0].lex_str).str;
          }
#line 26397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 93: /* master_def: MASTER_PASSWORD_SYM '=' TEXT_STRING_sys  */
#line 1981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.password = (yyvsp[0].lex_str).str;
          }
#line 26405 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 94: /* master_def: MASTER_PORT_SYM '=' ulong_num  */
#line 1985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.port = (yyvsp[0].ulong_num);
          }
#line 26413 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 95: /* master_def: MASTER_CONNECT_RETRY_SYM '=' ulong_num  */
#line 1989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.connect_retry = (yyvsp[0].ulong_num);
          }
#line 26421 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 96: /* master_def: MASTER_DELAY_SYM '=' ulong_num  */
#line 1993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].ulong_num) > MASTER_DELAY_MAX)
            {
              my_error(ER_MASTER_DELAY_VALUE_OUT_OF_RANGE, MYF(0),
                       (ulong) (yyvsp[0].ulong_num), (ulong) MASTER_DELAY_MAX);
            }
            else
              Lex->mi.sql_delay = (yyvsp[0].ulong_num);
          }
#line 26435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 97: /* master_def: MASTER_SSL_SYM '=' ulong_num  */
#line 2003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl= (yyvsp[0].ulong_num) ? 
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 26444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 98: /* master_def: MASTER_SSL_CA_SYM '=' TEXT_STRING_sys  */
#line 2008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_ca= (yyvsp[0].lex_str).str;
          }
#line 26452 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 99: /* master_def: MASTER_SSL_CAPATH_SYM '=' TEXT_STRING_sys  */
#line 2012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_capath= (yyvsp[0].lex_str).str;
          }
#line 26460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 100: /* master_def: MASTER_SSL_CERT_SYM '=' TEXT_STRING_sys  */
#line 2016 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_cert= (yyvsp[0].lex_str).str;
          }
#line 26468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 101: /* master_def: MASTER_SSL_CIPHER_SYM '=' TEXT_STRING_sys  */
#line 2020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_cipher= (yyvsp[0].lex_str).str;
          }
#line 26476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 102: /* master_def: MASTER_SSL_KEY_SYM '=' TEXT_STRING_sys  */
#line 2024 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_key= (yyvsp[0].lex_str).str;
          }
#line 26484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 103: /* master_def: MASTER_SSL_VERIFY_SERVER_CERT_SYM '=' ulong_num  */
#line 2028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_verify_server_cert= (yyvsp[0].ulong_num) ?
              LEX_MASTER_INFO::LEX_MI_ENABLE : LEX_MASTER_INFO::LEX_MI_DISABLE;
          }
#line 26493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 104: /* master_def: MASTER_SSL_CRL_SYM '=' TEXT_STRING_sys  */
#line 2033 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_crl= (yyvsp[0].lex_str).str;
          }
#line 26501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 105: /* master_def: MASTER_SSL_CRLPATH_SYM '=' TEXT_STRING_sys  */
#line 2037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.ssl_crlpath= (yyvsp[0].lex_str).str;
          }
#line 26509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 106: /* master_def: MASTER_HEARTBEAT_PERIOD_SYM '=' NUM_literal  */
#line 2042 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.heartbeat_period= (float) (yyvsp[0].item_num)->val_real();
            if (unlikely(Lex->mi.heartbeat_period >
                         SLAVE_MAX_HEARTBEAT_PERIOD) ||
                unlikely(Lex->mi.heartbeat_period < 0.0))
               my_yyabort_error((ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE, MYF(0),
                                 SLAVE_MAX_HEARTBEAT_PERIOD));

            if (unlikely(Lex->mi.heartbeat_period > slave_net_timeout))
            {
              push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                  ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX,
                                  ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MAX));
            }
            if (unlikely(Lex->mi.heartbeat_period < 0.001))
            {
              if (unlikely(Lex->mi.heartbeat_period != 0.0))
              {
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                    ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN,
                                    ER_THD(thd, ER_SLAVE_HEARTBEAT_VALUE_OUT_OF_RANGE_MIN));
                Lex->mi.heartbeat_period= 0.0;
              }
              Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_DISABLE;
            }
            Lex->mi.heartbeat_opt=  LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26541 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 107: /* master_def: IGNORE_SERVER_IDS_SYM '=' '(' ignore_server_id_list ')'  */
#line 2070 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_ignore_server_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
           }
#line 26549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 108: /* master_def: DO_DOMAIN_IDS_SYM '=' '(' do_domain_id_list ')'  */
#line 2074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_do_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 109: /* master_def: IGNORE_DOMAIN_IDS_SYM '=' '(' ignore_domain_id_list ')'  */
#line 2078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.repl_ignore_domain_ids_opt= LEX_MASTER_INFO::LEX_MI_ENABLE;
          }
#line 26565 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 114: /* ignore_server_id: ulong_num  */
#line 2093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_server_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 118: /* do_domain_id: ulong_num  */
#line 2106 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_do_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 122: /* ignore_domain_id: ulong_num  */
#line 2119 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            insert_dynamic(&Lex->mi.repl_ignore_domain_ids, (uchar*) &((yyvsp[0].ulong_num)));
          }
#line 26589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 123: /* master_file_def: MASTER_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.log_file_name = (yyvsp[0].lex_str).str;
          }
#line 26597 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 124: /* master_file_def: MASTER_LOG_POS_SYM '=' ulonglong_num  */
#line 2130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* 
               If the user specified a value < BIN_LOG_HEADER_SIZE, adjust it
               instead of causing subsequent errors. 
               We need to do it in this file, because only there we know that 
               MASTER_LOG_POS has been explicitly specified. On the contrary
               in change_master() (sql_repl.cc) we cannot distinguish between 0
               (MASTER_LOG_POS explicitly specified as 0) and 0 (unspecified),
               whereas we want to distinguish (specified 0 means "read the binlog
               from 0" (4 in fact), unspecified means "don't change the position
               (keep the preceding value)").
            */
            Lex->mi.pos= MY_MAX(BIN_LOG_HEADER_SIZE, (yyvsp[0].ulonglong_number));
          }
#line 26616 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 125: /* master_file_def: RELAY_LOG_FILE_SYM '=' TEXT_STRING_sys  */
#line 2145 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.relay_log_name = (yyvsp[0].lex_str).str;
          }
#line 26624 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 126: /* master_file_def: RELAY_LOG_POS_SYM '=' ulong_num  */
#line 2149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.relay_log_pos = (yyvsp[0].ulong_num);
            /* Adjust if < BIN_LOG_HEADER_SIZE (same comment as Lex->mi.pos) */
            Lex->mi.relay_log_pos= MY_MAX(BIN_LOG_HEADER_SIZE, Lex->mi.relay_log_pos);
          }
#line 26634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 127: /* master_file_def: MASTER_USE_GTID_SYM '=' CURRENT_POS_SYM  */
#line 2155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_CURRENT_POS;
          }
#line 26644 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 128: /* master_file_def: MASTER_USE_GTID_SYM '=' SLAVE_POS_SYM  */
#line 2161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_SLAVE_POS;
          }
#line 26654 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 129: /* master_file_def: MASTER_USE_GTID_SYM '=' NO_SYM  */
#line 2167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->mi.use_gtid_opt != LEX_MASTER_INFO::LEX_GTID_UNCHANGED))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MASTER_use_gtid"));
            Lex->mi.use_gtid_opt= LEX_MASTER_INFO::LEX_GTID_NO;
          }
#line 26664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 130: /* optional_connection_name: %empty  */
#line 2176 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
          }
#line 26673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 132: /* connection_name: TEXT_STRING_sys  */
#line 2185 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
           Lex->mi.connection_name= (yyvsp[0].lex_str);
#ifdef HAVE_REPLICATION
           if (unlikely(check_master_connection_name(&(yyvsp[0].lex_str))))
              my_yyabort_error((ER_WRONG_ARGUMENTS, MYF(0), "MASTER_CONNECTION_NAME"));
#endif
         }
#line 26685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 133: /* $@8: %empty  */
#line 2198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_table()))
              MYSQL_YYABORT;
            lex->create_info.init();
            if (lex->main_select_push())
              MYSQL_YYABORT;
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
            if (lex->set_command_with_check(SQLCOM_CREATE_TABLE, (yyvsp[-2].num), (yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
               MYSQL_YYABORT;
          }
#line 26701 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 134: /* $@9: %empty  */
#line 2210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            if (!lex->first_select_lex()->
                add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                  TL_WRITE, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            lex->alter_info.reset();
            /*
              For CREATE TABLE we should not open the table even if it exists.
              If the table exists, we should either not create it or replace it
            */
            lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
            lex->create_info.default_table_charset= NULL;
            lex->name= null_clex_str;
            lex->create_last_non_select_table= lex->last_table();
          }
#line 26722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 135: /* create: create_or_replace opt_temporary TABLE_SYM opt_if_not_exists $@8 table_ident $@9 create_body  */
#line 2227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 26732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 136: /* $@10: %empty  */
#line 2233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           LEX *lex= thd->lex;
           if (lex->main_select_push())
             MYSQL_YYABORT;
           if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_create_sequence()))
              MYSQL_YYABORT;
           lex->create_info.init();
           if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_SEQUENCE, (yyvsp[-3].num),
                        (yyvsp[-4].object_ddl_options) | (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;

           if (!lex->first_select_lex()->
               add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_UPDATING,
                                 TL_WRITE, MDL_EXCLUSIVE))
             MYSQL_YYABORT;

               /*
                 For CREATE TABLE, an non-existing table is not an error.
                 Instruct open_tables() to just take an MDL lock if the
                 table does not exist.
               */
             lex->alter_info.reset();
             lex->query_tables->open_strategy= TABLE_LIST::OPEN_STUB;
             lex->name= null_clex_str;
             lex->create_last_non_select_table= lex->last_table();
             if (unlikely(!(lex->create_info.seq_create_info=
                            new (thd->mem_root) sequence_definition())))
               MYSQL_YYABORT;
         }
#line 26766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 137: /* create: create_or_replace opt_temporary SEQUENCE_SYM opt_if_not_exists table_ident $@10 opt_sequence opt_create_table_options  */
#line 2263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
            LEX *lex= thd->lex;

            if (unlikely(lex->create_info.seq_create_info->check_and_adjust(1)))
            {
              my_error(ER_SEQUENCE_INVALID_DATA, MYF(0),
                       lex->first_select_lex()->table_list.first->db.str,
                       lex->first_select_lex()->table_list.first->
                         table_name.str);
              MYSQL_YYABORT;
            }

            /* No fields specified, generate them */
            if (unlikely(prepare_sequence_fields(thd,
                         &lex->alter_info.create_list)))
               MYSQL_YYABORT;

            /* CREATE SEQUENCE always creates a sequence */
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= 1;

            create_table_set_open_action_and_adjust_tables(lex);
            Lex->pop_select(); //main select
          }
#line 26795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 138: /* $@11: %empty  */
#line 2288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 139: /* $@12: %empty  */
#line 2295 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-7].key_type), &(yyvsp[-3].ident_sys), (yyvsp[-2].key_alg), (yyvsp[-8].object_ddl_options) | (yyvsp[-5].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 140: /* create: create_or_replace opt_unique INDEX_SYM opt_if_not_exists $@11 ident opt_key_algorithm_clause ON table_ident $@12 '(' key_list ')' opt_lock_wait_timeout normal_key_options opt_index_lock_algorithm  */
#line 2303 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26823 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 141: /* $@13: %empty  */
#line 2307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26832 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 142: /* $@14: %empty  */
#line 2313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 143: /* create: create_or_replace fulltext INDEX_SYM $@13 opt_if_not_exists ident ON table_ident $@14 '(' key_list ')' opt_lock_wait_timeout fulltext_key_options opt_index_lock_algorithm  */
#line 2321 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26851 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 144: /* $@15: %empty  */
#line 2325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 26860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 145: /* $@16: %empty  */
#line 2331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_create_index_prepare((yyvsp[0].table)))
              MYSQL_YYABORT;
            if (Lex->add_create_index((yyvsp[-6].key_type), &(yyvsp[-2].ident_sys), HA_KEY_ALG_UNDEF, (yyvsp[-7].object_ddl_options) | (yyvsp[-3].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26871 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 146: /* create: create_or_replace spatial INDEX_SYM $@15 opt_if_not_exists ident ON table_ident $@16 '(' key_list ')' opt_lock_wait_timeout spatial_key_options opt_index_lock_algorithm  */
#line 2339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 147: /* $@17: %empty  */
#line 2343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
          }
#line 26888 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 148: /* create: create_or_replace DATABASE opt_if_not_exists ident $@17 opt_create_database_options  */
#line 2348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->set_command_with_check(SQLCOM_CREATE_DB, 0,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
               MYSQL_YYABORT;
            lex->name= (yyvsp[-2].ident_sys);
          }
#line 26900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 149: /* $@18: %empty  */
#line 2357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
            if (Lex->add_create_view(thd, (yyvsp[-5].object_ddl_options) | (yyvsp[-1].object_ddl_options),
                                     DTYPE_ALGORITHM_UNDEFINED, (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 26913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 150: /* create: create_or_replace definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@18 view_list_opt AS view_select  */
#line 2366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26921 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 151: /* $@19: %empty  */
#line 2371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_create_view(thd, (yyvsp[-6].object_ddl_options) | (yyvsp[-1].object_ddl_options), (yyvsp[-5].num), (yyvsp[-3].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
            Lex->inc_select_stack_outer_barrier();
          }
#line 26933 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 152: /* create: create_or_replace view_algorithm definer_opt opt_view_suid VIEW_SYM opt_if_not_exists table_ident $@19 view_list_opt AS view_select  */
#line 2379 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 153: /* $@20: %empty  */
#line 2383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 26951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 154: /* create: create_or_replace definer_opt TRIGGER_SYM $@20 trigger_tail  */
#line 2389 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 155: /* $@21: %empty  */
#line 2393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_procedure_start((yyvsp[-3].object_ddl_options) | (yyvsp[0].object_ddl_options)))
              MYSQL_YYABORT;
          }
#line 26968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 156: /* create: create_or_replace definer_opt PROCEDURE_SYM opt_if_not_exists $@21 sp_tail_standalone  */
#line 2398 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_create_routine_finalize();
          }
#line 26976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 157: /* $@22: %empty  */
#line 2402 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->create_info.set((yyvsp[-2].object_ddl_options));
          }
#line 26986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 158: /* create: create_or_replace definer_opt EVENT_SYM $@22 event_tail  */
#line 2408 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 26994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 159: /* $@23: %empty  */
#line 2413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 27003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 160: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name RETURN_ORACLE_SYM $@23 sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2420 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 27012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 161: /* $@24: %empty  */
#line 2426 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 27021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 162: /* create: create_or_replace definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@24 sp_fdparam_list ')' RETURN_ORACLE_SYM sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 27030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 163: /* $@25: %empty  */
#line 2440 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 27039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 164: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name RETURN_ORACLE_SYM $@25 sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 27048 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 165: /* $@26: %empty  */
#line 2453 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_start((yyvsp[-6].object_ddl_options) | (yyvsp[-2].object_ddl_options), (yyvsp[-4].sp_aggregate_type), (yyvsp[-1].spname)))
              MYSQL_YYABORT;
          }
#line 27057 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 166: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists sp_name '(' $@26 sp_fdparam_list ')' RETURN_ORACLE_SYM sf_return_type sf_c_chistics_and_body_standalone opt_sp_name  */
#line 2461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_stored_function_finalize_standalone((yyvsp[0].spname)))
              MYSQL_YYABORT;
          }
#line 27066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 167: /* create: create_or_replace no_definer opt_aggregate FUNCTION_SYM opt_if_not_exists ident RETURNS_SYM udf_type SONAME_SYM TEXT_STRING_sys  */
#line 2467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_create_udf_function((yyvsp[-9].object_ddl_options) | (yyvsp[-5].object_ddl_options), (yyvsp[-7].sp_aggregate_type), (yyvsp[-4].ident_sys),
                                              (Item_result) (yyvsp[-2].num), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 27076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 168: /* create: create_or_replace USER_SYM opt_if_not_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 2474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_USER,
                                                     (yyvsp[-7].object_ddl_options) | (yyvsp[-5].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 27086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 169: /* create: create_or_replace ROLE_SYM opt_if_not_exists clear_privileges role_list opt_with_admin  */
#line 2481 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_command_with_check(SQLCOM_CREATE_ROLE,
                         (yyvsp[-5].object_ddl_options) | (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 27096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 170: /* create: CREATE LOGFILE_SYM GROUP_SYM logfile_group_info  */
#line 2487 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_LOGFILE_GROUP;
          }
#line 27104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 171: /* create: CREATE TABLESPACE tablespace_info  */
#line 2491 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_tablespace_info->ts_cmd_type= CREATE_TABLESPACE;
          }
#line 27112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 172: /* $@27: %empty  */
#line 2494 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->set_command(SQLCOM_CREATE_SERVER, (yyvsp[0].object_ddl_options)); }
#line 27118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 173: /* create: create_or_replace $@27 server_def  */
#line 2496 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 27124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 174: /* $@28: %empty  */
#line 2501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg;
            if (unlikely(!(pkg= Lex->
                           create_package_start(thd,
                                                SQLCOM_CREATE_PACKAGE,
                                                &sp_handler_package_spec,
                                                (yyvsp[-3].spname), (yyvsp[-7].object_ddl_options) | (yyvsp[-4].object_ddl_options)))))
              MYSQL_YYABORT;
            pkg->set_c_chistics(Lex->sp_chistics);
          }
#line 27139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 175: /* create: create_or_replace definer_opt PACKAGE_ORACLE_SYM opt_if_not_exists sp_name opt_create_package_chistics_init sp_tail_is remember_name $@28 opt_package_specification_element_list END remember_end_opt opt_sp_name  */
#line 2513 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_package_finalize(thd, (yyvsp[-8].spname), (yyvsp[0].spname), (yyvsp[-5].simple_string), (yyvsp[-1].simple_string))))
              MYSQL_YYABORT;
          }
#line 27148 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 176: /* $@29: %empty  */
#line 2521 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg;
            if (unlikely(!(pkg= Lex->
                           create_package_start(thd,
                                                SQLCOM_CREATE_PACKAGE_BODY,
                                                &sp_handler_package_body,
                                                (yyvsp[-3].spname), (yyvsp[-8].object_ddl_options) | (yyvsp[-4].object_ddl_options)))))
              MYSQL_YYABORT;
            pkg->set_c_chistics(Lex->sp_chistics);
            Lex->sp_block_init(thd);
          }
#line 27164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 177: /* $@30: %empty  */
#line 2533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 27173 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 178: /* $@31: %empty  */
#line 2538 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].spblock).hndlrs+= (yyvsp[0].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-2].spblock))))
              MYSQL_YYABORT;
          }
#line 27183 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 179: /* create: create_or_replace definer_opt PACKAGE_ORACLE_SYM BODY_ORACLE_SYM opt_if_not_exists sp_name opt_create_package_chistics_init sp_tail_is remember_name $@29 package_implementation_declare_section $@30 package_implementation_executable_section $@31 remember_end_opt opt_sp_name  */
#line 2544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_package_finalize(thd, (yyvsp[-10].spname), (yyvsp[0].spname), (yyvsp[-7].simple_string), (yyvsp[-1].simple_string))))
              MYSQL_YYABORT;
          }
#line 27192 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 180: /* package_implementation_executable_section: END  */
#line 2552 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_add_empty(thd)))
              MYSQL_YYABORT;
            (yyval.spblock_handlers).init(0);
          }
#line 27202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 181: /* package_implementation_executable_section: BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END  */
#line 2557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                  { (yyval.spblock_handlers)= (yyvsp[-1].spblock_handlers); }
#line 27208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 184: /* package_implementation_declare_section: package_implementation_declare_section_list1 package_implementation_declare_section_list2  */
#line 2569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 27214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 186: /* package_implementation_declare_section_list1: package_implementation_declare_section_list1 package_implementation_item_declaration  */
#line 2576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 27220 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 188: /* package_implementation_declare_section_list2: package_implementation_declare_section_list2 package_implementation_routine_definition  */
#line 2583 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spblock).join((yyvsp[-1].spblock), (yyvsp[0].spblock)); }
#line 27226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 189: /* package_routine_lex: %empty  */
#line 2587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex)= new (thd->mem_root)
                           sp_lex_local(thd, thd->lex))))
              MYSQL_YYABORT;
            thd->m_parser_state->m_yacc.reset_before_substatement();
          }
#line 27237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 190: /* $@32: %empty  */
#line 2598 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].lex)->sphead->get_package());
            (yyvsp[-1].lex)->sql_command= SQLCOM_CREATE_FUNCTION;
            sp_name *spname= (yyvsp[-2].lex)->make_sp_name_package_routine(thd, &(yyvsp[0].ident_sys));
            if (unlikely(!spname))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-1].lex);
            if (unlikely(!(yyvsp[-1].lex)->make_sp_head_no_recursive(thd, spname,
                                                        &sp_handler_package_function,
                                                        NOT_AGGREGATE)))
              MYSQL_YYABORT;
            (yyvsp[-2].lex)->sphead->get_package()->m_current_routine= (yyvsp[-1].lex);
            (void) is_native_function_with_warn(thd, &(yyvsp[0].ident_sys));
          }
#line 27256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 191: /* package_specification_function: remember_lex package_routine_lex ident $@32 opt_sp_parenthesized_fdparam_list RETURN_ORACLE_SYM sf_return_type sp_c_chistics  */
#line 2615 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= thd->lex->sphead;
            sp->restore_thd_mem_root(thd);
            thd->lex= (yyvsp[-7].lex);
            (yyval.lex)= (yyvsp[-6].lex);
          }
#line 27267 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 192: /* $@33: %empty  */
#line 2625 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].lex)->sphead->get_package());
            (yyvsp[-1].lex)->sql_command= SQLCOM_CREATE_PROCEDURE;
            sp_name *spname= (yyvsp[-2].lex)->make_sp_name_package_routine(thd, &(yyvsp[0].ident_sys));
            if (unlikely(!spname))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-1].lex);
            if (unlikely(!(yyvsp[-1].lex)->make_sp_head_no_recursive(thd, spname,
                                                        &sp_handler_package_procedure,
                                                        DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
            (yyvsp[-2].lex)->sphead->get_package()->m_current_routine= (yyvsp[-1].lex);
          }
#line 27285 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 193: /* package_specification_procedure: remember_lex package_routine_lex ident $@33 opt_sp_parenthesized_pdparam_list sp_c_chistics  */
#line 2640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= thd->lex->sphead;
            sp->restore_thd_mem_root(thd);
            thd->lex= (yyvsp[-5].lex);
            (yyval.lex)= (yyvsp[-4].lex);

          }
#line 27297 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 194: /* package_implementation_routine_definition: FUNCTION_SYM package_specification_function package_implementation_function_body ';'  */
#line 2653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_implementation((yyvsp[-2].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
            (yyval.spblock).init();
          }
#line 27309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 195: /* package_implementation_routine_definition: PROCEDURE_SYM package_specification_procedure package_implementation_procedure_body ';'  */
#line 2662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_implementation((yyvsp[-2].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
            (yyval.spblock).init();
          }
#line 27321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 196: /* package_implementation_routine_definition: package_specification_element  */
#line 2669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        { (yyval.spblock).init(); }
#line 27327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 197: /* $@34: %empty  */
#line 2675 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            sp_head *sp= pkg->m_current_routine->sphead;
            thd->lex= pkg->m_current_routine;
            sp->reset_thd_mem_root(thd);
            sp->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 27339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 198: /* package_implementation_function_body: sp_tail_is remember_lex $@34 sp_body opt_package_routine_end_name  */
#line 2683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->lex->sp_body_finalize_function(thd) ||
                         thd->lex->sphead->check_package_routine_end_name((yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-3].lex);
          }
#line 27350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 199: /* $@35: %empty  */
#line 2693 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            sp_head *sp= pkg->m_current_routine->sphead;
            thd->lex= pkg->m_current_routine;
            sp->reset_thd_mem_root(thd);
            sp->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 27362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 200: /* package_implementation_procedure_body: sp_tail_is remember_lex $@35 sp_body opt_package_routine_end_name  */
#line 2701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->lex->sp_body_finalize_procedure(thd) ||
                         thd->lex->sphead->check_package_routine_end_name((yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            thd->lex= (yyvsp[-3].lex);
          }
#line 27373 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 206: /* package_specification_element: FUNCTION_SYM package_specification_function ';'  */
#line 2726 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_declaration((yyvsp[-1].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
          }
#line 27384 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 207: /* package_specification_element: PROCEDURE_SYM package_specification_procedure ';'  */
#line 2733 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_package *pkg= Lex->get_sp_package();
            if (unlikely(pkg->add_routine_declaration((yyvsp[-1].lex))))
              MYSQL_YYABORT;
            pkg->m_current_routine= NULL;
          }
#line 27395 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 208: /* opt_sequence: %empty  */
#line 2743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 27401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 212: /* sequence_def: MINVALUE_SYM opt_equal longlong_num  */
#line 2754 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.seq_create_info->min_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 213: /* sequence_def: NO_SYM MINVALUE_SYM  */
#line 2759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 214: /* sequence_def: NOMINVALUE_SYM  */
#line 2765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_min_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MINVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_min_value;
          }
#line 27430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 215: /* sequence_def: MAXVALUE_SYM opt_equal longlong_num  */
#line 2771 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           if (unlikely(Lex->create_info.seq_create_info->used_fields &
               seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->max_value= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 216: /* sequence_def: NO_SYM MAXVALUE_SYM  */
#line 2779 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27452 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 217: /* sequence_def: NOMAXVALUE_SYM  */
#line 2785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields & seq_field_used_max_value))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "MAXVALUE"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_max_value;
          }
#line 27462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 218: /* sequence_def: START_SYM opt_with longlong_num  */
#line 2791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_start))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "START"));
            Lex->create_info.seq_create_info->start= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_start;
          }
#line 27474 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 219: /* sequence_def: INCREMENT_SYM opt_by longlong_num  */
#line 2799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_increment))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "INCREMENT"));
            Lex->create_info.seq_create_info->increment= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_increment;
          }
#line 27486 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 220: /* sequence_def: CACHE_SYM opt_equal longlong_num  */
#line 2807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 27498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 221: /* sequence_def: NOCACHE_SYM  */
#line 2815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cache))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CACHE"));
            Lex->create_info.seq_create_info->cache= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cache;
          }
#line 27510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 222: /* sequence_def: CYCLE_SYM  */
#line 2823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 1;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 27522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 223: /* sequence_def: NOCYCLE_SYM  */
#line 2831 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                seq_field_used_cycle))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CYCLE"));
            Lex->create_info.seq_create_info->cycle= 0;
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_cycle;
          }
#line 27534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 224: /* sequence_def: RESTART_SYM  */
#line 2839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart;
          }
#line 27550 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 225: /* sequence_def: RESTART_SYM opt_with longlong_num  */
#line 2851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sql_command != SQLCOM_ALTER_SEQUENCE))
            {
              thd->parse_error(ER_SYNTAX_ERROR, "RESTART");
              YYABORT;
            }
            if (unlikely(Lex->create_info.seq_create_info->used_fields &
                         seq_field_used_restart))
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "RESTART"));
            Lex->create_info.seq_create_info->restart= (yyvsp[0].longlong_number);
            Lex->create_info.seq_create_info->used_fields|= seq_field_used_restart | seq_field_used_restart_value;
          }
#line 27567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 226: /* force_lookahead: %empty  */
#line 2866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 27573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 227: /* force_lookahead: FORCE_LOOKAHEAD  */
#line 2866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      {}
#line 27579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 228: /* $@36: %empty  */
#line 2870 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 27589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 229: /* server_def: SERVER_SYM opt_if_not_exists ident_or_text $@36 FOREIGN DATA_SYM WRAPPER_SYM ident_or_text OPTIONS_SYM '(' server_options_list ')'  */
#line 2877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->server_options.scheme= (yyvsp[-4].lex_str); }
#line 27595 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 232: /* server_option: USER_SYM TEXT_STRING_sys  */
#line 2887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.username.str == 0);
            Lex->server_options.username= (yyvsp[0].lex_str);
          }
#line 27604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 233: /* server_option: HOST_SYM TEXT_STRING_sys  */
#line 2892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.host.str == 0);
            Lex->server_options.host= (yyvsp[0].lex_str);
          }
#line 27613 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 234: /* server_option: DATABASE TEXT_STRING_sys  */
#line 2897 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.db.str == 0);
            Lex->server_options.db= (yyvsp[0].lex_str);
          }
#line 27622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 235: /* server_option: OWNER_SYM TEXT_STRING_sys  */
#line 2902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.owner.str == 0);
            Lex->server_options.owner= (yyvsp[0].lex_str);
          }
#line 27631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 236: /* server_option: PASSWORD_SYM TEXT_STRING_sys  */
#line 2907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.password.str == 0);
            Lex->server_options.password= (yyvsp[0].lex_str);
          }
#line 27640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 237: /* server_option: SOCKET_SYM TEXT_STRING_sys  */
#line 2912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS(Lex->server_options.socket.str == 0);
            Lex->server_options.socket= (yyvsp[0].lex_str);
          }
#line 27649 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 238: /* server_option: PORT_SYM ulong_num  */
#line 2917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->server_options.port= (yyvsp[0].ulong_num);
          }
#line 27657 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 239: /* $@37: %empty  */
#line 2924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->stmt_definition_begin= (yyvsp[-2].simple_string);
            if (unlikely(lex->add_create_options_with_check((yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
            if (unlikely(!(lex->event_parse_data=
                           Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            lex->event_parse_data->identifier= (yyvsp[0].spname);
            lex->event_parse_data->on_completion=
                                  Event_parse_data::ON_COMPLETION_DROP;

            lex->sql_command= SQLCOM_CREATE_EVENT;
            /* We need that for disallowing subqueries */
          }
#line 27678 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 240: /* event_tail: remember_name opt_if_not_exists sp_name $@37 ON SCHEDULE_SYM ev_schedule_time opt_ev_on_completion opt_ev_status opt_ev_comment DO_SYM ev_sql_stmt  */
#line 2945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_CREATE_EVENT;
          }
#line 27690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 241: /* $@38: %empty  */
#line 2956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_expression= (yyvsp[-1].item);
            Lex->event_parse_data->interval= (yyvsp[0].interval);
          }
#line 27699 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 243: /* ev_schedule_time: AT_SYM expr  */
#line 2963 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_execute_at= (yyvsp[0].item);
          }
#line 27707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 244: /* opt_ev_status: %empty  */
#line 2969 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27713 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 245: /* opt_ev_status: ENABLE_SYM  */
#line 2971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::ENABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 27723 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 246: /* opt_ev_status: DISABLE_SYM ON SLAVE  */
#line 2977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::SLAVESIDE_DISABLED;
            Lex->event_parse_data->status_changed= true; 
            (yyval.num)= 1;
          }
#line 27733 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 247: /* opt_ev_status: DISABLE_SYM  */
#line 2983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->status= Event_parse_data::DISABLED;
            Lex->event_parse_data->status_changed= true;
            (yyval.num)= 1;
          }
#line 27743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 248: /* ev_starts: %empty  */
#line 2992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, 0);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->event_parse_data->item_starts= item;
          }
#line 27754 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 249: /* ev_starts: STARTS_SYM expr  */
#line 2999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_starts= (yyvsp[0].item);
          }
#line 27762 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 251: /* ev_ends: ENDS_SYM expr  */
#line 3007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->item_ends= (yyvsp[0].item);
          }
#line 27770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 252: /* opt_ev_on_completion: %empty  */
#line 3013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 254: /* ev_on_completion: ON COMPLETION_SYM opt_not PRESERVE_SYM  */
#line 3019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->event_parse_data->on_completion= (yyvsp[-1].num)
                                    ? Event_parse_data::ON_COMPLETION_DROP
                                    : Event_parse_data::ON_COMPLETION_PRESERVE;
            (yyval.num)= 1;
          }
#line 27787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 255: /* opt_ev_comment: %empty  */
#line 3028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 27793 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 256: /* opt_ev_comment: COMMENT_SYM TEXT_STRING_sys  */
#line 3030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->comment= Lex->event_parse_data->comment= (yyvsp[0].lex_str);
            (yyval.num)= 1;
          }
#line 27802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 257: /* $@39: %empty  */
#line 3037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            /*
              This stops the following :
              - CREATE EVENT ... DO CREATE EVENT ...;
              - ALTER  EVENT ... DO CREATE EVENT ...;
              - CREATE EVENT ... DO ALTER EVENT DO ....;
              - CREATE PROCEDURE ... BEGIN CREATE EVENT ... END|
              This allows:
              - CREATE EVENT ... DO DROP EVENT yyy;
              - CREATE EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO ALTER EVENT yyy;
                (the nested ALTER EVENT can have anything but DO clause)
              - ALTER  EVENT ... DO DROP EVENT yyy;
              - CREATE PROCEDURE ... BEGIN ALTER EVENT ... END|
                (the nested ALTER EVENT can have anything but DO clause)
              - CREATE PROCEDURE ... BEGIN DROP EVENT ... END|
            */
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_EVENT_RECURSION_FORBIDDEN, MYF(0)));
              
            if (unlikely(!lex->make_sp_head(thd,
                                            lex->event_parse_data->identifier,
                                            &sp_handler_procedure,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_ptr());
          }
#line 27839 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 258: /* ev_sql_stmt: $@39 sp_proc_stmt force_lookahead  */
#line 3070 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* return back to the original memory root ASAP */
            if (Lex->sp_body_finalize_event(thd))
              MYSQL_YYABORT;
          }
#line 27849 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 259: /* clear_privileges: %empty  */
#line 3079 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           LEX *lex=Lex;
           lex->users_list.empty();
           lex->columns.empty();
           lex->grant= lex->grant_tot_col= 0;
           lex->all_privileges= 0;
           lex->first_select_lex()->db= null_clex_str;
           lex->account_options.reset();
         }
#line 27863 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 260: /* opt_aggregate: %empty  */
#line 3091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.sp_aggregate_type)= NOT_AGGREGATE; }
#line 27869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 261: /* opt_aggregate: AGGREGATE_SYM  */
#line 3092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.sp_aggregate_type)= GROUP_AGGREGATE; }
#line 27875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 262: /* sp_name: ident '.' ident  */
#line 3097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 263: /* sp_name: ident  */
#line 3102 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spname)= Lex->make_sp_name(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 27893 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 264: /* opt_sp_name: %empty  */
#line 3109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spname)= NULL; }
#line 27899 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 265: /* opt_sp_name: sp_name  */
#line 3110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spname)= (yyvsp[0].spname); }
#line 27905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 266: /* sp_a_chistics: %empty  */
#line 3114 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 27911 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 267: /* sp_a_chistics: sp_a_chistics sp_chistic  */
#line 3115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 27917 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 268: /* sp_c_chistics: %empty  */
#line 3119 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 27923 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 269: /* sp_c_chistics: sp_c_chistics sp_c_chistic  */
#line 3120 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     {}
#line 27929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 270: /* sp_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 27935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 271: /* sp_chistic: LANGUAGE_SYM SQL_SYM  */
#line 3128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* Just parse it, we only have one language for now. */ }
#line 27941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 272: /* sp_chistic: NO_SYM SQL_SYM  */
#line 3130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_NO_SQL; }
#line 27947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 273: /* sp_chistic: CONTAINS_SYM SQL_SYM  */
#line 3132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_CONTAINS_SQL; }
#line 27953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 274: /* sp_chistic: READS_SYM SQL_SYM DATA_SYM  */
#line 3134 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_READS_SQL_DATA; }
#line 27959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 275: /* sp_chistic: MODIFIES_SYM SQL_SYM DATA_SYM  */
#line 3136 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.daccess= SP_MODIFIES_SQL_DATA; }
#line 27965 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 276: /* sp_chistic: sp_suid  */
#line 3138 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 27971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 277: /* create_package_chistic: COMMENT_SYM TEXT_STRING_sys  */
#line 3143 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.comment= (yyvsp[0].lex_str); }
#line 27977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 278: /* create_package_chistic: sp_suid  */
#line 3145 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.suid= (yyvsp[0].sp_suid); }
#line 27983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 279: /* create_package_chistics: create_package_chistic  */
#line 3149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 27989 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 280: /* create_package_chistics: create_package_chistics create_package_chistic  */
#line 3150 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                         { }
#line 27995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 282: /* opt_create_package_chistics: create_package_chistics  */
#line 3155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { }
#line 28001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 283: /* $@40: %empty  */
#line 3159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sp_chistics.init(); }
#line 28007 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 285: /* sp_c_chistic: sp_chistic  */
#line 3165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { }
#line 28013 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 286: /* sp_c_chistic: opt_not DETERMINISTIC_SYM  */
#line 3166 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { Lex->sp_chistics.detistic= ! (yyvsp[-1].num); }
#line 28019 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 287: /* sp_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 3170 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.sp_suid)= SP_IS_SUID; }
#line 28025 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 288: /* sp_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 3171 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.sp_suid)= SP_IS_NOT_SUID; }
#line 28031 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 289: /* $@41: %empty  */
#line 3176 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28040 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 290: /* call: CALL_SYM ident $@41 opt_sp_cparam_list  */
#line 3181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28049 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 291: /* $@42: %empty  */
#line 3186 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28058 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 292: /* call: CALL_SYM ident '.' ident $@42 opt_sp_cparam_list  */
#line 3191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28067 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 293: /* $@43: %empty  */
#line 3196 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 294: /* call: CALL_SYM ident '.' ident '.' ident $@43 opt_sp_cparam_list  */
#line 3201 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 28085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 299: /* sp_cparams: sp_cparams ',' expr  */
#line 3220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
           Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 28093 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 300: /* sp_cparams: expr  */
#line 3224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->value_list.push_back((yyvsp[0].item), thd->mem_root);
          }
#line 28101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 301: /* sp_fdparam_list: %empty  */
#line 3232 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
            Lex->sphead->m_param_end= Lex->sphead->m_param_begin;
          }
#line 28110 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 302: /* $@44: %empty  */
#line 3237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start();
          }
#line 28118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 303: /* sp_fdparam_list: $@44 sp_fdparams  */
#line 3241 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 28126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 306: /* sp_param_name: ident  */
#line 3253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.spvar)= Lex->sp_param_init(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28135 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 307: /* sp_param_name_and_type: sp_param_name sp_param_type  */
#line 3261 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_param_fill_definition((yyval.spvar)= (yyvsp[-1].spvar))))
              MYSQL_YYABORT;
          }
#line 28144 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 308: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 309: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3271 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyval.spvar)= (yyvsp[-7].spvar), (yyvsp[-6].ident_sys), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28162 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 310: /* sp_param_name_and_type: sp_param_name sp_decl_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-3].spvar), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28171 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 311: /* sp_param_name_and_type: sp_param_name sp_decl_ident '.' ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyval.spvar)= (yyvsp[-5].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 312: /* sp_param_name_and_type: sp_param_name ROW_SYM row_type_body  */
#line 3286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyval.spvar)= (yyvsp[-2].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 28189 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 317: /* sp_pdparam: sp_param_name sp_opt_inout sp_param_type  */
#line 3305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].spvar)->mode= (yyvsp[-1].spvar_mode);
            if (unlikely(Lex->sp_param_fill_definition((yyvsp[-2].spvar))))
              MYSQL_YYABORT;
          }
#line 28199 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 318: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-6].spvar)->mode= (yyvsp[-5].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyvsp[-6].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28209 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 319: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident '.' ident PERCENT_ORACLE_SYM TYPE_SYM  */
#line 3317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-8].spvar)->mode= (yyvsp[-7].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_type_reference(thd, (yyvsp[-8].spvar), (yyvsp[-6].ident_sys), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 320: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3323 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-4].spvar)->mode= (yyvsp[-3].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyvsp[-4].spvar), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 321: /* sp_pdparam: sp_param_name sp_opt_inout sp_decl_ident '.' ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM  */
#line 3329 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-6].spvar)->mode= (yyvsp[-5].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_table_rowtype_reference(thd, (yyvsp[-6].spvar), (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 322: /* sp_pdparam: sp_param_name sp_opt_inout ROW_SYM row_type_body  */
#line 3335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].spvar)->mode= (yyvsp[-2].spvar_mode);
            if (unlikely(Lex->sphead->spvar_fill_row(thd, (yyvsp[-3].spvar), (yyvsp[0].spvar_definition_list))))
              MYSQL_YYABORT;
          }
#line 28249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 323: /* sp_opt_inout: %empty  */
#line 3343 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 28255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 324: /* sp_opt_inout: IN_SYM  */
#line 3344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_IN; }
#line 28261 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 325: /* sp_opt_inout: OUT_SYM  */
#line 3345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_OUT; }
#line 28267 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 326: /* sp_opt_inout: INOUT_SYM  */
#line 3346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 28273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 327: /* sp_opt_inout: IN_SYM OUT_SYM  */
#line 3347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.spvar_mode)= sp_variable::MODE_INOUT; }
#line 28279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 328: /* $@45: %empty  */
#line 3352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= YYLIP->get_cpp_tok_start() + 1;
          }
#line 28287 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 329: /* sp_parenthesized_pdparam_list: '(' $@45 sp_pdparam_list ')'  */
#line 3357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_end= YYLIP->get_cpp_tok_start();
          }
#line 28295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 330: /* sp_no_param: %empty  */
#line 3364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->m_param_begin= Lex->sphead->m_param_end=
              YYLIP->get_cpp_tok_start() + 1;
          }
#line 28304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 335: /* sp_proc_stmts: %empty  */
#line 3381 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 28310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 337: /* sp_proc_stmts1: sp_proc_stmt ';'  */
#line 3386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 28316 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 339: /* $@46: %empty  */
#line 3391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 28324 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 340: /* sp_proc_stmts1_implicit_block: $@46 sp_proc_stmts1  */
#line 3395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 28333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 341: /* opt_sp_decl_body_list: %empty  */
#line 3403 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).init();
          }
#line 28341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 342: /* opt_sp_decl_body_list: sp_decl_body_list  */
#line 3406 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.spblock)= (yyvsp[0].spblock); }
#line 28347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 343: /* $@47: %empty  */
#line 3411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->sp_add_instr_cpush_for_cursors(thd, Lex->spcont)))
              MYSQL_YYABORT;
          }
#line 28356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 344: /* sp_decl_body_list: sp_decl_non_handler_list $@47 opt_sp_decl_handler_list  */
#line 3416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[0].spblock));
          }
#line 28364 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 346: /* sp_decl_non_handler_list: sp_decl_non_handler ';'  */
#line 3423 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.spblock)= (yyvsp[-1].spblock); }
#line 28370 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 347: /* sp_decl_non_handler_list: sp_decl_non_handler_list sp_decl_non_handler ';'  */
#line 3425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[-1].spblock));
          }
#line 28378 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 348: /* sp_decl_handler_list: sp_decl_handler ';'  */
#line 3431 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.spblock)= (yyvsp[-1].spblock); }
#line 28384 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 349: /* sp_decl_handler_list: sp_decl_handler_list sp_decl_handler ';'  */
#line 3433 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spblock).join((yyvsp[-2].spblock), (yyvsp[-1].spblock));
          }
#line 28392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 350: /* opt_sp_decl_handler_list: %empty  */
#line 3439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.spblock).init(); }
#line 28398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 352: /* optionally_qualified_column_ident: sp_decl_ident  */
#line 3445 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                         Qualified_column_ident(&(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 353: /* optionally_qualified_column_ident: sp_decl_ident '.' ident  */
#line 3451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 354: /* optionally_qualified_column_ident: sp_decl_ident '.' ident '.' ident  */
#line 3457 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.qualified_column_ident)= new (thd->mem_root)
                           Qualified_column_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 28428 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 355: /* row_field_name: ident_directly_assignable  */
#line 3466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.spvar_definition)= Lex->row_field_name(thd, (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 28437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 357: /* row_field_definition_list: row_field_definition  */
#line 3478 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.spvar_definition_list)= Row_definition_list::make(thd->mem_root, (yyvsp[0].spvar_definition))))
              MYSQL_YYABORT;
          }
#line 28446 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 358: /* row_field_definition_list: row_field_definition_list ',' row_field_definition  */
#line 3483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (((yyval.spvar_definition_list)= (yyvsp[-2].spvar_definition_list))->append_uniq(thd->mem_root, (yyvsp[0].spvar_definition)))
              MYSQL_YYABORT;
          }
#line 28455 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 359: /* row_type_body: '(' row_field_definition_list ')'  */
#line 3490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            { (yyval.spvar_definition_list)= (yyvsp[-1].spvar_definition_list); }
#line 28461 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 360: /* sp_decl_idents_init_vars: sp_decl_idents  */
#line 3495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_variable_declarations_init(thd, (yyvsp[0].num));
          }
#line 28469 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 361: /* sp_decl_vars: sp_decl_idents_init_vars field_type sp_opt_default  */
#line 3504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_finalize(thd, (yyvsp[-2].num),
                                                                &Lex->last_field[0],
                                                                (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-2].num));
          }
#line 28481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 362: /* sp_decl_vars: sp_decl_idents_init_vars optionally_qualified_column_ident PERCENT_ORACLE_SYM TYPE_SYM sp_opt_default  */
#line 3514 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_with_ref_finalize(thd, (yyvsp[-4].num), (yyvsp[-3].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 28491 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 363: /* sp_decl_vars: sp_decl_idents_init_vars optionally_qualified_column_ident PERCENT_ORACLE_SYM ROWTYPE_ORACLE_SYM sp_opt_default  */
#line 3522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_rowtype_finalize(thd, (yyvsp[-4].num), (yyvsp[-3].qualified_column_ident), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-4].num));
          }
#line 28501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 364: /* sp_decl_vars: sp_decl_idents_init_vars ROW_SYM row_type_body sp_opt_default  */
#line 3530 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_variable_declarations_row_finalize(thd, (yyvsp[-3].num), (yyvsp[-1].spvar_definition_list), (yyvsp[0].item))))
              MYSQL_YYABORT;
            (yyval.spblock).init_using_vars((yyvsp[-3].num));
          }
#line 28511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 366: /* sp_decl_non_handler: ident_directly_assignable CONDITION_SYM FOR_SYM sp_cond  */
#line 3540 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-3].ident_sys), (yyvsp[0].spcondvalue))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 28522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 367: /* sp_decl_non_handler: ident_directly_assignable EXCEPTION_ORACLE_SYM  */
#line 3547 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_condition_value *spcond= new (thd->mem_root)
                                        sp_condition_value_user_defined();
            if (unlikely(!spcond) ||
                unlikely(Lex->spcont->declare_condition(thd, &(yyvsp[-1].ident_sys), spcond)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).hndlrs= (yyval.spblock).curs= 0;
            (yyval.spblock).conds= 1;
          }
#line 28536 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 368: /* $@48: %empty  */
#line 3557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 28544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 369: /* sp_decl_non_handler: CURSOR_SYM ident_directly_assignable $@48 opt_parenthesized_cursor_formal_parameters IS sp_cursor_stmt  */
#line 3562 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_pcontext *param_ctx= Lex->spcont;
            if (unlikely(Lex->sp_block_finalize(thd)))
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_declare_cursor(thd, &(yyvsp[-4].ident_sys), (yyvsp[0].sp_cursor_stmt), param_ctx, false)))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).hndlrs= 0;
            (yyval.spblock).curs= 1;
          }
#line 28558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 370: /* $@49: %empty  */
#line 3575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, (yyvsp[-2].num))))
              MYSQL_YYABORT;
          }
#line 28567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 371: /* sp_decl_handler: sp_handler_type HANDLER_SYM FOR_SYM $@49 sp_hcond_list sp_proc_stmt  */
#line 3580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, (yyvsp[-5].num))))
              MYSQL_YYABORT;
            (yyval.spblock).vars= (yyval.spblock).conds= (yyval.spblock).curs= 0;
            (yyval.spblock).hndlrs= 1;
          }
#line 28578 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 374: /* sp_cursor_stmt_lex: %empty  */
#line 3595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->lex->sphead);
            if (unlikely(!((yyval.sp_cursor_stmt)= new (thd->mem_root)
                           sp_lex_cursor(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 28589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 375: /* $@50: %empty  */
#line 3605 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].sp_cursor_stmt));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 28600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 376: /* sp_cursor_stmt: sp_cursor_stmt_lex $@50 select  */
#line 3612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex == (yyvsp[-2].sp_cursor_stmt));
            Lex->pop_select(); //main select
            if (unlikely((yyvsp[-2].sp_cursor_stmt)->stmt_finalize(thd)) ||
                unlikely((yyvsp[-2].sp_cursor_stmt)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            (yyval.sp_cursor_stmt)= (yyvsp[-2].sp_cursor_stmt);
          }
#line 28613 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 377: /* sp_handler_type: EXIT_MARIADB_SYM  */
#line 3623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= sp_handler::EXIT; }
#line 28619 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 378: /* sp_handler_type: CONTINUE_MARIADB_SYM  */
#line 3624 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= sp_handler::CONTINUE; }
#line 28625 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 379: /* sp_handler_type: EXIT_ORACLE_SYM  */
#line 3625 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.num)= sp_handler::EXIT; }
#line 28631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 380: /* sp_handler_type: CONTINUE_ORACLE_SYM  */
#line 3626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.num)= sp_handler::CONTINUE; }
#line 28637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 381: /* sp_hcond_list: sp_hcond_element  */
#line 3632 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 1; }
#line 28643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 382: /* sp_hcond_list: sp_hcond_list ',' sp_hcond_element  */
#line 3634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)+= 1; }
#line 28649 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 383: /* sp_hcond_element: sp_hcond  */
#line 3639 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont->parent_context();

            if (unlikely(ctx->check_duplicate_handler((yyvsp[0].spcondvalue))))
              my_yyabort_error((ER_SP_DUP_HANDLER, MYF(0)));

            sp_instr_hpush_jump *i= (sp_instr_hpush_jump *)sp->last_instruction();
            i->add_condition((yyvsp[0].spcondvalue));
          }
#line 28665 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 384: /* sp_cond: ulong_num  */
#line 3654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* mysql errno */
            if (unlikely((yyvsp[0].ulong_num) == 0))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "CONDITION", "0"));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].ulong_num));
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28677 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 386: /* sqlstate: SQLSTATE_SYM opt_value TEXT_STRING_literal  */
#line 3666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* SQLSTATE */

            /*
              An error is triggered:
                - if the specified string is not a valid SQLSTATE,
                - or if it represents the completion condition -- it is not
                  allowed to SIGNAL, or declare a handler for the completion
                  condition.
            */
            if (unlikely(!is_sqlstate_valid(&(yyvsp[0].lex_str)) ||
                         is_sqlstate_completion((yyvsp[0].lex_str).str)))
              my_yyabort_error((ER_SP_BAD_SQLSTATE, MYF(0), (yyvsp[0].lex_str).str));
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value((yyvsp[0].lex_str).str);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28698 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 387: /* opt_value: %empty  */
#line 3685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 28704 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 388: /* opt_value: VALUE_SYM  */
#line 3686 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 28710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 389: /* sp_hcond: sp_cond  */
#line 3691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= (yyvsp[0].spcondvalue);
          }
#line 28718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 390: /* sp_hcond: ident  */
#line 3695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= Lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely((yyval.spcondvalue) == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 28728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 391: /* sp_hcond: SQLWARNING_SYM  */
#line 3701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::WARNING);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28738 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 392: /* sp_hcond: not FOUND_SYM  */
#line 3707 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::NOT_FOUND);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28748 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 393: /* sp_hcond: SQLEXCEPTION_SYM  */
#line 3713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 394: /* sp_hcond: OTHERS_ORACLE_SYM  */
#line 3719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.spcondvalue)= new (thd->mem_root) sp_condition_value(sp_condition_value::EXCEPTION);
            if (unlikely((yyval.spcondvalue) == NULL))
              MYSQL_YYABORT;
          }
#line 28768 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 395: /* raise_stmt_oracle: RAISE_ORACLE_SYM opt_set_signal_information  */
#line 3729 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 28777 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 396: /* raise_stmt_oracle: RAISE_ORACLE_SYM signal_value opt_set_signal_information  */
#line 3734 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 28786 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 397: /* signal_stmt: SIGNAL_SYM signal_value opt_set_signal_information  */
#line 3742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_signal_statement(thd, (yyvsp[-1].spcondvalue)))
              MYSQL_YYABORT;
          }
#line 28795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 398: /* signal_value: ident  */
#line 3750 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_condition_value *cond;

            /* SIGNAL foo cannot be used outside of stored programs */
            if (unlikely(lex->spcont == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            cond= lex->spcont->find_declared_or_predefined_condition(thd, &(yyvsp[0].ident_sys));
            if (unlikely(cond == NULL))
              my_yyabort_error((ER_SP_COND_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            if (unlikely(!cond->has_sql_state()))
              my_yyabort_error((ER_SIGNAL_BAD_CONDITION_TYPE, MYF(0)));
            (yyval.spcondvalue)= cond;
          }
#line 28814 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 399: /* signal_value: sqlstate  */
#line 3765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 28820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 400: /* opt_signal_value: %empty  */
#line 3770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= NULL; }
#line 28826 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 401: /* opt_signal_value: signal_value  */
#line 3772 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.spcondvalue)= (yyvsp[0].spcondvalue); }
#line 28832 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 402: /* opt_set_signal_information: %empty  */
#line 3777 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->m_parser_state->m_yacc.m_set_signal_info.clear();
          }
#line 28840 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 404: /* signal_information_item_list: signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            info->clear();
            info->m_item[index]= (yyvsp[0].item);
          }
#line 28852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 405: /* signal_information_item_list: signal_information_item_list ',' signal_condition_information_item_name '=' signal_allowed_expr  */
#line 3794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Set_signal_information *info;
            info= &thd->m_parser_state->m_yacc.m_set_signal_info;
            int index= (int) (yyvsp[-2].diag_condition_item_name);
            if (unlikely(info->m_item[index] != NULL))
              my_yyabort_error((ER_DUP_SIGNAL_SET, MYF(0),
                                Diag_condition_item_names[index].str));
            info->m_item[index]= (yyvsp[0].item);
          }
#line 28866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 406: /* signal_allowed_expr: literal  */
#line 3810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28872 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 407: /* signal_allowed_expr: variable  */
#line 3812 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].item)->type() == Item::FUNC_ITEM)
            {
              Item_func *item= (Item_func*) (yyvsp[0].item);
              if (unlikely(item->functype() == Item_func::SUSERVAR_FUNC))
              {
                /*
                  Don't allow the following syntax:
                    SIGNAL/RESIGNAL ...
                    SET <signal condition item name> = @foo := expr
                */
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            (yyval.item)= (yyvsp[0].item);
          }
#line 28894 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 408: /* signal_allowed_expr: simple_ident  */
#line 3830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 28900 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 409: /* signal_condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CLASS_ORIGIN; }
#line 28906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 410: /* signal_condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_SUBCLASS_ORIGIN; }
#line 28912 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 411: /* signal_condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_CATALOG; }
#line 28918 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 412: /* signal_condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_SCHEMA; }
#line 28924 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 413: /* signal_condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CONSTRAINT_NAME; }
#line 28930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 414: /* signal_condition_information_item_name: CATALOG_NAME_SYM  */
#line 3846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CATALOG_NAME; }
#line 28936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 415: /* signal_condition_information_item_name: SCHEMA_NAME_SYM  */
#line 3848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_SCHEMA_NAME; }
#line 28942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 416: /* signal_condition_information_item_name: TABLE_NAME_SYM  */
#line 3850 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_TABLE_NAME; }
#line 28948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 417: /* signal_condition_information_item_name: COLUMN_NAME_SYM  */
#line 3852 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_COLUMN_NAME; }
#line 28954 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 418: /* signal_condition_information_item_name: CURSOR_NAME_SYM  */
#line 3854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_CURSOR_NAME; }
#line 28960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 419: /* signal_condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 3856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_MESSAGE_TEXT; }
#line 28966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 420: /* signal_condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 3858 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_condition_item_name)= DIAG_MYSQL_ERRNO; }
#line 28972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 421: /* resignal_stmt: RESIGNAL_SYM opt_signal_value opt_set_signal_information  */
#line 3863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_resignal_statement(thd, (yyvsp[-1].spcondvalue))))
              MYSQL_YYABORT;
          }
#line 28981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 422: /* get_diagnostics: GET_SYM which_area DIAGNOSTICS_SYM diagnostics_information  */
#line 3871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Diagnostics_information *info= (yyvsp[0].diag_info);

            info->set_which_da((yyvsp[-2].diag_area));

            Lex->sql_command= SQLCOM_GET_DIAGNOSTICS;
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_get_diagnostics(info);

            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 28997 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 423: /* which_area: %empty  */
#line 3886 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 424: /* which_area: CURRENT_SYM  */
#line 3888 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.diag_area)= Diagnostics_information::CURRENT_AREA; }
#line 29009 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 425: /* diagnostics_information: statement_information  */
#line 3893 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Statement_information((yyvsp[0].stmt_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29019 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 426: /* diagnostics_information: CONDITION_SYM condition_number condition_information  */
#line 3899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.diag_info)= new (thd->mem_root) Condition_information((yyvsp[-1].item), (yyvsp[0].cond_info_list));
            if (unlikely((yyval.diag_info) == NULL))
              MYSQL_YYABORT;
          }
#line 29029 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 427: /* statement_information: statement_information_item  */
#line 3908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.stmt_info_list)= new (thd->mem_root) List<Statement_information_item>;
            if (unlikely((yyval.stmt_info_list) == NULL) ||
                unlikely((yyval.stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29040 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 428: /* statement_information: statement_information ',' statement_information_item  */
#line 3915 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].stmt_info_list)->push_back((yyvsp[0].stmt_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.stmt_info_list)= (yyvsp[-2].stmt_info_list);
          }
#line 29050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 429: /* statement_information_item: simple_target_specification '=' statement_information_item_name  */
#line 3924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.stmt_info_item)= new (thd->mem_root) Statement_information_item((yyvsp[0].stmt_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.stmt_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29060 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 430: /* simple_target_specification: ident_cli  */
#line 3933 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= thd->lex->create_item_for_sp_var(&(yyvsp[0].ident_cli), NULL))))
              MYSQL_YYABORT;
          }
#line 29069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 431: /* simple_target_specification: '@' ident_or_text  */
#line 3938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 29079 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 432: /* statement_information_item_name: NUMBER_MARIADB_SYM  */
#line 3947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 433: /* statement_information_item_name: NUMBER_ORACLE_SYM  */
#line 3949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::NUMBER; }
#line 29091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 434: /* statement_information_item_name: ROW_COUNT_SYM  */
#line 3951 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.stmt_info_item_name)= Statement_information_item::ROW_COUNT; }
#line 29097 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 435: /* condition_number: signal_allowed_expr  */
#line 3960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.item)= (yyvsp[0].item); }
#line 29103 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 436: /* condition_information: condition_information_item  */
#line 3965 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.cond_info_list)= new (thd->mem_root) List<Condition_information_item>;
            if (unlikely((yyval.cond_info_list) == NULL) ||
                unlikely((yyval.cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 29114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 437: /* condition_information: condition_information ',' condition_information_item  */
#line 3972 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].cond_info_list)->push_back((yyvsp[0].cond_info_item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.cond_info_list)= (yyvsp[-2].cond_info_list);
          }
#line 29124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 438: /* condition_information_item: simple_target_specification '=' condition_information_item_name  */
#line 3981 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.cond_info_item)= new (thd->mem_root) Condition_information_item((yyvsp[0].cond_info_item_name), (yyvsp[-2].item));
            if (unlikely((yyval.cond_info_item) == NULL))
              MYSQL_YYABORT;
          }
#line 29134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 439: /* condition_information_item_name: CLASS_ORIGIN_SYM  */
#line 3990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CLASS_ORIGIN; }
#line 29140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 440: /* condition_information_item_name: SUBCLASS_ORIGIN_SYM  */
#line 3992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SUBCLASS_ORIGIN; }
#line 29146 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 441: /* condition_information_item_name: CONSTRAINT_CATALOG_SYM  */
#line 3994 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_CATALOG; }
#line 29152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 442: /* condition_information_item_name: CONSTRAINT_SCHEMA_SYM  */
#line 3996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_SCHEMA; }
#line 29158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 443: /* condition_information_item_name: CONSTRAINT_NAME_SYM  */
#line 3998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CONSTRAINT_NAME; }
#line 29164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 444: /* condition_information_item_name: CATALOG_NAME_SYM  */
#line 4000 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CATALOG_NAME; }
#line 29170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 445: /* condition_information_item_name: SCHEMA_NAME_SYM  */
#line 4002 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::SCHEMA_NAME; }
#line 29176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 446: /* condition_information_item_name: TABLE_NAME_SYM  */
#line 4004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::TABLE_NAME; }
#line 29182 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 447: /* condition_information_item_name: COLUMN_NAME_SYM  */
#line 4006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::COLUMN_NAME; }
#line 29188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 448: /* condition_information_item_name: CURSOR_NAME_SYM  */
#line 4008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::CURSOR_NAME; }
#line 29194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 449: /* condition_information_item_name: MESSAGE_TEXT_SYM  */
#line 4010 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MESSAGE_TEXT; }
#line 29200 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 450: /* condition_information_item_name: MYSQL_ERRNO_SYM  */
#line 4012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::MYSQL_ERRNO; }
#line 29206 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 451: /* condition_information_item_name: RETURNED_SQLSTATE_SYM  */
#line 4014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.cond_info_item_name)= Condition_information_item::RETURNED_SQLSTATE; }
#line 29212 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 453: /* sp_decl_ident: keyword_sp_decl  */
#line 4020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_ident_cli(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 29221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 454: /* sp_decl_idents: sp_decl_ident  */
#line 4028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= 1;
          }
#line 29237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 455: /* sp_decl_idents: sp_decl_idents ',' ident  */
#line 4040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* NOTE: field definition is filled in sp_decl section. */

            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;

            if (unlikely(spc->find_variable(&(yyvsp[0].ident_sys), TRUE)))
              my_yyabort_error((ER_SP_DUP_VAR, MYF(0), (yyvsp[0].ident_sys).str));
            spc->add_variable(thd, &(yyvsp[0].ident_sys));
            (yyval.num)= (yyvsp[-2].num) + 1;
          }
#line 29253 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 456: /* sp_opt_default: %empty  */
#line 4054 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item) = NULL; }
#line 29259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 457: /* sp_opt_default: DEFAULT expr  */
#line 4055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 29265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 458: /* sp_opt_default: SET_VAR expr  */
#line 4056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item); }
#line 29271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 464: /* sp_proc_stmt: labels_declaration_oracle sp_labelable_stmt  */
#line 4065 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                      {}
#line 29277 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 477: /* sp_labelable_stmt: NULL_SYM  */
#line 4081 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { }
#line 29283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 482: /* $@51: %empty  */
#line 4093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sphead->new_cont_backpatch(NULL);
          }
#line 29293 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 483: /* sp_proc_stmt_if: IF_SYM $@51 sp_if END IF_SYM  */
#line 4099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sphead->do_cont_backpatch(); }
#line 29299 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 485: /* $@52: %empty  */
#line 4105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // Direct procedure call (without the CALL keyword)
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 486: /* sp_statement: ident_directly_assignable $@52 opt_sp_cparam_list  */
#line 4111 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29318 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 487: /* $@53: %empty  */
#line 4116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 488: /* sp_statement: ident_directly_assignable '.' ident $@53 opt_sp_cparam_list  */
#line 4121 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 489: /* $@54: %empty  */
#line 4126 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->call_statement_start(thd, (yyvsp[-4].ident_sys), (yyvsp[-2].ident_sys), (yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 490: /* sp_statement: ident_directly_assignable '.' ident '.' ident $@54 opt_sp_cparam_list  */
#line 4131 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 29354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 491: /* $@55: %empty  */
#line 4138 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            lex->sphead->reset_lex(thd);
            /*
              We should not push main select here, it will be done or not
              done by the statement, we just provide only new LEX for the
              statement here as if it is start of parsing new statement.
            */
            lex->sphead->m_tmp_query= lip->get_tok_start();
          }
#line 29371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 492: /* sp_proc_stmt_statement: $@55 sp_statement  */
#line 4151 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_proc_stmt_statement_finalize(thd, yychar == YYEMPTY) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 495: /* $@56: %empty  */
#line 4166 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29391 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 496: /* sp_proc_stmt_return: RETURN_ALLMODES_SYM $@56 expr  */
#line 4172 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
            if (unlikely(sp->m_handler->add_instr_freturn(thd, sp, lex->spcont,
                                                          (yyvsp[0].item), lex)) ||
                unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29407 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 497: /* sp_proc_stmt_return: RETURN_ORACLE_SYM  */
#line 4184 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            if (unlikely(sp->m_handler->add_instr_preturn(thd, sp,
                                                               lex->spcont)))
              MYSQL_YYABORT;
          }
#line 29419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 498: /* $@57: %empty  */
#line 4194 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 499: /* reset_lex_expr: $@57 expr  */
#line 4200 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
            Lex->pop_select(); //main select
          }
#line 29438 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 500: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM  */
#line 4208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 501: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident  */
#line 4213 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_exit_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 29456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 502: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_exit_statement(thd, (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 503: /* sp_proc_stmt_exit_oracle: EXIT_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_exit_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 504: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM  */
#line 4233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, NULL)))
              MYSQL_YYABORT;
          }
#line 29485 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 505: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident  */
#line 4238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_continue_statement(thd, &(yyvsp[0].ident_sys), NULL)))
              MYSQL_YYABORT;
          }
#line 29494 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 506: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM WHEN_SYM reset_lex_expr  */
#line 4243 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_continue_statement(thd, (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 507: /* sp_proc_stmt_continue_oracle: CONTINUE_ORACLE_SYM label_ident WHEN_SYM reset_lex_expr  */
#line 4249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->sp_continue_statement(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].item)) ||
                Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 508: /* sp_proc_stmt_leave: LEAVE_SYM label_ident  */
#line 4259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_leave_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29523 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 509: /* sp_proc_stmt_iterate: ITERATE_SYM label_ident  */
#line 4267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_iterate_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 510: /* sp_proc_stmt_goto_oracle: GOTO_ORACLE_SYM label_ident  */
#line 4275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_goto_statement(thd, &(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29541 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 511: /* remember_lex: %empty  */
#line 4283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex)= thd->lex;
          }
#line 29549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 512: /* assignment_source_lex: %empty  */
#line 4289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->sphead);
            if (unlikely(!((yyval.assignment_lex)= new (thd->mem_root)
                           sp_assignment_lex(thd, thd->lex))))
              MYSQL_YYABORT;
          }
#line 29560 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 513: /* $@58: %empty  */
#line 4299 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(thd->free_list == NULL);
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29571 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 514: /* assignment_source_expr: assignment_source_lex $@58 expr  */
#line 4306 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), thd->free_list);
            thd->free_list= NULL;
            Lex->pop_select(); //main select
            if ((yyval.assignment_lex)->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29586 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 515: /* $@59: %empty  */
#line 4320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd, (yyvsp[0].assignment_lex));
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= FOR_LOOP_BOUND;
          }
#line 29597 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 516: /* for_loop_bound_expr: assignment_source_lex $@59 expr  */
#line 4327 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-2].assignment_lex) == thd->lex);
            (yyval.assignment_lex)= (yyvsp[-2].assignment_lex);
            (yyval.assignment_lex)->sp_lex_in_use= true;
            (yyval.assignment_lex)->set_item_and_free_list((yyvsp[0].item), NULL);
            Lex->pop_select(); //main select
            if (unlikely((yyval.assignment_lex)->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
            Lex->current_select->parsing_place= NO_MATTER;
          }
#line 29612 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 517: /* cursor_actual_parameters: assignment_source_expr  */
#line 4341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.sp_assignment_lex_list)= new (thd->mem_root) List<sp_assignment_lex>)))
              MYSQL_YYABORT;
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 29622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 518: /* cursor_actual_parameters: cursor_actual_parameters ',' assignment_source_expr  */
#line 4347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.sp_assignment_lex_list)= (yyvsp[-2].sp_assignment_lex_list);
            (yyval.sp_assignment_lex_list)->push_back((yyvsp[0].assignment_lex), thd->mem_root);
          }
#line 29631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 519: /* opt_parenthesized_cursor_actual_parameters: %empty  */
#line 4354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             { (yyval.sp_assignment_lex_list)= NULL; }
#line 29637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 520: /* opt_parenthesized_cursor_actual_parameters: '(' cursor_actual_parameters ')'  */
#line 4355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             { (yyval.sp_assignment_lex_list)= (yyvsp[-1].sp_assignment_lex_list); }
#line 29643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 521: /* sp_proc_stmt_open: OPEN_SYM ident opt_parenthesized_cursor_actual_parameters  */
#line 4360 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_open_cursor(thd, &(yyvsp[-1].ident_sys), (yyvsp[0].sp_assignment_lex_list))))
              MYSQL_YYABORT;
          }
#line 29652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 522: /* sp_proc_stmt_fetch_head: FETCH_SYM ident INTO  */
#line 4368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 523: /* sp_proc_stmt_fetch_head: FETCH_SYM FROM ident INTO  */
#line 4373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 524: /* sp_proc_stmt_fetch_head: FETCH_SYM NEXT_SYM FROM ident INTO  */
#line 4378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_add_cfetch(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
          }
#line 29679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 525: /* sp_proc_stmt_fetch: sp_proc_stmt_fetch_head sp_fetch_list  */
#line 4385 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { }
#line 29685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 526: /* sp_proc_stmt_fetch: FETCH_SYM GROUP_SYM NEXT_SYM ROW_SYM  */
#line 4387 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           if (unlikely(Lex->sp_add_agg_cfetch()))
             MYSQL_YYABORT;
         }
#line 29694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 527: /* sp_proc_stmt_close: CLOSE_SYM ident  */
#line 4395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint offset;
            sp_instr_cclose *i;

            if (unlikely(!lex->spcont->find_cursor(&(yyvsp[0].ident_sys), &offset, false)))
              my_yyabort_error((ER_SP_CURSOR_MISMATCH, MYF(0), (yyvsp[0].ident_sys).str));
            i= new (thd->mem_root)
              sp_instr_cclose(sp->instructions(), lex->spcont,  offset);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 29713 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 528: /* sp_fetch_list: ident  */
#line 4413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;
            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 29732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 529: /* sp_fetch_list: sp_fetch_list ',' ident  */
#line 4428 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *spc= lex->spcont;
            sp_variable *spv= likely(spc != NULL)
              ? spc->find_variable(&(yyvsp[0].ident_sys), false)
              : NULL;
            if (unlikely(!spv))
              my_yyabort_error((ER_SP_UNDECLARED_VAR, MYF(0), (yyvsp[0].ident_sys).str));

            /* An SP local variable */
            sp_instr_cfetch *i= (sp_instr_cfetch *)sp->last_instruction();
            i->add_to_varlist(spv);
          }
#line 29751 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 530: /* $@60: %empty  */
#line 4445 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 531: /* $@61: %empty  */
#line 4451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            sp_pcontext *ctx= lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, ctx, (yyvsp[-1].item), lex);
            if (unlikely(i == NULL) ||
                unlikely(sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0))) ||
                unlikely(sp->add_cont_backpatch(i)) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (unlikely(sp->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 532: /* $@62: %empty  */
#line 4468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            sp_head *sp= Lex->sphead;
            sp_pcontext *ctx= Lex->spcont;
            uint ip= sp->instructions();
            sp_instr_jump *i= new (thd->mem_root) sp_instr_jump(ip, ctx);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
            sp->backpatch(ctx->pop_label());
            sp->push_backpatch(thd, i, ctx->push_label(thd, &empty_clex_str, 0));
          }
#line 29798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 533: /* sp_if: $@60 expr THEN_SYM $@61 sp_proc_stmts1_implicit_block $@62 sp_elseifs  */
#line 4480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sphead->backpatch(lex->spcont->pop_label());
          }
#line 29808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 537: /* $@63: %empty  */
#line 4495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;

            /**
              An example of the CASE statement in use is
            <pre>
            CREATE PROCEDURE proc_19194_simple(i int)
            BEGIN
              DECLARE str CHAR(10);

              CASE i
                WHEN 1 THEN SET str="1";
                WHEN 2 THEN SET str="2";
                WHEN 3 THEN SET str="3";
                ELSE SET str="unknown";
              END CASE;

              SELECT str;
            END
            </pre>
              The actions are used to generate the following code:
            <pre>
            SHOW PROCEDURE CODE proc_19194_simple;
            Pos     Instruction
            0       set str@1 NULL
            1       set_case_expr (12) 0 i@0
            2       jump_if_not 5(12) (case_expr@0 = 1)
            3       set str@1 _latin1'1'
            4       jump 12
            5       jump_if_not 8(12) (case_expr@0 = 2)
            6       set str@1 _latin1'2'
            7       jump 12
            8       jump_if_not 11(12) (case_expr@0 = 3)
            9       set str@1 _latin1'3'
            10      jump 12
            11      set str@1 _latin1'unknown'
            12      stmt 0 "SELECT str"
            </pre>
            */

            Lex->sphead->new_cont_backpatch(NULL);

            /*
              BACKPATCH: Creating target label for the jump to after END CASE
              (instruction 12 in the example)
            */
            Lex->spcont->push_label(thd, &empty_clex_str, Lex->sphead->instructions());
          }
#line 29862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 538: /* case_stmt_specification: CASE_SYM $@63 case_stmt_body else_clause_opt END CASE_SYM  */
#line 4548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              BACKPATCH: Resolving forward jump from
              "case_stmt_action_then" to after END CASE
              (jump from instruction 4 to 12, 7 to 12 ... in the example)
            */
            Lex->sphead->backpatch(Lex->spcont->pop_label());

            if ((yyvsp[-3].num))
              Lex->spcont->pop_case_expr_id();

            Lex->sphead->do_cont_backpatch();
          }
#line 29880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 539: /* $@64: %empty  */
#line 4564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $2 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 540: /* $@65: %empty  */
#line 4570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_expr((yyvsp[0].item))))
              MYSQL_YYABORT;

            Lex->pop_select(); //main select
            if (Lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
          }
#line 29903 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 541: /* case_stmt_body: $@64 expr $@65 simple_when_clause_list  */
#line 4579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 1; }
#line 29909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 542: /* case_stmt_body: searched_when_clause_list  */
#line 4581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 0; }
#line 29915 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 547: /* $@66: %empty  */
#line 4596 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 548: /* $@67: %empty  */
#line 4602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Simple case: <caseval> = <whenval> */

            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), true)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 549: /* simple_when_clause: WHEN_SYM $@66 expr $@67 THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4615 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 29950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 550: /* $@68: %empty  */
#line 4623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd); /* For expr $3 */
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 29960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 551: /* $@69: %empty  */
#line 4629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->case_stmt_action_when((yyvsp[0].item), false)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            /* For expr $3 */
            if (unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 29974 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 552: /* searched_when_clause: WHEN_SYM $@68 expr $@69 THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->case_stmt_action_then()))
              MYSQL_YYABORT;
          }
#line 29983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 553: /* else_clause_opt: %empty  */
#line 4648 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_head *sp= lex->sphead;
            uint ip= sp->instructions();
            sp_instr_error *i= new (thd->mem_root)
              sp_instr_error(ip, lex->spcont, ER_SP_CASE_NOT_FOUND);
            if (unlikely(i == NULL) ||
                unlikely(sp->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 29998 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 555: /* sp_opt_label: %empty  */
#line 4662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lex_str)= null_clex_str; }
#line 30004 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 556: /* sp_opt_label: label_ident  */
#line 4663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 30010 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 557: /* sp_block_label: labels_declaration_oracle  */
#line 4668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->spcont->block_label_declare(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[0].lex_str);
          }
#line 30020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 558: /* $@70: %empty  */
#line 4678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 30030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 559: /* sp_labeled_block: sp_block_label BEGIN_ORACLE_SYM $@70 sp_block_statements_and_exceptions END sp_opt_label  */
#line 4686 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, Lex_spblock((yyvsp[-2].spblock_handlers)), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 560: /* $@71: %empty  */
#line 4692 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd, &(yyvsp[-1].lex_str));
          }
#line 30047 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 561: /* $@72: %empty  */
#line 4696 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 30056 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 562: /* sp_labeled_block: sp_block_label DECLARE_ORACLE_SYM $@71 opt_sp_decl_body_list $@72 BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END sp_opt_label  */
#line 4704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-5].spblock).hndlrs+= (yyvsp[-2].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-5].spblock), &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 565: /* $@73: %empty  */
#line 4718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 30078 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 566: /* sp_unlabeled_block: BEGIN_ORACLE_SYM opt_not_atomic $@73 sp_block_statements_and_exceptions END  */
#line 4727 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_finalize(thd, Lex_spblock((yyvsp[-1].spblock_handlers)))))
              MYSQL_YYABORT;
          }
#line 30087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 567: /* $@74: %empty  */
#line 4732 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd);
          }
#line 30097 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 568: /* $@75: %empty  */
#line 4738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 30106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 569: /* sp_unlabeled_block: DECLARE_ORACLE_SYM $@74 opt_sp_decl_body_list $@75 BEGIN_ORACLE_SYM sp_block_statements_and_exceptions END  */
#line 4745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-4].spblock).hndlrs+= (yyvsp[-1].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-4].spblock))))
              MYSQL_YYABORT;
          }
#line 30116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 570: /* sp_instr_addr: %empty  */
#line 4753 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.sp_instr_addr)= Lex->sphead->instructions(); }
#line 30122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 571: /* $@76: %empty  */
#line 4757 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_block_init(thd);
          }
#line 30130 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 572: /* $@77: %empty  */
#line 4761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_declarations(thd)))
              MYSQL_YYABORT;
          }
#line 30139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 573: /* $@78: %empty  */
#line 4767 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].spblock).hndlrs+= (yyvsp[0].spblock_handlers).hndlrs;
            if (unlikely(Lex->sp_block_finalize(thd, (yyvsp[-3].spblock))))
              MYSQL_YYABORT;
          }
#line 30149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 575: /* $@79: %empty  */
#line 4778 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_executable_section(thd, (yyvsp[-1].sp_instr_addr))))
              MYSQL_YYABORT;
          }
#line 30158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 576: /* sp_block_statements_and_exceptions: sp_instr_addr sp_proc_stmts $@79 opt_exception_clause  */
#line 4783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_block_with_exceptions_finalize_exceptions(thd, (yyvsp[-3].sp_instr_addr), (yyvsp[0].num))))
              MYSQL_YYABORT;
            (yyval.spblock_handlers).init((yyvsp[0].num));
          }
#line 30168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 577: /* opt_exception_clause: %empty  */
#line 4791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.num)= 0; }
#line 30174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 578: /* opt_exception_clause: EXCEPTION_ORACLE_SYM exception_handlers  */
#line 4792 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.num)= (yyvsp[0].num); }
#line 30180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 579: /* exception_handlers: exception_handler  */
#line 4796 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= 1; }
#line 30186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 580: /* exception_handlers: exception_handlers exception_handler  */
#line 4797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= (yyvsp[-1].num) + 1; }
#line 30192 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 581: /* $@80: %empty  */
#line 4802 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_init(thd, sp_handler::EXIT)))
              MYSQL_YYABORT;
          }
#line 30201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 582: /* exception_handler: WHEN_SYM $@80 sp_hcond_list THEN_SYM sp_proc_stmts1_implicit_block  */
#line 4809 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_handler_declaration_finalize(thd, sp_handler::EXIT)))
              MYSQL_YYABORT;
          }
#line 30210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 583: /* opt_sp_for_loop_direction: %empty  */
#line 4817 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= 1; }
#line 30216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 584: /* opt_sp_for_loop_direction: REVERSE_SYM  */
#line 4818 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= -1; }
#line 30222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 585: /* $@81: %empty  */
#line 4823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 586: /* sp_for_loop_index_and_bounds: ident_directly_assignable $@81 sp_for_loop_bounds  */
#line 4828 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (unlikely(Lex->sp_for_loop_declarations(thd, &(yyval.for_loop), &(yyvsp[-2].ident_sys), (yyvsp[0].for_loop_bounds))))
              MYSQL_YYABORT;
          }
#line 30241 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 587: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr DOT_DOT_SYM for_loop_bound_expr  */
#line 4838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.for_loop_bounds)= Lex_for_loop_bounds_intrange((yyvsp[-3].num), (yyvsp[-2].assignment_lex), (yyvsp[0].assignment_lex));
          }
#line 30249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 588: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction for_loop_bound_expr  */
#line 4842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.for_loop_bounds).m_direction= (yyvsp[-1].num);
            (yyval.for_loop_bounds).m_index= (yyvsp[0].assignment_lex);
            (yyval.for_loop_bounds).m_target_bound= NULL;
            (yyval.for_loop_bounds).m_implicit_cursor= false;
          }
#line 30260 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 589: /* sp_for_loop_bounds: IN_SYM opt_sp_for_loop_direction '(' sp_cursor_stmt ')'  */
#line 4849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_implicit_cursor_statement(thd, &(yyval.for_loop_bounds),
                                                                    (yyvsp[-1].sp_cursor_stmt))))
              MYSQL_YYABORT;
          }
#line 30270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 590: /* loop_body: sp_proc_stmts1 END LOOP_SYM  */
#line 4858 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump *i= new (thd->mem_root)
              sp_instr_jump(ip, lex->spcont, lab->ip);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
          }
#line 30285 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 591: /* $@82: %empty  */
#line 4872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sp_while_loop_expression(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            if (lex->main_select_push(true))
               MYSQL_YYABORT;
          }
#line 30300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 592: /* while_body: expr LOOP_SYM $@82 sp_proc_stmts1 END LOOP_SYM  */
#line 4883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_while_loop_finalize(thd)))
              MYSQL_YYABORT;
          }
#line 30309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 593: /* $@83: %empty  */
#line 4891 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30319 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 594: /* repeat_body: sp_proc_stmts1 UNTIL_SYM $@83 expr END REPEAT_SYM  */
#line 4897 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            uint ip= lex->sphead->instructions();
            sp_label *lab= lex->spcont->last_label();  /* Jumping back */
            sp_instr_jump_if_not *i= new (thd->mem_root)
              sp_instr_jump_if_not(ip, lex->spcont, (yyvsp[-2].item), lab->ip, lex);
            if (unlikely(i == NULL) ||
                unlikely(lex->sphead->add_instr(i)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (lex->sphead->restore_lex(thd))
              MYSQL_YYABORT;
            /* We can shortcut the cont_backpatch here */
            i->m_cont_dest= ip+1;
          }
#line 30339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 595: /* pop_sp_loop_label: sp_opt_label  */
#line 4916 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_pop_loop_label(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 30348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 596: /* $@84: %empty  */
#line 4924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 597: /* sp_labeled_control: labels_declaration_oracle LOOP_SYM $@84 loop_body pop_sp_loop_label  */
#line 4929 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 598: /* $@85: %empty  */
#line 4931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 599: /* sp_labeled_control: labels_declaration_oracle WHILE_SYM $@85 while_body pop_sp_loop_label  */
#line 4939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 600: /* $@86: %empty  */
#line 4941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30390 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 601: /* $@87: %empty  */
#line 4946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-3].lex_str)))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 602: /* $@88: %empty  */
#line 4955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 603: /* sp_labeled_control: labels_declaration_oracle FOR_SYM $@86 sp_for_loop_index_and_bounds $@87 LOOP_SYM sp_proc_stmts1 END LOOP_SYM $@88 pop_sp_loop_label  */
#line 4960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-7].for_loop))))
              MYSQL_YYABORT;
          }
#line 30419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 604: /* $@89: %empty  */
#line 4965 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_label(thd, &(yyvsp[-1].lex_str))))
              MYSQL_YYABORT;
          }
#line 30428 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 605: /* sp_labeled_control: labels_declaration_oracle REPEAT_SYM $@89 repeat_body pop_sp_loop_label  */
#line 4970 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 30434 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 606: /* $@90: %empty  */
#line 4975 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 607: /* sp_unlabeled_control: LOOP_SYM $@90 loop_body  */
#line 4980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30451 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 608: /* $@91: %empty  */
#line 4984 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
            Lex->sphead->reset_lex(thd);
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 30463 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 609: /* sp_unlabeled_control: WHILE_SYM $@91 while_body  */
#line 4992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 610: /* $@92: %empty  */
#line 4996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            // See "The FOR LOOP statement" comments in sql_lex.cc
            if (unlikely(Lex->maybe_start_compound_statement(thd)))
              MYSQL_YYABORT;
            Lex->sp_block_init(thd); // The outer DECLARE..BEGIN..END block
          }
#line 30482 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 611: /* $@93: %empty  */
#line 5003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd))) // The inner WHILE block
              MYSQL_YYABORT;
            if (unlikely(Lex->sp_for_loop_condition_test(thd, (yyvsp[0].for_loop))))
              MYSQL_YYABORT;
          }
#line 30493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 612: /* sp_unlabeled_control: FOR_SYM $@92 sp_for_loop_index_and_bounds $@93 LOOP_SYM sp_proc_stmts1 END LOOP_SYM  */
#line 5012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_for_loop_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
            Lex->sp_pop_loop_empty_label(thd); // The inner WHILE block
            if (unlikely(Lex->sp_for_loop_outer_block_finalize(thd, (yyvsp[-5].for_loop))))
              MYSQL_YYABORT;
          }
#line 30505 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 613: /* $@94: %empty  */
#line 5020 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_loop_empty_label(thd)))
              MYSQL_YYABORT;
          }
#line 30514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 614: /* sp_unlabeled_control: REPEAT_SYM $@94 repeat_body  */
#line 5025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sp_pop_loop_empty_label(thd);
          }
#line 30522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 615: /* trg_action_time: BEFORE_SYM  */
#line 5032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_BEFORE; }
#line 30528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 616: /* trg_action_time: AFTER_SYM  */
#line 5034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.action_time= TRG_ACTION_AFTER; }
#line 30534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 617: /* trg_event: INSERT  */
#line 5039 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_INSERT; }
#line 30540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 618: /* trg_event: UPDATE_SYM  */
#line 5041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_UPDATE; }
#line 30546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 619: /* trg_event: DELETE_SYM  */
#line 5043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { Lex->trg_chistics.event= TRG_EVENT_DELETE; }
#line 30552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 623: /* opt_logfile_group_name: %empty  */
#line 5077 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 624: /* opt_logfile_group_name: USE_SYM LOGFILE_SYM GROUP_SYM ident  */
#line 5079 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
          }
#line 30567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 625: /* alter_tablespace_info: tablespace_name ADD ts_datafile alter_tablespace_option_list  */
#line 5089 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_ADD_FILE; 
          }
#line 30575 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 626: /* alter_tablespace_info: tablespace_name DROP ts_datafile alter_tablespace_option_list  */
#line 5095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->alter_tablespace_info->ts_alter_tablespace_type= ALTER_TABLESPACE_DROP_FILE; 
          }
#line 30583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 631: /* $@95: %empty  */
#line 5118 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 678: /* ts_datafile: DATAFILE_SYM TEXT_STRING_sys  */
#line 5212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->data_file_name= (yyvsp[0].lex_str).str;
          }
#line 30598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 679: /* lg_undofile: UNDOFILE_SYM TEXT_STRING_sys  */
#line 5220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_file_name= (yyvsp[0].lex_str).str;
          }
#line 30607 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 680: /* lg_redofile: REDOFILE_SYM TEXT_STRING_sys  */
#line 5228 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_file_name= (yyvsp[0].lex_str).str;
          }
#line 30616 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 681: /* tablespace_name: ident  */
#line 5236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->tablespace_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 30630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 682: /* logfile_group_name: ident  */
#line 5249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info= (new (thd->mem_root)
                                         st_alter_tablespace());
            if (unlikely(lex->alter_tablespace_info == NULL))
              MYSQL_YYABORT;
            lex->alter_tablespace_info->logfile_group_name= (yyvsp[0].ident_sys).str;
            lex->sql_command= SQLCOM_ALTER_TABLESPACE;
          }
#line 30644 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 683: /* ts_access_mode: READ_ONLY_SYM  */
#line 5262 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_ONLY;
          }
#line 30653 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 684: /* ts_access_mode: READ_WRITE_SYM  */
#line 5267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_READ_WRITE;
          }
#line 30662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 685: /* ts_access_mode: NOT_SYM ACCESSIBLE_SYM  */
#line 5272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_access_mode= TS_NOT_ACCESSIBLE;
          }
#line 30671 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 686: /* opt_ts_initial_size: INITIAL_SIZE_SYM opt_equal size_number  */
#line 5280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->initial_size= (yyvsp[0].ulonglong_number);
          }
#line 30680 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 687: /* opt_ts_autoextend_size: AUTOEXTEND_SIZE_SYM opt_equal size_number  */
#line 5288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->autoextend_size= (yyvsp[0].ulonglong_number);
          }
#line 30689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 688: /* opt_ts_max_size: MAX_SIZE_SYM opt_equal size_number  */
#line 5296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->max_size= (yyvsp[0].ulonglong_number);
          }
#line 30698 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 689: /* opt_ts_extent_size: EXTENT_SIZE_SYM opt_equal size_number  */
#line 5304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->extent_size= (yyvsp[0].ulonglong_number);
          }
#line 30707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 690: /* opt_ts_undo_buffer_size: UNDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->undo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 30716 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 691: /* opt_ts_redo_buffer_size: REDO_BUFFER_SIZE_SYM opt_equal size_number  */
#line 5320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->redo_buffer_size= (yyvsp[0].ulonglong_number);
          }
#line 30725 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 692: /* opt_ts_nodegroup: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 5328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->nodegroup_id != UNDEF_NODEGROUP))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NODEGROUP"));
            lex->alter_tablespace_info->nodegroup_id= (yyvsp[0].ulong_num);
          }
#line 30736 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 693: /* opt_ts_comment: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 5338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->ts_comment != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"COMMENT"));
            lex->alter_tablespace_info->ts_comment= (yyvsp[0].lex_str).str;
          }
#line 30747 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 694: /* opt_ts_engine: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 5348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->alter_tablespace_info->storage_engine != NULL))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE, MYF(0),
                                "STORAGE ENGINE"));
            lex->alter_tablespace_info->storage_engine= (yyvsp[0].db_type);
          }
#line 30759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 697: /* ts_wait: WAIT_SYM  */
#line 5364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->wait_until_completed= TRUE;
          }
#line 30768 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 698: /* ts_wait: NO_WAIT_SYM  */
#line 5369 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!(lex->alter_tablespace_info->wait_until_completed)))
              my_yyabort_error((ER_FILEGROUP_OPTION_ONLY_ONCE,MYF(0),"NO_WAIT"));
            lex->alter_tablespace_info->wait_until_completed= FALSE;
          }
#line 30779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 699: /* size_number: real_ulonglong_num  */
#line 5378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.ulonglong_number)= (yyvsp[0].ulonglong_number);}
#line 30785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 700: /* size_number: IDENT_sys  */
#line 5380 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].ident_sys).to_size_number(&(yyval.ulonglong_number)))
              MYSQL_YYABORT;
          }
#line 30794 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 701: /* $@96: %empty  */
#line 5392 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.option_list= NULL; }
#line 30800 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 702: /* create_body: create_field_list_parens $@96 opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                             {}
#line 30806 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 703: /* create_body: opt_create_table_options opt_create_partitioning opt_create_select  */
#line 5394 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                                             {}
#line 30812 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 704: /* create_body: create_like  */
#line 5396 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {

            Lex->create_info.add(DDL_options_st::OPT_LIKE);
            TABLE_LIST *src_table= Lex->first_select_lex()->
              add_table_to_list(thd, (yyvsp[0].table), NULL, 0, TL_READ, MDL_SHARED_READ);
            if (unlikely(! src_table))
              MYSQL_YYABORT;
            /* CREATE TABLE ... LIKE is not allowed for views. */
            src_table->required_type= TABLE_TYPE_NORMAL;
          }
#line 30827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 705: /* create_like: LIKE table_ident  */
#line 5409 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.table)= (yyvsp[0].table); }
#line 30833 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 706: /* create_like: LEFT_PAREN_LIKE LIKE table_ident ')'  */
#line 5410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.table)= (yyvsp[-1].table); }
#line 30839 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 707: /* opt_create_select: %empty  */
#line 5414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30845 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 708: /* opt_create_select: opt_duplicate opt_as create_select_query_expression opt_versioning_option  */
#line 5417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 30854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 709: /* create_select_query_expression: query_expression  */
#line 5425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_insert_select((yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 30863 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 710: /* create_select_query_expression: LEFT_PAREN_WITH with_clause query_expression_no_with_clause ')'  */
#line 5430 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *first_select= (yyvsp[-1].select_lex_unit)->first_select();
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to(first_select);
            if (Lex->parsed_insert_select(first_select))
              MYSQL_YYABORT;
          }
#line 30875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 711: /* opt_create_partitioning: opt_partitioning  */
#line 5441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Remove all tables used in PARTITION clause from the global table
              list. Partitioning with subqueries is not allowed anyway.
            */
            TABLE_LIST *last_non_sel_table= Lex->create_last_non_select_table;
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;
          }
#line 30889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 712: /* opt_partitioning: %empty  */
#line 5477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 30895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 714: /* $@97: %empty  */
#line 5483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;
            if (lex->sql_command == SQLCOM_ALTER_TABLE)
            {
              lex->alter_info.partition_flags|= ALTER_PARTITION_INFO;
            }
          }
#line 30910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 716: /* have_partitioning: %empty  */
#line 5498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef WITH_PARTITION_STORAGE_ENGINE
            LEX_CSTRING partition_name={STRING_WITH_LEN("partition")};
            if (unlikely(!plugin_is_ready(&partition_name, MYSQL_STORAGE_ENGINE_PLUGIN)))
              my_yyabort_error((ER_OPTION_PREVENTS_STATEMENT, MYF(0),
                                "--skip-partition"));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), "partitioning",
                              "--with-plugin-partition"));
#endif
          }
#line 30926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 717: /* $@98: %empty  */
#line 5513 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->part_info))
            {
              thd->parse_error(ER_PARTITION_ENTRY_ERROR);
              MYSQL_YYABORT;
            }
            DBUG_ASSERT(Lex->part_info->table);
            /*
              We enter here when opening the frm file to translate
              partition info string into part_info data structure.
            */
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 30945 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 718: /* partition_entry: PARTITION_SYM $@98 partition  */
#line 5528 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 30953 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 719: /* $@99: %empty  */
#line 5535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->safe_to_cache_query= 1; }
#line 30959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 721: /* part_type_def: opt_linear KEY_SYM opt_key_algo '(' part_field_list ')'  */
#line 5541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->list_of_part_fields= TRUE;
            part_info->column_list= FALSE;
            part_info->part_type= HASH_PARTITION;
          }
#line 30970 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 722: /* $@100: %empty  */
#line 5548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= HASH_PARTITION; }
#line 30976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 723: /* part_type_def: opt_linear HASH_SYM $@100 part_func  */
#line 5549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 30982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 724: /* part_type_def: RANGE_SYM part_func  */
#line 5551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 30988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 725: /* part_type_def: RANGE_SYM part_column_list  */
#line 5553 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= RANGE_PARTITION; }
#line 30994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 726: /* $@101: %empty  */
#line 5555 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= IN_PART_FUNC;
          }
#line 31002 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 727: /* part_type_def: LIST_SYM $@101 part_func  */
#line 5559 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
	    Lex->part_info->part_type= LIST_PARTITION; 
	    Select->parsing_place= NO_MATTER;
	  }
#line 31011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 728: /* part_type_def: LIST_SYM part_column_list  */
#line 5564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->part_type= LIST_PARTITION; }
#line 31017 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 729: /* $@102: %empty  */
#line 5566 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(Lex->part_info->vers_init_info(thd)))
               MYSQL_YYABORT;
          }
#line 31026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 731: /* opt_linear: %empty  */
#line 5574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31032 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 732: /* opt_linear: LINEAR_SYM  */
#line 5576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->linear_hash_ind= TRUE;}
#line 31038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 733: /* opt_key_algo: %empty  */
#line 5581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_NONE;}
#line 31044 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 734: /* opt_key_algo: ALGORITHM_SYM '=' real_ulong_num  */
#line 5583 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch ((yyvsp[0].ulong_num)) {
            case 1:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_51;
              break;
            case 2:
              Lex->part_info->key_algorithm= partition_info::KEY_ALGORITHM_55;
              break;
            default:
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 31062 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 735: /* part_field_list: %empty  */
#line 5599 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 736: /* part_field_list: part_field_item_list  */
#line 5600 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 31074 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 737: /* part_field_item_list: part_field_item  */
#line 5604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31080 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 738: /* part_field_item_list: part_field_item_list ',' part_field_item  */
#line 5605 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   {}
#line 31086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 739: /* part_field_item: ident  */
#line 5610 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_columns++;
            if (unlikely(part_info->part_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;
            if (unlikely(part_info->num_columns > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of partition fields"));
          }
#line 31101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 740: /* part_column_list: COLUMNS '(' part_field_list ')'  */
#line 5624 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->column_list= TRUE;
            part_info->list_of_part_fields= TRUE;
          }
#line 31111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 741: /* part_func: '(' part_func_expr ')'  */
#line 5634 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->set_part_expr(thd, (yyvsp[-1].item), FALSE)))
              MYSQL_YYABORT;
            part_info->num_columns= 1;
            part_info->column_list= FALSE;
          }
#line 31123 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 742: /* sub_part_func: '(' part_func_expr ')'  */
#line 5645 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->part_info->set_part_expr(thd, (yyvsp[-1].item), TRUE)))
              MYSQL_YYABORT;
          }
#line 31132 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 743: /* opt_num_parts: %empty  */
#line 5653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31138 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 744: /* opt_num_parts: PARTITIONS_SYM real_ulong_num  */
#line 5655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            uint num_parts= (yyvsp[0].ulong_num);
            partition_info *part_info= Lex->part_info;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "partitions"));

            part_info->num_parts= num_parts;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 745: /* opt_sub_part: %empty  */
#line 5667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 746: /* $@103: %empty  */
#line 5669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->subpart_type= HASH_PARTITION; }
#line 31164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 747: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear HASH_SYM sub_part_func $@103 opt_num_subparts  */
#line 5670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 31170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 748: /* $@104: %empty  */
#line 5673 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->subpart_type= HASH_PARTITION;
            part_info->list_of_subpart_fields= TRUE;
          }
#line 31180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 749: /* opt_sub_part: SUBPARTITION_SYM BY opt_linear KEY_SYM opt_key_algo '(' sub_part_field_list ')' $@104 opt_num_subparts  */
#line 5678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 31186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 750: /* sub_part_field_list: sub_part_field_item  */
#line 5682 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31192 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 751: /* sub_part_field_list: sub_part_field_list ',' sub_part_field_item  */
#line 5683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                      {}
#line 31198 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 752: /* sub_part_field_item: ident  */
#line 5688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->subpart_field_list.push_back((yyvsp[0].ident_sys).str,
                         thd->mem_root)))
              MYSQL_YYABORT;

            if (unlikely(part_info->subpart_field_list.elements > MAX_REF_PARTS))
              my_yyabort_error((ER_TOO_MANY_PARTITION_FUNC_FIELDS_ERROR, MYF(0),
                                "list of subpartition fields"));
          }
#line 31213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 753: /* part_func_expr: bit_expr  */
#line 5702 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            (yyval.item)=(yyvsp[0].item);
          }
#line 31226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 754: /* opt_num_subparts: %empty  */
#line 5713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 755: /* opt_num_subparts: SUBPARTITIONS_SYM real_ulong_num  */
#line 5715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            uint num_parts= (yyvsp[0].ulong_num);
            LEX *lex= Lex;
            if (unlikely(num_parts == 0))
              my_yyabort_error((ER_NO_PARTS_ERROR, MYF(0), "subpartitions"));
            lex->part_info->num_subparts= num_parts;
            lex->part_info->use_default_num_subpartitions= FALSE;
          }
#line 31245 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 756: /* part_defs: %empty  */
#line 5727 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == RANGE_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "RANGE"));
            if (unlikely(part_info->part_type == LIST_PARTITION))
              my_yyabort_error((ER_PARTITIONS_MUST_BE_DEFINED_ERROR, MYF(0),
                                "LIST"));
          }
#line 31259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 757: /* part_defs: '(' part_def_list ')'  */
#line 5737 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            uint count_curr_parts= part_info->partitions.elements;
            if (part_info->num_parts != 0)
            {
              if (unlikely(part_info->num_parts !=
                           count_curr_parts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_PART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (count_curr_parts > 0)
            {
              part_info->num_parts= count_curr_parts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 758: /* part_def_list: part_definition  */
#line 5758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 759: /* part_def_list: part_def_list ',' part_definition  */
#line 5759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            {}
#line 31294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 760: /* $@105: %empty  */
#line 5764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= new (thd->mem_root) partition_element();

            if (unlikely(!p_elem) ||
                unlikely(part_info->partitions.push_back(p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            p_elem->part_state= PART_NORMAL;
            p_elem->id= part_info->partitions.elements - 1;
            part_info->curr_part_elem= p_elem;
            part_info->current_partition= p_elem;
            part_info->use_default_partitions= FALSE;
            part_info->use_default_num_partitions= FALSE;
          }
#line 31314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 761: /* part_definition: PARTITION_SYM $@105 part_name opt_part_values opt_part_options opt_sub_partition  */
#line 5783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 31320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 762: /* part_name: ident  */
#line 5788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *p_elem= part_info->curr_part_elem;
            if (unlikely(check_ident_length(&(yyvsp[0].ident_sys))))
              MYSQL_YYABORT;
            p_elem->partition_name= (yyvsp[0].ident_sys).str;
          }
#line 31332 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 763: /* opt_part_values: %empty  */
#line 5799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->error_if_requires_values()))
                MYSQL_YYABORT;
              if (unlikely(part_info->part_type == VERSIONING_PARTITION))
                my_yyabort_error((ER_VERS_WRONG_PARTS, MYF(0),
                                  lex->create_last_non_select_table->
                                  table_name.str));
            }
            else
              part_info->part_type= HASH_PARTITION;
          }
#line 31352 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 764: /* $@106: %empty  */
#line 5815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != RANGE_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "RANGE", "LESS THAN"));
            }
            else
              part_info->part_type= RANGE_PARTITION;
          }
#line 31369 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 765: /* opt_part_values: VALUES_LESS_SYM THAN_SYM $@106 part_func_max  */
#line 5827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 31375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 766: /* $@107: %empty  */
#line 5829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "IN"));
            }
            else
              part_info->part_type= LIST_PARTITION;
          }
#line 31392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 767: /* opt_part_values: VALUES_IN_SYM $@107 part_values_in  */
#line 5841 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 31398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 768: /* opt_part_values: CURRENT_SYM  */
#line 5843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->part_values_current(thd))
              MYSQL_YYABORT;
          }
#line 31407 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 769: /* opt_part_values: HISTORY_SYM  */
#line 5848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->part_values_history(thd))
              MYSQL_YYABORT;
          }
#line 31416 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 770: /* opt_part_values: DEFAULT  */
#line 5853 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            if (! lex->is_partition_management())
            {
              if (unlikely(part_info->part_type != LIST_PARTITION))
                my_yyabort_error((ER_PARTITION_WRONG_VALUES_ERROR, MYF(0),
                                  "LIST", "DEFAULT"));
            }
            else
              part_info->part_type= LIST_PARTITION;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
         }
#line 31437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 771: /* part_func_max: MAXVALUE_SYM  */
#line 5873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;

            if (unlikely(part_info->num_columns &&
                         part_info->num_columns != 1U))
            {
              part_info->print_debug("Kilroy II", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            else
              part_info->num_columns= 1U;
            if (unlikely(part_info->init_column_part(thd)))
              MYSQL_YYABORT;
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31459 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 772: /* part_func_max: part_value_item  */
#line 5890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 773: /* part_values_in: part_value_item  */
#line 5895 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            part_info->print_debug("part_values_in: part_value_item", NULL);

            if (part_info->num_columns != 1U)
            {
              if (unlikely(!lex->is_partition_management() ||
                           part_info->num_columns == 0 ||
                           part_info->num_columns > MAX_REF_PARTS))
              {
                part_info->print_debug("Kilroy III", NULL);
                thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
                MYSQL_YYABORT;
              }
              /*
                Reorganize the current large array into a list of small
                arrays with one entry in each array. This can happen
                in the first partition of an ALTER TABLE statement where
                we ADD or REORGANIZE partitions. Also can only happen
                for LIST partitions.
              */
              if (unlikely(part_info->reorganize_into_single_field_col_val(thd)))
                MYSQL_YYABORT;
            }
          }
#line 31496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 774: /* part_values_in: '(' part_value_list ')'  */
#line 5922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_columns < 2U))
            {
              thd->parse_error(ER_ROW_SINGLE_PARTITION_FIELD_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 31509 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 775: /* part_value_list: part_value_item  */
#line 5933 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31515 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 776: /* part_value_list: part_value_list ',' part_value_item  */
#line 5934 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              {}
#line 31521 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 777: /* $@108: %empty  */
#line 5939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug("( part_value_item", NULL);
            /* Initialisation code needed for each list of value expressions */
            if (unlikely(!(part_info->part_type == LIST_PARTITION &&
                           part_info->num_columns == 1U) &&
                           part_info->init_column_part(thd)))
              MYSQL_YYABORT;
          }
#line 31535 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 778: /* $@109: %empty  */
#line 5948 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 31541 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 779: /* part_value_item: '(' $@108 part_value_item_list $@109 ')'  */
#line 5950 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->print_debug(") part_value_item", NULL);
            if (part_info->num_columns == 0)
              part_info->num_columns= part_info->curr_list_object;
            if (unlikely(part_info->num_columns != part_info->curr_list_object))
            {
              /*
                All value items lists must be of equal length, in some cases
                which is covered by the above if-statement we don't know yet
                how many columns is in the partition so the assignment above
                ensures that we only report errors when we know we have an
                error.
              */
              part_info->print_debug("Kilroy I", NULL);
              thd->parse_error(ER_PARTITION_COLUMN_LIST_ERROR);
              MYSQL_YYABORT;
            }
            part_info->curr_list_object= 0;
          }
#line 31566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 780: /* part_value_item_list: part_value_expr_item  */
#line 5973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 31572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 781: /* part_value_item_list: part_value_item_list ',' part_value_expr_item  */
#line 5974 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                        {}
#line 31578 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 782: /* part_value_expr_item: MAXVALUE_SYM  */
#line 5979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->part_type == LIST_PARTITION))
            {
              thd->parse_error(ER_MAXVALUE_IN_VALUES_IN);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_max_value(thd)))
              MYSQL_YYABORT;
          }
#line 31593 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 783: /* part_value_expr_item: bit_expr  */
#line 5990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            partition_info *part_info= lex->part_info;
            Item *part_expr= (yyvsp[0].item);

            if (unlikely(!lex->safe_to_cache_query))
            {
              thd->parse_error(ER_WRONG_EXPR_IN_PARTITION_FUNC_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(part_info->add_column_list_value(thd, part_expr)))
              MYSQL_YYABORT;
          }
#line 31611 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 784: /* opt_sub_partition: %empty  */
#line 6008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (unlikely(part_info->num_subparts != 0 &&
                         !part_info->use_default_subpartitions))
            {
              /*
                We come here when we have defined subpartitions on the first
                partition but not on all the subsequent partitions. 
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
          }
#line 31629 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 785: /* opt_sub_partition: '(' sub_part_list ')'  */
#line 6022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            if (part_info->num_subparts != 0)
            {
              if (unlikely(part_info->num_subparts !=
                           part_info->count_curr_subparts))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
            }
            else if (part_info->count_curr_subparts > 0)
            {
              if (unlikely(part_info->partitions.elements > 1))
              {
                thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
                MYSQL_YYABORT;
              }
              part_info->num_subparts= part_info->count_curr_subparts;
            }
            part_info->count_curr_subparts= 0;
          }
#line 31656 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 786: /* sub_part_list: sub_part_definition  */
#line 6047 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 787: /* sub_part_list: sub_part_list ',' sub_part_definition  */
#line 6048 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                {}
#line 31668 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 788: /* $@110: %empty  */
#line 6053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            partition_element *curr_part= part_info->current_partition;
            partition_element *sub_p_elem= new (thd->mem_root)
                                           partition_element(curr_part);
            if (unlikely(part_info->use_default_subpartitions &&
                         part_info->partitions.elements >= 2))
            {
              /*
                create table t1 (a int)
                partition by list (a) subpartition by hash (a)
                (partition p0 values in (1),
                 partition p1 values in (2) subpartition sp11);
                causes use to arrive since we are on the second
                partition, but still use_default_subpartitions
                is set. When we come here we're processing at least
                the second partition (the current partition processed
                have already been put into the partitions list.
              */
              thd->parse_error(ER_PARTITION_WRONG_NO_SUBPART_ERROR);
              MYSQL_YYABORT;
            }
            if (unlikely(!sub_p_elem) ||
                unlikely(curr_part->subpartitions.push_back(sub_p_elem, thd->mem_root)))
              MYSQL_YYABORT;

            sub_p_elem->id= curr_part->subpartitions.elements - 1;
            part_info->curr_part_elem= sub_p_elem;
            part_info->use_default_subpartitions= FALSE;
            part_info->use_default_num_subpartitions= FALSE;
            part_info->count_curr_subparts++;
          }
#line 31705 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 789: /* sub_part_definition: SUBPARTITION_SYM $@110 sub_name opt_part_options  */
#line 6085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    {}
#line 31711 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 790: /* sub_name: ident_or_text  */
#line 6090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(check_ident_length(&(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
            Lex->part_info->curr_part_elem->partition_name= (yyvsp[0].lex_str).str;
          }
#line 31721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 791: /* opt_part_options: %empty  */
#line 6098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 31727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 792: /* opt_part_options: opt_part_option_list  */
#line 6099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 31733 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 793: /* opt_part_option_list: opt_part_option_list opt_part_option  */
#line 6103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              {}
#line 31739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 794: /* opt_part_option_list: opt_part_option  */
#line 6104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 31745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 795: /* opt_part_option: TABLESPACE opt_equal ident_or_text  */
#line 6109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->tablespace_name= (yyvsp[0].lex_str).str; }
#line 31751 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 796: /* opt_part_option: opt_storage ENGINE_SYM opt_equal storage_engines  */
#line 6111 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->curr_part_elem->engine_type= (yyvsp[0].db_type);
            part_info->default_engine_type= (yyvsp[0].db_type);
          }
#line 31761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 797: /* opt_part_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info->curr_part_elem->connect_string.str= (yyvsp[0].lex_str).str;
            lex->part_info->curr_part_elem->connect_string.length= (yyvsp[0].lex_str).length;
          }
#line 31771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 798: /* opt_part_option: NODEGROUP_SYM opt_equal real_ulong_num  */
#line 6123 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->nodegroup_id= (uint16) (yyvsp[0].ulong_num); }
#line 31777 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 799: /* opt_part_option: MAX_ROWS opt_equal real_ulonglong_num  */
#line 6125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_max_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 31783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 800: /* opt_part_option: MIN_ROWS opt_equal real_ulonglong_num  */
#line 6127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_min_rows= (ha_rows) (yyvsp[0].ulonglong_number); }
#line 31789 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 801: /* opt_part_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6129 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->data_file_name= (yyvsp[0].lex_str).str; }
#line 31795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 802: /* opt_part_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6131 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->index_file_name= (yyvsp[0].lex_str).str; }
#line 31801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 803: /* opt_part_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6133 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->part_info->curr_part_elem->part_comment= (yyvsp[0].lex_str).str; }
#line 31807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 804: /* opt_versioning_rotation: %empty  */
#line 6137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 31813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 805: /* $@111: %empty  */
#line 6138 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         { Lex->clause_that_disallows_subselect= "INTERVAL"; }
#line 31819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 806: /* opt_versioning_rotation: $@111 INTERVAL_SYM expr interval opt_versioning_interval_start  */
#line 6140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           partition_info *part_info= Lex->part_info;
           if (unlikely(part_info->vers_set_interval(thd, (yyvsp[-2].item), (yyvsp[-1].interval), (yyvsp[0].ulong_num))))
             MYSQL_YYABORT;
         }
#line 31829 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 807: /* opt_versioning_rotation: LIMIT ulonglong_num  */
#line 6146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         partition_info *part_info= Lex->part_info;
         if (unlikely(part_info->vers_set_limit((yyvsp[0].ulonglong_number))))
         {
           my_error(ER_PART_WRONG_VALUE, MYF(0),
                    Lex->create_last_non_select_table->table_name.str,
                    "LIMIT");
           MYSQL_YYABORT;
         }
       }
#line 31844 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 808: /* opt_versioning_interval_start: %empty  */
#line 6161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           (yyval.ulong_num)= thd->query_start();
         }
#line 31852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 809: /* opt_versioning_interval_start: STARTS_SYM ulong_num  */
#line 6165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           /* only allowed from mysql_unpack_partition() */
           if (unlikely(!Lex->part_info->table))
           {
             thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].kwd).pos());
             MYSQL_YYABORT;
           }
           (yyval.ulong_num)= (ulong)(yyvsp[0].ulong_num);
         }
#line 31866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 810: /* opt_as: %empty  */
#line 6181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31872 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 811: /* opt_as: AS  */
#line 6182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 31878 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 812: /* opt_create_database_options: %empty  */
#line 6186 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 31884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 813: /* opt_create_database_options: create_database_options  */
#line 6187 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 31890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 814: /* create_database_options: create_database_option  */
#line 6191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 31896 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 815: /* create_database_options: create_database_options create_database_option  */
#line 6192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                         {}
#line 31902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 816: /* create_database_option: default_collation  */
#line 6196 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 31908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 817: /* create_database_option: default_charset  */
#line 6197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 31914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 818: /* opt_if_not_exists_table_element: %empty  */
#line 6202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->check_exists= FALSE;
          }
#line 31922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 819: /* opt_if_not_exists_table_element: IF_SYM not EXISTS  */
#line 6206 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->check_exists= TRUE;
          }
#line 31930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 820: /* opt_if_not_exists: %empty  */
#line 6213 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 31938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 821: /* opt_if_not_exists: IF_SYM not EXISTS  */
#line 6217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_NOT_EXISTS);
          }
#line 31946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 822: /* create_or_replace: CREATE  */
#line 6224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).init();
          }
#line 31954 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 823: /* create_or_replace: CREATE OR_SYM REPLACE  */
#line 6228 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.object_ddl_options).set(DDL_options_st::OPT_OR_REPLACE);
          }
#line 31962 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 831: /* create_table_option: ENGINE_SYM opt_equal ident_or_text  */
#line 6251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!lex->m_sql_cmd)
            {
              DBUG_ASSERT(lex->sql_command == SQLCOM_ALTER_TABLE);
              if (!(lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table()))
                MYSQL_YYABORT;
            }
            Storage_engine_name *opt=
              lex->m_sql_cmd->option_storage_engine_name();
            DBUG_ASSERT(opt); // Expect a proper Sql_cmd
            *opt= Storage_engine_name((yyvsp[0].lex_str));
            lex->create_info.used_fields|= HA_CREATE_USED_ENGINE;
          }
#line 31981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 832: /* create_table_option: MAX_ROWS opt_equal ulonglong_num  */
#line 6266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.max_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MAX_ROWS;
          }
#line 31990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 833: /* create_table_option: MIN_ROWS opt_equal ulonglong_num  */
#line 6271 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.min_rows= (yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_MIN_ROWS;
          }
#line 31999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 834: /* create_table_option: AVG_ROW_LENGTH opt_equal ulong_num  */
#line 6276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.avg_row_length=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_AVG_ROW_LENGTH;
          }
#line 32008 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 835: /* create_table_option: PASSWORD_SYM opt_equal TEXT_STRING_sys  */
#line 6281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.password=(yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_PASSWORD;
          }
#line 32017 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 836: /* create_table_option: COMMENT_SYM opt_equal TEXT_STRING_sys  */
#line 6286 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.comment=(yyvsp[0].lex_str);
            Lex->create_info.used_fields|= HA_CREATE_USED_COMMENT;
          }
#line 32026 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 837: /* create_table_option: AUTO_INC opt_equal ulonglong_num  */
#line 6291 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.auto_increment_value=(yyvsp[0].ulonglong_number);
            Lex->create_info.used_fields|= HA_CREATE_USED_AUTO;
          }
#line 32035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 838: /* create_table_option: PACK_KEYS_SYM opt_equal ulong_num  */
#line 6296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_PACK_KEYS;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_PACK_KEYS;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 839: /* create_table_option: PACK_KEYS_SYM opt_equal DEFAULT  */
#line 6311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_PACK_KEYS | HA_OPTION_NO_PACK_KEYS);
            Lex->create_info.used_fields|= HA_CREATE_USED_PACK_KEYS;
          }
#line 32064 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 840: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal ulong_num  */
#line 6317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_OFF;
                break;
            case 1:
                Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_ON;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 841: /* create_table_option: STATS_AUTO_RECALC_SYM opt_equal DEFAULT  */
#line 6332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.stats_auto_recalc= HA_STATS_AUTO_RECALC_DEFAULT;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_AUTO_RECALC;
          }
#line 32092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 842: /* create_table_option: STATS_PERSISTENT_SYM opt_equal ulong_num  */
#line 6337 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            switch((yyvsp[0].ulong_num)) {
            case 0:
                Lex->create_info.table_options|= HA_OPTION_NO_STATS_PERSISTENT;
                break;
            case 1:
                Lex->create_info.table_options|= HA_OPTION_STATS_PERSISTENT;
                break;
            default:
                thd->parse_error();
                MYSQL_YYABORT;
            }
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 843: /* create_table_option: STATS_PERSISTENT_SYM opt_equal DEFAULT  */
#line 6352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options&=
              ~(HA_OPTION_STATS_PERSISTENT | HA_OPTION_NO_STATS_PERSISTENT);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_PERSISTENT;
          }
#line 32121 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 844: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal ulong_num  */
#line 6358 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* From user point of view STATS_SAMPLE_PAGES can be specified as
            STATS_SAMPLE_PAGES=N (where 0<N<=65535, it does not make sense to
            scan 0 pages) or STATS_SAMPLE_PAGES=default. Internally we record
            =default as 0. See create_frm() in sql/table.cc, we use only two
            bytes for stats_sample_pages and this is why we do not allow
            larger values. 65535 pages, 16kb each means to sample 1GB, which
            is impractical. If at some point this needs to be extended, then
            we can store the higher bits from stats_sample_pages in .frm too. */
            if (unlikely((yyvsp[0].ulong_num) == 0 || (yyvsp[0].ulong_num) > 0xffff))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            Lex->create_info.stats_sample_pages=(yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 845: /* create_table_option: STATS_SAMPLE_PAGES_SYM opt_equal DEFAULT  */
#line 6376 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.stats_sample_pages=0;
            Lex->create_info.used_fields|= HA_CREATE_USED_STATS_SAMPLE_PAGES;
          }
#line 32152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 846: /* create_table_option: CHECKSUM_SYM opt_equal ulong_num  */
#line 6381 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
            Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32161 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 847: /* create_table_option: TABLE_CHECKSUM_SYM opt_equal ulong_num  */
#line 6386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_CHECKSUM : HA_OPTION_NO_CHECKSUM;
             Lex->create_info.used_fields|= HA_CREATE_USED_CHECKSUM;
          }
#line 32170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 848: /* create_table_option: PAGE_CHECKSUM_SYM opt_equal choice  */
#line 6391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_PAGE_CHECKSUM;
            Lex->create_info.page_checksum= (yyvsp[0].choice);
          }
#line 32179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 849: /* create_table_option: DELAY_KEY_WRITE_SYM opt_equal ulong_num  */
#line 6396 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.table_options|= (yyvsp[0].ulong_num) ? HA_OPTION_DELAY_KEY_WRITE : HA_OPTION_NO_DELAY_KEY_WRITE;
            Lex->create_info.used_fields|= HA_CREATE_USED_DELAY_KEY_WRITE;
          }
#line 32188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 850: /* create_table_option: ROW_FORMAT_SYM opt_equal row_types  */
#line 6401 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.row_type= (yyvsp[0].row_type);
            Lex->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
          }
#line 32197 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 851: /* $@112: %empty  */
#line 6406 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->first_select_lex()->table_list.save_and_clear(&Lex->save_list);
          }
#line 32205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 852: /* create_table_option: UNION_SYM opt_equal $@112 '(' opt_table_list ')'  */
#line 6410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Move the union list to the merge_list and exclude its tables
              from the global list.
            */
            LEX *lex=Lex;
            lex->create_info.merge_list= lex->first_select_lex()->table_list.first;
            lex->first_select_lex()->table_list= lex->save_list;
            /*
              When excluding union list from the global list we assume that
              elements of the former immediately follow elements which represent
              table being created/altered and parent tables.
            */
            TABLE_LIST *last_non_sel_table= lex->create_last_non_select_table;
            DBUG_ASSERT(last_non_sel_table->next_global ==
                        lex->create_info.merge_list);
            last_non_sel_table->next_global= 0;
            Lex->query_tables_last= &last_non_sel_table->next_global;

            lex->create_info.used_fields|= HA_CREATE_USED_UNION;
          }
#line 32231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 855: /* create_table_option: INSERT_METHOD opt_equal merge_insert_types  */
#line 6434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.merge_insert_method= (yyvsp[0].ulong_num);
            Lex->create_info.used_fields|= HA_CREATE_USED_INSERT_METHOD;
          }
#line 32240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 856: /* create_table_option: DATA_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.data_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_DATADIR;
          }
#line 32249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 857: /* create_table_option: INDEX_SYM DIRECTORY_SYM opt_equal TEXT_STRING_sys  */
#line 6444 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.index_file_name= (yyvsp[0].lex_str).str;
            Lex->create_info.used_fields|= HA_CREATE_USED_INDEXDIR;
          }
#line 32258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 858: /* create_table_option: TABLESPACE ident  */
#line 6449 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.tablespace= (yyvsp[0].ident_sys).str;}
#line 32264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 859: /* create_table_option: STORAGE_SYM DISK_SYM  */
#line 6451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.storage_media= HA_SM_DISK;}
#line 32270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 860: /* create_table_option: STORAGE_SYM MEMORY_SYM  */
#line 6453 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {Lex->create_info.storage_media= HA_SM_MEMORY;}
#line 32276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 861: /* create_table_option: CONNECTION_SYM opt_equal TEXT_STRING_sys  */
#line 6455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.connect_string.str= (yyvsp[0].lex_str).str;
            Lex->create_info.connect_string.length= (yyvsp[0].lex_str).length;
            Lex->create_info.used_fields|= HA_CREATE_USED_CONNECTION;
          }
#line 32286 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 862: /* create_table_option: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 6461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
            Lex->create_info.key_block_size= (yyvsp[0].ulong_num);
          }
#line 32295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 863: /* create_table_option: TRANSACTIONAL_SYM opt_equal choice  */
#line 6466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_TRANSACTIONAL;
            Lex->create_info.transactional= (yyvsp[0].choice);
          }
#line 32304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 864: /* create_table_option: IDENT_sys equal TEXT_STRING_sys  */
#line 6471 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 865: /* create_table_option: IDENT_sys equal ident  */
#line 6480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32330 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 866: /* create_table_option: IDENT_sys equal real_ulonglong_num  */
#line 6489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->create_info.option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 32340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 867: /* create_table_option: IDENT_sys equal DEFAULT  */
#line 6495 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->create_info.option_list,
                                       &Lex->option_list_last);
          }
#line 32350 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 868: /* create_table_option: SEQUENCE_SYM opt_equal choice  */
#line 6501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Lex->create_info.used_fields|= HA_CREATE_USED_SEQUENCE;
            Lex->create_info.sequence= ((yyvsp[0].choice) == HA_CHOICE_YES);
	  }
#line 32359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 872: /* versioning_option: WITH_SYSTEM_SYM VERSIONING_SYM  */
#line 6515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.options & HA_LEX_CREATE_TMP_TABLE))
            {
              if (DBUG_EVALUATE_IF("sysvers_force", 0, 1))
              {
                my_error(ER_VERS_NOT_SUPPORTED, MYF(0), "CREATE TEMPORARY TABLE");
                MYSQL_YYABORT;
              }
            }
            else
            {
              Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
              Lex->create_info.options|= HA_VERSIONED_TABLE;
            }
          }
#line 32379 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 873: /* default_charset: opt_default charset opt_equal charset_name_or_default  */
#line 6534 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->create_info.add_table_option_default_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
          }
#line 32388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 874: /* default_collation: opt_default COLLATE_SYM opt_equal collation_name_or_default  */
#line 6542 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            HA_CREATE_INFO *cinfo= &Lex->create_info;
            if (unlikely((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                         cinfo->default_table_charset && (yyvsp[0].charset) &&
                         !((yyvsp[0].charset)= merge_charset_and_collation(cinfo->default_table_charset,
                                                           (yyvsp[0].charset)))))
              MYSQL_YYABORT;

            Lex->create_info.default_table_charset= (yyvsp[0].charset);
            Lex->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
          }
#line 32404 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 875: /* storage_engines: ident_or_text  */
#line 6557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Storage_engine_name((yyvsp[0].lex_str)).
                 resolve_storage_engine_with_error(thd, &(yyval.db_type),
                                            thd->lex->create_info.tmp_table()))
              MYSQL_YYABORT;
          }
#line 32415 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 876: /* known_storage_engines: ident_or_text  */
#line 6567 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            plugin_ref plugin;
            if (likely((plugin= ha_resolve_by_name(thd, &(yyvsp[0].lex_str), false))))
              (yyval.db_type)= plugin_hton(plugin);
            else
              my_yyabort_error((ER_UNKNOWN_STORAGE_ENGINE, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 32427 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 877: /* row_types: DEFAULT  */
#line 6577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_DEFAULT; }
#line 32433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 878: /* row_types: FIXED_SYM  */
#line 6578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_FIXED; }
#line 32439 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 879: /* row_types: DYNAMIC_SYM  */
#line 6579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_DYNAMIC; }
#line 32445 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 880: /* row_types: COMPRESSED_SYM  */
#line 6580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPRESSED; }
#line 32451 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 881: /* row_types: REDUNDANT_SYM  */
#line 6581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_REDUNDANT; }
#line 32457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 882: /* row_types: COMPACT_SYM  */
#line 6582 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_COMPACT; }
#line 32463 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 883: /* row_types: PAGE_SYM  */
#line 6583 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.row_type)= ROW_TYPE_PAGE; }
#line 32469 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 884: /* merge_insert_types: NO_SYM  */
#line 6587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_DISABLED; }
#line 32475 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 885: /* merge_insert_types: FIRST_SYM  */
#line 6588 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_FIRST; }
#line 32481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 886: /* merge_insert_types: LAST_SYM  */
#line 6589 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= MERGE_INSERT_TO_LAST; }
#line 32487 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 887: /* udf_type: STRING_SYM  */
#line 6593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {(yyval.num) = (int) STRING_RESULT; }
#line 32493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 888: /* udf_type: REAL  */
#line 6594 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {(yyval.num) = (int) REAL_RESULT; }
#line 32499 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 889: /* udf_type: DECIMAL_SYM  */
#line 6595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {(yyval.num) = (int) DECIMAL_RESULT; }
#line 32505 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 890: /* udf_type: INT_SYM  */
#line 6596 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {(yyval.num) = (int) INT_RESULT; }
#line 32511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 891: /* create_field_list: field_list  */
#line 6602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 32519 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 892: /* create_field_list_parens: LEFT_PAREN_ALT field_list ')'  */
#line 6609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->create_last_non_select_table= Lex->last_table();
        }
#line 32527 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 895: /* field_list_item: column_def  */
#line 6620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 32533 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 899: /* field_list_item: PERIOD_SYM period_for_application_time  */
#line 6624 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 { }
#line 32539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 900: /* column_def: field_spec  */
#line 6629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.create_field)= (yyvsp[0].create_field); }
#line 32545 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 901: /* column_def: field_spec references  */
#line 6631 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.create_field)= (yyvsp[-1].create_field); }
#line 32551 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 902: /* $@113: %empty  */
#line 6636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-1].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 903: /* key_def: key_or_index opt_if_not_exists opt_ident opt_USING_key_algorithm $@113 '(' key_list ')' normal_key_options  */
#line 6641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 904: /* $@114: %empty  */
#line 6643 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key(Key::MULTIPLE, &(yyvsp[-2].ident_sys), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32577 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 905: /* key_def: key_or_index opt_if_not_exists ident TYPE_SYM btree_or_rtree $@114 '(' key_list ')' normal_key_options  */
#line 6648 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 906: /* $@115: %empty  */
#line 6650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32593 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 907: /* key_def: fulltext opt_key_or_index opt_if_not_exists opt_ident $@115 '(' key_list ')' fulltext_key_options  */
#line 6655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { }
#line 32599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 908: /* $@116: %empty  */
#line 6657 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), &(yyvsp[0].lex_str), HA_KEY_ALG_UNDEF, (yyvsp[-1].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 909: /* key_def: spatial opt_key_or_index opt_if_not_exists opt_ident $@116 '(' key_list ')' spatial_key_options  */
#line 6662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { }
#line 32615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 910: /* $@117: %empty  */
#line 6666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-3].key_type), (yyvsp[-1].lex_str).str ? &(yyvsp[-1].lex_str) : &(yyvsp[-4].lex_str), (yyvsp[0].key_alg), (yyvsp[-2].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32625 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 911: /* key_def: opt_constraint constraint_key_type opt_if_not_exists opt_ident opt_USING_key_algorithm $@117 '(' key_list ')' normal_key_options  */
#line 6671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 912: /* $@118: %empty  */
#line 6674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_list= NULL;
            if (unlikely(Lex->add_key((yyvsp[-4].key_type), (yyvsp[-2].ident_sys).str ? &(yyvsp[-2].ident_sys) : &(yyvsp[-5].lex_str), (yyvsp[0].key_alg), (yyvsp[-3].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 32641 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 913: /* key_def: opt_constraint constraint_key_type opt_if_not_exists ident TYPE_SYM btree_or_rtree $@118 '(' key_list ')' normal_key_options  */
#line 6679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { }
#line 32647 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 914: /* $@119: %empty  */
#line 6681 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->check_add_key((yyvsp[-1].object_ddl_options))) ||
                unlikely(!(Lex->last_key= (new (thd->mem_root)
                                           Key(Key::MULTIPLE,
                                           (yyvsp[-4].lex_str).str ? &(yyvsp[-4].lex_str) : &(yyvsp[0].lex_str),
                                           HA_KEY_ALG_UNDEF, true, (yyvsp[-1].object_ddl_options))))))
              MYSQL_YYABORT;
            Lex->option_list= NULL;
          }
#line 32661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 915: /* key_def: opt_constraint FOREIGN KEY_SYM opt_if_not_exists opt_ident $@119 '(' key_list ')' references  */
#line 6691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Key *key= (new (thd->mem_root)
                       Foreign_key((yyvsp[-5].lex_str).str ? &(yyvsp[-5].lex_str) : &(yyvsp[-9].lex_str),
                                   &lex->last_key->columns,
                                   &(yyvsp[0].table)->db,
                                   &(yyvsp[0].table)->table,
                                   &lex->ref_list,
                                   lex->fk_delete_opt,
                                   lex->fk_update_opt,
                                   lex->fk_match_option,
                                    (yyvsp[-6].object_ddl_options)));
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            /*
              handle_if_exists_options() expectes the two keys in this order:
              the Foreign_key, followed by its auto-generated Key.
            */
            lex->alter_info.key_list.push_back(key, thd->mem_root);
            lex->alter_info.key_list.push_back(Lex->last_key, thd->mem_root);
            lex->option_list= NULL;

            /* Only used for ALTER TABLE. Ignored otherwise. */
            lex->alter_info.flags|= ALTER_ADD_FOREIGN_KEY;
          }
#line 32691 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 916: /* constraint_def: opt_constraint check_constraint  */
#line 6720 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), FALSE);
         }
#line 32699 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 917: /* period_for_system_time: PERIOD_SYM FOR_SYSTEM_TIME_SYM '(' ident ',' ident ')'  */
#line 6728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Vers_parse_info &info= Lex->vers_get_info();
            info.set_period((yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys));
          }
#line 32708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 918: /* period_for_application_time: FOR_SYM ident '(' ident ',' ident ')'  */
#line 6736 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->add_period((yyvsp[-5].ident_sys), (yyvsp[-3].ident_sys), (yyvsp[-1].ident_sys)))
              MYSQL_YYABORT;
          }
#line 32717 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 919: /* opt_check_constraint: %empty  */
#line 6743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.virtual_column)= (Virtual_column_info*) 0; }
#line 32723 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 920: /* opt_check_constraint: check_constraint  */
#line 6744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.virtual_column)= (yyvsp[0].virtual_column);}
#line 32729 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 921: /* check_constraint: CHECK_SYM '(' expr ')'  */
#line 6749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 32740 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 922: /* opt_constraint_no_id: %empty  */
#line 6758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 32746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 923: /* opt_constraint_no_id: CONSTRAINT  */
#line 6759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 32752 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 924: /* opt_constraint: %empty  */
#line 6763 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 32758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 925: /* opt_constraint: constraint  */
#line 6764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 32764 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 926: /* constraint: CONSTRAINT opt_ident  */
#line 6768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 32770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 927: /* @120: %empty  */
#line 6773 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Create_field *f= new (thd->mem_root) Create_field();

            if (unlikely(check_string_char_length(&(yyvsp[0].lex_str), 0, NAME_CHAR_LEN,
                                                  system_charset_info, 1)))
              my_yyabort_error((ER_TOO_LONG_IDENT, MYF(0), (yyvsp[0].lex_str).str));

            if (unlikely(!f))
              MYSQL_YYABORT;

            lex->init_last_field(f, &(yyvsp[0].lex_str), NULL);
            (yyval.create_field)= f;
            lex->parsing_options.lookup_keywords_after_qualifier= true;
          }
#line 32790 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 928: /* field_spec: field_ident @120 field_type_or_serial opt_check_constraint  */
#line 6789 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->parsing_options.lookup_keywords_after_qualifier= false;
            (yyval.create_field)= (yyvsp[-2].create_field);

            (yyval.create_field)->check_constraint= (yyvsp[0].virtual_column);

            if (unlikely((yyval.create_field)->check(thd)))
              MYSQL_YYABORT;

            lex->alter_info.create_list.push_back((yyval.create_field), thd->mem_root);

            (yyval.create_field)->create_if_not_exists= Lex->check_exists;
            if ((yyval.create_field)->flags & PRI_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::PRIMARY, lex->check_exists);
            else if ((yyval.create_field)->flags & UNIQUE_KEY_FLAG)
              lex->add_key_to_list(&(yyvsp[-3].lex_str), Key::UNIQUE, lex->check_exists);
          }
#line 32813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 929: /* $@121: %empty  */
#line 6810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { Lex->last_field->set_attributes((yyvsp[0].Lex_field_type), Lex->charset); }
#line 32819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 931: /* $@122: %empty  */
#line 6813 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->set_handler(&type_handler_longlong);
            Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG
                                     | UNSIGNED_FLAG | UNIQUE_KEY_FLAG;
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32830 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 933: /* opt_serial_attribute: %empty  */
#line 6823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 934: /* opt_serial_attribute: opt_serial_attribute_list  */
#line 6824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    {}
#line 32842 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 935: /* opt_serial_attribute_list: opt_serial_attribute_list serial_attribute  */
#line 6828 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                     {}
#line 32848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 937: /* opt_asrow_attribute: %empty  */
#line 6833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 938: /* opt_asrow_attribute: opt_asrow_attribute_list  */
#line 6834 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 32860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 939: /* opt_asrow_attribute_list: opt_asrow_attribute_list asrow_attribute  */
#line 6838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   {}
#line 32866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 941: /* field_def: %empty  */
#line 6843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 32872 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 945: /* $@123: %empty  */
#line 6848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->last_field->vcol_info= (yyvsp[0].virtual_column);
           Lex->last_field->flags&= ~NOT_NULL_FLAG; // undo automatic NOT NULL for timestamps
         }
#line 32881 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 947: /* field_def: opt_generated_always AS ROW_SYM START_SYM opt_asrow_attribute  */
#line 6854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->last_field_generated_always_as_row_start())
              MYSQL_YYABORT;
          }
#line 32890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 948: /* field_def: opt_generated_always AS ROW_SYM END opt_asrow_attribute  */
#line 6859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->last_field_generated_always_as_row_end())
              MYSQL_YYABORT;
          }
#line 32899 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 949: /* opt_generated_always: %empty  */
#line 6866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 950: /* opt_generated_always: GENERATED_SYM ALWAYS_SYM  */
#line 6867 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 32911 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 951: /* vcol_opt_specifier: %empty  */
#line 6872 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 32919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 952: /* vcol_opt_specifier: VIRTUAL_SYM  */
#line 6876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(FALSE);
          }
#line 32927 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 953: /* vcol_opt_specifier: PERSISTENT_SYM  */
#line 6880 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 32935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 954: /* vcol_opt_specifier: STORED_SYM  */
#line 6884 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->vcol_info->set_stored_in_db_flag(TRUE);
          }
#line 32943 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 955: /* vcol_opt_attribute: %empty  */
#line 6890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 32949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 956: /* vcol_opt_attribute: vcol_opt_attribute_list  */
#line 6891 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 32955 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 957: /* vcol_opt_attribute_list: vcol_opt_attribute_list vcol_attribute  */
#line 6895 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 {}
#line 32961 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 959: /* vcol_attribute: UNIQUE_SYM  */
#line 6901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 960: /* vcol_attribute: UNIQUE_SYM KEY_SYM  */
#line 6907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 32981 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 961: /* vcol_attribute: COMMENT_SYM TEXT_STRING_sys  */
#line 6912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->last_field->comment= (yyvsp[0].lex_str); }
#line 32987 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 962: /* vcol_attribute: INVISIBLE_SYM  */
#line 6914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->invisible= INVISIBLE_USER;
          }
#line 32995 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 963: /* $@124: %empty  */
#line 6921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              "PARSE_VCOL_EXPR" can only be used by the SQL server
              when reading a '*.frm' file.
              Prevent the end user from invoking this command.
            */
            MYSQL_YYABORT_UNLESS(Lex->parse_vcol_expr);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 33010 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 964: /* parse_vcol_expr: PARSE_VCOL_EXPR_SYM $@124 expr  */
#line 6932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v= add_virtual_expression(thd, (yyvsp[0].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            Lex->last_field->vcol_info= v;
            Lex->pop_select(); //main select
          }
#line 33022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 966: /* parenthesized_expr: expr ',' expr_list  */
#line 6944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[0].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 33033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 967: /* virtual_column_func: '(' parenthesized_expr ')'  */
#line 6954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Virtual_column_info *v=
              add_virtual_expression(thd, (yyvsp[-1].item));
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 968: /* virtual_column_func: subquery  */
#line 6962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item;
            if (!(item= new (thd->mem_root) Item_singlerow_subselect(thd, (yyvsp[0].select_lex))))
              MYSQL_YYABORT;
            Virtual_column_info *v= add_virtual_expression(thd, item);
            if (unlikely(!v))
              MYSQL_YYABORT;
            (yyval.virtual_column)= v;
          }
#line 33059 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 972: /* column_default_expr: expr_or_literal  */
#line 6978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.virtual_column)= add_virtual_expression(thd, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 33068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 973: /* field_type: field_type_all  */
#line 6985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 33077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 974: /* qualified_field_type: field_type_all  */
#line 6993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          }
#line 33085 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 975: /* qualified_field_type: sp_decl_ident '.' field_type_all  */
#line 6997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->map_data_type((yyvsp[-2].ident_sys), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type))))
              MYSQL_YYABORT;
          }
#line 33094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 986: /* field_type_numeric: int_type opt_field_length field_options  */
#line 7022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].const_simple_string)); }
#line 33100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 987: /* field_type_numeric: real_type opt_precision field_options  */
#line 7023 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { (yyval.Lex_field_type).set((yyvsp[-2].type_handler), (yyvsp[-1].Lex_length_and_dec)); }
#line 33106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 988: /* field_type_numeric: FLOAT_SYM float_options field_options  */
#line 7025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_float, (yyvsp[-1].Lex_length_and_dec));
            if ((yyvsp[-1].Lex_length_and_dec).length() && !(yyvsp[-1].Lex_length_and_dec).dec())
            {
              int err;
              ulonglong tmp_length= my_strtoll10((yyvsp[-1].Lex_length_and_dec).length(), NULL, &err);
              if (unlikely(err || tmp_length > PRECISION_FOR_DOUBLE))
                my_yyabort_error((ER_WRONG_FIELD_SPEC, MYF(0),
                                  Lex->last_field->field_name.str));
              if (tmp_length > PRECISION_FOR_FLOAT)
                (yyval.Lex_field_type).set(&type_handler_double);
              else
                (yyval.Lex_field_type).set(&type_handler_float);
            }
          }
#line 33126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 989: /* field_type_numeric: BIT_SYM opt_field_length_default_1  */
#line 7041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_bit, (yyvsp[0].const_simple_string));
          }
#line 33134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 990: /* field_type_numeric: BOOL_SYM  */
#line 7045 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 991: /* field_type_numeric: BOOLEAN_SYM  */
#line 7049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_tiny, "1");
          }
#line 33150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 992: /* field_type_numeric: DECIMAL_SYM float_options field_options  */
#line 7053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 993: /* field_type_numeric: NUMBER_ORACLE_SYM float_options field_options  */
#line 7055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].Lex_length_and_dec).length() != 0)
              (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));
            else
              (yyval.Lex_field_type).set(&type_handler_double);
          }
#line 33167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 994: /* field_type_numeric: NUMERIC_SYM float_options field_options  */
#line 7062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33173 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 995: /* field_type_numeric: FIXED_SYM float_options field_options  */
#line 7064 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_newdecimal, (yyvsp[-1].Lex_length_and_dec));}
#line 33179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1000: /* field_type_string: char opt_field_length_default_1 opt_binary  */
#line 7077 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
          }
#line 33187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1001: /* field_type_string: nchar opt_field_length_default_1 opt_bin_mod  */
#line 7081 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[-1].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1002: /* field_type_string: BINARY opt_field_length_default_1  */
#line 7086 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_string, (yyvsp[0].const_simple_string));
          }
#line 33205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1003: /* field_type_string: varchar field_length opt_binary_and_compression  */
#line 7091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1004: /* field_type_string: VARCHAR2_ORACLE_SYM field_length opt_binary_and_compression  */
#line 7095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1005: /* field_type_string: nvarchar field_length opt_compressed opt_bin_mod  */
#line 7099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-2].const_simple_string));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1006: /* field_type_string: VARBINARY field_length opt_compressed  */
#line 7104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33239 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1007: /* field_type_string: RAW_ORACLE_SYM field_length opt_compressed  */
#line 7109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].const_simple_string));
          }
#line 33248 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1008: /* sp_param_field_type_string: char opt_field_length_default_sp_param_char opt_binary  */
#line 7118 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 33256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1009: /* sp_param_field_type_string: nchar opt_field_length_default_sp_param_char opt_bin_mod  */
#line 7122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1010: /* sp_param_field_type_string: BINARY opt_field_length_default_sp_param_char  */
#line 7127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 33274 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1011: /* sp_param_field_type_string: varchar opt_field_length_default_sp_param_varchar opt_binary  */
#line 7132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 33282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1012: /* sp_param_field_type_string: VARCHAR2_ORACLE_SYM opt_field_length_default_sp_param_varchar opt_binary  */
#line 7136 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
          }
#line 33290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1013: /* sp_param_field_type_string: nvarchar opt_field_length_default_sp_param_varchar opt_bin_mod  */
#line 7140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[-1].Lex_length_and_dec));
            bincmp_collation(national_charset_info, (yyvsp[0].num));
          }
#line 33299 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1014: /* sp_param_field_type_string: VARBINARY opt_field_length_default_sp_param_varchar  */
#line 7145 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 33308 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1015: /* sp_param_field_type_string: RAW_ORACLE_SYM opt_field_length_default_sp_param_varchar  */
#line 7150 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_varchar, (yyvsp[0].Lex_length_and_dec));
          }
#line 33317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1016: /* field_type_temporal: YEAR_SYM opt_field_length field_options  */
#line 7159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].const_simple_string))
            {
              errno= 0;
              ulong length= strtoul((yyvsp[-1].const_simple_string), NULL, 10);
              if (errno == 0 && length <= MAX_FIELD_BLOBLENGTH && length != 4)
              {
                char buff[sizeof("YEAR()") + MY_INT64_NUM_DECIMAL_DIGITS + 1];
                my_snprintf(buff, sizeof(buff), "YEAR(%lu)", length);
                push_warning_printf(thd, Sql_condition::WARN_LEVEL_NOTE,
                                    ER_WARN_DEPRECATED_SYNTAX,
                                    ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                    buff, "YEAR(4)");
              }
            }
            (yyval.Lex_field_type).set(&type_handler_year, (yyvsp[-1].const_simple_string));
          }
#line 33339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1017: /* field_type_temporal: DATE_SYM  */
#line 7176 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.Lex_field_type).set(&type_handler_newdate); }
#line 33345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1018: /* field_type_temporal: TIME_SYM opt_field_length  */
#line 7178 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_time2) :
                   static_cast<const Type_handler*>(&type_handler_time),
                   (yyvsp[0].const_simple_string));
          }
#line 33356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1019: /* field_type_temporal: TIMESTAMP opt_field_length  */
#line 7185 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(opt_mysql56_temporal_format ?
                   static_cast<const Type_handler*>(&type_handler_timestamp2):
                   static_cast<const Type_handler*>(&type_handler_timestamp),
                   (yyvsp[0].const_simple_string));
          }
#line 33367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1020: /* field_type_temporal: DATETIME opt_field_length  */
#line 7192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_field_type).set(thd->type_handler_for_datetime(), (yyvsp[0].const_simple_string));
          }
#line 33375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1021: /* field_type_lob: TINYBLOB opt_compressed  */
#line 7200 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_tiny_blob);
          }
#line 33384 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1022: /* field_type_lob: BLOB_MARIADB_SYM opt_field_length opt_compressed  */
#line 7205 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33393 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1023: /* field_type_lob: BLOB_ORACLE_SYM field_length opt_compressed  */
#line 7210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string));
          }
#line 33402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1024: /* field_type_lob: BLOB_ORACLE_SYM opt_compressed  */
#line 7215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1025: /* field_type_lob: spatial_type float_options srid_option  */
#line 7220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            Lex->charset=&my_charset_bin;
            Lex->last_field->geom_type= (yyvsp[-2].geom_type);
            (yyval.Lex_field_type).set(&type_handler_geometry, (yyvsp[-1].Lex_length_and_dec));
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 33426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1026: /* field_type_lob: MEDIUMBLOB opt_compressed  */
#line 7231 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1027: /* field_type_lob: LONGBLOB opt_compressed  */
#line 7236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_long_blob);
          }
#line 33444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1028: /* field_type_lob: LONG_SYM VARBINARY opt_compressed  */
#line 7241 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset=&my_charset_bin;
            (yyval.Lex_field_type).set(&type_handler_medium_blob);
          }
#line 33453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1029: /* field_type_lob: LONG_SYM varchar opt_binary_and_compression  */
#line 7246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33459 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1030: /* field_type_lob: TINYTEXT opt_binary_and_compression  */
#line 7248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_tiny_blob); }
#line 33465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1031: /* field_type_lob: TEXT_SYM opt_field_length opt_binary_and_compression  */
#line 7250 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_blob, (yyvsp[-1].const_simple_string)); }
#line 33471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1032: /* field_type_lob: MEDIUMTEXT opt_binary_and_compression  */
#line 7252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1033: /* field_type_lob: LONGTEXT opt_binary_and_compression  */
#line 7254 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1034: /* field_type_lob: CLOB_ORACLE_SYM opt_binary_and_compression  */
#line 7256 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_long_blob); }
#line 33489 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1035: /* field_type_lob: LONG_SYM opt_binary_and_compression  */
#line 7258 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_medium_blob); }
#line 33495 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1036: /* field_type_lob: JSON_SYM opt_compressed  */
#line 7260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= &my_charset_utf8mb4_bin;
            (yyval.Lex_field_type).set(&type_handler_json_longtext);
          }
#line 33504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1037: /* field_type_misc: ENUM '(' string_list ')' opt_binary  */
#line 7268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_enum); }
#line 33510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1038: /* field_type_misc: SET '(' string_list ')' opt_binary  */
#line 7270 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_field_type).set(&type_handler_set); }
#line 33516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1039: /* spatial_type: GEOMETRY_SYM  */
#line 7274 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRY; }
#line 33522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1040: /* spatial_type: GEOMETRYCOLLECTION  */
#line 7275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_GEOMETRYCOLLECTION; }
#line 33528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1041: /* spatial_type: POINT_SYM  */
#line 7276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_POINT; }
#line 33534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1042: /* spatial_type: MULTIPOINT  */
#line 7277 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOINT; }
#line 33540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1043: /* spatial_type: LINESTRING  */
#line 7278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_LINESTRING; }
#line 33546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1044: /* spatial_type: MULTILINESTRING  */
#line 7279 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTILINESTRING; }
#line 33552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1045: /* spatial_type: POLYGON  */
#line 7280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_POLYGON; }
#line 33558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1046: /* spatial_type: MULTIPOLYGON  */
#line 7281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.geom_type)= Field::GEOM_MULTIPOLYGON; }
#line 33564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1047: /* char: CHAR_SYM  */
#line 7285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   {}
#line 33570 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1048: /* nchar: NCHAR_SYM  */
#line 7289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 33576 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1049: /* nchar: NATIONAL_SYM CHAR_SYM  */
#line 7290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                {}
#line 33582 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1050: /* varchar: char VARYING  */
#line 7294 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33588 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1051: /* varchar: VARCHAR  */
#line 7295 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 33594 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1052: /* nvarchar: NATIONAL_SYM VARCHAR  */
#line 7299 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {}
#line 33600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1053: /* nvarchar: NVARCHAR_SYM  */
#line 7300 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 33606 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1054: /* nvarchar: NCHAR_SYM VARCHAR  */
#line 7301 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 33612 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1055: /* nvarchar: NATIONAL_SYM CHAR_SYM VARYING  */
#line 7302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        {}
#line 33618 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1056: /* nvarchar: NCHAR_SYM VARYING  */
#line 7303 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 33624 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1057: /* int_type: INT_SYM  */
#line 7307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_long; }
#line 33630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1058: /* int_type: TINYINT  */
#line 7308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_tiny; }
#line 33636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1059: /* int_type: SMALLINT  */
#line 7309 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_short; }
#line 33642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1060: /* int_type: MEDIUMINT  */
#line 7310 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_int24; }
#line 33648 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1061: /* int_type: BIGINT  */
#line 7311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.type_handler)= &type_handler_longlong; }
#line 33654 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1062: /* real_type: REAL  */
#line 7316 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.type_handler)= thd->variables.sql_mode & MODE_REAL_AS_FLOAT ?
              static_cast<const Type_handler *>(&type_handler_float) :
              static_cast<const Type_handler *>(&type_handler_double);
          }
#line 33664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1063: /* real_type: DOUBLE_SYM  */
#line 7321 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 33670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1064: /* real_type: DOUBLE_SYM PRECISION  */
#line 7322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.type_handler)= &type_handler_double; }
#line 33676 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1065: /* srid_option: %empty  */
#line 7327 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->srid= 0; }
#line 33682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1066: /* srid_option: REF_SYSTEM_ID_SYM '=' NUM  */
#line 7330 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->srid=atoi((yyvsp[0].lex_str).str);
          }
#line 33690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1067: /* float_options: %empty  */
#line 7336 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set(0, 0);  }
#line 33696 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1068: /* float_options: field_length  */
#line 7337 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), 0); }
#line 33702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1069: /* float_options: precision  */
#line 7338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 33708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1070: /* precision: '(' NUM ',' NUM ')'  */
#line 7342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.Lex_length_and_dec).set((yyvsp[-3].lex_str).str, (yyvsp[-1].lex_str).str); }
#line 33714 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1071: /* field_options: %empty  */
#line 7346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33720 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1072: /* field_options: SIGNED_SYM  */
#line 7347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 33726 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1073: /* field_options: UNSIGNED  */
#line 7348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG;}
#line 33732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1074: /* field_options: ZEROFILL  */
#line 7349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33738 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1075: /* field_options: UNSIGNED ZEROFILL  */
#line 7350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33744 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1076: /* field_options: ZEROFILL UNSIGNED  */
#line 7351 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_field->flags|= UNSIGNED_FLAG | ZEROFILL_FLAG; }
#line 33750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1077: /* field_length: '(' LONG_NUM ')'  */
#line 7355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33756 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1078: /* field_length: '(' ULONGLONG_NUM ')'  */
#line 7356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33762 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1079: /* field_length: '(' DECIMAL_NUM ')'  */
#line 7357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33768 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1080: /* field_length: '(' NUM ')'  */
#line 7358 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.const_simple_string)= (yyvsp[-1].lex_str).str; }
#line 33774 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1081: /* opt_field_length: %empty  */
#line 7362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (char*) 0; /* use default length */ }
#line 33780 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1082: /* opt_field_length: field_length  */
#line 7363 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 33786 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1083: /* opt_field_length_default_1: %empty  */
#line 7367 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (char*) "1"; }
#line 33792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1084: /* opt_field_length_default_1: field_length  */
#line 7368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.const_simple_string)= (yyvsp[0].const_simple_string); }
#line 33798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1085: /* opt_field_length_default_sp_param_varchar: %empty  */
#line 7389 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set("4000", "4000"); }
#line 33804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1086: /* opt_field_length_default_sp_param_varchar: field_length  */
#line 7390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), NULL); }
#line 33810 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1087: /* opt_field_length_default_sp_param_char: %empty  */
#line 7394 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set("2000", "2000"); }
#line 33816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1088: /* opt_field_length_default_sp_param_char: field_length  */
#line 7395 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.Lex_length_and_dec).set((yyvsp[0].const_simple_string), NULL); }
#line 33822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1089: /* opt_precision: %empty  */
#line 7399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_length_and_dec).set(0, 0); }
#line 33828 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1090: /* opt_precision: precision  */
#line 7400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_length_and_dec)= (yyvsp[0].Lex_length_and_dec); }
#line 33834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1091: /* attribute_list: attribute_list attribute  */
#line 7405 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   {}
#line 33840 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1093: /* attribute: NULL_SYM  */
#line 7410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags&= ~ NOT_NULL_FLAG; }
#line 33846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1094: /* attribute: DEFAULT column_default_expr  */
#line 7411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->last_field->default_value= (yyvsp[0].virtual_column); }
#line 33852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1095: /* attribute: ON UPDATE_SYM NOW_SYM opt_default_time_precision  */
#line 7413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            Lex->last_field->on_update= item;
          }
#line 33863 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1096: /* attribute: AUTO_INC  */
#line 7419 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { Lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG; }
#line 33869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1097: /* attribute: SERIAL_SYM DEFAULT VALUE_SYM  */
#line 7421 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= AUTO_INCREMENT_FLAG | NOT_NULL_FLAG | UNIQUE_KEY_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1098: /* attribute: COLLATE_SYM collation_name  */
#line 7427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->charset && !my_charset_same(Lex->charset,(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name,Lex->charset->csname));
            Lex->last_field->charset= (yyvsp[0].charset);
          }
#line 33890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1100: /* opt_compression_method: %empty  */
#line 7437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.const_simple_string)= NULL; }
#line 33896 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1101: /* opt_compression_method: equal ident  */
#line 7438 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.const_simple_string)= (yyvsp[0].ident_sys).str; }
#line 33902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1102: /* opt_compressed: %empty  */
#line 7442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 33908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1103: /* opt_compressed: compressed  */
#line 7443 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { }
#line 33914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1104: /* compressed: COMPRESSED_SYM opt_compression_method  */
#line 7448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->set_compressed((yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33923 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1105: /* compressed_deprecated_data_type_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7456 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->set_compressed_deprecated(thd, (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1106: /* compressed_deprecated_column_attribute: COMPRESSED_SYM opt_compression_method  */
#line 7464 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->last_field->
                set_compressed_deprecated_column_attribute(thd, (yyvsp[-1].kwd).pos(), (yyvsp[0].const_simple_string))))
              MYSQL_YYABORT;
          }
#line 33942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1107: /* asrow_attribute: not NULL_SYM  */
#line 7473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->flags|= NOT_NULL_FLAG;
          }
#line 33950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1108: /* asrow_attribute: opt_primary KEY_SYM  */
#line 7477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->last_field->flags|= PRI_KEY_FLAG | NOT_NULL_FLAG;
            lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 33960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1111: /* serial_attribute: IDENT_sys equal TEXT_STRING_sys  */
#line 7488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33973 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1112: /* serial_attribute: IDENT_sys equal ident  */
#line 7497 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false,
                                       &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 33986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1113: /* serial_attribute: IDENT_sys equal real_ulonglong_num  */
#line 7506 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->last_field->option_list,
                                       &Lex->option_list_last, thd->mem_root);
          }
#line 33996 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1114: /* serial_attribute: IDENT_sys equal DEFAULT  */
#line 7512 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->last_field->option_list,
                                       &Lex->option_list_last);
          }
#line 34006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1115: /* serial_attribute: with_or_without_system VERSIONING_SYM  */
#line 7518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_field->versioning= (yyvsp[-1].vers_column_versioning);
            Lex->create_info.options|= HA_VERSIONED_TABLE;
            if (Lex->alter_info.flags & ALTER_DROP_SYSTEM_VERSIONING)
            {
              my_yyabort_error((ER_VERS_NOT_VERSIONED, MYF(0),
                       Lex->create_last_non_select_table->table_name.str));
            }
          }
#line 34020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1116: /* with_or_without_system: WITH_SYSTEM_SYM  */
#line 7531 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.versioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITH_VERSIONING;
          }
#line 34030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1117: /* with_or_without_system: WITHOUT SYSTEM  */
#line 7537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_COLUMN_UNVERSIONED;
            Lex->create_info.vers_info.unversioned_fields= true;
            (yyval.vers_column_versioning)= Column_definition::WITHOUT_VERSIONING;
          }
#line 34040 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1118: /* sp_param_type: sp_param_field_type  */
#line 7547 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->map_data_type(Lex_ident_sys(), &((yyval.Lex_field_type)= (yyvsp[0].Lex_field_type)));
          Lex->last_field->set_attributes((yyval.Lex_field_type), Lex->charset);
        }
#line 34049 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1119: /* charset: CHAR_SYM SET  */
#line 7554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 34055 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1120: /* charset: CHARSET  */
#line 7555 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34061 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1121: /* charset_name: ident_or_text  */
#line 7560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34070 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1122: /* charset_name: BINARY  */
#line 7564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34076 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1123: /* charset_name_or_default: charset_name  */
#line 7568 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.charset)=(yyvsp[0].charset);   }
#line 34082 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1124: /* charset_name_or_default: DEFAULT  */
#line 7569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 34088 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1125: /* opt_load_data_charset: %empty  */
#line 7573 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.charset)= NULL; }
#line 34094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1126: /* opt_load_data_charset: charset charset_name_or_default  */
#line 7574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.charset)= (yyvsp[0].charset); }
#line 34100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1127: /* old_or_new_charset_name: ident_or_text  */
#line 7579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)=get_charset_by_csname((yyvsp[0].lex_str).str,
                                                    MY_CS_PRIMARY,MYF(0))) &&
                         !((yyval.charset)=get_old_charset_by_name((yyvsp[0].lex_str).str))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), (yyvsp[0].lex_str).str));
          }
#line 34111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1128: /* old_or_new_charset_name: BINARY  */
#line 7585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.charset)= &my_charset_bin; }
#line 34117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1129: /* old_or_new_charset_name_or_default: old_or_new_charset_name  */
#line 7589 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.charset)=(yyvsp[0].charset);   }
#line 34123 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1130: /* old_or_new_charset_name_or_default: DEFAULT  */
#line 7590 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 34129 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1131: /* collation_name: ident_or_text  */
#line 7595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)= mysqld_collation_get_by_name((yyvsp[0].lex_str).str))))
              MYSQL_YYABORT;
          }
#line 34138 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1132: /* opt_collate: %empty  */
#line 7602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.charset)=NULL; }
#line 34144 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1133: /* opt_collate: COLLATE_SYM collation_name_or_default  */
#line 7603 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.charset)=(yyvsp[0].charset); }
#line 34150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1134: /* collation_name_or_default: collation_name  */
#line 7607 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.charset)=(yyvsp[0].charset); }
#line 34156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1135: /* collation_name_or_default: DEFAULT  */
#line 7608 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.charset)=NULL; }
#line 34162 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1136: /* opt_default: %empty  */
#line 7612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1137: /* opt_default: DEFAULT  */
#line 7613 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1138: /* charset_or_alias: charset charset_name  */
#line 7617 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34180 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1139: /* charset_or_alias: ASCII_SYM  */
#line 7618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.charset)= &my_charset_latin1; }
#line 34186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1140: /* charset_or_alias: UNICODE_SYM  */
#line 7620 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.charset)= get_charset_by_csname("ucs2", MY_CS_PRIMARY,MYF(0)))))
              my_yyabort_error((ER_UNKNOWN_CHARACTER_SET, MYF(0), "ucs2"));
          }
#line 34195 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1141: /* collate: COLLATE_SYM collation_name_or_default  */
#line 7626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { (yyval.charset)= (yyvsp[0].charset); }
#line 34201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1142: /* opt_binary: %empty  */
#line 7630 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(NULL, false); }
#line 34207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1143: /* opt_binary: binary  */
#line 7631 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 34213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1144: /* binary: BYTE_SYM  */
#line 7635 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(&my_charset_bin, false); }
#line 34219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1145: /* binary: charset_or_alias opt_bin_mod  */
#line 7636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                       { bincmp_collation((yyvsp[-1].charset), (yyvsp[0].num)); }
#line 34225 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1146: /* binary: BINARY  */
#line 7637 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation(NULL, true); }
#line 34231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1147: /* binary: BINARY charset_or_alias  */
#line 7638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { bincmp_collation((yyvsp[0].charset), true); }
#line 34237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1148: /* binary: charset_or_alias collate  */
#line 7640 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].charset))
              Lex->charset= (yyvsp[-1].charset); // CHARACTER SET cs COLLATE DEFAULT
            else
            {
              if (!my_charset_same((yyvsp[0].charset), (yyvsp[-1].charset)))
                my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                  (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
              Lex->charset= (yyvsp[0].charset);
            }
          }
#line 34253 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1149: /* binary: collate  */
#line 7651 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { Lex->charset= (yyvsp[0].charset); }
#line 34259 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1150: /* opt_bin_mod: %empty  */
#line 7655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= false; }
#line 34265 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1151: /* opt_bin_mod: BINARY  */
#line 7656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= true; }
#line 34271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1152: /* $@125: %empty  */
#line 7661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely((yyvsp[0].ulong_num) == 0))
          {
            thd->parse_error();
            MYSQL_YYABORT;
          }
        }
#line 34283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1153: /* ws_nweights: '(' real_ulong_num $@125 ')'  */
#line 7669 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { (yyval.ulong_num)= (yyvsp[-2].ulong_num); }
#line 34289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1154: /* ws_level_flag_desc: ASC  */
#line 7673 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.ulong_num)= 0; }
#line 34295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1155: /* ws_level_flag_desc: DESC  */
#line 7674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.ulong_num)= 1 << MY_STRXFRM_DESC_SHIFT; }
#line 34301 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1156: /* ws_level_flag_reverse: REVERSE_SYM  */
#line 7678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 1 << MY_STRXFRM_REVERSE_SHIFT; }
#line 34307 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1157: /* ws_level_flags: %empty  */
#line 7681 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 0; }
#line 34313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1158: /* ws_level_flags: ws_level_flag_desc  */
#line 7682 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34319 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1159: /* ws_level_flags: ws_level_flag_desc ws_level_flag_reverse  */
#line 7683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   { (yyval.ulong_num)= (yyvsp[-1].ulong_num) | (yyvsp[0].ulong_num); }
#line 34325 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1160: /* ws_level_flags: ws_level_flag_reverse  */
#line 7684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.ulong_num)= (yyvsp[0].ulong_num) ; }
#line 34331 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1161: /* ws_level_number: real_ulong_num  */
#line 7689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.ulong_num)= (yyvsp[0].ulong_num) < 1 ? 1 : ((yyvsp[0].ulong_num) > MY_STRXFRM_NLEVELS ? MY_STRXFRM_NLEVELS : (yyvsp[0].ulong_num));
          (yyval.ulong_num)--;
        }
#line 34340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1162: /* ws_level_list_item: ws_level_number ws_level_flags  */
#line 7697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.ulong_num)= (1 | (yyvsp[0].ulong_num)) << (yyvsp[-1].ulong_num);
        }
#line 34348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1163: /* ws_level_list: ws_level_list_item  */
#line 7703 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1164: /* ws_level_list: ws_level_list ',' ws_level_list_item  */
#line 7704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               { (yyval.ulong_num)|= (yyvsp[0].ulong_num); }
#line 34360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1165: /* ws_level_range: ws_level_number '-' ws_level_number  */
#line 7709 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          uint start= (yyvsp[-2].ulong_num);
          uint end= (yyvsp[0].ulong_num);
          for ((yyval.ulong_num)= 0; start <= end; start++)
            (yyval.ulong_num)|= (1 << start);
        }
#line 34371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1166: /* ws_level_list_or_range: ws_level_list  */
#line 7718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1167: /* ws_level_list_or_range: ws_level_range  */
#line 7719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34383 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1168: /* opt_ws_levels: %empty  */
#line 7723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.ulong_num)= 0; }
#line 34389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1169: /* opt_ws_levels: LEVEL_SYM ws_level_list_or_range  */
#line 7724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.ulong_num)= (yyvsp[0].ulong_num); }
#line 34395 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1172: /* references: REFERENCES table_ident opt_ref_list opt_match_clause opt_on_update_delete  */
#line 7738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)=(yyvsp[-3].table);
          }
#line 34403 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1173: /* opt_ref_list: %empty  */
#line 7745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->ref_list.empty(); }
#line 34409 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1175: /* ref_list: ref_list ',' ident  */
#line 7751 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            Lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1176: /* ref_list: ident  */
#line 7758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Key_part_spec *key= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely(key == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->ref_list.empty();
            lex->ref_list.push_back(key, thd->mem_root);
          }
#line 34433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1177: /* opt_match_clause: %empty  */
#line 7770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_UNDEF; }
#line 34439 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1178: /* opt_match_clause: MATCH FULL  */
#line 7772 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_FULL; }
#line 34445 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1179: /* opt_match_clause: MATCH PARTIAL  */
#line 7774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_PARTIAL; }
#line 34451 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1180: /* opt_match_clause: MATCH SIMPLE_SYM  */
#line 7776 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->fk_match_option= Foreign_key::FK_MATCH_SIMPLE; }
#line 34457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1181: /* opt_on_update_delete: %empty  */
#line 7781 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34467 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1182: /* opt_on_update_delete: ON UPDATE_SYM delete_option  */
#line 7787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= FK_OPTION_UNDEF;
          }
#line 34477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1183: /* opt_on_update_delete: ON DELETE_SYM delete_option  */
#line 7793 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= FK_OPTION_UNDEF;
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34487 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1184: /* opt_on_update_delete: ON UPDATE_SYM delete_option ON DELETE_SYM delete_option  */
#line 7800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[-3].m_fk_option);
            lex->fk_delete_opt= (yyvsp[0].m_fk_option);
          }
#line 34497 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1185: /* opt_on_update_delete: ON DELETE_SYM delete_option ON UPDATE_SYM delete_option  */
#line 7807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->fk_update_opt= (yyvsp[0].m_fk_option);
            lex->fk_delete_opt= (yyvsp[-3].m_fk_option);
          }
#line 34507 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1186: /* delete_option: RESTRICT  */
#line 7815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_RESTRICT; }
#line 34513 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1187: /* delete_option: CASCADE  */
#line 7816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_CASCADE; }
#line 34519 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1188: /* delete_option: SET NULL_SYM  */
#line 7817 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_NULL; }
#line 34525 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1189: /* delete_option: NO_SYM ACTION  */
#line 7818 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_NO_ACTION; }
#line 34531 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1190: /* delete_option: SET DEFAULT  */
#line 7819 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.m_fk_option)= FK_OPTION_SET_DEFAULT; }
#line 34537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1191: /* constraint_key_type: PRIMARY_SYM KEY_SYM  */
#line 7823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.key_type)= Key::PRIMARY; }
#line 34543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1192: /* constraint_key_type: UNIQUE_SYM opt_key_or_index  */
#line 7824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { (yyval.key_type)= Key::UNIQUE; }
#line 34549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1193: /* key_or_index: KEY_SYM  */
#line 7828 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1194: /* key_or_index: INDEX_SYM  */
#line 7829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 34561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1195: /* opt_key_or_index: %empty  */
#line 7833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1197: /* keys_or_index: KEYS  */
#line 7838 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 34573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1198: /* keys_or_index: INDEX_SYM  */
#line 7839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 34579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1199: /* keys_or_index: INDEXES  */
#line 7840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 34585 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1200: /* opt_unique: %empty  */
#line 7844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::MULTIPLE; }
#line 34591 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1201: /* opt_unique: UNIQUE_SYM  */
#line 7845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::UNIQUE; }
#line 34597 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1202: /* fulltext: FULLTEXT_SYM  */
#line 7849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.key_type)= Key::FULLTEXT;}
#line 34603 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1203: /* spatial: SPATIAL_SYM  */
#line 7854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.key_type)= Key::SPATIAL;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 34616 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1204: /* normal_key_options: %empty  */
#line 7865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1205: /* normal_key_options: normal_key_opts  */
#line 7866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { Lex->last_key->option_list= Lex->option_list; }
#line 34628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1206: /* fulltext_key_options: %empty  */
#line 7870 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1207: /* fulltext_key_options: fulltext_key_opts  */
#line 7871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->last_key->option_list= Lex->option_list; }
#line 34640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1208: /* spatial_key_options: %empty  */
#line 7875 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 34646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1209: /* spatial_key_options: spatial_key_opts  */
#line 7876 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Lex->last_key->option_list= Lex->option_list; }
#line 34652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1216: /* opt_USING_key_algorithm: %empty  */
#line 7895 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 34658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1217: /* opt_USING_key_algorithm: USING btree_or_rtree  */
#line 7896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34664 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1218: /* opt_key_algorithm_clause: %empty  */
#line 7901 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= HA_KEY_ALG_UNDEF; }
#line 34670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1219: /* opt_key_algorithm_clause: USING btree_or_rtree  */
#line 7902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34676 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1220: /* opt_key_algorithm_clause: TYPE_SYM btree_or_rtree  */
#line 7903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.key_alg)= (yyvsp[0].key_alg); }
#line 34682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1221: /* key_using_alg: USING btree_or_rtree  */
#line 7908 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 34688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1222: /* key_using_alg: TYPE_SYM btree_or_rtree  */
#line 7910 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.algorithm= (yyvsp[0].key_alg); }
#line 34694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1223: /* all_key_opt: KEY_BLOCK_SIZE opt_equal ulong_num  */
#line 7915 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->key_create_info.block_size= (yyvsp[0].ulong_num);
            Lex->last_key->key_create_info.flags|= HA_USES_BLOCK_SIZE;
         }
#line 34703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1224: /* all_key_opt: COMMENT_SYM TEXT_STRING_sys  */
#line 7920 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_key->key_create_info.comment= (yyvsp[0].lex_str); }
#line 34709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1225: /* all_key_opt: IDENT_sys equal TEXT_STRING_sys  */
#line 7922 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].lex_str).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].lex_str), true, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1226: /* all_key_opt: IDENT_sys equal ident  */
#line 7930 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[0].ident_sys).length > ENGINE_OPTION_MAX_LENGTH))
              my_yyabort_error((ER_VALUE_TOO_LONG, MYF(0), (yyvsp[-2].ident_sys).str));
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ident_sys), false, &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34733 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1227: /* all_key_opt: IDENT_sys equal real_ulonglong_num  */
#line 7938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                  engine_option_value((yyvsp[-2].ident_sys), (yyvsp[0].ulonglong_number), &Lex->option_list,
                                      &Lex->option_list_last, thd->mem_root);
          }
#line 34743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1228: /* all_key_opt: IDENT_sys equal DEFAULT  */
#line 7944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (void) new (thd->mem_root)
                   engine_option_value((yyvsp[-2].ident_sys), &Lex->option_list,
                                       &Lex->option_list_last);
          }
#line 34753 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1233: /* fulltext_key_opt: WITH PARSER_SYM IDENT_sys  */
#line 7963 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (likely(plugin_is_ready(&(yyvsp[0].ident_sys), MYSQL_FTPARSER_PLUGIN)))
              Lex->last_key->key_create_info.parser_name= (yyvsp[0].ident_sys);
            else
              my_yyabort_error((ER_FUNCTION_NOT_DEFINED, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 34764 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1234: /* btree_or_rtree: BTREE_SYM  */
#line 7972 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_BTREE; }
#line 34770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1235: /* btree_or_rtree: RTREE_SYM  */
#line 7973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_RTREE; }
#line 34776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1236: /* btree_or_rtree: HASH_SYM  */
#line 7974 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.key_alg)= HA_KEY_ALG_HASH; }
#line 34782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1237: /* key_list: key_list ',' key_part order_dir  */
#line 7979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 34790 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1238: /* key_list: key_part order_dir  */
#line 7983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_key->columns.push_back((yyvsp[-1].key_part), thd->mem_root);
          }
#line 34798 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1239: /* key_part: ident  */
#line 7990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 34808 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1240: /* key_part: ident '(' NUM ')'  */
#line 7996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int key_part_len= atoi((yyvsp[-1].lex_str).str);
            if (unlikely(!key_part_len))
              my_yyabort_error((ER_KEY_PART_0, MYF(0), (yyvsp[-3].ident_sys).str));
            (yyval.key_part)= new (thd->mem_root) Key_part_spec(&(yyvsp[-3].ident_sys), (uint) key_part_len);
            if (unlikely((yyval.key_part) == NULL))
              MYSQL_YYABORT;
          }
#line 34821 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1241: /* opt_ident: %empty  */
#line 8007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 34827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1242: /* opt_ident: field_ident  */
#line 8008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 34833 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1243: /* string_list: text_string  */
#line 8013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 34839 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1244: /* string_list: string_list ',' text_string  */
#line 8015 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->last_field->interval_list.push_back((yyvsp[0].string), thd->mem_root); }
#line 34845 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1245: /* $@126: %empty  */
#line 8024 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->name= null_clex_str;
            Lex->table_type= TABLE_TYPE_UNKNOWN;
            Lex->sql_command= SQLCOM_ALTER_TABLE;
            Lex->duplicates= DUP_ERROR;
            Lex->first_select_lex()->order_list.empty();
            Lex->create_info.init();
            Lex->create_info.row_type= ROW_TYPE_NOT_USED;
            Lex->alter_info.reset();
            Lex->no_write_to_binlog= 0;
            Lex->create_info.storage_media= HA_SM_DEFAULT;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            DBUG_ASSERT(!Lex->m_sql_cmd);
          }
#line 34865 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1246: /* $@127: %empty  */
#line 8040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                    TL_READ_NO_INSERT, MDL_SHARED_UPGRADABLE))
              MYSQL_YYABORT;
            Lex->first_select_lex()->db=
              (Lex->first_select_lex()->table_list.first)->db;
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->mark_first_table_as_inserting();
          }
#line 34880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1247: /* alter: ALTER $@126 alter_options TABLE_SYM table_ident opt_lock_wait_timeout $@127 alter_commands  */
#line 8051 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (likely(!Lex->m_sql_cmd))
            {
              /* Create a generic ALTER TABLE statment. */
              Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_table();
              if (unlikely(Lex->m_sql_cmd == NULL))
                MYSQL_YYABORT;
            }
            Lex->pop_select(); //main select
          }
#line 34895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1248: /* $@128: %empty  */
#line 8062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.default_table_charset= NULL;
            Lex->create_info.used_fields= 0;
            if (Lex->main_select_push(true))
              MYSQL_YYABORT;
          }
#line 34906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1249: /* alter: ALTER DATABASE ident_or_empty $@128 create_database_options  */
#line 8069 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_ALTER_DB;
            lex->name= (yyvsp[-2].ident_sys);
            if (lex->name.str == NULL &&
                unlikely(lex->copy_db_to(&lex->name)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 34920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1250: /* alter: ALTER DATABASE ident UPGRADE_SYM DATA_SYM DIRECTORY_SYM NAME_SYM  */
#line 8079 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "DATABASE"));
            lex->sql_command= SQLCOM_ALTER_DB_UPGRADE;
            lex->name= (yyvsp[-4].ident_sys);
          }
#line 34932 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1251: /* $@129: %empty  */
#line 8087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 34946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1252: /* alter: ALTER PROCEDURE_SYM sp_name $@129 sp_a_chistics  */
#line 8097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_PROCEDURE;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1253: /* $@130: %empty  */
#line 8107 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            lex->sp_chistics.init();
          }
#line 34974 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1254: /* alter: ALTER FUNCTION_SYM sp_name $@130 sp_a_chistics  */
#line 8117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command= SQLCOM_ALTER_FUNCTION;
            lex->spname= (yyvsp[-2].spname);
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 34988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1255: /* $@131: %empty  */
#line 8127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, (yyvsp[-4].num), (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 34999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1256: /* alter: ALTER view_algorithm definer_opt opt_view_suid VIEW_SYM table_ident $@131 view_list_opt AS view_select  */
#line 8134 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35009 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1257: /* $@132: %empty  */
#line 8145 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            if (Lex->add_alter_view(thd, VIEW_ALGORITHM_INHERIT, (yyvsp[-2].view_suid), (yyvsp[0].table)))
              MYSQL_YYABORT;
          }
#line 35020 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1258: /* alter: ALTER definer_opt opt_view_suid VIEW_SYM table_ident $@132 view_list_opt AS view_select  */
#line 8152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1259: /* $@133: %empty  */
#line 8158 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            /*
              It is safe to use Lex->spname because
              ALTER EVENT xxx RENATE TO yyy DO ALTER EVENT RENAME TO
              is not allowed. Lex->spname is used in the case of RENAME TO
              If it had to be supported spname had to be added to
              Event_parse_data.
            */

            if (unlikely(!(Lex->event_parse_data= Event_parse_data::new_instance(thd))))
              MYSQL_YYABORT;
            Lex->event_parse_data->identifier= (yyvsp[0].spname);

            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_begin= (yyvsp[-2].simple_string);
          }
#line 35053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1260: /* alter: ALTER definer_opt remember_name EVENT_SYM sp_name $@133 ev_alter_on_schedule_completion opt_ev_rename_to opt_ev_status opt_ev_comment opt_ev_sql_stmt  */
#line 8181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyvsp[-4].num) || (yyvsp[-3].num) || (yyvsp[-2].num) || (yyvsp[-1].num) || (yyvsp[0].num))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            /*
              sql_command is set here because some rules in ev_sql_stmt
              can overwrite it
            */
            Lex->sql_command= SQLCOM_ALTER_EVENT;
            Lex->stmt_definition_end= (char*)YYLIP->get_cpp_ptr();

            Lex->pop_select(); //main select
          }
#line 35073 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1261: /* alter: ALTER TABLESPACE alter_tablespace_info  */
#line 8197 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_TABLESPACE;
          }
#line 35082 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1262: /* alter: ALTER LOGFILE_SYM GROUP_SYM alter_logfile_group_info  */
#line 8202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_LOGFILE_GROUP;
          }
#line 35091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1263: /* alter: ALTER TABLESPACE change_tablespace_info  */
#line 8207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= CHANGE_FILE_TABLESPACE;
          }
#line 35100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1264: /* alter: ALTER TABLESPACE change_tablespace_access  */
#line 8212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= ALTER_ACCESS_MODE_TABLESPACE;
          }
#line 35109 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1265: /* $@134: %empty  */
#line 8217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_ALTER_SERVER;
            lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 35119 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1266: /* alter: ALTER SERVER_SYM ident_or_text $@134 OPTIONS_SYM '(' server_options_list ')'  */
#line 8221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                    { }
#line 35125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1267: /* alter: ALTER USER_SYM opt_if_exists clear_privileges grant_list opt_require_clause opt_resource_options opt_account_locking_and_opt_password_expiration  */
#line 8225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_info.set((yyvsp[-5].object_ddl_options));
            Lex->sql_command= SQLCOM_ALTER_USER;
          }
#line 35134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1268: /* $@135: %empty  */
#line 8230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->name= null_clex_str;
            lex->table_type= TABLE_TYPE_UNKNOWN;
            lex->sql_command= SQLCOM_ALTER_SEQUENCE;
            lex->create_info.init();
            lex->no_write_to_binlog= 0;
            DBUG_ASSERT(!lex->m_sql_cmd);
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 35150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1269: /* $@136: %empty  */
#line 8242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!(lex->create_info.seq_create_info= new (thd->mem_root)
                                                     sequence_definition()) ||
                !lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[0].table), NULL, TL_OPTION_SEQUENCE,
                                    TL_WRITE, MDL_EXCLUSIVE))
              MYSQL_YYABORT;
          }
#line 35164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1270: /* alter: ALTER SEQUENCE_SYM opt_if_exists $@135 table_ident $@136 sequence_defs  */
#line 8252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Create a generic ALTER SEQUENCE statment. */
            Lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_alter_sequence((yyvsp[-4].object_ddl_options));
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 35178 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1271: /* account_locking_option: LOCK_SYM  */
#line 8265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_LOCKED;
          }
#line 35186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1272: /* account_locking_option: UNLOCK_SYM  */
#line 8269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.account_locked= ACCOUNTLOCK_UNLOCKED;
          }
#line 35194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1273: /* opt_password_expire_option: %empty  */
#line 8276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NOW;
          }
#line 35202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1274: /* opt_password_expire_option: NEVER_SYM  */
#line 8280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_NEVER;
          }
#line 35210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1275: /* opt_password_expire_option: DEFAULT  */
#line 8284 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_DEFAULT;
          }
#line 35218 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1276: /* opt_password_expire_option: INTERVAL_SYM NUM DAY_SYM  */
#line 8288 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.password_expire= PASSWORD_EXPIRE_INTERVAL;
            if (!(Lex->account_options.num_expiration_days= atoi((yyvsp[-1].lex_str).str)))
              my_yyabort_error((ER_WRONG_VALUE, MYF(0), "DAY", (yyvsp[-1].lex_str).str));
          }
#line 35228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1282: /* ev_alter_on_schedule_completion: %empty  */
#line 8304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0;}
#line 35234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1283: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time  */
#line 8305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.num)= 1; }
#line 35240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1284: /* ev_alter_on_schedule_completion: ev_on_completion  */
#line 8306 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.num)= 1; }
#line 35246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1285: /* ev_alter_on_schedule_completion: ON SCHEDULE_SYM ev_schedule_time ev_on_completion  */
#line 8307 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                            { (yyval.num)= 1; }
#line 35252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1286: /* opt_ev_rename_to: %empty  */
#line 8311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0;}
#line 35258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1287: /* opt_ev_rename_to: RENAME TO_SYM sp_name  */
#line 8313 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Use lex's spname to hold the new name.
              The original name is in the Event_parse_data object
            */
            Lex->spname= (yyvsp[0].spname); 
            (yyval.num)= 1;
          }
#line 35271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1288: /* opt_ev_sql_stmt: %empty  */
#line 8324 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.num)= 0;}
#line 35277 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1289: /* opt_ev_sql_stmt: DO_SYM ev_sql_stmt  */
#line 8325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= 1; }
#line 35283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1290: /* ident_or_empty: %empty  */
#line 8329 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.ident_sys)= Lex_ident_sys(); }
#line 35289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1293: /* alter_commands: DISCARD TABLESPACE  */
#line 8336 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::DISCARD_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35301 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1294: /* alter_commands: IMPORT TABLESPACE  */
#line 8344 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->m_sql_cmd= new (thd->mem_root)
              Sql_cmd_discard_import_tablespace(
                Sql_cmd_discard_import_tablespace::IMPORT_TABLESPACE);
            if (unlikely(Lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1300: /* alter_commands: DROP PARTITION_SYM opt_if_exists alt_part_name_list  */
#line 8366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_DROP;
            DBUG_ASSERT(!Lex->if_exists());
            Lex->create_info.add((yyvsp[-1].object_ddl_options));
          }
#line 35323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1301: /* alter_commands: REBUILD_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_REBUILD;
            lex->no_write_to_binlog= (yyvsp[-1].num);
          }
#line 35333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1302: /* $@137: %empty  */
#line 8380 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_optimize_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1304: /* alter_commands: ANALYZE_SYM PARTITION_SYM opt_no_write_to_binlog all_or_alt_part_name_list  */
#line 8393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_analyze_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
               MYSQL_YYABORT;
          }
#line 35363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1305: /* $@138: %empty  */
#line 8404 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_check_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1307: /* $@139: %empty  */
#line 8416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_repair_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1309: /* alter_commands: COALESCE PARTITION_SYM opt_no_write_to_binlog real_ulong_num  */
#line 8428 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_info.partition_flags|= ALTER_PARTITION_COALESCE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->alter_info.num_parts= (yyvsp[0].ulong_num);
          }
#line 35403 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1310: /* alter_commands: TRUNCATE_SYM PARTITION_SYM all_or_alt_part_name_list  */
#line 8435 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->check_opt.init();
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root)
                              Sql_cmd_alter_table_truncate_partition();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 35417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1312: /* alter_commands: EXCHANGE_SYM PARTITION_SYM alt_part_name_item WITH TABLE_SYM table_ident have_partitioning  */
#line 8447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_alter_table_exchange_partition((yyvsp[-1].table)))
              MYSQL_YYABORT;
          }
#line 35426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1313: /* remove_partitioning: REMOVE_SYM PARTITIONING_SYM  */
#line 8455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REMOVE;
          }
#line 35434 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1314: /* all_or_alt_part_name_list: ALL  */
#line 8462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ALL;
          }
#line 35442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1316: /* $@140: %empty  */
#line 8471 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->alter_info.partition_flags|= ALTER_PARTITION_ADD;
            DBUG_ASSERT(!Lex->create_info.if_not_exists());
            lex->create_info.set((yyvsp[-1].object_ddl_options));
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35458 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1317: /* add_partition_rule: ADD PARTITION_SYM opt_if_not_exists opt_no_write_to_binlog $@140 add_part_extra  */
#line 8483 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 35464 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1319: /* add_part_extra: '(' part_def_list ')'  */
#line 8489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info->num_parts= lex->part_info->partitions.elements;
          }
#line 35473 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1320: /* add_part_extra: PARTITIONS_SYM real_ulong_num  */
#line 8494 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->part_info->num_parts= (yyvsp[0].ulong_num);
          }
#line 35481 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1321: /* $@141: %empty  */
#line 8501 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->part_info= new (thd->mem_root) partition_info();
            if (unlikely(!lex->part_info))
              MYSQL_YYABORT;

            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 35494 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1323: /* reorg_parts_rule: %empty  */
#line 8514 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_TABLE_REORG;
          }
#line 35502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1324: /* $@142: %empty  */
#line 8518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_REORGANIZE;
          }
#line 35510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1325: /* reorg_parts_rule: alt_part_name_list $@142 INTO '(' part_def_list ')'  */
#line 8522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            partition_info *part_info= Lex->part_info;
            part_info->num_parts= part_info->partitions.elements;
          }
#line 35519 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1326: /* alt_part_name_list: alt_part_name_item  */
#line 8529 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             {}
#line 35525 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1327: /* alt_part_name_list: alt_part_name_list ',' alt_part_name_item  */
#line 8530 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                    {}
#line 35531 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1328: /* alt_part_name_item: ident  */
#line 8535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.partition_names.push_back((yyvsp[0].ident_sys).str,
                                                                   thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 35541 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1332: /* alter_list_item: add_column column_def opt_place  */
#line 8557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->create_last_non_select_table= lex->last_table();
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1333: /* alter_list_item: ADD key_def  */
#line 8564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->create_last_non_select_table= Lex->last_table();
            Lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1334: /* alter_list_item: ADD period_for_system_time  */
#line 8569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_PERIOD;
          }
#line 35569 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1335: /* alter_list_item: ADD PERIOD_SYM opt_if_not_exists_table_element period_for_application_time  */
#line 8574 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_period_info &period= Lex->create_info.period_info;
            period.create_if_not_exists= Lex->check_exists;
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
          }
#line 35579 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1336: /* alter_list_item: add_column '(' create_field_list ')'  */
#line 8580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_PARSER_ADD_COLUMN;
            if (!lex->alter_info.key_list.is_empty())
              lex->alter_info.flags|= ALTER_ADD_INDEX;
          }
#line 35590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1337: /* alter_list_item: ADD constraint_def  */
#line 8587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
	  }
#line 35598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1338: /* alter_list_item: ADD CONSTRAINT IF_SYM not EXISTS field_ident check_constraint  */
#line 8591 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           Lex->alter_info.flags|= ALTER_ADD_CHECK_CONSTRAINT;
           Lex->add_constraint((yyvsp[-1].lex_str), (yyvsp[0].virtual_column), TRUE);
         }
#line 35607 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1339: /* alter_list_item: CHANGE opt_column opt_if_exists_table_element field_ident field_spec opt_place  */
#line 8597 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN | ALTER_RENAME_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-2].lex_str);
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35618 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1340: /* alter_list_item: MODIFY_SYM opt_column opt_if_exists_table_element field_spec opt_place  */
#line 8605 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_CHANGE_COLUMN;
            Lex->create_last_non_select_table= Lex->last_table();
            (yyvsp[-1].create_field)->change= (yyvsp[-1].create_field)->field_name;
            (yyvsp[-1].create_field)->after= (yyvsp[0].lex_str);
          }
#line 35629 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1341: /* alter_list_item: DROP opt_column opt_if_exists_table_element field_ident opt_restrict  */
#line 8612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::COLUMN, (yyvsp[-1].lex_str).str, (yyvsp[-2].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_PARSER_DROP_COLUMN;
          }
#line 35643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1342: /* alter_list_item: DROP CONSTRAINT opt_if_exists_table_element field_ident  */
#line 8622 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::CHECK_CONSTRAINT,
                                        (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 35658 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1343: /* alter_list_item: DROP FOREIGN KEY_SYM opt_if_exists_table_element field_ident  */
#line 8633 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::FOREIGN_KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_FOREIGN_KEY;
          }
#line 35672 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1344: /* alter_list_item: DROP opt_constraint_no_id PRIMARY_SYM KEY_SYM  */
#line 8643 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, primary_key_name,
                                        FALSE));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 35687 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1345: /* alter_list_item: DROP key_or_index opt_if_exists_table_element field_ident  */
#line 8654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[0].lex_str).str, (yyvsp[-1].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            lex->alter_info.flags|= ALTER_DROP_INDEX;
          }
#line 35701 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1346: /* alter_list_item: DISABLE_SYM KEYS  */
#line 8664 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::DISABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 35711 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1347: /* alter_list_item: ENABLE_SYM KEYS  */
#line 8670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.keys_onoff= Alter_info::ENABLE;
            lex->alter_info.flags|= ALTER_KEYS_ONOFF;
          }
#line 35721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1348: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident SET DEFAULT column_default_expr  */
#line 8676 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (check_expression((yyvsp[0].virtual_column), &(yyvsp[-3].lex_str), VCOL_DEFAULT))
              MYSQL_YYABORT;
            if (unlikely(Lex->add_alter_list((yyvsp[-3].lex_str).str, (yyvsp[0].virtual_column), (yyvsp[-4].num))))
              MYSQL_YYABORT;
          }
#line 35732 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1349: /* alter_list_item: ALTER opt_column opt_if_exists_table_element field_ident DROP DEFAULT  */
#line 8683 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_alter_list((yyvsp[-2].lex_str).str, (Virtual_column_info*) 0,
                                             (yyvsp[-3].num))))
              MYSQL_YYABORT;
          }
#line 35742 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1350: /* alter_list_item: RENAME opt_to table_ident  */
#line 8689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->db= (yyvsp[0].table)->db;
            if (lex->first_select_lex()->db.str == NULL &&
                lex->copy_db_to(&lex->first_select_lex()->db))
              MYSQL_YYABORT;
            if (unlikely(check_table_name((yyvsp[0].table)->table.str,(yyvsp[0].table)->table.length,
                                          FALSE)) ||
                ((yyvsp[0].table)->db.str && unlikely(check_db_name((LEX_STRING*) &(yyvsp[0].table)->db))))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[0].table)->table.str));
            lex->name= (yyvsp[0].table)->table;
            lex->alter_info.flags|= ALTER_RENAME;
          }
#line 35760 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1351: /* alter_list_item: CONVERT_SYM TO_SYM charset charset_name_or_default opt_collate  */
#line 8703 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[-1].charset))
            {
              (yyvsp[-1].charset)= thd->variables.collation_database;
            }
            (yyvsp[0].charset)= (yyvsp[0].charset) ? (yyvsp[0].charset) : (yyvsp[-1].charset);
            if (unlikely(!my_charset_same((yyvsp[-1].charset),(yyvsp[0].charset))))
              my_yyabort_error((ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                                (yyvsp[0].charset)->name, (yyvsp[-1].charset)->csname));
            if (unlikely(Lex->create_info.add_alter_list_item_convert_to_charset((yyvsp[0].charset))))
              MYSQL_YYABORT;
            Lex->alter_info.flags|= ALTER_CONVERT_TO;
          }
#line 35778 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1352: /* alter_list_item: create_table_options_space_separated  */
#line 8717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_OPTIONS;
          }
#line 35787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1353: /* alter_list_item: FORCE_SYM  */
#line 8722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_RECREATE;
          }
#line 35795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1354: /* alter_list_item: alter_order_clause  */
#line 8726 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->alter_info.flags|= ALTER_ORDER;
          }
#line 35804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1357: /* alter_list_item: ADD SYSTEM VERSIONING_SYM  */
#line 8733 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_ADD_SYSTEM_VERSIONING;
            Lex->create_info.options|= HA_VERSIONED_TABLE;
          }
#line 35813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1358: /* alter_list_item: DROP SYSTEM VERSIONING_SYM  */
#line 8738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_SYSTEM_VERSIONING;
            Lex->create_info.options&= ~HA_VERSIONED_TABLE;
          }
#line 35822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1359: /* alter_list_item: DROP PERIOD_SYM FOR_SYSTEM_TIME_SYM  */
#line 8743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.flags|= ALTER_DROP_PERIOD;
          }
#line 35830 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1360: /* alter_list_item: DROP PERIOD_SYM opt_if_exists_table_element FOR_SYM ident  */
#line 8747 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Alter_drop *ad= new Alter_drop(Alter_drop::PERIOD, (yyvsp[0].ident_sys).str, (yyvsp[-2].num));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            Lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            Lex->alter_info.flags|= ALTER_DROP_CHECK_CONSTRAINT;
          }
#line 35842 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1366: /* alter_algorithm_option: ALGORITHM_SYM opt_equal DEFAULT  */
#line 8766 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.set_requested_algorithm(
              Alter_info::ALTER_TABLE_ALGORITHM_DEFAULT);
          }
#line 35851 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1367: /* alter_algorithm_option: ALGORITHM_SYM opt_equal ident  */
#line 8771 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_algorithm(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_ALGORITHM, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1368: /* alter_lock_option: LOCK_SYM opt_equal DEFAULT  */
#line 8779 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_DEFAULT;
          }
#line 35869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1369: /* alter_lock_option: LOCK_SYM opt_equal ident  */
#line 8784 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->alter_info.set_requested_lock(&(yyvsp[0].ident_sys))))
              my_yyabort_error((ER_UNKNOWN_ALTER_LOCK, MYF(0), (yyvsp[0].ident_sys).str));
          }
#line 35878 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1370: /* opt_column: %empty  */
#line 8791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 35884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1371: /* opt_column: COLUMN_SYM  */
#line 8792 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 35890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1372: /* opt_ignore: %empty  */
#line 8796 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->ignore= 0;}
#line 35896 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1373: /* opt_ignore: IGNORE_SYM  */
#line 8797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1;}
#line 35902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1374: /* $@143: %empty  */
#line 8801 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->ignore= 0;}
#line 35908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1380: /* alter_option: IGNORE_SYM  */
#line 8815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1;}
#line 35914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1381: /* alter_option: ONLINE_SYM  */
#line 8817 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.requested_lock=
              Alter_info::ALTER_TABLE_LOCK_NONE;
          }
#line 35923 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1382: /* opt_restrict: %empty  */
#line 8824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_DEFAULT; }
#line 35929 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1383: /* opt_restrict: RESTRICT  */
#line 8825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_RESTRICT; }
#line 35935 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1384: /* opt_restrict: CASCADE  */
#line 8826 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->drop_mode= DROP_CASCADE; }
#line 35941 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1385: /* opt_place: %empty  */
#line 8830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.lex_str)= null_clex_str; }
#line 35947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1386: /* opt_place: AFTER_SYM ident  */
#line 8832 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str)= (yyvsp[0].ident_sys);
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 35956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1387: /* opt_place: FIRST_SYM  */
#line 8837 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str).str=    first_keyword;
	    (yyval.lex_str).length= 5; /* Length of "first" */
            Lex->alter_info.flags |= ALTER_COLUMN_ORDER;
          }
#line 35966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1388: /* opt_to: %empty  */
#line 8845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 35972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1389: /* opt_to: TO_SYM  */
#line 8846 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 {}
#line 35978 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1390: /* opt_to: '='  */
#line 8847 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 35984 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1391: /* opt_to: AS  */
#line 8848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 35990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1392: /* $@144: %empty  */
#line 8853 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_START;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE START too */
          }
#line 36001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1393: /* slave: START_SYM SLAVE optional_connection_name slave_thread_opts $@144 slave_until  */
#line 8860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36007 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1394: /* $@145: %empty  */
#line 8862 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_START;
            lex->type = 0;
            /* If you change this code don't forget to update STOP SLAVE too */
          }
#line 36018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1395: /* slave: START_SYM ALL SLAVES slave_thread_opts $@145  */
#line 8868 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1396: /* slave: STOP_SYM SLAVE optional_connection_name slave_thread_opts  */
#line 8870 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1397: /* slave: STOP_SYM ALL SLAVES slave_thread_opts  */
#line 8877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_SLAVE_ALL_STOP;
            lex->type = 0;
            /* If you change this code don't forget to update SLAVE STOP too */
          }
#line 36046 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1398: /* start: START_SYM TRANSACTION_SYM opt_start_transaction_option_list  */
#line 8887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_BEGIN;
            /* READ ONLY and READ WRITE are mutually exclusive. */
            if (unlikely(((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_WRITE) &&
                         ((yyvsp[0].num) & MYSQL_START_TRANS_OPT_READ_ONLY)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
            lex->start_transaction_opt= (yyvsp[0].num);
          }
#line 36063 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1399: /* opt_start_transaction_option_list: %empty  */
#line 8903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= 0;
          }
#line 36071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1400: /* opt_start_transaction_option_list: start_transaction_option_list  */
#line 8907 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36079 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1401: /* start_transaction_option_list: start_transaction_option  */
#line 8914 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[0].num);
          }
#line 36087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1402: /* start_transaction_option_list: start_transaction_option_list ',' start_transaction_option  */
#line 8918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (yyvsp[-2].num) | (yyvsp[0].num);
          }
#line 36095 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1403: /* start_transaction_option: WITH CONSISTENT_SYM SNAPSHOT_SYM  */
#line 8925 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_WITH_CONS_SNAPSHOT;
          }
#line 36103 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1404: /* start_transaction_option: READ_SYM ONLY_SYM  */
#line 8929 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_ONLY;
          }
#line 36111 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1405: /* start_transaction_option: READ_SYM WRITE_SYM  */
#line 8933 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= MYSQL_START_TRANS_OPT_READ_WRITE;
          }
#line 36119 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1406: /* $@146: %empty  */
#line 8939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->slave_thd_opt= 0; }
#line 36125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1407: /* slave_thread_opts: $@146 slave_thread_opt_list  */
#line 8941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1410: /* slave_thread_opt: %empty  */
#line 8950 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 36137 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1411: /* slave_thread_opt: SQL_THREAD  */
#line 8951 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->slave_thd_opt|=SLAVE_SQL; }
#line 36143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1412: /* slave_thread_opt: RELAY_THREAD  */
#line 8952 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->slave_thd_opt|=SLAVE_IO; }
#line 36149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1413: /* slave_until: %empty  */
#line 8956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 36155 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1414: /* slave_until: UNTIL_SYM slave_until_opts  */
#line 8958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(((lex->mi.log_file_name || lex->mi.pos) &&
                         (lex->mi.relay_log_name || lex->mi.relay_log_pos)) ||
                         !((lex->mi.log_file_name && lex->mi.pos) ||
                           (lex->mi.relay_log_name && lex->mi.relay_log_pos))))
               my_yyabort_error((ER_BAD_SLAVE_UNTIL_COND, MYF(0)));
          }
#line 36168 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1415: /* slave_until: UNTIL_SYM MASTER_GTID_POS_SYM '=' TEXT_STRING_sys  */
#line 8967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->mi.gtid_pos_str = (yyvsp[0].lex_str);
          }
#line 36176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1418: /* $@147: %empty  */
#line 8979 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_CHECKSUM;
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1419: /* checksum: CHECKSUM_SYM table_or_tables $@147 table_list opt_checksum_type  */
#line 8986 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36193 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1420: /* opt_checksum_type: %empty  */
#line 8990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= 0; }
#line 36199 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1421: /* opt_checksum_type: QUICK  */
#line 8991 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= T_QUICK; }
#line 36205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1422: /* opt_checksum_type: EXTENDED_SYM  */
#line 8992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->check_opt.flags= T_EXTEND; }
#line 36211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1424: /* $@148: %empty  */
#line 8998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36217 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1426: /* $@149: %empty  */
#line 9004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPAIR;
            lex->no_write_to_binlog= (yyvsp[0].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1427: /* repair: REPAIR opt_no_write_to_binlog $@149 repair_table_or_view  */
#line 9014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_repair_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1428: /* opt_mi_repair_type: %empty  */
#line 9024 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1429: /* opt_mi_repair_type: mi_repair_types  */
#line 9025 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 36255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1430: /* mi_repair_types: mi_repair_type  */
#line 9029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 36261 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1431: /* mi_repair_types: mi_repair_type mi_repair_types  */
#line 9030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         {}
#line 36267 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1432: /* mi_repair_type: QUICK  */
#line 9034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.flags|= T_QUICK; }
#line 36273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1433: /* mi_repair_type: EXTENDED_SYM  */
#line 9035 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.flags|= T_EXTEND; }
#line 36279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1434: /* mi_repair_type: USE_FRM  */
#line 9036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->check_opt.sql_flags|= TT_USEFRM; }
#line 36285 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1435: /* opt_view_repair_type: %empty  */
#line 9040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 36291 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1436: /* opt_view_repair_type: FROM MYSQL_SYM  */
#line 9041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->check_opt.sql_flags|= TT_FROM_MYSQL; }
#line 36297 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1437: /* $@150: %empty  */
#line 9046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_ANALYZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36311 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1438: /* analyze: ANALYZE_SYM opt_no_write_to_binlog table_or_tables $@150 analyze_table_list  */
#line 9056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_analyze_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1442: /* opt_persistent_stat_clause: %empty  */
#line 9076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36329 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1443: /* opt_persistent_stat_clause: PERSISTENT_SYM FOR_SYM persistent_stat_spec  */
#line 9078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            thd->lex->with_persistent_for_clause= TRUE;
          }
#line 36337 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1444: /* persistent_stat_spec: ALL  */
#line 9085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1445: /* persistent_stat_spec: COLUMNS persistent_column_stat_spec INDEXES persistent_index_stat_spec  */
#line 9087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36349 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1446: /* persistent_column_stat_spec: ALL  */
#line 9091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 36355 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1447: /* $@151: %empty  */
#line 9093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX* lex= thd->lex;
            lex->column_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->column_list == NULL))
              MYSQL_YYABORT;
          }
#line 36366 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1448: /* persistent_column_stat_spec: '(' $@151 table_column_list ')'  */
#line 9101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 36372 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1449: /* persistent_index_stat_spec: ALL  */
#line 9105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 36378 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1450: /* $@152: %empty  */
#line 9107 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX* lex= thd->lex;
            lex->index_list= new (thd->mem_root) List<LEX_STRING>;
            if (unlikely(lex->index_list == NULL))
              MYSQL_YYABORT;
          }
#line 36389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1451: /* persistent_index_stat_spec: '(' $@152 table_index_list ')'  */
#line 9115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 36395 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1452: /* table_column_list: %empty  */
#line 9120 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1453: /* table_column_list: ident  */
#line 9122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1454: /* table_column_list: table_column_list ',' ident  */
#line 9127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->column_list->push_back((LEX_STRING*)
                thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)), thd->mem_root);
          }
#line 36419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1455: /* table_index_list: %empty  */
#line 9135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 36425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1458: /* table_index_name: ident  */
#line 9142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->index_list->push_back((LEX_STRING*)
                                       thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_STRING)),
                                       thd->mem_root);
          }
#line 36435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1459: /* table_index_name: PRIMARY_SYM  */
#line 9149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_STRING str= {(char*) "PRIMARY", 7};
            Lex->index_list->push_back((LEX_STRING*)
                                        thd->memdup(&str, sizeof(LEX_STRING)),
                                        thd->mem_root);
          }
#line 36446 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1460: /* binlog_base64_event: BINLOG_SYM TEXT_STRING_sys  */
#line 9159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[0].lex_str);
            Lex->ident.str=    NULL;
            Lex->ident.length= 0;
          }
#line 36457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1461: /* binlog_base64_event: BINLOG_SYM '@' ident_or_text ',' '@' ident_or_text  */
#line 9167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_BINLOG_BASE64_EVENT;
            Lex->comment= (yyvsp[-3].lex_str);
            Lex->ident=   (yyvsp[0].lex_str);
          }
#line 36467 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1463: /* $@153: %empty  */
#line 9177 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->table_type= TABLE_TYPE_VIEW; }
#line 36473 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1465: /* $@154: %empty  */
#line 9182 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->sql_command = SQLCOM_CHECK;
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36487 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1466: /* check: CHECK_SYM $@154 check_view_or_table  */
#line 9192 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "CHECK"));
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_check_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1467: /* opt_mi_check_type: %empty  */
#line 9204 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->check_opt.flags = T_MEDIUM; }
#line 36507 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1468: /* opt_mi_check_type: mi_check_types  */
#line 9205 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 36513 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1469: /* mi_check_types: mi_check_type  */
#line 9209 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 36519 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1470: /* mi_check_types: mi_check_type mi_check_types  */
#line 9210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                       {}
#line 36525 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1471: /* mi_check_type: QUICK  */
#line 9214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_QUICK; }
#line 36531 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1472: /* mi_check_type: FAST_SYM  */
#line 9215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_FAST; }
#line 36537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1473: /* mi_check_type: MEDIUM_SYM  */
#line 9216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_MEDIUM; }
#line 36543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1474: /* mi_check_type: EXTENDED_SYM  */
#line 9217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_EXTEND; }
#line 36549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1475: /* mi_check_type: CHANGED  */
#line 9218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.flags|= T_CHECK_ONLY_CHANGED; }
#line 36555 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1476: /* mi_check_type: FOR_SYM UPGRADE_SYM  */
#line 9219 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1477: /* opt_view_check_type: %empty  */
#line 9223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 36567 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1478: /* opt_view_check_type: FOR_SYM UPGRADE_SYM  */
#line 9224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->check_opt.sql_flags|= TT_FOR_UPGRADE; }
#line 36573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1479: /* $@155: %empty  */
#line 9229 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_OPTIMIZE;
            lex->no_write_to_binlog= (yyvsp[-1].num);
            lex->check_opt.init();
            lex->alter_info.reset();
            /* Will be overridden during execution. */
            YYPS->m_lock_type= TL_UNLOCK;
          }
#line 36587 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1480: /* optimize: OPTIMIZE opt_no_write_to_binlog table_or_tables $@155 table_list opt_lock_wait_timeout  */
#line 9239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_optimize_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 36599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1481: /* opt_no_write_to_binlog: %empty  */
#line 9249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 36605 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1482: /* opt_no_write_to_binlog: NO_WRITE_TO_BINLOG  */
#line 9250 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= 1; }
#line 36611 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1483: /* opt_no_write_to_binlog: LOCAL_SYM  */
#line 9251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= 1; }
#line 36617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1484: /* $@156: %empty  */
#line 9256 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_RENAME_TABLE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 36627 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1485: /* rename: RENAME table_or_tables $@156 table_to_table_list  */
#line 9262 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 36635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1486: /* rename: RENAME USER_SYM clear_privileges rename_list  */
#line 9266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_RENAME_USER;
          }
#line 36643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1487: /* rename_list: user TO_SYM user  */
#line 9273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 36653 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1488: /* rename_list: rename_list ',' user TO_SYM user  */
#line 9279 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[-2].lex_user), thd->mem_root) ||
                         Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 36663 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1491: /* table_to_table: table_ident opt_lock_wait_timeout TO_SYM table_ident  */
#line 9293 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            SELECT_LEX *sl= lex->current_select;
            if (unlikely(!sl->add_table_to_list(thd, (yyvsp[-3].table),NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)) ||
                unlikely(!sl->add_table_to_list(thd, (yyvsp[0].table), NULL,
                                                TL_OPTION_UPDATING,
                                                TL_IGNORE, MDL_EXCLUSIVE)))
              MYSQL_YYABORT;
          }
#line 36679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1492: /* $@157: %empty  */
#line 9308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.reset();
          }
#line 36687 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1493: /* keycache: CACHE_SYM INDEX_SYM $@157 keycache_list_or_parts IN_SYM key_cache_name  */
#line 9312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ASSIGN_TO_KEYCACHE;
            lex->ident= (yyvsp[0].lex_str);
          }
#line 36697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1498: /* assign_to_keycache: table_ident cache_keys_spec  */
#line 9331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1499: /* assign_to_keycache_parts: table_ident adm_partition cache_keys_spec  */
#line 9342 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, 0, TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1500: /* key_cache_name: ident  */
#line 9352 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 36727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1501: /* key_cache_name: DEFAULT  */
#line 9353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str) = default_key_cache_base; }
#line 36733 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1502: /* $@158: %empty  */
#line 9358 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_PRELOAD_KEYS;
            lex->alter_info.reset();
            if (lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 36745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1503: /* preload: LOAD INDEX_SYM INTO CACHE_SYM $@158 preload_list_or_parts  */
#line 9366 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 36753 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1508: /* preload_keys: table_ident cache_keys_spec opt_ignore_leaves  */
#line 9383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-2].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36765 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1509: /* preload_keys_parts: table_ident adm_partition cache_keys_spec opt_ignore_leaves  */
#line 9394 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-3].table), NULL, (yyvsp[0].num), TL_READ,
                                                    MDL_SHARED_READ,
                                                    Select->
                                                    pop_index_hints())))
              MYSQL_YYABORT;
          }
#line 36777 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1510: /* $@159: %empty  */
#line 9405 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->alter_info.partition_flags|= ALTER_PARTITION_ADMIN;
          }
#line 36785 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1512: /* $@160: %empty  */
#line 9412 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->first_select_lex()->alloc_index_hints(thd);
            Lex->first_select_lex()->set_index_hint_type(INDEX_HINT_USE,
                                                         INDEX_HINT_MASK_ALL);
          }
#line 36795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1514: /* cache_key_list_or_empty: %empty  */
#line 9421 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 36801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1516: /* opt_ignore_leaves: %empty  */
#line 9427 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= 0; }
#line 36807 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1517: /* opt_ignore_leaves: IGNORE_SYM LEAVES  */
#line 9428 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.num)= TL_OPTION_IGNORE_LEAVES; }
#line 36813 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1518: /* $@161: %empty  */
#line 9437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 36824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1519: /* select: query_expression_no_with_clause $@161 opt_procedure_or_into  */
#line 9444 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause(NULL);
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 36835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1520: /* $@162: %empty  */
#line 9451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex_unit)->fake_select_lex ?
                                 (yyvsp[0].select_lex_unit)->fake_select_lex :
                                 (yyvsp[0].select_lex_unit)->first_select()))
              MYSQL_YYABORT;
          }
#line 36846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1521: /* select: with_clause query_expression_no_with_clause $@162 opt_procedure_or_into  */
#line 9458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyvsp[-2].select_lex_unit)->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex_unit)->first_select());
            if (Lex->select_finalize((yyvsp[-2].select_lex_unit), (yyvsp[0].select_lock)))
              MYSQL_YYABORT;
          }
#line 36858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1522: /* $@163: %empty  */
#line 9470 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 36867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1523: /* select_into: select_into_query_specification $@163 opt_order_limit_lock  */
#line 9475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
           }
#line 36881 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1524: /* $@164: %empty  */
#line 9486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->push_select((yyvsp[0].select_lex)))
              MYSQL_YYABORT;
          }
#line 36890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1525: /* select_into: with_clause select_into_query_specification $@164 opt_order_limit_lock  */
#line 9491 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX_UNIT *unit;
            if (!(unit  = Lex->create_unit((yyvsp[-2].select_lex))))
              MYSQL_YYABORT;
            if ((yyvsp[0].order_limit_lock))
              unit= Lex->add_tail_to_query_expression_body(unit, (yyvsp[0].order_limit_lock));
            unit->set_with_clause((yyvsp[-3].with_clause));
            (yyvsp[-3].with_clause)->attach_to((yyvsp[-2].select_lex));
            if (Lex->select_finalize(unit))
              MYSQL_YYABORT;
          }
#line 36906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1526: /* simple_table: query_specification  */
#line 9506 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36912 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1527: /* simple_table: table_value_constructor  */
#line 9507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 36918 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1528: /* $@165: %empty  */
#line 9512 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_TVC_start())
              MYSQL_YYABORT;
	  }
#line 36927 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1529: /* table_value_constructor: VALUES $@165 values_list  */
#line 9517 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_TVC_end()))
	      MYSQL_YYABORT;
	  }
#line 36936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1530: /* $@166: %empty  */
#line 9525 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel;
            LEX *lex= Lex;
            if (!(sel= lex->alloc_select(TRUE)) ||
                  lex->push_select(sel))
              MYSQL_YYABORT;
            sel->init_select();
            sel->braces= FALSE;
          }
#line 36950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1531: /* $@167: %empty  */
#line 9535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= SELECT_LIST;
          }
#line 36958 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1532: /* query_specification_start: SELECT_SYM $@166 select_options $@167 select_item_list  */
#line 9539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
          }
#line 36966 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1533: /* query_specification: query_specification_start opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 36974 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1534: /* select_into_query_specification: query_specification_start into opt_from_clause opt_where_clause opt_group_clause opt_having_clause opt_window_clause  */
#line 9564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lex)= Lex->pop_select();
          }
#line 36982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1535: /* query_expression: query_expression_no_with_clause  */
#line 9622 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause(NULL);
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 36991 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1536: /* query_expression: with_clause query_expression_no_with_clause  */
#line 9628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].select_lex_unit)->set_with_clause((yyvsp[-1].with_clause));
            (yyvsp[-1].with_clause)->attach_to((yyvsp[0].select_lex_unit)->first_select());
            (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit);
          }
#line 37001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1537: /* query_expression_no_with_clause: query_expression_body_ext  */
#line 9641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37007 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1538: /* query_expression_no_with_clause: query_expression_body_ext_parens  */
#line 9642 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.select_lex_unit)= (yyvsp[0].select_lex_unit); }
#line 37013 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1539: /* $@168: %empty  */
#line 9657 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[0].select_lex_unit)->first_select()->next_select())
            {
              if (Lex->parsed_multi_operand_query_expression_body((yyvsp[0].select_lex_unit)))
                MYSQL_YYABORT;
            }
          }
#line 37025 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1540: /* query_expression_body_ext: query_expression_body $@168 opt_query_expression_tail  */
#line 9665 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].order_limit_lock))
              (yyval.select_lex_unit)= (yyvsp[-2].select_lex_unit);
            else
              (yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock));
          }
#line 37036 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1541: /* $@169: %empty  */
#line 9672 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->push_select(!(yyvsp[0].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[0].select_lex_unit)->first_select() : (yyvsp[0].select_lex_unit)->fake_select_lex);
          }
#line 37045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1542: /* query_expression_body_ext: query_expression_body_ext_parens $@169 query_expression_tail  */
#line 9677 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_tail_to_query_expression_body_ext_parens((yyvsp[-2].select_lex_unit), (yyvsp[0].order_limit_lock))))
               MYSQL_YYABORT;
          }
#line 37054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1543: /* query_expression_body_ext_parens: '(' query_expression_body_ext_parens ')'  */
#line 9685 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit); }
#line 37060 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1544: /* query_expression_body_ext_parens: '(' query_expression_body_ext ')'  */
#line 9687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= (yyvsp[-1].select_lex_unit)->first_select()->next_select() ?
                               (yyvsp[-1].select_lex_unit)->fake_select_lex : (yyvsp[-1].select_lex_unit)->first_select();
            sel->braces= true;
            (yyval.select_lex_unit)= (yyvsp[-1].select_lex_unit);
          }
#line 37071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1545: /* query_expression_body: query_simple  */
#line 9702 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->push_select((yyvsp[0].select_lex));
            if (!((yyval.select_lex_unit)= Lex->create_unit((yyvsp[0].select_lex))))
              MYSQL_YYABORT;
          }
#line 37081 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1546: /* $@170: %empty  */
#line 9709 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[-1].select_lex_unit)->first_select()->next_select())
            {
              Lex->pop_select();
            }
          }
#line 37092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1547: /* query_expression_body: query_expression_body unit_type_decl $@170 query_primary  */
#line 9716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body((yyvsp[-3].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-2].unit_operation).unit_type,
                                                                (yyvsp[-2].unit_operation).distinct,
                                                                TRUE)))
              MYSQL_YYABORT;
          }
#line 37104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1548: /* query_expression_body: query_expression_body_ext_parens unit_type_decl query_primary  */
#line 9726 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex_unit)= Lex->add_primary_to_query_expression_body_ext_parens(
                                                                (yyvsp[-2].select_lex_unit), (yyvsp[0].select_lex),
                                                                (yyvsp[-1].unit_operation).unit_type,
                                                                (yyvsp[-1].unit_operation).distinct)))
              MYSQL_YYABORT;
          }
#line 37116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1549: /* query_primary: query_simple  */
#line 9742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex); }
#line 37122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1550: /* query_primary: query_expression_body_ext_parens  */
#line 9744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_lex)= (yyvsp[0].select_lex_unit)->first_select(); }
#line 37128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1551: /* query_simple: simple_table  */
#line 9753 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.select_lex)= (yyvsp[0].select_lex);}
#line 37134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1552: /* subselect: query_expression  */
#line 9758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              YYABORT;
          }
#line 37143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1553: /* subquery: query_expression_body_ext_parens  */
#line 9799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!(yyvsp[0].select_lex_unit)->fake_select_lex)
              (yyvsp[0].select_lex_unit)->first_select()->braces= false;
            else
              (yyvsp[0].select_lex_unit)->fake_select_lex->braces= false;
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[0].select_lex_unit))))
              YYABORT;
          }
#line 37156 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1554: /* subquery: '(' with_clause query_expression_no_with_clause ')'  */
#line 9808 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].select_lex_unit)->set_with_clause((yyvsp[-2].with_clause));
            (yyvsp[-2].with_clause)->attach_to((yyvsp[-1].select_lex_unit)->first_select());
            if (!((yyval.select_lex)= Lex->parsed_subselect((yyvsp[-1].select_lex_unit))))
              YYABORT;
          }
#line 37167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1558: /* table_reference_list: join_table_list  */
#line 9827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->context.table_list=
              Select->context.first_name_resolution_table=
                Select->table_list.first;
          }
#line 37177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1561: /* select_options: select_option_list  */
#line 9842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((Select->options & SELECT_DISTINCT) &&
                         (Select->options & SELECT_ALL)))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "ALL", "DISTINCT"));
          }
#line 37187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1562: /* opt_history_unit: %empty  */
#line 9851 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_UNDEFINED;
          }
#line 37195 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1563: /* opt_history_unit: TRANSACTION_SYM  */
#line 9855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_TRX_ID;
          }
#line 37203 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1564: /* opt_history_unit: TIMESTAMP  */
#line 9859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_range_unit)= VERS_TIMESTAMP;
          }
#line 37211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1565: /* history_point: TIMESTAMP TEXT_STRING  */
#line 9866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item;
            if (!(item= type_handler_datetime2.create_literal_item(thd,
                                                      (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                      YYCSCL, true)))
              MYSQL_YYABORT;
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, item);
          }
#line 37224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1566: /* history_point: function_call_keyword_timestamp  */
#line 9875 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_history_point)= Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item));
          }
#line 37232 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1567: /* history_point: opt_history_unit bit_expr  */
#line 9879 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.vers_history_point)= Vers_history_point((yyvsp[-1].vers_range_unit), (yyvsp[0].item));
          }
#line 37240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1568: /* for_portion_of_time_clause: FOR_SYM PORTION_SYM OF_SYM remember_tok_start ident FROM bit_expr TO_SYM bit_expr  */
#line 9887 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(0 == strcasecmp((yyvsp[-4].ident_sys).str, "SYSTEM_TIME")))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-5].simple_string));
              MYSQL_YYABORT;
            }
            Lex->period_conditions.init(SYSTEM_TIME_FROM_TO,
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[-2].item)),
                                        Vers_history_point(VERS_TIMESTAMP, (yyvsp[0].item)),
                                        (yyvsp[-4].ident_sys));
          }
#line 37256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1569: /* opt_for_portion_of_time_clause: %empty  */
#line 9902 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= false;
          }
#line 37264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1570: /* opt_for_portion_of_time_clause: for_portion_of_time_clause  */
#line 9906 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
            (yyval.num)= true;
          }
#line 37272 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1571: /* opt_for_system_time_clause: %empty  */
#line 9913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= false;
          }
#line 37280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1572: /* opt_for_system_time_clause: FOR_SYSTEM_TIME_SYM system_time_expr  */
#line 9917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= true;
          }
#line 37288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1573: /* system_time_expr: AS OF_SYM history_point  */
#line 9924 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_AS_OF, (yyvsp[0].vers_history_point));
          }
#line 37296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1574: /* system_time_expr: ALL  */
#line 9928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 37304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1575: /* system_time_expr: FROM history_point TO_SYM history_point  */
#line 9932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_FROM_TO, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37312 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1576: /* system_time_expr: BETWEEN_SYM history_point AND_SYM history_point  */
#line 9936 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BETWEEN, (yyvsp[-2].vers_history_point), (yyvsp[0].vers_history_point));
          }
#line 37320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1580: /* select_option: SQL_NO_CACHE_SYM  */
#line 9949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_NO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_NO_CACHE"));
            Select->options|= OPTION_NO_QUERY_CACHE;
          }
#line 37333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1581: /* select_option: SQL_CACHE_SYM  */
#line 9958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Allow this flag once per query.
            */
            if (Select->options & OPTION_TO_QUERY_CACHE)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SQL_CACHE"));
            Select->options|= OPTION_TO_QUERY_CACHE;
          }
#line 37346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1582: /* select_lock_type: FOR_SYM UPDATE_SYM opt_lock_wait_timeout_new  */
#line 9971 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= TRUE;
          }
#line 37356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1583: /* select_lock_type: LOCK_SYM IN_SYM SHARE_SYM MODE_SYM opt_lock_wait_timeout_new  */
#line 9977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
            (yyval.select_lock).defined_lock= TRUE;
            (yyval.select_lock).update_lock= FALSE;
          }
#line 37366 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1584: /* opt_select_lock_type: %empty  */
#line 9986 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1585: /* opt_select_lock_type: select_lock_type  */
#line 9990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock)= (yyvsp[0].select_lock);
        }
#line 37382 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1586: /* opt_lock_wait_timeout_new: %empty  */
#line 9997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).empty();
        }
#line 37390 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1587: /* opt_lock_wait_timeout_new: WAIT_SYM ulong_num  */
#line 10001 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= (yyvsp[0].ulong_num);
        }
#line 37399 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1588: /* opt_lock_wait_timeout_new: NOWAIT_SYM  */
#line 10006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.select_lock).defined_timeout= TRUE;
          (yyval.select_lock).timeout= 0;
        }
#line 37408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1591: /* select_item_list: '*'  */
#line 10016 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root)
                          Item_field(thd, &thd->lex->current_select->context,
                                     NULL, NULL, &star_clex_str);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_item_to_list(thd, item)))
              MYSQL_YYABORT;
            (thd->lex->current_select->with_wild)++;
          }
#line 37423 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1592: /* select_item: remember_name select_sublist_qualified_asterisk remember_end  */
#line 10030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_item_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
          }
#line 37432 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1593: /* select_item: remember_name expr remember_end select_alias  */
#line 10035 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT((yyvsp[-3].simple_string) < (yyvsp[-1].simple_string));

            if (unlikely(add_item_to_list(thd, (yyvsp[-2].item))))
              MYSQL_YYABORT;
            if ((yyvsp[0].lex_str).str)
            {
              if (unlikely(Lex->sql_command == SQLCOM_CREATE_VIEW &&
                          check_column_name((yyvsp[0].lex_str).str)))
                my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), (yyvsp[0].lex_str).str));
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            else if (!(yyvsp[-2].item)->name.str || (yyvsp[-2].item)->name.str == item_empty_name)
            {
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            }
          }
#line 37455 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1594: /* remember_tok_start: %empty  */
#line 10056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_tok_start();
          }
#line 37463 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1595: /* remember_name: %empty  */
#line 10062 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_start();
          }
#line 37471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1596: /* remember_end: %empty  */
#line 10068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37479 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1597: /* remember_end_opt: %empty  */
#line 10074 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (yychar == YYEMPTY)
              (yyval.simple_string)= (char*) YYLIP->get_cpp_ptr_rtrim();
            else
              (yyval.simple_string)= (char*) YYLIP->get_cpp_tok_end_rtrim();
          }
#line 37490 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1598: /* select_alias: %empty  */
#line 10083 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)=null_clex_str;}
#line 37496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1599: /* select_alias: AS ident  */
#line 10084 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1600: /* select_alias: AS TEXT_STRING_sys  */
#line 10085 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37508 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1601: /* select_alias: ident  */
#line 10086 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys); }
#line 37514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1602: /* select_alias: TEXT_STRING_sys  */
#line 10087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str); }
#line 37520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1603: /* opt_default_time_precision: %empty  */
#line 10091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37526 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1604: /* opt_default_time_precision: '(' ')'  */
#line 10092 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= NOT_FIXED_DEC;  }
#line 37532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1605: /* opt_default_time_precision: '(' real_ulong_num ')'  */
#line 10093 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1606: /* opt_time_precision: %empty  */
#line 10097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= 0;  }
#line 37544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1607: /* opt_time_precision: '(' ')'  */
#line 10098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= 0;  }
#line 37550 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1608: /* opt_time_precision: '(' real_ulong_num ')'  */
#line 10099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.num)= (yyvsp[-1].ulong_num); }
#line 37556 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1609: /* optional_braces: %empty  */
#line 10103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 37562 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1610: /* optional_braces: '(' ')'  */
#line 10104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 37568 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1611: /* expr: expr or expr  */
#line 10110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Design notes:
              Do not use a manually maintained stack like thd->lex->xxx_list,
              but use the internal bison stack ($$, $1 and $3) instead.
              Using the bison stack is:
              - more robust to changes in the grammar,
              - guaranteed to be in sync with the parser state,
              - better for performances (no memory allocation).
            */
            Item_cond_or *item1;
            Item_cond_or *item3;
            if (is_cond_or((yyvsp[-2].item)))
            {
              item1= (Item_cond_or*) (yyvsp[-2].item);
              if (is_cond_or((yyvsp[0].item)))
              {
                item3= (Item_cond_or*) (yyvsp[0].item);
                /*
                  (X1 OR X2) OR (Y1 OR Y2) ==> OR (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 OR X2) OR Y ==> OR (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_or((yyvsp[0].item)))
            {
              item3= (Item_cond_or*) (yyvsp[0].item);
              /*
                X OR (Y1 OR Y2) ==> OR (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X OR Y */
              (yyval.item)= new (thd->mem_root) Item_cond_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 37623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1612: /* expr: expr XOR expr  */
#line 10161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* XOR is a proprietary extension */
            (yyval.item)= new (thd->mem_root) Item_func_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1613: /* expr: expr and expr  */
#line 10168 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* See comments in rule expr: expr or expr */
            Item_cond_and *item1;
            Item_cond_and *item3;
            if (is_cond_and((yyvsp[-2].item)))
            {
              item1= (Item_cond_and*) (yyvsp[-2].item);
              if (is_cond_and((yyvsp[0].item)))
              {
                item3= (Item_cond_and*) (yyvsp[0].item);
                /*
                  (X1 AND X2) AND (Y1 AND Y2) ==> AND (X1, X2, Y1, Y2)
                */
                item3->add_at_head(item1->argument_list());
                (yyval.item) = (yyvsp[0].item);
              }
              else
              {
                /*
                  (X1 AND X2) AND Y ==> AND (X1, X2, Y)
                */
                item1->add((yyvsp[0].item), thd->mem_root);
                (yyval.item) = (yyvsp[-2].item);
              }
            }
            else if (is_cond_and((yyvsp[0].item)))
            {
              item3= (Item_cond_and*) (yyvsp[0].item);
              /*
                X AND (Y1 AND Y2) ==> AND (X, Y1, Y2)
              */
              item3->add_at_head((yyvsp[-2].item), thd->mem_root);
              (yyval.item) = (yyvsp[0].item);
            }
            else
            {
              /* X AND Y */
              (yyval.item)= new (thd->mem_root) Item_cond_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
              if (unlikely((yyval.item) == NULL))
                MYSQL_YYABORT;
            }
          }
#line 37681 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1614: /* expr: NOT_SYM expr  */
#line 10211 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37691 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1616: /* boolean_test: boolean_test IS TRUE_SYM  */
#line 10221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_istrue(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37701 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1617: /* boolean_test: boolean_test IS not TRUE_SYM  */
#line 10227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnottrue(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37711 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1618: /* boolean_test: boolean_test IS FALSE_SYM  */
#line 10233 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isfalse(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1619: /* boolean_test: boolean_test IS not FALSE_SYM  */
#line 10239 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotfalse(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37731 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1620: /* boolean_test: boolean_test IS UNKNOWN_SYM  */
#line 10245 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37741 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1621: /* boolean_test: boolean_test IS not UNKNOWN_SYM  */
#line 10251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37751 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1622: /* boolean_test: boolean_test IS NULL_SYM  */
#line 10257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnull(thd, (yyvsp[-2].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1623: /* boolean_test: boolean_test IS not NULL_SYM  */
#line 10263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_isnotnull(thd, (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1624: /* boolean_test: boolean_test EQUAL_SYM predicate  */
#line 10269 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_equal(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37781 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1625: /* boolean_test: boolean_test comp_op predicate  */
#line 10275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (*(yyvsp[-1].boolfunc2creator))(0)->create(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1626: /* boolean_test: boolean_test comp_op all_or_any '(' subselect ')'  */
#line 10281 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= all_any_subquery_creator(thd, (yyvsp[-5].item), (yyvsp[-4].boolfunc2creator), (yyvsp[-3].num), (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1628: /* predicate: predicate IN_SYM subquery  */
#line 10291 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-2].item), (yyvsp[0].select_lex));
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1629: /* predicate: predicate not IN_SYM subquery  */
#line 10297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_in_subselect(thd, (yyvsp[-3].item), (yyvsp[0].select_lex));
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1630: /* predicate: predicate IN_SYM '(' expr ')'  */
#line 10306 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-4].item), true, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1631: /* predicate: predicate IN_SYM '(' expr ',' expr_list ')'  */
#line 10312 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-6].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1632: /* predicate: predicate not IN_SYM '(' expr ')'  */
#line 10320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= handle_sql2003_note184_exception(thd, (yyvsp[-5].item), false, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37856 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1633: /* predicate: predicate not IN_SYM '(' expr ',' expr_list ')'  */
#line 10326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-7].item), thd->mem_root);
            Item_func_in *item= new (thd->mem_root) Item_func_in(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1634: /* predicate: predicate BETWEEN_SYM predicate AND_SYM predicate  */
#line 10335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_between(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1635: /* predicate: predicate not BETWEEN_SYM predicate AND_SYM predicate  */
#line 10341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_func_between *item;
            item= new (thd->mem_root) Item_func_between(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1636: /* predicate: predicate SOUNDS_SYM LIKE predicate  */
#line 10349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item1= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[-3].item));
            Item *item4= new (thd->mem_root) Item_func_soundex(thd, (yyvsp[0].item));
            if (unlikely(item1 == NULL) || unlikely(item4 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_eq(thd, item1, item4);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37905 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1637: /* predicate: predicate LIKE predicate  */
#line 10359 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-2].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37915 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1638: /* predicate: predicate LIKE predicate ESCAPE_SYM predicate  */
#line 10365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->escape_used= true;
            (yyval.item)= new (thd->mem_root) Item_func_like(thd, (yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!(yyval.item)))
              MYSQL_YYABORT;
          }
#line 37926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1639: /* predicate: predicate not LIKE predicate  */
#line 10372 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-3].item), (yyvsp[0].item), escape(thd), false);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1640: /* predicate: predicate not LIKE predicate ESCAPE_SYM predicate  */
#line 10379 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->escape_used= true;
            Item *item= new (thd->mem_root) Item_func_like(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[0].item), true);
            if (unlikely(!item))
              MYSQL_YYABORT;
            (yyval.item)= item->neg_transformer(thd);
          }
#line 37949 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1641: /* predicate: predicate REGEXP predicate  */
#line 10387 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1642: /* predicate: predicate not REGEXP predicate  */
#line 10393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_func_regex(thd, (yyvsp[-3].item), (yyvsp[0].item));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= negate_expression(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1644: /* bit_expr: bit_expr '|' bit_expr  */
#line 10406 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_or(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1645: /* bit_expr: bit_expr '&' bit_expr  */
#line 10412 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_and(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 37992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1646: /* bit_expr: bit_expr SHIFT_LEFT bit_expr  */
#line 10418 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_left(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38002 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1647: /* bit_expr: bit_expr SHIFT_RIGHT bit_expr  */
#line 10424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_shift_right(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1648: /* bit_expr: bit_expr ORACLE_CONCAT_SYM bit_expr  */
#line 10430 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat_operator_oracle(thd,
                                                                     (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38023 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1649: /* bit_expr: bit_expr '+' bit_expr  */
#line 10437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_plus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1650: /* bit_expr: bit_expr '-' bit_expr  */
#line 10443 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minus(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38043 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1651: /* bit_expr: bit_expr '+' INTERVAL_SYM expr interval  */
#line 10449 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38053 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1652: /* bit_expr: bit_expr '-' INTERVAL_SYM expr interval  */
#line 10455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-4].item), (yyvsp[-1].item), (yyvsp[0].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38063 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1653: /* bit_expr: INTERVAL_SYM expr interval '+' expr  */
#line 10462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38073 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1654: /* bit_expr: '+' INTERVAL_SYM expr interval '+' expr  */
#line 10468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38083 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1655: /* bit_expr: '-' INTERVAL_SYM expr interval '+' expr  */
#line 10474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[0].item), (yyvsp[-3].item), (yyvsp[-2].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38093 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1656: /* bit_expr: bit_expr '*' bit_expr  */
#line 10480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mul(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38103 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1657: /* bit_expr: bit_expr '/' bit_expr  */
#line 10486 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38113 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1658: /* bit_expr: bit_expr '%' bit_expr  */
#line 10492 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38123 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1659: /* bit_expr: bit_expr DIV_SYM bit_expr  */
#line 10498 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_int_div(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1660: /* bit_expr: bit_expr MOD_SYM bit_expr  */
#line 10504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1661: /* bit_expr: bit_expr '^' bit_expr  */
#line 10510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_xor(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1671: /* comp_op: '='  */
#line 10539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.boolfunc2creator) = &comp_eq_creator; }
#line 38159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1672: /* comp_op: GE  */
#line 10540 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_ge_creator; }
#line 38165 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1673: /* comp_op: '>'  */
#line 10541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { (yyval.boolfunc2creator) = &comp_gt_creator; }
#line 38171 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1674: /* comp_op: LE  */
#line 10542 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_le_creator; }
#line 38177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1675: /* comp_op: '<'  */
#line 10543 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.boolfunc2creator) = &comp_lt_creator; }
#line 38183 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1676: /* comp_op: NE  */
#line 10544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.boolfunc2creator) = &comp_ne_creator; }
#line 38189 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1677: /* all_or_any: ALL  */
#line 10548 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.num) = 1; }
#line 38195 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1678: /* all_or_any: ANY_SYM  */
#line 10549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.num) = 0; }
#line 38201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1679: /* opt_dyncol_type: %empty  */
#line 10554 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_NULL); /* automatic type */
            Lex->charset= NULL;
	  }
#line 38210 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1680: /* opt_dyncol_type: AS dyncol_type  */
#line 10558 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1681: /* dyncol_type: numeric_dyncol_type  */
#line 10562 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1682: /* dyncol_type: temporal_dyncol_type  */
#line 10563 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); Lex->charset= NULL; }
#line 38228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1683: /* dyncol_type: string_dyncol_type  */
#line 10564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type)= (yyvsp[0].Lex_dyncol_type); }
#line 38234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1684: /* numeric_dyncol_type: INT_SYM  */
#line 10568 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_INT); }
#line 38240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1685: /* numeric_dyncol_type: UNSIGNED INT_SYM  */
#line 10569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_UINT);  }
#line 38246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1686: /* numeric_dyncol_type: DOUBLE_SYM  */
#line 10570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE);  }
#line 38252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1687: /* numeric_dyncol_type: REAL  */
#line 10571 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1688: /* numeric_dyncol_type: FLOAT_SYM  */
#line 10572 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DOUBLE); }
#line 38264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1689: /* numeric_dyncol_type: DECIMAL_SYM float_options  */
#line 10573 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DECIMAL, (yyvsp[0].Lex_length_and_dec)); }
#line 38270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1690: /* temporal_dyncol_type: DATE_SYM  */
#line 10577 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATE); }
#line 38276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1691: /* temporal_dyncol_type: TIME_SYM opt_field_length  */
#line 10578 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_TIME, 0, (yyvsp[0].const_simple_string)); }
#line 38282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1692: /* temporal_dyncol_type: DATETIME opt_field_length  */
#line 10579 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.Lex_dyncol_type).set(DYN_COL_DATETIME, 0, (yyvsp[0].const_simple_string)); }
#line 38288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1693: /* $@171: %empty  */
#line 10584 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 38294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1694: /* string_dyncol_type: char $@171 opt_binary  */
#line 10586 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
          }
#line 38302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1695: /* string_dyncol_type: nchar  */
#line 10590 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_dyncol_type).set(DYN_COL_STRING);
            Lex->charset= national_charset_info;
          }
#line 38311 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1696: /* dyncall_create_element: expr ',' expr opt_dyncol_type  */
#line 10598 "/home/buildbot/git/sql/sql_yacc_ora.yy"
   {
     LEX *lex= Lex;
     (yyval.dyncol_def)= (DYNCALL_CREATE_DEF *)
       alloc_root(thd->mem_root, sizeof(DYNCALL_CREATE_DEF));
     if (unlikely((yyval.dyncol_def) == NULL))
       MYSQL_YYABORT;
     (yyval.dyncol_def)->key= (yyvsp[-3].item);
     (yyval.dyncol_def)->value= (yyvsp[-1].item);
     (yyval.dyncol_def)->type= (DYNAMIC_COLUMN_TYPE)(yyvsp[0].Lex_dyncol_type).dyncol_type();
     (yyval.dyncol_def)->cs= lex->charset;
     if ((yyvsp[0].Lex_dyncol_type).length())
       (yyval.dyncol_def)->len= strtoul((yyvsp[0].Lex_dyncol_type).length(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
     if ((yyvsp[0].Lex_dyncol_type).dec())
       (yyval.dyncol_def)->frac= strtoul((yyvsp[0].Lex_dyncol_type).dec(), NULL, 10);
     else
       (yyval.dyncol_def)->len= 0;
   }
#line 38335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1697: /* dyncall_create_list: dyncall_create_element  */
#line 10621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         (yyval.dyncol_def_list)= new (thd->mem_root) List<DYNCALL_CREATE_DEF>;
         if (unlikely((yyval.dyncol_def_list) == NULL))
           MYSQL_YYABORT;
         (yyval.dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
       }
#line 38346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1698: /* dyncall_create_list: dyncall_create_list ',' dyncall_create_element  */
#line 10628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
       {
         (yyvsp[-2].dyncol_def_list)->push_back((yyvsp[0].dyncol_def), thd->mem_root);
         (yyval.dyncol_def_list)= (yyvsp[-2].dyncol_def_list);
       }
#line 38355 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1699: /* plsql_cursor_attr: ISOPEN_SYM  */
#line 10636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ISOPEN; }
#line 38361 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1700: /* plsql_cursor_attr: FOUND_SYM  */
#line 10637 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_FOUND; }
#line 38367 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1701: /* plsql_cursor_attr: NOTFOUND_SYM  */
#line 10638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_NOTFOUND; }
#line 38373 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1702: /* plsql_cursor_attr: ROWCOUNT_SYM  */
#line 10639 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.plsql_cursor_attr)= PLSQL_CURSOR_ATTR_ROWCOUNT; }
#line 38379 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1703: /* explicit_cursor_attr: ident PERCENT_ORACLE_SYM plsql_cursor_attr  */
#line 10644 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_plsql_cursor_attr(thd, &(yyvsp[-2].ident_sys), (yyvsp[0].plsql_cursor_attr)))))
              MYSQL_YYABORT;
          }
#line 38388 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1704: /* trim_operands: expr  */
#line 10652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1705: /* trim_operands: LEADING expr FROM expr  */
#line 10653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[-2].item), (yyvsp[0].item));  }
#line 38400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1706: /* trim_operands: TRAILING expr FROM expr  */
#line 10654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[-2].item), (yyvsp[0].item)); }
#line 38406 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1707: /* trim_operands: BOTH expr FROM expr  */
#line 10655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38412 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1708: /* trim_operands: LEADING FROM expr  */
#line 10656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_LEADING, (yyvsp[0].item));      }
#line 38418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1709: /* trim_operands: TRAILING FROM expr  */
#line 10657 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_TRAILING, (yyvsp[0].item));     }
#line 38424 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1710: /* trim_operands: BOTH FROM expr  */
#line 10658 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[0].item));         }
#line 38430 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1711: /* trim_operands: expr FROM expr  */
#line 10659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.trim).set(TRIM_BOTH, (yyvsp[-2].item), (yyvsp[0].item));     }
#line 38436 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1718: /* column_default_non_parenthesized_expr: param_marker  */
#line 10697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item)= (yyvsp[0].item_param); }
#line 38442 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1720: /* column_default_non_parenthesized_expr: sum_expr  */
#line 10700 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->select_stack_top)
            {
              my_error(ER_INVALID_GROUP_FUNC_USE, MYF(0));
              MYSQL_YYABORT;
            }
          }
#line 38454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1721: /* column_default_non_parenthesized_expr: window_func_expr  */
#line 10708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!Lex->select_stack_top)
            {
               my_error(ER_WRONG_PLACEMENT_OF_WINDOW_FUNCTION, MYF(0));
               MYSQL_YYABORT;
            }
          }
#line 38466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1723: /* column_default_non_parenthesized_expr: ROW_SYM '(' expr ',' expr_list ')'  */
#line 10717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1724: /* column_default_non_parenthesized_expr: EXISTS '(' subselect ')'  */
#line 10724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_exists_subselect(thd, (yyvsp[-1].select_lex));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38487 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1725: /* column_default_non_parenthesized_expr: '{' ident expr '}'  */
#line 10730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].item)->make_odbc_literal(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 38496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1726: /* column_default_non_parenthesized_expr: MATCH ident_list_arg AGAINST '(' bit_expr fulltext_options ')'  */
#line 10735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-5].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            Item_func_match *i1= new (thd->mem_root) Item_func_match(thd, *(yyvsp[-5].item_list),
                                                                     (yyvsp[-1].num));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            Select->add_ftfunc_to_list(thd, i1);
            (yyval.item)= i1;
          }
#line 38510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1727: /* column_default_non_parenthesized_expr: CAST_SYM '(' expr AS cast_type ')'  */
#line 10745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38519 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1728: /* column_default_non_parenthesized_expr: CASE_SYM when_list_opt_else END  */
#line 10750 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= new(thd->mem_root) Item_func_case_searched(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1729: /* column_default_non_parenthesized_expr: CASE_SYM expr when_list_opt_else END  */
#line 10755 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-2].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_case_simple(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 38538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1730: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr ',' cast_type ')'  */
#line 10761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].Lex_cast_type).create_typecast_item(thd, (yyvsp[-3].item), Lex->charset))))
              MYSQL_YYABORT;
          }
#line 38547 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1731: /* column_default_non_parenthesized_expr: CONVERT_SYM '(' expr USING charset_name ')'  */
#line 10766 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_conv_charset(thd, (yyvsp[-3].item), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1732: /* column_default_non_parenthesized_expr: DEFAULT '(' simple_ident ')'  */
#line 10772 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_splocal *il= (yyvsp[-1].item)->get_item_splocal();
            if (unlikely(il))
              my_yyabort_error((ER_WRONG_COLUMN_NAME, MYF(0), il->my_name()->str));
            (yyval.item)= new (thd->mem_root) Item_default_value(thd, Lex->current_context(),
                                                         (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->default_used= TRUE;
          }
#line 38572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1733: /* column_default_non_parenthesized_expr: VALUE_SYM '(' simple_ident_nospvar ')'  */
#line 10783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_insert_value(thd, Lex->current_context(),
                                                        (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1734: /* column_default_non_parenthesized_expr: NEXT_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10790 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 38592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1735: /* column_default_non_parenthesized_expr: NEXTVAL_SYM '(' table_ident ')'  */
#line 10795 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_nextval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 38601 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1736: /* column_default_non_parenthesized_expr: PREVIOUS_SYM VALUE_SYM FOR_SYM table_ident  */
#line 10800 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[0].table)))))
              MYSQL_YYABORT;
          }
#line 38610 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1737: /* column_default_non_parenthesized_expr: LASTVAL_SYM '(' table_ident ')'  */
#line 10805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_lastval(thd, (yyvsp[-1].table)))))
              MYSQL_YYABORT;
          }
#line 38619 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1738: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ')'  */
#line 10810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-3].table), (yyvsp[-1].longlong_number), 0, 1))))
              MYSQL_YYABORT;
          }
#line 38628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1739: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ')'  */
#line 10815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-5].table), (yyvsp[-3].longlong_number), 0, (yyvsp[-1].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 38637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1740: /* column_default_non_parenthesized_expr: SETVAL_SYM '(' table_ident ',' longlong_num ',' bool ',' ulonglong_num ')'  */
#line 10820 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_func_setval(thd, (yyvsp[-7].table), (yyvsp[-5].longlong_number), (yyvsp[-1].ulonglong_number), (yyvsp[-3].ulong_num)))))
              MYSQL_YYABORT;
          }
#line 38646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1743: /* primary_expr: '(' parenthesized_expr ')'  */
#line 10829 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     { (yyval.item)= (yyvsp[-1].item); }
#line 38652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1744: /* primary_expr: subquery  */
#line 10831 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.item)= Lex->create_item_query_expression(thd, (yyvsp[0].select_lex)->master_unit())))
              MYSQL_YYABORT;
          }
#line 38661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1746: /* string_factor_expr: string_factor_expr COLLATE_SYM collation_name  */
#line 10840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_set_collation(thd, (yyvsp[-2].item), (yyvsp[0].charset)))))
              MYSQL_YYABORT;
          }
#line 38670 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1748: /* simple_expr: BINARY simple_expr  */
#line 10849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Type_cast_attributes at(&my_charset_bin);
            if (unlikely(!((yyval.item)= type_handler_long_blob.create_typecast_item(thd, (yyvsp[0].item), at))))
              MYSQL_YYABORT;
          }
#line 38680 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1749: /* simple_expr: '+' simple_expr  */
#line 10855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 38688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1750: /* simple_expr: '-' simple_expr  */
#line 10859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item)->neg(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38698 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1751: /* simple_expr: '~' simple_expr  */
#line 10865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_bit_neg(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38708 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1752: /* simple_expr: not2 simple_expr  */
#line 10871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= negate_expression(thd, (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1754: /* mysql_concatenation_expr: mysql_concatenation_expr MYSQL_CONCAT_SYM simple_expr  */
#line 10881 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_concat(thd, (yyvsp[-2].item), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1755: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ')'  */
#line 10890 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_datetime_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1756: /* function_call_keyword_timestamp: TIMESTAMP '(' expr ',' expr ')'  */
#line 10897 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1757: /* function_call_keyword: CHAR_SYM '(' expr_list ')'  */
#line 10911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1758: /* function_call_keyword: CHAR_SYM '(' expr_list USING charset_name ')'  */
#line 10917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_char(thd, *(yyvsp[-3].item_list), (yyvsp[-1].charset));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38769 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1759: /* function_call_keyword: CURRENT_USER optional_braces  */
#line 10923 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_user(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1760: /* function_call_keyword: CURRENT_ROLE optional_braces  */
#line 10932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_current_role(thd,
                                      Lex->current_context());
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1761: /* function_call_keyword: DATE_SYM '(' expr ')'  */
#line 10941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_typecast(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1762: /* function_call_keyword: DAY_SYM '(' expr ')'  */
#line 10947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dayofmonth(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1763: /* function_call_keyword: HOUR_SYM '(' expr ')'  */
#line 10953 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_hour(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1764: /* function_call_keyword: INSERT '(' expr ',' expr ',' expr ',' expr ')'  */
#line 10959 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_insert(thd, (yyvsp[-7].item), (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1765: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ')'  */
#line 10965 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            if (unlikely(list->push_front((yyvsp[-1].item), thd->mem_root)) ||
                unlikely(list->push_front((yyvsp[-3].item), thd->mem_root)))
              MYSQL_YYABORT;
            Item_row *item= new (thd->mem_root) Item_row(thd, *list);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1766: /* function_call_keyword: INTERVAL_SYM '(' expr ',' expr ',' expr_list ')'  */
#line 10980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            (yyvsp[-1].item_list)->push_front((yyvsp[-5].item), thd->mem_root);
            Item_row *item= new (thd->mem_root) Item_row(thd, *(yyvsp[-1].item_list));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_func_interval(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1767: /* function_call_keyword: LEFT '(' expr ',' expr ')'  */
#line 10991 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_left(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1768: /* function_call_keyword: MINUTE_SYM '(' expr ')'  */
#line 10997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_minute(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1769: /* function_call_keyword: MONTH_SYM '(' expr ')'  */
#line 11003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_month(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38899 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1770: /* function_call_keyword: RIGHT '(' expr ',' expr ')'  */
#line 11009 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_right(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1771: /* function_call_keyword: SECOND_SYM '(' expr ')'  */
#line 11015 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_second(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1772: /* function_call_keyword: SQL_SYM PERCENT_ORACLE_SYM ROWCOUNT_SYM  */
#line 11021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_oracle_sql_rowcount(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 38931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1773: /* function_call_keyword: TIME_SYM '(' expr ')'  */
#line 11029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_time_typecast(thd, (yyvsp[-1].item),
                                      AUTO_SEC_PART_DIGITS);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1774: /* function_call_keyword: function_call_keyword_timestamp  */
#line 11036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 38950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1775: /* function_call_keyword: TRIM '(' trim_operands ')'  */
#line 11040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_trim(thd, (yyvsp[-1].trim)))))
              MYSQL_YYABORT;
          }
#line 38960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1776: /* function_call_keyword: USER_SYM '(' ')'  */
#line 11046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_user(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query=0;
          }
#line 38972 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1777: /* function_call_keyword: YEAR_SYM '(' expr ')'  */
#line 11054 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_year(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 38982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1778: /* substring_operands: expr ',' expr ',' expr  */
#line 11063 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1779: /* substring_operands: expr ',' expr  */
#line 11067 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 38998 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1780: /* substring_operands: expr FROM expr FOR_SYM expr  */
#line 11071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-4].item), (yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1781: /* substring_operands: expr FROM expr  */
#line 11075 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.substring_spec)= Lex_substring_spec_st::init((yyvsp[-2].item), (yyvsp[0].item));
          }
#line 39014 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1782: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' expr ')'  */
#line 11095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39025 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1783: /* function_call_nonkeyword: ADDDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11102 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39035 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1784: /* function_call_nonkeyword: CURDATE optional_braces  */
#line 11108 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_local(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39046 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1785: /* function_call_nonkeyword: CURTIME opt_time_precision  */
#line 11115 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39057 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1786: /* function_call_nonkeyword: DATE_ADD_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39067 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1787: /* function_call_nonkeyword: DATE_SUB_INTERVAL '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1788: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ')'  */
#line 11134 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1789: /* function_call_nonkeyword: DATE_FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_date_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39097 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1790: /* function_call_nonkeyword: DECODE_MARIADB_SYM '(' expr ',' expr ')'  */
#line 11146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_decode(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1791: /* function_call_nonkeyword: DECODE_ORACLE_SYM '(' expr ',' decode_when_list_oracle ')'  */
#line 11152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-1].item_list)->push_front((yyvsp[-3].item), thd->mem_root);
            if (unlikely(!((yyval.item)= new (thd->mem_root) Item_func_decode_oracle(thd, *(yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39117 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1792: /* function_call_nonkeyword: EXTRACT_SYM '(' interval FROM expr ')'  */
#line 11158 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_extract(thd, (yyvsp[-3].interval), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39127 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1793: /* function_call_nonkeyword: GET_FORMAT '(' date_time_type ',' expr ')'  */
#line 11164 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_format(thd, (yyvsp[-3].date_time_type), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39137 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1794: /* function_call_nonkeyword: NOW_SYM opt_time_precision  */
#line 11170 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39148 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1795: /* function_call_nonkeyword: POSITION_SYM '(' bit_expr IN_SYM expr ')'  */
#line 11177 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_locate(thd, (yyvsp[-1].item), (yyvsp[-3].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1796: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' expr ')'  */
#line 11183 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                             INTERVAL_DAY, 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1797: /* function_call_nonkeyword: SUBDATE_SYM '(' expr ',' INTERVAL_SYM expr interval ')'  */
#line 11190 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-5].item), (yyvsp[-2].item), (yyvsp[-1].interval), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1798: /* function_call_nonkeyword: SUBSTRING '(' substring_operands ')'  */
#line 11196 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_substr(thd, (yyvsp[-1].substring_spec)))))
              MYSQL_YYABORT;
          }
#line 39189 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1799: /* function_call_nonkeyword: SYSDATE opt_time_precision  */
#line 11202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Unlike other time-related functions, SYSDATE() is
              replication-unsafe because it is not affected by the
              TIMESTAMP variable.  It is unsafe even if
              sysdate_is_now=1, because the slave may have
              sysdate_is_now=0.
            */
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            if (global_system_variables.sysdate_is_now == 0)
              (yyval.item)= new (thd->mem_root) Item_func_sysdate_local(thd, (yyvsp[0].num));
            else
              (yyval.item)= new (thd->mem_root) Item_func_now_local(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1800: /* function_call_nonkeyword: TIMESTAMP_ADD '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_date_add_interval(thd, (yyvsp[-1].item), (yyvsp[-3].item), (yyvsp[-5].interval_time_st), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1801: /* function_call_nonkeyword: TIMESTAMP_DIFF '(' interval_time_stamp ',' expr ',' expr ')'  */
#line 11226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_timestamp_diff(thd, (yyvsp[-3].item), (yyvsp[-1].item), (yyvsp[-5].interval_time_st));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1802: /* function_call_nonkeyword: TRIM_ORACLE '(' trim_operands ')'  */
#line 11232 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= (yyvsp[-1].trim).make_item_func_trim_oracle(thd))))
              MYSQL_YYABORT;
          }
#line 39240 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1803: /* function_call_nonkeyword: UTC_DATE_SYM optional_braces  */
#line 11237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curdate_utc(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39251 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1804: /* function_call_nonkeyword: UTC_TIME_SYM opt_time_precision  */
#line 11244 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_curtime_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39262 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1805: /* function_call_nonkeyword: UTC_TIMESTAMP_SYM opt_time_precision  */
#line 11251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_now_utc(thd, (yyvsp[0].num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1806: /* function_call_nonkeyword: COLUMN_ADD_SYM '(' expr ',' dyncall_create_list ')'  */
#line 11259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_add(thd, (yyvsp[-3].item), *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39283 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1807: /* function_call_nonkeyword: COLUMN_DELETE_SYM '(' expr ',' expr_list ')'  */
#line 11266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_delete(thd, (yyvsp[-3].item), *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39293 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1808: /* function_call_nonkeyword: COLUMN_CHECK_SYM '(' expr ')'  */
#line 11273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_dyncol_check(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39303 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1809: /* function_call_nonkeyword: COLUMN_CREATE_SYM '(' dyncall_create_list ')'  */
#line 11280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= create_func_dyncol_create(thd, *(yyvsp[-1].dyncol_def_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1810: /* function_call_nonkeyword: COLUMN_GET_SYM '(' expr ',' expr AS cast_type ')'  */
#line 11287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            (yyval.item)= create_func_dyncol_get(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].Lex_cast_type).type_handler(),
                                        (yyvsp[-1].Lex_cast_type).length(), (yyvsp[-1].Lex_cast_type).dec(),
                                        lex->charset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39326 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1811: /* function_call_conflict: ASCII_SYM '(' expr ')'  */
#line 11304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_ascii(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1812: /* function_call_conflict: CHARSET '(' expr ')'  */
#line 11310 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_charset(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1813: /* function_call_conflict: COALESCE '(' expr_list ')'  */
#line 11316 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_coalesce(thd, *(yyvsp[-1].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1814: /* function_call_conflict: COLLATION_SYM '(' expr ')'  */
#line 11322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_collation(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39366 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1815: /* function_call_conflict: DATABASE '(' ')'  */
#line 11328 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_database(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->safe_to_cache_query=0;
          }
#line 39377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1816: /* function_call_conflict: IF_SYM '(' expr ',' expr ',' expr ')'  */
#line 11335 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_if(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39387 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1817: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ')'  */
#line 11341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1818: /* function_call_conflict: FORMAT_SYM '(' expr ',' expr ',' expr ')'  */
#line 11347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_format(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39407 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1819: /* function_call_conflict: LAST_VALUE '(' expr ')'  */
#line 11356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            List<Item> *list= new (thd->mem_root) List<Item>;
            if (unlikely(list == NULL))
              MYSQL_YYABORT;
            list->push_back((yyvsp[-1].item), thd->mem_root);

            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *list);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39422 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1820: /* function_call_conflict: LAST_VALUE '(' expr_list ',' expr ')'  */
#line 11367 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].item_list)->push_back((yyvsp[-1].item), thd->mem_root);
            (yyval.item)= new (thd->mem_root) Item_func_last_value(thd, *(yyvsp[-3].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1821: /* function_call_conflict: MICROSECOND_SYM '(' expr ')'  */
#line 11374 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_microsecond(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1822: /* function_call_conflict: MOD_SYM '(' expr ',' expr ')'  */
#line 11380 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_mod(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1823: /* function_call_conflict: OLD_PASSWORD_SYM '(' expr ')'  */
#line 11386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=  new (thd->mem_root)
              Item_func_password(thd, (yyvsp[-1].item), Item_func_password::OLD);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39464 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1824: /* function_call_conflict: PASSWORD_SYM '(' expr ')'  */
#line 11393 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item* i1;
            i1= new (thd->mem_root) Item_func_password(thd, (yyvsp[-1].item));
            if (unlikely(i1 == NULL))
              MYSQL_YYABORT;
            (yyval.item)= i1;
          }
#line 39476 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1825: /* function_call_conflict: QUARTER_SYM '(' expr ')'  */
#line 11401 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_quarter(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39486 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1826: /* function_call_conflict: REPEAT_SYM '(' expr ',' expr ')'  */
#line 11407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_repeat(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1827: /* function_call_conflict: REPLACE '(' expr ',' expr ',' expr ')'  */
#line 11413 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Schema::find_implied(thd)->
                                 make_item_func_replace(thd, (yyvsp[-5].item), (yyvsp[-3].item), (yyvsp[-1].item)))))
              MYSQL_YYABORT;
          }
#line 39506 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1828: /* function_call_conflict: REVERSE_SYM '(' expr ')'  */
#line 11419 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_reverse(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1829: /* function_call_conflict: ROW_COUNT_SYM '(' ')'  */
#line 11425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_row_count(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_SYSTEM_FUNCTION);
            Lex->safe_to_cache_query= 0;
          }
#line 39528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1830: /* function_call_conflict: TRUNCATE_SYM '(' expr ',' expr ')'  */
#line 11433 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_round(thd, (yyvsp[-3].item), (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1831: /* function_call_conflict: WEEK_SYM '(' expr ')'  */
#line 11439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1832: /* function_call_conflict: WEEK_SYM '(' expr ',' expr ')'  */
#line 11445 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_week(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1833: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr opt_ws_levels ')'  */
#line 11451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-2].item), 0, 0, (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39568 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1834: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS CHAR_SYM ws_nweights opt_ws_levels ')'  */
#line 11457 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, (yyvsp[-5].item), 0, (yyvsp[-2].ulong_num),
                                        (yyvsp[-1].ulong_num) | MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39580 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1835: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr AS BINARY ws_nweights ')'  */
#line 11465 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_char_typecast(thd, (yyvsp[-4].item), (yyvsp[-1].ulong_num),
                                                               &my_charset_bin);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root)
                Item_func_weight_string(thd, item, 0, (yyvsp[-1].ulong_num),
                                        MY_STRXFRM_PAD_WITH_SPACE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39596 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1836: /* function_call_conflict: WEIGHT_STRING_SYM '(' expr ',' ulong_num ',' ulong_num ',' ulong_num ')'  */
#line 11477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_weight_string(thd, (yyvsp[-7].item), (yyvsp[-5].ulong_num), (yyvsp[-3].ulong_num),
                                                            (yyvsp[-1].ulong_num));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39607 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1837: /* function_call_conflict: geometry_function  */
#line 11484 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_SPATIAL
            (yyval.item)= (yyvsp[0].item);
            /* $1 may be NULL, GEOM_NEW not tested for out of memory */
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
#else
            my_yyabort_error((ER_FEATURE_DISABLED, MYF(0), sym_group_geom.name,
                              sym_group_geom.needed_define));
#endif
          }
#line 39623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1838: /* geometry_function: CONTAINS_SYM '(' expr ',' expr ')'  */
#line 11499 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                 Item_func::SP_CONTAINS_FUNC));
          }
#line 39633 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1839: /* geometry_function: GEOMETRYCOLLECTION '(' expr_list ')'  */
#line 11505 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_geometrycollection,
                           Geometry::wkb_point));
          }
#line 39644 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1840: /* geometry_function: LINESTRING '(' expr_list ')'  */
#line 11512 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_linestring,
                           Geometry::wkb_point));
          }
#line 39655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1841: /* geometry_function: MULTILINESTRING '(' expr_list ')'  */
#line 11519 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multilinestring,
                           Geometry::wkb_linestring));
          }
#line 39666 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1842: /* geometry_function: MULTIPOINT '(' expr_list ')'  */
#line 11526 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipoint,
                           Geometry::wkb_point));
          }
#line 39677 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1843: /* geometry_function: MULTIPOLYGON '(' expr_list ')'  */
#line 11533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_multipolygon,
                           Geometry::wkb_polygon));
          }
#line 39688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1844: /* geometry_function: POINT_SYM '(' expr ',' expr ')'  */
#line 11540 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_point(thd, (yyvsp[-3].item), (yyvsp[-1].item)));
          }
#line 39696 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1845: /* geometry_function: POLYGON '(' expr_list ')'  */
#line 11544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd,
                         Item_func_spatial_collection(thd, *(yyvsp[-1].item_list),
                           Geometry::wkb_polygon,
                           Geometry::wkb_linestring));
          }
#line 39707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1846: /* geometry_function: WITHIN '(' expr ',' expr ')'  */
#line 11551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= GEOM_NEW(thd, Item_func_spatial_precise_rel(thd, (yyvsp[-3].item), (yyvsp[-1].item),
                                                    Item_func::SP_WITHIN_FUNC));
          }
#line 39716 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1847: /* @172: %empty  */
#line 11568 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
#ifdef HAVE_DLOPEN
            udf_func *udf= 0;
            LEX *lex= Lex;
            if (using_udf_functions &&
                (udf= find_udf((yyvsp[-1].ident_sys).str, (yyvsp[-1].ident_sys).length)) &&
                udf->type == UDFTYPE_AGGREGATE)
            {
              if (unlikely(lex->current_select->inc_in_sum_expr()))
              {
                thd->parse_error();
                MYSQL_YYABORT;
              }
            }
            /* Temporary placing the result of find_udf in $3 */
            (yyval.udf)= udf;
#endif
          }
#line 39739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1848: /* function_call_generic: IDENT_sys '(' @172 opt_udf_expr_list ')'  */
#line 11587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Create_func *builder;
            Item *item= NULL;

            if (unlikely(check_routine_name(&(yyvsp[-4].ident_sys))))
              MYSQL_YYABORT;

            /*
              Implementation note:
              names are resolved with the following order:
              - MySQL native functions,
              - User Defined Functions,
              - Stored Functions (assuming the current <use> database)

              This will be revised with WL#2128 (SQL PATH)
            */
            builder= find_native_function_builder(thd, &(yyvsp[-4].ident_sys));
            if (builder)
            {
              item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
            }
            else
            {
#ifdef HAVE_DLOPEN
              /* Retrieving the result of find_udf */
              udf_func *udf= (yyvsp[-2].udf);

              if (udf)
              {
                if (udf->type == UDFTYPE_AGGREGATE)
                {
                  Select->in_sum_expr--;
                }

                item= Create_udf_func::s_singleton.create(thd, udf, (yyvsp[-1].item_list));
              }
              else
#endif
              {
                builder= find_qualified_function_builder(thd);
                DBUG_ASSERT(builder);
                item= builder->create_func(thd, &(yyvsp[-4].ident_sys), (yyvsp[-1].item_list));
              }
            }

            if (unlikely(! ((yyval.item)= item)))
              MYSQL_YYABORT;
          }
#line 39792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1849: /* function_call_generic: ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11636 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39801 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1850: /* function_call_generic: ident_cli '.' ident_cli '.' ident_cli '(' opt_expr_list ')'  */
#line 11641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_func_call_generic(thd, &(yyvsp[-7].ident_cli), &(yyvsp[-5].ident_cli), &(yyvsp[-3].ident_cli), (yyvsp[-1].item_list)))))
              MYSQL_YYABORT;
          }
#line 39810 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1851: /* fulltext_options: opt_natural_language_mode opt_query_expansion  */
#line 11649 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= (yyvsp[-1].num) | (yyvsp[0].num); }
#line 39816 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1852: /* fulltext_options: IN_SYM BOOLEAN_SYM MODE_SYM  */
#line 11651 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.num)= FT_BOOL; }
#line 39822 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1853: /* opt_natural_language_mode: %empty  */
#line 11655 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_NL; }
#line 39828 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1854: /* opt_natural_language_mode: IN_SYM NATURAL LANGUAGE_SYM MODE_SYM  */
#line 11656 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_NL; }
#line 39834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1855: /* opt_query_expansion: %empty  */
#line 11660 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= 0;         }
#line 39840 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1856: /* opt_query_expansion: WITH QUERY_SYM EXPANSION_SYM  */
#line 11661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                { (yyval.num)= FT_EXPAND; }
#line 39846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1857: /* opt_udf_expr_list: %empty  */
#line 11665 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item_list)= NULL; }
#line 39852 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1858: /* opt_udf_expr_list: udf_expr_list  */
#line 11666 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item_list)= (yyvsp[0].item_list); }
#line 39858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1859: /* udf_expr_list: udf_expr  */
#line 11671 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root);
          }
#line 39869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1860: /* udf_expr_list: udf_expr_list ',' udf_expr  */
#line 11678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 39878 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1861: /* udf_expr: remember_name expr remember_end select_alias  */
#line 11686 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
             Use Item::name as a storage for the attribute value of user
             defined function argument. It is safe to use Item::name
             because the syntax will not allow having an explicit name here.
             See WL#1017 re. udf attributes.
            */
            if ((yyvsp[0].lex_str).str)
            {
              (yyvsp[-2].item)->is_autogenerated_name= FALSE;
              (yyvsp[-2].item)->set_name(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length, system_charset_info);
            }
            /* 
               A field has to have its proper name in order for name
               resolution to work, something we are only guaranteed if we
               parse it out. If we hijack the input stream with
               remember_name we may get quoted or escaped names.
            */
            else if ((yyvsp[-2].item)->type() != Item::FIELD_ITEM &&
                     (yyvsp[-2].item)->type() != Item::REF_ITEM /* For HAVING */ )
              (yyvsp[-2].item)->set_name(thd, (yyvsp[-3].simple_string), (uint) ((yyvsp[-1].simple_string) - (yyvsp[-3].simple_string)), thd->charset());
            (yyval.item)= (yyvsp[-2].item);
          }
#line 39906 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1862: /* sum_expr: AVG_SYM '(' in_sum_expr ')'  */
#line 11713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1863: /* sum_expr: AVG_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_avg(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1864: /* sum_expr: BIT_AND '(' in_sum_expr ')'  */
#line 11725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_and(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1865: /* sum_expr: BIT_OR '(' in_sum_expr ')'  */
#line 11731 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_or(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1866: /* sum_expr: BIT_XOR '(' in_sum_expr ')'  */
#line 11737 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_xor(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39956 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1867: /* sum_expr: COUNT_SYM '(' opt_all '*' ')'  */
#line 11743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *item= new (thd->mem_root) Item_int(thd, (int32) 0L, 1);
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, item);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1868: /* sum_expr: COUNT_SYM '(' in_sum_expr ')'  */
#line 11752 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 39979 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1869: /* $@173: %empty  */
#line 11758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr++; }
#line 39985 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1870: /* $@174: %empty  */
#line 11760 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr--; }
#line 39991 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1871: /* sum_expr: COUNT_SYM '(' DISTINCT $@173 expr_list $@174 ')'  */
#line 11762 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_count(thd, *(yyvsp[-2].item_list));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40001 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1872: /* sum_expr: MIN_SYM '(' in_sum_expr ')'  */
#line 11768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1873: /* sum_expr: MIN_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11779 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_min(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1874: /* sum_expr: MAX_SYM '(' in_sum_expr ')'  */
#line 11785 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40031 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1875: /* sum_expr: MAX_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11791 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_max(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40041 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1876: /* sum_expr: STD_SYM '(' in_sum_expr ')'  */
#line 11797 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40051 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1877: /* sum_expr: VARIANCE_SYM '(' in_sum_expr ')'  */
#line 11803 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40061 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1878: /* sum_expr: STDDEV_SAMP_SYM '(' in_sum_expr ')'  */
#line 11809 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_std(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40071 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1879: /* sum_expr: VAR_SAMP_SYM '(' in_sum_expr ')'  */
#line 11815 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_variance(thd, (yyvsp[-1].item), 1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40081 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1880: /* sum_expr: SUM_SYM '(' in_sum_expr ')'  */
#line 11821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), FALSE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1881: /* sum_expr: SUM_SYM '(' DISTINCT in_sum_expr ')'  */
#line 11827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_sum(thd, (yyvsp[-1].item), TRUE);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40101 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1882: /* $@175: %empty  */
#line 11833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->in_sum_expr++; }
#line 40107 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1883: /* sum_expr: GROUP_CONCAT_SYM '(' opt_distinct $@175 expr_list opt_gorder_clause opt_gconcat_separator opt_glimit_clause ')'  */
#line 11837 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->in_sum_expr--;
            (yyval.item)= new (thd->mem_root)
                  Item_func_group_concat(thd, Lex->current_context(),
                                        (yyvsp[-6].num), (yyvsp[-4].item_list),
                                        sel->gorder_list, (yyvsp[-2].string), (yyvsp[-1].num),
                                        sel->select_limit,
                                        sel->offset_limit);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            sel->select_limit= NULL;
            sel->offset_limit= NULL;
            sel->explicit_limit= 0;
            (yyvsp[-4].item_list)->empty();
            sel->gorder_list.empty();
          }
#line 40129 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1884: /* window_func_expr: window_func OVER_SYM window_name  */
#line 11858 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item), (yyvsp[0].lex_str_ptr));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40141 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1885: /* window_func_expr: window_func OVER_SYM window_spec  */
#line 11867 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 lex->win_frame)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-2].item),
                                                      thd->lex->win_spec); 
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40160 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1888: /* window_func: function_call_generic  */
#line 11889 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item* item = (Item*)(yyvsp[0].item);
            /* Only UDF aggregate here possible */
            if ((item == NULL) ||
                (item->type() != Item::SUM_FUNC_ITEM)
                || (((Item_sum *)item)->sum_func() != Item_sum::UDF_SUM_FUNC))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1889: /* simple_window_func: ROW_NUMBER_SYM '(' ')'  */
#line 11904 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_row_number(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40186 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1890: /* simple_window_func: RANK_SYM '(' ')'  */
#line 11911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1891: /* simple_window_func: DENSE_RANK_SYM '(' ')'  */
#line 11918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_dense_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40206 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1892: /* simple_window_func: PERCENT_RANK_SYM '(' ')'  */
#line 11925 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percent_rank(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40216 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1893: /* simple_window_func: CUME_DIST_SYM '(' ')'  */
#line 11932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_cume_dist(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40226 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1894: /* simple_window_func: NTILE_SYM '(' expr ')'  */
#line 11939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_ntile(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40236 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1895: /* simple_window_func: FIRST_VALUE_SYM '(' expr ')'  */
#line 11946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_first_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1896: /* simple_window_func: LAST_VALUE '(' expr ')'  */
#line 11953 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_last_value(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1897: /* simple_window_func: NTH_VALUE_SYM '(' expr ',' expr ')'  */
#line 11960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_nth_value(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40266 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1898: /* simple_window_func: LEAD_SYM '(' expr ')'  */
#line 11967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1899: /* simple_window_func: LEAD_SYM '(' expr ',' expr ')'  */
#line 11978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lead(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1900: /* simple_window_func: LAG_SYM '(' expr ')'  */
#line 11985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* No second argument defaults to 1. */
            Item* item_offset= new (thd->mem_root) Item_uint(thd, 1);
            if (unlikely(item_offset == NULL))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-1].item), item_offset);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40304 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1901: /* simple_window_func: LAG_SYM '(' expr ',' expr ')'  */
#line 11996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_lag(thd, (yyvsp[-3].item), (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1902: /* inverse_distribution_function: percentile_function OVER_SYM '(' opt_window_partition_clause ')'  */
#line 12008 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(Select->add_window_spec(thd, lex->win_ref,
                                                 Select->group_list,
                                                 Select->order_list,
                                                 NULL)))
              MYSQL_YYABORT;
            (yyval.item)= new (thd->mem_root) Item_window_func(thd, (Item_sum *) (yyvsp[-4].item),
                                                     thd->lex->win_spec);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            if (unlikely(Select->add_window_func((Item_window_func *) (yyval.item))))
              MYSQL_YYABORT;
          }
#line 40333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1903: /* $@176: %empty  */
#line 12026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           { Select->prepare_add_window_spec(thd); }
#line 40339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1904: /* percentile_function: inverse_distribution_function_def WITHIN GROUP_SYM '(' $@176 order_by_single_element_list ')'  */
#line 12028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             (yyval.item)= (yyvsp[-6].item);
           }
#line 40347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1905: /* percentile_function: MEDIAN_SYM '(' expr ')'  */
#line 12032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *args= new (thd->mem_root) Item_decimal(thd, "0.5", 3,
                                                   thd->charset());
            if (unlikely(args == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
            Select->prepare_add_window_spec(thd);
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),FALSE)))
              MYSQL_YYABORT;

            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, args);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1906: /* inverse_distribution_function_def: PERCENTILE_CONT_SYM '(' expr ')'  */
#line 12049 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_cont(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1907: /* inverse_distribution_function_def: PERCENTILE_DISC_SYM '(' expr ')'  */
#line 12055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_sum_percentile_disc(thd, (yyvsp[-1].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 40385 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1908: /* order_by_single_element_list: ORDER_SYM BY order_ident order_dir  */
#line 12064 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
          }
#line 40394 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1909: /* window_name: ident  */
#line 12073 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 40404 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1910: /* $@177: %empty  */
#line 12082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(! Lex->parsing_options.allows_variable))
              my_yyabort_error((ER_VIEW_SELECT_VARIABLE, MYF(0)));
          }
#line 40413 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1911: /* variable: '@' $@177 variable_aux  */
#line 12087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= (yyvsp[0].item);
          }
#line 40421 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1912: /* variable_aux: ident_or_text SET_VAR expr  */
#line 12094 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_func_set_user_var *item;
            (yyval.item)= item= new (thd->mem_root) Item_func_set_user_var(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            lex->set_var_list.push_back(item, thd->mem_root);
          }
#line 40435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1913: /* variable_aux: ident_or_text  */
#line 12104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_func_get_user_var(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 40447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1914: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name  */
#line 12112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-1].var_type), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1915: /* variable_aux: '@' opt_var_ident_type ident_sysvar_name '.' ident  */
#line 12117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_sysvar(thd, (yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 40465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1916: /* opt_distinct: %empty  */
#line 12124 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 0; }
#line 40471 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1917: /* opt_distinct: DISTINCT  */
#line 12125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 1; }
#line 40477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1918: /* opt_gconcat_separator: %empty  */
#line 12130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string)= new (thd->mem_root) String(",", 1, &my_charset_latin1);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 40487 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1919: /* opt_gconcat_separator: SEPARATOR_SYM text_string  */
#line 12135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.string) = (yyvsp[0].string); }
#line 40493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1922: /* gorder_list: gorder_list ',' order_ident order_dir  */
#line 12145 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1923: /* gorder_list: order_ident order_dir  */
#line 12150 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_gorder_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 40511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1924: /* opt_glimit_clause: %empty  */
#line 12157 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) = 0; }
#line 40517 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1925: /* opt_glimit_clause: glimit_clause  */
#line 12158 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num) = 1; }
#line 40523 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1926: /* glimit_clause_init: LIMIT  */
#line 12162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 40529 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1927: /* glimit_clause: glimit_clause_init glimit_options  */
#line 12167 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 40537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1928: /* glimit_options: limit_option  */
#line 12174 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= 0;
            sel->explicit_limit= 1;
          }
#line 40548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1929: /* glimit_options: limit_option ',' limit_option  */
#line 12181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            sel->offset_limit= (yyvsp[-2].item);
            sel->explicit_limit= 1;
          }
#line 40559 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1930: /* glimit_options: limit_option OFFSET_SYM limit_option  */
#line 12188 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[-2].item);
            sel->offset_limit= (yyvsp[0].item);
            sel->explicit_limit= 1;
          }
#line 40570 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1931: /* $@178: %empty  */
#line 12200 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->current_select->inc_in_sum_expr()))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40583 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1932: /* in_sum_expr: opt_all $@178 expr  */
#line 12209 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->in_sum_expr--;
            (yyval.item)= (yyvsp[0].item);
          }
#line 40592 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1933: /* cast_type: BINARY opt_field_length  */
#line 12217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string)); Lex->charset= &my_charset_bin; }
#line 40598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1934: /* $@179: %empty  */
#line 12219 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40604 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1935: /* cast_type: CHAR_SYM opt_field_length $@179 opt_binary  */
#line 12221 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40610 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1936: /* $@180: %empty  */
#line 12223 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40616 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1937: /* cast_type: VARCHAR field_length $@180 opt_binary  */
#line 12225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1938: /* $@181: %empty  */
#line 12227 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->charset= thd->variables.collation_connection; }
#line 40628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1939: /* cast_type: VARCHAR2_ORACLE_SYM field_length $@181 opt_binary  */
#line 12229 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[-2].const_simple_string)); }
#line 40634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1940: /* cast_type: NCHAR_SYM opt_field_length  */
#line 12231 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->charset= national_charset_info;
            (yyval.Lex_cast_type).set(&type_handler_long_blob, (yyvsp[0].const_simple_string), 0);
          }
#line 40643 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1941: /* cast_type: cast_type_numeric  */
#line 12235 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 40649 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1942: /* cast_type: cast_type_temporal  */
#line 12236 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.Lex_cast_type)= (yyvsp[0].Lex_cast_type); Lex->charset= NULL; }
#line 40655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1943: /* cast_type_numeric: INT_SYM  */
#line 12240 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40661 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1944: /* cast_type_numeric: SIGNED_SYM  */
#line 12241 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40667 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1945: /* cast_type_numeric: SIGNED_SYM INT_SYM  */
#line 12242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_longlong); }
#line 40673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1946: /* cast_type_numeric: UNSIGNED  */
#line 12243 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 40679 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1947: /* cast_type_numeric: UNSIGNED INT_SYM  */
#line 12244 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_ulonglong); }
#line 40685 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1948: /* cast_type_numeric: DECIMAL_SYM float_options  */
#line 12245 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdecimal, (yyvsp[0].Lex_length_and_dec)); }
#line 40691 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1949: /* cast_type_numeric: FLOAT_SYM  */
#line 12246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_float); }
#line 40697 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1950: /* cast_type_numeric: DOUBLE_SYM opt_precision  */
#line 12247 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_double, (yyvsp[0].Lex_length_and_dec));  }
#line 40703 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1951: /* cast_type_temporal: DATE_SYM  */
#line 12251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_newdate); }
#line 40709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1952: /* cast_type_temporal: TIME_SYM opt_field_length  */
#line 12252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_time2, 0, (yyvsp[0].const_simple_string)); }
#line 40715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1953: /* cast_type_temporal: DATETIME opt_field_length  */
#line 12253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.Lex_cast_type).set(&type_handler_datetime2, 0, (yyvsp[0].const_simple_string)); }
#line 40721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1954: /* cast_type_temporal: INTERVAL_SYM DAY_SECOND_SYM field_length  */
#line 12255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.Lex_cast_type).set(&type_handler_interval_DDhhmmssff, 0, (yyvsp[0].const_simple_string));
          }
#line 40729 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1955: /* opt_expr_list: %empty  */
#line 12261 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item_list)= NULL; }
#line 40735 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1956: /* opt_expr_list: expr_list  */
#line 12262 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.item_list)= (yyvsp[0].item_list);}
#line 40741 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1957: /* expr_list: expr  */
#line 12267 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_list)= List<Item>::make(thd->mem_root, (yyvsp[0].item)))))
              MYSQL_YYABORT;
          }
#line 40750 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1958: /* expr_list: expr_list ',' expr  */
#line 12272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40759 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1959: /* ident_list_arg: ident_list  */
#line 12279 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.item_list)= (yyvsp[0].item_list); }
#line 40765 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1960: /* ident_list_arg: '(' ident_list ')'  */
#line 12280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.item_list)= (yyvsp[-1].item_list); }
#line 40771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1961: /* ident_list: simple_ident  */
#line 12285 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 40782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1962: /* ident_list: ident_list ',' simple_ident  */
#line 12292 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root);
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1963: /* when_list: WHEN_SYM expr THEN_SYM expr  */
#line 12300 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL))
              MYSQL_YYABORT;
            if (unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 40804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1964: /* when_list: when_list WHEN_SYM expr THEN_SYM expr  */
#line 12309 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-4].item_list)->push_back((yyvsp[-2].item), thd->mem_root) ||
                         (yyvsp[-4].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-4].item_list);
          }
#line 40815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1966: /* when_list_opt_else: when_list ELSE expr  */
#line 12320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyvsp[-2].item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.item_list)= (yyvsp[-2].item_list);
          }
#line 40825 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1967: /* decode_when_list_oracle: expr ',' expr  */
#line 12329 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= new (thd->mem_root) List<Item>;
            if (unlikely((yyval.item_list) == NULL) ||
                unlikely((yyval.item_list)->push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;

          }
#line 40838 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1968: /* decode_when_list_oracle: decode_when_list_oracle ',' expr  */
#line 12338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_list)= (yyvsp[-2].item_list);
            if (unlikely((yyval.item_list)->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 40848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1969: /* table_ref: table_factor  */
#line 12349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 40854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1970: /* table_ref: join_table  */
#line 12351 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->nest_last_join(thd))))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 40867 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1971: /* join_table_list: derived_table_list  */
#line 12362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { MYSQL_YYABORT_UNLESS((yyval.table_list)=(yyvsp[0].table_list)); }
#line 40873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1972: /* esc_table_ref: table_ref  */
#line 12373 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.table_list)=(yyvsp[0].table_list); }
#line 40879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1973: /* esc_table_ref: '{' ident table_ref '}'  */
#line 12374 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { (yyval.table_list)=(yyvsp[-1].table_list); }
#line 40885 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1974: /* derived_table_list: esc_table_ref  */
#line 12381 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table_list)=(yyvsp[0].table_list);
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40894 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1975: /* derived_table_list: derived_table_list ',' esc_table_ref  */
#line 12386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 40903 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1976: /* join_table: table_ref normal_join table_ref  */
#line 12400 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            if (unlikely(Select->add_cross_joined_table((yyvsp[-2].table_list), (yyvsp[0].table_list), (yyvsp[-1].num))))
              MYSQL_YYABORT;
          }
#line 40913 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1977: /* $@182: %empty  */
#line 12407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-3].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40927 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1978: /* join_table: table_ref normal_join table_ref ON $@182 expr  */
#line 12417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[-3].table_list)->straight=(yyvsp[-4].num);
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 40938 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1979: /* $@183: %empty  */
#line 12425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
          }
#line 40948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1980: /* join_table: table_ref normal_join table_ref USING $@183 '(' using_list ')'  */
#line 12431 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    (yyvsp[-5].table_list)->straight=(yyvsp[-6].num);
            add_join_natural((yyvsp[-7].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
	    (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 40958 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1981: /* join_table: table_ref NATURAL inner_join table_factor  */
#line 12437 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-3].table_list) && ((yyval.table_list)=(yyvsp[0].table_list)));
            Select->add_joined_table((yyvsp[-3].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
	    (yyvsp[0].table_list)->straight=(yyvsp[-1].num);
            add_join_natural((yyvsp[-3].table_list),(yyvsp[0].table_list),NULL,Select);
          }
#line 40970 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1982: /* $@184: %empty  */
#line 12448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 40984 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1983: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_ref ON $@184 expr  */
#line 12458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            add_join_on(thd, (yyvsp[-3].table_list), (yyvsp[0].item));
            (yyvsp[-3].table_list)->on_context= Lex->pop_context();
            (yyvsp[-3].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[-3].table_list);
            Select->parsing_place= NO_MATTER;
          }
#line 40996 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1984: /* $@185: %empty  */
#line 12466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1985: /* join_table: table_ref LEFT opt_outer JOIN_SYM table_factor $@185 USING '(' using_list ')'  */
#line 12472 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            add_join_natural((yyvsp[-9].table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select); 
            (yyvsp[-5].table_list)->outer_join|=JOIN_TYPE_LEFT; 
            (yyval.table_list)=(yyvsp[-5].table_list); 
          }
#line 41016 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1986: /* join_table: table_ref NATURAL LEFT opt_outer JOIN_SYM table_factor  */
#line 12478 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[-5].table_list),(yyvsp[0].table_list),NULL,Select);
            (yyvsp[0].table_list)->outer_join|=JOIN_TYPE_LEFT;
            (yyval.table_list)=(yyvsp[0].table_list);
          }
#line 41029 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1987: /* $@186: %empty  */
#line 12490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[-1].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[-1].table_list));
            /* Change the current name resolution context to a local context. */
            if (unlikely(push_new_name_resolution_context(thd, (yyvsp[-5].table_list), (yyvsp[-1].table_list))))
              MYSQL_YYABORT;
            Select->parsing_place= IN_ON;
          }
#line 41043 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1988: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_ref ON $@186 expr  */
#line 12500 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_on(thd, (yyval.table_list), (yyvsp[0].item));
            (yyvsp[-7].table_list)->on_context= Lex->pop_context();
            Select->parsing_place= NO_MATTER;
          }
#line 41056 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1989: /* $@187: %empty  */
#line 12509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-4].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
          }
#line 41066 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1990: /* join_table: table_ref RIGHT opt_outer JOIN_SYM table_factor $@187 USING '(' using_list ')'  */
#line 12515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
            add_join_natural((yyval.table_list),(yyvsp[-5].table_list),(yyvsp[-1].string_list),Select);
          }
#line 41077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1991: /* join_table: table_ref NATURAL RIGHT opt_outer JOIN_SYM table_factor  */
#line 12522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-5].table_list) && (yyvsp[0].table_list));
            Select->add_joined_table((yyvsp[-5].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            add_join_natural((yyvsp[0].table_list),(yyvsp[-5].table_list),NULL,Select);
            LEX *lex= Lex;
            if (unlikely(!((yyval.table_list)= lex->current_select->convert_right_join())))
              MYSQL_YYABORT;
          }
#line 41091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1992: /* inner_join: JOIN_SYM  */
#line 12535 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 41097 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1993: /* inner_join: INNER_SYM JOIN_SYM  */
#line 12536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 41103 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1994: /* inner_join: STRAIGHT_JOIN  */
#line 12537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 1; }
#line 41109 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1995: /* normal_join: inner_join  */
#line 12541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = (yyvsp[0].num); }
#line 41115 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1996: /* normal_join: CROSS JOIN_SYM  */
#line 12542 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num) = 0; }
#line 41121 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1997: /* opt_use_partition: %empty  */
#line 12550 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.string_list)= 0;}
#line 41127 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 1999: /* use_partition: PARTITION_SYM '(' using_list ')' have_partitioning  */
#line 12556 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string_list)= (yyvsp[-2].string_list);
            Select->parsing_place= Select->save_parsing_place;
            Select->save_parsing_place= NO_MATTER;
          }
#line 41137 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2000: /* table_factor: table_primary_ident_opt_parens  */
#line 12564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41143 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2001: /* table_factor: table_primary_derived_opt_parens  */
#line 12565 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2002: /* table_factor: join_table_parens  */
#line 12567 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyvsp[0].table_list)->nested_join->nest_type= 0;
            (yyval.table_list)= (yyvsp[0].table_list);
          }
#line 41158 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2003: /* table_factor: table_reference_list_parens  */
#line 12571 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2004: /* table_primary_ident_opt_parens: table_primary_ident  */
#line 12575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2005: /* table_primary_ident_opt_parens: '(' table_primary_ident_opt_parens ')'  */
#line 12576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                 { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2006: /* table_primary_derived_opt_parens: table_primary_derived  */
#line 12580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.table_list)= (yyvsp[0].table_list); }
#line 41182 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2007: /* table_primary_derived_opt_parens: '(' table_primary_derived_opt_parens ')'  */
#line 12581 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                   { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41188 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2008: /* table_reference_list_parens: '(' table_reference_list_parens ')'  */
#line 12585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                              { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41194 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2009: /* table_reference_list_parens: '(' nested_table_reference_list ')'  */
#line 12587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.table_list)= Select->end_nested_join(thd)))
              MYSQL_YYABORT;
          }
#line 41203 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2010: /* nested_table_reference_list: table_ref ',' table_ref  */
#line 12595 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Select->init_nested_join(thd))
              MYSQL_YYABORT;
            Select->add_joined_table((yyvsp[-2].table_list));
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list)->embedding;
          }
#line 41215 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2011: /* nested_table_reference_list: nested_table_reference_list ',' table_ref  */
#line 12603 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->add_joined_table((yyvsp[0].table_list));
            (yyval.table_list)= (yyvsp[-2].table_list);
          }
#line 41224 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2012: /* join_table_parens: '(' join_table_parens ')'  */
#line 12610 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                    { (yyval.table_list)= (yyvsp[-1].table_list); }
#line 41230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2013: /* join_table_parens: '(' join_table ')'  */
#line 12612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (!((yyval.table_list)= lex->current_select->nest_last_join(thd)))
            {
              thd->parse_error();
              MYSQL_YYABORT;
            }
          }
#line 41243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2014: /* table_primary_ident: table_ident opt_use_partition opt_for_system_time_clause opt_table_alias_clause opt_key_definition  */
#line 12626 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            if ((yyvsp[-2].num))
              (yyval.table_list)->vers_conditions= Lex->vers_conditions;
          }
#line 41261 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2015: /* table_primary_derived: subquery opt_for_system_time_clause table_alias_clause  */
#line 12644 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!((yyval.table_list)= Lex->parsed_derived_table((yyvsp[-2].select_lex)->master_unit(), (yyvsp[-1].num), (yyvsp[0].lex_str_ptr))))
              MYSQL_YYABORT;
          }
#line 41270 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2016: /* opt_outer: %empty  */
#line 12652 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41276 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2017: /* opt_outer: OUTER  */
#line 12653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                {}
#line 41282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2018: /* index_hint_clause: %empty  */
#line 12658 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= thd->variables.old_mode ?  INDEX_HINT_MASK_JOIN : INDEX_HINT_MASK_ALL; 
          }
#line 41290 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2019: /* index_hint_clause: FOR_SYM JOIN_SYM  */
#line 12661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_JOIN;  }
#line 41296 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2020: /* index_hint_clause: FOR_SYM ORDER_SYM BY  */
#line 12662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_ORDER; }
#line 41302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2021: /* index_hint_clause: FOR_SYM GROUP_SYM BY  */
#line 12663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                { (yyval.num)= INDEX_HINT_MASK_GROUP; }
#line 41308 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2022: /* index_hint_type: FORCE_SYM  */
#line 12667 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.index_hint)= INDEX_HINT_FORCE; }
#line 41314 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2023: /* index_hint_type: IGNORE_SYM  */
#line 12668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.index_hint)= INDEX_HINT_IGNORE; }
#line 41320 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2024: /* $@188: %empty  */
#line 12673 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_index_hint_type((yyvsp[-2].index_hint), (yyvsp[0].num));
          }
#line 41328 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2026: /* $@189: %empty  */
#line 12678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_index_hint_type(INDEX_HINT_USE, (yyvsp[0].num));
          }
#line 41336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2031: /* $@190: %empty  */
#line 12691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->alloc_index_hints(thd); }
#line 41342 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2033: /* $@191: %empty  */
#line 12695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {  Select->clear_index_hints(); }
#line 41348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2035: /* opt_key_usage_list: %empty  */
#line 12700 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Select->add_index_hint(thd, NULL, 0); }
#line 41354 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2036: /* opt_key_usage_list: key_usage_list  */
#line 12701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         {}
#line 41360 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2037: /* key_usage_element: ident  */
#line 12706 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->add_index_hint(thd, (yyvsp[0].ident_sys).str, (yyvsp[0].ident_sys).length); }
#line 41366 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2038: /* key_usage_element: PRIMARY_SYM  */
#line 12708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->add_index_hint(thd, "PRIMARY", 7); }
#line 41372 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2041: /* using_list: ident  */
#line 12718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.string_list)= new (thd->mem_root) List<String>)))
              MYSQL_YYABORT;
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            (yyval.string_list)->push_back(s, thd->mem_root);
          }
#line 41387 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2042: /* using_list: using_list ',' ident  */
#line 12729 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            String *s= new (thd->mem_root) String((const char *) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(unlikely(s == NULL)))
              MYSQL_YYABORT;
            if (unlikely((yyvsp[-2].string_list)->push_back(s, thd->mem_root)))
              MYSQL_YYABORT;
            (yyval.string_list)= (yyvsp[-2].string_list);
          }
#line 41402 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2043: /* interval: interval_time_stamp  */
#line 12742 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 41408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2044: /* interval: DAY_HOUR_SYM  */
#line 12743 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_HOUR; }
#line 41414 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2045: /* interval: DAY_MICROSECOND_SYM  */
#line 12744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MICROSECOND; }
#line 41420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2046: /* interval: DAY_MINUTE_SYM  */
#line 12745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_MINUTE; }
#line 41426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2047: /* interval: DAY_SECOND_SYM  */
#line 12746 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_DAY_SECOND; }
#line 41432 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2048: /* interval: HOUR_MICROSECOND_SYM  */
#line 12747 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MICROSECOND; }
#line 41438 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2049: /* interval: HOUR_MINUTE_SYM  */
#line 12748 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_MINUTE; }
#line 41444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2050: /* interval: HOUR_SECOND_SYM  */
#line 12749 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_HOUR_SECOND; }
#line 41450 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2051: /* interval: MINUTE_MICROSECOND_SYM  */
#line 12750 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_MICROSECOND; }
#line 41456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2052: /* interval: MINUTE_SECOND_SYM  */
#line 12751 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_MINUTE_SECOND; }
#line 41462 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2053: /* interval: SECOND_MICROSECOND_SYM  */
#line 12752 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_SECOND_MICROSECOND; }
#line 41468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2054: /* interval: YEAR_MONTH_SYM  */
#line 12753 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.interval)=INTERVAL_YEAR_MONTH; }
#line 41474 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2055: /* interval_time_stamp: DAY_SYM  */
#line 12757 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_DAY; }
#line 41480 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2056: /* interval_time_stamp: WEEK_SYM  */
#line 12758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_WEEK; }
#line 41486 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2057: /* interval_time_stamp: HOUR_SYM  */
#line 12759 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_HOUR; }
#line 41492 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2058: /* interval_time_stamp: MINUTE_SYM  */
#line 12760 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MINUTE; }
#line 41498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2059: /* interval_time_stamp: MONTH_SYM  */
#line 12761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MONTH; }
#line 41504 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2060: /* interval_time_stamp: QUARTER_SYM  */
#line 12762 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_QUARTER; }
#line 41510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2061: /* interval_time_stamp: SECOND_SYM  */
#line 12763 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_SECOND; }
#line 41516 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2062: /* interval_time_stamp: MICROSECOND_SYM  */
#line 12764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_MICROSECOND; }
#line 41522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2063: /* interval_time_stamp: YEAR_SYM  */
#line 12765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.interval_time_st)=INTERVAL_YEAR; }
#line 41528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2064: /* date_time_type: DATE_SYM  */
#line 12769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATE;}
#line 41534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2065: /* date_time_type: TIME_SYM  */
#line 12770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_TIME;}
#line 41540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2066: /* date_time_type: DATETIME  */
#line 12771 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41546 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2067: /* date_time_type: TIMESTAMP  */
#line 12772 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {(yyval.date_time_type)=MYSQL_TIMESTAMP_DATETIME;}
#line 41552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2071: /* opt_table_alias_clause: %empty  */
#line 12782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str_ptr)=0; }
#line 41558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2072: /* opt_table_alias_clause: table_alias_clause  */
#line 12783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.lex_str_ptr)= (yyvsp[0].lex_str_ptr); }
#line 41564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2073: /* table_alias_clause: table_alias ident_table_alias  */
#line 12788 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_str_ptr)= (LEX_CSTRING*) thd->memdup(&(yyvsp[0].ident_sys),sizeof(LEX_STRING));
            if (unlikely((yyval.lex_str_ptr) == NULL))
              MYSQL_YYABORT;
          }
#line 41574 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2076: /* opt_where_clause: %empty  */
#line 12801 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Select->where= 0; }
#line 41580 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2077: /* $@192: %empty  */
#line 12803 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= IN_WHERE;
          }
#line 41588 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2078: /* opt_where_clause: WHERE $@192 expr  */
#line 12807 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *select= Select;
            select->where= normalize_cond(thd, (yyvsp[0].item));
            select->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 41600 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2080: /* $@193: %empty  */
#line 12819 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= IN_HAVING;
          }
#line 41608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2081: /* opt_having_clause: HAVING $@193 expr  */
#line 12823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->having= normalize_cond(thd, (yyvsp[0].item));
            sel->parsing_place= NO_MATTER;
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
          }
#line 41620 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2084: /* group_list: group_list ',' order_ident order_dir  */
#line 12843 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
               MYSQL_YYABORT;
           }
#line 41629 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2085: /* group_list: order_ident order_dir  */
#line 12848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_group_to_list(thd, (yyvsp[-1].item),(bool) (yyvsp[0].num))))
              MYSQL_YYABORT;
           }
#line 41638 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2086: /* olap_opt: %empty  */
#line 12855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41644 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2087: /* olap_opt: WITH_CUBE_SYM  */
#line 12857 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              'WITH CUBE' is reserved in the MySQL syntax, but not implemented,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH CUBE
              SQL-2003: GROUP BY ... CUBE(col1, col2, col3)
            */
            LEX *lex=Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH CUBE",
                                "global union parameters"));
            lex->current_select->olap= CUBE_TYPE;

            my_yyabort_error((ER_NOT_SUPPORTED_YET, MYF(0), "CUBE"));
          }
#line 41665 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2088: /* olap_opt: WITH_ROLLUP_SYM  */
#line 12874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              'WITH ROLLUP' is needed for backward compatibility,
              and cause LALR(2) conflicts.
              This syntax is not standard.
              MySQL syntax: GROUP BY col1, col2, col3 WITH ROLLUP
              SQL-2003: GROUP BY ... ROLLUP(col1, col2, col3)
            */
            LEX *lex= Lex;
            if (unlikely(lex->current_select->get_linkage() == GLOBAL_OPTIONS_TYPE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "WITH ROLLUP",
                                "global union parameters"));
            lex->current_select->olap= ROLLUP_TYPE;
          }
#line 41684 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2089: /* opt_window_clause: %empty  */
#line 12896 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 41690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2090: /* opt_window_clause: WINDOW_SYM window_def_list  */
#line 12899 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 41696 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2093: /* window_def: window_name AS window_spec  */
#line 12909 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(Select->add_window_def(thd, (yyvsp[-2].lex_str_ptr), lex->win_ref,
                                                Select->group_list,
                                                Select->order_list,
                                                lex->win_frame)))
              MYSQL_YYABORT;
          }
#line 41709 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2094: /* $@194: %empty  */
#line 12921 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Select->prepare_add_window_spec(thd); }
#line 41715 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2095: /* window_spec: '(' $@194 opt_window_ref opt_window_partition_clause opt_window_order_clause opt_window_frame_clause ')'  */
#line 12925 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { }
#line 41721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2096: /* opt_window_ref: %empty  */
#line 12929 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2097: /* opt_window_ref: ident  */
#line 12931 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->lex->win_ref= (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            if (unlikely(thd->lex->win_ref == NULL))
              MYSQL_YYABORT;
          }
#line 41737 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2098: /* opt_window_partition_clause: %empty  */
#line 12939 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 41743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2100: /* opt_window_order_clause: %empty  */
#line 12944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { }
#line 41749 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2101: /* opt_window_order_clause: ORDER_SYM BY order_list  */
#line 12945 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Select->order_list= *((yyvsp[0].select_order)); }
#line 41755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2102: /* opt_window_frame_clause: %empty  */
#line 12949 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 41761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2103: /* opt_window_frame_clause: window_frame_units window_frame_extent opt_window_frame_exclusion  */
#line 12951 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->win_frame=
              new (thd->mem_root) Window_frame((yyvsp[-2].frame_units),
                                               lex->frame_top_bound,
                                               lex->frame_bottom_bound,
                                               (yyvsp[0].frame_exclusion));
            if (unlikely(lex->win_frame == NULL))
              MYSQL_YYABORT;
          }
#line 41776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2104: /* window_frame_units: ROWS_SYM  */
#line 12964 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { (yyval.frame_units)= Window_frame::UNITS_ROWS; }
#line 41782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2105: /* window_frame_units: RANGE_SYM  */
#line 12965 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.frame_units)= Window_frame::UNITS_RANGE; }
#line 41788 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2106: /* window_frame_extent: window_frame_start  */
#line 12970 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[0].window_frame_bound);
            lex->frame_bottom_bound=
              new (thd->mem_root)
                Window_frame_bound(Window_frame_bound::CURRENT, NULL);
            if (unlikely(lex->frame_bottom_bound == NULL))
              MYSQL_YYABORT;
          }
#line 41802 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2107: /* window_frame_extent: BETWEEN_SYM window_frame_bound AND_SYM window_frame_bound  */
#line 12980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->frame_top_bound= (yyvsp[-2].window_frame_bound);
            lex->frame_bottom_bound= (yyvsp[0].window_frame_bound);
          }
#line 41812 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2108: /* window_frame_start: UNBOUNDED_SYM PRECEDING_SYM  */
#line 12989 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root) 
                  Window_frame_bound(Window_frame_bound::PRECEDING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41823 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2109: /* window_frame_start: CURRENT_SYM ROW_SYM  */
#line 12996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::CURRENT, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41834 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2110: /* window_frame_start: literal PRECEDING_SYM  */
#line 13003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::PRECEDING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41845 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2111: /* window_frame_bound: window_frame_start  */
#line 13012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.window_frame_bound)= (yyvsp[0].window_frame_bound); }
#line 41851 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2112: /* window_frame_bound: UNBOUNDED_SYM FOLLOWING_SYM  */
#line 13014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, NULL); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2113: /* window_frame_bound: literal FOLLOWING_SYM  */
#line 13021 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.window_frame_bound)= new (thd->mem_root)
                  Window_frame_bound(Window_frame_bound::FOLLOWING, (yyvsp[-1].item)); 
            if (unlikely((yyval.window_frame_bound) == NULL))
              MYSQL_YYABORT;
          }
#line 41873 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2114: /* opt_window_frame_exclusion: %empty  */
#line 13030 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41879 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2115: /* opt_window_frame_exclusion: EXCLUDE_SYM CURRENT_SYM ROW_SYM  */
#line 13032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_CURRENT_ROW; }
#line 41885 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2116: /* opt_window_frame_exclusion: EXCLUDE_SYM GROUP_SYM  */
#line 13034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_GROUP; }
#line 41891 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2117: /* opt_window_frame_exclusion: EXCLUDE_SYM TIES_SYM  */
#line 13036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_TIES; }
#line 41897 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2118: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_MARIADB_SYM  */
#line 13038 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41903 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2119: /* opt_window_frame_exclusion: EXCLUDE_SYM NO_SYM OTHERS_ORACLE_SYM  */
#line 13040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.frame_exclusion)= Window_frame::EXCL_NONE; }
#line 41909 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2123: /* alter_order_item: simple_ident_nospvar order_dir  */
#line 13058 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            bool ascending= ((yyvsp[0].num) == 1) ? true : false;
            if (unlikely(add_order_to_list(thd, (yyvsp[-1].item), ascending)))
              MYSQL_YYABORT;
          }
#line 41919 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2124: /* opt_order_clause: %empty  */
#line 13071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_order)= NULL; }
#line 41925 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2125: /* opt_order_clause: order_clause  */
#line 13073 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_order)= (yyvsp[0].select_order); }
#line 41931 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2126: /* $@195: %empty  */
#line 13078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thd->where= "ORDER clause";
          }
#line 41939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2127: /* order_clause: ORDER_SYM BY $@195 order_list  */
#line 13082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= (yyvsp[0].select_order);
          }
#line 41947 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2128: /* order_list: order_list ',' order_ident order_dir  */
#line 13089 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= (yyvsp[-3].select_order);
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item),(bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 41957 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2129: /* order_list: order_ident order_dir  */
#line 13095 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_order)= new (thd->mem_root) SQL_I_List<ORDER>();
            if (add_to_list(thd, *(yyval.select_order), (yyvsp[-1].item), (bool) (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 41967 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2130: /* order_dir: %empty  */
#line 13103 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num) =  1; }
#line 41973 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2131: /* order_dir: ASC  */
#line 13104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.num) =1; }
#line 41979 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2132: /* order_dir: DESC  */
#line 13105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.num) =0; }
#line 41985 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2133: /* opt_limit_clause: %empty  */
#line 13110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_limit).empty(); }
#line 41991 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2134: /* opt_limit_clause: limit_clause  */
#line 13112 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.select_limit)= (yyvsp[0].select_limit); }
#line 41997 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2135: /* limit_clause: LIMIT limit_options  */
#line 13117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit)= (yyvsp[0].select_limit);
            if (!(yyval.select_limit).select_limit->basic_const_item() ||
                (yyval.select_limit).select_limit->val_int() > 0)
              Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42008 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2136: /* limit_clause: LIMIT limit_options ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13125 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit)= (yyvsp[-3].select_limit);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42017 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2137: /* limit_clause: LIMIT ROWS_SYM EXAMINED_SYM limit_rows_option  */
#line 13130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= 0;
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
          }
#line 42028 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2138: /* opt_global_limit_clause: opt_limit_clause  */
#line 13140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->explicit_limit= (yyvsp[0].select_limit).explicit_limit;
            Select->select_limit= (yyvsp[0].select_limit).select_limit;
            Select->offset_limit= (yyvsp[0].select_limit).offset_limit;
          }
#line 42038 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2139: /* limit_options: limit_option  */
#line 13149 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= 0;
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42048 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2140: /* limit_options: limit_option ',' limit_option  */
#line 13155 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[0].item);
            (yyval.select_limit).offset_limit= (yyvsp[-2].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42058 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2141: /* limit_options: limit_option OFFSET_SYM limit_option  */
#line 13161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_limit).select_limit= (yyvsp[-2].item);
            (yyval.select_limit).offset_limit= (yyvsp[0].item);
            (yyval.select_limit).explicit_limit= 1;
          }
#line 42068 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2142: /* limit_option: ident_cli  */
#line 13170 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2143: /* limit_option: ident_cli '.' ident_cli  */
#line 13175 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_limit(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 42086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2144: /* limit_option: param_marker  */
#line 13180 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_param)->limit_clause_param= TRUE;
          }
#line 42094 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2145: /* limit_option: ULONGLONG_NUM  */
#line 13184 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2146: /* limit_option: LONG_NUM  */
#line 13190 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2147: /* limit_option: NUM  */
#line 13196 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 42124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2148: /* limit_rows_option: limit_option  */
#line 13205 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex=Lex;
            lex->limit_rows_examined= (yyvsp[0].item);
          }
#line 42133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2149: /* delete_limit_clause: %empty  */
#line 13213 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->current_select->select_limit= 0;
          }
#line 42142 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2150: /* delete_limit_clause: LIMIT limit_option  */
#line 13218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->select_limit= (yyvsp[0].item);
            Lex->set_stmt_unsafe(LEX::BINLOG_STMT_UNSAFE_LIMIT);
            sel->explicit_limit= 1;
          }
#line 42153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2151: /* delete_limit_clause: LIMIT ROWS_SYM EXAMINED_SYM  */
#line 13224 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     { thd->parse_error(); MYSQL_YYABORT; }
#line 42159 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2152: /* delete_limit_clause: LIMIT limit_option ROWS_SYM EXAMINED_SYM  */
#line 13225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                  { thd->parse_error(); MYSQL_YYABORT; }
#line 42165 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2153: /* order_limit_lock: order_or_limit  */
#line 13230 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock);
            (yyval.order_limit_lock)->lock.empty();
          }
#line 42174 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2154: /* order_limit_lock: order_or_limit select_lock_type  */
#line 13235 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= (yyvsp[-1].order_limit_lock);
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42183 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2155: /* order_limit_lock: select_lock_type  */
#line 13240 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit.empty();
            (yyval.order_limit_lock)->lock= (yyvsp[0].select_lock);
          }
#line 42196 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2156: /* opt_order_limit_lock: %empty  */
#line 13251 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select();
            (yyval.order_limit_lock)= NULL;
          }
#line 42205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2157: /* opt_order_limit_lock: order_limit_lock  */
#line 13255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.order_limit_lock)= (yyvsp[0].order_limit_lock); }
#line 42211 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2160: /* opt_procedure_or_into: %empty  */
#line 13268 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock).empty();
          }
#line 42219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2161: /* opt_procedure_or_into: procedure_clause opt_select_lock_type  */
#line 13272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42227 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2162: /* opt_procedure_or_into: into opt_select_lock_type  */
#line 13276 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            push_warning_printf(thd, Sql_condition::WARN_LEVEL_WARN,
                                ER_WARN_DEPRECATED_SYNTAX,
                                ER_THD(thd, ER_WARN_DEPRECATED_SYNTAX),
                                "<select expression> INTO <destination>;",
                                "'SELECT <select list> INTO <destination>"
                                " FROM...'");
            (yyval.select_lock)= (yyvsp[0].select_lock);
          }
#line 42241 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2163: /* order_or_limit: order_clause opt_limit_clause  */
#line 13290 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            (yyval.order_limit_lock)->order_list= (yyvsp[-1].select_order);
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42253 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2164: /* order_or_limit: limit_clause  */
#line 13298 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_order_limit_lock *op= (yyval.order_limit_lock)= new(thd->mem_root) Lex_order_limit_lock;
            if (!(yyval.order_limit_lock))
              YYABORT;
            op->order_list= NULL;
            op->limit= (yyvsp[0].select_limit);
            (yyval.order_limit_lock)->order_list= NULL;
            (yyval.order_limit_lock)->limit= (yyvsp[0].select_limit);
          }
#line 42267 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2167: /* int_num: opt_plus NUM  */
#line 13316 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.num)= (int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2168: /* int_num: '-' NUM  */
#line 13317 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.num)= -(int) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42279 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2169: /* ulong_num: opt_plus NUM  */
#line 13321 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42285 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2170: /* ulong_num: HEX_NUM  */
#line 13322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42291 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2171: /* ulong_num: opt_plus LONG_NUM  */
#line 13323 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42297 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2172: /* ulong_num: opt_plus ULONGLONG_NUM  */
#line 13324 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42303 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2173: /* ulong_num: opt_plus DECIMAL_NUM  */
#line 13325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42309 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2174: /* ulong_num: opt_plus FLOAT_NUM  */
#line 13326 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42315 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2175: /* real_ulong_num: NUM  */
#line 13330 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42321 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2176: /* real_ulong_num: HEX_NUM  */
#line 13331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulong_num)= (ulong) strtol((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42327 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2177: /* real_ulong_num: LONG_NUM  */
#line 13332 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2178: /* real_ulong_num: ULONGLONG_NUM  */
#line 13333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulong_num)= (ulong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42339 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2179: /* real_ulong_num: dec_num_error  */
#line 13334 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { MYSQL_YYABORT; }
#line 42345 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2180: /* longlong_num: opt_plus NUM  */
#line 13338 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42351 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2181: /* longlong_num: LONG_NUM  */
#line 13339 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.longlong_number)= (longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42357 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2182: /* longlong_num: '-' NUM  */
#line 13340 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42363 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2183: /* longlong_num: '-' LONG_NUM  */
#line 13341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.longlong_number)= -(longlong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42369 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2184: /* ulonglong_num: opt_plus NUM  */
#line 13345 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2185: /* ulonglong_num: opt_plus ULONGLONG_NUM  */
#line 13346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2186: /* ulonglong_num: opt_plus LONG_NUM  */
#line 13347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42387 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2187: /* ulonglong_num: opt_plus DECIMAL_NUM  */
#line 13348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42393 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2188: /* ulonglong_num: opt_plus FLOAT_NUM  */
#line 13349 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42399 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2189: /* real_ulonglong_num: NUM  */
#line 13353 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42405 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2190: /* real_ulonglong_num: ULONGLONG_NUM  */
#line 13354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42411 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2191: /* real_ulonglong_num: HEX_NUM  */
#line 13355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ulonglong_number)= strtoull((yyvsp[0].lex_str).str, (char**) 0, 16); }
#line 42417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2192: /* real_ulonglong_num: LONG_NUM  */
#line 13356 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { int error; (yyval.ulonglong_number)= (ulonglong) my_strtoll10((yyvsp[0].lex_str).str, (char**) 0, &error); }
#line 42423 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2193: /* real_ulonglong_num: dec_num_error  */
#line 13357 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { MYSQL_YYABORT; }
#line 42429 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2194: /* dec_num_error: dec_num  */
#line 13362 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { thd->parse_error(ER_ONLY_INTEGERS_ALLOWED); }
#line 42435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2197: /* choice: ulong_num  */
#line 13371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.choice)= (yyvsp[0].ulong_num) != 0 ? HA_CHOICE_YES : HA_CHOICE_NO; }
#line 42441 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2198: /* choice: DEFAULT  */
#line 13372 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.choice)= HA_CHOICE_UNDEF; }
#line 42447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2199: /* bool: ulong_num  */
#line 13376 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= (yyvsp[0].ulong_num) != 0; }
#line 42453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2200: /* bool: TRUE_SYM  */
#line 13377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 1; }
#line 42459 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2201: /* bool: FALSE_SYM  */
#line 13378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.ulong_num)= 0; }
#line 42465 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2202: /* $@196: %empty  */
#line 13383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;

            lex->proc_list.elements=0;
            lex->proc_list.first=0;
            lex->proc_list.next= &lex->proc_list.first;
            Item_field *item= new (thd->mem_root)
                                Item_field(thd, &lex->current_select->context,
                                           NULL, NULL, &(yyvsp[0].ident_sys));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            if (unlikely(add_proc_to_list(thd, item)))
              MYSQL_YYABORT;
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);

            /*
              PROCEDURE CLAUSE cannot handle subquery as one of its parameter,
              so disallow any subqueries further.
              Alow subqueries back once the parameters are reduced.
            */
            Lex->clause_that_disallows_subselect= "PROCEDURE";
            Select->options|= OPTION_PROCEDURE_CLAUSE;
          }
#line 42493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2203: /* procedure_clause: PROCEDURE_SYM ident $@196 '(' procedure_list ')'  */
#line 13407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* Subqueries are allowed from now.*/
            Lex->clause_that_disallows_subselect= NULL;
          }
#line 42502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2204: /* procedure_list: %empty  */
#line 13414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 42508 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2205: /* procedure_list: procedure_list2  */
#line 13415 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 42514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2208: /* procedure_item: remember_name expr remember_end  */
#line 13425 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(add_proc_to_list(thd, (yyvsp[-1].item))))
              MYSQL_YYABORT;
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 42525 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2209: /* $@197: %empty  */
#line 13434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe &&
                unlikely((!(lex->result= new (thd->mem_root)
                            select_dumpvar(thd)))))
              MYSQL_YYABORT;
          }
#line 42537 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2210: /* select_var_list_init: $@197 select_var_list  */
#line 13442 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42543 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2212: /* select_var_list: select_var_ident  */
#line 13447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 42549 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2213: /* select_var_ident: select_outvar  */
#line 13451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->result)
            {
              if (unlikely((yyvsp[0].myvar) == NULL))
                MYSQL_YYABORT;
              ((select_dumpvar *)Lex->result)->var_list.push_back((yyvsp[0].myvar), thd->mem_root);
            }
            else
            {
              /*
                The parser won't create select_result instance only
                if it's an EXPLAIN.
              */
              DBUG_ASSERT(Lex->describe);
            }
          }
#line 42570 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2214: /* select_outvar: '@' ident_or_text  */
#line 13471 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.myvar) = Lex->result ? new (thd->mem_root) my_var_user(&(yyvsp[0].lex_str)) : NULL;
          }
#line 42578 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2215: /* select_outvar: ident_or_text  */
#line 13475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[0].lex_str))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42587 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2216: /* select_outvar: ident '.' ident  */
#line 13480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.myvar)= Lex->create_outvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys))) && Lex->result))
              MYSQL_YYABORT;
          }
#line 42596 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2217: /* into: INTO into_destination  */
#line 13488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42602 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2218: /* $@198: %empty  */
#line 13493 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
            if (unlikely(!(lex->exchange=
                         new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str, 0))) ||
                unlikely(!(lex->result=
                         new (thd->mem_root)
                         select_export(thd, lex->exchange))))
              MYSQL_YYABORT;
          }
#line 42617 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2219: /* $@199: %empty  */
#line 13504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 42623 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2221: /* into_destination: DUMPFILE TEXT_STRING_filesystem  */
#line 13507 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (!lex->describe)
            {
              lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
              if (unlikely(!(lex->exchange=
                             new (thd->mem_root) sql_exchange((yyvsp[0].lex_str).str,1))))
                MYSQL_YYABORT;
              if (unlikely(!(lex->result=
                           new (thd->mem_root)
                           select_dump(thd, lex->exchange))))
                MYSQL_YYABORT;
            }
          }
#line 42642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2222: /* into_destination: select_var_list_init  */
#line 13522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->uncacheable(UNCACHEABLE_SIDEEFFECT);
          }
#line 42650 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2223: /* $@200: %empty  */
#line 13533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_DO;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 42662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2224: /* do: DO_SYM $@200 expr_list  */
#line 13541 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->insert_list= (yyvsp[0].item_list);
            Lex->pop_select(); //main select
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 42673 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2225: /* $@201: %empty  */
#line 13555 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_TABLE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42684 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2226: /* drop: DROP opt_temporary table_or_tables opt_if_exists $@201 table_list opt_lock_wait_timeout opt_restrict  */
#line 13562 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2227: /* $@202: %empty  */
#line 13564 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 42699 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2228: /* drop: DROP INDEX_SYM $@202 opt_if_exists_table_element ident ON table_ident opt_lock_wait_timeout  */
#line 13569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Alter_drop *ad= (new (thd->mem_root)
                             Alter_drop(Alter_drop::KEY, (yyvsp[-3].ident_sys).str, (yyvsp[-4].num)));
            if (unlikely(ad == NULL))
              MYSQL_YYABORT;
            lex->sql_command= SQLCOM_DROP_INDEX;
            lex->alter_info.reset();
            lex->alter_info.flags= ALTER_DROP_INDEX;
            lex->alter_info.drop_list.push_back(ad, thd->mem_root);
            if (unlikely(!lex->current_select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           TL_READ_NO_INSERT,
                                           MDL_SHARED_UPGRADABLE)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
          }
#line 42721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2229: /* drop: DROP DATABASE opt_if_exists ident  */
#line 13587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_command(SQLCOM_DROP_DB, (yyvsp[-1].object_ddl_options));
            lex->name= (yyvsp[0].ident_sys);
          }
#line 42731 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2230: /* drop: DROP PACKAGE_ORACLE_SYM opt_if_exists sp_name  */
#line 13593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_PACKAGE, (yyvsp[-1].object_ddl_options));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PACKAGE"));
            lex->spname= (yyvsp[0].spname);
          }
#line 42743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2231: /* drop: DROP PACKAGE_ORACLE_SYM BODY_ORACLE_SYM opt_if_exists sp_name  */
#line 13601 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_PACKAGE_BODY, (yyvsp[-1].object_ddl_options));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PACKAGE BODY"));
            lex->spname= (yyvsp[0].spname);
          }
#line 42755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2232: /* drop: DROP FUNCTION_SYM opt_if_exists ident '.' ident  */
#line 13609 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            sp_name *spname;
            if (unlikely((yyvsp[-2].ident_sys).str && check_db_name((LEX_STRING*) &(yyvsp[-2].ident_sys))))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-3].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), true);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 42773 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2233: /* drop: DROP FUNCTION_SYM opt_if_exists ident  */
#line 13623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            LEX_CSTRING db= {0, 0};
            sp_name *spname;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "FUNCTION"));
            if (thd->db.str && unlikely(lex->copy_db_to(&db)))
              MYSQL_YYABORT;
            lex->set_command(SQLCOM_DROP_FUNCTION, (yyvsp[-1].object_ddl_options));
            spname= new (thd->mem_root) sp_name(&db, &(yyvsp[0].ident_sys), false);
            if (unlikely(spname == NULL))
              MYSQL_YYABORT;
            lex->spname= spname;
          }
#line 42792 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2234: /* drop: DROP PROCEDURE_SYM opt_if_exists sp_name  */
#line 13638 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_DROP_SP, MYF(0), "PROCEDURE"));
            lex->set_command(SQLCOM_DROP_PROCEDURE, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 42804 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2235: /* drop: DROP USER_SYM opt_if_exists clear_privileges user_list  */
#line 13646 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_USER, (yyvsp[-2].object_ddl_options));
          }
#line 42812 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2236: /* drop: DROP ROLE_SYM opt_if_exists clear_privileges role_list  */
#line 13650 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_ROLE, (yyvsp[-2].object_ddl_options));
          }
#line 42820 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2237: /* $@203: %empty  */
#line 13654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_VIEW, (yyvsp[0].object_ddl_options));
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42831 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2238: /* drop: DROP VIEW_SYM opt_if_exists $@203 table_list opt_restrict  */
#line 13661 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42837 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2239: /* drop: DROP EVENT_SYM opt_if_exists sp_name  */
#line 13663 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->set_command(SQLCOM_DROP_EVENT, (yyvsp[-1].object_ddl_options));
          }
#line 42846 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2240: /* drop: DROP TRIGGER_SYM opt_if_exists sp_name  */
#line 13668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_TRIGGER, (yyvsp[-1].object_ddl_options));
            lex->spname= (yyvsp[0].spname);
          }
#line 42856 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2241: /* drop: DROP TABLESPACE tablespace_name opt_ts_engine opt_ts_wait  */
#line 13674 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_TABLESPACE;
          }
#line 42865 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2242: /* drop: DROP LOGFILE_SYM GROUP_SYM logfile_group_name opt_ts_engine opt_ts_wait  */
#line 13679 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->alter_tablespace_info->ts_cmd_type= DROP_LOGFILE_GROUP;
          }
#line 42874 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2243: /* drop: DROP SERVER_SYM opt_if_exists ident_or_text  */
#line 13684 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_DROP_SERVER, (yyvsp[-1].object_ddl_options));
            Lex->server_options.reset((yyvsp[0].lex_str));
          }
#line 42883 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2244: /* $@204: %empty  */
#line 13690 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->set_command(SQLCOM_DROP_SEQUENCE, (yyvsp[-2].num), (yyvsp[0].object_ddl_options));
            lex->table_type= TABLE_TYPE_SEQUENCE;
            YYPS->m_lock_type= TL_UNLOCK;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 42895 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2245: /* drop: DROP opt_temporary SEQUENCE_SYM opt_if_exists $@204 table_list  */
#line 13698 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 42901 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2248: /* table_name: table_ident  */
#line 13708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (!thd->lex->current_select_or_default()->
                                           add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type))
              MYSQL_YYABORT;
          }
#line 42914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2249: /* table_name_with_opt_use_partition: table_ident opt_use_partition  */
#line 13720 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                    TL_OPTION_UPDATING,
                                                    YYPS->m_lock_type,
                                                    YYPS->m_mdl_type,
                                                    NULL,
                                                    (yyvsp[0].string_list))))
              MYSQL_YYABORT;
          }
#line 42928 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2252: /* table_alias_ref: table_ident_opt_wild  */
#line 13738 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[0].table), NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 42942 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2253: /* opt_if_exists_table_element: %empty  */
#line 13751 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->check_exists= FALSE;
          (yyval.num)= 0;
        }
#line 42951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2254: /* opt_if_exists_table_element: IF_SYM EXISTS  */
#line 13756 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->check_exists= TRUE;
          (yyval.num)= 1;
        }
#line 42960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2255: /* opt_if_exists: %empty  */
#line 13764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_NONE);
        }
#line 42968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2256: /* opt_if_exists: IF_SYM EXISTS  */
#line 13768 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.object_ddl_options).set(DDL_options_st::OPT_IF_EXISTS);
        }
#line 42976 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2257: /* opt_temporary: %empty  */
#line 13774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)= 0; }
#line 42982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2258: /* opt_temporary: TEMPORARY  */
#line 13775 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= HA_LEX_CREATE_TMP_TABLE; }
#line 42988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2259: /* $@205: %empty  */
#line 13783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_INSERT;
            lex->duplicates= DUP_ERROR;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43002 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2260: /* $@206: %empty  */
#line 13794 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_lock_for_tables((yyvsp[-2].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2261: /* insert: INSERT $@205 insert_lock_option opt_ignore insert2 $@206 insert_field_spec opt_insert_update  */
#line 13799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2262: /* $@207: %empty  */
#line 13809 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_REPLACE;
            lex->duplicates= DUP_REPLACE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= BEFORE_OPT_LIST;
          }
#line 43036 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2263: /* $@208: %empty  */
#line 13819 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->set_lock_for_tables((yyvsp[-1].lock_type), true);
            Lex->current_select= Lex->first_select_lex();
          }
#line 43045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2264: /* replace: REPLACE $@207 replace_lock_option insert2 $@208 insert_field_spec  */
#line 13824 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 43056 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2265: /* insert_lock_option: %empty  */
#line 13834 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              If it is SP we do not allow insert optimisation when result of
              insert visible only after the table unlocking but everyone can
              read table.
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 43069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2266: /* insert_lock_option: LOW_PRIORITY  */
#line 13842 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43075 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2267: /* insert_lock_option: DELAYED_SYM  */
#line 13844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
         // QQ: why was +1?
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43086 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2268: /* insert_lock_option: HIGH_PRIORITY  */
#line 13850 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.lock_type)= TL_WRITE; }
#line 43092 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2269: /* replace_lock_option: opt_low_priority  */
#line 13854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lock_type)= (yyvsp[0].lock_type); }
#line 43098 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2270: /* replace_lock_option: DELAYED_SYM  */
#line 13856 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->keyword_delayed_begin_offset= (uint)((yyvsp[0].kwd).pos() - thd->query());
          Lex->keyword_delayed_end_offset= (uint)((yyvsp[0].kwd).end() - thd->query());
          (yyval.lock_type)= TL_WRITE_DELAYED;
        }
#line 43108 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2271: /* insert2: INTO insert_table  */
#line 13864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 43114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2272: /* insert2: insert_table  */
#line 13865 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 43120 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2273: /* $@209: %empty  */
#line 13869 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->save_parsing_place= Select->parsing_place;
          }
#line 43128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2274: /* insert_table: $@209 table_name_with_opt_use_partition  */
#line 13873 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            //lex->field_list.empty();
            lex->many_values.empty();
            lex->insert_list=0;
          }
#line 43139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2275: /* insert_field_spec: insert_values  */
#line 13882 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 43145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2276: /* insert_field_spec: insert_field_list insert_values  */
#line 13883 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          {}
#line 43151 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2277: /* $@210: %empty  */
#line 13885 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)) ||
                unlikely(lex->many_values.push_back(lex->insert_list,
                         thd->mem_root)))
              MYSQL_YYABORT;
            lex->current_select->parsing_place= NO_MATTER;
          }
#line 43164 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2279: /* insert_field_list: LEFT_PAREN_ALT opt_fields ')'  */
#line 13898 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->current_select->parsing_place= AFTER_LIST;
          }
#line 43172 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2282: /* fields: fields ',' insert_ident  */
#line 13910 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43178 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2283: /* fields: insert_ident  */
#line 13911 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 43184 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2284: /* insert_values: create_select_query_expression  */
#line 13917 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                        {}
#line 43190 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2289: /* ident_eq_value: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 13932 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->field_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
                unlikely(lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43201 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2290: /* equal: '='  */
#line 13941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              {}
#line 43207 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2291: /* equal: SET_VAR  */
#line 13942 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 43213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2292: /* opt_equal: %empty  */
#line 13946 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43219 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2293: /* opt_equal: equal  */
#line 13947 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                {}
#line 43225 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2294: /* opt_with: opt_equal  */
#line 13951 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 43231 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2295: /* opt_with: WITH  */
#line 13952 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               {}
#line 43237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2296: /* opt_by: opt_equal  */
#line 13956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 43243 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2297: /* opt_by: BY  */
#line 13957 "/home/buildbot/git/sql/sql_yacc_ora.yy"
             {}
#line 43249 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2298: /* $@211: %empty  */
#line 13962 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43258 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2299: /* no_braces: '(' $@211 opt_values ')'  */
#line 13967 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43269 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2300: /* $@212: %empty  */
#line 13977 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!(Lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 43278 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2301: /* no_braces_with_names: '(' $@212 opt_values_with_names ')'  */
#line 13982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->many_values.push_back(lex->insert_list,
                                                    thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2302: /* opt_values: %empty  */
#line 13991 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2304: /* opt_values_with_names: %empty  */
#line 13996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43301 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2306: /* values: values ',' expr_or_ignore_or_default  */
#line 14002 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43310 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2307: /* values: expr_or_ignore_or_default  */
#line 14007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43319 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2308: /* values_with_names: values_with_names ',' remember_name expr_or_ignore_or_default remember_end  */
#line 14015 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
           }
#line 43331 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2309: /* values_with_names: remember_name expr_or_ignore_or_default remember_end  */
#line 14023 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->insert_list->push_back((yyvsp[-1].item), thd->mem_root)))
               MYSQL_YYABORT;
            // give some name in case of using in table value constuctor (TVC)
            if (!(yyvsp[-1].item)->name.str || (yyvsp[-1].item)->name.str == item_empty_name)
              (yyvsp[-1].item)->set_name(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 43343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2310: /* expr_or_ignore: expr  */
#line 14033 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)= (yyvsp[0].item);}
#line 43349 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2311: /* expr_or_ignore: IGNORE_SYM  */
#line 14035 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_ignore_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2312: /* expr_or_ignore_or_default: expr_or_ignore  */
#line 14043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { (yyval.item)= (yyvsp[0].item);}
#line 43365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2313: /* expr_or_ignore_or_default: DEFAULT  */
#line 14045 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_default_specification(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 43375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2315: /* $@213: %empty  */
#line 14054 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Lex->duplicates= DUP_UPDATE; }
#line 43381 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2316: /* $@214: %empty  */
#line 14056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= IN_UPDATE_ON_DUP_KEY;
          }
#line 43389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2317: /* opt_insert_update: ON DUPLICATE_SYM $@213 KEY_SYM UPDATE_SYM $@214 insert_update_list  */
#line 14060 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    Select->parsing_place= NO_MATTER;
          }
#line 43397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2318: /* update_table_list: table_ident opt_use_partition for_portion_of_time_clause opt_table_alias_clause opt_key_definition  */
#line 14068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *sel= Select;
            sel->table_join_options= 0;
            if (!((yyval.table_list)= Select->add_table_to_list(thd, (yyvsp[-4].table), (yyvsp[-1].lex_str_ptr),
                                                Select->get_table_join_options(),
                                                YYPS->m_lock_type,
                                                YYPS->m_mdl_type,
                                                Select->pop_index_hints(),
                                                (yyvsp[-3].string_list))))
              MYSQL_YYABORT;
            (yyval.table_list)->period_conditions= Lex->period_conditions;
          }
#line 43414 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2319: /* update_table_list: join_table_list  */
#line 14080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.table_list)= (yyvsp[0].table_list); }
#line 43420 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2320: /* $@215: %empty  */
#line 14087 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->sql_command= SQLCOM_UPDATE;
            lex->duplicates= DUP_ERROR; 
          }
#line 43433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2321: /* $@216: %empty  */
#line 14097 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            SELECT_LEX *slex= Lex->first_select_lex();
            if (slex->table_list.elements > 1)
              Lex->sql_command= SQLCOM_UPDATE_MULTI;
            else if (slex->get_table_list()->derived)
            {
              /* it is single table update and it is update of derived table */
              my_error(ER_NON_UPDATABLE_TABLE, MYF(0),
                       slex->get_table_list()->alias.str, "UPDATE");
              MYSQL_YYABORT;
            }
            /*
              In case of multi-update setting write lock for all tables may
              be too pessimistic. We will decrease lock level if possible in
              mysql_multi_update().
            */
            slex->set_lock_for_tables((yyvsp[-4].lock_type), slex->table_list.elements == 1);
          }
#line 43456 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2322: /* update: UPDATE_SYM $@215 opt_low_priority opt_ignore update_table_list SET update_list $@216 opt_where_clause opt_order_clause delete_limit_clause  */
#line 14116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-1].select_order))
              Select->order_list= *((yyvsp[-1].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43468 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2325: /* update_elem: simple_ident_nospvar equal DEFAULT  */
#line 14132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *def= new (thd->mem_root) Item_default_value(thd,
                                             Lex->current_context(), (yyvsp[-2].item), 1);
            if (!def || add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, def))
              MYSQL_YYABORT;
          }
#line 43479 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2326: /* update_elem: simple_ident_nospvar equal expr_or_ignore  */
#line 14139 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (add_item_to_list(thd, (yyvsp[-2].item)) || add_value_to_list(thd, (yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 43488 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2329: /* insert_update_elem: simple_ident_nospvar equal expr_or_ignore_or_default  */
#line 14152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
          LEX *lex= Lex;
          if (unlikely(lex->update_list.push_back((yyvsp[-2].item), thd->mem_root)) ||
              unlikely(lex->value_list.push_back((yyvsp[0].item), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 43499 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2330: /* opt_low_priority: %empty  */
#line 14161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 43505 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2331: /* opt_low_priority: LOW_PRIORITY  */
#line 14162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 43511 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2332: /* $@217: %empty  */
#line 14169 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_DELETE;
            YYPS->m_lock_type= TL_WRITE_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_WRITE;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->ignore= 0;
            lex->first_select_lex()->order_list.empty();
          }
#line 43527 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2333: /* delete: DELETE_SYM $@217 delete_part2  */
#line 14181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->check_cte_dependencies_and_resolve_references())
              MYSQL_YYABORT;
          }
#line 43536 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2334: /* opt_delete_system_time: %empty  */
#line 14189 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_ALL);
          }
#line 43544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2335: /* opt_delete_system_time: BEFORE_SYM SYSTEM_TIME_SYM history_point  */
#line 14193 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->vers_conditions.init(SYSTEM_TIME_BEFORE, (yyvsp[0].vers_history_point));
          }
#line 43552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2336: /* delete_part2: opt_delete_options single_multi  */
#line 14199 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          {}
#line 43558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2337: /* delete_part2: HISTORY_SYM delete_single_table opt_delete_system_time  */
#line 14201 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->last_table()->vers_conditions= Lex->vers_conditions;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43569 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2338: /* delete_single_table: FROM table_ident opt_use_partition  */
#line 14211 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Select->
                         add_table_to_list(thd, (yyvsp[-1].table), NULL, TL_OPTION_UPDATING,
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type,
                                           NULL,
                                           (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43585 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2339: /* delete_single_table_for_period: delete_single_table opt_for_portion_of_time_clause  */
#line 14226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
          if ((yyvsp[0].num))
            Lex->last_table()->period_conditions= Lex->period_conditions;
          }
#line 43594 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2340: /* single_multi: delete_single_table_for_period opt_where_clause opt_order_clause delete_limit_clause opt_select_expressions  */
#line 14238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if ((yyvsp[-2].select_order))
              Select->order_list= *((yyvsp[-2].select_order));
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43606 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2341: /* $@218: %empty  */
#line 14246 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43616 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2342: /* single_multi: table_wild_list $@218 FROM join_table_list opt_where_clause  */
#line 14252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2343: /* $@219: %empty  */
#line 14260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            mysql_init_multi_delete(Lex);
            YYPS->m_lock_type= TL_READ_DEFAULT;
            YYPS->m_mdl_type= MDL_SHARED_READ;
          }
#line 43638 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2344: /* single_multi: FROM table_alias_ref_list $@219 USING join_table_list opt_where_clause  */
#line 14266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(multi_delete_set_locks_and_link_aux_tables(Lex)))
              MYSQL_YYABORT;
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 43650 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2349: /* table_wild_one: ident opt_wild  */
#line 14287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43669 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2350: /* table_wild_one: ident '.' ident opt_wild  */
#line 14302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Table_ident *ti= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely(ti == NULL))
              MYSQL_YYABORT;
            if (unlikely(!Select->
                         add_table_to_list(thd,
                                           ti,
                                           NULL,
                                           (TL_OPTION_UPDATING |
                                            TL_OPTION_ALIAS),
                                           YYPS->m_lock_type,
                                           YYPS->m_mdl_type)))
              MYSQL_YYABORT;
          }
#line 43688 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2351: /* opt_wild: %empty  */
#line 14319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43694 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2352: /* opt_wild: '.' '*'  */
#line 14320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 43700 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2353: /* opt_delete_options: %empty  */
#line 14324 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 43706 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2354: /* opt_delete_options: opt_delete_option opt_delete_options  */
#line 14325 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               {}
#line 43712 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2355: /* opt_delete_option: QUICK  */
#line 14329 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Select->options|= OPTION_QUICK; }
#line 43718 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2356: /* opt_delete_option: LOW_PRIORITY  */
#line 14330 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { YYPS->m_lock_type= TL_WRITE_LOW_PRIORITY; }
#line 43724 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2357: /* opt_delete_option: IGNORE_SYM  */
#line 14331 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->ignore= 1; }
#line 43730 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2358: /* $@220: %empty  */
#line 14336 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= Lex;
            lex->sql_command= SQLCOM_TRUNCATE;
            lex->alter_info.reset();
            lex->first_select_lex()->options= 0;
            lex->sql_cache= LEX::SQL_CACHE_UNSPECIFIED;
            lex->first_select_lex()->order_list.empty();
            YYPS->m_lock_type= TL_WRITE;
            YYPS->m_mdl_type= MDL_EXCLUSIVE;
          }
#line 43745 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2359: /* $@221: %empty  */
#line 14347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX* lex= thd->lex;
            DBUG_ASSERT(!lex->m_sql_cmd);
            lex->m_sql_cmd= new (thd->mem_root) Sql_cmd_truncate_table();
            if (unlikely(lex->m_sql_cmd == NULL))
              MYSQL_YYABORT;
          }
#line 43757 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2360: /* truncate: TRUNCATE_SYM $@220 opt_table_sym table_name opt_lock_wait_timeout $@221 opt_truncate_table_storage_clause  */
#line 14354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                            { }
#line 43763 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2370: /* profile_def: CPU_SYM  */
#line 14378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_CPU;
    }
#line 43771 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2371: /* profile_def: MEMORY_SYM  */
#line 14382 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_MEMORY;
    }
#line 43779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2372: /* profile_def: BLOCK_SYM IO_SYM  */
#line 14386 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_BLOCK_IO;
    }
#line 43787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2373: /* profile_def: CONTEXT_SYM SWITCHES_SYM  */
#line 14390 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_CONTEXT;
    }
#line 43795 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2374: /* profile_def: PAGE_SYM FAULTS_SYM  */
#line 14394 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_PAGE_FAULTS;
    }
#line 43803 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2375: /* profile_def: IPC_SYM  */
#line 14398 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_IPC;
    }
#line 43811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2376: /* profile_def: SWAPS_SYM  */
#line 14402 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_SWAPS;
    }
#line 43819 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2377: /* profile_def: SOURCE_SYM  */
#line 14406 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_SOURCE;
    }
#line 43827 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2378: /* profile_def: ALL  */
#line 14410 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_options|= PROFILE_ALL;
    }
#line 43835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2379: /* opt_profile_args: %empty  */
#line 14417 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_query_id= 0;
    }
#line 43843 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2380: /* opt_profile_args: FOR_SYM QUERY_SYM NUM  */
#line 14421 "/home/buildbot/git/sql/sql_yacc_ora.yy"
    {
      Lex->profile_query_id= atoi((yyvsp[0].lex_str).str);
    }
#line 43851 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2381: /* $@222: %empty  */
#line 14430 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->wild=0;
            lex->ident= null_clex_str;
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->create_info.init();
          }
#line 43866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2382: /* show: SHOW $@222 show_param  */
#line 14441 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 43875 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2383: /* show_param: DATABASES wild_and_where  */
#line 14449 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_DATABASES;
             if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SCHEMATA)))
               MYSQL_YYABORT;
           }
#line 43886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2384: /* show_param: opt_full TABLES opt_db wild_and_where  */
#line 14456 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLES;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLE_NAMES))
               MYSQL_YYABORT;
           }
#line 43898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2385: /* show_param: opt_full TRIGGERS_SYM opt_db wild_and_where  */
#line 14464 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TRIGGERS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TRIGGERS))
               MYSQL_YYABORT;
           }
#line 43910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2386: /* show_param: EVENTS_SYM opt_db wild_and_where  */
#line 14472 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_EVENTS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_EVENTS))
               MYSQL_YYABORT;
           }
#line 43922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2387: /* show_param: TABLE_SYM STATUS_SYM opt_db wild_and_where  */
#line 14480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             lex->sql_command= SQLCOM_SHOW_TABLE_STATUS;
             lex->first_select_lex()->db= (yyvsp[-1].lex_str);
             if (prepare_schema_table(thd, lex, 0, SCH_TABLES))
               MYSQL_YYABORT;
           }
#line 43934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2388: /* show_param: OPEN_SYM TABLES opt_db wild_and_where  */
#line 14488 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_OPEN_TABLES;
            lex->first_select_lex()->db= (yyvsp[-1].lex_str);
            if (prepare_schema_table(thd, lex, 0, SCH_OPEN_TABLES))
              MYSQL_YYABORT;
          }
#line 43946 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2389: /* show_param: PLUGINS_SYM  */
#line 14496 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43957 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2390: /* show_param: PLUGINS_SYM SONAME_SYM TEXT_STRING_sys  */
#line 14503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->ident= (yyvsp[0].lex_str);
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2391: /* show_param: PLUGINS_SYM SONAME_SYM wild_and_where  */
#line 14510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PLUGINS;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_ALL_PLUGINS)))
              MYSQL_YYABORT;
          }
#line 43978 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2392: /* show_param: ENGINE_SYM known_storage_engines show_engine_param  */
#line 14516 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.db_type= (yyvsp[-1].db_type); }
#line 43984 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2393: /* show_param: ENGINE_SYM ALL show_engine_param  */
#line 14518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->create_info.db_type= NULL; }
#line 43990 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2394: /* show_param: opt_full COLUMNS from_or_in table_ident opt_db wild_and_where  */
#line 14520 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2395: /* show_param: master_or_binary LOGS_SYM  */
#line 14529 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_BINLOGS;
          }
#line 44011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2396: /* show_param: SLAVE HOSTS_SYM  */
#line 14533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_HOSTS;
          }
#line 44019 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2397: /* $@223: %empty  */
#line 14537 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_BINLOG_EVENTS;
          }
#line 44028 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2399: /* $@224: %empty  */
#line 14543 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_RELAYLOG_EVENTS;
          }
#line 44037 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2401: /* show_param: keys_or_index from_or_in table_ident opt_db opt_where_clause  */
#line 14549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_KEYS;
            if ((yyvsp[-1].lex_str).str)
              (yyvsp[-2].table)->change_db(&(yyvsp[-1].lex_str));
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[-2].table), SCH_STATISTICS)))
              MYSQL_YYABORT;
          }
#line 44050 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2402: /* show_param: opt_storage ENGINES_SYM  */
#line 14558 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_STORAGE_ENGINES;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_ENGINES)))
              MYSQL_YYABORT;
          }
#line 44061 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2403: /* show_param: AUTHORS_SYM  */
#line 14565 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_AUTHORS;
          }
#line 44070 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2404: /* show_param: CONTRIBUTORS_SYM  */
#line 14570 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_CONTRIBUTORS;
          }
#line 44079 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2405: /* show_param: PRIVILEGES  */
#line 14575 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_PRIVILEGES;
          }
#line 44088 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2406: /* show_param: COUNT_SYM '(' '*' ')' WARNINGS  */
#line 14580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("warning_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44097 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2407: /* show_param: COUNT_SYM '(' '*' ')' ERRORS  */
#line 14585 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING var= {STRING_WITH_LEN("error_count")};
            (void) create_select_for_variable(thd, &var);
          }
#line 44106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2408: /* show_param: WARNINGS opt_global_limit_clause  */
#line 14590 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_WARNS;}
#line 44112 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2409: /* show_param: ERRORS opt_global_limit_clause  */
#line 14592 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_ERRORS;}
#line 44118 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2410: /* show_param: PROFILES_SYM  */
#line 14594 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command = SQLCOM_SHOW_PROFILES; }
#line 44124 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2411: /* show_param: PROFILE_SYM opt_profile_defs opt_profile_args opt_global_limit_clause  */
#line 14596 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_PROFILE;
            if (unlikely(prepare_schema_table(thd, lex, NULL, SCH_PROFILES)))
              MYSQL_YYABORT;
          }
#line 44135 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2412: /* show_param: opt_var_type STATUS_SYM wild_and_where  */
#line 14603 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_STATUS)))
              MYSQL_YYABORT;
          }
#line 44147 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2413: /* show_param: opt_full PROCESSLIST_SYM  */
#line 14611 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_PROCESSLIST;}
#line 44153 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2414: /* show_param: opt_var_type VARIABLES wild_and_where  */
#line 14613 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_VARIABLES;
            lex->option_type= (yyvsp[-2].var_type);
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_SESSION_VARIABLES)))
              MYSQL_YYABORT;
          }
#line 44165 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2415: /* show_param: charset wild_and_where  */
#line 14621 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CHARSETS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_CHARSETS)))
              MYSQL_YYABORT;
          }
#line 44176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2416: /* show_param: COLLATION_SYM wild_and_where  */
#line 14628 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_COLLATIONS;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_COLLATIONS)))
              MYSQL_YYABORT;
          }
#line 44187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2417: /* show_param: GRANTS  */
#line 14635 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_GRANTS;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user_and_current_role;
          }
#line 44199 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2418: /* show_param: GRANTS FOR_SYM user_or_role clear_privileges  */
#line 14643 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SHOW_GRANTS;
            lex->grant_user=(yyvsp[-1].lex_user);
          }
#line 44209 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2419: /* show_param: CREATE DATABASE opt_if_not_exists ident  */
#line 14649 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->set_command(SQLCOM_SHOW_CREATE_DB, (yyvsp[-1].object_ddl_options));
            Lex->name= (yyvsp[0].ident_sys);
          }
#line 44218 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2420: /* show_param: CREATE TABLE_SYM table_ident  */
#line 14654 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL,0))
              MYSQL_YYABORT;
            lex->create_info.storage_media= HA_SM_DEFAULT;
          }
#line 44230 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2421: /* show_param: CREATE VIEW_SYM table_ident  */
#line 14662 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_VIEW;
          }
#line 44242 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2422: /* show_param: CREATE SEQUENCE_SYM table_ident  */
#line 14670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE;
            if (!lex->first_select_lex()->add_table_to_list(thd, (yyvsp[0].table), NULL, 0))
              MYSQL_YYABORT;
            lex->table_type= TABLE_TYPE_SEQUENCE;
          }
#line 44254 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2423: /* show_param: MASTER_SYM STATUS_SYM  */
#line 14678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_MASTER_STAT;
          }
#line 44262 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2424: /* show_param: ALL SLAVES STATUS_SYM  */
#line 14682 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 1;
          }
#line 44271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2425: /* show_param: SLAVE STATUS_SYM  */
#line 14687 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->mi.connection_name= null_clex_str;
            lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            lex->verbose= 0;
          }
#line 44282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2426: /* show_param: SLAVE connection_name STATUS_SYM  */
#line 14694 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_SHOW_SLAVE_STAT;
            Lex->verbose= 0;
          }
#line 44291 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2427: /* show_param: CREATE PROCEDURE_SYM sp_name  */
#line 14699 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_PROC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44302 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2428: /* show_param: CREATE FUNCTION_SYM sp_name  */
#line 14706 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            lex->sql_command = SQLCOM_SHOW_CREATE_FUNC;
            lex->spname= (yyvsp[0].spname);
          }
#line 44313 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2429: /* show_param: CREATE PACKAGE_ORACLE_SYM sp_name  */
#line 14713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE;
            lex->spname= (yyvsp[0].spname);
          }
#line 44323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2430: /* show_param: CREATE PACKAGE_ORACLE_SYM BODY_ORACLE_SYM sp_name  */
#line 14719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command = SQLCOM_SHOW_CREATE_PACKAGE_BODY;
            lex->spname= (yyvsp[0].spname);
          }
#line 44333 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2431: /* show_param: CREATE TRIGGER_SYM sp_name  */
#line 14725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_CREATE_TRIGGER;
            lex->spname= (yyvsp[0].spname);
          }
#line 44343 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2432: /* show_param: CREATE USER_SYM  */
#line 14731 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
            if (unlikely(!(Lex->grant_user=
                          (LEX_USER*)thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            Lex->grant_user->user= current_user;
          }
#line 44355 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2433: /* show_param: CREATE USER_SYM user  */
#line 14739 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->sql_command= SQLCOM_SHOW_CREATE_USER;
             Lex->grant_user= (yyvsp[0].lex_user);
          }
#line 44364 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2434: /* show_param: PROCEDURE_SYM STATUS_SYM wild_and_where  */
#line 14744 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PROC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44375 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2435: /* show_param: FUNCTION_SYM STATUS_SYM wild_and_where  */
#line 14751 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_FUNC;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2436: /* show_param: PACKAGE_ORACLE_SYM STATUS_SYM wild_and_where  */
#line 14758 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44397 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2437: /* show_param: PACKAGE_ORACLE_SYM BODY_ORACLE_SYM STATUS_SYM wild_and_where  */
#line 14765 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_SHOW_STATUS_PACKAGE_BODY;
            if (unlikely(prepare_schema_table(thd, lex, 0, SCH_PROCEDURES)))
              MYSQL_YYABORT;
          }
#line 44408 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2438: /* show_param: PROCEDURE_SYM CODE_SYM sp_name  */
#line 14772 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PROC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44417 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2439: /* show_param: FUNCTION_SYM CODE_SYM sp_name  */
#line 14777 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_FUNC_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44426 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2440: /* show_param: PACKAGE_ORACLE_SYM BODY_ORACLE_SYM CODE_SYM sp_name  */
#line 14782 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_PACKAGE_BODY_CODE;
            Lex->spname= (yyvsp[0].spname);
          }
#line 44435 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2441: /* show_param: CREATE EVENT_SYM sp_name  */
#line 14787 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->spname= (yyvsp[0].spname);
            Lex->sql_command = SQLCOM_SHOW_CREATE_EVENT;
          }
#line 44444 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2442: /* show_param: describe_command FOR_SYM expr  */
#line 14792 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_SHOW_EXPLAIN;
            if (unlikely(prepare_schema_table(thd, Lex, 0, SCH_EXPLAIN)))
              MYSQL_YYABORT;
            add_value_to_list(thd, (yyvsp[0].item));
          }
#line 44455 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2443: /* show_param: IDENT_sys remember_tok_start wild_and_where  */
#line 14799 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             LEX *lex= Lex;
             bool in_plugin;
             lex->sql_command= SQLCOM_SHOW_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-2].ident_sys), &in_plugin);
             if (unlikely(!table || !table->old_format || !in_plugin))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-1].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(lex->wild && table->idx_field1 < 0))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(make_schema_select(thd, Lex->current_select, table)))
               MYSQL_YYABORT;
           }
#line 44478 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2444: /* show_engine_param: STATUS_SYM  */
#line 14821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_STATUS; }
#line 44484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2445: /* show_engine_param: MUTEX_SYM  */
#line 14823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_MUTEX; }
#line 44490 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2446: /* show_engine_param: LOGS_SYM  */
#line 14825 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->sql_command= SQLCOM_SHOW_ENGINE_LOGS; }
#line 44496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2451: /* opt_db: %empty  */
#line 14839 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lex_str)= null_clex_str; }
#line 44502 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2452: /* opt_db: from_or_in ident  */
#line 14840 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 44508 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2453: /* opt_full: %empty  */
#line 14844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->verbose=0; }
#line 44514 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2454: /* opt_full: FULL  */
#line 14845 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->verbose=1; }
#line 44520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2457: /* binlog_in: %empty  */
#line 14854 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { Lex->mi.log_file_name = 0; }
#line 44526 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2458: /* binlog_in: IN_SYM TEXT_STRING_sys  */
#line 14855 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { Lex->mi.log_file_name = (yyvsp[0].lex_str).str; }
#line 44532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2459: /* binlog_from: %empty  */
#line 14859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->mi.pos = 4; /* skip magic number */ }
#line 44538 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2460: /* binlog_from: FROM ulonglong_num  */
#line 14860 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->mi.pos = (yyvsp[0].ulonglong_number); }
#line 44544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2461: /* wild_and_where: %empty  */
#line 14864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.simple_string)= 0; }
#line 44550 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2462: /* wild_and_where: LIKE remember_tok_start TEXT_STRING_sys  */
#line 14866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->wild= new (thd->mem_root) String((yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44562 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2463: /* wild_and_where: WHERE remember_tok_start expr  */
#line 14874 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->where= normalize_cond(thd, (yyvsp[0].item));
            if ((yyvsp[0].item))
              (yyvsp[0].item)->top_level_item();
            (yyval.simple_string)= (yyvsp[-1].simple_string);
          }
#line 44573 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2464: /* $@225: %empty  */
#line 14885 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
            lex->current_select->parsing_place= SELECT_LIST;
            lex->sql_command= SQLCOM_SHOW_FIELDS;
            lex->first_select_lex()->db= null_clex_str;
            lex->verbose= 0;
            if (unlikely(prepare_schema_table(thd, lex, (yyvsp[0].table), SCH_COLUMNS)))
              MYSQL_YYABORT;
          }
#line 44590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2465: /* describe: describe_command table_ident $@225 opt_describe_column  */
#line 14898 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Select->parsing_place= NO_MATTER;
            Lex->pop_select(); //main select
          }
#line 44599 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2466: /* $@226: %empty  */
#line 14903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->describe|= DESCRIBE_NORMAL; }
#line 44605 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2467: /* describe: describe_command opt_extended_describe $@226 explainable_command  */
#line 14905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->first_select_lex()->options|= SELECT_DESCRIBE;
          }
#line 44614 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2476: /* analyze_stmt_command: ANALYZE_SYM opt_format_json explainable_command  */
#line 14927 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->analyze_stmt= true;
          }
#line 44622 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2477: /* opt_extended_describe: EXTENDED_SYM  */
#line 14933 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->describe|= DESCRIBE_EXTENDED; }
#line 44628 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2478: /* opt_extended_describe: EXTENDED_SYM ALL  */
#line 14935 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->describe|= DESCRIBE_EXTENDED | DESCRIBE_EXTENDED2; }
#line 44634 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2479: /* opt_extended_describe: PARTITIONS_SYM  */
#line 14936 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { Lex->describe|= DESCRIBE_PARTITIONS; }
#line 44640 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2480: /* opt_extended_describe: opt_format_json  */
#line 14937 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 44646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2481: /* opt_format_json: %empty  */
#line 14941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44652 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2482: /* opt_format_json: FORMAT_SYM '=' ident_or_text  */
#line 14943 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("JSON")))
              Lex->explain_json= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("TRADITIONAL")))
              DBUG_ASSERT(Lex->explain_json==false);
            else
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0), "EXPLAIN",
                               (yyvsp[0].lex_str).str));
          }
#line 44666 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2483: /* opt_describe_column: %empty  */
#line 14955 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44672 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2484: /* opt_describe_column: text_string  */
#line 14956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->wild= (yyvsp[0].string); }
#line 44678 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2485: /* opt_describe_column: ident  */
#line 14958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->wild= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,
                                                    (yyvsp[0].ident_sys).length,
                                                    system_charset_info);
            if (unlikely(Lex->wild == NULL))
              MYSQL_YYABORT;
          }
#line 44690 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2486: /* $@227: %empty  */
#line 14972 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_FLUSH;
            lex->type= 0;
            lex->no_write_to_binlog= (yyvsp[0].num);
          }
#line 44701 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2487: /* flush: FLUSH_SYM opt_no_write_to_binlog $@227 flush_options  */
#line 14978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 44707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2488: /* $@228: %empty  */
#line 14983 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->type|= REFRESH_TABLES;
            /*
              Set type of metadata and table locks for
              FLUSH TABLES table_list [WITH READ LOCK].
            */
            YYPS->m_lock_type= TL_READ_NO_INSERT;
            YYPS->m_mdl_type= MDL_SHARED_HIGH_PRIO;
          }
#line 44721 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2489: /* flush_options: table_or_tables $@228 opt_table_list opt_flush_lock  */
#line 14993 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2490: /* flush_options: flush_options_list  */
#line 14995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44733 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2491: /* opt_flush_lock: %empty  */
#line 14999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44739 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2492: /* opt_flush_lock: flush_lock  */
#line 15001 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          TABLE_LIST *tables= Lex->query_tables;
          for (; tables; tables= tables->next_global)
          {
            tables->mdl_request.set_type(MDL_SHARED_NO_WRITE);
            /* Don't try to flush views. */
            tables->required_type= TABLE_TYPE_NORMAL;
            /* Ignore temporary tables. */
            tables->open_type= OT_BASE_ONLY;
          }
        }
#line 44755 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2493: /* flush_lock: WITH READ_SYM LOCK_SYM optional_flush_tables_arguments  */
#line 15016 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_READ_LOCK | (yyvsp[0].num); }
#line 44761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2494: /* $@229: %empty  */
#line 15018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->query_tables == NULL))
            {
              // Table list can't be empty
              thd->parse_error(ER_NO_TABLES_USED);
              MYSQL_YYABORT;
            } 
            Lex->type|= REFRESH_FOR_EXPORT;
          }
#line 44775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2495: /* flush_lock: FOR_SYM $@229 EXPORT_SYM  */
#line 15026 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 44781 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2497: /* flush_options_list: flush_option  */
#line 15032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44787 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2498: /* flush_option: ERROR_SYM LOGS_SYM  */
#line 15037 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_ERROR_LOG; }
#line 44793 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2499: /* flush_option: ENGINE_SYM LOGS_SYM  */
#line 15039 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_ENGINE_LOG; }
#line 44799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2500: /* flush_option: GENERAL LOGS_SYM  */
#line 15041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_GENERAL_LOG; }
#line 44805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2501: /* flush_option: SLOW LOGS_SYM  */
#line 15043 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_SLOW_LOG; }
#line 44811 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2502: /* flush_option: BINARY LOGS_SYM opt_delete_gtid_domain  */
#line 15045 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_BINARY_LOG; }
#line 44817 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2503: /* flush_option: RELAY LOGS_SYM optional_connection_name  */
#line 15047 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_RELAY_LOG))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH", "RELAY LOGS"));
            lex->type|= REFRESH_RELAY_LOG;
            lex->relay_log_connection_name= lex->mi.connection_name;
           }
#line 44829 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2504: /* flush_option: QUERY_SYM CACHE_SYM  */
#line 15055 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_QUERY_CACHE_FREE; }
#line 44835 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2505: /* flush_option: HOSTS_SYM  */
#line 15057 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_HOSTS; }
#line 44841 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2506: /* flush_option: PRIVILEGES  */
#line 15059 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_GRANT; }
#line 44847 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2507: /* flush_option: LOGS_SYM  */
#line 15061 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->type|= REFRESH_LOG;
            Lex->relay_log_connection_name= empty_clex_str;
          }
#line 44856 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2508: /* flush_option: STATUS_SYM  */
#line 15066 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_STATUS; }
#line 44862 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2509: /* flush_option: SLAVE optional_connection_name  */
#line 15068 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            LEX *lex= Lex;
            if (unlikely(lex->type & REFRESH_SLAVE))
              my_yyabort_error((ER_WRONG_USAGE, MYF(0), "FLUSH","SLAVE"));
            lex->type|= REFRESH_SLAVE;
            lex->reset_slave_info.all= false;
          }
#line 44874 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2510: /* flush_option: MASTER_SYM  */
#line 15076 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_MASTER; }
#line 44880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2511: /* flush_option: DES_KEY_FILE  */
#line 15078 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_DES_KEY_FILE; }
#line 44886 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2512: /* flush_option: RESOURCES  */
#line 15080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_USER_RESOURCES; }
#line 44892 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2513: /* flush_option: SSL_SYM  */
#line 15082 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->type|= REFRESH_SSL;}
#line 44898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2514: /* flush_option: IDENT_sys remember_tok_start  */
#line 15084 "/home/buildbot/git/sql/sql_yacc_ora.yy"
           {
             Lex->type|= REFRESH_GENERIC;
             ST_SCHEMA_TABLE *table= find_schema_table(thd, &(yyvsp[-1].ident_sys));
             if (unlikely(!table || !table->reset_table))
             {
               thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[0].simple_string));
               MYSQL_YYABORT;
             }
             if (unlikely(Lex->view_list.push_back((LEX_CSTRING*)
                                                   thd->memdup(&(yyvsp[-1].ident_sys), sizeof(LEX_CSTRING)),
                                                   thd->mem_root)))
               MYSQL_YYABORT;
           }
#line 44916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2515: /* opt_table_list: %empty  */
#line 15100 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 44922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2516: /* opt_table_list: table_list  */
#line 15101 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     {}
#line 44928 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2517: /* backup: BACKUP_SYM backup_statements  */
#line 15105 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                     {}
#line 44934 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2518: /* backup_statements: STAGE_SYM ident  */
#line 15110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          int type;
          if (unlikely(Lex->sphead))
            my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "BACKUP STAGE"));
          if ((type= find_type((yyvsp[0].ident_sys).str, &backup_stage_names,
                               FIND_TYPE_NO_PREFIX)) <= 0)
            my_yyabort_error((ER_BACKUP_UNKNOWN_STAGE, MYF(0), (yyvsp[0].ident_sys).str));
          Lex->sql_command= SQLCOM_BACKUP;
          Lex->backup_stage= (backup_stages) (type-1);
          break;
        }
#line 44950 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2519: /* $@230: %empty  */
#line 15122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 44959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2520: /* backup_statements: LOCK_SYM $@230 table_ident  */
#line 15127 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    if (unlikely(!Select->add_table_to_list(thd, (yyvsp[0].table), NULL, 0,
                                                    TL_READ, MDL_SHARED_HIGH_PRIO)))
             MYSQL_YYABORT;
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
            Lex->pop_select(); //main select
          }
#line 44971 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2521: /* backup_statements: UNLOCK_SYM  */
#line 15135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
	    /* Table list is empty for unlock */
            Lex->sql_command= SQLCOM_BACKUP_LOCK;
          }
#line 44980 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2522: /* opt_delete_gtid_domain: %empty  */
#line 15142 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 44986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2523: /* opt_delete_gtid_domain: DELETE_DOMAIN_ID_SYM '=' '(' delete_domain_id_list ')'  */
#line 15144 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 44992 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2527: /* delete_domain_id: ulonglong_num  */
#line 15154 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            uint32 value= (uint32) (yyvsp[0].ulonglong_number);
            if ((yyvsp[0].ulonglong_number) > UINT_MAX32)
            {
              my_printf_error(ER_BINLOG_CANT_DELETE_GTID_DOMAIN,
                              "The value of gtid domain being deleted ('%llu') "
                              "exceeds its maximum size "
                              "of 32 bit unsigned integer", MYF(0), (yyvsp[0].ulonglong_number));
              MYSQL_YYABORT;
            }
            insert_dynamic(&Lex->delete_gtid_domain, (uchar*) &value);
          }
#line 45009 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2528: /* optional_flush_tables_arguments: %empty  */
#line 15169 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             {(yyval.num)= 0;}
#line 45015 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2529: /* optional_flush_tables_arguments: AND_SYM DISABLE_SYM CHECKPOINT_SYM  */
#line 15170 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                             {(yyval.num)= REFRESH_CHECKPOINT; }
#line 45021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2530: /* $@231: %empty  */
#line 15175 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RESET; lex->type=0;
          }
#line 45030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2531: /* reset: RESET_SYM $@231 reset_options  */
#line 15180 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 45036 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2534: /* $@232: %empty  */
#line 15189 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->type|= REFRESH_SLAVE; }
#line 45042 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2535: /* reset_option: SLAVE $@232 optional_connection_name slave_reset_options  */
#line 15191 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 45048 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2536: /* $@233: %empty  */
#line 15193 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             Lex->type|= REFRESH_MASTER;
             Lex->next_binlog_file_number= 0;
          }
#line 45057 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2538: /* reset_option: QUERY_SYM CACHE_SYM  */
#line 15198 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->type|= REFRESH_QUERY_CACHE;}
#line 45063 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2539: /* slave_reset_options: %empty  */
#line 15202 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->reset_slave_info.all= false; }
#line 45069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2540: /* slave_reset_options: ALL  */
#line 15203 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->reset_slave_info.all= true; }
#line 45075 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2541: /* master_reset_options: %empty  */
#line 15207 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 45081 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2542: /* master_reset_options: TO_SYM ulong_num  */
#line 15209 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->next_binlog_file_number = (yyvsp[0].ulong_num);
          }
#line 45089 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2543: /* purge: PURGE master_or_binary LOGS_SYM TO_SYM TEXT_STRING_sys  */
#line 15216 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_purge_to((yyvsp[0].lex_str));
          }
#line 45097 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2544: /* $@234: %empty  */
#line 15220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->clause_that_disallows_subselect= "PURGE..BEFORE"; }
#line 45103 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2545: /* purge: PURGE master_or_binary LOGS_SYM BEFORE_SYM $@234 expr  */
#line 15222 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->clause_that_disallows_subselect= NULL;
            if (Lex->stmt_purge_before((yyvsp[0].item)))
              MYSQL_YYABORT;
          }
#line 45113 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2546: /* $@235: %empty  */
#line 15234 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->value_list.empty();
            lex->users_list.empty();
            lex->sql_command= SQLCOM_KILL;
            lex->kill_type= KILL_TYPE_ID;
          }
#line 45125 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2547: /* kill: KILL_SYM $@235 kill_type kill_option  */
#line 15242 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->kill_signal= (killed_state) ((yyvsp[-1].num) | (yyvsp[0].num));
          }
#line 45133 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2548: /* kill_type: %empty  */
#line 15248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45139 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2549: /* kill_type: HARD_SYM  */
#line 15249 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= (int) KILL_HARD_BIT; }
#line 45145 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2550: /* kill_type: SOFT_SYM  */
#line 15250 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 0; }
#line 45151 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2551: /* kill_option: opt_connection kill_expr  */
#line 15254 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.num)= (int) KILL_CONNECTION; }
#line 45157 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2552: /* kill_option: QUERY_SYM kill_expr  */
#line 15255 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.num)= (int) KILL_QUERY; }
#line 45163 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2553: /* kill_option: QUERY_SYM ID_SYM expr  */
#line 15257 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (int) KILL_QUERY;
            Lex->kill_type= KILL_TYPE_QUERY;
            Lex->value_list.push_front((yyvsp[0].item), thd->mem_root);
          }
#line 45173 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2554: /* opt_connection: %empty  */
#line 15265 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 45179 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2555: /* opt_connection: CONNECTION_SYM  */
#line 15266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                         { }
#line 45185 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2556: /* kill_expr: expr  */
#line 15271 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->value_list.push_front((yyval.item), thd->mem_root);
         }
#line 45193 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2557: /* kill_expr: USER_SYM user  */
#line 15275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root);
            Lex->kill_type= KILL_TYPE_USER;
          }
#line 45202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2558: /* $@236: %empty  */
#line 15282 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { Lex->sql_command= SQLCOM_SHUTDOWN; }
#line 45208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2559: /* shutdown: SHUTDOWN $@236 shutdown_option  */
#line 15283 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        {}
#line 45214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2560: /* shutdown_option: %empty  */
#line 15287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->is_shutdown_wait_for_slaves= false; }
#line 45220 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2561: /* shutdown_option: WAIT_SYM FOR_SYM ALL SLAVES  */
#line 15289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          Lex->is_shutdown_wait_for_slaves= true;
        }
#line 45228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2562: /* use: USE_SYM ident  */
#line 15297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command=SQLCOM_CHANGE_DB;
            lex->first_select_lex()->db= (yyvsp[0].ident_sys);
          }
#line 45238 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2563: /* $@237: %empty  */
#line 15308 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;

            if (unlikely(lex->sphead))
            {
              my_error(ER_SP_BADSTATEMENT, MYF(0), 
                       (yyvsp[0].filetype) == FILETYPE_CSV ? "LOAD DATA" : "LOAD XML");
              MYSQL_YYABORT;
            }
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            mysql_init_select(lex);
          }
#line 45256 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2564: /* $@238: %empty  */
#line 15322 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_LOAD;
            lex->local_file=  (yyvsp[-2].num);
            lex->duplicates= DUP_ERROR;
            lex->ignore= 0;
            if (unlikely(!(lex->exchange= new (thd->mem_root)
                         sql_exchange((yyvsp[0].lex_str).str, 0, (yyvsp[-5].filetype)))))
              MYSQL_YYABORT;
          }
#line 45271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2565: /* $@239: %empty  */
#line 15333 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!Select->add_table_to_list(thd, (yyvsp[-1].table), NULL,
                                                   TL_OPTION_UPDATING,
                                                   (yyvsp[-9].lock_type), MDL_SHARED_WRITE,
                                                   NULL, (yyvsp[0].string_list))))
              MYSQL_YYABORT;
            lex->field_list.empty();
            lex->update_list.empty();
            lex->value_list.empty();
            lex->many_values.empty();
          }
#line 45288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2566: /* $@240: %empty  */
#line 15346 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->cs= (yyvsp[0].charset); }
#line 45294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2567: /* load: LOAD data_or_xml $@237 load_data_lock opt_local INFILE TEXT_STRING_filesystem $@238 opt_duplicate INTO TABLE_SYM table_ident opt_use_partition $@239 opt_load_data_charset $@240 opt_xml_rows_identified_by opt_field_term opt_line_term opt_ignore_lines opt_field_or_var_spec opt_load_data_set_spec  */
#line 15350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
            Lex->mark_first_table_as_inserting();
          }
#line 45305 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2568: /* data_or_xml: DATA_SYM  */
#line 15359 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.filetype)= FILETYPE_CSV; }
#line 45311 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2569: /* data_or_xml: XML_SYM  */
#line 15360 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.filetype)= FILETYPE_XML; }
#line 45317 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2570: /* opt_local: %empty  */
#line 15364 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)=0;}
#line 45323 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2571: /* opt_local: LOCAL_SYM  */
#line 15365 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=1;}
#line 45329 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2572: /* load_data_lock: %empty  */
#line 15369 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lock_type)= TL_WRITE_DEFAULT; }
#line 45335 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2573: /* load_data_lock: CONCURRENT  */
#line 15371 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              Ignore this option in SP to avoid problem with query cache and
              triggers with non default priority locks
            */
            (yyval.lock_type)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 45347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2574: /* load_data_lock: LOW_PRIORITY  */
#line 15378 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lock_type)= TL_WRITE_LOW_PRIORITY; }
#line 45353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2575: /* opt_duplicate: %empty  */
#line 15382 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { Lex->duplicates=DUP_ERROR; }
#line 45359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2576: /* opt_duplicate: REPLACE  */
#line 15383 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { Lex->duplicates=DUP_REPLACE; }
#line 45365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2577: /* opt_duplicate: IGNORE_SYM  */
#line 15384 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { Lex->ignore= 1; }
#line 45371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2582: /* field_term: TERMINATED BY text_string  */
#line 15399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->field_term= (yyvsp[0].string);
          }
#line 45380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2583: /* field_term: OPTIONALLY ENCLOSED BY text_string  */
#line 15404 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->exchange != 0);
            lex->exchange->enclosed= (yyvsp[0].string);
            lex->exchange->opt_enclosed= 1;
          }
#line 45391 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2584: /* field_term: ENCLOSED BY text_string  */
#line 15411 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->enclosed= (yyvsp[0].string);
          }
#line 45400 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2585: /* field_term: ESCAPED BY text_string  */
#line 15416 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->escaped= (yyvsp[0].string);
          }
#line 45409 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2590: /* line_term: TERMINATED BY text_string  */
#line 15434 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_term= (yyvsp[0].string);
          }
#line 45418 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2591: /* line_term: STARTING BY text_string  */
#line 15439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->line_start= (yyvsp[0].string);
          }
#line 45427 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2592: /* opt_xml_rows_identified_by: %empty  */
#line 15446 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { }
#line 45433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2593: /* opt_xml_rows_identified_by: ROWS_SYM IDENTIFIED_SYM BY text_string  */
#line 15448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->exchange->line_term = (yyvsp[0].string); }
#line 45439 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2595: /* opt_ignore_lines: IGNORE_SYM NUM lines_or_rows  */
#line 15454 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            DBUG_ASSERT(Lex->exchange != 0);
            Lex->exchange->skip_lines= atol((yyvsp[-1].lex_str).str);
          }
#line 45448 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2596: /* lines_or_rows: LINES  */
#line 15461 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { }
#line 45454 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2597: /* lines_or_rows: ROWS_SYM  */
#line 15462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   { }
#line 45460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2598: /* opt_field_or_var_spec: %empty  */
#line 15466 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 45466 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2599: /* opt_field_or_var_spec: '(' fields_or_vars ')'  */
#line 15467 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 45472 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2600: /* opt_field_or_var_spec: '(' ')'  */
#line 15468 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 45478 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2601: /* fields_or_vars: fields_or_vars ',' field_or_var  */
#line 15473 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45484 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2602: /* fields_or_vars: field_or_var  */
#line 15475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->field_list.push_back((yyvsp[0].item), thd->mem_root); }
#line 45490 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2603: /* field_or_var: simple_ident_nospvar  */
#line 15479 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               {(yyval.item)= (yyvsp[0].item);}
#line 45496 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2604: /* field_or_var: '@' ident_or_text  */
#line 15481 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_user_var_as_out_param(thd, &(yyvsp[0].lex_str));
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45506 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2605: /* opt_load_data_set_spec: %empty  */
#line 15489 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 45512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2606: /* opt_load_data_set_spec: SET load_data_set_list  */
#line 15490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 45518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2609: /* load_data_set_elem: simple_ident_nospvar equal remember_name expr_or_ignore_or_default remember_end  */
#line 15500 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->update_list.push_back((yyvsp[-4].item), thd->mem_root)) ||
                unlikely(lex->value_list.push_back((yyvsp[-1].item), thd->mem_root)))
                MYSQL_YYABORT;
            (yyvsp[-1].item)->set_name_no_truncate(thd, (yyvsp[-2].simple_string), (uint) ((yyvsp[0].simple_string) - (yyvsp[-2].simple_string)), thd->charset());
          }
#line 45530 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2610: /* text_literal: TEXT_STRING  */
#line 15513 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45539 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2611: /* text_literal: NCHAR_STRING  */
#line 15518 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_nchar((yyvsp[0].lex_string_with_metadata)))))
              MYSQL_YYABORT;
          }
#line 45548 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2612: /* text_literal: UNDERSCORE_CHARSET TEXT_STRING  */
#line 15523 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= thd->make_string_literal_charset((yyvsp[0].lex_string_with_metadata), (yyvsp[-1].charset)))))
              MYSQL_YYABORT;
          }
#line 45557 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2613: /* text_literal: text_literal TEXT_STRING_literal  */
#line 15528 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_basic_constant)= (yyvsp[-1].item_basic_constant)->make_string_literal_concat(thd, &(yyvsp[0].lex_str)))))
              MYSQL_YYABORT;
          }
#line 45566 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2614: /* text_string: TEXT_STRING_literal  */
#line 15536 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.string)= new (thd->mem_root) String((yyvsp[0].lex_str).str,
                                             (yyvsp[0].lex_str).length,
                                             thd->variables.collation_connection);
            if (unlikely((yyval.string) == NULL))
              MYSQL_YYABORT;
          }
#line 45578 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2615: /* text_string: hex_or_bin_String  */
#line 15543 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { (yyval.string)= (yyvsp[0].string); }
#line 45584 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2616: /* hex_or_bin_String: HEX_NUM  */
#line 15549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45596 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2617: /* hex_or_bin_String: HEX_STRING  */
#line 15557 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45608 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2618: /* hex_or_bin_String: BIN_NUM  */
#line 15565 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item *tmp= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str,
                                                           (yyvsp[0].lex_str).length);
            if (unlikely(tmp == NULL))
              MYSQL_YYABORT;
            /*
              it is OK only emulate fix_fields, because we need only
              value of constant
            */
            (yyval.string)= tmp->val_str((String*) 0);
          }
#line 45624 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2619: /* param_marker: PARAM_MARKER  */
#line 15580 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &param_clex_str,
                                                    YYLIP->get_tok_start(),
                                                    YYLIP->get_tok_start() + 1))))
              MYSQL_YYABORT;
          }
#line 45635 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2620: /* param_marker: COLON_ORACLE_SYM ident_cli  */
#line 15587 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(), (yyvsp[0].ident_cli).end()))))
              MYSQL_YYABORT;
          }
#line 45645 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2621: /* param_marker: COLON_ORACLE_SYM NUM  */
#line 15593 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item_param)= Lex->add_placeholder(thd, &null_clex_str,
                                                    (yyvsp[-1].kwd).pos(),
                                                    YYLIP->get_ptr()))))
              MYSQL_YYABORT;
          }
#line 45656 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2622: /* signed_literal: '+' NUM_literal  */
#line 15602 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.item) = (yyvsp[0].item_num); }
#line 45662 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2623: /* signed_literal: '-' NUM_literal  */
#line 15604 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].item_num)->max_length++;
            (yyval.item)= (yyvsp[0].item_num)->neg(thd);
          }
#line 45671 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2624: /* literal: text_literal  */
#line 15611 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.item) = (yyvsp[0].item_basic_constant); }
#line 45677 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2625: /* literal: NUM_literal  */
#line 15612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.item) = (yyvsp[0].item_num); }
#line 45683 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2626: /* literal: temporal_literal  */
#line 15613 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { (yyval.item)= (yyvsp[0].item); }
#line 45689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2627: /* literal: NULL_SYM  */
#line 15615 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              For the digest computation, in this context only,
              NULL is considered a literal, hence reduced to '?'
              REDUCE:
                TOK_GENERIC_VALUE := NULL_SYM
            */
            YYLIP->reduce_digest_token(TOK_GENERIC_VALUE, NULL_SYM);
            (yyval.item)= new (thd->mem_root) Item_null(thd);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
            YYLIP->next_state= MY_LEX_OPERATOR_OR_IDENT;
          }
#line 45707 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2628: /* literal: FALSE_SYM  */
#line 15629 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "FALSE",0);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45717 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2629: /* literal: TRUE_SYM  */
#line 15635 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bool(thd, (char*) "TRUE",1);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45727 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2630: /* literal: HEX_NUM  */
#line 15641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_hybrid(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45737 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2631: /* literal: HEX_STRING  */
#line 15647 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_hex_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45747 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2632: /* literal: BIN_NUM  */
#line 15653 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)= new (thd->mem_root) Item_bin_string(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 45757 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2633: /* literal: UNDERSCORE_CHARSET hex_or_bin_String  */
#line 15659 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Item_string_with_introducer *item_str;
            /*
              Pass NULL as name. Name will be set in the "select_item" rule and
              will include the introducer and the original hex/bin notation.
            */
            item_str= new (thd->mem_root)
               Item_string_with_introducer(thd, NULL, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(),
                                           (yyvsp[-1].charset));
            if (unlikely(!item_str ||
                         !item_str->check_well_formed_result(true)))
              MYSQL_YYABORT;

            (yyval.item)= item_str;
          }
#line 45777 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2634: /* NUM_literal: NUM  */
#line 15678 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2635: /* NUM_literal: LONG_NUM  */
#line 15688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            int error;
            (yyval.item_num)= new (thd->mem_root)
                  Item_int(thd, (yyvsp[0].lex_str).str,
                           (longlong) my_strtoll10((yyvsp[0].lex_str).str, NULL, &error),
                           (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45805 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2636: /* NUM_literal: ULONGLONG_NUM  */
#line 15698 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_uint(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL))
              MYSQL_YYABORT;
          }
#line 45815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2637: /* NUM_literal: DECIMAL_NUM  */
#line 15704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_decimal(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length,
                                                   thd->charset());
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 45826 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2638: /* NUM_literal: FLOAT_NUM  */
#line 15711 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item_num)= new (thd->mem_root) Item_float(thd, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            if (unlikely((yyval.item_num) == NULL) || unlikely(thd->is_error()))
              MYSQL_YYABORT;
          }
#line 45836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2639: /* temporal_literal: DATE_SYM TEXT_STRING  */
#line 15721 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_newdate.create_literal_item(thd,
                                                           (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                           YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45847 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2640: /* temporal_literal: TIME_SYM TEXT_STRING  */
#line 15728 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_time2.create_literal_item(thd,
                                                         (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                         YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2641: /* temporal_literal: TIMESTAMP TEXT_STRING  */
#line 15735 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= type_handler_datetime2.create_literal_item(thd,
                                                             (yyvsp[0].lex_string_with_metadata).str, (yyvsp[0].lex_string_with_metadata).length,
                                                             YYCSCL, true))))
              MYSQL_YYABORT;
          }
#line 45869 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2642: /* $@241: %empty  */
#line 15745 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
             LEX *lex= Lex;
             With_clause *with_clause=
             new With_clause((yyvsp[0].num), Lex->curr_with_clause);
             if (unlikely(with_clause == NULL))
               MYSQL_YYABORT;
             lex->derived_tables|= DERIVED_WITH;
             lex->with_cte_resolution= true;
             lex->curr_with_clause= with_clause;
             with_clause->add_to_list(&lex->with_clauses_list,
                                      lex->with_clauses_list_last_next);
             if (lex->current_select &&
                 lex->current_select->parsing_place == BEFORE_OPT_LIST)
               lex->current_select->parsing_place= NO_MATTER;
          }
#line 45889 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2643: /* with_clause: WITH opt_recursive $@241 with_list  */
#line 15761 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.with_clause)= Lex->curr_with_clause;
            Lex->curr_with_clause= Lex->curr_with_clause->pop();
          }
#line 45898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2644: /* opt_recursive: %empty  */
#line 15769 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)= 0; }
#line 45904 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2645: /* opt_recursive: RECURSIVE_SYM  */
#line 15770 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.num)= 1; }
#line 45910 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2648: /* $@242: %empty  */
#line 15783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyvsp[0].lex_str_list)= new List<LEX_CSTRING> (Lex->with_column_list);
            if (unlikely((yyvsp[0].lex_str_list) == NULL))
              MYSQL_YYABORT;
            Lex->with_column_list.empty();
          }
#line 45921 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2649: /* with_list_element: with_element_head opt_with_column_list $@242 AS '(' query_expression ')'  */
#line 15790 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            const char *query_start= lex->sphead ? lex->sphead->m_tmp_query
                                                 : thd->query();
            const char *spec_start= (yyvsp[-2].kwd).pos() + 1;
            With_element *elem= new With_element((yyvsp[-6].with_element_head), *(yyvsp[-5].lex_str_list), (yyvsp[-1].select_lex_unit));
	    if (elem == NULL || Lex->curr_with_clause->add_with_element(elem))
	      MYSQL_YYABORT;
            if (elem->set_unparsed_spec(thd, spec_start, (yyvsp[0].kwd).pos(),
                                        spec_start - query_start))
              MYSQL_YYABORT;
            elem->set_tables_end_pos(lex->query_tables_last);
	  }
#line 45939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2650: /* opt_with_column_list: %empty  */
#line 15808 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.lex_str_list)= NULL; }
#line 45945 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2651: /* opt_with_column_list: '(' with_column_list ')'  */
#line 15810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.lex_str_list)= NULL; }
#line 45951 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2652: /* with_column_list: ident  */
#line 15816 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
	  }
#line 45960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2653: /* with_column_list: with_column_list ',' ident  */
#line 15821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->with_column_list.push_back((LEX_CSTRING*)
                    thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)));
          }
#line 45969 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2654: /* with_element_head: ident  */
#line 15830 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING *name=
              (LEX_CSTRING *) thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING));
            (yyval.with_element_head)= new (thd->mem_root) With_element_head(name);
            if (unlikely(name == NULL || (yyval.with_element_head) == NULL))
              MYSQL_YYABORT;
            (yyval.with_element_head)->tables_pos.set_start_pos(Lex->query_tables_last);
          }
#line 45982 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2655: /* insert_ident: simple_ident_nospvar  */
#line 15847 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                               { (yyval.item)=(yyvsp[0].item); }
#line 45988 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2656: /* insert_ident: table_wild  */
#line 15848 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.item)=(yyvsp[0].item); }
#line 45994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2657: /* table_wild: ident '.' '*'  */
#line 15853 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46003 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2658: /* table_wild: ident '.' ident '.' '*'  */
#line 15858 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2659: /* select_sublist_qualified_asterisk: ident_cli '.' '*'  */
#line 15866 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46021 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2660: /* select_sublist_qualified_asterisk: ident_cli '.' ident_cli '.' '*'  */
#line 15871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_qualified_asterisk(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2661: /* order_ident: expr  */
#line 15878 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 46036 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2662: /* simple_ident: ident_cli  */
#line 15884 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2663: /* simple_ident: ident_cli '.' ident_cli  */
#line 15889 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2664: /* simple_ident: '.' ident_cli '.' ident_cli  */
#line 15894 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_ident_cli empty((yyvsp[-2].ident_cli).pos(), 0);
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &empty, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46064 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2665: /* simple_ident: ident_cli '.' ident_cli '.' ident_cli  */
#line 15900 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_cli), &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46073 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2666: /* simple_ident: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15905 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46082 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2667: /* simple_ident_nospvar: ident  */
#line 15913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nosp(thd, &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46091 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2668: /* simple_ident_nospvar: ident '.' ident  */
#line 15918 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident_nospvar(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46100 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2669: /* simple_ident_nospvar: COLON_ORACLE_SYM ident_cli '.' ident_cli  */
#line 15923 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->make_item_colon_ident_ident(thd, &(yyvsp[-2].ident_cli), &(yyvsp[0].ident_cli)))))
              MYSQL_YYABORT;
          }
#line 46109 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2670: /* simple_ident_nospvar: '.' ident '.' ident  */
#line 15928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex_ident_sys none;
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &none, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46119 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2671: /* simple_ident_nospvar: ident '.' ident '.' ident  */
#line 15934 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.item)= Lex->create_item_ident(thd, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys)))))
              MYSQL_YYABORT;
          }
#line 46128 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2672: /* field_ident: ident  */
#line 15941 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46134 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2673: /* field_ident: ident '.' ident '.' ident  */
#line 15943 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-4].ident_sys).str,
                                       table->db.str)))
              my_yyabort_error((ER_WRONG_DB_NAME, MYF(0), (yyvsp[-4].ident_sys).str));
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                                       table->table_name.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46149 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2674: /* field_ident: ident '.' ident  */
#line 15954 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            TABLE_LIST *table= Select->table_list.first;
            if (unlikely(my_strcasecmp(table_alias_charset, (yyvsp[-2].ident_sys).str,
                         table->alias.str)))
              my_yyabort_error((ER_WRONG_TABLE_NAME, MYF(0), (yyvsp[-2].ident_sys).str));
            (yyval.lex_str)=(yyvsp[0].ident_sys);
          }
#line 46161 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2675: /* field_ident: '.' ident  */
#line 15961 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46167 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2676: /* table_ident: ident  */
#line 15966 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46177 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2677: /* table_ident: ident '.' ident  */
#line 15972 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-2].ident_sys), &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46187 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2678: /* table_ident: '.' ident  */
#line 15978 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /* For Delphi */
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[0].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46198 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2679: /* table_ident_opt_wild: ident opt_wild  */
#line 15988 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(&(yyvsp[-1].ident_sys));
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2680: /* table_ident_opt_wild: ident '.' ident opt_wild  */
#line 15994 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &(yyvsp[-3].ident_sys), &(yyvsp[-1].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46218 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2681: /* table_ident_nodb: ident  */
#line 16003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING db={(char*) any_db,3};
            (yyval.table)= new (thd->mem_root) Table_ident(thd, &db, &(yyvsp[0].ident_sys), 0);
            if (unlikely((yyval.table) == NULL))
              MYSQL_YYABORT;
          }
#line 46229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2686: /* ident_cli: keyword_ident  */
#line 16019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { (yyval.ident_cli)= (yyvsp[0].kwd); }
#line 46235 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2687: /* IDENT_sys: IDENT_cli  */
#line 16024 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(thd->to_ident_sys_alloc(&(yyval.ident_sys), &(yyvsp[0].ident_cli))))
              MYSQL_YYABORT;
          }
#line 46244 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2688: /* TEXT_STRING_sys: TEXT_STRING  */
#line 16032 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_sys(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46253 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2689: /* TEXT_STRING_literal: TEXT_STRING  */
#line 16040 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_connection(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46262 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2690: /* TEXT_STRING_filesystem: TEXT_STRING  */
#line 16048 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (thd->make_text_string_filesystem(&(yyval.lex_str), &(yyvsp[0].lex_string_with_metadata)))
              MYSQL_YYABORT;
          }
#line 46271 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2692: /* ident_table_alias: keyword_table_alias  */
#line 16057 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46280 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2694: /* ident_set_usual_case: keyword_set_usual_case  */
#line 16066 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46289 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2696: /* ident_sysvar_name: keyword_sysvar_name  */
#line 16075 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46298 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2697: /* ident_sysvar_name: TEXT_STRING_sys  */
#line 16080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_sys(thd, &(yyvsp[0].lex_str))))
              MYSQL_YYABORT;
          }
#line 46307 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2699: /* ident: keyword_ident  */
#line 16090 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46316 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2701: /* ident_directly_assignable: keyword_directly_assignable  */
#line 16099 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46325 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2703: /* label_ident: keyword_label  */
#line 16109 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely((yyval.ident_sys).copy_keyword(thd, &(yyvsp[0].kwd))))
              MYSQL_YYABORT;
          }
#line 46334 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2704: /* labels_declaration_oracle: label_declaration_oracle  */
#line 16116 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 46340 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2705: /* labels_declaration_oracle: labels_declaration_oracle label_declaration_oracle  */
#line 16117 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                                             { (yyval.lex_str)= (yyvsp[0].lex_str); }
#line 46346 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2706: /* label_declaration_oracle: SHIFT_LEFT label_ident SHIFT_RIGHT  */
#line 16122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_push_goto_label(thd, &(yyvsp[-1].ident_sys))))
              MYSQL_YYABORT;
            (yyval.lex_str)= (yyvsp[-1].ident_sys);
          }
#line 46356 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2707: /* ident_or_text: ident  */
#line 16130 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].ident_sys);}
#line 46362 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2708: /* ident_or_text: TEXT_STRING_sys  */
#line 16131 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46368 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2709: /* ident_or_text: LEX_HOSTNAME  */
#line 16132 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.lex_str)=(yyvsp[0].lex_str);}
#line 46374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2710: /* user_maybe_role: ident_or_text  */
#line 16137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  system_charset_info, 0)))
              MYSQL_YYABORT;
          }
#line 46389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2711: /* user_maybe_role: ident_or_text '@' ident_or_text  */
#line 16148 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user = (yyvsp[-2].lex_str); (yyval.lex_user)->host=(yyvsp[0].lex_str);

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                 system_charset_info, 0)) ||
                unlikely(check_host_name(&(yyval.lex_user)->host)))
              MYSQL_YYABORT;
            if ((yyval.lex_user)->host.str[0])
            {
              /*
                Convert hostname part of username to lowercase.
                It's OK to use in-place lowercase as long as
                the character set is utf8.
              */
              my_casedn_str(system_charset_info, (char*) (yyval.lex_user)->host.str);
            }
            else
            {
              /*
                fix historical undocumented convention that empty host is the
                same as '%'
              */
              (yyval.lex_user)->host= host_not_specified;
            }
          }
#line 46422 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2712: /* user_maybe_role: CURRENT_USER optional_braces  */
#line 16177 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*)thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_user;
            (yyval.lex_user)->auth= new (thd->mem_root) USER_AUTH();
          }
#line 46433 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 2715: /* user: user_maybe_role  */
#line 16188 "/home/buildbot/git/sql/sql_yacc_ora.yy"
         {
           if ((yyvsp[0].lex_user)->user.str != current_user.str && (yyvsp[0].lex_user)->host.str == 0)
             (yyvsp[0].lex_user)->host= host_not_specified;
           (yyval.lex_user)= (yyvsp[0].lex_user);
         }
#line 46443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3203: /* $@243: %empty  */
#line 16811 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->main_select_push(true))
              MYSQL_YYABORT;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46457 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3204: /* set: SET $@243 start_option_value_list  */
#line 16821 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46467 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3205: /* $@244: %empty  */
#line 16827 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
            Lex->set_stmt_init();
          }
#line 46477 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3206: /* $@245: %empty  */
#line 16833 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->table_or_sp_used()))
              my_yyabort_error((ER_SUBQUERIES_NOT_SUPPORTED, MYF(0), "SET STATEMENT"));
            lex->stmt_var_list= lex->var_list;
            lex->var_list.empty();
            Lex->pop_select(); //main select
            if (Lex->check_main_unit_semantics())
              MYSQL_YYABORT;
          }
#line 46492 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3207: /* set: SET STATEMENT_SYM $@244 set_stmt_option_value_following_option_type_list $@245 FOR_SYM verb_clause  */
#line 16844 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 46498 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3208: /* $@246: %empty  */
#line 16849 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_stmt_init();
            lex->var_list.empty();
            if(sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46510 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3209: /* set_assign: ident_directly_assignable SET_VAR $@246 set_expr_or_default  */
#line 16857 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46520 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3210: /* $@247: %empty  */
#line 16863 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46532 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3211: /* set_assign: ident_directly_assignable '.' ident SET_VAR $@247 set_expr_or_default  */
#line 16871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            DBUG_ASSERT(lex->var_list.is_empty());
            if (unlikely(lex->set_variable(&(yyvsp[-5].ident_sys), &(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(lex->sphead->restore_lex(thd)))
              MYSQL_YYABORT;
          }
#line 46544 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3212: /* $@248: %empty  */
#line 16879 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(!lex->is_trigger_new_or_old_reference(&(yyvsp[-3].ident_sys))))
            {
              thd->parse_error(ER_SYNTAX_ERROR, (yyvsp[-4].kwd).pos());
              MYSQL_YYABORT;
            }
            lex->set_stmt_init();
            lex->var_list.empty();
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46561 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3213: /* set_assign: COLON_ORACLE_SYM ident '.' ident SET_VAR $@248 set_expr_or_default  */
#line 16892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX_CSTRING tmp= { (yyvsp[-5].ident_sys).str, (yyvsp[-5].ident_sys).length };
            if (unlikely(Lex->set_trigger_field(&tmp, &(yyvsp[-3].ident_sys), (yyvsp[0].item))) ||
                unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46572 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3216: /* $@249: %empty  */
#line 16913 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46581 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3218: /* $@250: %empty  */
#line 16919 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= OPT_DEFAULT;
          }
#line 46589 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3219: /* start_option_value_list: TRANSACTION_SYM $@250 transaction_characteristics  */
#line 16923 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46598 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3220: /* $@251: %empty  */
#line 16928 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46606 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3222: /* $@252: %empty  */
#line 16938 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46615 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3224: /* start_option_value_list_following_option_type: TRANSACTION_SYM transaction_characteristics  */
#line 16944 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46624 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3227: /* $@253: %empty  */
#line 16958 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46633 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3228: /* option_value_list: $@253 option_value  */
#line 16963 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3229: /* $@254: %empty  */
#line 16968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (sp_create_assignment_lex(thd, yychar == YYEMPTY))
              MYSQL_YYABORT;
          }
#line 46651 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3230: /* option_value_list: option_value_list ',' $@254 option_value  */
#line 16973 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(sp_create_assignment_instr(thd, yychar == YYEMPTY)))
              MYSQL_YYABORT;
          }
#line 46660 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3231: /* $@255: %empty  */
#line 16982 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->option_type= (yyvsp[0].var_type);
          }
#line 46668 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3234: /* option_type: GLOBAL_SYM  */
#line 16990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46674 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3235: /* option_type: LOCAL_SYM  */
#line 16991 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46680 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3236: /* option_type: SESSION_SYM  */
#line 16992 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46686 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3237: /* opt_var_type: %empty  */
#line 16996 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3238: /* opt_var_type: GLOBAL_SYM  */
#line 16997 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_GLOBAL; }
#line 46698 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3239: /* opt_var_type: LOCAL_SYM  */
#line 16998 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46704 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3240: /* opt_var_type: SESSION_SYM  */
#line 16999 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.var_type)=OPT_SESSION; }
#line 46710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3241: /* opt_var_ident_type: %empty  */
#line 17003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_DEFAULT; }
#line 46716 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3242: /* opt_var_ident_type: GLOBAL_SYM '.'  */
#line 17004 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_GLOBAL; }
#line 46722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3243: /* opt_var_ident_type: LOCAL_SYM '.'  */
#line 17005 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3244: /* opt_var_ident_type: SESSION_SYM '.'  */
#line 17006 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          { (yyval.var_type)=OPT_SESSION; }
#line 46734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3245: /* option_value_following_option_type: ident equal set_expr_or_default  */
#line 17012 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46743 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3246: /* option_value_following_option_type: ident '.' ident equal set_expr_or_default  */
#line 17017 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, Lex->option_type, &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46752 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3247: /* option_value_following_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 17022 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46761 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3248: /* option_value_no_option_type: ident_set_usual_case equal set_expr_or_default  */
#line 17031 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3249: /* option_value_no_option_type: ident '.' ident equal set_expr_or_default  */
#line 17036 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46779 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3250: /* option_value_no_option_type: DEFAULT '.' ident equal set_expr_or_default  */
#line 17041 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable(Lex->option_type, &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46788 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3251: /* option_value_no_option_type: '@' ident_or_text equal expr  */
#line 17046 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_user_variable(thd, &(yyvsp[-2].lex_str), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46797 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3252: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name equal set_expr_or_default  */
#line 17051 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable((yyvsp[-3].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46806 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3253: /* option_value_no_option_type: '@' '@' opt_var_ident_type ident_sysvar_name '.' ident equal set_expr_or_default  */
#line 17056 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_system_variable(thd, (yyvsp[-5].var_type), &(yyvsp[-4].ident_sys), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46815 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3254: /* option_value_no_option_type: '@' '@' opt_var_ident_type DEFAULT '.' ident equal set_expr_or_default  */
#line 17061 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_default_system_variable((yyvsp[-5].var_type), &(yyvsp[-2].ident_sys), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3255: /* option_value_no_option_type: charset old_or_new_charset_name_or_default  */
#line 17066 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            CHARSET_INFO *cs2;
            cs2= (yyvsp[0].charset) ? (yyvsp[0].charset): global_system_variables.character_set_client;
            set_var_collation_client *var;
            var= (new (thd->mem_root)
                  set_var_collation_client(cs2,
                                           thd->variables.collation_database,
                                            cs2));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            lex->var_list.push_back(var, thd->mem_root);
          }
#line 46842 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3256: /* option_value_no_option_type: NAMES_SYM equal expr  */
#line 17080 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING names= { STRING_WITH_LEN("names") };
            if (unlikely(spc && spc->find_variable(&names, false)))
              my_error(ER_SP_BAD_VAR_SHADOW, MYF(0), names.str);
            else
              thd->parse_error();
            MYSQL_YYABORT;
          }
#line 46857 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3257: /* option_value_no_option_type: NAMES_SYM charset_name_or_default opt_collate  */
#line 17091 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            CHARSET_INFO *cs2;
            CHARSET_INFO *cs3;
            cs2= (yyvsp[-1].charset) ? (yyvsp[-1].charset) : global_system_variables.character_set_client;
            cs3= (yyvsp[0].charset) ? (yyvsp[0].charset) : cs2;
            if (unlikely(!my_charset_same(cs2, cs3)))
            {
              my_error(ER_COLLATION_CHARSET_MISMATCH, MYF(0),
                       cs3->name, cs2->csname);
              MYSQL_YYABORT;
            }
            set_var_collation_client *var;
            var= new (thd->mem_root) set_var_collation_client(cs3, cs3, cs3);
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46880 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3258: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role  */
#line 17110 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            LEX_USER *user;
            if (unlikely(!(user=(LEX_USER *) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            user->user= current_user;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role(user,
                                                             (yyvsp[0].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;

            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3259: /* option_value_no_option_type: DEFAULT ROLE_SYM grant_role FOR_SYM user  */
#line 17128 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_default_role *var= (new (thd->mem_root)
                                        set_var_default_role((yyvsp[0].lex_user), (yyvsp[-2].lex_user)->user));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            thd->lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46918 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3260: /* option_value_no_option_type: ROLE_SYM ident_or_text  */
#line 17140 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_role *var= new (thd->mem_root) set_var_role((yyvsp[0].lex_str));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46930 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3261: /* option_value_no_option_type: ROLE_SYM equal set_expr_or_default  */
#line 17148 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->set_variable(&(yyvsp[-2].kwd), (yyvsp[0].item))))
              MYSQL_YYABORT;
          }
#line 46939 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3262: /* option_value_no_option_type: PASSWORD_SYM opt_for_user text_or_password  */
#line 17153 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex = Lex;
            set_var_password *var= (new (thd->mem_root)
                                    set_var_password(lex->definer));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
            lex->autocommit= TRUE;
            if (lex->sphead)
              lex->sphead->m_flags|= sp_head::HAS_SET_AUTOCOMMIT_STMT;
          }
#line 46955 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3267: /* transaction_access_mode: transaction_access_mode_types  */
#line 17176 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].num));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_read_only"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL))
              MYSQL_YYABORT;
            if (unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46975 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3268: /* isolation_level: ISOLATION LEVEL_SYM isolation_types  */
#line 17195 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            Item *item= new (thd->mem_root) Item_int(thd, (int32) (yyvsp[0].tx_isolation));
            if (unlikely(item == NULL))
              MYSQL_YYABORT;
            set_var *var= (new (thd->mem_root)
                           set_var(thd, lex->option_type,
                                   find_sys_var(thd, "tx_isolation"),
                                   &null_clex_str,
                                   item));
            if (unlikely(var == NULL) ||
                unlikely(lex->var_list.push_back(var, thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 46994 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3269: /* transaction_access_mode_types: READ_SYM ONLY_SYM  */
#line 17212 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { (yyval.num)= true; }
#line 47000 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3270: /* transaction_access_mode_types: READ_SYM WRITE_SYM  */
#line 17213 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.num)= false; }
#line 47006 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3271: /* isolation_types: READ_SYM UNCOMMITTED_SYM  */
#line 17217 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_READ_UNCOMMITTED; }
#line 47012 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3272: /* isolation_types: READ_SYM COMMITTED_SYM  */
#line 17218 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_READ_COMMITTED; }
#line 47018 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3273: /* isolation_types: REPEATABLE_SYM READ_SYM  */
#line 17219 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_REPEATABLE_READ; }
#line 47024 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3274: /* isolation_types: SERIALIZABLE_SYM  */
#line 17220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.tx_isolation)= ISO_SERIALIZABLE; }
#line 47030 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3275: /* opt_for_user: equal  */
#line 17225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            sp_pcontext *spc= lex->spcont;
            LEX_CSTRING pw= { STRING_WITH_LEN("password") };

            if (unlikely(spc && spc->find_variable(&pw, false)))
              my_yyabort_error((ER_SP_BAD_VAR_SHADOW, MYF(0), pw.str));
            if (unlikely(!(lex->definer= (LEX_USER*)
                           thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            lex->definer->user= current_user;
            lex->definer->auth= new (thd->mem_root) USER_AUTH();
          }
#line 47048 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3276: /* opt_for_user: FOR_SYM user equal  */
#line 17238 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { Lex->definer= (yyvsp[-1].lex_user); }
#line 47054 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3277: /* text_or_password: TEXT_STRING  */
#line 17243 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 47063 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3278: /* text_or_password: PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17248 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
          }
#line 47072 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3279: /* text_or_password: OLD_PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17253 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer->auth= new (thd->mem_root) USER_AUTH();
            Lex->definer->auth->pwtext= (yyvsp[-1].lex_string_with_metadata);
            Lex->definer->auth->auth_str.str= Item_func_password::alloc(thd,
                                   (yyvsp[-1].lex_string_with_metadata).str, (yyvsp[-1].lex_string_with_metadata).length, Item_func_password::OLD);
            Lex->definer->auth->auth_str.length=  SCRAMBLED_PASSWORD_CHAR_LENGTH_323;
          }
#line 47084 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3280: /* set_expr_or_default: expr  */
#line 17263 "/home/buildbot/git/sql/sql_yacc_ora.yy"
               { (yyval.item)=(yyvsp[0].item); }
#line 47090 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3281: /* set_expr_or_default: DEFAULT  */
#line 17264 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.item)=0; }
#line 47096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3282: /* set_expr_or_default: ON  */
#line 17266 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ON",  2);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47106 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3283: /* set_expr_or_default: ALL  */
#line 17272 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "ALL", 3);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47116 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3284: /* set_expr_or_default: BINARY  */
#line 17278 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.item)=new (thd->mem_root) Item_string_sys(thd, "binary", 6);
            if (unlikely((yyval.item) == NULL))
              MYSQL_YYABORT;
          }
#line 47126 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3285: /* $@256: %empty  */
#line 17289 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "LOCK"));
            lex->sql_command= SQLCOM_LOCK_TABLES;
          }
#line 47138 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3286: /* lock: LOCK_SYM table_or_tables $@256 table_lock_list opt_lock_wait_timeout  */
#line 17297 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47144 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3287: /* opt_lock_wait_timeout: %empty  */
#line 17302 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {}
#line 47150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3288: /* opt_lock_wait_timeout: WAIT_SYM ulong_num  */
#line 17304 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), (yyvsp[0].ulong_num))) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), (yyvsp[0].ulong_num))))
            MYSQL_YYABORT;
        }
#line 47160 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3289: /* opt_lock_wait_timeout: NOWAIT_SYM  */
#line 17310 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("lock_wait_timeout"), 0)) ||
              unlikely(set_statement_var_if_exists(thd, STRING_WITH_LEN("innodb_lock_wait_timeout"), 0)))
            MYSQL_YYABORT;
        }
#line 47170 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3290: /* table_or_tables: TABLE_SYM  */
#line 17318 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { }
#line 47176 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3291: /* table_or_tables: TABLES  */
#line 17319 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { }
#line 47182 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3294: /* table_lock: table_ident opt_table_alias_clause lock_option  */
#line 17329 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            thr_lock_type lock_type= (thr_lock_type) (yyvsp[0].num);
            bool lock_for_write= (lock_type >= TL_WRITE_ALLOW_WRITE);
            ulong table_options= lock_for_write ? TL_OPTION_UPDATING : 0;
            enum_mdl_type mdl_type= !lock_for_write
                                    ? MDL_SHARED_READ
                                    : lock_type == TL_WRITE_CONCURRENT_INSERT
                                      ? MDL_SHARED_WRITE
                                      : MDL_SHARED_NO_READ_WRITE;

            if (unlikely(!Lex->current_select_or_default()->
                         add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[-1].lex_str_ptr), table_options,
                                           lock_type, mdl_type)))
              MYSQL_YYABORT;
          }
#line 47202 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3295: /* lock_option: READ_SYM  */
#line 17347 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_READ_NO_INSERT; }
#line 47208 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3296: /* lock_option: WRITE_SYM  */
#line 17348 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_WRITE_DEFAULT; }
#line 47214 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3297: /* lock_option: WRITE_SYM CONCURRENT  */
#line 17350 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.num)= (Lex->sphead ? TL_WRITE_DEFAULT : TL_WRITE_CONCURRENT_INSERT);
          }
#line 47222 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3298: /* lock_option: LOW_PRIORITY WRITE_SYM  */
#line 17354 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_WRITE_LOW_PRIORITY; }
#line 47228 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3299: /* lock_option: READ_SYM LOCAL_SYM  */
#line 17355 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 { (yyval.num)= TL_READ; }
#line 47234 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3300: /* $@257: %empty  */
#line 17360 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "UNLOCK"));
            lex->sql_command= SQLCOM_UNLOCK_TABLES;
          }
#line 47246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3301: /* unlock: UNLOCK_SYM $@257 table_or_tables  */
#line 17368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47252 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3302: /* $@258: %empty  */
#line 17377 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->main_select_push())
              MYSQL_YYABORT;
          }
#line 47261 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3303: /* handler: HANDLER_SYM $@258 handler_tail  */
#line 17382 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->pop_select(); //main select
          }
#line 47269 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3304: /* handler_tail: table_ident OPEN_SYM opt_table_alias_clause  */
#line 17389 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_OPEN;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-2].table), (yyvsp[0].lex_str_ptr), 0))
              MYSQL_YYABORT;
          }
#line 47282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3305: /* handler_tail: table_ident_nodb CLOSE_SYM  */
#line 17398 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->sql_command = SQLCOM_HA_CLOSE;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47295 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3306: /* $@259: %empty  */
#line 17407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_BADSTATEMENT, MYF(0), "HANDLER"));
            lex->clause_that_disallows_subselect= "HANDLER..READ";
            lex->sql_command = SQLCOM_HA_READ;
            lex->ha_rkey_mode= HA_READ_KEY_EXACT; /* Avoid purify warnings */
            Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
            if (unlikely(one == NULL))
              MYSQL_YYABORT;
            lex->current_select->select_limit= one;
            lex->current_select->offset_limit= 0;
            lex->limit_rows_examined= 0;
            if (!lex->current_select->add_table_to_list(thd, (yyvsp[-1].table), 0, 0))
              MYSQL_YYABORT;
          }
#line 47316 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3307: /* handler_tail: table_ident_nodb READ_SYM $@259 handler_read_or_scan opt_where_clause opt_global_limit_clause  */
#line 17424 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->clause_that_disallows_subselect= NULL;
            if (!lex->current_select->explicit_limit)
            {
              Item *one= new (thd->mem_root) Item_int(thd, (int32) 1);
              if (one == NULL)
                MYSQL_YYABORT;
              lex->current_select->select_limit= one;
              lex->current_select->offset_limit= 0;
              lex->limit_rows_examined= 0;
            }
            /* Stored functions are not supported for HANDLER READ. */
            if (lex->uses_stored_routines())
            {
              my_error(ER_NOT_SUPPORTED_YET, MYF(0),
                       "stored functions in HANDLER ... READ");
              MYSQL_YYABORT;
            }
          }
#line 47341 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3308: /* handler_read_or_scan: handler_scan_function  */
#line 17447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->ident= null_clex_str; }
#line 47347 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3309: /* handler_read_or_scan: ident handler_rkey_function  */
#line 17448 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->ident= (yyvsp[-1].ident_sys); }
#line 47353 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3310: /* handler_scan_function: FIRST_SYM  */
#line 17452 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47359 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3311: /* handler_scan_function: NEXT_SYM  */
#line 17453 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47365 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3312: /* handler_rkey_function: FIRST_SYM  */
#line 17457 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RFIRST; }
#line 47371 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3313: /* handler_rkey_function: NEXT_SYM  */
#line 17458 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RNEXT;  }
#line 47377 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3314: /* handler_rkey_function: PREV_SYM  */
#line 17459 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RPREV;  }
#line 47383 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3315: /* handler_rkey_function: LAST_SYM  */
#line 17460 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { Lex->ha_read_mode = RLAST;  }
#line 47389 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3316: /* $@260: %empty  */
#line 17462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->ha_read_mode = RKEY;
            lex->ha_rkey_mode=(yyvsp[0].ha_rkey_mode);
            if (unlikely(!(lex->insert_list= new (thd->mem_root) List_item)))
              MYSQL_YYABORT;
          }
#line 47401 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3317: /* handler_rkey_function: handler_rkey_mode $@260 '(' values ')'  */
#line 17470 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47407 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3318: /* handler_rkey_mode: '='  */
#line 17474 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_KEY_EXACT;   }
#line 47413 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3319: /* handler_rkey_mode: GE  */
#line 17475 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_NEXT; }
#line 47419 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3320: /* handler_rkey_mode: LE  */
#line 17476 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                 { (yyval.ha_rkey_mode)=HA_READ_KEY_OR_PREV; }
#line 47425 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3321: /* handler_rkey_mode: '>'  */
#line 17477 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { (yyval.ha_rkey_mode)=HA_READ_AFTER_KEY;   }
#line 47431 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3322: /* handler_rkey_mode: '<'  */
#line 17478 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  { (yyval.ha_rkey_mode)=HA_READ_BEFORE_KEY;  }
#line 47437 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3323: /* revoke: REVOKE clear_privileges revoke_command  */
#line 17485 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47443 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3324: /* revoke_command: grant_privileges ON opt_table grant_ident FROM user_and_role_list  */
#line 17490 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= 0;
          }
#line 47453 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3325: /* revoke_command: grant_privileges ON FUNCTION_SYM grant_ident FROM user_and_role_list  */
#line 17496 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47463 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3326: /* revoke_command: grant_privileges ON PROCEDURE_SYM grant_ident FROM user_and_role_list  */
#line 17502 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                         TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47473 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3327: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47483 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3328: /* revoke_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident FROM user_and_role_list  */
#line 17516 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_REVOKE,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47493 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3329: /* revoke_command: ALL opt_privileges ',' GRANT OPTION FROM user_and_role_list  */
#line 17522 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_REVOKE_ALL;
          }
#line 47501 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3330: /* revoke_command: PROXY_SYM ON user FROM user_list  */
#line 17526 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-2].lex_user));
            lex->sql_command= SQLCOM_REVOKE;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3331: /* revoke_command: admin_option_for_role FROM user_and_role_list  */
#line 17533 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_REVOKE_ROLE;
            if (unlikely(Lex->users_list.push_front((yyvsp[-2].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47522 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3332: /* admin_option_for_role: ADMIN_SYM OPTION FOR_SYM grant_role  */
#line 17542 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->with_admin_option= true; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47528 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3333: /* admin_option_for_role: grant_role  */
#line 17544 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        { Lex->with_admin_option= false; (yyval.lex_user)= (yyvsp[0].lex_user); }
#line 47534 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3334: /* grant: GRANT clear_privileges grant_command  */
#line 17549 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 47540 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3335: /* grant_command: grant_privileges ON opt_table grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17555 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT;
            lex->type= 0;
          }
#line 47550 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3336: /* grant_command: grant_privileges ON FUNCTION_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17562 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_FUNCTION)))
              MYSQL_YYABORT;
          }
#line 47560 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3337: /* grant_command: grant_privileges ON PROCEDURE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17569 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PROCEDURE)))
              MYSQL_YYABORT;
          }
#line 47570 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3338: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17576 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE)))
              MYSQL_YYABORT;
          }
#line 47580 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3339: /* grant_command: grant_privileges ON PACKAGE_ORACLE_SYM BODY_ORACLE_SYM grant_ident TO_SYM grant_list opt_require_clause opt_grant_options  */
#line 17583 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_grant_command(thd, SQLCOM_GRANT,
                                                TYPE_ENUM_PACKAGE_BODY)))
              MYSQL_YYABORT;
          }
#line 47590 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3340: /* grant_command: PROXY_SYM ON user TO_SYM grant_list opt_grant_option  */
#line 17589 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->users_list.push_front ((yyvsp[-3].lex_user));
            lex->sql_command= SQLCOM_GRANT;
            lex->type= TYPE_ENUM_PROXY;
          }
#line 47601 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3341: /* grant_command: grant_role TO_SYM grant_list opt_with_admin_option  */
#line 17596 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->sql_command= SQLCOM_GRANT_ROLE;
            /* The first role is the one that is granted */
            if (unlikely(Lex->users_list.push_front((yyvsp[-3].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47613 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3342: /* opt_with_admin: %empty  */
#line 17607 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->definer = 0; }
#line 47619 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3343: /* opt_with_admin: WITH ADMIN_SYM user_or_role  */
#line 17608 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->definer = (yyvsp[0].lex_user); }
#line 47625 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3344: /* opt_with_admin_option: %empty  */
#line 17612 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->with_admin_option= false; }
#line 47631 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3345: /* opt_with_admin_option: WITH ADMIN_SYM OPTION  */
#line 17613 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                      { Lex->with_admin_option= true; }
#line 47637 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3346: /* role_list: grant_role  */
#line 17618 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47646 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3347: /* role_list: role_list ',' grant_role  */
#line 17623 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 47655 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3348: /* current_role: CURRENT_ROLE optional_braces  */
#line 17631 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->calloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= current_role;
            (yyval.lex_user)->auth= NULL;
          }
#line 47666 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3349: /* grant_role: ident_or_text  */
#line 17641 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            CHARSET_INFO *cs= system_charset_info;
            /* trim end spaces (as they'll be lost in mysql.user anyway) */
            (yyvsp[0].lex_str).length= cs->cset->lengthsp(cs, (yyvsp[0].lex_str).str, (yyvsp[0].lex_str).length);
            ((char*) (yyvsp[0].lex_str).str)[(yyvsp[0].lex_str).length] = '\0';
            if (unlikely((yyvsp[0].lex_str).length == 0))
              my_yyabort_error((ER_INVALID_ROLE, MYF(0), ""));
            if (unlikely(!((yyval.lex_user)=(LEX_USER*) thd->alloc(sizeof(LEX_USER)))))
              MYSQL_YYABORT;
            (yyval.lex_user)->user= (yyvsp[0].lex_str);
            (yyval.lex_user)->host= empty_clex_str;
            (yyval.lex_user)->auth= NULL;

            if (unlikely(check_string_char_length(&(yyval.lex_user)->user, ER_USERNAME,
                                                  username_char_length,
                                                  cs, 0)))
              MYSQL_YYABORT;
          }
#line 47689 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3353: /* grant_privileges: object_privilege_list  */
#line 17668 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                {}
#line 47695 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3354: /* grant_privileges: ALL opt_privileges  */
#line 17670 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            Lex->all_privileges= 1; 
            Lex->grant= GLOBAL_ACLS;
          }
#line 47704 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3359: /* $@261: %empty  */
#line 17688 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = SELECT_ACL;}
#line 47710 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3360: /* object_privilege: SELECT_SYM $@261 opt_column_list  */
#line 17689 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47716 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3361: /* $@262: %empty  */
#line 17691 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = INSERT_ACL;}
#line 47722 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3362: /* object_privilege: INSERT $@262 opt_column_list  */
#line 17692 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47728 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3363: /* $@263: %empty  */
#line 17694 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = UPDATE_ACL; }
#line 47734 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3364: /* object_privilege: UPDATE_SYM $@263 opt_column_list  */
#line 17695 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47740 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3365: /* $@264: %empty  */
#line 17697 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->which_columns = REFERENCES_ACL;}
#line 47746 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3366: /* object_privilege: REFERENCES $@264 opt_column_list  */
#line 17698 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 47752 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3367: /* object_privilege: DELETE_SYM  */
#line 17699 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DELETE_ACL;}
#line 47758 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3368: /* object_privilege: USAGE  */
#line 17700 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  {}
#line 47764 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3369: /* object_privilege: INDEX_SYM  */
#line 17701 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= INDEX_ACL;}
#line 47770 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3370: /* object_privilege: ALTER  */
#line 17702 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= ALTER_ACL;}
#line 47776 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3371: /* object_privilege: CREATE  */
#line 17703 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_ACL;}
#line 47782 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3372: /* object_privilege: DROP  */
#line 17704 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DROP_ACL;}
#line 47788 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3373: /* object_privilege: EXECUTE_SYM  */
#line 17705 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= EXECUTE_ACL;}
#line 47794 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3374: /* object_privilege: RELOAD  */
#line 17706 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= RELOAD_ACL;}
#line 47800 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3375: /* object_privilege: SHUTDOWN  */
#line 17707 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHUTDOWN_ACL;}
#line 47806 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3376: /* object_privilege: PROCESS  */
#line 17708 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= PROCESS_ACL;}
#line 47812 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3377: /* object_privilege: FILE_SYM  */
#line 17709 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= FILE_ACL;}
#line 47818 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3378: /* object_privilege: GRANT OPTION  */
#line 17710 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= GRANT_ACL;}
#line 47824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3379: /* object_privilege: SHOW DATABASES  */
#line 17711 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHOW_DB_ACL;}
#line 47830 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3380: /* object_privilege: SUPER_SYM  */
#line 17712 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SUPER_ACL;}
#line 47836 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3381: /* object_privilege: CREATE TEMPORARY TABLES  */
#line 17713 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_TMP_ACL;}
#line 47842 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3382: /* object_privilege: LOCK_SYM TABLES  */
#line 17714 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= LOCK_TABLES_ACL; }
#line 47848 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3383: /* object_privilege: REPLICATION SLAVE  */
#line 17715 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= REPL_SLAVE_ACL; }
#line 47854 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3384: /* object_privilege: REPLICATION CLIENT_SYM  */
#line 17716 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= REPL_CLIENT_ACL; }
#line 47860 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3385: /* object_privilege: CREATE VIEW_SYM  */
#line 17717 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_VIEW_ACL; }
#line 47866 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3386: /* object_privilege: SHOW VIEW_SYM  */
#line 17718 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= SHOW_VIEW_ACL; }
#line 47872 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3387: /* object_privilege: CREATE ROUTINE_SYM  */
#line 17719 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_PROC_ACL; }
#line 47878 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3388: /* object_privilege: ALTER ROUTINE_SYM  */
#line 17720 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= ALTER_PROC_ACL; }
#line 47884 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3389: /* object_privilege: CREATE USER_SYM  */
#line 17721 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_USER_ACL; }
#line 47890 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3390: /* object_privilege: EVENT_SYM  */
#line 17722 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= EVENT_ACL;}
#line 47896 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3391: /* object_privilege: TRIGGER_SYM  */
#line 17723 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= TRIGGER_ACL; }
#line 47902 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3392: /* object_privilege: CREATE TABLESPACE  */
#line 17724 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= CREATE_TABLESPACE_ACL; }
#line 47908 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3393: /* object_privilege: DELETE_SYM HISTORY_SYM  */
#line 17725 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                  { Lex->grant |= DELETE_HISTORY_ACL; }
#line 47914 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3394: /* opt_and: %empty  */
#line 17729 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 47920 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3395: /* opt_and: AND_SYM  */
#line 17730 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                  {}
#line 47926 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3398: /* require_list_element: SUBJECT_SYM TEXT_STRING  */
#line 17740 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_subject.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "SUBJECT"));
            lex->account_options.x509_subject= (yyvsp[0].lex_string_with_metadata);
          }
#line 47937 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3399: /* require_list_element: ISSUER_SYM TEXT_STRING  */
#line 17747 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.x509_issuer.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "ISSUER"));
            lex->account_options.x509_issuer= (yyvsp[0].lex_string_with_metadata);
          }
#line 47948 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3400: /* require_list_element: CIPHER_SYM TEXT_STRING  */
#line 17754 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (lex->account_options.ssl_cipher.str)
              my_yyabort_error((ER_DUP_ARGUMENT, MYF(0), "CIPHER"));
            lex->account_options.ssl_cipher= (yyvsp[0].lex_string_with_metadata);
          }
#line 47959 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3401: /* grant_ident: '*'  */
#line 17764 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            if (unlikely(lex->copy_db_to(&lex->first_select_lex()->db)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47973 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3402: /* grant_ident: ident '.' '*'  */
#line 17774 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= (yyvsp[-2].ident_sys);
            if (lex->grant == GLOBAL_ACLS)
              lex->grant = DB_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47986 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3403: /* grant_ident: '*' '.' '*'  */
#line 17783 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->first_select_lex()->db= null_clex_str;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant= GLOBAL_ACLS & ~GRANT_ACL;
            else if (unlikely(lex->columns.elements))
              my_yyabort_error((ER_ILLEGAL_GRANT_FOR_TABLE, MYF(0)));
          }
#line 47999 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3404: /* grant_ident: table_ident  */
#line 17792 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            if (unlikely(!lex->first_select_lex()->
                         add_table_to_list(thd, (yyvsp[0].table),NULL,
                                           TL_OPTION_UPDATING)))
              MYSQL_YYABORT;
            if (lex->grant == GLOBAL_ACLS)
              lex->grant =  TABLE_ACLS & ~GRANT_ACL;
          }
#line 48013 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3405: /* user_list: user  */
#line 17805 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3406: /* user_list: user_list ',' user  */
#line 17810 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48031 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3407: /* grant_list: grant_user  */
#line 17818 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48040 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3408: /* grant_list: grant_list ',' grant_user  */
#line 17823 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48049 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3409: /* user_and_role_list: user_or_role  */
#line 17831 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48058 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3410: /* user_and_role_list: user_and_role_list ',' user_or_role  */
#line 17836 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->users_list.push_back((yyvsp[0].lex_user), thd->mem_root)))
              MYSQL_YYABORT;
          }
#line 48067 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3415: /* grant_user: user IDENTIFIED_SYM BY TEXT_STRING  */
#line 17847 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-3].lex_user)->auth->pwtext= (yyvsp[0].lex_string_with_metadata);
          }
#line 48077 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3416: /* grant_user: user IDENTIFIED_SYM BY PASSWORD_SYM TEXT_STRING  */
#line 17853 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { 
            (yyval.lex_user)= (yyvsp[-4].lex_user); 
            (yyvsp[-4].lex_user)->auth= new (thd->mem_root) USER_AUTH();
            (yyvsp[-4].lex_user)->auth->auth_str= (yyvsp[0].lex_string_with_metadata);
          }
#line 48087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3417: /* grant_user: user IDENTIFIED_SYM via_or_with auth_expression  */
#line 17859 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[-3].lex_user);
            (yyvsp[-3].lex_user)->auth= (yyvsp[0].user_auth);
          }
#line 48096 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3418: /* grant_user: user_or_role  */
#line 17864 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.lex_user)= (yyvsp[0].lex_user);
          }
#line 48104 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3419: /* auth_expression: auth_token OR_SYM auth_expression  */
#line 17871 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.user_auth)= (yyvsp[-2].user_auth);
            DBUG_ASSERT((yyval.user_auth)->next == NULL);
            (yyval.user_auth)->next= (yyvsp[0].user_auth);
          }
#line 48114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3420: /* auth_expression: auth_token  */
#line 17877 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            (yyval.user_auth)= (yyvsp[0].user_auth);
          }
#line 48122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3421: /* auth_token: ident_or_text opt_auth_str  */
#line 17884 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          (yyval.user_auth)= (yyvsp[0].user_auth);
          (yyval.user_auth)->plugin= (yyvsp[-1].lex_str);
        }
#line 48131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3422: /* opt_auth_str: %empty  */
#line 17892 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
        }
#line 48140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3423: /* opt_auth_str: using_or_as TEXT_STRING_sys  */
#line 17897 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->auth_str= (yyvsp[0].lex_str);
        }
#line 48150 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3424: /* opt_auth_str: using_or_as PASSWORD_SYM '(' TEXT_STRING ')'  */
#line 17903 "/home/buildbot/git/sql/sql_yacc_ora.yy"
        {
          if (!((yyval.user_auth)=(USER_AUTH*) thd->calloc(sizeof(USER_AUTH))))
            MYSQL_YYABORT;
          (yyval.user_auth)->pwtext= (yyvsp[-1].lex_string_with_metadata);
        }
#line 48160 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3425: /* opt_column_list: %empty  */
#line 17912 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->grant |= lex->which_columns;
          }
#line 48169 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3426: /* opt_column_list: '(' column_list ')'  */
#line 17916 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { }
#line 48175 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3429: /* column_list_id: ident  */
#line 17926 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            String *new_str= new (thd->mem_root) String((const char*) (yyvsp[0].ident_sys).str,(yyvsp[0].ident_sys).length,system_charset_info);
            if (unlikely(new_str == NULL))
              MYSQL_YYABORT;
            List_iterator <LEX_COLUMN> iter(Lex->columns);
            class LEX_COLUMN *point;
            LEX *lex=Lex;
            while ((point=iter++))
            {
              if (!my_strcasecmp(system_charset_info,
                                 point->column.c_ptr(), new_str->c_ptr()))
                break;
            }
            lex->grant_tot_col|= lex->which_columns;
            if (point)
              point->rights |= lex->which_columns;
            else
            {
              LEX_COLUMN *col= (new (thd->mem_root)
                                LEX_COLUMN(*new_str,lex->which_columns));
              if (unlikely(col == NULL))
                MYSQL_YYABORT;
              lex->columns.push_back(col, thd->mem_root);
            }
          }
#line 48205 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3431: /* opt_require_clause: REQUIRE_SYM require_list  */
#line 17956 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_SPECIFIED;
          }
#line 48213 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3432: /* opt_require_clause: REQUIRE_SYM SSL_SYM  */
#line 17960 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_ANY;
          }
#line 48221 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3433: /* opt_require_clause: REQUIRE_SYM X509_SYM  */
#line 17964 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_X509;
          }
#line 48229 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3434: /* opt_require_clause: REQUIRE_SYM NONE_SYM  */
#line 17968 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.ssl_type= SSL_TYPE_NONE;
          }
#line 48237 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3435: /* resource_option: MAX_QUERIES_PER_HOUR ulong_num  */
#line 17975 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.questions=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::QUERIES_PER_HOUR;
          }
#line 48246 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3436: /* resource_option: MAX_UPDATES_PER_HOUR ulong_num  */
#line 17980 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.updates=(yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::UPDATES_PER_HOUR;
          }
#line 48255 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3437: /* resource_option: MAX_CONNECTIONS_PER_HOUR ulong_num  */
#line 17985 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.conn_per_hour= (yyvsp[0].ulong_num);
            Lex->account_options.specified_limits|= USER_RESOURCES::CONNECTIONS_PER_HOUR;
          }
#line 48264 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3438: /* resource_option: MAX_USER_CONNECTIONS_SYM int_num  */
#line 17990 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.user_conn= (yyvsp[0].num);
            Lex->account_options.specified_limits|= USER_RESOURCES::USER_CONNECTIONS;
          }
#line 48273 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3439: /* resource_option: MAX_STATEMENT_TIME_SYM NUM_literal  */
#line 17995 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->account_options.max_statement_time= (yyvsp[0].item_num)->val_real();
            Lex->account_options.specified_limits|= USER_RESOURCES::MAX_STATEMENT_TIME;
          }
#line 48282 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3440: /* resource_option_list: resource_option_list resource_option  */
#line 18002 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                               {}
#line 48288 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3441: /* resource_option_list: resource_option  */
#line 18003 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 48294 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3442: /* opt_resource_options: %empty  */
#line 18007 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48300 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3444: /* opt_grant_options: %empty  */
#line 18013 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48306 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3445: /* opt_grant_options: WITH grant_option_list  */
#line 18014 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                 {}
#line 48312 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3446: /* opt_grant_option: %empty  */
#line 18018 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48318 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3447: /* opt_grant_option: WITH GRANT OPTION  */
#line 18019 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->grant |= GRANT_ACL;}
#line 48324 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3448: /* grant_option_list: grant_option_list grant_option  */
#line 18023 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                         {}
#line 48330 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3449: /* grant_option_list: grant_option  */
#line 18024 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       {}
#line 48336 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3450: /* grant_option: GRANT OPTION  */
#line 18028 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { Lex->grant |= GRANT_ACL;}
#line 48342 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3451: /* grant_option: resource_option  */
#line 18029 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                          {}
#line 48348 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3452: /* $@265: %empty  */
#line 18034 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command = SQLCOM_BEGIN;
            lex->start_transaction_opt= 0;
          }
#line 48358 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3453: /* begin_stmt_mariadb: BEGIN_MARIADB_SYM $@265 opt_work  */
#line 18039 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                   {}
#line 48364 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3454: /* compound_statement: sp_proc_stmt_compound_ok  */
#line 18044 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command= SQLCOM_COMPOUND;
            if (Lex->sp_body_finalize_procedure(thd))
              MYSQL_YYABORT;
          }
#line 48374 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3455: /* opt_not: %empty  */
#line 18052 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 0; }
#line 48380 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3456: /* opt_not: not  */
#line 18053 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                       { (yyval.num)= 1; }
#line 48386 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3457: /* opt_work: %empty  */
#line 18057 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      {}
#line 48392 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3458: /* opt_work: WORK_SYM  */
#line 18058 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 48398 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3459: /* opt_chain: %empty  */
#line 18063 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48404 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3460: /* opt_chain: AND_SYM NO_SYM CHAIN_SYM  */
#line 18064 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48410 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3461: /* opt_chain: AND_SYM CHAIN_SYM  */
#line 18065 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                   { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48416 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3462: /* opt_release: %empty  */
#line 18070 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.m_yes_no_unk)= TVL_UNKNOWN; }
#line 48422 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3463: /* opt_release: RELEASE_SYM  */
#line 18071 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.m_yes_no_unk)= TVL_YES; }
#line 48428 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3464: /* opt_release: NO_SYM RELEASE_SYM  */
#line 18072 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                             { (yyval.m_yes_no_unk)= TVL_NO; }
#line 48434 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3465: /* commit: COMMIT_SYM opt_work opt_chain opt_release  */
#line 18077 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_COMMIT;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48447 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3466: /* rollback: ROLLBACK_SYM opt_work opt_chain opt_release  */
#line 18089 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK;
            /* Don't allow AND CHAIN RELEASE. */
            MYSQL_YYABORT_UNLESS((yyvsp[-1].m_yes_no_unk) != TVL_YES || (yyvsp[0].m_yes_no_unk) != TVL_YES);
            lex->tx_chain= (yyvsp[-1].m_yes_no_unk);
            lex->tx_release= (yyvsp[0].m_yes_no_unk);
          }
#line 48460 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3467: /* rollback: ROLLBACK_SYM opt_work TO_SYM SAVEPOINT_SYM ident  */
#line 18098 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48470 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3468: /* rollback: ROLLBACK_SYM opt_work TO_SYM ident  */
#line 18104 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_ROLLBACK_TO_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48480 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3469: /* savepoint: SAVEPOINT_SYM ident  */
#line 18113 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48490 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3470: /* release: RELEASE_SYM SAVEPOINT_SYM ident  */
#line 18122 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex=Lex;
            lex->sql_command= SQLCOM_RELEASE_SAVEPOINT;
            lex->ident= (yyvsp[0].ident_sys);
          }
#line 48500 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3471: /* unit_type_decl: UNION_SYM union_option  */
#line 18135 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= UNION_TYPE; (yyval.unit_operation).distinct= (yyvsp[0].num); }
#line 48506 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3472: /* unit_type_decl: INTERSECT_SYM  */
#line 18137 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= INTERSECT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48512 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3473: /* unit_type_decl: EXCEPT_SYM  */
#line 18139 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { (yyval.unit_operation).unit_type= EXCEPT_TYPE; (yyval.unit_operation).distinct= 1; }
#line 48518 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3474: /* union_option: %empty  */
#line 18146 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.num)=1; }
#line 48524 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3475: /* union_option: DISTINCT  */
#line 18147 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=1; }
#line 48530 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3476: /* union_option: ALL  */
#line 18148 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    { (yyval.num)=0; }
#line 48536 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3477: /* query_expression_option: STRAIGHT_JOIN  */
#line 18152 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Select->options|= SELECT_STRAIGHT_JOIN; }
#line 48542 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3478: /* query_expression_option: HIGH_PRIORITY  */
#line 18154 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            YYPS->m_lock_type= TL_READ_HIGH_PRIORITY;
            YYPS->m_mdl_type= MDL_SHARED_READ;
            Select->options|= SELECT_HIGH_PRIORITY;
          }
#line 48552 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3479: /* query_expression_option: DISTINCT  */
#line 18159 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48558 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3480: /* query_expression_option: UNIQUE_SYM  */
#line 18160 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_DISTINCT; }
#line 48564 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3481: /* query_expression_option: SQL_SMALL_RESULT  */
#line 18161 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_SMALL_RESULT; }
#line 48570 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3482: /* query_expression_option: SQL_BIG_RESULT  */
#line 18162 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           { Select->options|= SELECT_BIG_RESULT; }
#line 48576 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3483: /* query_expression_option: SQL_BUFFER_RESULT  */
#line 18163 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Select->options|= OPTION_BUFFER_RESULT; }
#line 48582 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3484: /* query_expression_option: SQL_CALC_FOUND_ROWS  */
#line 18164 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Select->options|= OPTION_FOUND_ROWS; }
#line 48588 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3485: /* query_expression_option: ALL  */
#line 18165 "/home/buildbot/git/sql/sql_yacc_ora.yy"
              { Select->options|= SELECT_ALL; }
#line 48594 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3488: /* no_definer: %empty  */
#line 18181 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            /*
              We have to distinguish missing DEFINER-clause from case when
              CURRENT_USER specified as definer explicitly in order to properly
              handle CREATE TRIGGER statements which come to replication thread
              from older master servers (i.e. to create non-suid trigger in this
              case).
            */
            thd->lex->definer= 0;
          }
#line 48609 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3489: /* definer: DEFINER_SYM '=' user_or_role  */
#line 18195 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->definer= (yyvsp[0].lex_user);
            Lex->account_options.reset();
          }
#line 48618 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3490: /* view_algorithm: ALGORITHM_SYM '=' UNDEFINED_SYM  */
#line 18208 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= DTYPE_ALGORITHM_UNDEFINED; }
#line 48624 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3491: /* view_algorithm: ALGORITHM_SYM '=' MERGE_SYM  */
#line 18209 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_MERGE; }
#line 48630 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3492: /* view_algorithm: ALGORITHM_SYM '=' TEMPTABLE_SYM  */
#line 18210 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_ALGORITHM_TMPTABLE; }
#line 48636 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3493: /* opt_view_suid: %empty  */
#line 18214 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFAULT; }
#line 48642 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3494: /* opt_view_suid: view_suid  */
#line 18215 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= (yyvsp[0].view_suid); }
#line 48648 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3495: /* view_suid: SQL_SYM SECURITY_SYM DEFINER_SYM  */
#line 18219 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_DEFINER; }
#line 48654 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3496: /* view_suid: SQL_SYM SECURITY_SYM INVOKER_SYM  */
#line 18220 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                           { (yyval.view_suid)= VIEW_SUID_INVOKER; }
#line 48660 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3497: /* view_list_opt: %empty  */
#line 18225 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {}
#line 48666 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3498: /* view_list_opt: '(' view_list ')'  */
#line 18226 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { }
#line 48672 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3499: /* view_list: ident  */
#line 18231 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48682 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3500: /* view_list: view_list ',' ident  */
#line 18237 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->view_list.push_back((LEX_CSTRING*)
                                     thd->memdup(&(yyvsp[0].ident_sys), sizeof(LEX_CSTRING)),
                                     thd->mem_root);
          }
#line 48692 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3501: /* $@266: %empty  */
#line 18245 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->parsing_options.allows_variable= FALSE;
            lex->create_view->select.str= (char *) YYLIP->get_cpp_ptr();
          }
#line 48702 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3502: /* view_select: $@266 query_expression view_check_option  */
#line 18252 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->parsed_create_view((yyvsp[-1].select_lex_unit), (yyvsp[0].num)))
              MYSQL_YYABORT;
          }
#line 48711 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3503: /* view_check_option: %empty  */
#line 18259 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_NONE; }
#line 48717 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3504: /* view_check_option: WITH CHECK_SYM OPTION  */
#line 18260 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48723 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3505: /* view_check_option: WITH CASCADED CHECK_SYM OPTION  */
#line 18261 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_CASCADED; }
#line 48729 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3506: /* view_check_option: WITH LOCAL_SYM CHECK_SYM OPTION  */
#line 18262 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                                          { (yyval.num)= VIEW_CHECK_LOCAL; }
#line 48735 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3507: /* trigger_action_order: FOLLOWS_SYM  */
#line 18273 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_FOLLOWS; }
#line 48741 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3508: /* trigger_action_order: PRECEDES_SYM  */
#line 18275 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            { (yyval.trigger_action_order_type)= TRG_ORDER_PRECEDES; }
#line 48747 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3509: /* trigger_follows_precedes_clause: %empty  */
#line 18280 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
              (yyval.trg_execution_order).ordering_clause= TRG_ORDER_NONE;
              (yyval.trg_execution_order).anchor_trigger_name.str= NULL;
              (yyval.trg_execution_order).anchor_trigger_name.length= 0;
            }
#line 48757 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3510: /* trigger_follows_precedes_clause: trigger_action_order ident_or_text  */
#line 18287 "/home/buildbot/git/sql/sql_yacc_ora.yy"
            {
              (yyval.trg_execution_order).ordering_clause= (yyvsp[-1].trigger_action_order_type);
              (yyval.trg_execution_order).anchor_trigger_name= (yyvsp[0].lex_str);
            }
#line 48766 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3511: /* $@267: %empty  */
#line 18296 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->add_create_options_with_check((yyvsp[0].object_ddl_options))))
              MYSQL_YYABORT;
          }
#line 48775 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3512: /* $@268: %empty  */
#line 18305 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $9 */
            Lex->raw_trg_on_table_name_begin= YYLIP->get_tok_start();
          }
#line 48783 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3513: /* $@269: %empty  */
#line 18311 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $13 */
            Lex->raw_trg_on_table_name_end= YYLIP->get_tok_start();
          }
#line 48791 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3514: /* $@270: %empty  */
#line 18316 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->trg_chistics.ordering_clause_begin= YYLIP->get_cpp_ptr();
          }
#line 48799 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3515: /* $@271: %empty  */
#line 18320 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $18 */
            LEX *lex= thd->lex;
            Lex_input_stream *lip= YYLIP;

            if (unlikely(lex->sphead))
              my_yyabort_error((ER_SP_NO_RECURSIVE_CREATE, MYF(0), "TRIGGER"));

            lex->stmt_definition_begin= (yyvsp[-16].simple_string);
            lex->ident.str= (yyvsp[-9].simple_string);
            lex->ident.length= (yyvsp[-5].simple_string) - (yyvsp[-9].simple_string);
            lex->spname= (yyvsp[-13].spname);
            (*static_cast<st_trg_execution_order*>(&lex->trg_chistics))= ((yyvsp[0].trg_execution_order));
            lex->trg_chistics.ordering_clause_end= lip->get_cpp_ptr();

            if (unlikely(!lex->make_sp_head(thd, (yyvsp[-13].spname), &sp_handler_trigger,
                                            DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;

            lex->sphead->set_body_start(thd, lip->get_cpp_tok_start());
          }
#line 48824 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3516: /* trigger_tail: remember_name opt_if_not_exists $@267 sp_name trg_action_time trg_event ON remember_name $@268 table_ident FOR_SYM remember_name $@269 EACH_SYM ROW_SYM $@270 trigger_follows_precedes_clause $@271 sp_proc_stmt force_lookahead  */
#line 18341 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { /* $21 */
            LEX *lex= Lex;

            lex->sql_command= SQLCOM_CREATE_TRIGGER;
            if (lex->sp_body_finalize_trigger(thd))
              MYSQL_YYABORT;

            /*
              We have to do it after parsing trigger body, because some of
              sp_proc_stmt alternatives are not saving/restoring LEX, so
              lex->query_tables can be wiped out.
            */
            if (!lex->first_select_lex()->
                  add_table_to_list(thd, (yyvsp[-10].table), (LEX_CSTRING*) 0,
                                    TL_OPTION_UPDATING, TL_READ_NO_INSERT,
                                    MDL_SHARED_NO_WRITE))
              MYSQL_YYABORT;
          }
#line 48847 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3517: /* $@272: %empty  */
#line 18368 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= Lex;
            lex->init_last_field(&lex->sphead->m_return_field_def,
                                 &empty_clex_str,
                                 thd->variables.collation_database);
          }
#line 48858 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3518: /* sf_return_type: $@272 sp_param_type  */
#line 18375 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sphead->fill_field_definition(thd,
                                                            Lex->last_field)))
              MYSQL_YYABORT;
          }
#line 48868 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3519: /* $@273: %empty  */
#line 18384 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            LEX *lex= thd->lex;
            lex->sphead->set_c_chistics(lex->sp_chistics);
            lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 48878 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3520: /* sf_c_chistics_and_body_standalone: sp_c_chistics $@273 sp_tail_is sp_body force_lookahead  */
#line 18391 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_body_finalize_function(thd)))
              MYSQL_YYABORT;
          }
#line 48887 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3521: /* $@274: %empty  */
#line 18399 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(!Lex->make_sp_head_no_recursive(thd, (yyvsp[0].spname),
                                                         &sp_handler_procedure,
                                                         DEFAULT_AGGREGATE)))
              MYSQL_YYABORT;
          }
#line 48898 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3522: /* $@275: %empty  */
#line 18407 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sphead->set_c_chistics(Lex->sp_chistics);
            Lex->sphead->set_body_start(thd, YYLIP->get_cpp_tok_start());
          }
#line 48907 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3523: /* sp_tail_standalone: sp_name $@274 opt_sp_parenthesized_pdparam_list sp_c_chistics $@275 sp_tail_is sp_body opt_sp_name  */
#line 18414 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (unlikely(Lex->sp_body_finalize_procedure_standalone(thd, (yyvsp[0].spname))))
              MYSQL_YYABORT;
          }
#line 48916 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3524: /* opt_package_routine_end_name: %empty  */
#line 18422 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= null_clex_str; }
#line 48922 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3525: /* opt_package_routine_end_name: ident  */
#line 18423 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                      { (yyval.lex_str)= (yyvsp[0].ident_sys); }
#line 48928 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3528: /* xa: XA_SYM begin_or_start xid opt_join_or_resume  */
#line 18435 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_START;
          }
#line 48936 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3529: /* xa: XA_SYM END xid opt_suspend  */
#line 18439 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_END;
          }
#line 48944 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3530: /* xa: XA_SYM PREPARE_SYM xid  */
#line 18443 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_PREPARE;
          }
#line 48952 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3531: /* xa: XA_SYM COMMIT_SYM xid opt_one_phase  */
#line 18447 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_COMMIT;
          }
#line 48960 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3532: /* xa: XA_SYM ROLLBACK_SYM xid  */
#line 18451 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_ROLLBACK;
          }
#line 48968 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3533: /* xa: XA_SYM RECOVER_SYM opt_format_xid  */
#line 18455 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->sql_command = SQLCOM_XA_RECOVER;
            Lex->verbose= (yyvsp[0].num);
          }
#line 48977 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3534: /* opt_format_xid: %empty  */
#line 18462 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                     { (yyval.num)= false; }
#line 48983 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3535: /* opt_format_xid: FORMAT_SYM '=' ident_or_text  */
#line 18464 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("SQL")))
              (yyval.num)= true;
            else if (lex_string_eq(&(yyvsp[0].lex_str), STRING_WITH_LEN("RAW")))
              (yyval.num)= false;
            else
            {
              my_yyabort_error((ER_UNKNOWN_EXPLAIN_FORMAT, MYF(0),
                               "XA RECOVER", (yyvsp[0].lex_str).str));
              (yyval.num)= false;
            }
          }
#line 49000 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3536: /* xid: text_string  */
#line 18480 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[0].string)->length() <= MAXGTRIDSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length(), 0, 0);
          }
#line 49011 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3537: /* xid: text_string ',' text_string  */
#line 18487 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-2].string)->length() <= MAXGTRIDSIZE && (yyvsp[0].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set(1L, (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length(), (yyvsp[0].string)->ptr(), (yyvsp[0].string)->length());
          }
#line 49022 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3538: /* xid: text_string ',' text_string ',' ulong_num  */
#line 18494 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            MYSQL_YYABORT_UNLESS((yyvsp[-4].string)->length() <= MAXGTRIDSIZE && (yyvsp[-2].string)->length() <= MAXBQUALSIZE);
            if (unlikely(!(Lex->xid=(XID *)thd->alloc(sizeof(XID)))))
              MYSQL_YYABORT;
            Lex->xid->set((yyvsp[0].ulong_num), (yyvsp[-4].string)->ptr(), (yyvsp[-4].string)->length(), (yyvsp[-2].string)->ptr(), (yyvsp[-2].string)->length());
          }
#line 49033 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3539: /* begin_or_start: BEGIN_MARIADB_SYM  */
#line 18503 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            {}
#line 49039 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3540: /* begin_or_start: BEGIN_ORACLE_SYM  */
#line 18504 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                           {}
#line 49045 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3541: /* begin_or_start: START_SYM  */
#line 18505 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                    {}
#line 49051 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3542: /* opt_join_or_resume: %empty  */
#line 18509 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_NONE;        }
#line 49057 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3543: /* opt_join_or_resume: JOIN_SYM  */
#line 18510 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_JOIN;        }
#line 49063 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3544: /* opt_join_or_resume: RESUME_SYM  */
#line 18511 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                        { Lex->xa_opt=XA_RESUME;      }
#line 49069 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3545: /* opt_one_phase: %empty  */
#line 18515 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->xa_opt=XA_NONE;        }
#line 49075 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3546: /* opt_one_phase: ONE_SYM PHASE_SYM  */
#line 18516 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                            { Lex->xa_opt=XA_ONE_PHASE;   }
#line 49081 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3547: /* opt_suspend: %empty  */
#line 18521 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->xa_opt=XA_NONE;        }
#line 49087 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3548: /* $@276: %empty  */
#line 18523 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          { Lex->xa_opt=XA_SUSPEND;     }
#line 49093 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3550: /* opt_migrate: %empty  */
#line 18528 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              {}
#line 49099 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3551: /* opt_migrate: FOR_SYM MIGRATE_SYM  */
#line 18529 "/home/buildbot/git/sql/sql_yacc_ora.yy"
                              { Lex->xa_opt=XA_FOR_MIGRATE; }
#line 49105 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3552: /* install: INSTALL_SYM PLUGIN_SYM opt_if_not_exists ident SONAME_SYM TEXT_STRING_sys  */
#line 18534 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_install_plugin((yyvsp[-3].object_ddl_options), (yyvsp[-2].ident_sys), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49114 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3553: /* install: INSTALL_SYM SONAME_SYM TEXT_STRING_sys  */
#line 18539 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            Lex->stmt_install_plugin((yyvsp[0].lex_str));
          }
#line 49122 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3554: /* uninstall: UNINSTALL_SYM PLUGIN_SYM opt_if_exists ident  */
#line 18546 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_name((yyvsp[-1].object_ddl_options), (yyvsp[0].ident_sys)))
              MYSQL_YYABORT;
          }
#line 49131 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3555: /* uninstall: UNINSTALL_SYM SONAME_SYM opt_if_exists TEXT_STRING_sys  */
#line 18551 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            if (Lex->stmt_uninstall_plugin_by_soname((yyvsp[-1].object_ddl_options), (yyvsp[0].lex_str)))
              MYSQL_YYABORT;
          }
#line 49140 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;

  case 3556: /* keep_gcc_happy: IMPOSSIBLE_ACTION  */
#line 18560 "/home/buildbot/git/sql/sql_yacc_ora.yy"
          {
            YYERROR;
          }
#line 49148 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"
    break;


#line 49152 "/home/buildbot/git/mkdist/sql/sql_yacc_ora.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (thd, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, thd);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, thd);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (thd, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, thd);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, thd);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

